/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(le){for(var e=[],l=0,N=le.length;l<N;l++)e[l]=ke[le[l]];return e};define(ke[162],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class l{static get(){const L=new Map,R=new Map,M=new Map,b=new Map;function $(E,v){E.has(v.detail)||E.set(v.detail,-v.timestamp)}function S(E,v){const u=E.get(v.detail);u&&(u>=0||E.set(v.detail,u+v.timestamp))}let A=[];typeof le=="function"&&typeof le.getStats=="function"&&(A=le.getStats().slice(0).sort((E,v)=>E.timestamp-v.timestamp));for(const E of A)switch(E.type){case 10:$(L,E);break;case 11:case 12:S(L,E);break;case 21:$(R,E);break;case 22:S(R,E);break;case 33:$(M,E);break;case 34:S(M,E);break;case 31:$(b,E);break;case 32:S(b,E);break}let C=0;M.forEach(E=>C+=E);function m(E){const v=[];return E.forEach((u,f)=>v.push([f,u])),v}return{amdLoad:m(L),amdInvoke:m(R),nodeRequire:m(M),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(L,R){let M="";const b=[];return L.forEach(($,S)=>{b[S]=$.length}),R.forEach($=>{$.forEach((S,A)=>{typeof S>"u"&&(S=$[A]="-");const C=S.toString().length;b[A]=Math.max(C,b[A])})}),L.forEach(($,S)=>{M+=`| ${$+" ".repeat(b[S]-$.toString().length)} `}),M+=`|
`,L.forEach(($,S)=>{M+=`| ${"-".repeat(b[S])} `}),M+=`|
`,R.forEach($=>{$.forEach((S,A)=>{typeof S<"u"&&(M+=`| ${S+" ".repeat(b[A]-S.toString().length)} `)}),M+=`|
`}),M}}e.$U=l}),define(ke[163],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=l,e.$gb=N,e.$hb=L,e.$ib=R,e.$jb=M,e.$kb=b,e.$lb=$,e.$nb=A,e.$ob=C,e.$pb=m,e.$qb=E,e.$rb=v;function l(u,f){const a=N(u,f);if(a!==-1)return u[a]}function N(u,f,a=u.length-1){for(let n=a;n>=0;n--){const i=u[n];if(f(i))return n}return-1}function L(u,f){const a=R(u,f);return a===-1?void 0:u[a]}function R(u,f,a=0,n=u.length){let i=a,s=n;for(;i<s;){const o=Math.floor((i+s)/2);f(u[o])?i=o+1:s=o}return i-1}function M(u,f){const a=b(u,f);return a===u.length?void 0:u[a]}function b(u,f,a=0,n=u.length){let i=a,s=n;for(;i<s;){const o=Math.floor((i+s)/2);f(u[o])?s=o:i=o+1}return i}function $(u,f,a=0,n=u.length){const i=b(u,f,a,n);return i===u.length?-1:i}class S{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(S.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!f(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const a=R(this.e,f,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=S;function A(u,f){if(u.length===0)return;let a=u[0];for(let n=1;n<u.length;n++){const i=u[n];f(i,a)>0&&(a=i)}return a}function C(u,f){if(u.length===0)return;let a=u[0];for(let n=1;n<u.length;n++){const i=u[n];f(i,a)>=0&&(a=i)}return a}function m(u,f){return A(u,(a,n)=>-f(a,n))}function E(u,f){if(u.length===0)return-1;let a=0;for(let n=1;n<u.length;n++){const i=u[n];f(i,u[a])>0&&(a=n)}return a}function v(u,f){for(const a of u){const n=f(a);if(n!==void 0)return n}}}),define(ke[73],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=l,e.$L=N,e.$M=L,e.$N=R;function l(M,b){const $=Object.create(null);for(const S of M){const A=b(S);let C=$[A];C||(C=$[A]=[]),C.push(S)}return $}function N(M,b){const $=[],S=[];for(const A of M)b.has(A)||$.push(A);for(const A of b)M.has(A)||S.push(A);return{removed:$,added:S}}function L(M,b){const $=[],S=[];for(const[A,C]of M)b.has(A)||$.push(C);for(const[A,C]of b)M.has(A)||S.push(C);return{removed:$,added:S}}function R(M,b){const $=new Set;for(const S of b)M.has(S)&&$.add(S);return $}}),define(ke[55],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=N,e.$Vh=L,e.$Wh=R;function l(M){return(b,$,S)=>{let A=null,C=null;if(typeof S.value=="function"?(A="value",C=S.value):typeof S.get=="function"&&(A="get",C=S.get),!C)throw new Error("not supported");S[A]=M(C,$)}}function N(M,b,$){let S=null,A=null;if(typeof $.value=="function"?(S="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(S="get",A=$.get),!A)throw new Error("not supported");const C=`$memoize$${b}`;$[S]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,m)}),this[C]}}function L(M,b,$){return l((S,A)=>{const C=`$debounce$${A}`,m=`$debounce$result$${A}`;return function(...E){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...E),E=[this[m]]),this[C]=setTimeout(()=>{S.apply(this,E),this[m]=$?$():void 0},M)}})}function R(M,b,$){return l((S,A)=>{const C=`$throttle$timer$${A}`,m=`$throttle$result$${A}`,E=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...u){if(this[m]||(this[m]=$?$():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...u)),this[v])return;const f=this[E]+M;f<=Date.now()?(this[E]=Date.now(),S.apply(this,[this[m]]),this[m]=$?$():void 0):(this[v]=!0,this[C]=setTimeout(()=>{this[v]=!1,this[E]=Date.now(),S.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}}),define(ke[13],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=R,e.$2=M,e.$3=b,e.$4=S,e.$6=C,e.$7=m,e.$8=E,e.$0=u;class l{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(g=>{g(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=l,e.$X=new l;function N(o){e.$X.setUnexpectedErrorHandler(o)}function L(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(o){S(o)||e.$X.onUnexpectedError(o)}function M(o){S(o)||e.$X.onUnexpectedExternalError(o)}function b(o){if(o instanceof Error){const{name:t,message:g}=o,h=o.stacktrace||o.stack;return{$isError:!0,name:t,message:g,stack:h,noTelemetry:i.isErrorNoTelemetry(o)}}return o}const $="Canceled";function S(o){return o instanceof A?!0:o instanceof Error&&o.name===$&&o.message===$}class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function C(){const o=new Error($);return o.name=o.message,o}function m(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function E(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function u(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const g=new i;return g.message=t.message,g.stack=t.stack,g}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$cb=s}),define(ke[19],Ee([1,0,13,163]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=R,e.$ub=M,e.$vb=b,e.$wb=$,e.$xb=S,e.$yb=A,e.$zb=C,e.$Ab=m,e.$Bb=E,e.$Cb=v,e.$Db=u,e.$Eb=f,e.top=a,e.$Gb=n,e.$Hb=s,e.$Ib=o,e.$Jb=t,e.$Kb=g,e.$Lb=h,e.$Mb=c,e.$Nb=r,e.$Ob=w,e.$Pb=d,e.$Qb=D,e.$Rb=p,e.$Sb=k,e.$Tb=y,e.$Ub=P,e.$Vb=I,e.$Wb=F,e.$Xb=j,e.$Yb=z,e.$Zb=O,e.$1b=T,e.$2b=B,e.$3b=W,e.$4b=X,e.$5b=x,e.$6b=Z,e.$7b=te,e.$8b=we,e.$$b=U;function L(se,re=0){return se[se.length-(1+re)]}function R(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}function M(se,re,oe=(G,ie)=>G===ie){if(se===re)return!0;if(!se||!re||se.length!==re.length)return!1;for(let G=0,ie=se.length;G<ie;G++)if(!oe(se[G],re[G]))return!1;return!0}function b(se,re){const oe=se.length-1;re<oe&&(se[re]=se[oe]),se.pop()}function $(se,re,oe){return S(se.length,G=>oe(se[G],re))}function S(se,re){let oe=0,G=se-1;for(;oe<=G;){const ie=(oe+G)/2|0,me=re(ie);if(me<0)oe=ie+1;else if(me>0)G=ie-1;else return ie}return-(oe+1)}function A(se,re,oe){if(se=se|0,se>=re.length)throw new TypeError("invalid index");const G=re[Math.floor(re.length*Math.random())],ie=[],me=[],be=[];for(const Ae of re){const fe=oe(Ae,G);fe<0?ie.push(Ae):fe>0?me.push(Ae):be.push(Ae)}return se<ie.length?A(se,ie,oe):se<ie.length+be.length?be[0]:A(se-(ie.length+be.length),me,oe)}function C(se,re){const oe=[];let G;for(const ie of se.slice(0).sort(re))!G||re(G[0],ie)!==0?(G=[ie],oe.push(G)):G.push(ie);return oe}function*m(se,re){let oe,G;for(const ie of se)G!==void 0&&re(G,ie)?oe.push(ie):(oe&&(yield oe),oe=[ie]),G=ie;oe&&(yield oe)}function E(se,re){for(let oe=0;oe<=se.length;oe++)re(oe===0?void 0:se[oe-1],oe===se.length?void 0:se[oe])}function v(se,re){for(let oe=0;oe<se.length;oe++)re(oe===0?void 0:se[oe-1],se[oe],oe+1===se.length?void 0:se[oe+1])}function u(se,re,oe){const G=[];function ie(Ae,fe,De){if(fe===0&&De.length===0)return;const Ie=G[G.length-1];Ie&&Ie.start+Ie.deleteCount===Ae?(Ie.deleteCount+=fe,Ie.toInsert.push(...De)):G.push({start:Ae,deleteCount:fe,toInsert:De})}let me=0,be=0;for(;;){if(me===se.length){ie(me,0,re.slice(be));break}if(be===re.length){ie(me,se.length-me,[]);break}const Ae=se[me],fe=re[be],De=oe(Ae,fe);De===0?(me+=1,be+=1):De<0?(ie(me,1,[]),me+=1):De>0&&(ie(me,0,[fe]),be+=1)}return G}function f(se,re,oe){const G=u(se,re,oe),ie=[],me=[];for(const be of G)ie.push(...se.slice(be.start,be.start+be.deleteCount)),me.push(...be.toInsert);return{removed:ie,added:me}}function a(se,re,oe){if(oe===0)return[];const G=se.slice(0,oe).sort(re);return i(se,re,G,oe,se.length),G}function n(se,re,oe,G,ie){return oe===0?Promise.resolve([]):new Promise((me,be)=>{(async()=>{const Ae=se.length,fe=se.slice(0,oe).sort(re);for(let De=oe,Ie=Math.min(oe+G,Ae);De<Ae;De=Ie,Ie=Math.min(Ie+G,Ae)){if(De>oe&&await new Promise(Te=>setTimeout(Te)),ie&&ie.isCancellationRequested)throw new l.$5;i(se,re,fe,De,Ie)}return fe})().then(me,be)})}function i(se,re,oe,G,ie){for(const me=oe.length;G<ie;G++){const be=se[G];if(re(be,oe[me-1])<0){oe.pop();const Ae=(0,N.$kb)(oe,fe=>re(be,fe)<0);oe.splice(Ae,0,be)}}}function s(se){return se.filter(re=>!!re)}function o(se){let re=0;for(let oe=0;oe<se.length;oe++)se[oe]&&(se[re]=se[oe],re+=1);se.length=re}function t(se,re,oe){se.splice(oe,0,se.splice(re,1)[0])}function g(se){return!Array.isArray(se)||se.length===0}function h(se){return Array.isArray(se)&&se.length>0}function c(se,re=oe=>oe){const oe=new Set;return se.filter(G=>{const ie=re(G);return oe.has(ie)?!1:(oe.add(ie),!0)})}function r(se){const re=new Set;return oe=>{const G=se(oe);return re.has(G)?!1:(re.add(G),!0)}}function w(se,re){return se.length>0?se[0]:re}function d(se,re){return se.length>0?se[se.length-1]:re}function D(se,re,oe=(G,ie)=>G===ie){let G=0;for(let ie=0,me=Math.min(se.length,re.length);ie<me&&oe(se[ie],re[ie]);ie++)G++;return G}function p(se){return[].concat(...se)}function k(se,re){let oe=typeof re=="number"?se:0;typeof re=="number"?oe=se:(oe=0,re=se);const G=[];if(oe<=re)for(let ie=oe;ie<re;ie++)G.push(ie);else for(let ie=oe;ie>re;ie--)G.push(ie);return G}function y(se,re,oe){return se.reduce((G,ie)=>(G[re(ie)]=oe?oe(ie):ie,G),Object.create(null))}function P(se,re){return se.push(re),()=>I(se,re)}function I(se,re){const oe=se.indexOf(re);if(oe>-1)return se.splice(oe,1),re}function F(se,re,oe){const G=se.slice(0,re),ie=se.slice(re);return G.concat(oe,ie)}function j(se,re){let oe;if(typeof re=="number"){let G=re;oe=()=>{const ie=Math.sin(G++)*179426549;return ie-Math.floor(ie)}}else oe=Math.random;for(let G=se.length-1;G>0;G-=1){const ie=Math.floor(oe()*(G+1)),me=se[G];se[G]=se[ie],se[ie]=me}}function z(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.unshift(re))}function O(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.push(re))}function T(se,re){for(const oe of re)se.push(oe)}function B(se,re){return Array.isArray(se)?se.map(re):re(se)}function W(se){return Array.isArray(se)?se:[se]}function X(se){return se[Math.floor(Math.random()*se.length)]}function x(se,re,oe){const G=Y(se,re),ie=se.length,me=oe.length;se.length=ie+me;for(let be=ie-1;be>=G;be--)se[be+me]=se[be];for(let be=0;be<me;be++)se[be+G]=oe[be]}function Z(se,re,oe,G){const ie=Y(se,re);let me=se.splice(ie,oe);return me===void 0&&(me=[]),x(se,ie,G),me}function Y(se,re){return re<0?Math.max(re+se.length,0):Math.min(re,se.length)}var ue;(function(se){function re(me){return me<0}se.isLessThan=re;function oe(me){return me<=0}se.isLessThanOrEqual=oe;function G(me){return me>0}se.isGreaterThan=G;function ie(me){return me===0}se.isNeitherLessOrGreaterThan=ie,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function te(se,re){return(oe,G)=>re(se(oe),se(G))}function we(...se){return(re,oe)=>{for(const G of se){const ie=G(re,oe);if(!ue.isNeitherLessOrGreaterThan(ie))return ie}return ue.neitherLessOrGreaterThan}}const Se=(se,re)=>se-re;e.$9b=Se;const _=(se,re)=>(0,e.$9b)(se?1:0,re?1:0);e.$0b=_;function U(se){return(re,oe)=>-se(re,oe)}class ne{constructor(re){this.g=re,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(re){let oe=this.c;for(;oe<this.g.length&&re(this.g[oe]);)oe++;const G=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,G}takeFromEndWhile(re){let oe=this.d;for(;oe>=0&&re(this.g[oe]);)oe--;const G=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,G}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const re=this.g[this.c];return this.c++,re}removeLast(){const re=this.g[this.d];return this.d--,re}takeCount(re){const oe=this.g.slice(this.c,this.c+re);return this.c+=re,oe}}e.$_b=ne;class $e{static{this.empty=new $e(re=>{})}constructor(re){this.iterate=re}forEach(re){this.iterate(oe=>(re(oe),!0))}toArray(){const re=[];return this.iterate(oe=>(re.push(oe),!0)),re}filter(re){return new $e(oe=>this.iterate(G=>re(G)?oe(G):!0))}map(re){return new $e(oe=>this.iterate(G=>oe(re(G))))}some(re){let oe=!1;return this.iterate(G=>(oe=re(G),!oe)),oe}findFirst(re){let oe;return this.iterate(G=>re(G)?(oe=G,!1):!0),oe}findLast(re){let oe;return this.iterate(G=>(re(G)&&(oe=G),!0)),oe}findLastMaxBy(re){let oe,G=!0;return this.iterate(ie=>((G||ue.isGreaterThan(re(ie,oe)))&&(G=!1,oe=ie),!0)),oe}}e.$ac=$e;class Pe{constructor(re){this.c=re}static createSortPermutation(re,oe){const G=Array.from(re.keys()).sort((ie,me)=>oe(re[ie],re[me]));return new Pe(G)}apply(re){return re.map((oe,G)=>re[this.c[G]])}inverse(){const re=this.c.slice();for(let oe=0;oe<this.c.length;oe++)re[this.c[oe]]=oe;return new Pe(re)}}e.$bc=Pe}),define(ke[62],Ee([1,0,13]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$cd=L,e.$dd=R,e.$ed=M,e.$fd=b,e.$gd=$;function N(S,A){if(!S)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(S,A="Unreachable"){throw new Error(A)}function R(S){if(!S)throw new l.$cb("Assertion Failed")}function M(S){S||(0,l.$1)(new l.$cb("Soft Assertion Failed"))}function b(S){if(!S()){debugger;S(),(0,l.$1)(new l.$cb("Assertion Failed"))}}function $(S,A){let C=0;for(;C<S.length-1;){const m=S[C],E=S[C+1];if(!A(m,E))return!1;C++}return!0}}),define(ke[74],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=l;function l(N,L){const R=this;let M=!1,b;return function(){if(M)return b;if(M=!0,L)try{b=N.apply(R,arguments)}finally{L()}else b=N.apply(R,arguments);return b}}}),define(ke[124],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=void 0;class l{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$hP=l,e.$iP=new l("id#")}),define(ke[39],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const R=Object.freeze([]);function M(){return R}N.empty=M;function*b(t){yield t}N.single=b;function $(t){return L(t)?t:b(t)}N.wrap=$;function S(t){return t||R}N.from=S;function*A(t){for(let g=t.length-1;g>=0;g--)yield t[g]}N.reverse=A;function C(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}N.first=m;function E(t,g){for(const h of t)if(g(h))return!0;return!1}N.some=E;function v(t,g){for(const h of t)if(g(h))return h}N.find=v;function*u(t,g){for(const h of t)g(h)&&(yield h)}N.filter=u;function*f(t,g){let h=0;for(const c of t)yield g(c,h++)}N.map=f;function*a(...t){for(const g of t)yield*g}N.concat=a;function n(t,g,h){let c=h;for(const r of t)c=g(c,r);return c}N.reduce=n;function*i(t,g,h=t.length){for(g<0&&(g+=t.length),h<0?h+=t.length:h>t.length&&(h=t.length);g<h;g++)yield t[g]}N.slice=i;function s(t,g=Number.POSITIVE_INFINITY){const h=[];if(g===0)return[h,t];const c=t[Symbol.iterator]();for(let r=0;r<g;r++){const w=c.next();if(w.done)return[h,N.empty()];h.push(w.value)}return[h,{[Symbol.iterator](){return c}}]}N.consume=s;async function o(t){const g=[];for await(const h of t)g.push(h);return Promise.resolve(g)}N.asyncToArray=o})(l||(e.Iterable=l={}))}),define(ke[164],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=M,e.$Cn=C,e.$Dn=m,e.$En=E,e.$Fn=v,e.$Gn=u,e.$Hn=f,e.$In=a,e.$Jn=n,e.$Kn=i,e.$Ln=s,e.$Mn=o;var l;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(l||(e.ScanError=l={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function M(t,g=!1){let h=0;const c=t.length;let r="",w=0,d=16,D=0;function p(z){let O=0,T=0;for(;O<z;){const B=t.charCodeAt(h);if(B>=48&&B<=57)T=T*16+B-48;else if(B>=65&&B<=70)T=T*16+B-65+10;else if(B>=97&&B<=102)T=T*16+B-97+10;else break;h++,O++}return O<z&&(T=-1),T}function k(z){h=z,r="",w=0,d=16,D=0}function y(){const z=h;if(t.charCodeAt(h)===48)h++;else for(h++;h<t.length&&S(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===46)if(h++,h<t.length&&S(t.charCodeAt(h)))for(h++;h<t.length&&S(t.charCodeAt(h));)h++;else return D=3,t.substring(z,h);let O=h;if(h<t.length&&(t.charCodeAt(h)===69||t.charCodeAt(h)===101))if(h++,(h<t.length&&t.charCodeAt(h)===43||t.charCodeAt(h)===45)&&h++,h<t.length&&S(t.charCodeAt(h))){for(h++;h<t.length&&S(t.charCodeAt(h));)h++;O=h}else D=3;return t.substring(z,O)}function P(){let z="",O=h;for(;;){if(h>=c){z+=t.substring(O,h),D=2;break}const T=t.charCodeAt(h);if(T===34){z+=t.substring(O,h),h++;break}if(T===92){if(z+=t.substring(O,h),h++,h>=c){D=2;break}switch(t.charCodeAt(h++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=p(4);W>=0?z+=String.fromCharCode(W):D=4;break}default:D=5}O=h;continue}if(T>=0&&T<=31)if($(T)){z+=t.substring(O,h),D=2;break}else D=6;h++}return z}function I(){if(r="",D=0,w=h,h>=c)return w=c,d=17;let z=t.charCodeAt(h);if(b(z)){do h++,r+=String.fromCharCode(z),z=t.charCodeAt(h);while(b(z));return d=15}if($(z))return h++,r+=String.fromCharCode(z),z===13&&t.charCodeAt(h)===10&&(h++,r+=`
`),d=14;switch(z){case 123:return h++,d=1;case 125:return h++,d=2;case 91:return h++,d=3;case 93:return h++,d=4;case 58:return h++,d=6;case 44:return h++,d=5;case 34:return h++,r=P(),d=10;case 47:{const O=h-1;if(t.charCodeAt(h+1)===47){for(h+=2;h<c&&!$(t.charCodeAt(h));)h++;return r=t.substring(O,h),d=12}if(t.charCodeAt(h+1)===42){h+=2;const T=c-1;let B=!1;for(;h<T;){if(t.charCodeAt(h)===42&&t.charCodeAt(h+1)===47){h+=2,B=!0;break}h++}return B||(h++,D=1),r=t.substring(O,h),d=13}return r+=String.fromCharCode(z),h++,d=16}case 45:if(r+=String.fromCharCode(z),h++,h===c||!S(t.charCodeAt(h)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=y(),d=11;default:for(;h<c&&F(z);)h++,z=t.charCodeAt(h);if(w!==h){switch(r=t.substring(w,h),r){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return r+=String.fromCharCode(z),h++,d=16}}function F(z){if(b(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:k,getPosition:()=>h,scan:g?j:I,getToken:()=>d,getTokenValue:()=>r,getTokenOffset:()=>w,getTokenLength:()=>h-w,getTokenError:()=>D}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,g){const h=[],c=new Object;let r;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function D(p,k,y,P){w.value=p,w.offset=k,w.length=y,w.type=P,w.colonOffset=void 0,r=w}try{i(t,{onObjectBegin:(p,k)=>{if(g<=p)throw c;r=void 0,d=g>p,h.push("")},onObjectProperty:(p,k,y)=>{if(g<k||(D(p,k,y,"property"),h[h.length-1]=p,g<=k+y))throw c},onObjectEnd:(p,k)=>{if(g<=p)throw c;r=void 0,h.pop()},onArrayBegin:(p,k)=>{if(g<=p)throw c;r=void 0,h.push(0)},onArrayEnd:(p,k)=>{if(g<=p)throw c;r=void 0,h.pop()},onLiteralValue:(p,k,y)=>{if(g<k||(D(p,k,y,o(p)),g<=k+y))throw c},onSeparator:(p,k,y)=>{if(g<=k)throw c;if(p===":"&&r&&r.type==="property")r.colonOffset=k,d=!1,r=void 0;else if(p===","){const P=h[h.length-1];typeof P=="number"?h[h.length-1]=P+1:(d=!0,h[h.length-1]=""),r=void 0}}})}catch(p){if(p!==c)throw p}return{path:h,previousNode:r,isAtPropertyKey:d,matches:p=>{let k=0;for(let y=0;k<p.length&&y<h.length;y++)if(p[k]===h[y]||p[k]==="*")k++;else if(p[k]!=="**")return!1;return k===p.length}}}function m(t,g=[],h=R.DEFAULT){let c=null,r=[];const w=[];function d(p){Array.isArray(r)?r.push(p):c!==null&&(r[c]=p)}return i(t,{onObjectBegin:()=>{const p={};d(p),w.push(r),r=p,c=null},onObjectProperty:p=>{c=p},onObjectEnd:()=>{r=w.pop()},onArrayBegin:()=>{const p=[];d(p),w.push(r),r=p,c=null},onArrayEnd:()=>{r=w.pop()},onLiteralValue:d,onError:(p,k,y)=>{g.push({error:p,offset:k,length:y})}},h),r[0]}function E(t,g=[],h=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){c.type==="property"&&(c.length=p-c.offset,c=c.parent)}function w(p){return c.children.push(p),p}i(t,{onObjectBegin:p=>{c=w({type:"object",offset:p,length:-1,parent:c,children:[]})},onObjectProperty:(p,k,y)=>{c=w({type:"property",offset:k,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:p,offset:k,length:y,parent:c})},onObjectEnd:(p,k)=>{c.length=p+k-c.offset,c=c.parent,r(p+k)},onArrayBegin:(p,k)=>{c=w({type:"array",offset:p,length:-1,parent:c,children:[]})},onArrayEnd:(p,k)=>{c.length=p+k-c.offset,c=c.parent,r(p+k)},onLiteralValue:(p,k,y)=>{w({type:o(p),offset:k,length:y,parent:c,value:p}),r(k+y)},onSeparator:(p,k,y)=>{c.type==="property"&&(p===":"?c.colonOffset=k:p===","&&r(k))},onError:(p,k,y)=>{g.push({error:p,offset:k,length:y})}},h);const D=c.children[0];return D&&delete D.parent,D}function v(t,g){if(!t)return;let h=t;for(const c of g)if(typeof c=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let r=!1;for(const w of h.children)if(Array.isArray(w.children)&&w.children[0].value===c){h=w.children[1],r=!0;break}if(!r)return}else{const r=c;if(h.type!=="array"||r<0||!Array.isArray(h.children)||r>=h.children.length)return;h=h.children[r]}return h}function u(t){if(!t.parent||!t.parent.children)return[];const g=u(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;g.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&g.push(h)}return g}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const g=Object.create(null);for(const h of t.children){const c=h.children[1];c&&(g[h.children[0].value]=f(c))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,g,h=!1){return g>=t.offset&&g<t.offset+t.length||h&&g===t.offset+t.length}function n(t,g,h=!1){if(a(t,g,h)){const c=t.children;if(Array.isArray(c))for(let r=0;r<c.length&&c[r].offset<=g;r++){const w=n(c[r],g,h);if(w)return w}return t}}function i(t,g,h=R.DEFAULT){const c=M(t,!1);function r(te){return te?()=>te(c.getTokenOffset(),c.getTokenLength()):()=>!0}function w(te){return te?we=>te(we,c.getTokenOffset(),c.getTokenLength()):()=>!0}const d=r(g.onObjectBegin),D=w(g.onObjectProperty),p=r(g.onObjectEnd),k=r(g.onArrayBegin),y=r(g.onArrayEnd),P=w(g.onLiteralValue),I=w(g.onSeparator),F=r(g.onComment),j=w(g.onError),z=h&&h.disallowComments,O=h&&h.allowTrailingComma;function T(){for(;;){const te=c.scan();switch(c.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(te){case 12:case 13:z?B(10):F();break;case 16:B(1);break;case 15:case 14:break;default:return te}}}function B(te,we=[],Se=[]){if(j(te),we.length+Se.length>0){let _=c.getToken();for(;_!==17;){if(we.indexOf(_)!==-1){T();break}else if(Se.indexOf(_)!==-1)break;_=T()}}}function W(te){const we=c.getTokenValue();return te?P(we):D(we),T(),!0}function X(){switch(c.getToken()){case 11:{let te=0;try{te=JSON.parse(c.getTokenValue()),typeof te!="number"&&(B(2),te=0)}catch{B(2)}P(te);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function x(){return c.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),c.getToken()===6?(I(":"),T(),ue()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Z(){d(),T();let te=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(te||B(4,[],[]),I(","),T(),c.getToken()===2&&O)break}else te&&B(6,[],[]);x()||B(4,[],[2,5]),te=!0}return p(),c.getToken()!==2?B(7,[2],[]):T(),!0}function Y(){k(),T();let te=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(te||B(4,[],[]),I(","),T(),c.getToken()===4&&O)break}else te&&B(6,[],[]);ue()||B(4,[],[4,5]),te=!0}return y(),c.getToken()!==4?B(8,[4],[]):T(),!0}function ue(){switch(c.getToken()){case 3:return Y();case 1:return Z();case 10:return W(!0);default:return X()}}return T(),c.getToken()===17?h.allowEmptyContent?!0:(B(4,[],[]),!1):ue()?(c.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function s(t,g){const h=M(t),c=[];let r,w=0,d;do switch(d=h.getPosition(),r=h.scan(),r){case 12:case 13:case 17:w!==d&&c.push(t.substring(w,d)),g!==void 0&&c.push(h.getTokenValue().replace(/[^\r\n]/g,g)),w=h.getPosition();break}while(r!==17);return c.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class l{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=l}),define(ke[75],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class l{static{this.Undefined=new l(void 0)}constructor(R){this.element=R,this.next=l.Undefined,this.prev=l.Undefined}}class N{constructor(){this.a=l.Undefined,this.b=l.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===l.Undefined}clear(){let R=this.a;for(;R!==l.Undefined;){const M=R.next;R.prev=l.Undefined,R.next=l.Undefined,R=M}this.a=l.Undefined,this.b=l.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const b=new l(R);if(this.a===l.Undefined)this.a=b,this.b=b;else if(M){const S=this.b;this.b=b,b.prev=S,S.next=b}else{const S=this.a;this.a=b,b.next=S,S.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==l.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==l.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==l.Undefined&&R.next!==l.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===l.Undefined&&R.next===l.Undefined?(this.a=l.Undefined,this.b=l.Undefined):R.next===l.Undefined?(this.b=this.b.prev,this.b.next=l.Undefined):R.prev===l.Undefined&&(this.a=this.a.next,this.a.prev=l.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==l.Undefined;)yield R.element,R=R.next}}e.$5c=N}),define(ke[27],Ee([1,0]),function(le,e){"use strict";var l,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=M,e.$Ac=b,e.$Ic=n;function R(i,s,o){let t=i.get(s);return t===void 0&&(t=o,i.set(s,t)),t}function M(i){const s=[];return i.forEach((o,t)=>{s.push(`${t} => ${o}`)}),`Map(${i.size}) {${s.join(", ")}}`}function b(i){const s=[];return i.forEach(o=>{s.push(o)}),`Set(${i.size}) {${s.join(", ")}}`}class ${constructor(s,o){this.uri=s,this.value=o}}function S(i){return Array.isArray(i)}class A{static{this.c=s=>s.toString()}constructor(s,o){if(this[l]="ResourceMap",s instanceof A)this.d=new Map(s.d),this.e=o??A.c;else if(S(s)){this.d=new Map,this.e=o??A.c;for(const[t,g]of s)this.set(t,g)}else this.d=new Map,this.e=s??A.c}set(s,o){return this.d.set(this.e(s),new $(s,o)),this}get(s){return this.d.get(this.e(s))?.value}has(s){return this.d.has(this.e(s))}get size(){return this.d.size}clear(){this.d.clear()}delete(s){return this.d.delete(this.e(s))}forEach(s,o){typeof o<"u"&&(s=s.bind(o));for(const[t,g]of this.d)s(g.value,g.uri,this)}*values(){for(const s of this.d.values())yield s.value}*keys(){for(const s of this.d.values())yield s.uri}*entries(){for(const s of this.d.values())yield[s.uri,s.value]}*[(l=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.d)yield[s.uri,s.value]}}e.$Bc=A;class C{constructor(s,o){this[N]="ResourceSet",!s||typeof s=="function"?this.c=new A(s):(this.c=new A(o),s.forEach(this.add,this))}get size(){return this.c.size}add(s){return this.c.set(s,s),this}clear(){this.c.clear()}delete(s){return this.c.delete(s)}forEach(s,o){this.c.forEach((t,g)=>s.call(o,g,g,this))}has(s){return this.c.has(s)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=C;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class E{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(s){return this.c.has(s)}get(s,o=0){const t=this.c.get(s);if(t)return o!==0&&this.l(t,o),t.value}set(s,o,t=0){let g=this.c.get(s);if(g)g.value=o,t!==0&&this.l(g,t);else{switch(g={key:s,value:o,next:void 0,previous:void 0},t){case 0:this.j(g);break;case 1:this.i(g);break;case 2:this.j(g);break;default:this.j(g);break}this.c.set(s,g),this.f++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this.c.get(s);if(o)return this.c.delete(s),this.k(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const s=this.d;return this.c.delete(s.key),this.k(s),this.f--,s.value}forEach(s,o){const t=this.g;let g=this.d;for(;g;){if(o?s.bind(o)(g.value,g.key,this):s(g.value,g.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const s=this,o=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(s.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.key,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return g}values(){const s=this,o=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(s.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.value,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return g}entries(){const s=this,o=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(s.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:[t.key,t.value],done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return g}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this.d,t=this.size;for(;o&&t>s;)this.c.delete(o.key),o=o.next,t--;this.d=o,this.f=t,o&&(o.previous=void 0),this.g++}i(s){if(!this.d&&!this.e)this.e=s;else if(this.d)s.next=this.d,this.d.previous=s;else throw new Error("Invalid list");this.d=s,this.g++}j(s){if(!this.d&&!this.e)this.d=s;else if(this.e)s.previous=this.e,this.e.next=s;else throw new Error("Invalid list");this.e=s,this.g++}k(s){if(s===this.d&&s===this.e)this.d=void 0,this.e=void 0;else if(s===this.d){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.d=s.next}else if(s===this.e){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.e=s.previous}else{const o=s.next,t=s.previous;if(!o||!t)throw new Error("Invalid list");o.previous=t,t.next=o}s.next=void 0,s.previous=void 0,this.g++}l(s,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this.d)return;const t=s.next,g=s.previous;s===this.e?(g.next=void 0,this.e=g):(t.previous=g,g.next=t),s.previous=void 0,s.next=this.d,this.d.previous=s,this.d=s,this.g++}else if(o===2){if(s===this.e)return;const t=s.next,g=s.previous;s===this.d?(t.previous=void 0,this.d=t):(t.previous=g,g.next=t),s.next=void 0,s.previous=this.e,this.e.next=s,this.e=s,this.g++}}}toJSON(){const s=[];return this.forEach((o,t)=>{s.push([t,o])}),s}fromJSON(s){this.clear();for(const[o,t]of s)this.set(o,t)}}e.$Dc=E;class v extends E{constructor(s,o=1){super(),this.m=s,this.n=Math.min(Math.max(0,o),1)}get limit(){return this.m}set limit(s){this.m=s,this.o()}get ratio(){return this.n}set ratio(s){this.n=Math.min(Math.max(0,s),1),this.o()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=v;class u{constructor(){this.c=new Map}add(s){return this.c.set(s,(this.c.get(s)||0)+1),this}delete(s){let o=this.c.get(s)||0;return o===0?!1:(o--,o===0?this.c.delete(s):this.c.set(s,o),!0)}has(s){return this.c.has(s)}}e.$Fc=u;class f{constructor(s){if(this.c=new Map,this.d=new Map,s)for(const[o,t]of s)this.set(o,t)}clear(){this.c.clear(),this.d.clear()}set(s,o){this.c.set(s,o),this.d.set(o,s)}get(s){return this.c.get(s)}getKey(s){return this.d.get(s)}delete(s){const o=this.c.get(s);return o===void 0?!1:(this.c.delete(s),this.d.delete(o),!0)}forEach(s,o){this.c.forEach((t,g)=>{s.call(o,t,g,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=f;class a{constructor(){this.c=new Map}add(s,o){let t=this.c.get(s);t||(t=new Set,this.c.set(s,t)),t.add(o)}delete(s,o){const t=this.c.get(s);t&&(t.delete(o),t.size===0&&this.c.delete(s))}forEach(s,o){const t=this.c.get(s);t&&t.forEach(o)}get(s){const o=this.c.get(s);return o||new Set}}e.$Hc=a;function n(i,s){if(i===s)return!0;if(i.size!==s.size)return!1;for(const[o,t]of i)if(!s.has(o)||s.get(o)!==t)return!1;for(const[o]of s)if(!i.has(o))return!1;return!0}}),define(ke[3],Ee([1,0,19,73,27,74,39]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=C,e.$Mc=m,e.$Nc=u,e.$Oc=f,e.$Pc=a,e.$Qc=n,e.$Rc=i,e.$Sc=s,e.$3c=p;const b=!1;let $=null;class S{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:S.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const F=this.c(P);F.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const F=I.get(P);if(F)return F;const j=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,j),j}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,I){let F;if(I)F=I;else{const B=new Map,W=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,B).isSingleton);if(W.length===0)return;const X=new Set(W.map(x=>x.value));if(F=W.filter(x=>!(x.parent&&X.has(x.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function j(B){function W(x,Z){for(;x.length>0&&Z.some(Y=>typeof Y=="string"?Y===x[0]:x[0].match(Y));)x.shift()}const X=B.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return W(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const z=new L.$Hc;for(const B of F){const W=j(B);for(let X=0;X<=W.length;X++)z.add(W.slice(0,X).join(`
`),B)}F.sort((0,l.$7b)(B=>B.idx,l.$9b));let O="",T=0;for(const B of F.slice(0,P)){T++;const W=j(B),X=[];for(let x=0;x<W.length;x++){let Z=W[x];Z=`(shared with ${z.get(W.slice(0,x+1).join(`
`)).size}/${F.length} leaks) at ${Z}`;const ue=z.get(W.slice(0,x).join(`
`)),te=(0,N.$K)([...ue].map(we=>j(we)[x]),we=>we);delete te[W[x]];for(const[we,Se]of Object.entries(te))X.unshift(`    - stacktraces of ${Se.length} other leaks continue with ${we}`);X.unshift(Z)}O+=`


==================== Leaking disposable ${T}/${F.length}: ${B.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return F.length>P&&(O+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:O}}}e.$Jc=S;function A(y){$=y}if(b){const y="__is_disposable_tracked__";A(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[y]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsSingleton(P){}})}function C(y){return $?.trackDisposable(y),y}function m(y){$?.markAsDisposed(y)}function E(y,P){$?.setParent(y,P)}function v(y,P){if($)for(const I of y)$.setParent(I,P)}function u(y){return $?.markAsSingleton(y),y}function f(y){return typeof y=="object"&&y!==null&&typeof y.dispose=="function"&&y.dispose.length===0}function a(y){if(M.Iterable.is(y)){const P=[];for(const I of y)if(I)try{I.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function n(y){for(const P of y)f(P)&&P.dispose();return[]}function i(...y){const P=s(()=>a(y));return v(y,P),P}function s(y){const P=C({dispose:(0,R.$db)(()=>{m(P),y()})});return P}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return E(P,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),E(P,null))}}e.$Tc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,C(this),E(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=t;class g{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&E(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&E(P,null),P}}e.$Vc=g;class h{constructor(P){this.a=new g,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=h;class c{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=c;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,m(this))},this}}e.$Yc=r;class w{constructor(){this.a=new Map}acquire(P,...I){let F=this.a.get(P);F||(F={counter:0,object:this.b(P,...I)},this.a.set(P,F));const{object:j}=F,z=(0,R.$db)(()=>{--F.counter===0&&(this.c(P,F.object),this.a.delete(P))});return F.counter++,{object:j,dispose:z}}}e.$Zc=w;class d{constructor(P){this.a=P}async acquire(P,...I){const F=this.a.acquire(P,...I);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(j){throw F.dispose(),j}}}e.$1c=d;class D{constructor(P){this.object=P}dispose(){}}e.$2c=D;function p(y){const P=new o;try{y(P)}finally{P.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=k}),function(le,e){typeof define=="function"&&define.amd?define(ke[165],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(se,re){for(var oe=0;oe<re.length;oe++){var G=re[oe];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(se,G.key,G)}}function l(se,re,oe){return re&&e(se.prototype,re),oe&&e(se,oe),Object.defineProperty(se,"prototype",{writable:!1}),se}function N(se,re){if(se){if(typeof se=="string")return L(se,re);var oe=Object.prototype.toString.call(se).slice(8,-1);if(oe==="Object"&&se.constructor&&(oe=se.constructor.name),oe==="Map"||oe==="Set")return Array.from(se);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return L(se,re)}}function L(se,re){(re==null||re>se.length)&&(re=se.length);for(var oe=0,G=new Array(re);oe<re;oe++)G[oe]=se[oe];return G}function R(se,re){var oe=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(oe)return(oe=oe.call(se)).next.bind(oe);if(Array.isArray(se)||(oe=N(se))||re&&se&&typeof se.length=="number"){oe&&(se=oe);var G=0;return function(){return G>=se.length?{done:!0}:{done:!1,value:se[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=M();function b(se){le.defaults=se}var $=/[&<>"']/,S=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(re){return m[re]};function v(se,re){if(re){if($.test(se))return se.replace(S,E)}else if(A.test(se))return se.replace(C,E);return se}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(se){return se.replace(u,function(re,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var a=/(^|[^\[])\^/g;function n(se,re){se=typeof se=="string"?se:se.source,re=re||"";var oe={replace:function(ie,me){return me=me.source||me,me=me.replace(a,"$1"),se=se.replace(ie,me),oe},getRegex:function(){return new RegExp(se,re)}};return oe}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(se,re,oe){if(se){var G;try{G=decodeURIComponent(f(oe)).replace(i,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}re&&!s.test(oe)&&(oe=r(re,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},g=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(se,re){t[" "+se]||(g.test(se)?t[" "+se]=se+"/":t[" "+se]=p(se,"/",!0)),se=t[" "+se];var oe=se.indexOf(":")===-1;return re.substring(0,2)==="//"?oe?re:se.replace(h,"$1")+re:re.charAt(0)==="/"?oe?re:se.replace(c,"$1")+re:se+re}var w={exec:function(){}};function d(se){for(var re=1,oe,G;re<arguments.length;re++){oe=arguments[re];for(G in oe)Object.prototype.hasOwnProperty.call(oe,G)&&(se[G]=oe[G])}return se}function D(se,re){var oe=se.replace(/\|/g,function(me,be,Ae){for(var fe=!1,De=be;--De>=0&&Ae[De]==="\\";)fe=!fe;return fe?"|":" |"}),G=oe.split(/ \|/),ie=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>re)G.splice(re);else for(;G.length<re;)G.push("");for(;ie<G.length;ie++)G[ie]=G[ie].trim().replace(/\\\|/g,"|");return G}function p(se,re,oe){var G=se.length;if(G===0)return"";for(var ie=0;ie<G;){var me=se.charAt(G-ie-1);if(me===re&&!oe)ie++;else if(me!==re&&oe)ie++;else break}return se.slice(0,G-ie)}function k(se,re){if(se.indexOf(re[1])===-1)return-1;for(var oe=se.length,G=0,ie=0;ie<oe;ie++)if(se[ie]==="\\")ie++;else if(se[ie]===re[0])G++;else if(se[ie]===re[1]&&(G--,G<0))return ie;return-1}function y(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(se,re){if(re<1)return"";for(var oe="";re>1;)re&1&&(oe+=se),re>>=1,se+=se;return oe+se}function I(se,re,oe,G){var ie=re.href,me=re.title?v(re.title):null,be=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){G.state.inLink=!0;var Ae={type:"link",raw:oe,href:ie,title:me,text:be,tokens:G.inlineTokens(be)};return G.state.inLink=!1,Ae}return{type:"image",raw:oe,href:ie,title:me,text:v(be)}}function F(se,re){var oe=se.match(/^(\s+)(?:```)/);if(oe===null)return re;var G=oe[1];return re.split(`
`).map(function(ie){var me=ie.match(/^\s+/);if(me===null)return ie;var be=me[0];return be.length>=G.length?ie.slice(G.length):ie}).join(`
`)}var j=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.space=function(G){var ie=this.rules.block.newline.exec(G);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},re.code=function(G){var ie=this.rules.block.code.exec(G);if(ie){var me=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?me:p(me,`
`)}}},re.fences=function(G){var ie=this.rules.block.fences.exec(G);if(ie){var me=ie[0],be=F(me,ie[3]||"");return{type:"code",raw:me,lang:ie[2]?ie[2].trim():ie[2],text:be}}},re.heading=function(G){var ie=this.rules.block.heading.exec(G);if(ie){var me=ie[2].trim();if(/#$/.test(me)){var be=p(me,"#");(this.options.pedantic||!be||/ $/.test(be))&&(me=be.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:me,tokens:this.lexer.inline(me)}}},re.hr=function(G){var ie=this.rules.block.hr.exec(G);if(ie)return{type:"hr",raw:ie[0]}},re.blockquote=function(G){var ie=this.rules.block.blockquote.exec(G);if(ie){var me=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},re.list=function(G){var ie=this.rules.block.list.exec(G);if(ie){var me,be,Ae,fe,De,Ie,Te,q,V,J,Q,he,pe=ie[1].trim(),ze=pe.length>1,Ve={type:"list",raw:"",ordered:ze,start:ze?+pe.slice(0,-1):"",loose:!1,items:[]};pe=ze?"\\d{1,9}\\"+pe.slice(-1):"\\"+pe,this.options.pedantic&&(pe=ze?pe:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(he=!1,!(!(ie=Ze.exec(G))||this.rules.block.hr.test(G)));){if(me=ie[0],G=G.substring(me.length),q=ie[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(fe=2,Q=q.trimLeft()):(fe=ie[2].search(/[^ ]/),fe=fe>4?1:fe,Q=q.slice(fe),fe+=ie[1].length),Ie=!1,!q&&/^ *$/.test(V)&&(me+=V+`
`,G=G.substring(V.length+1),he=!0),!he)for(var it=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");G&&(J=G.split(`
`,1)[0],q=J,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(q)||st.test(q)||it.test(q)||ot.test(G)));){if(q.search(/[^ ]/)>=fe||!q.trim())Q+=`
`+q.slice(fe);else if(!Ie)Q+=`
`+q;else break;!Ie&&!q.trim()&&(Ie=!0),me+=J+`
`,G=G.substring(J.length+1)}Ve.loose||(Te?Ve.loose=!0:/\n *\n *$/.test(me)&&(Te=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(Q),be&&(Ae=be[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:me,task:!!be,checked:Ae,loose:!1,text:Q}),Ve.raw+=me}Ve.items[Ve.items.length-1].raw=me.trimRight(),Ve.items[Ve.items.length-1].text=Q.trimRight(),Ve.raw=Ve.raw.trimRight();var Ce=Ve.items.length;for(De=0;De<Ce;De++){this.lexer.state.top=!1,Ve.items[De].tokens=this.lexer.blockTokens(Ve.items[De].text,[]);var Be=Ve.items[De].tokens.filter(function(Ne){return Ne.type==="space"}),He=Be.every(function(Ne){for(var Xe=Ne.raw.split(""),ae=0,ce=R(Xe),Re;!(Re=ce()).done;){var Ge=Re.value;if(Ge===`
`&&(ae+=1),ae>1)return!0}return!1});!Ve.loose&&Be.length&&He&&(Ve.loose=!0,Ve.items[De].loose=!0)}return Ve}},re.html=function(G){var ie=this.rules.block.html.exec(G);if(ie){var me={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]);me.type="paragraph",me.text=be,me.tokens=this.lexer.inline(be)}return me}},re.def=function(G){var ie=this.rules.block.def.exec(G);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var me=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ie[0],href:ie[2],title:ie[3]}}},re.table=function(G){var ie=this.rules.block.table.exec(G);if(ie){var me={type:"table",header:D(ie[1]).map(function(Te){return{text:Te}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ie[0];var be=me.align.length,Ae,fe,De,Ie;for(Ae=0;Ae<be;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(be=me.rows.length,Ae=0;Ae<be;Ae++)me.rows[Ae]=D(me.rows[Ae],me.header.length).map(function(Te){return{text:Te}});for(be=me.header.length,fe=0;fe<be;fe++)me.header[fe].tokens=this.lexer.inline(me.header[fe].text);for(be=me.rows.length,fe=0;fe<be;fe++)for(Ie=me.rows[fe],De=0;De<Ie.length;De++)Ie[De].tokens=this.lexer.inline(Ie[De].text);return me}}},re.lheading=function(G){var ie=this.rules.block.lheading.exec(G);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},re.paragraph=function(G){var ie=this.rules.block.paragraph.exec(G);if(ie){var me=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:me,tokens:this.lexer.inline(me)}}},re.text=function(G){var ie=this.rules.block.text.exec(G);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},re.escape=function(G){var ie=this.rules.inline.escape.exec(G);if(ie)return{type:"escape",raw:ie[0],text:v(ie[1])}},re.tag=function(G){var ie=this.rules.inline.tag.exec(G);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]}},re.link=function(G){var ie=this.rules.inline.link.exec(G);if(ie){var me=ie[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var be=p(me.slice(0,-1),"\\");if((me.length-be.length)%2===0)return}else{var Ae=k(ie[2],"()");if(Ae>-1){var fe=ie[0].indexOf("!")===0?5:4,De=fe+ie[1].length+Ae;ie[2]=ie[2].substring(0,Ae),ie[0]=ie[0].substring(0,De).trim(),ie[3]=""}}var Ie=ie[2],Te="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);q&&(Ie=q[1],Te=q[3])}else Te=ie[3]?ie[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(me)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),I(ie,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},re.reflink=function(G,ie){var me;if((me=this.rules.inline.reflink.exec(G))||(me=this.rules.inline.nolink.exec(G))){var be=(me[2]||me[1]).replace(/\s+/g," ");if(be=ie[be.toLowerCase()],!be||!be.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return I(me,be,me[0],this.lexer)}},re.emStrong=function(G,ie,me){me===void 0&&(me="");var be=this.rules.inline.emStrong.lDelim.exec(G);if(be&&!(be[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=be[1]||be[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var fe=be[0].length-1,De,Ie,Te=fe,q=0,V=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,ie=ie.slice(-1*G.length+fe);(be=V.exec(ie))!=null;)if(De=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!De){if(Ie=De.length,be[3]||be[4]){Te+=Ie;continue}else if((be[5]||be[6])&&fe%3&&!((fe+Ie)%3)){q+=Ie;continue}if(Te-=Ie,!(Te>0)){if(Ie=Math.min(Ie,Ie+Te+q),Math.min(fe,Ie)%2){var J=G.slice(1,fe+be.index+Ie);return{type:"em",raw:G.slice(0,fe+be.index+Ie+1),text:J,tokens:this.lexer.inlineTokens(J)}}var Q=G.slice(2,fe+be.index+Ie-1);return{type:"strong",raw:G.slice(0,fe+be.index+Ie+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},re.codespan=function(G){var ie=this.rules.inline.code.exec(G);if(ie){var me=ie[2].replace(/\n/g," "),be=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return be&&Ae&&(me=me.substring(1,me.length-1)),me=v(me,!0),{type:"codespan",raw:ie[0],text:me}}},re.br=function(G){var ie=this.rules.inline.br.exec(G);if(ie)return{type:"br",raw:ie[0]}},re.del=function(G){var ie=this.rules.inline.del.exec(G);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},re.autolink=function(G,ie){var me=this.rules.inline.autolink.exec(G);if(me){var be,Ae;return me[2]==="@"?(be=v(this.options.mangle?ie(me[1]):me[1]),Ae="mailto:"+be):(be=v(me[1]),Ae=be),{type:"link",raw:me[0],text:be,href:Ae,tokens:[{type:"text",raw:be,text:be}]}}},re.url=function(G,ie){var me;if(me=this.rules.inline.url.exec(G)){var be,Ae;if(me[2]==="@")be=v(this.options.mangle?ie(me[0]):me[0]),Ae="mailto:"+be;else{var fe;do fe=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(fe!==me[0]);be=v(me[0]),me[1]==="www."?Ae="http://"+be:Ae=be}return{type:"link",raw:me[0],text:be,href:Ae,tokens:[{type:"text",raw:be,text:be}]}}},re.inlineText=function(G,ie){var me=this.rules.inline.text.exec(G);if(me){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):v(me[0]):me[0]:be=v(this.options.smartypants?ie(me[0]):me[0]),{type:"text",raw:me[0],text:be}}},se}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:w,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=d({},z),z.gfm=d({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=d({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:w,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:w,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:w,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=n(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=n(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=n(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=n(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=n(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=n(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=n(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=n(O.reflink).replace("label",O._label).replace("ref",z._label).getRegex(),O.nolink=n(O.nolink).replace("ref",z._label).getRegex(),O.reflinkSearch=n(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=d({},O),O.pedantic=d({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=d({},O.normal,{escape:n(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=n(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=d({},O.gfm,{br:n(O.br).replace("{2,}","*").getRegex(),text:n(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(se){var re="",oe,G,ie=se.length;for(oe=0;oe<ie;oe++)G=se.charCodeAt(oe),Math.random()>.5&&(G="x"+G.toString(16)),re+="&#"+G+";";return re}var W=function(){function se(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||le.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:z.normal,inline:O.normal};this.options.pedantic?(G.block=z.pedantic,G.inline=O.pedantic):this.options.gfm&&(G.block=z.gfm,this.options.breaks?G.inline=O.breaks:G.inline=O.gfm),this.tokenizer.rules=G}se.lex=function(G,ie){var me=new se(ie);return me.lex(G)},se.lexInline=function(G,ie){var me=new se(ie);return me.inlineTokens(G)};var re=se.prototype;return re.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},re.blockTokens=function(G,ie){var me=this;ie===void 0&&(ie=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Te,q,V){return q+"    ".repeat(V.length)});for(var be,Ae,fe,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(be=Te.call({lexer:me},G,ie))?(G=G.substring(be.raw.length),ie.push(be),!0):!1}))){if(be=this.tokenizer.space(G)){G=G.substring(be.raw.length),be.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(be);continue}if(be=this.tokenizer.code(G)){G=G.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(be);continue}if(be=this.tokenizer.fences(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.heading(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.hr(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.blockquote(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.list(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.html(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.def(G)){G=G.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.lheading(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(fe=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,q=G.slice(1),V=void 0;me.options.extensions.startBlock.forEach(function(J){V=J.call({lexer:this},q),typeof V=="number"&&V>=0&&(Te=Math.min(Te,V))}),Te<1/0&&Te>=0&&(fe=G.substring(0,Te+1))}(),this.state.top&&(be=this.tokenizer.paragraph(fe))){Ae=ie[ie.length-1],De&&Ae.type==="paragraph"?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(be),De=fe.length!==G.length,G=G.substring(be.raw.length);continue}if(be=this.tokenizer.text(G)){G=G.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(be);continue}if(G){var Ie="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ie},re.inline=function(G,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:G,tokens:ie}),ie},re.inlineTokens=function(G,ie){var me=this;ie===void 0&&(ie=[]);var be,Ae,fe,De=G,Ie,Te,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)V.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Ie.index)+"["+P("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Ie.index)+"["+P("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Ie.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Te||(q=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(be=Q.call({lexer:me},G,ie))?(G=G.substring(be.raw.length),ie.push(be),!0):!1}))){if(be=this.tokenizer.escape(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.tag(G)){G=G.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&be.type==="text"&&Ae.type==="text"?(Ae.raw+=be.raw,Ae.text+=be.text):ie.push(be);continue}if(be=this.tokenizer.link(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&be.type==="text"&&Ae.type==="text"?(Ae.raw+=be.raw,Ae.text+=be.text):ie.push(be);continue}if(be=this.tokenizer.emStrong(G,De,q)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.codespan(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.br(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.del(G)){G=G.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.autolink(G,B)){G=G.substring(be.raw.length),ie.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(G,B))){G=G.substring(be.raw.length),ie.push(be);continue}if(fe=G,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,he=G.slice(1),pe=void 0;me.options.extensions.startInline.forEach(function(ze){pe=ze.call({lexer:this},he),typeof pe=="number"&&pe>=0&&(Q=Math.min(Q,pe))}),Q<1/0&&Q>=0&&(fe=G.substring(0,Q+1))}(),be=this.tokenizer.inlineText(fe,T)){G=G.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(q=be.raw.slice(-1)),Te=!0,Ae=ie[ie.length-1],Ae&&Ae.type==="text"?(Ae.raw+=be.raw,Ae.text+=be.text):ie.push(be);continue}if(G){var J="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ie},l(se,null,[{key:"rules",get:function(){return{block:z,inline:O}}}]),se}(),X=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.code=function(G,ie,me){var be=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(G,be);Ae!=null&&Ae!==G&&(me=!0,G=Ae)}return G=G.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+v(be,!0)+'">'+(me?G:v(G,!0))+`</code></pre>
`:"<pre><code>"+(me?G:v(G,!0))+`</code></pre>
`},re.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},re.html=function(G){return G},re.heading=function(G,ie,me,be){if(this.options.headerIds){var Ae=this.options.headerPrefix+be.slug(me);return"<h"+ie+' id="'+Ae+'">'+G+"</h"+ie+`>
`}return"<h"+ie+">"+G+"</h"+ie+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(G,ie,me){var be=ie?"ol":"ul",Ae=ie&&me!==1?' start="'+me+'"':"";return"<"+be+Ae+`>
`+G+"</"+be+`>
`},re.listitem=function(G){return"<li>"+G+`</li>
`},re.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(G){return"<p>"+G+`</p>
`},re.table=function(G,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ie+`</table>
`},re.tablerow=function(G){return`<tr>
`+G+`</tr>
`},re.tablecell=function(G,ie){var me=ie.header?"th":"td",be=ie.align?"<"+me+' align="'+ie.align+'">':"<"+me+">";return be+G+("</"+me+`>
`)},re.strong=function(G){return"<strong>"+G+"</strong>"},re.em=function(G){return"<em>"+G+"</em>"},re.codespan=function(G){return"<code>"+G+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(G){return"<del>"+G+"</del>"},re.link=function(G,ie,me){if(G=o(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var be='<a href="'+v(G)+'"';return ie&&(be+=' title="'+ie+'"'),be+=">"+me+"</a>",be},re.image=function(G,ie,me){if(G=o(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var be='<img src="'+G+'" alt="'+me+'"';return ie&&(be+=' title="'+ie+'"'),be+=this.options.xhtml?"/>":">",be},re.text=function(G){return G},se}(),x=function(){function se(){}var re=se.prototype;return re.strong=function(G){return G},re.em=function(G){return G},re.codespan=function(G){return G},re.del=function(G){return G},re.html=function(G){return G},re.text=function(G){return G},re.link=function(G,ie,me){return""+me},re.image=function(G,ie,me){return""+me},re.br=function(){return""},se}(),Z=function(){function se(){this.seen={}}var re=se.prototype;return re.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(G,ie){var me=G,be=0;if(this.seen.hasOwnProperty(me)){be=this.seen[G];do be++,me=G+"-"+be;while(this.seen.hasOwnProperty(me))}return ie||(this.seen[G]=be,this.seen[me]=0),me},re.slug=function(G,ie){ie===void 0&&(ie={});var me=this.serialize(G);return this.getNextSafeSlug(me,ie.dryrun)},se}(),Y=function(){function se(oe){this.options=oe||le.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Z}se.parse=function(G,ie){var me=new se(ie);return me.parse(G)},se.parseInline=function(G,ie){var me=new se(ie);return me.parseInline(G)};var re=se.prototype;return re.parse=function(G,ie){ie===void 0&&(ie=!0);var me="",be,Ae,fe,De,Ie,Te,q,V,J,Q,he,pe,ze,Ve,Ze,it,ot,nt,st,Ce=G.length;for(be=0;be<Ce;be++){if(Q=G[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(st=this.options.extensions.renderers[Q.type].call({parser:this},Q),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){me+=st||"";continue}switch(Q.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,f(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(V="",q="",De=Q.header.length,Ae=0;Ae<De;Ae++)q+=this.renderer.tablecell(this.parseInline(Q.header[Ae].tokens),{header:!0,align:Q.align[Ae]});for(V+=this.renderer.tablerow(q),J="",De=Q.rows.length,Ae=0;Ae<De;Ae++){for(Te=Q.rows[Ae],q="",Ie=Te.length,fe=0;fe<Ie;fe++)q+=this.renderer.tablecell(this.parseInline(Te[fe].tokens),{header:!1,align:Q.align[fe]});J+=this.renderer.tablerow(q)}me+=this.renderer.table(V,J);continue}case"blockquote":{J=this.parse(Q.tokens),me+=this.renderer.blockquote(J);continue}case"list":{for(he=Q.ordered,pe=Q.start,ze=Q.loose,De=Q.items.length,J="",Ae=0;Ae<De;Ae++)Ze=Q.items[Ae],it=Ze.checked,ot=Ze.task,Ve="",Ze.task&&(nt=this.renderer.checkbox(it),ze?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=nt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=nt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:nt}):Ve+=nt),Ve+=this.parse(Ze.tokens,ze),J+=this.renderer.listitem(Ve,ot,it);me+=this.renderer.list(J,he,pe);continue}case"html":{me+=this.renderer.html(Q.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(J=Q.tokens?this.parseInline(Q.tokens):Q.text;be+1<Ce&&G[be+1].type==="text";)Q=G[++be],J+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);me+=ie?this.renderer.paragraph(J):J;continue}default:{var Be='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return me},re.parseInline=function(G,ie){ie=ie||this.renderer;var me="",be,Ae,fe,De=G.length;for(be=0;be<De;be++){if(Ae=G[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(fe=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=fe||"";continue}switch(Ae.type){case"escape":{me+=ie.text(Ae.text);break}case"html":{me+=ie.html(Ae.text);break}case"link":{me+=ie.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ie));break}case"image":{me+=ie.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=ie.strong(this.parseInline(Ae.tokens,ie));break}case"em":{me+=ie.em(this.parseInline(Ae.tokens,ie));break}case"codespan":{me+=ie.codespan(Ae.text);break}case"br":{me+=ie.br();break}case"del":{me+=ie.del(this.parseInline(Ae.tokens,ie));break}case"text":{me+=ie.text(Ae.text);break}default:{var Ie='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return me},se}();function ue(se,re,oe){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof re=="function"&&(oe=re,re=null),re=d({},ue.defaults,re||{}),y(re),oe){var G=re.highlight,ie;try{ie=W.lex(se,re)}catch(De){return oe(De)}var me=function(Ie){var Te;if(!Ie)try{re.walkTokens&&ue.walkTokens(ie,re.walkTokens),Te=Y.parse(ie,re)}catch(q){Ie=q}return re.highlight=G,Ie?oe(Ie):oe(null,Te)};if(!G||G.length<3||(delete re.highlight,!ie.length))return me();var be=0;ue.walkTokens(ie,function(De){De.type==="code"&&(be++,setTimeout(function(){G(De.text,De.lang,function(Ie,Te){if(Ie)return me(Ie);Te!=null&&Te!==De.text&&(De.text=Te,De.escaped=!0),be--,be===0&&me()})},0))}),be===0&&me();return}function Ae(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+v(De.message+"",!0)+"</pre>";throw De}try{var fe=W.lex(se,re);if(re.walkTokens){if(re.async)return Promise.all(ue.walkTokens(fe,re.walkTokens)).then(function(){return Y.parse(fe,re)}).catch(Ae);ue.walkTokens(fe,re.walkTokens)}return Y.parse(fe,re)}catch(De){Ae(De)}}ue.options=ue.setOptions=function(se){return d(ue.defaults,se),b(ue.defaults),ue},ue.getDefaults=M,ue.defaults=le.defaults,ue.use=function(){for(var se=arguments.length,re=new Array(se),oe=0;oe<se;oe++)re[oe]=arguments[oe];var G=d.apply(void 0,[{}].concat(re)),ie=ue.defaults.extensions||{renderers:{},childTokens:{}},me;re.forEach(function(be){if(be.extensions&&(me=!0,be.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var De=ie.renderers?ie.renderers[fe.name]:null;De?ie.renderers[fe.name]=function(){for(var Ie=arguments.length,Te=new Array(Ie),q=0;q<Ie;q++)Te[q]=arguments[q];var V=fe.renderer.apply(this,Te);return V===!1&&(V=De.apply(this,Te)),V}:ie.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[fe.level]?ie[fe.level].unshift(fe.tokenizer):ie[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?ie.startBlock?ie.startBlock.push(fe.start):ie.startBlock=[fe.start]:fe.level==="inline"&&(ie.startInline?ie.startInline.push(fe.start):ie.startInline=[fe.start]))}fe.childTokens&&(ie.childTokens[fe.name]=fe.childTokens)})),be.renderer&&function(){var fe=ue.defaults.renderer||new X,De=function(q){var V=fe[q];fe[q]=function(){for(var J=arguments.length,Q=new Array(J),he=0;he<J;he++)Q[he]=arguments[he];var pe=be.renderer[q].apply(fe,Q);return pe===!1&&(pe=V.apply(fe,Q)),pe}};for(var Ie in be.renderer)De(Ie);G.renderer=fe}(),be.tokenizer&&function(){var fe=ue.defaults.tokenizer||new j,De=function(q){var V=fe[q];fe[q]=function(){for(var J=arguments.length,Q=new Array(J),he=0;he<J;he++)Q[he]=arguments[he];var pe=be.tokenizer[q].apply(fe,Q);return pe===!1&&(pe=V.apply(fe,Q)),pe}};for(var Ie in be.tokenizer)De(Ie);G.tokenizer=fe}(),be.walkTokens){var Ae=ue.defaults.walkTokens;G.walkTokens=function(fe){var De=[];return De.push(be.walkTokens.call(this,fe)),Ae&&(De=De.concat(Ae.call(this,fe))),De}}me&&(G.extensions=ie),ue.setOptions(G)})},ue.walkTokens=function(se,re){for(var oe=[],G=function(){var Ae=me.value;switch(oe=oe.concat(re.call(ue,Ae)),Ae.type){case"table":{for(var fe=R(Ae.header),De;!(De=fe()).done;){var Ie=De.value;oe=oe.concat(ue.walkTokens(Ie.tokens,re))}for(var Te=R(Ae.rows),q;!(q=Te()).done;)for(var V=q.value,J=R(V),Q;!(Q=J()).done;){var he=Q.value;oe=oe.concat(ue.walkTokens(he.tokens,re))}break}case"list":{oe=oe.concat(ue.walkTokens(Ae.items,re));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Ae.type]?ue.defaults.extensions.childTokens[Ae.type].forEach(function(pe){oe=oe.concat(ue.walkTokens(Ae[pe],re))}):Ae.tokens&&(oe=oe.concat(ue.walkTokens(Ae.tokens,re)))}},ie=R(se),me;!(me=ie()).done;)G();return oe},ue.parseInline=function(se,re){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");re=d({},ue.defaults,re||{}),y(re);try{var oe=W.lexInline(se,re);return re.walkTokens&&ue.walkTokens(oe,re.walkTokens),Y.parseInline(oe,re)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+v(G.message+"",!0)+"</pre>";throw G}},ue.Parser=Y,ue.parser=Y.parse,ue.Renderer=X,ue.TextRenderer=x,ue.Lexer=W,ue.lexer=W.lex,ue.Tokenizer=j,ue.Slugger=Z,ue.parse=ue;var te=ue.options,we=ue.setOptions,Se=ue.use,_=ue.walkTokens,U=ue.parseInline,ne=ue,$e=Y.parse,Pe=W.lex;le.Lexer=W,le.Parser=Y,le.Renderer=X,le.Slugger=Z,le.TextRenderer=x,le.Tokenizer=j,le.getDefaults=M,le.lexer=Pe,le.marked=ue,le.options=te,le.parse=ne,le.parseInline=U,le.parser=$e,le.setOptions=we,le.use=Se,le.walkTokens=_,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[166],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=l;function l(u){const f=R(u);if(f&&f.length>0)return new Uint32Array(f)}let N=0;const L=new Uint32Array(10);function R(u){if(N=0,M(u,C,4352),N>0||(M(u,m,4449),N>0)||(M(u,E,4520),N>0)||(M(u,v,12593),N))return L.subarray(0,N);if(u>=44032&&u<=55203){const f=u-44032,a=f%588,n=Math.floor(f/588),i=Math.floor(a/28),s=a%28-1;if(n<C.length?M(n,C,0):4352+n-12593<v.length&&M(4352+n,v,12593),i<m.length?M(i,m,0):4449+i-12593<v.length&&M(4449+i-12593,v,12593),s>=0&&(s<E.length?M(s,E,0):4520+s-12593<v.length&&M(4520+s-12593,v,12593)),N>0)return L.subarray(0,N)}}function M(u,f,a){u>=a&&u<a+f.length&&b(f[u-a])}function b(u){u!==0&&(L[N++]=u&255,u>>8&&(L[N++]=u>>8&255),u>>16&&(L[N++]=u>>16&255))}var $;(function(u){u[u.InitialConsonant=4352]="InitialConsonant",u[u.Vowel=4449]="Vowel",u[u.FinalConsonant=4520]="FinalConsonant",u[u.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var S;(function(u){u[u.NUL=0]="NUL",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z"})(S||(S={}));var A;(function(u){u[u.fa=24934]="fa",u[u.fg=26470]="fg",u[u.fq=29030]="fq",u[u.fr=29286]="fr",u[u.ft=29798]="ft",u[u.fv=30310]="fv",u[u.fx=30822]="fx",u[u.hk=27496]="hk",u[u.hl=27752]="hl",u[u.ho=28520]="ho",u[u.ml=27757]="ml",u[u.nj=27246]="nj",u[u.nl=27758]="nl",u[u.np=28782]="np",u[u.qt=29809]="qt",u[u.rt=29810]="rt",u[u.sg=26483]="sg",u[u.sw=30579]="sw"})(A||(A={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Ee([1,0,27]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=void 0,e.$8l=L,e.$9l=M;const N=new l.$Ec(1e4);function L(S){return $(S,"NFC",N)}const R=new l.$Ec(1e4);function M(S){return $(S,"NFD",R)}const b=/[^\u0000-\u0080]/;function $(S,A,C){if(!S)return S;const m=C.get(S);if(m)return m;let E;return b.test(S)?E=S.normalize(A):E=S,C.set(S,E),E}e.$0l=function(){const S=/[\u0300-\u036f]/g;return function(A){return M(A).replace(S,"")}}()}),define(ke[125],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=l,e.rot=N;function l(b,$,S){return Math.min(Math.max(b,$),S)}function N(b,$){return($+b%$)%$}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=L;class R{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=R;class M{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const S=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=M}),function(){function le(L){const R=[];typeof L=="number"&&R.push("code/timeOrigin",L);function M($){R.push($,Date.now())}function b(){const $=[];for(let S=0;S<R.length;S+=2)$.push({name:R[S],startTime:R[S+1]});return $}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(L+M.startTime)});return R}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function l(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=l(N))}(),define(ke[167],Ee([1,0,39]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=void 0;const N=Symbol("unset");class L{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||l.Iterable.empty()}insert($,S,A){this.d($,C=>C._value=S,A)}mutate($,S){this.d($,A=>A._value=S(A._value===N?void 0:A._value))}delete($){const S=this.c($);if(!S)return;let A=S.length-1;const C=S[A].node._value;if(C!==N){for(this.b--,S[A].node._value=N;A>0;A--){const{node:m,part:E}=S[A];if(m.children?.size||m._value!==N)break;S[A-1].node.children.delete(E)}return C}}*deleteRecursive($){const S=this.c($);if(!S)return;const A=S[S.length-1].node;for(let C=S.length-1;C>0;C--){const m=S[C-1];if(m.node.children.delete(S[C].part),m.node.children.size>0||m.node._value!==N)break}for(const C of R(A))C._value!==N&&(this.b--,yield C._value)}find($){let S=this.a;for(const A of $){const C=S.children?.get(A);if(!C)return;S=C}return S._value===N?void 0:S._value}hasKeyOrParent($){let S=this.a;for(const A of $){const C=S.children?.get(A);if(!C)return!1;if(C._value!==N)return!0;S=C}return!1}hasKeyOrChildren($){let S=this.a;for(const A of $){const C=S.children?.get(A);if(!C)return!1;S=C}return!0}hasKey($){let S=this.a;for(const A of $){const C=S.children?.get(A);if(!C)return!1;S=C}return S._value!==N}c($){const S=[{part:"",node:this.a}];let A=0;for(const C of $){const m=S[A].node.children?.get(C);if(!m)return;S.push({part:C,node:m}),A++}return S}d($,S,A){let C=this.a;for(const v of $){if(C.children)if(C.children.has(v))C=C.children.get(v);else{const u=new M;C.children.set(v,u),C=u}else{const u=new M;C.children=new Map([[v,u]]),C=u}A?.(C)}const m=C._value===N?0:1;S(C);const E=C._value===N?0:1;this.b+=E-m}*values(){for(const{_value:$}of R(this.a))$!==N&&(yield $)}}e.$4O=L;function*R(b){const $=[b];for(;$.length>0;){const S=$.pop();if(yield S,S.children)for(const A of S.children.values())$.push(A)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value($){this._value=$===void 0?N:$}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var N in l)(typeof exports=="object"?exports:le)[N]=l[N]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function l(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return le[N].call(L.exports,L,L.exports,l),L.l=!0,L.exports}return l.m=le,l.c=e,l.d=function(N,L,R){l.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:R})},l.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},l.t=function(N,L){if(1&L&&(N=l(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var R=Object.create(null);if(l.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var M in N)l.d(R,M,function(b){return N[b]}.bind(null,M));return R},l.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return l.d(L,"a",L),L},l.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},l.p="",l(l.s=0)}([function(le,e,l){(function(N){var L;e=le.exports=Se,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],S=0,A=S++;$[A]="0|[1-9]\\d*";var C=S++;$[C]="[0-9]+";var m=S++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=S++;$[E]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var v=S++;$[v]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var u=S++;$[u]="(?:"+$[A]+"|"+$[m]+")";var f=S++;$[f]="(?:"+$[C]+"|"+$[m]+")";var a=S++;$[a]="(?:-("+$[u]+"(?:\\."+$[u]+")*))";var n=S++;$[n]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var i=S++;$[i]="[0-9A-Za-z-]+";var s=S++;$[s]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var o=S++,t="v?"+$[E]+$[a]+"?"+$[s]+"?";$[o]="^"+t+"$";var g="[v=\\s]*"+$[v]+$[n]+"?"+$[s]+"?",h=S++;$[h]="^"+g+"$";var c=S++;$[c]="((?:<|>)?=?)";var r=S++;$[r]=$[C]+"|x|X|\\*";var w=S++;$[w]=$[A]+"|x|X|\\*";var d=S++;$[d]="[v=\\s]*("+$[w]+")(?:\\.("+$[w]+")(?:\\.("+$[w]+")(?:"+$[a]+")?"+$[s]+"?)?)?";var D=S++;$[D]="[v=\\s]*("+$[r]+")(?:\\.("+$[r]+")(?:\\.("+$[r]+")(?:"+$[n]+")?"+$[s]+"?)?)?";var p=S++;$[p]="^"+$[c]+"\\s*"+$[d]+"$";var k=S++;$[k]="^"+$[c]+"\\s*"+$[D]+"$";var y=S++;$[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=S++;$[P]="(?:~>?)";var I=S++;$[I]="(\\s*)"+$[P]+"\\s+",b[I]=new RegExp($[I],"g");var F=S++;$[F]="^"+$[P]+$[d]+"$";var j=S++;$[j]="^"+$[P]+$[D]+"$";var z=S++;$[z]="(?:\\^)";var O=S++;$[O]="(\\s*)"+$[z]+"\\s+",b[O]=new RegExp($[O],"g");var T=S++;$[T]="^"+$[z]+$[d]+"$";var B=S++;$[B]="^"+$[z]+$[D]+"$";var W=S++;$[W]="^"+$[c]+"\\s*("+g+")$|^$";var X=S++;$[X]="^"+$[c]+"\\s*("+t+")$|^$";var x=S++;$[x]="(\\s*)"+$[c]+"\\s*("+g+"|"+$[d]+")",b[x]=new RegExp($[x],"g");var Z=S++;$[Z]="^\\s*("+$[d]+")\\s+-\\s+("+$[d]+")\\s*$";var Y=S++;$[Y]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var ue=S++;$[ue]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)L(te,$[te]),b[te]||(b[te]=new RegExp($[te]));function we(V,J){if(V instanceof Se)return V;if(typeof V!="string"||V.length>R||!(J?b[h]:b[o]).test(V))return null;try{return new Se(V,J)}catch{return null}}function Se(V,J){if(V instanceof Se){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Se))return new Se(V,J);L("SemVer",V,J),this.loose=J;var Q=V.trim().match(J?b[h]:b[o]);if(!Q)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<M)return pe}return he}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=we,e.valid=function(V,J){var Q=we(V,J);return Q?Q.version:null},e.clean=function(V,J){var Q=we(V.trim().replace(/^[=v]+/,""),J);return Q?Q.version:null},e.SemVer=Se,Se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Se.prototype.toString=function(){return this.version},Se.prototype.compare=function(V){return L("SemVer.compare",this.version,this.loose,V),V instanceof Se||(V=new Se(V,this.loose)),this.compareMain(V)||this.comparePre(V)},Se.prototype.compareMain=function(V){return V instanceof Se||(V=new Se(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},Se.prototype.comparePre=function(V){if(V instanceof Se||(V=new Se(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var Q=this.prerelease[J],he=V.prerelease[J];if(L("prerelease compare",J,Q,he),Q===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(Q===void 0)return-1;if(Q!==he)return U(Q,he)}while(++J)},Se.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,Q,he){typeof Q=="string"&&(he=Q,Q=void 0);try{return new Se(V,Q).inc(J,he).version}catch{return null}},e.diff=function(V,J){if(se(V,J))return null;var Q=we(V),he=we(J);if(Q.prerelease.length||he.prerelease.length){for(var pe in Q)if((pe==="major"||pe==="minor"||pe==="patch")&&Q[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in Q)if((pe==="major"||pe==="minor"||pe==="patch")&&Q[pe]!==he[pe])return pe},e.compareIdentifiers=U;var _=/^[0-9]+$/;function U(V,J){var Q=_.test(V),he=_.test(J);return Q&&he&&(V=+V,J=+J),Q&&!he?-1:he&&!Q?1:V<J?-1:V>J?1:0}function ne(V,J,Q){return new Se(V,Q).compare(new Se(J,Q))}function $e(V,J,Q){return ne(V,J,Q)>0}function Pe(V,J,Q){return ne(V,J,Q)<0}function se(V,J,Q){return ne(V,J,Q)===0}function re(V,J,Q){return ne(V,J,Q)!==0}function oe(V,J,Q){return ne(V,J,Q)>=0}function G(V,J,Q){return ne(V,J,Q)<=0}function ie(V,J,Q,he){var pe;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof Q=="object"&&(Q=Q.version),pe=V===Q;break;case"!==":typeof V=="object"&&(V=V.version),typeof Q=="object"&&(Q=Q.version),pe=V!==Q;break;case"":case"=":case"==":pe=se(V,Q,he);break;case"!=":pe=re(V,Q,he);break;case">":pe=$e(V,Q,he);break;case">=":pe=oe(V,Q,he);break;case"<":pe=Pe(V,Q,he);break;case"<=":pe=G(V,Q,he);break;default:throw new TypeError("Invalid operator: "+J)}return pe}function me(V,J){if(V instanceof me){if(V.loose===J)return V;V=V.value}if(!(this instanceof me))return new me(V,J);L("comparator",V,J),this.loose=J,this.parse(V),this.semver===be?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(V,J){return U(J,V)},e.major=function(V,J){return new Se(V,J).major},e.minor=function(V,J){return new Se(V,J).minor},e.patch=function(V,J){return new Se(V,J).patch},e.compare=ne,e.compareLoose=function(V,J){return ne(V,J,!0)},e.rcompare=function(V,J,Q){return ne(J,V,Q)},e.sort=function(V,J){return V.sort(function(Q,he){return e.compare(Q,he,J)})},e.rsort=function(V,J){return V.sort(function(Q,he){return e.rcompare(Q,he,J)})},e.gt=$e,e.lt=Pe,e.eq=se,e.neq=re,e.gte=oe,e.lte=G,e.cmp=ie,e.Comparator=me;var be={};function Ae(V,J){if(V instanceof Ae)return V.loose===J?V:new Ae(V.raw,J);if(V instanceof me)return new Ae(V.value,J);if(!(this instanceof Ae))return new Ae(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function fe(V){return!V||V.toLowerCase()==="x"||V==="*"}function De(V,J,Q,he,pe,ze,Ve,Ze,it,ot,nt,st,Ce){return((J=fe(Q)?"":fe(he)?">="+Q+".0.0":fe(pe)?">="+Q+"."+he+".0":">="+J)+" "+(Ze=fe(it)?"":fe(ot)?"<"+(+it+1)+".0.0":fe(nt)?"<"+it+"."+(+ot+1)+".0":st?"<="+it+"."+ot+"."+nt+"-"+st:"<="+Ze)).trim()}function Ie(V,J){for(var Q=0;Q<V.length;Q++)if(!V[Q].test(J))return!1;if(J.prerelease.length){for(Q=0;Q<V.length;Q++)if(L(V[Q].semver),V[Q].semver!==be&&V[Q].semver.prerelease.length>0){var he=V[Q].semver;if(he.major===J.major&&he.minor===J.minor&&he.patch===J.patch)return!0}return!1}return!0}function Te(V,J,Q){try{J=new Ae(J,Q)}catch{return!1}return J.test(V)}function q(V,J,Q,he){var pe,ze,Ve,Ze,it;switch(V=new Se(V,he),J=new Ae(J,he),Q){case">":pe=$e,ze=G,Ve=Pe,Ze=">",it=">=";break;case"<":pe=Pe,ze=oe,Ve=$e,Ze="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(V,J,he))return!1;for(var ot=0;ot<J.set.length;++ot){var nt=J.set[ot],st=null,Ce=null;if(nt.forEach(function(Be){Be.semver===be&&(Be=new me(">=0.0.0")),st=st||Be,Ce=Ce||Be,pe(Be.semver,st.semver,he)?st=Be:Ve(Be.semver,Ce.semver,he)&&(Ce=Be)}),st.operator===Ze||st.operator===it||(!Ce.operator||Ce.operator===Ze)&&ze(V,Ce.semver)||Ce.operator===it&&Ve(V,Ce.semver))return!1}return!0}me.prototype.parse=function(V){var J=this.loose?b[W]:b[X],Q=V.match(J);if(!Q)throw new TypeError("Invalid comparator: "+V);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new Se(Q[2],this.loose):this.semver=be},me.prototype.toString=function(){return this.value},me.prototype.test=function(V){return L("Comparator.test",V,this.loose),this.semver===be||(typeof V=="string"&&(V=new Se(V,this.loose)),ie(V,this.operator,this.semver,this.loose))},me.prototype.intersects=function(V,J){if(!(V instanceof me))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Ae(V.value,J),Te(this.value,Q,J);if(V.operator==="")return Q=new Ae(this.value,J),Te(V.semver,Q,J);var he=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),ze=this.semver.version===V.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ze=ie(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),it=ie(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return he||pe||ze&&Ve||Ze||it},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),L("range",V,J);var Q=J?b[Y]:b[Z];V=V.replace(Q,De),L("hyphen replace",V),V=V.replace(b[x],"$1$2$3"),L("comparator trim",V,b[x]),V=(V=(V=V.replace(b[I],"$1~")).replace(b[O],"$1^")).split(/\s+/).join(" ");var he=J?b[W]:b[X],pe=V.split(" ").map(function(ze){return function(Ve,Ze){return L("comp",Ve),Ve=function(it,ot){return it.trim().split(/\s+/).map(function(nt){return function(st,Ce){L("caret",st,Ce);var Be=Ce?b[B]:b[T];return st.replace(Be,function(He,Ne,Xe,ae,ce){var Re;return L("caret",st,He,Ne,Xe,ae,ce),fe(Ne)?Re="":fe(Xe)?Re=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":fe(ae)?Re=Ne==="0"?">="+Ne+"."+Xe+".0 <"+Ne+"."+(+Xe+1)+".0":">="+Ne+"."+Xe+".0 <"+(+Ne+1)+".0.0":ce?(L("replaceCaret pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Re=Ne==="0"?Xe==="0"?">="+Ne+"."+Xe+"."+ae+ce+" <"+Ne+"."+Xe+"."+(+ae+1):">="+Ne+"."+Xe+"."+ae+ce+" <"+Ne+"."+(+Xe+1)+".0":">="+Ne+"."+Xe+"."+ae+ce+" <"+(+Ne+1)+".0.0"):(L("no pr"),Re=Ne==="0"?Xe==="0"?">="+Ne+"."+Xe+"."+ae+" <"+Ne+"."+Xe+"."+(+ae+1):">="+Ne+"."+Xe+"."+ae+" <"+Ne+"."+(+Xe+1)+".0":">="+Ne+"."+Xe+"."+ae+" <"+(+Ne+1)+".0.0"),L("caret return",Re),Re})}(nt,ot)}).join(" ")}(Ve,Ze),L("caret",Ve),Ve=function(it,ot){return it.trim().split(/\s+/).map(function(nt){return function(st,Ce){var Be=Ce?b[j]:b[F];return st.replace(Be,function(He,Ne,Xe,ae,ce){var Re;return L("tilde",st,He,Ne,Xe,ae,ce),fe(Ne)?Re="":fe(Xe)?Re=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":fe(ae)?Re=">="+Ne+"."+Xe+".0 <"+Ne+"."+(+Xe+1)+".0":ce?(L("replaceTilde pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Re=">="+Ne+"."+Xe+"."+ae+ce+" <"+Ne+"."+(+Xe+1)+".0"):Re=">="+Ne+"."+Xe+"."+ae+" <"+Ne+"."+(+Xe+1)+".0",L("tilde return",Re),Re})}(nt,ot)}).join(" ")}(Ve,Ze),L("tildes",Ve),Ve=function(it,ot){return L("replaceXRanges",it,ot),it.split(/\s+/).map(function(nt){return function(st,Ce){st=st.trim();var Be=Ce?b[k]:b[p];return st.replace(Be,function(He,Ne,Xe,ae,ce,Re){L("xRange",st,He,Ne,Xe,ae,ce,Re);var Ge=fe(Xe),Me=Ge||fe(ae),tt=Me||fe(ce);return Ne==="="&&tt&&(Ne=""),Ge?He=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&tt?(Me&&(ae=0),tt&&(ce=0),Ne===">"?(Ne=">=",Me?(Xe=+Xe+1,ae=0,ce=0):tt&&(ae=+ae+1,ce=0)):Ne==="<="&&(Ne="<",Me?Xe=+Xe+1:ae=+ae+1),He=Ne+Xe+"."+ae+"."+ce):Me?He=">="+Xe+".0.0 <"+(+Xe+1)+".0.0":tt&&(He=">="+Xe+"."+ae+".0 <"+Xe+"."+(+ae+1)+".0"),L("xRange return",He),He})}(nt,ot)}).join(" ")}(Ve,Ze),L("xrange",Ve),Ve=function(it,ot){return L("replaceStars",it,ot),it.trim().replace(b[ue],"")}(Ve,Ze),L("stars",Ve),Ve}(ze,J)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(ze){return!!ze.match(he)})),pe=pe.map(function(ze){return new me(ze,J)})},Ae.prototype.intersects=function(V,J){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(he){return V.set.some(function(pe){return pe.every(function(ze){return he.intersects(ze,J)})})})})},e.toComparators=function(V,J){return new Ae(V,J).set.map(function(Q){return Q.map(function(he){return he.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new Se(V,this.loose));for(var J=0;J<this.set.length;J++)if(Ie(this.set[J],V))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(V,J,Q){var he=null,pe=null;try{var ze=new Ae(J,Q)}catch{return null}return V.forEach(function(Ve){ze.test(Ve)&&(he&&pe.compare(Ve)!==-1||(pe=new Se(he=Ve,Q)))}),he},e.minSatisfying=function(V,J,Q){var he=null,pe=null;try{var ze=new Ae(J,Q)}catch{return null}return V.forEach(function(Ve){ze.test(Ve)&&(he&&pe.compare(Ve)!==1||(pe=new Se(he=Ve,Q)))}),he},e.validRange=function(V,J){try{return new Ae(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,Q){return q(V,J,"<",Q)},e.gtr=function(V,J,Q){return q(V,J,">",Q)},e.outside=q,e.prerelease=function(V,J){var Q=we(V,J);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(V,J,Q){return V=new Ae(V,Q),J=new Ae(J,Q),V.intersects(J)},e.coerce=function(V){if(V instanceof Se)return V;if(typeof V!="string")return null;var J=V.match(b[y]);return J==null?null:we((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,l(1))},function(le,e){var l,N,L=le.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(f){if(l===setTimeout)return setTimeout(f,0);if((l===R||!l)&&setTimeout)return l=setTimeout,setTimeout(f,0);try{return l(f,0)}catch{try{return l.call(null,f,0)}catch{return l.call(this,f,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:R}catch{l=R}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var $,S=[],A=!1,C=-1;function m(){A&&$&&(A=!1,$.length?S=$.concat(S):C=-1,S.length&&E())}function E(){if(!A){var f=b(m);A=!0;for(var a=S.length;a;){for($=S,S=[];++C<a;)$&&$[C].run();C=-1,a=S.length}$=null,A=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(f)}}function v(f,a){this.fun=f,this.array=a}function u(){}L.nextTick=function(f){var a=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)a[n-1]=arguments[n];S.push(new v(f,a)),S.length!==1||A||b(E)},v.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=u,L.addListener=u,L.once=u,L.off=u,L.removeListener=u,L.removeAllListeners=u,L.emit=u,L.prependListener=u,L.prependOnceListener=u,L.listeners=function(f){return[]},L.binding=function(f){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(f){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ke[40],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const l=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(R){return new N(R)}constructor(R){this.c=l&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=N}),define(ke[4],Ee([1,0,13,74,3,75,40]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=E;const b=!1,$=!1,S=!1;var A;(function(I){I.None=()=>L.$Uc.None;function F(Ae){if(S){const{onDidAddListener:fe}=Ae,De=u.create();let Ie=0;Ae.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),fe?.()}}}function j(Ae,fe){return ue(Ae,()=>{},0,void 0,!0,void 0,fe)}I.defer=j;function z(Ae){return(fe,De=null,Ie)=>{let Te=!1,q;return q=Ae(V=>{if(!Te)return q?q.dispose():Te=!0,fe.call(De,V)},null,Ie),Te&&q.dispose(),q}}I.once=z;function O(Ae,fe,De){return Z((Ie,Te=null,q)=>Ae(V=>Ie.call(Te,fe(V)),null,q),De)}I.map=O;function T(Ae,fe,De){return Z((Ie,Te=null,q)=>Ae(V=>{fe(V),Ie.call(Te,V)},null,q),De)}I.forEach=T;function B(Ae,fe,De){return Z((Ie,Te=null,q)=>Ae(V=>fe(V)&&Ie.call(Te,V),null,q),De)}I.filter=B;function W(Ae){return Ae}I.signal=W;function X(...Ae){return(fe,De=null,Ie)=>{const Te=(0,L.$Rc)(...Ae.map(q=>q(V=>fe.call(De,V))));return Y(Te,Ie)}}I.any=X;function x(Ae,fe,De,Ie){let Te=De;return O(Ae,q=>(Te=fe(Te,q),Te),Ie)}I.reduce=x;function Z(Ae,fe){let De;const Ie={onWillAddFirstListener(){De=Ae(Te.fire,Te)},onDidRemoveLastListener(){De?.dispose()}};fe||F(Ie);const Te=new o(Ie);return fe?.add(Te),Te.event}function Y(Ae,fe){return fe instanceof Array?fe.push(Ae):fe&&fe.add(Ae),Ae}function ue(Ae,fe,De=100,Ie=!1,Te=!1,q,V){let J,Q,he,pe=0,ze;const Ve={leakWarningThreshold:q,onWillAddFirstListener(){J=Ae(it=>{pe++,Q=fe(Q,it),Ie&&!he&&(Ze.fire(Q),Q=void 0),ze=()=>{const ot=Q;Q=void 0,he=void 0,(!Ie||pe>1)&&Ze.fire(ot),pe=0},typeof De=="number"?(clearTimeout(he),he=setTimeout(ze,De)):he===void 0&&(he=0,queueMicrotask(ze))})},onWillRemoveListener(){Te&&pe>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,J.dispose()}};V||F(Ve);const Ze=new o(Ve);return V?.add(Ze),Ze.event}I.debounce=ue;function te(Ae,fe=0,De){return I.debounce(Ae,(Ie,Te)=>Ie?(Ie.push(Te),Ie):[Te],fe,void 0,!0,void 0,De)}I.accumulate=te;function we(Ae,fe=(Ie,Te)=>Ie===Te,De){let Ie=!0,Te;return B(Ae,q=>{const V=Ie||!fe(q,Te);return Ie=!1,Te=q,V},De)}I.latch=we;function Se(Ae,fe,De){return[I.filter(Ae,fe,De),I.filter(Ae,Ie=>!fe(Ie),De)]}I.split=Se;function _(Ae,fe=!1,De=[],Ie){let Te=De.slice(),q=Ae(Q=>{Te?Te.push(Q):J.fire(Q)});Ie&&Ie.add(q);const V=()=>{Te?.forEach(Q=>J.fire(Q)),Te=null},J=new o({onWillAddFirstListener(){q||(q=Ae(Q=>J.fire(Q)),Ie&&Ie.add(q))},onDidAddFirstListener(){Te&&(fe?setTimeout(V):V())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return Ie&&Ie.add(J),J.event}I.buffer=_;function U(Ae,fe){return(Ie,Te,q)=>{const V=fe(new $e);return Ae(function(J){const Q=V.evaluate(J);Q!==ne&&Ie.call(Te,Q)},void 0,q)}}I.chain=U;const ne=Symbol("HaltChainable");class $e{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(De=>(fe(De),De)),this}filter(fe){return this.f.push(De=>fe(De)?De:ne),this}reduce(fe,De){let Ie=De;return this.f.push(Te=>(Ie=fe(Ie,Te),Ie)),this}latch(fe=(De,Ie)=>De===Ie){let De=!0,Ie;return this.f.push(Te=>{const q=De||!fe(Te,Ie);return De=!1,Ie=Te,q?Te:ne}),this}evaluate(fe){for(const De of this.f)if(fe=De(fe),fe===ne)break;return fe}}function Pe(Ae,fe,De=Ie=>Ie){const Ie=(...J)=>V.fire(De(...J)),Te=()=>Ae.on(fe,Ie),q=()=>Ae.removeListener(fe,Ie),V=new o({onWillAddFirstListener:Te,onDidRemoveLastListener:q});return V.event}I.fromNodeEventEmitter=Pe;function se(Ae,fe,De=Ie=>Ie){const Ie=(...J)=>V.fire(De(...J)),Te=()=>Ae.addEventListener(fe,Ie),q=()=>Ae.removeEventListener(fe,Ie),V=new o({onWillAddFirstListener:Te,onDidRemoveLastListener:q});return V.event}I.fromDOMEventEmitter=se;function re(Ae){return new Promise(fe=>z(Ae)(fe))}I.toPromise=re;function oe(Ae){const fe=new o;return Ae.then(De=>{fe.fire(De)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}I.fromPromise=oe;function G(Ae,fe,De){return fe(De),Ae(Ie=>fe(Ie))}I.runAndSubscribe=G;class ie{constructor(fe,De){this._observable=fe,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};De||F(Ie),this.emitter=new o(Ie),De&&De.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,De){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function me(Ae,fe){return new ie(Ae,fe).emitter.event}I.fromObservable=me;function be(Ae){return(fe,De,Ie)=>{let Te=0,q=!1;const V={beginUpdate(){Te++},endUpdate(){Te--,Te===0&&(Ae.reportChanges(),q&&(q=!1,fe.call(De)))},handlePossibleChange(){},handleChange(){q=!0}};Ae.addObserver(V),Ae.reportChanges();const J={dispose(){Ae.removeObserver(V)}};return Ie instanceof L.$Tc?Ie.add(J):Array.isArray(Ie)&&Ie.push(J),J}}I.fromObservableLight=be})(A||(e.Event=A={}));class C{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${C.f++}`,C.all.add(this)}start(F){this.g=new M.$0d,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$_d=C;let m=-1;function E(I){const F=m;return m=I,{dispose(){m=F}}}class v{constructor(F,j=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=j,this.g=0}dispose(){this.f?.clear()}check(F,j){const z=this.threshold;if(z<=0||j<z)return;this.f||(this.f=new Map);const O=this.f.get(F.value)||0;if(this.f.set(F.value,O+1),this.g-=1,this.g<=0){this.g=z*.5;let T,B=0;for(const[W,X]of this.f)(!T||B<X)&&(T=W,B=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${j} listeners already. MOST frequent listener (${B}):`),console.warn(T)}return()=>{const T=this.f.get(F.value)||0;this.f.set(F.value,T-1)}}}class u{static create(){return new u(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class a{constructor(F){this.value=F,this.id=f++}}const n=2,i=(I,F)=>{if(I instanceof a)F(I);else for(let j=0;j<I.length;j++){const z=I[j];z&&F(z)}},s=b?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class o{constructor(F){this.w=0,this.f=F,this.g=m>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const F=this.t;queueMicrotask(()=>{i(F,j=>j.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,j,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;j&&(F=F.bind(j));const O=new a(F);let T,B;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=u.create(),T=this.g.check(O.stack,this.w+1)),$&&(O.stack=B??u.create()),this.t?this.t instanceof a?(this.u??=new g,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,L.$Sc)(()=>{s?.unregister(W),T?.(),this.x(O)});if(z instanceof L.$Tc?z.add(W):Array.isArray(z)&&z.push(W),s){const X=new Error().stack.split(`
`).slice(2).join(`
`).trim();s.register(W,X,W)}return W},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const j=this.t,z=j.indexOf(F);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,j[z]=void 0;const O=this.u.current===this;if(this.w*n<=j.length){let T=0;for(let B=0;B<j.length;B++)j[B]?j[T++]=j[B]:O&&(this.u.end--,T<this.u.i&&this.u.i--);j.length=T}}y(F,j){if(!F)return;const z=this.f?.onListenerError||l.$1;if(!z){F.value(j);return}try{F.value(j)}catch(O){z(O)}}z(F){const j=F.current.t;for(;F.i<F.end;)this.y(j[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,F);else{const j=this.u;j.enqueue(this,F,this.t.length),this.z(j)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=o;const t=()=>new g;e.$ce=t;class g{constructor(){this.i=-1,this.end=0}enqueue(F,j,z){this.i=0,this.end=z,this.current=F,this.value=j}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends o{async fireAsync(F,j,z){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,O=>this.h.push([O.value,F]));this.h.size>0&&!j.isCancellationRequested;){const[O,T]=this.h.shift(),B=[],W={...T,token:j,waitUntil:X=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");z&&(X=z(X,O)),B.push(X)}};try{O(W)}catch(X){(0,l.$1)(X);continue}Object.freeze(B),await Promise.allSettled(B).then(X=>{for(const x of X)x.status==="rejected"&&(0,l.$1)(x.reason)})}}}e.$de=h;class c extends o{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ee=c;class r extends c{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$fe=r;class w extends o{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(j=>super.fire(j)),this.h=[]}))}}e.$ge=w;class d{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const j={event:F,listener:null};this.h.push(j),this.g&&this.m(j);const z=()=>{this.g&&this.o(j);const O=this.h.indexOf(j);this.h.splice(O,1)};return(0,L.$Sc)((0,N.$db)(z))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(j=>this.f.fire(j))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$he=d;class D{constructor(F,j,z,O){this.f=new L.$Tc;const T=this.f.add(new d),B=this.f.add(new L.$4c);function W(X){B.set(X,T.add(O(X)))}for(const X of F)W(X);this.f.add(j(X=>{W(X)})),this.f.add(z(X=>{B.deleteAndDispose(X)})),this.event=T.event}dispose(){this.f.dispose()}}e.$ie=D;class p{constructor(){this.f=[]}wrapEvent(F){return(j,z,O)=>F(T=>{const B=this.f[this.f.length-1];B?B.push(()=>j.call(z,T)):j.call(z,T)},void 0,O)}bufferEvents(F){const j=[];this.f.push(j);const z=F();return this.f.pop(),j.forEach(O=>O()),z}}e.$je=p;class k{constructor(){this.f=!1,this.g=A.None,this.h=L.$Uc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=k;class y{static const(F){return new P(F)}constructor(F){this.g=F,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$le=y;class P{constructor(F){this.value=F,this.onDidChange=A.None}}}),define(ke[22],Ee([1,0,4]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const N=Object.freeze(function(b,$){const S=setTimeout(b.bind($),0);return{dispose(){clearTimeout(S)}}});var L;(function(b){function $(S){return S===b.None||S===b.Cancelled||S instanceof R?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new l.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=L.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=L.None}}e.$me=M}),define(ke[168],Ee([1,0,22]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ze=e.$Ye=e.$Xe=void 0;class N{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new l.$me,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Xe=N;class L{constructor(b,$=JSON.stringify){this.c=b,this.d=$,this.a=void 0,this.b=void 0}get(b){const $=this.d(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Ye=L;class R{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$Ze=R}),define(ke[98],Ee([1,0,13,3]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=L,e.$oe=R,e.$pe=M,e.$qe=b,e.$re=S,e.$se=A,e.$te=C,e.$ue=m,e.$ve=E,e.$we=v,e.$xe=u,e.$ye=f,e.$ze=a,e.$Ae=n,e.$Be=i;function L(s){const o=s;return o?typeof o.read=="function":!1}function R(s){const o=s;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function M(s){const o=s;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function b(s,o){return new $(s,o)}class ${constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,l.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let g;switch(o){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const h=g.indexOf(t);h>=0&&g.splice(h,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(s,o){const t=[];let g;for(;(g=s.read())!==null;)t.push(g);return o(t)}function A(s,o,t){const g=[];let h;for(;(h=s.read())!==null&&g.length<t;)g.push(h);return h===null&&g.length>0?o(g):{read:()=>{if(g.length>0)return g.shift();if(typeof h<"u"){const c=h;return h=void 0,c}return s.read()}}}function C(s,o){return new Promise((t,g)=>{const h=[];m(s,{onData:c=>{o&&h.push(c)},onError:c=>{o?g(c):t(void 0)},onEnd:()=>{t(o?o(h):void 0)}})})}function m(s,o,t){s.on("error",g=>{t?.isCancellationRequested||o.onError(g)}),s.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),s.on("data",g=>{t?.isCancellationRequested||o.onData(g)})}function E(s,o){return new Promise((t,g)=>{const h=new N.$Tc,c=[],r=D=>{if(c.push(D),c.length>o)return h.dispose(),s.pause(),t({stream:s,buffer:c,ended:!1})},w=D=>(h.dispose(),g(D)),d=()=>(h.dispose(),t({stream:s,buffer:c,ended:!0}));h.add((0,N.$Sc)(()=>s.removeListener("error",w))),s.on("error",w),h.add((0,N.$Sc)(()=>s.removeListener("end",d))),s.on("end",d),h.add((0,N.$Sc)(()=>s.removeListener("data",r))),s.on("data",r)})}function v(s,o){const t=b(o);return t.end(s),t}function u(){const s=b(()=>{throw new Error("not supported")});return s.end(),s}function f(s){let o=!1;return{read:()=>o?null:(o=!0,s)}}function a(s,o,t){const g=b(t);return m(s,{onData:h=>g.write(o.data(h)),onError:h=>g.error(o.error?o.error(h):h),onEnd:()=>g.end()}),g}function n(s,o,t){let g=!1;return{read:()=>{const h=o.read();return g?h:(g=!0,h!==null?t([s,h]):s)}}}function i(s,o,t){let g=!1;const h=b(t);return m(o,{onData:c=>g?h.write(c):(g=!0,h.write(t([s,c]))),onError:c=>h.error(c),onEnd:()=>{g||(g=!0,h.write(s)),h.end()}}),h}}),define(ke[21],Ee([1,0,46,98]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=S,e.$Ee=A,e.$Fe=C,e.$Ge=m,e.$He=E,e.$Ie=v,e.$Je=u,e.$Ke=f,e.$Le=a,e.$Me=n,e.$Ne=i,e.$Oe=s,e.$Pe=o,e.$Qe=t,e.$Re=g,e.$Se=h,e.$Te=c,e.$Ue=r,e.$Ve=w,e.$We=p;const L=typeof Buffer<"u",R=new l.$V(()=>new Uint8Array(256));let M,b;class ${static alloc(y){return L?new $(Buffer.allocUnsafe(y)):new $(new Uint8Array(y))}static wrap(y){return L&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new $(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&L?new $(Buffer.from(y)):(M||(M=new TextEncoder),new $(M.encode(y)))}static fromByteArray(y){const P=$.alloc(y.length);for(let I=0,F=y.length;I<F;I++)P.buffer[I]=y[I];return P}static concat(y,P){if(typeof P>"u"){P=0;for(let j=0,z=y.length;j<z;j++)P+=y[j].byteLength}const I=$.alloc(P);let F=0;for(let j=0,z=y.length;j<z;j++){const O=y[j];I.set(O,F),F+=O.byteLength}return I}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=$.alloc(this.byteLength);return y.set(this),y}toString(){return L?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(y,P){return new $(this.buffer.subarray(y,P))}set(y,P){if(y instanceof $)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return m(this.buffer,y)}writeUInt32BE(y,P){E(this.buffer,y,P)}readUInt32LE(y){return v(this.buffer,y)}writeUInt32LE(y,P){u(this.buffer,y,P)}readUInt8(y){return f(this.buffer,y)}writeUInt8(y,P){a(this.buffer,y,P)}indexOf(y,P=0){return S(this.buffer,y instanceof $?y.buffer:y,P)}}e.$Ce=$;function S(k,y,P=0){const I=y.byteLength,F=k.byteLength;if(I===0)return 0;if(I===1)return k.indexOf(y[0]);if(I>F-P)return-1;const j=R.value;j.fill(y.length);for(let B=0;B<y.length;B++)j[y[B]]=y.length-B-1;let z=P+y.length-1,O=z,T=-1;for(;z<F;)if(k[z]===y[O]){if(O===0){T=z;break}z--,O--}else z+=Math.max(y.length-O,j[k[z]]),O=y.length-1;return T}function A(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0}function C(k,y,P){k[P+0]=y&255,y=y>>>8,k[P+1]=y&255}function m(k,y){return k[y]*2**24+k[y+1]*2**16+k[y+2]*2**8+k[y+3]}function E(k,y,P){k[P+3]=y,y=y>>>8,k[P+2]=y,y=y>>>8,k[P+1]=y,y=y>>>8,k[P]=y}function v(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0|k[y+2]<<16>>>0|k[y+3]<<24>>>0}function u(k,y,P){k[P+0]=y&255,y=y>>>8,k[P+1]=y&255,y=y>>>8,k[P+2]=y&255,y=y>>>8,k[P+3]=y&255}function f(k,y){return k[y]}function a(k,y,P){k[P]=y}function n(k){return N.$re(k,y=>$.concat(y))}function i(k){return N.$ye(k)}function s(k){return N.$te(k,y=>$.concat(y))}async function o(k){return k.ended?$.concat(k.buffer):$.concat([...k.buffer,await s(k.stream)])}function t(k){return N.$we(k,y=>$.concat(y))}function g(k){return N.$ze(k,{data:y=>typeof y=="string"?$.fromString(y):$.wrap(y)},y=>$.concat(y))}function h(k){return N.$qe(y=>$.concat(y),k)}function c(k,y){return N.$Ae(k,y,P=>$.concat(P))}function r(k,y){return N.$Be(k,y,P=>$.concat(P))}function w(k){let y=0,P=0,I=0;const F=new Uint8Array(Math.floor(k.length/4*3)),j=O=>{switch(P){case 3:F[I++]=y|O,P=0;break;case 2:F[I++]=y|O>>>2,y=O<<6,P=3;break;case 1:F[I++]=y|O>>>4,y=O<<4,P=2;break;default:y=O<<2,P=1}};for(let O=0;O<k.length;O++){const T=k.charCodeAt(O);if(T>=65&&T<=90)j(T-65);else if(T>=97&&T<=122)j(T-97+26);else if(T>=48&&T<=57)j(T-48+52);else if(T===43||T===45)j(62);else if(T===47||T===95)j(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${k[O]}`)}}const z=I;for(;P>0;)j(0);return $.wrap(F).slice(0,z)}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:k},y=!0,P=!1){const I=P?D:d;let F="";const j=k.byteLength%3;let z=0;for(;z<k.byteLength-j;z+=3){const O=k[z+0],T=k[z+1],B=k[z+2];F+=I[O>>>2],F+=I[(O<<4|T>>>4)&63],F+=I[(T<<2|B>>>6)&63],F+=I[B&63]}if(j===1){const O=k[z+0];F+=I[O>>>2],F+=I[O<<4&63],y&&(F+="==")}else if(j===2){const O=k[z+0],T=k[z+1];F+=I[O>>>2],F+=I[(O<<4|T>>>4)&63],F+=I[T<<2&63],y&&(F+="=")}return F}}),define(ke[14],Ee([1,0,168,46]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=e.$1f=e.GraphemeBreakType=e.$Qf=e.$Jf=e.$Cf=e.$Bf=void 0,e.$3e=L,e.$4e=M,e.$5e=$,e.$6e=S,e.$7e=A,e.$8e=C,e.$9e=m,e.$0e=E,e.$$e=v,e.$_e=u,e.$af=f,e.$bf=a,e.$cf=n,e.$df=i,e.$ef=s,e.$ff=o,e.$gf=t,e.$hf=g,e.$if=h,e.$jf=c,e.$kf=r,e.$lf=w,e.$mf=d,e.$nf=D,e.$of=p,e.$pf=k,e.$qf=y,e.$rf=P,e.$sf=I,e.$tf=F,e.$uf=j,e.$vf=z,e.$wf=O,e.$xf=T,e.$yf=B,e.$zf=W,e.$Af=X,e.$Df=ue,e.$Ef=te,e.$Ff=we,e.$Gf=Se,e.$Hf=ne,e.$If=Pe,e.$Kf=se,e.$Lf=re,e.$Mf=oe,e.$Nf=G,e.$Of=me,e.$Pf=be,e.$Rf=Ae,e.$Sf=fe,e.$Tf=De,e.$Uf=Ie,e.$Vf=Te,e.$Wf=q,e.$Xf=V,e.$Yf=J,e.$Zf=Ve;function L(Ce){return!Ce||typeof Ce!="string"?!0:Ce.trim().length===0}const R=/{(\d+)}/g;function M(Ce,...Be){return Be.length===0?Ce:Ce.replace(R,function(He,Ne){const Xe=parseInt(Ne,10);return isNaN(Xe)||Xe<0||Xe>=Be.length?He:Be[Xe]})}const b=/{([^}]+)}/g;function $(Ce,Be){return Object.keys(Be).length===0?Ce:Ce.replace(b,(He,Ne)=>Be[Ne]??He)}function S(Ce){return Ce.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(Ce){return Ce.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function C(Ce){return Ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(Ce,Be){let He=0;const Ne=Be.charCodeAt(0);for(let Xe=Ce.length-1;Xe>=0;Xe--)Ce.charCodeAt(Xe)===Ne&&He++;return He}function E(Ce,Be,He="\u2026"){return Ce.length<=Be?Ce:`${Ce.substr(0,Be)}${He}`}function v(Ce,Be,He="\u2026"){if(Ce.length<=Be)return Ce;const Ne=Math.ceil(Be/2)-He.length/2,Xe=Math.floor(Be/2)-He.length/2;return`${Ce.substr(0,Ne)}${He}${Ce.substr(Ce.length-Xe)}`}function u(Ce,Be=" "){const He=f(Ce,Be);return a(He,Be)}function f(Ce,Be){if(!Ce||!Be)return Ce;const He=Be.length;if(He===0||Ce.length===0)return Ce;let Ne=0;for(;Ce.indexOf(Be,Ne)===Ne;)Ne=Ne+He;return Ce.substring(Ne)}function a(Ce,Be){if(!Ce||!Be)return Ce;const He=Be.length,Ne=Ce.length;if(He===0||Ne===0)return Ce;let Xe=Ne,ae=-1;for(;ae=Ce.lastIndexOf(Be,Xe-1),!(ae===-1||ae+He!==Xe);){if(ae===0)return"";Xe=ae}return Ce.substring(0,Xe)}function n(Ce){return Ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Ce){return Ce.replace(/\*/g,"")}function s(Ce,Be,He={}){if(!Ce)throw new Error("Cannot create regex from empty string");Be||(Ce=C(Ce)),He.wholeWord&&(/\B/.test(Ce.charAt(0))||(Ce="\\b"+Ce),/\B/.test(Ce.charAt(Ce.length-1))||(Ce=Ce+"\\b"));let Ne="";return He.global&&(Ne+="g"),He.matchCase||(Ne+="i"),He.multiline&&(Ne+="m"),He.unicode&&(Ne+="u"),new RegExp(Ce,Ne)}function o(Ce){return Ce.source==="^"||Ce.source==="^$"||Ce.source==="$"||Ce.source==="^\\s*$"?!1:!!(Ce.exec("")&&Ce.lastIndex===0)}function t(Ce){return Ce.split(/\r\n|\r|\n/)}function g(Ce){const Be=[],He=Ce.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(He.length/2);Ne++)Be.push(He[2*Ne]+(He[2*Ne+1]??""));return Be}function h(Ce){for(let Be=0,He=Ce.length;Be<He;Be++){const Ne=Ce.charCodeAt(Be);if(Ne!==32&&Ne!==9)return Be}return-1}function c(Ce,Be=0,He=Ce.length){for(let Ne=Be;Ne<He;Ne++){const Xe=Ce.charCodeAt(Ne);if(Xe!==32&&Xe!==9)return Ce.substring(Be,Ne)}return Ce.substring(Be,He)}function r(Ce,Be=Ce.length-1){for(let He=Be;He>=0;He--){const Ne=Ce.charCodeAt(He);if(Ne!==32&&Ne!==9)return He}return-1}function w(Ce,Be,He){const Ne=[];let Xe=0;for(const ae of Ce.matchAll(Be)){if(Ne.push(Ce.slice(Xe,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Xe=ae.index+ae[0].length,Ne.push(He(ae[0],...ae.slice(1),ae.index,Ce,ae.groups))}return Ne.push(Ce.slice(Xe)),Promise.all(Ne).then(ae=>ae.join(""))}function d(Ce,Be){return Ce<Be?-1:Ce>Be?1:0}function D(Ce,Be,He=0,Ne=Ce.length,Xe=0,ae=Be.length){for(;He<Ne&&Xe<ae;He++,Xe++){const Ge=Ce.charCodeAt(He),Me=Be.charCodeAt(Xe);if(Ge<Me)return-1;if(Ge>Me)return 1}const ce=Ne-He,Re=ae-Xe;return ce<Re?-1:ce>Re?1:0}function p(Ce,Be){return k(Ce,Be,0,Ce.length,0,Be.length)}function k(Ce,Be,He=0,Ne=Ce.length,Xe=0,ae=Be.length){for(;He<Ne&&Xe<ae;He++,Xe++){let Ge=Ce.charCodeAt(He),Me=Be.charCodeAt(Xe);if(Ge===Me)continue;if(Ge>=128||Me>=128)return D(Ce.toLowerCase(),Be.toLowerCase(),He,Ne,Xe,ae);P(Ge)&&(Ge-=32),P(Me)&&(Me-=32);const tt=Ge-Me;if(tt!==0)return tt}const ce=Ne-He,Re=ae-Xe;return ce<Re?-1:ce>Re?1:0}function y(Ce){return Ce>=48&&Ce<=57}function P(Ce){return Ce>=97&&Ce<=122}function I(Ce){return Ce>=65&&Ce<=90}function F(Ce,Be){return Ce.length===Be.length&&k(Ce,Be)===0}function j(Ce,Be){const He=Be.length;return Be.length>Ce.length?!1:k(Ce,Be,0,He)===0}function z(Ce,Be){const He=Math.min(Ce.length,Be.length);let Ne;for(Ne=0;Ne<He;Ne++)if(Ce.charCodeAt(Ne)!==Be.charCodeAt(Ne))return Ne;return He}function O(Ce,Be){const He=Math.min(Ce.length,Be.length);let Ne;const Xe=Ce.length-1,ae=Be.length-1;for(Ne=0;Ne<He;Ne++)if(Ce.charCodeAt(Xe-Ne)!==Be.charCodeAt(ae-Ne))return Ne;return He}function T(Ce){return 55296<=Ce&&Ce<=56319}function B(Ce){return 56320<=Ce&&Ce<=57343}function W(Ce,Be){return(Ce-55296<<10)+(Be-56320)+65536}function X(Ce,Be,He){const Ne=Ce.charCodeAt(He);if(T(Ne)&&He+1<Be){const Xe=Ce.charCodeAt(He+1);if(B(Xe))return W(Ne,Xe)}return Ne}function x(Ce,Be){const He=Ce.charCodeAt(Be-1);if(B(He)&&Be>1){const Ne=Ce.charCodeAt(Be-2);if(T(Ne))return W(Ne,He)}return He}class Z{get offset(){return this.e}constructor(Be,He=0){this.c=Be,this.d=Be.length,this.e=He}setOffset(Be){this.e=Be}prevCodePoint(){const Be=x(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=X(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$Bf=Z;class Y{get offset(){return this.c.offset}constructor(Be,He=0){this.c=new Z(Be,He)}nextGraphemeLength(){const Be=pe.getInstance(),He=this.c,Ne=He.offset;let Xe=Be.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const ae=He.offset,ce=Be.getGraphemeBreakType(He.nextCodePoint());if(Q(Xe,ce)){He.setOffset(ae);break}Xe=ce}return He.offset-Ne}prevGraphemeLength(){const Be=pe.getInstance(),He=this.c,Ne=He.offset;let Xe=Be.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const ae=He.offset,ce=Be.getGraphemeBreakType(He.prevCodePoint());if(Q(ce,Xe)){He.setOffset(ae);break}Xe=ce}return Ne-He.offset}eol(){return this.c.eol()}}e.$Cf=Y;function ue(Ce,Be){return new Y(Ce,Be).nextGraphemeLength()}function te(Ce,Be){return new Y(Ce,Be).prevGraphemeLength()}function we(Ce,Be){Be>0&&B(Ce.charCodeAt(Be))&&Be--;const He=Be+ue(Ce,Be);return[He-te(Ce,He),He]}function Se(Ce){const Be=new Y(Ce);let He=0;for(;!Be.eol();)He++,Be.nextGraphemeLength();return He}let _;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(Ce){return _||(_=U()),_.test(Ce)}const $e=/^[\t\n\r\x20-\x7E]*$/;function Pe(Ce){return $e.test(Ce)}e.$Jf=/[\u2028\u2029]/;function se(Ce){return e.$Jf.test(Ce)}function re(Ce){return Ce>=11904&&Ce<=55215||Ce>=63744&&Ce<=64255||Ce>=65281&&Ce<=65374}function oe(Ce){return Ce>=127462&&Ce<=127487||Ce===8986||Ce===8987||Ce===9200||Ce===9203||Ce>=9728&&Ce<=10175||Ce===11088||Ce===11093||Ce>=127744&&Ce<=128591||Ce>=128640&&Ce<=128764||Ce>=128992&&Ce<=129008||Ce>=129280&&Ce<=129535||Ce>=129648&&Ce<=129782}function G(Ce,Be,He=""){const Ne=Ce.trimStart();if(Ne.length<Be)return Ne;const Xe=/\b/g;let ae=0;for(;Xe.test(Ne)&&!(Ne.length-Xe.lastIndex<Be);)ae=Xe.lastIndex,Xe.lastIndex+=1;return ae===0?Ne:He+Ne.substring(ae).trimStart()}const ie=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*me(Ce){let Be=0;for(const He of Ce.matchAll(ie))Be!==He.index&&(yield{isCode:!1,str:Ce.substring(Be,He.index)}),yield{isCode:!0,str:He[0]},Be=He.index+He[0].length;Be!==Ce.length&&(yield{isCode:!1,str:Ce.substring(Be)})}function be(Ce){return Ce&&(Ce=Ce.replace(ie,"")),Ce}e.$Qf="\uFEFF";function Ae(Ce){return!!(Ce&&Ce.length>0&&Ce.charCodeAt(0)===65279)}function fe(Ce){return Ae(Ce)?Ce.substr(1):Ce}function De(Ce,Be){if(!Ce||!Be||Ce.length<Be.length)return!1;const He=Be.length,Ne=Ce.toLowerCase();let Xe=0,ae=-1;for(;Xe<He;){const ce=Ne.indexOf(Be[Xe],ae+1);if(ce<0)return!1;ae=ce,Xe++}return!0}function Ie(Ce,Be=!1){return Ce?(Be&&(Ce=Ce.replace(/\\./g,"")),Ce.toLowerCase()!==Ce):!1}function Te(Ce){return Ce.charAt(0).toUpperCase()+Ce.slice(1)}function q(Ce,Be=1){if(Be===0)return"";let He=-1;do He=Ce.indexOf(`
`,He+1),Be--;while(Be>0&&He>=0);return He===-1?Ce:(Ce[He-1]==="\r"&&He--,Ce.substr(0,He))}function V(Ce){return Ce=Ce%(2*26),Ce<26?String.fromCharCode(97+Ce):String.fromCharCode(65+Ce-26)}function J(Ce){return pe.getInstance().getGraphemeBreakType(Ce)}function Q(Ce,Be){return Ce===0?Be!==5&&Be!==7:Ce===2&&Be===3?!1:Ce===4||Ce===2||Ce===3||Be===4||Be===2||Be===3?!0:!(Ce===8&&(Be===8||Be===9||Be===11||Be===12)||(Ce===11||Ce===9)&&(Be===9||Be===10)||(Ce===12||Ce===10)&&Be===10||Be===5||Be===13||Be===7||Ce===1||Ce===13&&Be===14||Ce===6&&Be===6)}var he;(function(Ce){Ce[Ce.Other=0]="Other",Ce[Ce.Prepend=1]="Prepend",Ce[Ce.CR=2]="CR",Ce[Ce.LF=3]="LF",Ce[Ce.Control=4]="Control",Ce[Ce.Extend=5]="Extend",Ce[Ce.Regional_Indicator=6]="Regional_Indicator",Ce[Ce.SpacingMark=7]="SpacingMark",Ce[Ce.L=8]="L",Ce[Ce.V=9]="V",Ce[Ce.T=10]="T",Ce[Ce.LV=11]="LV",Ce[Ce.LVT=12]="LVT",Ce[Ce.ZWJ=13]="ZWJ",Ce[Ce.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class pe{static{this.c=null}static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=ze()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const He=this.d,Ne=He.length/3;let Xe=1;for(;Xe<=Ne;)if(Be<He[3*Xe])Xe=2*Xe;else if(Be>He[3*Xe+1])Xe=2*Xe+1;else return He[3*Xe+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(Ce,Be){if(Ce===0)return 0;const He=Ze(Ce,Be);if(He!==void 0)return He;const Ne=new Z(Be,Ce);return Ne.prevCodePoint(),Ne.offset}function Ze(Ce,Be){const He=new Z(Be,Ce);let Ne=He.prevCodePoint();for(;it(Ne)||Ne===65039||Ne===8419;){if(He.offset===0)return;Ne=He.prevCodePoint()}if(!oe(Ne))return;let Xe=He.offset;return Xe>0&&He.prevCodePoint()===8205&&(Xe=He.offset),Xe}function it(Ce){return 127995<=Ce&&Ce<=127999}var ot;(function(Ce){Ce[Ce.zwj=8205]="zwj",Ce[Ce.emojiVariantSelector=65039]="emojiVariantSelector",Ce[Ce.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.$1f="\xA0";class nt{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new l.$Ye(Be=>{function He(tt){const ht=new Map;for(let wt=0;wt<tt.length;wt+=2)ht.set(tt[wt],tt[wt+1]);return ht}function Ne(tt,ht){const wt=new Map(tt);for(const[Lt,At]of ht)wt.set(Lt,At);return wt}function Xe(tt,ht){if(!tt)return ht;const wt=new Map;for(const[Lt,At]of tt)ht.has(Lt)&&wt.set(Lt,At);return wt}const ae=this.c.value;let ce=Be.filter(tt=>!tt.startsWith("_")&&tt in ae);ce.length===0&&(ce=["_default"]);let Re;for(const tt of ce){const ht=He(ae[tt]);Re=Xe(Re,ht)}const Ge=He(ae._common),Me=Ne(Ge,Re);return new nt(Me)})}static getInstance(Be){return nt.d.get(Array.from(Be))}static{this.e=new N.$V(()=>Object.keys(nt.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return nt.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$2f=nt;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Be){return st.e().has(Be)}static get codePoints(){return st.e()}}e.$3f=st}),define(ke[126],Ee([1,0,27,166,14]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.FuzzyScore=e.$sk=e.$rk=void 0,e.or=R,e.$tk=b,e.$uk=$,e.$vk=C,e.$wk=w,e.$xk=d,e.$yk=I,e.$zk=F,e.$Ak=j,e.$Bk=z,e.$Ck=ne,e.$Ek=re,e.$Fk=ie,e.$Gk=me;function R(...fe){return function(De,Ie){for(let Te=0,q=fe.length;Te<q;Te++){const V=fe[Te](De,Ie);if(V)return V}return null}}e.$rk=M.bind(void 0,!1),e.$sk=M.bind(void 0,!0);function M(fe,De,Ie){if(!Ie||Ie.length<De.length)return null;let Te;return fe?Te=L.$uf(Ie,De):Te=Ie.indexOf(De)===0,Te?De.length>0?[{start:0,end:De.length}]:[]:null}function b(fe,De){const Ie=De.toLowerCase().indexOf(fe.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+fe.length}]}function $(fe,De){return S(fe.toLowerCase(),De.toLowerCase(),0,0)}function S(fe,De,Ie,Te){if(Ie===fe.length)return[];if(Te===De.length)return null;if(fe[Ie]===De[Te]){let q=null;return(q=S(fe,De,Ie+1,Te+1))?s({start:Te,end:Te+1},q):null}return S(fe,De,Ie,Te+1)}function A(fe){return 97<=fe&&fe<=122}function C(fe){return 65<=fe&&fe<=90}function m(fe){return 48<=fe&&fe<=57}function E(fe){return fe===32||fe===9||fe===10||fe===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>v.add(fe.charCodeAt(0)));function u(fe){return E(fe)||v.has(fe)}function f(fe,De){return fe===De||u(fe)&&u(De)}const a=new Map;function n(fe){if(a.has(fe))return a.get(fe);let De;const Ie=(0,N.$pk)(fe);return Ie&&(De=Ie),a.set(fe,De),De}function i(fe){return A(fe)||C(fe)||m(fe)}function s(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function o(fe,De){for(let Ie=De;Ie<fe.length;Ie++){const Te=fe.charCodeAt(Ie);if(C(Te)||m(Te)||Ie>0&&!i(fe.charCodeAt(Ie-1)))return Ie}return fe.length}function t(fe,De,Ie,Te){if(Ie===fe.length)return[];if(Te===De.length)return null;if(fe[Ie]!==De[Te].toLowerCase())return null;{let q=null,V=Te+1;for(q=t(fe,De,Ie+1,Te+1);!q&&(V=o(De,V))<De.length;)q=t(fe,De,Ie+1,V),V++;return q===null?null:s({start:Te,end:Te+1},q)}}function g(fe){let De=0,Ie=0,Te=0,q=0,V=0;for(let ze=0;ze<fe.length;ze++)V=fe.charCodeAt(ze),C(V)&&De++,A(V)&&Ie++,i(V)&&Te++,m(V)&&q++;const J=De/fe.length,Q=Ie/fe.length,he=Te/fe.length,pe=q/fe.length;return{upperPercent:J,lowerPercent:Q,alphaPercent:he,numericPercent:pe}}function h(fe){const{upperPercent:De,lowerPercent:Ie}=fe;return Ie===0&&De>.6}function c(fe){const{upperPercent:De,lowerPercent:Ie,alphaPercent:Te,numericPercent:q}=fe;return Ie>.2&&De<.8&&Te>.6&&q<.2}function r(fe){let De=0,Ie=0,Te=0,q=0;for(let V=0;V<fe.length;V++)Te=fe.charCodeAt(V),C(Te)&&De++,A(Te)&&Ie++,E(Te)&&q++;return(De===0||Ie===0)&&q===0?fe.length<=30:De<=5}function w(fe,De){if(!De||(De=De.trim(),De.length===0)||!r(fe))return null;De.length>60&&(De=De.substring(0,60));const Ie=g(De);if(!c(Ie)){if(!h(Ie))return null;De=De.toLowerCase()}let Te=null,q=0;for(fe=fe.toLowerCase();q<De.length&&(Te=t(fe,De,0,q))===null;)q=o(De,q+1);return Te}function d(fe,De,Ie=!1){if(!De||De.length===0)return null;let Te=null,q=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();q<De.length&&(Te=D(fe,De,0,q,Ie),Te===null);)q=p(De,q+1);return Te}function D(fe,De,Ie,Te,q){let V=0;if(Ie===fe.length)return[];if(Te===De.length)return null;if(!f(fe.charCodeAt(Ie),De.charCodeAt(Te))){const he=n(fe.charCodeAt(Ie));if(!he)return null;for(let pe=0;pe<he.length;pe++)if(!f(he[pe],De.charCodeAt(Te+pe)))return null;V+=he.length-1}let J=null,Q=Te+V+1;if(J=D(fe,De,Ie+1,Q,q),!q)for(;!J&&(Q=p(De,Q))<De.length;)J=D(fe,De,Ie+1,Q,q),Q++;if(!J)return null;if(fe.charCodeAt(Ie)!==De.charCodeAt(Te)){const he=n(fe.charCodeAt(Ie));if(!he)return J;for(let pe=0;pe<he.length;pe++)if(he[pe]!==De.charCodeAt(Te+pe))return J}return s({start:Te,end:Te+V+1},J)}function p(fe,De){for(let Ie=De;Ie<fe.length;Ie++)if(u(fe.charCodeAt(Ie))||Ie>0&&u(fe.charCodeAt(Ie-1)))return Ie;return fe.length}const k=R(e.$sk,w,b),y=R(e.$sk,w,$),P=new l.$Ec(1e4);function I(fe,De,Ie=!1){if(typeof fe!="string"||typeof De!="string")return null;let Te=P.get(fe);Te||(Te=new RegExp(L.$cf(fe),"i"),P.set(fe,Te));const q=Te.exec(De);return q?[{start:q.index,end:q.index+q[0].length}]:Ie?y(fe,De):k(fe,De)}function F(fe,De){const Ie=re(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ie?z(Ie):null}function j(fe,De,Ie,Te,q,V){const J=Math.min(13,fe.length);for(;Ie<J;Ie++){const Q=re(fe,De,Ie,Te,q,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,V]}function z(fe){if(typeof fe>"u")return[];const De=[],Ie=fe[1];for(let Te=fe.length-1;Te>1;Te--){const q=fe[Te]+Ie,V=De[De.length-1];V&&V.end===q?V.end=q+1:De.push({start:q,end:q+1})}return De}const O=128;function T(){const fe=[],De=[];for(let Ie=0;Ie<=O;Ie++)De[Ie]=0;for(let Ie=0;Ie<=O;Ie++)fe.push(De.slice(0));return fe}function B(fe){const De=[];for(let Ie=0;Ie<=fe;Ie++)De[Ie]=0;return De}const W=B(2*O),X=B(2*O),x=T(),Z=T(),Y=T(),ue=!1;function te(fe,De,Ie,Te,q){function V(Q,he,pe=" "){for(;Q.length<he;)Q=pe+Q;return Q}let J=` |   |${Te.split("").map(Q=>V(Q,3)).join("|")}
`;for(let Q=0;Q<=Ie;Q++)Q===0?J+=" |":J+=`${De[Q-1]}|`,J+=fe[Q].slice(0,q+1).map(he=>V(he.toString(),3)).join("|")+`
`;return J}function we(fe,De,Ie,Te){fe=fe.substr(De),Ie=Ie.substr(Te),console.log(te(Z,fe,fe.length,Ie,Ie.length)),console.log(te(Y,fe,fe.length,Ie,Ie.length)),console.log(te(x,fe,fe.length,Ie,Ie.length))}function Se(fe,De){if(De<0||De>=fe.length)return!1;const Ie=fe.codePointAt(De);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Mf(Ie)}}function _(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function U(fe,De,Ie){return De[fe]!==Ie[fe]}function ne(fe,De,Ie,Te,q,V,J=!1){for(;De<Ie&&q<V;)fe[De]===Te[q]&&(J&&(W[De]=q),De+=1),q+=1;return De===Ie}var $e;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})($e||($e={}));var Pe;(function(fe){fe.Default=[-100,0];function De(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}fe.isDefault=De})(Pe||(e.FuzzyScore=Pe={}));class se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Ie){this.firstMatchCanBeWeak=De,this.boostFullMatch=Ie}}e.$Dk=se;function re(fe,De,Ie,Te,q,V,J=se.default){const Q=fe.length>O?O:fe.length,he=Te.length>O?O:Te.length;if(Ie>=Q||V>=he||Q-Ie>he-V||!ne(De,Ie,Q,q,V,he,!0))return;oe(Q,he,Ie,V,De,q);let pe=1,ze=1,Ve=Ie,Ze=V;const it=[!1];for(pe=1,Ve=Ie;Ve<Q;pe++,Ve++){const Be=W[Ve],He=X[Ve],Ne=Ve+1<Q?X[Ve+1]:he;for(ze=Be-V+1,Ze=Be;Ze<Ne;ze++,Ze++){let Xe=Number.MIN_SAFE_INTEGER,ae=!1;Ze<=He&&(Xe=G(fe,De,Ve,Ie,Te,q,Ze,he,V,x[pe-1][ze-1]===0,it));let ce=0;Xe!==Number.MAX_SAFE_INTEGER&&(ae=!0,ce=Xe+Z[pe-1][ze-1]);const Re=Ze>Be,Ge=Re?Z[pe][ze-1]+(x[pe][ze-1]>0?-5:0):0,Me=Ze>Be+1&&x[pe][ze-1]>0,tt=Me?Z[pe][ze-2]+(x[pe][ze-2]>0?-5:0):0;if(Me&&(!Re||tt>=Ge)&&(!ae||tt>=ce))Z[pe][ze]=tt,Y[pe][ze]=3,x[pe][ze]=0;else if(Re&&(!ae||Ge>=ce))Z[pe][ze]=Ge,Y[pe][ze]=2,x[pe][ze]=0;else if(ae)Z[pe][ze]=ce,Y[pe][ze]=1,x[pe][ze]=x[pe-1][ze-1]+1;else throw new Error("not possible")}}if(ue&&we(fe,Ie,Te,V),!it[0]&&!J.firstMatchCanBeWeak)return;pe--,ze--;const ot=[Z[pe][ze],V];let nt=0,st=0;for(;pe>=1;){let Be=ze;do{const He=Y[pe][Be];if(He===3)Be=Be-2;else if(He===2)Be=Be-1;else break}while(Be>=1);nt>1&&De[Ie+pe-1]===q[V+ze-1]&&!U(Be+V-1,Te,q)&&nt+1>x[pe][Be]&&(Be=ze),Be===ze?nt++:nt=1,st||(st=Be),pe--,ze=Be-1,ot.push(ze)}he===Q&&J.boostFullMatch&&(ot[0]+=2);const Ce=st-Q;return ot[0]-=Ce,ot}function oe(fe,De,Ie,Te,q,V){let J=fe-1,Q=De-1;for(;J>=Ie&&Q>=Te;)q[J]===V[Q]&&(X[J]=Q,J--),Q--}function G(fe,De,Ie,Te,q,V,J,Q,he,pe,ze){if(De[Ie]!==V[J])return Number.MIN_SAFE_INTEGER;let Ve=1,Ze=!1;return J===Ie-Te?Ve=fe[Ie]===q[J]?7:5:U(J,q,V)&&(J===0||!U(J-1,q,V))?(Ve=fe[Ie]===q[J]?7:5,Ze=!0):Se(V,J)&&(J===0||!Se(V,J-1))?Ve=5:(Se(V,J-1)||_(V,J-1))&&(Ve=5,Ze=!0),Ve>1&&Ie===Te&&(ze[0]=!0),Ze||(Ze=U(J,q,V)||Se(V,J-1)||_(V,J-1)),Ie===Te?J>he&&(Ve-=Ze?3:5):pe?Ve+=Ze?2:0:Ve+=Ze?0:1,J+1===Q&&(Ve-=Ze?3:5),Ve}function ie(fe,De,Ie,Te,q,V,J){return be(fe,De,Ie,Te,q,V,!0,J)}function me(fe,De,Ie,Te,q,V,J){return be(fe,De,Ie,Te,q,V,!1,J)}function be(fe,De,Ie,Te,q,V,J,Q){let he=re(fe,De,Ie,Te,q,V,Q);if(he&&!J)return he;if(fe.length>=3){const pe=Math.min(7,fe.length-1);for(let ze=Ie+1;ze<pe;ze++){const Ve=Ae(fe,ze);if(Ve){const Ze=re(Ve,Ve.toLowerCase(),Ie,Te,q,V,Q);Ze&&(Ze[0]-=3,(!he||Ze[0]>he[0])&&(he=Ze))}}}return he}function Ae(fe,De){if(De+1>=fe.length)return;const Ie=fe[De],Te=fe[De+1];if(Ie!==Te)return fe.slice(0,De)+Te+Ie+fe.slice(De+2)}}),define(ke[56],Ee([1,0,14]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$ij=void 0,e.$ej=N,e.$fj=L,e.$gj=R,e.$hj=b,e.$jj=u;function N(a){return L(a,0)}function L(a,n){switch(typeof a){case"object":return a===null?R(349,n):Array.isArray(a)?$(a,n):S(a,n);case"string":return b(a,n);case"boolean":return M(a,n);case"number":return R(a,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(a,n){return(n<<5)-n+a|0}function M(a,n){return R(a?433:863,n)}function b(a,n){n=R(149417,n);for(let i=0,s=a.length;i<s;i++)n=R(a.charCodeAt(i),n);return n}function $(a,n){return n=R(104579,n),a.reduce((i,s)=>L(s,i),n)}function S(a,n){return n=R(181387,n),Object.keys(a).sort().reduce((i,s)=>(i=b(s,i),L(a[s],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$ij=A;var C;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(a,n,i=32){const s=i-n,o=~((1<<s)-1);return(a<<n|(o&a)>>>s)>>>0}function E(a,n=0,i=a.byteLength,s=0){for(let o=0;o<i;o++)a[n+o]=s}function v(a,n,i="0"){for(;a.length<n;)a=i+a;return a}function u(a,n=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((a>>>0).toString(16),n/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const s=this.p;let o=this.r,t=this.u,g,h;for(t!==0?(g=t,h=-1,t=0):(g=n.charCodeAt(0),h=0);;){let c=g;if(l.$xf(g))if(h+1<i){const r=n.charCodeAt(h+1);l.$yf(r)?(h++,c=l.$zf(g,r)):c=65533}else{t=g;break}else l.$yf(g)&&(c=65533);if(o=this.w(s,o,c),h++,h<i)g=n.charCodeAt(h);else break}this.r=o,this.u=t}w(n,i,s){return s<128?n[i++]=s:s<2048?(n[i++]=192|(s&1984)>>>6,n[i++]=128|(s&63)>>>0):s<65536?(n[i++]=224|(s&61440)>>>12,n[i++]=128|(s&4032)>>>6,n[i++]=128|(s&63)>>>0):(n[i++]=240|(s&1835008)>>>18,n[i++]=128|(s&258048)>>>12,n[i++]=128|(s&4032)>>>6,n[i++]=128|(s&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=f.g,i=this.q;for(let d=0;d<64;d+=4)n.setUint32(d,i.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)n.setUint32(d,m(n.getUint32(d-12,!1)^n.getUint32(d-32,!1)^n.getUint32(d-56,!1)^n.getUint32(d-64,!1),1),!1);let s=this.h,o=this.l,t=this.m,g=this.n,h=this.o,c,r,w;for(let d=0;d<80;d++)d<20?(c=o&t|~o&g,r=1518500249):d<40?(c=o^t^g,r=1859775393):d<60?(c=o&t|o&g|t&g,r=2400959708):(c=o^t^g,r=3395469782),w=m(s,5)+c+h+r+n.getUint32(d*4,!1)&4294967295,h=g,g=t,t=m(o,30),o=s,s=w;this.h=this.h+s&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+g&4294967295,this.o=this.o+h&4294967295}}e.$kj=f}),define(ke[41],Ee([1,0,14]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const R="error",M="warning",b="warn",$="info",S="ignore";function A(m){return m?l.$tf(R,m)?L.Error:l.$tf(M,m)||l.$tf(b,m)?L.Warning:l.$tf($,m)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function C(m){switch(m){case L.Error:return R;case L.Warning:return M;case L.Info:return $;default:return S}}L.toString=C}(N||(N={})),e.default=N}),define(ke[169],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(ke[77],Ee([1,0,19,14]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class L{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const v=E.charCodeAt(0),u=this.b.charCodeAt(this.c);return v-u}value(){return this.b[this.c]}}e.$si=L;class R{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,N.$nf)(E,this.b,0,E.length,this.c,this.d):(0,N.$pf)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=R;class M{constructor(E=!0,v=!0){this.f=E,this.g=v}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let v=E.length-1;v>=0;v--,this.c--){const u=this.b.charCodeAt(v);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,N.$nf)(E,this.b,0,E.length,this.d,this.e):(0,N.$pf)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=M;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(E,v){this.f=E,this.g=v,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,N.$of)(E,this.c.scheme);if(this.d[this.e]===2)return(0,N.$of)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,N.$mf)(E,this.c.query);if(this.d[this.e]===5)return(0,N.$mf)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=$;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(A||(A={}));class C{static forUris(E=()=>!1,v=()=>!1){return new C(new $(E,v))}static forPaths(E=!1){return new C(new M(void 0,!E))}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new R)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,v){if(v){const u=v.slice(0);(0,l.$Xb)(u);for(const f of u)this.set(f,E)}else{const u=E.slice(0);(0,l.$Xb)(u);for(const f of u)this.set(f[0],f[1])}}set(E,v){const u=this.b.reset(E);let f;this.c||(this.c=new S,this.c.segment=u.value());const a=[];for(f=this.c;;){const i=u.cmp(f.segment);if(i>0)f.left||(f.left=new S,f.left.segment=u.value()),a.push([-1,f]),f=f.left;else if(i<0)f.right||(f.right=new S,f.right.segment=u.value()),a.push([1,f]),f=f.right;else if(u.hasNext())u.next(),f.mid||(f.mid=new S,f.mid.segment=u.value()),a.push([0,f]),f=f.mid;else break}const n=f.value;f.value=v,f.key=E;for(let i=a.length-1;i>=0;i--){const s=a[i][1];s.updateHeight();const o=s.balanceFactor();if(o<-1||o>1){const t=a[i][0],g=a[i+1][0];if(t===1&&g===1)a[i][1]=s.rotateLeft();else if(t===-1&&g===-1)a[i][1]=s.rotateRight();else if(t===1&&g===-1)s.right=a[i+1][1]=a[i+1][1].rotateRight(),a[i][1]=s.rotateLeft();else if(t===-1&&g===1)s.left=a[i+1][1]=a[i+1][1].rotateLeft(),a[i][1]=s.rotateRight();else throw new Error;if(i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}return n}get(E){return this.d(E)?.value}d(E){const v=this.b.reset(E);let u=this.c;for(;u;){const f=v.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(v.hasNext())v.next(),u=u.mid;else break}return u}has(E){const v=this.d(E);return!(v?.value===void 0&&v?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,v){const u=this.b.reset(E),f=[];let a=this.c;for(;a;){const n=u.cmp(a.segment);if(n>0)f.push([-1,a]),a=a.left;else if(n<0)f.push([1,a]),a=a.right;else if(u.hasNext())u.next(),f.push([0,a]),a=a.mid;else break}if(a){if(v?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const n=this.f(a.right);if(n.key){const{key:i,value:s,segment:o}=n;this.e(n.key,!1),a.key=i,a.value=s,a.segment=o}}else{const n=a.left??a.right;if(f.length>0){const[i,s]=f[f.length-1];switch(i){case-1:s.left=n;break;case 0:s.mid=n;break;case 1:s.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const i=f[n][1];i.updateHeight();const s=i.balanceFactor();if(s>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),f[n][1]=i.rotateLeft()):s<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),f[n][1]=i.rotateRight()),n>0)switch(f[n-1][0]){case-1:f[n-1][1].left=f[n][1];break;case 1:f[n-1][1].right=f[n][1];break;case 0:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const v=this.b.reset(E);let u=this.c,f;for(;u;){const a=v.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(v.hasNext())v.next(),f=u.value||f,u=u.mid;else break}return u&&u.value||f}findSuperstr(E){return this.g(E,!1)}g(E,v){const u=this.b.reset(E);let f=this.c;for(;f;){const a=u.cmp(f.segment);if(a>0)f=f.left;else if(a<0)f=f.right;else if(u.hasNext())u.next(),f=f.mid;else return f.mid?this.h(f.mid):v?f.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[v,u]of this)E(u,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const v=[];return this.j(E,v),v[Symbol.iterator]()}j(E,v){E&&(E.left&&this.j(E.left,v),E.value&&v.push([E.key,E.value]),E.mid&&this.j(E.mid,v),E.right&&this.j(E.right,v))}_isBalanced(){const E=v=>{if(!v)return!0;const u=v.balanceFactor();return u<-1||u>1?!1:E(v.left)&&E(v.right)};return E(this.c)}}e.$wi=C}),define(ke[18],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=l,e.$5f=N,e.$6f=L,e.$7f=R,e.$8f=M,e.$9f=b,e.$0f=$,e.$$f=S,e.$_f=A,e.$ag=C,e.$bg=m,e.$cg=E,e.$dg=v,e.$eg=f,e.$fg=a,e.$gg=n,e.$hg=i,e.$ig=s;function l(o){return typeof o=="string"}function N(o){return Array.isArray(o)&&o.every(t=>l(t))}function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function R(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function M(o){return typeof o=="number"&&!isNaN(o)}function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}function $(o){return o===!0||o===!1}function S(o){return typeof o>"u"}function A(o){return!C(o)}function C(o){return S(o)||o===null}function m(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function E(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function v(...o){const t=[];for(let g=0;g<o.length;g++){const h=o[g];if(C(h))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);t.push(h)}return t}const u=Object.prototype.hasOwnProperty;function f(o){if(!L(o))return!1;for(const t in o)if(u.call(o,t))return!1;return!0}function a(o){return typeof o=="function"}function n(...o){return o.length>0&&o.every(a)}function i(o,t){const g=Math.min(o.length,t.length);for(let h=0;h<g;h++)s(o[h],t[h])}function s(o,t){if(l(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!C(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Ee([1,0,18]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=L,e.$Lj=R;const N=Object.create(null);function L(M,b){if((0,l.$4f)(b)){const $=N[b];if($===void 0)throw new Error(`${M} references an unknown codicon: ${b}`);b=$}return N[M]=b,{id:M}}function R(){return N}}),define(ke[170],Ee([1,0,99]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=void 0,e.$Mj={add:(0,l.$Kj)("add",6e4),plus:(0,l.$Kj)("plus",6e4),gistNew:(0,l.$Kj)("gist-new",6e4),repoCreate:(0,l.$Kj)("repo-create",6e4),lightbulb:(0,l.$Kj)("lightbulb",60001),lightBulb:(0,l.$Kj)("light-bulb",60001),repo:(0,l.$Kj)("repo",60002),repoDelete:(0,l.$Kj)("repo-delete",60002),gistFork:(0,l.$Kj)("gist-fork",60003),repoForked:(0,l.$Kj)("repo-forked",60003),gitPullRequest:(0,l.$Kj)("git-pull-request",60004),gitPullRequestAbandoned:(0,l.$Kj)("git-pull-request-abandoned",60004),recordKeys:(0,l.$Kj)("record-keys",60005),keyboard:(0,l.$Kj)("keyboard",60005),tag:(0,l.$Kj)("tag",60006),gitPullRequestLabel:(0,l.$Kj)("git-pull-request-label",60006),tagAdd:(0,l.$Kj)("tag-add",60006),tagRemove:(0,l.$Kj)("tag-remove",60006),person:(0,l.$Kj)("person",60007),personFollow:(0,l.$Kj)("person-follow",60007),personOutline:(0,l.$Kj)("person-outline",60007),personFilled:(0,l.$Kj)("person-filled",60007),gitBranch:(0,l.$Kj)("git-branch",60008),gitBranchCreate:(0,l.$Kj)("git-branch-create",60008),gitBranchDelete:(0,l.$Kj)("git-branch-delete",60008),sourceControl:(0,l.$Kj)("source-control",60008),mirror:(0,l.$Kj)("mirror",60009),mirrorPublic:(0,l.$Kj)("mirror-public",60009),star:(0,l.$Kj)("star",60010),starAdd:(0,l.$Kj)("star-add",60010),starDelete:(0,l.$Kj)("star-delete",60010),starEmpty:(0,l.$Kj)("star-empty",60010),comment:(0,l.$Kj)("comment",60011),commentAdd:(0,l.$Kj)("comment-add",60011),alert:(0,l.$Kj)("alert",60012),warning:(0,l.$Kj)("warning",60012),search:(0,l.$Kj)("search",60013),searchSave:(0,l.$Kj)("search-save",60013),logOut:(0,l.$Kj)("log-out",60014),signOut:(0,l.$Kj)("sign-out",60014),logIn:(0,l.$Kj)("log-in",60015),signIn:(0,l.$Kj)("sign-in",60015),eye:(0,l.$Kj)("eye",60016),eyeUnwatch:(0,l.$Kj)("eye-unwatch",60016),eyeWatch:(0,l.$Kj)("eye-watch",60016),circleFilled:(0,l.$Kj)("circle-filled",60017),primitiveDot:(0,l.$Kj)("primitive-dot",60017),closeDirty:(0,l.$Kj)("close-dirty",60017),debugBreakpoint:(0,l.$Kj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,l.$Kj)("debug-breakpoint-disabled",60017),debugHint:(0,l.$Kj)("debug-hint",60017),terminalDecorationSuccess:(0,l.$Kj)("terminal-decoration-success",60017),primitiveSquare:(0,l.$Kj)("primitive-square",60018),edit:(0,l.$Kj)("edit",60019),pencil:(0,l.$Kj)("pencil",60019),info:(0,l.$Kj)("info",60020),issueOpened:(0,l.$Kj)("issue-opened",60020),gistPrivate:(0,l.$Kj)("gist-private",60021),gitForkPrivate:(0,l.$Kj)("git-fork-private",60021),lock:(0,l.$Kj)("lock",60021),mirrorPrivate:(0,l.$Kj)("mirror-private",60021),close:(0,l.$Kj)("close",60022),removeClose:(0,l.$Kj)("remove-close",60022),x:(0,l.$Kj)("x",60022),repoSync:(0,l.$Kj)("repo-sync",60023),sync:(0,l.$Kj)("sync",60023),clone:(0,l.$Kj)("clone",60024),desktopDownload:(0,l.$Kj)("desktop-download",60024),beaker:(0,l.$Kj)("beaker",60025),microscope:(0,l.$Kj)("microscope",60025),vm:(0,l.$Kj)("vm",60026),deviceDesktop:(0,l.$Kj)("device-desktop",60026),file:(0,l.$Kj)("file",60027),fileText:(0,l.$Kj)("file-text",60027),more:(0,l.$Kj)("more",60028),ellipsis:(0,l.$Kj)("ellipsis",60028),kebabHorizontal:(0,l.$Kj)("kebab-horizontal",60028),mailReply:(0,l.$Kj)("mail-reply",60029),reply:(0,l.$Kj)("reply",60029),organization:(0,l.$Kj)("organization",60030),organizationFilled:(0,l.$Kj)("organization-filled",60030),organizationOutline:(0,l.$Kj)("organization-outline",60030),newFile:(0,l.$Kj)("new-file",60031),fileAdd:(0,l.$Kj)("file-add",60031),newFolder:(0,l.$Kj)("new-folder",60032),fileDirectoryCreate:(0,l.$Kj)("file-directory-create",60032),trash:(0,l.$Kj)("trash",60033),trashcan:(0,l.$Kj)("trashcan",60033),history:(0,l.$Kj)("history",60034),clock:(0,l.$Kj)("clock",60034),folder:(0,l.$Kj)("folder",60035),fileDirectory:(0,l.$Kj)("file-directory",60035),symbolFolder:(0,l.$Kj)("symbol-folder",60035),logoGithub:(0,l.$Kj)("logo-github",60036),markGithub:(0,l.$Kj)("mark-github",60036),github:(0,l.$Kj)("github",60036),terminal:(0,l.$Kj)("terminal",60037),console:(0,l.$Kj)("console",60037),repl:(0,l.$Kj)("repl",60037),zap:(0,l.$Kj)("zap",60038),symbolEvent:(0,l.$Kj)("symbol-event",60038),error:(0,l.$Kj)("error",60039),stop:(0,l.$Kj)("stop",60039),variable:(0,l.$Kj)("variable",60040),symbolVariable:(0,l.$Kj)("symbol-variable",60040),array:(0,l.$Kj)("array",60042),symbolArray:(0,l.$Kj)("symbol-array",60042),symbolModule:(0,l.$Kj)("symbol-module",60043),symbolPackage:(0,l.$Kj)("symbol-package",60043),symbolNamespace:(0,l.$Kj)("symbol-namespace",60043),symbolObject:(0,l.$Kj)("symbol-object",60043),symbolMethod:(0,l.$Kj)("symbol-method",60044),symbolFunction:(0,l.$Kj)("symbol-function",60044),symbolConstructor:(0,l.$Kj)("symbol-constructor",60044),symbolBoolean:(0,l.$Kj)("symbol-boolean",60047),symbolNull:(0,l.$Kj)("symbol-null",60047),symbolNumeric:(0,l.$Kj)("symbol-numeric",60048),symbolNumber:(0,l.$Kj)("symbol-number",60048),symbolStructure:(0,l.$Kj)("symbol-structure",60049),symbolStruct:(0,l.$Kj)("symbol-struct",60049),symbolParameter:(0,l.$Kj)("symbol-parameter",60050),symbolTypeParameter:(0,l.$Kj)("symbol-type-parameter",60050),symbolKey:(0,l.$Kj)("symbol-key",60051),symbolText:(0,l.$Kj)("symbol-text",60051),symbolReference:(0,l.$Kj)("symbol-reference",60052),goToFile:(0,l.$Kj)("go-to-file",60052),symbolEnum:(0,l.$Kj)("symbol-enum",60053),symbolValue:(0,l.$Kj)("symbol-value",60053),symbolRuler:(0,l.$Kj)("symbol-ruler",60054),symbolUnit:(0,l.$Kj)("symbol-unit",60054),activateBreakpoints:(0,l.$Kj)("activate-breakpoints",60055),archive:(0,l.$Kj)("archive",60056),arrowBoth:(0,l.$Kj)("arrow-both",60057),arrowDown:(0,l.$Kj)("arrow-down",60058),arrowLeft:(0,l.$Kj)("arrow-left",60059),arrowRight:(0,l.$Kj)("arrow-right",60060),arrowSmallDown:(0,l.$Kj)("arrow-small-down",60061),arrowSmallLeft:(0,l.$Kj)("arrow-small-left",60062),arrowSmallRight:(0,l.$Kj)("arrow-small-right",60063),arrowSmallUp:(0,l.$Kj)("arrow-small-up",60064),arrowUp:(0,l.$Kj)("arrow-up",60065),bell:(0,l.$Kj)("bell",60066),bold:(0,l.$Kj)("bold",60067),book:(0,l.$Kj)("book",60068),bookmark:(0,l.$Kj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,l.$Kj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,l.$Kj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,l.$Kj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,l.$Kj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,l.$Kj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,l.$Kj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,l.$Kj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,l.$Kj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,l.$Kj)("debug-breakpoint-log-disabled",60075),briefcase:(0,l.$Kj)("briefcase",60076),broadcast:(0,l.$Kj)("broadcast",60077),browser:(0,l.$Kj)("browser",60078),bug:(0,l.$Kj)("bug",60079),calendar:(0,l.$Kj)("calendar",60080),caseSensitive:(0,l.$Kj)("case-sensitive",60081),check:(0,l.$Kj)("check",60082),checklist:(0,l.$Kj)("checklist",60083),chevronDown:(0,l.$Kj)("chevron-down",60084),chevronLeft:(0,l.$Kj)("chevron-left",60085),chevronRight:(0,l.$Kj)("chevron-right",60086),chevronUp:(0,l.$Kj)("chevron-up",60087),chromeClose:(0,l.$Kj)("chrome-close",60088),chromeMaximize:(0,l.$Kj)("chrome-maximize",60089),chromeMinimize:(0,l.$Kj)("chrome-minimize",60090),chromeRestore:(0,l.$Kj)("chrome-restore",60091),circleOutline:(0,l.$Kj)("circle-outline",60092),circle:(0,l.$Kj)("circle",60092),debugBreakpointUnverified:(0,l.$Kj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,l.$Kj)("terminal-decoration-incomplete",60092),circleSlash:(0,l.$Kj)("circle-slash",60093),circuitBoard:(0,l.$Kj)("circuit-board",60094),clearAll:(0,l.$Kj)("clear-all",60095),clippy:(0,l.$Kj)("clippy",60096),closeAll:(0,l.$Kj)("close-all",60097),cloudDownload:(0,l.$Kj)("cloud-download",60098),cloudUpload:(0,l.$Kj)("cloud-upload",60099),code:(0,l.$Kj)("code",60100),collapseAll:(0,l.$Kj)("collapse-all",60101),colorMode:(0,l.$Kj)("color-mode",60102),commentDiscussion:(0,l.$Kj)("comment-discussion",60103),creditCard:(0,l.$Kj)("credit-card",60105),dash:(0,l.$Kj)("dash",60108),dashboard:(0,l.$Kj)("dashboard",60109),database:(0,l.$Kj)("database",60110),debugContinue:(0,l.$Kj)("debug-continue",60111),debugDisconnect:(0,l.$Kj)("debug-disconnect",60112),debugPause:(0,l.$Kj)("debug-pause",60113),debugRestart:(0,l.$Kj)("debug-restart",60114),debugStart:(0,l.$Kj)("debug-start",60115),debugStepInto:(0,l.$Kj)("debug-step-into",60116),debugStepOut:(0,l.$Kj)("debug-step-out",60117),debugStepOver:(0,l.$Kj)("debug-step-over",60118),debugStop:(0,l.$Kj)("debug-stop",60119),debug:(0,l.$Kj)("debug",60120),deviceCameraVideo:(0,l.$Kj)("device-camera-video",60121),deviceCamera:(0,l.$Kj)("device-camera",60122),deviceMobile:(0,l.$Kj)("device-mobile",60123),diffAdded:(0,l.$Kj)("diff-added",60124),diffIgnored:(0,l.$Kj)("diff-ignored",60125),diffModified:(0,l.$Kj)("diff-modified",60126),diffRemoved:(0,l.$Kj)("diff-removed",60127),diffRenamed:(0,l.$Kj)("diff-renamed",60128),diff:(0,l.$Kj)("diff",60129),diffSidebyside:(0,l.$Kj)("diff-sidebyside",60129),discard:(0,l.$Kj)("discard",60130),editorLayout:(0,l.$Kj)("editor-layout",60131),emptyWindow:(0,l.$Kj)("empty-window",60132),exclude:(0,l.$Kj)("exclude",60133),extensions:(0,l.$Kj)("extensions",60134),eyeClosed:(0,l.$Kj)("eye-closed",60135),fileBinary:(0,l.$Kj)("file-binary",60136),fileCode:(0,l.$Kj)("file-code",60137),fileMedia:(0,l.$Kj)("file-media",60138),filePdf:(0,l.$Kj)("file-pdf",60139),fileSubmodule:(0,l.$Kj)("file-submodule",60140),fileSymlinkDirectory:(0,l.$Kj)("file-symlink-directory",60141),fileSymlinkFile:(0,l.$Kj)("file-symlink-file",60142),fileZip:(0,l.$Kj)("file-zip",60143),files:(0,l.$Kj)("files",60144),filter:(0,l.$Kj)("filter",60145),flame:(0,l.$Kj)("flame",60146),foldDown:(0,l.$Kj)("fold-down",60147),foldUp:(0,l.$Kj)("fold-up",60148),fold:(0,l.$Kj)("fold",60149),folderActive:(0,l.$Kj)("folder-active",60150),folderOpened:(0,l.$Kj)("folder-opened",60151),gear:(0,l.$Kj)("gear",60152),gift:(0,l.$Kj)("gift",60153),gistSecret:(0,l.$Kj)("gist-secret",60154),gist:(0,l.$Kj)("gist",60155),gitCommit:(0,l.$Kj)("git-commit",60156),gitCompare:(0,l.$Kj)("git-compare",60157),compareChanges:(0,l.$Kj)("compare-changes",60157),gitMerge:(0,l.$Kj)("git-merge",60158),githubAction:(0,l.$Kj)("github-action",60159),githubAlt:(0,l.$Kj)("github-alt",60160),globe:(0,l.$Kj)("globe",60161),grabber:(0,l.$Kj)("grabber",60162),graph:(0,l.$Kj)("graph",60163),gripper:(0,l.$Kj)("gripper",60164),heart:(0,l.$Kj)("heart",60165),home:(0,l.$Kj)("home",60166),horizontalRule:(0,l.$Kj)("horizontal-rule",60167),hubot:(0,l.$Kj)("hubot",60168),inbox:(0,l.$Kj)("inbox",60169),issueReopened:(0,l.$Kj)("issue-reopened",60171),issues:(0,l.$Kj)("issues",60172),italic:(0,l.$Kj)("italic",60173),jersey:(0,l.$Kj)("jersey",60174),json:(0,l.$Kj)("json",60175),kebabVertical:(0,l.$Kj)("kebab-vertical",60176),key:(0,l.$Kj)("key",60177),law:(0,l.$Kj)("law",60178),lightbulbAutofix:(0,l.$Kj)("lightbulb-autofix",60179),linkExternal:(0,l.$Kj)("link-external",60180),link:(0,l.$Kj)("link",60181),listOrdered:(0,l.$Kj)("list-ordered",60182),listUnordered:(0,l.$Kj)("list-unordered",60183),liveShare:(0,l.$Kj)("live-share",60184),loading:(0,l.$Kj)("loading",60185),location:(0,l.$Kj)("location",60186),mailRead:(0,l.$Kj)("mail-read",60187),mail:(0,l.$Kj)("mail",60188),markdown:(0,l.$Kj)("markdown",60189),megaphone:(0,l.$Kj)("megaphone",60190),mention:(0,l.$Kj)("mention",60191),milestone:(0,l.$Kj)("milestone",60192),gitPullRequestMilestone:(0,l.$Kj)("git-pull-request-milestone",60192),mortarBoard:(0,l.$Kj)("mortar-board",60193),move:(0,l.$Kj)("move",60194),multipleWindows:(0,l.$Kj)("multiple-windows",60195),mute:(0,l.$Kj)("mute",60196),noNewline:(0,l.$Kj)("no-newline",60197),note:(0,l.$Kj)("note",60198),octoface:(0,l.$Kj)("octoface",60199),openPreview:(0,l.$Kj)("open-preview",60200),package:(0,l.$Kj)("package",60201),paintcan:(0,l.$Kj)("paintcan",60202),pin:(0,l.$Kj)("pin",60203),play:(0,l.$Kj)("play",60204),run:(0,l.$Kj)("run",60204),plug:(0,l.$Kj)("plug",60205),preserveCase:(0,l.$Kj)("preserve-case",60206),preview:(0,l.$Kj)("preview",60207),project:(0,l.$Kj)("project",60208),pulse:(0,l.$Kj)("pulse",60209),question:(0,l.$Kj)("question",60210),quote:(0,l.$Kj)("quote",60211),radioTower:(0,l.$Kj)("radio-tower",60212),reactions:(0,l.$Kj)("reactions",60213),references:(0,l.$Kj)("references",60214),refresh:(0,l.$Kj)("refresh",60215),regex:(0,l.$Kj)("regex",60216),remoteExplorer:(0,l.$Kj)("remote-explorer",60217),remote:(0,l.$Kj)("remote",60218),remove:(0,l.$Kj)("remove",60219),replaceAll:(0,l.$Kj)("replace-all",60220),replace:(0,l.$Kj)("replace",60221),repoClone:(0,l.$Kj)("repo-clone",60222),repoForcePush:(0,l.$Kj)("repo-force-push",60223),repoPull:(0,l.$Kj)("repo-pull",60224),repoPush:(0,l.$Kj)("repo-push",60225),report:(0,l.$Kj)("report",60226),requestChanges:(0,l.$Kj)("request-changes",60227),rocket:(0,l.$Kj)("rocket",60228),rootFolderOpened:(0,l.$Kj)("root-folder-opened",60229),rootFolder:(0,l.$Kj)("root-folder",60230),rss:(0,l.$Kj)("rss",60231),ruby:(0,l.$Kj)("ruby",60232),saveAll:(0,l.$Kj)("save-all",60233),saveAs:(0,l.$Kj)("save-as",60234),save:(0,l.$Kj)("save",60235),screenFull:(0,l.$Kj)("screen-full",60236),screenNormal:(0,l.$Kj)("screen-normal",60237),searchStop:(0,l.$Kj)("search-stop",60238),server:(0,l.$Kj)("server",60240),settingsGear:(0,l.$Kj)("settings-gear",60241),settings:(0,l.$Kj)("settings",60242),shield:(0,l.$Kj)("shield",60243),smiley:(0,l.$Kj)("smiley",60244),sortPrecedence:(0,l.$Kj)("sort-precedence",60245),splitHorizontal:(0,l.$Kj)("split-horizontal",60246),splitVertical:(0,l.$Kj)("split-vertical",60247),squirrel:(0,l.$Kj)("squirrel",60248),starFull:(0,l.$Kj)("star-full",60249),starHalf:(0,l.$Kj)("star-half",60250),symbolClass:(0,l.$Kj)("symbol-class",60251),symbolColor:(0,l.$Kj)("symbol-color",60252),symbolConstant:(0,l.$Kj)("symbol-constant",60253),symbolEnumMember:(0,l.$Kj)("symbol-enum-member",60254),symbolField:(0,l.$Kj)("symbol-field",60255),symbolFile:(0,l.$Kj)("symbol-file",60256),symbolInterface:(0,l.$Kj)("symbol-interface",60257),symbolKeyword:(0,l.$Kj)("symbol-keyword",60258),symbolMisc:(0,l.$Kj)("symbol-misc",60259),symbolOperator:(0,l.$Kj)("symbol-operator",60260),symbolProperty:(0,l.$Kj)("symbol-property",60261),wrench:(0,l.$Kj)("wrench",60261),wrenchSubaction:(0,l.$Kj)("wrench-subaction",60261),symbolSnippet:(0,l.$Kj)("symbol-snippet",60262),tasklist:(0,l.$Kj)("tasklist",60263),telescope:(0,l.$Kj)("telescope",60264),textSize:(0,l.$Kj)("text-size",60265),threeBars:(0,l.$Kj)("three-bars",60266),thumbsdown:(0,l.$Kj)("thumbsdown",60267),thumbsup:(0,l.$Kj)("thumbsup",60268),tools:(0,l.$Kj)("tools",60269),triangleDown:(0,l.$Kj)("triangle-down",60270),triangleLeft:(0,l.$Kj)("triangle-left",60271),triangleRight:(0,l.$Kj)("triangle-right",60272),triangleUp:(0,l.$Kj)("triangle-up",60273),twitter:(0,l.$Kj)("twitter",60274),unfold:(0,l.$Kj)("unfold",60275),unlock:(0,l.$Kj)("unlock",60276),unmute:(0,l.$Kj)("unmute",60277),unverified:(0,l.$Kj)("unverified",60278),verified:(0,l.$Kj)("verified",60279),versions:(0,l.$Kj)("versions",60280),vmActive:(0,l.$Kj)("vm-active",60281),vmOutline:(0,l.$Kj)("vm-outline",60282),vmRunning:(0,l.$Kj)("vm-running",60283),watch:(0,l.$Kj)("watch",60284),whitespace:(0,l.$Kj)("whitespace",60285),wholeWord:(0,l.$Kj)("whole-word",60286),window:(0,l.$Kj)("window",60287),wordWrap:(0,l.$Kj)("word-wrap",60288),zoomIn:(0,l.$Kj)("zoom-in",60289),zoomOut:(0,l.$Kj)("zoom-out",60290),listFilter:(0,l.$Kj)("list-filter",60291),listFlat:(0,l.$Kj)("list-flat",60292),listSelection:(0,l.$Kj)("list-selection",60293),selection:(0,l.$Kj)("selection",60293),listTree:(0,l.$Kj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,l.$Kj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,l.$Kj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,l.$Kj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,l.$Kj)("debug-stackframe-active",60297),circleSmallFilled:(0,l.$Kj)("circle-small-filled",60298),debugStackframeDot:(0,l.$Kj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,l.$Kj)("terminal-decoration-mark",60298),debugStackframe:(0,l.$Kj)("debug-stackframe",60299),debugStackframeFocused:(0,l.$Kj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,l.$Kj)("debug-breakpoint-unsupported",60300),symbolString:(0,l.$Kj)("symbol-string",60301),debugReverseContinue:(0,l.$Kj)("debug-reverse-continue",60302),debugStepBack:(0,l.$Kj)("debug-step-back",60303),debugRestartFrame:(0,l.$Kj)("debug-restart-frame",60304),debugAlt:(0,l.$Kj)("debug-alt",60305),callIncoming:(0,l.$Kj)("call-incoming",60306),callOutgoing:(0,l.$Kj)("call-outgoing",60307),menu:(0,l.$Kj)("menu",60308),expandAll:(0,l.$Kj)("expand-all",60309),feedback:(0,l.$Kj)("feedback",60310),gitPullRequestReviewer:(0,l.$Kj)("git-pull-request-reviewer",60310),groupByRefType:(0,l.$Kj)("group-by-ref-type",60311),ungroupByRefType:(0,l.$Kj)("ungroup-by-ref-type",60312),account:(0,l.$Kj)("account",60313),gitPullRequestAssignee:(0,l.$Kj)("git-pull-request-assignee",60313),bellDot:(0,l.$Kj)("bell-dot",60314),debugConsole:(0,l.$Kj)("debug-console",60315),library:(0,l.$Kj)("library",60316),output:(0,l.$Kj)("output",60317),runAll:(0,l.$Kj)("run-all",60318),syncIgnored:(0,l.$Kj)("sync-ignored",60319),pinned:(0,l.$Kj)("pinned",60320),githubInverted:(0,l.$Kj)("github-inverted",60321),serverProcess:(0,l.$Kj)("server-process",60322),serverEnvironment:(0,l.$Kj)("server-environment",60323),pass:(0,l.$Kj)("pass",60324),issueClosed:(0,l.$Kj)("issue-closed",60324),stopCircle:(0,l.$Kj)("stop-circle",60325),playCircle:(0,l.$Kj)("play-circle",60326),record:(0,l.$Kj)("record",60327),debugAltSmall:(0,l.$Kj)("debug-alt-small",60328),vmConnect:(0,l.$Kj)("vm-connect",60329),cloud:(0,l.$Kj)("cloud",60330),merge:(0,l.$Kj)("merge",60331),export:(0,l.$Kj)("export",60332),graphLeft:(0,l.$Kj)("graph-left",60333),magnet:(0,l.$Kj)("magnet",60334),notebook:(0,l.$Kj)("notebook",60335),redo:(0,l.$Kj)("redo",60336),checkAll:(0,l.$Kj)("check-all",60337),pinnedDirty:(0,l.$Kj)("pinned-dirty",60338),passFilled:(0,l.$Kj)("pass-filled",60339),circleLargeFilled:(0,l.$Kj)("circle-large-filled",60340),circleLarge:(0,l.$Kj)("circle-large",60341),circleLargeOutline:(0,l.$Kj)("circle-large-outline",60341),combine:(0,l.$Kj)("combine",60342),gather:(0,l.$Kj)("gather",60342),table:(0,l.$Kj)("table",60343),variableGroup:(0,l.$Kj)("variable-group",60344),typeHierarchy:(0,l.$Kj)("type-hierarchy",60345),typeHierarchySub:(0,l.$Kj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,l.$Kj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,l.$Kj)("git-pull-request-create",60348),runAbove:(0,l.$Kj)("run-above",60349),runBelow:(0,l.$Kj)("run-below",60350),notebookTemplate:(0,l.$Kj)("notebook-template",60351),debugRerun:(0,l.$Kj)("debug-rerun",60352),workspaceTrusted:(0,l.$Kj)("workspace-trusted",60353),workspaceUntrusted:(0,l.$Kj)("workspace-untrusted",60354),workspaceUnknown:(0,l.$Kj)("workspace-unknown",60355),terminalCmd:(0,l.$Kj)("terminal-cmd",60356),terminalDebian:(0,l.$Kj)("terminal-debian",60357),terminalLinux:(0,l.$Kj)("terminal-linux",60358),terminalPowershell:(0,l.$Kj)("terminal-powershell",60359),terminalTmux:(0,l.$Kj)("terminal-tmux",60360),terminalUbuntu:(0,l.$Kj)("terminal-ubuntu",60361),terminalBash:(0,l.$Kj)("terminal-bash",60362),arrowSwap:(0,l.$Kj)("arrow-swap",60363),copy:(0,l.$Kj)("copy",60364),personAdd:(0,l.$Kj)("person-add",60365),filterFilled:(0,l.$Kj)("filter-filled",60366),wand:(0,l.$Kj)("wand",60367),debugLineByLine:(0,l.$Kj)("debug-line-by-line",60368),inspect:(0,l.$Kj)("inspect",60369),layers:(0,l.$Kj)("layers",60370),layersDot:(0,l.$Kj)("layers-dot",60371),layersActive:(0,l.$Kj)("layers-active",60372),compass:(0,l.$Kj)("compass",60373),compassDot:(0,l.$Kj)("compass-dot",60374),compassActive:(0,l.$Kj)("compass-active",60375),azure:(0,l.$Kj)("azure",60376),issueDraft:(0,l.$Kj)("issue-draft",60377),gitPullRequestClosed:(0,l.$Kj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,l.$Kj)("git-pull-request-draft",60379),debugAll:(0,l.$Kj)("debug-all",60380),debugCoverage:(0,l.$Kj)("debug-coverage",60381),runErrors:(0,l.$Kj)("run-errors",60382),folderLibrary:(0,l.$Kj)("folder-library",60383),debugContinueSmall:(0,l.$Kj)("debug-continue-small",60384),beakerStop:(0,l.$Kj)("beaker-stop",60385),graphLine:(0,l.$Kj)("graph-line",60386),graphScatter:(0,l.$Kj)("graph-scatter",60387),pieChart:(0,l.$Kj)("pie-chart",60388),bracket:(0,l.$Kj)("bracket",60175),bracketDot:(0,l.$Kj)("bracket-dot",60389),bracketError:(0,l.$Kj)("bracket-error",60390),lockSmall:(0,l.$Kj)("lock-small",60391),azureDevops:(0,l.$Kj)("azure-devops",60392),verifiedFilled:(0,l.$Kj)("verified-filled",60393),newline:(0,l.$Kj)("newline",60394),layout:(0,l.$Kj)("layout",60395),layoutActivitybarLeft:(0,l.$Kj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,l.$Kj)("layout-activitybar-right",60397),layoutPanelLeft:(0,l.$Kj)("layout-panel-left",60398),layoutPanelCenter:(0,l.$Kj)("layout-panel-center",60399),layoutPanelJustify:(0,l.$Kj)("layout-panel-justify",60400),layoutPanelRight:(0,l.$Kj)("layout-panel-right",60401),layoutPanel:(0,l.$Kj)("layout-panel",60402),layoutSidebarLeft:(0,l.$Kj)("layout-sidebar-left",60403),layoutSidebarRight:(0,l.$Kj)("layout-sidebar-right",60404),layoutStatusbar:(0,l.$Kj)("layout-statusbar",60405),layoutMenubar:(0,l.$Kj)("layout-menubar",60406),layoutCentered:(0,l.$Kj)("layout-centered",60407),target:(0,l.$Kj)("target",60408),indent:(0,l.$Kj)("indent",60409),recordSmall:(0,l.$Kj)("record-small",60410),errorSmall:(0,l.$Kj)("error-small",60411),terminalDecorationError:(0,l.$Kj)("terminal-decoration-error",60411),arrowCircleDown:(0,l.$Kj)("arrow-circle-down",60412),arrowCircleLeft:(0,l.$Kj)("arrow-circle-left",60413),arrowCircleRight:(0,l.$Kj)("arrow-circle-right",60414),arrowCircleUp:(0,l.$Kj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,l.$Kj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,l.$Kj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,l.$Kj)("layout-sidebar-left-off",60418),blank:(0,l.$Kj)("blank",60419),heartFilled:(0,l.$Kj)("heart-filled",60420),map:(0,l.$Kj)("map",60421),mapHorizontal:(0,l.$Kj)("map-horizontal",60421),foldHorizontal:(0,l.$Kj)("fold-horizontal",60421),mapFilled:(0,l.$Kj)("map-filled",60422),mapHorizontalFilled:(0,l.$Kj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,l.$Kj)("fold-horizontal-filled",60422),circleSmall:(0,l.$Kj)("circle-small",60423),bellSlash:(0,l.$Kj)("bell-slash",60424),bellSlashDot:(0,l.$Kj)("bell-slash-dot",60425),commentUnresolved:(0,l.$Kj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,l.$Kj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,l.$Kj)("git-pull-request-new-changes",60428),searchFuzzy:(0,l.$Kj)("search-fuzzy",60429),commentDraft:(0,l.$Kj)("comment-draft",60430),send:(0,l.$Kj)("send",60431),sparkle:(0,l.$Kj)("sparkle",60432),insert:(0,l.$Kj)("insert",60433),mic:(0,l.$Kj)("mic",60434),thumbsdownFilled:(0,l.$Kj)("thumbsdown-filled",60435),thumbsupFilled:(0,l.$Kj)("thumbsup-filled",60436),coffee:(0,l.$Kj)("coffee",60437),snake:(0,l.$Kj)("snake",60438),game:(0,l.$Kj)("game",60439),vr:(0,l.$Kj)("vr",60440),chip:(0,l.$Kj)("chip",60441),piano:(0,l.$Kj)("piano",60442),music:(0,l.$Kj)("music",60443),micFilled:(0,l.$Kj)("mic-filled",60444),repoFetch:(0,l.$Kj)("repo-fetch",60445),copilot:(0,l.$Kj)("copilot",60446),lightbulbSparkle:(0,l.$Kj)("lightbulb-sparkle",60447),robot:(0,l.$Kj)("robot",60448),sparkleFilled:(0,l.$Kj)("sparkle-filled",60449),diffSingle:(0,l.$Kj)("diff-single",60450),diffMultiple:(0,l.$Kj)("diff-multiple",60451),surroundWith:(0,l.$Kj)("surround-with",60452),share:(0,l.$Kj)("share",60453),gitStash:(0,l.$Kj)("git-stash",60454),gitStashApply:(0,l.$Kj)("git-stash-apply",60455),gitStashPop:(0,l.$Kj)("git-stash-pop",60456),vscode:(0,l.$Kj)("vscode",60457),vscodeInsiders:(0,l.$Kj)("vscode-insiders",60458),codeOss:(0,l.$Kj)("code-oss",60459),runCoverage:(0,l.$Kj)("run-coverage",60460),runAllCoverage:(0,l.$Kj)("run-all-coverage",60461),coverage:(0,l.$Kj)("coverage",60462),githubProject:(0,l.$Kj)("github-project",60463),mapVertical:(0,l.$Kj)("map-vertical",60464),foldVertical:(0,l.$Kj)("fold-vertical",60464),mapVerticalFilled:(0,l.$Kj)("map-vertical-filled",60465),foldVerticalFilled:(0,l.$Kj)("fold-vertical-filled",60465),goToSearch:(0,l.$Kj)("go-to-search",60466),percentage:(0,l.$Kj)("percentage",60467),sortPercentage:(0,l.$Kj)("sort-percentage",60467)}}),define(ke[78],Ee([1,0,99,170]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=void 0,e.$Nj=L;function L(){return Object.values(e.$Pj)}e.$Oj={dialogError:(0,l.$Kj)("dialog-error","error"),dialogWarning:(0,l.$Kj)("dialog-warning","warning"),dialogInfo:(0,l.$Kj)("dialog-info","info"),dialogClose:(0,l.$Kj)("dialog-close","close"),treeItemExpanded:(0,l.$Kj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,l.$Kj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,l.$Kj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,l.$Kj)("tree-filter-clear","close"),treeItemLoading:(0,l.$Kj)("tree-item-loading","loading"),menuSelection:(0,l.$Kj)("menu-selection","check"),menuSubmenu:(0,l.$Kj)("menu-submenu","chevron-right"),menuBarMore:(0,l.$Kj)("menubar-more","more"),scrollbarButtonLeft:(0,l.$Kj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,l.$Kj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,l.$Kj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,l.$Kj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,l.$Kj)("toolbar-more","more"),quickInputBack:(0,l.$Kj)("quick-input-back","arrow-left"),dropDownButton:(0,l.$Kj)("drop-down-button",60084),symbolCustomColor:(0,l.$Kj)("symbol-customcolor",60252),exportIcon:(0,l.$Kj)("export",60332),workspaceUnspecified:(0,l.$Kj)("workspace-unspecified",60355),newLine:(0,l.$Kj)("newline",60394),thumbsDownFilled:(0,l.$Kj)("thumbsdown-filled",60435),thumbsUpFilled:(0,l.$Kj)("thumbsup-filled",60436),gitFetch:(0,l.$Kj)("git-fetch",60445),lightbulbSparkleAutofix:(0,l.$Kj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,l.$Kj)("debug-breakpoint-pending",60377)},e.$Pj={...N.$Mj,...e.$Oj}}),define(ke[24],Ee([1,0,18]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=N,e.$Xn=L,e.$Yn=M,e.$Zn=$,e.$1n=S,e.$2n=A,e.$3n=C,e.$4n=m,e.$5n=E,e.$6n=v,e.$7n=u,e.$8n=f;function N(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const n=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([i,s])=>{n[i]=s&&typeof s=="object"?N(s):s}),n}function L(a){if(!a||typeof a!="object")return a;const n=[a];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const s in i)if(R.call(i,s)){const o=i[s];typeof o=="object"&&!Object.isFrozen(o)&&!(0,l.$7f)(o)&&n.push(o)}}return a}const R=Object.prototype.hasOwnProperty;function M(a,n){return b(a,n,new Set)}function b(a,n,i){if((0,l.$ag)(a))return a;const s=n(a);if(typeof s<"u")return s;if(Array.isArray(a)){const o=[];for(const t of a)o.push(b(t,n,i));return o}if((0,l.$6f)(a)){if(i.has(a))throw new Error("Cannot clone recursive data-structure");i.add(a);const o={};for(const t in a)R.call(a,t)&&(o[t]=b(a[t],n,i));return i.delete(a),o}return a}function $(a,n,i=!0){return(0,l.$6f)(a)?((0,l.$6f)(n)&&Object.keys(n).forEach(s=>{s in a?i&&((0,l.$6f)(a[s])&&(0,l.$6f)(n[s])?$(a[s],n[s],i):a[s]=n[s]):a[s]=n[s]}),a):n}function S(a,n){if(a===n)return!0;if(a==null||n===null||n===void 0||typeof a!=typeof n||typeof a!="object"||Array.isArray(a)!==Array.isArray(n))return!1;let i,s;if(Array.isArray(a)){if(a.length!==n.length)return!1;for(i=0;i<a.length;i++)if(!S(a[i],n[i]))return!1}else{const o=[];for(s in a)o.push(s);o.sort();const t=[];for(s in n)t.push(s);if(t.sort(),!S(o,t))return!1;for(i=0;i<o.length;i++)if(!S(a[o[i]],n[o[i]]))return!1}return!0}function A(a){const n=new Set;return JSON.stringify(a,(i,s)=>{if((0,l.$6f)(s)||Array.isArray(s)){if(n.has(s))return"[Circular]";n.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function C(a,n){const i=Object.create(null);return!a||!n||Object.keys(n).forEach(o=>{const t=a[o],g=n[o];S(t,g)||(i[o]=g)}),i}function m(a,n){const i=n.toLowerCase(),s=Object.keys(a).find(o=>o.toLowerCase()===i);return s?a[s]:a[n]}function E(a,n){const i=Object.create(null);for(const[s,o]of Object.entries(a))n(s,o)&&(i[s]=o);return i}function v(a){let n=[];for(;Object.prototype!==a;)n=n.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return n}function u(a){const n=[];for(const i of v(a))typeof a[i]=="function"&&n.push(i);return n}function f(a,n){const i=o=>function(){const t=Array.prototype.slice.call(arguments,0);return n(o,t)},s={};for(const o of a)s[o]=i(o);return s}}),define(ke[57],Ee([1,0,78]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=L;var N;(function(M){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}M.isThemeColor=b})(N||(e.ThemeColor=N={}));function L(M){return{id:M}}var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function $(n){const i=b.exec(n.id);if(!i)return $(l.$Pj.error);const[,s,o]=i,t=["codicon","codicon-"+s];return o&&t.push("codicon-modifier-"+o.substring(1)),t}M.asClassNameArray=$;function S(n){return $(n).join(" ")}M.asClassName=S;function A(n){return"."+$(n).join(".")}M.asCSSSelector=A;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}M.isThemeIcon=C;const m=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function E(n){const i=m.exec(n);if(!i)return;const[,s]=i;return{id:s}}M.fromString=E;function v(n){return{id:n}}M.fromId=v;function u(n,i){let s=n.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),i&&(s=`${s}~${i}`),{id:s}}M.modify=u;function f(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=f;function a(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=a})(R||(e.ThemeIcon=R={}))}),define(ke[171],Ee([1,0,126,14,57]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=$,e.$Ik=A,e.$Jk=m,e.$Kk=E,e.$Lk=u,e.$Mk=f;const R="$(",M=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function $(a){return a.replace(b,(n,i)=>i?n:`\\${n}`)}const S=new RegExp(`\\\\${M.source}`,"g");function A(a){return a.replace(S,n=>`\\${n}`)}const C=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(a){return a.indexOf(R)===-1?a:a.replace(C,(n,i,s,o)=>s?n:i||o||"")}function E(a){return a?a.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(a){v.lastIndex=0;let n="";const i=[];let s=0;for(;;){const o=v.lastIndex,t=v.exec(a),g=a.substring(o,t?.index);if(g.length>0){n+=g;for(let h=0;h<g.length;h++)i.push(s)}if(!t)break;s+=t[0].length}return{text:n,iconOffsets:i}}function f(a,n,i=!1){const{text:s,iconOffsets:o}=n;if(!o||o.length===0)return(0,l.$yk)(a,s,i);const t=(0,N.$af)(s," "),g=s.length-t.length,h=(0,l.$yk)(a,t,i);if(h)for(const c of h){const r=o[c.start+g]+g;c.start+=r,c.end+=r}return h}}),define(ke[127],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$1e=N,e.$2e=L;var l;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l||(e.Constants=l={}));function N(R){return R<0?0:R>255?255:R|0}function L(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(ke[30],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return l.test(L)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){L(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,S="";return S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+="-",S+=M[R[$++]],S+=M[R[$++]],S+="-",S+=M[R[$++]],S+=M[R[$++]],S+="-",S+=M[R[$++]],S+=M[R[$++]],S+="-",S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S}}()}),define(ke[172],Ee([1,0,19,39,30]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=R,e.$Ht=M,e.$Jt=S;function R(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}function M(C,m,E){const v={id:(0,L.$Mg)(),name:C,uri:m,data:E};return{asString:async()=>"",asFile:()=>v,value:void 0}}class b{constructor(){this.a=new Map}get size(){let m=0;for(const E of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const E=[...this.a.keys()];return N.Iterable.some(this,([v,u])=>u.asFile())&&E.push("files"),A($(m),E)}get(m){return this.a.get(this.b(m))?.[0]}append(m,E){const v=this.a.get(m);v?v.push(E):this.a.set(this.b(m),[E])}replace(m,E){this.a.set(this.b(m),[E])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,E]of this.a)for(const v of E)yield[m,v]}b(m){return $(m)}}e.$It=b;function $(C){return C.toLowerCase()}function S(C,m){return A($(C),m.map($))}function A(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const E=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[v,u,f]=E;return f==="*"?m.some(a=>a.startsWith(u+"/")):!1}e.$Kt=Object.freeze({create:C=>(0,l.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Kt.split(C).filter(m=>!m.startsWith("#"))})}),define(ke[173],Ee([1,0,63]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=N,e.$Qg=R;function N(b,$,S,A=1){let C=!1;return new Promise(m=>{const E=setTimeout(()=>{if(!C)return C=!0,m(0)},S);L(b,$,A,v=>{if(!C)return C=!0,clearTimeout(E),m(v)})})}function L(b,$,S,A){if($===0)return A(0);const C=new l.Socket;C.once("connect",()=>(M(C),L(b+S,$-1,S,A))),C.once("data",()=>{}),C.once("error",m=>(M(C),m.code!=="ECONNREFUSED"?L(b+S,$-1,S,A):A(b))),C.connect(b,"127.0.0.1")}e.$Pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,$,S,A="127.0.0.1"){let C=!1,m,E=1;const v=l.createServer({pauseOnConnect:!0});function u(f,a){C||(C=!0,v.removeAllListeners(),v.close(),m&&clearTimeout(m),a(f))}return new Promise(f=>{m=setTimeout(()=>{u(0,f)},S),v.on("listening",()=>{u(b,f)}),v.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&E<$?(b++,E++,v.listen(b,A)):u(0,f)}),v.on("close",()=>{u(0,f)}),v.listen(b,A)})}function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[128],Ee([1,0,127]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.$yt=void 0;class N{constructor(b){const $=(0,l.$1e)(b);this.c=$,this.a=N.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const S=(0,l.$1e)($);b>=0&&b<256?this.a[b]=S:this.b.set(b,S)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$yt=N;var L;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(L||(L={}));class R{constructor(){this.a=new N(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$zt=R}),define(ke[174],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=N;var l;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(l||(e.StringEOL=l={}));function N(L){let R=0,M=0,b=0,$=0;for(let S=0,A=L.length;S<A;S++){const C=L.charCodeAt(S);C===13?(R===0&&(M=S),R++,S+1<A&&L.charCodeAt(S+1)===10?($|=2,S++):$|=3,b=S+1):C===10&&($|=1,R===0&&(M=S),R++,b=S+1)}return R===0&&(M=L.length),[R,M,L.length-b,$]}}),define(ke[50],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=void 0;class l{constructor(L,R){this.lineNumber=L,this.column=R}with(L=this.lineNumber,R=this.column){return L===this.lineNumber&&R===this.column?this:new l(L,R)}delta(L=0,R=0){return this.with(this.lineNumber+L,this.column+R)}equals(L){return l.equals(this,L)}static equals(L,R){return!L&&!R?!0:!!L&&!!R&&L.lineNumber===R.lineNumber&&L.column===R.column}isBefore(L){return l.isBefore(this,L)}static isBefore(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<R.column}isBeforeOrEqual(L){return l.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<=R.column}static compare(L,R){const M=L.lineNumber|0,b=R.lineNumber|0;if(M===b){const $=L.column|0,S=R.column|0;return $-S}return M-b}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new l(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$jt=l}),define(ke[29],Ee([1,0,50]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0;class N{constructor(R,M,b,$){R>b||R===b&&M>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=R,this.endColumn=M):(this.startLineNumber=R,this.startColumn=M,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return N.containsPosition(this,R)}static containsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<R.startColumn||M.lineNumber===R.endLineNumber&&M.column>R.endColumn)}static strictContainsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<=R.startColumn||M.lineNumber===R.endLineNumber&&M.column>=R.endColumn)}containsRange(R){return N.containsRange(this,R)}static containsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>R.endColumn)}strictContainsRange(R){return N.strictContainsRange(this,R)}static strictContainsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<=R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>=R.endColumn)}plusRange(R){return N.plusRange(this,R)}static plusRange(R,M){let b,$,S,A;return M.startLineNumber<R.startLineNumber?(b=M.startLineNumber,$=M.startColumn):M.startLineNumber===R.startLineNumber?(b=M.startLineNumber,$=Math.min(M.startColumn,R.startColumn)):(b=R.startLineNumber,$=R.startColumn),M.endLineNumber>R.endLineNumber?(S=M.endLineNumber,A=M.endColumn):M.endLineNumber===R.endLineNumber?(S=M.endLineNumber,A=Math.max(M.endColumn,R.endColumn)):(S=R.endLineNumber,A=R.endColumn),new N(b,$,S,A)}intersectRanges(R){return N.intersectRanges(this,R)}static intersectRanges(R,M){let b=R.startLineNumber,$=R.startColumn,S=R.endLineNumber,A=R.endColumn;const C=M.startLineNumber,m=M.startColumn,E=M.endLineNumber,v=M.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),S>E?(S=E,A=v):S===E&&(A=Math.min(A,v)),b>S||b===S&&$>A?null:new N(b,$,S,A)}equalsRange(R){return N.equalsRange(this,R)}static equalsRange(R,M){return!R&&!M?!0:!!R&&!!M&&R.startLineNumber===M.startLineNumber&&R.startColumn===M.startColumn&&R.endLineNumber===M.endLineNumber&&R.endColumn===M.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(R){return new l.$jt(R.endLineNumber,R.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(R){return new l.$jt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,M){return new N(this.startLineNumber,this.startColumn,R,M)}setStartPosition(R,M){return new N(R,M,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(R){return new N(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(R){return new N(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new N(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,M=R){return new N(R.lineNumber,R.column,M.lineNumber,M.column)}static lift(R){return R?new N(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<R.startColumn)}static areIntersecting(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<=M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,M){if(R&&M){const S=R.startLineNumber|0,A=M.startLineNumber|0;if(S===A){const C=R.startColumn|0,m=M.startColumn|0;if(C===m){const E=R.endLineNumber|0,v=M.endLineNumber|0;if(E===v){const u=R.endColumn|0,f=M.endColumn|0;return u-f}return E-v}return C-m}return S-A}return(R?1:0)-(M?1:0)}static compareRangesUsingEnds(R,M){return R.endLineNumber===M.endLineNumber?R.endColumn===M.endColumn?R.startLineNumber===M.startLineNumber?R.startColumn-M.startColumn:R.startLineNumber-M.startLineNumber:R.endColumn-M.endColumn:R.endLineNumber-M.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$kt=N}),define(ke[175],Ee([1,0,29]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0;class N{static insert(R,M){return{range:new l.$kt(R.lineNumber,R.column,R.lineNumber,R.column),text:M,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,M){return{range:R,text:M}}static replaceMove(R,M){return{range:R,text:M,forceMoveMarkers:!0}}}e.$lt=N}),define(ke[176],Ee([1,0,50,29]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.SelectionDirection=void 0;var L;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class R extends N.$kt{constructor(b,$,S,A){super(b,$,S,A),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=S,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,$):new R(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new l.$jt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.$jt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new R(b,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new R(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let S=0,A=b.length;S<A;S++)if(!this.selectionsEqual(b[S],$[S]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,S,A,C){return C===0?new R(b,$,S,A):new R(S,A,b,$)}}e.$mt=R}),define(ke[177],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[178],Ee([1,0,27,128]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.WordCharacterClass=void 0,e.$Bt=b;var L;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class R extends N.$yt{constructor(S,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let C=0,m=S.length;C<m;C++)this.set(S.charCodeAt(C),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(S,A){let C=null;for(const m of this.h(S)){if(m.index>A)break;C=m}return C}findNextIntlWordAtOrAfterOffset(S,A){for(const C of this.h(S))if(!(C.index<A))return C;return null}h(S){return this.e?this.f===S?this.g:(this.f=S,this.g=this.j(this.e.segment(S)),this.g):[]}j(S){const A=[];for(const C of S)this.k(C)&&A.push(C);return A}k(S){return!!S.isWordLike}}e.$At=R;const M=new l.$Ec(10);function b($,S){const A=`${$}/${S.join(",")}`;let C=M.get(A);return C||(C=new R($,S),M.set(A,C)),C}}),define(ke[129],Ee([1,0,39,3,75]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=void 0,e.$Xs=M,e.$Ys=$,e.$Zs=S,e.$Vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$Vs)C.indexOf(E)>=0||(m+="\\"+E);return m+="\\s]+)",new RegExp(m,"g")}e.$Ws=R();function M(C){let m=e.$Ws;if(C&&C instanceof RegExp)if(C.global)m=C;else{let E="g";C.ignoreCase&&(E+="i"),C.multiline&&(E+="m"),C.unicode&&(E+="u"),m=new RegExp(C.source,E)}return m.lastIndex=0,m}const b=new L.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,N.$Sc)(m)}function S(C,m,E,v,u){if(m=M(m),u||(u=l.Iterable.first(b)),E.length>u.maxLen){let s=C-u.maxLen/2;return s<0?s=0:v+=s,E=E.substring(s,C+u.maxLen/2),S(C,m,E,v,u)}const f=Date.now(),a=C-1-v;let n=-1,i=null;for(let s=1;!(Date.now()-f>=u.timeBudget);s++){const o=a-u.windowSize*s;m.lastIndex=Math.max(0,o);const t=A(m,E,a,n);if(!t&&i||(i=t,o<=0))break;n=o}if(i){const s={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return m.lastIndex=0,s}return null}function A(C,m,E,v){let u;for(;u=C.exec(m);){const f=u.index||0;if(f<=E&&C.lastIndex>=E)return u;if(v>0&&f>v)return null}return null}}),define(ke[179],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var l;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(l||(e.IndentAction=l={}));class N{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,S=b.notIn.length;$<S;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const S=b.findTokenIndexAtOffset($-2),A=b.getStandardTokenType(S);return this.isOK(A)}g(b,$){for(let S=b;S<=$;S++){const A=String.fromCharCode(S);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=N;class L{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)R(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),R(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),R(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),R(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&R(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$bu=L;function R(M,b,$){M.has(b)?M.get(b).push($):M.set(b,[$])}}),define(ke[180],Ee([1,0,128]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$42=e.$32=e.State=void 0,e.$52=m;var N;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class L{constructor(v,u,f){const a=new Uint8Array(v*u);for(let n=0,i=v*u;n<i;n++)a[n]=f;this.a=a,this.rows=v,this.cols=u}get(v,u){return this.a[v*this.cols+u]}set(v,u,f){this.a[v*this.cols+u]=f}}class R{constructor(v){let u=0,f=0;for(let n=0,i=v.length;n<i;n++){const[s,o,t]=v[n];o>u&&(u=o),s>f&&(f=s),t>f&&(f=t)}u++,f++;const a=new L(f,u,0);for(let n=0,i=v.length;n<i;n++){const[s,o,t]=v[n];a.set(s,o,t)}this.a=a,this.b=u}nextState(v,u){return u<0||u>=this.b?0:this.a.get(v,u)}}e.$32=R;let M=null;function b(){return M===null&&(M=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var $;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})($||($={}));let S=null;function A(){if(S===null){S=new l.$yt(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<E.length;u++)S.set(E.charCodeAt(u),1);const v=".,;:";for(let u=0;u<v.length;u++)S.set(v.charCodeAt(u),2)}return S}class C{static a(v,u,f,a,n){let i=n-1;do{const s=u.charCodeAt(i);if(v.get(s)!==2)break;i--}while(i>a);if(a>0){const s=u.charCodeAt(a-1),o=u.charCodeAt(i);(s===40&&o===41||s===91&&o===93||s===123&&o===125)&&i--}return{range:{startLineNumber:f,startColumn:a+1,endLineNumber:f,endColumn:i+2},url:u.substring(a,i+1)}}static computeLinks(v,u=b()){const f=A(),a=[];for(let n=1,i=v.getLineCount();n<=i;n++){const s=v.getLineContent(n),o=s.length;let t=0,g=0,h=0,c=1,r=!1,w=!1,d=!1,D=!1;for(;t<o;){let p=!1;const k=s.charCodeAt(t);if(c===13){let y;switch(k){case 40:r=!0,y=0;break;case 41:y=r?0:1;break;case 91:d=!0,w=!0,y=0;break;case 93:d=!1,y=w?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:h===k?y=1:h===39||h===34||h===96?y=0:y=1;break;case 42:y=h===42?1:0;break;case 124:y=h===124?1:0;break;case 32:y=d?0:1;break;default:y=f.get(k)}y===1&&(a.push(C.a(f,s,n,g,t)),p=!0)}else if(c===12){let y;k===91?(w=!0,y=0):y=f.get(k),y===1?p=!0:c=13}else c=u.nextState(c,k),c===0&&(p=!0);p&&(c=1,r=!1,w=!1,D=!1,g=t+1,h=k),t++}c===13&&a.push(C.a(f,s,n,g,o))}return a}}e.$42=C;function m(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:C.computeLinks(E)}}),define(ke[79],Ee([1,0,24]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$vv=e.$uv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$wv=v,e.$Av=s;var N;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var L;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var R;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var M;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var b;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var $;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var S;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(S||(e.DefaultEndOfLine=S={}));var A;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class C{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,l.$1n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$uv=C;class m{constructor(t,g){this._findMatchBrand=void 0,this.range=t,this.matches=g}}e.$vv=m;var E;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(E||(e.TrackedRangeStickiness=E={}));function v(o){return o&&typeof o.read=="function"}var u;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(u||(e.PositionAffinity=u={}));var f;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f||(e.ModelConstants=f={}));class a{constructor(t,g,h,c,r,w){this.identifier=t,this.range=g,this.text=h,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=r,this._isTracked=w}}e.$xv=a;class n{constructor(t,g,h){this.regex=t,this.wordSeparators=g,this.simpleSearch=h}}e.$yv=n;class i{constructor(t,g,h){this.reverseEdits=t,this.changes=g,this.trimAutoWhitespaceLineNumbers=h}}e.$zv=i;function s(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(ke[181],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=e.NodeColor=e.$qC=void 0,e.$sC=L,e.$tC=R,e.$uC=S,e.$vC=A,e.$wC=C,e.$xC=m,e.$yC=E,e.$zC=v;class l{constructor(f,a){this.piece=f,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rC)return L(this.right);let f=this;for(;f.parent!==e.$rC&&f.parent.left!==f;)f=f.parent;return f.parent===e.$rC?e.$rC:f.parent}prev(){if(this.left!==e.$rC)return R(this.left);let f=this;for(;f.parent!==e.$rC&&f.parent.right!==f;)f=f.parent;return f.parent===e.$rC?e.$rC:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qC=l;var N;(function(u){u[u.Black=0]="Black",u[u.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$rC=new l(null,0),e.$rC.parent=e.$rC,e.$rC.left=e.$rC,e.$rC.right=e.$rC,e.$rC.color=0;function L(u){for(;u.left!==e.$rC;)u=u.left;return u}function R(u){for(;u.right!==e.$rC;)u=u.right;return u}function M(u){return u===e.$rC?0:u.size_left+u.piece.length+M(u.right)}function b(u){return u===e.$rC?0:u.lf_left+u.piece.lineFeedCnt+b(u.right)}function $(){e.$rC.parent=e.$rC}function S(u,f){const a=f.right;a.size_left+=f.size_left+(f.piece?f.piece.length:0),a.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=a.left,a.left!==e.$rC&&(a.left.parent=f),a.parent=f.parent,f.parent===e.$rC?u.root=a:f.parent.left===f?f.parent.left=a:f.parent.right=a,a.left=f,f.parent=a}function A(u,f){const a=f.left;f.left=a.right,a.right!==e.$rC&&(a.right.parent=f),a.parent=f.parent,f.size_left-=a.size_left+(a.piece?a.piece.length:0),f.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),f.parent===e.$rC?u.root=a:f===f.parent.right?f.parent.right=a:f.parent.left=a,a.right=f,f.parent=a}function C(u,f){let a,n;if(f.left===e.$rC?(n=f,a=n.right):f.right===e.$rC?(n=f,a=n.left):(n=L(f.right),a=n.right),n===u.root){u.root=a,a.color=0,f.detach(),$(),u.root.parent=e.$rC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=a:n.parent.right=a,n===f?(a.parent=n.parent,v(u,a)):(n.parent===f?a.parent=n:a.parent=n.parent,v(u,a),n.left=f.left,n.right=f.right,n.parent=f.parent,n.color=f.color,f===u.root?u.root=n:f===f.parent.left?f.parent.left=n:f.parent.right=n,n.left!==e.$rC&&(n.left.parent=n),n.right!==e.$rC&&(n.right.parent=n),n.size_left=f.size_left,n.lf_left=f.lf_left,v(u,n)),f.detach(),a.parent.left===a){const o=M(a),t=b(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const g=o-a.parent.size_left,h=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,E(u,a.parent,g,h)}}if(v(u,a.parent),i){$();return}let s;for(;a!==u.root&&a.color===0;)a===a.parent.left?(s=a.parent.right,s.color===1&&(s.color=0,a.parent.color=1,S(u,a.parent),s=a.parent.right),s.left.color===0&&s.right.color===0?(s.color=1,a=a.parent):(s.right.color===0&&(s.left.color=0,s.color=1,A(u,s),s=a.parent.right),s.color=a.parent.color,a.parent.color=0,s.right.color=0,S(u,a.parent),a=u.root)):(s=a.parent.left,s.color===1&&(s.color=0,a.parent.color=1,A(u,a.parent),s=a.parent.left),s.left.color===0&&s.right.color===0?(s.color=1,a=a.parent):(s.left.color===0&&(s.right.color=0,s.color=1,S(u,s),s=a.parent.left),s.color=a.parent.color,a.parent.color=0,s.left.color=0,A(u,a.parent),a=u.root));a.color=0,$()}function m(u,f){for(v(u,f);f!==u.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const a=f.parent.parent.right;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,S(u,f)),f.parent.color=0,f.parent.parent.color=1,A(u,f.parent.parent))}else{const a=f.parent.parent.left;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,A(u,f)),f.parent.color=0,f.parent.parent.color=1,S(u,f.parent.parent))}u.root.color=0}function E(u,f,a,n){for(;f!==u.root&&f!==e.$rC;)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}function v(u,f){let a=0,n=0;if(f!==u.root){for(;f!==u.root&&f===f.parent.right;)f=f.parent;if(f!==u.root)for(f=f.parent,a=M(f.left)-f.size_left,n=b(f.left)-f.lf_left,f.size_left+=a,f.lf_left+=n;f!==u.root&&(a!==0||n!==0);)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}}}),define(ke[182],Ee([1,0,19,127]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.$Mv=void 0;class L{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,S){$=(0,N.$2e)($);const A=this.a,C=this.b,m=S.length;return m===0?!1:(this.a=new Uint32Array(A.length+m),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+m),this.a.set(S,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,S){return $=(0,N.$2e)($),S=(0,N.$2e)(S),this.a[$]===S?!1:(this.a[$]=S,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,S){$=(0,N.$2e)($),S=(0,N.$2e)(S);const A=this.a,C=this.b;if($>=A.length)return!1;const m=A.length-$;return S>=m&&(S=m),S===0?!1:(this.a=new Uint32Array(A.length-S),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+S),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$2e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let S=this.c[0]+1;S===0&&(this.b[0]=this.a[0],S++),$>=this.a.length&&($=this.a.length-1);for(let A=S;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let S=0,A=this.a.length-1,C=0,m=0,E=0;for(;S<=A;)if(C=S+(A-S)/2|0,m=this.b[C],E=m-this.a[C],$<E)A=C-1;else if($>=m)S=C+1;else break;return new M(C,$-E)}}e.$Mv=L;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const S=this.e[$],A=S>0?this.d[S-1]:0;return new M(S,$-A)}removeValues($,S){this.a.splice($,S),this.f($)}insertValues($,S){this.a=(0,l.$Wb)(this.a,$,S),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,S=this.a.length;$<S;$++){const A=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+A;for(let m=0;m<A;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,S){this.a[$]!==S&&(this.a[$]=S,this.f($))}}e.$Nv=R;class M{constructor($,S){this.index=$,this.remainder=S,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=S}}e.$Ov=M}),define(ke[183],Ee([1,0,14,50,182]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=void 0;class R{constructor(b,$,S,A){this.d=b,this.f=$,this.g=S,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const S of $)this.o(S.range),this.p(new N.$jt(S.range.startLineNumber,S.range.startColumn),S.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,S=new Uint32Array($);for(let A=0;A<$;A++)S[A]=this.f[A].length+b;this.j=new L.$Mv(S)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const S=(0,l.$gf)($);if(S.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+S[0]+this.f[b.lineNumber-1].substring(b.column-1));return}S[S.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+S[0]);const A=new Uint32Array(S.length-1);for(let C=1;C<S.length;C++)this.f.splice(b.lineNumber+C-1,0,S[C]),A[C-1]=S[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$Pv=R}),define(ke[100],Ee([1,0,14,178,50,29,79]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FC=e.$DC=e.$AC=void 0,e.$BC=S,e.$CC=A,e.$EC=u;const b=999;class ${constructor(n,i,s,o){this.searchString=n,this.isRegex=i,this.matchCase=s,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=S(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=l.$ef(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let s=!this.isRegex&&!n;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new M.$yv(i,this.wordSeparators?(0,N.$Bt)(this.wordSeparators,[]):null,s?this.searchString:null)}}e.$AC=$;function S(a){if(!a||a.length===0)return!1;for(let n=0,i=a.length;n<i;n++){const s=a.charCodeAt(n);if(s===10)return!0;if(s===92){if(n++,n>=i)break;const o=a.charCodeAt(n);if(o===110||o===114||o===87)return!0}}return!1}function A(a,n,i){if(!i)return new M.$vv(a,null);const s=[];for(let o=0,t=n.length;o<t;o++)s[o]=n[o];return new M.$vv(a,s)}class C{constructor(n){const i=[];let s=0;for(let o=0,t=n.length;o<t;o++)n.charCodeAt(o)===10&&(i[s++]=o);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let s=0,o=i.length-1;if(o===-1||n<=i[0])return 0;for(;s<o;){const t=s+((o-s)/2>>0);i[t]>=n?o=t-1:i[t+1]>=n?(s=t,o=t):s=t+1}return s+1}}class m{static findMatches(n,i,s,o,t){const g=i.parseSearchRequest();return g?g.regex.multiline?this.b(n,s,new f(g.wordSeparators,g.regex),o,t):this.c(n,s,g,o,t):[]}static a(n,i,s,o,t,g){let h,c=0;o?(c=o.findLineFeedCountBeforeOffset(t),h=i+t+c):h=i+t;let r;if(o){const p=o.findLineFeedCountBeforeOffset(t+g.length)-c;r=h+g.length+p}else r=h+g.length;const w=n.getPositionAt(h),d=n.getPositionAt(r);return new R.$kt(w.lineNumber,w.column,d.lineNumber,d.column)}static b(n,i,s,o,t){const g=n.getOffsetAt(i.getStartPosition()),h=n.getValueInRange(i,1),c=n.getEOL()===`\r
`?new C(h):null,r=[];let w=0,d;for(s.reset(0);d=s.next(h);)if(r[w++]=A(this.a(n,g,h,c,d.index,d[0]),d,o),w>=t)return r;return r}static c(n,i,s,o,t){const g=[];let h=0;if(i.startLineNumber===i.endLineNumber){const r=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return h=this.d(s,r,i.startLineNumber,i.startColumn-1,h,g,o,t),g}const c=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);h=this.d(s,c,i.startLineNumber,i.startColumn-1,h,g,o,t);for(let r=i.startLineNumber+1;r<i.endLineNumber&&h<t;r++)h=this.d(s,n.getLineContent(r),r,0,h,g,o,t);if(h<t){const r=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);h=this.d(s,r,i.endLineNumber,0,h,g,o,t)}return g}static d(n,i,s,o,t,g,h,c){const r=n.wordSeparators;if(!h&&n.simpleSearch){const D=n.simpleSearch,p=D.length,k=i.length;let y=-p;for(;(y=i.indexOf(D,y+p))!==-1;)if((!r||u(r,i,k,y,p))&&(g[t++]=new M.$vv(new R.$kt(s,y+1+o,s,y+1+p+o),null),t>=c))return t;return t}const w=new f(n.wordSeparators,n.regex);let d;w.reset(0);do if(d=w.next(i),d&&(g[t++]=A(new R.$kt(s,d.index+1+o,s,d.index+1+d[0].length+o),d,h),t>=c))return t;while(d);return t}static findNextMatch(n,i,s,o){const t=i.parseSearchRequest();if(!t)return null;const g=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,s,g,o):this.f(n,s,g,o)}static e(n,i,s,o){const t=new L.$jt(i.lineNumber,1),g=n.getOffsetAt(t),h=n.getLineCount(),c=n.getValueInRange(new R.$kt(t.lineNumber,t.column,h,n.getLineMaxColumn(h)),1),r=n.getEOL()===`\r
`?new C(c):null;s.reset(i.column-1);const w=s.next(c);return w?A(this.a(n,g,c,r,w.index,w[0]),w,o):i.lineNumber!==1||i.column!==1?this.e(n,new L.$jt(1,1),s,o):null}static f(n,i,s,o){const t=n.getLineCount(),g=i.lineNumber,h=n.getLineContent(g),c=this.g(s,h,g,i.column,o);if(c)return c;for(let r=1;r<=t;r++){const w=(g+r-1)%t,d=n.getLineContent(w+1),D=this.g(s,d,w+1,1,o);if(D)return D}return null}static g(n,i,s,o,t){n.reset(o-1);const g=n.next(i);return g?A(new R.$kt(s,g.index+1,s,g.index+1+g[0].length),g,t):null}static findPreviousMatch(n,i,s,o){const t=i.parseSearchRequest();if(!t)return null;const g=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,s,g,o):this.j(n,s,g,o)}static h(n,i,s,o){const t=this.b(n,new R.$kt(1,1,i.lineNumber,i.column),s,o,10*b);if(t.length>0)return t[t.length-1];const g=n.getLineCount();return i.lineNumber!==g||i.column!==n.getLineMaxColumn(g)?this.h(n,new L.$jt(g,n.getLineMaxColumn(g)),s,o):null}static j(n,i,s,o){const t=n.getLineCount(),g=i.lineNumber,h=n.getLineContent(g).substring(0,i.column-1),c=this.k(s,h,g,o);if(c)return c;for(let r=1;r<=t;r++){const w=(t+g-r-1)%t,d=n.getLineContent(w+1),D=this.k(s,d,w+1,o);if(D)return D}return null}static k(n,i,s,o){let t=null,g;for(n.reset(0);g=n.next(i);)t=A(new R.$kt(s,g.index+1,s,g.index+1+g[0].length),g,o);return t}}e.$DC=m;function E(a,n,i,s,o){if(s===0)return!0;const t=n.charCodeAt(s-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const g=n.charCodeAt(s);if(a.get(g)!==0)return!0}return!1}function v(a,n,i,s,o){if(s+o===i)return!0;const t=n.charCodeAt(s+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const g=n.charCodeAt(s+o-1);if(a.get(g)!==0)return!0}return!1}function u(a,n,i,s,o){return E(a,n,i,s,o)&&v(a,n,i,s,o)}class f{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let s;do{if(this.b+this.c===i||(s=this.a.exec(n),!s))return null;const o=s.index,t=s[0].length;if(o===this.b&&t===this.c){if(t===0){l.$Af(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||u(this._wordSeparators,n,i,o,t))return s}while(s);return null}}e.$FC=f}),define(ke[130],Ee([1,0,50,29,79,181,100]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=void 0,e.$GC=A,e.$HC=C;const b=65535;function $(a){let n;return a[a.length-1]<65536?n=new Uint16Array(a.length):n=new Uint32Array(a.length),n.set(a,0),n}class S{constructor(n,i,s,o,t){this.lineStarts=n,this.cr=i,this.lf=s,this.crlf=o,this.isBasicASCII=t}}function A(a,n=!0){const i=[0];let s=1;for(let o=0,t=a.length;o<t;o++){const g=a.charCodeAt(o);g===13?o+1<t&&a.charCodeAt(o+1)===10?(i[s++]=o+2,o++):i[s++]=o+1:g===10&&(i[s++]=o+1)}return n?$(i):i}function C(a,n){a.length=0,a[0]=0;let i=1,s=0,o=0,t=0,g=!0;for(let c=0,r=n.length;c<r;c++){const w=n.charCodeAt(c);w===13?c+1<r&&n.charCodeAt(c+1)===10?(t++,a[i++]=c+2,c++):(s++,a[i++]=c+1):w===10?(o++,a[i++]=c+1):g&&w!==9&&(w<32||w>126)&&(g=!1)}const h=new S($(a),s,o,t,g);return a.length=0,h}class m{constructor(n,i,s,o,t){this.bufferIndex=n,this.start=i,this.end=s,this.lineFeedCnt=o,this.length=t}}e.$IC=m;class E{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$JC=E;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$rC&&n.iterate(n.root,s=>(s!==R.$rC&&this.a.push(s.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class u{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const s=this.b[i];if(s.nodeStartOffset<=n&&s.nodeStartOffset+s.node.piece.length>=n)return s}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const s=this.b[i];if(s.nodeStartLineNumber&&s.nodeStartLineNumber<n&&s.nodeStartLineNumber+s.node.piece.lineFeedCnt>=n)return s}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const s=this.b;for(let o=0;o<s.length;o++){const t=s[o];if(t.node.parent===null||t.nodeStartOffset>=n){s[o]=null,i=!0;continue}}if(i){const o=[];for(const t of s)t!==null&&o.push(t);this.b=o}}}class f{constructor(n,i,s){this.create(n,i,s)}create(n,i,s){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=R.$rC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=s;let o=null;for(let t=0,g=n.length;t<g;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const h=new m(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),o=this.S(o,h)}this.h=new u(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,s=i-Math.floor(i/3),o=s*2;let t="",g=0;const h=[];if(this.iterate(this.root,c=>{const r=this.R(c),w=r.length;if(g<=s||g+w<o)return t+=r,g+=w,!0;const d=t.replace(/\r\n|\r|\n/g,n);return h.push(new E(d,A(d))),t=r,g=w,!0}),g>0){const c=t.replace(/\r\n|\r|\n/g,n);h.push(new E(c,A(c)))}this.create(h,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,o=>{if(o===R.$rC)return!0;const t=this.R(o),g=t.length,h=n.G(i),c=n.G(i+g),r=n.getValueInRange2(h,c);return i+=g,t===r})}getOffsetAt(n,i){let s=0,o=this.root;for(;o!==R.$rC;)if(o.left!==R.$rC&&o.lf_left+1>=n)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=n){s+=o.size_left;const t=this.B(o,n-o.lf_left-2);return s+=t+i-1}else n-=o.lf_left+o.piece.lineFeedCnt,s+=o.size_left+o.piece.length,o=o.right;return s}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,s=0;const o=n;for(;i!==R.$rC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(s+=i.lf_left+t.index,t.index===0){const g=this.getOffsetAt(s+1,1),h=o-g;return new l.$jt(s+1,h+1)}return new l.$jt(s+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,s+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$rC){const t=this.getOffsetAt(s+1,1),g=o-n-t;return new l.$jt(s+1,g+1)}else i=i.right;return new l.$jt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const s=this.H(n.startLineNumber,n.startColumn),o=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(s,o);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const h=n.node,c=this.a[h.piece.bufferIndex].buffer,r=this.u(h.piece.bufferIndex,h.piece.start);return c.substring(r+n.remainder,r+i.remainder)}let s=n.node;const o=this.a[s.piece.bufferIndex].buffer,t=this.u(s.piece.bufferIndex,s.piece.start);let g=o.substring(t+n.remainder,t+s.piece.length);for(s=s.next();s!==R.$rC;){const h=this.a[s.piece.bufferIndex].buffer,c=this.u(s.piece.bufferIndex,s.piece.start);if(s===i.node){g+=h.substring(c,c+i.remainder);break}else g+=h.substr(c,s.piece.length);s=s.next()}return g}getLinesContent(){const n=[];let i=0,s="",o=!1;return this.iterate(this.root,t=>{if(t===R.$rC)return!0;const g=t.piece;let h=g.length;if(h===0)return!0;const c=this.a[g.bufferIndex].buffer,r=this.a[g.bufferIndex].lineStarts,w=g.start.line,d=g.end.line;let D=r[w]+g.start.column;if(o&&(c.charCodeAt(D)===10&&(D++,h--),n[i++]=s,s="",o=!1,h===0))return!0;if(w===d)return!this.f&&c.charCodeAt(D+h-1)===13?(o=!0,s+=c.substr(D,h-1)):s+=c.substr(D,h),!0;s+=this.f?c.substring(D,Math.max(D,r[w+1]-this.e)):c.substring(D,r[w+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=s;for(let p=w+1;p<d;p++)s=this.f?c.substring(r[p],r[p+1]-this.e):c.substring(r[p],r[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=s;return!this.f&&c.charCodeAt(r[d]+g.end.column-1)===13?(o=!0,g.end.column===0?i--:s=c.substr(r[d],g.end.column-1)):s=c.substr(r[d],g.end.column),!0}),o&&(n[i++]=s,s=""),n[i++]=s,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const s=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start);return s.buffer.charCodeAt(o)}else{const i=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(o)}}getLineCharCode(n,i){const s=this.H(n,i+1);return this.l(s)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,s,o,t,g,h,c,r,w,d){const D=this.a[n.piece.bufferIndex],p=this.u(n.piece.bufferIndex,n.piece.start),k=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,g);let P;const I={line:0,column:0};let F,j;i._wordSeparators?(F=D.buffer.substring(k,y),j=z=>z+k,i.reset(0)):(F=D.buffer,j=z=>z,i.reset(k));do if(P=i.next(F),P){if(j(P.index)>=y)return w;this.s(n,j(P.index)-p,I);const z=this.t(n.piece.bufferIndex,t,I),O=I.line===t.line?I.column-t.column+o:I.column+1,T=O+P[0].length;if(d[w++]=(0,M.$CC)(new N.$kt(s+z,O,s+z,T),P,c),j(P.index)+P[0].length>=y||w>=r)return w}while(P);return w}findMatchesLineByLine(n,i,s,o){const t=[];let g=0;const h=new M.$FC(i.wordSeparators,i.regex);let c=this.H(n.startLineNumber,n.startColumn);if(c===null)return[];const r=this.H(n.endLineNumber,n.endColumn);if(r===null)return[];let w=this.s(c.node,c.remainder);const d=this.s(r.node,r.remainder);if(c.node===r.node)return this.findMatchesInNode(c.node,h,n.startLineNumber,n.startColumn,w,d,i,s,o,g,t),t;let D=n.startLineNumber,p=c.node;for(;p!==r.node;){const y=this.t(p.piece.bufferIndex,w,p.piece.end);if(y>=1){const I=this.a[p.piece.bufferIndex].lineStarts,F=this.u(p.piece.bufferIndex,p.piece.start),j=I[w.line+y],z=D===n.startLineNumber?n.startColumn:1;if(g=this.findMatchesInNode(p,h,D,z,w,this.s(p,j-F),i,s,o,g,t),g>=o)return t;D+=y}const P=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const I=this.getLineContent(D).substring(P,n.endColumn-1);return g=this.n(i,h,I,n.endLineNumber,P,g,t,s,o),t}if(g=this.n(i,h,this.getLineContent(D).substr(P),D,P,g,t,s,o),g>=o)return t;D++,c=this.H(D,1),p=c.node,w=this.s(c.node,c.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(D).substring(y,n.endColumn-1);return g=this.n(i,h,P,n.endLineNumber,y,g,t,s,o),t}const k=D===n.startLineNumber?n.startColumn:1;return g=this.findMatchesInNode(r.node,h,D,k,w,d,i,s,o,g,t),t}n(n,i,s,o,t,g,h,c,r){const w=n.wordSeparators;if(!c&&n.simpleSearch){const D=n.simpleSearch,p=D.length,k=s.length;let y=-p;for(;(y=s.indexOf(D,y+p))!==-1;)if((!w||(0,M.$EC)(w,s,k,y,p))&&(h[g++]=new L.$vv(new N.$kt(o,y+1+t,o,y+1+p+t),null),g>=r))return g;return g}let d;i.reset(0);do if(d=i.next(s),d&&(h[g++]=(0,M.$CC)(new N.$kt(o,d.index+1+t,o,d.index+1+d[0].length+t),d,c),g>=r))return g;while(d);return g}insert(n,i,s=!1){if(this.f=this.f&&s,this.j.lineNumber=0,this.j.value="",this.root!==R.$rC){const{node:o,remainder:t,nodeStartOffset:g}=this.G(n),h=o.piece,c=h.bufferIndex,r=this.s(o,t);if(o.piece.bufferIndex===0&&h.end.line===this.g.line&&h.end.column===this.g.column&&g+h.length===n&&i.length<b){this.F(o,i),this.y();return}if(g===n)this.o(i,o),this.h.validate(n);else if(g+o.piece.length>n){const w=[];let d=new m(h.bufferIndex,r,h.end,this.t(h.bufferIndex,r,h.end),this.u(c,h.end)-this.u(c,r));if(this.K()&&this.M(i)&&this.I(o,t)===10){const y={line:d.start.line+1,column:0};d=new m(d.bufferIndex,y,d.end,this.t(d.bufferIndex,y,d.end),d.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(o,t-1)===13){const y=this.s(o,t-1);this.C(o,y),i="\r"+i,o.piece.length===0&&w.push(o)}else this.C(o,r);else this.C(o,r);const D=this.w(i);d.length>0&&this.S(o,d);let p=o;for(let k=0;k<D.length;k++)p=this.S(p,D[k]);this.v(w)}else this.q(i,o)}else{const o=this.w(i);let t=this.T(null,o[0]);for(let g=1;g<o.length;g++)t=this.S(t,o[g])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$rC)return;const s=this.G(n),o=this.G(n+i),t=s.node,g=o.node;if(t===g){const D=this.s(t,s.remainder),p=this.s(t,o.remainder);if(s.nodeStartOffset===n){if(i===t.piece.length){const k=t.next();(0,R.$wC)(this,t),this.N(k),this.y();return}this.D(t,p),this.h.validate(n),this.N(t),this.y();return}if(s.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,p),this.y();return}const h=[],c=this.s(t,s.remainder);this.C(t,c),this.h.validate(n),t.piece.length===0&&h.push(t);const r=this.s(g,o.remainder);this.D(g,r),g.piece.length===0&&h.push(g);const w=t.next();for(let D=w;D!==R.$rC&&D!==g;D=D.next())h.push(D);const d=t.piece.length===0?t.prev():t;this.v(h),this.O(d),this.y()}o(n,i){const s=[];if(this.K()&&this.M(n)&&this.L(i)){const g=i.piece,h={line:g.start.line+1,column:0},c=new m(g.bufferIndex,h,g.end,this.t(g.bufferIndex,h,g.end),g.length-1);i.piece=c,n+=`
`,(0,R.$yC)(this,i,-1,-1),i.piece.length===0&&s.push(i)}const o=this.w(n);let t=this.T(i,o[o.length-1]);for(let g=o.length-2;g>=0;g--)t=this.T(t,o[g]);this.N(t),this.v(s)}q(n,i){this.Q(n,i)&&(n+=`
`);const s=this.w(n),o=this.S(i,s[0]);let t=o;for(let g=1;g<s.length;g++)t=this.S(t,s[g]);this.N(o)}s(n,i,s){const o=n.piece,t=n.piece.bufferIndex,g=this.a[t].lineStarts,c=g[o.start.line]+o.start.column+i;let r=o.start.line,w=o.end.line,d=0,D=0,p=0;for(;r<=w&&(d=r+(w-r)/2|0,p=g[d],d!==w);)if(D=g[d+1],c<p)w=d-1;else if(c>=D)r=d+1;else break;return s?(s.line=d,s.column=c-p,null):{line:d,column:c-p}}t(n,i,s){if(s.column===0)return s.line-i.line;const o=this.a[n].lineStarts;if(s.line===o.length-1)return s.line-i.line;const t=o[s.line+1],g=o[s.line]+s.column;if(t>g+1)return s.line-i.line;const h=g-1;return this.a[n].buffer.charCodeAt(h)===13?s.line-i.line+1:s.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$wC)(this,n[i])}w(n){if(n.length>b){const w=[];for(;n.length>b;){const D=n.charCodeAt(b-1);let p;D===13||D>=55296&&D<=56319?(p=n.substring(0,b-1),n=n.substring(b-1)):(p=n.substring(0,b),n=n.substring(b));const k=A(p);w.push(new m(this.a.length,{line:0,column:0},{line:k.length-1,column:p.length-k[k.length-1]},k.length-1,p.length)),this.a.push(new E(p,k))}const d=A(n);return w.push(new m(this.a.length,{line:0,column:0},{line:d.length-1,column:n.length-d[d.length-1]},d.length-1,n.length)),this.a.push(new E(n,d)),w}let i=this.a[0].buffer.length;const s=A(n,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let w=0;w<s.length;w++)s[w]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let w=0;w<s.length;w++)s[w]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,h=t-this.a[0].lineStarts[g],c={line:g,column:h},r=new m(0,o,c,this.t(0,o,c),t-i);return this.g=c,[r]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let s=this.root,o="";const t=this.h.get2(n);if(t){s=t.node;const g=this.B(s,n-t.nodeStartLineNumber-1),h=this.a[s.piece.bufferIndex].buffer,c=this.u(s.piece.bufferIndex,s.piece.start);if(t.nodeStartLineNumber+s.piece.lineFeedCnt===n)o=h.substring(c+g,c+s.piece.length);else{const r=this.B(s,n-t.nodeStartLineNumber);return h.substring(c+g,c+r-i)}}else{let g=0;const h=n;for(;s!==R.$rC;)if(s.left!==R.$rC&&s.lf_left>=n-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>n-1){const c=this.B(s,n-s.lf_left-2),r=this.B(s,n-s.lf_left-1),w=this.a[s.piece.bufferIndex].buffer,d=this.u(s.piece.bufferIndex,s.piece.start);return g+=s.size_left,this.h.set({node:s,nodeStartOffset:g,nodeStartLineNumber:h-(n-1-s.lf_left)}),w.substring(d+c,d+r-i)}else if(s.lf_left+s.piece.lineFeedCnt===n-1){const c=this.B(s,n-s.lf_left-2),r=this.a[s.piece.bufferIndex].buffer,w=this.u(s.piece.bufferIndex,s.piece.start);o=r.substring(w+c,w+s.piece.length);break}else n-=s.lf_left+s.piece.lineFeedCnt,g+=s.size_left+s.piece.length,s=s.right}for(s=s.next();s!==R.$rC;){const g=this.a[s.piece.bufferIndex].buffer;if(s.piece.lineFeedCnt>0){const h=this.B(s,0),c=this.u(s.piece.bufferIndex,s.piece.start);return o+=g.substring(c,c+h-i),o}else{const h=this.u(s.piece.bufferIndex,s.piece.start);o+=g.substr(h,s.piece.length)}s=s.next()}return o}y(){let n=this.root,i=1,s=0;for(;n!==R.$rC;)i+=n.lf_left+n.piece.lineFeedCnt,s+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=s,this.h.validate(this.c)}A(n,i){const s=n.piece,o=this.s(n,i),t=o.line-s.start.line;if(this.u(s.bufferIndex,s.end)-this.u(s.bufferIndex,s.start)===i){const g=this.t(n.piece.bufferIndex,s.start,o);if(g!==t)return{index:g,remainder:0}}return{index:t,remainder:o.column}}B(n,i){if(i<0)return 0;const s=n.piece,o=this.a[s.bufferIndex].lineStarts,t=s.start.line+i+1;return t>s.end.line?o[s.end.line]+s.end.column-o[s.start.line]-s.start.column:o[t]-o[s.start.line]-s.start.column}C(n,i){const s=n.piece,o=s.lineFeedCnt,t=this.u(s.bufferIndex,s.end),g=i,h=this.u(s.bufferIndex,g),c=this.t(s.bufferIndex,s.start,g),r=c-o,w=h-t,d=s.length+w;n.piece=new m(s.bufferIndex,s.start,g,c,d),(0,R.$yC)(this,n,w,r)}D(n,i){const s=n.piece,o=s.lineFeedCnt,t=this.u(s.bufferIndex,s.start),g=i,h=this.t(s.bufferIndex,g,s.end),c=this.u(s.bufferIndex,g),r=h-o,w=t-c,d=s.length+w;n.piece=new m(s.bufferIndex,g,s.end,h,d),(0,R.$yC)(this,n,w,r)}E(n,i,s){const o=n.piece,t=o.start,g=o.end,h=o.length,c=o.lineFeedCnt,r=i,w=this.t(o.bufferIndex,o.start,r),d=this.u(o.bufferIndex,i)-this.u(o.bufferIndex,t);n.piece=new m(o.bufferIndex,o.start,r,w,d),(0,R.$yC)(this,n,d-h,w-c);const D=new m(o.bufferIndex,s,g,this.t(o.bufferIndex,s,g),this.u(o.bufferIndex,g)-this.u(o.bufferIndex,s)),p=this.S(n,D);this.N(p)}F(n,i){this.Q(i,n)&&(i+=`
`);const s=this.K()&&this.L(i)&&this.M(n),o=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let p=0;p<t.length;p++)t[p]+=o;if(s){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const g=this.a[0].lineStarts.length-1,h=this.a[0].buffer.length-this.a[0].lineStarts[g],c={line:g,column:h},r=n.piece.length+i.length,w=n.piece.lineFeedCnt,d=this.t(0,n.piece.start,c),D=d-w;n.piece=new m(n.piece.bufferIndex,n.piece.start,c,d,r),this.g=c,(0,R.$yC)(this,n,i.length,D)}G(n){let i=this.root;const s=this.h.get(n);if(s)return{node:s.node,nodeStartOffset:s.nodeStartOffset,remainder:n-s.nodeStartOffset};let o=0;for(;i!==R.$rC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){o+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:o};return this.h.set(t),t}else n-=i.size_left+i.piece.length,o+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let s=this.root,o=0;for(;s!==R.$rC;)if(s.left!==R.$rC&&s.lf_left>=n-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>n-1){const t=this.B(s,n-s.lf_left-2),g=this.B(s,n-s.lf_left-1);return o+=s.size_left,{node:s,remainder:Math.min(t+i-1,g),nodeStartOffset:o}}else if(s.lf_left+s.piece.lineFeedCnt===n-1){const t=this.B(s,n-s.lf_left-2);if(t+i-1<=s.piece.length)return{node:s,remainder:t+i-1,nodeStartOffset:o};i-=s.piece.length-t;break}else n-=s.lf_left+s.piece.lineFeedCnt,o+=s.size_left+s.piece.length,s=s.right;for(s=s.next();s!==R.$rC;){if(s.piece.lineFeedCnt>0){const t=this.B(s,0),g=this.J(s);return{node:s,remainder:Math.min(i-1,t),nodeStartOffset:g}}else if(s.piece.length>=i-1){const t=this.J(s);return{node:s,remainder:i-1,nodeStartOffset:t}}else i-=s.piece.length;s=s.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const s=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start)+i;return s.buffer.charCodeAt(o)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$rC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,s=this.a[i.bufferIndex].lineStarts,o=i.start.line,t=s[o]+i.start.column;return o===s.length-1||s[o+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$rC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const s=[],o=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:o[n.piece.end.line]-o[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const g=n.piece.length-1,h=n.piece.lineFeedCnt-1;n.piece=new m(n.piece.bufferIndex,n.piece.start,t,h,g),(0,R.$yC)(this,n,-1,-1),n.piece.length===0&&s.push(n);const c={line:i.piece.start.line+1,column:0},r=i.piece.length-1,w=this.t(i.piece.bufferIndex,c,i.piece.end);i.piece=new m(i.piece.bufferIndex,c,i.piece.end,w,r),(0,R.$yC)(this,i,-1,-1),i.piece.length===0&&s.push(i);const d=this.w(`\r
`);this.S(n,d[0]);for(let D=0;D<s.length;D++)(0,R.$wC)(this,s[D])}Q(n,i){if(this.K()&&this.M(n)){const s=i.next();if(this.L(s)){if(n+=`
`,s.piece.length===1)(0,R.$wC)(this,s);else{const o=s.piece,t={line:o.start.line+1,column:0},g=o.length-1,h=this.t(o.bufferIndex,t,o.end);s.piece=new m(o.bufferIndex,t,o.end,h,g),(0,R.$yC)(this,s,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$rC)return i(R.$rC);const s=this.iterate(n.left,i);return s&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$rC)return"";const i=this.a[n.piece.bufferIndex],s=n.piece,o=this.u(s.bufferIndex,s.start),t=this.u(s.bufferIndex,s.end);return i.buffer.substring(o,t)}getPieceContent(n){const i=this.a[n.bufferIndex],s=this.u(n.bufferIndex,n.start),o=this.u(n.bufferIndex,n.end);return i.buffer.substring(s,o)}S(n,i){const s=new R.$qC(i,1);if(s.left=R.$rC,s.right=R.$rC,s.parent=R.$rC,s.size_left=0,s.lf_left=0,this.root===R.$rC)this.root=s,s.color=0;else if(n.right===R.$rC)n.right=s,s.parent=n;else{const t=(0,R.$sC)(n.right);t.left=s,s.parent=t}return(0,R.$xC)(this,s),s}T(n,i){const s=new R.$qC(i,1);if(s.left=R.$rC,s.right=R.$rC,s.parent=R.$rC,s.size_left=0,s.lf_left=0,this.root===R.$rC)this.root=s,s.color=0;else if(n.left===R.$rC)n.left=s,s.parent=n;else{const o=(0,R.$tC)(n.left);o.right=s,s.parent=o}return(0,R.$xC)(this,s),s}U(n){let i="";return this.iterate(n,s=>(i+=this.R(s),!0)),i}}e.$KC=f}),define(ke[184],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c9=e.$b9=void 0;class l{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const M=this.a.get(R);return this.a.delete(R),M}}addDragOperationTransfer(R,M){this.a.set(R,M)}}e.$b9=l;class N{constructor(R){this.identifier=R}}e.$c9=N}),define(ke[185],Ee([1,0,4,3]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new l.$be,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,N.$Sc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const S=new R(this,b,$);return this.b.set(b,S),(0,N.$Sc)(()=>{const A=this.b.get(b);!A||A!==S||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const S=this.b.get(b);return!S||S.isResolved?null:(await S.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const S=this.b.get(b);return!!(!S||S.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Mt=L;class R extends N.$Uc{get isResolved(){return this.c}constructor(b,$,S){super(),this.f=b,this.g=$,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[186],Ee([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[187],Ee([1,0,4,3,186]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0,e.$aj=A;class R extends N.$Uc{constructor(m,E="",v="",u=!0,f){super(),this.h=this.B(new l.$be),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=E,this.u=v,this.w=u,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,E){this.C&&await this.C(m)}}e.$8i=R;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new l.$be),this.onWillRun=this.f.event,this.m=this.B(new l.$be),this.onDidRun=this.m.event}async run(m,E){if(!m.enabled)return;this.f.fire({action:m});let v;try{await this.u(m,E)}catch(u){v=u}this.m.fire({action:m,error:v})}async u(m,E){await m.run(E)}}e.$9i=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let E=[];for(const v of m)v.length&&(E.length?E=[...E,new b,...v]:E=v);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$0i=b;class ${get actions(){return this.a}constructor(m,E,v,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=E,this.class=u,this.a=v}async run(){}}e.$$i=$;class S extends R{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,L.localize(0,null),void 0,!1)}}e.$_i=S;function A(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...m)=>C.run(...m),tooltip:C.label}}}),define(ke[188],Ee([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[189],Ee([1,0,188]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=S,e.$Wm=A,e.$Xm=C;const N=60,L=N*60,R=L*24,M=R*7,b=R*30,$=R*365;function S(m,E,v,u){typeof m!="number"&&(m=m.getTime());const f=Math.round((new Date().getTime()-m)/1e3);if(f<-30)return(0,l.localize)(0,null,S(new Date().getTime()+f*1e3,!1));if(!u&&f<30)return(0,l.localize)(1,null);let a;return f<N?(a=f,E?a===1?v?(0,l.localize)(2,null,a):(0,l.localize)(3,null,a):v?(0,l.localize)(4,null,a):(0,l.localize)(5,null,a):a===1?v?(0,l.localize)(6,null,a):(0,l.localize)(7,null,a):v?(0,l.localize)(8,null,a):(0,l.localize)(9,null,a)):f<L?(a=Math.floor(f/N),E?a===1?v?(0,l.localize)(10,null,a):(0,l.localize)(11,null,a):v?(0,l.localize)(12,null,a):(0,l.localize)(13,null,a):a===1?v?(0,l.localize)(14,null,a):(0,l.localize)(15,null,a):v?(0,l.localize)(16,null,a):(0,l.localize)(17,null,a)):f<R?(a=Math.floor(f/L),E?a===1?v?(0,l.localize)(18,null,a):(0,l.localize)(19,null,a):v?(0,l.localize)(20,null,a):(0,l.localize)(21,null,a):a===1?v?(0,l.localize)(22,null,a):(0,l.localize)(23,null,a):v?(0,l.localize)(24,null,a):(0,l.localize)(25,null,a)):f<M?(a=Math.floor(f/R),E?a===1?(0,l.localize)(26,null,a):(0,l.localize)(27,null,a):a===1?(0,l.localize)(28,null,a):(0,l.localize)(29,null,a)):f<b?(a=Math.floor(f/M),E?a===1?v?(0,l.localize)(30,null,a):(0,l.localize)(31,null,a):v?(0,l.localize)(32,null,a):(0,l.localize)(33,null,a):a===1?v?(0,l.localize)(34,null,a):(0,l.localize)(35,null,a):v?(0,l.localize)(36,null,a):(0,l.localize)(37,null,a)):f<$?(a=Math.floor(f/b),E?a===1?v?(0,l.localize)(38,null,a):(0,l.localize)(39,null,a):v?(0,l.localize)(40,null,a):(0,l.localize)(41,null,a):a===1?v?(0,l.localize)(42,null,a):(0,l.localize)(43,null,a):v?(0,l.localize)(44,null,a):(0,l.localize)(45,null,a)):(a=Math.floor(f/$),E?a===1?v?(0,l.localize)(46,null,a):(0,l.localize)(47,null,a):v?(0,l.localize)(48,null,a):(0,l.localize)(49,null,a):a===1?v?(0,l.localize)(50,null,a):(0,l.localize)(51,null,a):v?(0,l.localize)(52,null,a):(0,l.localize)(53,null,a))}function A(m,E){const v=Math.abs(m/1e3);return v<1?E?(0,l.localize)(54,null,m):(0,l.localize)(55,null,m):v<N?E?(0,l.localize)(56,null,Math.round(m)/1e3):(0,l.localize)(57,null,Math.round(m)/1e3):v<L?E?(0,l.localize)(58,null,Math.round(m/(1e3*N))):(0,l.localize)(59,null,Math.round(m/(1e3*N))):v<R?E?(0,l.localize)(60,null,Math.round(m/(1e3*L))):(0,l.localize)(61,null,Math.round(m/(1e3*L))):(0,l.localize)(62,null,Math.round(m/(1e3*R)))}function C(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[190],Ee([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[47],Ee([1,0,19,18,190]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=$,e.$cj=S,e.$dj=A;function R(C,m){return m&&(C.stack||C.stacktrace)?L.localize(0,null,b(C),M(C.stack)||M(C.stacktrace)):b(C)}function M(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function $(C=null,m=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const E=l.$Hb(C),v=$(E[0],m);return E.length>1?L.localize(4,null,v,E.length):v}if(N.$4f(C))return C;if(C.detail){const E=C.detail;if(E.error)return R(E.error,m);if(E.exception)return R(E.exception,m)}return C.stack?R(C,m):C.message?C.message:L.localize(5,null)}function S(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}function A(C,m){let E;return typeof C=="string"?E=new Error(C):E=C,E.actions=m,E}}),define(ke[191],Ee([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(ke[11],Ee([1,0,191]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=g,e.$D=D,e.$J=p,e.$g="en";let N=!1,L=!1,R=!1,M=!1,b=!1,$=!1,S=!1,A=!1,C=!1,m=!1,E,v=e.$g,u=e.$g,f,a;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const s=typeof i?.versions?.electron=="string",o=s&&i?.type==="renderer";if(typeof i=="object"){N=i.platform==="win32",L=i.platform==="darwin",R=i.platform==="linux",M=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,S=s,C=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,v=e.$g;const k=i.env.VSCODE_NLS_CONFIG;if(k)try{const y=JSON.parse(k),P=y.availableLanguages["*"];E=y.locale,u=y.osLocale,v=P||e.$g,f=y._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,N=a.indexOf("Windows")>=0,L=a.indexOf("Macintosh")>=0,A=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,m=a?.indexOf("Mobi")>=0,$=!0,E=l.getConfiguredDefaultLocale(l.localize(0,null))||e.$g,v=E,u=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function g(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let h=0;L?h=1:N?h=3:R&&(h=2),e.$i=N,e.$j=L,e.$k=R,e.$l=M,e.$m=b,e.$n=S,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=m,e.$t=C,e.$u=h,e.$v=a,e.$w=v;var c;(function(k){function y(){return e.$w}k.value=y;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=P;function I(){return e.$w==="en"}k.isDefault=I})(c||(e.Language=c={})),e.$x=E,e.$y=u,e.$z=f,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const k=[];n.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,F=k.length;I<F;I++){const j=k[I];if(j.id===P.data.vscodeScheduleAsyncWork){k.splice(I,1),j.callback();return}}});let y=0;return P=>{const I=++y;k.push({id:I,callback:P}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return k=>setTimeout(k)})();var r;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=L||A?2:N?1:3;let w=!0,d=!1;function D(){if(!d){d=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,w=new Uint16Array(k.buffer)[0]===513}return w}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function p(k){return parseFloat(k)>=20}}),define(ke[51],Ee([1,0,11]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const R=L.process;N={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return l.$i?"win32":l.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ke[17],Ee([1,0,51]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,L=97,R=90,M=122,b=46,$=47,S=92,A=58,C=63;class m extends Error{constructor(g,h,c){let r;typeof h=="string"&&h.indexOf("not ")===0?(r="must not be",h=h.replace(/^not /,"")):r="must be";const w=g.indexOf(".")!==-1?"property":"argument";let d=`The "${g}" ${w} ${r} of type ${h}`;d+=`. Received type ${typeof c}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,g){if(t===null||typeof t!="object")throw new m(g,"Object",t)}function v(t,g){if(typeof t!="string")throw new m(g,"string",t)}const u=l.$ec==="win32";function f(t){return t===$||t===S}function a(t){return t===$}function n(t){return t>=N&&t<=R||t>=L&&t<=M}function i(t,g,h,c){let r="",w=0,d=-1,D=0,p=0;for(let k=0;k<=t.length;++k){if(k<t.length)p=t.charCodeAt(k);else{if(c(p))break;p=$}if(c(p)){if(!(d===k-1||D===1))if(D===2){if(r.length<2||w!==2||r.charCodeAt(r.length-1)!==b||r.charCodeAt(r.length-2)!==b){if(r.length>2){const y=r.lastIndexOf(h);y===-1?(r="",w=0):(r=r.slice(0,y),w=r.length-1-r.lastIndexOf(h)),d=k,D=0;continue}else if(r.length!==0){r="",w=0,d=k,D=0;continue}}g&&(r+=r.length>0?`${h}..`:"..",w=2)}else r.length>0?r+=`${h}${t.slice(d+1,k)}`:r=t.slice(d+1,k),w=k-d-1;d=k,D=0}else p===b&&D!==-1?++D:D=-1}return r}function s(t,g){E(g,"pathObject");const h=g.dir||g.root,c=g.base||`${g.name||""}${g.ext||""}`;return h?h===g.root?`${h}${c}`:`${h}${t}${c}`:c}e.$gc={resolve(...t){let g="",h="",c=!1;for(let r=t.length-1;r>=-1;r--){let w;if(r>=0){if(w=t[r],v(w,"path"),w.length===0)continue}else g.length===0?w=l.cwd():(w=l.env[`=${g}`]||l.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==g.toLowerCase()&&w.charCodeAt(2)===S)&&(w=`${g}\\`));const d=w.length;let D=0,p="",k=!1;const y=w.charCodeAt(0);if(d===1)f(y)&&(D=1,k=!0);else if(f(y))if(k=!0,f(w.charCodeAt(1))){let P=2,I=P;for(;P<d&&!f(w.charCodeAt(P));)P++;if(P<d&&P!==I){const F=w.slice(I,P);for(I=P;P<d&&f(w.charCodeAt(P));)P++;if(P<d&&P!==I){for(I=P;P<d&&!f(w.charCodeAt(P));)P++;(P===d||P!==I)&&(p=`\\\\${F}\\${w.slice(I,P)}`,D=P)}}}else D=1;else n(y)&&w.charCodeAt(1)===A&&(p=w.slice(0,2),D=2,d>2&&f(w.charCodeAt(2))&&(k=!0,D=3));if(p.length>0)if(g.length>0){if(p.toLowerCase()!==g.toLowerCase())continue}else g=p;if(c){if(g.length>0)break}else if(h=`${w.slice(D)}\\${h}`,c=k,k&&g.length>0)break}return h=i(h,!c,"\\",f),c?`${g}\\${h}`:`${g}${h}`||"."},normalize(t){v(t,"path");const g=t.length;if(g===0)return".";let h=0,c,r=!1;const w=t.charCodeAt(0);if(g===1)return a(w)?"\\":t;if(f(w))if(r=!0,f(t.charCodeAt(1))){let D=2,p=D;for(;D<g&&!f(t.charCodeAt(D));)D++;if(D<g&&D!==p){const k=t.slice(p,D);for(p=D;D<g&&f(t.charCodeAt(D));)D++;if(D<g&&D!==p){for(p=D;D<g&&!f(t.charCodeAt(D));)D++;if(D===g)return`\\\\${k}\\${t.slice(p)}\\`;D!==p&&(c=`\\\\${k}\\${t.slice(p,D)}`,h=D)}}}else h=1;else n(w)&&t.charCodeAt(1)===A&&(c=t.slice(0,2),h=2,g>2&&f(t.charCodeAt(2))&&(r=!0,h=3));let d=h<g?i(t.slice(h),!r,"\\",f):"";return d.length===0&&!r&&(d="."),d.length>0&&f(t.charCodeAt(g-1))&&(d+="\\"),c===void 0?r?`\\${d}`:d:r?`${c}\\${d}`:`${c}${d}`},isAbsolute(t){v(t,"path");const g=t.length;if(g===0)return!1;const h=t.charCodeAt(0);return f(h)||g>2&&n(h)&&t.charCodeAt(1)===A&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let g,h;for(let w=0;w<t.length;++w){const d=t[w];v(d,"path"),d.length>0&&(g===void 0?g=h=d:g+=`\\${d}`)}if(g===void 0)return".";let c=!0,r=0;if(typeof h=="string"&&f(h.charCodeAt(0))){++r;const w=h.length;w>1&&f(h.charCodeAt(1))&&(++r,w>2&&(f(h.charCodeAt(2))?++r:c=!1))}if(c){for(;r<g.length&&f(g.charCodeAt(r));)r++;r>=2&&(g=`\\${g.slice(r)}`)}return e.$gc.normalize(g)},relative(t,g){if(v(t,"from"),v(g,"to"),t===g)return"";const h=e.$gc.resolve(t),c=e.$gc.resolve(g);if(h===c||(t=h.toLowerCase(),g=c.toLowerCase(),t===g))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===S;)r++;let w=t.length;for(;w-1>r&&t.charCodeAt(w-1)===S;)w--;const d=w-r;let D=0;for(;D<g.length&&g.charCodeAt(D)===S;)D++;let p=g.length;for(;p-1>D&&g.charCodeAt(p-1)===S;)p--;const k=p-D,y=d<k?d:k;let P=-1,I=0;for(;I<y;I++){const j=t.charCodeAt(r+I);if(j!==g.charCodeAt(D+I))break;j===S&&(P=I)}if(I!==y){if(P===-1)return c}else{if(k>y){if(g.charCodeAt(D+I)===S)return c.slice(D+I+1);if(I===2)return c.slice(D+I)}d>y&&(t.charCodeAt(r+I)===S?P=I:I===2&&(P=3)),P===-1&&(P=0)}let F="";for(I=r+P+1;I<=w;++I)(I===w||t.charCodeAt(I)===S)&&(F+=F.length===0?"..":"\\..");return D+=P,F.length>0?`${F}${c.slice(D,p)}`:(c.charCodeAt(D)===S&&++D,c.slice(D,p))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const g=e.$gc.resolve(t);if(g.length<=2)return t;if(g.charCodeAt(0)===S){if(g.charCodeAt(1)===S){const h=g.charCodeAt(2);if(h!==C&&h!==b)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(n(g.charCodeAt(0))&&g.charCodeAt(1)===A&&g.charCodeAt(2)===S)return`\\\\?\\${g}`;return t},dirname(t){v(t,"path");const g=t.length;if(g===0)return".";let h=-1,c=0;const r=t.charCodeAt(0);if(g===1)return f(r)?t:".";if(f(r)){if(h=c=1,f(t.charCodeAt(1))){let D=2,p=D;for(;D<g&&!f(t.charCodeAt(D));)D++;if(D<g&&D!==p){for(p=D;D<g&&f(t.charCodeAt(D));)D++;if(D<g&&D!==p){for(p=D;D<g&&!f(t.charCodeAt(D));)D++;if(D===g)return t;D!==p&&(h=c=D+1)}}}}else n(r)&&t.charCodeAt(1)===A&&(h=g>2&&f(t.charCodeAt(2))?3:2,c=h);let w=-1,d=!0;for(let D=g-1;D>=c;--D)if(f(t.charCodeAt(D))){if(!d){w=D;break}}else d=!1;if(w===-1){if(h===-1)return".";w=h}return t.slice(0,w)},basename(t,g){g!==void 0&&v(g,"ext"),v(t,"path");let h=0,c=-1,r=!0,w;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(h=2),g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let d=g.length-1,D=-1;for(w=t.length-1;w>=h;--w){const p=t.charCodeAt(w);if(f(p)){if(!r){h=w+1;break}}else D===-1&&(r=!1,D=w+1),d>=0&&(p===g.charCodeAt(d)?--d===-1&&(c=w):(d=-1,c=D))}return h===c?c=D:c===-1&&(c=t.length),t.slice(h,c)}for(w=t.length-1;w>=h;--w)if(f(t.charCodeAt(w))){if(!r){h=w+1;break}}else c===-1&&(r=!1,c=w+1);return c===-1?"":t.slice(h,c)},extname(t){v(t,"path");let g=0,h=-1,c=0,r=-1,w=!0,d=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(g=c=2);for(let D=t.length-1;D>=g;--D){const p=t.charCodeAt(D);if(f(p)){if(!w){c=D+1;break}continue}r===-1&&(w=!1,r=D+1),p===b?h===-1?h=D:d!==1&&(d=1):h!==-1&&(d=-1)}return h===-1||r===-1||d===0||d===1&&h===r-1&&h===c+1?"":t.slice(h,r)},format:s.bind(null,"\\"),parse(t){v(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const h=t.length;let c=0,r=t.charCodeAt(0);if(h===1)return f(r)?(g.root=g.dir=t,g):(g.base=g.name=t,g);if(f(r)){if(c=1,f(t.charCodeAt(1))){let P=2,I=P;for(;P<h&&!f(t.charCodeAt(P));)P++;if(P<h&&P!==I){for(I=P;P<h&&f(t.charCodeAt(P));)P++;if(P<h&&P!==I){for(I=P;P<h&&!f(t.charCodeAt(P));)P++;P===h?c=P:P!==I&&(c=P+1)}}}}else if(n(r)&&t.charCodeAt(1)===A){if(h<=2)return g.root=g.dir=t,g;if(c=2,f(t.charCodeAt(2))){if(h===3)return g.root=g.dir=t,g;c=3}}c>0&&(g.root=t.slice(0,c));let w=-1,d=c,D=-1,p=!0,k=t.length-1,y=0;for(;k>=c;--k){if(r=t.charCodeAt(k),f(r)){if(!p){d=k+1;break}continue}D===-1&&(p=!1,D=k+1),r===b?w===-1?w=k:y!==1&&(y=1):w!==-1&&(y=-1)}return D!==-1&&(w===-1||y===0||y===1&&w===D-1&&w===d+1?g.base=g.name=t.slice(d,D):(g.name=t.slice(d,w),g.base=t.slice(d,D),g.ext=t.slice(w,D))),d>0&&d!==c?g.dir=t.slice(0,d-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(u){const t=/\\/g;return()=>{const g=l.cwd().replace(t,"/");return g.slice(g.indexOf("/"))}}return()=>l.cwd()})();e.$hc={resolve(...t){let g="",h=!1;for(let c=t.length-1;c>=-1&&!h;c--){const r=c>=0?t[c]:o();v(r,"path"),r.length!==0&&(g=`${r}/${g}`,h=r.charCodeAt(0)===$)}return g=i(g,!h,"/",a),h?`/${g}`:g.length>0?g:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===$,h=t.charCodeAt(t.length-1)===$;return t=i(t,!g,"/",a),t.length===0?g?"/":h?"./":".":(h&&(t+="/"),g?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let g;for(let h=0;h<t.length;++h){const c=t[h];v(c,"path"),c.length>0&&(g===void 0?g=c:g+=`/${c}`)}return g===void 0?".":e.$hc.normalize(g)},relative(t,g){if(v(t,"from"),v(g,"to"),t===g||(t=e.$hc.resolve(t),g=e.$hc.resolve(g),t===g))return"";const h=1,c=t.length,r=c-h,w=1,d=g.length-w,D=r<d?r:d;let p=-1,k=0;for(;k<D;k++){const P=t.charCodeAt(h+k);if(P!==g.charCodeAt(w+k))break;P===$&&(p=k)}if(k===D)if(d>D){if(g.charCodeAt(w+k)===$)return g.slice(w+k+1);if(k===0)return g.slice(w+k)}else r>D&&(t.charCodeAt(h+k)===$?p=k:k===0&&(p=0));let y="";for(k=h+p+1;k<=c;++k)(k===c||t.charCodeAt(k)===$)&&(y+=y.length===0?"..":"/..");return`${y}${g.slice(w+p)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===$;let h=-1,c=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===$){if(!c){h=r;break}}else c=!1;return h===-1?g?"/":".":g&&h===1?"//":t.slice(0,h)},basename(t,g){g!==void 0&&v(g,"ext"),v(t,"path");let h=0,c=-1,r=!0,w;if(g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let d=g.length-1,D=-1;for(w=t.length-1;w>=0;--w){const p=t.charCodeAt(w);if(p===$){if(!r){h=w+1;break}}else D===-1&&(r=!1,D=w+1),d>=0&&(p===g.charCodeAt(d)?--d===-1&&(c=w):(d=-1,c=D))}return h===c?c=D:c===-1&&(c=t.length),t.slice(h,c)}for(w=t.length-1;w>=0;--w)if(t.charCodeAt(w)===$){if(!r){h=w+1;break}}else c===-1&&(r=!1,c=w+1);return c===-1?"":t.slice(h,c)},extname(t){v(t,"path");let g=-1,h=0,c=-1,r=!0,w=0;for(let d=t.length-1;d>=0;--d){const D=t.charCodeAt(d);if(D===$){if(!r){h=d+1;break}continue}c===-1&&(r=!1,c=d+1),D===b?g===-1?g=d:w!==1&&(w=1):g!==-1&&(w=-1)}return g===-1||c===-1||w===0||w===1&&g===c-1&&g===h+1?"":t.slice(g,c)},format:s.bind(null,"/"),parse(t){v(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const h=t.charCodeAt(0)===$;let c;h?(g.root="/",c=1):c=0;let r=-1,w=0,d=-1,D=!0,p=t.length-1,k=0;for(;p>=c;--p){const y=t.charCodeAt(p);if(y===$){if(!D){w=p+1;break}continue}d===-1&&(D=!1,d=p+1),y===b?r===-1?r=p:k!==1&&(k=1):r!==-1&&(k=-1)}if(d!==-1){const y=w===0&&h?1:w;r===-1||k===0||k===1&&r===d-1&&r===w+1?g.base=g.name=t.slice(y,d):(g.name=t.slice(y,r),g.base=t.slice(y,d),g.ext=t.slice(r,d))}return w>0?g.dir=t.slice(0,w-1):h&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=u?e.$gc.normalize:e.$hc.normalize,e.$jc=u?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=u?e.$gc.join:e.$hc.join,e.$lc=u?e.$gc.resolve:e.$hc.resolve,e.$mc=u?e.$gc.relative:e.$hc.relative,e.$nc=u?e.$gc.dirname:e.$hc.dirname,e.$oc=u?e.$gc.basename:e.$hc.basename,e.$pc=u?e.$gc.extname:e.$hc.extname,e.$qc=u?e.$gc.format:e.$hc.format,e.$rc=u?e.$gc.parse:e.$hc.parse,e.$sc=u?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=u?e.$gc.sep:e.$hc.sep,e.$uc=u?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Ee([1,0,46,17]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=b,e.$_q=$,e.$ar=S,e.$br=A,e.$cr=C,e.$dr=m,e.$er=E,e.$fr=v,e.$gr=u,e.$hr=f,e.$ir=r,e.$jr=w,e.$kr=d;const L=new l.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,p,k=!1){const y=D||"",P=p||"",I=L.value.collator.compare(y,P);return L.value.collatorIsNumeric&&I===0&&y!==P?y<P?-1:1:I}function $(D,p){const k=R.value.collator;return D=D||"",p=p||"",s(k,D,p)}function S(D,p){const k=R.value.collator;return D=D||"",p=p||"",h(D,p)||s(k,D,p)}function A(D,p){const k=R.value.collator;return D=D||"",p=p||"",g(D,p)||s(k,D,p)}function C(D,p){return D=D||"",p=p||"",D===p?0:D<p?-1:1}function m(D,p){const[k,y]=n(D),[P,I]=n(p);let F=L.value.collator.compare(y,I);if(F===0){if(L.value.collatorIsNumeric&&y!==I)return y<I?-1:1;if(F=L.value.collator.compare(k,P),L.value.collatorIsNumeric&&F===0&&k!==P)return k<P?-1:1}return F}function E(D,p){D=D||"",p=p||"";const k=i(D),y=i(p),P=R.value.collator,I=M.value.collator;return s(I,k,y)||s(P,D,p)}function v(D,p){D=D||"",p=p||"";const k=i(D),y=i(p),P=R.value.collator,I=M.value.collator;return s(I,k,y)||h(D,p)||s(P,D,p)}function u(D,p){D=D||"",p=p||"";const k=i(D),y=i(p),P=R.value.collator,I=M.value.collator;return s(I,k,y)||g(D,p)||s(P,D,p)}function f(D,p){D=D||"",p=p||"";const k=i(D).toLowerCase(),y=i(p).toLowerCase();return k!==y?k<y?-1:1:D!==p?D<p?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function n(D,p=!1){const k=D?a.exec(D):[];let y=[k&&k[1]||"",k&&k[3]||""];return p&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const p=D?a.exec(D):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function s(D,p,k){const y=D.compare(p,k);return y!==0?y:p.length!==k.length?p.length<k.length?-1:1:0}function o(D){const p=D.charAt(0);return p.toLocaleUpperCase()!==p}function t(D){const p=D.charAt(0);return p.toLocaleLowerCase()!==p}function g(D,p){return o(D)&&t(p)?-1:t(D)&&o(p)?1:0}function h(D,p){return t(D)&&o(p)?-1:o(D)&&t(p)?1:0}function c(D,p,k=!1){return k||(D=D&&D.toLowerCase(),p=p&&p.toLowerCase()),D===p?0:D<p?-1:1}function r(D,p,k=!1){const y=D.split(N.sep),P=p.split(N.sep),I=y.length-1,F=P.length-1;let j,z;for(let O=0;;O++){if(j=I===O,z=F===O,j&&z)return b(y[O],P[O],k);if(j)return-1;if(z)return 1;const T=c(y[O],P[O],k);if(T!==0)return T}}function w(D,p,k){const y=D.toLowerCase(),P=p.toLowerCase(),I=d(D,p,k);if(I)return I;const F=y.endsWith(k),j=P.endsWith(k);if(F!==j)return F?-1:1;const z=b(y,P);return z!==0?z:y.localeCompare(P)}function d(D,p,k){const y=D.toLowerCase(),P=p.toLowerCase(),I=y.startsWith(k),F=P.startsWith(k);if(I!==F)return I?-1:1;if(I&&F){if(y.length<P.length)return-1;if(y.length>P.length)return 1}return 0}}),define(ke[34],Ee([1,0,17,11,14,18]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=M,e.$kg=b,e.$lg=$,e.$mg=S,e.$ng=A,e.$og=v,e.$pg=u,e.$qg=f,e.$rg=a,e.$sg=n,e.$tg=i,e.$ug=s,e.$vg=o,e.$wg=t,e.$xg=g,e.$yg=r;function M(w){return w===47||w===92}function b(w){return w.replace(/[\\/]/g,l.$hc.sep)}function $(w){return w.indexOf("/")===-1&&(w=b(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function S(w,d=l.$hc.sep){if(!w)return"";const D=w.length,p=w.charCodeAt(0);if(M(p)){if(M(w.charCodeAt(1))&&!M(w.charCodeAt(2))){let y=3;const P=y;for(;y<D&&!M(w.charCodeAt(y));y++);if(P!==y&&!M(w.charCodeAt(y+1))){for(y+=1;y<D;y++)if(M(w.charCodeAt(y)))return w.slice(0,y+1).replace(/[\\/]/g,d)}}return d}else if(a(p)&&w.charCodeAt(1)===58)return M(w.charCodeAt(2))?w.slice(0,2)+d:w.slice(0,2);let k=w.indexOf("://");if(k!==-1){for(k+=3;k<D;k++)if(M(w.charCodeAt(k)))return w.slice(0,k+1)}return""}function A(w){if(!N.$i||!w||w.length<5)return!1;let d=w.charCodeAt(0);if(d!==92||(d=w.charCodeAt(1),d!==92))return!1;let D=2;const p=D;for(;D<w.length&&(d=w.charCodeAt(D),d!==92);D++);return!(p===D||(d=w.charCodeAt(D+1),isNaN(d)||d===92))}const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(w,d=N.$i){const D=d?C:m;return!(!w||w.length===0||/^\s+$/.test(w)||(D.lastIndex=0,D.test(w))||d&&E.test(w)||w==="."||w===".."||d&&w[w.length-1]==="."||d&&w.length!==w.trim().length||w.length>255)}function u(w,d,D){const p=w===d;return!D||p?p:!w||!d?!1:(0,L.$tf)(w,d)}function f(w,d,D,p=l.sep){if(w===d)return!0;if(!w||!d||d.length>w.length)return!1;if(D){if(!(0,L.$uf)(w,d))return!1;if(d.length===w.length)return!0;let y=d.length;return d.charAt(d.length-1)===p&&y--,w.charAt(y)===p}return d.charAt(d.length-1)!==p&&(d+=p),w.indexOf(d)===0}function a(w){return w>=65&&w<=90||w>=97&&w<=122}function n(w,d){return N.$i&&w.endsWith(":")&&(w+=l.sep),(0,l.$jc)(w)||(w=(0,l.$kc)(d,w)),w=(0,l.$ic)(w),N.$i?(w=(0,L.$bf)(w,l.sep),w.endsWith(":")&&(w+=l.sep)):(w=(0,L.$bf)(w,l.sep),w||(w=l.sep)),w}function i(w){const d=(0,l.$ic)(w);return N.$i?w.length>3?!1:s(d)&&(w.length===2||d.charCodeAt(2)===92):d===l.$hc.sep}function s(w,d=N.$i){return d?a(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}function o(w,d=N.$i){return s(w,d)?w[0]:void 0}function t(w,d,D){return d.length>w.length?-1:w===d?0:(D&&(w=w.toLowerCase(),d=d.toLowerCase()),w.indexOf(d))}function g(w){const d=w.split(":");let D,p,k;for(const y of d){const P=Number(y);(0,R.$8f)(P)?p===void 0?p=P:k===void 0&&(k=P):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:p!==void 0?p:void 0,column:k!==void 0?k:p!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(w,d,D=8){let p="";for(let y=0;y<D;y++){let P;y===0&&N.$i&&!d&&(D===3||D===4)?P=c:P=h,p+=P.charAt(Math.floor(Math.random()*P.length))}let k;return d?k=`${d}-${p}`:k=p,w?(0,l.$kc)(w,k):k}}),define(ke[132],Ee([1,0,131,126,56,17,11,14]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=A,e.$mr=f,e.$nr=h,e.$or=k,e.$pr=z,e.$qr=T;const $=0,S=[$,[]];function A(B,W,X,x){if(!B||!W)return S;const Z=B.length,Y=W.length;if(Z<Y)return S;const ue=B.toLowerCase();return C(W,X,Y,B,ue,Z,x)}function C(B,W,X,x,Z,Y,ue){const te=[],we=[];for(let ne=0;ne<X;ne++){const $e=ne*Y,Pe=$e-Y,se=ne>0,re=B[ne],oe=W[ne];for(let G=0;G<Y;G++){const ie=G>0,me=$e+G,be=me-1,Ae=Pe+G-1,fe=ie?te[be]:0,De=se&&ie?te[Ae]:0,Ie=se&&ie?we[Ae]:0;let Te;!De&&se?Te=0:Te=m(re,oe,x,Z,G,Ie),Te&&De+Te>=fe&&(ue||se||Z.startsWith(W,G))?(we[me]=Ie+1,te[me]=De+Te):(we[me]=$,te[me]=fe)}}const Se=[];let _=X-1,U=Y-1;for(;_>=0&&U>=0;){const ne=_*Y+U;we[ne]===$||(Se.push(U),_--),U--}return[te[X*Y-1],Se.reverse()]}function m(B,W,X,x,Z,Y){let ue=0;if(!E(W,x[Z]))return ue;if(ue+=1,Y>0&&(ue+=Y*5),B===X[Z]&&(ue+=1),Z===0)ue+=8;else{const te=v(X.charCodeAt(Z-1));te?ue+=te:(0,N.$vk)(X.charCodeAt(Z))&&Y===0&&(ue+=2)}return ue}function E(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function f(B,W,X=0,x=0){const Z=W;return Z.values&&Z.values.length>1?a(B,Z.values,X,x):n(B,W,X,x)}function a(B,W,X,x){let Z=0;const Y=[];for(const ue of W){const[te,we]=n(B,ue,X,x);if(typeof te!="number")return u;Z+=te,Y.push(...we)}return[Z,D(Y)]}function n(B,W,X,x){const Z=(0,N.$Ek)(W.original,W.originalLowercase,X,B,B.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,N.$Bk)(Z)]:u}const i=Object.freeze({score:0}),s=1<<18,o=1<<17,t=65536;function g(B,W,X,x){const Z=x.values?x.values:[x];return(0,L.$ej)({[x.normalized]:{values:Z.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:X}})}function h(B,W,X,x,Z){if(!B||!W.normalized)return i;const Y=x.getItemLabel(B);if(!Y)return i;const ue=x.getItemDescription(B),te=g(Y,ue,X,W),we=Z[te];if(we)return we;const Se=c(Y,ue,x.getItemPath(B),W,X);return Z[te]=Se,Se}function c(B,W,X,x,Z){const Y=!X||!x.containsPathSeparator;return X&&(M.$k?x.pathNormalized===X:(0,b.$tf)(x.pathNormalized,X))?{score:s,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:x.values&&x.values.length>1?r(B,W,X,x.values,Y,Z):w(B,W,X,x,Y,Z)}function r(B,W,X,x,Z,Y){let ue=0;const te=[],we=[];for(const Se of x){const{score:_,labelMatch:U,descriptionMatch:ne}=w(B,W,X,Se,Z,Y);if(_===$)return i;ue+=_,U&&te.push(...U),ne&&we.push(...ne)}return{score:ue,labelMatch:D(te),descriptionMatch:D(we)}}function w(B,W,X,x,Z,Y){if(Z||!W){const[ue,te]=A(B,x.normalized,x.normalizedLowercase,Y&&!x.expectContiguousMatch);if(ue){const we=(0,N.$sk)(x.normalized,B);let Se;if(we){Se=o;const _=Math.round(x.normalized.length/B.length*100);Se+=_}else Se=t;return{score:Se+ue,labelMatch:we||d(te)}}}if(W){let ue=W;X&&(ue=`${W}${R.sep}`);const te=ue.length,we=`${ue}${B}`,[Se,_]=A(we,x.normalized,x.normalizedLowercase,Y&&!x.expectContiguousMatch);if(Se){const U=d(_),ne=[],$e=[];return U.forEach(Pe=>{Pe.start<te&&Pe.end>te?(ne.push({start:0,end:Pe.end-te}),$e.push({start:Pe.start,end:te})):Pe.start>=te?ne.push({start:Pe.start-te,end:Pe.end-te}):$e.push(Pe)}),{score:Se,labelMatch:ne,descriptionMatch:$e}}}return i}function d(B){const W=[];if(!B)return W;let X;for(const x of B)X&&X.end===x?X.end+=1:(X={start:x,end:x+1},W.push(X));return W}function D(B){const W=B.sort((Z,Y)=>Z.start-Y.start),X=[];let x;for(const Z of W)!x||!p(x,Z)?(x=Z,X.push(Z)):(x.start=Math.min(x.start,Z.start),x.end=Math.max(x.end,Z.end));return X}function p(B,W){return!(B.end<W.start||W.end<B.start)}function k(B,W,X,x,Z,Y){const ue=h(B,X,x,Z,Y),te=h(W,X,x,Z,Y),we=ue.score,Se=te.score;if((we===s||Se===s)&&we!==Se)return we===s?-1:1;if(we>t||Se>t){if(we!==Se)return we>Se?-1:1;if(we<o&&Se<o){const re=P(ue.labelMatch,te.labelMatch);if(re!==0)return re}const Pe=Z.getItemLabel(B)||"",se=Z.getItemLabel(W)||"";if(Pe.length!==se.length)return Pe.length-se.length}if(we!==Se)return we>Se?-1:1;const _=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,U=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(_&&!U)return-1;if(U&&!_)return 1;const ne=y(B,ue,Z),$e=y(W,te,Z);return ne&&$e&&ne!==$e?$e>ne?-1:1:I(B,W,X,Z)}function y(B,W,X){let x=-1,Z=-1;if(W.descriptionMatch&&W.descriptionMatch.length?x=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(x=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(Z=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const Y=X.getItemDescription(B);Y&&(Z+=Y.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(Z=W.descriptionMatch[W.descriptionMatch.length-1].end);return Z-x}function P(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const X=B[0].start,Z=B[B.length-1].end-X,Y=W[0].start,te=W[W.length-1].end-Y;return Z===te?0:te<Z?1:-1}function I(B,W,X,x){const Z=x.getItemLabel(B)||"",Y=x.getItemLabel(W)||"",ue=x.getItemDescription(B),te=x.getItemDescription(W),we=Z.length+(ue?ue.length:0),Se=Y.length+(te?te.length:0);if(we!==Se)return we-Se;const _=x.getItemPath(B),U=x.getItemPath(W);return _&&U&&_.length!==U.length?_.length-U.length:Z!==Y?(0,l.$jr)(Z,Y,X.normalized):ue&&te&&ue!==te?(0,l.$jr)(ue,te,X.normalized):_&&U&&_!==U?(0,l.$jr)(_,U,X.normalized):0}function F(B){return B.startsWith('"')&&B.endsWith('"')}const j=" ";function z(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:X,normalized:x,normalizedLowercase:Z}=O(B),Y=X.indexOf(R.sep)>=0,ue=F(B);let te;const we=B.split(j);if(we.length>1)for(const Se of we){const _=F(Se),{pathNormalized:U,normalized:ne,normalizedLowercase:$e}=O(Se);ne&&(te||(te=[]),te.push({original:Se,originalLowercase:Se.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:$e,expectContiguousMatch:_}))}return{original:B,originalLowercase:W,pathNormalized:X,normalized:x,normalizedLowercase:Z,values:te,containsPathSeparator:Y,expectContiguousMatch:ue}}function O(B){let W;M.$i?W=B.replace(/\//g,R.sep):W=B.replace(/\\/g,R.sep);const X=(0,b.$df)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:X,normalizedLowercase:X.toLowerCase()}}function T(B){return Array.isArray(B)?z(B.map(W=>W.original).join(j)):z(B.original)}}),define(ke[101],Ee([1,0,17]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=R,e.$Js=M,e.$Ks=b,e.$Ls=S,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const C=(0,l.$pc)(A),m=N[C.toLowerCase()];return m!==void 0?m:M(A)}function M(A){const C=(0,l.$pc)(A);return L[C.toLowerCase()]}function b(A){for(const C in L)if(L[C]===A)return C}const $=/^(.+)\/(.+?)(;.+)?$/;function S(A,C){const m=$.exec(A);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:A}}),define(ke[102],Ee([1,0,11]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$gm=R,e.$hm=M;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function R(b,...$){const S=$.reduce((m,E)=>(m[E]=!0,m),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!S[m]).forEach(m=>{for(let E=0;E<A.length;E++)if(m.search(A[E])!==-1){delete b[m];break}})}function M(b){b&&(delete b.DEBUG,l.$j&&delete b.DYLD_LIBRARY_PATH,l.$k&&delete b.LD_PRELOAD)}}),define(ke[2],Ee([1,0,17,11]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=s;const L=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function b(c,r){if(!c.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!L.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!R.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(c,r){return!c&&!r?"file":c}function S(c,r){switch(c){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const A="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(r){return r instanceof E?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,w,d,D,p,k=!1){typeof r=="object"?(this.scheme=r.scheme||A,this.authority=r.authority||A,this.path=r.path||A,this.query=r.query||A,this.fragment=r.fragment||A):(this.scheme=$(r,k),this.authority=w||A,this.path=S(this.scheme,d||A),this.query=D||A,this.fragment=p||A,b(this,k))}get fsPath(){return s(this,!1)}with(r){if(!r)return this;let{scheme:w,authority:d,path:D,query:p,fragment:k}=r;return w===void 0?w=this.scheme:w===null&&(w=A),d===void 0?d=this.authority:d===null&&(d=A),D===void 0?D=this.path:D===null&&(D=A),p===void 0?p=this.query:p===null&&(p=A),k===void 0?k=this.fragment:k===null&&(k=A),w===this.scheme&&d===this.authority&&D===this.path&&p===this.query&&k===this.fragment?this:new f(w,d,D,p,k)}static parse(r,w=!1){const d=m.exec(r);return d?new f(d[2]||A,h(d[4]||A),h(d[5]||A),h(d[7]||A),h(d[9]||A),w):new f(A,A,A,A,A)}static file(r){let w=A;if(N.$i&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const d=r.indexOf(C,2);d===-1?(w=r.substring(2),r=C):(w=r.substring(2,d),r=r.substring(d)||C)}return new f("file",w,r,A,A)}static from(r,w){return new f(r.scheme,r.authority,r.path,r.query,r.fragment,w)}static joinPath(r,...w){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return N.$i&&r.scheme==="file"?d=E.file(l.$gc.join(s(r,!0),...w)).path:d=l.$hc.join(r.path,...w),r.with({path:d})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof E)return r;{const w=new f(r);return w._formatted=r.external??null,w._fsPath=r._sep===u?r.fsPath??null:null,w}}else return r}}e.URI=E;function v(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const u=N.$i?1:void 0;class f extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=u),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(c,r,w){let d,D=-1;for(let p=0;p<c.length;p++){const k=c.charCodeAt(p);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||r&&k===47||w&&k===91||w&&k===93||w&&k===58)D!==-1&&(d+=encodeURIComponent(c.substring(D,p)),D=-1),d!==void 0&&(d+=c.charAt(p));else{d===void 0&&(d=c.substr(0,p));const y=a[k];y!==void 0?(D!==-1&&(d+=encodeURIComponent(c.substring(D,p)),D=-1),d+=y):D===-1&&(D=p)}}return D!==-1&&(d+=encodeURIComponent(c.substring(D))),d!==void 0?d:c}function i(c){let r;for(let w=0;w<c.length;w++){const d=c.charCodeAt(w);d===35||d===63?(r===void 0&&(r=c.substr(0,w)),r+=a[d]):r!==void 0&&(r+=c[w])}return r!==void 0?r:c}function s(c,r){let w;return c.authority&&c.path.length>1&&c.scheme==="file"?w=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?r?w=c.path.substr(1):w=c.path[1].toLowerCase()+c.path.substr(2):w=c.path,N.$i&&(w=w.replace(/\//g,"\\")),w}function o(c,r){const w=r?i:n;let d="",{scheme:D,authority:p,path:k,query:y,fragment:P}=c;if(D&&(d+=D,d+=":"),(p||D==="file")&&(d+=C,d+=C),p){let I=p.indexOf("@");if(I!==-1){const F=p.substr(0,I);p=p.substr(I+1),I=F.lastIndexOf(":"),I===-1?d+=w(F,!1,!1):(d+=w(F.substr(0,I),!1,!1),d+=":",d+=w(F.substr(I+1),!1,!0)),d+="@"}p=p.toLowerCase(),I=p.lastIndexOf(":"),I===-1?d+=w(p,!1,!0):(d+=w(p.substr(0,I),!1,!0),d+=p.substr(I))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const I=k.charCodeAt(1);I>=65&&I<=90&&(k=`/${String.fromCharCode(I+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const I=k.charCodeAt(0);I>=65&&I<=90&&(k=`${String.fromCharCode(I+32)}:${k.substr(2)}`)}d+=w(k,!0,!1)}return y&&(d+="?",d+=w(y,!1,!1)),P&&(d+="#",d+=r?P:n(P,!1,!1)),d}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(c){return c.match(g)?c.replace(g,r=>t(r)):c}}),define(ke[192],Ee([1,0,2]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=N,e.$Oq=L,e.$Pq=R,e.log=b;function N(S){const A=S;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(S){const A=[];let C;try{const m=JSON.parse(S.arguments),E=m[m.length-1];E&&E.__$stack&&(m.pop(),C=E.__$stack),A.push(...m)}catch{A.push("Unable to log remote console arguments",S.arguments)}return{args:A,stack:C}}function R(S){if(typeof S!="string")return R(L(S).stack);const A=S;if(A){const C=M(A),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:l.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function M(S){if(!S)return S;const A=S.indexOf(`
`);return A===-1?S:S.substring(0,A)}function b(S,A){const{args:C,stack:m}=L(S),E=typeof C[0]=="string"&&C.length===1;let v=M(m);v&&(v=`(${v.trim()})`);let u=[];if(typeof C[0]=="string"?v&&E?u=[`%c[${A}] %c${C[0]} %c${v}`,$("blue"),$(""),$("grey")]:u=[`%c[${A}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:u=[`%c[${A}]%`,$("blue"),...C],v&&!E&&u.push(v),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,u)}function $(S){return`color: ${S}`}}),define(ke[58],Ee([1,0,21,2]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=L,e.$Yh=R,e.$Zh=b;function L($){return JSON.stringify($,M)}function R($){let S=JSON.parse($);return S=b(S),S}function M($,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function b($,S=0){if(!$||S>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof l.$Ce||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=b($[A],S+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=b($[A],S+1))}return $}}),define(ke[15],Ee([1,0,13,11,14,2,17]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=$,e.$Ag=S,e.$Eg=C;var b;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(b||(e.Schemas=b={}));function $(v,u){return R.URI.isUri(v)?(0,L.$tf)(v.scheme,u):(0,L.$uf)(v,u+":")}function S(v,...u){return u.some(f=>$(v,f))}e.$Bg="vscode-tkn",e.$Cg="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u,f){this.f=C(u,f)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,b.vscodeRemoteResource)}set(u,f,a){this.a[u]=f,this.b[u]=a}setConnectionToken(u,f){this.c[u]=f}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch(o){return l.$1(o),u}const f=u.authority;let a=this.a[f];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const n=this.b[f],i=this.c[f];let s=`path=${encodeURIComponent(u.path)}`;return typeof i=="string"&&(s+=`&${e.$Cg}=${encodeURIComponent(i)}`),R.URI.from({scheme:N.$o?this.d:b.vscodeRemoteResource,authority:`${a}:${n}`,path:this.g,query:s})}}e.$Dg=new A;function C(v,u){return M.$hc.join(u??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class m{static{this.a=e.$Jg}asBrowserUri(u){const f=this.b(u,le);return this.uriToBrowserUri(f)}uriToBrowserUri(u){return u.scheme===b.vscodeRemote?e.$Dg.rewrite(u):u.scheme===b.file&&(N.$m||N.$q===`${b.vscodeFileResource}://${m.a}`)?u.with({scheme:b.vscodeFileResource,authority:u.authority||m.a,query:null,fragment:null}):u}asFileUri(u){const f=this.b(u,le);return this.uriToFileUri(f)}uriToFileUri(u){return u.scheme===b.vscodeFileResource?u.with({scheme:b.file,authority:u.authority!==m.a?u.authority:null,query:null,fragment:null}):u}b(u,f){return R.URI.isUri(u)?u:R.URI.parse(f.toUrl(u))}}e.$Kg=new m;var E;(function(v){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(u.get("3"));const f="vscode-coi";function a(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:R.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const o=s?.get(f);if(o)return u.get(o)}v.getHeadersFromQuery=a;function n(i,s,o){if(!globalThis.crossOriginIsolated)return;const t=s&&o?"3":o?"2":"1";i instanceof URLSearchParams?i.set(f,t):i[f]=t}v.addSearchParam=n})(E||(e.COI=E={}))}),define(ke[193],Ee([1,0,162,15,11,2]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RD=A;class M{constructor(m,E,v){this.id=m,this.dependencies=E,this.callback=v}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,E,v)=>{typeof m!="string"&&(v=E,E=m,m=null),(typeof E!="object"||!Array.isArray(E))&&(v=E,E=null),this.c.push(new M(m,E,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const E=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!E)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(m){return new Promise((E,v)=>{const u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript");const f=()=>{u.removeEventListener("load",a),u.removeEventListener("error",n)},a=i=>{f(),E(this.c.pop())},n=i=>{f(),v(i)};u.addEventListener("load",a),u.addEventListener("error",n),this.f&&(m=this.f.createScriptURL(m)),u.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(u)})}i(m){return new Promise((E,v)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),E(this.c.pop())}catch(u){v(u)}})}async j(m){try{const E=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,u=globalThis._VSCODE_NODE_MODULES.module,f=R.URI.parse(m).fsPath,a=E.readFileSync(f).toString(),n=u.wrap(a.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const $=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function A(C,m,E){if(l.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[C]&&(C=S[C]);const v=`${C}/${m}`;if($.has(v))return $.get(v);let u;if(/^\w[\w\d+.-]*:\/\//.test(v))u=v;else{const i=`${E&&!L.$o?N.$Hg:N.$Gg}/${v}`;u=N.$Kg.asBrowserUri(i).toString(!0)}const f=b.INSTANCE.load(u);return $.set(v,f),f}else return await new Promise((v,u)=>{le([C],v,u)})}}),define(ke[23],Ee([1,0,34,15,17,11,14,2]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=$,e.$ah=A,e.$bh=m;function $(E){return(0,b.$xc)(E,!0)}class S{constructor(v){this.a=v}compare(v,u,f=!1){return v===u?0:(0,M.$mf)(this.getComparisonKey(v,f),this.getComparisonKey(u,f))}isEqual(v,u,f=!1){return v===u?!0:!v||!u?!1:this.getComparisonKey(v,f)===this.getComparisonKey(u,f)}getComparisonKey(v,u=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,u,f=!1){if(v.scheme===u.scheme){if(v.scheme===N.Schemas.file)return l.$qg($(v),$(u),this.a(v))&&v.query===u.query&&(f||v.fragment===u.fragment);if((0,e.$9g)(v.authority,u.authority))return l.$qg(v.path,u.path,this.a(v),"/")&&v.query===u.query&&(f||v.fragment===u.fragment)}return!1}joinPath(v,...u){return b.URI.joinPath(v,...u)}basenameOrAuthority(v){return(0,e.$1g)(v)||v.authority}basename(v){return L.$hc.basename(v.path)}extname(v){return L.$hc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let u;return v.scheme===N.Schemas.file?u=b.URI.file(L.$nc($(v))).path:(u=L.$hc.dirname(v.path),v.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),u="/")),v.with({path:u})}normalizePath(v){if(!v.path.length)return v;let u;return v.scheme===N.Schemas.file?u=b.URI.file(L.$ic($(v))).path:u=L.$hc.normalize(v.path),v.with({path:u})}relativePath(v,u){if(v.scheme!==u.scheme||!(0,e.$9g)(v.authority,u.authority))return;if(v.scheme===N.Schemas.file){const n=L.$mc($(v),$(u));return R.$i?l.$kg(n):n}let f=v.path||"/";const a=u.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(f.length,a.length);n<i&&!(f.charCodeAt(n)!==a.charCodeAt(n)&&f.charAt(n).toLowerCase()!==a.charAt(n).toLowerCase());n++);f=a.substr(0,n)+f.substr(n)}return L.$hc.relative(f,a)}resolvePath(v,u){if(v.scheme===N.Schemas.file){const f=b.URI.file(L.$lc($(v),u));return v.with({authority:f.authority,path:f.path})}return u=l.$lg(u),v.with({path:L.$hc.resolve(v.path,u)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,u){return v===u||v!==void 0&&u!==void 0&&(0,M.$tf)(v,u)}hasTrailingPathSeparator(v,u=L.sep){if(v.scheme===N.Schemas.file){const f=$(v);return f.length>l.$mg(f).length&&f[f.length-1]===u}else{const f=v.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,u=L.sep){return(0,e.$0g)(v,u)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,u=L.sep){let f=!1;if(v.scheme===N.Schemas.file){const a=$(v);f=a!==void 0&&a.length===l.$mg(a).length&&a[a.length-1]===u}else{u="/";const a=v.path;f=a.length===1&&a.charCodeAt(a.length-1)===47}return!f&&!(0,e.$0g)(v,u)?v.with({path:v.path+"/"}):v}}e.$Sg=S,e.$Tg=new S(()=>!1),e.$Ug=new S(E=>E.scheme===N.Schemas.file?!R.$k:!0),e.$Vg=new S(E=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function A(E,v){const u=[];for(let f=0;f<E.length;f++){const a=v(E[f]);E.some((n,i)=>i===f?!1:(0,e.$Xg)(a,v(n)))||u.push(E[f])}return u}var C;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function v(u){const f=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(i=>{const[s,o]=i.split(":");s&&o&&f.set(s,o)});const n=u.path.substring(0,u.path.indexOf(";"));return n&&f.set(E.META_DATA_MIME,n),f}E.parseMetaData=v})(C||(e.DataUri=C={}));function m(E,v,u){if(v){let f=E.path;return f&&f[0]!==L.$hc.sep&&(f=L.$hc.sep+f),E.with({scheme:u,authority:v,path:f})}return E.with({scheme:u})}}),define(ke[8],Ee([1,0,22,13,4,3,23,11,169,46]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=A,e.$dh=C,e.$eh=m,e.$fh=E,e.$gh=v,e.$hh=u,e.$ih=f,e.$jh=a,e.$rh=w,e.$sh=d,e.$th=D,e.$uh=p,e.$vh=k,e.$Kh=Z,e.$Sh=se;function A(oe){return!!oe&&typeof oe.then=="function"}function C(oe){const G=new l.$me,ie=oe(G.token),me=new Promise((be,Ae)=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),Ae(new N.$5)});Promise.resolve(ie).then(De=>{fe.dispose(),G.dispose(),be(De)},De=>{fe.dispose(),G.dispose(),Ae(De)})});return new class{cancel(){G.cancel(),G.dispose()}then(be,Ae){return me.then(be,Ae)}catch(be){return this.then(void 0,be)}finally(be){return me.finally(be)}}}function m(oe,G,ie){return new Promise((me,be)=>{const Ae=G.onCancellationRequested(()=>{Ae.dispose(),me(ie)});oe.then(me,be).finally(()=>Ae.dispose())})}function E(oe,G){return new Promise((ie,me)=>{const be=G.onCancellationRequested(()=>{be.dispose(),me(new N.$5)});oe.then(ie,me).finally(()=>be.dispose())})}async function v(oe){let G=-1;const ie=oe.map((me,be)=>me.then(Ae=>(G=be,Ae)));try{return await Promise.race(ie)}finally{oe.forEach((me,be)=>{be!==G&&me.cancel()})}}function u(oe,G,ie){let me;const be=setTimeout(()=>{me?.(void 0),ie?.()},G);return Promise.race([oe.finally(()=>clearTimeout(be)),new Promise(Ae=>me=Ae)])}function f(oe){return new Promise((G,ie)=>{const me=oe();A(me)?me.then(G,ie):G(me)})}function a(){let oe,G;return{promise:new Promise((me,be)=>{oe=me,G=be}),resolve:oe,reject:G}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const ie=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(ie,ie).then(me)})}return new Promise((ie,me)=>{this.b.then(ie,me)})}return this.a=G(),new Promise((ie,me)=>{this.a.then(be=>{this.a=null,ie(be)},be=>{this.a=null,me(be)})})}dispose(){this.f=!0}}e.$kh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$lh=i;class s{constructor(){this.a=new Map}queue(G,ie){const be=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(G)===be&&this.a.delete(G)});return this.a.set(G,be),be}}e.$mh=s;const o=(oe,G)=>{let ie=!0;const me=setTimeout(()=>{ie=!1,G()},oe);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(me),ie=!1}}},t=oe=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,oe())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class g{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,ie=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((be,Ae)=>{this.d=be,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=ie===$.$$d?t(me):o(ie,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=g;class h{constructor(G){this.a=new g(G),this.b=new n}trigger(G,ie){return this.a.trigger(()=>this.b.queue(G),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=h;class c{constructor(){this.a=!1,this.b=new Promise((G,ie)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=c;class r extends c{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$qh=r;function w(oe,G){return G?new Promise((ie,me)=>{const be=setTimeout(()=>{Ae.dispose(),ie()},oe),Ae=G.onCancellationRequested(()=>{clearTimeout(be),Ae.dispose(),me(new N.$5)})}):C(ie=>w(oe,ie))}function d(oe,G=0,ie){const me=setTimeout(()=>{oe(),ie&&be.dispose()},G),be=(0,R.$Sc)(()=>{clearTimeout(me),ie?.deleteAndLeak(be)});return ie?.add(be),be}function D(oe){const G=[];let ie=0;const me=oe.length;function be(){return ie<me?oe[ie++]():null}function Ae(fe){fe!=null&&G.push(fe);const De=be();return De?De.then(Ae):Promise.resolve(G)}return Promise.resolve(null).then(Ae)}function p(oe,G=me=>!!me,ie=null){let me=0;const be=oe.length,Ae=()=>{if(me>=be)return Promise.resolve(ie);const fe=oe[me++];return Promise.resolve(fe()).then(Ie=>G(Ie)?Promise.resolve(Ie):Ae())};return Ae()}function k(oe,G=me=>!!me,ie=null){if(oe.length===0)return Promise.resolve(ie);let me=oe.length;const be=()=>{me=-1;for(const Ae of oe)Ae.cancel?.()};return new Promise((Ae,fe)=>{for(const De of oe)De.then(Ie=>{--me>=0&&G(Ie)?(be(),Ae(Ie)):me===0&&Ae(ie)}).catch(Ie=>{--me>=0&&(be(),fe(Ie))})})}class y{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new L.$be}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,me)=>{this.g.push({factory:G,c:ie,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const ie=G.factory();ie.then(G.c,G.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=y;class P extends y{constructor(){super(1)}}e.$xh=P;class I{constructor(){this.a=new Y,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$yh=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new we;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,ie=M.$Tg){const me=ie.getComparisonKey(G);return this.a.get(me)?.size??0}queueFor(G,ie,me=M.$Tg){const be=me.getComparisonKey(G);let Ae=this.a.get(be);if(!Ae){Ae=new P;const fe=this.f++,De=L.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(fe,De),this.a.set(be,Ae)}return Ae.queue(ie)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=F;class j{constructor(G,ie){this.a=-1,typeof G=="function"&&typeof ie=="number"&&this.setIfNotSet(G,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},ie)}setIfNotSet(G,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},ie))}}e.$Ah=j;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,ie,me=globalThis){this.cancel();const be=me.setInterval(()=>{G()},ie);this.d=(0,R.$Sc)(()=>{me.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=z;class O{constructor(G,ie){this.b=-1,this.a=G,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=O;class T{constructor(G,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=G,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=T;class B extends O{constructor(G,ie){super(G,ie),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$Eh=B;class W extends R.$Uc{constructor(G,ie){super(),this.g=G,this.h=ie,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of G)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(oe,G)=>{(0,b.$B)(()=>{if(ie)return;const me=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Hh=(oe,G,ie)=>{const me=oe.requestIdleCallback(G,typeof ie=="number"?{timeout:ie}:void 0);let be=!1;return{dispose(){be||(be=!0,oe.cancelIdleCallback(me))}}},e.$Gh=oe=>(0,e.$Hh)(globalThis,oe)}();class X{constructor(G,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Hh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=X;class x extends X{constructor(G){super(globalThis,G)}}e.$Jh=x;async function Z(oe,G,ie){let me;for(let be=0;be<ie;be++)try{return await oe()}catch(Ae){me=Ae,await w(G)}throw me}class Y{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,ie,me){return this.a={taskId:G,cancel:()=>me?.(),promise:ie},ie.then(()=>this.d(G),()=>this.d(G)),ie}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:ie,resolve:me,reject:be}=a();this.b={run:G,promise:ie,promiseResolve:me,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=Y;class ue{constructor(G,ie=()=>Date.now()){this.d=G,this.f=ie,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Mh=ue;var te;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(te||(te={}));class we{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,ie)=>{this.a=G,this.b=ie})}complete(G){return new Promise(ie=>{this.a(G),this.d={outcome:0,value:G},ie()})}error(G){return new Promise(ie=>{this.b(G),this.d={outcome:1,value:G},ie()})}cancel(){return this.error(new N.$5)}}e.$Nh=we;var Se;(function(oe){async function G(me){let be;const Ae=await Promise.all(me.map(fe=>fe.then(De=>De,De=>{be||(be=De)})));if(typeof be<"u")throw be;return Ae}oe.settled=G;function ie(me){return new Promise(async(be,Ae)=>{try{await me(be,Ae)}catch(fe){Ae(fe)}})}oe.withAsyncBody=ie})(Se||(e.Promises=Se={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=_;class U{constructor(G){this.b=G,this.a=new S.$V(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=U;var ne;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(ne||(ne={}));class $e{static fromArray(G){return new $e(ie=>{ie.emitMany(G)})}static fromPromise(G){return new $e(async ie=>{ie.emitMany(await G)})}static fromPromises(G){return new $e(async ie=>{await Promise.all(G.map(async me=>ie.emitOne(await me)))})}static merge(G){return new $e(async ie=>{await Promise.all(G.map(async me=>{for await(const be of me)ie.emitOne(be)}))})}static{this.EMPTY=$e.fromArray([])}constructor(G,ie){this.a=0,this.b=[],this.d=null,this.f=ie,this.g=new L.$be,queueMicrotask(async()=>{const me={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(G(me)),this.k()}catch(be){this.l(be)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(G,ie){return new $e(async me=>{for await(const be of G)me.emitOne(ie(be))})}map(G){return $e.map(this,G)}static filter(G,ie){return new $e(async me=>{for await(const be of G)ie(be)&&me.emitOne(be)})}filter(G){return $e.filter(this,G)}static coalesce(G){return $e.filter(G,ie=>!!ie)}coalesce(){return $e.coalesce(this)}static async toPromise(G){const ie=[];for await(const me of G)ie.push(me);return ie}toPromise(){return $e.toPromise(this)}h(G){this.a===0&&(this.b.push(G),this.g.fire())}j(G){this.a===0&&(this.b=this.b.concat(G),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(G){this.a===0&&(this.a=2,this.d=G,this.g.fire())}}e.$Qh=$e;class Pe extends $e{constructor(G,ie){super(ie),this.m=G}cancel(){this.m.cancel()}}e.$Rh=Pe;function se(oe){const G=new l.$me,ie=oe(G.token);return new Pe(G,async me=>{const be=G.token.onCancellationRequested(()=>{be.dispose(),G.dispose(),me.reject(new N.$5)});try{for await(const Ae of ie){if(G.token.isCancellationRequested)return;me.emitOne(Ae)}be.dispose(),G.dispose()}catch(Ae){be.dispose(),G.dispose(),me.reject(Ae)}})}class re{constructor(G){this.a=new we,this.b=new $e(be=>{if(ie){be.reject(ie);return}return me&&be.emitMany(me),this.d=Ae=>be.reject(Ae),this.f=Ae=>be.emitOne(Ae),this.a.p},G);let ie,me;this.f=be=>{me||(me=[]),me.push(be)},this.d=be=>{ie||(ie=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$Th=re}),define(ke[35],Ee([1,0,19,8,34,27,17,11,14]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=S,e.$ik=v,e.$jk=P,e.$kk=I,e.$lk=F,e.$mk=j,e.$nk=z,e.$ok=W;function S(){return Object.create(null)}e.$gk="**",e.$hk="/";const A="[/\\\\]",C="[^/\\\\]",m=/\//g;function E(X,x){switch(X){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}${x?`|${A}${C}+`:""})*?`}}function v(X,x){if(!X)return[];const Z=[];let Y=!1,ue=!1,te="";for(const we of X){switch(we){case x:if(!Y&&!ue){Z.push(te),te="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}te+=we}return te&&Z.push(te),Z}function u(X){if(!X)return"";let x="";const Z=v(X,e.$hk);if(Z.every(Y=>Y===e.$gk))x=".*";else{let Y=!1;Z.forEach((ue,te)=>{if(ue===e.$gk){if(Y)return;x+=E(2,te===Z.length-1)}else{let we=!1,Se="",_=!1,U="";for(const ne of ue){if(ne!=="}"&&we){Se+=ne;continue}if(_&&(ne!=="]"||!U)){let $e;ne==="-"?$e=ne:(ne==="^"||ne==="!")&&!U?$e="^":ne===e.$hk?$e="":$e=(0,$.$8e)(ne),U+=$e;continue}switch(ne){case"{":we=!0;continue;case"[":_=!0;continue;case"}":{const Pe=`(?:${v(Se,",").map(se=>u(se)).join("|")})`;x+=Pe,we=!1,Se="";break}case"]":{x+="["+U+"]",_=!1,U="";break}case"?":x+=C;continue;case"*":x+=E(1);continue;default:x+=(0,$.$8e)(ne)}}te<Z.length-1&&(Z[te+1]!==e.$gk||te+2<Z.length)&&(x+=A)}Y=ue===e.$gk})}return x}const f=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),g=function(){return!1},h=function(){return null};function c(X,x){if(!X)return h;let Z;typeof X!="string"?Z=X.pattern:Z=X,Z=Z.trim();const Y=`${Z}_${!!x.trimForExclusions}`;let ue=t.get(Y);if(ue)return r(ue,X);let te;return f.test(Z)?ue=d(Z.substr(4),Z):(te=a.exec(w(Z,x)))?ue=D(te[1],Z):(x.trimForExclusions?i:n).test(Z)?ue=p(Z,x):(te=s.exec(w(Z,x)))?ue=k(te[1].substr(1),Z,!0):(te=o.exec(w(Z,x)))?ue=k(te[1],Z,!1):ue=y(Z),t.set(Y,ue),r(ue,X)}function r(X,x){if(typeof x=="string")return X;const Z=function(Y,ue){return(0,L.$qg)(Y,x.base,!b.$k)?X((0,$.$af)(Y.substr(x.base.length),M.sep),ue):null};return Z.allBasenames=X.allBasenames,Z.allPaths=X.allPaths,Z.basenames=X.basenames,Z.patterns=X.patterns,Z}function w(X,x){return x.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function d(X,x){return function(Z,Y){return typeof Z=="string"&&Z.endsWith(X)?x:null}}function D(X,x){const Z=`/${X}`,Y=`\\${X}`,ue=function(we,Se){return typeof we!="string"?null:Se?Se===X?x:null:we===X||we.endsWith(Z)||we.endsWith(Y)?x:null},te=[X];return ue.basenames=te,ue.patterns=[x],ue.allBasenames=te,ue}function p(X,x){const Z=B(X.slice(1,-1).split(",").map(Se=>c(Se,x)).filter(Se=>Se!==h),X),Y=Z.length;if(!Y)return h;if(Y===1)return Z[0];const ue=function(Se,_){for(let U=0,ne=Z.length;U<ne;U++)if(Z[U](Se,_))return X;return null},te=Z.find(Se=>!!Se.allBasenames);te&&(ue.allBasenames=te.allBasenames);const we=Z.reduce((Se,_)=>_.allPaths?Se.concat(_.allPaths):Se,[]);return we.length&&(ue.allPaths=we),ue}function k(X,x,Z){const Y=M.sep===M.$hc.sep,ue=Y?X:X.replace(m,M.sep),te=M.sep+ue,we=M.$hc.sep+X;let Se;return Z?Se=function(_,U){return typeof _=="string"&&(_===ue||_.endsWith(te)||!Y&&(_===X||_.endsWith(we)))?x:null}:Se=function(_,U){return typeof _=="string"&&(_===ue||!Y&&_===X)?x:null},Se.allPaths=[(Z?"*/":"./")+X],Se}function y(X){try{const x=new RegExp(`^${u(X)}$`);return function(Z){return x.lastIndex=0,typeof Z=="string"&&x.test(Z)?X:null}}catch{return h}}function P(X,x,Z){return!X||typeof x!="string"?!1:I(X)(x,void 0,Z)}function I(X,x={}){if(!X)return g;if(typeof X=="string"||F(X)){const Z=c(X,x);if(Z===h)return g;const Y=function(ue,te){return!!Z(ue,te)};return Z.allBasenames&&(Y.allBasenames=Z.allBasenames),Z.allPaths&&(Y.allPaths=Z.allPaths),Y}return O(X,x)}function F(X){const x=X;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}function j(X){return X.allBasenames||[]}function z(X){return X.allPaths||[]}function O(X,x){const Z=B(Object.getOwnPropertyNames(X).map(Se=>T(Se,X[Se],x)).filter(Se=>Se!==h)),Y=Z.length;if(!Y)return h;if(!Z.some(Se=>!!Se.requiresSiblings)){if(Y===1)return Z[0];const Se=function(ne,$e){let Pe;for(let se=0,re=Z.length;se<re;se++){const oe=Z[se](ne,$e);if(typeof oe=="string")return oe;(0,N.$ch)(oe)&&(Pe||(Pe=[]),Pe.push(oe))}return Pe?(async()=>{for(const se of Pe){const re=await se;if(typeof re=="string")return re}return null})():null},_=Z.find(ne=>!!ne.allBasenames);_&&(Se.allBasenames=_.allBasenames);const U=Z.reduce((ne,$e)=>$e.allPaths?ne.concat($e.allPaths):ne,[]);return U.length&&(Se.allPaths=U),Se}const ue=function(Se,_,U){let ne,$e;for(let Pe=0,se=Z.length;Pe<se;Pe++){const re=Z[Pe];re.requiresSiblings&&U&&(_||(_=(0,M.$oc)(Se)),ne||(ne=_.substr(0,_.length-(0,M.$pc)(Se).length)));const oe=re(Se,_,ne,U);if(typeof oe=="string")return oe;(0,N.$ch)(oe)&&($e||($e=[]),$e.push(oe))}return $e?(async()=>{for(const Pe of $e){const se=await Pe;if(typeof se=="string")return se}return null})():null},te=Z.find(Se=>!!Se.allBasenames);te&&(ue.allBasenames=te.allBasenames);const we=Z.reduce((Se,_)=>_.allPaths?Se.concat(_.allPaths):Se,[]);return we.length&&(ue.allPaths=we),ue}function T(X,x,Z){if(x===!1)return h;const Y=c(X,Z);if(Y===h)return h;if(typeof x=="boolean")return Y;if(x){const ue=x.when;if(typeof ue=="string"){const te=(we,Se,_,U)=>{if(!U||!Y(we,Se))return null;const ne=ue.replace("$(basename)",()=>_),$e=U(ne);return(0,N.$ch)($e)?$e.then(Pe=>Pe?X:null):$e?X:null};return te.requiresSiblings=!0,te}}return Y}function B(X,x){const Z=X.filter(Se=>!!Se.basenames);if(Z.length<2)return X;const Y=Z.reduce((Se,_)=>{const U=_.basenames;return U?Se.concat(U):Se},[]);let ue;if(x){ue=[];for(let Se=0,_=Y.length;Se<_;Se++)ue.push(x)}else ue=Z.reduce((Se,_)=>{const U=_.patterns;return U?Se.concat(U):Se},[]);const te=function(Se,_){if(typeof Se!="string")return null;if(!_){let ne;for(ne=Se.length;ne>0;ne--){const $e=Se.charCodeAt(ne-1);if($e===47||$e===92)break}_=Se.substr(ne)}const U=Y.indexOf(_);return U!==-1?ue[U]:null};te.basenames=Y,te.patterns=ue,te.allBasenames=Y;const we=X.filter(Se=>!Se.basenames);return we.push(te),we}function W(X,x){return(0,l.$ub)(X,x,(Z,Y)=>typeof Z=="string"&&typeof Y=="string"?Z===Y:typeof Z!="string"&&typeof Y!="string"?Z.base===Y.base&&Z.pattern===Y.pattern:!1)}}),define(ke[80],Ee([1,0,13,171,23,14,2]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ok=S,e.$Pk=A,e.$Qk=C,e.$Rk=m,e.$Sk=E,e.$Tk=v,e.$Uk=u,e.$Vk=f;var b;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,l.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=m(this.supportThemeIcons?(0,N.$Hk)(n):n).replace(/([ \t]+)/g,(s,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${E(i,n)}
`,this}appendLink(n,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(n,i){const s=new RegExp((0,R.$8e)(i),"g");return n.replace(s,(o,t)=>n.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$Nk=$;function S(a){return A(a)?!a.value:Array.isArray(a)?a.every(S):!0}function A(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function C(a,n){return a===n?!0:!a||!n?!1:a.value===n.value&&a.isTrusted===n.isTrusted&&a.supportThemeIcons===n.supportThemeIcons&&a.supportHtml===n.supportHtml&&(a.baseUri===n.baseUri||!!a.baseUri&&!!n.baseUri&&(0,L.$Wg)(M.URI.from(a.baseUri),M.URI.from(n.baseUri)))}function m(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(a,n){const i=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${n}`,a,`${"`".repeat(s)}`].join(`
`)}function v(a){return a.replace(/"/g,"&quot;")}function u(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function f(a){const n=[],i=a.split("|").map(o=>o.trim());a=i[0];const s=i[1];if(s){const o=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),g=o?o[1]:"",h=t?t[1]:"",c=isFinite(parseInt(h)),r=isFinite(parseInt(g));c&&n.push(`width="${h}"`),r&&n.push(`height="${g}"`)}return{href:a,dimensions:n}}}),define(ke[103],Ee([1,0,19,34,17,11,23,14]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=$,e.$pw=A,e.$qw=m,e.$rw=E,e.$sw=a,e.$tw=i,e.$uw=s,e.$vw=o,e.$ww=t,e.$xw=g;function $(c,r){const{os:w,tildify:d,relative:D}=r;if(D){const y=S(c,D,w);if(typeof y=="string")return y}let p=c.fsPath;if(w===1&&!R.$i?p=p.replace(/\//g,"\\"):w!==1&&R.$i&&(p=p.replace(/\\/g,"/")),w!==1&&d?.userHome){const y=d.userHome.fsPath;let P;c.scheme!==d.userHome.scheme&&c.path[0]===L.$hc.sep&&c.path[1]!==L.$hc.sep?P=d.userHome.with({path:c.path}).fsPath:P=p,p=m(P,y,w)}return(w===1?L.$gc:L.$hc).normalize(A(p,w===1))}function S(c,r,w){const d=w===1?L.$gc:L.$hc,D=w===3?M.$Tg:M.$Vg,p=r.getWorkspace(),k=(0,l.$Ob)(p.folders);if(!k)return;c.scheme!==k.uri.scheme&&c.path[0]===L.$hc.sep&&c.path[1]!==L.$hc.sep&&(c=k.uri.with({path:c.path}));const y=r.getWorkspaceFolder(c);if(!y)return;let P;if(D.isEqual(y.uri,c)?P="":P=D.relativePath(y.uri,c)??"",P&&(P=d.normalize(P)),p.folders.length>1&&!r.noPrefix){const I=y.name?y.name:D.basenameOrAuthority(y.uri);P=P?`${I} \u2022 ${P}`:I}return P}function A(c,r=R.$i){return(0,N.$ug)(c,r)?c.charAt(0).toUpperCase()+c.slice(1):c}let C=Object.create(null);function m(c,r,w=R.OS){if(w===1||!c||!r)return c;let d=C.original===r?C.normalized:void 0;d||(d=r,R.$i&&(d=(0,N.$kg)(d)),d=`${(0,b.$bf)(d,L.$hc.sep)}${L.$hc.sep}`,C={original:r,normalized:d});let D=c;return R.$i&&(D=(0,N.$kg)(D)),(w===3?D.startsWith(d):(0,b.$uf)(D,d))?`~/${D.substr(d.length)}`:c}function E(c,r){return c.replace(/^~($|\/|\\)/,`${r}$1`)}const v="\u2026",u="\\\\",f="~";function a(c,r=L.sep){const w=new Array(c.length);let d=!1;for(let D=0;D<c.length;D++){const p=c[D];if(p===""){w[D]=`.${r}`;continue}if(!p){w[D]=p;continue}d=!0;let k="",y=p;y.indexOf(u)===0?(k=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(r)===0?(k=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(f)===0&&(k=y.substr(0,y.indexOf(f)+f.length),y=y.substr(y.indexOf(f)+f.length));const P=y.split(r);for(let I=1;d&&I<=P.length;I++)for(let F=P.length-I;d&&F>=0;F--){d=!1;let j=P.slice(F,F+I).join(r);for(let z=0;!d&&z<c.length;z++)if(z!==D&&c[z]&&c[z].indexOf(j)>-1){const O=F+I===P.length,T=F>0&&c[z].indexOf(r)>-1?r+j:j,B=c[z].endsWith(T);d=!O||B}if(!d){let z="";(P[0].endsWith(":")||k!=="")&&(F===1&&(F=0,I++,j=P[0]+r+j),F>0&&(z=P[0]+r),z=k+z),F>0&&(z=z+v+r),z=z+j,F+I<P.length&&(z=z+r+v),w[D]=z}}d&&(w[D]=p)}return w}var n;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(c,r=Object.create(null)){const w=[];let d=!1,D="";for(const p of c)if(p==="$"||d&&p==="{")D&&w.push({value:D,type:n.TEXT}),D="",d=!0;else if(p==="}"&&d){const k=r[D];if(typeof k=="string")k.length&&w.push({value:k,type:n.VARIABLE});else if(k){const y=w[w.length-1];(!y||y.type!==n.SEPARATOR)&&w.push({value:k.label,type:n.SEPARATOR})}D="",d=!1}else D+=p;return D&&!d&&w.push({value:D,type:n.TEXT}),w.filter((p,k)=>{if(p.type===n.SEPARATOR){const y=w[k-1],P=w[k+1];return[y,P].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(p=>p.value).join("")}function s(c,r){return R.$j||r?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):c.replace(/&&|&/g,w=>w==="&"?"&&":"&")}function o(c,r){return R.$j||r?c.replace(/\(&&\w\)|&&/g,""):R.$i?c.replace(/&&|&/g,w=>w==="&"?"&&":"&"):c.replace(/&&/g,"_")}function t(c){return c.replace(/&/g,"&&")}function g(c){if(c.endsWith("]")){const r=c.lastIndexOf(" [",c.length-2);if(r!==-1){const w=h(c.substring(0,r)),d=c.substring(r);return{name:w.name+d,parentPath:w.parentPath}}}return h(c)}function h(c){const r=c.indexOf("/")!==-1?L.$hc:L.$gc,w=r.basename(c),d=r.dirname(c);return w.length?{name:w,parentPath:d}:{name:d,parentPath:""}}}),define(ke[133],Ee([1,0,21,2]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=b,e.$vn=S,e.$wn=A;function L(C){return C.toJSON()}class R{constructor(m){this.a=m}transformIncoming(m){const E=this.a.transformIncoming(m);return E===m?m:L(N.URI.from(E))}transformOutgoing(m){const E=this.a.transformOutgoing(m);return E===m?m:L(N.URI.from(E))}transformOutgoingURI(m){const E=this.a.transformOutgoing(m);return E===m?m:N.URI.from(E)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$sn=R,e.$tn=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function M(C,m,E){if(!C||E>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return m.transformOutgoing(C);for(const v in C)if(Object.hasOwnProperty.call(C,v)){const u=M(C[v],m,E+1);u!==null&&(C[v]=u)}}return null}function b(C,m){const E=M(C,m,0);return E===null?C:E}function $(C,m,E,v){if(!C||v>200)return null;if(typeof C=="object"){if(C.$mid===1)return E?N.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof l.$Ce)return null;for(const u in C)if(Object.hasOwnProperty.call(C,u)){const f=$(C[u],m,E,v+1);f!==null&&(C[u]=f)}}return null}function S(C,m){const E=$(C,m,!1,0);return E===null?C:E}function A(C,m){const E=$(C,m,!0,0);return E===null?C:E}}),define(ke[31],Ee([1,0,52,64,395,8,34,76,17,11,23,2]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=w,e.writeFileSync=D;var m;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function E(T,B=m.UNLINK,W){if((0,M.$tg)(T))throw new Error("rimraf - will refuse to recursively delete root");return B===m.UNLINK?u(T):v(T,W)}async function v(T,B=(0,M.$yg)((0,N.tmpdir)())){try{try{await l.promises.rename(T,B)}catch(W){return W.code==="ENOENT"?void 0:u(T)}u(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function u(T){return(0,L.promisify)(l.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function f(T){if((0,M.$tg)(T))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}async function a(T,B){return s(await(B?n(T):(0,L.promisify)(l.readdir)(T)))}async function n(T){try{return await(0,L.promisify)(l.readdir)(T,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const B=[],W=await a(T);for(const X of W){let x=!1,Z=!1,Y=!1;try{const ue=await e.Promises.lstat((0,$.$kc)(T,X));x=ue.isFile(),Z=ue.isDirectory(),Y=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}B.push({name:X,isFile:()=>x,isDirectory:()=>Z,isSymbolicLink:()=>Y})}return B}function i(T){return s(l.readdirSync(T))}function s(T){return T.map(B=>typeof B=="string"?S.$j?(0,b.$8l)(B):B:(B.name=S.$j?(0,b.$8l)(B.name):B.name,B))}async function o(T){const B=await a(T),W=[];for(const X of B)await g.existsDirectory((0,$.$kc)(T,X))&&W.push(X);return W}function t(T,B=1e3){return new Promise(W=>{let X=!1;const x=setInterval(()=>{X||(X=!0,l.access(T,Z=>{X=!1,Z&&(clearInterval(x),W(void 0))}))},B)})}var g;(function(T){async function B(x){let Z;try{if(Z=await e.Promises.lstat(x),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(S.$i&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw ue}throw Y}}T.stat=B;async function W(x){try{const{stat:Z,symbolicLink:Y}=await T.stat(x);return Z.isFile()&&Y?.dangling!==!0}catch{}return!1}T.existsFile=W;async function X(x){try{const{stat:Z,symbolicLink:Y}=await T.stat(x);return Z.isDirectory()&&Y?.dangling!==!0}catch{}return!1}T.existsDirectory=X})(g||(e.SymlinkSupport=g={}));const h=new R.$zh;function c(T,B,W){return h.queueFor(C.URI.file(T),()=>{const X=p(W);return new Promise((x,Z)=>d(T,B,X,Y=>Y?Z(Y):x()))},A.$Ug)}let r=!0;function w(T){r=T}function d(T,B,W,X){if(!r)return l.writeFile(T,B,{mode:W.mode,flag:W.flag},X);l.open(T,W.flag,W.mode,(x,Z)=>{if(x)return X(x);l.writeFile(Z,B,Y=>{if(Y)return l.close(Z,()=>X(Y));l.fdatasync(Z,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),w(!1)),l.close(Z,te=>X(te))))})})}function D(T,B,W){const X=p(W);if(!r)return l.writeFileSync(T,B,{mode:X.mode,flag:X.flag});const x=l.openSync(T,X.flag,X.mode);try{l.writeFileSync(x,B);try{l.fdatasyncSync(x)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),w(!1)}}finally{l.closeSync(x)}}function p(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function k(T,B,W=6e4){if(T!==B)try{S.$i&&typeof W=="number"?await y(T,B,Date.now(),W):await(0,L.promisify)(l.rename)(T,B)}catch(X){if(T.toLowerCase()!==B.toLowerCase()&&X.code==="EXDEV"||T.endsWith("."))await P(T,B,{preserveSymlinks:!1}),await E(T,m.MOVE);else throw X}}async function y(T,B,W,X,x=0){try{return await(0,L.promisify)(l.rename)(T,B)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-W>=X)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${Z}`),Z;if(x===0){let Y=!1;try{const{stat:ue}=await g.stat(B);ue.isFile()||(Y=!0)}catch{}if(Y)throw Z}return await(0,R.$rh)(Math.min(100,x*10)),y(T,B,W,X,x+1)}}async function P(T,B,W){return F(T,B,{root:{source:T,target:B},options:W,handledSourcePaths:new Set})}const I=511;async function F(T,B,W){if(W.handledSourcePaths.has(T))return;W.handledSourcePaths.add(T);const{stat:X,symbolicLink:x}=await g.stat(T);if(x){if(W.options.preserveSymlinks)try{return await O(T,B,W)}catch{}if(x.dangling)return}return X.isDirectory()?j(T,B,X.mode&I,W):z(T,B,X.mode&I)}async function j(T,B,W,X){await e.Promises.mkdir(B,{recursive:!0,mode:W});const x=await a(T);for(const Z of x)await F((0,$.$kc)(T,Z),(0,$.$kc)(B,Z),X)}async function z(T,B,W){await e.Promises.copyFile(T,B),await e.Promises.chmod(B,W)}async function O(T,B,W){let X=await e.Promises.readlink(T);(0,M.$qg)(X,W.root.source,!S.$k)&&(X=(0,$.$kc)(W.root.target,X.substr(W.root.source.length+1))),await e.Promises.symlink(X,B)}e.Promises=new class{get access(){return(0,L.promisify)(l.access)}get stat(){return(0,L.promisify)(l.stat)}get lstat(){return(0,L.promisify)(l.lstat)}get utimes(){return(0,L.promisify)(l.utimes)}get read(){return(T,B,W,X,x)=>new Promise((Z,Y)=>{l.read(T,B,W,X,x,(ue,te,we)=>ue?Y(ue):Z({bytesRead:te,buffer:we}))})}get readFile(){return(0,L.promisify)(l.readFile)}get write(){return(T,B,W,X,x)=>new Promise((Z,Y)=>{l.write(T,B,W,X,x,(ue,te,we)=>ue?Y(ue):Z({bytesWritten:te,buffer:we}))})}get appendFile(){return(0,L.promisify)(l.appendFile)}get fdatasync(){return(0,L.promisify)(l.fdatasync)}get truncate(){return(0,L.promisify)(l.truncate)}get copyFile(){return(0,L.promisify)(l.copyFile)}get open(){return(0,L.promisify)(l.open)}get close(){return(0,L.promisify)(l.close)}get symlink(){return(0,L.promisify)(l.symlink)}get readlink(){return(0,L.promisify)(l.readlink)}get chmod(){return(0,L.promisify)(l.chmod)}get mkdir(){return(0,L.promisify)(l.mkdir)}get unlink(){return(0,L.promisify)(l.unlink)}get rmdir(){return(0,L.promisify)(l.rmdir)}get realpath(){return(0,L.promisify)(l.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return c}get rm(){return E}get rename(){return k}get copy(){return P}}}),define(ke[104],Ee([1,0,52,17,11,14,31]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=b,e.$Wq=$,e.$Xq=S,e.$Yq=A;function b(m){if(L.$k)return m;const E=(0,N.$nc)(m);if(m===E)return m;const v=((0,N.$oc)(m)||m).toLowerCase();try{const f=(0,M.readdirSync)(E).filter(a=>a.toLowerCase()===v);if(f.length===1){const a=b(E);if(a)return(0,N.$kc)(a,f[0])}else if(f.length>1){const a=f.indexOf(v);if(a>=0){const n=b(E);if(n)return(0,N.$kc)(n,f[a])}}}catch{}return null}async function $(m,E){if(L.$k)return m;const v=(0,N.$nc)(m);if(m===v)return m;const u=((0,N.$oc)(m)||m).toLowerCase();try{if(E?.isCancellationRequested)return null;const a=(await M.Promises.readdir(v)).filter(n=>n.toLowerCase()===u);if(a.length===1){const n=await $(v,E);if(n)return(0,N.$kc)(n,a[0])}else if(a.length>1){const n=a.indexOf(u);if(n>=0){const i=await $(v,E);if(i)return(0,N.$kc)(i,a[n])}}}catch{}return null}async function S(m){try{return await M.Promises.realpath(m)}catch{const v=C(m);return await M.Promises.access(v,l.constants.R_OK),v}}function A(m){try{return l.realpathSync(m)}catch{const v=C(m);return l.accessSync(v,l.constants.R_OK),v}}function C(m){return(0,R.$bf)((0,N.$ic)(m),N.sep)}}),define(ke[105],Ee([1,0,17,11,51,102,18,31]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$im=$,e.$jm=S,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(C=L.env){return C.comspec||"cmd.exe"}function S(C){let m=[],E=!1;const v=function(u){if(E){m.push(u);return}(!C.send(u,a=>{if(a&&console.error(a),E=!1,m.length>0){const n=m.slice(0);m=[],n.forEach(i=>v(i))}})||N.$i)&&(E=!0)};return{send:v}}var A;(function(C){async function m(E,v,u){if(l.$jc(E))return E;if(v===void 0&&(v=L.cwd()),l.$nc(E)!=="."||(u===void 0&&M.$4f(L.env.PATH)&&(u=L.env.PATH.split(l.$uc)),u===void 0||u.length===0))return l.$kc(v,E);async function a(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(s){s.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of u){let i;if(l.$jc(n)?i=l.$kc(n,E):i=l.$kc(v,n,E),await a(i))return i;let s=i+".com";if(await a(s)||(s=i+".exe",await a(s)))return s}return l.$kc(v,E)}C.findExecutable=m})(A||(e.win32=A={}))});var Je=this&&this.__decorate||function(le,e,l,N){var L=arguments.length,R=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,l):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(le,e,l,N);else for(var b=le.length-1;b>=0;b--)(M=le[b])&&(R=(L<3?M(R):L>3?M(e,l,R):M(e,l))||R);return L>3&&R&&Object.defineProperty(e,l,R),R};define(ke[81],Ee([1,0,19,8,21,22,55,13,4,3,58,14,18]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.ProxyChannel=e.$$h=e.$8h=e.$7h=e.$6h=e.RequestInitiator=e.$5h=e.$2h=e.$1h=void 0,e.$3h=w,e.$4h=d,e.$9h=I,e.$0h=F;var E;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(E||(E={}));function v(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(u||(u={}));function f(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(a||(a={}));function n(x){let Z=0;for(let Y=0;;Y+=7){const ue=x.read(1);if(Z|=(ue.buffer[0]&127)<<Y,!(ue.buffer[0]&128))return Z}}const i=h(0);function s(x,Z){if(Z===0){x.write(i);return}let Y=0;for(let te=Z;te!==0;te=te>>>7)Y++;const ue=L.$Ce.alloc(Y);for(let te=0;Z!==0;te++)ue.buffer[te]=Z&127,Z=Z>>>7,Z>0&&(ue.buffer[te]|=128);x.write(ue)}class o{constructor(Z){this.b=Z,this.a=0}read(Z){const Y=this.b.slice(this.a,this.a+Z);return this.a+=Y.byteLength,Y}}e.$1h=o;class t{constructor(){this.a=[]}get buffer(){return L.$Ce.concat(this.a)}write(Z){this.a.push(Z)}}e.$2h=t;var g;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(g||(g={}));function h(x){const Z=L.$Ce.alloc(1);return Z.writeUInt8(x,0),Z}const c={Undefined:h(g.Undefined),String:h(g.String),Buffer:h(g.Buffer),VSBuffer:h(g.VSBuffer),Array:h(g.Array),Object:h(g.Object),Uint:h(g.Int)},r=typeof Buffer<"u";function w(x,Z){if(typeof Z>"u")x.write(c.Undefined);else if(typeof Z=="string"){const Y=L.$Ce.fromString(Z);x.write(c.String),s(x,Y.byteLength),x.write(Y)}else if(r&&Buffer.isBuffer(Z)){const Y=L.$Ce.wrap(Z);x.write(c.Buffer),s(x,Y.byteLength),x.write(Y)}else if(Z instanceof L.$Ce)x.write(c.VSBuffer),s(x,Z.byteLength),x.write(Z);else if(Array.isArray(Z)){x.write(c.Array),s(x,Z.length);for(const Y of Z)w(x,Y)}else if(typeof Z=="number"&&(Z|0)===Z)x.write(c.Uint),s(x,Z);else{const Y=L.$Ce.fromString(JSON.stringify(Z));x.write(c.Object),s(x,Y.byteLength),x.write(Y)}}function d(x){switch(x.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return x.read(n(x)).toString();case g.Buffer:return x.read(n(x)).buffer;case g.VSBuffer:return x.read(n(x));case g.Array:{const Y=n(x),ue=[];for(let te=0;te<Y;te++)ue.push(d(x));return ue}case g.Object:return JSON.parse(x.read(n(x)).toString());case g.Int:return n(x)}}class D{constructor(Z,Y,ue=null,te=1e3){this.h=Z,this.j=Y,this.k=ue,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(we=>this.q(we)),this.m({type:200})}registerChannel(Z,Y){this.b.set(Z,Y),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const Y=this.o([Z.type]);this.k?.logOutgoing(Y,0,1,f(Z.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(Y,Z.id,1,f(Z.type),Z.data);return}}}o(Z,Y=void 0){const ue=new t;return w(ue,Z),w(ue,Y),this.p(ue.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const Y=new o(Z),ue=d(Y),te=d(Y),we=ue[0];switch(we){case 100:return this.k?.logIncoming(Z.byteLength,ue[1],1,`${v(we)}: ${ue[2]}.${ue[3]}`,te),this.s({type:we,id:ue[1],channelName:ue[2],name:ue[3],arg:te});case 102:return this.k?.logIncoming(Z.byteLength,ue[1],1,`${v(we)}: ${ue[2]}.${ue[3]}`,te),this.t({type:we,id:ue[1],channelName:ue[2],name:ue[3],arg:te});case 101:return this.k?.logIncoming(Z.byteLength,ue[1],1,`${v(we)}`),this.u({type:we,id:ue[1]});case 103:return this.k?.logIncoming(Z.byteLength,ue[1],1,`${v(we)}`),this.u({type:we,id:ue[1]})}}s(Z){const Y=this.b.get(Z.channelName);if(!Y){this.v(Z);return}const ue=new R.$me;let te;try{te=Y.call(this.j,Z.name,Z.arg,ue.token)}catch(_){te=Promise.reject(_)}const we=Z.id;te.then(_=>{this.m({id:we,data:_,type:201})},_=>{_ instanceof Error?this.m({id:we,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:we,data:_,type:203})}).finally(()=>{Se.dispose(),this.d.delete(Z.id)});const Se=(0,S.$Sc)(()=>ue.cancel());this.d.set(Z.id,Se)}t(Z){const Y=this.b.get(Z.channelName);if(!Y){this.v(Z);return}const ue=Z.id,we=Y.listen(this.j,Z.name,Z.arg)(Se=>this.m({id:ue,data:Se,type:204}));this.d.set(Z.id,we)}u(Z){const Y=this.d.get(Z.id);Y&&(Y.dispose(),this.d.delete(Z.id))}v(Z){let Y=this.g.get(Z.channelName);Y||(Y=[],this.g.set(Z.channelName,Y));const ue=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:Z,timeoutTimer:ue})}w(Z){const Y=this.g.get(Z);if(Y){for(const ue of Y)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.s(ue.request);break;case 102:this.t(ue.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$5h=D;var p;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class k{constructor(Z,Y=null){this.l=Z,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ue=>this.s(ue)),this.j=Y}getChannel(Z){const Y=this;return{call(ue,te,we){return Y.a?Promise.reject(new b.$5):Y.m(Z,ue,te,we)},listen(ue,te){return Y.a?$.Event.None:Y.o(Z,ue,te)}}}m(Z,Y,ue,te=R.CancellationToken.None){const we=this.g++,_={id:we,type:100,channelName:Z,name:Y,arg:ue};if(te.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise(($e,Pe)=>{if(te.isCancellationRequested)return Pe(new b.$5);const se=()=>{const ie=me=>{switch(me.type){case 201:this.f.delete(we),$e(me.data);break;case 202:{this.f.delete(we);const be=new Error(me.data.message);be.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,be.name=me.data.name,Pe(be);break}case 203:this.f.delete(we),Pe(me.data);break}};this.f.set(we,ie),this.p(_)};let re=null;this.b===a.Idle?se():(re=(0,N.$dh)(ie=>this.u()),re.then(()=>{re=null,se()}));const oe=()=>{re?(re.cancel(),re=null):this.p({id:we,type:101}),Pe(new b.$5)},G=te.onCancellationRequested(oe);U=(0,S.$Rc)((0,S.$Sc)(oe),G),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Z,Y,ue){const te=this.g++,Se={id:te,type:102,channelName:Z,name:Y,arg:ue};let _=null;const U=new $.$be({onWillAddFirstListener:()=>{_=(0,N.$dh)($e=>this.u()),_.then(()=>{_=null,this.d.add(U),this.p(Se)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(U),this.p({id:te,type:103}))}}),ne=$e=>U.fire($e.data);return this.f.set(te,ne),U.event}p(Z){switch(Z.type){case 100:case 102:{const Y=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(Y,Z.id,0,`${v(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const Y=this.q([Z.type,Z.id]);this.j?.logOutgoing(Y,Z.id,0,v(Z.type));return}}}q(Z,Y=void 0){const ue=new t;return w(ue,Z),w(ue,Y),this.r(ue.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const Y=new o(Z),ue=d(Y),te=d(Y),we=ue[0];switch(we){case 200:return this.j?.logIncoming(Z.byteLength,0,0,f(we)),this.t({type:ue[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,ue[1],0,f(we),te),this.t({type:ue[0],id:ue[1],data:te})}}t(Z){if(Z.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$6h=k,Je([M.$Uh],k.prototype,"onDidInitializePromise",null);class y{get connections(){const Z=[];return this.f.forEach(Y=>Z.push(Y)),Z}constructor(Z,Y,ue){this.a=new Map,this.f=new Set,this.g=new $.$be,this.onDidAddConnection=this.g.event,this.h=new $.$be,this.onDidRemoveConnection=this.h.event,this.j=new S.$Tc,this.j.add(Z(({protocol:te,onDidClientDisconnect:we})=>{const Se=$.Event.once(te.onMessage);this.j.add(Se(_=>{const U=new o(_),ne=d(U),$e=new D(te,ne,Y,ue),Pe=new k(te,Y);this.a.forEach((re,oe)=>$e.registerChannel(oe,re));const se={channelServer:$e,channelClient:Pe,ctx:ne};this.f.add(se),this.g.fire(se),this.j.add(we(()=>{$e.dispose(),Pe.dispose(),this.f.delete(se),this.h.fire(se)}))}))}))}getChannel(Z,Y){const ue=this;return{call(te,we,Se){let _;if((0,m.$fg)(Y)){const ne=(0,l.$4b)(ue.connections.filter(Y));_=ne?Promise.resolve(ne):$.Event.toPromise($.Event.filter(ue.onDidAddConnection,Y))}else _=Y.routeCall(ue,te,we);const U=_.then(ne=>ne.channelClient.getChannel(Z));return I(U).call(te,we,Se)},listen(te,we){if((0,m.$fg)(Y))return ue.k(Z,Y,te,we);const Se=Y.routeEvent(ue,te,we).then(_=>_.channelClient.getChannel(Z));return I(Se).listen(te,we)}}}k(Z,Y,ue,te){const we=this;let Se;const _=new $.$be({onWillAddFirstListener:()=>{Se=new S.$Tc;const U=new $.$he,ne=new Map,$e=se=>{const oe=se.channelClient.getChannel(Z).listen(ue,te),G=U.add(oe);ne.set(se,G)},Pe=se=>{const re=ne.get(se);re&&(re.dispose(),ne.delete(se))};we.connections.filter(Y).forEach($e),$.Event.filter(we.onDidAddConnection,Y)($e,void 0,Se),we.onDidRemoveConnection(Pe,void 0,Se),U.event(_.fire,_,Se),Se.add(U)},onDidRemoveLastListener:()=>{Se?.dispose(),Se=void 0}});return _.event}registerChannel(Z,Y){this.a.set(Z,Y);for(const ue of this.f)ue.channelServer.registerChannel(Z,Y)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$7h=y;class P{constructor(Z,Y,ue=null){const te=new t;w(te,Y),Z.send(te.buffer),this.a=new k(Z,ue),this.d=new D(Z,Y,ue)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,Y){this.d.registerChannel(Z,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$8h=P;function I(x){return{call(Z,Y,ue){return x.then(te=>te.call(Z,Y,ue))},listen(Z,Y){const ue=new $.$ke;return x.then(te=>ue.input=te.listen(Z,Y)),ue.event}}}function F(x){let Z=!1;return{call(Y,ue,te){return Z?x.call(Y,ue,te):(0,N.$rh)(0).then(()=>Z=!0).then(()=>x.call(Y,ue,te))},listen(Y,ue){if(Z)return x.listen(Y,ue);const te=new $.$ke;return(0,N.$rh)(0).then(()=>Z=!0).then(()=>te.input=x.listen(Y,ue)),te.event}}}class j{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const Y of Z.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await $.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$$h=j;var z;(function(x){function Z(we,Se,_){const U=we,ne=_&&_.disableMarshalling,$e=new Map;for(const Pe in U)ue(Pe)&&$e.set(Pe,$.Event.buffer(U[Pe],!0,void 0,Se));return new class{listen(Pe,se,re){const oe=$e.get(se);if(oe)return oe;const G=U[se];if(typeof G=="function"){if(te(se))return G.call(U,re);if(ue(se))return $e.set(se,$.Event.buffer(U[se],!0,void 0,Se)),$e.get(se)}throw new b.$bb(`Event not found: ${se}`)}call(Pe,se,re){const oe=U[se];if(typeof oe=="function"){if(!ne&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,A.$Zh)(re[ie]);let G=oe.apply(U,re);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$bb(`Method not found: ${se}`)}}}x.fromService=Z;function Y(we,Se){const _=Se&&Se.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return Se?.properties?.has(ne)?Se.properties.get(ne):te(ne)?function($e){return we.listen(ne,$e)}:ue(ne)?we.listen(ne):async function(...$e){let Pe;Se&&!(0,m.$ag)(Se.context)?Pe=[Se.context,...$e]:Pe=$e;const se=await we.call(ne,Pe);return _?se:(0,A.$Zh)(se)};throw new b.$bb(`Property not found: ${String(ne)}`)}})}x.toService=Y;function ue(we){return we[0]==="o"&&we[1]==="n"&&C.$sf(we.charCodeAt(2))}function te(we){return/^onDynamic/.test(we)&&C.$sf(we.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const Z=x.toString();if(Z!=="[object Object]")return Z}return x}function B(x){return Array.isArray(x)?x.map(T):T(x)}function W(x,Z,Y,ue,te,we,Se){Se=B(Se);const _=O[te],U=_[ue%_.length];let ne=[`%c[${x}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(we)?(ne=ne.concat(Se),ne.push(")")):ne.push(Se),console.log.apply(console,ne)}class X{constructor(Z,Y){this.d=Z,this.f=Y,this.a=0,this.b=0}logOutgoing(Z,Y,ue,te,we){this.b+=Z,W(this.d,this.b,Z,Y,ue,te,we)}logIncoming(Z,Y,ue,te,we){this.a+=Z,W(this.f,this.a,Z,Y,ue,te,we)}}e.$_h=X}),define(ke[82],Ee([1,0,21,4,3,81]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.ProtocolConstants=e.$ai=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(c){c.enableDiagnostics=!1,c.records=[];const r=new WeakMap;let w=0;function d(p,k){if(!r.has(p)){const y=String(++w);r.set(p,y)}return r.get(p)}function D(p,k,y,P){if(!c.enableDiagnostics)return;const I=d(p,k);if(P instanceof l.$Ce||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=l.$Ce.alloc(P.byteLength);F.set(P),c.records.push({timestamp:Date.now(),id:I,label:k,type:y,buff:F})}else c.records.push({timestamp:Date.now(),id:I,label:k,type:y,data:P})}c.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var $;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let S=null;function A(){return S||(S=l.$Ce.alloc(0)),S}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,w){if(r===0)return A();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const k=this.a[0];return w&&(this.a.shift(),this.b-=r),k}if(this.a[0].byteLength>r){const k=this.a[0].slice(0,r);return w&&(this.a[0]=this.a[0].slice(r),this.b-=r),k}const d=l.$Ce.alloc(r);let D=0,p=0;for(;r>0;){const k=this.a[p];if(k.byteLength>r){const y=k.slice(0,r);d.set(y,D),D+=r,w&&(this.a[p]=k.slice(r),this.b-=r),r-=r}else d.set(k,D),D+=k.byteLength,w?(this.a.shift(),this.b-=k.byteLength):p++,r-=k.byteLength}return d}}e.$ai=C;var m;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})(m||(m={}));function E(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class u{constructor(r,w,d,D){this.type=r,this.id=w,this.ack=d,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends L.$Uc{constructor(r){super(),this.f=this.B(new N.$be),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new C,this.B(this.a.onData(w=>this.acceptChunk(w))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const w=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=w.readUInt32BE(9),this.g.messageType=w.readUInt8(0),this.g.id=w.readUInt32BE(1),this.g.ack=w.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const d=this.g.messageType,D=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",w),this.f.fire(new u(d,D,p,w)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const w=l.$Ce.alloc(13);w.writeUInt8(r.type,0),w.writeUInt32BE(r.id,1),w.writeUInt32BE(r.ack,5),w.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(w,r.data)}g(r,w){const d=this.f===0;return this.d.push(r,w),this.f+=r.byteLength+w.byteLength,d}h(){const r=l.$Ce.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,w){this.g(r,w)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class n extends L.$Uc{constructor(r){super(),this.f=new N.$be,this.onMessage=this.f.event,this.g=new N.$be,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new a(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(w=>{w.type===1&&this.f.fire(w.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new u(1,0,0,r))}}e.$bi=n;class i extends R.$8h{static fromSocket(r,w){return new i(new n(r),w)}get onDidDispose(){return this.b.onDidDispose}constructor(r,w,d=null){super(r,w,d),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.$ci=i;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$be({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.$di=s;class o{constructor(r){this.data=r,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let r=0,w=this.a;for(;w;)w=w.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let w=0,d=this.a;for(;d;)r[w++]=d.data,d=d.next;return r}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const w=new o(r);if(!this.a){this.a=w,this.b=w;return}this.b.next=w,this.b=w}}class g{static{this.a=10}static{this.b=null}static getInstance(){return g.b||(g.b=new g),g.b}constructor(){this.c=[];const r=Date.now();for(let w=0;w<g.a;w++)this.c[w]=r-1e3*w;setInterval(()=>{for(let w=g.a;w>=1;w--)this.c[w]=this.c[w-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),w=(1+g.a)*1e3;let d=0;for(let D=0;D<g.a;D++)r-this.c[D]<=w&&d++;return 1-d/g.a}hasHighLoad(){return this.d()>=.5}}class h{get unacknowledgedCount(){return this.c-this.d}constructor(r){this.u=new s,this.onControlMessage=this.u.event,this.v=new s,this.onMessage=this.v.event,this.w=new s,this.onDidDispose=this.w.event,this.x=new s,this.onSocketClose=this.x.event,this.y=new s,this.onSocketTimeout=this.y.event,this.s=r.loadEstimator??g.getInstance(),this.t=r.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=r.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),r.initialChunk&&this.q.acceptChunk(r.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const r=new u(5,0,0,A());this.p.write(r),this.p.flush()}sendPause(){const r=new u(7,0,0,A());this.p.write(r)}sendResume(){const r=new u(8,0,0,A());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,w){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),this.q.acceptChunk(w)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new u(3,0,this.h,A());this.p.write(r);const w=this.b.toArray();for(let d=0,D=w.length;d<D;d++)this.p.write(w[d]);this.B()}acceptDisconnect(){this.w.fire()}z(r){if(r.ack>this.d){this.d=r.ack;do{const w=this.b.peek();if(w&&w.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const w=Date.now();w-this.m>1e4&&(this.m=w,this.p.write(new u(6,0,0,A())))}else this.g=r.id,this.j=Date.now(),this.A(),this.v.fire(r.data);break}case 2:{this.u.fire(r.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const w=this.b.toArray();for(let d=0,D=w.length;d<D;d++)this.p.write(w[d]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const w=++this.c;this.h=this.g;const d=new u(1,w,this.h,r);this.b.push(d),this.a||(this.p.write(d),this.B())}sendControl(r){const w=new u(2,0,0,r);this.p.write(w)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),w=Date.now()-r.writtenTime,d=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(w>=2e4&&d>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:w,timeSinceLastReceivedSomeData:d});return}const p=Math.max(2e4-w,2e4-d,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new u(3,0,this.h,A());this.p.write(r)}D(){this.h=this.g;const r=new u(9,0,this.h,A());this.p.write(r)}}e.$ei=h}),define(ke[194],Ee([1,0,53,8,21,22,192,13,4,3,24,105,102,81]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class v extends E.$5h{constructor(a){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>L.$Ce.wrap(Buffer.from(n,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$Rq=v;class u{constructor(a,n){this.i=a,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$be,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$nh(i),this.d=null,this.f=null}getChannel(a){const n=this;return{call(i,s,o){return n.k(a,i,s,o)},listen(i,s){return n.l(a,i,s)}}}k(a,n,i,s=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const o=this.n(a),t=(0,N.$dh)(c=>o.call(n,i,c)),g=s.onCancellationRequested(()=>t.cancel()),h=(0,S.$Sc)(()=>t.cancel());return this.c.add(h),t.finally(()=>{g.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,n,i){if(!this.b)return $.Event.None;this.b.cancel();let s;const o=new $.$be({onWillAddFirstListener:()=>{s=this.n(a).listen(n,i)(o.fire,o),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$Wn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(w=>!/^--inspect(-brk)?=/.test(w)).filter(w=>!w.startsWith("--vscode-"))),(0,m.$hm)(n.env),this.d=(0,l.fork)(this.i,a,n);const i=new $.$be,o=$.Event.fromNodeEventEmitter(this.d,"message",w=>w)(w=>{if((0,M.$Nq)(w)){(0,M.log)(w,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$Ce.wrap(Buffer.from(w,"base64")))}),t=this.j.useQueue?(0,C.$jm)(this.d):this.d,g=w=>this.d&&this.d.connected&&t.send(w.buffer.toString("base64")),h=i.event,c={send:g,onMessage:h};this.f=new E.$6h(c);const r=()=>this.o();process.once("exit",r),this.d.on("error",w=>console.warn('IPC "'+this.j.serverName+'" errored with '+w)),this.d.on("exit",(w,d)=>{process.removeListener("exit",r),o.dispose(),this.c.forEach(D=>(0,S.$Pc)(D)),this.c.clear(),w!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+w+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:w,signal:d})})}return this.f}n(a){let n=this.g.get(a);return n||(n=this.m.getChannel(a),this.g.set(a,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sq=u}),define(ke[195],Ee([1,0,8,4,3,58,18]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.StorageState=e.StorageHint=void 0,e.$Pp=$;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const E=m;return E?.changed instanceof Map||E?.deleted instanceof Set}var S;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(S||(e.StorageState=S={}));class A extends L.$Uc{static{this.a=100}constructor(E,v=Object.create(null)){super(),this.r=E,this.s=v,this.b=this.B(new N.$ee),this.onDidChangeStorage=this.b.event,this.c=S.None,this.f=new Map,this.g=this.B(new l.$oh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((v,u)=>this.w(u,v)),E.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(E,v){if(this.c===S.Closed)return;let u=!1;(0,M.$ag)(v)?u=this.f.delete(E):this.f.get(E)!==v&&(this.f.set(E,v),u=!0),u&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===S.None&&(this.c=S.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,v){const u=this.f.get(E);return(0,M.$ag)(u)?v:u}getBoolean(E,v){const u=this.get(E);return(0,M.$ag)(u)?v:u==="true"}getNumber(E,v){const u=this.get(E);return(0,M.$ag)(u)?v:parseInt(u,10)}getObject(E,v){const u=this.get(E);return(0,M.$ag)(u)?v:(0,R.$Yh)(u)}async set(E,v,u=!1){if(this.c===S.Closed)return;if((0,M.$ag)(v))return this.delete(E,u);const f=(0,M.$6f)(v)||Array.isArray(v)?(0,R.$Xh)(v):String(v);if(this.f.get(E)!==f)return this.f.set(E,f),this.j.set(E,f),this.h.delete(E),this.b.fire({key:E,external:u}),this.D()}async delete(E,v=!1){if(!(this.c===S.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:v}),this.D()}async optimize(){if(this.c!==S.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=S.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Qp=A;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((v,u)=>this.a.set(u,v)),E.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Rp=C}),define(ke[196],Ee([1,0,14,11,21]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=A,e.$ut=C;let R;function M(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let S;function A(){return S||(S=N.$D()?M():$()),S}function C(v,u,f){const a=new Uint16Array(v.buffer,u,f);return f>0&&(a[0]===65279||a[0]===65534)?m(v,u,f):M().decode(a)}function m(v,u,f){const a=[];let n=0;for(let i=0;i<f;i++){const s=L.$Ee(v,u);u+=2,a[n++]=String.fromCharCode(s)}return a.join("")}class E{constructor(u){this.a=u|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const u=new Uint16Array(this.b.buffer,0,this.d);return A().decode(u)}f(){const u=this.e();this.d=0,this.c===null?this.c=[u]:this.c[this.c.length]=u}appendCharCode(u){const f=this.a-this.d;f<=1&&(f===0||l.$xf(u))&&this.f(),this.b[this.d++]=u}appendASCIICharCode(u){this.d===this.a&&this.f(),this.b[this.d++]=u}appendString(u){const f=u.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=u;return}for(let a=0;a<f;a++)this.b[this.d++]=u.charCodeAt(a)}}e.$vt=E}),define(ke[197],Ee([1,0,21,196]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=M;function L($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,A,C,m){this.oldPosition=S,this.oldText=A,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(S){return 4+2*S.length}static c(S,A,C){const m=A.length;l.$He(S,m,C),C+=4;for(let E=0;E<m;E++)l.$Fe(S,A.charCodeAt(E),C),C+=2;return C}static d(S,A){const C=l.$Ge(S,A);return A+=4,(0,N.$ut)(S,A,C)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(S,A){return l.$He(S,this.oldPosition,A),A+=4,l.$He(S,this.newPosition,A),A+=4,A=R.c(S,this.oldText,A),A=R.c(S,this.newText,A),A}static read(S,A,C){const m=l.$Ge(S,A);A+=4;const E=l.$Ge(S,A);A+=4;const v=R.d(S,A);A+=R.a(v);const u=R.d(S,A);return A+=R.a(u),C.push(new R(m,v,E,u)),A}}e.$wt=R;function M($,S){return $===null||$.length===0?S:new b($,S).compress()}class b{constructor(S,A){this.a=S,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let S=0,A=0,C=this.n(S),m=this.l(A);for(;S<this.f||A<this.h;){if(C===null){this.k(m),m=this.l(++A);continue}if(m===null){this.m(C),C=this.n(++S);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++A);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++S);continue}if(m.oldPosition<C.newPosition){const[a,n]=b.r(m,C.newPosition-m.oldPosition);this.k(a),m=n;continue}if(C.newPosition<m.oldPosition){const[a,n]=b.q(C,m.oldPosition-C.newPosition);this.m(a),C=n;continue}let u,f;if(m.oldEnd===C.newEnd)u=C,f=m,C=this.n(++S),m=this.l(++A);else if(m.oldEnd<C.newEnd){const[a,n]=b.q(C,m.oldLength);u=a,f=m,C=n,m=this.l(++A)}else{const[a,n]=b.r(m,C.newLength);u=C,f=a,C=this.n(++S),m=n}this.d[this.e++]=new R(u.oldPosition,u.oldText,f.newPosition,f.newText),this.g+=u.newLength-u.oldLength,this.j+=f.newLength-f.oldLength}const E=b.s(this.d);return b.t(E)}k(S){this.d[this.e++]=b.o(this.g,S),this.j+=S.newLength-S.oldLength}l(S){return S<this.h?this.c[S]:null}m(S){this.d[this.e++]=b.p(this.j,S),this.g+=S.newLength-S.oldLength}n(S){return S<this.f?this.a[S]:null}static o(S,A){return new R(A.oldPosition-S,A.oldText,A.newPosition,A.newText)}static p(S,A){return new R(A.oldPosition,A.oldText,A.newPosition+S,A.newText)}static q(S,A){const C=S.newText.substr(0,A),m=S.newText.substr(A);return[new R(S.oldPosition,S.oldText,S.newPosition,C),new R(S.oldEnd,"",S.newPosition+A,m)]}static r(S,A){const C=S.oldText.substr(0,A),m=S.oldText.substr(A);return[new R(S.oldPosition,C,S.newPosition,S.newText),new R(S.oldPosition+A,m,S.newEnd,"")]}static s(S){if(S.length===0)return S;const A=[];let C=0,m=S[0];for(let E=1;E<S.length;E++){const v=S[E];m.oldEnd===v.oldPosition?m=new R(m.oldPosition,m.oldText+v.oldText,m.newPosition,m.newText+v.newText):(A[C++]=m,m=v)}return A[C++]=m,A}static t(S){if(S.length===0)return S;const A=[];let C=0;for(let m=0;m<S.length;m++){const E=S[m];E.oldText!==E.newText&&(A[C++]=E)}return A}}}),define(ke[198],Ee([1,0,35,17]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=L,e.$Vt=R;function L(M,b,$,S,A,C){if(Array.isArray(M)){let m=0;for(const E of M){const v=L(E,b,$,S,A,C);if(v===10)return v;v>m&&(m=v)}return m}else{if(typeof M=="string")return S?M==="*"?5:M===$?10:0:0;if(M){const{language:m,pattern:E,scheme:v,hasAccessToAllModels:u,notebookType:f}=M;if(!S&&!u)return 0;f&&A&&(b=A);let a=0;if(v)if(v===b.scheme)a=10;else if(v==="*")a=5;else return 0;if(m)if(m===$)a=10;else if(m==="*")a=Math.max(a,5);else return 0;if(f)if(f===C)a=10;else if(f==="*"&&C!==void 0)a=Math.max(a,5);else return 0;if(E){let n;if(typeof E=="string"?n=E:n={...E,base:(0,N.$ic)(E.base)},n===b.fsPath||(0,l.$jk)(n,b.fsPath))a=10;else return 0}return a}else return 0}}function R(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(R):!!M.notebookType}}),define(ke[199],Ee([1,0,4,14,29,79,130,174,197,3]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class A extends S.$Uc{constructor(m,E,v,u,f,a,n){super(),this.m=this.B(new l.$be),this.onDidChangeContent=this.m.event,this.f=E,this.j=!a,this.g=u,this.h=f,this.c=new M.$KC(m,v,n)}equals(m){return!(m instanceof A)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,E){return this.c.getOffsetAt(m,E)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,E){const v=m+E,u=this.getPositionAt(m),f=this.getPositionAt(v);return new L.$kt(u.lineNumber,u.column,f.lineNumber,f.column)}getValueInRange(m,E=0){if(m.isEmpty())return"";const v=this.n(E);return this.c.getValueInRange(m,v)}getValueLengthInRange(m,E=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const v=this.getOffsetAt(m.startLineNumber,m.startColumn),u=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const a=this.n(E),n=this.getEOL();if(a.length!==n.length){const i=a.length-n.length,s=m.endLineNumber-m.startLineNumber;f=i*s}return u-v+f}getCharacterCountInRange(m,E=0){if(this.j){let v=0;const u=m.startLineNumber,f=m.endLineNumber;for(let a=u;a<=f;a++){const n=this.getLineContent(a),i=a===u?m.startColumn-1:0,s=a===f?m.endColumn-1:n.length;for(let o=i;o<s;o++)N.$xf(n.charCodeAt(o))?(v=v+1,o=o+1):v=v+1}return v+=this.n(E).length*(f-u),v}return this.getValueLengthInRange(m,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,E){return this.c.getLineCharCode(m,E)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const E=N.$if(this.getLineContent(m));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(m){const E=N.$kf(this.getLineContent(m));return E===-1?0:E+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,E,v){let u=this.g,f=this.h,a=this.j,n=!0,i=[];for(let r=0;r<m.length;r++){const w=m[r];n&&w._isTracked&&(n=!1);const d=w.range;if(w.text){let P=!0;a||(P=!N.$If(w.text),a=P),!u&&P&&(u=N.$Hf(w.text)),!f&&P&&(f=N.$Kf(w.text))}let D="",p=0,k=0,y=0;if(w.text){let P;[p,k,y,P]=(0,b.$Nt)(w.text);const I=this.getEOL();P===0||P===(I===`\r
`?2:1)?D=w.text:D=w.text.replace(/\r\n|\r|\n/g,I)}i[r]={sortIndex:r,identifier:w.identifier||null,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d),text:D,eolCount:p,firstLineLength:k,lastLineLength:y,forceMoveMarkers:!!w.forceMoveMarkers,isAutoWhitespaceEdit:w.isAutoWhitespaceEdit||!1}}i.sort(A.u);let s=!1;for(let r=0,w=i.length-1;r<w;r++){const d=i[r].range.getEndPosition(),D=i[r+1].range.getStartPosition();if(D.isBeforeOrEqual(d)){if(D.isBefore(d))throw new Error("Overlapping ranges are not allowed!");s=!0}}n&&(i=this.s(i));const o=v||E?A._getInverseEditRanges(i):[],t=[];if(E)for(let r=0;r<i.length;r++){const w=i[r],d=o[r];if(w.isAutoWhitespaceEdit&&w.range.isEmpty())for(let D=d.startLineNumber;D<=d.endLineNumber;D++){let p="";D===d.startLineNumber&&(p=this.getLineContent(w.range.startLineNumber),N.$if(p)!==-1)||t.push({lineNumber:D,oldContent:p})}}let g=null;if(v){let r=0;g=[];for(let w=0;w<i.length;w++){const d=i[w],D=o[w],p=this.getValueInRange(d.range),k=d.rangeOffset+r;r+=d.text.length-p.length,g[w]={sortIndex:d.sortIndex,identifier:d.identifier,range:D,text:p,textChange:new $.$wt(d.rangeOffset,p,k,d.text)}}s||g.sort((w,d)=>w.sortIndex-d.sortIndex)}this.g=u,this.h=f,this.j=a;const h=this.t(i);let c=null;if(E&&t.length>0){t.sort((r,w)=>w.lineNumber-r.lineNumber),c=[];for(let r=0,w=t.length;r<w;r++){const d=t[r].lineNumber;if(r>0&&t[r-1].lineNumber===d)continue;const D=t[r].oldContent,p=this.getLineContent(d);p.length===0||p===D||N.$if(p)!==-1||c.push(d)}}return this.m.fire(),new R.$zv(g,h,c)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let E=!1;const v=m[0].range,u=m[m.length-1].range,f=new L.$kt(v.startLineNumber,v.startColumn,u.endLineNumber,u.endColumn);let a=v.startLineNumber,n=v.startColumn;const i=[];for(let h=0,c=m.length;h<c;h++){const r=m[h],w=r.range;E=E||r.forceMoveMarkers,i.push(this.getValueInRange(new L.$kt(a,n,w.startLineNumber,w.startColumn))),r.text.length>0&&i.push(r.text),a=w.endLineNumber,n=w.endColumn}const s=i.join(""),[o,t,g]=(0,b.$Nt)(s);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:s,eolCount:o,firstLineLength:t,lastLineLength:g,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(m){m.sort(A.w);const E=[];for(let v=0;v<m.length;v++){const u=m[v],f=u.range.startLineNumber,a=u.range.startColumn,n=u.range.endLineNumber,i=u.range.endColumn;if(f===n&&a===i&&u.text.length===0)continue;u.text?(this.c.delete(u.rangeOffset,u.rangeLength),this.c.insert(u.rangeOffset,u.text,!0)):this.c.delete(u.rangeOffset,u.rangeLength);const s=new L.$kt(f,a,n,i);E.push({range:s,rangeLength:u.rangeLength,text:u.text,rangeOffset:u.rangeOffset,forceMoveMarkers:u.forceMoveMarkers})}return E}findMatchesLineByLine(m,E,v,u){return this.c.findMatchesLineByLine(m,E,v,u)}getPieceTree(){return this.c}static _getInverseEditRange(m,E){const v=m.startLineNumber,u=m.startColumn,[f,a,n]=(0,b.$Nt)(E);let i;if(E.length>0){const s=f+1;s===1?i=new L.$kt(v,u,v,u+a):i=new L.$kt(v,u,v+s-1,n+1)}else i=new L.$kt(v,u,v,u);return i}static _getInverseEditRanges(m){const E=[];let v=0,u=0,f=null;for(let a=0,n=m.length;a<n;a++){const i=m[a];let s,o;f?f.range.endLineNumber===i.range.startLineNumber?(s=v,o=u+(i.range.startColumn-f.range.endColumn)):(s=v+(i.range.startLineNumber-f.range.endLineNumber),o=i.range.startColumn):(s=i.range.startLineNumber,o=i.range.startColumn);let t;if(i.text.length>0){const g=i.eolCount+1;g===1?t=new L.$kt(s,o,s,o+i.firstLineLength):t=new L.$kt(s,o,s+g-1,i.lastLineLength+1)}else t=new L.$kt(s,o,s,o);v=t.endLineNumber,u=t.endColumn,E.push(t),f=i}return E}static u(m,E){const v=L.$kt.compareRangesUsingEnds(m.range,E.range);return v===0?m.sortIndex-E.sortIndex:v}static w(m,E){const v=L.$kt.compareRangesUsingEnds(m.range,E.range);return v===0?E.sortIndex-m.sortIndex:-v}}e.$LC=A}),define(ke[200],Ee([1,0,14,130,199]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=void 0;class R{constructor($,S,A,C,m,E,v,u,f){this.a=$,this.b=S,this.c=A,this.d=C,this.e=m,this.f=E,this.g=v,this.h=u,this.j=f}k($){const S=this.c+this.d+this.e,A=this.c+this.e;return S===0?$===1?`
`:`\r
`:A>S/2?`\r
`:`
`}create($){const S=this.k($),A=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let m=0,E=A.length;m<E;m++){const v=A[m].buffer.replace(/\r\n|\r|\n/g,S),u=(0,N.$GC)(v);A[m]=new N.$JC(v,u)}const C=new L.$LC(A,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&l.$Rf($)&&(this.b=l.$Qf,$=$.substr(1));const S=$.charCodeAt($.length-1);S===13||S>=55296&&S<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=S):(this.m($,!1),this.c=!1,this.d=S)}m($,S){!S&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const S=(0,N.$HC)(this.e,$);this.a.push(new N.$JC($,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=l.$Hf($)),this.k||(this.k=l.$Kf($)))}finish($=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const S=(0,N.$GC)($.buffer);$.lineStarts=S,this.d===13&&this.f++}}}e.$MC=M}),define(ke[134],Ee([1,0,21,11]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbb=$,e.$ubb=A;var L;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(L||(L={}));function R(C){for(let m=0,E=C.length;m<E;m+=4){const v=C[m+0],u=C[m+1],f=C[m+2],a=C[m+3];C[m+0]=a,C[m+1]=f,C[m+2]=u,C[m+3]=v}}function M(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||R(m),l.$Ce.wrap(m)}function b(C){const m=C.buffer;if(N.$D()||R(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const E=new Uint8Array(m.byteLength);return E.set(m),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function $(C){const m=new Uint32Array(S(C));let E=0;if(m[E++]=C.id,C.type==="full")m[E++]=1,m[E++]=C.data.length,m.set(C.data,E),E+=C.data.length;else{m[E++]=2,m[E++]=C.deltas.length;for(const v of C.deltas)m[E++]=v.start,m[E++]=v.deleteCount,v.data?(m[E++]=v.data.length,m.set(v.data,E),E+=v.data.length):m[E++]=0}return M(m)}function S(C){let m=0;if(m+=2,C.type==="full")m+=1+C.data.length;else{m+=1,m+=3*C.deltas.length;for(const E of C.deltas)E.data&&(m+=E.data.length)}return m}function A(C){const m=b(C);let E=0;const v=m[E++];if(m[E++]===1){const n=m[E++],i=m.subarray(E,E+n);return E+=n,{id:v,type:"full",data:i}}const f=m[E++],a=[];for(let n=0;n<f;n++){const i=m[E++],s=m[E++],o=m[E++];let t;o>0&&(t=m.subarray(E,E+o),E+=o),a[n]={start:i,deleteCount:s,data:t}}return{id:v,type:"delta",deltas:a}}}),define(ke[201],Ee([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Ee([1,0,19,24,11,177,129,201]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=f,e.clampedInt=n,e.clampedFloat=s,e.stringSet=g,e.cursorStyleToString=y,e.filterValidationDecorations=be;var $;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=S;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class C{constructor(ce,Re,Ge,Me){this.id=ce,this.name=Re,this.defaultValue=Ge,this.schema=Me}applyUpdate(ce,Re){return E(ce,Re)}compute(ce,Re,Ge){return Ge}}class m{constructor(ce,Re){this.newValue=ce,this.didChange=Re}}e.ApplyUpdateResult=m;function E(ae,ce){if(typeof ae!="object"||typeof ce!="object"||!ae||!ce)return new m(ce,ae!==ce);if(Array.isArray(ae)||Array.isArray(ce)){const Ge=Array.isArray(ae)&&Array.isArray(ce)&&l.$ub(ae,ce);return new m(ce,!Ge)}let Re=!1;for(const Ge in ce)if(ce.hasOwnProperty(Ge)){const Me=E(ae[Ge],ce[Ge]);Me.didChange&&(ae[Ge]=Me.newValue,Re=!0)}return new m(ae,Re)}class v{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Re){return E(ce,Re)}validate(ce){return this.defaultValue}}class u{constructor(ce,Re,Ge,Me){this.id=ce,this.name=Re,this.defaultValue=Ge,this.schema=Me}applyUpdate(ce,Re){return E(ce,Re)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Re,Ge){return Ge}}function f(ae,ce){return typeof ae>"u"?ce:ae==="false"?!1:!!ae}class a extends u{constructor(ce,Re,Ge,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Ge),super(ce,Re,Ge,Me)}validate(ce){return f(ce,this.defaultValue)}}function n(ae,ce,Re,Ge){if(typeof ae>"u")return ce;let Me=parseInt(ae,10);return isNaN(Me)?ce:(Me=Math.max(Re,Me),Me=Math.min(Ge,Me),Me|0)}class i extends u{static clampedInt(ce,Re,Ge,Me){return n(ce,Re,Ge,Me)}constructor(ce,Re,Ge,Me,tt,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Ge,ht.minimum=Me,ht.maximum=tt),super(ce,Re,Ge,ht),this.minimum=Me,this.maximum=tt}validate(ce){return i.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function s(ae,ce,Re,Ge){if(typeof ae>"u")return ce;const Me=o.float(ae,ce);return o.clamp(Me,Re,Ge)}class o extends u{static clamp(ce,Re,Ge){return ce<Re?Re:ce>Ge?Ge:ce}static float(ce,Re){if(typeof ce=="number")return ce;if(typeof ce>"u")return Re;const Ge=parseFloat(ce);return isNaN(Ge)?Re:Ge}constructor(ce,Re,Ge,Me,tt){typeof tt<"u"&&(tt.type="number",tt.default=Ge),super(ce,Re,Ge,tt),this.validationFn=Me}validate(ce){return this.validationFn(o.float(ce,this.defaultValue))}}class t extends u{static string(ce,Re){return typeof ce!="string"?Re:ce}constructor(ce,Re,Ge,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Ge),super(ce,Re,Ge,Me)}validate(ce){return t.string(ce,this.defaultValue)}}function g(ae,ce,Re,Ge){return typeof ae!="string"?ce:Ge&&ae in Ge?Ge[ae]:Re.indexOf(ae)===-1?ce:ae}class h extends u{constructor(ce,Re,Ge,Me,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Me,tt.default=Ge),super(ce,Re,Ge,tt),this.c=Me}validate(ce){return g(ce,this.defaultValue,this.c)}}class c extends C{constructor(ce,Re,Ge,Me,tt,ht,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=tt,wt.default=Me),super(ce,Re,Ge,wt),this.c=tt,this.d=ht}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function r(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class w extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Re,Ge){return Ge===0?ce.accessibilitySupport:Ge}}class d extends C{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{insertSpace:f(Re.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Re.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function p(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function y(ae){switch(ae){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function P(ae){switch(ae){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class I extends v{constructor(){super(142)}compute(ce,Re,Ge){const Me=["monaco-editor"];return Re.get(39)&&Me.push(Re.get(39)),ce.extraEditorClassName&&Me.push(ce.extraEditorClassName),Re.get(74)==="default"?Me.push("mouse-default"):Re.get(74)==="copy"&&Me.push("mouse-copy"),Re.get(111)&&Me.push("showUnused"),Re.get(140)&&Me.push("showDeprecated"),Me.join(" ")}}class F extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ce,Re,Ge){return Ge&&ce.emptySelectionClipboard}}class j extends C{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:b.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:b.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{cursorMoveOnType:f(Re.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":g(Re.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":g(Re.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Re.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Re.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Re.loop,this.defaultValue.loop)}}}class z extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"||ce.length===0?z.OFF:ce==="true"?z.ON:ce:ce?z.ON:z.OFF}}e.EditorFontLigatures=z;class O extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?O.OFF:ce==="true"?O.TRANSLATE:ce:ce?O.TRANSLATE:O.OFF}compute(ce,Re,Ge){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class T extends v{constructor(){super(50)}compute(ce,Re,Ge){return ce.fontInfo}}class B extends u{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ce){const Re=o.float(ce,this.defaultValue);return Re===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Re,6,100)}compute(ce,Re,Ge){return ce.fontInfo.fontSize}}class W extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(i.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class X extends C{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Re={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Re},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Re},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Re},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Re},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Re},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ge,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ge,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ge,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ge,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ge,description:b.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{multiple:g(Re.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Re.multipleDefinitions??g(Re.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Re.multipleTypeDefinitions??g(Re.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Re.multipleDeclarations??g(Re.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Re.multipleImplementations??g(Re.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Re.multipleReferences??g(Re.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Re.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Re.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Re.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Re.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Re.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends C{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:b.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),delay:i.clampedInt(Re.delay,this.defaultValue.delay,0,1e4),sticky:f(Re.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Re.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Re.above,this.defaultValue.above)}}}var Z;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(Z||(e.RenderMinimap=Z={}));class Y extends v{constructor(){super(145)}compute(ce,Re,Ge){return Y.computeLayout(Re,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Re=ce.height/ce.lineHeight,Ge=Math.floor(ce.paddingTop/ce.lineHeight);let Me=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Me=Math.max(Me,Re-1));const tt=(Ge+ce.viewLineCount+Me)/(ce.pixelRatio*ce.height),ht=Math.floor(ce.viewLineCount/tt);return{typicalViewportLineCount:Re,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Me,desiredRatio:tt,minimapLineCount:ht}}static c(ce,Re){const Ge=ce.outerWidth,Me=ce.outerHeight,tt=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const ht=Re.stableMinimapLayoutInput,wt=ht&&ce.outerHeight===ht.outerHeight&&ce.lineHeight===ht.lineHeight&&ce.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&ce.pixelRatio===ht.pixelRatio&&ce.scrollBeyondLastLine===ht.scrollBeyondLastLine&&ce.paddingTop===ht.paddingTop&&ce.paddingBottom===ht.paddingBottom&&ce.minimap.enabled===ht.minimap.enabled&&ce.minimap.side===ht.minimap.side&&ce.minimap.size===ht.minimap.size&&ce.minimap.showSlider===ht.minimap.showSlider&&ce.minimap.renderCharacters===ht.minimap.renderCharacters&&ce.minimap.maxColumn===ht.minimap.maxColumn&&ce.minimap.scale===ht.minimap.scale&&ce.verticalScrollbarWidth===ht.verticalScrollbarWidth&&ce.isViewportWrapping===ht.isViewportWrapping,Lt=ce.lineHeight,At=ce.typicalHalfwidthCharacterWidth,xt=ce.scrollBeyondLastLine,_t=ce.minimap.renderCharacters;let Pt=tt>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Vt=ce.minimap.maxColumn,Xt=ce.minimap.size,et=ce.minimap.side,si=ce.verticalScrollbarWidth,Zt=ce.viewLineCount,dt=ce.remainingWidth,vt=ce.isViewportWrapping,ti=_t?2:3;let Yt=Math.floor(tt*Me);const zt=Yt/tt;let gt=!1,Ut=!1,Wt=ti*Pt,Kt=Pt/tt,Ye=1;if(Xt==="fill"||Xt==="fit"){const{typicalViewportLineCount:Ft,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Gt,desiredRatio:ni,minimapLineCount:Nt}=Y.computeContainedMinimapLineCount({viewLineCount:Zt,scrollBeyondLastLine:xt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Me,lineHeight:Lt,pixelRatio:tt});if(Zt/Nt>1)gt=!0,Ut=!0,Pt=1,Wt=1,Kt=Pt/tt;else{let It=!1,St=Pt+1;if(Xt==="fit"){const pt=Math.ceil((ii+Zt+Gt)*Wt);vt&&wt&&dt<=Re.stableFitRemainingWidth?(It=!0,St=Re.stableFitMaxMinimapScale):It=pt>Yt}if(Xt==="fill"||It){gt=!0;const pt=Pt;Wt=Math.min(Lt*tt,Math.max(1,Math.floor(1/ni))),vt&&wt&&dt<=Re.stableFitRemainingWidth&&(St=Re.stableFitMaxMinimapScale),Pt=Math.min(St,Math.max(1,Math.floor(Wt/ti))),Pt>pt&&(Ye=Math.min(2,Pt/pt)),Kt=Pt/tt/Ye,Yt=Math.ceil(Math.max(Ft,ii+Zt+Gt)*Wt),vt?(Re.stableMinimapLayoutInput=ce,Re.stableFitRemainingWidth=dt,Re.stableFitMaxMinimapScale=Pt):(Re.stableMinimapLayoutInput=null,Re.stableFitRemainingWidth=0)}}}const ui=Math.floor(Vt*Kt),Ht=Math.min(ui,Math.max(0,Math.floor((dt-si-2)*Kt/(At+Kt)))+e.MINIMAP_GUTTER_WIDTH);let Bt=Math.floor(tt*Ht);const mt=Bt/tt;Bt=Math.floor(Bt*Ye);const Tt=_t?1:2,Rt=et==="left"?0:Ge-Ht-si;return{renderMinimap:Tt,minimapLeft:Rt,minimapWidth:Ht,minimapHeightIsEditorHeight:gt,minimapIsSampling:Ut,minimapScale:Pt,minimapLineHeight:Wt,minimapCanvasInnerWidth:Bt,minimapCanvasInnerHeight:Yt,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:zt}}static computeLayout(ce,Re){const Ge=Re.outerWidth|0,Me=Re.outerHeight|0,tt=Re.lineHeight|0,ht=Re.lineNumbersDigitCount|0,wt=Re.typicalHalfwidthCharacterWidth,Lt=Re.maxDigitWidth,At=Re.pixelRatio,xt=Re.viewLineCount,_t=ce.get(137),Pt=_t==="inherit"?ce.get(136):_t,Vt=Pt==="inherit"?ce.get(132):Pt,Xt=ce.get(135),et=Re.isDominatedByLongLines,si=ce.get(57),Zt=ce.get(68).renderType!==0,dt=ce.get(69),vt=ce.get(105),ti=ce.get(84),Yt=ce.get(73),zt=ce.get(103),gt=zt.verticalScrollbarSize,Ut=zt.verticalHasArrows,Wt=zt.arrowSize,Kt=zt.horizontalScrollbarSize,Ye=ce.get(43),ui=ce.get(110)!=="never";let Ht=ce.get(66);Ye&&ui&&(Ht+=16);let Bt=0;if(Zt){const li=Math.max(ht,dt);Bt=Math.round(li*Lt)}let mt=0;si&&(mt=tt*Re.glyphMarginDecorationLaneCount);let Tt=0,Rt=Tt+mt,Ft=Rt+Bt,ii=Ft+Ht;const Gt=Ge-mt-Bt-Ht;let ni=!1,Nt=!1,Ot=-1;Pt==="inherit"&&et?(ni=!0,Nt=!0):Vt==="on"||Vt==="bounded"?Nt=!0:Vt==="wordWrapColumn"&&(Ot=Xt);const It=Y.c({outerWidth:Ge,outerHeight:Me,lineHeight:tt,typicalHalfwidthCharacterWidth:wt,pixelRatio:At,scrollBeyondLastLine:vt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Yt,verticalScrollbarWidth:gt,viewLineCount:xt,remainingWidth:Gt,isViewportWrapping:Nt},Re.memory||new A);It.renderMinimap!==0&&It.minimapLeft===0&&(Tt+=It.minimapWidth,Rt+=It.minimapWidth,Ft+=It.minimapWidth,ii+=It.minimapWidth);const St=Gt-It.minimapWidth,pt=Math.max(1,Math.floor((St-gt-2)/wt)),Ct=Ut?Wt:0;return Nt&&(Ot=Math.max(1,pt),Vt==="bounded"&&(Ot=Math.min(Ot,Xt))),{width:Ge,height:Me,glyphMarginLeft:Tt,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:Re.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:Bt,decorationsLeft:Ft,decorationsWidth:Ht,contentLeft:ii,contentWidth:St,minimap:It,viewportColumn:pt,isWordWrapMinified:ni,isViewportWrapping:Nt,wrappingColumn:Ot,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Kt,overviewRuler:{top:Ct,width:gt,height:Me-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=Y;class ue extends C{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ce){return g(ce,"simple",["simple","advanced"])}compute(ce,Re,Ge){return Re.get(2)===2?"advanced":Ge}}var te;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(te||(e.ShowLightbulbIconMode=te={}));class we extends C{constructor(){const ce={enabled:te.On};super(65,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[te.Off,te.OnCode,te.On],default:ce.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:g(ce.enabled,this.defaultValue.enabled,[te.Off,te.OnCode,te.On])}}}class Se extends C{constructor(){const ce={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:b.localize(57,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Re.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(Re.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Re.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends C{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:b.localize(65,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return typeof Re.enabled=="boolean"&&(Re.enabled=Re.enabled?"on":"off"),{enabled:g(Re.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Re.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Re.fontFamily,this.defaultValue.fontFamily),padding:f(Re.padding,this.defaultValue.padding)}}}class U extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):i.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Re,Ge){return Ge<0?i.clampedInt(-Ge*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ne extends o{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>o.clamp(ce,0,150),{markdownDescription:b.localize(66,null)})}compute(ce,Re,Ge){return ce.fontInfo.lineHeight}}class $e extends C{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ce.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ce.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ce.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ce.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),autohide:f(Re.autohide,this.defaultValue.autohide),size:g(Re.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Re.side,this.defaultValue.side,["right","left"]),showSlider:g(Re.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Re.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Re.scale,1,1,3),maxColumn:i.clampedInt(Re.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:f(Re.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:f(Re.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:o.clamp(Re.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Pe(ae){return ae==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class se extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{top:i.clampedInt(Re.top,0,0,1e3),bottom:i.clampedInt(Re.bottom,0,0,1e3)}}}class re extends C{constructor(){const ce={enabled:!0,cycle:!0};super(86,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:b.localize(84,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),cycle:f(Re.cycle,this.defaultValue.cycle)}}}class oe extends v{constructor(){super(143)}compute(ce,Re,Ge){return ce.pixelRatio}}class G extends C{constructor(){const ce={other:"on",comments:"off",strings:"off"},Re=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Re,default:ce.strings,description:b.localize(88,null)},comments:{anyOf:Re,default:ce.comments,description:b.localize(89,null)},other:{anyOf:Re,default:ce.other,description:b.localize(90,null)}},default:ce,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const At=ce?"on":"off";return{comments:At,strings:At,other:At}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Re,comments:Ge,strings:Me}=ce,tt=["on","inline","off"];let ht,wt,Lt;return typeof Re=="boolean"?ht=Re?"on":"off":ht=g(Re,this.defaultValue.other,tt),typeof Ge=="boolean"?wt=Ge?"on":"off":wt=g(Ge,this.defaultValue.comments,tt),typeof Me=="boolean"?Lt=Me?"on":"off":Lt=g(Me,this.defaultValue.strings,tt),{other:ht,comments:wt,strings:Lt}}}var ie;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class me extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ce){let Re=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Re=4,Ge=ce):ce==="interval"?Re=3:ce==="relative"?Re=2:ce==="on"?Re=1:Re=0),{renderType:Re,renderFn:Ge}}}function be(ae){const ce=ae.get(98);return ce==="editable"?ae.get(91):ce!=="on"}class Ae extends C{constructor(){const ce=[],Re={type:"number",description:b.localize(97,null)};super(102,"rulers",ce,{type:"array",items:{anyOf:[Re,{type:["object"],properties:{column:Re,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ce,description:b.localize(99,null)})}validate(ce){if(Array.isArray(ce)){const Re=[];for(const Ge of ce)if(typeof Ge=="number")Re.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Me=Ge;Re.push({column:i.clampedInt(Me.column,0,0,1e4),color:Me.color})}return Re.sort((Ge,Me)=>Ge.column-Me.column),Re}return this.defaultValue}}class fe extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function De(ae,ce){if(typeof ae!="string")return ce;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ie extends C{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce,Ge=i.clampedInt(Re.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=i.clampedInt(Re.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Re.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Re.vertical,this.defaultValue.vertical),horizontal:De(Re.horizontal,this.defaultValue.horizontal),useShadows:f(Re.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Re.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Re.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Re.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Re.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(Re.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:i.clampedInt(Re.verticalSliderSize,Me,0,1e3),scrollByPage:f(Re.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Re.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Te extends C{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ce,Re){let Ge=!1;Re.allowedCharacters&&ce&&(N.$1n(ce.allowedCharacters,Re.allowedCharacters)||(ce={...ce,allowedCharacters:Re.allowedCharacters},Ge=!0)),Re.allowedLocales&&ce&&(N.$1n(ce.allowedLocales,Re.allowedLocales)||(ce={...ce,allowedLocales:Re.allowedLocales},Ge=!0));const Me=super.applyUpdate(ce,Re);return Ge?new m(Me.newValue,!0):Me}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{nonBasicASCII:he(Re.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Re.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Re.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Re.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Re.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Re){if(typeof ce!="object"||!ce)return Re;const Ge={};for(const[Me,tt]of Object.entries(ce))tt===!0&&(Ge[Me]=!0);return Ge}}class q extends C{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(125,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),mode:g(Re.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(Re.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Re.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Re.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Re.fontFamily,this.defaultValue.fontFamily)}}}class V extends C{constructor(){const ce={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ce,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ce.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ce.backgroundColoring,description:b.localize(132,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),showToolbar:g(Re.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Re.fontFamily,this.defaultValue.fontFamily),keepOnBlur:f(Re.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:f(Re.backgroundColoring,this.defaultValue.backgroundColoring)}}}class J extends C{constructor(){const ce={enabled:R.$Us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Re.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends C{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ce.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ce.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ce.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{bracketPairs:he(Re.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Re.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Re.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Re.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Re.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ae,ce,Re){const Ge=Re.indexOf(ae);return Ge===-1?ce:Re[Ge]}class pe extends C{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ce.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ce.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{insertMode:g(Re.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Re.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Re.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Re.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Re.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(Re.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Re.showIcons,this.defaultValue.showIcons),showStatusBar:f(Re.showStatusBar,this.defaultValue.showStatusBar),preview:f(Re.preview,this.defaultValue.preview),previewMode:g(Re.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Re.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Re.showMethods,this.defaultValue.showMethods),showFunctions:f(Re.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Re.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Re.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Re.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Re.showFields,this.defaultValue.showFields),showVariables:f(Re.showVariables,this.defaultValue.showVariables),showClasses:f(Re.showClasses,this.defaultValue.showClasses),showStructs:f(Re.showStructs,this.defaultValue.showStructs),showInterfaces:f(Re.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Re.showModules,this.defaultValue.showModules),showProperties:f(Re.showProperties,this.defaultValue.showProperties),showEvents:f(Re.showEvents,this.defaultValue.showEvents),showOperators:f(Re.showOperators,this.defaultValue.showOperators),showUnits:f(Re.showUnits,this.defaultValue.showUnits),showValues:f(Re.showValues,this.defaultValue.showValues),showConstants:f(Re.showConstants,this.defaultValue.showConstants),showEnums:f(Re.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Re.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Re.showKeywords,this.defaultValue.showKeywords),showWords:f(Re.showWords,this.defaultValue.showWords),showColors:f(Re.showColors,this.defaultValue.showColors),showFiles:f(Re.showFiles,this.defaultValue.showFiles),showReferences:f(Re.showReferences,this.defaultValue.showReferences),showFolders:f(Re.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Re.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Re.showSnippets,this.defaultValue.showSnippets),showUsers:f(Re.showUsers,this.defaultValue.showUsers),showIssues:f(Re.showIssues,this.defaultValue.showIssues)}}}class ze extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ce.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends C{constructor(){const ce=[];super(130,"wordSegmenterLocales",ce,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ce){if(typeof ce=="string"&&(ce=[ce]),Array.isArray(ce)){const Re=[];for(const Ge of ce)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Re.push(Ge)}catch{}return Re}return this.defaultValue}}var Ze;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ze||(e.WrappingIndent=Ze={}));class it extends C{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Re,Ge){return Re.get(2)===2?0:Ge}}class ot extends v{constructor(){super(146)}compute(ce,Re,Ge){const Me=Re.get(145);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class nt extends C{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),showDropSelector:g(Re.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),showPasteSelector:g(Re.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ce="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Be:L.$k?He:Ce,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Xe;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Ne(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Ne(new w),accessibilityPageSize:Ne(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Ne(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Ne(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new h(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Ne(new h(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Ne(new h(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Ne(new h(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Ne(new h(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Ne(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Ne(new a(13,"automaticLayout",!1)),autoSurround:Ne(new h(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Ne(new J),bracketPairGuides:Ne(new Q),stickyTabStops:Ne(new a(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Ne(new a(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Ne(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Ne(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Ne(new a(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Ne(new h(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Ne(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Ne(new a(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Ne(new d),contextmenu:Ne(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new a(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Ne(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Ne(new h(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Ne(new c(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(260,null)})),cursorSurroundingLines:Ne(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Ne(new h(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Ne(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Ne(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new a(34,"domReadOnly",!1)),dragAndDrop:Ne(new a(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Ne(new F),dropIntoEditor:Ne(new nt),stickyScroll:Ne(new Se),experimentalWhitespaceRendering:Ne(new h(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Ne(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ne(new o(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:b.localize(271,null)})),find:Ne(new j),fixedOverflowWidgets:Ne(new a(42,"fixedOverflowWidgets",!1)),folding:Ne(new a(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Ne(new h(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Ne(new a(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Ne(new a(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Ne(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ne(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Ne(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Ne(new T),fontLigatures2:Ne(new z),fontSize:Ne(new B),fontWeight:Ne(new W),fontVariations:Ne(new O),formatOnPaste:Ne(new a(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Ne(new a(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Ne(new a(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Ne(new X),hideCursorInOverviewRuler:Ne(new a(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Ne(new x),inDiffEditor:Ne(new a(61,"inDiffEditor",!1)),letterSpacing:Ne(new o(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>o.clamp(ae,-5,20),{description:b.localize(285,null)})),lightbulb:Ne(new we),lineDecorationsWidth:Ne(new U),lineHeight:Ne(new ne),lineNumbers:Ne(new me),lineNumbersMinChars:Ne(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new a(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Ne(new a(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Ne(new h(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Ne(new $e),mouseStyle:Ne(new h(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new o(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Ne(new a(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Ne(new a(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Ne(new c(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Pe,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Ne(new h(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Ne(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Ne(new h(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Ne(new a(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Ne(new i(83,"overviewRulerLanes",3,0,3)),padding:Ne(new se),pasteAs:Ne(new st),parameterHints:Ne(new re),peekWidgetDefaultFocus:Ne(new h(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Ne(new a(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Ne(new G),quickSuggestionsDelay:Ne(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Ne(new a(91,"readOnly",!1)),readOnlyMessage:Ne(new fe),renameOnType:Ne(new a(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Ne(new a(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Ne(new h(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Ne(new h(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ne(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Ne(new h(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new h(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Ne(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new a(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Ne(new Ae),scrollbar:Ne(new Ie),scrollBeyondLastColumn:Ne(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Ne(new a(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Ne(new a(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Ne(new a(107,"selectionClipboard",!0,{description:b.localize(325,null),included:L.$k})),selectionHighlight:Ne(new a(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Ne(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new h(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Ne(new a(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Ne(new a(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Ne(new _),snippetSuggestions:Ne(new h(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Ne(new ze),smoothScrolling:Ne(new a(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Ne(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new pe),inlineSuggest:Ne(new q),inlineEdit:Ne(new V),inlineCompletionsAccessibilityVerbose:Ne(new a(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Ne(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new a(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Ne(new h(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Ne(new h(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Ne(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new Te),unusualLineTerminators:Ne(new h(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Ne(new a(127,"useShadowDOM",!0)),useTabStops:Ne(new a(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Ne(new h(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Ne(new Ve),wordSeparators:Ne(new t(131,"wordSeparators",M.$Vs,{description:b.localize(359,null)})),wordWrap:Ne(new h(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Ne(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Ne(new h(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new h(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new I),defaultColorDecorators:Ne(new a(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Ne(new oe),tabFocusMode:Ne(new a(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Ne(new Y),wrappingInfo:Ne(new ot),wrappingIndent:Ne(new it),wrappingStrategy:Ne(new ue)}}),define(ke[202],Ee([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(ke[83],Ee([1,0,78,2,175,29,185,202]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$8t=e.$7t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$6t=e.$5t=e.SymbolKinds=e.SymbolTag=e.$3t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$1t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Zt=e.$Yt=e.$Xt=void 0,e.$2t=g,e.$4t=c;class ${constructor(X,x,Z){this.offset=X,this.type=x,this.language=Z,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Xt=$;class S{constructor(X,x){this.tokens=X,this.endState=x,this._tokenizationResultBrand=void 0}}e.$Yt=S;class A{constructor(X,x){this.tokens=X,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$Zt=A;var C;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(W){const X=new Map;X.set(0,l.$Pj.symbolMethod),X.set(1,l.$Pj.symbolFunction),X.set(2,l.$Pj.symbolConstructor),X.set(3,l.$Pj.symbolField),X.set(4,l.$Pj.symbolVariable),X.set(5,l.$Pj.symbolClass),X.set(6,l.$Pj.symbolStruct),X.set(7,l.$Pj.symbolInterface),X.set(8,l.$Pj.symbolModule),X.set(9,l.$Pj.symbolProperty),X.set(10,l.$Pj.symbolEvent),X.set(11,l.$Pj.symbolOperator),X.set(12,l.$Pj.symbolUnit),X.set(13,l.$Pj.symbolValue),X.set(15,l.$Pj.symbolEnum),X.set(14,l.$Pj.symbolConstant),X.set(15,l.$Pj.symbolEnum),X.set(16,l.$Pj.symbolEnumMember),X.set(17,l.$Pj.symbolKeyword),X.set(27,l.$Pj.symbolSnippet),X.set(18,l.$Pj.symbolText),X.set(19,l.$Pj.symbolColor),X.set(20,l.$Pj.symbolFile),X.set(21,l.$Pj.symbolReference),X.set(22,l.$Pj.symbolCustomColor),X.set(23,l.$Pj.symbolFolder),X.set(24,l.$Pj.symbolTypeParameter),X.set(25,l.$Pj.account),X.set(26,l.$Pj.issues);function x(ue){let te=X.get(ue);return te||(console.info("No codicon found for CompletionItemKind "+ue),te=l.$Pj.symbolProperty),te}W.toIcon=x;const Z=new Map;Z.set("method",0),Z.set("function",1),Z.set("constructor",2),Z.set("field",3),Z.set("variable",4),Z.set("class",5),Z.set("struct",6),Z.set("interface",7),Z.set("module",8),Z.set("property",9),Z.set("event",10),Z.set("operator",11),Z.set("unit",12),Z.set("value",13),Z.set("constant",14),Z.set("enum",15),Z.set("enum-member",16),Z.set("enumMember",16),Z.set("keyword",17),Z.set("snippet",27),Z.set("text",18),Z.set("color",19),Z.set("file",20),Z.set("reference",21),Z.set("customcolor",22),Z.set("folder",23),Z.set("type-parameter",24),Z.set("typeParameter",24),Z.set("account",25),Z.set("issue",26);function Y(ue,te){let we=Z.get(ue);return typeof we>"u"&&!te&&(we=9),we}W.fromString=Y})(m||(e.CompletionItemKinds=m={}));var E;(function(W){W[W.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var v;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var u;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(u||(e.PartialAcceptTriggerKind=u={}));var f;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var a;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(a||(e.InlineCompletionTriggerKind=a={}));class n{constructor(X,x,Z,Y){this.range=X,this.text=x,this.completionKind=Z,this.isSnippetText=Y}equals(X){return R.$kt.lift(this.range).equalsRange(X.range)&&this.text===X.text&&this.completionKind===X.completionKind&&this.isSnippetText===X.isSnippetText}}e.$1t=n;var i;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var s;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(s||(e.DocumentPasteTriggerKind=s={}));var o;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var t;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function g(W){return W&&N.URI.isUri(W.uri)&&R.$kt.isIRange(W.range)&&(R.$kt.isIRange(W.originSelectionRange)||R.$kt.isIRange(W.targetSelectionRange))}var h;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(h||(e.SymbolKind=h={})),e.$3t={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function c(W,X){return(0,b.localize)(26,null,W,e.$3t[X])}var r;(function(W){W[W.Deprecated=1]="Deprecated"})(r||(e.SymbolTag=r={}));var w;(function(W){const X=new Map;X.set(0,l.$Pj.symbolFile),X.set(1,l.$Pj.symbolModule),X.set(2,l.$Pj.symbolNamespace),X.set(3,l.$Pj.symbolPackage),X.set(4,l.$Pj.symbolClass),X.set(5,l.$Pj.symbolMethod),X.set(6,l.$Pj.symbolProperty),X.set(7,l.$Pj.symbolField),X.set(8,l.$Pj.symbolConstructor),X.set(9,l.$Pj.symbolEnum),X.set(10,l.$Pj.symbolInterface),X.set(11,l.$Pj.symbolFunction),X.set(12,l.$Pj.symbolVariable),X.set(13,l.$Pj.symbolConstant),X.set(14,l.$Pj.symbolString),X.set(15,l.$Pj.symbolNumber),X.set(16,l.$Pj.symbolBoolean),X.set(17,l.$Pj.symbolArray),X.set(18,l.$Pj.symbolObject),X.set(19,l.$Pj.symbolKey),X.set(20,l.$Pj.symbolNull),X.set(21,l.$Pj.symbolEnumMember),X.set(22,l.$Pj.symbolStruct),X.set(23,l.$Pj.symbolEvent),X.set(24,l.$Pj.symbolOperator),X.set(25,l.$Pj.symbolTypeParameter);function x(Z){let Y=X.get(Z);return Y||(console.info("No codicon found for SymbolKind "+Z),Y=l.$Pj.symbolProperty),Y}W.toIcon=x})(w||(e.SymbolKinds=w={}));class d{static asEditOperation(X){return L.$lt.replace(R.$kt.lift(X.range),X.text)}}e.$5t=d;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(X){switch(X){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(X)}constructor(X){this.value=X}}e.$6t=D;var p;(function(W){W[W.AIGenerated=1]="AIGenerated"})(p||(e.NewSymbolNameTag=p={}));var k;(function(W){function X(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}W.is=X})(k||(e.Command=k={}));var y;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var P;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(P||(e.CommentThreadState=P={}));var I;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(I||(e.CommentThreadApplicability=I={}));var F;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(F||(e.CommentMode=F={}));var j;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(j||(e.CommentState=j={}));var z;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(z||(e.InlayHintKind=z={}));class O{constructor(X){this.b=X,this.a=null}dispose(){this.a&&this.a.then(X=>{X&&X.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$7t=O,e.$8t=new M.$Mt;var T;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}));var B;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[203],Ee([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[204],Ee([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[205],Ee([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[206],Ee([9,10]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[207],Ee([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[208],Ee([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[209],Ee([9,10]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[210],Ee([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[211],Ee([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(ke[212],Ee([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[213],Ee([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[214],Ee([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[215],Ee([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[216],Ee([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[217],Ee([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[218],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[219],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[220],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[221],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[222],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[223],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[224],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[225],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[226],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[227],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[228],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[229],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[230],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[231],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[232],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[233],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[234],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[235],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[236],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[237],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[238],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[239],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[240],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[241],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[242],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[243],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[244],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[245],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[246],Ee([1,0,13,205]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var L;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const M=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,l.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const C=this.d,m=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:A}),this.f.push(E)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,C=!1,m=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const v=this.c.charCodeAt(A);if(C)C=!1;else if(v===47&&!m){A++;break}else v===91?m=!0:v===92?C=!0:v===93&&(m=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=$}),define(ke[247],Ee([1,0,23,41,208,396]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=$,e.$Bp=S,e.$Cp=A,e.$Dp=C,e.$Ep=m,e.$Fp=E,e.$Gp=v;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||M.test(a)}function S(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=a.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(a){if(!a)return null;const n=a.majorBase,i=a.majorMustEqual,s=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(n===0||(o=!1),g=!1);let h=0;if(a.preRelease){const c=b.exec(a.preRelease);if(c){const[,r,w,d]=c;h=Date.UTC(Number(r),Number(w)-1,Number(d))}}return{majorBase:n,majorMustEqual:i,minorBase:s,minorMustEqual:o,patchBase:t,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:h}}function C(a,n,i){let s;typeof a=="string"?s=A(S(a)):s=a;let o;n instanceof Date?o=n.getTime():typeof n=="string"&&(o=new Date(n).getTime());let t;if(typeof i=="string"?t=A(S(i)):t=i,!s||!t)return!1;const g=s.majorBase,h=s.minorBase,c=s.patchBase;let r=t.majorBase,w=t.minorBase,d=t.patchBase;const D=t.notBefore;let p=t.majorMustEqual,k=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?g>r?!0:g<r?!1:h>w?!0:h<w||o&&o<D?!1:c>=d:(g===1&&r===0&&(!p||!k||!y)&&(r=1,w=0,d=0,p=!0,k=!1,y=!1),g<r?!1:g>r?!p:h<w?!1:h>w?!k:c<d?!1:c>d?!y:!(o&&o<D))}function m(a,n,i,s,o){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof s.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!s.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!f(s.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!f(s.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const c=(0,l.$4g)(i,s.main);(0,l.$Xg)(c,i)||t.push([N.default.Warning,L.localize(10,null,c.path,i.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const c=(0,l.$4g)(i,s.browser);(0,l.$Xg)(c,i)||t.push([N.default.Warning,L.localize(12,null,c.path,i.path)])}}if(!R.valid(s.version))return t.push([N.default.Error,L.localize(13,null)]),t;const g=[];if(!E(a,n,s,o,g))for(const c of g)t.push([N.default.Error,c]);return t}function E(a,n,i,s,o){return s||typeof i.main>"u"&&typeof i.browser>"u"?!0:u(a,n,i.engines.vscode,o)}function v(a,n,i){return a==="*"||u(n,i,a)}function u(a,n,i,s=[]){const o=A(S(i));if(!o)return s.push(L.localize(14,null,i)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return s.push(L.localize(15,null,i)),!1}else if(!o.majorMustEqual)return s.push(L.localize(16,null,i)),!1;return C(a,n,o)?!0:(s.push(L.localize(17,null,a,i)),!1)}function f(a){if(!Array.isArray(a))return!1;for(let n=0,i=a.length;n<i;n++)if(typeof a[n]!="string")return!1;return!0}}),define(ke[106],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class l{constructor(L,R=[],M=!1){this.ctor=L,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.$ni=l}),define(ke[84],Ee([1,0,106]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=R,e.$ps=M;const N=[];var L;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function R(b,$,S){$ instanceof l.$ni||($=new l.$ni($,[],!!S)),N.push([b,$])}function M(){return N}}),define(ke[248],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class l{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$5q=l;class N{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const b=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(M);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let b=this.a.get(M);return b||(b=new l(M,R),this.a.set(M,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,b]of this.a)R.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const b=new Set([R]),$=this.c(M,b);if($)return $}}c(R,M){for(const[b,$]of R.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const S=this.c($,M);if(S)return S;M.delete(b)}}}e.$6q=N}),define(ke[5],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=L,e.$ri=R;var l;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b($){return $[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(l||(e._util=l={})),e.$pi=L("instantiationService");function N(M,b,$){b[l.DI_TARGET]===b?b[l.DI_DEPENDENCIES].push({id:M,index:$}):(b[l.DI_DEPENDENCIES]=[{id:M,index:$}],b[l.DI_TARGET]=b)}function L(M){if(l.serviceIds.has(M))return l.serviceIds.get(M);const b=function($,S,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(b,$,A)};return b.toString=()=>M,l.serviceIds.set(M,b),b}function R(M){return M}}),define(ke[54],Ee([1,0,18,2,5]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=R,e.$Yi=M,e.$Zi=$,e.$1i=S,e.$2i=A,e.$3i=C,e.$4i=m,e.$5i=v,e.$6i=u,e.$7i=f,e.$Wi=(0,L.$qi)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof N.URI)}function M(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof N.URI)}var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function S(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function A(a,n){const i=Object.create(null);for(const s in a)C(i,s,a[s],n);return i}function C(a,n,i,s){const o=n.split("."),t=o.pop();let g=a;for(let h=0;h<o.length;h++){const c=o[h];let r=g[c];switch(typeof r){case"undefined":r=g[c]=Object.create(null);break;case"object":if(r===null){s(`Ignoring ${n} as ${o.slice(0,h+1).join(".")} is null`);return}break;default:s(`Ignoring ${n} as ${o.slice(0,h+1).join(".")} is ${JSON.stringify(r)}`);return}g=r}if(typeof g=="object"&&g!==null)try{g[t]=i}catch{s(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(g)}`)}else s(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(g)}`)}function m(a,n){const i=n.split(".");E(a,i)}function E(a,n){const i=n.shift();if(n.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const s=a[i];typeof s=="object"&&!Array.isArray(s)&&(E(s,n),Object.keys(s).length===0&&delete a[i])}}function v(a,n,i){function s(g,h){let c=g;for(const r of h){if(typeof c!="object"||c===null)return;c=c[r]}return c}const o=n.split("."),t=s(a,o);return typeof t>"u"?i:t}function u(a,n,i){Object.keys(n).forEach(s=>{s!=="__proto__"&&(s in a?l.$6f(a[s])&&l.$6f(n[s])?u(a[s],n[s],i):i&&(a[s]=n[s]):a[s]=n[s])})}function f(a){return a.replace(/[\[\]]/g,"")}}),define(ke[37],Ee([1,0,11,14,246,5,204,13]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=S,e.$pj=g,e.$qj=h,e.$Jj=te;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",l.$j),$.set("isLinux",l.$k),$.set("isWindows",l.$i),$.set("isWeb",l.$o),$.set("isMacNative",l.$j&&!l.$o),$.set("isEdge",l.$H),$.set("isFirefox",l.$F),$.set("isChrome",l.$E),$.set("isSafari",l.$G);function S(_,U){if($.get(_)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(_,U)}const A=Object.prototype.hasOwnProperty;var C;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},E=(0,M.localize)(0,null),v=(0,M.localize)(1,null),u=(0,M.localize)(2,null),f=(0,M.localize)(3,null),a=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),s=(0,M.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=m){this.k=U,this.d=new L.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const $e=this.D(),Pe=$e.type===17?n:void 0;throw this.h.push({message:a,offset:$e.offset,lexeme:L.$lj.getLexeme($e),additionalInfo:Pe}),o.c}return ne}catch(ne){if(ne!==o.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),w.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,f),ne?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,f),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==10)throw this.B("REGEX",Pe);const se=Pe.lexeme,re=se.lastIndexOf("/"),oe=re===se.length-1?void 0:this.w(se.substring(re+1));let G;try{G=new RegExp(se.substring(1,re),oe)}catch{throw this.B("REGEX",Pe)}return T.create(ne,G)}switch(Pe.type){case 10:case 19:{const se=[Pe.lexeme];this.z();let re=this.D(),oe=0;for(let Ae=0;Ae<Pe.lexeme.length;Ae++)Pe.lexeme.charCodeAt(Ae)===40?oe++:Pe.lexeme.charCodeAt(Ae)===41&&oe--;for(;!this.E()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Ae=0;Ae<re.lexeme.length;Ae++)re.lexeme.charCodeAt(Ae)===40?oe++:Pe.lexeme.charCodeAt(Ae)===41&&oe--}if(oe<0)break;se.push(L.$lj.getLexeme(re)),this.z(),re=this.D()}const G=se.join(""),ie=G.lastIndexOf("/"),me=ie===G.length-1?void 0:this.w(G.substring(ie+1));let be;try{be=new RegExp(G.substring(1,ie),me)}catch{throw this.B("REGEX",Pe)}return t.regex(ne,be)}case 18:{const se=Pe.lexeme;this.z();let re=null;if(!(0,N.$3e)(se)){const oe=se.indexOf("/"),G=se.lastIndexOf("/");if(oe!==G&&oe>=0){const ie=se.slice(oe+1,G),me=se[G+1]==="i"?"i":"";try{re=new RegExp(ie,me)}catch{throw this.B("REGEX",Pe)}}}if(re===null)throw this.B("REGEX",Pe);return T.create(ne,re)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,u);const Pe=this.u();return t.notIn(ne,Pe)}switch(this.D().type){case 3:{this.z();const Pe=this.u();if(this.x().type===18)return t.equals(ne,Pe);switch(Pe){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,Pe)}}case 4:{this.z();const Pe=this.u();if(this.x().type===18)return t.notEquals(ne,Pe);switch(Pe){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,Pe)}}case 5:return this.z(),z.create(ne,this.u());case 6:return this.z(),O.create(ne,this.u());case 7:return this.z(),F.create(ne,this.u());case 8:return this.z(),j.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:s}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,$e){const Pe=(0,M.localize)(8,null,U,L.$lj.getLexeme(ne)),se=ne.offset,re=L.$lj.getLexeme(ne);return this.h.push({message:Pe,offset:se,lexeme:re,additionalInfo:$e}),o.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=o;class t{static false(){return r.INSTANCE}static true(){return w.INSTANCE}static has(U){return d.create(U)}static equals(U,ne){return D.create(U,ne)}static notEquals(U,ne){return y.create(U,ne)}static regex(U,ne){return T.create(U,ne)}static in(U,ne){return p.create(U,ne)}static notIn(U,ne){return k.create(U,ne)}static not(U){return P.create(U)}static and(...U){return X.create(U,null,!0)}static or(...U){return x.create(U,null,!0)}static greater(U,ne){return F.create(U,ne)}static greaterEquals(U,ne){return j.create(U,ne)}static smaller(U,ne){return z.create(U,ne)}static smallerEquals(U,ne){return O.create(U,ne)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$oj=t;function g(_){const U=new o({regexParsingWithErrorRecovery:!1});return _.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map($e=>({errorMessage:$e.additionalInfo?(0,M.localize)(9,null,$e.additionalInfo):(0,M.localize)(10,null),offset:$e.offset,length:$e.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map($e=>({errorMessage:$e.additionalInfo?`${$e.message}. ${$e.additionalInfo}`:$e.message,offset:$e.offset,length:$e.lexeme.length})):[]))}function h(_,U){const ne=_?_.substituteConstants():void 0,$e=U?U.substituteConstants():void 0;return!ne&&!$e?!0:!ne||!$e?!1:ne.equals($e)}function c(_,U){return _.cmp(U)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return w.INSTANCE}}e.$rj=r;class w{static{this.INSTANCE=new w}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return r.INSTANCE}}e.$sj=w;class d{static create(U,ne=null){const $e=$.get(U);return typeof $e=="boolean"?$e?w.INSTANCE:r.INSTANCE:new d(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?w.INSTANCE:r.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$tj=d;class D{static create(U,ne,$e=null){if(typeof ne=="boolean")return ne?d.create(U,$e):P.create(U,$e);const Pe=$.get(U);return typeof Pe=="boolean"?ne===(Pe?"true":"false")?w.INSTANCE:r.INSTANCE:new D(U,ne,$e)}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?w.INSTANCE:r.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$uj=D;class p{static create(U,ne){return new p(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),$e=U.getValue(this.d);return Array.isArray(ne)?ne.includes($e):typeof $e=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,$e):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$vj=p;class k{static create(U,ne){return new k(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=p.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=k;class y{static create(U,ne,$e=null){if(typeof ne=="boolean")return ne?P.create(U,$e):d.create(U,$e);const Pe=$.get(U);return typeof Pe=="boolean"?ne===(Pe?"true":"false")?r.INSTANCE:w.INSTANCE:new y(U,ne,$e)}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?r.INSTANCE:w.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$xj=y;class P{static create(U,ne=null){const $e=$.get(U);return typeof $e=="boolean"?$e?r.INSTANCE:w.INSTANCE:new P(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?r.INSTANCE:w.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.$yj=P;function I(_,U){if(typeof _=="string"){const ne=parseFloat(_);isNaN(ne)||(_=ne)}return typeof _=="string"||typeof _=="number"?U(_):r.INSTANCE}class F{static create(U,ne,$e=null){return I(ne,Pe=>new F(U,Pe,$e))}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$zj=F;class j{static create(U,ne,$e=null){return I(ne,Pe=>new j(U,Pe,$e))}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Aj=j;class z{static create(U,ne,$e=null){return I(ne,Pe=>new z(U,Pe,$e))}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Bj=z;class O{static create(U,ne,$e=null){return I(ne,Pe=>new O(U,Pe,$e))}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Cj=O;class T{static create(U,ne){return new T(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",$e=U.f?U.f.source:"";return ne<$e?-1:ne>$e?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",$e=U.f?U.f.source:"";return this.d===U.d&&ne===$e}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Dj=T;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Ej=B;function W(_){let U=null;for(let ne=0,$e=_.length;ne<$e;ne++){const Pe=_[ne].substituteConstants();if(_[ne]!==Pe&&U===null){U=[];for(let se=0;se<ne;se++)U[se]=_[se]}U!==null&&(U[ne]=Pe)}return U===null?_:U}class X{static create(U,ne,$e){return X.d(U,ne,$e)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,$e=this.expr.length;ne<$e;ne++){const Pe=c(this.expr[ne],U.expr[ne]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,$e=this.expr.length;ne<$e;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:X.create(U,this.c,!1)}evaluate(U){for(let ne=0,$e=this.expr.length;ne<$e;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,$e){const Pe=[];let se=!1;for(const re of U)if(re){if(re.type===1){se=!0;continue}if(re.type===0)return r.INSTANCE;if(re.type===6){Pe.push(...re.expr);continue}Pe.push(re)}if(Pe.length===0&&se)return w.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(c);for(let re=1;re<Pe.length;re++)Pe[re-1].equals(Pe[re])&&(Pe.splice(re,1),re--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const re=Pe[Pe.length-1];if(re.type!==9)break;Pe.pop();const oe=Pe.pop(),G=Pe.length===0,ie=x.create(re.expr.map(me=>X.create([me,oe],null,$e)),null,G);ie&&(Pe.push(ie),Pe.sort(c))}if(Pe.length===1)return Pe[0];if($e){for(let re=0;re<Pe.length;re++)for(let oe=re+1;oe<Pe.length;oe++)if(Pe[re].negate().equals(Pe[oe]))return r.INSTANCE;if(Pe.length===1)return Pe[0]}return new X(Pe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new X(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=x.create(U,this,!0)}return this.c}}e.$Fj=X;class x{static create(U,ne,$e){return x.d(U,ne,$e)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,$e=this.expr.length;ne<$e;ne++){const Pe=c(this.expr[ne],U.expr[ne]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,$e=this.expr.length;ne<$e;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:x.create(U,this.c,!1)}evaluate(U){for(let ne=0,$e=this.expr.length;ne<$e;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,$e){let Pe=[],se=!1;if(U){for(let re=0,oe=U.length;re<oe;re++){const G=U[re];if(G){if(G.type===0){se=!0;continue}if(G.type===1)return w.INSTANCE;if(G.type===9){Pe=Pe.concat(G.expr);continue}Pe.push(G)}}if(Pe.length===0&&se)return r.INSTANCE;Pe.sort(c)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let re=1;re<Pe.length;re++)Pe[re-1].equals(Pe[re])&&(Pe.splice(re,1),re--);if(Pe.length===1)return Pe[0];if($e){for(let re=0;re<Pe.length;re++)for(let oe=re+1;oe<Pe.length;oe++)if(Pe[re].negate().equals(Pe[oe]))return w.INSTANCE;if(Pe.length===1)return Pe[0]}return new x(Pe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new x(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),$e=U.shift(),Pe=[];for(const se of Se(ne))for(const re of Se($e))Pe.push(X.create([se,re],null,!1));U.unshift(x.create(Pe,null,!1))}this.c=x.create(U,this,!0)}return this.c}}e.$Gj=x;class Z extends d{static{this.d=[]}static all(){return Z.d.values()}constructor(U,ne,$e){super(U,null),this.f=ne,typeof $e=="object"?Z.d.push({...$e,key:U}):$e!==!0&&Z.d.push({key:U,description:$e,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$Hj=Z,e.$Ij=(0,R.$qi)("contextKeyService");function Y(_,U){return _<U?-1:_>U?1:0}function ue(_,U,ne,$e){return _<ne?-1:_>ne?1:U<$e?-1:U>$e?1:0}function te(_,U){if(_.type===0||U.type===1)return!0;if(_.type===9)return U.type===9?we(_.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(te(_,ne))return!0;return!1}if(_.type===6){if(U.type===6)return we(U.expr,_.expr);for(const ne of _.expr)if(te(ne,U))return!0;return!1}return _.equals(U)}function we(_,U){let ne=0,$e=0;for(;ne<_.length&&$e<U.length;){const Pe=_[ne].cmp(U[$e]);if(Pe<0)return!1;Pe===0&&ne++,$e++}return ne===_.length}function Se(_){return _.type===9?_.expr:[_]}}),define(ke[249],Ee([1,0,23,41,206,5,103,11,24]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Aw=e.$zw=e.$yw=void 0,e.$Bw=E,e.$Cw=v,e.$yw=(0,R.$qi)("dialogService");var S;(function(u){u[u.Confirmation=1]="Confirmation",u[u.Prompt=2]="Prompt",u[u.Input=3]="Input"})(S||(S={}));class A{a(f){return this.d(f,S.Confirmation)}b(f){return this.d(f,S.Prompt)}c(f){return this.d(f,S.Input)}d(f,a){const n=[];switch(a){case S.Confirmation:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case S.Prompt:{const i=f;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case S.Input:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===N.default.Info?"info":f===N.default.Error?"error":f===N.default.Warning?"warning":"none"}f(f,a,n){const i=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&i.push(f.cancelButton);let s=i[a]?.run({checkboxChecked:n});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:n}}}e.$zw=A,e.$Aw=(0,R.$qi)("fileDialogService");var C;(function(u){u[u.SAVE=0]="SAVE",u[u.DONT_SAVE=1]="DONT_SAVE",u[u.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function E(u){const f=[];return f.push(...u.slice(0,m).map(a=>typeof a=="string"?a:(0,l.$1g)(a))),u.length>m&&(u.length-m===1?f.push((0,L.localize)(7,null)):f.push((0,L.localize)(8,null,u.length-m))),f.push(""),f.join(`
`)}function v(u,f){const a=(0,$.$Wn)(u);let n=(a.buttons??[]).map(t=>(0,M.$vw)(t)),i=(u.buttons||[]).map((t,g)=>g),s=0,o=a.cancelId??n.length-1;if(n.length>1){const t=typeof o=="number"?n[o]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&o!==1){n.splice(o,1),n.splice(1,0,t);const g=i[o];i.splice(o,1),i.splice(1,0,g),o=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),s=n.length-1,typeof t=="string"&&(o=s-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&o!==n.length-1){n.splice(o,1),n.push(t);const g=i[o];i.splice(o,1),i.push(g),o=n.length-1}}return a.buttons=n,a.defaultId=s,a.cancelId=o,a.noLink=!0,a.title=a.title||f.nameLong,{options:a,buttonIndeces:i}}}),define(ke[136],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,l.$qi)("environmentService"),e.$yi=(0,l.$ri)(e.$xi)}),define(ke[137],Ee([1,0,207,5]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=L,e.$Uo=R,e.$Vo=M,e.$Wo=b,e.$Xo=$,e.$Yo=S,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function L(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,s){switch(i){case 3:return s==="x64"?"win32-x64":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,s){return s==="web"&&!i.includes("web")}function $(i,s,o){return b(s,o)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===o}function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var C;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(i){i.Install="install",i.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var E;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Zo=(0,N.$qi)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var u;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class f extends Error{constructor(s,o){super(s),this.code=o,this.name=o}}e.$1o=f;var a;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(a||(e.ExtensionGalleryErrorCode=a={}));class n extends Error{constructor(s,o){super(s),this.code=o,this.name=o}}e.$2o=n,e.$3o=(0,N.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,N.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,N.$qi)("IExtensionTipsService"),e.$8o=(0,l.localize2)(0,"Extensions"),e.$9o=(0,l.localize2)(1,"Preferences")}),define(ke[250],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=e.$q6b=void 0,e.$q6b=(0,l.$qi)("externalTerminal"),e.$r6b="Terminal.app"}),define(ke[251],Ee([1,0,53,55,15,17,11,102,31,105,209,250]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=e.$zbc=e.$ybc=void 0;const m=A.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends E{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(l,o,S.$im(),t)}spawnTerminal(o,t,g,h){const c=t.windowsExec||v.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const r=R.$oc(c,".exe").toLowerCase();if(r==="cmder")return o.spawn(c,h?[h]:void 0),Promise.resolve(void 0);const w=["/c","start","/wait"];return c.indexOf(" ")>=0&&w.push('""'),w.push(c),r==="wt"&&w.push("-d ."),new Promise((d,D)=>{const p=a(process),k=o.spawn(g,w,{cwd:h,env:p,detached:!0});k.on("error",D),k.on("exit",()=>d())})}async runInTerminal(o,t,g,h,c){const r="windowsExec"in c&&c.windowsExec?c.windowsExec:v.getDefaultTerminalWindows(),w=await v.f();return new Promise((d,D)=>{const p=`"${t} - ${m}"`,k=`"${g.join('" "')}" & pause`,y=Object.assign({},a(process),h);Object.keys(y).filter(z=>y[z]===null).forEach(z=>delete y[z]);const P={cwd:t,env:y,windowsVerbatimArguments:!0};let I,F;R.$oc(r,".exe")==="wt"?(I=r,F=["-d",".",v.b,"/c",k]):w?(I=w,F=["-d",".",r,"/c",k]):(I=v.b,F=["/c","start",p,"/wait",r,"/c",`"${k}"`]),l.spawn(I,F,P).on("error",z=>{D(n(z))}),d(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const o=await S.win32.findExecutable("wt");return await $.Promises.exists(o)?o:void 0}catch{return}}}e.$ybc=v,Je([N.$Uh],v,"f",null);class u extends E{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(l,o,t)}runInTerminal(o,t,g,h,c){const r=c.osxExec||C.$r6b;return new Promise((w,d)=>{if(r===C.$r6b||r==="iTerm.app"){const D=r===C.$r6b?"TerminalHelper":"iTermHelper",k=[L.$Kg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",o||m,"-w",t];for(const I of g)k.push("-a"),k.push(I);if(h){const I=Object.assign({},a(process),h);for(const F in I){const j=I[F];j===null?(k.push("-u"),k.push(F)):(k.push("-e"),k.push(`${F}=${j}`))}}let y="";const P=l.spawn(u.b,k);P.on("error",I=>{d(n(I))}),P.stderr.on("data",I=>{y+=I.toString()}),P.on("exit",I=>{if(I===0)w(void 0);else if(y){const F=y.split(`
`,1);d(new Error(F[0]))}else d(new Error(A.localize(1,null,D,I)))})}else d(new Error(A.localize(2,null,r)))})}spawnTerminal(o,t,g){const h=t.osxExec||C.$r6b;return new Promise((c,r)=>{const w=["-a",h];g&&w.push(g);const d=a(process),D=o.spawn("/usr/bin/open",w,{cwd:g,env:d});D.on("error",r),D.on("exit",()=>c())})}}e.$zbc=u;class f extends E{static{this.b=A.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(l,o,t)}runInTerminal(o,t,g,h,c){const r=c.linuxExec?Promise.resolve(c.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((w,d)=>{const D=[];r.then(p=>{p.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const k=`${i(g)}; echo; read -p "${f.b}" -n1;`;D.push(`''${k}''`);const y=Object.assign({},a(process),h);Object.keys(y).filter(j=>y[j]===null).forEach(j=>delete y[j]);const P={cwd:t,env:y};let I="";const F=l.spawn(p,D,P);F.on("error",j=>{d(n(j))}),F.stderr.on("data",j=>{I+=j.toString()}),F.on("exit",j=>{if(j===0)w(void 0);else if(I){const z=I.split(`
`,1);d(new Error(z[0]))}else d(new Error(A.localize(4,null,p,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!M.$k)f.d=Promise.resolve("xterm");else{const o=await $.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(o,t,g){const h=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((c,r)=>{h.then(w=>{const d=a(process),D=o.spawn(w,[],{cwd:g,env:d});D.on("error",r),D.on("exit",()=>c())})})}}e.$Abc=f;function a(s){const o={...s.env};return(0,b.$gm)(o),o}function n(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(A.localize(5,null,s.path)):s}function i(s){let o="";for(const t of s)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(ke[32],Ee([1,0,77,17,14,18,2,210,5,11,15,46]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=m,e.$Yk=u,e.$Zk=a,e.$1k=n,e.$2k=i,e.$3k=s,e.$4k=o,e.$5k=t,e.$6k=g,e.$7k=h,e.$8k=c,e.$0k=d,e.$$k=D,e.$_k=p,e.$al=k,e.$bl=y,e.$el=z,e.$ql=x,e.$rl=Z,e.$tl=ue,e.$Wk=(0,$.$qi)("fileService");function m(te){return te.create===!0}var E;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var v;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function u(te){const we=te;return!!we&&typeof we.onDidChange=="function"}var f;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function a(te){return!!(te.capabilities&2)}function n(te){return!!(te.capabilities&8)}function i(te){return!!(te.capabilities&131072)}function s(te){return!!(te.capabilities&4)}function o(te){return!!(te.capabilities&16)}function t(te){return a(te)?!!(te.capabilities&16384):!1}function g(te){return a(te)?!!(te.capabilities&32768):!1}function h(te){return!!(te.capabilities&65536)}function c(te){return!!(te.capabilities&2048)}var r;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class w extends Error{static create(we,Se){const _=new w(we.toString(),Se);return p(_,Se),_}constructor(we,Se){super(we),this.code=Se}}e.$9k=w;function d(te,we){return w.create(te,we)}function D(te){return te||d((0,b.localize)(0,null),r.Unknown)}function p(te,we){return te.name=we?`${we} (FileSystemError)`:"FileSystemError",te}function k(te){if(!te)return r.Unknown;if(te instanceof w)return te.code;const we=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!we)return r.Unknown;switch(we[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function y(te){if(te instanceof O)return te.fileOperationResult;switch(k(te)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}var P;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class I{constructor(we,Se,_){this.resource=we,this.operation=Se,this.target=_}isOperation(we){return this.operation===we}}e.$cl=I;var F;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class j{static{this.a=null}constructor(we,Se){this.c=Se,this.b=void 0,this.d=new C.$V(()=>{const _=l.$wi.forUris(()=>this.c);return _.fill(this.rawAdded.map(U=>[U,!0])),_}),this.f=new C.$V(()=>{const _=l.$wi.forUris(()=>this.c);return _.fill(this.rawUpdated.map(U=>[U,!0])),_}),this.g=new C.$V(()=>{const _=l.$wi.forUris(()=>this.c);return _.fill(this.rawDeleted.map(U=>[U,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of we){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==j.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(we,...Se){return this.h(we,{includeChildren:!1},...Se)}affects(we,...Se){return this.h(we,{includeChildren:!0},...Se)}h(we,Se,..._){if(!we)return!1;const U=_.length>0;return!!((!U||_.includes(1))&&(this.d.value.get(we)||Se.includeChildren&&this.d.value.findSuperstr(we))||(!U||_.includes(0))&&(this.f.value.get(we)||Se.includeChildren&&this.f.value.findSuperstr(we))||(!U||_.includes(2))&&(this.g.value.findSubstr(we)||Se.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$dl=j;function z(te,we,Se){return!te||!we||te===we||we.length>te.length?!1:(we.charAt(we.length-1)!==N.sep&&(we+=N.sep),Se?(0,L.$uf)(te,we):te.indexOf(we)===0)}class O extends Error{constructor(we,Se,_){super(we),this.fileOperationResult=Se,this.options=_}}e.$fl=O;class T extends O{constructor(we,Se,_,U){super(we,Se,U),this.fileOperationResult=Se,this.size=_}}e.$gl=T;class B extends O{constructor(we,Se,_){super(we,2,_),this.stat=Se}}e.$hl=B;var W;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var X;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$pl="";function x(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function Z(te,we){if(!we.hasProvider(M.URI.from({scheme:te.scheme})))return new Promise(Se=>{const _=we.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===te.scheme&&U.added&&(_.dispose(),Se())})})}class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(we){return(0,R.$8f)(we)||(we=0),we<Y.KB?(0,b.localize)(1,null,we.toFixed(0)):we<Y.MB?(0,b.localize)(2,null,(we/Y.KB).toFixed(2)):we<Y.GB?(0,b.localize)(3,null,(we/Y.MB).toFixed(2)):we<Y.TB?(0,b.localize)(4,null,(we/Y.GB).toFixed(2)):(0,b.localize)(5,null,(we/Y.TB).toFixed(2))}}e.$sl=Y;function ue(te){const we=typeof te=="string"||te?.scheme===A.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===A.Schemas.file?1024*Y.MB:we?10*Y.MB:S.$o?50*Y.MB:1024*Y.MB}}),define(ke[252],Ee([1,0,21,13,211,32]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=M;async function M(A,C,m,E,v,u){let f;try{await b(A,C,m,E,v,u)}catch(a){f=a}finally{f&&v.errorTransformer&&(f=v.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}async function b(A,C,m,E,v,u){$(u);const f=await A.open(C,{create:!1});try{$(u);let a=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,s=l.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),o=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(f,o,s.buffer,t,s.byteLength-t),o+=n,t+=n,a+=n,typeof i=="number"&&(i-=n),t===s.byteLength&&(await m.write(E(s)),s=l.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(u)&&S(a,v));if(t>0){let g=t;typeof i=="number"&&(g=Math.min(t,i)),m.write(E(s.slice(0,g)))}}catch(a){throw(0,R.$$k)(a)}finally{await A.close(f)}}function $(A){if(A.isCancellationRequested)throw(0,N.$6)();return!0}function S(A,C){if(typeof C?.limits?.size=="number"&&A>C.limits.size)throw(0,R.$0k)((0,L.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Ee([1,0,35,3,17,11,2,32]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0,e.$Dq=$,e.$Eq=S,e.$Iq=E,e.$Jq=v,e.$Kq=u,e.$Lq=f;function $(n){return typeof n.correlationId=="number"}function S(n){return n.recursive===!0}class A extends N.$Uc{static{this.a=5}constructor(i,s,o,t){super(),this.h=i,this.j=s,this.m=o,this.n=t,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const i=new N.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(s=>this.h(s))),i.add(this.b.onDidLogMessage(s=>this.j(s))),i.add(this.b.onDidError(s=>this.t(s)))}t(i){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fq=A;class C extends A{constructor(i,s,o){super(i,s,o,{type:"node.js",restartOnError:!1})}}e.$Gq=C;class m extends A{constructor(i,s,o){super(i,s,o,{type:"universal",restartOnError:!0})}}e.$Hq=m;function E(n){return n.map(i=>({type:i.type,resource:M.URI.revive(i.resource),cId:i.cId}))}function v(n){const i=new a;for(const s of n)i.processEvent(s);return i.coalesce()}function u(n,i){return typeof i=="string"&&!i.startsWith(l.$gk)&&!(0,L.$jc)(i)?{base:n,pattern:i}:i}function f(n,i){const s=[];for(const o of i)s.push((0,l.$kk)(u(n,o)));return s}class a{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const s=this.b.get(this.c(i));let o=!1;if(s){const t=s.type,g=i.type;s.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:t===1&&g===2?(this.b.delete(this.c(i)),this.a.delete(s)):t===2&&g===1?s.type=0:t===1&&g===0||(s.type=g)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],s=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,t)=>o.resource.fsPath.length-t.resource.fsPath.length).filter(o=>s.some(t=>(0,b.$el)(o.resource.fsPath,t,!R.$k))?!1:(s.push(o.resource.fsPath),!0)).concat(i)}}}),define(ke[253],Ee([1,0,52,3,65,4,2,8]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class $ extends N.$Uc{constructor(){super(),this.a=this.B(new R.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new b.$Nh,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,L.$Dq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new b.$Nh;try{this.h.clear(),this.g.clear();for(const C of A)this.t(C)?this.h.set(C.correlationId,C):this.g.add(C);for(const[C]of this.j)this.h.has(C)||(this.j.deleteAndDispose(C),this.m.delete(C));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const C=new N.$Tc;this.j.set(A.correlationId,C),await this.r.p,!C.isDisposed&&(this.z(A,C),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,C){this.C(A,C)?(this.M(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,C),this.m.add(A.correlationId))}C(A,C){const m=this.L?.subscribe(A.path,(E,v)=>{C.isDisposed||(E?this.z(A,C):v?.type===1&&this.F(A))});return m?(C.add(m),!0):!1}D(A,C){let m=!1;const E=(v,u)=>{if(C.isDisposed)return;const f=this.G(v),a=this.G(u),n=m;m=f,!f&&(a||n)&&this.F(A)};this.M(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,l.watchFile)(A.path,{persistent:!1,interval:this.n},E)}catch(v){this.N(`fs.watchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}C.add((0,N.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,l.unwatchFile)(A.path,E)}catch(v){this.N(`fs.unwatchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.M(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const C={resource:M.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([C]),this.H(C,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,C){const m=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.M(typeof C.correlationId=="number"?`${m} (correlationId: ${C.correlationId})`:m)}I(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}}e.$Uq=$}),define(ke[254],Ee([1,0,52,8,22,34,3,76,17,11,23,2,104,31,65]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0,e.$1q=f;class u extends M.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(n,i,s,o,t,g){super(),this.r=n,this.s=i,this.t=s,this.u=o,this.w=t,this.y=g,this.c=this.B(new N.$Fh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.t(h))),this.f=this.B(new N.$Eh(h=>this.L(h),u.b)),this.g=(0,v.$Lq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,v.$Lq)(this.r.path,this.r.includes):void 0,this.j=new L.$me,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const n=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const i=await E.Promises.stat(n);if(this.j.token.isCancellationRequested)return;this.B(await this.F(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.N(n):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${n})`),this.C()}}C(){this.n=!0,this.u?.()}async D(n){let i=n.path;try{i=await E.Promises.realpath(n.path),n.path===i&&(i=await(0,m.$Wq)(n.path,this.j.token)??n.path),n.path!==i&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async F(n,i){const s=new M.$Tc;return this.G(n,i,s)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(n,i,s)),s}G(n,i,s){if(i)return!1;const o=C.URI.file(this.r.path),t=this.s?.subscribe(this.r.path,async(g,h)=>{if(!s.isDisposed)if(g){const c=await this.F(n,i);s.isDisposed?c.dispose():s.add(c)}else h&&(typeof h.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:o,type:h.type,cId:this.r.correlationId}])});return t?(s.add(t),!0):!1}async H(n,i,s){if(S.$j&&(0,R.$qg)(n,"/Volumes/",!0)){this.N(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new L.$me(this.j.token);s.add((0,M.$Sc)(()=>o.dispose(!0)));const t=new M.$Tc;s.add(t);try{const g=C.URI.file(this.r.path),h=(0,$.$oc)(n),c=(0,l.watch)(n);t.add((0,M.$Sc)(()=>{c.removeAllListeners(),c.close()})),this.P(`Started watching: '${n}'`);const r=new Set;if(i)try{for(const d of await E.Promises.readdir(n))r.add(d)}catch(d){this.N(d)}if(o.token.isCancellationRequested)return;const w=new Map;t.add((0,M.$Sc)(()=>{for(const[,d]of w)d.dispose();w.clear()})),c.on("error",(d,D)=>{o.token.isCancellationRequested||(this.N(`Failed to watch ${n} for changes using fs.watch() (${d}, ${D})`),this.C())}),c.on("change",(d,D)=>{if(o.token.isCancellationRequested)return;this.P(`[raw] ["${d}"] ${D}`);let p="";if(D&&(p=D.toString(),S.$j&&(p=(0,b.$8l)(p))),!(!p||d!=="change"&&d!=="rename"))if(i)if(d==="rename"){w.get(p)?.dispose();const k=setTimeout(async()=>{if(w.delete(p),p===h&&!await E.Promises.exists(n)){this.I(g);return}if(o.token.isCancellationRequested)return;const y=await this.M((0,$.$kc)(n,p));if(o.token.isCancellationRequested)return;let P;y?r.has(p)?P=0:(P=1,r.add(p)):(r.delete(p),P=2),this.J({resource:(0,A.$4g)(g,p),type:P,cId:this.r.correlationId})},u.a);w.set(p,(0,M.$Sc)(()=>clearTimeout(k)))}else{let k;r.has(p)?k=0:(k=1,r.add(p)),this.J({resource:(0,A.$4g)(g,p),type:k,cId:this.r.correlationId})}else if(d==="rename"||p!==h){const k=setTimeout(async()=>{const y=await E.Promises.exists(n);o.token.isCancellationRequested||(y?(this.J({resource:g,type:0,cId:this.r.correlationId},!0),t.add(await this.F(n,!1))):this.I(g))},u.a);t.clear(),t.add((0,M.$Sc)(()=>clearTimeout(k)))}else this.J({resource:g,type:0,cId:this.r.correlationId},!0)})}catch(g){o.token.isCancellationRequested||this.N(`Failed to watch ${n} for changes using fs.watch() (${g.toString()})`),this.C()}}I(n){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:n,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(n,i=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(s=>s(n.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(s=>s(n.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}L(n){const i=(0,v.$Jq)(n);if(i.length>0){if(this.y)for(const o of i)this.P(` >> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(n){if(S.$k)return E.Promises.exists(n);try{const i=(0,$.$oc)(n);return(await E.Promises.readdir((0,$.$nc)(n))).some(o=>o===i)}catch(i){return this.P(i),!1}}setVerboseLogging(n){this.y=n}N(n){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}O(n){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}P(n){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Zq=u;async function f(a,n,i,s,o=512){const t=await E.Promises.open(a,"r"),g=Buffer.allocUnsafe(o),h=new L.$me(s);let c,r=!1;const w={path:a,excludes:[],recursive:!1},d=new u(w,void 0,D=>{(async()=>{for(const{type:p}of D)if(p===0){if(r)return;r=!0;try{for(;!h.token.isCancellationRequested;){const{bytesRead:k}=await E.Promises.read(t,g,0,o,null);if(!k||h.token.isCancellationRequested)break;n(g.slice(0,k))}}catch(k){c=new Error(k),h.dispose(!0)}finally{r=!1}}})()});return await d.ready,i(),new Promise((D,p)=>{h.token.onCancellationRequested(async()=>{d.dispose();try{await E.Promises.close(t)}catch(k){c=new Error(k)}c?p(c):D()})})}}),define(ke[255],Ee([1,0,4,35,253,11,254,34]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class $ extends L.$Uq{constructor(A){super(),this.L=A,this.onDidError=l.Event.None,this.watchers=new Set,this.O=!1}async J(A){A=this.W(A);const C=[],m=new Set(Array.from(this.watchers));for(const E of A){const v=this.R(E);v&&(0,N.$ok)(v.request.excludes,E.excludes)&&(0,N.$ok)(v.request.includes,E.includes)?m.delete(v):C.push(E)}C.length&&this.M(`Request to start watching: ${C.map(E=>this.I(E)).join(",")}`),m.size&&this.M(`Request to stop watching: ${Array.from(m).map(E=>this.I(E.request)).join(",")}`);for(const E of m)this.U(E);for(const E of C)this.S(E)}R(A){for(const C of this.watchers)if(typeof A.correlationId=="number"||typeof C.request.correlationId=="number"){if(C.request.correlationId===A.correlationId)return C}else if((0,b.$pg)(C.request.path,A.path,!R.$k))return C}S(A){const C=new M.$Zq(A,this.L,E=>this.a.fire(E),()=>this.c.fire(A),E=>this.b.fire(E),this.O),m={request:A,instance:C};this.watchers.add(m)}async stop(){await super.stop();for(const A of this.watchers)this.U(A)}U(A){this.M("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}W(A){const C=new Map;for(const m of A){const E=R.$k?m.path:m.path.toLowerCase();let v=C.get(m.correlationId);v||(v=new Map,C.set(m.correlationId,v)),v.has(E)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(m)}`),v.set(E,m)}return Array.from(C.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(A){this.O=A;for(const C of this.watchers)C.instance.setVerboseLogging(A)}M(A,C){this.O&&this.b.fire({type:"trace",message:this.Z(A,C)})}N(A){this.b.fire({type:"warn",message:this.Z(A)})}Z(A,C){return C?`[File Watcher (node.js)] ${A} (${this.I(C.request)})`:`[File Watcher (node.js)] ${A}`}}e.$2q=$}),define(ke[256],Ee([1,0,65,255]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class L extends l.$Gq{constructor(M,b,$){super(M,b,$),this.s()}r(M){return M.add(new N.$2q(void 0))}}e.$3q=L}),define(ke[257],Ee([1,0,15,81,194,65]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class M extends R.$Hq{constructor($,S,A){super($,S,A),this.s()}r($){const S=$.add(new L.$Sq(l.$Kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(S.onDidProcessExit(({code:A,signal:C})=>this.t(`terminated by itself with code ${A}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$0h)(S.getChannel("watcher")))}}e.$Tq=M}),define(ke[107],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class l{constructor(...L){this.a=new Map;for(const[R,M]of L)this.set(R,M)}set(L,R){const M=this.a.get(L);return this.a.set(L,R),M}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$oi=l}),define(ke[258],Ee([1,0,8,13,3,106,248,5,107,75]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const A=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$oi,a=!1,n,i=A){this.i=f,this.j=a,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$pi,this),this._globalGraph=i?n?._globalGraph??new M.$6q(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const f of this.g)(0,L.$Oc)(f)&&f.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(f){this.m();const a=new class extends m{dispose(){this.h.delete(a),super.dispose()}}(f,this.j,this,this.l);return this.h.add(a),a}invokeFunction(f,...a){this.m();const n=v.traceInvocation(this.l,f);let i=!1;try{return f({get:o=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(o,n);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{i=!0,n.stop()}}createInstance(f,...a){this.m();let n,i;return f instanceof R.$ni?(n=v.traceCreation(this.l,f.ctor),i=this.o(f.ctor,f.staticArguments.concat(a),n)):(n=v.traceCreation(this.l,f),i=this.o(f,a,n)),n.stop(),i}o(f,a=[],n){const i=b._util.getServiceDependencies(f).sort((t,g)=>t.index-g.index),s=[];for(const t of i){const g=this.s(t.id,n);g||this.y(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(g)}const o=i.length>0?i[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${f.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(f,a.concat(s))}q(f,a){if(this.i.get(f)instanceof R.$ni)this.i.set(f,a);else if(this.k)this.k.q(f,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(f){const a=this.i.get(f);return!a&&this.k?this.k.r(f):a}s(f,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const n=this.r(f);return n instanceof R.$ni?this.u(f,n,a.branch(f,!0)):(a.branch(f,!1),n)}u(f,a,n){if(this.t.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.t.add(f);try{return this.v(f,a,n)}finally{this.t.delete(f)}}v(f,a,n){const i=new M.$6q(t=>t.id.toString());let s=0;const o=[{id:f,desc:a,_trace:n}];for(;o.length;){const t=o.pop();if(i.lookupOrInsertNode(t),s++>1e3)throw new C(i);for(const g of b._util.getServiceDependencies(t.desc.ctor)){const h=this.r(g.id);if(h||this.y(`[createInstance] ${f} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(g.id)),h instanceof R.$ni){const c={id:g.id,desc:h,_trace:t._trace.branch(g.id,!0)};i.insertEdge(t,c),o.push(c)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new C(i);break}for(const{data:g}of t){if(this.r(g.id)instanceof R.$ni){const c=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,c)}i.removeNode(g)}}return this.r(f)}w(f,a,n=[],i,s){if(this.i.get(f)instanceof R.$ni)return this.x(f,a,n,i,s,this.g);if(this.k)return this.k.w(f,a,n,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(f,a,n=[],i,s,o){if(i){const t=new m(void 0,this.j,this,this.l);t.c=String(f);const g=new Map,h=new l.$Jh(()=>{const c=t.o(a,n,s);for(const[r,w]of g){const d=c[r];if(typeof d=="function")for(const D of w)D.disposable=d.apply(c,D.listener)}return g.clear(),o.add(c),c});return new Proxy(Object.create(null),{get(c,r){if(!h.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let D=g.get(r);return D||(D=new S.$5c,g.set(r,D)),(k,y,P)=>{if(h.isInitialized)return h.value[r](k,y,P);{const I={listener:[k,y,P],disposable:void 0},F=D.push(I);return(0,L.$Sc)(()=>{F(),I.disposable?.dispose()})}}}if(r in c)return c[r];const w=h.value;let d=w[r];return typeof d!="function"||(d=d.bind(w),c[r]=d),d},set(c,r,w){return h.value[r]=w,!0},getPrototypeOf(c){return a.prototype}})}else{const t=this.o(a,n,s);return o.add(t),t}}y(f,a){if(a&&console.warn(f),this.j)throw new Error(f)}}e.$7q=m;var E;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(E||(E={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,a){return f?new v(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(f,a){return f?new v(1,a.name):v.c}static{this.f=0}constructor(f,a){this.type=f,this.name=a,this.g=Date.now(),this.h=[]}branch(f,a){const n=new v(3,f.toString());return this.h.push([f,a,n]),n}stop(){const f=Date.now()-this.g;v.f+=f;let a=!1;function n(s,o){const t=[],g=new Array(s+1).join("	");for(const[h,c,r]of o.h)if(c&&r){a=!0,t.push(`${g}CREATES -> ${h}`);const w=n(s+1,r);w&&t.push(w)}else t.push(`${g}uses -> ${h}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(f>2||a)&&v.all.add(i.join(`
`))}}e.$8q=v}),define(ke[12],Ee([1,0,213,47,4,56,3,27,11,23,18,2,37,5]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=u,e.log=a,e.$$j=d,e.$_j=D,e.$ak=p,e.$bk=k,e.$Wj=(0,E.$qi)("logService"),e.$Xj=(0,E.$qi)("loggerService");function v(){return new Date().toISOString()}function u(y){return(0,A.$8f)(y)}var f;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$Zj=f.Info;function a(y,P,I){switch(P){case f.Trace:y.trace(I);break;case f.Debug:y.debug(I);break;case f.Info:y.info(I);break;case f.Warning:y.warn(I);break;case f.Error:y.error(I);break;case f.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(y,P=!1){let I="";for(let F=0;F<y.length;F++){let j=y[F];if(j instanceof Error&&(j=(0,N.$bj)(j,P)),typeof j=="object")try{j=JSON.stringify(j)}catch{}I+=(F>0?" ":"")+j}return I}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new L.$be),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==f.Off&&this.b<=P}}e.$2j=i;class s extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...I){this.f(f.Trace)&&this.g(f.Trace,n([P,...I],!0))}debug(P,...I){this.f(f.Debug)&&this.g(f.Debug,n([P,...I]))}info(P,...I){this.f(f.Info)&&this.g(f.Info,n([P,...I]))}warn(P,...I){this.f(f.Warning)&&this.g(f.Warning,n([P,...I]))}error(P,...I){if(this.f(f.Error))if(P instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=P.stack,this.g(f.Error,n(F))}else this.g(f.Error,n([P,...I]))}flush(){}}e.$3j=s;class o extends i{constructor(P=e.$Zj){super(),this.setLevel(P),this.g=!$.$i}trace(P,...I){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}debug(P,...I){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}info(P,...I){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}warn(P,...I){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,P,...I):console.warn(`[main ${v()}]`,P,...I))}error(P,...I){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,P,...I):console.error(`[main ${v()}]`,P,...I))}flush(){}}e.$4j=o;class t extends i{constructor(P=e.$Zj,I=!0){super(),this.g=I,this.setLevel(P)}trace(P,...I){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...I):console.log(P,...I))}debug(P,...I){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...I):console.log(P,...I))}info(P,...I){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...I):console.log(P,...I))}warn(P,...I){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...I):console.log(P,...I))}error(P,...I){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...I):console.error(P,...I))}flush(){}}e.$5j=t;class g extends i{constructor(P,I=e.$Zj){super(),this.g=P,this.setLevel(I)}trace(P,...I){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(P),...I])}debug(P,...I){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(P),...I])}info(P,...I){this.f(f.Info)&&this.g.log(f.Info,[this.h(P),...I])}warn(P,...I){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(P),...I])}error(P,...I){this.f(f.Error)&&this.g.log(f.Error,[this.h(P),...I])}h(P){return typeof P=="string"?P:(0,N.$bj)(P,this.f(f.Trace))}flush(){}}e.$6j=g;class h extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const I of this.g)I.setLevel(P);super.setLevel(P)}trace(P,...I){for(const F of this.g)F.trace(P,...I)}debug(P,...I){for(const F of this.g)F.debug(P,...I)}info(P,...I){for(const F of this.g)F.info(P,...I)}warn(P,...I){for(const F of this.g)F.warn(P,...I)}error(P,...I){for(const F of this.g)F.error(P,...I)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$7j=h;class c extends M.$Uc{constructor(P,I,F){if(super(),this.h=P,this.j=I,this.b=new b.$Bc,this.c=this.B(new L.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$be),this.onDidChangeVisibility=this.g.event,F)for(const j of F)this.b.set(j.resource,{logger:void 0,info:j})}m(P){return(0,A.$4f)(P)?[...this.b.values()].find(I=>I.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,I){const F=this.n(P),j=(0,A.$4f)(P)?P:I?.id??(0,R.$ej)(F.toString()).toString(16);let z=this.b.get(F)?.logger;const O=I?.logLevel==="always"?f.Trace:I?.logLevel;z||(z=this.s(F,O??this.getLogLevel(F)??this.h,{...I,id:j}));const T={logger:z,info:{resource:F,id:j,logLevel:O,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(T.info),this.b.set(F,T),z}n(P){return(0,A.$4f)(P)?(0,S.$4g)(this.j,`${P}.log`):P}setLogLevel(P,I){if(C.URI.isUri(P)){const F=P,j=I,z=this.b.get(F);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([F,j]))}else{this.h=P;for(const[F,j]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,I){const F=this.m(P);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(P){let I;return P&&(I=this.b.get(P)?.info.logLevel),I??this.h}registerLogger(P){const I=this.b.get(P.resource);I?I.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const I=this.b.get(P);I&&(I.logger&&I.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=c;class r{constructor(){this.onDidChangeLogLevel=new L.$be().event}setLevel(P){}getLevel(){return f.Info}trace(P,...I){}debug(P,...I){}info(P,...I){}warn(P,...I){}error(P,...I){}critical(P,...I){}dispose(){}flush(){}}e.$9j=r;class w extends r{}e.$0j=w;function d(y){if(y.verbose)return f.Trace;if(typeof y.logLevel=="string"){const P=k(y.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Zj}function D(y){switch(y){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function p(y){switch(y){case f.Trace:return{original:"Trace",value:l.localize(0,null)};case f.Debug:return{original:"Debug",value:l.localize(1,null)};case f.Info:return{original:"Info",value:l.localize(2,null)};case f.Warning:return{original:"Warning",value:l.localize(3,null)};case f.Error:return{original:"Error",value:l.localize(4,null)};case f.Off:return{original:"Off",value:l.localize(5,null)}}}function k(y){switch(y){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$ck=new m.$Hj("logLevel",D(f.Info))}),define(ke[259],Ee([1,0,19,8,13,4,3,17,65,12]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class A extends M.$Uc{constructor(m,E){super(),this.a=m,this.b=E,this.c=this.B(new R.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$oh(0)),this.w=[],this.y=this.B(new N.$oh(0))}watch(m,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(m,E):this.z(m,E)}n(m,E){const v={path:this.I(m),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},u=(0,l.$Ub)(this.j,v);return this.r(),(0,M.$Sc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,L.$1)(m))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,$.$Iq)(E)),E=>this.G(E),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const E of this.j)(0,$.$Eq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const E of this.j)(0,$.$Eq)(E)&&m.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,E){const v={path:this.I(m),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},u=(0,l.$Ub)(this.w,v);return this.C(),(0,M.$Sc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,L.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$Iq)(m)),m=>this.G(m),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,b.$ic)(m.fsPath)}}e.$Mq=A}),define(ke[260],Ee([1,0,52,397,8,27,21,4,34,3,17,11,23,98,31,212,32,252,259,47,257,256]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0,(()=>{try{(0,N.gracefulify)(l)}catch(g){console.error(`Error enabling graceful-fs: ${(0,i.$bj)(g)}`)}})();class t extends n.$Mq{static{this.J=!1}constructor(h,c){super(h,c),this.onDidChangeCapabilities=b.Event.None,this.O=new R.$Bc(r=>m.$Ug.getComparisonKey(r)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,C.$k&&(this.L|=1024)),this.L}async stat(h){try{const{stat:c,symbolicLink:r}=await v.SymlinkSupport.stat(this.I(h));return{type:this.N(c,r),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:f.FilePermission.Locked}}catch(c){throw this.gb(c)}}async M(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const c=await v.Promises.readdir(this.I(h),{withFileTypes:!0}),r=[];return await Promise.all(c.map(async w=>{try{let d;w.isSymbolicLink()?d=(await this.stat((0,m.$4g)(h,w.name))).type:d=this.N(w),r.push([w.name,d])}catch(d){this.a.trace(d)}})),r}catch(c){throw this.gb(c)}}N(h,c){let r;return c?.dangling?r=f.FileType.Unknown:h.isFile()?r=f.FileType.File:h.isDirectory()?r=f.FileType.Directory:r=f.FileType.Unknown,c&&(r|=f.FileType.SymbolicLink),r}async P(h){const c=this.I(h);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let r;for(;r=this.O.get(h);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await r.wait();const w=new L.$ph;return this.O.set(h,w),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,S.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.O.get(h)===w&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.O.delete(h)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),w.open()})}async readFile(h,c){let r;try{c?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),r=await this.P(h));const w=this.I(h);return await v.Promises.readFile(w)}catch(w){throw this.gb(w)}finally{r?.dispose()}}Q(h){t.J&&this.a.trace(h)}readFileStream(h,c,r){const w=(0,E.$qe)(d=>M.$Ce.concat(d.map(D=>M.$Ce.wrap(D))).buffer);return(0,a.$Bq)(this,h,w,d=>d.buffer,{...c,bufferSize:256*1024},r),w}async writeFile(h,c,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.R(h)?this.S(h,(0,m.$4g)((0,m.$3g)(h),`${(0,m.$1g)(h)}${r.atomic.postfix}`),c,r):this.U(h,c,r)}async R(h){try{const c=this.I(h),{symbolicLink:r}=await v.SymlinkSupport.stat(c);if(r)return!1}catch{}return!0}async S(h,c,r,w){const d=new S.$Tc;try{d.add(await this.P(h)),d.add(await this.P(c)),await this.U(c,r,w,!0);try{await this.rename(c,h,{overwrite:!0})}catch(D){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{d.dispose()}}async U(h,c,r,w){let d;try{const D=this.I(h);if(!r.create||!r.overwrite){if(await v.Promises.exists(D)){if(!r.overwrite)throw(0,f.$0k)((0,u.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,f.$0k)((0,u.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(h,{create:!0,unlock:r.unlock},w),await this.write(d,0,c,0,c.byteLength)}catch(D){throw await this.hb(h,D)}finally{typeof d=="number"&&await this.close(d)}}static{this.Z=!0}static configureFlushOnWrite(h){t.Z=h}async open(h,c,r){const w=this.I(h);let d;(0,f.$Xk)(c)&&!r&&(d=await this.P(h));let D;try{if((0,f.$Xk)(c)&&c.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(w);k.mode&128||await v.Promises.chmod(w,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let p;if((0,f.$Xk)(c)){if(C.$i)try{await v.Promises.truncate(w,0),p="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}p||(p="w")}else p="r";D=await v.Promises.open(w,p)}catch(p){throw d?.dispose(),(0,f.$Xk)(c)?await this.hb(h,p):this.gb(p)}if(this.W.set(D,0),(0,f.$Xk)(c)&&this.Y.set(D,h),d){const p=this.X.get(D);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${w})`),this.X.set(D,d),p&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${w})`),p.dispose())}return D}async close(h){const c=this.X.get(h);try{if(this.W.delete(h),this.Y.delete(h)&&t.Z)try{await v.Promises.fdatasync(h)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await v.Promises.close(h)}catch(r){throw this.gb(r)}finally{c&&(this.X.get(h)===c&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.X.delete(h)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),c.dispose())}}async read(h,c,r,w,d){const D=this.$(h,c);let p=null;try{p=(await v.Promises.read(h,r,w,d,D)).bytesRead}catch(k){throw this.gb(k)}finally{this.ab(h,D,p)}return p}$(h,c){return c===this.W.get(h)?null:c}ab(h,c,r){const w=this.W.get(h);typeof w=="number"&&(typeof c=="number"||(typeof r=="number"?this.W.set(h,w+r):this.W.delete(h)))}async write(h,c,r,w,d){return(0,L.$Kh)(()=>this.bb(h,c,r,w,d),100,3)}async bb(h,c,r,w,d){const D=this.$(h,c);let p=null;try{p=(await v.Promises.write(h,r,w,d,D)).bytesWritten}catch(k){throw await this.hb(this.Y.get(h),k)}finally{this.ab(h,D,p)}return p}async mkdir(h){try{await v.Promises.mkdir(this.I(h))}catch(c){throw this.gb(c)}}async delete(h,c){try{const r=this.I(h);if(c.recursive){let w;c?.atomic!==!1&&c.atomic.postfix&&(w=(0,A.$kc)((0,A.$nc)(r),`${(0,A.$oc)(r)}${c.atomic.postfix}`)),await v.Promises.rm(r,v.RimRafMode.MOVE,w)}else try{await v.Promises.unlink(r)}catch(w){if(w.code==="EPERM"||w.code==="EISDIR"){let d=!1;try{const{stat:D,symbolicLink:p}=await v.SymlinkSupport.stat(r);d=D.isDirectory()&&!p}catch{}if(d)await v.Promises.rmdir(r);else throw w}else throw w}}catch(r){throw this.gb(r)}}async rename(h,c,r){const w=this.I(h),d=this.I(c);if(w!==d)try{await this.cb(h,c,"move",r.overwrite),await v.Promises.rename(w,d)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,u.localize)(2,null,(0,A.$oc)(w),(0,A.$oc)((0,A.$nc)(d)),D.toString()))),this.gb(D)}}async copy(h,c,r){const w=this.I(h),d=this.I(c);if(w!==d)try{await this.cb(h,c,"copy",r.overwrite),await v.Promises.copy(w,d,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,u.localize)(3,null,(0,A.$oc)(w),(0,A.$oc)((0,A.$nc)(d)),D.toString()))),this.gb(D)}}async cb(h,c,r,w){const d=this.I(h),D=this.I(c);let p=!1;if(!!(this.capabilities&1024)||(p=(0,$.$pg)(d,D,!0)),p){if(r==="copy")throw(0,f.$0k)((0,u.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const y=await this.M(h);if(!y)throw(0,f.$0k)((0,u.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const P=await this.M(c);if(P){if(!w)throw(0,f.$0k)((0,u.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);y.type&f.FileType.File&&P.type&f.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,c){return this.db(h,c,!1)}async db(h,c,r){const w=this.I(h),d=this.I(c),D=!!(this.capabilities&1024);if((0,$.$pg)(w,d,!D))return;const p=new S.$Tc;try{p.add(await this.P(h)),p.add(await this.P(c)),r&&await v.Promises.mkdir((0,A.$nc)(d),{recursive:!0}),await v.Promises.copyFile(w,d)}catch(k){if(k.code==="ENOENT"&&!r)return this.db(h,c,!0);throw this.gb(k)}finally{p.dispose()}}t(h,c,r){return new s.$Tq(w=>h(w),w=>c(w),r)}F(h,c,r){return new o.$3q(w=>h(w),w=>c(w),r)}gb(h){if(h instanceof f.$9k)return h;let c=h,r;switch(h.code){case"ENOENT":r=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=f.FileSystemProviderErrorCode.Unknown;break;default:r=f.FileSystemProviderErrorCode.Unknown}return(0,f.$0k)(c,r)}async hb(h,c){let r=this.gb(c);if(h&&r.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await v.SymlinkSupport.stat(this.I(h));w.mode&128||(r=(0,f.$0k)(c,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.a.trace(w)}return r}}e.$4q=t}),define(ke[261],Ee([1,0,3,12]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0;class L extends l.$Uc{constructor(M,b=[]){super(),this.a=new N.$7j([M,...b]),this.B(M.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$AQ=L}),define(ke[262],Ee([1,0,32,12]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=void 0;var L;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(L||(L={}));async function R(S,A,C,m,E){try{const v=await new Promise((f,a)=>{le(["@vscode/spdlog"],f,a)});v.setFlushOn(L.Trace);const u=await v.createAsyncRotatingLogger(S,A,C,m);return E?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(v){console.error(v)}return null}function M(S,A,C){switch(A){case N.LogLevel.Trace:S.trace(C);break;case N.LogLevel.Debug:S.debug(C);break;case N.LogLevel.Info:S.info(C);break;case N.LogLevel.Warning:S.warn(C);break;case N.LogLevel.Error:S.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(S,A){switch(A){case N.LogLevel.Trace:S.setLevel(L.Trace);break;case N.LogLevel.Debug:S.setLevel(L.Debug);break;case N.LogLevel.Info:S.setLevel(L.Info);break;case N.LogLevel.Warning:S.setLevel(L.Warning);break;case N.LogLevel.Error:S.setLevel(L.Error);break;case N.LogLevel.Off:S.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends N.$3j{constructor(A,C,m,E,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,C,m,E),this.B(this.onDidChangeLogLevel(u=>{this.r&&b(this.r,u)}))}async s(A,C,m,E){const v=m?6:1,u=30/v*l.$sl.MB,f=await R(A,C,u,v,E);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:a,message:n}of this.m)M(this.r,a,n);this.m=[]}}g(A,C){this.r?M(this.r,A,C):this.getLevel()<=A&&this.m.push({level:A,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$pQ=$}),define(ke[138],Ee([1,0,41,214,5]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var M;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function($){function S(v,u){return u-v}$.compare=S;const A=Object.create(null);A[$.Error]=(0,N.localize)(0,null),A[$.Warning]=(0,N.localize)(1,null),A[$.Info]=(0,N.localize)(2,null);function C(v){return A[v]||""}$.toString=C;function m(v){switch(v){case l.default.Error:return $.Error;case l.default.Warning:return $.Warning;case l.default.Info:return $.Info;case l.default.Ignore:return $.Hint}}$.fromSeverity=m;function E(v){switch(v){case $.Error:return l.default.Error;case $.Warning:return l.default.Warning;case $.Info:return l.default.Info;case $.Hint:return l.default.Ignore}}$.toSeverity=E}(M||(e.MarkerSeverity=M={}));var b;(function($){const S="";function A(m){return C(m,!0)}$.makeKey=A;function C(m,E){const v=[S];return m.source?v.push(m.source.replace("\xA6","\\\xA6")):v.push(S),m.code?typeof m.code=="string"?v.push(m.code.replace("\xA6","\\\xA6")):v.push(m.code.value.replace("\xA6","\\\xA6")):v.push(S),m.severity!==void 0&&m.severity!==null?v.push(M.toString(m.severity)):v.push(S),m.message&&E?v.push(m.message.replace("\xA6","\\\xA6")):v.push(S),m.startLineNumber!==void 0&&m.startLineNumber!==null?v.push(m.startLineNumber.toString()):v.push(S),m.startColumn!==void 0&&m.startColumn!==null?v.push(m.startColumn.toString()):v.push(S),m.endLineNumber!==void 0&&m.endLineNumber!==null?v.push(m.endLineNumber.toString()):v.push(S),m.endColumn!==void 0&&m.endColumn!==null?v.push(m.endColumn.toString()):v.push(S),v.push(S),v.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$Tt=(0,L.$qi)("markerService")}),define(ke[263],Ee([1,0,4,41,5]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tv=e.Severity=void 0,e.$Uv=b,e.Severity=N.default,e.$Tv=(0,L.$qi)("notificationService");var R;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var M;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function b(C){if(C){const m=C;return typeof m.id=="string"&&typeof m.label=="string"}return!1}var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class S{constructor(){this.progress=new A,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$Vv=S;class A{infinite(){}done(){}total(m){}worked(m){}}e.$Wv=A}),define(ke[264],Ee([1,0,51]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const R=L.context.configuration();if(R)N=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,l.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:R.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[139],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,l.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(le,e){return function(l,N){e(l,N,le)}};define(ke[108],Ee([1,0,8,22,3,5]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.ProgressLocation=e.$Xv=void 0,e.$Xv=(0,R.$qi)("progressService");var M;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Yv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$Zv=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const E=this.d;this.d=()=>{E?.(),m()}}):Promise.resolve()}}e.$1v=$;let S=class extends L.$Uc{constructor(m,E){super(),this.a=new l.$Nh,E.withProgress(m,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,L.$Sc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$2v=S,e.$2v=S=Je([qe(1,e.$Xv)],S);class A extends L.$Uc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new L.$Tc)}start(m){this.stop();const E=++this.a,v=new N.$me;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,L.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Sc)(()=>v.cancel())),this.b.add((0,L.$Sc)(()=>this.c?this.c.done():void 0)),{id:E,token:v.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$3v=A,e.$4v=(0,R.$qi)("editorProgressService")}),define(ke[38],Ee([1,0,62,18]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class L{constructor(){this.a=new Map}add(M,b){l.ok(N.$4f(M)),l.ok(N.$6f(b)),l.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$9n=new L}),define(ke[109],Ee([1,0,4,38]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new l.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,S){this.a[L($)]=S,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;N.$9n.add(e.$0n.JSONContribution,M)}),define(ke[85],Ee([1,0,19,4,18,203,54,109,38]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=u,e.$no=f,e.$oo=a,e.$po=i,e.$qo=s;var S;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.$bo={Configuration:"base.contributions.configuration"};var A;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const C=$.$9n.as(b.$0n.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$io,this.g),this.v()}registerConfiguration(t,g=!0){this.registerConfigurations([t],g)}registerConfigurations(t,g=!0){const h=new Set;this.n(t,g,h),C.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:h})}deregisterConfigurations(t){const g=new Set;this.o(t,g),C.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:t,remove:g}){const h=new Set;this.o(g,h),this.n(t,!1,h),C.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:h})}registerDefaultConfigurations(t){const g=new Set;this.k(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(t,g){const h=[];for(const{overrides:c,source:r}of t)for(const w in c)if(g.add(w),e.$lo.test(w)){const d=this.a.get(w),D=d?.valuesSources??new Map;if(r)for(const P of Object.keys(c[w]))D.set(P,r);const p={...d?.value||{},...c[w]};this.a.set(w,{source:r,value:p,valuesSources:D});const k=(0,M.$7i)(w),y={type:"object",default:p,description:R.localize(1,null,k),$ref:e.$io,defaultDefaultValue:p,source:L.$4f(r)?void 0:r,defaultValueSource:r};h.push(...u(w)),this.d[w]=y,this.b.properties[w]=y}else{this.a.set(w,{value:c[w],source:r});const d=this.d[w];d&&(this.w(w,d),this.r(w,d))}this.m(h)}deregisterDefaultConfigurations(t){const g=new Set;this.l(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(t,g){for(const{overrides:h,source:c}of t)for(const r in h){const w=this.a.get(r),d=L.$4f(c)?c:c?.id,D=L.$4f(w?.source)?w?.source:w?.source?.id;if(d===D)if(g.add(r),this.a.delete(r),e.$lo.test(r))delete this.d[r],delete this.b.properties[r];else{const p=this.d[r];p&&(this.w(r,p),this.r(r,p))}}this.u()}deltaConfiguration(t){let g=!1;const h=new Set;t.removedDefaults&&(this.l(t.removedDefaults,h),g=!0),t.addedDefaults&&(this.k(t.addedDefaults,h),g=!0),t.removedConfigurations&&this.o(t.removedConfigurations,h),t.addedConfigurations&&this.n(t.addedConfigurations,!1,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const g of t)this.h.add(g);this.u()}n(t,g,h){t.forEach(c=>{this.p(c,g,c.extensionInfo,c.restrictedProperties,void 0,h),this.c.push(c),this.q(c)})}o(t,g){const h=c=>{if(c.properties)for(const r in c.properties){g.add(r);const w=this.d[r];w?.policy?.name&&this.e.delete(w.policy.name),delete this.d[r],this.s(r,c.properties[r])}c.allOf?.forEach(r=>h(r))};for(const c of t){h(c);const r=this.c.indexOf(c);r!==-1&&this.c.splice(r,1)}}p(t,g=!0,h,c,r=3,w){r=L.$ag(t.scope)?r:t.scope;const d=t.properties;if(d)for(const p in d){const k=d[p];if(g&&i(p,k)){delete d[p];continue}if(k.source=h,k.defaultDefaultValue=d[p].default,this.w(p,k),e.$lo.test(p)?k.scope=void 0:(k.scope=L.$ag(k.scope)?r:k.scope,k.restricted=L.$ag(k.restricted)?!!c?.includes(p):k.restricted),d[p].hasOwnProperty("included")&&!d[p].included){this.f[p]=d[p],delete d[p];continue}else this.d[p]=d[p],d[p].policy?.name&&this.e.set(d[p].policy.name,p);!d[p].deprecationMessage&&d[p].markdownDeprecationMessage&&(d[p].deprecationMessage=d[p].markdownDeprecationMessage),w.add(p)}const D=t.allOf;if(D)for(const p of D)this.p(p,g,h,c,r,w)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const g=h=>{const c=h.properties;if(c)for(const w in c)this.r(w,c[w]);h.allOf?.forEach(g)};g(t)}r(t,g){switch(e.$co.properties[t]=g,g.scope){case 1:e.$do.properties[t]=g;break;case 2:e.$eo.properties[t]=g;break;case 6:e.$fo.properties[t]=g;break;case 3:e.$go.properties[t]=g;break;case 4:e.$ho.properties[t]=g;break;case 5:e.$ho.properties[t]=g,this.g.properties[t]=g;break}}s(t,g){switch(delete e.$co.properties[t],g.scope){case 1:delete e.$do.properties[t];break;case 2:delete e.$eo.properties[t];break;case 6:delete e.$fo.properties[t];break;case 3:delete e.$go.properties[t];break;case 4:case 5:delete e.$ho.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const g=`[${t}]`,h={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$io};this.w(g,h),e.$co.properties[g]=h,e.$do.properties[g]=h,e.$eo.properties[g]=h,e.$fo.properties[g]=h,e.$go.properties[g]=h,e.$ho.properties[g]=h}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=t,e.$do.patternProperties[e.$ko]=t,e.$eo.patternProperties[e.$ko]=t,e.$fo.patternProperties[e.$ko]=t,e.$go.patternProperties[e.$ko]=t,e.$ho.patternProperties[e.$ko]=t,this.i.fire()}w(t,g){const h=this.a.get(t);let c=h?.value,r=h?.source;L.$$f(c)&&(c=g.defaultDefaultValue,r=void 0),L.$$f(c)&&(c=a(g.type)),g.default=c,g.defaultValueSource=r}}const E="\\[([^\\]]+)\\]",v=new RegExp(E,"g");e.$ko=`^(${E})+$`,e.$lo=new RegExp(e.$ko);function u(o){const t=[];if(e.$lo.test(o)){let g=v.exec(o);for(;g?.length;){const h=g[1].trim();h&&t.push(h),g=v.exec(o)}}return(0,l.$Mb)(t)}function f(o){return o.reduce((t,g)=>`${t}[${g}]`,"")}function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new m;$.$9n.add(e.$bo.Configuration,n);function i(o,t){return o.trim()?e.$lo.test(o)?R.localize(7,null,o):n.getConfigurationProperties()[o]!==void 0?R.localize(8,null,o):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,o,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function s(){const o=[],t=n.getConfigurationProperties();for(const g of Object.keys(t))o.push([g,t[g].scope]);return o.push(["launch",4]),o.push(["task",4]),o}}),define(ke[265],Ee([1,0,19,4,164,3,27,24,18,2,54,85,38]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=i;function E(g){return Object.isFrozen(g)?g:b.$Xn(g)}class v{static createEmptyModel(h){return new v({},[],[],void 0,h)}constructor(h,c,r,w,d){this.b=h,this.c=c,this.d=r,this.raw=w,this.f=d,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const h=this.raw.map(c=>{if(c instanceof v)return c;const r=new u("",this.f);return r.parseRaw(c),r.configurationModel});this.g=h.reduce((c,r)=>r===c?r:c.merge(r),h[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(h){return h?(0,A.$5i)(this.contents,h):this.contents}inspect(h,c){const r=this;return{get value(){return E(r.rawConfiguration.getValue(h))},get override(){return c?E(r.rawConfiguration.getOverrideValue(h,c)):void 0},get merged(){return E(c?r.rawConfiguration.override(c).getValue(h):r.rawConfiguration.getValue(h))},get overrides(){const w=[];for(const{contents:d,identifiers:D,keys:p}of r.rawConfiguration.overrides){const k=new v(d,p,[],void 0,r.f).getValue(h);k!==void 0&&w.push({identifiers:D,value:k})}return w.length?E(w):void 0}}}getOverrideValue(h,c){const r=this.j(c);return r?h?(0,A.$5i)(r,h):r:void 0}getKeysForOverrideIdentifier(h){const c=[];for(const r of this.overrides)r.identifiers.includes(h)&&c.push(...r.keys);return l.$Mb(c)}getAllOverrideIdentifiers(){const h=[];for(const c of this.overrides)h.push(...c.identifiers);return l.$Mb(h)}override(h){let c=this.a.get(h);return c||(c=this.h(h),this.a.set(h,c)),c}merge(...h){const c=b.$Wn(this.contents),r=b.$Wn(this.overrides),w=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const D of h)if(d.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(c,D.contents);for(const p of D.overrides){const[k]=r.filter(y=>l.$ub(y.identifiers,p.identifiers));k?(this.i(k.contents,p.contents),k.keys.push(...p.keys),k.keys=l.$Mb(k.keys)):r.push(b.$Wn(p))}for(const p of D.keys)w.indexOf(p)===-1&&w.push(p)}return new v(c,w,r,d.every(D=>D instanceof v)?void 0:d,this.f)}h(h){const c=this.j(h);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const r={};for(const w of l.$Mb([...Object.keys(this.contents),...Object.keys(c)])){let d=this.contents[w];const D=c[w];D&&(typeof d=="object"&&typeof D=="object"?(d=b.$Wn(d),this.i(d,D)):d=D),r[w]=d}return new v(r,this.keys,this.overrides,void 0,this.f)}i(h,c){for(const r of Object.keys(c)){if(r in h&&$.$6f(h[r])&&$.$6f(c[r])){this.i(h[r],c[r]);continue}h[r]=b.$Wn(c[r])}}j(h){let c=null,r=null;const w=d=>{d&&(r?this.i(r,d):r=b.$Wn(d))};for(const d of this.overrides)d.identifiers.length===1&&d.identifiers[0]===h?c=d.contents:d.identifiers.includes(h)&&w(d.contents);return w(c),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(h,c){this.k(h,c,!0)}setValue(h,c){this.k(h,c,!1)}removeValue(h){const c=this.keys.indexOf(h);c!==-1&&(this.keys.splice(c,1),(0,A.$4i)(this.contents,h),C.$lo.test(h)&&this.overrides.splice(this.overrides.findIndex(r=>l.$ub(r.identifiers,(0,C.$mo)(h))),1))}k(h,c,r){(0,A.$3i)(this.contents,h,c,w=>this.f.error(w)),r=r||this.keys.indexOf(h)===-1,r&&this.keys.push(h),C.$lo.test(h)&&this.overrides.push({identifiers:(0,C.$mo)(h),keys:Object.keys(this.contents[h]),contents:(0,A.$2i)(this.contents[h],w=>this.f.error(w))})}}e.$ro=v;class u{constructor(h,c){this.f=h,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||v.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(h,c){if(!$.$ag(h)){const r=this.h(h);this.parseRaw(r,c)}}reparse(h){this.a&&this.parseRaw(this.a,h)}parseRaw(h,c){this.a=h;const{contents:r,keys:w,overrides:d,restricted:D,hasExcludedProperties:p}=this.i(h,c);this.b=new v(r,w,d,p?[h]:void 0,this.g),this.c=D||[]}h(h){let c={},r=null,w=[];const d=[],D=[];function p(y){Array.isArray(w)?w.push(y):r!==null&&(w[r]=y)}const k={onObjectBegin:()=>{const y={};p(y),d.push(w),w=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{w=d.pop()},onArrayBegin:()=>{const y=[];p(y),d.push(w),w=y,r=null},onArrayEnd:()=>{w=d.pop()},onLiteralValue:p,onError:(y,P,I)=>{D.push({error:y,offset:P,length:I})}};if(h)try{L.$Kn(h,k),c=w[0]||{}}catch(y){this.g.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return c}i(h,c){const r=m.$9n.as(C.$bo.Configuration).getConfigurationProperties(),w=this.j(h,r,!0,c);h=w.raw;const d=(0,A.$2i)(h,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(h),p=this.l(h,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:d,keys:D,overrides:p,restricted:w.restricted,hasExcludedProperties:w.hasExcludedProperties}}j(h,c,r,w){let d=!1;if(!w?.scopes&&!w?.skipRestricted&&!w?.exclude?.length)return{raw:h,restricted:[],hasExcludedProperties:d};const D={},p=[];for(const k in h)if(C.$lo.test(k)&&r){const y=this.j(h[k],c,!1,w);D[k]=y.raw,d=d||y.hasExcludedProperties,p.push(...y.restricted)}else{const y=c[k],P=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&p.push(k),!w.exclude?.includes(k)&&(w.include?.includes(k)||(P===void 0||w.scopes===void 0||w.scopes.includes(P))&&!(w.skipRestricted&&y?.restricted))?D[k]=h[k]:d=!0}return{raw:D,restricted:p,hasExcludedProperties:d}}l(h,c){const r=[];for(const w of Object.keys(h))if(C.$lo.test(w)){const d={};for(const D in h[w])d[D]=h[w][D];r.push({identifiers:(0,C.$mo)(w),keys:Object.keys(d),contents:(0,A.$2i)(d,c)})}return r}}e.$so=u;class f extends R.$Uc{constructor(h,c,r,w,d){super(),this.c=h,this.f=c,this.g=w,this.h=d,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new u(this.c.toString(),d),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&r.isEqual(D.resource,h)))(()=>this.b.fire()))}async loadConfiguration(){try{const h=await this.g.readFile(this.c);return this.a.parse(h.value.toString()||"{}",this.f),this.a.configurationModel}catch{return v.createEmptyModel(this.h)}}reparse(h){return h&&(this.f=h),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=f;class a{constructor(h,c,r,w,d,D,p,k,y,P,I,F,j){this.a=h,this.b=c,this.c=r,this.overrideIdentifiers=w,this.d=d,this.f=D,this.g=p,this.h=k,this.i=y,this.j=P,this.k=I,this.l=F,this.m=j}get value(){return E(this.c)}n(h){return h?.value!==void 0||h?.override!==void 0||h?.overrides!==void 0?h:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(h,c,r,w,d,D,p,k,y,P){this.j=h,this.l=c,this.m=r,this.n=w,this.p=d,this.q=D,this.r=p,this.s=k,this.t=y,this.u=P,this.h=null,this.i=new M.$Bc,this.v=null}getValue(h,c,r){return this.w(h,c,r).getValue(h)}updateValue(h,c,r={}){let w;r.resource?(w=this.t.get(r.resource),w||(w=v.createEmptyModel(this.u),this.t.set(r.resource,w))):w=this.s,c===void 0?w.removeValue(h):w.setValue(h,c),r.resource||(this.h=null)}inspect(h,c,r){const w=this.w(h,c,r),d=this.A(c.resource,r),D=c.resource?this.t.get(c.resource)||this.s:this.s,p=new Set;for(const k of w.overrides)for(const y of k.identifiers)w.getOverrideValue(h,y)!==void 0&&p.add(y);return new a(h,c,w.getValue(h),p.size?[...p]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,d||void 0,D)}keys(h){const c=this.A(void 0,h);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(h){this.j=h,this.h=null,this.i.clear()}updatePolicyConfiguration(h){this.l=h}updateApplicationConfiguration(h){this.m=h,this.h=null,this.i.clear()}updateLocalUserConfiguration(h){this.n=h,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(h){this.p=h,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(h){this.q=h,this.h=null,this.i.clear()}updateFolderConfiguration(h,c){this.r.set(h,c),this.i.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this.i.delete(h)}compareAndUpdateDefaultConfiguration(h,c){const r=[];if(!c){const{added:w,updated:d,removed:D}=o(this.j,h);c=[...w,...d,...D]}for(const w of c)for(const d of(0,C.$mo)(w)){const D=this.j.getKeysForOverrideIdentifier(d),p=h.getKeysForOverrideIdentifier(d),k=[...p.filter(y=>D.indexOf(y)===-1),...D.filter(y=>p.indexOf(y)===-1),...D.filter(y=>!b.$1n(this.j.override(d).getValue(y),h.override(d).getValue(y)))];r.push([d,k])}return this.updateDefaultConfiguration(h),{keys:c,overrides:r}}compareAndUpdatePolicyConfiguration(h){const{added:c,updated:r,removed:w}=o(this.l,h),d=[...c,...r,...w];return d.length&&this.updatePolicyConfiguration(h),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:c,updated:r,removed:w,overrides:d}=o(this.applicationConfiguration,h),D=[...c,...r,...w];return D.length&&this.updateApplicationConfiguration(h),{keys:D,overrides:d}}compareAndUpdateLocalUserConfiguration(h){const{added:c,updated:r,removed:w,overrides:d}=o(this.localUserConfiguration,h),D=[...c,...r,...w];return D.length&&this.updateLocalUserConfiguration(h),{keys:D,overrides:d}}compareAndUpdateRemoteUserConfiguration(h){const{added:c,updated:r,removed:w,overrides:d}=o(this.remoteUserConfiguration,h),D=[...c,...r,...w];return D.length&&this.updateRemoteUserConfiguration(h),{keys:D,overrides:d}}compareAndUpdateWorkspaceConfiguration(h){const{added:c,updated:r,removed:w,overrides:d}=o(this.workspaceConfiguration,h),D=[...c,...r,...w];return D.length&&this.updateWorkspaceConfiguration(h),{keys:D,overrides:d}}compareAndUpdateFolderConfiguration(h,c){const r=this.folderConfigurations.get(h),{added:w,updated:d,removed:D,overrides:p}=o(r,c),k=[...w,...d,...D];return(k.length||!r)&&this.updateFolderConfiguration(h,c),{keys:k,overrides:p}}compareAndDeleteFolderConfiguration(h){const c=this.folderConfigurations.get(h);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:r,updated:w,removed:d,overrides:D}=o(c,void 0);return{keys:[...r,...w,...d],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(h,c,r){let w=this.x(c,r);return c.overrideIdentifier&&(w=w.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(h)!==void 0&&(w=w.merge(this.l)),w}x({resource:h},c){let r=this.y();if(c&&h){const w=c.getFolder(h);w&&(r=this.z(w.uri)||r);const d=this.t.get(h);d&&(r=r.merge(d))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(h){let c=this.i.get(h);if(!c){const r=this.y(),w=this.r.get(h);w?(c=r.merge(w),this.i.set(h,c)):c=r}return c}A(h,c){if(c&&h){const r=c.getFolder(h);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((h,c)=>{const{contents:r,overrides:w,keys:d}=this.r.get(c);return h.push([c,{contents:r,overrides:w,keys:d}]),h},[])}}allKeys(){const h=new Set;return this.j.keys.forEach(c=>h.add(c)),this.userConfiguration.keys.forEach(c=>h.add(c)),this.q.keys.forEach(c=>h.add(c)),this.r.forEach(c=>c.keys.forEach(r=>h.add(r))),[...h.values()]}B(){const h=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>h.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>h.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>h.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(r=>h.add(r))),[...h.values()]}D(h){const c=new Set;return this.j.getKeysForOverrideIdentifier(h).forEach(r=>c.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(r=>c.add(r)),this.q.getKeysForOverrideIdentifier(h).forEach(r=>c.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(h).forEach(w=>c.add(w))),[...c.values()]}static parse(h,c){const r=this.E(h.defaults,c),w=this.E(h.policy,c),d=this.E(h.application,c),D=this.E(h.user,c),p=this.E(h.workspace,c),k=h.folders.reduce((y,P)=>(y.set(S.URI.revive(P[0]),this.E(P[1],c)),y),new M.$Bc);return new n(r,w,d,D,v.createEmptyModel(c),p,k,v.createEmptyModel(c),new M.$Bc,c)}static E(h,c){return new v(h.contents,h.keys,h.overrides,void 0,c)}}e.$uo=n;function i(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const h=new Set,c=new Map;for(const w of g)w.keys.forEach(d=>h.add(d)),w.overrides.forEach(([d,D])=>{const p=(0,M.$yc)(c,d,new Set);D.forEach(k=>p.add(k))});const r=[];return c.forEach((w,d)=>r.push([d,[...w.values()]])),{keys:[...h.values()],overrides:r}}class s{constructor(h,c,r,w,d){this.change=h,this.f=c,this.g=r,this.h=w,this.i=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of h.keys)this.affectedKeys.add(D);for(const[,D]of h.overrides)for(const p of D)this.affectedKeys.add(p);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(h,c){const r=this.a+h,w=this.d.indexOf(r);if(w<0)return!1;const d=w+r.length;if(d>=this.d.length)return!1;const D=this.d.charCodeAt(d);if(D!==this.b&&D!==this.c)return!1;if(c){const p=this.previousConfiguration?this.previousConfiguration.getValue(h,c,this.f?.workspace):void 0,k=this.g.getValue(h,c,this.h);return!b.$1n(p,k)}return!0}}e.$wo=s;function o(g,h){const{added:c,removed:r,updated:w}=t(h?.rawConfiguration,g?.rawConfiguration),d=[],D=g?.getAllOverrideIdentifiers()||[],p=h?.getAllOverrideIdentifiers()||[];if(h){const k=p.filter(y=>!D.includes(y));for(const y of k)d.push([y,h.getKeysForOverrideIdentifier(y)])}if(g){const k=D.filter(y=>!p.includes(y));for(const y of k)d.push([y,g.getKeysForOverrideIdentifier(y)])}if(h&&g){for(const k of D)if(p.includes(k)){const y=t({contents:g.getOverrideValue(void 0,k)||{},keys:g.getKeysForOverrideIdentifier(k)},{contents:h.getOverrideValue(void 0,k)||{},keys:h.getKeysForOverrideIdentifier(k)});d.push([k,[...y.added,...y.removed,...y.updated]])}}return{added:c,removed:r,updated:w,overrides:d}}function t(g,h){const c=g?h?g.keys.filter(d=>h.keys.indexOf(d)===-1):[...g.keys]:[],r=h?g?h.keys.filter(d=>g.keys.indexOf(d)===-1):[...h.keys]:[],w=[];if(g&&h){for(const d of h.keys)if(g.keys.indexOf(d)!==-1){const D=(0,A.$5i)(h.contents,d),p=(0,A.$5i)(g.contents,d);b.$1n(D,p)||w.push(d)}}return{added:c,removed:r,updated:w}}}),define(ke[266],Ee([1,0,21,4,3,82]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zsb=e.$xsb=e.$wsb=void 0,e.$ysb=b;const M=(S,A,C)=>{const m=new Uint8Array(16);for(let u=0;u<16;u++)m[u]=Math.round(Math.random()*256);const E=(0,l.$We)(l.$Ce.wrap(m));return[`GET ws://localhost${S}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$wsb=M,e.$xsb=l.$Ce.fromString(`\r
\r
`);async function b(S,A,C,m,E){S.write(l.$Ce.fromString((0,e.$wsb)(A,C,m)));const v=new L.$Tc;try{return await new Promise((u,f)=>{let a;v.add(S.onData(n=>{a?a=l.$Ce.concat([a,n],a.byteLength+n.byteLength):a=n;const i=a.indexOf(e.$xsb);if(i===-1)return;u(S),S.pauseData();const s=a.slice(i+e.$xsb.byteLength);s.byteLength&&E.onData.fire(s)})),v.add(S.onClose(n=>f(n??new Error("socket closed")))),v.add(S.onEnd(()=>f(new Error("socket ended"))))})}catch(u){throw S.dispose(),u}finally{v.dispose()}}class $ extends L.$Uc{constructor(A,C){super(),this.g=A,this.a=this.B(new N.$ee),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new N.$be),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,C){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$zsb=$}),define(ke[66],Ee([1,0,13,5]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=S,e.$Bl=(0,N.$qi)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class R{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=R;class M{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=M;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends l.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,E){super(C),this._message=C,this._code=m,this._detail=E,this.isHandled=m===b.NotAvailable&&E===!0,Object.setPrototypeOf(this,$.prototype)}}e.$El=$;function S(A){const C=A.indexOf("+");return C===-1?A:A.substring(0,C)}}),define(ke[267],Ee([1,0,8,21,22,13,4,3,15,59,40,30,82,66]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Kl=D,e.$Ll=p,e.$Ml=y;const v=30*1e3;var u;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(u||(e.ConnectionType=u={}));function f(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(_){const U=new L.$me;return setTimeout(()=>U.cancel(),_),U.token}function n(_,U){if(_.isCancellationRequested||U.isCancellationRequested)return L.CancellationToken.Cancelled;const ne=new L.$me;return _.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,l.$jh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function s(_,U){const ne=new i(U);return ne.registerDisposable(_.onControlMessage($e=>{const Pe=JSON.parse($e.toString()),se=Z(Pe);se?ne.reject(se):ne.resolve(Pe)})),ne.promise}function o(_,U,ne,$e,Pe,se,re,oe){const G=new i(oe),ie=A.$0d.create(!1);return _.info(`Creating a socket (${re})...`),S.mark(`code/willCreateSocket/${se}`),U.connect(ne,$e,Pe,re).then(me=>{G.didTimeout?(S.mark(`code/didCreateSocketError/${se}`),_.info(`Creating a socket (${re}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),me?.dispose()):(S.mark(`code/didCreateSocketOK/${se}`),_.info(`Creating a socket (${re}) was successful after ${ie.elapsed()} ms.`),G.resolve(me))},me=>{S.mark(`code/didCreateSocketError/${se}`),_.info(`Creating a socket (${re}) returned an error after ${ie.elapsed()} ms.`),_.error(me),G.reject(me)}),G.promise}function t(_,U){const ne=new i(U);return _.then($e=>{ne.didTimeout||ne.resolve($e)},$e=>{ne.didTimeout||ne.reject($e)}),ne.promise}async function g(_,U,ne,$e){const Pe=we(_,U);_.logService.trace(`${Pe} 1/6. invoking socketFactory.connect().`);let se;try{se=await o(_.logService,_.remoteSocketFactoryService,_.connectTo,$.$Dg.getServerRootPath(),`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,f(U),`renderer-${f(U)}-${_.reconnectionToken}`,$e)}catch(me){throw _.logService.error(`${Pe} socketFactory.connect() failed or timed out. Error:`),_.logService.error(me),me}_.logService.trace(`${Pe} 2/6. socketFactory.connect() was successful.`);let re,oe;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(se,null),re=_.reconnectionProtocol,oe=!1):(re=new m.$ei({socket:se}),oe=!0),_.logService.trace(`${Pe} 3/6. sending AuthRequest control message.`);const G=await t(_.signService.createNewMessage((0,C.$Mg)()),$e),ie={type:"auth",auth:_.connectionToken||"00000000000000000000",data:G.data};re.sendControl(N.$Ce.fromString(JSON.stringify(ie)));try{const me=await s(re,n($e,a(1e4)));if(me.type!=="sign"||typeof me.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(_.logService.trace(`${Pe} 4/6. received SignRequest control message.`),!await t(_.signService.validate(G,me.signedData),$e)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ae=await t(_.signService.sign(me.data),$e),fe={type:"connectionType",commit:_.commit,signedData:Ae,desiredConnectionType:U};return ne&&(fe.args=ne),_.logService.trace(`${Pe} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(N.$Ce.fromString(JSON.stringify(fe))),{protocol:re,ownsProtocol:oe}}catch(me){throw me&&me.code==="ETIMEDOUT"&&(_.logService.error(`${Pe} the handshake timed out. Error:`),_.logService.error(me)),me&&me.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${Pe} received error control message when negotiating connection. Error:`),_.logService.error(me)),oe&&x(re),me}}async function h(_,U,ne,$e){const Pe=Date.now(),se=we(_,U),{protocol:re,ownsProtocol:oe}=await g(_,U,ne,$e),G=new i($e);return G.registerDisposable(re.onControlMessage(ie=>{const me=JSON.parse(ie.toString()),be=Z(me);be?(_.logService.error(`${se} received error control message when negotiating connection. Error:`),_.logService.error(be),oe&&x(re),G.reject(be)):(_.reconnectionProtocol?.endAcceptReconnection(),_.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${Se(Pe)}!`),G.resolve({protocol:re,firstMessage:me}))})),G.promise}async function c(_,U){const{protocol:ne}=await h(_,1,void 0,U);return{protocol:ne}}async function r(_,U,ne){const{protocol:$e,firstMessage:Pe}=await h(_,2,U,ne),se=Pe&&Pe.debugPort;return{protocol:$e,debugPort:se}}async function w(_,U,ne){const $e=Date.now(),Pe=we(_,3),{protocol:se}=await g(_,3,U,ne);return _.logService.trace(`${Pe} 6/6. handshake finished, connection is up and running after ${Se($e)}!`),se}async function d(_,U,ne){const{connectTo:$e,connectionToken:Pe}=await _.addressProvider.getAddress();return{commit:_.commit,quality:_.quality,connectTo:$e,connectionToken:Pe,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:_.remoteSocketFactoryService,signService:_.signService,logService:_.logService}}async function D(_,U,ne){return k(_,async $e=>{const{protocol:Pe}=await c($e,L.CancellationToken.None);return new W(_,U,ne,$e.reconnectionToken,Pe)})}async function p(_,U){return k(_,async ne=>{const{protocol:$e,debugPort:Pe}=await r(ne,U,L.CancellationToken.None);return new X(_,U,ne.reconnectionToken,$e,Pe)})}async function k(_,U){for(let $e=1;;$e++)try{const Pe=(0,C.$Mg)(),se=await d(_,Pe,null);return await U(se)}catch(Pe){if($e<5)_.logService.error(`[remote-connection][attempt ${$e}] An error occurred in initial connection! Will retry... Error:`),_.logService.error(Pe);else throw _.logService.error(`[remote-connection][attempt ${$e}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),_.logService.error(Pe),B.triggerPermanentFailure(0,0,E.$El.isHandled(Pe)),Pe}}async function y(_,U,ne){const $e=await d(_,(0,C.$Mg)(),null);return await w($e,{host:U,port:ne},L.CancellationToken.None)}function P(_){return(0,l.$dh)(U=>new Promise((ne,$e)=>{const Pe=setTimeout(ne,_*1e3);U.onCancellationRequested(()=>{clearTimeout(Pe),ne()})}))}var I;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class F{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$Nl=F;class j{constructor(U,ne,$e,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=$e,this.c=Pe,this.type=1}skipWait(){this.c.cancel()}}e.$Ol=j;class z{constructor(U,ne,$e){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=$e,this.type=2}}e.$Pl=z;class O{constructor(U,ne,$e){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=$e,this.type=4}}e.$Ql=O;class T{constructor(U,ne,$e,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=$e,this.handled=Pe,this.type=3}}e.$Rl=T;class B extends b.$Uc{static triggerPermanentFailure(U,ne,$e){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=$e,this.j.forEach(Pe=>Pe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ne,$e,Pe,se){super(),this.t=U,this.u=ne,this.reconnectionToken=$e,this.protocol=Pe,this.w=se,this.m=this.B(new M.$be),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(Pe.onSocketClose(re=>{const oe=te(this.t,this.reconnectionToken,!0);re?re.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${re.hadError}).`),re.error&&this.u.logService.error(re.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this.u.logService.error(re.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(Pe.onSocketTimeout(re=>{const oe=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Sc)(()=>{const re=B.j.indexOf(this);re>=0&&B.j.splice(re,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let $e=-1;do{$e++;const Pe=$e<ne.length?ne[$e]:ne[ne.length-1];try{if(Pe>0){const re=P(Pe);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Pe,re)),this.u.logService.info(`${U} waiting for ${Pe} seconds before reconnecting...`);try{await re}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$e+1)),this.u.logService.info(`${U} resolving connection...`);const se=await d(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${se.connectTo}...`),await this.G(se,a(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$e+1));break}catch(se){if(se.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),$e+1,!1);break}if($e>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),$e+1,!1);break}if(E.$El.isTemporarilyNotAvailable(se)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((se.code==="ETIMEDOUT"||se.code==="ENETUNREACH"||se.code==="ECONNREFUSED"||se.code==="ECONNRESET")&&se.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((0,R.$4)(se)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if(se instanceof E.$El){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),$e+1,E.$El.isHandled(se));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),$e+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,$e){this.w?B.triggerPermanentFailure(U,ne,$e):this.D(U,ne,$e)}D(U,ne,$e){this.m.fire(new T(this.reconnectionToken,U,ne,$e)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Sl=B;class W extends B{constructor(U,ne,$e,Pe,se){super(1,U,Pe,se,!0),this.client=this.B(new m.$ci(se,{remoteAuthority:ne,clientId:$e},U.ipcLogger))}async G(U,ne){await c(U,ne)}}e.$Tl=W;class X extends B{constructor(U,ne,$e,Pe,se){super(2,U,$e,Pe,!1),this.H=ne,this.debugPort=se}async G(U,ne){await r(U,this.H,ne)}}e.$Ul=X;function x(_){try{_.acceptDisconnect();const U=_.getSocket();_.dispose(),U.dispose()}catch(U){(0,R.$1)(U)}}function Z(_){if(_&&_.type==="error"){const U=new Error(`Connection error: ${_.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Y(_,U){for(;_.length<U;)_+=" ";return _}function ue(_,U){return`[remote-connection][${Y(f(_),13)}][${U.substr(0,5)}\u2026]`}function te(_,U,ne){return`${ue(_,U)}[${ne?"reconnect":"initial"}]`}function we(_,U){return`${te(U,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.connectTo}]`}function Se(_){return`${Date.now()-_} ms`}}),define(ke[86],Ee([1,0,15]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=N,e.$Cm=L,e.$Dm=R,e.$Em=M;function N($){return $.scheme===l.Schemas.vscodeRemote?$.authority:void 0}function L($){if(!$)return;const S=$.indexOf("+");return S<0?$:$.substr(0,S)}function R($){const{host:S,port:A}=b($);if(typeof A>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:S,port:A}}function M($,S){let{host:A,port:C}=b($);return typeof C>"u"&&(C=S),{host:A,port:C}}function b($){const S=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const A=$.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const C=$.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:$,port:void 0}}}),define(ke[25],Ee([1,0,14,5,86]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=R,e.$Om=C,e.$Pm=m,e.$Qm=E,e.$Rm=v,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function R(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(u){u.WIN32_X64="win32-x64",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,a){if(typeof f>"u"||f===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof f=="string"||typeof a=="string"){const n=typeof f=="string"?f:f.value,i=typeof a=="string"?a:a.value;return l.$tf(n,i)}return f._lower===a._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Lm=$;class S{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const a of f)this.add(a)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$Mm=S;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,a){this.c.set($.toKey(f),a)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=A;function C(u){return m(u)}function m(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}function E(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}function v(u,f){if(f){const a=`onResolveRemoteAuthority:${(0,L.$Cm)(f)}`;return!!u.activationEvents?.includes(a)}return!1}e.$Sm=(0,N.$qi)("IBuiltinExtensionsScannerService")}),define(ke[140],Ee([1,0,13,25]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const $ of M){const S=this.readActivationEvents($);S.length>0&&(b[N.$Lm.toKey($.identifier)]=S)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${N.$Lm.toKey(M.identifier)}`);if(!M.contributes)return b;for(const $ in M.contributes){const S=this.a.get($);if(!S)continue;const A=M.contributes[$],C=Array.isArray(A)?A:[A];try{S(C,b)}catch(m){(0,l.$1)(m)}}return b}}e.$cG=L,e.$dG=new L}),define(ke[268],Ee([1,0,3,5]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=void 0,e.$Gl=(0,N.$qi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(M,b){return this.a[M]??=[],this.a[M].push(b),(0,l.$Sc)(()=>{const $=this.a[M]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[M]?.splice($,1)})}b(M){return(this.a[M.type]||[]).find($=>$.supports(M))}connect(M,b,$,S){const A=this.b(M);if(!A)throw new Error(`No socket factory found for ${M}`);return A.connect(M,b,$,S)}}e.$Hl=L}),define(ke[269],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0b=void 0;class l{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const R=await this.c();if(R){const M=String(l.a++);return this.b.set(M,R),{id:M,data:R.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,R){if(!L.id)return!0;const M=this.b.get(L.id);if(!M)return!1;this.b.delete(L.id);try{return M.validate(R)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$R0b=l}),define(ke[110],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=void 0,e.$Il="signService",e.$Jl=(0,l.$qi)(e.$Il)}),define(ke[141],Ee([1,0,269]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class N extends l.$R0b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(M=>new M.signer().sign(R))}h(){return new Promise((R,M)=>le(["vsda"],R,M))}}e.$Ncc=N}),define(ke[270],Ee([1,0,11,51,30]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=M,e.$$o=b;function R($){if(l.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function M($,S,A,C,m,E,v,u,f){const a=Object.create(null);a["common.machineId"]=E,a["common.sqmId"]=v,a.sessionID=(0,L.$Mg)()+Date.now(),a.commitHash=C,a.version=m,a["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,l.$h)(l.$u),a["common.nodePlatform"]=N.$ec,a["common.nodeArch"]=A,a["common.product"]=f||"desktop",u&&(a["common.msftInternal"]=u);let n=0;const i=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),l.$l&&(a["common.snap"]="true");const s=R(S);return s&&(a["common.platformDetail"]=s),a}function b($){const S=N.env.USERDNSDOMAIN;if(!S)return!1;const A=S.toLowerCase();return $.some(C=>A===C)}}),define(ke[271],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,l.$qi)("telemetryService"),e.$Wl=(0,l.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var N;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ke[87],Ee([1,0,24,18,86,270,271]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=A,e.$hp=C,e.$ip=m,e.$jp=E,e.$kp=u,e.$lp=a,e.$mp=n,e.$np=o;class b{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$_o=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=$,e.$bp=new $;class S{async publicLog(g,h,c){}async publicLogError(g,h,c){}}e.$cp=S,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!t.enableTelemetry)}function C(t,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function m(t){const g=t.getValue(M.$4l),h=t.getValue(M.$5l);if(t.getValue(M.$6l)===!1||h===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function E(t){const g={},h={},c={};f(t,c);for(let r in c){r=r.length>150?r.substr(r.length-149):r;const w=c[r];typeof w=="number"?h[r]=w:typeof w=="boolean"?h[r]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${w.length}`),g[r]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(g[r]=w)}return{properties:g,measurements:h}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const g=(0,L.$Cm)(t);return v.has(g)?g:"other"}function f(t,g,h=0,c){if(t)for(const r of Object.getOwnPropertyNames(t)){const w=t[r],d=c?c+r:r;Array.isArray(w)?g[d]=(0,l.$2n)(w):w instanceof Date?g[d]=w.toISOString():(0,N.$6f)(w)?h<2?f(w,g,h+1,d+"."):g[d]=(0,l.$2n)(w):g[d]=w}}function a(t,g){const h=t.msftInternalDomains||[],c=g.getValue("telemetry.internalTesting");return(0,R.$$o)(h)||c}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,g){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let h=t;const c=[];for(const D of g)for(;;){const p=D.exec(t);if(!p)break;c.push([p.index,D.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(h="";;){const D=w.exec(t);if(!D)break;const p=c.some(([k,y])=>D.index<y&&k<w.lastIndex);!r.test(D[0])&&!p&&(h+=t.substring(d,D.index)+"<REDACTED: user-file-path>",d=w.lastIndex)}return d<t.length&&(h+=t.substr(d)),h}function s(t){if(!t)return t;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of g)if(h.regex.test(t))return`<REDACTED: ${h.label}>`;return t}function o(t,g){return(0,l.$Yn)(t,h=>{if(h instanceof b||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let c=h.replaceAll("%20"," ");c=i(c,g);for(const r of g)c=c.replace(r,"");return c=s(c),c}})}}),define(ke[272],Ee([1,0,14,137,25,11,2,13,51,87]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=A,e.$qp=v,e.$rp=u,e.$sp=f,e.$tp=a,e.$up=n,e.$vp=i,e.$wp=s,e.$yp=o,e.$zp=g;function A(h,c){return h.uuid&&c.uuid?h.uuid===c.uuid:h.id===c.id?!0:(0,l.$of)(h.id,c.id)===0}const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(c){const r=c.manifest?c.manifest.version:c.version,w=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new m(c.identifier,r,w)}static parse(c){const r=C.exec(c);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(c,r,w="undefined"){this.version=r,this.targetPlatform=w,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof m?A(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$pp=m;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(h){const c=E.exec(h);return c&&c[1]?[f(c[1]),c[2]]:[f(h),void 0]}function u(h,c){return`${h}.${c}`}function f(h){return h.toLowerCase()}function a(h,c){return f(u(h??L.$Hm,c))}function n(h,c){const r=[],w=d=>{for(const D of r)if(D.some(p=>A(c(p),c(d))))return D;return null};for(const d of h){const D=w(d);D?D.push(d):r.push([d])}return r}function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}function s(h){return{id:new S.$_o(h.identifier.id),name:new S.$_o(h.name),galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.$xp=new L.$Lm("pprice.better-merge");function o(h,c){const r=[],w=c.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const d=w.shift();if(d&&r.every(D=>!A(D.identifier,{id:d}))){const D=h.filter(p=>A(p.identifier,{id:d}));D.length===1&&(r.push(D[0]),w.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function t(h,c){if(!R.$k)return!1;let r;try{r=(await h.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await h.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){c.debug("Error while getting the os-release file.",(0,b.$0)(d))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(h,c){const r=await t(h,c),w=(0,N.$Vo)(r?"alpine":R.$u,$.$fc);return c.debug("ComputeTargetPlatform:",w),w}}),define(ke[273],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=l,e.$ds=N,e.$es=L,e.$fs=R,e.$gs=M,e.$hs=b;function l($){return[...$.entries()]}function N($){return $?[...$.entries()]:[]}function L($){return new Map($)}function R($){return new Map($??[])}function M($){return Array.from($.entries()).map(S=>[S[0],l(S[1].map),N(S[1].descriptionMap)])}function b($){return new Map($.map(S=>[S[0],{map:L(S[1]),descriptionMap:R(S[2])}]))}}),define(ke[274],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rsb=void 0;class l{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,R,M=5){const b=R($=>{const S=typeof $=="string"?$:$.data;let A=this.a.get(L);if(A){A.data.push(S);return}const C=setTimeout(()=>this.flushBuffer(L),M);A={data:[S],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(L),b.dispose()}},this.a.set(L,A)});return b}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const R=this.a.get(L);R&&(this.a.delete(L),this.b(L,R.data.join("")))}}e.$Rsb=l}),define(ke[275],Ee([1,0,8,78,99,57,4,18,2,215,109,38]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0w=e.$9w=e.$8w=e.$7w=e.$6w=e.$5w=e.IconFontDefinition=e.IconContribution=e.$2w=void 0,e.$3w=f,e.$4w=a,e.$2w={IconContribution:"base.contributions.icons"};var m;(function(o){function t(g,h){let c=g.defaults;for(;R.ThemeIcon.isThemeIcon(c);){const r=u.getIcon(c.id);if(!r)return;c=r.defaults}return c}o.getDefinition=t})(m||(e.IconContribution=m={}));var E;(function(o){function t(h){return{weight:h.weight,style:h.style,src:h.src.map(c=>({format:c.format,location:c.location.toString()}))}}o.toJSONObject=t;function g(h){const c=r=>(0,b.$4f)(r)?r:void 0;if(h&&Array.isArray(h.src)&&h.src.every(r=>(0,b.$4f)(r.format)&&(0,b.$4f)(r.location)))return{weight:c(h.weight),style:c(h.style),src:h.src.map(r=>({format:r.format,location:$.URI.parse(r.location)}))}}o.fromJSONObject=g})(E||(e.IconFontDefinition=E={}));class v{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,g,h,c){const r=this.b[t];if(r){if(h&&!r.description){r.description=h,this.d.properties[t].markdownDescription=`${h} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=h),this.a.fire()}return r}const w={id:t,description:h,defaults:g,deprecationMessage:c};this.b[t]=w;const d={$ref:"#/definitions/icons"};return c&&(d.deprecationMessage=c),h&&(d.markdownDescription=`${h}: $(${t})`),this.d.properties[t]=d,this.e.enum.push(t),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const g=this.e.enum.indexOf(t);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,g){const h=this.f[t];return h||(this.f[t]=g,this.a.fire(),g)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(r,w)=>r.id.localeCompare(w.id),g=r=>{for(;R.ThemeIcon.isThemeIcon(r.defaults);)r=this.b[r.defaults.id];return`codicon codicon-${r?r.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(r=>this.b[r]);for(const r of c.filter(w=>!!w.description).sort(t))h.push(`|<i class="${g(r)}"></i>|${r.id}|${R.ThemeIcon.isThemeIcon(r.defaults)?r.defaults.id:r.id}|${r.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const r of c.filter(w=>!R.ThemeIcon.isThemeIcon(w.defaults)).sort(t))h.push(`|<i class="${g(r)}"></i>|${r.id}|`);return h.join(`
`)}}const u=new v;C.$9n.add(e.$2w.IconContribution,u);function f(o,t,g,h){return u.registerIcon(o,t,g,h)}function a(){return u}function n(){const o=(0,L.$Lj)();for(const t in o){const g="\\"+o[t].toString(16);u.registerIcon(t,{fontCharacter:g})}}n(),e.$5w="vscode://schemas/icons";const i=C.$9n.as(A.$0n.JSONContribution);i.registerSchema(e.$5w,u.getIconSchema());const s=new l.$Ch(()=>i.notifySchemaChanged(e.$5w),200);u.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$6w=f("widget-close",N.$Pj.close,(0,S.localize)(2,null)),e.$7w=f("goto-previous-location",N.$Pj.arrowUp,(0,S.localize)(3,null)),e.$8w=f("goto-next-location",N.$Pj.arrowDown,(0,S.localize)(4,null)),e.$9w=R.ThemeIcon.modify(N.$Pj.sync,"spin"),e.$0w=R.ThemeIcon.modify(N.$Pj.loading,"spin")}),define(ke[88],Ee([1,0,4,2,54,5,12]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=S,e.$8v=C,e.$9v=m,e.$$v=E,e.$aw=v,e.$bw=u,e.$5v=(0,R.$qi)("tunnelService"),e.$6v=(0,R.$qi)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function S(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function C(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function m(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const s of i){const o=s.split("=")[1];if(/^https?:/.exec(o)){const t=C(N.URI.parse(o));if(t)return t}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(n){return e.$0v.indexOf(n)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$_v.indexOf(n)>=0}function u(n,i,s,o){if(s===1)return!1;if(s===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class f{constructor(i,s,o){this.remoteAddress=i,this.localAddress=s,this.b=o,this.a=new l.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=f;let a=class{constructor(i,s){this.k=i,this.l=s,this.a=new l.$be,this.onTunnelOpened=this.a.event,this.b=new l.$be,this.onTunnelClosed=this.b.event,this.c=new l.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],s=Array.from(this.e.values());for(const o of s){const t=Array.from(o.values());for(const g of t){const h=await g.value;h&&typeof h!="string"&&i.push(h)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:s}of i.values())await s.then(o=>typeof o!="string"?o?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,s,o,t,g){this.q(i,s,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:s,localAddress:o,privacy:t,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,s){(v(i)||E(i))&&(i=e.$0v[0]);const o=this.s(i,s);if(o)return++o.refcount,o.value}openTunnel(i,s,o,t,g,h=!1,c,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${o} on local port ${g}.`);const w=this.f??i;if(!w)return;if(s||(s="localhost"),t||(t=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.t(w,s,o,t,g,h,c,r);return d?d.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(s,o),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(s,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.o(D);return(D.tunnelRemoteHost!==s||D.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&D.privacy!==c&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const s=this.e.get(i.tunnelRemoteHost);if(s){const o=s.get(i.tunnelRemotePort);o&&(o.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,o))}}}}async p(i,s,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${s}.`);const t=o.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(s),t}}async closeTunnel(i,s){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${s} `);const o=this.e.get(i);if(o&&o.has(s)){const t=o.get(s);t.refcount=0,await this.p(i,s,t)}}q(i,s,o){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(s,{refcount:1,value:o})}async r(i,s){const o=this.e.get(i);if(o){const t=o.get(s),g=t?await t.value:void 0;(!g||typeof g=="string")&&o.delete(s),o.size===0&&this.e.delete(i)}}s(i,s){const o=[i];E(i)?(o.push(...e.$0v),o.push(...e.$_v)):v(i)&&o.push(...e.$_v);const t=o.map(g=>this.e.get(g));for(const g of t){const h=g?.get(s);if(h)return h}}canTunnel(i){return!!C(i)}u(i,s,o,t,g,h,c){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${o} on local port ${t}.`);const r=o;this.j.add(r);const w=t===void 0?o:t,d={elevationRequired:g?this.isPortPrivileged(w):!1},D={remoteAddress:{host:s,port:o},localAddressPort:t,privacy:h,public:h?h!==$.Private:void 0,protocol:c},p=i.forwardPort(D,d);return p?(this.q(s,o,p),p.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),p}};e.$dw=a,e.$dw=a=Je([qe(0,M.$Wj),qe(1,L.$Wi)],a)}),define(ke[276],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0,e.$ul=(0,l.$qi)("IUriIdentityService")}),define(ke[277],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ew=void 0,e.$ew=(0,l.$qi)("editSessionIdentityService");var N;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[278],Ee([1,0,15]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=N,e.$nM=L,e.$oM=R,e.$pM=M,e.$qM=b;function N($){return $.scheme!==l.Schemas.file&&$.scheme!==l.Schemas.vscodeRemote}function L($){if($.folders.length)return $.folders.every(S=>N(S.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}function R($){return L($)?.scheme}function M($){return L($)?.authority}function b($){return L($)!==void 0}}),define(ke[42],Ee([1,0,217,17,77,23,2,5,15]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=S,e.$Bi=A,e.$Ei=C,e.$Fi=m,e.$Gi=E,e.$Hi=u,e.$Ii=f,e.$Li=i,e.$Qi=s,e.$Ri=o,e.$Ti=t,e.$Ui=g,e.$Vi=h,e.$zi=(0,b.$qi)("contextService");function S(c){const r=c;return typeof r?.id=="string"&&M.URI.isUri(r.uri)}function A(c){return typeof c?.id=="string"&&!S(c)&&!m(c)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function C(c,r){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,N.$oc)(c)}:r?e.$Ci:e.$Di;const w=c;return w.configuration?{id:w.id,configPath:w.configuration}:w.folders.length===1?{id:w.id,uri:w.folders[0].uri}:{id:w.id}}function m(c){const r=c;return typeof r?.id=="string"&&M.URI.isUri(r.configPath)}function E(c){const r=c;if(r?.uri)return{id:r.id,uri:M.URI.revive(r.uri)};const w=c;if(w?.configPath)return{id:w.id,configPath:M.URI.revive(w.configPath)};if(c?.id)return{id:c.id}}var v;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function u(c){const r=c;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function f(c){const r=c;return!!(r&&typeof r=="object"&&M.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class a{constructor(r,w,d,D,p){this.h=r,this.j=d,this.k=D,this.l=p,this.c=L.$wi.forUris(this.l,()=>!0),this.folders=w}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=L.$wi.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=a;class n{constructor(r,w){this.raw=w,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.$4g)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=n;function i(c){return new n({uri:c,index:0,name:(0,R.$Zg)(c)},{uri:c.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,l.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function s(c,r){return R.$Ug.isEqualOrParent(c,r.untitledWorkspacesHome)}function o(c){let r;return M.URI.isUri(c)?r=c:r=c.configuration,r?.scheme===$.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$Si}function g(c,r){return!s(c,r)&&!o(c)}function h(c){return(typeof c=="string"?(0,N.$pc)(c):(0,R.$2g)(c))===e.$Ni}}),define(ke[279],Ee([1,0,56,4,3,23,2,216,136,32,5,12,42,27,276,8,30,14,18]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$wl=e.ProfileResourceType=void 0,e.$vl=s,e.$xl=o,e.$yl=t;var i;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(c){const r=c;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&M.URI.isUri(r.location)&&M.URI.isUri(r.globalStorageHome)&&M.URI.isUri(r.settingsResource)&&M.URI.isUri(r.keybindingsResource)&&M.URI.isUri(r.tasksResource)&&M.URI.isUri(r.snippetsHome)&&M.URI.isUri(r.extensionsResource))}e.$wl=(0,A.$qi)("IUserDataProfilesService");function o(c,r){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:M.URI.revive(c.location).with({scheme:r}),globalStorageHome:M.URI.revive(c.globalStorageHome).with({scheme:r}),settingsResource:M.URI.revive(c.settingsResource).with({scheme:r}),keybindingsResource:M.URI.revive(c.keybindingsResource).with({scheme:r}),tasksResource:M.URI.revive(c.tasksResource).with({scheme:r}),snippetsHome:M.URI.revive(c.snippetsHome).with({scheme:r}),extensionsResource:M.URI.revive(c.extensionsResource).with({scheme:r}),cacheHome:M.URI.revive(c.cacheHome).with({scheme:r}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function t(c,r,w,d,D,p){return{id:c,name:r,location:w,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:p&&D?.useDefaultFlags?.globalState?p.globalStorageHome:(0,R.$4g)(w,"globalStorage"),settingsResource:p&&D?.useDefaultFlags?.settings?p.settingsResource:(0,R.$4g)(w,"settings.json"),keybindingsResource:p&&D?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,R.$4g)(w,"keybindings.json"),tasksResource:p&&D?.useDefaultFlags?.tasks?p.tasksResource:(0,R.$4g)(w,"tasks.json"),snippetsHome:p&&D?.useDefaultFlags?.snippets?p.snippetsHome:(0,R.$4g)(w,"snippets"),extensionsResource:p&&D?.useDefaultFlags?.extensions?p.extensionsResource:(0,R.$4g)(w,"extensions.json"),cacheHome:(0,R.$4g)(d,c),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let g=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,w,d,D){super(),this.t=r,this.u=w,this.w=d,this.y=D,this.f=!0,this.h=this.B(new N.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$4g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$4g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),w=[r];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,n.$4f)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}w.push(t((0,R.$1g)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},r))}}catch(p){this.y.error(p)}const d=new E.$Bc,D=new Map;if(w.length)try{const p=this.Q();if(p.workspaces)for(const[k,y]of Object.entries(p.workspaces)){const P=M.URI.parse(k),I=w.find(F=>F.id===y);I&&d.set(P,I)}if(p.emptyWindows)for(const[k,y]of Object.entries(p.emptyWindows)){const P=w.find(I=>I.id===y);P&&D.set(k,P)}}catch(p){this.y.error(p)}this.z={profiles:w,workspaces:d,emptyWindows:D}}return this.z}D(){const r=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const w="Temp",d=new RegExp(`${(0,a.$8e)(w)}\\s(\\d+)`);let D=0;for(const k of this.profiles){const y=d.exec(k.name),P=y?parseInt(y[1]):0;D=P>D?P:D}const p=`${w} ${D+1}`;return this.createProfile((0,l.$ej)((0,f.$Mg)()).toString(16),p,{transient:!0},r)}async createNamedProfile(r,w,d){return this.createProfile((0,l.$ej)((0,f.$Mg)()).toString(16),r,w,d)}async createProfile(r,w,d,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(r,w,d);return D&&await this.setProfileForWorkspace(D,p),p}async F(r,w,d){if(!(0,n.$4f)(w)||!w)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(w);return D||(D=(async()=>{try{if(this.profiles.find(P=>P.name===w||P.id===r))throw new Error(`Profile with ${w} name already exists`);const k=t(r,w,(0,R.$4g)(this.profilesHome,r),this.g,d,this.defaultProfile);await this.u.createFolder(k.location);const y=[];return this.j.fire({profile:k,join(P){y.push(P)}}),await u.Promises.settled(y),this.I([k],[],[]),k}finally{this.r.delete(w)}})(),this.r.set(w,D)),D}async updateProfile(r,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let d=this.profiles.find(D=>D.id===r.id);if(!d)throw new Error(`Profile '${r.name}' does not exist`);return d=t(d.id,w.name??d.name,d.location,this.g,{shortName:w.shortName??d.shortName,icon:w.icon===null?void 0:w.icon??d.icon,transient:w.transient??d.isTransient,useDefaultFlags:w.useDefaultFlags??d.useDefaultFlags},this.defaultProfile),this.I([],[],[d]),d}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const w=this.profiles.find(D=>D.id===r.id);if(!w)throw new Error(`Profile '${r.name}' does not exist`);const d=[];this.m.fire({profile:w,join(D){d.push(D)}});try{await Promise.allSettled(d)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])w.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])w.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[w],[]);try{await this.u.del(w.cacheHome,{recursive:!0})}catch(D){(0,S.$bl)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(r,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const d=this.profiles.find(D=>D.id===w.id);if(!d)throw new Error(`Profile '${w.name}' does not exist`);this.L(r,d)}unsetWorkspace(r,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,w)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(w=>w.isDirectory&&this.profiles.every(d=>!this.w.extUri.isEqual(d.location,w.resource))).map(w=>this.u.del(w.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(w=>!this.H(w));await Promise.allSettled(r.map(w=>this.removeProfile(w)))}getProfileForWorkspace(r){const w=this.G(r);return M.URI.isUri(w)?this.s.workspaces.get(w)??this.C.workspaces.get(w):this.s.emptyWindows.get(w)??this.C.emptyWindows.get(w)}G(r){return(0,m.$Ai)(r)?r.uri:(0,m.$Fi)(r)?r.configPath:r.id}H(r){return!!([...this.s.emptyWindows.values()].some(w=>this.w.extUri.isEqual(w.location,r.location))||[...this.s.workspaces.values()].some(w=>this.w.extUri.isEqual(w.location,r.location))||[...this.C.emptyWindows.values()].some(w=>this.w.extUri.isEqual(w.location,r.location))||[...this.C.workspaces.values()].some(w=>this.w.extUri.isEqual(w.location,r.location)))}I(r,w,d){const D=[...this.profiles,...r],p=[];this.s.profiles=[];for(let k of D)k.isDefault||w.some(y=>k.id===y.id)||(k=d.find(y=>k.id===y.id)??k,k.isTransient?this.s.profiles.push(k):p.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(p),this.z=void 0,this.J(r,w,d)}J(r,w,d){this.h.fire({added:r,removed:w,updated:d,all:this.profiles})}L(r,w,d){d=w?.isTransient?!0:d,d||this.L(r,void 0,!0);const D=this.G(r),p=d?this.s:this.C;M.URI.isUri(D)?(p.workspaces.delete(D),w&&p.workspaces.set(D,w)):(p.emptyWindows.delete(D),w&&p.emptyWindows.set(D,w)),d||this.M()}M(){const r={};for(const[d,D]of this.C.workspaces.entries())r[d.toString()]=D.id;const w={};for(const[d,D]of this.C.emptyWindows.entries())w[d.toString()]=D.id;this.R({workspaces:r,emptyWindows:w}),this.z=void 0}N(r){const w={},d=this.D();if(r.workspaces)for(const[p,k]of Object.entries(r.workspaces)){const y=M.URI.parse(k);w[p]=this.w.extUri.isEqual(y,d.location)?d.id:this.w.extUri.basename(y)}const D={};if(r.emptyWindows)for(const[p,k]of Object.entries(r.emptyWindows)){const y=M.URI.parse(k);D[p]=this.w.extUri.isEqual(y,d.location)?d.id:this.w.extUri.basename(y)}return{workspaces:w,emptyWindows:D}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$zl=g,e.$zl=g=Je([qe(0,$.$xi),qe(1,S.$Wk),qe(2,v.$ul),qe(3,C.$Wj)],g);class h extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$Al=h}),define(ke[280],Ee([1,0,8,4,3,59,18,195,5,279]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Wp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Up=e.$Tp=e.$Sp=void 0,e.$Vp=E,e.$Xp=u,e.$Zp=a,e.$Sp="__$__isNewStorageMarker",e.$Tp="__$__targetStorageMarker",e.$Up=(0,$.$qi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var C;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function E(n){const i=n.get(e.$Tp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends L.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new N.$ee),this.c=this.B(new N.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$be),this.onWillSaveState=this.f.event,this.h=this.B(new l.$Ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,o){return N.Event.filter(this.b.event,t=>t.scope===i&&(s===void 0||t.key===s),o)}n(){this.j.value=(0,l.$Gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:o,external:t}=s;if(o===e.$Tp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:o,target:this.J(i)[o],external:t})}w(i){this.f.fire({reason:i})}get(i,s,o){return this.P(s)?.get(i,o)}getBoolean(i,s,o){return this.P(s)?.getBoolean(i,o)}getNumber(i,s,o){return this.P(s)?.getNumber(i,o)}getObject(i,s,o){return this.P(s)?.getObject(i,o)}storeAll(i,s){this.y(()=>{for(const o of i)this.store(o.key,o.value,o.scope,o.target,s)})}store(i,s,o,t,g=!1){if((0,M.$ag)(s)){this.remove(i,o,g);return}this.y(()=>{this.z(i,o,t),this.P(o)?.set(i,s,g)})}remove(i,s,o=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,o)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const o=[],t=this.J(i);for(const g of Object.keys(t))t[g]===s&&o.push(g);return o}z(i,s,o,t=!1){const g=this.J(s);typeof o=="number"?g[i]!==o&&(g[i]=o,this.P(s)?.set(e.$Tp,JSON.stringify(g),t)):typeof g[i]=="number"&&(delete g[i],this.P(s)?.set(e.$Tp,JSON.stringify(g),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?E(s):Object.create(null)}isNew(i){return this.getBoolean(e.$Sp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const s=this.P(-1),o=this.P(0),t=this.P(1);switch(i){case A.NONE:await l.Promises.settled([s?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await l.Promises.settled([s?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,s=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(i,s,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(A.NONE),(0,S.$vl)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||u(s)&&u(i))}N(i,s,o){this.y(()=>{const t=new Set;for(const[g,h]of i)t.add(g),s.get(g)!==h&&this.u(o,{key:g,external:!0});for(const[g]of s.items)t.has(g)||this.u(o,{key:g,external:!0})})}}e.$Wp=v;function u(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class f extends v{constructor(){super(),this.U=this.B(new b.$Qp(new b.$Rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Qp(new b.$Rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Qp(new b.$Rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Yp=f;async function a(n,i,s,o,t,g){const h=P=>{try{return JSON.parse(P)}catch{return P}},c=new Map,r=new Map;n.forEach((P,I)=>{c.set(I,P),r.set(I,h(P))});const w=new Map,d=new Map;i.forEach((P,I)=>{w.set(I,P),d.set(I,h(P))});const D=new Map,p=new Map;s.forEach((P,I)=>{D.set(I,P),p.set(I,h(P))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const k=[];if(c.forEach((P,I)=>{k.push({key:I,value:P})}),console.table(k),console.groupEnd(),console.log(r),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];w.forEach((I,F)=>{P.push({key:F,value:I})}),console.table(P),console.groupEnd(),console.log(d)}console.group(`Storage: Workspace (path: ${g})`);const y=[];D.forEach((P,I)=>{y.push({key:I,value:P})}),console.table(y),console.groupEnd(),console.log(p)}}),define(ke[111],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class l{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const R=this.c++;return this.b.set(R,L),this.e(),R}get(L,R){return this.b.has(L)?this.b.get(L)[R]:void 0}delete(L){this.b.delete(L),this.e()}e(){l.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$dkc=l}),define(ke[60],Ee([1,0,15,23,5]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=void 0;class R{constructor(){this.a=new Set(Object.keys(l.Schemas)),this.b=new Map,this.extUri=new N.$Sg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$ikc=R,e.$jkc=(0,L.$qi)("IExtHostFileSystemInfo")}),define(ke[28],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=void 0,e.$sP=(0,l.$qi)("IExtHostInitDataService")}),define(ke[281],Ee([1,0,223,12,261,28]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=void 0;let M=class extends L.$AQ{constructor($,S,A){const C=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=A.remote.isRemote?(0,l.localize)(0,null):$?(0,l.localize)(1,null):(0,l.localize)(2,null);super(S.createLogger(C,{name:m}))}};e.$pmc=M,e.$pmc=M=Je([qe(1,N.$Xj),qe(2,R.$sP)],M)}),define(ke[282],Ee([1,0,8]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=e.$1kc=void 0;class N{constructor(M,b,$){this.h=new Map,this.a=M,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(S=>(this.f=S,this)),this.g=this.c.onDidChangeStorage(S=>{S.shared===this.b&&S.key===this.a&&(this.f=S.value)}),this.i=new l.$Ch(()=>{const S=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of S.values())A.complete()}catch(A){for(const C of S.values())C.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let $=this.f[M];return typeof $>"u"&&($=b),$}update(M,b){this.f[M]=b;const $=this.h.get(M);if($!==void 0)return $.p;const S=new l.$Nh;return this.h.set(M,S),this.i.isScheduled()||this.i.schedule(),S.p}dispose(){this.g.dispose()}}e.$1kc=N;class L extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$2kc=L}),define(ke[283],Ee([1,0,4,2]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=void 0;class L{constructor(M){this.c=M,this.a=new l.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new l.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,$,S){const C=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(b.value,$,S);this.b.fire(C)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$Plc=L}),define(ke[20],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0,e.$cP=(0,l.$qi)("IExtHostRpcService");class N{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$dP=N}),define(ke[284],Ee([1,0,25,4]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class L{#e;constructor(M,b){this.b=new N.$be,this.onDidChange=this.b.event,this.a=l.$Lm.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$$kc=L}),define(ke[67],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=e.$ykc=void 0,e.$ykc=(0,l.$qi)("IURITransformerService");class N{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$zkc=N}),define(ke[285],Ee([1,0,21]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nb=L,e.$$nb=M;class N{constructor(){this.buffers=[]}add($){let S=this.buffers.indexOf($);return S<0&&(S=this.buffers.length,this.buffers.push($)),S}}function L(b,$){if($.serializeBuffersForPostMessage){const S=new N,C=JSON.stringify(b,(E,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v)};if(ArrayBuffer.isView(v)){const u=R(v);if(u)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v.buffer),view:{type:u,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),m=S.buffers.map(E=>{const v=new Uint8Array(E);return l.$Ce.wrap(v)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,$){const S=$.map(m=>{const E=new ArrayBuffer(m.byteLength);return new Uint8Array(E).set(m.buffer),E}),A=$.length?(m,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const v=E,{index:u}=v,f=S[u];if(v.view)switch(v.view.type){case 1:return new Int8Array(f,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return E}:void 0;return{message:JSON.parse(b,A),arrayBuffers:S}}}),define(ke[286],Ee([1,0,287,398,399,63,2,12,400]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=A;const S=!1;function A(i,s,o,t,g,h){const c=h.environment.useHostProxy,r=typeof c=="boolean"?c:!h.remote.isRemote,w={resolveProxy:p=>i.resolveProxy(p),lookupProxyAuthorization:f.bind(void 0,t,g,s,{},h.remote.isRemote),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(s),addCertificatesV2:()=>E(s),log:t,getLogLevel:()=>{const p=t.getLevel();switch(p){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return k(p)}function k(y){return t.error("Unknown log level",y),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:r,loadAdditionalCertificates:async()=>{const p=[];if(h.remote.isRemote&&p.push((0,$.loadSystemCertificates)({log:t})),r){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=i.loadCertificates();k.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),p.push(k)}return(await Promise.all(p)).flat()},env:process.env},d=(0,$.createProxyResolver)(w),D=C(w,d);return u(o,D)}function C(i,s){return{http:Object.assign(l,(0,$.createHttpPatch)(i,l,s)),https:Object.assign(N,(0,$.createHttpPatch)(i,N,s)),net:Object.assign(R,(0,$.createNetPatch)(i,R)),tls:Object.assign(L,(0,$.createTlsPatch)(i,L))}}function m(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",S)&&!!s.get("systemCertificates")}function E(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",S)&&!!s.get("systemCertificates")}const v=new Map;function u(i,s){return i.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,g=t._load;t._load=function(c,r,w){if(c==="net")return s.net;if(c==="tls")return s.tls;if(c!=="http"&&c!=="https")return g.apply(this,arguments);const d=o.findSubstr(M.URI.file(r.filename));let D=v.get(d);if(D||v.set(d,D={}),!D[c]){const p=s[c];D[c]={...p}}return D[c]}})}async function f(i,s,o,t,g,h,c,r){const w=t[h];c&&(t[h]=c),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${w}`);const d=c||w,D=Array.isArray(d)?d:typeof d=="string"?[d]:[];if(n(s,D,g),D.some(p=>/^(Negotiate|Kerberos)( |$)/i.test(p))&&!r.kerberosRequested)try{r.kerberosRequested=!0;const p=await new Promise((F,j)=>{le(["kerberos"],F,j)}),k=new URL(h),y=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${y}`),"Negotiate "+await(await p.initializeClient(y)).step("")}catch(p){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",p)}}let a=!1;function n(i,s,o){a||!s.length||(a=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(ke[288],Ee([1,0,133]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=L;function N(R){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:R,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function L(R){return new l.$sn(N(R))}}),define(ke[142],Ee([1,0,233,18,2,3,5,38,32,15,47,187,41]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$BF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$sF=e.EditorInputCapabilities=e.$rF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=void 0,e.$iF=u,e.$jF=f,e.$kF=a,e.$lF=n,e.$mF=i,e.$nF=s,e.$oF=o,e.$pF=t,e.$qF=g,e.$tF=D,e.$uF=k,e.$vF=y,e.$wF=P,e.$xF=I,e.$yF=F,e.$zF=j,e.$AF=X,e.$CF=Y,e.$DF=te,e.$EF=we,e.$FF=Se,e.$dF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$eF={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.$fF="workbench.editor.sidebysideEditor",e.$gF="workbench.editors.textDiffEditor",e.$hF="workbench.editors.binaryResourceDiffEditor";var E;(function(_){_[_.PROGRAMMATIC=1]="PROGRAMMATIC",_[_.USER=2]="USER",_[_.EDIT=3]="EDIT",_[_.NAVIGATION=4]="NAVIGATION",_[_.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var v;(function(_){_[_.IDENTICAL=1]="IDENTICAL",_[_.SIMILAR=2]="SIMILAR",_[_.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function u(_){const U=_;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function f(_){const U=_;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function a(_,U,ne){for(const $e of ne.visibleEditorPanes)if($e.group.id===U&&_.matches($e.input))return $e.getViewState()}function n(_){if(D(_))return!1;const U=_;return L.URI.isUri(U?.resource)}function i(_){if(D(_))return!1;const U=_;return U?.original!==void 0&&U.modified!==void 0}function s(_){if(D(_))return!1;const U=_;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function o(_){if(D(_)||i(_))return!1;const U=_;return U?.primary!==void 0&&U.secondary!==void 0}function t(_){if(D(_))return!1;const U=_;return U?U.resource===void 0||U.resource.scheme===S.Schemas.untitled||U.forceUntitled===!0:!1}function g(_){if(D(_))return!1;const U=_;return L.URI.isUri(U?.base?.resource)&&L.URI.isUri(U?.input1?.resource)&&L.URI.isUri(U?.input2?.resource)&&L.URI.isUri(U?.result?.resource)}var h;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var c;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class r{constructor(){this.a=new Map}registerSource(U,ne){let $e=this.a.get(U);return $e||($e={source:U,label:ne},this.a.set(U,$e)),$e.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$rF=new r;var w;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription",_[_.CanDropIntoEditor=128]="CanDropIntoEditor",_[_.MultipleEditors=256]="MultipleEditors",_[_.Scratchpad=512]="Scratchpad"})(w||(e.EditorInputCapabilities=w={}));class d extends R.$Uc{}e.$sF=d;function D(_){return _ instanceof d}function p(_){const U=_;return L.URI.isUri(U?.preferredResource)}function k(_){const U=_;return D(U?.primary)&&D(U?.secondary)}function y(_){const U=_;return D(U?.modified)&&D(U?.original)}function P(_,U,ne,$e,Pe){return Se($e,[(0,C.$aj)({id:"workbench.action.openLargeFile",label:(0,l.localize)(2,null),run:()=>{const se={...ne,limits:{size:Number.MAX_VALUE}};_.openEditor(U,se)}}),(0,C.$aj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,l.localize)(3,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}function I(_){return D(_?.editor)}function F(_){const U=_;return I(_)&&U?.group!==void 0}function j(_){const U=_;return typeof U?.groupId=="number"&&D(U.editor)}var z;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var O;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LABEL=2]="GROUP_LABEL",_[_.GROUP_LOCKED=3]="GROUP_LOCKED",_[_.EDITOR_OPEN=4]="EDITOR_OPEN",_[_.EDITOR_CLOSE=5]="EDITOR_CLOSE",_[_.EDITOR_MOVE=6]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=8]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=10]="EDITOR_PIN",_[_.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",_[_.EDITOR_STICKY=12]="EDITOR_STICKY",_[_.EDITOR_DIRTY=13]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var T;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class B{getOriginalUri(U,ne){if(!U)return;if(g(U))return e.$BF.getOriginalUri(U.result,ne);if(ne?.supportSideBySide){const{primary:Pe,secondary:se}=this.a(U);if(Pe&&se){if(ne?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===T.ANY)return this.getOriginalUri(Pe,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(se,{filterByScheme:ne.filterByScheme});U=ne.supportSideBySide===T.PRIMARY?Pe:se}}if(i(U)||s(U)||o(U)||g(U))return;const $e=p(U)?U.preferredResource:U.resource;return!$e||!ne||!ne.filterByScheme?$e:this.b($e,ne.filterByScheme)}a(U){return k(U)||o(U)?{primary:U.primary,secondary:U.secondary}:y(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ne){if(!U)return;if(g(U))return e.$BF.getCanonicalUri(U.result,ne);if(ne?.supportSideBySide){const{primary:Pe,secondary:se}=this.a(U);if(Pe&&se){if(ne?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===T.ANY)return this.getCanonicalUri(Pe,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:ne.filterByScheme});U=ne.supportSideBySide===T.PRIMARY?Pe:se}}if(i(U)||s(U)||o(U)||g(U))return;const $e=U.resource;return!$e||!ne||!ne.filterByScheme?$e:this.b($e,ne.filterByScheme)}b(U,ne){if(Array.isArray(ne)){if(ne.some($e=>U.scheme===$e))return U}else if(ne===U.scheme)return U}}var W;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.KEYBOARD=1]="KEYBOARD",_[_.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function X(_,U,ne,$e){if(!_.isSticky(U))return!1;switch($e.preventPinnedEditorClose){case"keyboardAndMouse":return ne===W.MOUSE||ne===W.KEYBOARD;case"mouse":return ne===W.MOUSE;case"keyboard":return ne===W.KEYBOARD}return!1}e.$BF=new B;var x;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(x||(e.CloseDirection=x={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(U){const ne=this.a=U.get(M.$pi);for(const[$e,Pe]of this.c)this.e($e,Pe,ne);this.c.clear()}e(U,ne,$e){const Pe=$e.createInstance(ne);this.d.set(U,Pe)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$cg)(this.b)}registerEditorSerializer(U,ne){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ne,this.a):this.c.set(U,ne),(0,R.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}b.$9n.add(e.$dF.EditorFactory,new Z);async function Y(_,U,ne){return!_||!_.length?[]:await Promise.all(_.map(async $e=>{const Pe=L.URI.revive($e.fileUri);if(!Pe){ne.info("Cannot resolve the path because it is not valid.",$e);return}if(!await U.canHandleResource(Pe)){ne.info("Cannot resolve the path because it cannot be handled",$e);return}let re=$e.exists,oe=$e.type;if(typeof re!="boolean"||typeof oe!="number")try{oe=(await U.stat(Pe)).isDirectory?$.FileType.Directory:$.FileType.Unknown,re=!0}catch(ie){ne.error(ie),re=!1}if(!re&&$e.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",$e);return}if(oe===$.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",$e);return}const G={...$e.options,pinned:!0};return re?{resource:Pe,options:G}:{resource:Pe,options:G,forceUntitled:!0}}))}var ue;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function te(_){const U=_;if(!U)return!1;const ne=U;if(ne.modified)return te(ne.modified);const $e=U;return!!($e.contributionsState&&$e.viewState&&Array.isArray($e.cursorState))}function we(_){return(0,A.$cj)(_)}function Se(_,U,ne){const $e=(0,A.$dj)(_,U);return $e.forceMessage=ne?.forceMessage,$e.forceSeverity=ne?.forceSeverity,$e.allowDialog=ne?.allowDialog,$e}}),define(ke[289],Ee([1,0,4,234,5,3,27,38,19,24,78,275]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.$MF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$LF=e.ViewContentGroups=e.$JF=e.ViewContainerLocation=e.Extensions=e.$IF=e.$HF=e.$GF=void 0,e.$KF=v,e.$GF="views",e.$HF=(0,N.localize)(0,null),e.$IF=(0,C.$3w)("default-view-icon",A.$Pj.window,(0,N.localize)(1,null));var m;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var E;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$JF=[0,1,2];function v(g){switch(g){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class u extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new l.$be),this.onDidRegister=this.c.event,this.f=this.B(new l.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(h,c,r){const w=this.get(h.id);if(w)return w;const d=h;return d.openCommandActionDescriptor=r?.doNotRegisterOpenCommand?void 0:d.openCommandActionDescriptor??{id:d.id},(0,M.$yc)(this.g,c,[]).push(d),r?.isDefault&&this.h.push(d),this.c.fire({viewContainer:d,viewContainerLocation:c}),d}deregisterViewContainer(h){for(const c of this.g.keys()){const r=this.g.get(c),w=r?.indexOf(h);if(w!==-1){r?.splice(w,1),r.length===0&&this.g.delete(c),this.f.fire({viewContainer:h,viewContainerLocation:c});return}}}get(h){return this.all.filter(c=>c.id===h)[0]}getViewContainers(h){return[...this.g.get(h)||[]]}getViewContainerLocation(h){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(r=>r?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.h.find(c=>this.getViewContainerLocation(c)===h)}}b.$9n.add(m.ViewContainersRegistry,new u);var f;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(f||(e.ViewContentGroups=f={}));function a(g,h){const c=g.group??f.More,r=h.group??f.More;return c!==r?c.localeCompare(r):(g.order??5)-(h.order??5)}class n extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new l.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new l.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new l.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new l.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(h,c){this.registerViews2([{views:h,viewContainer:c}])}registerViews2(h){h.forEach(({views:c,viewContainer:r})=>this.r(c,r)),this.c.fire(h)}deregisterViews(h,c){const r=this.s(h,c);r.length&&this.f.fire({views:r,viewContainer:c})}moveViews(h,c){for(const r of this.m.keys())if(r!==c){const w=this.s(h,r);w.length&&(this.r(w,c),this.g.fire({views:w,from:r,to:c}))}}getViews(h){return this.m.get(h)||[]}getView(h){for(const c of this.j){const r=(this.m.get(c)||[]).filter(w=>w.id===h)[0];if(r)return r}return null}getViewContainer(h){for(const c of this.j)if((this.m.get(c)||[]).filter(w=>w.id===h)[0])return c;return null}registerViewWelcomeContent(h,c){return this.n.add(h,c),this.h.fire(h),(0,R.$Sc)(()=>{this.n.delete(h,c),this.h.fire(h)})}registerViewWelcomeContent2(h,c){const r=new Map;for(const[w,d]of c)this.n.add(h,d),r.set(w,(0,R.$Sc)(()=>{this.n.delete(h,d),this.h.fire(h)}));return this.h.fire(h),r}getViewWelcomeContent(h){const c=[];return this.n.forEach(h,r=>c.push(r)),c.sort(a)}r(h,c){let r=this.m.get(c);r||(r=[],this.m.set(c,r),this.j.push(c));for(const w of h){if(this.getView(w.id)!==null)throw new Error((0,N.localize)(2,null,w.id));r.push(w)}}s(h,c){const r=this.m.get(c);if(!r)return[];const w=[],d=[];for(const D of r)h.includes(D)?w.push(D):d.push(D);return w.length&&(d.length?this.m.set(c,d):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),w}}b.$9n.add(m.ViewsRegistry,new n),e.$LF=(0,L.$qi)("viewDescriptorService");var i;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var s;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(s||(e.TreeItemCollapsibleState=s={}));class o{constructor(h,c){this.c=!1,this.d=!1,(0,S.$Zn)(this,h),this.d=!!c,this.resolve=async r=>{if(c&&!this.c){const w=await c(r);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}r.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$MF=o;class t extends Error{constructor(h){super((0,N.localize)(3,null,h)),this.name="NoTreeViewError"}static is(h){return h.name==="NoTreeViewError"}}e.$NF=t}),define(ke[290],Ee([1,0,235,37]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$RF=new N.$Hj("chatSessionResponseVote","",{type:"string",description:(0,l.localize)(0,null)}),e.$SF=new N.$Hj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,l.localize)(1,null)}),e.$TF=new N.$Hj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,l.localize)(2,null)}),e.$UF=new N.$Hj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,l.localize)(3,null)}),e.$VF=new N.$Hj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,l.localize)(4,null)}),e.$WF=new N.$Hj("chatResponse",!1,{type:"boolean",description:(0,l.localize)(5,null)}),e.$XF=new N.$Hj("chatRequest",!1,{type:"boolean",description:(0,l.localize)(6,null)}),e.$YF=new N.$Hj("chatInputHasText",!1,{type:"boolean",description:(0,l.localize)(7,null)}),e.$ZF=new N.$Hj("chatInputHasFocus",!1,{type:"boolean",description:(0,l.localize)(8,null)}),e.$1F=new N.$Hj("inChatInput",!1,{type:"boolean",description:(0,l.localize)(9,null)}),e.$2F=new N.$Hj("inChat",!1,{type:"boolean",description:(0,l.localize)(10,null)}),e.$3F=new N.$Hj("chatIsEnabled",!1,{type:"boolean",description:(0,l.localize)(11,null)}),e.$4F=new N.$Hj("chatCursorAtTop",!1),e.$5F=new N.$Hj("chatInputHasAgent",!1),e.$6F=new N.$Hj("chatLocation",void 0)}),define(ke[291],Ee([1,0,4,39,3,37,5,290]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.$4G=e.$3G=e.ChatAgentLocation=void 0;var $;(function(C){C.Panel="panel",C.Terminal="terminal",C.Notebook="notebook",C.Editor="editor"})($||(e.ChatAgentLocation=$={})),function(C){function m(E){switch(E){case"panel":return C.Panel;case"terminal":return C.Terminal;case"notebook":return C.Notebook;case"editor":return C.Editor}return C.Panel}C.fromRaw=m}($||(e.ChatAgentLocation=$={})),e.$3G=(0,M.$qi)("chatAgentService");let S=class{static{this.AGENT_LEADER="@"}constructor(m){this.f=m,this.b=[],this.d=new l.$be,this.onDidChangeAgents=this.d.event,this.e=b.$3F.bindTo(this.f)}registerAgent(m,E){if(this.getAgent(m))throw new Error(`Agent already registered: ${JSON.stringify(m)}`);const u=this,f=E.slashCommands;E={...E,get slashCommands(){return f.filter(n=>!n.when||u.f.contextMatchesRules(R.$oj.deserialize(n.when)))}};const a={data:E};return this.b.push(a),(0,L.$Sc)(()=>{this.b=this.b.filter(n=>n!==a),this.d.fire(void 0)})}registerAgentImplementation(m,E){const v=this.g(m);if(!v)throw new Error(`Unknown agent: ${JSON.stringify(m)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(m)}`);return v.data.isDefault&&this.e.set(!0),v.impl=E,this.d.fire(new A(v.data,E)),(0,L.$Sc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(m,E){const v={data:m,impl:E};return this.b.push(v),this.d.fire(new A(m,E)),(0,L.$Sc)(()=>{this.b=this.b.filter(u=>u!==v),this.d.fire(void 0)})}updateAgent(m,E){const v=this.g(m);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify(m)} registered`);v.data.metadata={...v.data.metadata,...E},this.d.fire(new A(v.data,v.impl))}getDefaultAgent(m){return this.getActivatedAgents().find(E=>!!E.isDefault&&E.locations.includes(m))}getContributedDefaultAgent(m){return this.getAgents().find(E=>!!E.isDefault&&E.locations.includes(m))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),m=>!!m.data.metadata.isSecondary)?.data}g(m){return this.b.find(E=>E.data.id===m)}getAgent(m){return this.g(m)?.data}getAgents(){return this.b.map(m=>m.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(m=>!!m.impl).map(m=>new A(m.data,m.impl))}getAgentsByName(m){return this.getAgents().filter(E=>E.name===m)}async invokeAgent(m,E,v,u,f){const a=this.g(m);if(!a?.impl)throw new Error(`No activated agent with id ${m}`);return await a.impl.invoke(E,v,u,f)}async getFollowups(m,E,v,u,f){const a=this.g(m);if(!a?.impl)throw new Error(`No activated agent with id ${m}`);return a.impl?.provideFollowups?a.impl.provideFollowups(E,v,u,f):[]}};e.$4G=S,e.$4G=S=Je([qe(0,R.$Ij)],S);class A{constructor(m,E){this.b=m,this.d=E}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(m,E,v,u){return this.d.invoke(m,E,v,u)}async provideFollowups(m,E,v,u){return this.d.provideFollowups?this.d.provideFollowups(m,E,v,u):[]}provideWelcomeMessage(m,E){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(m,E)}provideSampleQuestions(m,E){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(m,E)}}e.$5G=A}),define(ke[292],Ee([1,0,2,29,5]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$$F=R,e.$_F=M;function R(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof l.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(N.$kt.isIRange)}function M(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(R)}var b;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$aG=(0,L.$qi)("IChatService"),e.$bG="accessibility.voice.keywordActivation"}),define(ke[143],Ee([1,0,4,8,236]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eob=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new l.$be,this.o=new l.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,$,S,A){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.u("request",C),typeof A=="number"){const m=setTimeout(()=>{clearTimeout(m);const E=this.f.get(C.seq);if(E){this.f.delete(C.seq);const v={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,L.localize)(0,null,A,b)};E(v)}},A)}return S&&this.f.set(C.seq,S),C.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,$){return b.type!=="event"||$.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,N.$rh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,S=this.f.get($.request_seq);S&&(this.f.delete($.request_seq),S($));break}}}}u(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,S)=>b.set(S,$)),await(0,N.$rh)(500),b.forEach(($,S)=>{$({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.f.delete(S)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Eob=R}),define(ke[293],Ee([1,0,2,237,37,5]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$iJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$gJ=e.MemoryRangeType=e.State=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=void 0,e.$fJ=$,e.$hJ=A,e.$6H="workbench.view.debug",e.$7H="workbench.debug.variablesView",e.$8H="workbench.debug.watchExpressionsView",e.$9H="workbench.debug.callStackView",e.$0H="workbench.debug.loadedScriptsView",e.$$H="workbench.debug.breakPointsView",e.$_H="workbench.debug.disassemblyView",e.$aI="workbench.panel.repl",e.$bI="workbench.panel.repl.view",e.$cI=new L.$Hj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$dI=new L.$Hj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$eI=new L.$Hj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$fI="debugUx",e.$gI=new L.$Hj(e.$fI,"default",{type:"string",description:N.localize(3,null)}),e.$hI=new L.$Hj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$iI=new L.$Hj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$jI=new L.$Hj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$kI=new L.$Hj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$lI=new L.$Hj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$mI=new L.$Hj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$nI=new L.$Hj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$oI=new L.$Hj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$pI=new L.$Hj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$qI=new L.$Hj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$rI=new L.$Hj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$sI=new L.$Hj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$tI=new L.$Hj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$uI=new L.$Hj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$vI=new L.$Hj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$wI=new L.$Hj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$xI=new L.$Hj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$yI=new L.$Hj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$zI=new L.$Hj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$AI=new L.$Hj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$BI=new L.$Hj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$CI=new L.$Hj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$DI=new L.$Hj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$EI=new L.$Hj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$FI=new L.$Hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$GI=new L.$Hj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$HI=new L.$Hj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$II=new L.$Hj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$JI=new L.$Hj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$KI=new L.$Hj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$LI=new L.$Hj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$MI=new L.$Hj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$NI=new L.$Hj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$OI=new L.$Hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$PI=new L.$Hj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$QI=new L.$Hj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$RI=new L.$Hj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$SI=new L.$Hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$TI=new L.$Hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$UI=new L.$Hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$VI=new L.$Hj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$WI=new L.$Hj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$XI=new L.$Hj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$YI=new L.$Hj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$ZI=new L.$Hj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$1I=new L.$Hj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$2I=new L.$Hj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$3I=new L.$Hj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$4I=new L.$Hj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$5I=new L.$Hj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$6I=new L.$Hj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$7I=new L.$Hj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$8I=new L.$Hj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$9I=new L.$Hj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$0I=new L.$Hj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$$I=new L.$Hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$_I=new L.$Hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$aJ=M,e.$bJ="editor.contrib.debug",e.$cJ="editor.contrib.breakpoint",e.$dJ="debug",e.$eJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var b;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(b||(e.State=b={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var S;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$gJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var C;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(C||(e.DataBreakpointSetType=C={}));var m;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$iJ=(0,R.$qi)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var u;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(u||(e.DebugVisualizationType=u={}));var f;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(f||(e.DebugTreeItemCollapsibleState=f={}));var a;(function(i){i.deserialize=s=>s,i.serialize=s=>s})(a||(e.IDebugVisualizationTreeItem=a={}));var n;(function(i){i.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:l.URI.revive(s.iconPath.light),dark:l.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),i.serialize=s=>s})(n||(e.IDebugVisualization=n={}))}),define(ke[294],Ee([1,0,14,2,17,24,15,29,22,19]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=void 0,e.$8G=C,e.$9G=m,e.$0G=E,e.$$G=v,e.$_G=u,e.$aH=f,e.$bH=a,e.$cH=i,e.$dH=t,e.$eH=g,e.$fH=c,e.$gH=w;const A=/{([^}]+)}/g;function C(D,p,k){return D.replace(A,function(y,P){return p&&P.length>0&&P[0]!=="_"?y:k&&k.hasOwnProperty(P)?k[P]:y})}function m(D){const p={};for(const k of Object.keys(D))k.startsWith("!")||(p[k]=D[k]);return p}function E(D){return D.configuration.request==="attach"&&!v(D)&&(!D.parentSession||E(D.parentSession))}function v(D){let p=D.configuration.type;if(p)return p==="vslsShare"&&(p=D.configuration.adapterProxy.configuration.type),(0,l.$tf)(p,"extensionhost")||(0,l.$tf)(p,"pwa-extensionhost")?D:D.parentSession?v(D.parentSession):void 0}function u(D){return D.type&&(D.label||D.program||D.runtime)}function f(D,p,k){let y,P=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=I.exec(D);){const j=F.index+1,z=j+F[0].length;if(j<=p&&z>=k){y=F[0],P=j;break}}if(y){const j=/\w+/g;let z=null;for(;(z=j.exec(y))&&!(z.index+1+P+z[0].length>=k););z&&(y=y.substring(0,j.lastIndex))}return y?{start:P,end:P+y.length-1}:{start:0,end:0}}async function a(D,p,k,y){if(D.evaluatableExpressionProvider.has(p)){const P=D.evaluatableExpressionProvider.ordered(p),I=(0,S.$Hb)(await Promise.all(P.map(async F=>{try{return await F.provideEvaluatableExpression(p,k,y??$.CancellationToken.None)}catch{return}})));if(I.length>0){let F=I[0].expression;const j=I[0].range;return F||(F=p.getLineContent(k.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:F}}}else{const P=p.getLineContent(k.lineNumber),{start:I,end:F}=f(P,k.column,k.column),j=P.substring(I-1,F);return{matchingExpression:j,range:new b.$kt(k.lineNumber,I,k.lineNumber,I+j.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function s(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return N.URI.parse(D.path);if((0,L.$jc)(D.path))return N.URI.file(D.path)}return D.path}function o(D){if(typeof D.path=="object"){const p=N.URI.revive(D.path);if(p)return p.scheme===M.Schemas.file?p.fsPath:p.toString()}return D.path}function t(D,p){const k=p?s:o,y=(0,R.$Wn)(D);return h(y,(P,I)=>{P&&I&&(I.path=k(I))}),y}function g(D,p){const k=p?s:o,y=(0,R.$Wn)(D);return h(y,(P,I)=>{!P&&I&&(I.path=k(I))}),y}function h(D,p){switch(D.type){case"event":{const k=D;switch(k.event){case"output":p(!1,k.body.source);break;case"loadedSource":p(!1,k.body.source);break;case"breakpoint":p(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=D;switch(k.command){case"setBreakpoints":p(!0,k.arguments.source);break;case"breakpointLocations":p(!0,k.arguments.source);break;case"source":p(!0,k.arguments.source);break;case"gotoTargets":p(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(y=>p(!1,y));break;default:break}break}case"response":{const k=D;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(y=>p(!1,y.source));break;case"loadedSources":k.body.sources.forEach(y=>p(!1,y));break;case"scopes":k.body.scopes.forEach(y=>p(!1,y.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(y=>p(!1,y.source));break;case"setBreakpoints":k.body.breakpoints.forEach(y=>p(!1,y.source));break;case"disassemble":k.body?.instructions.forEach(P=>p(!1,P.location));break;default:break}break}}}function c(D){return D.filter(p=>!p.presentation?.hidden).sort((p,k)=>p.presentation?k.presentation?p.presentation.group?k.presentation.group?p.presentation.group!==k.presentation.group?p.presentation.group.localeCompare(k.presentation.group):r(p.presentation.order,k.presentation.order):-1:k.presentation.group?1:r(p.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function r(D,p){return typeof D!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:D-p}async function w(D,p){const k=D.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(k!=="none"&&(await p.saveAll(),k==="allEditorsInActiveGroup")){const y=p.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await p.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const d=(D,p)=>!D||!p?D===p:D.name===p.name&&D.path===p.path&&D.sourceReference===p.sourceReference;e.$hH=d}),define(ke[295],Ee([1,0,53,63,24,17,11,14,31,238,143]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=e.$ymc=e.$xmc=e.$wmc=e.$vmc=void 0;class C extends A.$Eob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(a,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,a.on("data",i=>this.v(i))}sendMessage(a){if(this.l){const n=JSON.stringify(a);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${C.a}${n}`,"utf8")}}v(a){for(this.p=Buffer.concat([this.p,a]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(C.a);if(n!==-1){const s=this.p.toString("utf8",0,n).split(C.b);for(const o of s){const t=o.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+C.a.length);continue}}break}}}e.$vmc=C;class m extends C{startSession(){return new Promise((a,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),a(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",s=>{i?this.n.fire(s):n(s)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$wmc=m;class E extends m{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$xmc=E;class v extends m{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.path,a)}}e.$ymc=v;class u extends C{constructor(a,n){super(),this.y=a,this.z=n}async startSession(){const a=this.y.command,n=this.y.args,i=this.y.options||{};try{if(a)if(R.$jc(a)){if(!await $.Promises.exists(a))throw new Error(S.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.z));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=L.$Zn(L.$Wn(process.env),i.env)),a==="node")if(Array.isArray(n)&&n.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:s,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const g=l.fork(n[0],n.slice(1),t);if(!g.pid)throw new Error(S.localize(2,null,n[0]));this.x=g}else throw new Error(S.localize(3,null));else{const o={env:s};i.cwd&&(o.cwd=i.cwd),this.x=l.spawn(a,n,o)}this.x.on("error",o=>{this.n.fire(o)}),this.x.on("exit",(o,t)=>{this.o.fire(o)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.n.fire(o)}),this.x.stdin.on("error",o=>{this.n.fire(o)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((a,n)=>{const i=l.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,o,t){if(s)return n(s)});i.on("exit",a),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,n){if(!a)return;const i=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?i.runtime=R.$kc(n,a.runtime):i.runtime=a.runtime),a.runtimeArgs&&(i.runtimeArgs=a.runtimeArgs),a.program&&(R.$jc(a.program)?i.program=a.program:i.program=R.$kc(n,a.program)),a.args&&(i.args=a.args);const s=a;return s.win&&(i.win=u.A(s.win,n)),s.winx86&&(i.winx86=u.A(s.winx86,n)),s.windows&&(i.windows=u.A(s.windows,n)),s.osx&&(i.osx=u.A(s.osx,n)),s.linux&&(i.linux=u.A(s.linux,n)),i}static platformAdapterExecutable(a,n){let i=Object.create(null);n=n.toLowerCase();for(const c of a)if(c.contributes){const r=c.contributes.debuggers;r&&r.length>0&&r.filter(w=>typeof w.type=="string"&&b.$tf(w.type,n)).forEach(w=>{const d=u.A(w,c.extensionLocation.fsPath);i=L.$Zn(i,d,c.isBuiltin)})}let s;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:M.$i?s=i.win||i.windows:M.$j?s=i.osx:M.$k&&(s=i.linux),s=s||i;const o=s.program||i.program,t=s.args||i.args,g=s.runtime||i.runtime,h=s.runtimeArgs||i.runtimeArgs;if(g)return{type:"executable",command:g,args:(h||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$zmc=u}),define(ke[296],Ee([1,0,53,34,11]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=M,e.$Bmc=$;function R(S,A){return new Promise((C,m)=>{let E="";const v=l.spawn(S,A);v.pid&&v.stdout.on("data",u=>{E+=u.toString()}),v.on("error",u=>{m(u)}),v.on("close",u=>{C(E)})})}async function M(S){if(S)if(L.$i){const A=await new Promise((C,m)=>{le(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{A.getProcessTree(S,m=>{C(!!m&&m.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(S)]).then(A=>{const C=A.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(S){S[S.cmd=0]="cmd",S[S.powershell=1]="powershell",S[S.bash=2]="bash"})(b||(b={}));function $(S,A,C,m,E){S=S.trim().toLowerCase();let v;S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0?v=1:S.indexOf("cmd.exe")>=0?v=0:S.indexOf("bash")>=0?v=2:L.$i?v=0:v=2;let u,f=" ";switch(v){case 1:if(u=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),m){const a=(0,N.$vg)(m);a&&(f+=`${a}:; `),f+=`cd ${u(m)}; `}if(E)for(const a in E){const n=E[a];n===null?f+=`Remove-Item env:${a}; `:f+=`\${env:${a}}='${n}'; `}if(A.length>0){const a=A.shift(),n=C?a:u(a);f+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of A)f+=i==="<"||i===">"||C?i:u(i),f+=" "}break;case 0:if(u=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>a.includes(n))||a.length===0?`"${a}"`:a),m){const a=(0,N.$vg)(m);a&&(f+=`${a}: && `),f+=`cd ${u(m)} && `}if(E){f+='cmd /C "';for(const a in E){let n=E[a];n===null?f+=`set "${a}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),f+=`set "${a}=${n}" && `)}}for(const a of A)f+=a==="<"||a===">"||C?a:u(a),f+=" ";E&&(f+='"');break;case 2:{u=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const a=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(m&&(f+=`cd ${u(m)} ; `),E){f+="/usr/bin/env";for(const n in E){const i=E[n];i===null?f+=` -u ${a(n)}`:f+=` ${a(`${n}=${i}`)}`}f+=" "}for(const n of A)f+=n==="<"||n===">"||C?n:u(n),f+=" ";break}}return f}}),define(ke[297],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.CellExecutionUpdateType=void 0;var N;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$vK=(0,l.$qi)("INotebookExecutionService")}),define(ke[298],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yib=e.$xib=e.ProxyKernelState=e.$wib=void 0,e.$wib=100;var N;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$xib=(0,l.$qi)("INotebookKernelService"),e.$yib=(0,l.$qi)("INotebookKernelHistoryService")}),define(ke[299],Ee([1,0,3,29,200,100]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mWb=void 0;class M extends l.$Uc{constructor($,S,A){super(),this._source=$,this.b=S,this.c=A,this.a=void 0}f($){const S=$.getLineCount();return new N.$kt(1,1,S,this.g($,S))}g($,S){if(S<1||S>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(S)+1}get inputTextBuffer(){if(!this.b){const $=new L.$MC;$.acceptChunk(this._source);const S=$.finish(!0),{textBuffer:A,disposable:C}=S.create(1);this.b=A,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const S=new L.$MC;S.acceptChunk($);const A=S.finish(!0),{textBuffer:C,disposable:m}=A.create(1);return this.B(m),C})),this.a}findInInputs($){const A=new R.$AC($,!1,!1,null).parseSearchRequest();if(!A)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,A,!0,5e3)}findInOutputs($){const A=new R.$AC($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),A,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$mWb=M}),define(ke[68],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(R){R.Delimiter="\0"})(l||(e.TestIdPathParts=l={}));var N;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class L{static fromExtHostTestItem(M,b,$=M.parent){if(M._isRoot)return new L([b]);const S=[M.id];for(let A=$;A&&A.id!==b;A=A.parent)S.push(A.id);return S.push(b),new L(S.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new L(M.split("\0"))}static join(M,b){return new L([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:L.isChild(M,b)?2:L.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new L(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new L(this.path,M)}compare(M){if(typeof M=="string")return L.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$BL=L}),define(ke[89],Ee([1,0,2,50,29,68]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$IL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HL=e.$GL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EL=e.$DL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$CL=e.TestResultState=void 0;var M;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$CL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$DL=[2,4,8,16,32,64];const S=O=>"runId"in O;e.$EL=S;var A;(function(O){O.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({range:L.$kt.lift(B.range),uri:T.asCanonicalUri(l.URI.revive(B.uri))})})(A||(e.IRichLocation=A={}));var C;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(O){O.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&A.deserialize(T,B.location)})})(m||(e.ITestErrorMessage=m={}));const E=(O,T)=>`${T?"s":"e"}${O}`;e.$FL=E;var v;(function(O){O.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&A.deserialize(T,B.location)})})(v||(e.ITestOutputMessage=v={}));var u;(function(O){O.serialize=T=>T.type===0?m.serialize(T):v.serialize(T),O.deserialize=(T,B)=>B.type===0?m.deserialize(T,B):v.deserialize(T,B)})(u||(e.ITestMessage=u={}));var f;(function(O){O.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),O.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(u.serialize)}),O.deserialize=(T,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>u.deserialize(T,W))})})(f||(e.ITestTaskState=f={}));const a="\0",n=(O,T)=>O+a+T;e.$GL=n;const i=O=>{const T=O.indexOf(a);return{ctrlId:O.slice(0,T),tagId:O.slice(T+1)}};e.$HL=i;var s;(function(O){O.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),O.deserialize=(T,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?T.asCanonicalUri(l.URI.revive(B.uri)):void 0,range:B.range?L.$kt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(s||(e.ITestItem=s={}));var o;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(O){O.serialize=T=>({expand:T.expand,item:s.serialize(T.item)}),O.deserialize=(T,B)=>({controllerId:R.$BL.root(B.item.extId),expand:B.expand,item:s.deserialize(T,B.item)})})(t||(e.InternalTestItem=t={}));var g;(function(O){O.serialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.uri!==void 0&&(B.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(B.range=T.item.range?.toJSON()),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}},O.deserialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.range!==void 0&&(B.range=T.item.range?L.$kt.lift(T.item.range):null),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}}})(g||(e.ITestItemUpdate=g={}));const h=(O,T)=>{T.expand!==void 0&&(O.expand=T.expand),T.item!==void 0&&(O.item=O.item?Object.assign(O.item,T.item):T.item)};e.$IL=h;var c;(function(O){O.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(f.serializeWithoutMessages)}),O.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(f.serialize)}),O.deserialize=(T,B)=>({...t.deserialize(T,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>f.deserialize(T,W)),retired:!0})})(c||(e.TestResultItem=c={}));var r;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(T,B)=>{T.covered+=B.covered,T.total+=B.total}})(r||(e.ICoverageCount=r={}));var w;(function(O){O.serialize=T=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:T.asCanonicalUri(l.URI.revive(B.uri))})})(w||(e.IFileCoverage=w={}));function d(O){return{...O,location:O.location?.toJSON()}}function D(O){return O.location=O.location?N.$jt.isIPosition(O.location)?N.$jt.lift(O.location):L.$kt.lift(O.location):void 0,O}e.$JL=3;var p;(function(O){O[O.Declaration=0]="Declaration",O[O.Statement=1]="Statement",O[O.Branch=2]="Branch"})(p||(e.DetailType=p={}));var k;(function(O){O.serialize=T=>T.type===0?P.serialize(T):I.serialize(T),O.deserialize=T=>T.type===0?P.deserialize(T):I.deserialize(T)})(k||(e.CoverageDetails=k={}));var y;(function(O){O.serialize=d,O.deserialize=D})(y||(e.IBranchCoverage=y={}));var P;(function(O){O.serialize=d,O.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var I;(function(O){O.serialize=T=>({...d(T),branches:T.branches?.map(y.serialize)}),O.deserialize=T=>({...D(T),branches:T.branches?.map(y.deserialize)})})(I||(e.IStatementCoverage=I={}));var F;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var j;(function(O){O.deserialize=(T,B)=>B.op===0?{op:B.op,item:t.deserialize(T,B.item)}:B.op===1?{op:B.op,item:g.deserialize(B.item)}:B.op===2?{op:B.op,uri:T.asCanonicalUri(l.URI.revive(B.uri)),docv:B.docv}:B,O.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:g.serialize(T.item)}:T})(j||(e.TestsDiffOp=j={}));class z{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const B=this.v();for(const W of T)switch(W.op){case 0:this.l(t.deserialize(this.k,W.item),B);break;case 1:this.o(g.deserialize(W.item),B);break;case 3:this.p(W.itemId,B);break;case 5:this.q(W.itemId);break;case 4:this.updatePendingRoots(W.amount);break;case 6:this.c.set(W.tag.id,W.tag);break;case 7:this.c.delete(W.id);break}B.complete?.()}l(T,B){const W=R.$BL.parentId(T.item.extId)?.toString();let X;if(!W)X=this.w(T),this.g.add(X),this.f.set(T.item.extId,X);else if(this.f.has(W)){const x=this.f.get(W);x.children.add(T.item.extId),X=this.w(T,x),this.f.set(T.item.extId,X)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return B.add?.(X),T.expand===2&&this.h++,X}o(T,B){const W=this.f.get(T.extId);if(W)return T.expand!==void 0&&(W.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$IL)(W,T),B.update?.(W),W}p(T,B){const W=this.f.get(T);if(!W)return;const X=R.$BL.parentId(W.item.extId)?.toString();X?this.f.get(X).children.delete(W.item.extId):this.g.delete(W);const x=[[T]];for(;x.length;)for(const Z of x.pop()){const Y=this.f.get(Z);Y&&(x.push(Y.children),this.f.delete(Z),B.remove?.(Y,Y!==W),Y.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$KL=z}),define(ke[112],Ee([1,0,8,4,3,62,89,68]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const S=(n,i)=>n===i,C=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:S,label:S,description:S,error:S,sortText:S,tags:(n,i)=>!(n.length!==i.length||n.some(s=>!i.includes(s)))}),m=(n,i)=>{let s;for(const[o,t]of C)t(n[o],i[o])||(s?s[o]=i[o]:s={[o]:i[o]});return s};class E extends L.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new l.$Ch(()=>this.flushDiff(),200)),this.g=this.B(new N.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const s of this.m)if(s.op===2&&s.uri===i.uri){s.docv=i.docv;return}break}case 1:{const s=this.m[this.m.length-1];if(s){if(s.op===1&&s.item.extId===i.item.extId){(0,M.$IL)(s.item,i.item);return}if(s.op===0&&s.item.item.extId===i.item.extId){(0,M.$IL)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const o=this.tree.get(i);if(o){if((o.expandLevels===void 0||s>o.expandLevels)&&(o.expandLevels=s),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,s-1):t.wait().then(()=>this.L(o,s-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,s-1)):this.L(o,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,s){switch(s.op){case 3:this.O(b.$BL.joinToString(i.fullId,s.id));break;case 0:this.z(s.item,i);break;case 5:for(const o of s.ops)this.w(i,o);break;case 1:this.C(s.new,s.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:s.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$cd)(s)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,s){const o=b.$BL.fromExtHostTestItem(i,this.root.id,s?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(i.id);let g=this.tree.get(o.toString());if(!g){g={fullId:o,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(i,s),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(i)}}),this.I(i,g,s);return}if(g.actual===i){this.H(i,g,s);return}if(g.actual.uri?.toString()!==i.uri?.toString())return this.O(o.toString()),this.z(i,s);const h=this.s.getChildren(g.actual),c=g.actual,r=m(this.s.toITestItem(c),this.s.toITestItem(i));this.s.getApiFor(c).listener=void 0,g.actual=i,g.resolveBarrier=void 0,g.expand=0,r&&(r.hasOwnProperty("tags")&&(this.C(i.tags,c.tags,o.toString()),delete r.tags),this.w(g,{op:4,update:r})),this.I(i,g,s);for(const[d,D]of h)this.s.getChildren(i).get(D.id)||this.O(b.$BL.joinToString(o,D.id));const w=g.expandLevels;w!==void 0&&queueMicrotask(()=>{g.expand===1&&(g.expandLevels=void 0,this.expand(o.toString(),w))}),this.y(g.actual.uri)}C(i,s,o){const t=new Set(s.map(g=>g.id));for(const g of i)t.delete(g.id)||this.D(g);this.pushDiff({op:1,item:{extId:o,item:{tags:i.map(g=>(0,M.$GL)(this.s.controllerId,g.id))}}}),t.forEach(this.F,this)}D(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$GL)(this.s.controllerId,i.id)}}))}F(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$GL)(this.s.controllerId,i)}))}G(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}H(i,s,o){this.G(i,o);const t=this.s.getApiFor(i);t.parent=o?.actual,t.listener=g=>this.w(s,g),this.J(s)}I(i,s,o){this.H(i,s,o);for(const[t,g]of this.s.getChildren(i))this.z(g,s)}J(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?3:2:s=i.actual.canResolveChildren?1:0:s=0,s!==i.expand&&(i.expand=s,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:s}}),s===1&&i.expandLevels!==void 0&&this.M(i))}L(i,s){if(s<0)return;const o=[];for(const[t,g]of this.s.getChildren(i.actual)){const h=this.expand(b.$BL.joinToString(i.fullId,g.id),s);(0,l.$ch)(h)&&o.push(h)}if(o.length)return Promise.all(o).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const g=new l.$ph;return g.open(),g}i.expand=2,this.N(i);const s=i.resolveBarrier=new l.$ph,o=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(g){o(g)}return(0,l.$ch)(t)?t.catch(o).then(()=>{s.open(),this.J(i)}):(s.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const o=[s];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const g of t.actual.tags)this.F(g.id);this.tree.delete(t.fullId.toString());for(const[g,h]of this.s.getChildren(t.actual))o.push(this.tree.get(b.$BL.joinToString(t.fullId,h.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$5O=E;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$6O=v;class u extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$7O=u;class f extends Error{constructor(i,s,o){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${o}".`)}}e.$8O=f;const a=(n,i,s)=>{let o=new Map;return{get size(){return o.size},forEach(t,g){for(const h of o.values())t.call(g,h,this)},[Symbol.iterator](){return o.entries()},replace(t){const g=new Map,h=new Set(o.keys()),c={op:5,ops:[]};for(const r of t){if(!(r instanceof s))throw new u(r.id);const w=i(r).controllerId;if(w!==n.controllerId)throw new f(r.id,w,n.controllerId);if(g.has(r.id))throw new v(r.id);g.set(r.id,r),h.delete(r.id),c.ops.push({op:0,item:r})}for(const r of h.keys())c.ops.push({op:3,id:r});n.listener?.(c),o=g},add(t){if(!(t instanceof s))throw new u(t.id);o.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){o.delete(t)&&n.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$9O=a}),define(ke[144],Ee([1,0,112]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.$0O=void 0;const N=new WeakMap,L=(M,b)=>{const $={controllerId:b};return N.set(M,$),$};e.$0O=L;const R=M=>{const b=N.get(M);if(!b)throw new l.$7O(M?.id||"<unknown>");return b};e.$$O=R}),define(ke[113],Ee([1,0,15,2]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qxb=e.$Pxb=e.$Oxb=void 0,e.$Rxb=L,e.$Sxb=M,e.$Oxb="vscode-cdn.net",e.$Pxb=`vscode-resource.${e.$Oxb}`,e.$Qxb=`'self' https://*.${e.$Oxb}`;function L(b,$){return b.scheme===l.Schemas.http||b.scheme===l.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===l.Schemas.file&&(b=N.URI.from({scheme:l.Schemas.vscodeRemote,authority:$.authority,path:b.path})),N.URI.from({scheme:l.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$Pxb}`,path:b.path,fragment:b.fragment,query:b.query}))}function R(b){return b.replace(/./g,$=>{const S=$.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?$:"-"+S.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,($,S)=>String.fromCharCode(parseInt(S,16)))}}),define(ke[300],Ee([1,0,4,3,113]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=void 0;class R{constructor(b,$,S){this.d=b,this.e=$,this.f=S,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const C of this.c.values())A.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,S,A,C){let m;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){m=i;break}if(!m)throw new Error("not a visible editor");const E=this,v=this.a++,u=new l.$be,f=new l.$be,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$Rxb)(i,E.f)}get cspSource(){return L.$Qxb}set options(i){this.b=i,E.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(i){return E.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=b,this.line=$,this.height=S,this.webview=a,this.onDidDispose=f.event}dispose(){E.c.has(v)&&(E.c.delete(v),E.d.$disposeEditorInset(v),f.fire(),f.dispose(),u.dispose())}};return this.d.$createEditorInset(v,m.id,m.value.document.uri,$+1,S,A||{},C.identifier,C.extensionLocation),this.c.set(v,{editor:b,inset:n,onDidReceiveMessage:u}),n}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$wkc=R}),define(ke[145],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=void 0,e.$RL="__",e.$SL=(0,l.$qi)("IAuthenticationService"),e.$TL=(0,l.$qi)("IAuthenticationExtensionsService")}),define(ke[301],Ee([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.VariableKind=e.$1P=void 0,e.$1P=(0,l.$qi)("configurationResolverService");var N;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class L extends Error{constructor(M,b){super(b),this.variable=M}}e.$2P=L}),define(ke[302],Ee([1,0,17,51,18,24,11,103,241,301,14]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,v,u,f){this.h=new Map,this.a=E,this.b=v,this.g=u,f&&(this.c=f.then(a=>this.i(a)))}i(E){if(M.$i){const v=Object.create(null);return Object.keys(E).forEach(u=>{v[u.toLowerCase()]=E[u]}),v}return E}resolveWithEnvironment(E,v,u){return this.l({env:this.i(E),userHome:void 0},v?v.uri:void 0,u)}async resolveAsync(E,v){const u={env:await this.c,userHome:await this.g};return this.l(u,E?E.uri:void 0,v)}async j(E,v,u,f){const a=R.$Wn(v);M.$i&&a.windows?Object.keys(a.windows).forEach(i=>a[i]=a.windows[i]):M.$j&&a.osx?Object.keys(a.osx).forEach(i=>a[i]=a.osx[i]):M.$k&&a.linux&&Object.keys(a.linux).forEach(i=>a[i]=a.linux[i]),delete a.windows,delete a.osx,delete a.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,a,u,f)}async resolveAnyAsync(E,v,u){return this.j(E,v,u)}async resolveAnyMap(E,v,u){const f=new Map;return{newConfig:await this.j(E,v,u,f),resolvedVariables:f}}resolveWithInteractionReplace(E,v,u,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,v,u,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,v){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,v)}async l(E,v,u,f,a){if(L.$4f(u))return this.m(E,v,u,f,a);if(Array.isArray(u))return Promise.all(u.map(n=>this.l(E,v,n,f,a)));if(L.$6f(u)){const n=Object.create(null),i=await Promise.all(Object.keys(u).map(async s=>[await this.m(E,v,s,f,a),await this.l(E,v,u[s],f,a)]));for(const[s,o]of i)n[s]=o;return n}return u}m(E,v,u,f,a){return(0,A.$lf)(u,C.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(C.VARIABLE_LHS))return n;let s=await this.o(E,n,i,v,f);return a?.set(i,s),s!==n&&L.$4f(s)&&s.match(C.VARIABLE_REGEXP)&&(s=await this.m(E,v,s,f,a)),s})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,v,u,f,a){let n;const i=u.split(":");i.length>1&&(u=i[0],n=i[1]);const s=g=>{const h=this.a.getFilePath();if(h)return(0,b.$pw)(h);throw new S.$2P(g,(0,$.localize)(0,null,v))},o=g=>{const h=s(g);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,b.$pw)(c)}throw new S.$2P(g,(0,$.localize)(1,null,v,l.$oc(h)))},t=g=>{if(n){const h=this.a.getFolderUri(n);if(h)return h;throw new S.$2P(g,(0,$.localize)(2,null,v,n))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new S.$2P(g,(0,$.localize)(3,null,v)):new S.$2P(g,(0,$.localize)(4,null,v))};switch(u){case"env":if(n){if(E.env){const g=E.env[M.$i?n.toLowerCase():n];if(L.$4f(g))return g}return""}throw new S.$2P(S.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(n){const g=this.a.getConfigurationValue(f,n);if(L.$ag(g))throw new S.$2P(S.VariableKind.Config,(0,$.localize)(6,null,v,n));if(L.$6f(g))throw new S.$2P(S.VariableKind.Config,(0,$.localize)(7,null,v,n));return g}throw new S.$2P(S.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(S.VariableKind.Command,v,n,a,"command");case"input":return this.p(S.VariableKind.Input,v,n,a,"input");case"extensionInstallFolder":if(n){const g=await this.a.getExtension(n);if(!g)throw new S.$2P(S.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,n));return this.n(g.extensionLocation)}throw new S.$2P(S.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,b.$pw)(this.n(t(S.VariableKind.WorkspaceFolder)));case"cwd":return f||n?(0,b.$pw)(this.n(t(S.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$pw)(l.$oc(this.n(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new S.$2P(S.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new S.$2P(S.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new S.$2P(S.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return s(S.VariableKind.File);case"fileWorkspaceFolder":return o(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return l.$oc(o(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||n?l.$mc(this.n(t(S.VariableKind.RelativeFile)),s(S.VariableKind.RelativeFile)):s(S.VariableKind.RelativeFile);case"relativeFileDirname":{const g=l.$nc(s(S.VariableKind.RelativeFileDirname));if(f||n){const h=l.$mc(this.n(t(S.VariableKind.RelativeFileDirname)),g);return h.length===0?".":h}return g}case"fileDirname":return l.$nc(s(S.VariableKind.FileDirname));case"fileExtname":return l.$pc(s(S.VariableKind.FileExtname));case"fileBasename":return l.$oc(s(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=l.$oc(s(S.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-l.$pc(g).length)}case"fileDirnameBasename":return l.$oc(l.$nc(s(S.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||v}case"execInstallFolder":{const g=this.a.getAppRoot();return g||v}case"pathSeparator":case"/":return l.sep;default:try{const g=n?`${u}:${n}`:u;return this.p(S.VariableKind.Unknown,v,g,a,void 0)}catch{return v}}}}p(E,v,u,f,a){if(u&&f){const n=a===void 0?f[u]:f[a+":"+u];if(typeof n=="string")return n;throw new S.$2P(E,(0,$.localize)(14,null,v))}return v}}e.$eQ=C}),define(ke[146],Ee([1,0,5,142]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ID=void 0,e.$JD=S,e.$KD=m,e.$LD=E,e.$ID=(0,l.$qi)("editorGroupsService");var L;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var M;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function S(v){const u=v;return(0,N.$tF)(u?.editor)&&(0,N.$tF)(u?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var C;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(v){const u=v;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}function E(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[303],Ee([1,0,5,146]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$QD=L,e.$MD=(0,l.$qi)("editorService"),e.$ND=-1,e.$OD=-2,e.$PD=-3;function L(R){const M=R;return typeof R=="number"||(0,N.$KD)(M)}}),define(ke[147],Ee([1,0,5,136]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=void 0,e.$aM=(0,l.$ri)(N.$xi)}),define(ke[148],Ee([1,0,25,4,17,3,8]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=e.$T$b=e.$S$b=e.$R$b=e.$Q$b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$Q$b=b;class ${static isHostExtension(n,i,s){if(i.getExtensionDescription(n))return!1;const o=s.getExtensionDescription(n);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$be,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(u),this.f=new l.$Nm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=f(this.e,i),this.e=this.e.concat(n);const s=$.l(this.e);return this.e=f(this.e,s.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,s)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,c){this.addNode(h),this.addNode(c),this.c.has(h)?this.c.get(h).push(c):this.c.set(h,[c])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,c){const r=i.getArcs(h);for(let w=0;w<r.length;w++)if(!c.has(r[w]))return!1;return!0}getNodes(){return this.e}},s=new l.$Nm;for(const h of n)if(s.set(h.identifier,h),h.extensionDependencies)for(const c of h.extensionDependencies)i.addArc(l.$Lm.toKey(h.identifier),l.$Lm.toKey(c));const o=new Set;i.getNodes().filter(h=>i.getArcs(h).length===0).forEach(h=>o.add(h));const t=i.getNodes().filter(h=>!o.has(h));let g;do{g=!1;for(let h=0;h<t.length;h++){const c=t[h];i.hasOnlyGoodArcs(c,o)&&(t.splice(h,1),h--,o.add(c),g=!0)}}while(g);return t.map(h=>s.get(h))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$R$b=$;class S{constructor(n,i){this.versionId=n,this.extensions=i}}e.$S$b=S;class A{constructor(n){this.d=new E,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new C(this,i)}deltaExtensions(n,i,s){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$T$b=A;class C extends R.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$U$b=C;class m{constructor(n){this.name=n;const i=(0,M.$jh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class E{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new m(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Sc)(o))}}var v;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(v||(v={}));function u(a,n){const i=a.isBuiltin?0:a.isUnderDevelopment?2:1,s=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==s)return i-s;const o=L.$hc.basename(a.extensionLocation.path),t=L.$hc.basename(n.extensionLocation.path);return o<t?-1:o>t?1:0}function f(a,n){const i=new l.$Mm(n);return a.filter(s=>!i.has(s.identifier))}}),define(ke[304],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.ExtHostConnectionType=void 0,e.$hn=b,e.$in=$;var l;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(l||(e.ExtHostConnectionType=l={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$en=N;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[L.ENV_KEY]="1"}}e.$fn=L;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[R.ENV_KEY]="1"}}e.$gn=R;function M(A){delete A[N.ENV_KEY],delete A[L.ENV_KEY],delete A[R.ENV_KEY]}function b(A,C){M(C),A.serialize(C)}function $(A){if(A[N.ENV_KEY])return S(A,new N(A[N.ENV_KEY]));if(A[L.ENV_KEY])return S(A,new L);if(A[R.ENV_KEY])return S(A,new R);throw new Error("No connection information defined in environment!")}function S(A,C){return M(A),C}}),define(ke[114],Ee([1,0,21]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Tm=M,e.$Um=b;var N;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(N||(e.UIKind=N={}));var L;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var R;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function M(S){const A=l.$Ce.alloc(1);switch(S){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(S,A){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var $;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Ee([1,0,5,4,12,28,114,86,87,24,2,3,226]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$uP=e.$tP=void 0,e.$vP=u;let E=class extends C.$Uc{constructor(a,n){super(),this.s=a,this.t=n,this.a=this.B(new N.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$ep,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$Yj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,n,i){const s=this.getTelemetryDetails(),o=new v(n,i,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,n,i){this.f=a,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const n=Object.create(null);switch(n["common.extname"]=`${a.publisher}.${a.name}`,n["common.extversion"]=a.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=u(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$Cm)((0,$.$kp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const n=this.getTelemetryDetails();this.r.forEach((i,s)=>{const o=i.filter(t=>!t.isDisposed);o.length===0?this.r.delete(s):this.r.set(s,o)}),this.r.forEach(i=>{for(const s of i)s.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,n){const s=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!s)return this.r.delete(a.value),!1;let o=!1;for(const t of s)t.ignoreUnhandledExtHostErrors||(t.logError(n),o=!0);return o}};e.$tP=E,e.$tP=E=Je([qe(0,R.$sP),qe(1,L.$Xj)],E);class v{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,n,i,s,o,t,g){this.g=i,this.h=s,this.i=o,this.j=t,this.a=new N.$be,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(a,n){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let n="properties"in a?a.properties??{}:a;return n=(0,$.$np)(n,[]),this.c&&(n=(0,S.$Zn)(n,this.c)),this.b||(n=(0,S.$Zn)(n,this.j)),"properties"in a?a.properties=n:a=n,a}k(a,n){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(a,n),this.h.trace(a,n))}logUsage(a,n){this.d.isUsageEnabled&&this.k(a,n)}logError(a,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,n);else{const i={name:a.name,message:a.message,stack:a.stack,cause:a.cause},s=(0,$.$np)(i,[]),o=new Error(s.message,{cause:s.cause});o.stack=s.stack,o.name=s.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(o,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const a=this,n={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$uP=v;function u(f){const a=Date.now()-new Date(f).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$wP=(0,l.$qi)("IExtHostTelemetry")}),define(ke[26],Ee([1,0,4,2,272,140,25,5]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=e.ActivationKind=e.$AG=e.$zG=e.$wG=e.ExtensionHostStartup=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$xG=m,e.$yG=E,e.$BG=a,e.$CG=n,e.$sG=Object.freeze({identifier:new M.$Lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$tG="extensions.webWorker",e.$uG=(0,b.$qi)("extensionService");class ${constructor(o){this.dependency=o}}e.$vG=$;var S;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,g){this.c=o,this.d=t.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$dG.createActivationEventsMap(this.d)}}set(o,t,g){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const h=[],c=[],r=[],w=[],d=C(this.d),D=C(t),p=(F,j)=>F.extensionLocation.toString()===j.extensionLocation.toString()||F.isBuiltin===j.isBuiltin||F.isUserBuiltin===j.isUserBuiltin||F.isUnderDevelopment===j.isUnderDevelopment;for(const F of this.d){const j=D.get(F.identifier);if(!j){h.push(F.identifier),d.delete(F.identifier);continue}if(!p(F,j)){h.push(F.identifier),d.delete(F.identifier);continue}}for(const F of t){const j=d.get(F.identifier);if(!j){c.push(F);continue}if(!p(j,F)){h.push(j.identifier),d.delete(j.identifier);continue}}const k=new M.$Mm(this.e),y=new M.$Mm(g);for(const F of this.e)y.has(F)||r.push(F);for(const F of g)k.has(F)||w.push(F);const P=R.$dG.createActivationEventsMap(c),I={versionId:o,toRemove:h,toAdd:c,addActivationEvents:P,myToRemove:r,myToAdd:w};return this.delta(I),I}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:g,myToRemove:h,myToAdd:c}=o,r=new M.$Mm(t),w=new M.$Mm(h);for(let d=0;d<this.d.length;d++)r.has(this.d[d].identifier)&&(this.d.splice(d,1),d--);for(let d=0;d<this.e.length;d++)w.has(this.e[d])&&(this.e.splice(d,1),d--);for(const d of g)this.d.push(d);for(const d of c)this.e.push(d);return this.f=null,o}containsExtension(o){for(const t of this.e)if(M.$Lm.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const g=R.$dG.readActivationEvents(t);for(const h of g)o.add(h)}return o}}e.$wG=A;function C(s){const o=new M.$Nm;for(const t of s)o.set(t.identifier,t);return o}function m(s,o){return s.enabledApiProposals?s.enabledApiProposals.includes(o):!1}function E(s,o){if(!m(s,o))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class v{constructor(o,t,g,h){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=g,this.activationReason=h}}e.$zG=v;class u{constructor(o,t){this.description=o,this.value=t}}e.$AG=u;var f;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function a(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,L.$tp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function n(s,o){return{identifier:new M.$Lm((0,L.$rp)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!o,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.onWillStop=l.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$DG=i}),define(ke[305],Ee([1,0,13,148,25,26,12,8]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=e.$Vkc=e.$Ukc=e.$Tkc=e.$Skc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,n,i,s){this.startup=a,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=s}}e.$Skc=$;class S{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,n){return a===-1||n===-1?-1:n-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Tkc=S;class A{constructor(a,n,i,s,o,t){this.activationFailed=a,this.activationFailedError=n,this.activationTimes=i,this.module=s,this.exports=o,this.subscriptions=t}}e.$Ukc=A;class C extends A{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Vkc=C;class m extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wkc=m;class E extends A{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(a,n,i,s){this.g=s,this.a=a,this.b=n,this.c=i,this.d=new L.$Nm,this.f=Object.create(null)}dispose(){for(const[a,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const a=[];for(const[n,i]of this.d)a.push(i.wait());await Promise.all(a)}isActivated(a){const n=this.d.get(a);return!!(n&&n.value)}getActivatedExtension(a){const n=this.d.get(a);if(!n||!n.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return n.value}async activateByEvent(a,n){if(this.f[a])return;const i=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(i.map(s=>({id:s.identifier,reason:{startup:n,extensionId:s.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,n){const i=this.a.getExtensionDescription(a);if(!i)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(a){const n=a.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const n=this.a.getExtensionDescription(a.id);if(!n){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new E(o));return this.c.onExtensionActivationError(a.id,o,new R.$vG(a.id.value)),t}const i=[],s=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const o of s){if(this.m(o))continue;const t=this.d.get(o);if(t){i.push(t);continue}if(this.l(o)){i.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const g=this.a.getExtensionDescription(o);if(g){if(!g.main&&!g.browser)continue;i.push(this.j({id:g.identifier,reason:a.reason}));continue}const h=n.displayName||n.identifier.value,c=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${o}'`),r=this.k(a,n.displayName,[],new E(c));return this.c.onExtensionActivationError(n.identifier,c,new R.$vG(o)),r}return this.k(a,n.displayName,i,null)}k(a,n,i,s){const o=new u(a.id,n,a.reason,i,s,this.c,this.g);return this.d.set(a.id,o),o}l(a){return N.$R$b.isHostExtension(a,this.a,this.b)}m(a){const n=this.b.getExtensionDescription(a);return n?!n.main&&!n.browser:!1}};e.$Xkc=v,e.$Xkc=v=Je([qe(3,M.$Wj)],v);let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,n,i,s,o,t,g){this.c=a,this.d=n,this.f=i,this.g=s,this.h=o,this.j=t,this.k=g,this.a=new b.$ph,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const n=this.g[a];if(n.value&&!n.value.activationFailed){this.g.splice(a,1),a--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const n=new Error;if(a&&a.name&&(n.name=a.name),a&&a.message?n.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(n.stack=a.stack),this.h=new E(n),this.b&&l.$4(a))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};u=Je([qe(6,M.$Wj)],u)}),define(ke[306],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[307],Ee([1,0,243,13,41,137,109,38,25,306,139,140]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=void 0;const m=b.$9n.as(M.$0n.JSONContribution);class E{constructor(o,t,g){this.a=o,this.b=t,this.c=g}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(L.default.Error,o)}warn(o){this.d(L.default.Warning,o)}info(o){this.d(L.default.Info,o)}}e.$mG=E;class v{static a(o){const t=new $.$Mm;for(let g=0,h=o.length;g<h;g++)t.add(o[g].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new v(t,[]);if(!t||!t.length)return new v([],o);const g=this.a(o),h=this.a(t),c=t.filter(w=>!g.has(w.description.identifier)),r=o.filter(w=>!h.has(w.description.identifier));return new v(c,r)}constructor(o,t){this.added=o,this.removed=t}}e.$nG=v;class u{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=v.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,N.$1)(o)}}}e.$oG=u;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$pG={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Km},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:l.localize(15,null),type:"string",enum:["none"],enumDescriptions:[l.localize(16,null)]},activationEvents:{description:l.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(32,null)},{label:"onUri",body:"onUri",description:l.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(37,null)},{label:"onRenderer",description:l.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:l.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:l.localize(42,null)},{label:"*",description:l.localize(43,null),body:"*"}]}},badges:{type:"array",description:l.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(45,null)},href:{type:"string",description:l.localize(46,null)},description:{type:"string",description:l.localize(47,null)}}}},markdown:{type:"string",description:l.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$No}},extensionPack:{description:l.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$No}},extensionKind:{description:l.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(53,null)},{body:["workspace"],description:l.localize(54,null)},{body:["ui","workspace"],description:l.localize(55,null)},{body:["workspace","ui"],description:l.localize(56,null)},{body:[],description:l.localize(57,null)}]},capabilities:{description:l.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(61,null),l.localize(62,null),l.localize(63,null)]},description:{type:"string",markdownDescription:l.localize(64,null)}}},untrustedWorkspaces:{description:l.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(67,null),l.localize(68,null),l.localize(69,null)]},restrictedConfigurations:{description:l.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(71,null)}}}}},sponsor:{description:l.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(74,null),type:"string"},"vscode:uninstall":{description:l.localize(75,null),type:"string"}}},icon:{type:"string",description:l.localize(76,null)},l10n:{type:"string",description:l.localize(77,null)},pricing:{type:"string",markdownDescription:l.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new u(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&C.$dG.register(o.extensionPoint,o.activationEventsGenerator),e.$pG.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,m.registerSchema(a,e.$pG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$qG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$9n.add(i.ExtensionsRegistry,new n),e.$rG=b.$9n.as(i.ExtensionsRegistry),m.registerSchema(a,e.$pG),m.registerSchema(A.$ek,{properties:{extensionEnabledApiProposals:{description:l.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(ke[308],Ee([1,0,239,18,24,307,37,4]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var S;(function(m){function E(v,u,f){if(!v)return;const a=N.$4f(v.type)?v.type:void 0;if(!a||a.length===0){f.error(l.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)N.$4f(i)&&n.push(i);return{extensionId:u.value,taskType:a,required:n,properties:v.properties?L.$Wn(v.properties):{},when:v.when?M.$oj.deserialize(v.when):void 0}}m.from=E})(S||(S={}));const A=R.$rG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,E)=>{for(const v of m)v.type&&E.push(`onTaskType:${v.type}`)},jsonSchema:{description:l.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,v)=>{A.setHandler((u,f)=>{this.c=void 0;try{for(const a of f.removed){const n=a.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const a of f.added){const n=a.value;for(const i of n){const s=S.from(i,a.description.identifier,a.collector);s&&(this.a[s.taskType]=s)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const v of this.all()){const u={type:"object",additionalProperties:!1};v.required.length>0&&(u.required=v.required.slice(0)),v.properties!==void 0?u.properties=L.$Wn(v.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[v.taskType]},E.push(u)}this.c={oneOf:E}}return this.c}}e.$UH=new C}),define(ke[309],Ee([1,0,240,18,23,24,37,308]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5H=e.JsonSchemaVersion=e.ExecutionEngine=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YH=e.ShellQuoting=e.$XH=e.$WH=e.$VH=void 0,e.$VH="settings",e.$WH=new M.$Hj("taskRunning",!1,l.localize(0,null)),e.$XH=l.localize2(2,"Tasks");var $;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$YH="$customized",function(O){function T(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=T}($||(e.ShellQuoting=$={}));var S;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var A;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(A||(e.RevealKind=A={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=T}(A||(e.RevealKind=A={}));var C;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=T}(C||(e.RevealProblemKind=C={}));var m;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(m||(e.PanelKind=m={})),function(O){function T(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=T}(m||(e.PanelKind=m={}));var E;(function(O){O.defaults={echo:!0,reveal:A.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var v;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(O){function T(W){switch(W.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=T;function B(W){switch(W){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(v||(e.RuntimeType=v={}));var u;(function(O){function T(B){return N.$4f(B)?B:B.value}O.value=T})(u||(e.CommandString=u={}));var f;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function T(W){return W===O.Clean._id||W===O.Build._id||W===O.Rebuild._id||W===O.Test._id}O.is=T;function B(W){if(W!==void 0)return N.$4f(W)?T(W)?{_id:W,isDefault:!1}:void 0:W}O.from=B})(f||(e.TaskGroup=f={}));var a;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var n;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function T(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var i;(function(O){O.parallel="parallel",O.sequence="sequence"})(i||(e.DependsOrder=i={}));var s;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(s||(e.RunOnOptions=s={}));var o;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:s.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(T,B,W,X,x,Z){this._label="",this._id=T,B&&(this._label=B),W&&(this.type=W),this.runOptions=X,this.configurationProperties=x,this._source=Z}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,B=!1){if(T===void 0)return!1;if(N.$4f(T))return T===this._label||T===this.configurationProperties.identifier||B&&T===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$ZH=t;class g extends t{constructor(T,B,W,X,x,Z,Y,ue){super(T,W,void 0,Y,ue,B),this.command={},this._source=B,this.hasDefinedMatchers=Z,x&&(this.command=x)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(T){return T instanceof g}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$YH,folder:T,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$1g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new g(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$1H=g;class h extends t{constructor(T,B,W,X,x,Z,Y){super(T,W,X,Z,Y,B),this._source=B,this.configures=x}static is(T){return T instanceof h}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$1g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$YH,folder:T,id:B};return JSON.stringify(W)}}e.$2H=h;class c extends t{constructor(T,B,W,X,x,Z,Y,ue,te){super(T,W,X,ue,te,B),this.defines=x,this.hasDefinedMatchers=Y,this.command=Z,this.icon=te.icon,this.hide=te.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof c}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new c(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$3H=c;class r extends t{constructor(T,B,W,X,x,Z){super(T,W,X,x,Z,B),this._source=B}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new r(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$4H=r;var w;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(w||(e.ExecutionEngine=w={})),function(O){O._default=O.Terminal}(w||(e.ExecutionEngine=w={}));var d;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(d||(e.JsonSchemaVersion=d={}));class D{constructor(T){this.c=new Map;for(let B=0;B<T.length;B++)this.c.set(T[B].uri.toString(),B)}compare(T,B){const W=T.getWorkspaceFolder(),X=B.getWorkspaceFolder();if(W&&X){let x=this.c.get(W.uri.toString());x=x===void 0?0:x+1;let Z=this.c.get(X.uri.toString());return Z=Z===void 0?0:Z+1,x===Z?T._label.localeCompare(B._label):x-Z}else return!W&&X?-1:W&&!X?1:0}}e.$5H=D;var p;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(p||(e.TaskEventKind=p={}));var k;(function(O){O.SingleRun="singleRun",O.Background="background"})(k||(e.TaskRunType=k={}));var y;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var P;(function(O){function T(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function B(ue,te,we){return{...T(ue),kind:"start",terminalId:te,resolvedVariables:we}}O.start=B;function W(ue,te,we){return{...T(ue),kind:"processStarted",terminalId:te,processId:we}}O.processStarted=W;function X(ue,te,we){return{...T(ue),kind:"processEnded",terminalId:te,exitCode:we}}O.processEnded=X;function x(ue,te,we){return{...T(ue),kind:"terminated",exitReason:we,terminalId:te}}O.terminated=x;function Z(ue,te,we){return{...T(te),kind:ue,terminalId:we}}O.general=Z;function Y(){return{kind:"changed"}}O.changed=Y})(P||(e.TaskEvent=P={}));var I;(function(O){function T(W){const X=Object.keys(W).sort();let x="";for(const Z of X){let Y=W[Z];Y instanceof Object?Y=T(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),x+=Z+","+Y+","}return x}function B(W){const x={_key:T(W),type:W.taskType};return Object.assign(x,W),x}O.create=B})(I||(e.KeyedTaskIdentifier=I={}));var F;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var j;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(O){function T(B,W){const X=b.$UH.get(B.type);if(X===void 0){const ue=R.$Wn(B);return delete ue._key,I.create(ue)}const x=Object.create(null);x.type=X.taskType;const Z=new Set;X.required.forEach(ue=>Z.add(ue));const Y=X.properties;for(const ue of Object.keys(Y)){const te=B[ue];if(te!=null)x[ue]=te;else if(Z.has(ue)){const we=Y[ue];if(we.default!==void 0)x[ue]=R.$Wn(we.default);else switch(we.type){case"boolean":x[ue]=!1;break;case"number":case"integer":x[ue]=0;break;case"string":x[ue]="";break;default:W.error(l.localize(1,null,JSON.stringify(B,void 0,0),ue));return}}}return I.create(x)}O.createTaskIdentifier=T})(z||(e.TaskDefinition=z={}))}),define(ke[310],Ee([1,0,13]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=e.$V$b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,l.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$V$b=N;class L extends N{constructor(){super(),this.h=!0,this.i=new l.$5}}e.$W$b=L}),define(ke[48],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$jw=void 0,e.$kw=L,e.$lw=R;class l{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++l.count}}e.$jw=l;const N=[];function L(b){const $=new l(b);return N[$.nid]=$,$}function R(b){return N[b].sid}class M{constructor($){this.value=$}}e.$mw=M}),define(ke[6],Ee([1,0,48]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$OM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var L;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput",u[u.ChatEditorInput=10]="ChatEditorInput",u[u.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var R;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var M;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var S;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var A;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$OM=C;var m;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var E;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var v;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$PM={MainThreadAuthentication:(0,l.$kw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.$kw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,l.$kw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,l.$kw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,l.$kw)("MainThreadChatVariables"),MainThreadClipboard:(0,l.$kw)("MainThreadClipboard"),MainThreadCommands:(0,l.$kw)("MainThreadCommands"),MainThreadComments:(0,l.$kw)("MainThreadComments"),MainThreadConfiguration:(0,l.$kw)("MainThreadConfiguration"),MainThreadConsole:(0,l.$kw)("MainThreadConsole"),MainThreadDebugService:(0,l.$kw)("MainThreadDebugService"),MainThreadDecorations:(0,l.$kw)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.$kw)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.$kw)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.$kw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.$kw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.$kw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.$kw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.$kw)("MainThreadEditorTabs"),MainThreadErrors:(0,l.$kw)("MainThreadErrors"),MainThreadTreeViews:(0,l.$kw)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.$kw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,l.$kw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.$kw)("MainThreadLanguages"),MainThreadLogger:(0,l.$kw)("MainThreadLogger"),MainThreadMessageService:(0,l.$kw)("MainThreadMessageService"),MainThreadOutputService:(0,l.$kw)("MainThreadOutputService"),MainThreadProgress:(0,l.$kw)("MainThreadProgress"),MainThreadQuickDiff:(0,l.$kw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,l.$kw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.$kw)("MainThreadStatusBar"),MainThreadSecretState:(0,l.$kw)("MainThreadSecretState"),MainThreadStorage:(0,l.$kw)("MainThreadStorage"),MainThreadSpeech:(0,l.$kw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,l.$kw)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.$kw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,l.$kw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,l.$kw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.$kw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.$kw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.$kw)("MainThreadCustomEditors"),MainThreadUrls:(0,l.$kw)("MainThreadUrls"),MainThreadUriOpeners:(0,l.$kw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,l.$kw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,l.$kw)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.$kw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,l.$kw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,l.$kw)("MainThreadExtensionService"),MainThreadSCM:(0,l.$kw)("MainThreadSCM"),MainThreadSearch:(0,l.$kw)("MainThreadSearch"),MainThreadShare:(0,l.$kw)("MainThreadShare"),MainThreadTask:(0,l.$kw)("MainThreadTask"),MainThreadWindow:(0,l.$kw)("MainThreadWindow"),MainThreadLabelService:(0,l.$kw)("MainThreadLabelService"),MainThreadNotebook:(0,l.$kw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.$kw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.$kw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.$kw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.$kw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.$kw)("MainThreadInteractive"),MainThreadInlineChat:(0,l.$kw)("MainThreadInlineChatShape"),MainThreadTheming:(0,l.$kw)("MainThreadTheming"),MainThreadTunnelService:(0,l.$kw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,l.$kw)("MainThreadManagedSockets"),MainThreadTimeline:(0,l.$kw)("MainThreadTimeline"),MainThreadTesting:(0,l.$kw)("MainThreadTesting"),MainThreadLocalization:(0,l.$kw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,l.$kw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,l.$kw)("MainThreadAiEmbeddingVector")},e.$QM={ExtHostCommands:(0,l.$kw)("ExtHostCommands"),ExtHostConfiguration:(0,l.$kw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.$kw)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.$kw)("ExtHostDebugService"),ExtHostDecorations:(0,l.$kw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.$kw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.$kw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.$kw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.$kw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.$kw)("ExtHostEditors"),ExtHostTreeViews:(0,l.$kw)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.$kw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.$kw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.$kw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.$kw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.$kw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.$kw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,l.$kw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,l.$kw)("ExtHostStatusBar"),ExtHostShare:(0,l.$kw)("ExtHostShare"),ExtHostExtensionService:(0,l.$kw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.$kw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.$kw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,l.$kw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,l.$kw)("ExtHostSCM"),ExtHostSearch:(0,l.$kw)("ExtHostSearch"),ExtHostTask:(0,l.$kw)("ExtHostTask"),ExtHostWorkspace:(0,l.$kw)("ExtHostWorkspace"),ExtHostWindow:(0,l.$kw)("ExtHostWindow"),ExtHostWebviews:(0,l.$kw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.$kw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.$kw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.$kw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.$kw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.$kw)("ExtHostEditorTabs"),ExtHostProgress:(0,l.$kw)("ExtHostProgress"),ExtHostComments:(0,l.$kw)("ExtHostComments"),ExtHostSecretState:(0,l.$kw)("ExtHostSecretState"),ExtHostStorage:(0,l.$kw)("ExtHostStorage"),ExtHostUrls:(0,l.$kw)("ExtHostUrls"),ExtHostUriOpeners:(0,l.$kw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,l.$kw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,l.$kw)("ExtHostOutputService"),ExtHostLabelService:(0,l.$kw)("ExtHostLabelService"),ExtHostNotebook:(0,l.$kw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.$kw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.$kw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.$kw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.$kw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,l.$kw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,l.$kw)("ExtHostInteractive"),ExtHostInlineChat:(0,l.$kw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,l.$kw)("ExtHostChatAgents"),ExtHostChatVariables:(0,l.$kw)("ExtHostChatVariables"),ExtHostChatProvider:(0,l.$kw)("ExtHostChatProvider"),ExtHostSpeech:(0,l.$kw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,l.$kw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,l.$kw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,l.$kw)("ExtHostTheming"),ExtHostTunnelService:(0,l.$kw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,l.$kw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,l.$kw)("ExtHostAuthentication"),ExtHostTimeline:(0,l.$kw)("ExtHostTimeline"),ExtHostTesting:(0,l.$kw)("ExtHostTesting"),ExtHostTelemetry:(0,l.$kw)("ExtHostTelemetry"),ExtHostLocalization:(0,l.$kw)("ExtHostLocalization")}}),define(ke[91],Ee([1,0,5,12,6,20]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=e.$gkc=e.$fkc=void 0,e.$fkc=(0,l.$qi)("IExtHostApiDeprecationService");let M=class{constructor($,S){this.c=S,this.a=new Set,this.b=$.getProxy(L.$PM.MainThreadTelemetry)}report($,S,A){const C=this.d($,S);this.a.has(C)||(this.a.add(C),S.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:$}))}d($,S){return`${$}-${S.identifier.value}`}};e.$gkc=M,e.$gkc=M=Je([qe(0,R.$cP),qe(1,N.$Wj)],M),e.$hkc=Object.freeze(new class{report(b,$,S){}})}),define(ke[311],Ee([1,0,6]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class N{constructor(R){const M=R.getProxy(l.$PM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$ukc=N}),define(ke[312],Ee([1,0,24,6,28,20]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0;let M=class{constructor(A,C){this.a=A.getProxy(N.$PM.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,C){const m=this,E=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){m.e(A,C,E,arguments)}})}e(A,C,m,E){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(E,this.b)}),this.c&&this.f(A,m,E)}};e.$omc=M,e.$omc=M=Je([qe(0,R.$cP),qe(1,L.$sP)],M);const b=1e5;function $(S,A){const C=[];if(S.length)for(let m=0;m<S.length;m++){let E=S[m];if(typeof E>"u")E="undefined";else if(E instanceof Error){const v=E;v.stack?E=v.stack:E=v.toString()}C.push(E)}if(A){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,l.$2n)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[313],Ee([1,0,2,6,26]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class R{constructor(b){this.a=b.getProxy(N.$PM.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,L.$yG)(b,"showLocal"),this.a.$showOpenDialog($).then(S=>S?S.map(A=>l.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?l.URI.revive($):void 0)}}e.$rlc=R}),define(ke[314],Ee([1,0,3,6]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;class L{constructor(M){this.b=0,this.a=M.getProxy(N.$PM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,l.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Llc=L}),define(ke[115],Ee([1,0,11,14,2,5,12,6,28,20]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=e.$_kc=void 0;let A=class{constructor(m,E,v){this.f=v,this.d=new Map,this.a=E.getProxy(b.$PM.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===l.$g}getMessage(m,E){const{message:v,args:u,comment:f}=E;if(this.c)return(0,N.$5e)(v,u??{});let a=v;f&&f.length>0&&(a+=`/${Array.isArray(f)?f.join(""):f}`);const n=this.d.get(m)?.contents[a];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,N.$5e)(n??v,u??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let E;const v=await this.g(m);if(!v){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents(v),f=JSON.parse(u);E=m.isBuiltin?f.contents?.bundle:f}catch(u){this.f.error(`Failed to load translations for ${m.identifier.value} from ${v}: ${u.message}`);return}E&&this.d.set(m.identifier.value,{contents:E,uri:v})}async g(m){if(m.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return L.URI.revive(E)}return m.l10n?L.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$_kc=A,e.$_kc=A=Je([qe(0,$.$sP),qe(1,S.$cP),qe(2,M.$Wj)],A),e.$alc=(0,R.$qi)("IExtHostLocalizationService")}),define(ke[149],Ee([1,0,12,6,28,20,2,58]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;let $=class extends l.$8j{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(E=>(0,b.$Zh)(E))),this.r=C.getProxy(N.$PM.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(M.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,E){return new S(this.r,C,m,E)}};e.$nmc=$,e.$nmc=$=Je([qe(0,R.$cP),qe(1,L.$sP)],$);class S extends l.$3j{constructor(C,m,E,v){super(v?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(m,v).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const E=[[C,m]];this.m?this.u(E):this.n.push(...E)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Ee([1,0,6,5,3,20,21]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=e.$blc=void 0,e.$blc=(0,N.$qi)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(l.$PM.MainThreadManagedSockets)}setFactory(C,m){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,E=await this.c.makeConnection(),v=new L.$Tc;return this.d.set(m,new S(m,E,v)),v.add((0,L.$Sc)(()=>this.d.delete(m))),v.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),v.dispose()})),v.add(E.onDidClose(u=>{this.a.$onDidManagedSocketClose(m,u?.stack??u?.message),v.dispose()})),v.add(E.onDidReceiveMessage(u=>this.a.$onDidManagedSocketHaveData(m,M.$Ce.wrap(u)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$clc=b,e.$clc=b=Je([qe(0,R.$cP)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class S extends L.$Uc{constructor(C,m,E){super(),this.socketId=C,this.actual=m,this.B(E)}}}),define(ke[315],Ee([1,0,6,12,26]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;function R(b){return b&&b.title}let M=class{constructor($,S){this.b=S,this.a=$.getProxy(l.$PM.MainThreadMessageService)}showMessage($,S,A,C,m){const E={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof C=="string"||R(C)?v=[C,...m]:(E.modal=C?.modal,E.useCustom=C?.useCustom,E.detail=C?.detail,v=m),E.useCustom&&(0,L.$yG)($,"resolvers");const u=[];let f=!1;for(let a=0;a<v.length;a++){const n=v[a];if(typeof n=="string")u.push({title:n,handle:a,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:s}=n;u.push({title:i,isCloseAffordance:!!s,handle:a}),s&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(S,A,E,u).then(a=>{if(typeof a=="number")return v[a]})}};e.$Nlc=M,e.$Nlc=M=Je([qe(1,N.$Wj)],M)}),define(ke[316],Ee([1,0,3,18,2,26,6]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class b{constructor(S){this.b=new Map,this.a=S.getProxy(M.$PM.MainThreadProfileContentHandlers)}registerProfileContentHandler(S,A,C){if((0,R.$yG)(S,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,C),this.a.$registerProfileContentHandler(A,C.name,C.description,S.identifier.value),(0,l.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(S,A,C,m){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(A,C,m)}async $readProfile(S,A,C){const m=this.b.get(S);if(!m)throw new Error(`Unknown handler with id: ${S}`);return m.readProfile((0,N.$4f)(A)?A:L.URI.revive(A),C)}}e.$Wlc=b}),define(ke[117],Ee([1,0,6,4,5]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=e.$9kc=void 0;class R{constructor(b){this.b=new N.$be,this.onDidChangePassword=this.b.event,this.a=b.getProxy(l.$PM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,S){return this.a.$setPassword(b,$,S)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$9kc=R,e.$0kc=(0,L.$qi)("IExtHostSecretState")}),define(ke[317],Ee([1,0,22,3,6]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(L.$PM.MainThreadSpeech)}async $createSpeechToTextSession(b,$,S){const A=this.c.get(b);if(!A)return;const C=new N.$Tc,m=new l.$me;this.d.set($,m);const E=C.add(A.provideSpeechToTextSession(m.token,S?{language:S}:void 0));C.add(E.onDidChange(v=>{m.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),C.add(m.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,$){const S=this.c.get(b);if(!S)return;const A=new N.$Tc,C=new l.$me;this.d.set($,C);const m=A.add(S.provideKeywordRecognitionSession(C.token));A.add(m.onDidChange(E=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,E)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,S){const A=R.a++;return this.c.set(A,S),this.b.$registerProvider(A,$,{extension:b,displayName:b.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$4lc=R}),define(ke[118],Ee([1,0,6,4,5]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=e.$Ykc=void 0;class R{constructor(b,$){this.c=$,this.b=new N.$be,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(l.$PM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,S){const A=await this.a.$initializeExtensionStorage(b,$);let C;return A&&(C=this.d(b,$,A)),C||S}setValue(b,$,S){return this.a.$setValue(b,$,S)}$acceptValue(b,$,S){const A=this.d(b,$,S);A&&this.b.fire({shared:b,key:$,value:A})}d(b,$,S){try{return JSON.parse(S)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${A}`)}}}e.$Ykc=R,e.$Zkc=(0,L.$qi)("IExtHostStorage")}),define(ke[318],Ee([1,0,3,15,2,6]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(R.$PM.MainThreadUriOpeners)}registerExternalUriOpener($,S,A,C){if(this.c.has(S))throw new Error(`Opener with id '${S}' already registered`);const m=C.schemes.find(E=>!M.a.has(E));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(S,A),this.b.$registerUriOpener(S,C.schemes,$,C.label),(0,l.$Sc)(()=>{this.c.delete(S),this.b.$unregisterUriOpener(S)})}async $canOpenUri($,S,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=L.URI.revive(S);return C.canOpenExternalUri(m,A)}async $openUri($,S,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(L.URI.revive(S.resolvedUri),{sourceUri:L.URI.revive(S.sourceUri)},A)}}e.$hmc=M}),define(ke[319],Ee([1,0,6,2,3,13,25]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;class b{static{this.a=0}constructor(S){this.c=new M.$Mm,this.d=new Map,this.b=S.getProxy(l.$PM.MainThreadUrls)}registerUriHandler(S,A){const C=S.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,A),this.b.$registerUriHandler(m,C,S.displayName||S.name),(0,L.$Sc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(S,A){const C=this.d.get(S);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(A))}catch(m){(0,R.$1)(m)}return Promise.resolve(void 0)}async createAppUri(S){return N.URI.revive(await this.b.$createAppUri(S))}}e.$imc=b}),define(ke[92],Ee([1,0,4,3,15,24,2,247,285,113,6]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Jkc=void 0,e.$Kkc=m,e.$Mkc=u,e.$Nkc=f;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(s,o,t,g,h,c,r){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new l.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new l.$be,this._onDidDispose=this.#h.event,this.#e=s,this.#t=o,this.#o=t,this.#n=g,this.#s=h,this.#r=c,this.#l=m(c),this.#d=E(c),this.#i=r}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#u=!0,(0,S.$Rxb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===L.Schemas.https||s.scheme===L.Schemas.http){let o=s.toString();return o.endsWith("/")||(o+="/"),o+" "+S.$Qxb}return S.$Qxb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),R.$1n(this.#o,s)||this.#t.$setOptions(this.#e,f(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const o=(0,$.$0nb)(s,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const o=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,h,c,r,w,d)=>{const D=M.URI.from({scheme:r||"file",path:decodeURIComponent(w)}),p=(0,S.$Rxb)(D,{isRemote:o,authority:t}).toString();return`${h}${p}${d}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,h,c,r,w,d)=>{const D=M.URI.from({scheme:r||"file",path:decodeURIComponent(w)}),p=(0,S.$Rxb)(D,{isRemote:o,authority:t}).toString();return`${h}${p}${d}`})}}e.$Jkc=C;function m(i){try{const s=(0,b.$Cp)((0,b.$Bp)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function E(i){try{const s=(0,b.$Cp)((0,b.$Bp)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class v extends N.$Uc{constructor(s,o,t,g,h){super(),this.c=o,this.f=t,this.g=g,this.h=h,this.b=new Map,this.a=s.getProxy(A.$PM.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,o,t){const g=this.j(s);if(g){const{message:h}=(0,$.$$nb)(o,t.value);g._onMessageEmitter.fire(h)}}$onMissingCsp(s,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,o,t){const g=new C(s,this.a,a(o),this.c,this.f,t,this.h);this.b.set(s,g);const h=g._onDidDispose(()=>{h.dispose(),this.deleteWebview(s)});return g}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$Lkc=v;function u(i){return{id:i.identifier,location:i.extensionLocation}}function f(i,s,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||n(i,s)}}function a(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>M.URI.from(s))}}function n(i,s){return[...(s?.getWorkspaceFolders()||[]).map(o=>o.uri),i.extensionLocation]}}),define(ke[150],Ee([1,0,4,6,2,15,14,5,20,26]),function(le,e,l,N,L,R,M,b,$,S){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0;let C=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(E){const v=this.d;return{get focused(){return v.focused},get active(){return(0,S.$yG)(E,"windowActivity"),v.active}}}constructor(E){this.c=new l.$be,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=E.getProxy(N.$PM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:u})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",u)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,v){v!==this.d[E]&&(this.d={...this.d,[E]:v},this.c.fire(this.d))}openUri(E,v){let u;if(typeof E=="string"){u=E;try{E=L.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,M.$3e)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,u,v)}async asExternalUri(E,v){if((0,M.$3e)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this.b.$asExternalUri(E,v);return L.URI.from(u)}};e.$kmc=C,e.$kmc=C=A=Je([qe(0,$.$cP)],C),e.$lmc=(0,b.$qi)("IExtHostWindow")}),define(ke[320],Ee([1,0,312,28,20]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;const R=1024*1024;let M=class extends l.$omc{constructor($,S){super($,S),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,S,A){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),S.apply(console,A),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,S){const A=process[$],C=A.write;let m="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(E,v,u)=>{if(!this.g){m+=E.toString(v);const f=m.length>R?m.length:m.lastIndexOf(`
`);f!==-1&&(console[S](m.slice(0,f)),m=m.slice(f+1))}C.call(A,E,v,u)}})}};e.$Zmc=M,e.$Zmc=M=Je([qe(0,L.$cP),qe(1,N.$sP)],M)}),define(ke[321],Ee([1,0,149,15,262,30]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;class M extends l.$nmc{s($,S,A){return $.scheme===N.Schemas.file?new L.$pQ(A?.name||(0,R.$Mg)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,S):super.s($,S,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$_mc=M}),define(ke[322],Ee([1,0,8,21,22,13,4,3,133,310,48]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$X$b=f,e.$Y$b=a;function m(y,P){try{return JSON.stringify(y,P)}catch{return"null"}}const E="$$ref$$",v={[E]:-1};class u{constructor(P,I){this.jsonString=P,this.referencedBuffers=I}}function f(y,P=null,I=!1){const F=[];return{jsonString:(I?m:JSON.stringify)(y,(z,O)=>{if(typeof O>"u")return v;if(typeof O=="object"){if(O instanceof N.$Ce){const T=F.push(O)-1;return{[E]:T}}if(P)return P(z,O)}return O}),referencedBuffers:F}}function a(y,P,I){return JSON.parse(y,(F,j)=>{if(j){const z=j[E];if(typeof z=="number")return P[z];if(I&&j.$mid===1)return I.transformIncoming(j)}return j})}function n(y,P){return JSON.stringify(y,P)}function i(y){return y?(P,I)=>I&&I.$mid===1?y.transformOutgoing(I):I:null}var s;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(s||(e.RequestInitiator=s={}));var o;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},g=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class c extends b.$Uc{static{C=g}static{this.a=3*1e3}constructor(P,I=null,F=null){super(),this[C]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=I,this.g=F,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,z=A.$jw.count;j<z;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new l.$Ch(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const I=this.w[P];delete this.w[P],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$vn)(P,this.g):P}getProxy(P){const{nid:I,sid:F}=P;return this.s[I]||(this.s[I]=this.J(I,F)),this.s[I]}J(P,I){const F={get:(j,z)=>(typeof z=="string"&&!j[z]&&z.charCodeAt(0)===36&&(j[z]=(...O)=>this.U(P,z,O)),z===h?I:j[z])};return new Proxy(Object.create(null),F)}set(P,I){return this.m[P.nid]=I,I}assertRegistered(P){for(let I=0,F=P.length;I<F;I++){const j=P[I];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(P){if(this.j)return;const I=P.byteLength,F=w.read(P,0),j=F.readUInt8(),z=F.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:T,args:B}=D.deserializeRequestJSONArgs(F);this.g&&(B=(0,$.$vn)(B,this.g)),this.M(I,z,O,T,B,j===2);break}case 3:case 4:{let{rpcId:O,method:T,args:B}=D.deserializeRequestMixedArgs(F);this.g&&(B=(0,$.$vn)(B,this.g)),this.M(I,z,O,T,B,j===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let O=D.deserializeReplyOKJSON(F);this.g&&(O=(0,$.$vn)(O,this.g)),this.O(I,z,O);break}case 10:{const O=D.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(I,z,O);break}case 8:{const O=D.deserializeReplyOKVSBuffer(F);this.O(I,z,O);break}case 11:{let O=D.deserializeReplyErrError(F);this.g&&(O=(0,$.$vn)(O,this.g)),this.P(I,z,O);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,I,F,j,z,O){this.f?.logIncoming(P,I,1,`receiveRequest ${(0,A.$lw)(F)}.${j}(`,z);const T=String(I);let B,W;if(O){const x=new L.$me;z.push(x.token),B=this.Q(F,j,z),W=()=>x.cancel()}else B=this.Q(F,j,z),W=t;this.u[T]=W;const X=D.serializeAcknowledged(I);this.f?.logOutgoing(X.byteLength,I,1,"ack"),this.c.send(X),B.then(x=>{delete this.u[T];const Z=D.serializeReplyOK(I,x,this.h);this.f?.logOutgoing(Z.byteLength,I,1,"reply:",x),this.c.send(Z)},x=>{delete this.u[T];const Z=D.serializeReplyErr(I,x);this.f?.logOutgoing(Z.byteLength,I,1,"replyErr:",x),this.c.send(Z)})}N(P,I){this.f?.logIncoming(P,I,1,"receiveCancel");const F=String(I);this.u[F]?.()}O(P,I,F){this.f?.logIncoming(P,I,0,"receiveReply:",F);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j],z.resolveOk(F)}P(P,I,F){this.f?.logIncoming(P,I,0,"receiveReplyErr:",F);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j];let O;F&&(F.$isError?(O=new Error,O.name=F.name,O.message=F.message,O.stack=F.stack):O=F),z.resolveErr(O)}Q(P,I,F){try{return Promise.resolve(this.S(P,I,F))}catch(j){return Promise.reject(j)}}S(P,I,F){const j=this.m[P];if(!j)throw new Error("Unknown actor "+(0,A.$lw)(P));const z=j[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$lw)(P));return z.apply(j,F)}U(P,I,F){if(this.j)return new S.$W$b;let j=null;if(F.length>0&&L.CancellationToken.isCancellationToken(F[F.length-1])&&(j=F.pop()),j&&j.isCancellationRequested)return Promise.reject(R.$6());const z=D.serializeRequestArguments(F,this.h),O=++this.t,T=String(O),B=new S.$V$b,W=new b.$Tc;j&&W.add(j.onCancellationRequested(()=>{const x=D.serializeCancel(O);this.f?.logOutgoing(x.byteLength,O,0,"cancel"),this.c.send(D.serializeCancel(O))})),this.w[T]=new r(B,W),this.F(O);const X=D.serializeRequest(O,P,I,z,!!j);return this.f?.logOutgoing(X.byteLength,O,0,`request: ${(0,A.$lw)(P)}.${I}(`,F),this.c.send(X),B}}e.$Z$b=c;class r{constructor(P,I){this.a=P,this.b=I}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class w{static alloc(P,I,F){const j=new w(N.$Ce.alloc(F+1+4),0);return j.writeUInt8(P),j.writeUInt32(I),j}static read(P,I){return new w(P,I)}get buffer(){return this.a}constructor(P,I){this.a=P,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+P);return this.b+=P,I}static sizeMixedArray(P){let I=0;I+=1;for(let F=0,j=P.length;F<j;F++){const z=P[F];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let O=0;O<z.buffers.length;++O)I+=this.sizeVSBuffer(z.buffers[O]);break;case 4:break}}return I}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let I=0,F=P.length;I<F;I++){const j=P[I];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let z=0;z<j.buffers.length;++z)this.writeBuffer(j.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const I=new Array(P);for(let F=0;F<P;F++)switch(this.readUInt8()){case 1:I[F]=this.readLongString();break;case 2:I[F]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),O=this.readLongString(),T=[];for(let B=0;B<z;++B)T.push(this.readVSBuffer());I[F]=new A.$mw(a(O,T,null));break}case 4:I[F]=void 0;break}return I}}var d;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(d||(d={}));class D{static a(P){for(let I=0,F=P.length;I<F;I++)if(P[I]instanceof N.$Ce||P[I]instanceof A.$mw||typeof P[I]>"u")return!0;return!1}static serializeRequestArguments(P,I){if(this.a(P)){const F=[];for(let j=0,z=P.length;j<z;j++){const O=P[j];if(O instanceof N.$Ce)F[j]={type:2,value:O};else if(typeof O>"u")F[j]={type:4};else if(O instanceof A.$mw){const{jsonString:T,referencedBuffers:B}=f(O.value,I);F[j]={type:3,value:N.$Ce.fromString(T),buffers:B}}else F[j]={type:1,value:N.$Ce.fromString(n(O,I))}}return{type:1,args:F}}return{type:0,args:n(P,I)}}static serializeRequest(P,I,F,j,z){switch(j.type){case 0:return this.b(P,I,F,j.args,z);case 1:return this.c(P,I,F,j.args,z)}}static b(P,I,F,j,z){const O=N.$Ce.fromString(F),T=N.$Ce.fromString(j);let B=0;B+=w.sizeUInt8(),B+=w.sizeShortString(O),B+=w.sizeLongString(T);const W=w.alloc(z?2:1,P,B);return W.writeUInt8(I),W.writeShortString(O),W.writeLongString(T),W.buffer}static deserializeRequestJSONArgs(P){const I=P.readUInt8(),F=P.readShortString(),j=P.readLongString();return{rpcId:I,method:F,args:JSON.parse(j)}}static c(P,I,F,j,z){const O=N.$Ce.fromString(F);let T=0;T+=w.sizeUInt8(),T+=w.sizeShortString(O),T+=w.sizeMixedArray(j);const B=w.alloc(z?4:3,P,T);return B.writeUInt8(I),B.writeShortString(O),B.writeMixedArray(j),B.buffer}static deserializeRequestMixedArgs(P){const I=P.readUInt8(),F=P.readShortString(),j=P.readMixedArray(),z=new Array(j.length);for(let O=0,T=j.length;O<T;O++){const B=j[O];typeof B=="string"?z[O]=JSON.parse(B):z[O]=B}return{rpcId:I,method:F,args:z}}static serializeAcknowledged(P){return w.alloc(5,P,0).buffer}static serializeCancel(P){return w.alloc(6,P,0).buffer}static serializeReplyOK(P,I,F){if(typeof I>"u")return this.d(P);if(I instanceof N.$Ce)return this.e(P,I);if(I instanceof A.$mw){const{jsonString:j,referencedBuffers:z}=f(I.value,F,!0);return this.g(P,j,z)}else return this.f(P,m(I,F))}static d(P){return w.alloc(7,P,0).buffer}static e(P,I){let F=0;F+=w.sizeVSBuffer(I);const j=w.alloc(8,P,F);return j.writeVSBuffer(I),j.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,I){const F=N.$Ce.fromString(I);let j=0;j+=w.sizeLongString(F);const z=w.alloc(9,P,j);return z.writeLongString(F),z.buffer}static g(P,I,F){const j=N.$Ce.fromString(I);let z=0;z+=w.sizeUInt32,z+=w.sizeLongString(j);for(const T of F)z+=w.sizeVSBuffer(T);const O=w.alloc(10,P,z);O.writeUInt32(F.length),O.writeLongString(j);for(const T of F)O.writeBuffer(T);return O.buffer}static deserializeReplyOKJSON(P){const I=P.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(P,I){const F=P.readUInt32(),j=P.readLongString(),z=[];for(let O=0;O<F;++O)z.push(P.readVSBuffer());return new A.$mw(a(j,z,I))}static serializeReplyErr(P,I){const F=I?m(R.$3(I),null):void 0;if(typeof F!="string")return this.h(P);const j=N.$Ce.fromString(F);let z=0;z+=w.sizeLongString(j);const O=w.alloc(11,P,z);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(P){const I=P.readLongString();return JSON.parse(I)}static h(P){return w.alloc(12,P,0).buffer}}var p;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var k;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(k||(k={}))}),define(ke[323],Ee([1,0,21,27,15,84,5]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$rK=void 0,e.$sK=A,e.$tK=C,e.$rK=(0,M.$qi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),S=7;function A(E){if(E.scheme!==L.Schemas.vscodeNotebookCell)return;const v=E.fragment.indexOf("s");if(v<0)return;const u=parseInt(E.fragment.substring(0,v).replace($,""),S),f=(0,l.$Ve)(E.fragment.substring(v+1)).toString();if(!isNaN(u))return{handle:u,notebook:E.with({scheme:f,fragment:null})}}function C(E,v){const u=v.toString(S),a=`${u.length<b.length?b[u.length-1]:"z"}${u}s${(0,l.$We)(l.$Ce.fromString(E.scheme),!0,!0)}`;return E.with({scheme:L.Schemas.vscodeNotebookCell,fragment:a})}class m{constructor(){this.a=new N.$Bc}getNotebook(v){if(v.scheme===L.Schemas.vscodeNotebookCell){const u=A(v);if(u){const f=this.a.get(u.notebook);if(f)return f}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$uK=m,(0,R.$os)(e.$rK,m,1)}),define(ke[119],Ee([1,0,21,35,39,101,15,17,11,37,323]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=e.CellStatusbarAlignment=e.$KK=e.NotebookEditorPriority=e.$HK=e.$GK=e.$EK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DK=e.$CK=e.$BK=e.$AK=e.CellKind=e.$zK=e.$yK=e.$xK=void 0,e.$FK=g,e.$IK=c,e.$JK=r,e.$MK=D,e.$NK=k,e.$xK="workbench.editor.notebook",e.$yK="workbench.editor.notebookTextDiffEditor",e.$zK="workbench.editor.interactive";var C;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(C||(e.CellKind=C={})),e.$AK=["application/json","application/javascript","text/html","image/svg+xml",R.$Hs.latex,R.$Hs.markdown,"image/png","image/jpeg",R.$Hs.text],e.$BK=[R.$Hs.latex,R.$Hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Hs.text],e.$CK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DK="_notAvailable";var m;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(m||(e.NotebookRunState=m={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var u;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(u||(e.NotebookRendererMatch=u={}));var f;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var a;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(B){B.scheme=M.Schemas.vscodeNotebookCell;function W(te,we){return(0,A.$tK)(te,we)}B.generate=W;function X(te){return(0,A.$sK)(te)}B.parse=X;function x(te,we){return te.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${we??""},${te.scheme!==M.Schemas.file?te.scheme:""}`})}B.generateCellOutputUri=x;function Z(te){if(te.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const we=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!we)return;const Se=we[1]&&we[1]!==""?we[1]:void 0,_=we[2];return{outputId:Se,notebook:te.with({scheme:_||M.Schemas.file,fragment:null})}}B.parseCellOutputUri=Z;function Y(te,we,Se){return B.generate(te,we).with({scheme:Se})}B.generateCellPropertyUri=Y;function ue(te,we){if(te.scheme===we)return B.parse(te.with({scheme:B.scheme}))}B.parseCellPropertyUri=ue})(s||(e.CellUri=s={}));const o=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(W=[],X=e.$AK){this.e=X,this.d=[...new Set(W)].map(x=>({pattern:x,matches:N.$kk(o(x))}))}sort(W){const X=new Map(L.Iterable.map(W,Z=>[Z,o(Z)]));let x=[];for(const{matches:Z}of this.d)for(const[Y,ue]of X)if(Z(ue)){x.push(Y),X.delete(Y);break}return X.size&&(x=x.concat([...X.keys()].sort((Z,Y)=>this.e.indexOf(Z)-this.e.indexOf(Y)))),x}prioritize(W,X){const x=this.f(W);if(x===-1){this.d.unshift({pattern:W,matches:N.$kk(o(W))});return}const Z=new Set(X.map(ue=>this.f(ue,x)));Z.delete(-1);const Y=Array.from(Z).sort();this.d.splice(x+1,0,...Y.map(ue=>this.d[ue]));for(let ue=Y.length-1;ue>=0;ue--)this.d.splice(Y[ue],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,X=this.d.length){const x=o(W);for(let Z=0;Z<X;Z++)if(this.d[Z].matches(x))return Z;return-1}}e.$EK=t;function g(B,W,X,x=(Z,Y)=>Z===Y){const Z=[];function Y(we,Se,_){if(Se===0&&_.length===0)return;const U=Z[Z.length-1];U&&U.start+U.deleteCount===we?(U.deleteCount+=Se,U.toInsert.push(..._)):Z.push({start:we,deleteCount:Se,toInsert:_})}let ue=0,te=0;for(;;){if(ue===B.length){Y(ue,0,W.slice(te));break}if(te===W.length){Y(ue,B.length-ue,[]);break}const we=B[ue],Se=W[te];if(x(we,Se)){ue+=1,te+=1;continue}X(Se)?(Y(ue,1,[]),ue+=1):(Y(ue,0,[Se]),te+=1)}return Z}e.$GK=new S.$Hj("notebookEditorCursorAtBoundary","none"),e.$HK=new S.$Hj("notebookEditorCursorAtLineBoundary","none");var h;(function(B){B.default="default",B.option="option"})(h||(e.NotebookEditorPriority=h={}));function c(B){const W=B;return!!((typeof W.include=="string"||N.$lk(W.include))&&(typeof W.exclude=="string"||N.$lk(W.exclude)))}function r(B,W,X){if(Array.isArray(B.viewType)&&B.viewType.indexOf(W)>=0||B.viewType===W)return!0;if(B.filenamePattern){const x=c(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,Z=c(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(N.$jk(x,(0,b.$oc)(X.fsPath).toLowerCase()))return!(Z&&N.$jk(Z,(0,b.$oc)(X.fsPath).toLowerCase()))}return!1}e.$KK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var w;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class d{static{this.d="notebook/"}static create(W){return`${d.d}${W}`}static parse(W){if(W.startsWith(d.d))return W.substring(d.d.length)}}e.$LK=d;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const p=new TextDecoder;function k(B){const W=[];let X=!1;for(const ue of B)(W.length===0||X)&&(W.push(ue),X=!0);let x=I(W);const Z=l.$Ce.concat(W.map(ue=>l.$Ce.wrap(ue))),Y=T(Z);return x=x||Y.byteLength!==Z.byteLength,{data:Y,didCompression:x}}e.$OK="\x1B[A";const y=e.$OK.split("").map(B=>B.charCodeAt(0)),P=10;function I(B){let W=!1;return B.forEach((X,x)=>{if(x===0||X.length<e.$OK.length)return;const Z=B[x-1],Y=X.subarray(0,e.$OK.length);if(Y[0]===y[0]&&Y[1]===y[1]&&Y[2]===y[2]){const ue=Z.lastIndexOf(P);if(ue===-1)return;W=!0,B[x-1]=Z.subarray(0,ue),B[x]=X.subarray(e.$OK.length)}}),W}function F(B){let W=B;do B=W,W=B.replace(/[^\n]\x08/gm,"");while(W.length<B.length);return B}function j(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const W=B.match(/^(.*)\r+/m)[1];let X=B.match(/\r+(.*)$/m)[1];X=X+W.slice(X.length,W.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return B}const z=8,O=13;function T(B){return!B.buffer.includes(z)&&!B.buffer.includes(O)?B:l.$Ce.fromString(j(F(p.decode(B.buffer))))}}),define(ke[7],Ee([1,0,19,13,80,27,101,14,18,2,30,25,32,66,119]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v){"use strict";var u,f,a,n,i,s,o,t,g,h,c,r,w,d,D,p,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$3O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$2O=e.$1O=e.$ZO=e.$YO=e.ChatLocation=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$MO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zO=e.$yO=e.$xO=e.$wO=e.$uO=e.$tO=e.$sO=e.$rO=e.TestRunProfileKind=e.TestResultState=e.$qO=e.$pO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oO=e.NotebookVariablesRequestKind=e.$nO=e.$mO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.ColorThemeKind=e.$fO=e.$eO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dO=e.$cO=e.DebugConsoleMode=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$9N=e.$8N=e.FileChangeType=e.$7N=e.NewSymbolNameTag=e.$6N=e.$5N=e.$4N=e.$3N=e.InlineCompletionTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$PN=e.ConfigurationTarget=e.$ON=e.$NN=e.$MN=e.$LN=e.DocumentPasteTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$EN=e.ViewBadge=e.ProgressLocation=e.$DN=e.$CN=e.TaskScope=e.ShellQuoting=e.$BN=e.$AN=e.$zN=e.TaskPanelKind=e.TaskRevealKind=e.$yN=e.TerminalLocation=e.$xN=e.$wN=e.$vN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$uN=e.$tN=e.$sN=e.$rN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$pN=e.$oN=e.$nN=e.$mN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$lN=e.$kN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.LanguageStatusSeverity=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.CodeActionTriggerKind=e.$$M=e.$0M=e.SymbolTag=e.SymbolKind=e.$9M=e.$8M=e.DocumentHighlightKind=e.$7M=e.$6M=e.$5M=e.$4M=e.DiagnosticSeverity=e.DiagnosticTag=e.$3M=e.$2M=e.FileEditType=e.$1M=e.$ZM=e.$YM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$qN=ht,e.$QN=ee,e.$vO=Mt;function y(H){return Object.assign(H,{apply:function(...ge){if(ge.length===0)return Reflect.construct(H,[]);{const Oe=ge.length===1?[]:ge[1];return Reflect.construct(H,Oe,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(H,[]);{const[Oe,...xe]=ge;return Reflect.construct(H,xe,Oe.constructor)}}})}var P;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var I;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let F=u=class{static from(...K){let ge=K;return new u(function(){if(ge){for(const Oe of ge)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();ge=void 0}})}#e;constructor(K){this.#e=K}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$RM=F,e.$RM=F=u=Je([y],F);let j=f=class{static Min(...K){if(K.length===0)throw new TypeError;let ge=K[0];for(let Oe=1;Oe<K.length;Oe++){const xe=K[Oe];xe.isBefore(ge)&&(ge=xe)}return ge}static Max(...K){if(K.length===0)throw new TypeError;let ge=K[0];for(let Oe=1;Oe<K.length;Oe++){const xe=K[Oe];xe.isAfter(ge)&&(ge=xe)}return ge}static isPosition(K){if(!K)return!1;if(K instanceof f)return!0;const{line:ge,character:Oe}=K;return typeof ge=="number"&&typeof Oe=="number"}static of(K){if(K instanceof f)return K;if(this.isPosition(K))return new f(K.line,K.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(K,ge){if(K<0)throw(0,N.$7)("line must be non-negative");if(ge<0)throw(0,N.$7)("character must be non-negative");this.c=K,this.e=ge}isBefore(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<K.e}isBeforeOrEqual(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<=K.e}isAfter(K){return!this.isBeforeOrEqual(K)}isAfterOrEqual(K){return!this.isBefore(K)}isEqual(K){return this.c===K.c&&this.e===K.e}compareTo(K){return this.c<K.c?-1:this.c>K.line?1:this.e<K.e?-1:this.e>K.e?1:0}translate(K,ge=0){if(K===null||ge===null)throw(0,N.$7)();let Oe;return typeof K>"u"?Oe=0:typeof K=="number"?Oe=K:(Oe=typeof K.lineDelta=="number"?K.lineDelta:0,ge=typeof K.characterDelta=="number"?K.characterDelta:0),Oe===0&&ge===0?this:new f(this.line+Oe,this.character+ge)}with(K,ge=this.character){if(K===null||ge===null)throw(0,N.$7)();let Oe;return typeof K>"u"?Oe=this.line:typeof K=="number"?Oe=K:(Oe=typeof K.line=="number"?K.line:this.line,ge=typeof K.character=="number"?K.character:this.character),Oe===this.line&&ge===this.character?this:new f(Oe,ge)}toJSON(){return{line:this.line,character:this.character}}};e.$SM=j,e.$SM=j=f=Je([y],j);let z=a=class{static isRange(K){return K instanceof a?!0:K?j.isPosition(K.start)&&j.isPosition(K.end):!1}static of(K){if(K instanceof a)return K;if(this.isRange(K))return new a(K.start,K.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(K,ge,Oe,xe){let rt,ft;if(typeof K=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof xe=="number"?(rt=new j(K,ge),ft=new j(Oe,xe)):j.isPosition(K)&&j.isPosition(ge)&&(rt=j.of(K),ft=j.of(ge)),!rt||!ft)throw new Error("Invalid arguments");rt.isBefore(ft)?(this.c=rt,this.e=ft):(this.c=ft,this.e=rt)}contains(K){return a.isRange(K)?this.contains(K.start)&&this.contains(K.end):j.isPosition(K)?!(j.of(K).isBefore(this.c)||this.e.isBefore(K)):!1}isEqual(K){return this.c.isEqual(K.c)&&this.e.isEqual(K.e)}intersection(K){const ge=j.Max(K.start,this.c),Oe=j.Min(K.end,this.e);if(!ge.isAfter(Oe))return new a(ge,Oe)}union(K){if(this.contains(K))return this;if(K.contains(this))return K;const ge=j.Min(K.start,this.c),Oe=j.Max(K.end,this.end);return new a(ge,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(K,ge=this.end){if(K===null||ge===null)throw(0,N.$7)();let Oe;return K?j.isPosition(K)?Oe=K:(Oe=K.start||this.start,ge=K.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&ge.isEqual(this.end)?this:new a(Oe,ge)}toJSON(){return[this.start,this.end]}};e.$TM=z,e.$TM=z=a=Je([y],z);let O=n=class extends z{static isSelection(K){return K instanceof n?!0:K?z.isRange(K)&&j.isPosition(K.anchor)&&j.isPosition(K.active)&&typeof K.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(K,ge,Oe,xe){let rt,ft;if(typeof K=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof xe=="number"?(rt=new j(K,ge),ft=new j(Oe,xe)):j.isPosition(K)&&j.isPosition(ge)&&(rt=j.of(K),ft=j.of(ge)),!rt||!ft)throw new Error("Invalid arguments");super(rt,ft),this.f=rt,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$UM=O,e.$UM=O=n=Je([y],O);const T=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,N.$7)("connectionToken")};class B{static isResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.host=="string"&&typeof K.port=="number"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,ge,Oe){if(typeof K!="string"||K.length===0)throw(0,N.$7)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,N.$7)("port");typeof Oe<"u"&&T(Oe),this.host=K,this.port=Math.round(ge),this.connectionToken=Oe}}e.$VM=B;class W{static isManagedResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.makeConnection=="function"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,ge){this.makeConnection=K,this.connectionToken=ge,typeof ge<"u"&&T(ge)}}e.$WM=W;class X extends Error{static NotAvailable(K,ge){return new X(K,E.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(K){return new X(K,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(K,ge=E.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(K),this._message=K,this._code=ge,this._detail=Oe,Object.setPrototypeOf(this,X.prototype)}}e.$XM=X;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var Z;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let Y=i=class{static isTextEdit(K){return K instanceof i?!0:K?z.isRange(K)&&typeof K.newText=="string":!1}static replace(K,ge){return new i(K,ge)}static insert(K,ge){return i.replace(new z(K,K),ge)}static delete(K){return i.replace(K,"")}static setEndOfLine(K){const ge=new i(new z(new j(0,0),new j(0,0)),"");return ge.newEol=K,ge}get range(){return this.c}set range(K){if(K&&!z.isRange(K))throw(0,N.$7)("range");this.c=K}get newText(){return this.e||""}set newText(K){if(K&&typeof K!="string")throw(0,N.$7)("newText");this.e=K}get newEol(){return this.f}set newEol(K){if(K&&typeof K!="number")throw(0,N.$7)("newEol");this.f=K}constructor(K,ge){this.c=K,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$YM=Y,e.$YM=Y=i=Je([y],Y);let ue=s=class{static isNotebookCellEdit(K){return K instanceof s?!0:K?at.isNotebookRange(K)&&Array.isArray(K.newCells):!1}static replaceCells(K,ge){return new s(K,ge)}static insertCells(K,ge){return new s(new at(K,K),ge)}static deleteCells(K){return new s(K,[])}static updateCellMetadata(K,ge){const Oe=new s(new at(K,K),[]);return Oe.newCellMetadata=ge,Oe}static updateNotebookMetadata(K){const ge=new s(new at(0,0),[]);return ge.newNotebookMetadata=K,ge}constructor(K,ge){this.range=K,this.newCells=ge}};e.$ZM=ue,e.$ZM=ue=s=Je([y],ue);class te{static isSnippetTextEdit(K){return K instanceof te?!0:K?z.isRange(K.range)&&_.isSnippetString(K.snippet):!1}static replace(K,ge){return new te(K,ge)}static insert(K,ge){return te.replace(new z(K,K),ge)}constructor(K,ge){this.range=K,this.snippet=ge}}e.$1M=te;var we;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let Se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(K,ge,Oe,xe){this.c.push({_type:1,from:K,to:ge,options:Oe,metadata:xe})}createFile(K,ge,Oe){this.c.push({_type:1,from:void 0,to:K,options:ge,metadata:Oe})}deleteFile(K,ge,Oe){this.c.push({_type:1,from:K,to:void 0,options:ge,metadata:Oe})}e(K,ge,Oe){this.c.push({_type:3,metadata:Oe,uri:K,edit:{editType:5,metadata:ge},notebookMetadata:ge})}f(K,ge,Oe,xe){const rt=ge.start,ft=ge.end;(rt!==ft||Oe.length>0)&&this.c.push({_type:5,uri:K,index:rt,count:ft-rt,cells:Oe,metadata:xe})}g(K,ge,Oe,xe){this.c.push({_type:3,metadata:xe,uri:K,edit:{editType:3,index:ge,metadata:Oe}})}replace(K,ge,Oe,xe){this.c.push({_type:2,uri:K,edit:new Y(ge,Oe),metadata:xe})}insert(K,ge,Oe,xe){this.replace(K,new z(ge,ge),Oe,xe)}delete(K,ge,Oe){this.replace(K,ge,"",Oe)}has(K){return this.c.some(ge=>ge._type===2&&ge.uri.toString()===K.toString())}set(K,ge){if(ge)for(const Oe of ge){if(!Oe)continue;let xe,rt;Array.isArray(Oe)?(xe=Oe[0],rt=Oe[1]):xe=Oe,ue.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(K,xe.range.start,xe.newCellMetadata,rt):xe.newNotebookMetadata?this.e(K,xe.newNotebookMetadata,rt):this.f(K,xe.range,xe.newCells,rt):te.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:K,range:xe.range,edit:xe.snippet,metadata:rt}):this.c.push({_type:2,uri:K,edit:xe,metadata:rt})}else{for(let Oe=0;Oe<this.c.length;Oe++){const xe=this.c[Oe];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===K.toString()&&(this.c[Oe]=void 0);break}}(0,l.$Ib)(this.c)}}get(K){const ge=[];for(const Oe of this.c)Oe._type===2&&Oe.uri.toString()===K.toString()&&ge.push(Oe.edit);return ge}entries(){const K=new R.$Bc;for(const ge of this.c)if(ge._type===2){let Oe=K.get(ge.uri);Oe||(Oe=[ge.uri,[]],K.set(ge.uri,Oe)),Oe[1].push(ge.edit)}return[...K.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$2M=Se,e.$2M=Se=Je([y],Se);let _=o=class{static isSnippetString(K){return K instanceof o?!0:K?typeof K.value=="string":!1}static c(K){return K.replace(/\$|}|\\/g,"\\$&")}constructor(K){this.e=1,this.value=K||""}appendText(K){return this.value+=o.c(K),this}appendTabstop(K=this.e++){return this.value+="$",this.value+=K,this}appendPlaceholder(K,ge=this.e++){if(typeof K=="function"){const Oe=new o;Oe.e=this.e,K(Oe),this.e=Oe.e,K=Oe.value}else K=o.c(K);return this.value+="${",this.value+=ge,this.value+=":",this.value+=K,this.value+="}",this}appendChoice(K,ge=this.e++){const Oe=K.map(xe=>xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(K,ge){if(typeof ge=="function"){const Oe=new o;Oe.e=this.e,ge(Oe),this.e=Oe.e,ge=Oe.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=K,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$3M=_,e.$3M=_=o=Je([y],_);var U;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ne;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let $e=t=class{static isLocation(K){return K instanceof t?!0:K?z.isRange(K.range)&&S.URI.isUri(K.uri):!1}constructor(K,ge){if(this.uri=K,ge)if(z.isRange(ge))this.range=z.of(ge);else if(j.isPosition(ge))this.range=new z(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$4M=$e,e.$4M=$e=t=Je([y],$e);let Pe=class{static is(K){return K?typeof K.message=="string"&&K.location&&z.isRange(K.location.range)&&S.URI.isUri(K.location.uri):!1}constructor(K,ge){this.location=K,this.message=ge}static isEqual(K,ge){return K===ge?!0:!K||!ge?!1:K.message===ge.message&&K.location.range.isEqual(ge.location.range)&&K.location.uri.toString()===ge.location.uri.toString()}};e.$5M=Pe,e.$5M=Pe=Je([y],Pe);let se=class{constructor(K,ge,Oe=ne.Error){if(!z.isRange(K))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=K,this.message=ge,this.severity=Oe}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(K,ge){return K===ge?!0:!K||!ge?!1:K.message===ge.message&&K.severity===ge.severity&&K.code===ge.code&&K.severity===ge.severity&&K.source===ge.source&&K.range.isEqual(ge.range)&&(0,l.$ub)(K.tags,ge.tags)&&(0,l.$ub)(K.relatedInformation,ge.relatedInformation,Pe.isEqual)}};e.$6M=se,e.$6M=se=Je([y],se);let re=class{constructor(K,ge){if(!K)throw new Error("Illegal argument, contents must be defined");Array.isArray(K)?this.contents=K:this.contents=[K],this.range=ge}};e.$7M=re,e.$7M=re=Je([y],re);var oe;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let G=class{constructor(K,ge=oe.Text){this.range=K,this.kind=ge}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$8M=G,e.$8M=G=Je([y],G);let ie=class{constructor(K,ge){this.uri=K,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(K=>K.toJSON())}}};e.$9M=ie,e.$9M=ie=Je([y],ie);var me;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var be;(function(H){H[H.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Ae=g=class{static validate(K){if(!K.name)throw new Error("name must not be falsy")}constructor(K,ge,Oe,xe,rt){this.name=K,this.kind=ge,this.containerName=rt,typeof Oe=="string"&&(this.containerName=Oe),xe instanceof $e?this.location=xe:Oe instanceof z&&(this.location=new $e(xe,Oe)),g.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$0M=Ae,e.$0M=Ae=g=Je([y],Ae);let fe=h=class{static validate(K){if(!K.name)throw new Error("name must not be falsy");if(!K.range.contains(K.selectionRange))throw new Error("selectionRange must be contained in fullRange");K.children?.forEach(h.validate)}constructor(K,ge,Oe,xe,rt){this.name=K,this.detail=ge,this.kind=Oe,this.range=xe,this.selectionRange=rt,this.children=[],h.validate(this)}};e.$$M=fe,e.$$M=fe=h=Je([y],fe);var De;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let Ie=class{constructor(K,ge){this.title=K,this.kind=ge}};e.$_M=Ie,e.$_M=Ie=Je([y],Ie);let Te=class{static{c=this}static{this.c="."}constructor(K){this.value=K}append(K){return new c(this.value?this.value+c.c+K:K)}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+c.c)}};e.$aN=Te,e.$aN=Te=c=Je([y],Te),Te.Empty=new Te(""),Te.QuickFix=Te.Empty.append("quickfix"),Te.Refactor=Te.Empty.append("refactor"),Te.RefactorExtract=Te.Refactor.append("extract"),Te.RefactorInline=Te.Refactor.append("inline"),Te.RefactorMove=Te.Refactor.append("move"),Te.RefactorRewrite=Te.Refactor.append("rewrite"),Te.Source=Te.Empty.append("source"),Te.SourceOrganizeImports=Te.Source.append("organizeImports"),Te.SourceFixAll=Te.Source.append("fixAll"),Te.Notebook=Te.Empty.append("notebook");let q=class{constructor(K,ge){if(this.range=K,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$bN=q,e.$bN=q=Je([y],q);class V{constructor(K,ge,Oe,xe,rt,ft){this.kind=K,this.name=ge,this.detail=Oe,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$cN=V;class J{constructor(K,ge){this.fromRanges=ge,this.from=K}}e.$dN=J;class Q{constructor(K,ge){this.fromRanges=ge,this.to=K}}e.$eN=Q;var he;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(he||(e.LanguageStatusSeverity=he={}));let pe=class{constructor(K,ge){this.range=K,this.command=ge}get isResolved(){return!!this.command}};e.$fN=pe,e.$fN=pe=Je([y],pe);let ze=r=class{#e;static isMarkdownString(K){return K instanceof r?!0:K&&K.appendCodeblock&&K.appendMarkdown&&K.appendText&&K.value!==void 0}constructor(K,ge=!1){this.#e=new L.$Nk(K,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(K){this.#e.value=K}get isTrusted(){return this.#e.isTrusted}set isTrusted(K){this.#e.isTrusted=K}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(K){this.#e.supportThemeIcons=K}get supportHtml(){return this.#e.supportHtml}set supportHtml(K){this.#e.supportHtml=K}get baseUri(){return this.#e.baseUri}set baseUri(K){this.#e.baseUri=K}appendText(K){return this.#e.appendText(K),this}appendMarkdown(K){return this.#e.appendMarkdown(K),this}appendCodeblock(K,ge){return this.#e.appendCodeblock(ge??"",K),this}};e.$gN=ze,e.$gN=ze=r=Je([y],ze);let Ve=class{constructor(K,ge){this.label=K,this.documentation=ge}};e.$hN=Ve,e.$hN=Ve=Je([y],Ve);let Ze=class{constructor(K,ge){this.label=K,this.documentation=ge,this.parameters=[]}};e.$iN=Ze,e.$iN=Ze=Je([y],Ze);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$jN=it,e.$jN=it=Je([y],it);var ot;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var nt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let st=class{constructor(K){this.value=K}};e.$kN=st,e.$kN=st=Je([y],st);let Ce=class{constructor(K,ge,Oe){this.position=K,this.label=ge,this.kind=Oe}};e.$lN=Ce,e.$lN=Ce=Je([y],Ce);var Be;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var He;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(He||(e.CompletionItemKind=He={}));var Ne;(function(H){H[H.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let Xe=class{constructor(K,ge){this.label=K,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$mN=Xe,e.$mN=Xe=Je([y],Xe);let ae=class{constructor(K=[],ge=!1){this.items=K,this.isIncomplete=ge}};e.$nN=ae,e.$nN=ae=Je([y],ae);let ce=class{constructor(K,ge,Oe){this.insertText=K,this.range=ge,this.command=Oe}};e.$oN=ce,e.$oN=ce=Je([y],ce);let Re=class{constructor(K){this.commands=void 0,this.suppressSuggestions=void 0,this.items=K}};e.$pN=Re,e.$pN=Re=Je([y],Re);var Ge;(function(H){H[H.Unknown=0]="Unknown",H[H.Word=1]="Word",H[H.Line=2]="Line",H[H.Suggest=3]="Suggest"})(Ge||(e.PartialAcceptTriggerKind=Ge={}));var Me;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(Me||(e.ViewColumn=Me={}));var tt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(tt||(e.StatusBarAlignment=tt={}));function ht(H,K){return`${C.$Lm.toKey(H)}.${K}`}var wt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var Lt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Lt||(e.TextDocumentSaveReason=Lt={}));var At;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var xt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Pt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Pt||(e.DecorationRangeBehavior=Pt={})),function(H){function K(ge){switch(ge){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=K}(xt||(e.TextEditorSelectionChangeKind=xt={}));var Vt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(H){function K(ge){switch(ge){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=K}(Vt||(e.SyntaxTokenType=Vt={}));let Xt=class{constructor(K,ge){if(ge&&!S.URI.isUri(ge))throw(0,N.$7)("target");if(!z.isRange(K)||K.isEmpty)throw(0,N.$7)("range");this.range=K,this.target=ge}};e.$rN=Xt,e.$rN=Xt=Je([y],Xt);let et=class{constructor(K,ge,Oe,xe){this.red=K,this.green=ge,this.blue=Oe,this.alpha=xe}};e.$sN=et,e.$sN=et=Je([y],et);let si=class{constructor(K,ge){if(ge&&!(ge instanceof et))throw(0,N.$7)("color");if(!z.isRange(K)||K.isEmpty)throw(0,N.$7)("range");this.range=K,this.color=ge}};e.$tN=si,e.$tN=si=Je([y],si);let Zt=class{constructor(K){if(!K||typeof K!="string")throw(0,N.$7)("label");this.label=K}};e.$uN=Zt,e.$uN=Zt=Je([y],Zt);var dt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(dt||(e.ColorFormat=dt={}));var vt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(vt||(e.SourceControlInputBoxValidationType=vt={}));var ti;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Yt;(function(H){H[H.Low=0]="Low",H[H.Medium=1]="Medium",H[H.High=2]="High"})(Yt||(e.TerminalShellExecutionCommandLineConfidence=Yt={}));class zt{constructor(K,ge,Oe){if(this.startIndex=K,this.length=ge,this.tooltip=Oe,typeof K!="number"||K<0)throw(0,N.$7)("startIndex");if(typeof ge!="number"||ge<1)throw(0,N.$7)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,N.$7)("tooltip")}}e.$vN=zt;class gt{constructor(K){this.uri=K}}e.$wN=gt;class Ut{constructor(K){this.terminalCommand=K}}e.$xN=Ut;var Wt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Wt||(e.TerminalLocation=Wt={}));class Kt{constructor(K){if(this.options=K,typeof K!="object")throw(0,N.$7)("options")}}e.$yN=Kt;var Ye;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Ye||(e.TaskRevealKind=Ye={}));var ui;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Ht=class{static{w=this}static{this.Clean=new w("clean","Clean")}static{this.Build=new w("build","Build")}static{this.Rebuild=new w("rebuild","Rebuild")}static{this.Test=new w("test","Test")}static from(K){switch(K){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(K,ge){if(this.label=ge,typeof K!="string"||typeof ge!="string")throw(0,N.$7)("name");this.c=K}get id(){return this.c}};e.$zN=Ht,e.$zN=Ht=w=Je([y],Ht);function Bt(H){let K="";for(let ge=0;ge<H.length;ge++)K+=H[ge].replace(/,/g,",,")+",";return K}let mt=class{constructor(K,ge,Oe){if(typeof K!="string")throw(0,N.$7)("process");this.e=[],this.c=K,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Oe):this.f=ge)}get process(){return this.c}set process(K){if(typeof K!="string")throw(0,N.$7)("process");this.c=K}get args(){return this.e}set args(K){Array.isArray(K)||(K=[]),this.e=K}get options(){return this.f}set options(K){this.f=K}computeId(){const K=[];if(K.push("process"),this.c!==void 0&&K.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)K.push(ge);return Bt(K)}};e.$AN=mt,e.$AN=mt=Je([y],mt);let Tt=class{constructor(K,ge,Oe){if(this.f=[],Array.isArray(ge)){if(!K)throw(0,N.$7)("command can't be undefined or null");if(typeof K!="string"&&typeof K.value!="string")throw(0,N.$7)("command");this.e=K,this.f=ge,this.g=Oe}else{if(typeof K!="string")throw(0,N.$7)("commandLine");this.c=K,this.g=ge}}get commandLine(){return this.c}set commandLine(K){if(typeof K!="string")throw(0,N.$7)("commandLine");this.c=K}get command(){return this.e?this.e:""}set command(K){if(typeof K!="string"&&typeof K.value!="string")throw(0,N.$7)("command");this.e=K}get args(){return this.f}set args(K){this.f=K||[]}get options(){return this.g}set options(K){this.g=K}computeId(){const K=[];if(K.push("shell"),this.c!==void 0&&K.push(this.c),this.e!==void 0&&K.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)K.push(typeof ge=="string"?ge:ge.value);return Bt(K)}};e.$BN=Tt,e.$BN=Tt=Je([y],Tt);var Rt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Rt||(e.ShellQuoting=Rt={}));var Ft;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Ft||(e.TaskScope=Ft={}));class ii{constructor(K){this.c=K}computeId(){return"customExecution"+(0,A.$Mg)()}set callback(K){this.c=K}get callback(){return this.c}}e.$CN=ii;let Gt=class{static{d=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(K,ge,Oe,xe,rt,ft){this.k=!1,this.l=this.definition=K;let $t;typeof ge=="string"?(this.o=this.name=ge,this.w=this.source=Oe,this.execution=xe,$t=rt,this.k=!0):ge===Ft.Global||ge===Ft.Workspace?(this.target=ge,this.o=this.name=Oe,this.w=this.source=xe,this.execution=rt,$t=ft):(this.target=ge,this.o=this.name=Oe,this.w=this.source=xe,this.execution=rt,$t=ft),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(K){this.j=K}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof mt?this.l={type:d.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:d.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:d.c,id:this.q.computeId()}:this.l={type:d.g,id:(0,A.$Mg)()}}get definition(){return this.l}set definition(K){if(K==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=K}get scope(){return this.m}set target(K){this.B(),this.m=K}get name(){return this.o}set name(K){if(typeof K!="string")throw(0,N.$7)("name");this.B(),this.o=K}get execution(){return this.q}set execution(K){K===null&&(K=void 0),this.B(),this.q=K;const ge=this.l.type;(d.g===ge||d.e===ge||d.f===ge||d.c===ge)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(K){if(Array.isArray(K))this.B(),this.r=K,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(K){K!==!0&&K!==!1&&(K=!1),this.B(),this.u=K}get source(){return this.w}set source(K){if(typeof K!="string"||K.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=K}get group(){return this.x}set group(K){K===null&&(K=void 0),this.B(),this.x=K}get detail(){return this.A}set detail(K){K===null&&(K=void 0),this.A=K}get presentationOptions(){return this.y}set presentationOptions(K){K==null&&(K=Object.create(null)),this.B(),this.y=K}get runOptions(){return this.z}set runOptions(K){K==null&&(K=Object.create(null)),this.B(),this.z=K}};e.$DN=Gt,e.$DN=Gt=d=Je([y],Gt);var ni;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Nt;(function(H){function K(ge){const Oe=ge;return(0,$.$8f)(Oe.value)?Oe.tooltip&&!(0,$.$4f)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}H.isViewBadge=K})(Nt||(e.ViewBadge=Nt={}));let Ot=D=class{static isTreeItem(K,ge){const Oe=K;if(Oe.checkboxState!==void 0){const xe=(0,$.$8f)(Oe.checkboxState)?Oe.checkboxState:(0,$.$6f)(Oe.checkboxState)&&(0,$.$8f)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,rt=!(0,$.$8f)(Oe.checkboxState)&&(0,$.$6f)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(xe===void 0||xe!==St.Checked&&xe!==St.Unchecked||rt!==void 0&&!(0,$.$4f)(rt))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(K instanceof D)return!0;if(Oe.label!==void 0&&!(0,$.$4f)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,$.$4f)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,$.$4f)(Oe.iconPath)&&!S.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,$.$4f)(Oe.iconPath.id))){const xe=Oe.iconPath;if(!xe||!(0,$.$4f)(xe.light)&&!S.URI.isUri(xe.light)&&!(0,$.$4f)(xe.dark)&&!S.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,$.$4f)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!S.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,$.$4f)(Oe.tooltip)&&!(Oe.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<It.None&&Oe.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,$.$4f)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(K,ge=It.None){this.collapsibleState=ge,S.URI.isUri(K)?this.resourceUri=K:this.label=K}};e.$EN=Ot,e.$EN=Ot=D=Je([y],Ot);var It;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var St;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(K){this.value=K}};e.$FN=pt,e.$FN=pt=Je([y],pt);class Ct extends pt{}e.$GN=Ct;class li extends Ct{#e;constructor(K){super(""),this.#e=K}asFile(){return this.#e}}e.$HN=li;class Dt{constructor(K,ge,Oe,xe){this.name=K,this.uri=ge,this._itemId=Oe,this.c=xe}data(){return this.c()}}e.$IN=Dt;let hi=class{#e=new Map;constructor(K){for(const[ge,Oe]of K??[]){const xe=this.#e.get(this.#t(ge));xe?xe.push(Oe):this.#e.set(this.#t(ge),[Oe])}}get(K){return this.#e.get(this.#t(K))?.[0]}set(K,ge){this.#e.set(this.#t(K),[ge])}forEach(K,ge){for(const[Oe,xe]of this.#e)for(const rt of xe)K.call(ge,rt,Oe,this)}*[Symbol.iterator](){for(const[K,ge]of this.#e)for(const Oe of ge)yield[K,Oe]}#t(K){return K.toLowerCase()}};e.$JN=hi,e.$JN=hi=Je([y],hi);let Jt=class{constructor(K,ge,Oe){this.insertText=K,this.title=ge,this.kind=Oe}};e.$KN=Jt,e.$KN=Jt=Je([y],Jt);var wi;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class ei{static{this.c="."}constructor(K){this.value=K}append(...K){return new ei((this.value?[this.value,...K]:K).join(ei.c))}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+ei.c)}}e.$LN=ei,ei.Empty=new ei("");class vi{constructor(K,ge,Oe){this.title=ge,this.insertText=K,this.kind=Oe}}e.$MN=vi;let kt=class{constructor(K,ge){this.id=K,this.color=ge}static isThemeIcon(K){return typeof K.id!="string"?(console.log("INVALID ThemeIcon, invalid id",K.id),!1):!0}};e.$NN=kt,e.$NN=kt=Je([y],kt),kt.File=new kt("file"),kt.Folder=new kt("folder");let $i=class{constructor(K){this.id=K}};e.$ON=$i,e.$ON=$i=Je([y],$i);var Le;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Le||(e.ConfigurationTarget=Le={}));let je=class{get base(){return this.c}set base(K){this.c=K,this.e=S.URI.file(K)}get baseUri(){return this.e}set baseUri(K){this.e=K,this.c=K.fsPath}constructor(K,ge){if(typeof K!="string"&&(!K||!S.URI.isUri(K)&&!S.URI.isUri(K.uri)))throw(0,N.$7)("base");if(typeof ge!="string")throw(0,N.$7)("pattern");typeof K=="string"?this.baseUri=S.URI.file(K):S.URI.isUri(K)?this.baseUri=K:this.baseUri=K.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PN=je,e.$PN=je=Je([y],je);const ye=new WeakMap;function ee(H,K){ye.set(H,K)}let Fe=class{constructor(K,ge,Oe,xe,rt){this.enabled=typeof K=="boolean"?K:!0,typeof ge=="string"&&(this.condition=ge),typeof Oe=="string"&&(this.hitCondition=Oe),typeof xe=="string"&&(this.logMessage=xe),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=ye.get(this)??(0,A.$Mg)()),this.c}};e.$RN=Fe,e.$RN=Fe=Je([y],Fe);let Ke=class extends Fe{constructor(K,ge,Oe,xe,rt,ft){if(super(ge,Oe,xe,rt,ft),K===null)throw(0,N.$7)("location");this.location=K}};e.$SN=Ke,e.$SN=Ke=Je([y],Ke);let _e=class extends Fe{constructor(K,ge,Oe,xe,rt,ft){super(ge,Oe,xe,rt,ft),this.functionName=K}};e.$TN=_e,e.$TN=_e=Je([y],_e);let Qe=class extends Fe{constructor(K,ge,Oe,xe,rt,ft,$t,Qt){if(super(xe,rt,ft,$t,Qt),!ge)throw(0,N.$7)("dataId");this.label=K,this.dataId=ge,this.canPersist=Oe}};e.$UN=Qe,e.$UN=Qe=Je([y],Qe);let lt=class{constructor(K,ge,Oe){this.command=K,this.args=ge||[],this.options=Oe}};e.$VN=lt,e.$VN=lt=Je([y],lt);let Et=class{constructor(K,ge){this.port=K,this.host=ge}};e.$WN=Et,e.$WN=Et=Je([y],Et);let jt=class{constructor(K){this.path=K}};e.$XN=jt,e.$XN=jt=Je([y],jt);let qt=class{constructor(K){this.implementation=K}};e.$YN=qt,e.$YN=qt=Je([y],qt);class ut{constructor(K,ge,Oe){this.session=K,this.threadId=ge,this.frameId=Oe}}e.$ZN=ut;class ri{constructor(K,ge){this.session=K,this.threadId=ge}}e.$1N=ri;let di=class{constructor(K,ge){this.range=K,this.expression=ge}};e.$2N=di,e.$2N=di=Je([y],di);var pi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let Di=class{constructor(K,ge){this.range=K,this.text=ge}};e.$3N=Di,e.$3N=Di=Je([y],Di);let Ri=class{constructor(K,ge,Oe=!0){this.range=K,this.variableName=ge,this.caseSensitiveLookup=Oe}};e.$4N=Ri,e.$4N=Ri=Je([y],Ri);let Mi=class{constructor(K,ge){this.range=K,this.expression=ge}};e.$5N=Mi,e.$5N=Mi=Je([y],Mi);let Li=class{constructor(K,ge){this.frameId=K,this.stoppedLocation=ge}};e.$6N=Li,e.$6N=Li=Je([y],Li);var Ni;(function(H){H[H.AIGenerated=1]="AIGenerated"})(Ni||(e.NewSymbolNameTag=Ni={}));class cn{constructor(K,ge){this.newSymbolName=K,this.tags=ge}}e.$7N=cn;var Oi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Ti=p=class extends Error{static FileExists(K){return new p(K,m.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(K){return new p(K,m.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(K){return new p(K,m.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(K){return new p(K,m.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(K){return new p(K,m.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(K){return new p(K,m.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(K,ge=m.FileSystemProviderErrorCode.Unknown,Oe){super(S.URI.isUri(K)?K.toString(!0):K),this.code=Oe?.name??"Unknown",(0,m.$_k)(this,ge),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$8N=Ti,e.$8N=Ti=p=Je([y],Ti);let yi=class{constructor(K,ge,Oe){this.start=K,this.end=ge,this.kind=Oe}};e.$9N=yi,e.$9N=yi=Je([y],yi);var Ci;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Ci||(e.FoldingRangeKind=Ci={}));var Hi;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Hi||(e.CommentThreadCollapsibleState=Hi={}));var Gi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Gi||(e.CommentMode=Gi={}));var bi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(bi||(e.CommentState=bi={}));var Ji;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Qi;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(K,ge=[]){this.tokenTypes=K,this.tokenModifiers=ge}}e.$0N=un;function Fi(H){return typeof H>"u"||(0,$.$5f)(H)}class ji{constructor(K){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,K){this.m=!0;for(let ge=0,Oe=K.tokenTypes.length;ge<Oe;ge++)this.k.set(K.tokenTypes[ge],ge);for(let ge=0,Oe=K.tokenModifiers.length;ge<Oe;ge++)this.l.set(K.tokenModifiers[ge],ge)}}push(K,ge,Oe,xe,rt){if(typeof K=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(K,ge,Oe,xe,rt);if(z.isRange(K)&&typeof ge=="string"&&Fi(Oe))return this.o(K,ge,Oe);throw(0,N.$7)()}o(K,ge,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(K.start.line!==K.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ge))throw new Error("`tokenType` is not in the provided legend");const xe=K.start.line,rt=K.start.character,ft=K.end.character-K.start.character,$t=this.k.get(ge);let Qt=0;if(Oe)for(const ci of Oe){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Qt|=1<<fi>>>0}this.q(xe,rt,ft,$t,Qt)}q(K,ge,Oe,xe,rt){if(this.f&&(K<this.c||K===this.c&&ge<this.e)){this.f=!1;const Qt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Qt;gi++){let mi=this.g[5*gi],Vi=this.g[5*gi+1];mi===0?(mi=ci,Vi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=Vi,ci=mi,fi=Vi}}let ft=K,$t=ge;this.f&&this.j>0&&(ft-=this.c,ft===0&&($t-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=$t,this.g[this.j++]=Oe,this.g[this.j++]=xe,this.g[this.j++]=rt,this.c=K,this.e=ge}static r(K){const ge=[],Oe=K.length/5|0;for(let $t=0;$t<Oe;$t++)ge[$t]=$t;ge.sort(($t,Qt)=>{const ci=K[5*$t],fi=K[5*Qt];if(ci===fi){const gi=K[5*$t+1],mi=K[5*Qt+1];return gi-mi}return ci-fi});const xe=new Uint32Array(K.length);let rt=0,ft=0;for(let $t=0;$t<Oe;$t++){const Qt=5*ge[$t],ci=K[Qt+0],fi=K[Qt+1],gi=K[Qt+2],mi=K[Qt+3],Vi=K[Qt+4],Mn=ci-rt,ur=Mn===0?fi-ft:fi,Ki=5*$t;xe[Ki+0]=Mn,xe[Ki+1]=ur,xe[Ki+2]=gi,xe[Ki+3]=mi,xe[Ki+4]=Vi,rt=ci,ft=fi}return xe}build(K){return this.f?new Pi(new Uint32Array(this.g),K):new Pi(ji.r(this.g),K)}}e.$$N=ji;class Pi{constructor(K,ge){this.resultId=ge,this.data=K}}e.$_N=Pi;class ln{constructor(K,ge,Oe){this.start=K,this.deleteCount=ge,this.data=Oe}}e.$aO=ln;class Xi{constructor(K,ge){this.resultId=ge,this.edits=K}}e.$bO=Xi;var Zi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));class hn{constructor(K){this.name=K}}e.$cO=hn;let zi=class{static{this.Back={iconPath:new kt("arrow-left")}}constructor(){}};e.$dO=zi,e.$dO=zi=Je([y],zi);var Yi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Ii;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(Ii||(e.InputBoxValidationSeverity=Ii={}));var Bi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Bi||(e.ExtensionKind=Bi={}));class We{static validate(K){if(typeof K.badge=="string"){let ge=(0,b.$Df)(K.badge,0);if(ge<K.badge.length&&(ge+=(0,b.$Df)(K.badge,ge)),K.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(K.badge&&!kt.isThemeIcon(K.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!K.color&&!K.badge&&!K.tooltip)throw new Error("The decoration is empty");return!0}constructor(K,ge,Oe){this.badge=K,this.tooltip=ge,this.color=Oe}}e.$eO=We;let oi=class{constructor(K){this.kind=K}};e.$fO=oi,e.$fO=oi=Je([y],oi);var Ui;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class at{static isNotebookRange(K){return K instanceof at?!0:K?typeof K.start=="number"&&typeof K.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(K,ge){if(K<0)throw(0,N.$7)("start must be positive");if(ge<0)throw(0,N.$7)("end must be positive");K<=ge?(this.c=K,this.e=ge):(this.c=ge,this.e=K)}with(K){let ge=this.c,Oe=this.e;return K.start!==void 0&&(ge=K.start),K.end!==void 0&&(Oe=K.end),ge===this.c&&Oe===this.e?this:new at(ge,Oe)}}e.$gO=at;class bt{static validate(K){if(typeof K.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof K.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof K.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(K){return Array.isArray(K)&&K.every(ge=>bt.isNotebookCellData(ge))}static isNotebookCellData(K){return!0}constructor(K,ge,Oe,xe,rt,ft,$t){this.kind=K,this.value=ge,this.languageId=Oe,this.mime=xe,this.outputs=rt??[],this.metadata=ft,this.executionSummary=$t,bt.validate(this)}}e.$hO=bt;class dn{constructor(K){this.cells=K}}e.$iO=dn;class ai{static isNotebookCellOutputItem(K){return K instanceof ai?!0:K?typeof K.mime=="string"&&K.data instanceof Uint8Array:!1}static error(K){const ge={name:K.name,message:K.message,stack:K.stack};return ai.json(ge,"application/vnd.code.notebook.error")}static stdout(K){return ai.text(K,"application/vnd.code.notebook.stdout")}static stderr(K){return ai.text(K,"application/vnd.code.notebook.stderr")}static bytes(K,ge="application/octet-stream"){return new ai(K,ge)}static#e=new TextEncoder;static text(K,ge=M.$Hs.text){const Oe=ai.#e.encode(String(K));return new ai(Oe,ge)}static json(K,ge="text/x-json"){const Oe=JSON.stringify(K,void 0,"	");return ai.text(Oe,ge)}constructor(K,ge){this.data=K,this.mime=ge;const Oe=(0,M.$Ls)(ge,!0);if(!Oe)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$jO=ai;class ki{static isNotebookCellOutput(K){return K instanceof ki?!0:!K||typeof K!="object"?!1:typeof K.id=="string"&&Array.isArray(K.items)}static ensureUniqueMimeTypes(K,ge=!1){const Oe=new Set,xe=new Set;for(let rt=0;rt<K.length;rt++){const ft=K[rt],$t=(0,M.$Ls)(ft.mime);if(!Oe.has($t)||(0,v.$MK)($t)){Oe.add($t);continue}xe.add(rt),ge&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return xe.size===0?K:K.filter((rt,ft)=>!xe.has(ft))}constructor(K,ge,Oe){this.items=ki.ensureUniqueMimeTypes(K,!0),typeof ge=="string"?(this.id=ge,this.metadata=Oe):(this.id=(0,A.$Mg)(),this.metadata=ge??Oe)}}e.$kO=ki;var xi;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Ei;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var _i;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(K,ge){this.text=K,this.alignment=ge}}e.$lO=fn;var Wi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var tn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(K,ge=[]){this.uri=K,this.provides=(0,l.$3b)(ge)}}e.$mO=gn;class mn{constructor(K){this.label=K}}e.$nO=mn;var nn;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let qi=class{constructor(K,ge){this.label=K,this.timestamp=ge}};e.$oO=qi,e.$oO=qi=Je([y],qi);var rn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(K,ge){this.ranges=K,this.wordPattern=ge}}e.$pO=$n;class pn{constructor(K){this.c=K}get autoForwardAction(){return this.c}}e.$qO=pn;var an;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var de;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(de||(e.TestRunProfileKind=de={}));let ve=class{constructor(K=void 0,ge=void 0,Oe=void 0,xe=!1){this.include=K,this.exclude=ge,this.profile=Oe,this.continuous=xe}};e.$rO=ve,e.$rO=ve=Je([y],ve);let Ue=k=class{static diff(K,ge,Oe){const xe=new k(K);return xe.expectedOutput=ge,xe.actualOutput=Oe,xe}constructor(K){this.message=K}};e.$sO=Ue,e.$sO=Ue=k=Je([y],Ue);let ct=class{constructor(K){this.id=K}};e.$tO=ct,e.$tO=ct=Je([y],ct);class yt{constructor(K,ge){this.covered=K,this.total=ge,Mt(this)}}e.$uO=yt;function Mt(H){if(H){if(H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`);if(H.total<0)throw new Error(`The number of covered items (${H.total}) cannot be negative`)}}class Si{static fromDetails(K,ge){const Oe=new yt(0,0),xe=new yt(0,0),rt=new yt(0,0);for(const $t of ge)if("branches"in $t){Oe.total+=1,Oe.covered+=$t.executed?1:0;for(const Qt of $t.branches)xe.total+=1,xe.covered+=Qt.executed?1:0}else rt.total+=1,rt.covered+=$t.executed?1:0;const ft=new Si(K,Oe,xe.total>0?xe:void 0,rt.total>0?rt:void 0);return ft.detailedCoverage=ge,ft}constructor(K,ge,Oe,xe){this.uri=K,this.statementCoverage=ge,this.branchCoverage=Oe,this.declarationCoverage=xe}}e.$wO=Si;class Ln{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,ge,Oe=[]){this.executed=K,this.location=ge,this.branches=Oe}}e.$xO=Ln;class Nn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,ge,Oe){this.executed=K,this.location=ge,this.label=Oe}}e.$yO=Nn;class On{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,ge,Oe){this.name=K,this.executed=ge,this.location=Oe}}e.$zO=On;var bn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var wn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var vn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class Tn{constructor(K,ge,Oe,xe,rt,ft){this.kind=K,this.name=ge,this.detail=Oe,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$AO=Tn;class Fn{constructor(K){this.uri=K}}e.$BO=Fn;class jn{constructor(K,ge){this.original=K,this.modified=ge}}e.$CO=jn;class zn{constructor(K,ge,Oe,xe){this.base=K,this.input1=ge,this.input2=Oe,this.result=xe}}e.$DO=zn;class Bn{constructor(K,ge){this.uri=K,this.viewType=ge}}e.$EO=Bn;class Un{constructor(K){this.viewType=K}}e.$FO=Un;class Wn{constructor(K,ge){this.uri=K,this.notebookType=ge}}e.$GO=Wn;class qn{constructor(K,ge,Oe){this.original=K,this.modified=ge,this.notebookType=Oe}}e.$HO=qn;class Vn{constructor(){}}e.$IO=Vn;class Kn{constructor(K,ge){this.uri=K,this.inputBoxUri=ge}}e.$JO=Kn;class Hn{constructor(){}}e.$KO=Hn;class Gn{constructor(K){this.textDiffs=K}}e.$LO=Gn;var yn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Jn{constructor(K,ge){this.label=K,this.values=ge}}e.$MO=Jn;var Sn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var Dn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Qn{constructor(K){this.value=typeof K=="string"?new ze(K):K}}e.$NO=Qn;class Xn{constructor(K,ge){this.value=typeof K=="string"?new ze(K):K,this.vulnerabilities=ge}}e.$OO=Xn;class Zn{constructor(K,ge){this.participant=K,this.command=ge}}e.$PO=Zn;class Yn{constructor(K,ge){this.value=K,this.baseUri=ge}}e.$QO=Yn;class xn{constructor(K,ge){this.value=K,this.title=ge}}e.$RO=xn;class _n{constructor(K){this.value=K}}e.$SO=_n;class er{constructor(K){this.value=K}}e.$TO=er;class tr{constructor(K){this.value=K}}e.$UO=tr;class ir{constructor(K,ge){this.uri=K,this.edits=Array.isArray(ge)?ge:[ge]}}e.$VO=ir;class nr{constructor(K,ge,Oe,xe){this.prompt=K,this.command=ge,this.variables=Oe,this.participant=xe}}e.$WO=nr;class rr{constructor(K,ge,Oe,xe){this.response=K,this.result=ge,this.participant=Oe,this.command=xe}}e.$XO=rr;var Cn;(function(H){H[H.Panel=1]="Panel",H[H.Terminal=2]="Terminal",H[H.Notebook=3]="Notebook",H[H.Editor=4]="Editor"})(Cn||(e.ChatLocation=Cn={}));class sr{constructor(K){this.content=K}}e.$YO=sr;class or{constructor(K,ge){this.content=K,this.name=ge}}e.$ZO=or;class ar{constructor(K,ge){this.content=K,this.name=ge}}e.$1O=ar;class Ai extends Error{static NotFound(K){return new Ai(K,Ai.NotFound.name)}static NoPermissions(K){return new Ai(K,Ai.NoPermissions.name)}constructor(K,ge,Oe){super(K,{cause:Oe}),this.name="LanguageModelError",this.code=ge??""}}e.$2O=Ai;var Pn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var In;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped",H[H.Error=5]="Error"})(In||(e.SpeechToTextStatus=In={}));var An;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class cr{constructor(K,ge){this.text=K,this.range=ge}}e.$3O=cr;var Rn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(ke[324],Ee([1,0,6,7]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(l.$PM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const S=this.a.get(M);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(b,$)??[]}getRelatedInformation(M,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(M,b,$){const S=this.b;return this.b++,this.a.set(S,$),this.c.$registerAiRelatedInformationProvider(S,b),new N.$RM(()=>{this.c.$unregisterAiRelatedInformationProvider(S),this.a.delete(S)})}}e.$ekc=L}),define(ke[120],Ee([1,0,4,6,7,25,145,5,20]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0,e.$pkc=(0,b.$qi)("IExtHostAuthentication");let S=class{constructor(m){this.b=new Map,this.c=new l.$be,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=m.getProxy(N.$PM.MainThreadAuthentication)}async getSession(m,E,v,u={}){const f=R.$Lm.toKey(m.identifier),a=[...v].sort().join(" ");return await this.d.getOrCreate(`${f} ${E} ${a}`,async()=>{await this.a.$ensureProvider(E);const n=m.displayName||m.name;return this.a.$getSession(E,v,f,n,u)})}async getSessions(m,E,v){const u=R.$Lm.toKey(m.identifier),f=[...v].sort().join(" ");return await this.f.getOrCreate(`${u} ${f}`,async()=>{await this.a.$ensureProvider(E);const a=m.displayName||m.name;return this.a.$getSessions(E,v,u,a)})}async removeSession(m,E){const v=this.b.get(m);return v?v.provider.removeSession(E):this.a.$removeSession(m,E)}registerAuthenticationProvider(m,E,v,u){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:E,provider:v,options:u??{supportsMultipleAccounts:!1}});const f=v.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(m,a));return this.a.$registerAuthenticationProvider(m,E,u?.supportsMultipleAccounts??!1),new L.$RM(()=>{f.dispose(),this.b.delete(m),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,E,v){const u=this.b.get(m);if(u)return Promise.resolve(u.provider.createSession(E,v));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,E){const v=this.b.get(m);if(v)return Promise.resolve(v.provider.removeSession(E));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,E){const v=this.b.get(m);if(v)return Promise.resolve(v.provider.getSessions(E));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,E){return m.startsWith(M.$RL)||this.c.fire({provider:{id:m,label:E}}),Promise.resolve()}};e.$qkc=S,e.$qkc=S=Je([qe(0,$.$cP)],S);class A{constructor(){this.a=new Map}getOrCreate(m,E){const v=this.a.get(m);if(v)return v;const u=E().finally(()=>this.a.delete(m));return this.a.set(m,u),u}}}),define(ke[151],Ee([1,0,2,6,7,5,20,12,19,14,17,26]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=e.$plc=void 0;let E=class{static{m=this}static{this.c=0}static{this.d=250}constructor(u,f){this.h=f,this.f=new Map,this.g=u.getProxy(N.$PM.MainThreadDecorations)}registerFileDecorationProvider(u,f){const a=m.c++;this.f.set(a,{provider:u,extensionDescription:f}),this.g.$registerDecorationProvider(a,f.identifier.value);const n=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(a,null);return}const s=(0,$.$3b)(i);if(s.length<=m.d){this.g.$onDidChange(a,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,s.length);const o=s.map(h=>({uri:h,rank:(0,S.$9e)(h.path,"/")})),t=(0,$.$zb)(o,(h,c)=>h.rank-c.rank||(0,S.$mf)(h.uri.path,c.uri.path)),g=[];e:for(const h of t){let c;for(const r of h){const w=(0,A.$nc)(r.uri.path);if(c!==w&&(c=w,g.push(r.uri)>=m.d))break e}}this.g.$onDidChange(a,g)});return new L.$RM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(u,f,a){if(!this.f.has(u))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(u);return await Promise.all(f.map(async o=>{try{const{uri:t,id:g}=o,h=await Promise.resolve(i.provideFileDecoration(l.URI.revive(t),a));if(!h)return;try{L.$eO.validate(h),h.badge&&typeof h.badge!="string"&&(0,C.$yG)(s,"codiconDecoration"),n[g]=[h.propagate,h.tooltip,h.badge,h.color]}catch(c){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),n}};e.$plc=E,e.$plc=E=m=Je([qe(0,M.$cP),qe(1,b.$Wj)],E),e.$qlc=(0,R.$qi)("IExtHostDecorations")}),define(ke[325],Ee([1,0,13,2,7,6,15,22,14]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;class S{static{this.a=0}constructor(C,m,E){this.d=m,this.e=E,this.b=new Map,this.c=C.getProxy(R.$PM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(M.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const E=S.a++;this.b.set(E,m),this.c.$registerTextContentProvider(E,C);let v;if(typeof m.onDidChange=="function"){let u;v=m.onDidChange(async f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;u&&await u;const a=this.$provideTextDocumentContent(E,f).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(f);if(!i)return;const s=(0,$.$gf)(n);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(f,n)}).catch(l.$1).finally(()=>{u===a&&(u=void 0)});u=a})}return new L.$RM(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(C,m){const E=this.b.get(C);return E?Promise.resolve(E.provideTextDocumentContent(N.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$slc=S}),define(ke[152],Ee([1,0,62,15,14,183,129,7,19]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0,e.$eP=A;const S=new Map;function A(v,u){u?S.set(v,u):S.delete(v)}function C(v){return S.get(v)}class m extends R.$Pv{constructor(u,f,a,n,i,s,o){super(f,a,n,i),this.c=u,this.m=s,this.q=o,this.b=!1}dispose(){(0,l.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,$.$ub)(this.f,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.d},get fileName(){return u.d.fsPath},get isUntitled(){return u.d.scheme===N.Schemas.untitled},get languageId(){return u.m},get version(){return u.h},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(f){return f?u.s(f):u.getText()},get eol(){return u.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return u.f.length},lineAt(f){return u.t(f)},offsetAt(f){return u.u(f)},positionAt(f){return u.v(f)},validateRange(f){return u.w(f)},validatePosition(f){return u.x(f)},getWordRangeAtPosition(f,a){return u.y(f,a)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,l.ok)(!this.b),this.m=u}_acceptIsDirty(u){(0,l.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(u){const f=this.w(u);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const a=this.g,n=f.start.line,i=f.end.line,s=[];s.push(this.f[n].substring(f.start.character));for(let o=n+1;o<i;o++)s.push(this.f[o]);return s.push(this.f[i].substring(0,f.end.character)),s.join(a)}t(u){let f;if(u instanceof b.$SM?f=u.line:typeof u=="number"&&(f=u),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new E(f,this.f[f],f===this.f.length-1)}u(u){return u=this.x(u),this.l(),this.j.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.l();const f=this.j.getIndexOf(u),a=this.f[f.index].length;return new b.$SM(f.index,Math.min(f.remainder,a))}w(u){if(!(u instanceof b.$TM))throw new Error("Invalid argument");const f=this.x(u.start),a=this.x(u.end);return f===u.start&&a===u.end?u:new b.$TM(f.line,f.character,a.line,a.character)}x(u){if(!(u instanceof b.$SM))throw new Error("Invalid argument");if(this.f.length===0)return u.with(0,0);let{line:f,character:a}=u,n=!1;if(f<0)f=0,a=0,n=!0;else if(f>=this.f.length)f=this.f.length-1,a=this.f[f].length,n=!0;else{const i=this.f[f].length;a<0?(a=0,n=!0):a>i&&(a=i,n=!0)}return n?new b.$SM(f,a):u}y(u,f){const a=this.x(u);if(!f)f=C(this.m);else if((0,L.$ff)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const n=(0,M.$Zs)(a.character+1,(0,M.$Xs)(f),this.f[a.line],0);if(n)return new b.$TM(a.line,n.startColumn-1,a.line,n.endColumn-1)}}e.$fP=m;class E{constructor(u,f,a){this.a=u,this.b=f,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$TM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$TM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$gP=E}),define(ke[326],Ee([1,0,6,7]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(l.$PM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const S=this.a.get(M);if(!S)throw new Error("Embedding vector provider not found");const A=await S.provideEmbeddingVector(b,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,b,$){const S=this.b;return this.b++,this.a.set(S,$),this.c.$registerAiEmbeddingVectorProvider(b,S),new N.$RM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(S),this.a.delete(S)})}}e.$ulc=L}),define(ke[69],Ee([1,0,6,32,7,21,5,20,60,3,8,23,15]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=e.$Fkc=void 0;let v=E=class{constructor(f,a){this.b=new Map,this.c=new A.$zh,this.a=f.getProxy(l.$PM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let s;const o=n.b.get(i.scheme);return o?(await n.a.$ensureActivation(i.scheme),s=await o.impl.stat(i)):s=await n.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===N.FilePermission.Readonly?1:void 0}}catch(s){E.e(s)}},async readDirectory(i){try{const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(s){return E.e(s)}},async createDirectory(i){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,i)):await n.a.$mkdir(i)}catch(s){return E.e(s)}},async readFile(i){try{const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(s){return E.e(s)}},async writeFile(i,s){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(o.impl,o.extUri,o.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(o.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Ce.wrap(s))}catch(o){return E.e(o)}},async delete(i,s){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly&&!s?.useTrash?(await n.a.$ensureActivation(i.scheme),await o.impl.delete(i,{recursive:!1,...s})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(o){return E.e(o)}},async rename(i,s,o){try{return await n.a.$rename(i,s,{overwrite:!1,...o})}catch(t){return E.e(t)}},async copy(i,s,o){try{return await n.a.$copy(i,s,{overwrite:!1,...o})}catch(t){return E.e(t)}},isWritableFileSystem(i){const s=a.getCapabilities(i);if(typeof s=="number")return!(s&2048)}})}async d(f,a,n){const i=[];for(;!a.isEqual(n,a.dirname(n));)try{if(!((await f.stat(n)).type&N.FileType.Directory))throw L.$8N.FileExists(`Unable to create folder '${n.scheme===m.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(N.$al(s)!==N.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(a.basename(n)),n=a.dirname(n)}for(let s=i.length-1;s>=0;s--){n=a.joinPath(n,i[s]);try{await f.createDirectory(n)}catch(o){if(N.$al(o)!==N.FileSystemProviderErrorCode.FileExists)throw o}}}static e(f){if(f instanceof L.$8N)throw f;if(f instanceof N.$9k)switch(f.code){case N.FileSystemProviderErrorCode.FileExists:throw L.$8N.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$8N.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$8N.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$8N.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$8N.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$8N.Unavailable(f.message);default:throw new L.$8N(f.message,f.name)}if(!(f instanceof Error))throw new L.$8N(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw L.$8N.Unavailable(f.message);switch(f.name){case N.FileSystemProviderErrorCode.FileExists:throw L.$8N.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$8N.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$8N.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$8N.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$8N.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$8N.Unavailable(f.message);default:throw new L.$8N(f.message,f.name)}}addFileSystemProvider(f,a,n){return this.b.set(f,{impl:a,extUri:n?.isCaseSensitive?C.$Tg:C.$Vg,isReadonly:!!n?.isReadonly}),(0,S.$Sc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$Tg}};e.$Fkc=v,e.$Fkc=v=E=Je([qe(0,b.$cP),qe(1,$.$jkc)],v),e.$Gkc=(0,M.$qi)("IExtHostConsumerFileSystem")}),define(ke[93],Ee([1,0,5,28,12,69,2]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0,e.$Hkc=(0,l.$qi)("IExtensionStoragePaths");let b=class{constructor(S,A,C){this.d=A,this.f=C,this.a=S.workspace??void 0,this.b=S.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(S){return M.URI.joinPath(this.b.workspaceStorageHome,S)}async h(){if(!this.a)return Promise.resolve(void 0);const S=this.a.id,A=await this.g(S);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(S){if(this.c)return M.URI.joinPath(this.c,S.identifier.value)}globalValue(S){return M.URI.joinPath(this.b.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ikc=b,e.$Ikc=b=Je([qe(0,N.$sP),qe(1,L.$Wj),qe(2,R.$Gkc)],b)}),define(ke[327],Ee([1,0,7,20,4]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;let R=class{constructor(b){this.a=new l.$fO(l.ColorThemeKind.Dark),this.b=new L.$be}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=l.ColorThemeKind.Light;break;case"hcDark":$=l.ColorThemeKind.HighContrast;break;case"hcLight":$=l.ColorThemeKind.HighContrastLight;break;default:$=l.ColorThemeKind.Dark}this.a=new l.$fO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$dmc=R,e.$dmc=R=Je([qe(0,N.$cP)],R)}),define(ke[70],Ee([1,0,22,4,3,229,5,12,88,6,28,20,7]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BCb=e.$ACb=e.TunnelDtoConverter=void 0;class E extends $.$cw{}var v;(function(f){function a(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}f.fromApiTunnel=a;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}f.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$ACb=(0,M.$qi)("IExtHostTunnelService");let u=class extends L.$Uc{constructor(a,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(S.$PM.MainThreadTunnelService)}async openTunnel(a,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,a.displayName);if(i){const s=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,n){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:a,provider:n}),this.a.$registerPortsAttributesProvider(a,i),new m.$RM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(a,n,i,s,o){const t=[];for(const h of a){const c=this.r.get(h);if(!c)return[];t.push(...await Promise.all(n.map(async r=>{let w;try{w=await c.provider.providePortAttributes({port:r,pid:i,commandLine:s},o)}catch{w=await c.provider.providePortAttributes(r,i,s,o)}return{providedAttributes:w,port:r}})))}const g=t.filter(h=>!!h.providedAttributes);return g.length>0?g.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,o)=>await a.provideTunnel(s,o,l.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,n){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const i=a.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let s=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,L.$Sc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,n){if(this.g.has(a.host)){const i=this.g.get(a.host);i.has(a.port)&&(n&&i.get(a.port).disposeListener.dispose(),await i.get(a.port).tunnel.dispose(),i.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(a,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:s,disposeListener:o}),v.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(a){const n=await Promise.all(a.map(s=>this.f(s.host,s.port,s.detail??""))),i=a.filter((s,o)=>n[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$BCb=u,e.$BCb=u=Je([qe(0,C.$cP),qe(1,A.$sP),qe(2,b.$Wj)],u)}),define(ke[16],Ee([1,0,19,21,172,74,80,27,165,58,101,24,167,23,18,2,29,83,138,144,142,291,119,68,89,303,7]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o,t,g,h,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$_O=T,e.$aP=W,e.$bP=X;var w;(function(Le){function je(ee){const{selectionStartLineNumber:Fe,selectionStartColumn:Ke,positionLineNumber:_e,positionColumn:Qe}=ee,lt=new r.$SM(Fe-1,Ke-1),Et=new r.$SM(_e-1,Qe-1);return new r.$UM(lt,Et)}Le.to=je;function ye(ee){const{anchor:Fe,active:Ke}=ee;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Le.from=ye})(w||(e.Selection=w={}));var d;(function(Le){function je(ee){if(!ee)return;const{start:Fe,end:Ke}=ee;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Le.from=je;function ye(ee){if(!ee)return;const{startLineNumber:Fe,startColumn:Ke,endLineNumber:_e,endColumn:Qe}=ee;return new r.$TM(Fe-1,Ke-1,_e-1,Qe-1)}Le.to=ye})(d||(e.Range=d={}));var D;(function(Le){function je(ee){return{uri:ee.uri,range:d.from(ee.range)}}Le.from=je;function ye(ee){return new r.$4M(u.URI.revive(ee.uri),d.to(ee.range))}Le.to=ye})(D||(e.Location=D={}));var p;(function(Le){function je(ye){switch(ye){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Le.to=je})(p||(e.TokenType=p={}));var k;(function(Le){function je(ee){return new r.$SM(ee.lineNumber-1,ee.column-1)}Le.to=je;function ye(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Le.from=ye})(k||(e.Position=k={}));var y;(function(Le){function je(Fe,Ke,_e){return(0,l.$Hb)((0,l.$3b)(Fe).map(Qe=>ye(Qe,Ke,_e)))}Le.from=je;function ye(Fe,Ke,_e){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:_e?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ee(Fe.scheme,Ke),pattern:ce.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:_e?.isBuiltin}}function ee(Fe,Ke){return Ke&&typeof Fe=="string"?Ke.transformOutgoingScheme(Fe):Fe}})(y||(e.DocumentSelector=y={}));var P;(function(Le){function je(ee){switch(ee){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Le.from=je;function ye(ee){switch(ee){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Le.to=ye})(P||(e.DiagnosticTag=P={}));var I;(function(Le){function je(ee){let Fe;return ee.code&&((0,v.$4f)(ee.code)||(0,v.$8f)(ee.code)?Fe=String(ee.code):Fe={value:String(ee.code.value),target:ee.code.target}),{...d.from(ee.range),message:ee.message,source:ee.source,code:Fe,severity:j.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(F.from),tags:Array.isArray(ee.tags)?(0,l.$Hb)(ee.tags.map(P.from)):void 0}}Le.from=je;function ye(ee){const Fe=new r.$6M(d.to(ee),ee.message,j.to(ee.severity));return Fe.source=ee.source,Fe.code=(0,v.$4f)(ee.code)?ee.code:ee.code?.value,Fe.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(F.to),Fe.tags=ee.tags&&(0,l.$Hb)(ee.tags.map(P.to)),Fe}Le.to=ye})(I||(e.Diagnostic=I={}));var F;(function(Le){function je(ee){return{...d.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Le.from=je;function ye(ee){return new r.$5M(new r.$4M(ee.resource,d.to(ee)),ee.message)}Le.to=ye})(F||(e.DiagnosticRelatedInformation=F={}));var j;(function(Le){function je(ee){switch(ee){case r.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Le.from=je;function ye(ee){switch(ee){case n.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Le.to=ye})(j||(e.DiagnosticSeverity=j={}));var z;(function(Le){function je(ee){return typeof ee=="number"&&ee>=r.ViewColumn.One?ee-1:ee===r.ViewColumn.Beside?c.$OD:c.$ND}Le.from=je;function ye(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=ye})(z||(e.ViewColumn=z={}));function O(Le){return typeof Le.range<"u"}function T(Le){return Le.length===0?!0:!!O(Le[0])}var B;(function(Le){function je(Qe){return Qe.map(Le.from)}Le.fromMany=je;function ye(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ee(Qe){let lt;if(ye(Qe)){const{language:ut,value:ri}=Qe;lt={value:"```"+ut+`
`+ri+"\n```\n"}}else r.$gN.isMarkdownString(Qe)?lt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?lt={value:Qe}:lt={value:""};const Et=Object.create(null);lt.uris=Et;const jt=ut=>{try{let ri=u.URI.parse(ut,!0);ri=ri.with({query:Fe(ri.query,Et)}),Et[ut]=ri}catch{}return""},qt=new $.marked.Renderer;return qt.link=jt,qt.image=ut=>typeof ut=="string"?jt(M.$Vk(ut).href):"",(0,$.marked)(lt.value,{renderer:qt}),lt}Le.from=ee;function Fe(Qe,lt){if(!Qe)return Qe;let Et;try{Et=(0,S.$Yh)(Qe)}catch{}if(!Et)return Qe;let jt=!1;return Et=(0,C.$Yn)(Et,qt=>{if(u.URI.isUri(qt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[ut]=qt,jt=!0,ut}else return}),jt?JSON.stringify(Et):Qe}function Ke(Qe){const lt=new r.$gN(Qe.value,Qe.supportThemeIcons);return lt.isTrusted=Qe.isTrusted,lt.supportHtml=Qe.supportHtml,lt.baseUri=Qe.baseUri?u.URI.from(Qe.baseUri):void 0,lt}Le.to=Ke;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Le.from(Qe)}Le.fromStrict=_e})(B||(e.MarkdownString=B={}));function W(Le){return T(Le)?Le.map(je=>({range:d.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?B.fromMany(je.hoverMessage):je.hoverMessage?B.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Le.map(je=>({range:d.from(je)}))}function X(Le){return typeof Le>"u"?Le:typeof Le=="string"?u.URI.file(Le):Le}var x;(function(Le){function je(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?X(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Le.from=je})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var Z;(function(Le){function je(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?X(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?x.from(ye.before):void 0,after:ye.after?x.from(ye.after):void 0}}Le.from=je})(Z||(e.ThemableDecorationRenderOptions=Z={}));var Y;(function(Le){function je(ye){if(typeof ye>"u")return ye;switch(ye){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=je})(Y||(e.DecorationRangeBehavior=Y={}));var ue;(function(Le){function je(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?Y.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?Z.from(ye.light):void 0,dark:ye.dark?Z.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?X(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?x.from(ye.before):void 0,after:ye.after?x.from(ye.after):void 0}}Le.from=je})(ue||(e.DecorationRenderOptions=ue={}));var te;(function(Le){function je(ee){return{text:ee.newText,eol:ee.newEol&&Be.from(ee.newEol),range:d.from(ee.range)}}Le.from=je;function ye(ee){const Fe=new r.$YM(d.to(ee.range),ee.text);return Fe.newEol=typeof ee.eol>"u"?void 0:Be.to(ee.eol),Fe}Le.to=ye})(te||(e.TextEdit=te={}));var we;(function(Le){function je(ee,Fe){const Ke={edits:[]};if(ee instanceof r.$2M){const _e=new b.$Cc;for(const Qe of ee._allEntries())Qe._type===1&&u.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of ee._allEntries())if(Qe._type===1){let lt;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?lt={type:"base64",value:(0,N.$We)(N.$Ce.wrap(Qe.options.contents))}:lt={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ke.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:lt},metadata:Qe.metadata})}else Qe._type===2?Ke.edits.push({resource:Qe.uri,textEdit:te.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Ke.edits.push({resource:Qe.uri,textEdit:{range:d.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(At.from)}})}return Ke}Le.from=je;function ye(ee){const Fe=new r.$2M,Ke=new b.$Bc;for(const _e of ee.edits)if(_e.textEdit){const Qe=_e,lt=u.URI.revive(Qe.resource),Et=d.to(Qe.textEdit.range),jt=Qe.textEdit.text,qt=Qe.textEdit.insertAsSnippet;let ut;qt?ut=r.$1M.replace(Et,new r.$3M(jt)):ut=r.$YM.replace(Et,jt);const ri=Ke.get(lt);ri?ri.push(ut):Ke.set(lt,[ut])}else Fe.renameFile(u.URI.revive(_e.oldResource),u.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of Ke)Fe.set(_e,Qe);return Fe}Le.to=ye})(we||(e.WorkspaceEdit=we={}));var Se;(function(Le){const je=Object.create(null);je[r.SymbolKind.File]=0,je[r.SymbolKind.Module]=1,je[r.SymbolKind.Namespace]=2,je[r.SymbolKind.Package]=3,je[r.SymbolKind.Class]=4,je[r.SymbolKind.Method]=5,je[r.SymbolKind.Property]=6,je[r.SymbolKind.Field]=7,je[r.SymbolKind.Constructor]=8,je[r.SymbolKind.Enum]=9,je[r.SymbolKind.Interface]=10,je[r.SymbolKind.Function]=11,je[r.SymbolKind.Variable]=12,je[r.SymbolKind.Constant]=13,je[r.SymbolKind.String]=14,je[r.SymbolKind.Number]=15,je[r.SymbolKind.Boolean]=16,je[r.SymbolKind.Array]=17,je[r.SymbolKind.Object]=18,je[r.SymbolKind.Key]=19,je[r.SymbolKind.Null]=20,je[r.SymbolKind.EnumMember]=21,je[r.SymbolKind.Struct]=22,je[r.SymbolKind.Event]=23,je[r.SymbolKind.Operator]=24,je[r.SymbolKind.TypeParameter]=25;function ye(Fe){return typeof je[Fe]=="number"?je[Fe]:6}Le.from=ye;function ee(Fe){for(const Ke in je)if(je[Ke]===Fe)return Number(Ke);return r.SymbolKind.Property}Le.to=ee})(Se||(e.SymbolKind=Se={}));var _;(function(Le){function je(ee){switch(ee){case r.SymbolTag.Deprecated:return 1}}Le.from=je;function ye(ee){switch(ee){case 1:return r.SymbolTag.Deprecated}}Le.to=ye})(_||(e.SymbolTag=_={}));var U;(function(Le){function je(ee){return{name:ee.name,kind:Se.from(ee.kind),tags:ee.tags&&ee.tags.map(_.from),containerName:ee.containerName,location:re.from(ee.location)}}Le.from=je;function ye(ee){const Fe=new r.$0M(ee.name,Se.to(ee.kind),ee.containerName,re.to(ee.location));return Fe.tags=ee.tags&&ee.tags.map(_.to),Fe}Le.to=ye})(U||(e.WorkspaceSymbol=U={}));var ne;(function(Le){function je(ee){const Fe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),kind:Se.from(ee.kind),tags:ee.tags?.map(_.from)??[]};return ee.children&&(Fe.children=ee.children.map(je)),Fe}Le.from=je;function ye(ee){const Fe=new r.$$M(ee.name,ee.detail,Se.to(ee.kind),d.to(ee.range),d.to(ee.selectionRange));return(0,l.$Lb)(ee.tags)&&(Fe.tags=ee.tags.map(_.to)),ee.children&&(Fe.children=ee.children.map(ye)),Fe}Le.to=ye})(ne||(e.DocumentSymbol=ne={}));var $e;(function(Le){function je(ee){const Fe=new r.$cN(Se.to(ee.kind),ee.name,ee.detail||"",u.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Le.to=je;function ye(ee,Fe,Ke){if(Fe=Fe??ee._sessionId,Ke=Ke??ee._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,name:ee.name,detail:ee.detail,kind:Se.from(ee.kind),uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(_.from)}}Le.from=ye})($e||(e.CallHierarchyItem=$e={}));var Pe;(function(Le){function je(ye){return new r.$dN($e.to(ye.from),ye.fromRanges.map(ee=>d.to(ee)))}Le.to=je})(Pe||(e.CallHierarchyIncomingCall=Pe={}));var se;(function(Le){function je(ye){return new r.$eN($e.to(ye.to),ye.fromRanges.map(ee=>d.to(ee)))}Le.to=je})(se||(e.CallHierarchyOutgoingCall=se={}));var re;(function(Le){function je(ee){return{range:ee.range&&d.from(ee.range),uri:ee.uri}}Le.from=je;function ye(ee){return new r.$4M(u.URI.revive(ee.uri),d.to(ee.range))}Le.to=ye})(re||(e.location=re={}));var oe;(function(Le){function je(ee){const Fe=ee,Ke=ee;return{originSelectionRange:Fe.originSelectionRange?d.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ke.uri,range:d.from(Fe.targetRange?Fe.targetRange:Ke.range),targetSelectionRange:Fe.targetSelectionRange?d.from(Fe.targetSelectionRange):void 0}}Le.from=je;function ye(ee){return{targetUri:u.URI.revive(ee.uri),targetRange:d.to(ee.range),targetSelectionRange:ee.targetSelectionRange?d.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?d.to(ee.originSelectionRange):void 0}}Le.to=ye})(oe||(e.DefinitionLink=oe={}));var G;(function(Le){function je(ee){return{range:d.from(ee.range),contents:B.fromMany(ee.contents)}}Le.from=je;function ye(ee){return new r.$7M(ee.contents.map(B.to),d.to(ee.range))}Le.to=ye})(G||(e.Hover=G={}));var ie;(function(Le){function je(ee){return{range:d.from(ee.range),expression:ee.expression}}Le.from=je;function ye(ee){return new r.$2N(d.to(ee.range),ee.expression)}Le.to=ye})(ie||(e.EvaluatableExpression=ie={}));var me;(function(Le){function je(ee){if(ee instanceof r.$3N)return{type:"text",range:d.from(ee.range),text:ee.text};if(ee instanceof r.$4N)return{type:"variable",range:d.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof r.$5N)return{type:"expression",range:d.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=je;function ye(ee){switch(ee.type){case"text":return{range:d.to(ee.range),text:ee.text};case"variable":return{range:d.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:d.to(ee.range),expression:ee.expression}}}Le.to=ye})(me||(e.InlineValue=me={}));var be;(function(Le){function je(ee){return{frameId:ee.frameId,stoppedLocation:d.from(ee.stoppedLocation)}}Le.from=je;function ye(ee){return new r.$6N(ee.frameId,d.to(ee.stoppedLocation))}Le.to=ye})(be||(e.InlineValueContext=be={}));var Ae;(function(Le){function je(ee){return{range:d.from(ee.range),kind:ee.kind}}Le.from=je;function ye(ee){return new r.$8M(d.to(ee.range),ee.kind)}Le.to=ye})(Ae||(e.DocumentHighlight=Ae={}));var fe;(function(Le){function je(ee){return{uri:ee.uri,highlights:ee.highlights.map(Ae.from)}}Le.from=je;function ye(ee){return new r.$9M(u.URI.revive(ee.uri),ee.highlights.map(Ae.to))}Le.to=ye})(fe||(e.MultiDocumentHighlight=fe={}));var De;(function(Le){function je(ye){switch(ye){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Le.to=je})(De||(e.CompletionTriggerKind=De={}));var Ie;(function(Le){function je(ye){return{triggerKind:De.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Le.to=je})(Ie||(e.CompletionContext=Ie={}));var Te;(function(Le){function je(ee){switch(ee){case r.CompletionItemTag.Deprecated:return 1}}Le.from=je;function ye(ee){switch(ee){case 1:return r.CompletionItemTag.Deprecated}}Le.to=ye})(Te||(e.CompletionItemTag=Te={}));var q;(function(Le){const je=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function ye(Ke){return je.get(Ke)??9}Le.from=ye;const ee=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Fe(Ke){return ee.get(Ke)??r.CompletionItemKind.Property}Le.to=Fe})(q||(e.CompletionItemKind=q={}));var V;(function(Le){function je(ye,ee){const Fe=new r.$mN(ye.label);return Fe.insertText=ye.insertText,Fe.kind=q.to(ye.kind),Fe.tags=ye.tags?.map(Te.to),Fe.detail=ye.detail,Fe.documentation=M.$Pk(ye.documentation)?B.to(ye.documentation):ye.documentation,Fe.sortText=ye.sortText,Fe.filterText=ye.filterText,Fe.preselect=ye.preselect,Fe.commitCharacters=ye.commitCharacters,f.$kt.isIRange(ye.range)?Fe.range=d.to(ye.range):typeof ye.range=="object"&&(Fe.range={inserting:d.to(ye.range.insert),replacing:d.to(ye.range.replace)}),Fe.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Fe.insertText=new r.$3M(ye.insertText):(Fe.insertText=ye.insertText,Fe.textEdit=Fe.range instanceof r.$TM?new r.$YM(Fe.range,Fe.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ye.additionalTextEdits.map(Ke=>te.to(Ke))),Fe.command=ee&&ye.command?ee.fromInternal(ye.command):void 0,Fe}Le.to=je})(V||(e.CompletionItem=V={}));var J;(function(Le){function je(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:B.fromStrict(ee.documentation)}}Le.from=je;function ye(ee){return{label:ee.label,documentation:M.$Pk(ee.documentation)?B.to(ee.documentation):ee.documentation}}Le.to=ye})(J||(e.ParameterInformation=J={}));var Q;(function(Le){function je(ee){return{label:ee.label,documentation:B.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.from):[],activeParameter:ee.activeParameter}}Le.from=je;function ye(ee){return{label:ee.label,documentation:M.$Pk(ee.documentation)?B.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.to):[],activeParameter:ee.activeParameter}}Le.to=ye})(Q||(e.SignatureInformation=Q={}));var he;(function(Le){function je(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Q.from):[]}}Le.from=je;function ye(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Q.to):[]}}Le.to=ye})(he||(e.SignatureHelp=he={}));var pe;(function(Le){function je(ye,ee){const Fe=new r.$lN(k.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(ze.to.bind(void 0,ye)),ee.kind&&Ve.to(ee.kind));return Fe.textEdits=ee.textEdits&&ee.textEdits.map(te.to),Fe.tooltip=M.$Pk(ee.tooltip)?B.to(ee.tooltip):ee.tooltip,Fe.paddingLeft=ee.paddingLeft,Fe.paddingRight=ee.paddingRight,Fe}Le.to=je})(pe||(e.InlayHint=pe={}));var ze;(function(Le){function je(ye,ee){const Fe=new r.$kN(ee.label);return Fe.tooltip=M.$Pk(ee.tooltip)?B.to(ee.tooltip):ee.tooltip,a.Command.is(ee.command)&&(Fe.command=ye.fromInternal(ee.command)),ee.location&&(Fe.location=re.to(ee.location)),Fe}Le.to=je})(ze||(e.InlayHintLabelPart=ze={}));var Ve;(function(Le){function je(ee){return ee}Le.from=je;function ye(ee){return ee}Le.to=ye})(Ve||(e.InlayHintKind=Ve={}));var Ze;(function(Le){function je(ee){return{range:d.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Le.from=je;function ye(ee){let Fe;if(ee.url)try{Fe=typeof ee.url=="string"?u.URI.parse(ee.url,!0):u.URI.revive(ee.url)}catch{}return new r.$rN(d.to(ee.range),Fe)}Le.to=ye})(Ze||(e.DocumentLink=Ze={}));var it;(function(Le){function je(ee){const Fe=new r.$uN(ee.label);return ee.textEdit&&(Fe.textEdit=te.to(ee.textEdit)),ee.additionalTextEdits&&(Fe.additionalTextEdits=ee.additionalTextEdits.map(Ke=>te.to(Ke))),Fe}Le.to=je;function ye(ee){return{label:ee.label,textEdit:ee.textEdit?te.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Fe=>te.from(Fe)):void 0}}Le.from=ye})(it||(e.ColorPresentation=it={}));var ot;(function(Le){function je(ee){return new r.$sN(ee[0],ee[1],ee[2],ee[3])}Le.to=je;function ye(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Le.from=ye})(ot||(e.Color=ot={}));var nt;(function(Le){function je(ee){return{range:d.from(ee.range)}}Le.from=je;function ye(ee){return new r.$bN(d.to(ee.range))}Le.to=ye})(nt||(e.SelectionRange=nt={}));var st;(function(Le){function je(ye){switch(ye){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Le.to=je})(st||(e.TextDocumentSaveReason=st={}));var Ce;(function(Le){function je(ee){switch(ee){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.Interval:return 3;case r.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=je;function ye(ee){switch(ee){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 3:return r.TextEditorLineNumbersStyle.Interval;case 1:default:return r.TextEditorLineNumbersStyle.On}}Le.to=ye})(Ce||(e.TextEditorLineNumbersStyle=Ce={}));var Be;(function(Le){function je(ee){if(ee===r.EndOfLine.CRLF)return 1;if(ee===r.EndOfLine.LF)return 0}Le.from=je;function ye(ee){if(ee===1)return r.EndOfLine.CRLF;if(ee===0)return r.EndOfLine.LF}Le.to=ye})(Be||(e.EndOfLine=Be={}));var He;(function(Le){function je(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=je})(He||(e.ProgressLocation=He={}));var Ne;(function(Le){function je(ee){const Fe={start:ee.start+1,end:ee.end+1};return ee.kind&&(Fe.kind=Xe.from(ee.kind)),Fe}Le.from=je;function ye(ee){const Fe={start:ee.start-1,end:ee.end-1};return ee.kind&&(Fe.kind=Xe.to(ee.kind)),Fe}Le.to=ye})(Ne||(e.FoldingRange=Ne={}));var Xe;(function(Le){function je(ee){if(ee)switch(ee){case r.FoldingRangeKind.Comment:return a.$6t.Comment;case r.FoldingRangeKind.Imports:return a.$6t.Imports;case r.FoldingRangeKind.Region:return a.$6t.Region}}Le.from=je;function ye(ee){if(ee)switch(ee.value){case a.$6t.Comment.value:return r.FoldingRangeKind.Comment;case a.$6t.Imports.value:return r.FoldingRangeKind.Imports;case a.$6t.Region.value:return r.FoldingRangeKind.Region}}Le.to=ye})(Xe||(e.FoldingRangeKind=Xe={}));var ae;(function(Le){function je(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?d.from(ye.selection):void 0,override:typeof ye.override=="boolean"?s.$eF.id:void 0}}Le.from=je})(ae||(e.TextEditorOpenOptions=ae={}));var ce;(function(Le){function je(Ke){return Ke instanceof r.$PN?Ke.toJSON():typeof Ke=="string"?Ke:ye(Ke)||ee(Ke)?new r.$PN(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Le.from=je;function ye(Ke){const _e=Ke;return _e?u.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(Ke){const _e=Ke;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Fe(Ke){return typeof Ke=="string"?Ke:new r.$PN(u.URI.revive(Ke.baseUri),Ke.pattern)}Le.to=Fe})(ce||(e.GlobPattern=ce={}));var Re;(function(Le){function je(ye){if(ye){if(Array.isArray(ye))return ye.map(je);if(typeof ye=="string")return ye;{const ee=ye;return{language:ee.language,scheme:ee.scheme,pattern:ce.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Le.from=je})(Re||(e.LanguageSelector=Re={}));var Ge;(function(Le){function je(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&u.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(_e=>_e instanceof r.$TM)))}Le.is=je;function ye(ee){return{documents:ee.documents.map(Fe=>Fe.map(Ke=>({uri:u.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(_e=>d.from(_e))})))}}Le.from=ye})(Ge||(e.MappedEditsContext=Ge={}));var Me;(function(Le){function je(ee){return{start:ee.start,end:ee.end}}Le.from=je;function ye(ee){return new r.$gO(ee.start,ee.end)}Le.to=ye})(Me||(e.NotebookRange=Me={}));var tt;(function(Le){function je(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Le.to=je;function ye(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Le.from=ye})(tt||(e.NotebookCellExecutionSummary=tt={}));var ht;(function(Le){function je(ye){if(ye===t.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(ye===t.NotebookCellExecutionState.Pending)return;if(ye===t.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Le.to=je})(ht||(e.NotebookCellExecutionState=ht={}));var wt;(function(Le){function je(ee){switch(ee){case r.NotebookCellKind.Markup:return t.CellKind.Markup;case r.NotebookCellKind.Code:default:return t.CellKind.Code}}Le.from=je;function ye(ee){switch(ee){case t.CellKind.Markup:return r.NotebookCellKind.Markup;case t.CellKind.Code:default:return r.NotebookCellKind.Code}}Le.to=ye})(wt||(e.NotebookCellKind=wt={}));var Lt;(function(Le){function je(ee){const Fe={metadata:ee.metadata??Object.create(null),cells:[]};for(const Ke of ee.cells)r.$hO.validate(Ke),Fe.cells.push(At.from(Ke));return Fe}Le.from=je;function ye(ee){const Fe=new r.$iO(ee.cells.map(At.to));return(0,v.$eg)(ee.metadata)||(Fe.metadata=ee.metadata),Fe}Le.to=ye})(Lt||(e.NotebookData=Lt={}));var At;(function(Le){function je(ee){return{cellKind:wt.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:tt.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(_t.from):[]}}Le.from=je;function ye(ee){return new r.$hO(wt.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(_t.to):void 0,ee.metadata,ee.internalMetadata?tt.to(ee.internalMetadata):void 0)}Le.to=ye})(At||(e.NotebookCellData=At={}));var xt;(function(Le){function je(ee){return{mime:ee.mime,valueBytes:N.$Ce.wrap(ee.data)}}Le.from=je;function ye(ee){return new r.$jO(ee.valueBytes.buffer,ee.mime)}Le.to=ye})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(Le){function je(ee){return{outputId:ee.id,items:ee.items.map(xt.from),metadata:ee.metadata}}Le.from=je;function ye(ee){const Fe=ee.items.map(xt.to);return new r.$kO(Fe,ee.outputId,ee.metadata)}Le.to=ye})(_t||(e.NotebookCellOutput=_t={}));var Pt;(function(Le){function je(Fe){return ee(Fe)?{include:ce.from(Fe.include)??void 0,exclude:ce.from(Fe.exclude)??void 0}:ce.from(Fe)??void 0}Le.from=je;function ye(Fe){return ee(Fe)?{include:ce.to(Fe.include),exclude:ce.to(Fe.exclude)}:ce.to(Fe)}Le.to=ye;function ee(Fe){const Ke=Fe;return Ke?!(0,v.$ag)(Ke.include)&&!(0,v.$ag)(Ke.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var Vt;(function(Le){function je(ye,ee,Fe){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(Ke,Fe),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Le.from=je})(Vt||(e.NotebookStatusBarItem=Vt={}));var Xt;(function(Le){function je(ye,ee,Fe){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:ee.toInternal(Ke,Fe),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Le.from=je})(Xt||(e.NotebookKernelSourceAction=Xt={}));var et;(function(Le){function je(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Le.from=je})(et||(e.NotebookDocumentContentOptions=et={}));var si;(function(Le){function je(ee){return{uri:ee.uri,provides:ee.provides}}Le.from=je;function ye(ee){return new r.$mO(u.URI.revive(ee.uri),ee.provides)}Le.to=ye})(si||(e.NotebookRendererScript=si={}));var Zt;(function(Le){function je(ee){return{message:B.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:d.from(ee.location.range),uri:ee.location.uri}}}Le.from=je;function ye(ee){const Fe=new r.$sO(typeof ee.message=="string"?ee.message:B.to(ee.message));return Fe.actualOutput=ee.actual,Fe.expectedOutput=ee.expected,Fe.contextValue=ee.contextValue,Fe.location=ee.location?re.to(ee.location):void 0,Fe}Le.to=ye})(Zt||(e.TestMessage=Zt={}));var dt;(function(Le){Le.namespace=h.$GL,Le.denamespace=h.$HL})(dt||(e.TestTag=dt={}));var vt;(function(Le){function je(ee){const Fe=(0,i.$$O)(ee).controllerId;return{extId:g.$BL.fromExtHostTestItem(ee,Fe).toString(),label:ee.label,uri:u.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(Ke=>dt.namespace(Fe,Ke.id)),range:f.$kt.lift(d.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&B.fromStrict(ee.error)||null}}Le.from=je;function ye(ee){return{parent:void 0,error:void 0,id:g.$BL.fromString(ee.extId).localId,label:ee.label,uri:u.URI.revive(ee.uri),tags:(ee.tags||[]).map(Fe=>{const{tagId:Ke}=dt.denamespace(Fe);return new r.$tO(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Le.toPlain=ye})(vt||(e.TestItem=vt={})),function(Le){function je(ee){return{id:ee.id}}Le.from=je;function ye(ee){return new r.$tO(ee.id)}Le.to=ye}(dt||(e.TestTag=dt={}));var ti;(function(Le){const je=(ee,Fe)=>{const Ke=ee.value;if(!Ke)return;const _e={...vt.toPlain(Ke.item),parent:Fe,taskStates:Ke.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(lt=>lt.type===0).map(Zt.to)})),children:[]};if(ee.children)for(const Qe of ee.children.values()){const lt=je(Qe,_e);lt&&_e.children.push(lt)}return _e};function ye(ee){const Fe=new m.$4O;for(const Qe of ee.items)Fe.insert(g.$BL.fromString(Qe.item.extId).path,Qe);const Ke=[Fe.nodes],_e=[];for(;Ke.length;)for(const Qe of Ke.pop())Qe.value?_e.push(Qe):Qe.children&&Ke.push(Qe.children.values());return{completedAt:ee.completedAt,results:_e.map(Qe=>je(Qe)).filter(v.$_f)}}Le.to=ye})(ti||(e.TestResults=ti={}));var Yt;(function(Le){function je(Ke){return{covered:Ke.covered,total:Ke.total}}function ye(Ke){return"line"in Ke?k.from(Ke):d.from(Ke)}function ee(Ke){if(typeof Ke.executed=="number"&&Ke.executed<0)throw new Error(`Invalid coverage count ${Ke.executed}`);return"branches"in Ke?{count:Ke.executed,location:ye(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(_e=>({count:_e.executed,location:_e.location&&ye(_e.location),label:_e.label})):void 0}:{type:0,name:Ke.name,count:Ke.executed,location:ye(Ke.location)}}Le.fromDetails=ee;function Fe(Ke,_e){return r.$vO(_e.statementCoverage),r.$vO(_e.branchCoverage),r.$vO(_e.declarationCoverage),{id:Ke,uri:_e.uri,statement:je(_e.statementCoverage),branch:_e.branchCoverage&&je(_e.branchCoverage),declaration:_e.declarationCoverage&&je(_e.declarationCoverage)}}Le.fromFile=Fe})(Yt||(e.TestCoverage=Yt={}));var zt;(function(Le){function je(ye){switch(ye){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Le.to=je})(zt||(e.CodeActionTriggerKind=zt={}));var gt;(function(Le){function je(ee){const Fe=new r.$AO(Se.to(ee.kind),ee.name,ee.detail||"",u.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Le.to=je;function ye(ee,Fe,Ke){if(Fe=Fe??ee._sessionId,Ke=Ke??ee._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,kind:Se.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(_.from)}}Le.from=ye})(gt||(e.TypeHierarchyItem=gt={}));var Ut;(function(Le){function je(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Le.from=je})(Ut||(e.ViewBadge=Ut={}));var Wt;(function(Le){function je(Ke,_e,Qe){const lt=_e.fileData;return lt?new r.$HN(new r.$IN(lt.name,u.URI.revive(lt.uri),lt.id,(0,R.$db)(()=>Qe(lt.id)))):Ke===A.$Hs.uriList&&_e.uriListData?new r.$GN(Fe(_e.uriListData)):new r.$GN(_e.asString)}Le.to=je;async function ye(Ke,_e){const Qe=await _e.asString();if(Ke===A.$Hs.uriList)return{asString:Qe,fileData:void 0,uriListData:ee(Qe)};const lt=_e.asFile();return{asString:Qe,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}Le.from=ye;function ee(Ke){return L.$Kt.split(Ke).map(_e=>{if(_e.startsWith("#"))return _e;try{return u.URI.parse(_e)}catch{}return _e})}function Fe(Ke){return L.$Kt.create(Ke.map(_e=>typeof _e=="string"?_e:u.URI.revive(_e)))}})(Wt||(e.DataTransferItem=Wt={}));var Kt;(function(Le){function je(ee,Fe){const Ke=ee.items.map(([_e,Qe])=>[_e,Wt.to(_e,Qe,Fe)]);return new r.$JN(Ke)}Le.toDataTransfer=je;async function ye(ee){const Fe={items:[]},Ke=[];for(const[_e,Qe]of ee)Ke.push((async()=>{Fe.items.push([_e,await Wt.from(_e,Qe)])})());return await Promise.all(Ke),Fe}Le.from=ye})(Kt||(e.DataTransfer=Kt={}));var Ye;(function(Le){function je(ee,Fe){return{kind:"reply",agentId:ee.participant??Fe?.agentId??"",subCommand:ee.command??Fe?.command,message:ee.prompt,title:ee.label}}Le.from=je;function ye(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Le.to=ye})(Ye||(e.ChatFollowup=Ye={}));var ui;(function(Le){function je(ye){return"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",when:ye.when??"",args:ye.args}:{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Le.from=je})(ui||(e.ChatInlineFollowup=ui={}));var Ht;(function(Le){function je(ee){switch(ee.role){case 0:return new r.$YO(ee.content);case 1:return new r.$ZO(ee.content);case 2:return new r.$1O(ee.content)}}Le.to=je;function ye(ee){if(ee instanceof r.$YO)return{role:0,content:ee.content};if(ee instanceof r.$ZO)return{role:1,content:ee.content};if(ee instanceof r.$1O)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Le.from=ye})(Ht||(e.LanguageModelMessage=Ht={}));var Bt;(function(Le){function je(Fe){const Ke={};for(const _e of Object.keys(Fe))Ke[_e]=Fe[_e].map(Le.to);return Ke}Le.objectTo=je;function ye(Fe){return{level:mt.to(Fe.level),kind:Fe.kind,value:(0,u.$wc)(Fe.value)?u.URI.revive(Fe.value):Fe.value,description:Fe.description}}Le.to=ye;function ee(Fe){return{level:mt.from(Fe.level),kind:Fe.kind,value:Fe.value,description:Fe.description}}Le.from=ee})(Bt||(e.ChatVariable=Bt={}));var mt;(function(Le){function je(ee){switch(ee){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Le.to=je;function ye(ee){switch(ee){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Le.from=ye})(mt||(e.ChatVariableLevel=mt={}));var Tt;(function(Le){function je(ye){switch(ye){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Le.to=je})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var Rt;(function(Le){function je(ee){return{kind:"markdownContent",content:B.from(ee.value)}}Le.from=je;function ye(ee){return new r.$NO(B.to(ee.content))}Le.to=ye})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var Ft;(function(Le){function je(ee){return{kind:"markdownVuln",content:B.from(ee.value),vulnerabilities:ee.vulnerabilities}}Le.from=je;function ye(ee){return new r.$OO(B.to(ee.content),ee.vulnerabilities)}Le.to=ye})(Ft||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ft={}));var ii;(function(Le){function je(ee){return{kind:"agentDetection",agentId:ee.participant,command:ee.command}}Le.from=je;function ye(ee){return new r.$PO(ee.agentId,ee.command)}Le.to=ye})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Gt;(function(Le){function je(ee){const{value:Fe,baseUri:Ke}=ee;function _e(Qe,lt){return Qe.map(Et=>{const jt=u.URI.joinPath(lt,Et.name);return{label:Et.name,uri:jt,children:Et.children&&_e(Et.children,jt)}})}return{kind:"treeData",treeData:{label:(0,E.$1g)(Ke),uri:Ke,children:_e(Fe,Ke)}}}Le.from=je;function ye(ee){const Fe=(0,S.$Zh)(ee.treeData);function Ke(lt){return lt.map(Et=>({name:Et.label,children:Et.children&&Ke(Et.children)}))}const _e=Fe.uri,Qe=Fe.children?Ke(Fe.children):[];return new r.$QO(Qe,_e)}Le.to=ye})(Gt||(e.ChatResponseFilesPart=Gt={}));var ni;(function(Le){function je(ee){return{kind:"inlineReference",name:ee.title,inlineReference:u.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Le.from=je;function ye(ee){const Fe=(0,S.$Zh)(ee);return new r.$RO(u.URI.isUri(Fe.inlineReference)?Fe.inlineReference:D.to(Fe.inlineReference),ee.name)}Le.to=ye})(ni||(e.ChatResponseAnchorPart=ni={}));var Nt;(function(Le){function je(ee){return{kind:"progressMessage",content:B.from(ee.value)}}Le.from=je;function ye(ee){return new r.$SO(ee.content.value)}Le.to=ye})(Nt||(e.ChatResponseProgressPart=Nt={}));var Ot;(function(Le){function je(ee,Fe,Ke){return{kind:"command",command:Fe.toInternal(ee.value,Ke)??{command:ee.value.command,title:ee.value.title}}}Le.from=je;function ye(ee,Fe){return new r.$TO(Fe.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Le.to=ye})(Ot||(e.ChatResponseCommandButtonPart=Ot={}));var It;(function(Le){function je(ee){return{kind:"textEdit",uri:ee.uri,edits:ee.edits.map(Fe=>te.from(Fe))}}Le.from=je;function ye(ee){return new r.$VO(u.URI.revive(ee.uri),ee.edits.map(Fe=>te.to(Fe)))}Le.to=ye})(It||(e.ChatResponseTextEditPart=It={}));var St;(function(Le){function je(ee){return"variableName"in ee.value?{kind:"reference",reference:{variableName:ee.value.variableName,value:u.URI.isUri(ee.value.value)||!ee.value.value?ee.value.value:D.from(ee.value.value)}}:{kind:"reference",reference:u.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Le.from=je;function ye(ee){const Fe=(0,S.$Zh)(ee),Ke=_e=>u.URI.isUri(_e)?_e:D.to(_e);return new r.$UO("variableName"in Fe.reference?{variableName:Fe.reference.variableName,value:Fe.reference.value&&Ke(Fe.reference.value)}:Ke(Fe.reference))}Le.to=ye})(St||(e.ChatResponseReferencePart=St={}));var pt;(function(Le){function je(Fe,Ke,_e){return Fe instanceof r.$NO?Rt.from(Fe):Fe instanceof r.$RO?ni.from(Fe):Fe instanceof r.$UO?St.from(Fe):Fe instanceof r.$SO?Nt.from(Fe):Fe instanceof r.$QO?Gt.from(Fe):Fe instanceof r.$TO?Ot.from(Fe,Ke,_e):Fe instanceof r.$VO?It.from(Fe):Fe instanceof r.$OO?Ft.from(Fe):Fe instanceof r.$PO?ii.from(Fe):{kind:"markdownContent",content:B.from("")}}Le.from=je;function ye(Fe,Ke){switch(Fe.kind){case"reference":return St.to(Fe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Fe,Ke)}}Le.to=ye;function ee(Fe,Ke){switch(Fe.kind){case"markdownContent":return Rt.to(Fe);case"inlineReference":return ni.to(Fe);case"progressMessage":return;case"treeData":return Gt.to(Fe);case"command":return Ot.to(Fe,Ke)}}Le.toContent=ee})(pt||(e.ChatResponsePart=pt={}));var Ct;(function(Le){function je(ye){return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,variables:ye.variables.variables.map(Dt.to),location:li.to(ye.location)}}Le.to=je})(Ct||(e.ChatAgentRequest=Ct={}));var li;(function(Le){function je(ye){switch(ye){case o.ChatAgentLocation.Notebook:return r.ChatLocation.Notebook;case o.ChatAgentLocation.Terminal:return r.ChatLocation.Terminal;case o.ChatAgentLocation.Panel:return r.ChatLocation.Panel;case o.ChatAgentLocation.Editor:return r.ChatLocation.Editor}}Le.to=je})(li||(e.ChatLocation=li={}));var Dt;(function(Le){function je(ye){return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],values:ye.values.map(Bt.to)}}Le.to=je})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var hi;(function(Le){function je(ye){return{label:ye.label,values:ye.values.map(Bt.from),insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation}}Le.from=je})(hi||(e.ChatAgentCompletionItem=hi={}));var Jt;(function(Le){function je(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Le.to=je})(Jt||(e.ChatAgentResult=Jt={}));var wi;(function(Le){function je(ye,ee,Fe){if(ee.action.kind==="vote")return;const Ke=Jt.to(ye);if(ee.action.kind==="command"){const _e=ee.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Fe.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:Ke}}else return ee.action.kind==="followUp"?{action:{kind:"followUp",followup:Ye.to(ee.action.followup)},result:Ke}:ee.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ee.action.action==="accepted"},result:Ke}:{action:ee.action,result:Ke}}Le.to=je})(wi||(e.ChatAgentUserActionEvent=wi={}));var ei;(function(Le){function je(ye,ee,Fe){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:ee.toInternal(ye,Fe)}Le.from=je})(ei||(e.TerminalQuickFix=ei={}));var vi;(function(Le){function je(ye){return{kind:kt.to(ye.kind)}}Le.to=je})(vi||(e.PartialAcceptInfo=vi={}));var kt;(function(Le){function je(ye){switch(ye){case 0:return r.PartialAcceptTriggerKind.Word;case 1:return r.PartialAcceptTriggerKind.Line;case 2:return r.PartialAcceptTriggerKind.Suggest;default:return r.PartialAcceptTriggerKind.Unknown}}Le.to=je})(kt||(e.PartialAcceptTriggerKind=kt={}));var $i;(function(Le){function je(ye,ee){return{id:ee,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Le.from=je})($i||(e.DebugTreeItem=$i={}))}),define(ke[328],Ee([1,0,6,20,16,48]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=void 0;let M=class{constructor($,S){this.a=$.getProxy(l.$PM.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>S.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,S,A){const C=new R.$mw(L.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(C,void 0,A?.isRefactoring??!1)}};e.$rkc=M,e.$rkc=M=Je([qe(0,N.$cP)],M)}),define(ke[329],Ee([1,0,19,8,47,4,39,3,40,18,2,218,25,6,16,7,292,26]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class n{constructor(t,g,h,c,r){this.i=t,this.j=g,this.k=h,this.l=c,this.m=r,this.b=$.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let g=function(c){if(t.c){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,c),r}};const t=this;this.b.reset();const h=c=>{typeof this.d>"u"&&"content"in c&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,c)};this.g={markdown(c){g(this.markdown);const r=new u.$NO(c),w=v.ChatResponseMarkdownPart.from(r);return h(w),this},markdownWithVulnerabilities(c,r){g(this.markdown),r&&(0,a.$yG)(t.i,"chatParticipantAdditions");const w=new u.$OO(c,r),d=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return h(d),this},filetree(c,r){g(this.filetree);const w=new u.$QO(c,r),d=v.ChatResponseFilesPart.from(w);return h(d),this},anchor(c,r){g(this.anchor);const w=new u.$RO(c,r),d=v.ChatResponseAnchorPart.from(w);return h(d),this},button(c){g(this.anchor);const r=new u.$TO(c),w=v.ChatResponseCommandButtonPart.from(r,t.l,t.m);return h(w),this},progress(c){g(this.progress);const r=new u.$SO(c),w=v.ChatResponseProgressPart.from(r);return h(w),this},reference(c){if(g(this.reference),"variableName"in c&&!c.value){const r=t.j.variables.variables.find(w=>w.name===c.variableName);if(r){let w;if(r.references?.length)w=r.references.map(d=>({kind:"reference",reference:{variableName:c.variableName,value:d.reference}}));else{const d=new u.$UO(c);w=[v.ChatResponseReferencePart.from(d)]}return w.forEach(d=>h(d)),this}}else{const r=new u.$UO(c),w=v.ChatResponseReferencePart.from(r);h(w)}return this},textEdit(c,r){g(this.textEdit),(0,a.$yG)(t.i,"chatParticipantAdditions");const w=new u.$VO(c,r),d=v.ChatResponseTextEditPart.from(w);return h(d),this},detectedParticipant(c,r){g(this.detectedParticipant),(0,a.$yG)(t.i,"chatParticipantAdditions");const w=new u.$PO(c,r),d=v.ChatResponseDetectedParticipantPart.from(w);return h(d),this},push(c){if(g(this.push),(c instanceof u.$VO||c instanceof u.$OO||c instanceof u.$PO)&&(0,a.$yG)(t.i,"chatParticipantAdditions"),c instanceof u.$UO)this.reference(c.value);else{const r=v.ChatResponsePart.from(c,t.l,t.m);h(r)}return this}}}return this.g}}class i{static{this.b=0}constructor(t,g,h){this.i=g,this.j=h,this.c=new Map,this.g=new b.$4c,this.d=t.getProxy(E.$PM.MainThreadChatAgents2)}transferActiveChat(t){this.d.$transferActiveChatSession(t)}createChatAgent(t,g,h){const c=i.b++,r=new s(t,g,this.d,c,h);return this.c.set(c,r),this.d.$registerAgent(c,t.identifier,g,{},void 0),r.apiAgent}createDynamicChatAgent(t,g,h,c,r){const w=i.b++,d=new s(t,g,this.d,w,r);return this.c.set(w,d),this.d.$registerAgent(w,t.identifier,g,{isSticky:!0},{name:h,description:c}),d.apiAgent}async $invokeAgent(t,g,h,c){const r=this.c.get(t);if(!r)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let w=this.g.get(g.sessionId);w||(w=new b.$Tc,this.g.set(g.sessionId,w));const d=new n(r.extension,g,this.d,this.j.converter,w);try{const D=await this.k(g.agentId,h),p=r.invoke(v.ChatAgentRequest.to(g),{history:D},d.apiObject,c);return await(0,N.$eh)(Promise.resolve(p).then(k=>{if(k?.metadata)try{JSON.stringify(k.metadata)}catch(y){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${r.extension.identifier.value}] [@${r.id}] ${P}`,r.extension),{errorDetails:{message:P},timings:d.timings}}return{errorDetails:k?.errorDetails,timings:d.timings,metadata:k?.metadata}}),c)}catch(D){return this.i.error(D,r.extension),{errorDetails:{message:(0,C.localize)(0,null,(0,L.$bj)(D)),responseIsIncomplete:!0}}}finally{d.close()}}async k(t,g){const h=[];for(const c of g.history){const r=v.ChatAgentResult.to(c.result),w=t===c.request.agentId?r:{...r,metadata:void 0};h.push(new u.$WO(c.request.message,c.request.command,c.request.variables.variables.map(v.ChatAgentResolvedVariable.to),c.request.agentId));const d=(0,l.$Hb)(c.response.map(D=>v.ChatResponsePart.toContent(D,this.j.converter)));h.push(new u.$XO(d,w,c.request.agentId,c.request.command))}return h}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,g,h,c,r){const w=this.c.get(g);if(!w)return Promise.resolve([]);const d=await this.k(w.id,c),D=v.ChatAgentResult.to(h);return(await w.provideFollowups(D,{history:d},r)).filter(p=>{const k=!p.participant||M.Iterable.some(this.c.values(),y=>y.id===p.participant&&m.$Lm.equals(y.extension.identifier,w.extension.identifier));return k||this.i.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),k}).map(p=>v.ChatFollowup.from(p,t))}$acceptFeedback(t,g,h,c){const r=this.c.get(t);if(!r)return;const w=v.ChatAgentResult.to(g);let d;switch(h){case f.InteractiveSessionVoteDirection.Down:d=u.ChatResultFeedbackKind.Unhelpful;break;case f.InteractiveSessionVoteDirection.Up:d=u.ChatResultFeedbackKind.Helpful;break}r.acceptFeedback(Object.freeze(c?{result:w,kind:d,reportIssue:c}:{result:w,kind:d}))}$acceptAction(t,g,h){const c=this.c.get(t);if(!c||h.action.kind==="vote")return;const r=v.ChatAgentUserActionEvent.to(g,h,this.j.converter);r&&c.acceptAction(Object.freeze(r))}async $invokeCompletionProvider(t,g,h){const c=this.c.get(t);return c?(await c.invokeCompletionProvider(g,h)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,g,h){const c=this.c.get(t);if(c)return await c.provideWelcomeMessage(v.ChatLocation.to(g),h)}async $provideSampleQuestions(t,g,h){const c=this.c.get(t);if(c)return(await c.provideSampleQuestions(v.ChatLocation.to(g),h)).map(r=>v.ChatFollowup.from(r,void 0))}}e.$skc=i;class s{constructor(t,g,h,c,r){this.extension=t,this.id=g,this.u=h,this.w=c,this.x=r,this.n=new R.$be,this.o=new R.$be}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,g){return this.q?await this.q.provider.provideCompletionItems(t,g)??[]:[]}async provideFollowups(t,g,h){if(!this.b)return[];const c=await this.b.provideFollowups(t,g,h);return c?c.filter(r=>!(r&&"commandId"in r)).filter(r=>!(r&&"message"in r)):[]}async provideWelcomeMessage(t,g){if(!this.s)return[];const h=await this.s.provideWelcomeMessage(t,g);return h?h.map(c=>typeof c=="string"?c:v.MarkdownString.from(c)):[]}async provideSampleQuestions(t,g){if(!this.s||!this.s.provideSampleQuestions)return[];const h=await this.s.provideSampleQuestions(t,g);return h||[]}get apiAgent(){let t=!1,g=!1;const h=()=>{t||g||(g=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof u.$NN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:v.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),g=!1}))},c=this;return{get id(){return c.id},get fullName(){return(0,a.$yG)(c.extension,"defaultChatParticipant"),c.c??c.extension.displayName??c.extension.name},set fullName(r){(0,a.$yG)(c.extension,"defaultChatParticipant"),c.c=r,h()},get iconPath(){return c.d},set iconPath(r){c.d=r,h()},get requestHandler(){return c.x},set requestHandler(r){(0,S.$bg)(typeof r=="function","Invalid request handler"),c.x=r},get followupProvider(){return c.b},set followupProvider(r){c.b=r,h()},get isDefault(){return(0,a.$yG)(c.extension,"defaultChatParticipant"),c.g},set isDefault(r){(0,a.$yG)(c.extension,"defaultChatParticipant"),c.g=r,h()},get helpTextPrefix(){return(0,a.$yG)(c.extension,"defaultChatParticipant"),c.i},set helpTextPrefix(r){(0,a.$yG)(c.extension,"defaultChatParticipant"),c.i=r,h()},get helpTextVariablesPrefix(){return(0,a.$yG)(c.extension,"defaultChatParticipant"),c.j},set helpTextVariablesPrefix(r){(0,a.$yG)(c.extension,"defaultChatParticipant"),c.j=r,h()},get helpTextPostfix(){return(0,a.$yG)(c.extension,"defaultChatParticipant"),c.k},set helpTextPostfix(r){(0,a.$yG)(c.extension,"defaultChatParticipant"),c.k=r,h()},get isSecondary(){return(0,a.$yG)(c.extension,"defaultChatParticipant"),c.m},set isSecondary(r){(0,a.$yG)(c.extension,"defaultChatParticipant"),c.m=r,h()},get sampleRequest(){return c.l},set sampleRequest(r){c.l=r,h()},get supportIssueReporting(){return(0,a.$yG)(c.extension,"chatParticipantAdditions"),c.p},set supportIssueReporting(r){(0,a.$yG)(c.extension,"chatParticipantAdditions"),c.p=r,h()},get onDidReceiveFeedback(){return c.n.event},set participantVariableProvider(r){if((0,a.$yG)(c.extension,"chatParticipantAdditions"),c.q=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");c.u.$registerAgentCompletionsProvider(c.w,r.triggerCharacters)}else c.u.$unregisterAgentCompletionsProvider(c.w)},get participantVariableProvider(){return(0,a.$yG)(c.extension,"chatParticipantAdditions"),c.q},set welcomeMessageProvider(r){(0,a.$yG)(c.extension,"defaultChatParticipant"),c.s=r,h()},get welcomeMessageProvider(){return(0,a.$yG)(c.extension,"defaultChatParticipant"),c.s},onDidPerformAction:(0,a.$xG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(r){c.t=r,h()},get requester(){return c.t},dispose(){t=!0,c.b=void 0,c.n.dispose(),c.u.$unregisterAgent(c.w)}}}invoke(t,g,h,c){return this.x(t,g,h,c)}}}),define(ke[330],Ee([1,0,13,3,6,16,7,26]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class ${static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy(L.$PM.MainThreadChatVariables)}async $resolveVariable(C,m,E,v){const u=this.b.get(C);if(u)try{if(u.resolver.resolve2){(0,b.$yG)(u.extension,"chatParticipantAdditions");const f=new S(m,this.c),a=await u.resolver.resolve2(u.data.name,{prompt:E},f.apiObject,v);if(a)return a.map(R.ChatVariable.from)}else{const f=await u.resolver.resolve(u.data.name,{prompt:E},v);if(f)return f.map(R.ChatVariable.from)}}catch(f){(0,l.$2)(f)}}registerVariableResolver(C,m,E,v){const u=$.a++;return this.b.set(u,{extension:C,data:{name:m,description:E},resolver:v}),this.c.$registerVariable(u,{name:m,description:E}),(0,N.$Sc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$tkc=$;class S{constructor(C,m){this.c=C,this.d=m,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let m=function(v){if(C.a){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,v),u}};const C=this,E=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){m(this.progress);const u=new M.$SO(v),f=R.ChatResponseProgressPart.from(u);return E(f),this},reference(v){m(this.reference);const u=new M.$UO(v),f=R.ChatResponseReferencePart.from(u);return E(f),this},push(v){return m(this.push),v instanceof M.$UO?E(R.ChatResponseReferencePart.from(v)):v instanceof M.$SO&&E(R.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[331],Ee([1,0,8,55,4,3,2,83,25,16,7,6,26]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=E;function E(v,u,f){const a=v.getProxy(C.$PM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Nm,u.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const D=this.b.get(d.handle);return D?D.value:d}else if(d&&d.$mid===7){const D=d,p=this.b.get(D.commentControlHandle);if(!p)return D;const k=p.getCommentThread(D.commentThreadHandle);return k?k.value:D}else if(d&&(d.$mid===9||d.$mid===8)){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const p=D.getCommentThread(d.thread.commentThreadHandle);return p?d.$mid===8?p.value:{thread:p.value,text:d.text}:d}else if(d&&d.$mid===10){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const p=D.getCommentThread(d.thread.commentThreadHandle);if(!p)return d;const k=d.commentUniqueId,y=p.getCommentByUniqueId(k);return y||d}else if(d&&d.$mid===11){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const p=D.getCommentThread(d.thread.commentThreadHandle);if(!p)return d;const k=d.text,y=d.commentUniqueId,P=p.getCommentByUniqueId(y);return P?(typeof P.body=="string"?P.body=k:P.body=new A.$gN(k),P):d}return d}})}createCommentController(d,D,p){const k=n.a++,y=new s(d,k,D,p);this.b.set(y.handle,y);const P=this.c.get(d.identifier)||[];return P.push(y),this.c.set(d.identifier,P),y.value}async $createCommentThreadTemplate(d,D,p){const k=this.b.get(d);k&&k.$createCommentThreadTemplate(D,p)}async $setActiveComment(d,D){const p=this.b.get(d);p&&p.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(d,D,p){const k=this.b.get(d);k&&k.$updateCommentThreadTemplate(D,p)}$deleteCommentThread(d,D){this.b.get(d)?.$deleteCommentThread(D)}async $provideCommentingRanges(d,D,p){const k=this.b.get(d);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const y=await f.ensureDocumentData(M.URI.revive(D));return(0,l.$ih)(async()=>{const P=await k.commentingRangeProvider.provideCommentingRanges(y.document,p);let I;return Array.isArray(P)?I={ranges:P,fileComments:!1}:P?I={ranges:P.ranges||[],fileComments:P.fileComments||!1}:I=P??void 0,I}).then(P=>{let I;return P&&(I={ranges:P.ranges.map(F=>S.Range.from(F)),fileComments:P.fileComments}),I})}$toggleReaction(d,D,p,k,y){const P=this.b.get(d);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,l.$ih)(()=>{const I=P.getCommentThread(D);if(I){const F=I.getCommentByUniqueId(k.uniqueIdInThread);if(P!==void 0&&F&&P.reactionHandler)return P.reactionHandler(F,g(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,typeof d=="object"?((0,m.$yG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=d.resolved,this.b.applicability=d.applicability):this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,D,p,k,y,P,I,F){this.m=D,this.n=p,this.o=k,this.p=y,this.q=P,this.extensionDescription=I,this.r=F,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${d}.${this.handle}`),a.$createCommentThread(D,this.handle,this.n,this.o,S.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{a.$deleteCommentThread(D,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(z){j.range=z},get comments(){return j.comments},set comments(z){j.comments=z},get collapsibleState(){return j.collapsibleState},set collapsibleState(z){j.collapsibleState=z},get canReply(){return j.canReply},set canReply(z){j.canReply=z},get contextValue(){return j.contextValue},set contextValue(z){j.contextValue=z},get label(){return j.label},set label(z){j.label=z},get state(){return j.state},set state(z){j.state=z},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const d=p=>Object.prototype.hasOwnProperty.call(this.b,p),D={};d("range")&&(D.range=S.Range.from(this.p)),d("label")&&(D.label=this.label),d("contextValue")&&(D.contextValue=this.contextValue??null),d("comments")&&(D.comments=this.q.map(p=>o(this,p,this.k,this.extensionDescription))),d("collapsibleState")&&(D.collapseState=h(this.g)),d("canReply")&&(D.canReply=this.canReply),d("state")&&(D.state=c(this.h)),d("applicability")&&(D.applicability=r(this.h)),d("isTemplate")&&(D.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(d){for(const D of this.k){const p=D[0],k=D[1];if(d===k)return p}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,N.$Vh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class s{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,d?.resourceHints&&(0,m.$yG)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,d?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,m.$yG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,m.$yG)(this.h,"activeComment"),this.f}constructor(d,D,p,k){this.h=d,this.i=D,this.j=p,this.k=k,this.a=new Map,a.$registerCommentController(this.handle,p,k,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(P){y.options=P},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(P){y.commentingRangeProvider=P},get reactionHandler(){return y.reactionHandler},set reactionHandler(P){y.reactionHandler=P},get activeCommentThread(){return y.activeCommentThread},createCommentThread(P,I,F){return y.createCommentThread(P,I,F).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(d,D,p){D===void 0&&(0,m.$yG)(this.h,"fileComments");const k=new i(this.id,this.handle,void 0,d,D,p,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(d){if(!d){this.e=void 0,this.f=void 0;return}const D=this.a.get(d.commentThreadHandle);D&&(this.e=d.uniqueIdInThread?D.getCommentByUniqueId(d.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(d,D){const p=new i(this.id,this.handle,void 0,M.URI.revive(d),S.Range.to(D),[],this.h,!0);return p.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(d,D){const p=this.a.get(d);p&&(p.range=S.Range.to(D))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.g.forEach(d=>d.dispose())}}function o(w,d,D,p){let k=D.get(d);return k||(k=++w.commentHandle,D.set(d,k)),d.state!==void 0&&(0,m.$yG)(p,"commentsDraftState"),d.reactions?.some(y=>y.reactors!==void 0)&&(0,m.$yG)(p,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:k,body:typeof d.body=="string"?d.body:S.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(y=>t(y)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(w){return{label:w.label,iconPath:w.iconPath?S.$bP(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted,reactors:w.reactors&&w.reactors.length>0&&typeof w.reactors[0]!="string"?w.reactors.map(d=>d.name):w.reactors}}function g(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?M.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1,reactors:w.reactors?.map(d=>({name:d}))}}function h(w){if(w!==void 0)switch(w){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function c(w){let d;if(typeof w=="object"?d=w.resolved:d=w,d!==void 0)switch(d){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function r(w){let d;if(typeof w=="object"&&(d=w.applicability),d!==void 0)switch(d){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ke[332],Ee([1,0,22,56,3,15,23,2,16,92,111,6,7]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class E{constructor(g,h){this.document=g,this.b=h,this.a=1,this.c=new A.$dkc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,h){await this.f(g).undo(),h||this.disposeBackup()}async redo(g,h){await this.f(g).redo(),h||this.disposeBackup()}disposeEdits(g){for(const h of g)this.c.delete(h)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=o(this.document.uri)+this.a++;return(0,M.$4g)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const h=this.c.get(g,0);if(!h)throw new Error("No edit found");return h}}class v{constructor(){this.a=new Map}get(g,h){return this.a.get(this.b(g,h))}add(g,h,c){const r=this.b(g,h.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${g} resource:${h.uri}`);const w=new E(h,c);return this.a.set(r,w),w}delete(g,h){const c=this.b(g,h.uri);this.a.delete(c)}b(g,h){return`${g}@@@${h}`}}var u;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(u||(u={}));class f{constructor(){this.a=new Map}addTextProvider(g,h,c){return this.b(0,g,h,c)}addCustomProvider(g,h,c){return this.b(1,g,h,c)}get(g){return this.a.get(g)}b(g,h,c,r){if(this.a.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this.a.set(h,{type:g,extension:c,provider:r}),new m.$RM(()=>this.a.delete(h))}}class a{constructor(g,h,c,r,w){this.d=h,this.f=c,this.g=r,this.h=w,this.b=new f,this.c=new v,this.a=g.getProxy(C.$PM.MainThreadCustomEditors)}registerCustomEditorProvider(g,h,c,r){const w=new L.$Tc;return i(c)?(w.add(this.b.addTextProvider(h,g,c)),this.a.$registerTextEditorProvider((0,S.$Mkc)(g),h,r.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,S.$Kkc)(g))):(w.add(this.b.addCustomProvider(h,g,c)),n(c)&&w.add(c.onDidChangeCustomDocument(d=>{const D=this.i(h,d.document.uri);if(s(d)){const p=D.addEdit(d);this.a.$onDidEdit(d.document.uri,h,p,d.label)}else this.a.$onContentChange(d.document.uri,h)})),this.a.$registerCustomEditorProvider((0,S.$Mkc)(g),h,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,S.$Kkc)(g))),m.$RM.from(w,new m.$RM(()=>{this.a.$unregisterEditorProvider(h)}))}async $createCustomDocument(g,h,c,r,w){const d=this.b.get(h);if(!d)throw new Error(`No provider found for '${h}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${h}'`);const D=b.URI.revive(g),p=await d.provider.openCustomDocument(D,{backupId:c,untitledDocumentData:r?.buffer},w);let k;return n(d.provider)&&this.f&&(k=this.f.workspaceValue(d.extension)??this.f.globalValue(d.extension)),this.c.add(h,p,k),{editable:n(d.provider)}}async $disposeCustomDocument(g,h){const c=this.b.get(h);if(!c)throw new Error(`No provider found for '${h}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${h}'`);const r=b.URI.revive(g),{document:w}=this.i(h,r);this.c.delete(h,w),w.dispose()}async $resolveCustomEditor(g,h,c,r,w,d){const D=this.b.get(c);if(!D)throw new Error(`No provider found for '${c}'`);const p=$.ViewColumn.to(w),k=this.g.createNewWebview(h,r.contentOptions,D.extension),y=this.h.createNewWebviewPanel(h,c,r.title,p,r.options,k,r.active),P=b.URI.revive(g);switch(D.type){case 1:{const{document:I}=this.i(c,P);return D.provider.resolveCustomEditor(I,y,d)}case 0:{const I=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(I,y,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,h,c){this.i(h,g).disposeEdits(c)}async $onMoveCustomEditor(g,h,c){const r=this.b.get(c);if(!r)throw new Error(`No provider found for '${c}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const w=this.h.getWebviewPanel(g);if(!w)throw new Error("No webview found");const d=b.URI.revive(h),D=this.d.getDocument(d);await r.provider.moveCustomTextEditor(D,w,l.CancellationToken.None)}async $undo(g,h,c,r){return this.i(h,g).undo(c,r)}async $redo(g,h,c,r){return this.i(h,g).redo(c,r)}async $revert(g,h,c){const r=this.i(h,g);await this.j(h).revertCustomDocument(r.document,c),r.disposeBackup()}async $onSave(g,h,c){const r=this.i(h,g);await this.j(h).saveCustomDocument(r.document,c),r.disposeBackup()}async $onSaveAs(g,h,c,r){const w=this.i(h,g);return this.j(h).saveCustomDocumentAs(w.document,b.URI.revive(c),r)}async $backup(g,h,c){const r=this.i(h,g),d=await this.j(h).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},c);return r.updateBackup(d),d.id}i(g,h){const c=this.c.get(g,b.URI.revive(h));if(!c)throw new Error("No custom document found");return c}j(g){const c=this.b.get(g)?.provider;if(!c||!n(c))throw new Error("Custom document is not editable");return c}}e.$Pkc=a;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const g=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,N.$ej)(g)+""}}),define(ke[333],Ee([1,0,219,138,2,6,7,16,4,12,27,60]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=void 0;class E{#e;#t;#i;constructor(f,a,n,i,s,o,t,g){this.d=f,this.e=a,this.f=n,this.g=i,this.h=s,this.c=!1,this.f=Math.max(i,n),this.#i=new A.$Bc(h=>o.getComparisonKey(h)),this.#e=t,this.#t=g}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,a){if(!f){this.clear();return}this.j();let n=[];if(L.URI.isUri(f)){if(!a){this.delete(f);return}this.#i.set(f,a.slice()),n=[f]}else if(Array.isArray(f)){n=[];let o;f=[...f].sort(E.k);for(const t of f){const[g,h]=t;if((!o||g.toString()!==o.toString())&&(o&&this.#i.get(o).length===0&&this.#i.delete(o),o=g,n.push(g),this.#i.set(g,[])),h)this.#i.get(g)?.push(...h);else{const c=this.#i.get(g);c&&(c.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let s=0;for(const o of n){let t=[];const g=this.#i.get(o);if(g)if(g.length>this.g){t=[];const h=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const r of g)if(r.severity===h[c]&&t.push({...b.Diagnostic.from(r),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,l.localize)(0,null,g.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=g.map(h=>({...b.Diagnostic.from(h),modelVersionId:this.h(o)}));if(i.push([o,t]),s+=t.length,s>this.f)break}this.#e.$changeMany(this.e,i)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,a){this.j();for(const[n,i]of this)f.call(a,n,i,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const a=this.#i.get(f);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,a){return f[0].toString()<a[0].toString()?-1:f[0].toString()>a[0].toString()?1:0}}e.$kkc=E;let v=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const a=new A.$Bc;for(const n of f)a.set(n,n);return{uris:Object.freeze(Array.from(a.values()))}}constructor(f,a,n,i){this.j=a,this.k=n,this.l=i,this.g=new Map,this.h=new $.$fe({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(R.$PM.MainThreadDiagnostics)}createDiagnosticCollection(f,a){const{g:n,f:i,h:s,j:o,k:t,l:g}=this,h=new class{$changeMany(w,d){i.$changeMany(w,d),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,w,d.length===0?"CLEARING":d)}$clear(w){i.$clear(w),o.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,w)}dispose(){i.dispose()}};let c;if(!a)a="_generated_diagnostic_collection_name_#"+m.c++,c=a;else if(!n.has(a))c=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do c=a+m.c++;while(n.has(c))}return new class extends E{constructor(){super(a,c,m.e,m.d,w=>g.getDocument(w)?.version,t.extUri,h,s),n.set(c,this)}dispose(){super.dispose(),n.delete(c)}}}getDiagnostics(f){if(f)return this.m(f);{const a=new Map,n=[];for(const i of this.g.values())i.forEach((s,o)=>{let t=a.get(s.toString());typeof t>"u"&&(t=n.length,a.set(s.toString(),t),n.push([s,[]])),n[t][1]=n[t][1].concat(...o)});return n}}m(f){let a=[];for(const n of this.g.values())n.has(f)&&(a=a.concat(n.get(f)));return a}$acceptMarkersChange(f){if(!this.n){const a="_generated_mirror",n=new E(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(a,n),this.n=n}for(const[a,n]of f)this.n.set(L.URI.revive(a),n.map(b.Diagnostic.to))}};e.$lkc=v,e.$lkc=v=m=Je([qe(1,S.$Wj),qe(2,C.$jkc)],v)}),define(ke[334],Ee([1,0,2,13,7,16,75,48]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class ${constructor(A,C,m,E={timeout:1500,errors:3}){this.c=A,this.d=C,this.f=m,this.g=E,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(C,m,E)=>{const u={dispose:this.a.push([C,m,A])};return Array.isArray(E)&&E.push(u),u}}async $participateInSave(A,C){const m=l.URI.revive(A);let E=!1;const v=setTimeout(()=>E=!0,this.g.timeout),u=[];try{for(const f of[...this.a]){if(E)break;const a=this.d.getDocument(m),n=await this.h(f,{document:a,reason:R.TextDocumentSaveReason.to(C)});u.push(n)}}finally{clearTimeout(v)}return u}h([A,C,m],E){const v=this.b.get(A);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(m,A,C,E).then(()=>!0,u=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' threw ERROR`),this.c.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const f=this.b.get(A);this.b.set(A,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,C,m,E){const v=[],u=Date.now(),{document:f,reason:a}=E,{version:n}=f,i=Object.freeze({document:f,reason:a,waitUntil(s){if(Object.isFrozen(v))throw(0,N.$8)("waitUntil can not be called async");v.push(Promise.resolve(s))}});try{C.apply(m,[i])}catch(s){return Promise.reject(s)}return Object.freeze(v),new Promise((s,o)=>{const t=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(v).then(g=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(t),s(g)}).catch(g=>{clearTimeout(t),o(g)})}).then(s=>{const o={edits:[]};for(const t of s)if(Array.isArray(t)&&t.every(g=>g instanceof L.$YM))for(const{newText:g,newEol:h,range:c}of t)o.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:c&&R.Range.from(c),text:g,eol:h&&R.EndOfLine.from(h)}});if(o.edits.length!==0)return n===f.version?this.f.$tryApplyWorkspaceEdit(new b.$mw(o)):Promise.reject(new Error("concurrent_edits"))})}}e.$tlc=$}),define(ke[335],Ee([1,0,4,3,2,6,152,16,18,24,7]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=void 0;class C{constructor(E,v){this.a=new l.$be,this.b=new l.$be,this.c=new l.$be,this.d=new l.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=E.getProxy(R.$PM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(u=>{for(const f of u)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const f of u)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const v=this.g.getDocument(E);if(v)return v}getDocument(E){const v=this.getDocumentData(E);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return v.document}ensureDocumentData(E){const v=this.g.getDocument(E);if(v)return Promise.resolve(v);let u=this.h.get(E.toString());return u||(u=this.f.$tryOpenDocument(E).then(f=>{this.h.delete(E.toString());const a=L.URI.revive(f);return(0,$.$cg)(this.g.getDocument(a))},f=>(this.h.delete(E.toString()),Promise.reject(f))),this.h.set(E.toString(),u)),u}createDocumentData(E){return this.f.$tryCreateDocument(E).then(v=>L.URI.revive(v))}$acceptModelLanguageChanged(E,v){const u=L.URI.revive(E),f=this.g.getDocument(u);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(v),this.a.fire(f.document)}$acceptModelSaved(E){const v=L.URI.revive(E),u=this.g.getDocument(v);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(E,v){const u=L.URI.revive(E),f=this.g.getDocument(u);if(!f)throw new Error("unknown document");f._acceptIsDirty(v),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,v,u){const f=L.URI.revive(E),a=this.g.getDocument(f);if(!a)throw new Error("unknown document");a._acceptIsDirty(u),a.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,S.$Xn)({document:a.document,contentChanges:v.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(E,v){(0,M.$eP)(E,v)}}e.$mkc=C}),define(ke[71],Ee([1,0,73,4,18,2,5,6,20,16,7]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=void 0,e.$Qkc=(0,M.$qi)("IExtHostEditorTabs");class C{constructor(f,a,n){this.e=n,this.d=a,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$BO(R.URI.revive(this.b.input.uri));case 2:return new A.$CO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$DO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$EO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$FO(this.b.input.viewType);case 4:return new A.$GO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$HO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$IO;case 9:return new A.$JO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$KO;case 11:return new A.$LO(this.b.input.diffEditors.map(f=>new A.$CO(R.URI.revive(f.original),R.URI.revive(f.modified))));default:return}}}class m{constructor(f,a){this.c=[],this.d="",this.b=f,this.e=a;for(const n of f.tabs)n.isActive&&(this.d=n.id),this.c.push(new C(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return S.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(n=>n.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(n=>n.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const n=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,n),f.tabDto.isActive&&(this.d=n.tabId),n}else if(f.kind===1){const n=this.c.splice(f.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(f.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,n),n}const a=this.c.find(n=>n.tabId===f.tabDto.id);if(!a)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(f.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(f){this.b=new N.$be,this.c=new N.$be,this.e=[],this.a=f.getProxy(b.$PM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,a={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(n=>n.apiObject))},get activeTabGroup(){const n=f.d;return(0,L.$cg)(f.e.find(s=>s.groupId===n)?.apiObject)},close:async(n,i)=>{const s=Array.isArray(n)?n:[n];return s.length?v(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(f){const a=new Set(this.e.map(h=>h.groupId)),n=new Set(f.map(h=>h.groupId)),i=(0,l.$L)(a,n),s=this.e.filter(h=>i.removed.includes(h.groupId)).map(h=>h.apiObject),o=[],t=[];this.e=f.map(h=>{const c=new m(h,()=>this.d);return i.added.includes(c.groupId)?o.push(c.apiObject):t.push(c.apiObject),c});const g=(0,L.$cg)(f.find(h=>h.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:o,closed:s,changed:t}))}$acceptTabGroupUpdate(f){const a=this.e.find(n=>n.groupId===f.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const a=this.e.find(i=>i.groupId===f.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const n=a.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(f){for(const a of this.e)for(const n of a.tabs)if(n.apiObject===f)return n}h(f){return this.e.find(a=>a.apiObject===f)}async i(f,a){const n=[];for(const i of f){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");n.push(s.tabId)}return this.a.$closeTab(n,a)}async j(f,a){const n=[];for(const i of f){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");n.push(s.groupId)}return this.a.$closeGroup(n,a)}};e.$Rkc=E,e.$Rkc=E=Je([qe(0,$.$cP)],E);function v(u){return u.tabs!==void 0}}),define(ke[336],Ee([1,0,2,6,3,7,16,180,14,21,26,80]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class m{constructor(){this.a=[]}add(u){this.b=void 0,this.a.push(u)}delete(u){const f=this.a.indexOf(u);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const u=this.a.sort(),f=[];let a,n,i=14,s=14;for(const o of u){let t=a?(0,$.$vf)(a,o):0;for(t===0?n=1:n=s;t<o.length;t++)t+1===o.length?(i=s,s=9):s+=1,f.push([n,o.toUpperCase().charCodeAt(t),s]),f.push([n,o.toLowerCase().charCodeAt(t),s]),n=s;a=o,s=i}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$32(f)}}provideDocumentLinks(u){this.c();const f=[],a=b.$42.computeLinks({getLineContent(n){return u.lineAt(n-1).text},getLineCount(){return u.lineCount}},this.b);for(const n of a){const i=M.DocumentLink.to(n);i.target&&f.push(i)}return f}}class E{constructor(u,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=u.getProxy(N.$PM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(u,f,a,n={}){if(E.j(a),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(u,"*",this.b));const i=this.h++;this.b.add(f),this.d.add(f),this.c.set(i,a);let s=2;n.isCaseSensitive&&(s+=1024),n.isReadonly&&(s+=2048),typeof a.copy=="function"&&(s+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,A.$yG)(u,"fsChunks"),s+=4);let o;n.isReadonly&&(0,C.$Pk)(n.isReadonly)&&n.isReadonly.value!==""&&(o={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,f,s,o).catch(g=>{console.error(`FAILED to register filesystem provider of ${u.identifier.value}-extension for the scheme ${f}`),console.error(g)});const t=a.onDidChangeFile(g=>{const h=[];for(const c of g){const{uri:r,type:w}=c;if(r.scheme!==f)continue;let d;switch(w){case R.FileChangeType.Changed:d=0;break;case R.FileChangeType.Created:d=1;break;case R.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:r,type:d})}this.a.$onFileSystemChange(i,h)});return(0,L.$Sc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(u){if(!u)throw new Error("MISSING provider");if(typeof u.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof u.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof u.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof u.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof u.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof u.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof u.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof u.rename!="function")throw new Error("Provider does NOT implement rename")}static k(u){const{type:f,ctime:a,mtime:n,size:i,permissions:s}=u;return{type:f,ctime:a,mtime:n,size:i,permissions:s}}$stat(u,f){return Promise.resolve(this.l(u).stat(l.URI.revive(f))).then(a=>E.k(a))}$readdir(u,f){return Promise.resolve(this.l(u).readDirectory(l.URI.revive(f)))}$readFile(u,f){return Promise.resolve(this.l(u).readFile(l.URI.revive(f))).then(a=>S.$Ce.wrap(a))}$writeFile(u,f,a,n){return Promise.resolve(this.l(u).writeFile(l.URI.revive(f),a.buffer,n))}$delete(u,f,a){return Promise.resolve(this.l(u).delete(l.URI.revive(f),a))}$rename(u,f,a,n){return Promise.resolve(this.l(u).rename(l.URI.revive(f),l.URI.revive(a),n))}$copy(u,f,a,n){const i=this.l(u);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(l.URI.revive(f),l.URI.revive(a),n))}$mkdir(u,f){return Promise.resolve(this.l(u).createDirectory(l.URI.revive(f)))}$watch(u,f,a,n){const i=this.l(u).watch(l.URI.revive(a),n);this.f.set(f,i)}$unwatch(u,f){const a=this.f.get(f);a&&(a.dispose(),this.f.delete(f))}$open(u,f,a){const n=this.l(u);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(l.URI.revive(f),a))}$close(u,f){const a=this.l(u);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(f))}$read(u,f,a,n){const i=this.l(u);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const s=S.$Ce.alloc(n);return Promise.resolve(i.read(f,a,s.buffer,0,n)).then(o=>s.slice(0,o))}$write(u,f,a,n){const i=this.l(u);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(f,a,n.buffer,0,n.byteLength))}l(u){const f=this.c.get(u);if(!f){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return f}}e.$vlc=E}),define(ke[337],Ee([1,0,4,35,2,6,16,7,46]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class S{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,v,u,f,a,n){this.a=Math.random(),this.b=new l.$be,this.c=new l.$be,this.d=new l.$be,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$kk)(a),s=typeof a=="string",o=n?.correlate,t=f(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(o&&typeof g.session>"u")){if(!n?.ignoreCreateEvents)for(const h of g.created){const c=L.URI.revive(h);i(c.fsPath)&&(!s||v.getWorkspaceFolder(c))&&this.b.fire(c)}if(!n?.ignoreChangeEvents)for(const h of g.changed){const c=L.URI.revive(h);i(c.fsPath)&&(!s||v.getWorkspaceFolder(c))&&this.c.fire(c)}if(!n?.ignoreDeleteEvents)for(const h of g.deleted){const c=L.URI.revive(h);i(c.fsPath)&&(!s||v.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=b.$RM.from(this.i(E,u,a,n,n?.correlate),this.b,this.c,this.d,t)}i(E,v,u,f,a){const n=b.$RM.from();if(typeof u=="string")return n;const i=E.getProxy(R.$PM.MainThreadFileSystemEventService);let s=!1;return(u.pattern.includes(N.$gk)||u.pattern.includes(N.$hk))&&(s=!0),i.$watch(v.identifier.value,this.a,u.baseUri,{recursive:s,excludes:f?.excludes??[]},!!a),b.$RM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(E){this.a=E,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(L.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(E,v,u){this.j=E,this.k=v,this.l=u,this.a=new l.$be,this.b=new l.$be,this.c=new l.$be,this.d=new l.$be,this.g=new l.$de,this.h=new l.$de,this.i=new l.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,v,u,f){return new S(this.j,E,v,this.a.event,M.GlobPattern.from(u),f)}$onFileEvent(E){this.a.fire(new A(E))}$onDidRunFileOperation(E,v){switch(E){case 2:this.b.fire(Object.freeze({files:v.map(u=>({oldUri:L.URI.revive(u.source),newUri:L.URI.revive(u.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(u=>L.URI.revive(u.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(u=>L.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,v){return(u,f,a)=>{const n=function(s){u.call(f,s)};return n.extension=E,v.event(n,void 0,a)}}async $onWillRunFileOperation(E,v,u,f){switch(E){case 2:return await this.n(this.g,{files:v.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))},u,f);case 1:return await this.n(this.i,{files:v.map(a=>L.URI.revive(a.target))},u,f);case 0:case 3:return await this.n(this.h,{files:v.map(a=>L.URI.revive(a.target))},u,f)}}async n(E,v,u,f){const a=new Set,n=[];if(await E.fireAsync(v,f,async(s,o)=>{const t=Date.now(),g=await Promise.resolve(s);g instanceof b.$2M&&(n.push([o.extension,g]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>u&&this.k.warn("SLOW file-participant",o.extension.identifier)}),f.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,s]of n){const{edits:o}=M.WorkspaceEdit.from(s,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(o)}return{edit:i,extensionNames:Array.from(a)}}}e.$wlc=C}),define(ke[338],Ee([1,0,19,8,22,13,124,3,24,40,14,18,2,29,176,83,134,221,25,16,7,26,111,6]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=void 0;class h{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const J=this.d.getDocument(q),Q=await this.e.provideDocumentSymbols(J,V);if(!(0,l.$Kb)(Q))return Q[0]instanceof s.$$M?Q.map(i.DocumentSymbol.from):h.f(Q)}static f(q){q=q.slice(0).sort((Q,he)=>{let pe=Q.location.range.start.compareTo(he.location.range.start);return pe===0&&(pe=he.location.range.end.compareTo(Q.location.range.end)),pe});const V=[],J=[];for(const Q of q){const he={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(J.length===0){J.push(he),V.push(he);break}const pe=J[J.length-1];if(E.$kt.containsRange(pe.range,he.range)&&!E.$kt.equalsRange(pe.range,he.range)){pe.children?.push(he),J.push(he);break}J.pop()}}return V}}class c{constructor(q,V,J,Q,he,pe){this.f=q,this.g=V,this.h=J,this.j=Q,this.k=he,this.l=pe,this.d=new t.$dkc("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const J=this.f.getDocument(q),Q=await this.h.provideCodeLenses(J,V);if(!Q||V.isCancellationRequested)return;const he=this.d.add(Q),pe=new b.$Tc;this.e.set(he,pe);const ze={cacheId:he,lenses:[]};for(let Ve=0;Ve<Q.length;Ve++)ze.lenses.push({cacheId:[he,Ve],range:i.Range.from(Q[Ve].range),command:this.g.toInternal(Q[Ve].command,pe)});return ze}async resolveCodeLens(q,V){const J=q.cacheId&&this.d.get(...q.cacheId);if(!J)return;let Q;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?Q=J:Q=await this.h.resolveCodeLens(J,V),Q||(Q=J),V.isCancellationRequested)return;const he=q.cacheId&&this.e.get(q.cacheId[0]);if(he){if(!Q.command){const pe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,pe),this.l.error(pe);return}return q.command=this.g.toInternal(Q.command,he),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function r(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class w{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideDefinition(Q,he,J);return r(pe)}}class d{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideDeclaration(Q,he,J);return r(pe)}}class D{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideImplementation(Q,he,J);return r(pe)}}class p{constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideTypeDefinition(Q,he,J);return r(pe)}}class k{constructor(q,V){this.d=q,this.e=V}async provideHover(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideHover(Q,he,J);if(!(!pe||(0,l.$Kb)(pe.contents)))return pe.range||(pe.range=Q.getWordRangeAtPosition(he)),pe.range||(pe.range=new s.$TM(he,he)),i.Hover.from(pe)}}class y{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideEvaluatableExpression(Q,he,J);if(pe)return i.EvaluatableExpression.from(pe)}}class P{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,J,Q){const he=this.d.getDocument(q),pe=await this.e.provideInlineValues(he,i.Range.to(V),i.InlineValueContext.to(J),Q);if(Array.isArray(pe))return pe.map(ze=>i.InlineValue.from(ze))}}class I{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideDocumentHighlights(Q,he,J);if(Array.isArray(pe))return pe.map(i.DocumentHighlight.from)}}class F{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,J,Q){const he=this.d.getDocument(q),pe=J.map(Ze=>this.d.getDocument(Ze)),ze=i.Position.to(V),Ve=await this.e.provideMultiDocumentHighlights(he,ze,pe,Q);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class j{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideLinkedEditingRanges(Q,he,J);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,l.$Hb)(pe.ranges.map(i.Range.from)),wordPattern:pe.wordPattern}}}class z{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,J,Q){const he=this.d.getDocument(q),pe=i.Position.to(V),ze=await this.e.provideReferences(he,pe,J,Q);if(Array.isArray(ze))return ze.map(i.location.from)}}class O{static{this.d=1e3}constructor(q,V,J,Q,he,pe,ze){this.g=q,this.h=V,this.j=J,this.k=Q,this.l=he,this.m=pe,this.n=ze,this.e=new t.$dkc("CodeAction"),this.f=new Map}async provideCodeActions(q,V,J,Q){const he=this.g.getDocument(q),pe=v.$mt.isISelection(V)?i.Selection.to(V):i.Range.to(V),ze=[];for(const st of this.j.getDiagnostics(q))if(pe.intersection(st.range)&&ze.push(st)>O.d)break;const Ve={diagnostics:ze,only:J.only?new s.$aN(J.only):void 0,triggerKind:i.CodeActionTriggerKind.to(J.trigger)},Ze=await this.k.provideCodeActions(he,pe,Ve,Q);if(!(0,l.$Lb)(Ze)||Q.isCancellationRequested)return;const it=this.e.add(Ze),ot=new b.$Tc;this.f.set(it,ot);const nt=[];for(let st=0;st<Ze.length;st++){const Ce=Ze[st];if(Ce)if(O.o(Ce))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:Ce.title,command:this.h.toInternal(Ce,ot)});else{Ve.only&&(Ce.kind?Ve.only.contains(Ce.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${Ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Ce.ranges??[];nt.push({cacheId:[it,st],title:Ce.title,command:Ce.command&&this.h.toInternal(Ce.command,ot),diagnostics:Ce.diagnostics&&Ce.diagnostics.map(i.Diagnostic.from),edit:Ce.edit&&i.WorkspaceEdit.from(Ce.edit,void 0),kind:Ce.kind&&Ce.kind.value,isPreferred:Ce.isPreferred,isAI:(0,o.$xG)(this.m,"codeActionAI")?Ce.isAI:!1,ranges:(0,o.$xG)(this.m,"codeActionRanges")?(0,l.$Hb)(Be.map(i.Range.from)):void 0,disabled:Ce.disabled?.reason})}}return{cacheId:it,actions:nt}}async resolveCodeAction(q,V){const[J,Q]=q,he=this.e.get(J,Q);if(!he||O.o(he))return{};if(!this.k.resolveCodeAction)return{};const pe=await this.k.resolveCodeAction(he,V)??he;let ze;pe.edit&&(ze=i.WorkspaceEdit.from(pe.edit,void 0));let Ve;if(pe.command){const Ze=this.f.get(J);Ze&&(Ve=this.h.toInternal(pe.command,Ze))}return{edit:ze,command:Ve}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class T{constructor(q,V,J,Q,he){this.e=q,this.f=V,this.g=J,this.h=Q,this.j=he,this.d=new t.$dkc("DocumentPasteEdit")}async prepareDocumentPaste(q,V,J,Q){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(q),pe=V.map(Ze=>i.Range.to(Ze)),ze=i.DataTransfer.toDataTransfer(J,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(he,pe,ze,Q),Q.isCancellationRequested)return;const Ve=Array.from(ze).filter(([,Ze])=>!(Ze instanceof s.$GN));return i.DataTransfer.from(Ve)}async providePasteEdits(q,V,J,Q,he,pe){if(!this.g.provideDocumentPasteEdits)return[];const ze=this.f.getDocument(V),Ve=J.map(nt=>i.Range.to(nt)),Ze=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolvePasteFileData(this.h,q,nt)).buffer),it=await this.g.provideDocumentPasteEdits(ze,Ve,Ze,{only:he.only?new s.$LN(he.only):void 0,triggerKind:he.triggerKind},pe);if(!it||pe.isCancellationRequested)return[];const ot=this.d.add(it);return it.map((nt,st)=>({_cacheId:[ot,st],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(Ce=>Ce.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[J,Q]=q,he=this.d.get(J,Q);if(!he||!this.g.resolveDocumentPasteEdit)return{};const pe=await this.g.resolveDocumentPasteEdit(he,V)??he;return{additionalEdit:pe.additionalEdit?i.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,J){const Q=this.d.getDocument(q),he=await this.e.provideDocumentFormattingEdits(Q,V,J);if(Array.isArray(he))return he.map(i.TextEdit.from)}}class W{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,J,Q){const he=this.d.getDocument(q),pe=i.Range.to(V),ze=await this.e.provideDocumentRangeFormattingEdits(he,pe,J,Q);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,J,Q){(0,C.$bg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(q),pe=V.map(i.Range.to),ze=await this.e.provideDocumentRangesFormattingEdits(he,pe,J,Q);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class X{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,J,Q,he){const pe=this.d.getDocument(q),ze=i.Position.to(V),Ve=await this.e.provideOnTypeFormattingEdits(pe,ze,J,Q,he);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class x{constructor(q,V){this.e=q,this.f=V,this.d=new t.$dkc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const J=await this.e.provideWorkspaceSymbols(q,V);if(!(0,l.$Lb)(J))return{symbols:[]};const Q=this.d.add(J),he={cacheId:Q,symbols:[]};for(let pe=0;pe<J.length;pe++){const ze=J[pe];if(!ze||!ze.name){this.f.warn("INVALID SymbolInformation",ze);continue}he.symbols.push({...i.WorkspaceSymbol.from(ze),cacheId:[Q,pe]})}return he}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const J=this.d.get(...q.cacheId);if(J){const Q=await this.e.resolveWorkspaceSymbol(J,V);return Q&&(0,$.$Zn)(q,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class Z{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideRenameEdits(q,V,J,Q){const he=this.d.getDocument(q),pe=i.Position.to(V);try{const ze=await this.e.provideRenameEdits(he,pe,J,Q);return ze?i.WorkspaceEdit.from(ze):void 0}catch(ze){const Ve=Z.g(ze);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(ze)}}async resolveRenameLocation(q,V,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(q),he=i.Position.to(V);try{const pe=await this.e.prepareRename(Q,he,J);let ze,Ve;if(s.$TM.isRange(pe)?(ze=pe,Ve=Q.getText(pe)):(0,C.$6f)(pe)&&(ze=pe.range,Ve=pe.placeholder),!ze||!Ve)return;if(ze.start.line>he.line||ze.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ze),text:Ve}}catch(pe){const ze=Z.g(pe);return ze?{rejectReason:ze,range:void 0,text:void 0}:Promise.reject(pe)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Y{constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideNewSymbolNames(q,V,J){const Q=this.d.getDocument(q),he=i.Range.to(V);try{const pe=await this.e.provideNewSymbolNames(Q,he,J);return pe?pe.map(ze=>typeof ze=="string"?{newSymbolName:ze}:{newSymbolName:ze.newSymbolName,tags:ze.tags}):void 0}catch(pe){this.f.error(Y.g(pe)??JSON.stringify(pe,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ue{constructor(q,V){this.resultId=q,this.tokens=V}}class te{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,J){const Q=this.f.getDocument(q),he=V!==0?this.d.get(V):null;let pe=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,he.resultId,J):await this.g.provideDocumentSemanticTokens(Q,J);return he&&this.d.delete(V),pe?(pe=te.h(pe),this.o(te.n(he,pe),pe)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return te.j(q)?te.k(q)?q:new s.$_N(new Uint32Array(q.data),q.resultId):te.l(q)?te.m(q)?q:new s.$bO(q.edits.map(V=>new s.$aO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!te.j(V)||!q||!q.tokens)return V;const J=q.tokens,Q=J.length,he=V.data,pe=he.length;let ze=0;const Ve=Math.min(Q,pe);for(;ze<Ve&&J[ze]===he[ze];)ze++;if(ze===Q&&ze===pe)return new s.$bO([],V.resultId);let Ze=0;const it=Ve-ze;for(;Ze<it&&J[Q-Ze-1]===he[pe-Ze-1];)Ze++;return new s.$bO([{start:ze,deleteCount:Q-ze-Ze,data:he.subarray(ze,pe-Ze)}],V.resultId)}o(q,V){if(te.j(q)){const J=this.e++;return this.d.set(J,new ue(q.resultId,q.data)),(0,f.$tbb)({id:J,type:"full",data:q.data})}if(te.l(q)){const J=this.e++;return te.j(V)?this.d.set(J,new ue(V.resultId,V.data)):this.d.set(J,new ue(q.resultId)),(0,f.$tbb)({id:J,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class we{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,J){const Q=this.d.getDocument(q),he=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(V),J);return he?this.f(he):null}f(q){return(0,f.$tbb)({id:0,type:"full",data:q.data})}}class Se{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,J,Q,he){this.f=q,this.g=V,this.h=J,this.j=Q,this.k=he,this.d=new t.$dkc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,J,Q){const he=this.f.getDocument(q),pe=i.Position.to(V),ze=he.getWordRangeAtPosition(pe)||new s.$TM(pe,pe),Ve=ze.with({end:pe}),Ze=new S.$0d,it=await this.h.provideCompletionItems(he,pe,Q,i.CompletionContext.to(J));if(!it||Q.isCancellationRequested)return;const ot=Array.isArray(it)?new s.$nN(it):it,nt=Se.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),st=new b.$Tc;this.e.set(nt,st);const Ce=[],Be={x:nt,b:Ce,a:{replace:i.Range.from(ze),insert:i.Range.from(Ve)},c:ot.isIncomplete||void 0,d:Ze.elapsed()};for(let He=0;He<ot.items.length;He++){const Ne=ot.items[He],Xe=this.l(Ne,[nt,He],Ve,ze);Ce.push(Xe)}return Be}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...q);if(!J)return;const Q=this.l(J,q),he=await this.h.resolveCompletionItem(J,V);if(!he)return;const pe=this.l(he,q);return(Q.h!==pe.h||Q.i!==pe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==pe.n||Q.o!==pe.o||!(0,$.$1n)(Q.p,pe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:pe.d,c:pe.c,l:pe.l,h:pe.h,i:pe.i,n:pe.n,o:pe.o,p:pe.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,J,Q){const he=this.e.get(V[0]);if(!he)throw Error("DisposableStore is missing...");const pe=this.g.toInternal(q.command,he),ze={x:V,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:pe?.$ident,o:pe?.id,p:pe?.$ident?void 0:pe?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ze.h=q.textEdit.newText):typeof q.insertText=="string"?ze.h=q.insertText:q.insertText instanceof s.$3M&&(ze.h=q.insertText.value,ze.i|=4);let Ve;return q.textEdit?Ve=q.textEdit.range:q.range&&(Ve=q.range),s.$TM.isRange(Ve)?ze.j=i.Range.from(Ve):Ve&&(!J?.isEqual(Ve.inserting)||!Q?.isEqual(Ve.replacing))&&(ze.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),ze}}class _{async provideInlineCompletions(q,V,J,Q){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,J){}handlePartialAccept(q,V,J,Q){}}class U extends _{constructor(q,V,J,Q){super(),this.f=q,this.g=V,this.h=J,this.j=Q,this.d=new $e,this.e=(0,o.$xG)(this.f,"inlineCompletionsAdditions"),this.k={[u.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[u.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,o.$xG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,J,Q){const he=this.g.getDocument(q),pe=i.Position.to(V),ze=await this.h.provideInlineCompletionItems(he,pe,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},Q);if(!ze||Q.isCancellationRequested)return;const Ve=Array.isArray(ze)?ze:ze.items,Ze=this.e?Array.isArray(ze)?[]:ze.commands||[]:[],it=this.e&&!Array.isArray(ze)?ze.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((st,Ce)=>{let Be;st.command&&(ot||(ot=new b.$Tc),Be=this.j.toInternal(st.command,ot));const He=st.insertText;return{insertText:typeof He=="string"?He:{snippet:He.value},filterText:st.filterText,range:st.range?i.Range.from(st.range):void 0,command:Be,idx:Ce,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Ze.map(st=>(ot||(ot=new b.$Tc),this.j.toInternal(st,ot))),suppressSuggestions:!1,enableForwardStability:it}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,J){const Q=this.d.get(q)?.items[V];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,J)}handlePartialAccept(q,V,J,Q){const he=this.d.get(q)?.items[V];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,J),this.h.handleDidPartiallyAcceptCompletionItem(he,i.PartialAcceptInfo.to(Q)))}}class ne{async provideInlineEdits(q,V,J){const Q=this.f.getDocument(q),he=await this.g.provideInlineEdit(Q,{triggerKind:this.e[V.triggerKind]},J);if(!he||J.isCancellationRequested)return;let pe;const ze=this.d.createReferenceId({dispose(){pe?.dispose()},item:he});let Ve;he.accepted&&(pe||(pe=new b.$Tc),Ve=this.h.toInternal(he.accepted,pe));let Ze;return he.rejected&&(pe||(pe=new b.$Tc),Ze=this.h.toInternal(he.rejected,pe)),{pid:ze,text:he.text,range:i.Range.from(he.range),accepted:Ve,rejected:Ze}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,J,Q){this.f=V,this.g=J,this.h=Q,this.d=new $e,this.e={[u.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[u.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class $e{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class Pe{constructor(q,V){this.e=q,this.f=V,this.d=new t.$dkc("SignatureHelp")}async provideSignatureHelp(q,V,J,Q){const he=this.e.getDocument(q),pe=i.Position.to(V),ze=this.g(J),Ve=await this.f.provideSignatureHelp(he,pe,Q,ze);if(Ve){const Ze=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Ze}}}g(q){let V;if(q.activeSignatureHelp){const J=i.SignatureHelp.to(q.activeSignatureHelp),Q=this.d.get(q.activeSignatureHelp.id,0);Q?(V=Q,V.activeSignature=J.activeSignature,V.activeParameter=J.activeParameter):V=J}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class se{constructor(q,V,J,Q,he){this.f=q,this.g=V,this.h=J,this.j=Q,this.k=he,this.d=new t.$dkc("InlayHints"),this.e=new Map}async provideInlayHints(q,V,J){const Q=this.f.getDocument(q),he=i.Range.to(V),pe=await this.h.provideInlayHints(Q,he,J);if(!Array.isArray(pe)||pe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(J.isCancellationRequested)return;const ze=this.d.add(pe);this.e.set(ze,new b.$Tc);const Ve={hints:[],cacheId:ze};for(let Ze=0;Ze<pe.length;Ze++)this.l(pe[Ze],he)&&Ve.hints.push(this.m(pe[Ze],[ze,Ze]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ve}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...q);if(!J)return;const Q=await this.h.resolveInlayHint(J,V);if(Q&&this.l(Q))return this.m(Q,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const J=this.e.get(V[0]);if(!J)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:V,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")Q.label=q.label;else{const he=[];Q.label=he;for(const pe of q.label){if(!pe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ze={label:pe.value,tooltip:i.MarkdownString.fromStrict(pe.tooltip)};s.$4M.isLocation(pe.location)&&(ze.location=i.location.from(pe.location)),pe.command&&(ze.command=this.g.toInternal(pe.command,J)),he.push(ze)}}return Q}}class re{constructor(q,V){this.e=q,this.f=V,this.d=new t.$dkc("DocumentLink")}async provideLinks(q,V){const J=this.e.getDocument(q),Q=await this.f.provideDocumentLinks(J,V);if(!(!Array.isArray(Q)||Q.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(re.g).map(i.DocumentLink.from)};{const he=this.d.add(Q),pe={links:[],cacheId:he};for(let ze=0;ze<Q.length;ze++){if(!re.g(Q[ze]))continue;const Ve=i.DocumentLink.from(Q[ze]);Ve.cacheId=[he,ze],pe.links.push(Ve)}return pe}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...q);if(!J)return;const Q=await this.f.resolveDocumentLink(J,V);if(!(!Q||!re.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(q){this.d.delete(q)}}class oe{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const J=this.d.getDocument(q),Q=await this.e.provideDocumentColors(J,V);return Array.isArray(Q)?Q.map(pe=>({color:i.Color.from(pe.color),range:i.Range.from(pe.range)})):[]}async provideColorPresentations(q,V,J){const Q=this.d.getDocument(q),he=i.Range.to(V.range),pe=i.Color.to(V.color),ze=await this.e.provideColorPresentations(pe,{document:Q,range:he},J);if(Array.isArray(ze))return ze.map(i.ColorPresentation.from)}}class G{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,J){const Q=this.d.getDocument(q),he=await this.e.provideFoldingRanges(Q,V,J);if(Array.isArray(he))return he.map(i.FoldingRange.from)}}class ie{constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideSelectionRanges(q,V,J){const Q=this.d.getDocument(q),he=V.map(i.Position.to),pe=await this.e.provideSelectionRanges(Q,he,J);if(!(0,l.$Lb)(pe))return[];if(pe.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ze=[];for(let Ve=0;Ve<he.length;Ve++){const Ze=[];ze.push(Ze);let it=he[Ve],ot=pe[Ve];for(;;){if(!ot.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Ze.push(i.SelectionRange.from(ot)),!ot.parent)break;it=ot.range,ot=ot.parent}}return ze}}class me{constructor(q,V){this.f=q,this.g=V,this.d=new M.$hP(""),this.e=new Map}async prepareSession(q,V,J){const Q=this.f.getDocument(q),he=i.Position.to(V),pe=await this.g.prepareCallHierarchy(Q,he,J);if(!pe)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(pe)?pe.map(Ve=>this.h(ze,Ve)):[this.h(ze,pe)]}async provideCallsTo(q,V,J){const Q=this.j(q,V);if(!Q)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Q,J);if(he)return he.map(pe=>({from:this.h(q,pe.from),fromRanges:pe.fromRanges.map(ze=>i.Range.from(ze))}))}async provideCallsFrom(q,V,J){const Q=this.j(q,V);if(!Q)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Q,J);if(he)return he.map(pe=>({to:this.h(q,pe.to),fromRanges:pe.fromRanges.map(ze=>i.Range.from(ze))}))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),Q=i.CallHierarchyItem.from(V,q,J.size.toString(36));return J.set(Q._itemId,V),Q}j(q,V){return this.e.get(q)?.get(V)}}class be{constructor(q,V){this.f=q,this.g=V,this.d=new M.$hP(""),this.e=new Map}async prepareSession(q,V,J){const Q=this.f.getDocument(q),he=i.Position.to(V),pe=await this.g.prepareTypeHierarchy(Q,he,J);if(!pe)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(pe)?pe.map(Ve=>this.h(ze,Ve)):[this.h(ze,pe)]}async provideSupertypes(q,V,J){const Q=this.j(q,V);if(!Q)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Q,J);if(he)return he.map(pe=>this.h(q,pe))}async provideSubtypes(q,V,J){const Q=this.j(q,V);if(!Q)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Q,J);if(he)return he.map(pe=>this.h(q,pe))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),Q=i.TypeHierarchyItem.from(V,q,J.size.toString(36));return J.set(Q._itemId,V),Q}j(q,V){return this.e.get(q)?.get(V)}}class Ae{constructor(q,V,J,Q,he){this.e=q,this.f=V,this.g=J,this.h=Q,this.j=he,this.d=new t.$dkc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,V,J,Q,he){const pe=this.f.getDocument(V),ze=i.Position.to(J),Ve=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,nt)).buffer),Ze=await this.g.provideDocumentDropEdits(pe,ze,Ve,he);if(!Ze)return;const it=(0,l.$3b)(Ze),ot=this.d.add(it);return it.map((nt,st)=>({_cacheId:[ot,st],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(Ce=>Ce.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,V){const[J,Q]=q,he=this.d.get(J,Q);if(!he||!this.g.resolveDocumentDropEdit)return{};const pe=await this.g.resolveDocumentDropEdit(he,V)??he;return{additionalEdit:pe.additionalEdit?i.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class fe{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,J,Q){const he=m.URI.revive(q),pe=this.d.getDocument(he),ze=J.documents.map(it=>it.map(ot=>({uri:m.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(nt=>i.Range.to(nt))}))),Ve={documents:ze,selections:ze[0]?.[0]?.ranges??[]},Ze=await this.e.provideMappedEdits(pe,V,Ve,Q);return Ze?i.WorkspaceEdit.from(Ze):null}}class De{constructor(q,V){this.adapter=q,this.extension=V}}class Ie{static{this.d=0}constructor(q,V,J,Q,he,pe,ze,Ve){this.g=V,this.h=J,this.j=Q,this.k=he,this.l=pe,this.m=ze,this.n=Ve,this.f=new Map,this.e=q.getProxy(g.$PM.MainThreadLanguageFeatures)}o(q,V){return i.DocumentSelector.from(q,this.g,V)}p(q){return new s.$RM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ie.d++}async s(q,V,J,Q,he,pe=!1){const ze=this.f.get(q);if(!ze||!(ze.adapter instanceof V))return Q;const Ve=Date.now();pe||this.l.trace(`[${ze.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ze=J(ze.adapter,ze.extension);return Promise.resolve(Ze).catch(it=>{(0,R.$4)(it)||(this.l.error(`[${ze.extension.identifier.value}] provider FAILED`),this.l.error(it),this.n.onExtensionError(ze.extension.identifier,it))}).finally(()=>{pe||this.l.trace(`[${ze.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),L.CancellationToken.isCancellationToken(he)?(0,N.$fh)(Ze,he):Ze}t(q,V){const J=this.q();return this.f.set(J,new De(q,V)),J}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,V,J,Q){const he=this.t(new h(this.h,J),q),pe=Q&&Q.label||Ie.u(q);return this.e.$registerDocumentSymbolProvider(he,this.o(V,q),pe),this.p(he)}$provideDocumentSymbols(q,V,J){return this.s(q,h,Q=>Q.provideDocumentSymbols(m.URI.revive(V),J),void 0,J)}registerCodeLensProvider(q,V,J){const Q=this.q(),he=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new De(new c(this.h,this.j.converter,J,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(Q,this.o(V,q),he);let pe=this.p(Q);if(he!==void 0){const ze=J.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(he));pe=s.$RM.from(pe,ze)}return pe}$provideCodeLenses(q,V,J){return this.s(q,c,Q=>Q.provideCodeLenses(m.URI.revive(V),J),void 0,J)}$resolveCodeLens(q,V,J){return this.s(q,c,Q=>Q.resolveCodeLens(V,J),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,c,J=>Promise.resolve(J.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,J){const Q=this.t(new w(this.h,J),q);return this.e.$registerDefinitionSupport(Q,this.o(V,q)),this.p(Q)}$provideDefinition(q,V,J,Q){return this.s(q,w,he=>he.provideDefinition(m.URI.revive(V),J,Q),[],Q)}registerDeclarationProvider(q,V,J){const Q=this.t(new d(this.h,J),q);return this.e.$registerDeclarationSupport(Q,this.o(V,q)),this.p(Q)}$provideDeclaration(q,V,J,Q){return this.s(q,d,he=>he.provideDeclaration(m.URI.revive(V),J,Q),[],Q)}registerImplementationProvider(q,V,J){const Q=this.t(new D(this.h,J),q);return this.e.$registerImplementationSupport(Q,this.o(V,q)),this.p(Q)}$provideImplementation(q,V,J,Q){return this.s(q,D,he=>he.provideImplementation(m.URI.revive(V),J,Q),[],Q)}registerTypeDefinitionProvider(q,V,J){const Q=this.t(new p(this.h,J),q);return this.e.$registerTypeDefinitionSupport(Q,this.o(V,q)),this.p(Q)}$provideTypeDefinition(q,V,J,Q){return this.s(q,p,he=>he.provideTypeDefinition(m.URI.revive(V),J,Q),[],Q)}registerHoverProvider(q,V,J,Q){const he=this.t(new k(this.h,J),q);return this.e.$registerHoverProvider(he,this.o(V,q)),this.p(he)}$provideHover(q,V,J,Q){return this.s(q,k,he=>he.provideHover(m.URI.revive(V),J,Q),void 0,Q)}registerEvaluatableExpressionProvider(q,V,J,Q){const he=this.t(new y(this.h,J),q);return this.e.$registerEvaluatableExpressionProvider(he,this.o(V,q)),this.p(he)}$provideEvaluatableExpression(q,V,J,Q){return this.s(q,y,he=>he.provideEvaluatableExpression(m.URI.revive(V),J,Q),void 0,Q)}registerInlineValuesProvider(q,V,J,Q){const he=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,pe=this.t(new P(this.h,J),q);this.e.$registerInlineValuesProvider(pe,this.o(V,q),he);let ze=this.p(pe);if(he!==void 0){const Ve=J.onDidChangeInlineValues(Ze=>this.e.$emitInlineValuesEvent(he));ze=s.$RM.from(ze,Ve)}return ze}$provideInlineValues(q,V,J,Q,he){return this.s(q,P,pe=>pe.provideInlineValues(m.URI.revive(V),J,Q,he),void 0,he)}registerDocumentHighlightProvider(q,V,J){const Q=this.t(new I(this.h,J),q);return this.e.$registerDocumentHighlightProvider(Q,this.o(V,q)),this.p(Q)}registerMultiDocumentHighlightProvider(q,V,J){const Q=this.t(new F(this.h,J),q);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(V,q)),this.p(Q)}$provideDocumentHighlights(q,V,J,Q){return this.s(q,I,he=>he.provideDocumentHighlights(m.URI.revive(V),J,Q),void 0,Q)}$provideMultiDocumentHighlights(q,V,J,Q,he){return this.s(q,F,pe=>pe.provideMultiDocumentHighlights(m.URI.revive(V),J,Q.map(ze=>m.URI.revive(ze)),he),void 0,he)}registerLinkedEditingRangeProvider(q,V,J){const Q=this.t(new j(this.h,J),q);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(V,q)),this.p(Q)}$provideLinkedEditingRanges(q,V,J,Q){return this.s(q,j,async he=>{const pe=await he.provideLinkedEditingRanges(m.URI.revive(V),J,Q);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?Ie.w(pe.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(q,V,J){const Q=this.t(new z(this.h,J),q);return this.e.$registerReferenceSupport(Q,this.o(V,q)),this.p(Q)}$provideReferences(q,V,J,Q,he){return this.s(q,z,pe=>pe.provideReferences(m.URI.revive(V),J,Q,he),void 0,he)}registerCodeActionProvider(q,V,J,Q){const he=new b.$Tc,pe=this.t(new O(this.h,this.j.converter,this.k,J,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(pe,this.o(V,q),{providedKinds:Q?.providedCodeActionKinds?.map(ze=>ze.value),documentation:Q?.documentation?.map(ze=>({kind:ze.kind.value,command:this.j.converter.toInternal(ze.command,he)}))},Ie.u(q),!!J.resolveCodeAction),he.add(this.p(pe)),he}$provideCodeActions(q,V,J,Q,he){return this.s(q,O,pe=>pe.provideCodeActions(m.URI.revive(V),J,Q,he),void 0,he)}$resolveCodeAction(q,V,J){return this.s(q,O,Q=>Q.resolveCodeAction(V,J),{},void 0)}$releaseCodeActions(q,V){this.s(q,O,J=>Promise.resolve(J.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,J){const Q=this.t(new B(this.h,J),q);return this.e.$registerDocumentFormattingSupport(Q,this.o(V,q),q.identifier,q.displayName||q.name),this.p(Q)}$provideDocumentFormattingEdits(q,V,J,Q){return this.s(q,B,he=>he.provideDocumentFormattingEdits(m.URI.revive(V),J,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(q,V,J){const Q=typeof J.provideDocumentRangesFormattingEdits=="function",he=this.t(new W(this.h,J),q);return this.e.$registerRangeFormattingSupport(he,this.o(V,q),q.identifier,q.displayName||q.name,Q),this.p(he)}$provideDocumentRangeFormattingEdits(q,V,J,Q,he){return this.s(q,W,pe=>pe.provideDocumentRangeFormattingEdits(m.URI.revive(V),J,Q,he),void 0,he)}$provideDocumentRangesFormattingEdits(q,V,J,Q,he){return this.s(q,W,pe=>pe.provideDocumentRangesFormattingEdits(m.URI.revive(V),J,Q,he),void 0,he)}registerOnTypeFormattingEditProvider(q,V,J,Q){const he=this.t(new X(this.h,J),q);return this.e.$registerOnTypeFormattingSupport(he,this.o(V,q),Q,q.identifier),this.p(he)}$provideOnTypeFormattingEdits(q,V,J,Q,he,pe){return this.s(q,X,ze=>ze.provideOnTypeFormattingEdits(m.URI.revive(V),J,Q,he,pe),void 0,pe)}registerWorkspaceSymbolProvider(q,V){const J=this.t(new x(V,this.l),q);return this.e.$registerNavigateTypeSupport(J,typeof V.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(q,V,J){return this.s(q,x,Q=>Q.provideWorkspaceSymbols(V,J),{symbols:[]},J)}$resolveWorkspaceSymbol(q,V,J){return this.s(q,x,Q=>Q.resolveWorkspaceSymbol(V,J),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,x,J=>J.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,J){const Q=this.t(new Z(this.h,J,this.l),q);return this.e.$registerRenameSupport(Q,this.o(V,q),Z.supportsResolving(J)),this.p(Q)}$provideRenameEdits(q,V,J,Q,he){return this.s(q,Z,pe=>pe.provideRenameEdits(m.URI.revive(V),J,Q,he),void 0,he)}$resolveRenameLocation(q,V,J,Q){return this.s(q,Z,he=>he.resolveRenameLocation(m.URI.revive(V),J,Q),void 0,Q)}registerNewSymbolNamesProvider(q,V,J){const Q=this.t(new Y(this.h,J,this.l),q);return this.e.$registerNewSymbolNamesProvider(Q,this.o(V,q)),this.p(Q)}$provideNewSymbolNames(q,V,J,Q){return this.s(q,Y,he=>he.provideNewSymbolNames(m.URI.revive(V),J,Q),void 0,Q)}registerDocumentSemanticTokensProvider(q,V,J,Q){const he=this.t(new te(this.h,J),q),pe=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(V,q),Q,pe);let ze=this.p(he);if(pe){const Ve=J.onDidChangeSemanticTokens(Ze=>this.e.$emitDocumentSemanticTokensEvent(pe));ze=s.$RM.from(ze,Ve)}return ze}$provideDocumentSemanticTokens(q,V,J,Q){return this.s(q,te,he=>he.provideDocumentSemanticTokens(m.URI.revive(V),J,Q),null,Q)}$releaseDocumentSemanticTokens(q,V){this.s(q,te,J=>J.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,J,Q){const he=this.t(new we(this.h,J),q);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(V,q),Q),this.p(he)}$provideDocumentRangeSemanticTokens(q,V,J,Q){return this.s(q,we,he=>he.provideDocumentRangeSemanticTokens(m.URI.revive(V),J,Q),null,Q)}registerCompletionItemProvider(q,V,J,Q){const he=this.t(new Se(this.h,this.j.converter,J,this.m,q),q);return this.e.$registerCompletionsProvider(he,this.o(V,q),Q,Se.supportsResolving(J),q.identifier),this.p(he)}$provideCompletionItems(q,V,J,Q,he){return this.s(q,Se,pe=>pe.provideCompletionItems(m.URI.revive(V),J,Q,he),void 0,he)}$resolveCompletionItem(q,V,J){return this.s(q,Se,Q=>Q.resolveCompletionItem(V,J),void 0,J)}$releaseCompletionItems(q,V){this.s(q,Se,J=>J.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,J,Q){const he=new U(q,this.h,J,this.j.converter),pe=this.t(he,q);return this.e.$registerInlineCompletionsSupport(pe,this.o(V,q),he.supportsHandleEvents,n.$Lm.toKey(q.identifier.value),Q?.yieldTo?.map(ze=>n.$Lm.toKey(ze))||[]),this.p(pe)}$provideInlineCompletions(q,V,J,Q,he){return this.s(q,_,pe=>pe.provideInlineCompletions(m.URI.revive(V),J,Q,he),void 0,he)}$handleInlineCompletionDidShow(q,V,J,Q){this.s(q,_,async he=>{he.handleDidShowCompletionItem(V,J,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,J,Q,he){this.s(q,_,async pe=>{pe.handlePartialAccept(V,J,Q,he)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,_,async J=>{J.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,J){const Q=new ne(q,this.h,J,this.j.converter),he=this.t(Q,q);return this.e.$registerInlineEditProvider(he,this.o(V,q),q.identifier),this.p(he)}$provideInlineEdit(q,V,J,Q){return this.s(q,ne,he=>he.provideInlineEdits(m.URI.revive(V),J,Q),void 0,Q)}$freeInlineEdit(q,V){this.s(q,ne,async J=>{J.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,J,Q){const he=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,pe=this.t(new Pe(this.h,J),q);return this.e.$registerSignatureHelpProvider(pe,this.o(V,q),he),this.p(pe)}$provideSignatureHelp(q,V,J,Q,he){return this.s(q,Pe,pe=>pe.provideSignatureHelp(m.URI.revive(V),J,Q,he),void 0,he)}$releaseSignatureHelp(q,V){this.s(q,Pe,J=>J.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,J){const Q=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new se(this.h,this.j.converter,J,this.l,q),q);this.e.$registerInlayHintsProvider(he,this.o(V,q),typeof J.resolveInlayHint=="function",Q,Ie.u(q));let pe=this.p(he);if(Q!==void 0){const ze=J.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(Q));pe=s.$RM.from(pe,ze)}return pe}$provideInlayHints(q,V,J,Q){return this.s(q,se,he=>he.provideInlayHints(m.URI.revive(V),J,Q),void 0,Q)}$resolveInlayHint(q,V,J){return this.s(q,se,Q=>Q.resolveInlayHint(V,J),void 0,J)}$releaseInlayHints(q,V){this.s(q,se,J=>J.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,J){const Q=this.t(new re(this.h,J),q);return this.e.$registerDocumentLinkProvider(Q,this.o(V,q),typeof J.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(q,V,J){return this.s(q,re,Q=>Q.provideLinks(m.URI.revive(V),J),void 0,J,V.scheme==="output")}$resolveDocumentLink(q,V,J){return this.s(q,re,Q=>Q.resolveLink(V,J),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,re,J=>J.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,J){const Q=this.t(new oe(this.h,J),q);return this.e.$registerDocumentColorProvider(Q,this.o(V,q)),this.p(Q)}$provideDocumentColors(q,V,J){return this.s(q,oe,Q=>Q.provideColors(m.URI.revive(V),J),[],J)}$provideColorPresentations(q,V,J,Q){return this.s(q,oe,he=>he.provideColorPresentations(m.URI.revive(V),J,Q),void 0,Q)}registerFoldingRangeProvider(q,V,J){const Q=this.q(),he=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new De(new G(this.h,J),q)),this.e.$registerFoldingRangeProvider(Q,this.o(V,q),q.identifier,he);let pe=this.p(Q);if(he!==void 0){const ze=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));pe=s.$RM.from(pe,ze)}return pe}$provideFoldingRanges(q,V,J,Q){return this.s(q,G,he=>he.provideFoldingRanges(m.URI.revive(V),J,Q),void 0,Q)}registerSelectionRangeProvider(q,V,J){const Q=this.t(new ie(this.h,J,this.l),q);return this.e.$registerSelectionRangeProvider(Q,this.o(V,q)),this.p(Q)}$provideSelectionRanges(q,V,J,Q){return this.s(q,ie,he=>he.provideSelectionRanges(m.URI.revive(V),J,Q),[],Q)}registerCallHierarchyProvider(q,V,J){const Q=this.t(new me(this.h,J),q);return this.e.$registerCallHierarchyProvider(Q,this.o(V,q)),this.p(Q)}$prepareCallHierarchy(q,V,J,Q){return this.s(q,me,he=>Promise.resolve(he.prepareSession(m.URI.revive(V),J,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(q,V,J,Q){return this.s(q,me,he=>he.provideCallsTo(V,J,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(q,V,J,Q){return this.s(q,me,he=>he.provideCallsFrom(V,J,Q),void 0,Q)}$releaseCallHierarchy(q,V){this.s(q,me,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,J){const Q=this.t(new be(this.h,J),q);return this.e.$registerTypeHierarchyProvider(Q,this.o(V,q)),this.p(Q)}$prepareTypeHierarchy(q,V,J,Q){return this.s(q,be,he=>Promise.resolve(he.prepareSession(m.URI.revive(V),J,Q)),void 0,Q)}$provideTypeHierarchySupertypes(q,V,J,Q){return this.s(q,be,he=>he.provideSupertypes(V,J,Q),void 0,Q)}$provideTypeHierarchySubtypes(q,V,J,Q){return this.s(q,be,he=>he.provideSubtypes(V,J,Q),void 0,Q)}$releaseTypeHierarchy(q,V){this.s(q,be,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,J,Q){const he=this.q();return this.f.set(he,new De(new Ae(this.e,this.h,J,he,q),q)),this.e.$registerDocumentOnDropEditProvider(he,this.o(V,q),(0,o.$xG)(q,"documentPaste")&&Q?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(q,V,J,Q,he,pe){return this.s(q,Ae,ze=>Promise.resolve(ze.provideDocumentOnDropEdits(V,m.URI.revive(J),Q,he,pe)),void 0,void 0)}$resolveDropEdit(q,V,J){return this.s(q,Ae,Q=>Q.resolveDropEdit(V,J),{},void 0)}$releaseDropEdits(q,V){this.s(q,Ae,J=>Promise.resolve(J.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(q,V,J){const Q=this.t(new fe(this.h,J),q);return this.e.$registerMappedEditsProvider(Q,this.o(V,q)),this.p(Q)}$provideMappedEdits(q,V,J,Q,he){return this.s(q,fe,pe=>Promise.resolve(pe.provideMappedEdits(V,J,Q,he)),null,he)}registerDocumentPasteEditProvider(q,V,J,Q){const he=this.q();return this.f.set(he,new De(new T(this.e,this.h,J,he,q),q)),this.e.$registerPasteEditProvider(he,this.o(V,q),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(pe=>pe.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(q,V,J,Q,he){return this.s(q,T,pe=>pe.prepareDocumentPaste(m.URI.revive(V),J,Q,he),void 0,he)}$providePasteEdits(q,V,J,Q,he,pe,ze){return this.s(q,T,Ve=>Ve.providePasteEdits(V,m.URI.revive(J),Q,he,pe,ze),void 0,ze)}$resolvePasteEdit(q,V,J){return this.s(q,T,Q=>Q.resolvePasteEdit(V,J),{},void 0)}$releasePasteEdits(q,V){this.s(q,T,J=>Promise.resolve(J.releasePasteEdits(V)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Ie.w(q.decreaseIndentPattern),increaseIndentPattern:Ie.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ie.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ie.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Ie.w(q.beforeText),afterText:q.afterText?Ie.w(q.afterText):void 0,previousLineText:q.previousLineText?Ie.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Ie.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>s.SyntaxTokenType.toString(V)):void 0}}static D(q){return q.map(Ie.C)}setLanguageConfiguration(q,V,J){const{wordPattern:Q}=J;if(Q&&(0,A.$ff)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(V,Q):this.h.setWordDefinitionFor(V,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const he=this.q(),pe={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ie.w(J.wordPattern):void 0,indentationRules:J.indentationRules?Ie.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ie.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ie.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,V,pe),this.p(he)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$nkc=Ie}),define(ke[121],Ee([1,0,22,3,6,16,7,108,25,8,4,222,145,13,5,20,120,12,39]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=e.$7kc=void 0,e.$7kc=(0,v.$qi)("IExtHostLanguageModels");class s{constructor(h,c){this.option=h,this.stream=new S.$Th,this.stream=c??new S.$Th}}class o{constructor(){this.a=new Map,this.b=new S.$Th,this.c=!1,this.d=!1;const h=this;this.apiObject={stream:h.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;this.d=!0;let c=this.a.get(h.index);c||(this.a.size===0?c=new s(h.index,this.b):c=new s(h.index),this.a.set(h.index,c)),c.stream.emitOne(h.part)}get isStreaming(){return this.d}reject(h){this.c=!0;for(const c of this.f())c.reject(h)}resolve(){this.c=!0;for(const h of this.f())h.resolve()}}let t=class{static{i=this}static{this.a=1}constructor(h,c,r){this.j=c,this.k=r,this.c=new A.$be,this.d=new A.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new $.$Nm,this.i=new Map,this.o=new Set,this.b=h.getProxy(L.$PM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,c,r,w){const d=i.a++;this.f.set(d,{extension:h.identifier,provider:r,languageModelId:c});let D;return w.auth&&(D={providerLabel:h.displayName||h.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(d,c,{extension:h.identifier,identifier:c,model:w.name??"",auth:D}),(0,N.$Sc)(()=>{this.f.delete(d),this.b.$unregisterProvider(d)})}async $provideLanguageModelResponse(h,c,r,w,d,D){const p=this.f.get(h);if(!p)return;const k=new b.$Zv(async y=>{if(D.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(c,{index:y.index,part:y.part})});return p.provider.provideLanguageModelResponse2(w.map(R.LanguageModelMessage.to),d,$.$Lm.toKey(r),k,D)}$provideTokenLength(h,c,r){const w=this.f.get(h);return w?Promise.resolve(w.provider.provideTokenCount(c,r)):Promise.resolve(0)}$updateLanguageModels(h){const c=[],r=[];if(h.added)for(const w of h.added)this.g.set(w.identifier,w),c.push(w.model);if(h.removed)for(const w of h.removed){this.g.delete(w),r.push(w);for(const[d,D]of this.i)D.languageModelId===w&&(D.res.reject(new E.$5),this.i.delete(d))}this.d.fire(Object.freeze({added:Object.freeze(c),removed:Object.freeze(r)})),h.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(h){const c=new Array;for(const{from:r,to:w,enabled:d}of h){const D=this.h.get(r)??new $.$Mm;if(D.has(w)!==d){d?D.add(w):D.delete(w),this.h.set(r,D);const k={from:r,to:w};c.push(k),this.c.fire(k)}}}async sendChatRequest(h,c,r,w,d){const D=h.identifier,p=await this.b.$prepareChatAccess(D,c,w.justification);if(!p||!this.g.has(c))throw M.$2O.NotFound(`Language model '${c}' is unknown.`);if(this.m(D,p)&&(!await this.l(h,{identifier:p.extension,displayName:p.auth.providerLabel},w.justification,w.silent)||!this.h.get(D)?.has(p.extension)))throw M.$2O.NoPermissions(`Language model '${c}' cannot be used by '${D.value}'.`);const k=Math.random()*1e6|0,y=this.b.$fetchResponse(D,c,k,r.map(R.LanguageModelMessage.from),w.modelOptions??{},d),P=new S.$ph,I=new o;this.i.set(k,{languageModelId:c,res:I});let F;if(y.catch(j=>{P.isOpen()?I.reject(j):F=j}).finally(()=>{this.i.delete(k),I.resolve(),P.open()}),await P.wait(),F)throw new M.$2O(`Language model '${c}' errored, check cause for more details`,"Unknown",F);return I.apiObject}async $handleResponseFragment(h,c){const r=this.i.get(h);r&&r.res.handleFragment(c)}async l(h,c,r,w){const d=m.$RL+c.identifier.value;if(await this.k.getSession(h,d,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:c.identifier,enabled:!0}]),!0;if(w)return!1;try{const p=r?(0,C.localize)(0,null,c.displayName,r):(0,C.localize)(1,null,c.displayName);return await this.k.getSession(h,d,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:h.identifier,to:c.identifier,enabled:!0}]),!0}catch{return!1}}m(h,c){return!!c.auth&&!$.$Lm.equals(c.extension,h)}async n(h){for(const c of this.o)try{await this.l(c,{identifier:h.extension,displayName:""},void 0,!0)}catch(r){this.j.error("Fake Auth request failed"),this.j.error(r)}}createLanguageModelAccessInformation(h){this.o.add(h);const c=this,r=A.Event.signal(A.Event.filter(this.c.event,d=>$.$Lm.equals(d.from,h.identifier))),w=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(r,w)},canSendRequest(d){const D=c.g.get(d);if(!D)return;if(!c.m(h.identifier,D))return!0;const p=c.h.get(h.identifier);if(p)return p.has(D.extension)},async computeTokenLength(d,D,p){p??=l.CancellationToken.None;const k=c.g.get(d);if(!k)throw M.$2O.NotFound(`Language model '${d}' is unknown.`);const y=n.Iterable.find(c.f.values(),P=>P.languageModelId===d);return y?y.provider.provideTokenCount(D,p):c.b.$countTokens(k.identifier,D,p)}}}};e.$8kc=t,e.$8kc=t=i=Je([qe(0,u.$cP),qe(1,a.$Wj),qe(2,f.$pkc)],t)}),define(ke[339],Ee([1,0,6,16,7,41,8,3,26]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class S{constructor(C,m,E,v){this.c=m,this.d=E,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(l.$PM.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const E=this.c.getDocumentData(C);if(!E)throw new Error(`document '${C.toString()}' NOT found`);return E.document}async tokenAtPosition(C,m){const E=C.version,v=N.Position.from(m),u=await this.a.$tokensAtPosition(C.uri,v),f={type:L.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new L.$TM(m.line,m.character,m.line,m.character)};if(!u)return f;const a={range:N.Range.to(u.range),type:N.TokenType.to(u.type)};return!a.range.contains(m)||E!==C.version?f:a}createLanguageStatusItem(C,m,E){const v=this.f++,u=this.a,f=this.g,a=`${C.identifier.value}/${m}`;if(f.has(a))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(a);const n={selector:E,id:m,name:C.displayName??C.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new b.$Tc,o=()=>{if(i?.dispose(),!f.has(a)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$sh)(()=>{s.clear(),this.a.$setLanguageStatus(v,{id:a,name:n.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?R.default.Error:n.severity===L.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,s),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){s.dispose(),i?.dispose(),u.$removeLanguageStatus(v),f.delete(a)},get id(){return n.id},get name(){return n.name},set name(g){n.name=g,o()},get selector(){return n.selector},set selector(g){n.selector=g,o()},get text(){return n.text},set text(g){n.text=g,o()},set text2(g){(0,$.$yG)(C,"languageStatusText"),n.text=g,o()},get text2(){return(0,$.$yG)(C,"languageStatusText"),n.text},get detail(){return n.detail},set detail(g){n.detail=g,o()},get severity(){return n.severity},set severity(g){n.severity=g,o()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(g){n.accessibilityInformation=g,o()},get command(){return n.command},set command(g){n.command=g,o()},get busy(){return n.busy},set busy(g){n.busy=g,o()}};return o(),t}}e.$Mlc=S}),define(ke[340],Ee([1,0,15,2,16,7,119]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=void 0;class b{constructor(C,m,E,v){this.start=C,this.deletedCount=m,this.deletedItems=E,this.items=v}asApiEvent(){return{range:new R.$gO(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,m,E){this.notebook=C,this.h=m,this.j=E,this.handle=E.handle,this.uri=N.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(L.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(v){C.g=v},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(E)}return this.f}setOutputs(C){this.a=C.map(L.NotebookCellOutput.to)}setOutputItems(C,m,E){const v=E.map(L.NotebookCellOutputItem.to),u=this.a.find(f=>f.id===C);if(u&&(m||(u.items.length=0),u.items.push(...v),u.items.length>1&&u.items.every(f=>M.$MK(f.mime)))){const f=new Map,a=[];u.items.forEach(n=>{let i;f.has(n.mime)?i=f.get(n.mime):(i=[],f.set(n.mime,i),a.push(n.mime)),i.push(n.data)}),u.items.length=0,a.forEach(n=>{const i=M.$NK(f.get(n));u.items.push({mime:n,data:i.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$ylc=$;class S{static{this.a=0}constructor(C,m,E,v,u){this.k=C,this.l=m,this.m=E,this.uri=v,this.handle=S.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===l.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(E){return E=C.n(E),C.b[E].apiCell},getCells(E){return(E?C.p(E):C.b).map(u=>u.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,E){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:E});const v={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},u=[];for(const a of C.rawEvents)a.kind===M.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,v.contentChanges):a.kind===M.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,v.contentChanges):a.kind===M.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),u.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===M.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),u.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),u.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===M.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),u.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),u.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const f=new Map;for(let a=0;a<u.length;a++){const n=u[a],i=f.get(n.cell);if(i===void 0){const s=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});f.set(n.cell,s-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,E=C.end|0;return m<0&&(m=0),E>this.b.length&&(E=this.b.length),C.with({start:m,end:E})}p(C){C=this.o(C);const m=[];for(let E=C.start;E<C.end;E++)m.push(this.b[E]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,E){if(this.j)return;const v=[],u=[],f=[];if(C.reverse().forEach(a=>{const i=a[2].map(t=>{const g=new $(this,this.l,t);return m||u.push($.asModelAddData(t)),g}),s=new b(a[0],a[1],[],i),o=this.b.splice(a[0],a[1],...i);for(const t of o)f.push(t.uri),s.deletedItems.push(t.apiCell);v.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:f}),E)for(const a of v)E.push(a.asApiEvent())}s(C,m,E,v){const u=this.b.splice(C,m);this.b.splice(E,0,...u);const f=[new b(C,m,u.map(a=>a.apiCell),[]),new b(E,0,[],u)];for(const a of f)v.push(a.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,E,v){this.b[C].setOutputItems(m,E,v)}v(C,m){const E=this.b[C];E.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(E.uri,m)}w(C,m){const E=this.b[C];E.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$zlc=S}),define(ke[341],Ee([1,0,4,2,16,7,48]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0;class b{constructor(S,A,C,m={timeout:1500,errors:3}){this.b=S,this.c=A,this.d=C,this.f=m,this.a=new l.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(A,C,m)=>{const E=function(u){A.call(C,u)};return E.extension=S,this.a.event(E,void 0,m)}}async $participateInSave(S,A,C){const m=N.URI.revive(S),E=this.c.getNotebookDocument(m);if(!E)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:L.TextDocumentSaveReason.to(A)},C,async(f,a)=>{const n=Date.now(),i=await await Promise.resolve(f);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!C.isCancellationRequested&&i&&(i instanceof R.$2M?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),C.isCancellationRequested)return!1;if(v.length===0)return!0;const u={edits:[]};for(const f of v){const{edits:a}=L.WorkspaceEdit.from(f);u.edits=u.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new M.$mw(u))}}e.$Olc=b}),define(ke[153],Ee([1,0,13,16,7]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,S,A,C,m){this.id=b,this.f=$,this.notebookData=S,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=A,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(L.$gO.isNotebookRange))throw(0,l.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,S){b.f.$tryRevealRange(b.id,N.NotebookRange.from($),S??L.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(N.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Alc=R}),define(ke[342],Ee([1,0,4,12,16]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;let R=class{constructor(b,$){this.c=b,this.d=$,this.a=new l.$be,this.b=new l.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const S=this.d.getEditorById(b);$.visibleRanges&&S._acceptVisibleRanges($.visibleRanges.ranges.map(L.NotebookRange.to)),$.selections&&S._acceptSelections($.selections.selections.map(L.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(L.ViewColumn.to(b[$]))}};e.$Qlc=R,e.$Qlc=R=Je([qe(0,N.$Wj)],R)}),define(ke[343],Ee([1,0,4,6,153]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=void 0;class R{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(N.$PM.MainThreadNotebookRenderers)}$postRendererMessage(b,$,S){const A=this.c.getEditorById(b);this.a.get($)?.fire({editor:A.apiEditor,message:S})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,C,m)=>this.d($).event(A,C,m),postMessage:(A,C)=>{L.$Alc.apiEditorsToExtHost.has(A)&&([A,C]=[C,A]);const m=C&&L.$Alc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,A)}}}d(b){let $=this.a.get(b);return $||($=new l.$be({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$Tlc=R}),define(ke[344],Ee([1,0,16,108,22,55,13]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;class b{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,m,E){const v=this.b++,{title:u,location:f,cancellable:a}=m,n={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(v,{location:l.ProgressLocation.from(f),title:u,source:n,cancellable:a},C.isUnderDevelopment?void 0:C.identifier.value).catch(M.$2),this.d(v,E,!!a)}d(C,m,E){let v;E&&(v=new L.$me,this.c.set(C,v));const u=a=>{this.a.$progressEnd(a),this.c.delete(a),v?.dispose()};let f;try{f=m(new S(this.a,C),E&&v?v.token:L.CancellationToken.None)}catch(a){throw u(C),a}return f.then(a=>u(C),a=>u(C)),f}$acceptProgressCanceled(C){const m=this.c.get(C);m&&(m.cancel(),this.c.delete(C))}}e.$Xlc=b;function $(A,C){return A.message=C.message,typeof C.increment=="number"&&(typeof A.increment=="number"?A.increment+=C.increment:A.increment=C.increment),A}class S extends N.$Zv{constructor(C,m){super(E=>this.throttledReport(E)),this.c=C,this.d=m}throttledReport(C){this.c.$progressReport(this.d,C)}}Je([(0,R.$Wh)(100,(A,C)=>$(A,C),()=>Object.create(null))],S.prototype,"throttledReport",null)}),define(ke[345],Ee([1,0,2,6,8,16]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;class M{static{this.a=0}constructor($,S){this.d=S,this.c=new Map,this.b=$.getProxy(N.$PM.MainThreadQuickDiff)}$provideOriginalResource($,S,A){const C=l.URI.revive(S),m=this.c.get($);return m?(0,L.$ih)(()=>m.provideOriginalResource(C,A)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider($,S,A,C){const m=M.a++;return this.c.set(m,S),this.b.$registerQuickDiffProvider(m,R.DocumentSelector.from($,this.d),A,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$Ylc=M}),define(ke[346],Ee([1,0,22,4,3,6,2,7,13,19,41,57,26,16]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=v;function v(u,f,a){const n=u.getProxy(R.$PM.MainThreadQuickOpen);class i{constructor(d,D){this.e=new Map,this.f=0,this.a=d,this.b=D}showQuickPick(d,D,p,k=l.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),P=++this.f,I=n.$show(P,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},k),F={},j=I.then(()=>F);return Promise.race([j,y]).then(z=>{if(z===F)return;const O=(0,m.$xG)(d,"quickPickItemTooltip");return y.then(T=>{const B=[];for(let W=0;W<T.length;W++){const X=T[W];if(typeof X=="string")B.push({label:X,handle:W});else if(X.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:X.label});else{X.tooltip&&!O&&console.warn(`Extension '${d.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`);const x=X.iconPath?h(X.iconPath):void 0;B.push({label:X.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:X.description,detail:X.detail,picked:X.picked,alwaysShow:X.alwaysShow,tooltip:O?E.MarkdownString.fromStrict(X.tooltip):void 0,handle:W})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=W=>{p.onDidSelectItem(T[W])}),n.$setItems(P,B),I.then(W=>{if(typeof W=="number")return T[W];if(Array.isArray(W))return W.map(X=>T[X])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return n.$setError(P,z),Promise.reject(z)})}$onItemSelected(d){this.c?.(d)}showInput(d,D=l.CancellationToken.None){return this.d=d?.validateInput,n.$input(d,typeof this.d=="function",D).then(void 0,p=>{if(!(0,$.$4)(p))return Promise.reject(p)})}async $validateInput(d){if(!this.d)return;const D=await this.d(d);if(!D||typeof D=="string")return D;let p;switch(D.severity){case b.InputBoxValidationSeverity.Info:p=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:p=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:p=A.default.Error;break;default:p=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:p}}async showWorkspaceFolderPick(d,D=l.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!p)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(y=>y.uri.toString()===p.uri.toString())}createQuickPick(d){const D=new c(d,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(d){const D=new r(d,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(d,D){this.e.get(d)?._fireDidChangeValue(D)}$onDidAccept(d){this.e.get(d)?._fireDidAccept()}$onDidChangeActive(d,D){const p=this.e.get(d);p instanceof c&&p._fireDidChangeActive(D)}$onDidChangeSelection(d,D){const p=this.e.get(d);p instanceof c&&p._fireDidChangeSelection(D)}$onDidTriggerButton(d,D){this.e.get(d)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(d,D,p){const k=this.e.get(d);k instanceof c&&k._fireDidTriggerItemButton(D,p)}$onDidHide(d){this.e.get(d)?._fireDidHide()}}class s{static{this.a=1}constructor(d,D){this.x=d,this.y=D,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$be,this.q=new N.$be,this.r=new N.$be,this.s=new N.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(d){this.b=d,this.z({title:d})}get step(){return this.c}set step(d){this.c=d,this.z({step:d})}get totalSteps(){return this.d}set totalSteps(d){this.d=d,this.z({totalSteps:d})}get enabled(){return this.g}set enabled(d){this.g=d,this.z({enabled:d})}get busy(){return this.j}set busy(d){this.j=d,this.z({busy:d})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(d){this.k=d,this.z({ignoreFocusOut:d})}get value(){return this.l}set value(d){this.l=d,this.z({value:d})}get placeholder(){return this.m}set placeholder(d){this.m=d,this.z({placeholder:d})}get buttons(){return this.n}set buttons(d){this.n=d.slice(),this.o.clear(),d.forEach((D,p)=>{const k=D===b.$dO.Back?-1:p;this.o.set(k,D)}),this.z({buttons:d.map((D,p)=>({...h(D.iconPath),tooltip:D.tooltip,handle:D===b.$dO.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(d){this.l=d,this.q.fire(d)}_fireDidTriggerButton(d){const D=this.o.get(d);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(d){if(!this.v){for(const D of Object.keys(d)){const p=d[D];this.u[D]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function o(w){if(w instanceof b.$NN)return{id:w.id};const d=g(w),D=t(w);return{dark:typeof d=="string"?M.URI.file(d):d,light:typeof D=="string"?M.URI.file(D):D}}function t(w){return typeof w=="object"&&"light"in w?w.light:w}function g(w){return typeof w=="object"&&"dark"in w?w.dark:w}function h(w){const d=o(w);let D,p;return"id"in d?p=C.ThemeIcon.asClassName(d):D=d,{iconPath:D,iconClass:p}}class c extends s{constructor(d,D){super(d.identifier,D),this.O=d,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$be,this.L=[],this.M=new N.$be,this.N=new N.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(d){this.B=d.slice(),this.C.clear(),this.D.clear(),d.forEach((k,y)=>{this.C.set(y,k),this.D.set(k,y)});const D=(0,m.$xG)(this.O,"quickPickItemTooltip"),p=[];for(let k=0;k<d.length;k++){const y=d[k];if(y.kind===b.QuickPickItemKind.Separator)p.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=y.iconPath?h(y.iconPath):void 0;p.push({handle:k,label:y.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((I,F)=>({...h(I.iconPath),tooltip:I.tooltip,handle:F}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(d){this.E=d,this.z({canSelectMany:d})}get matchOnDescription(){return this.F}set matchOnDescription(d){this.F=d,this.z({matchOnDescription:d})}get matchOnDetail(){return this.G}set matchOnDetail(d){this.G=d,this.z({matchOnDetail:d})}get sortByLabel(){return this.H}set sortByLabel(d){this.H=d,this.z({sortByLabel:d})}get keepScrollPosition(){return this.I}set keepScrollPosition(d){this.I=d,this.z({keepScrollPosition:d})}get activeItems(){return this.J}set activeItems(d){this.J=d.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(d){this.L=d.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(d){const D=(0,S.$Hb)(d.map(p=>this.C.get(p)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(d){const D=(0,S.$Hb)(d.map(p=>this.C.get(p)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(d,D){const p=this.C.get(d);if(!p||!p.buttons||!p.buttons.length)return;const k=p.buttons[D];k&&this.N.fire({button:k,item:p})}}class r extends s{constructor(d,D){super(d.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(d){this.B=d,this.z({password:d})}get prompt(){return this.C}set prompt(d){this.C=d,this.z({prompt:d})}get valueSelection(){return this.D}set valueSelection(d){this.D=d,this.z({valueSelection:d})}get validationMessage(){return this.E}set validationMessage(d){this.E=d,d?typeof d=="string"?this.z({validationMessage:d,severity:A.default.Error}):this.z({validationMessage:d.message,severity:d.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(f,a)}}),define(ke[347],Ee([1,0,2,4,55,3,8,6,19,131,12,25,57,16,26,15,11]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$1lc=void 0;function n(P){return P instanceof l.URI}function i(P,I){return P.scheme===u.Schemas.file&&I.scheme===u.Schemas.file&&f.$k?P.toString()===I.toString():P.toString().toLowerCase()===I.toString().toLowerCase()}function s(P){if(P)return typeof P.iconPath=="string"?l.URI.file(P.iconPath):l.URI.isUri(P.iconPath)||m.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function o(P){if(P.icon){if(l.URI.isUri(P.icon))return P.icon;if(m.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const I=P.icon;return{light:I.light,dark:I.dark}}}else return}function t(P,I){if(!P.iconPath&&!I.iconPath)return 0;if(P.iconPath){if(!I.iconPath)return 1}else return-1;const F=typeof P.iconPath=="string"?P.iconPath:l.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,j=typeof I.iconPath=="string"?I.iconPath:l.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,S.$ir)(F,j)}function g(P,I){let F=0;if(P.strikeThrough!==I.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==I.faded)return P.faded?1:-1;if(P.tooltip!==I.tooltip)return(P.tooltip||"").localeCompare(I.tooltip||"");if(F=t(P,I),F!==0)return F;if(P.light&&I.light)F=t(P.light,I.light);else{if(P.light)return 1;if(I.light)return-1}if(F!==0)return F;if(P.dark&&I.dark)F=t(P.dark,I.dark);else{if(P.dark)return 1;if(I.dark)return-1}return F}function h(P,I){if(P.command!==I.command)return P.command<I.command?-1:1;if(P.title!==I.title)return P.title<I.title?-1:1;if(P.tooltip!==I.tooltip){if(P.tooltip!==void 0&&I.tooltip!==void 0)return P.tooltip<I.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(P.arguments===I.arguments)return 0;if(P.arguments)if(I.arguments){if(P.arguments.length!==I.arguments.length)return P.arguments.length-I.arguments.length}else return 1;else return-1;for(let F=0;F<P.arguments.length;F++){const j=P.arguments[F],z=I.arguments[F];if(j!==z&&!(n(j)&&n(z)&&i(j,z)))return j<z?-1:1}return 0}function c(P,I){let F=(0,S.$ir)(P.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(F!==0)return F;if(P.command&&I.command)F=h(P.command,I.command);else{if(P.command)return 1;if(I.command)return-1}if(F!==0)return F;if(P.decorations&&I.decorations)F=g(P.decorations,I.decorations);else{if(P.decorations)return 1;if(I.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)F=(0,S.$ir)(P.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)F=(0,S.$ir)(P.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return F}function r(P,I){for(let F=0;F<P.length;F++)if(P[F]!==I[F])return!1;return!0}function w(P,I){return P.command===I.command&&P.title===I.title&&P.tooltip===I.tooltip&&(P.arguments&&I.arguments?r(P.arguments,I.arguments):P.arguments===I.arguments)}function d(P,I){return(0,$.$ub)(P,I,w)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,v.$yG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,v.$yG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,v.$yG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,F,j,z,O){this.k=I,this.l=z,this.m=O,this.d="",this.e=new N.$be,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=j}showValidationMessage(I,F){(0,v.$yG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,F)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$1lc=D;class p{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,F,j,z,O,T,B){this.q=I,this.s=F,this.t=j,this.u=z,this.v=O,this.multiDiffEditorEnableViewChanges=T,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=p.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,F){const j=this.h.get(I);return j?(0,M.$ih)(()=>this.s.executeCommand(j.command,...j.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(c),j=(0,$.$Db)(this.o,I,c).map(T=>{const B=T.toInsert.map(W=>{const X=this.e++;this.g.set(X,W);const x=W.resourceUri;let Z;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const oe=new R.$Tc;Z=this.s.converter.toInternal(W.command,oe),this.j.set(X,oe)}else this.h.set(X,W.command);const Y=(0,v.$xG)(this.w,"scmMultiDiffEditor"),ue=Y?W.multiDiffEditorOriginalUri:void 0,te=Y?W.multiFileDiffEditorModifiedUri:void 0,we=s(W.decorations),Se=W.decorations&&s(W.decorations.light)||we,_=W.decorations&&s(W.decorations.dark)||we,U=[Se,_],ne=W.decorations&&W.decorations.tooltip||"",$e=W.decorations&&!!W.decorations.strikeThrough,Pe=W.decorations&&!!W.decorations.faded,se=W.contextValue||"";return{rawResource:[X,x,U,ne,$e,Pe,se,Z,ue,te],handle:X}});return{start:T.start,deleteCount:T.deleteCount,toInsert:B}}),z=j.map(({start:T,deleteCount:B,toInsert:W})=>[T,B,W.map(X=>X.rawResource)]),O=j.reverse();for(const{start:T,deleteCount:B,toInsert:W}of O){const X=W.map(Z=>Z.handle),x=this.n.splice(T,B,...X);for(const Z of x)this.g.delete(Z),this.h.delete(Z),this.j.get(Z)?.dispose(),this.j.delete(Z)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let F;(0,v.$xG)(this.x,"quickDiffProvider")&&(F=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:F})}get historyProvider(){return(0,v.$yG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,v.$yG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Tc,this.o=I;const F=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,v.$yG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,v.$yG)(this.x,"scmActionButton"),this.p.value=new R.$Tc,this.q=I;const F=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(j=>j.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&d(this.t,I))return;this.s.value=new R.$Tc,this.t=I;const F=(I||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(I,F,j,z,O,T,B){this.x=I,this.y=z,this.z=O,this.A=T,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.m=void 0,this.n=new R.$Vc,this.o=void 0,this.p=new R.$Vc,this.s=new R.$Vc,this.t=void 0,this.u=!1,this.v=new N.$be,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=j;const W=l.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new D(I,F,this.#e,this.w,W),this.#e.$registerSourceControl(this.w,O,T,B,W)}createResourceGroup(I,F,j){const z=(0,v.$xG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,O=new p(this.#e,this.y,this.w,I,F,z,this.x),T=N.Event.once(O.onDidDispose)(()=>this.C.delete(O));return this.C.set(O,T),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const I=[],F=[];for(const[j,z]of this.C){z.dispose();const O=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});N.Event.once(j.onDidDispose)(()=>{this.D.delete(j),O.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),I.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const T=j._takeResourceStateSnapshot();T.length>0&&F.push([j.handle,T]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,I,F),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(F=>{const j=F._takeResourceStateSnapshot();j.length!==0&&I.push([F.handle,j])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,L.$Vh)(100)],k.prototype,"eventuallyAddResourceGroups",null),Je([(0,L.$Vh)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,F,j,z){this.l=F,this.m=j,this.n=z,this.g=new Map,this.h=new C.$Nm,this.j=new N.$be,this.e=I.getProxy(b.$PM.MainThreadSCM),this.f=I.getProxy(b.$PM.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const T=this.g.get(O.sourceControlHandle);if(!T)return O;const B=T.getResourceGroup(O.groupHandle);return B?B.getResourceState(O.handle):O}else if(O&&O.$mid===4){const T=this.g.get(O.sourceControlHandle);return T?T.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const T=this.g.get(O.handle);return T||O}return O}})}createSourceControl(I,F,j,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,F,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const O=a.d++,T=new k(I,this.m,this.e,this.l,F,j,z);this.g.set(O,T);const B=this.h.get(I.identifier)||[];return B.push(T),this.h.set(I.identifier,B),T}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const F=this.h.get(I.identifier),j=F&&F[F.length-1];return j&&j.inputBox}$provideOriginalResource(I,F,j){const z=l.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const O=this.g.get(I);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ih)(()=>O.quickDiffProvider.provideOriginalResource(z,j)).then(T=>T||null)}$onInputBoxValueChange(I,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const j=this.g.get(I);return j&&j.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(I,F,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,F,j);const O=this.g.get(I);if(!O)return Promise.resolve(void 0);const T=O.getResourceGroup(F);return T?T.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(I,F,j){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ih)(()=>z.inputBox.validateInput(F,j)).then(O=>{if(!O)return Promise.resolve(void 0);const T=E.MarkdownString.fromStrict(O.message);return T?Promise.resolve([T,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,F,j,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,j,z)??void 0}async $provideHistoryItems(I,F,j,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(F,j,z))?.map(B=>({...B,icon:o(B)}))??void 0}async $provideHistoryItemSummary(I,F,j,z){const O=this.g.get(I)?.historyProvider;if(typeof O?.provideHistoryItemSummary!="function")return;const T=await O.provideHistoryItemSummary(F,j,z);return T?{...T,icon:o(T)}:void 0}async $provideHistoryItemChanges(I,F,j,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(F,j,z)??void 0}};e.$2lc=y,e.$2lc=y=a=Je([qe(3,A.$Wj)],y)}),define(ke[348],Ee([1,0,6,16,2]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;class R{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(l.$PM.MainThreadShare)}async $provideShare(b,$,S){return await this.c.get(b)?.provideShare({selection:N.Range.to($.selection),resourceUri:L.URI.revive($.resourceUri)},S)??void 0}registerShareProvider(b,$){const S=R.a++;return this.c.set(S,$),this.b.$registerShareProvider(S,N.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(S),this.c.delete(S)}}}}e.$3lc=R}),define(ke[349],Ee([1,0,7,6,225,3,16,18]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=e.$5lc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new l.$ON("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.$ON("statusBarItem.warningForeground")]])}#e;#t;constructor(m,E,v,u,f,a=l.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=m,this.#t=E,f&&u){this.c=(0,l.$qN)(u.identifier,f);const i=v.get(this.c);i&&(a=i.alignLeft?l.StatusBarAlignment.Left:l.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=u,this.f=f,this.g=a,this.h=this.u(n)}u(m){if((0,b.$8f)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let E;this.m?E=this.m:E=(0,L.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const u=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,E,this.k,u,this.r?.internal,v,this.o,this.g===l.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5lc=$;class S{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const E={message:m};return this.b.unshift(E),this.c(),new l.$RM(()=>{const v=this.b.indexOf(E);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(m,E){this.e=new Map,this.a=m.getProxy(N.$PM.MainThreadStatusBar),this.b=E,this.c=new S(this)}$acceptStaticEntries(m){for(const E of m)this.e.set(E.entryId,E)}createStatusBarEntry(m,E,v,u){return new $(this.a,this.b,this.e,m,E,v,u)}setStatusBarMessage(m,E){const v=this.c.setMessage(m);let u;return typeof E=="number"?u=setTimeout(()=>v.dispose(),E):typeof E<"u"&&E.then(()=>v.dispose(),()=>v.dispose()),new l.$RM(()=>{v.dispose(),clearTimeout(u)})}}e.$6lc=A}),define(ke[154],Ee([1,0,29,144,68,112,89,16,2]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=e.$pP=e.$oP=void 0;const S=(i,s,o,t)=>{let g=s;return{enumerable:!0,configurable:!1,get(){return g},set(h){if(!o(g,h)){const c=g;g=h,i.listener?.(t(h,c))}}}},A=(i,s)=>i===s,C={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,s)=>!(i.length!==s.length||i.some(o=>!s.find(t=>o.id===t.id)))},m=i=>s=>({op:4,update:i(s)}),E=(i,s)=>({range:(()=>{let o;const t=m(g=>({range:l.$kt.lift(b.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return o},set(g){i.listener?.({op:6}),C.range(o,g)||(o=g,i.listener?.(t(g)))}}})(),label:S(i,s,C.label,m(o=>({label:o}))),description:S(i,void 0,C.description,m(o=>({description:o}))),sortText:S(i,void 0,C.sortText,m(o=>({sortText:o}))),canResolveChildren:S(i,!1,C.canResolveChildren,o=>({op:2,state:o})),busy:S(i,!1,C.busy,m(o=>({busy:o}))),error:S(i,void 0,C.error,m(o=>({error:b.MarkdownString.fromStrict(o)||null}))),tags:S(i,[],C.tags,(o,t)=>({op:1,new:o.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),v=i=>{const s=L.$BL.fromString(i.extId),o=new f(s.controllerId,s.localId,i.label,$.URI.revive(i.uri)||void 0);return o.range=b.Range.to(i.range||void 0),o.description=i.description||void 0,o.sortText=i.sortText||void 0,o.tags=i.tags.map(t=>b.TestTag.to({id:(0,M.$HL)(t).tagId})),o},u=i=>{let s;for(const o of i.tests){const t=v(o.item);(0,N.$$O)(t).parent=s,s=t}return s};e.$oP=u;class f{constructor(s,o,t,g){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const h=(0,N.$0O)(this,s);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof a?void 0:h.parent}},children:{value:(0,R.$9O)(h,N.$$O,f),enumerable:!0,writable:!1},...E(h,t)})}}e.$pP=f;class a extends f{constructor(s,o){super(s,s,o,void 0),this._isRoot=!0}}e.$qP=a;class n extends R.$5O{constructor(s,o,t){super({controllerId:s,getDocumentVersion:g=>g&&t.getDocument(g)?.version,getApiFor:N.$$O,getChildren:g=>g.children,root:new a(s,o),toITestItem:b.TestItem.from})}}e.$rP=n}),define(ke[33],Ee([1,0,18,7,16,24,6,19,12,58,29,50,2,3,5,20,154,21,48,47,40,87,90,30]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=void 0;let h=class{#e;#t;#i;constructor(p,k,y){this.b=new Map,this.c=new Map,this.#e=p.getProxy(M.$PM.MainThreadCommands),this.d=k,this.#i=y,this.#t=p.getProxy(M.$PM.MainThreadTelemetry),this.converter=new c(this,P=>{const I=this.c.get(P);return I?.result===w.Void?I:void 0},k),this.f=[{processArgument(P){return(0,S.$Zh)(P)}},{processArgument(P){return(0,R.$Yn)(P,function(I){if(A.$kt.isIRange(I))return L.Range.to(I);if(C.$jt.isIPosition(I))return L.Position.to(I);if(A.$kt.isIRange(I.range)&&m.URI.isUri(I.uri))return L.location.to(I);if(I instanceof a.$Ce)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const k=this.registerCommand(!1,p.id,async(...y)=>{const P=p.args.map((F,j)=>{if(!F.validate(y[j]))throw new Error(`Invalid argument '${F.name}' when running '${p.id}', received: ${typeof y[j]=="object"?JSON.stringify(y[j],null,"	"):y[j]} `);return F.convert(y[j])}),I=await this.executeCommand(p.internalId,...P);return p.result.convert(I,y,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new N.$RM(()=>{k.dispose(),this.c.delete(p.id)})}registerCommand(p,k,y,P,I,F){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:y,thisArg:P,metadata:I,extension:F}),p&&this.#e.$registerCommand(k),new N.$RM(()=>{this.b.delete(k)&&p&&this.#e.$unregisterCommand(k)})}executeCommand(p,...k){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,k,!0)}async g(p,k,y){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,k,!1);{let P=!1;const I=(0,R.$Yn)(k,function(F){if(F instanceof N.$SM)return L.Position.from(F);if(F instanceof N.$TM)return L.Range.from(F);if(F instanceof N.$4M)return L.location.from(F);if(N.$gO.isNotebookRange(F))return L.NotebookRange.from(F);if(F instanceof ArrayBuffer)return P=!0,a.$Ce.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return P=!0,a.$Ce.wrap(F);if(F instanceof a.$Ce)return P=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand(p,P?new n.$mw(I):I,y);return(0,S.$Zh)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this.g(p,k,!1);throw F}}}async h(p,k,y){const P=this.b.get(p);if(!P)throw new Error("Unknown command");const{callback:I,thisArg:F,metadata:j}=P;if(j?.args)for(let O=0;O<j.args.length;O++)try{(0,l.$ig)(k[O],j.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${j.args[O].name}' - ${j.args[O].description}`)}const z=s.$0d.create();try{return await I.apply(F,k)}catch(O){if(p===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...k);T&&(p=T.command)}if(this.d.error(O,p,P.extension?.identifier),!y)throw O;if(P.extension?.identifier){const T=this.#i.onExtensionError(P.extension.identifier,O);this.d.trace("forwarded error to extension?",T,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$bj)(O)),this.id=p,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,p,z.elapsed())}}j(p,k,y){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new o.$_o(k),duration:y})}$executeContributedCommand(p,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const y=this.b.get(p);return y?(k=k.map(P=>this.f.reduce((I,F)=>F.processArgument(I,y.extension?.identifier),P)),this.h(p,k,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(k=>(p&&(k=k.filter(y=>y[0]!=="_")),k))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[k,y]of this.b){const{metadata:P}=y;P&&(p[k]=P)}return Promise.resolve(p)}};e.$xP=h,e.$xP=h=Je([qe(0,u.$cP),qe(1,$.$Wj),qe(2,t.$wP)],h),e.$yP=(0,v.$qi)("IExtHostCommands");class c{constructor(p,k,y){this.d=p,this.f=k,this.g=y,this.delegatingCommandId=`__vsc${(0,g.$Mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,k){if(!p)return;const y={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return y;const P=this.f(p.command);if(P)y.id=P.internalId,y.arguments=P.args.map((I,F)=>I.convert(p.arguments&&p.arguments[F]));else if((0,b.$Lb)(p.arguments)){const I=`${p.command} /${++this.c}`;this.b.set(I,p),k.add((0,E.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),y.$ident=I,y.id=this.delegatingCommandId,y.arguments=[I],this.g.trace("CommandsConverter#CREATE",p.command,I)}return y}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const k=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$zP=c;class r{static{this.Uri=new r("uri","Uri of a text document",p=>m.URI.isUri(p),p=>p)}static{this.Position=new r("position","A position in a text document",p=>N.$SM.isPosition(p),L.Position.from)}static{this.Range=new r("range","A range in a text document",p=>N.$TM.isRange(p),L.Range.from)}static{this.Selection=new r("selection","A selection in a text document",p=>N.$UM.isSelection(p),L.Selection.from)}static{this.Number=new r("number","",p=>typeof p=="number",p=>p)}static{this.String=new r("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=r.Arr(r.String)}static Arr(p){return new r(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,k=>Array.isArray(k)&&k.every(y=>p.validate(y)),k=>k.map(y=>p.convert(y)))}static{this.CallHierarchyItem=new r("item","A call hierarchy item",p=>p instanceof N.$cN,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new r("item","A type hierarchy item",p=>p instanceof N.$AO,L.TypeHierarchyItem.from)}static{this.TestItem=new r("testItem","A VS Code TestItem",p=>p instanceof f.$pP,L.TestItem.from)}constructor(p,k,y,P){this.name=p,this.description=k,this.validate=y,this.convert=P}optional(){return new r(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,k){return new r(p??this.name,k??this.description,this.validate,this.convert)}}e.$AP=r;class w{static{this.Void=new w("no result",p=>p)}constructor(p,k){this.description=p,this.convert=k}}e.$BP=w;class d{constructor(p,k,y,P,I){this.id=p,this.internalId=k,this.description=y,this.args=P,this.result=I}}e.$CP=d}),define(ke[350],Ee([1,0,19,15,2,83,134,37,33,16,7]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=void 0;const C=[new $.$CP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of DocumentHighlight-instances.",E(S.DocumentHighlight.to))),new $.$CP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$AP.Uri],new $.$BP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,f)=>{if((0,l.$Kb)(u))return;class a extends A.$0M{static to(i){const s=new a(i.name,S.SymbolKind.to(i.kind),i.containerName||"",new A.$4M(f[0],S.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=S.Range.to(i.selectionRange),s.children=i.children?i.children.map(a.to):[],s}}return u.map(a.to)})),new $.$CP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$AP.Uri,new $.$AP("options","Formatting options",u=>!0,u=>u)],new $.$BP("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new $.$CP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$AP.Uri,$.$AP.Range,new $.$AP("options","Formatting options",u=>!0,u=>u)],new $.$BP("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new $.$CP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$AP.Uri,$.$AP.Position,new $.$AP("ch","Trigger character",u=>typeof u=="string",u=>u),new $.$AP("options","Formatting options",u=>!0,u=>u)],new $.$BP("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new $.$CP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$CP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$CP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$CP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$CP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location-instances.",E(S.location.to))),new $.$CP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Hover-instances.",E(S.Hover.to))),new $.$CP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$AP.Uri,new $.$AP("position","A position in a text document",u=>Array.isArray(u)&&u.every(f=>A.$SM.isPosition(f)),u=>u.map(S.Position.from))],new $.$BP("A promise that resolves to an array of ranges.",u=>u.map(f=>{let a;for(const n of f.reverse())a=new A.$bN(S.Range.to(n),a);return a}))),new $.$CP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$AP.String.with("query","Search string")],new $.$BP("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(S.WorkspaceSymbol.to))),new $.$CP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(S.CallHierarchyItem.to))),new $.$CP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$AP.CallHierarchyItem],new $.$BP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(S.CallHierarchyIncomingCall.to))),new $.$CP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$AP.CallHierarchyItem],new $.$BP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(S.CallHierarchyOutgoingCall.to))),new $.$CP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:S.Range.to(u.range),placeholder:u.text}})),new $.$CP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$AP.Uri,$.$AP.Position,$.$AP.String.with("newName","The new symbol name")],new $.$BP("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return S.WorkspaceEdit.to(u)}})),new $.$CP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$AP.Uri,$.$AP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$BP("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(S.DocumentLink.to))),new $.$CP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$AP.Uri],new $.$BP("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new A.$0N(u.tokenTypes,u.tokenModifiers)})),new $.$CP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$AP.Uri],new $.$BP("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const f=(0,M.$ubb)(u);if(f.type==="full")return new A.$_N(f.data,void 0)})),new $.$CP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$AP.Uri,$.$AP.Range.optional()],new $.$BP("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new A.$0N(u.tokenTypes,u.tokenModifiers)})),new $.$CP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$AP.Uri,$.$AP.Range],new $.$BP("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const f=(0,M.$ubb)(u);if(f.type==="full")return new A.$_N(f.data,void 0)})),new $.$CP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$AP.Uri,$.$AP.Position,$.$AP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$AP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$BP("A promise that resolves to a CompletionList-instance.",(u,f,a)=>{if(!u)return new A.$nN([]);const n=u.suggestions.map(i=>S.CompletionItem.to(i,a));return new A.$nN(n,u.incomplete)})),new $.$CP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$AP.Uri,$.$AP.Position,$.$AP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$BP("A promise that resolves to SignatureHelp.",u=>{if(u)return S.SignatureHelp.to(u)})),new $.$CP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$AP.Uri,$.$AP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$BP("A promise that resolves to an array of CodeLens-instances.",(u,f,a)=>E(n=>new A.$fN(S.Range.to(n.range),n.command&&a.fromInternal(n.command)))(u))),new $.$CP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$AP.Uri,new $.$AP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>A.$TM.isRange(u),u=>A.$UM.isSelection(u)?S.Selection.from(u):S.Range.from(u)),$.$AP.String.with("kind","Code action kind to return code actions for").optional(),$.$AP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$BP("A promise that resolves to an array of Command-instances.",(u,f,a)=>E(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(n.command)}else{const i=new A.$_M(n.title,n.kind?new A.$aN(n.kind):void 0);return n.edit&&(i.edit=S.WorkspaceEdit.to(n.edit)),n.command&&(i.command=a.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(u))),new $.$CP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$AP.Uri],new $.$BP("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(f=>new A.$tN(S.Range.to(f.range),S.Color.to(f.color))):[])),new $.$CP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$AP("color","The color to show and insert",u=>u instanceof A.$sN,S.Color.from),new $.$AP("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:S.Range.from(u.range)}))],new $.$BP("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(S.ColorPresentation.to):[])),new $.$CP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$AP.Uri,$.$AP.Range],new $.$BP("A promise that resolves to an array of Inlay objects",(u,f,a)=>u.map(S.InlayHint.to.bind(void 0,a)))),new $.$CP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$AP.Uri],new $.$BP("A promise that resolves to an array of FoldingRange objects",(u,f)=>{if(u)return u.map(S.FoldingRange.to)})),new $.$CP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$BP("A promise that resolves to an array of NotebookContentProvider static info objects.",E(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(f=>S.NotebookExclusiveDocumentPattern.to(f))})))),new $.$CP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$AP.Uri,$.$AP.Range,new $.$AP("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof A.$TM,u=>S.InlineValueContext.from(u))],new $.$BP("A promise that resolves to an array of InlineValue objects",u=>u.map(S.InlineValue.to))),new $.$CP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$AP("uriOrString","Uri-instance or string (only http/https)",u=>L.URI.isUri(u)||typeof u=="string"&&(0,N.$Ag)(u,N.Schemas.http,N.Schemas.https),u=>u),new $.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[S.ViewColumn.from(u),void 0]:[S.ViewColumn.from(u.viewColumn),S.TextEditorOpenOptions.from(u)])).optional(),$.$AP.String.with("label","").optional()],$.$BP.Void),new $.$CP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$AP.Uri.with("resource","Resource to open"),$.$AP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[S.ViewColumn.from(u),void 0]:[S.ViewColumn.from(u.viewColumn),S.TextEditorOpenOptions.from(u)])).optional()],$.$BP.Void),new $.$CP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$AP.Uri.with("left","Left-hand side resource of the diff editor"),$.$AP.Uri.with("right","Right-hand side resource of the diff editor"),$.$AP.String.with("title","Human readable title for the diff editor").optional(),new $.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[S.ViewColumn.from(u.viewColumn),S.TextEditorOpenOptions.from(u)]).optional()],$.$BP.Void),new $.$CP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$AP.String.with("title","Human readable title for the changes editor"),new $.$AP("resourceList","List of resources to compare",u=>{for(const f of u){if(f.length!==3)return!1;const[a,n,i]=f;if(!L.URI.isUri(a)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},u=>u)],$.$BP.Void),new $.$CP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(S.TypeHierarchyItem.to))),new $.$CP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$AP.TypeHierarchyItem],new $.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(S.TypeHierarchyItem.to))),new $.$CP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$AP.TypeHierarchyItem],new $.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(S.TypeHierarchyItem.to))),new $.$CP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$AP.TestItem],$.$BP.Void),new $.$CP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$AP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$BP.Void),new $.$CP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$AP.String.with("name","The context key name"),new $.$AP("value","The context key value",()=>!0,u=>u)],$.$BP.Void),new $.$CP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$AP.Uri,$.$AP.StringArray,new $.$AP("MappedEditsContext","Mapped Edits Context",u=>S.MappedEditsContext.is(u),u=>S.MappedEditsContext.from(u))],new $.$BP("A promise that resolves to a workspace edit or null",u=>u?S.WorkspaceEdit.to(u):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$pj)}}e.$okc=m;function E(u){return f=>{if(Array.isArray(f))return f.map(u)}}function v(u){if(!Array.isArray(u))return;const f=[];for(const a of u)R.$2t(a)?f.push(S.DefinitionLink.to(a)):f.push(S.location.to(a));return f}}),define(ke[351],Ee([1,0,8,3,2,6,33,16,7]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class S{static{this.a=0}constructor(E,v){this.extension=E,this.provider=v,this.handle=S.a++}}class A{constructor(E){this.session=E,this.responses=[]}}class C{static{this.a=0}constructor(E,v,u,f){this.f=u,this.g=f,this.b=new Map,this.d=new Map,this.e=E.getProxy(R.$PM.MainThreadInlineChat),v.registerApiCommand(new M.$CP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$AP("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?b.Range.from(a.initialRange):void 0,initialSelection:$.$UM.isSelection(a.initialSelection)?b.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?b.Position.from(a.position):void 0}})],M.$BP.Void))}registerProvider(E,v,u){const f=new S(E,v);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,u?.label??E.displayName??E.name,E.identifier,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",u?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(E,v,u,f){const a=this.b.get(E);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(v)),i=b.Selection.to(u),s=await a.provider.prepareInteractiveEditorSession({document:n,selection:i},f);if(!s)return;if(s.wholeRange&&!s.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=C.a++;return this.d.set(o,new A(s)),{id:o,placeholder:s.placeholder,input:s.input,slashCommands:s.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(s.wholeRange),message:s.message}}async $provideResponse(E,v,u,f){const a=this.b.get(E);if(!a)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:u.prompt,selection:b.Selection.to(u.selection),wholeRange:b.Range.to(u.wholeRange),attempt:u.attempt,live:u.live,previewDocument:this.f.getDocument(L.URI.revive(u.previewDocument)),withIntentDetection:u.withIntentDetection};let s=!1;const o={report:async D=>{if(!u.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");s||f.isCancellationRequested||await this.e.$handleProgressChunk(u.requestId,{message:D.message,edits:D.edits?.map(b.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:$.$gN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(n.session,i,o,f));let g;try{g=await(0,l.$eh)(t,f)}finally{s=!0}if(!g)return;const h=n.responses.push(g)-1,c={wholeRange:b.Range.from(g.wholeRange),placeholder:g.placeholder};if(!C.h(g))return{...c,id:h,type:"editorEdit",message:b.MarkdownString.from(g.contents),edits:[]};const{edits:r,contents:w}=g,d=w!==void 0?b.MarkdownString.from(w):void 0;return r instanceof $.$2M?{...c,id:h,type:"bulkEdit",edits:b.WorkspaceEdit.from(r),message:d}:{...c,id:h,type:"editorEdit",edits:r.map(b.TextEdit.from),message:d}}async $provideFollowups(E,v,u,f){const a=this.b.get(E),n=this.d.get(v),i=n?.responses[u];if(a&&i&&a.provider.provideFollowups){const s=Promise.resolve(a.provider.provideFollowups(n.session,i,f));return(await(0,l.$eh)(s,f))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(E,v,u,f){const a=this.b.get(E),n=this.d.get(v),i=n?.responses[u];if(a&&i){const s=b.InteractiveEditorResponseFeedbackKind.to(f);a.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,s)}}$releaseSession(E,v){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$xlc=C}),define(ke[352],Ee([1,0,2,33]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class L{constructor(M,b,$,S,A){this.a=b,this.b=$,this.c=S;const C=new N.$CP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$AP("showOptions","Show Options",m=>!0,m=>m),new N.$AP("resource","Interactive resource Uri",m=>!0,m=>m),new N.$AP("controllerId","Notebook controller Id",m=>!0,m=>m),new N.$AP("title","Interactive editor title",m=>!0,m=>m)],new N.$BP("Notebook and input URI",m=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const E=this.a.getEditorById(m.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:l.URI.revive(m.notebookUri),inputUri:l.URI.revive(m.inputUri),notebookEditor:E.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:l.URI.revive(m.notebookUri),inputUri:l.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(M,b,$,S){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Klc=L}),define(ke[353],Ee([1,0,19,8,22,4,3,27,2,25,12,6,33,16,7,113,297,26,48,298]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0,e.$Slc=r;let s=class{constructor(d,D,p,k,y){this.m=D,this.n=p,this.o=k,this.q=y,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(C.$PM.MainThreadNotebookKernels);const P=new m.$CP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$AP("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const j=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:j}}else if(F&&"notebookEditor"in F){const j=this.n.getIdByEditor(F.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return F})],m.$BP.Void),I=new m.$CP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[m.$AP.Uri],new m.$BP("A promise that resolves to an array of variables",(F,j)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(I)}createNotebookController(d,D,p,k,y,P){for(const we of this.j.values())if(we.controller.id===D&&S.$Lm.equals(d.identifier,we.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,F=this;this.q.trace(`NotebookController[${I}], CREATED by ${d.identifier.value}, ${D}`);const j=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${d.identifier}'`);let z=!1;const O=new R.$be,T=new R.$be,B={id:r(d.identifier,D),notebookType:p,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:k||d.identifier.value,preloads:P?P.map(E.NotebookRendererScript.from):[]};let W=y??j,X,x;this.a.$addKernel(I,B).catch(we=>{console.log(we),z=!0});let Z=0;const Y=()=>{if(z)return;const we=++Z;Promise.resolve().then(()=>{we===Z&&this.a.$updateKernel(I,B)})},ue=new b.$Bc,te={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return B.label},set label(we){B.label=we??d.displayName??d.name,Y()},get detail(){return B.detail??""},set detail(we){B.detail=we,Y()},get description(){return B.description??""},set description(we){B.description=we,Y()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(we){B.supportedLanguages=we,Y()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(we){B.supportsExecutionOrder=we,Y()},get rendererScripts(){return B.preloads?B.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(we){W=we??j},get interruptHandler(){return X},set interruptHandler(we){X=we,B.supportsInterrupt=!!we,Y()},set variableProvider(we){(0,a.$yG)(d,"notebookVariableProvider"),x=we,B.hasVariableProvider=!!we,we?.onDidChangeVariables(Se=>F.a.$variablesUpdated(Se.uri)),Y()},get variableProvider(){return x},createNotebookCellExecution(we){if(z)throw new Error("notebook controller is DISPOSED");if(!ue.has(we.notebook.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.notebook.uri.toString()}`);return F._createNotebookCellExecution(we,r(d.identifier,this.id))},createNotebookExecution(we){if((0,a.$yG)(d,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ue.has(we.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.uri.toString()}`);return F._createNotebookExecution(we,r(d.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),O.dispose(),T.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(we,Se){Se===v.NotebookControllerAffinity2.Hidden&&(0,a.$yG)(d,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(I,we.uri,Se)},onDidReceiveMessage:T.event,postMessage(we,Se){return(0,a.$yG)(d,"notebookMessaging"),F.a.$postMessage(I,Se&&F.n.getIdByEditor(Se),we)},asWebviewUri(we){return(0,a.$yG)(d,"notebookMessaging"),(0,u.$Rxb)(we,F.m.remote)}};return this.j.set(I,{extensionId:d.identifier,controller:te,onDidReceiveMessage:T,onDidChangeSelection:O,associatedNotebooks:ue}),te}getIdByController(d){for(const[D,p]of this.j)if(p.controller===d)return r(p.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,D){const p=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${p}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(p,D);const y={dispose:()=>{this.f.delete(p),k.a.$removeKernelDetectionTask(p)}};return this.f.set(p,y),y}registerKernelSourceActionProvider(d,D,p){const k=this.i++,y=typeof p.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,P=this;this.h.set(k,p),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,D);let I;return y!==void 0&&(I=p.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(k),P.a.$removeKernelSourceActionProvider(k,k),I?.dispose()}}}async $provideKernelSourceActions(d,D){const p=this.h.get(d);if(p){const k=new M.$Tc;return(await p.provideNotebookKernelSourceActions(D)??[]).map(P=>E.NotebookKernelSourceAction.from(P,this.o.converter,k))}return[]}$acceptNotebookAssociation(d,D,p){const k=this.j.get(d);if(k){const y=this.n.getNotebookDocument($.URI.revive(D));p?k.associatedNotebooks.set(y.uri,!0):k.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,y.uri.toString(),p),k.onDidChangeSelection.fire({selected:p,notebook:y.apiNotebook})}}async $executeCells(d,D,p){const k=this.j.get(d);if(!k)return;const y=this.n.getNotebookDocument($.URI.revive(D)),P=[];for(const I of p){const F=y.getCell(I);F&&P.push(F.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,y.uri.toString(),P.length),await k.controller.executeHandler.call(k.controller,P,y.apiNotebook,k.controller)}catch(I){this.q.error(`NotebookController[${d}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(d,D,p){const k=this.j.get(d);if(!k)return;const y=this.n.getNotebookDocument($.URI.revive(D));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,y.apiNotebook);else for(const P of p){const I=y.getCell(P);I&&this.b.get(I.uri)?.cancel()}if(k.controller.interruptHandler){const P=this.c.get(y.uri);p.length&&Array.isArray(P)&&P.length&&P.forEach(I=>I.dispose())}}async $provideVariables(d,D,p,k,y,P,I){const F=this.j.get(d);if(!F)return;const j=this.n.getNotebookDocument($.URI.revive(p)),z=F.controller.variableProvider;if(!z)return;let O;if(k!==void 0){if(O=this.s[k],!O)return}else this.s={};const T=y==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(j.apiNotebook,O,T,P,I);let W=0;for await(const X of B){if(I.isCancellationRequested)return;const x={id:this.r++,name:X.variable.name,value:X.variable.value,type:X.variable.type,interfaces:X.variable.interfaces,language:X.variable.language,expression:X.variable.expression,hasNamedChildren:X.hasNamedChildren,indexedChildrenCount:X.indexedChildrenCount,extensionId:F.extensionId.value};if(this.s[x.id]=X.variable,this.a.$receiveVariable(D,x),W++>=i.$wib)return}}$acceptKernelMessageFromRenderer(d,D,p){const k=this.j.get(d);if(!k)return;const y=this.n.getEditorById(D);k.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:p}))}$cellExecutionChanged(d,D,p){const y=this.n.getNotebookDocument($.URI.revive(d)).getCell(D);if(y){const P=p?E.NotebookCellExecutionState.to(p):v.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:y.apiCell,state:P})}}_createNotebookCellExecution(d,D){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const y=new t(D,k,this.a);this.b.set(k.uri,y);const P=y.onDidChangeState(()=>{y.state===o.Resolved&&(y.dispose(),P.dispose(),this.b.delete(k.uri))});return y.asApiObject()}_createNotebookExecution(d,D){const p=this.n.getNotebookDocument(d.uri),k=d.getCells().find(I=>{const F=p.getCellFromApiCell(I);return F&&this.b.has(F.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(p.uri))throw new Error(`duplicate notebook execution for ${p.uri}`);const y=new h(D,p,this.a),P=y.onDidChangeState(()=>{y.state===g.Resolved&&(y.dispose(),P.dispose(),this.c.delete(p.uri))});return this.c.set(p.uri,[y,P]),y.asApiObject()}};e.$Rlc=s,e.$Rlc=s=Je([qe(4,A.$Wj)],s);var o;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(o||(o={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,D,p){super(),this.m=D,this.n=p,this.b=t.a++,this.c=new R.$be,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new L.$me),this.h=new c(10,k=>this.s(k)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const D=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new n.$mw(D))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let D=this.m;if(d&&(D=this.m.notebook.getCellFromApiCell(d)),!D)throw new Error("INVALID cell");return D.handle}y(d){return d.map(D=>{const p=v.$kO.ensureUniqueMimeTypes(D.items,!0);return p===D.items?E.NotebookCellOutput.from(D):E.NotebookCellOutput.from({items:p,id:D.id,metadata:D.metadata})})}async z(d,D,p){const k=this.w(D),y=this.y((0,l.$3b)(d));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:k,append:p,outputs:y})}async C(d,D,p){return d=v.$kO.ensureUniqueMimeTypes((0,l.$3b)(d),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:d.map(E.NotebookCellOutputItem.from),outputId:D.id,append:p})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(p){d.j=p,d.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(p){if(d.f===o.Resolved||d.f===o.Started)throw new Error("Cannot call start again");d.f=o.Started,d.c.fire(),d.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:p})},end(p,k,y){if(d.f===o.Resolved)throw new Error("Cannot call resolve twice");d.f=o.Resolved,d.c.fire(),d.h.flush();const P=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;d.n.$completeExecution(d.b,new n.$mw({runEndTime:k,lastRunSuccess:p,error:P}))},clearOutput(p){return d.t(),d.z([],p,!1)},appendOutput(p,k){return d.t(),d.z(p,k,!0)},replaceOutput(p,k){return d.t(),d.z(p,k,!1)},appendOutputItems(p,k){return d.t(),d.C(p,k,!0)},replaceOutputItems(p,k){return d.t(),d.C(p,k,!1)}})}}var g;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(g||(g={}));class h extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,D,p){super(),this.h=D,this.j=p,this.b=h.a++,this.c=new R.$be,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new L.$me),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(d,D){this.f=d,this.g=D,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new N.$Nh,this.b=Date.now(),(0,N.$rh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>d.complete())}}function r(w,d){return`${w.value}/${d}`}}),define(ke[43],Ee([1,0,4,6,5,2,20,3,7,227,13,273,22,30,274,57,8,16,33]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=e.$5kc=e.$4kc=e.$3kc=void 0,e.$3kc=(0,L.$qi)("IExtHostTerminalService");class i extends b.$Uc{constructor(p,k,y,P){super(),this.u=p,this._id=k,this.w=y,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new l.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(F=>this.g=F);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(F,j=!0){I.C(),I.u.$sendText(I._id,F,j)},show(F){I.C(),I.u.$show(I._id,F)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??k?.cwd??void 0,env:p.env??void 0,icon:r(p.iconPath)??void 0,color:u.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z(p.location,k?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,k,y,P,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:u.ThemeColor.isThemeColor(I)?I.id:void 0,location:k?.location||this.z(p,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,k){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in p?{viewColumn:a.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,k){this.j=Object.freeze({code:p,reason:k})}setDimensions(p,k){return p===this.f&&k===this.h||p===0||k===0?!1:(this.f=p,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(k=>{k!==p&&(this.b=Promise.resolve(p))})}}e.$4kc=i;class s{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new l.$be,this.onProcessData=this.a.event,this.b=new l.$be,this.d=new l.$be,this.onDidChangeProperty=this.d.event,this.f=new l.$be,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,k){this.g.setDimensions?.({columns:p,rows:k})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,k,y){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new l.$be,this.onDidCloseTerminal=this.H.event,this.I=new l.$be,this.onDidOpenTerminal=this.I.event,this.J=new l.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new l.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new l.$be,this.onDidChangeTerminalState=this.M.event,this.N=new l.$be,this.onDidChangeShell=this.N.event,this.O=new l.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new l.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$PM.MainThreadTerminalService),this.y=new v.$Rsb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:P=>{const I=F=>{const j=F;return this.getTerminalById(j.instanceId)?.value};switch(P?.$mid){case 15:return I(P);default:{if(Array.isArray(P))for(let F=0;F<P.length&&P[F].$mid===15;F++)P[F]=I(P[F]);return P}}}}),this.B({dispose:()=>{for(const[P,I]of this.g)I.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,k){const y=new i(this.a,(0,E.$Mg)(),p,p.name),P=new s(p.pty);return y.createExtensionTerminal(p.location,k,this.R(p,k).resolvedExtHostIdentifier,r(p.iconPath),w(p.color)).then(I=>{const F=this.S(I,P);this.h[I]=F}),this.f.push(y),y.value}R(p,k){if(k=k||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const y=p.location.parentTerminal;if(y){const P=this.f.find(I=>I.value===y);P&&(k.resolvedExtHostIdentifier=P._id)}}else p.location&&typeof p.location!="object"?k.location=p.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal(p,k){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const P=new s(k),I=this.S(p,P);this.h[p]=I}async $acceptActiveTerminalChanged(p){const k=this.b;if(p===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById(p);y&&(this.b=y,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,k){const y=this.getTerminalById(p);y&&this.O.fire({terminal:y.value,data:k})}async $acceptTerminalDimensions(p,k,y){const P=this.getTerminalById(p);P&&P.setDimensions(k,y)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(p,k){const y=this.getTerminalById(p);y&&this.P.fire({terminal:y.value,...k})}async $acceptTerminalMaximumDimensions(p,k,y){this.g.get(p)?.resize(k,y)}async $acceptTerminalTitleChange(p,k){const y=this.getTerminalById(p);y&&(y.name=k)}async $acceptTerminalClosed(p,k,y){const P=this.X(this.f,p);if(P!==null){const I=this.f.splice(P,1)[0];I.setExitStatus(k,y),this.H.fire(I.value)}}$acceptTerminalOpened(p,k,y,P){if(k){const j=this.X(this.f,k);if(j!==null){this.f[j]._id=p,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const I={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},F=new i(this.a,p,I,y);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(p,k){this.getTerminalById(p)?._setProcessId(k)}async $startExtensionTerminal(p,k){const y=this.getTerminalById(p);if(!y)return{message:(0,S.localize)(0,null,p)};y.isOpen||await new Promise(I=>{const F=this.onDidOpenTerminal(async j=>{j===y.value&&(F.dispose(),I())})});const P=this.g.get(p);P?P.startSendingEvents(k):this.j[p]={initialDimensions:k}}S(p,k){const y=new b.$Tc;y.add(k.onProcessReady(I=>this.a.$sendProcessReady(p,I.pid,I.cwd,I.windowsPty))),y.add(k.onDidChangeProperty(I=>this.a.$sendProcessProperty(p,I))),this.y.startBuffering(p,k.onProcessData),y.add(k.onProcessExit(I=>this.U(p,I))),this.g.set(p,k);const P=this.j[p];return P&&k instanceof s&&(k.startSendingEvents(P.initialDimensions),delete this.j[p]),y}$acceptProcessAckDataEvent(p,k){this.g.get(p)?.acknowledgeDataEvent(k)}$acceptProcessInput(p,k){this.g.get(p)?.input(k)}$acceptTerminalInteraction(p){const k=this.getTerminalById(p);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection(p,k){this.getTerminalById(p)?.setSelection(k)}$acceptProcessResize(p,k,y){try{this.g.get(p)?.resize(k,y)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(p,k){this.g.get(p)?.shutdown(k)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(k=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(k=>this.a.$sendProcessProperty(p,{type:"cwd",value:k}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new $.$RM(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,k,y){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,y),this.a.$registerProfileProvider(k,p.identifier.value),new $.$RM(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider(p,k,y){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,y),this.a.$registerQuickFixProvider(p,k),new $.$RM(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,k){const y=new m.$me().token;if(y.isCancellationRequested)return;const P=this.D.get(p);if(!P)return;const I=await P.provideTerminalQuickFixes(k,y);if(I===null||Array.isArray(I)&&I.length===0)return;const F=new b.$Tc;if(this.w.value=F,!Array.isArray(I))return I?a.TerminalQuickFix.from(I,this.Q.converter,F):void 0;const j=[];for(const z of I){const O=a.TerminalQuickFix.from(z,this.Q.converter,F);O&&j.push(O)}return j}async $createContributedProfileTerminal(p,k){const y=new m.$me().token;let P=await this.C.get(p)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,k);return}this.createTerminalFromOptions(P.options,k)}}async $provideLinks(p,k){const y=this.getTerminalById(p);if(!y)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const I=new m.$me;this.G.set(p,I);const F=[],j={terminal:y.value,line:k},z=[];for(const B of this.z)z.push(f.Promises.withAsyncBody(async W=>{I.token.onCancellationRequested(()=>W({provider:B,links:[]}));const X=await B.provideTerminalLinks(j,I.token)||[];I.token.isCancellationRequested||W({provider:B,links:X})}));const O=await Promise.all(z);if(I.token.isCancellationRequested)return[];const T=new Map;for(const B of O)B&&B.links.length>0&&F.push(...B.links.map(W=>{const X={id:o++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return T.set(X.id,{provider:B.provider,link:W}),X}));return this.F.set(p,T),F}$activateLink(p,k){const y=this.F.get(p)?.get(k);y&&y.provider.handleTerminalLink(y.link)}U(p,k){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const y=this.h[p];y&&(y.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,k)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const k=this.f.findIndex(y=>y.value===p);return k>=0?k:null}W(p,k){const y=this.X(p,k);return y!==null?p[y]:null}X(p,k){const y=p.findIndex(P=>P._id===k);return y>=0?y:null}getEnvironmentVariableCollection(p){let k=this.n.get(p.identifier.value);return k||(k=new g,this.Z(p.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y(p,k){const y=(0,C.$cs)(k.map),P=(0,C.$ds)(k.descriptionMap);this.a.$setEnvironmentVariableCollection(p,k.persistent,y.length===0?void 0:y,P)}$initEnvironmentVariableCollections(p){p.forEach(k=>{const y=k[0],P=new g(k[1]);this.Z(y,P)})}$acceptDefaultProfile(p,k){const y=this.s;this.s=p,this.u=k,y?.path!==p.path&&this.N.fire(p.path)}Z(p,k){this.n.set(p,k),k.onDidChangeCollection(()=>{this.Y(p,k)})}};e.$5kc=t,e.$5kc=t=Je([qe(1,n.$yP),qe(2,M.$cP)],t);class g{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new l.$be,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const k=this.h(p);let y=this.a.get(k);return y||(y=new h(this,p),this.a.set(k,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(p,k,y,P){this.f(p,{value:k,type:$.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:P})}append(p,k,y,P){this.f(p,{value:k,type:$.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:P})}prepend(p,k,y,P){this.f(p,{value:k,type:$.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:P})}f(p,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(p,k.scope),P=this.map.get(y),I=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==k.value||P.type!==k.type||P.options?.applyAtProcessCreation!==I.applyAtProcessCreation||P.options?.applyAtShellIntegration!==I.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const F=this.g(p,k.scope),j={variable:p,...k,options:I};this.map.set(F,j),this.d.fire()}}get(p,k){const y=this.g(p,k),P=this.map.get(y);return P?d(P):void 0}g(p,k){const y=this.h(k);return y.length?`${p}:::${y}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const k=new Map;for(const[y,P]of this.map)this.h(P.scope)===this.h(p)&&k.set(P.variable,d(P));return k}delete(p,k){const y=this.g(p,k);this.map.delete(y),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[k,y]of this.map)y.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(k);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,k){const y=this.h(k),P=this.descriptionMap.get(y);if(!P||P.description!==p){let I;typeof p=="string"?I=p:I=p?.value.split(`

`)[0];const F={description:I,scope:k};this.descriptionMap.set(y,F),this.d.fire()}}getDescription(p){const k=this.h(p);return this.descriptionMap.get(k)?.description}k(p){const k=this.h(p);this.descriptionMap.delete(k)}}class h{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,k){this.b=p,this.d=k,this.a=new l.$be}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,k,y){this.b.replace(p,k,y,this.d)}append(p,k,y){this.b.append(p,k,y,this.d)}prepend(p,k,y){this.b.prepend(p,k,y,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,k){this.b.getVariableMap(this.d).forEach((y,P)=>p.call(k,P,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor(p,k){super(!1,p,k)}createTerminal(p,k,y){throw new A.$_}createTerminalFromOptions(p,k){throw new A.$_}};e.$6kc=c,e.$6kc=c=Je([qe(0,n.$yP),qe(1,M.$cP)],c);function r(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function w(D){return u.ThemeColor.isThemeColor(D)?D:void 0}function d(D){const p={...D};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[155],Ee([1,0,7,3,5,6,20,43,4,2,8]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=e.$0lc=void 0,e.$0lc=(0,L.$qi)("IExtHostTerminalShellIntegration");let C=class extends N.$Uc{constructor(f,a){super(),this.h=a,this.b=new Map,this.c=new $.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=f.getProxy(R.$PM.MainThreadTerminalShellIntegration),this.B((0,N.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(f){const a=this.h.getTerminalById(f);if(!a)return;const n=a.value;let i=this.b.get(f);i||(i=new m(a.value,this.f),this.b.set(f,i),i.store.add(a.onWillDispose(()=>this.b.get(f)?.dispose())),i.store.add(i.onDidRequestShellExecution(s=>this.a.$executeCommand(f,s))),i.store.add(i.onDidRequestEndExecution(s=>this.g.fire(s))),i.store.add(i.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),a.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(f,a,n,i,s){this.b.has(f)||this.$shellIntegrationChange(f);const o={value:a,confidence:n,isTrusted:i};this.b.get(f)?.startShellExecution(o,s)}$shellExecutionEnd(f,a,n,i,s){const o={value:a,confidence:n,isTrusted:i};this.b.get(f)?.endShellExecution(o,s)}$shellExecutionData(f,a){this.b.get(f)?.emitData(a)}$cwdChange(f,a){this.b.get(f)?.setCwd((0,S.$wc)(a)?S.URI.revive(a):a)}$closeTerminal(f){this.b.get(f)?.dispose(),this.b.delete(f)}};e.$$lc=C,e.$$lc=C=Je([qe(0,M.$cP),qe(1,b.$3kc)],C);class m extends N.$Uc{get currentExecution(){return this.a}constructor(f,a){super(),this.j=f,this.m=a,this.b=!1,this.store=this.B(new N.$Tc),this.f=this.B(new $.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$be),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,s){let o=i;s&&(o+=` "${s.map(h=>`${h.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(o);const t={value:o,confidence:l.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},g=n.startShellExecution(t,n.c,!0).value;return n.b=!0,g}}}startShellExecution(f,a,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(f,a);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(f){this.currentExecution?.emitData(f)}endShellExecution(f,a){this.a&&(this.a.endExecution(f),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(f){let a=!1;S.URI.isUri(this.c)?a=!S.URI.isUri(f)||this.c.toString()!==f.toString():this.c!==f&&(a=!0),a&&(this.c=f,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(f,a){this.c=f,this.cwd=a,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return A.$Qh.EMPTY;this.a=new v}return this.a.createIterable()}emitData(f){this.a?.emitData(f)}endExecution(f){f&&(this.c=f),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends N.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const f=this.a=new A.$ph;return new A.$Qh(async n=>{this.b.push(n),await f.wait()})}emitData(f){for(const a of this.b)a.emitOne(f)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[354],Ee([1,0,8,21,22,4,74,56,3,18,30,12,6,20,154,16,7,68,112,89]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=e.$amc=e.$_lc=void 0;let s=class extends $.$Uc{constructor(I,F,j,z){super(),this.w=z,this.f=this.B(new R.$be),this.g=new Map,this.s=this.B(new R.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(m.$PM.MainThreadTesting),this.m=new D(this.h),this.j=new h(this.h,F),j.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const T=O,B=T.tests[T.tests.length-1].item.extId;return this.g.get(a.$BL.root(B))?.collection.tree.get(B)?.actual??(0,v.$oP)(O)}case 18:{const{test:T,message:B}=O,W=T.item.extId;return{test:this.g.get(a.$BL.root(W))?.collection.tree.get(W)?.actual??(0,v.$oP)({$mid:16,tests:[T]}),message:u.TestMessage.to(B)}}default:return O}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await j.executeCommand("_testing.getExplorerSelection"),T=B=>{const W=this.g.get(a.$BL.root(B));if(W)return a.$BL.isRoot(B)?W.controller:W.collection.tree.get(B)?.actual};return{include:O?.include.map(T).filter(S.$_f)||[],exclude:O?.exclude.map(T).filter(S.$_f)||[]}})}createTestController(I,F,j,z){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const O=new $.$Tc,T=O.add(new v.$rP(F,j,this.w));T.root.label=j;const B=new Map,W=new Set,X=this.h,x={items:T.root.children,get label(){return j},set label(Y){j=Y,T.root.label=Y,X.$updateController(F,{label:j})},get refreshHandler(){return z},set refreshHandler(Y){z=Y,X.$updateController(F,{canRefresh:!!Y})},get id(){return F},createRunProfile:(Y,ue,te,we,Se,_)=>{let U=(0,b.$ej)(Y);for(;B.has(U);)U++;return new k(this.h,B,W,this.s.event,F,U,Y,ue,te,we,Se,_)},createTestItem(Y,ue,te){return new v.$pP(F,Y,ue,te)},createTestRun:(Y,ue,te=!0)=>this.j.createTestRun(F,T,Y,ue,te),invalidateTestResults:Y=>{if(Y===void 0)this.h.$markTestRetired(void 0);else{const ue=Y instanceof Array?Y:[Y];this.h.$markTestRetired(ue.map(te=>a.$BL.fromExtHostTestItem(te,F).toString()))}},set resolveHandler(Y){T.resolveHandler=Y},get resolveHandler(){return T.resolveHandler},dispose:()=>{O.dispose()}};X.$registerTestController(F,j,!!z),O.add((0,$.$Sc)(()=>X.$unregisterTestController(F)));const Z={controller:x,collection:T,profiles:B,extension:I,activeProfiles:W};return this.g.set(F,Z),O.add((0,$.$Sc)(()=>this.g.delete(F))),O.add(T.onDidGenerateDiff(Y=>X.$publishDiff(F,Y.map(i.TestsDiffOp.serialize)))),x}createTestObserver(){return this.m.checkout()}async runTests(I,F=L.CancellationToken.None){const j=c(I);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(j.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(O=>a.$BL.fromExtHostTestItem(O,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:y[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:I.exclude?.map(O=>O.id)},F)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,F){return(await this.j.getCoverageDetails(I,F))?.map(u.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,F){this.g.get(I)?.profiles.get(F)?.configureHandler?.()}$setDefaultRunProfiles(I){const F=new Map;for(const[j,z]of Object.entries(I)){const O=this.g.get(j);if(!O)continue;const T=new Map,B=z.filter(X=>!O.activeProfiles.has(X)),W=[...O.activeProfiles].filter(X=>!z.includes(X));for(const X of B)T.set(X,!0),O.activeProfiles.add(X);for(const X of W)T.set(X,!1),O.activeProfiles.delete(X);T.size&&F.set(j,T)}this.s.fire(F)}async $refreshTests(I,F){await this.g.get(I)?.controller.refreshHandler?.(F)}$publishTestResults(I){this.results=Object.freeze(I.map(u.TestResults.to).concat(this.results).sort((F,j)=>j.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,F){const j=this.g.get(a.$BL.fromString(I).controllerId)?.collection;j&&(await j.expand(I,F<0?1/0:F),j.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(F=>i.TestsDiffOp.deserialize({asCanonicalUri:j=>j},F)))}async $runControllerTests(I,F){return Promise.all(I.map(j=>this.y(j,!1,F)))}async $startContinuousRun(I,F){const j=new L.$me(F),z=await Promise.all(I.map(O=>this.y(O,!0,j.token)));return!F.isCancellationRequested&&!z.some(O=>O.error)&&await new Promise(O=>F.onCancellationRequested(O)),j.dispose(!0),z}async y(I,F,j){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:O,profiles:T}=z,B=T.get(I.profileId);if(!B)return{};const W=I.testIds.map(Y=>O.tree.get(Y)).filter(S.$_f),X=I.excludeExtIds.map(Y=>z.collection.tree.get(Y)).filter(S.$_f).filter(Y=>W.some(ue=>ue.fullId.compare(Y.fullId)===2));if(!W.length)return{};const x=new f.$rO(W.some(Y=>Y.actual instanceof v.$qP)?void 0:W.map(Y=>Y.actual),X.map(Y=>Y.actual),B,F),Z=(0,i.$EL)(I)&&this.j.prepareForMainThreadTestRun(x,r.fromInternal(I,z.collection),B,j);try{return await B.runHandler(x,j),{}}catch(Y){return{error:String(Y)}}finally{Z&&Z.hasRunningTasks&&!j.isCancellationRequested&&await R.Event.toPromise(Z.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$_lc=s,e.$_lc=s=Je([qe(0,E.$cP),qe(1,C.$Wj)],s);const o=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class g extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,F,j,z,O){super(),this.y=I,this.z=F,this.C=j,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$me(O));const T=this.B(new l.$Ch(()=>this.F(),o));this.B(this.j.token.onCancellationRequested(()=>T.schedule()));const B=new R.$be;this.s=B.event,this.B((0,$.$Sc)(()=>{B.fire(),B.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,F){const[,j,z]=a.$BL.fromString(I).path,O=this.w.get(z);if(!O)return[];const T=this.g.get(j);if(!T)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(T.run,O,F)??[]}createRun(I){const F=this.y.id,j=this.y.controllerId,z=(0,A.$Mg)(),O=X=>(x,...Z)=>{if(B){this.C.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.y.isIncluded(x)&&(this.H(x),X(x,...Z))},T=(X,x)=>{const Z=x instanceof Array?x.map(u.TestMessage.from):[u.TestMessage.from(x)];if(X.uri&&X.range){const Y={range:u.Range.from(X.range),uri:X.uri};for(const ue of Z)ue.location=ue.location||Y}this.z.$appendTestMessagesInRun(F,z,a.$BL.fromExtHostTestItem(X,j).toString(),Z)};let B=!1;const W={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:X=>{const x=X.uri.toString(),Z=new a.$BL([F,z,x]).toString();this.w.set(x,X),this.z.$appendCoverage(F,z,u.TestCoverage.fromFile(Z,X))},enqueued:O(X=>{this.z.$updateTestStateInRun(F,z,a.$BL.fromExtHostTestItem(X,j).toString(),1)}),skipped:O(X=>{this.z.$updateTestStateInRun(F,z,a.$BL.fromExtHostTestItem(X,j).toString(),5)}),started:O(X=>{this.z.$updateTestStateInRun(F,z,a.$BL.fromExtHostTestItem(X,j).toString(),2)}),errored:O((X,x,Z)=>{T(X,x),this.z.$updateTestStateInRun(F,z,a.$BL.fromExtHostTestItem(X,j).toString(),6,Z)}),failed:O((X,x,Z)=>{T(X,x),this.z.$updateTestStateInRun(F,z,a.$BL.fromExtHostTestItem(X,j).toString(),4,Z)}),passed:O((X,x)=>{this.z.$updateTestStateInRun(F,z,a.$BL.fromExtHostTestItem(X,this.y.controllerId).toString(),3,x)}),appendOutput:(X,x,Z)=>{B||(Z&&(this.y.isIncluded(Z)?this.H(Z):Z=void 0),this.z.$appendOutputToRun(F,z,N.$Ce.fromString(X),x&&u.location.from(x),Z&&a.$BL.fromExtHostTestItem(Z,j).toString()))},end:()=>{B||(B=!0,this.z.$finishedTestRunTask(F,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:W}),this.z.$startedTestRunTask(F,{id:z,name:I,running:!0}),W}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof v.$pP))throw new n.$7O(I.id);if(this.h.has(a.$BL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const F=[],j=this.y.colllection.root;for(;;){const z=u.TestItem.from(I);if(F.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===j))break;I=I.parent||j}this.z.$addTestsToRun(this.y.controllerId,this.y.id,F)}dispose(){this.G(),super.dispose()}}class h{get trackers(){return this.c.values()}constructor(I,F){this.g=I,this.h=F,this.c=new Map,this.f=new Map}getCoverageDetails(I,F){const j=a.$BL.root(I);return this.f.get(j)?.getCoverageDetails(I,F)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[F,{id:j}]of this.c)j===I&&this.c.delete(F)}prepareForMainThreadTestRun(I,F,j,z){return this.j(I,F,j,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,F,j,z,O){const T=this.c.get(j);if(T)return T.createRun(z);const B=r.fromPublic(I,F,j,O),W=c(j);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!j.continuous,profile:W&&{group:y[W.kind],id:W.profileId},exclude:j.exclude?.map(x=>a.$BL.fromExtHostTestItem(x,F.root.id).toString())??[],id:B.id,include:j.include?.map(x=>a.$BL.fromExtHostTestItem(x,F.root.id).toString())??[F.root.id],persist:O});const X=this.j(j,B,j.profile);return R.Event.once(X.onEnd)(()=>{this.g.$finishedExtensionTestRun(B.id)}),X.createRun(z)}j(I,F,j,z){const O=new g(F,this.g,this.h,j,z);return this.c.set(I,O),this.f.set(O.id,O),O}}e.$amc=h;const c=P=>{if(P.profile){if(!(P.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class r{static fromPublic(I,F,j,z){return new r(I,(0,A.$Mg)(),j.include?.map(O=>a.$BL.fromExtHostTestItem(O,I).toString())??[I],j.exclude?.map(O=>a.$BL.fromExtHostTestItem(O,I).toString())??[],z,F)}static fromInternal(I,F){return new r(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,F)}constructor(I,F,j,z,O,T){this.controllerId=I,this.id=F,this.isPersisted=O,this.colllection=T,this.c=j.map(B=>B+"\0"),this.f=z.map(B=>B+"\0")}isIncluded(I){const F=a.$BL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const j of this.f)if(F===j||F.startsWith(j))return!1;for(const j of this.c)if(F===j||F.startsWith(j))return!0;return!1}}e.$bmc=r;class w{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,u.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const F=a.$BL.parentId(I.item.extId);if(F&&this.h.has(F.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:F,g:j}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...j].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends i.$KL{constructor(){super(...arguments),this.s=new R.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,F){return{...I,revived:u.TestItem.toPlain(I.item),depth:F?F.depth+1:0,children:new Set}}v(){return new w(this.s)}}class D{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(F=>F.revived)},dispose:(0,M.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new d({asCanonicalUri:F=>F});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const p=(P,I,F,j)=>{F?Object.assign(F,j):I.$updateTestRunConfig(P.controllerId,P.profileId,j)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,p(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,p(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),p(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,p(this,this.#e,this.#n,{tag:I?u.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,p(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#i,I=>I.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(S.$_f))}constructor(I,F,j,z,O,T,B,W,X,x=!1,Z=void 0,Y=!1){this.controllerId=O,this.profileId=T,this.f=B,this.kind=W,this.runHandler=X,this._tag=Z,this.g=Y,this.#e=I,this.#s=F,this.#t=j,this.#i=z,F.set(T,this);const ue=y[W];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);x&&j.add(T),this.#n={profileId:T,controllerId:O,tag:Z?u.TestTag.namespace(this.controllerId,Z.id):null,label:B,group:ue,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:Y},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$cmc=k;const y={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ke[156],Ee([1,0,62,13,124,16,7]),function(le,e,l,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=e.$jP=void 0;class b{static{this.c=new L.$hP("TextEditorDecorationType")}constructor(m,E,v){const u=b.c.nextId();m.$registerTextEditorDecorationType(E.identifier,u,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:u,dispose(){m.$removeTextEditorDecorationType(u)}})}}e.$jP=b;class ${constructor(m,E){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,E){this.k();let v=null;if(m instanceof M.$SM)v=new M.$TM(m,m);else if(m instanceof M.$TM)v=m;else throw new Error("Unrecognized location");this.l(v,E,!1)}insert(m,E){this.k(),this.l(new M.$TM(m,m),E,!0)}delete(m){this.k();let E=null;if(m instanceof M.$TM)E=m;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(m,E,v){const u=this.c.validateRange(m);this.g.push({range:u,text:E,forceMoveMarkers:v})}setEndOfLine(m){if(this.k(),m!==M.EndOfLine.LF&&m!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=m}}class S{constructor(m,E,v,u){this.c=m,this.d=E,this._accept(v),this.e=u;const f=this;this.value={get tabSize(){return f.f},set tabSize(a){f.n(a)},get indentSize(){return f.g},set indentSize(a){f.p(a)},get insertSpaces(){return f.j},set insertSpaces(a){f.s(a)},get cursorStyle(){return f.k},set cursorStyle(a){f.t(a)},get lineNumbers(){return f.l},set lineNumbers(a){f.u(a)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const E=Math.floor(m);return E>0?E:null}if(typeof m=="string"){const E=parseInt(m,10);return isNaN(E)?null:E>0?E:null}return null}n(m){const E=this.m(m);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const E=Math.floor(m);return E>0?E:null}if(typeof m=="string"){const E=parseInt(m,10);return isNaN(E)?null:E>0?E:null}return null}p(m){const E=this.o(m);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const E=this.q(m);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(m)})))}assign(m){const E={};let v=!1;if(typeof m.tabSize<"u"){const u=this.m(m.tabSize);u==="auto"?(v=!0,E.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,v=!0,E.tabSize=u)}if(typeof m.indentSize<"u"){const u=this.o(m.indentSize);u==="tabSize"?(v=!0,E.indentSize=u):typeof u=="number"&&this.h!==u&&(this.g=u,this.h=u,v=!0,E.indentSize=u)}if(typeof m.insertSpaces<"u"){const u=this.q(m.insertSpaces);u==="auto"?(v=!0,E.insertSpaces=u):this.j!==u&&(this.j=u,v=!0,E.insertSpaces=u)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,v=!0,E.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,v=!0,E.lineNumbers=R.TextEditorLineNumbersStyle.from(m.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(m,E){E.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(v)})}}e.$kP=S;class A{constructor(m,E,v,u,f,a,n,i){this.id=m,this.j=E,this.k=v,this.g=!1,this.h=new Set,this.c=f,this.d=new S(this.j,this.id,a,v),this.e=n,this.f=i;const s=this;this.value=Object.freeze({get document(){return u.value},set document(o){throw new N.$9("document")},get selection(){return s.c&&s.c[0]},set selection(o){if(!(o instanceof M.$UM))throw(0,N.$7)("selection");s.c=[o],s.l()},get selections(){return s.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof M.$UM)))throw(0,N.$7)("selections");s.c=o,s.l()},get visibleRanges(){return s.e},set visibleRanges(o){throw new N.$9("visibleRanges")},get options(){return s.d.value},set options(o){s.g||s.d.assign(o)},get viewColumn(){return s.f},set viewColumn(o){throw new N.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new $(u.value,t);return o(g),s.m(g)},insertSnippet(o,t,g={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=s.c.map(c=>R.Range.from(c));else if(t instanceof M.$SM){const{lineNumber:c,column:r}=R.Position.from(t);h=[{startLineNumber:c,startColumn:r,endLineNumber:c,endColumn:r}]}else if(t instanceof M.$TM)h=[R.Range.from(t)];else{h=[];for(const c of t)if(c instanceof M.$TM)h.push(R.Range.from(c));else{const{lineNumber:r,column:w}=R.Position.from(c);h.push({startLineNumber:r,startColumn:w,endLineNumber:r,endColumn:w})}}return E.$tryInsertSnippet(m,u.value.version,o.value,h,g)},setDecorations(o,t){const g=t.length===0;g&&!s.h.has(o.key)||(g?s.h.delete(o.key):s.h.add(o.key),s.n(()=>{if(R.$_O(t))return E.$trySetDecorations(m,o.key,R.$aP(t));{const h=new Array(4*t.length);for(let c=0,r=t.length;c<r;c++){const w=t[c];h[4*c]=w.start.line+1,h[4*c+1]=w.start.character+1,h[4*c+2]=w.end.line+1,h[4*c+3]=w.end.character+1}return E.$trySetDecorationsFast(m,o.key,h)}}))},revealRange(o,t){s.n(()=>E.$tryRevealRange(m,R.Range.from(o),t||M.TextEditorRevealType.Default))},show(o){E.$tryShowEditor(m,R.ViewColumn.from(o))},hide(){E.$tryHideEditor(m)}})}dispose(){(0,l.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,l.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,l.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,l.ok)(!this.g),this.f=m}_acceptSelections(m){(0,l.ok)(!this.g),this.c=m}async l(){const m=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const E=m.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const v=E.edits.map(f=>f.range);v.sort((f,a)=>f.end.line===a.end.line?f.end.character===a.end.character?f.start.line===a.start.line?f.start.character-a.start.character:f.start.line-a.start.line:f.end.character-a.end.character:f.end.line-a.end.line);for(let f=0,a=v.length-1;f<a;f++){const n=v[f].end;if(v[f+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=E.edits.map(f=>({range:R.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,u,{setEndOfLine:typeof E.setEndOfLine=="number"?R.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$lP=A}),define(ke[72],Ee([1,0,62,4,3,2,5,6,152,20,156,16,12,27,15,39,46]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=void 0;class a{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(s,o){this.h=s,this.i=o,this.a=null,this.b=new Map,this.c=new E.$Bc,this.d=new N.$be,this.e=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const o=[],t=[],g=[];if(s.removedDocuments)for(const h of s.removedDocuments){const c=R.URI.revive(h),r=this.c.get(c);r?.unref()&&(this.c.delete(c),o.push(r.value))}if(s.addedDocuments)for(const h of s.addedDocuments){const c=R.URI.revive(h.uri);let r=this.c.get(c);if(r&&c.scheme!==v.Schemas.vscodeNotebookCell&&c.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);r||(r=new a(new $.$fP(this.h.getProxy(b.$PM.MainThreadDocuments),c,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty)),this.c.set(c,r),t.push(r.value)),r.ref()}if(s.removedEditors)for(const h of s.removedEditors){const c=this.b.get(h);this.b.delete(h),c&&g.push(c)}if(s.addedEditors)for(const h of s.addedEditors){const c=R.URI.revive(h.documentUri);l.ok(this.c.has(c),`document '${c}' does not exist`),l.ok(!this.b.has(h.id),`editor '${h.id}' already exists!`);const r=this.c.get(c).value,w=new A.$lP(h.id,this.h.getProxy(b.$PM.MainThreadTextEditors),this.i,new f.$V(()=>r.document),h.selections.map(C.Selection.to),h.options,h.visibleRanges.map(d=>C.Range.to(d)),typeof h.editorPosition=="number"?C.ViewColumn.to(h.editorPosition):void 0);this.b.set(h.id,w)}s.newActiveEditor!==void 0&&(l.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,L.$Pc)(o),(0,L.$Pc)(g),s.removedDocuments&&this.e.fire(o),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(h=>h.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return u.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const o=this.b.get(this.a);return s?o:o?.value}allEditors(){return[...this.b.values()]}};e.$mP=n,e.$mP=n=Je([qe(0,S.$cP),qe(1,m.$Wj)],n),e.$nP=(0,M.$qi)("IExtHostDocumentsAndEditors")}),define(ke[355],Ee([1,0,19,4,6,156,16,7]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=void 0;class ${constructor(A,C){this.i=C,this.a=new N.$be,this.b=new N.$be,this.c=new N.$be,this.d=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(L.$PM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const C=this.i.allEditors();return A?C:C.map(m=>m.value)}async showTextDocument(A,C,m){let E;typeof C=="number"?E={position:M.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?E={position:M.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?M.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:E={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,E),u=v&&this.i.getEditor(v);if(u)return u.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,C){return new R.$jP(this.h,A,C).value}$acceptEditorPropertiesChanged(A,C){const m=this.i.getEditor(A);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const E=C.selections.selections.map(M.Selection.to);m._acceptSelections(E)}if(C.visibleRanges){const E=l.$Hb(C.visibleRanges.map(M.Range.to));m._acceptVisibleRanges(E)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:M.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const E=b.TextEditorSelectionChangeKind.fromValue(C.selections.source),v=C.selections.selections.map(M.Selection.to);this.a.fire({textEditor:m.value,selections:v,kind:E})}if(C.visibleRanges){const E=l.$Hb(C.visibleRanges.map(M.Range.to));this.c.fire({textEditor:m.value,visibleRanges:E})}}$acceptEditorPositionData(A){for(const C in A){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const E=M.ViewColumn.to(A[C]);m.value.viewColumn!==E&&(m._acceptViewColumn(E),this.d.fire({textEditor:m.value,viewColumn:E}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$vkc=$}),define(ke[356],Ee([1,0,2,5,6,3,7,16,25,18]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=void 0,e.$emc=(0,N.$qi)("IExtHostTimeline");class A{constructor(E,v){this.b=new Map,this.c=new Map,this.a=E.getProxy(L.$PM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(u,f)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&$.$Lm.equals(f,this.b.get(u.source)?.extension)){const a=u.uri===void 0?void 0:l.URI.revive(u.uri);return this.c.get(u.source)?.get(C(a))?.get(u.handle)}else return;return u}})}async $getTimeline(E,v,u,f){return this.b.get(E)?.provider.provideTimeline(l.URI.revive(v),u,f)}registerTimelineProvider(E,v,u,f){const a=new R.$Tc,n=this.d(v.id,f,a).bind(this);let i;v.onDidChange&&(i=v.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:v.id}),this));const s=this.c;return this.f({...v,scheme:E,onDidChange:void 0,async provideTimeline(o,t,g){t?.resetCache&&(a.clear(),s.get(v.id)?.clear());const h=await v.provideTimeline(o,t,g);if(h==null)return;const c=n(o,t);return{...h,source:v.id,items:h.items.map(c)}},dispose(){for(const o of s.values())o.get(v.id)?.clear();i?.dispose(),a.dispose()}},u)}d(E,v,u){return(f,a)=>{let n;if(a?.cacheResults){let i=this.c.get(E);i===void 0&&(i=new Map,this.c.set(E,i));const s=C(f);n=i.get(s),n===void 0&&(n=new Map,i.set(s,n))}return i=>{const{iconPath:s,...o}=i,t=`${E}|${i.id??i.timestamp}`;n?.set(t,i);let g,h,c;i.iconPath&&(s instanceof M.$NN?c={id:s.id,color:s.color}:l.URI.isUri(s)?(g=s,h=s):{light:g,dark:h}=s);let r;return M.$gN.isMarkdownString(o.tooltip)?r=b.MarkdownString.from(o.tooltip):(0,S.$4f)(o.tooltip)?r=o.tooltip:M.$gN.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=b.MarkdownString.from(o.detail)):(0,S.$4f)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=o.detail),{...o,id:o.id??void 0,handle:t,source:E,command:i.command?v.toInternal(i.command,u):void 0,icon:g,iconDark:h,themeIcon:c,tooltip:r,accessibilityInformation:i.accessibilityInformation}}}}f(E,v){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:v}),(0,R.$Sc)(()=>{for(const f of this.c.values())f.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$fmc=A;function C(m){return m?.toString()}}),define(ke[357],Ee([1,0,228,23,2,4,3,289,8,7,18,19,16,80,22,184,26]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;function a(s,o){if((0,A.$4f)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class n extends M.$Uc{constructor(o,t,g){super(),this.f=o,this.g=t,this.h=g,this.a=new Map,this.b=new u.$b9;function h(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>h(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(r=>h(r)?this.r(r):r):c})}registerTreeDataProvider(o,t,g){const h=this.createTreeView(o,{treeDataProvider:t},g);return{dispose:()=>h.dispose()}}createTreeView(o,t,g){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],r=!!t.dragAndDropController?.handleDrag,w=!!t.dragAndDropController?.handleDrop,d=this.m(o,t,g),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:c,hasHandleDrag:r,hasHandleDrop:w,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(o,D),k={get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get activeItem(){return(0,f.$yG)(g,"treeViewActiveItem"),d.focusedElement},get onDidChangeActiveItem(){return(0,f.$yG)(g,"treeViewActiveItem"),d.onDidChangeActiveItem},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return d.onDidChangeCheckboxState},get message(){return d.message},set message(y){(0,E.$Pk)(y)&&(0,f.$yG)(g,"treeViewMarkdownMessage"),d.message=y},get title(){return d.title},set title(y){d.title=y},get description(){return d.description},set description(y){d.description=y},get badge(){return d.badge},set badge(y){y!==void 0&&S.ViewBadge.isViewBadge(y)?d.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(d.badge=void 0)},reveal:(y,P)=>d.reveal(y,P),dispose:async()=>{await p,this.a.delete(o),d.dispose()}};return this.B(k),k}$getChildren(o,t){const g=this.a.get(o);return g?g.getChildren(t):Promise.reject(new b.$NF(o))}async $handleDrop(o,t,g,h,c,r,w,d){const D=this.a.get(o);if(!D)return Promise.reject(new b.$NF(o));const p=m.DataTransfer.toDataTransfer(g,async k=>(await this.f.$resolveDropFileData(o,t,k)).buffer);return w===o&&d&&await this.j(p,D,d,c,r),D.onDrop(p,h,c)}async j(o,t,g,h,c){const r=this.b.removeDragOperationTransfer(c);if(r)(await r)?.forEach((w,d)=>{w&&o.set(d,w)});else if(c&&t.handleDrag){const w=t.handleDrag(g,o,h);this.b.addDragOperationTransfer(c,w),await w}return o}async $handleDrag(o,t,g,h){const c=this.a.get(o);if(!c)return Promise.reject(new b.$NF(o));const r=await this.j(new S.$JN,c,t,h,g);if(!(!r||h.isCancellationRequested))return m.DataTransfer.from(r)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new b.$NF(o);return t.hasResolve}$resolve(o,t,g){const h=this.a.get(o);if(!h)throw new b.$NF(o);return h.resolveTreeItem(t,g)}$setExpanded(o,t,g){const h=this.a.get(o);if(!h)throw new b.$NF(o);h.setExpanded(t,g)}$setSelectionAndFocus(o,t,g){const h=this.a.get(o);if(!h)throw new b.$NF(o);h.setSelectionAndFocus(t,g)}$setVisible(o,t){const g=this.a.get(o);if(!g){if(!t)return;throw new b.$NF(o)}g.setVisible(t)}$changeCheckboxState(o,t){const g=this.a.get(o);if(!g)throw new b.$NF(o);g.setCheckboxState(t)}m(o,t,g){const h=this.B(new i(o,t,this.f,this.g.converter,this.h,g));return this.a.set(o,h),h}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$gmc=n;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,A.$ag)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,g,h,c,r){if(super(),this.I=o,this.J=g,this.L=h,this.M=c,this.N=r,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$me,r.contributes&&r.contributes.views)for(const p in r.contributes.views)for(const k of r.contributes.views[p])k.id===o&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let w,d;const D=R.Event.debounce(this.F.event,(p,k)=>(p||(p={message:!1,elements:[]}),k.element!==!1&&(w||(w=new Promise(y=>d=y),this.G=this.G.then(()=>w)),Array.isArray(k.element)?p.elements.push(...k.element):p.elements.push(k.element)),k.message&&(p.message=!0),p),200,!0);this.B(D(({message:p,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const y=d;return w=null,this.$(k).then(()=>y())})),p&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let g=this.X(o);return g||(g=await this.Y(t)),g?g.map(h=>h.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const g=(0,A.$ag)(t.select)?!0:t.select,h=(0,A.$ag)(t.focus)?!1:t.focus,c=(0,A.$ag)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(r=>this.W(o,r[r.length-1]).then(w=>this.J.$reveal(this.I,{item:w.item,parentChain:r.map(d=>d.item)},{select:g,focus:h,expand:c})),r=>this.M.error(r)):this.J.$reveal(this.I,void 0,{select:g,focus:h,expand:c})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=m.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const g=this.getExtensionElement(o);g&&(t?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(o,t){const g=!(0,C.$ub)(this.s,o);this.s=o;const h=this.t!==t;this.t=t,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),h&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async g=>{const h=this.getExtensionElement(g.treeItemHandle);return h?{extensionItem:h,treeItem:await this.f.getTreeItem(h),newState:g.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);t.forEach(g=>{g.treeItem.checkboxState=g.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(g=>[g.extensionItem,g.newState])})}async handleDrag(o,t,g){const h=[];for(const c of o){const r=this.getExtensionElement(c);r&&h.push(r)}if(!(!this.g?.handleDrag||h.length===0))return await this.g.handleDrag(h,t,g),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,g){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.g?.handleDrop))return(0,$.$ih)(()=>this.g?.handleDrop?this.g.handleDrop(h,o,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const g=this.j.get(o);if(g){const h=this.m.get(g);if(h){const c=await this.f.resolveTreeItem(h.extensionItem,g,t)??h.extensionItem;return this.hb(c),h.item.tooltip=this.eb(c.tooltip),h.item.command=this.fb(h.disposableStore,c.command),h.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(g=>this.W(t,g[g.length-1]).then(h=>(g.push(h),g))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$ih)(()=>this.f.getParent(o))}W(o,t){const g=this.m.get(o);return g?Promise.resolve(g):(0,$.$ih)(()=>this.f.getTreeItem(o)).then(h=>this.kb(o,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(h);if(c){const r=this.m.get(c);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const g=this.getExtensionElement(o);t=g?this.m.get(g):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new v.$me(this.Z.token);try{const g=o?this.m.get(o):void 0,h=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const c=(0,C.$Hb)(h||[]),r=await Promise.all((0,C.$Hb)(c).map(d=>this.f.getTreeItem(d)));if(t.token.isCancellationRequested)return;const w=r.map((d,D)=>d?this.db(c[D],d,g):null);return(0,C.$Hb)(w)}finally{t.dispose()}}$(o){if(o.some(g=>!g))return this.Z.dispose(!0),this.Z=new v.$me,this.tb(),this.J.$refresh(this.I);{const g=this.ab(o);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(o){const t=new Set,g=o.map(c=>this.m.get(c));for(const c of g)if(c&&!t.has(c.item.handle)){let r=c;for(;r&&r.parent&&g.findIndex(w=>r&&r.parent&&w&&w.item.handle===r.parent.item.handle)===-1;){const w=this.j.get(r.parent.item.handle);r=w?this.m.get(w):void 0}r&&!r.parent&&t.add(c.item.handle)}const h=[];return t.forEach(c=>{const r=this.j.get(c);if(r){const w=this.m.get(r);w&&(!w.parent||!t.has(w.parent.item.handle))&&h.push(c)}}),h}bb(o){const t={};return Promise.all(o.map(g=>this.cb(g).then(h=>{h&&(t[g]=h.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const g=this.m.get(t);if(g)return this.rb(t),(0,$.$ih)(()=>this.f.getTreeItem(t)).then(h=>{if(h){const c=this.ib(t,h,g.parent);return this.pb(t,c,g,g.parent),g.dispose(),c}return null})}return Promise.resolve(null)}db(o,t,g){const h=this.ib(o,t,g);if(t.id&&this.j.has(h.item.handle))throw new Error((0,l.localize)(0,null,t.id));return this.ob(o,h),this.qb(h,g),h}eb(o){return S.$gN.isMarkdownString(o)?m.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,g,h;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,g=o.checkboxState.tooltip,h=o.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:h}}hb(o){if(!S.$EN.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,g){this.hb(t);const h=this.B(new M.$Tc),c=this.kb(o,t,g),r=this.lb(t);return{item:{handle:c,parentHandle:g?g.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(h,t.command),contextValue:t.contextValue,icon:r,iconDark:this.mb(t)||r,themeIcon:this.jb(t),collapsibleState:(0,A.$ag)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:g,children:void 0,disposableStore:h,dispose(){h.dispose()}}}jb(o){return o.iconPath instanceof S.$NN?o.iconPath:void 0}kb(o,{id:t,label:g,resourceUri:h},c,r){if(t)return`${i.b}/${t}`;const w=a(g,this.N),d=c?c.item.handle:i.a;let D=w?w.label:h?(0,N.$1g)(h):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const p=this.m.has(o)?this.m.get(o).item.handle:void 0,k=this.X(c)||[];let y,P=0;do{if(y=`${d}/${P}:${D}`,r||!this.j.has(y)||p===y)break;P++}while(P<=k.length);return y}lb(o){if(o.iconPath&&!(o.iconPath instanceof S.$NN))return typeof o.iconPath=="string"||L.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof S.$NN)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return L.URI.isUri(o)?o:L.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,g,h){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(o,t);const c=this.X(h)||[],r=c.filter(w=>w.item.handle===g.item.handle)[0];r&&c.splice(c.indexOf(r),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const g of t.children){const h=this.j.get(g.item.handle);h&&this.sb(h)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const g of t.children){const h=this.j.get(g.item.handle);h&&this.sb(h)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[358],Ee([1,0,4,3,2,30,16,92,6,7]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;class A extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,u,f,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new l.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new l.$be),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=u,this.#n=f,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,L.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,u){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:M.ViewColumn.from(v),preserveFocus:!!u})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Uc{static c(){return(0,R.$Mg)()}constructor(v,u,f){super(),this.j=u,this.m=f,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$PM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,u,f,a,n={}){const i=typeof a=="object"?a.viewColumn:a,s={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,b.$Kkc)(v),t=C.c();this.f.$createWebviewPanel((0,b.$Mkc)(v),t,u,{title:f,panelOptions:m(n),webviewOptions:(0,b.$Nkc)(v,this.m,n),serializeBuffersForPostMessage:o},s);const g=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,u,f,i,n,g,!0)}$onDidChangeWebviewPanelViewStates(v){const u=Object.keys(v);u.sort((f,a)=>{const n=v[f],i=v[a];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const f of u){const a=this.getWebviewPanel(f);if(!a)continue;const n=v[f];a._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,u,f){if(this.h.has(u))throw new Error(`Serializer for '${u}' already registered`);return this.h.set(u,{serializer:f,extension:v}),this.f.$registerSerializer(u,{serializeBuffersForPostMessage:(0,b.$Kkc)(v)}),new S.$RM(()=>{this.h.delete(u),this.f.$unregisterSerializer(u)})}async $deserializeWebviewPanel(v,u,f,a){const n=this.h.get(u);if(!n)throw new Error(`No serializer found for '${u}'`);const{serializer:i,extension:s}=n,o=this.j.createNewWebview(v,f.webviewOptions,s),t=this.createNewWebviewPanel(v,u,f.title,a,f.panelOptions,o,f.active);await i.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(v,u,f,a,n,i,s){const o=new A(v,this.f,i,{viewType:u,title:f,viewColumn:a,panelOptions:n,active:s});return this.g.set(v,o),o}getWebviewPanel(v){return this.g.get(v)}}e.$Okc=C;function m(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(ke[359],Ee([1,0,4,3,92,16,6,7]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=void 0;class $ extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,m,E,v,u,f){super(),this.#s=!1,this.#u=this.B(new l.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new l.$be),this.onDidDispose=this.#l.event,this.#i=E,this.#a=v,this.#e=C,this.#t=m,this.#n=u,this.#r=f}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class S{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(M.$PM.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,E,v){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:E,extension:C}),this.a.$registerWebviewViewProvider((0,L.$Mkc)(C),m,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$Kkc)(C)}),new b.$RM(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,E,v,u){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:a,extension:n}=f,i=this.d.createNewWebview(C,{},n),s=new $(C,this.a,m,E,i,!0);this.c.set(C,s),await a.resolveWebviewView(s,{state:v},u)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$jmc=S}),define(ke[360],Ee([1,0,69,15,12,260,32,11]),function(le,e,l,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(N.Schemas.file,new S(m),{isCaseSensitive:b.$k})}};e.$1mc=$,e.$1mc=$=Je([qe(0,l.$Gkc),qe(1,L.$Wj)],$);class S{constructor(C){this.b=C,this.a=new R.$4q(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,E){return this.a.writeFile(C,m,{...E,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,E){return this.a.rename(C,m,E)}copy(C,m,E){return this.a.copy(C,m,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(ke[361],Ee([1,0,17,64,30,33,3,6,2,20]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;let A=class extends M.$Uc{constructor(m,E){super();const v=m.getProxy(b.$PM.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async u=>{const f=$.URI.file((0,l.$kc)((0,N.tmpdir)(),(0,L.$Mg)()));return await v.$download(u,f),f})}};e.$Ymc=A,e.$Ymc=A=Je([qe(0,S.$cP),qe(1,R.$yP)],A)}),define(ke[362],Ee([1,0,52,17,2,93,3,15,8,31]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class A extends R.$Ikc{constructor(){super(...arguments),this.i=null}async g(t){const g=await super.g(t);if(g.scheme!==b.Schemas.file)return g;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${g.fsPath}.`),g;const h=g.fsPath;let c=0;do{let r;c===0?r=h:r=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${c}`:`${h}-${c}`,await C(r);const w=N.$kc(r,"vscode.lock"),d=await u(this.d,w,!1);if(d)return this.i=d,process.on("exit",()=>{d.dispose()}),L.URI.file(r);c++}while(c<10);return g}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$$mc=A;async function C(o){try{await S.Promises.stat(o);return}catch{}try{await S.Promises.mkdir(o,{recursive:!0})}catch{}}const m=1e3,E=10*60*1e3;class v extends M.$Uc{constructor(t,g){super(),this.b=t,this.c=g,this.a=this.B(new $.$Bh),this.a.cancelAndSet(async()=>{const h=await f(t,g);(!h||h.pid!==process.pid)&&(t.info(`Lock '${g}': The lock was lost unexpectedly.`),this.a.cancel());try{await S.Promises.utimes(g,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${g}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{l.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const g={pid:process.pid,willReleaseAt:Date.now()+t};await S.Promises.writeFile(this.c,JSON.stringify(g),{flag:"w"})}catch(g){this.b.error(g)}}}async function u(o,t,g){try{const c={pid:process.pid,willReleaseAt:0};await S.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){o.error(c)}const h=await f(o,t);return!h||h.pid!==process.pid?g?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new v(o,t))}async function f(o,t){let g;try{g=await S.Promises.readFile(t)}catch(h){return o.error(h),null}try{return JSON.parse(String(g))}catch(h){return o.error(h),null}}async function a(o,t){let g;try{g=await S.Promises.stat(t)}catch(h){return o.error(h),0}return g.mtime.getTime()}function n(o){try{return process.kill(o,0),!0}catch{return!1}}async function i(o,t){const g=await f(o,t);if(!g)return o.info(`Lock '${t}': Could not read pid of lock holder.`),s(o,t);if(g.willReleaseAt){let d=g.willReleaseAt-Date.now();if(d<5e3){for(d>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${d} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);d>0;){if(await(0,$.$rh)(Math.min(100,d)),await a(o,t)===0)return s(o,t);d=g.willReleaseAt-Date.now()}return s(o,t)}}if(!n(g.pid))return o.info(`Lock '${t}': The pid ${g.pid} appears to be gone.`),s(o,t);const h=await a(o,t),c=Date.now()-h;if(c<=E)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$rh)(2e3);const r=await a(o,t),w=Date.now()-r;return w<=E?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${w} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),s(o,t))}async function s(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await S.Promises.unlink(t)}catch{}return u(o,t,!0)}}),define(ke[363],Ee([1,0,30,20,43,33]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0;let M=class extends L.$5kc{constructor($,S){super(!0,$,S)}createTerminal($,S,A){return this.createTerminalFromOptions({name:$,shellPath:S,shellArgs:A})}createTerminalFromOptions($,S){const A=new L.$4kc(this.a,(0,l.$Mg)(),$,$.name);return this.f.push(A),A.create($,this.R($,S)),A.value}};e.$tmc=M,e.$tmc=M=Je([qe(0,R.$yP),qe(1,N.$cP)],M)}),define(ke[364],Ee([1,0,4,38,37,5]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.OutputChannelUpdateMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=void 0,e.$XL="text/x-code-output",e.$YL="output",e.$ZL="Log",e.$1L="text/x-code-log-output",e.$2L="log",e.$3L="workbench.panel.output",e.$4L=new L.$Hj("inOutput",!1),e.$5L=new L.$Hj("activeLogOutput",!1),e.$6L=new L.$Hj("activeLogOutput.levelSettable",!1),e.$7L=new L.$Hj("activeLogOutput.level",""),e.$8L=new L.$Hj("activeLogOutput.levelIsDefault",!1),e.$9L=new L.$Hj("outputView.scrollLock",!1),e.$0L=(0,R.$qi)("outputService");var M;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$$L={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new l.$be,this.onDidRegisterChannel=this.b.event,this.c=new l.$be,this.onDidRemoveChannel=this.c.event}registerChannel(S){this.a.has(S.id)||(this.a.set(S.id,S),this.b.fire(S.id))}getChannels(){const S=[];return this.a.forEach(A=>S.push(A)),S}getChannel(S){return this.a.get(S)}removeChannel(S){this.a.delete(S),this.c.fire(S)}}N.$9n.add(e.$$L.OutputChannels,new b),e.$_L=new L.$Hj("activeOutputChannel","")}),define(ke[157],Ee([1,0,6,5,20,25,12,364,69,28,60,189,21,18,32,4,3]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=void 0;class a extends M.$3j{get disposed(){return this.n}constructor(o,t,g,h,c){super(),this.id=o,this.name=t,this.r=g,this.s=h,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=m.$Ce.fromString(t).byteLength,(0,M.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends a{appendLine(o){this.append(o)}}let i=class{constructor(o,t,g,h,c,r){this.i=t,this.j=g,this.k=h,this.l=c,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(l.$PM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,g]of this.g)g.visible=t===this.h}createOutputChannel(o,t,g){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,c=(0,E.$4f)(t)?t:void 0;if((0,E.$4f)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const w=this.i.environment.extensionLogLevel?.find(([D])=>R.$Lm.equals(g.identifier,D))?.[1];w&&(r=(0,M.$bk)(w));const d=h?this.o(o,r,g):this.n(o,c,g);return d.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),h?this.r(o,r??this.m.getLevel(),d):this.q(o,d)}async n(o,t,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const h=await this.c,c=this.k.extUri.joinPath(h,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),w=await this.a.$register(o,c,t,g.identifier.value);return new a(w,o,r,this.a,g)}async o(o,t,g){const h=await this.p(g),c=o.replace(/[\\/:\*\?"<>\|]/g,""),r=this.k.extUri.joinPath(h,`${c}.log`),w=`${g.identifier.value}.${c}`,d=this.l.createLogger(r,{id:w,name:o,logLevel:t,extensionId:g.identifier.value});return new n(w,o,d,this.a,g)}p(o){let t=this.d.get(o.identifier.value);if(!t){const g=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(g)}catch(h){if((0,v.$al)(h)!==v.FileSystemProviderErrorCode.FileExists)throw h}return g})())}return t}q(o,t){let g=!1;const h=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return o},append(c){h(),t.then(r=>r.append(c))},appendLine(c){h(),t.then(r=>r.appendLine(c))},clear(){h(),t.then(c=>c.clear())},replace(c){h(),t.then(r=>r.replace(c))},show(c,r){h(),t.then(w=>w.show(c,r))},hide(){h(),t.then(c=>c.hide())},dispose(){g=!0,t.then(c=>c.dispose())}}}r(o,t,g){const h=new f.$Tc,c=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},r=h.add(new u.$be);function w(d){t=d,r.fire(d)}return g.then(d=>{h.add(d),d.logLevel!==t&&w(d.logLevel),h.add(d.onDidChangeLogLevel(D=>w(D)))}),{...this.q(o,g),get logLevel(){return t},onDidChangeLogLevel:r.event,trace(d,...D){c(),g.then(p=>p.trace(d,...D))},debug(d,...D){c(),g.then(p=>p.debug(d,...D))},info(d,...D){c(),g.then(p=>p.info(d,...D))},warn(d,...D){c(),g.then(p=>p.warn(d,...D))},error(d,...D){c(),g.then(p=>p.error(d,...D))},dispose(){h.dispose()}}}};e.$Ulc=i,e.$Ulc=i=Je([qe(0,L.$cP),qe(1,S.$sP),qe(2,$.$Gkc),qe(3,A.$jkc),qe(4,M.$Xj),qe(5,M.$Wj)],i),e.$Vlc=(0,N.$qi)("IExtHostOutputService")}),define(ke[158],Ee([1,0,5,8]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$an=(0,l.$qi)("remoteAgentService"),e.$bn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await L.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,N.$rh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(R):M=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:M,current:R,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:typeof M>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[365],Ee([1,0,232,85,38,42,54,3,4,158,11,24,8]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=void 0,e.$qJ=Object.freeze({id:"application",order:100,title:(0,l.localize)(0,null),type:"object"}),e.$rJ=Object.freeze({id:"workbench",order:7,title:(0,l.localize)(1,null),type:"object"}),e.$sJ=Object.freeze({id:"security",scope:1,title:(0,l.localize)(2,null),type:"object",order:7}),e.$tJ=Object.freeze({id:"problems",title:(0,l.localize)(3,null),type:"object",order:101}),e.$uJ={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new $.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new E;L.$9n.add(e.$uJ.ConfigurationMigration,v);let u=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async s=>{for(const o of s.added)await this.f(o,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(s=>this.c(s)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(s=>this.g(s,n?.uri))])}async g(n,i){const s=this.a.inspect(n.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,g]of o){const h=s[t];if(!h)continue;const c=[];if(h.value!==void 0){const r=await this.h(n,t,h.value,i,void 0);for(const w of r??[])c.push([w,[]])}for(const{identifiers:r,value:w}of h.overrides??[])if(w!==void 0){const d=await this.h(n,t,w,i,r);for(const D of d??[])c.push([D,r])}c.length&&await Promise.allSettled(c.map(async([[r,w],d])=>this.a.updateValue(r,w.value,{resource:i,overrideIdentifiers:d},g)))}}async h(n,i,s,o,t){const g=c=>{const w=this.a.inspect(c,{resource:o})[i];if(w)return t?w.overrides?.find(({identifiers:d})=>(0,C.$1n)(d,t))?.value:w.value},h=await n.migrateFn(s,g);return Array.isArray(h)?h:[[n.key,h]]}};e.$vJ=u,e.$vJ=u=Je([qe(0,M.$Wi),qe(1,R.$zi)],u);let f=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new m.$Nh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$9n.as(N.$bo.Configuration).registerConfiguration({...e.$sJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,l.localize)(4,null)},default:[],markdownDescription:(0,l.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,l.localize)(6,null),scope:2}}})}};e.$wJ=f,e.$wJ=f=Je([qe(0,S.$an)],f)}),define(ke[366],Ee([1,0,35,15,17,23,242,365,85,5,38]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$wgb=e.$vgb=void 0,e.$xgb=u,e.$ygb=f,e.$vgb=(0,S.$qi)("editorResolverService"),e.$wgb="workbench.editorAssociations";const C=A.$9n.as($.$bo.Configuration),m={...b.$rJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var E;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(E||(e.RegisteredEditorPriority=E={}));var v;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function u(a){switch(a){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function f(a,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const o=typeof a=="string"&&a.indexOf(L.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$1g)(n);return l.$jk(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}}),define(ke[367],Ee([1,0,34,15,17,11,23,2,5,278,42,147,158]),function(le,e,l,N,L,R,M,b,$,S,A,C,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,$.$qi)("pathService");let v=E=class{constructor(f,a,n,i){this.d=f,this.e=a,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??f})()}hasValidBasename(f,a,n){return typeof a=="string"||typeof a>"u"?this.a.then(i=>this.h(f,i,a)):this.h(f,a,n)}h(f,a,n){return f.scheme===N.Schemas.file||f.scheme===N.Schemas.vscodeRemote?(0,l.$og)(n??(0,M.$1g)(f),a===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,a){if(f.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,S.$oM)(a.getWorkspace());if(n)return n;const i=a.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=a.getWorkspace().configuration;return s?s.scheme:N.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?L.$gc:L.$hc)}async fileURI(f){let a="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const i=f.indexOf("/",2);i===-1?(a=f.substring(2),f="/"):(a=f.substring(2,i),f=f.substring(i)||"/")}return b.URI.from({scheme:N.Schemas.file,authority:a,path:f,query:"",fragment:""})}};e.$sM=v,e.$sM=v=E=Je([qe(1,m.$an),qe(2,C.$aM),qe(3,A.$zi)],v)}),define(ke[368],Ee([1,0,244,19,55,4,56,3,2,54,249,12,66,280,88,42,147,26,22,18,24,37]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.OnPortForward=e.$fM=e.$eM=e.TunnelSource=e.TunnelCloseReason=e.$cM=e.$bM=void 0,e.$dM=r,e.$gM=D,e.$hM=p,e.$iM=k,e.$jM=P;const t=10*1e3,g="remote.tunnels.toRestore",h="remote.tunnels.toRestoreExpiration",c=1e3*60*60*24*14;e.$bM="onTunnel",e.$cM=new o.$Hj("forwardedPortsViewEnabled",!1,l.localize(0,null));function r(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var w;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(w||(e.TunnelCloseReason=w={}));var d;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(d||(e.TunnelSource=d={})),e.$eM={source:d.User,description:l.localize(1,null)},e.$fM={source:d.Auto,description:l.localize(2,null)};function D(j,z,O){const T=j.get(k(z,O));if(T)return T;if((0,v.$$v)(z))for(const B of v.$0v){const W=k(B,O);if(j.has(W))return j.get(W)}else if((0,v.$aw)(z))for(const B of v.$_v){const W=k(B,O);if(j.has(W))return j.get(W)}}function p(j,z,O){const T=D(j,z,O);if(T)return T;const B=(0,v.$aw)(z)?"localhost":(0,v.$$v)(z)?"0.0.0.0":void 0;if(B)return D(j,B,O)}function k(j,z){return j+":"+z}var y;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(y||(e.OnPortForward=y={}));function P(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}class I extends b.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new R.$be,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(O=>{(O.affectsConfiguration(I.c)||O.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,O,T){let B=this.w(z,O,T,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const X=this.j[B];X.key===z?(W.onAutoForward=X.onAutoForward??W.onAutoForward,W.elevateIfNeeded=X.elevateIfNeeded!==void 0?X.elevateIfNeeded:W.elevateIfNeeded,W.label=X.label??W.label,W.requireLocalPort=X.requireLocalPort,W.protocol=X.protocol):(W.onAutoForward=W.onAutoForward??X.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:X.elevateIfNeeded,W.label=W.label??X.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??X.protocol),B=this.w(z,O,T,this.j,B+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,i.$4f)(z.host)&&(0,i.$8f)(z.port)}w(z,O,T,B,W){if(W>=B.length)return-1;const X=!(0,v.$$v)(O)&&!(0,v.$aw)(O),Z=B.slice(W).findIndex(Y=>(0,i.$8f)(Y.key)?X?!1:Y.key===z:this.t(Y.key)?X?!1:z>=Y.key.start&&z<=Y.key.end:this.u(Y.key)?z===Y.key.port&&O===Y.key.host:T?Y.key.test(T):!1);return Z>=0?Z+W:-1}y(){const z=this.r.getValue(I.c);if(!z||!(0,i.$6f)(z))return[];const O=[];for(const B in z){if(B===void 0)continue;const W=z[B];let X;if(Number(B))X=Number(B);else if((0,i.$4f)(B))if(I.g.test(B)){const x=B.match(I.g);X={start:Number(x[1]),end:Number(x[2])}}else if(I.h.test(B)){const x=B.match(I.h);X={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(B)}catch{}x&&(X=x)}X&&O.push({key:X,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const T=this.r.getValue(I.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(O)}z(z){function O(T,B){return(0,i.$8f)(T.key)?T.key:B.t(T.key)?T.key.start:B.u(T.key)?T.key.port:Number.MAX_VALUE}return z.sort((T,B)=>O(T,this)-O(B,this))}C(){return this.m}static providedActionToAction(z){switch(z){case v.ProvidedOnAutoForward.Notify:return y.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case v.ProvidedOnAutoForward.Silent:return y.Silent;case v.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(z,O,T){const W=this.r.inspect(I.c).userRemoteValue;let X;!W||!(0,i.$6f)(W)?X={}:X=(0,s.$Wn)(W),X[`${z}`]||(X[`${z}`]={});for(const x in O)X[`${z}`][x]=O[x];return this.r.updateValue(I.c,X,T)}}e.$kM=I;let F=class extends b.$Uc{constructor(z,O,T,B,W,X,x,Z,Y,ue){super(),this.H=z,this.I=O,this.J=T,this.L=B,this.M=W,this.N=X,this.O=x,this.P=Z,this.Q=Y,this.R=ue,this.c=new Map,this.g=new R.$be,this.onForwardPort=this.g.event,this.h=new R.$be,this.onClosePort=this.h.event,this.j=new R.$be,this.onPortName=this.j.event,this.n=new R.$be,this.onCandidatesChanged=this.n.event,this.t=new R.$be,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$be,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async te=>{const we=await this.getAttributes(te.map(Se=>({port:Se.tunnelRemotePort,host:Se.tunnelRemoteHost})));for(const Se of te)if(Se.localAddress){const _=k(Se.tunnelRemoteHost,Se.tunnelRemotePort),U=p(this.m??new Map,Se.tunnelRemoteHost,Se.tunnelRemotePort);this.forwarded.set(_,{remotePort:Se.tunnelRemotePort,remoteHost:Se.tunnelRemoteHost,localAddress:Se.localAddress,protocol:we?.get(Se.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(Se.localAddress,we?.get(Se.tunnelRemotePort)),localPort:Se.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:Se.privacy,source:e.$eM}),this.f.set(_,Se)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async te=>{const we=k(te.tunnelRemoteHost,te.tunnelRemotePort);if(!p(this.forwarded,te.tunnelRemoteHost,te.tunnelRemotePort)&&!p(this.detected,te.tunnelRemoteHost,te.tunnelRemotePort)&&!p(this.c,te.tunnelRemoteHost,te.tunnelRemotePort)&&te.localAddress){const Se=p(this.m??new Map,te.tunnelRemoteHost,te.tunnelRemotePort),_=(await this.getAttributes([{port:te.tunnelRemotePort,host:te.tunnelRemoteHost}]))?.get(te.tunnelRemotePort);this.forwarded.set(we,{remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localAddress:te.localAddress,protocol:_?.protocol??v.TunnelProtocol.Http,localUri:await this.X(te.localAddress,_),localPort:te.tunnelLocalPort,closeable:!0,runningProcess:Se?.detail,hasRunningProcess:!!Se,pid:Se?.pid,privacy:te.privacy,source:e.$eM})}await this.cb(),this.f.set(we,te),this.g.fire(this.forwarded.get(we))})),this.B(this.H.onTunnelClosed(te=>this.W(te,w.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$bM))?(this.R.createKey(e.$cM.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,O){const T=k(z.host,z.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(z))}X(z,O){if(z.startsWith("http"))return $.URI.parse(z);const T=O?.protocol??"http";return $.URI.parse(`${T}://${z}`)}async Y(z){const O=this.N.getWorkspace(),T=O.configuration?(0,M.$ej)(O.configuration.path):O.folders.length>0?(0,M.$ej)(O.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(g)}async $(){return this.Y(h)}async ab(){const z=this.I.get(g,1);if(z)return this.I.remove(g,1),await this.cb(),z;const O=await this.Z();if(O)return this.I.get(O,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const O=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${O.map(T=>T.remotePort).join(", ")}`);for(const T of O){const B=p(this.detected,T.remoteHost,T.remotePort);T.source.source!==d.Extension&&!B||T.source.source===d.Extension&&B?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===d.Extension&&!B&&this.D.set(k(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new b.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async O=>{O.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(0,0).filter(O=>O.startsWith(h));for(const O of z){const T=this.I.getNumber(O,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const B=O.replace(h,g);this.I.remove(O,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),O=z.map(X=>({remoteHost:X.remoteHost,remotePort:X.remotePort,localPort:X.localPort,name:X.name,localAddress:X.localAddress,localUri:X.localUri,protocol:X.protocol,source:X.source}));let T;z.length>0&&(T=JSON.stringify(O));const B=await this.Z(),W=await this.$();!T&&B&&W?(this.I.remove(B,0),this.I.remove(W,0)):T!==this.y&&B&&W&&(this.I.store(B,T,0,0),this.I.store(W,Date.now()+c,0,0)),this.y=T}}async eb(z,O,T){if(!z.tunnelLocalPort||!T?.requireLocalPort||z.tunnelLocalPort===O)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const W=l.localize(3,null,O,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(W)}async forward(z,O){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(z,O)}async fb(z,O){await this.Q.activateByEvent(e.$bM);const T=p(this.forwarded,z.remote.host,z.remote.port);O=O??(O!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const B=z.local!==void 0?z.local:z.remote.port;let W;if(T)return this.hb(T,z,O);{const X=this.L.remoteAuthority,x=X?{getAddress:async()=>(await this.M.resolveAuthority(X)).authority}:void 0,Z=k(z.remote.host,z.remote.port);this.c.set(Z,!0),z=this.gb(Z,z);const Y=await this.H.openTunnel(x,z.remote.host,z.remote.port,void 0,B,z.elevateIfNeeded?z.elevateIfNeeded:O?.elevateIfNeeded,z.privacy,O?.protocol);if(typeof Y=="string")W=Y;else if(Y&&Y.localAddress){const ue=p(this.m??new Map,z.remote.host,z.remote.port),te=Y.protocol?Y.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:O?.protocol??v.TunnelProtocol.Http,we={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:O?.label??z.name,closeable:!0,localAddress:Y.localAddress,protocol:te,localUri:await this.X(Y.localAddress,O),runningProcess:ue?.detail,hasRunningProcess:!!ue,pid:ue?.pid,source:z.source??e.$eM,privacy:Y.privacy};return this.forwarded.set(Z,we),this.f.set(Z,Y),this.c.delete(Z),await this.cb(),await this.eb(Y,B,O),this.g.fire(we),Y}this.c.delete(Z)}return W}gb(z,O){const T=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(T){const B=T.get(z);T.delete(z),B&&(O.name=B.name??O.name,O.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??O.local,O.privacy=O.privacy)}return O}async hb(z,O,T){const B=T?.label??O.name;let W;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(W||(W={}));let X=W.None;switch(B!==z.name&&(z.name=B,X=W.Fire),(T?.protocol||z.protocol!==v.TunnelProtocol.Http)&&T?.protocol!==z.protocol&&(O.source=z.source,X=W.Reopen),O.privacy&&z.privacy!==O.privacy&&(X=W.Reopen),X){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(z.remoteHost,z.remotePort,w.User),await this.fb(O,T)}return p(this.f,O.remote.host,O.remote.port)}async name(z,O,T){const B=p(this.forwarded,z,O),W=k(z,O);if(B){B.name=T,await this.cb(),this.j.fire({host:z,port:O});return}else this.detected.has(W)&&(this.detected.get(W).name=T,this.j.fire({host:z,port:O}))}async close(z,O,T){const B=k(z,O),W=this.forwarded.get(B);return T===w.AutoForwardEnd&&W&&W.source.source===d.Auto&&this.F.set(B,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(z,O),this.W({host:z,port:O},T)}address(z,O){const T=k(z,O);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const O of z){const T=p(this.m??new Map,O.remoteAddress.host,O.remoteAddress.port),B=typeof O.localAddress=="string"?O.localAddress:k(O.localAddress.host,O.localAddress.port);this.detected.set(k(O.remoteAddress.host,O.remoteAddress.port),{remoteHost:O.remoteAddress.host,remotePort:O.remoteAddress.port,localAddress:B,protocol:v.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:d.Extension,description:l.localize(4,null)}}),this.H.setEnvironmentTunnel(O.remoteAddress.host,O.remoteAddress.port,B,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let O=z;this.r&&(O=await this.r(z));const T=this.ib(O);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(B=>B.port).join(", ")}`),this.n.fire(T)}ib(z){const O=this.m??new Map,T=new Map;return this.m=T,z.forEach(B=>{const W=k(B.host,B.port);T.set(W,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),O.has(W)&&O.delete(W);const X=p(this.forwarded,B.host,B.port);X&&(X.runningProcess=B.detail,X.hasRunningProcess=!0,X.pid=B.pid)}),O.forEach((B,W)=>{const X=r(W);if(!X)return;const x=p(this.forwarded,X.host,X.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const Z=p(this.detected,X.host,X.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0)}),O}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),O=await this.getAttributes(z.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(O)for(const T of z){const B=O.get(T.remotePort);(B?.protocol||T.protocol!==v.TunnelProtocol.Http)&&B?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},B),B&&B.label&&B.label!==T.name&&await this.name(T.remoteHost,T.remotePort,B.label)}}async getAttributes(z,O=!0){const T=new Map,B=new Map;z.forEach(Y=>{const ue=p(this.m??new Map,v.$0v[0],Y.port)??Y;if(ue){T.set(Y.port,ue);const te=P(ue)?ue.pid:void 0;B.has(te)||B.set(te,[]),B.get(te)?.push(Y.port)}});const W=new Map;if(z.forEach(Y=>{const ue=this.configPortsAttributes.getAttributes(Y.port,Y.host,T.get(Y.port)?.detail);ue&&W.set(Y.port,ue)}),this.G.length===0||!O)return W.size>0?W:void 0;const X=await Promise.all((0,N.$Rb)(this.G.map(Y=>Array.from(B.entries()).map(ue=>{const te=ue[1],we=T.get(te[0]);return Y.providePortAttributes(te,we?.pid,we?.detail,n.CancellationToken.None)})))),x=new Map;if(X.forEach(Y=>Y.forEach(ue=>{ue&&x.set(ue.port,ue)})),!W&&!x)return;const Z=new Map;return z.forEach(Y=>{const ue=W.get(Y.port),te=x.get(Y.port);Z.set(Y.port,{elevateIfNeeded:ue?.elevateIfNeeded,label:ue?.label,onAutoForward:ue?.onAutoForward??I.providedActionToAction(te?.autoForwardAction),requireLocalPort:ue?.requireLocalPort,protocol:ue?.protocol})}),Z}addAttributesProvider(z){this.G.push(z)}};e.$lM=F,Je([(0,L.$Vh)(1e3)],F.prototype,"cb",null),e.$lM=F=Je([qe(0,v.$5v),qe(1,E.$Up),qe(2,S.$Wi),qe(3,f.$aM),qe(4,m.$Bl),qe(5,u.$zi),qe(6,C.$Wj),qe(7,A.$yw),qe(8,a.$uG),qe(9,o.$Ij)],F)}),define(ke[94],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$XK=e.$WK=void 0;class l{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new l(0,0)}with(M){return new l(0,0)}}e.$WK=l;class N{constructor(M,b,$,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(M,b),this.end=new l($,S)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$XK=N;var L;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ke[36],Ee([1,0,19,35,24,34,14,5,17,13,94,8]),function(le,e,l,N,L,R,M,b,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$iL=e.$bL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$$K=e.$0K=e.$9K=e.$8K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.TextSearchCompleteMessageType=void 0,e.$5K=a,e.$6K=n,e.$7K=i,e.$_K=d,e.$aL=D,e.$cL=y,e.$dL=P,e.$eL=I,e.$fL=F,e.$gL=j,e.$hL=z,e.$jL=T,e.$lL=X,e.$mL=x,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$YK="workbench.view.search",e.$ZK="workbench.panel.search",e.$1K="workbench.view.search",e.$2K="search-result",e.$3K="search.exclude";const m="\u27EA ",E=" characters skipped \u27EB",v=(m.length+E.length+5)*2;e.$4K=(0,b.$qi)("searchService");var u;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text",Y[Y.aiText=2]="aiText"})(u||(e.SearchProviderType=u={}));var f;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.aiText=3]="aiText"})(f||(e.QueryType=f={}));function a(Y){return!!Y.preview}function n(Y){return!!Y.resource}function i(Y){return!!Y.message}var s;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class o{constructor(ue){this.resource=ue,this.results=[]}}e.$8K=o;class t{constructor(ue,te,we,Se){this.ranges=te,this.webviewIndex=Se;const _=Array.isArray(te)?te:[te];if(we&&we.matchLines===1&&g(_)){ue=(0,M.$Wf)(ue,we.matchLines);let U="",ne=0,$e=0;const Pe=Math.floor(we.charsPerLine/5),se=[];for(const re of _){const oe=Math.max(re.startColumn-Pe,0),G=re.startColumn+we.charsPerLine;if(oe>$e+Pe+v){const ie=m+(oe-$e)+E;U+=ie+ue.slice(oe,G),ne+=oe-($e+ie.length)}else U+=ue.slice($e,G);se.push(new c(0,re.startColumn-ne,re.endColumn-ne)),$e=G}this.preview={text:U,matches:Array.isArray(this.ranges)?se:se[0]}}else{const U=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ue,matches:(0,l.$2b)(te,ne=>new h(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$9K=t;function g(Y){const ue=Y[0].startLineNumber;for(const te of Y)if(te.startLineNumber!==ue||te.endLineNumber!==ue)return!1;return!0}class h{constructor(ue,te,we,Se){this.startLineNumber=ue,this.startColumn=te,this.endLineNumber=we,this.endColumn=Se}}e.$0K=h;class c extends h{constructor(ue,te,we){super(ue,te,ue,we)}}e.$$K=c;var r;(function(Y){Y.List="list",Y.Tree="tree"})(r||(e.ViewMode=r={}));var w;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(w||(e.SearchSortOrder=w={}));function d(Y,ue=!0){const te=Y&&Y.files&&Y.files.exclude,we=ue&&Y&&Y.search&&Y.search.exclude;if(!te&&!we)return;if(!te||!we)return te||we;let Se=Object.create(null);return Se=L.$Zn(Se,L.$Wn(te)),Se=L.$Zn(Se,L.$Wn(we),!0),Se}function D(Y,ue){return Y.excludePattern&&N.$jk(Y.excludePattern,ue)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&N.$jk(Y.includePattern,ue)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(te=>{const we=te.folder.fsPath;if(R.$qg(ue,we)){const Se=$.$mc(we,ue);return!te.includePattern||!!N.$jk(te.includePattern,Se)}else return!1}):!1:!0}var p;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class k extends Error{constructor(ue,te){super(ue),this.code=te}}e.$bL=k;function y(Y){const ue=Y.message;if((0,S.$4)(Y))return new k(ue,p.canceled);try{const te=JSON.parse(ue);return new k(te.message,te.code)}catch{return new k(ue,p.other)}}function P(Y){const ue={message:Y.message,code:Y.code};return new Error(JSON.stringify(ue))}function I(Y){return Y.type==="error"?!0:Y.type==="success"}function F(Y){return Y.type==="success"}function j(Y){return!!Y.path}function z(Y,ue,te=!0){const we=Y.searchPath?Y.searchPath:Y.relativePath;return te?(0,M.$Tf)(we,ue):N.$jk(ue,we)}class O{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$iL=O;function T(Y,ue){const te={...Y||{},...ue||{}};return Object.keys(te).filter(we=>{const Se=te[we];return typeof Se=="boolean"&&Se})}class B{constructor(ue,te){this.c=null,this.a={...ue.excludePattern||{},...te.excludePattern||{}},this.b=N.$kk(this.a);let we=ue.includePattern;te.includePattern&&(we?we={...we,...te.includePattern}:we=te.includePattern),we&&(this.c=N.$kk(we))}matchesExcludesSync(ue,te,we){return!!(this.b&&this.b(ue,te,we))}includedInQuerySync(ue,te,we){return!(this.b&&this.b(ue,te,we)||this.c&&!this.c(ue,te,we))}includedInQuery(ue,te,we){const Se=this.b(ue,te,we),_=()=>this.c?!!this.c(ue,te,we):!0;return(0,C.$ch)(Se)?Se.then(U=>U?!1:_()):_()}hasSiblingExcludeClauses(){return W(this.a)}}e.$kL=B;function W(Y){for(const ue in Y)if(typeof Y[ue]!="boolean")return!0;return!1}function X(Y){if(!Y)return;let ue;return te=>(ue||(ue=(Y()||Promise.resolve([])).then(we=>we?Z(we):{})),ue.then(we=>!!we[te]))}function x(Y){if(!Y)return;let ue;return te=>{if(!ue){const we=Y();ue=we?Z(we):{}}return!!ue[te]}}function Z(Y){const ue={};for(const te of Y)ue[te]=!0;return ue}}),define(ke[44],Ee([1,0,19,8,22,4,3,77,15,125,23,14,2,230,5,12,263,42,60,28,20,16,7,67,36,6,58]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o,t,g,h,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=e.$Akc=void 0;function w(F,j,z){return new A.$Sg(O=>k(O,z)).isEqual(F,j)}function d(F,j,z){return w(F.uri,j.uri,z)?0:(0,C.$mf)(F.uri.toString(),j.uri.toString())}function D(F,j,z){return F.index!==j.index?F.index<j.index?-1:1:w(F.uri,j.uri,z)?(0,C.$mf)(F.name,j.name):(0,C.$mf)(F.uri.toString(),j.uri.toString())}function p(F,j,z,O){const T=F.slice(0).sort((W,X)=>z(W,X,O)),B=j.slice(0).sort((W,X)=>z(W,X,O));return(0,l.$Eb)(T,B,(W,X)=>z(W,X,O))}function k(F,j){const z=j.getCapabilities(F.scheme);return!(z&&z&1024)}class y extends a.$Ji{static toExtHostWorkspace(j,z,O,T){if(!j)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:X,configuration:x,transient:Z,isUntitled:Y}=j,ue=[],te=z;z?X.forEach((U,ne)=>{const $e=m.URI.revive(U.uri),Pe=y.o(O||z,$e,T);Pe?(Pe.name=U.name,Pe.index=U.index,ue.push(Pe)):ue.push({uri:$e,name:U.name,index:ne})}):ue.push(...X.map(({uri:U,name:ne,index:$e})=>({uri:m.URI.revive(U),name:ne,index:$e}))),ue.sort((U,ne)=>U.index<ne.index?-1:1);const we=new y(B,W,ue,!!Z,x?m.URI.revive(x):null,!!Y,U=>k(U,T)),{added:Se,removed:_}=p(te?te.workspaceFolders:[],we.workspaceFolders,d,T);return{workspace:we,added:Se,removed:_}}static o(j,z,O){for(let T=0;T<j.folders.length;T++){const B=j.workspaceFolders[T];if(w(B.uri,z,O))return B}}constructor(j,z,O,T,B,W,X){super(j,O.map(x=>new a.$Ki(x)),T,B,X),this.t=z,this.u=W,this.q=[],this.s=b.$wi.forUris(X),O.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,A.$3g)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let P=class{constructor(j,z,O,T,B){this.c=new R.$be,this.onDidChangeWorkspace=this.c.event,this.g=new R.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$de,this.C=new Map,this.h=T,this.s=O,this.t=B,this.j=new S.$xm,this.k=new N.$ph,this.o=j.getProxy(c.$PM.MainThreadWorkspace),this.q=j.getProxy(c.$PM.MainThreadMessageService);const W=z.workspace;this.l=W?new y(W.id,W.name,[],!!W.transient,W.configuration?m.URI.revive(W.configuration):null,!!W.isUntitled,X=>k(X,O)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,A.$1g)((0,A.$3g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,O,...T){const B=[];if(Array.isArray(T)&&T.forEach(Y=>{m.URI.isUri(Y.uri)&&!B.some(ue=>w(ue.uri,Y.uri,this.s))&&B.push({uri:Y.uri,name:Y.name||(0,A.$Zg)(Y.uri)})}),this.n||[z,O].some(Y=>typeof Y!="number"||Y<0)||O===0&&B.length===0)return!1;const W=this.x?this.x.workspaceFolders:[];if(z+O>W.length)return!1;const X=W.slice(0);X.splice(z,O,...B.map(Y=>({uri:Y.uri,name:Y.name||(0,A.$Zg)(Y.uri),index:void 0})));for(let Y=0;Y<X.length;Y++){const ue=X[Y];if(X.some((te,we)=>we!==Y&&w(ue.uri,te.uri,this.s)))return!1}X.forEach((Y,ue)=>Y.index=ue);const{added:x,removed:Z}=p(W,X,D,this.s);if(x.length===0&&Z.length===0)return!1;if(this.o){const Y=j.displayName||j.name;this.o.$updateWorkspaceFolders(Y,z,O,B).then(void 0,ue=>{this.n=void 0;const te={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(f.Severity.Error,(0,E.localize)(0,null,Y,ue.toString()),te,[])})}return this.y(X),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let O,T="";if(typeof j=="string"?(O=m.URI.file(j),T=j):typeof j<"u"&&(O=j,T=j.fsPath),!O)return T;const B=this.getWorkspaceFolder(O,!0);if(!B)return T;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let W=(0,A.$6g)(B.uri,O);return z&&B.name&&(W=`${B.name}/${W}`),W}y(j){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:O,removed:T}=y.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:T}))}findFiles(j,z,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let W="",X=!0;return z===null?X=!1:z!==void 0&&(typeof z=="string"?W=z:W=z.pattern),this.z(j,void 0,{exclude:W,maxResults:O,useDefaultExcludes:X,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(j,z={},O,T=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${O.value}, entryPoint: findFiles2`),this.z(void 0,j,z,T)}async z(j,z,O,T=L.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const B=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,W={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof O.useDefaultSearchExcludes=="boolean"?!O.useDefaultSearchExcludes:!1,maxResults:O.maxResults,excludePattern:B,shouldGlobSearch:typeof O.fuzzy=="boolean"?!O.fuzzy:!0,_reason:"startFileSearch"};let X;if(j){const{includePattern:x,folder:Z}=I(o.GlobPattern.from(j));X=Z,W.includePattern=x}else{const{includePattern:x,folder:Z}=I(o.GlobPattern.from(z));X=Z,W.filePattern=x}return this.o.$startFileSearch(X??null,W,T).then(x=>Array.isArray(x)?x.map(Z=>m.URI.revive(Z)):[])}async findTextInFiles(j,z,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const W=this.j.getNext(),X=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:x,folder:Z}=I(o.GlobPattern.from(z.include)),Y=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ue={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:X,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:x,excludePattern:Y},te=!1;if(this.u[W]=we=>{if(te)return;const Se=m.URI.revive(we.resource);we.results.forEach(_=>{const U=(0,r.$Zh)(_);(0,h.$5K)(U)?O({uri:Se,preview:{text:U.preview.text,matches:(0,l.$2b)(U.preview.matches,ne=>new t.$TM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,l.$2b)(U.ranges,ne=>new t.$TM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):O({uri:Se,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(j,Z??null,ue,W,B);return delete this.u[W],we||{}}catch(we){throw delete this.u[W],we}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return m.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return m.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const O=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,O),(0,M.$Sc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const O=await this.resolveWorkspaceFolder(m.URI.revive(j));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const T=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!T),!T)return;const B=await T.provideEditSessionIdentity(O,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(j,z,O,T){this.h.info("Getting edit session identifier for workspaceFolder",j);const B=await this.resolveWorkspaceFolder(m.URI.revive(j));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const X=await W.provideEditSessionIdentityMatch?.(z,O,T);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(j){return(z,O,T)=>{const B=function(X){z.call(O,X)};return B.extension=j,this.B.event(B,void 0,T)}}async $onWillCreateEditSessionIdentity(j,z,O){const T=await this.resolveWorkspaceFolder(m.URI.revive(j));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},z,async(B,W)=>{const X=Date.now();await Promise.resolve(B),Date.now()-X>O&&this.h.warn("SLOW edit session create-participant",W.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const O=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerCanonicalUriProvider(T,O),(0,M.$Sc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(j,z,O){const T=this.C.get(j.scheme);if(!T)return;const B=await T.provideCanonicalUri?.(m.URI.revive(j),z,O);if(B)return B}async $provideCanonicalUri(j,z,O){return this.provideCanonicalUri(m.URI.revive(j),{targetScheme:z},O)}};e.$Akc=P,e.$Akc=P=Je([qe(0,s.$cP),qe(1,i.$sP),qe(2,n.$jkc),qe(3,u.$Wj),qe(4,g.$ykc)],P),e.$Bkc=(0,v.$qi)("IExtHostWorkspace");function I(F){let j,z;return F&&(typeof F=="string"?j=F:(j=F.pattern,z=m.URI.revive(F.baseUri))),{includePattern:j,folder:z}}}),define(ke[45],Ee([1,0,24,4,44,6,7,265,85,18,8,5,20,12,2]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=e.$Dkc=e.$Ckc=void 0;function u(g,h){if(h){const c=h.split(".");let r=g;for(let w=0;r&&w<c.length;w++)r=r[c[w]];return r}}function f(g){return g instanceof v.URI}function a(g){return g&&g.uri instanceof v.URI&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&g.uri instanceof v.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function s(g){if(f(g))return{resource:g};if(a(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(n(g))return{overrideIdentifier:g.languageId};if(i(g))return{resource:g.uri};if(g===null)return{resource:null}}let o=class{constructor(h,c,r){this.a=h.getProxy(R.$PM.MainThreadConfiguration),this.c=c,this.b=r,this.d=new A.$ph,this.e=null}getConfigProvider(){return this.d.wait().then(h=>this.e)}$initializeConfiguration(h){this.e=new t(this.a,this.c,h,this.b),this.d.open()}$acceptConfigurationChanged(h,c){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(h,c))}};e.$Ckc=o,e.$Ckc=o=Je([qe(0,m.$cP),qe(1,L.$Bkc),qe(2,E.$Wj)],o);class t{constructor(h,c,r,w){this.a=new N.$be,this.b=h,this.f=w,this.c=c,this.e=b.$uo.parse(r,w),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(h,c){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$uo.parse(h,this.f),this.d=this.k(h.configurationScopes),this.a.fire(this.j(c,r))}getConfiguration(h,c,r){const w=s(c)||{},d=this.g(h?u(this.e.getValue(void 0,w,this.c.workspace),h):this.e.getValue(void 0,w,this.c.workspace));h&&this.h(h,w,r?.identifier);function D(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(k){return typeof u(d,k)<"u"},get:(k,y)=>{this.h(h?`${h}.${k}`:k,w,r?.identifier);let P=u(d,k);if(typeof P>"u")P=y;else{let I;const F=(j,z)=>{if((0,S.$6f)(j)){let O;const T=()=>{I=I||(0,l.$Wn)(d),O=O||u(I,z)};return new Proxy(j,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return T(),()=>O;if(I)return O=O||u(I,z),O[W];const X=B[W];return typeof W=="string"?F(X,`${z}.${W}`):X},set:(B,W,X)=>(T(),O&&(O[W]=X),!0),deleteProperty:(B,W)=>(T(),O&&delete O[W],!0),defineProperty:(B,W,X)=>(T(),O&&Object.defineProperty(O,W,X),!0)})}return Array.isArray(j)?(0,l.$Wn)(j):j};P=F(P,k)}return P},update:(k,y,P,I)=>{k=h?`${h}.${k}`:k;const F=D(P);return y!==void 0?this.b.$updateConfigurationOption(F,k,y,w,I):this.b.$removeConfigurationOption(F,k,w,I)},inspect:k=>{k=h?`${h}.${k}`:k;const y=this.e.inspect(k,w,this.c.workspace);if(y)return{key:k,defaultValue:(0,l.$Wn)(y.policy?.value??y.default?.value),globalValue:(0,l.$Wn)(y.user?.value??y.application?.value),workspaceValue:(0,l.$Wn)(y.workspace?.value),workspaceFolderValue:(0,l.$Wn)(y.workspaceFolder?.value),defaultLanguageValue:(0,l.$Wn)(y.default?.override),globalLanguageValue:(0,l.$Wn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,l.$Wn)(y.workspace?.override),workspaceFolderLanguageValue:(0,l.$Wn)(y.workspaceFolder?.override),languageIds:(0,l.$Wn)(y.overrideIdentifiers)}}};return typeof d=="object"&&(0,l.$Zn)(p,d,!1),Object.freeze(p)}g(h){const c=r=>(0,S.$6f)(r)?new Proxy(r,{get:(w,d)=>c(w[d]),set:(w,d,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(w,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(w,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return c(h)}h(h,c,r){const w=$.$lo.test(h)?4:this.d.get(h),d=r?`[${r.value}] `:"";if(w===4){typeof c?.resource>"u"&&this.f.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${h}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){c?.resource&&this.f.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${h}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(h,c){const r=new b.$wo(h,c,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(w,d)=>r.affectsConfiguration(w,s(d))})}k(h){return h.reduce((c,r)=>(c.set(r[0],r[1]),c),new Map)}}e.$Dkc=t,e.$Ekc=(0,C.$qi)("IExtHostConfiguration")}),define(ke[95],Ee([1,0,2,8,4,6,7,44,72,45,22,43,20,28,5,15,11,12,91,309,13]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=e.$7lc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(o||(o={}));var t;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(t||(t={}));var g;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(g||(g={}));var h;(function(F){function j(T){if(T){const B=T;return B&&!!B.process}else return!1}F.is=j;function z(T){if(T==null)return;const B={process:T.process,args:T.args};return T.options&&(B.options=g.from(T.options)),B}F.from=z;function O(T){if(T!=null)return new M.$AN(T.process,T.args,T.options)}F.to=O})(h||(h={}));var c;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(c||(c={}));var r;(function(F){function j(T){if(T){const B=T;return B&&(!!B.commandLine||!!B.command)}else return!1}F.is=j;function z(T){if(T==null)return;const B={};return T.commandLine!==void 0?B.commandLine=T.commandLine:(B.command=T.command,B.args=T.args),T.options&&(B.options=c.from(T.options)),B}F.from=z;function O(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new M.$BN(T.commandLine,T.options):new M.$BN(T.command,T.args?T.args:[],T.options)}F.to=O})(r||(r={}));var w;(function(F){function j(T){if(T){const B=T;return B&&B.customExecution==="customExecution"}else return!1}F.is=j;function z(T){return{customExecution:"customExecution"}}F.from=z;function O(T,B){return B.get(T)}F.to=O})(w||(e.CustomExecutionDTO=w={}));var d;(function(F){function j(z,O){let T;return z.scope!==void 0&&typeof z.scope!="number"?T=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===M.TaskScope.Workspace&&O&&O.workspaceFile?T=O.workspaceFile:T=i.$VH),{id:z._id,workspaceFolder:T}}F.from=j})(d||(e.TaskHandleDTO=d={}));var D;(function(F){function j(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}F.from=j})(D||(D={}));var p;(function(F){function j(T,B){if(T==null)return[];const W=[];for(const X of T){const x=z(X,B);x&&W.push(x)}return W}F.fromMany=j;function z(T,B){if(T==null)return;let W;T.execution instanceof M.$AN?W=h.from(T.execution):T.execution instanceof M.$BN?W=r.from(T.execution):T.execution&&T.execution instanceof M.$CN&&(W=w.from(T.execution));const X=o.from(T.definition);let x;return T.scope?typeof T.scope=="number"?x=T.scope:x=T.scope.uri:x=M.TaskScope.Workspace,!X||!x?void 0:{_id:T._id,definition:X,name:T.name,source:{extensionId:B.identifier.value,label:T.source,scope:x},execution:W,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}F.from=z;async function O(T,B,W){if(T==null)return;let X;h.is(T.execution)?X=h.to(T.execution):r.is(T.execution)?X=r.to(T.execution):w.is(T.execution)&&(X=w.to(T._id,W));const x=o.to(T.definition);let Z;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Z=T.source.scope:Z=await B.resolveWorkspaceFolder(l.URI.revive(T.source.scope)):Z=M.TaskScope.Workspace),!x||!Z)return;const Y=new M.$DN(x,Z,T.name,T.source.label,X,T.problemMatchers);return T.isBackground!==void 0&&(Y.isBackground=T.isBackground),T.group!==void 0&&(Y.group=M.$zN.from(T.group._id),Y.group&&T.group.isDefault&&(Y.group=new M.$zN(Y.group.id,Y.group.label),T.group.isDefault===!0&&(Y.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Y.presentationOptions=t.to(T.presentationOptions)),T._id&&(Y._id=T._id),T.detail&&(Y.detail=T.detail),Y}F.to=O})(p||(e.TaskDTO=p={}));var k;(function(F){function j(O){return O}F.from=j;function z(O){if(O)return Object.assign(Object.create(null),O)}F.to=z})(k||(k={}));class y{#e;constructor(j,z,O){this._id=z,this.a=O,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let P=class{constructor(j,z,O,T,B,W,X,x){this.q=new L.$be,this.r=new L.$be,this.s=new L.$be,this.u=new L.$be,this.a=j.getProxy(R.$PM.MainThreadTask),this.b=O,this.c=T,this.d=B,this.e=W,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=X,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,z,O){if(!O)return new M.$RM(()=>{});const T=this.x();return this.j.set(T,{type:z,provider:O,extension:j}),this.a.$registerTaskProvider(T,z),new M.$RM(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(j,z){this.a.$registerTaskSystem(j,z)}fetchTasks(j){return this.a.$fetchTasks(k.from(j)).then(async z=>{const O=[];for(const T of z){const B=await p.to(T,this.b,this.m);B&&O.push(B)}return O})}get taskExecutions(){const j=[];return this.k.forEach(z=>j.push(z)),j}terminateTask(j){if(!(j instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,z,O){const T=this.m.get(j.id);T&&(this.o.set(j.id,T),this.e.attachPtyToTerminal(z,await T.callback(O))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const z=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const z=await this.z(j.id);this.s.fire({execution:z,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const z=await this.z(j.id);this.u.fire({execution:z,exitCode:j.exitCode})}$provideTasks(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));const T=[],B=(0,N.$ih)(()=>O.provider.provideTasks(A.CancellationToken.None)).then(W=>this.v(z,T,O,W));return new Promise(W=>{B.then(X=>{Promise.all(T).then(()=>{W(X)})})})}async $resolveTask(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const T=await p.to(z,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(T,A.CancellationToken.None);if(!B)return;this.A(B,O);const W=p.from(B,O.extension);if(!W)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(W.execution)&&await this.y(W,B,!0),await this.w(W)}x(){return this.h++}async y(j,z,O){const T=await this.a.$createTaskId(j);!O&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,z.execution)),this.m.set(T,z.execution)}async z(j,z){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new s.$bb("Unexpected: The specified task is missing an execution");return B}const O=this.l.get(j.id);if(O)return O;let T;return z?T=Promise.resolve(new y(this,j.id,z)):T=p.to(j.task,this.b,this.m).then(B=>{if(!B)throw new s.$bb("Unexpected: Task does not exist.");return new y(this,j.id,B)}),this.l.set(j.id,T),T.then(B=>(this.k.set(j.id,B),B))}A(j,z){j._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const O=this.n.values();let T=O.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=O.next()}};e.$7lc=P,e.$7lc=P=Je([qe(0,m.$cP),qe(1,E.$sP),qe(2,b.$Bkc),qe(3,$.$nP),qe(4,S.$Ekc),qe(5,C.$3kc),qe(6,a.$Wj),qe(7,n.$fkc)],P);let I=class extends P{constructor(j,z,O,T,B,W,X,x){super(j,z,O,T,B,W,X,x),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(j,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=p.from(z,j);if(O===void 0)throw new Error("Task is not valid");if(w.is(O.execution))await this.y(O,z,!1);else throw new s.$_;const T=await this.z(await this.a.$getTaskExecution(O),z);return this.a.$executeTask(O).catch(B=>{throw new Error(B)}),T}v(j,z,O,T){const B=[];if(T)for(const W of T){if(this.A(W,O),!W.definition||!j[W.definition.type]){const x=W.source?W.source:"No task source";this.f.warn(`The task [${x}, ${W.name}] uses an undefined task type. The task will be ignored in the future.`)}const X=p.from(W,O.extension);X&&w.is(X.execution)?(B.push(X),z.push(this.y(X,W,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async w(j){if(w.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,z,O){}};e.$8lc=I,e.$8lc=I=Je([qe(0,m.$cP),qe(1,E.$sP),qe(2,b.$Bkc),qe(3,$.$nP),qe(4,S.$Ekc),qe(5,C.$3kc),qe(6,a.$Wj),qe(7,n.$fkc)],I),e.$9lc=(0,v.$qi)("IExtHostTask")}),define(ke[369],Ee([1,0,36,29]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=void 0,e.$sL=L,e.$uL=R;function L(M){return"cellResults"in M}e.$tL="rawCell#";function R(M,b){let $=-1;const S=[];let A=[];return M.forEach(m=>{m.range.startLineNumber!==$&&A.length>0&&(S.push([...A]),A=[]),A.push(m),$=m.range.endLineNumber}),A.length>0&&S.push([...A]),S.map(m=>{const E=[],v=m[0].range.startLineNumber,u=m[m.length-1].range.endLineNumber;for(let f=v;f<=u;f++)E.push(b.getLineContent(f));return new l.$9K(E.join(`
`)+`
`,m.map(f=>new N.$kt(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}}),define(ke[370],Ee([1,0,224,21,4,3,27,14,18,2,32,111,6,33,16,7,48,340,153,24,15,299,369,366]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(r=>r.apiEditor)}constructor(r,w,d,D,p,k){this.q=d,this.r=D,this.s=p,this.t=k,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new L.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$dkc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=r.getProxy(m.$PM.MainThreadNotebook),this.c=r.getProxy(m.$PM.MainThreadNotebookDocuments),this.d=r.getProxy(m.$PM.MainThreadNotebookEditors),this.i=w.converter,w.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const P=y.notebookEditor?.notebookUri,I=y.cell.handle,j=this.g.get(P)?.getCell(I);if(j)return j.apiCell}if(y&&y.$mid===14){const P=y.uri,I=this.g.get(P);if(I)return I.apiNotebook}return y}}),h.B(w)}getEditorById(r){const w=this.h.get(r);if(!w)throw new Error(`unknown text editor: ${r}. known editors: ${[...this.h.keys()]} `);return w}getIdByEditor(r){for(const[w,d]of this.h)if(d.apiEditor===r)return w}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(r,w){const d=this.g.get(r);if(!d&&!w)throw new Error(`NO notebook document for '${r}'`);return d}static u(r,w){if(!w)return;const d=w.filenamePattern.map(D=>v.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(w.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:r.identifier,providerDisplayName:r.displayName||r.name,displayName:w.displayName,filenamePattern:d,exclusive:w.exclusive||!1}}registerNotebookCellStatusBarItemProvider(r,w,d){const D=h.a++,p=typeof d.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(D,d),this.b.$registerNotebookCellStatusBarItemProvider(D,p,w);let k;return p!==void 0&&(k=d.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(p))),new u.$RM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,p),k?.dispose()})}async createNotebookDocument(r){const w=await this.c.$tryCreateNotebook({viewType:r.viewType,content:r.content&&v.NotebookData.from(r.content)});return S.URI.revive(w)}async openNotebookDocument(r){const w=this.g.get(r);if(w)return w.apiNotebook;const d=await this.c.$tryOpenNotebook(r),D=this.g.get(S.URI.revive(d));return(0,$.$cg)(D?.apiNotebook)}async showNotebookDocument(r,w){S.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let d;typeof w=="object"?d={position:v.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(v.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:d={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(r.uri,r.notebookType,d),p=D&&this.h.get(D)?.apiEditor;if(p)return p;throw D?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(r,w,d,D){const p=this.f.get(r),k=S.URI.revive(w),y=this.g.get(k);if(!y||!p)return;const P=y.getCellFromIndex(d);if(!P)return;const I=await p.provideCellStatusBarItems(P.apiCell,D);if(!I)return;const F=new R.$Tc,j=this.p.add([F]),O=(Array.isArray(I)?I:[I]).map(T=>v.NotebookStatusBarItem.from(T,this.i,F));return{cacheId:j,items:O}}$releaseNotebookCellStatusBarItems(r){this.p.delete(r)}registerNotebookSerializer(r,w,d,D,p){if((0,b.$3e)(w))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:w,serializer:d,options:D}),this.b.$registerNotebookSerializer(k,{id:r.identifier,location:r.extensionLocation},w,v.NotebookDocumentContentOptions.from(D),h.u(r,p)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(r,w,d){const D=this.x.get(r);if(!D)throw new Error("NO serializer found");const p=await D.serializer.deserializeNotebook(w.buffer,d);return new f.$mw(v.NotebookData.from(p))}async $notebookToData(r,w,d){const D=this.x.get(r);if(!D)throw new Error("NO serializer found");const p=await D.serializer.serializeNotebook(v.NotebookData.to(w.value),d);return N.$Ce.wrap(p)}async $saveNotebook(r,w,d,D,p){const k=S.URI.revive(w),y=this.x.get(r);if(!y)throw new Error("NO serializer found");const P=this.g.get(k);if(!P)throw new Error("Document NOT found");if(P.versionId!==d)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$fl((0,l.localize)(0,null,this.z(k)),6);await this.y(k,D);const I={metadata:(0,i.$5n)(P.apiNotebook.metadata,T=>!(y.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of P.apiNotebook.getCells()){const B=new u.$hO(T.kind,T.document.getText(),T.document.languageId,T.mime,y.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);B.metadata=(0,i.$5n)(T.metadata,W=>!(y.options?.transientCellMetadata??{})[W]),I.cells.push(B)}const F=await y.serializer.serializeNotebook(I,p);await this.s.value.writeFile(k,F);const j=this.s.getFileSystemProviderExtUri(k.scheme),z=await this.s.value.stat(k);return{name:j.basename(k),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$ql({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(r,w,d,D,p){const k=this.x.get(r)?.serializer;if(!k)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(z,O,T)=>{await Promise.all(z.map(async B=>await Promise.all(B.filenamePatterns.map(W=>{const X={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(X,O,x=>{x.forEach(Z=>{y.has(Z)||D.some(ue=>B.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(te=>(0,g.$ygb)(te,Z)))||y.add(Z)})}).catch(x=>{if(x.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw x})}))))})(d,p,w);const I=new M.$Bc;let F=!1;const j=Array.from(y).map(async z=>{const O=[];try{if(p.isCancellationRequested)return;if(w.maxResults&&[...I.values()].reduce((X,x)=>X+x.cellResults.length,0)>w.maxResults){F=!0;return}const T=[],B=this.g.get(z);if(B)B.apiNotebook.getCells().forEach(x=>T.push({input:x.document.getText(),outputs:x.outputs.flatMap(Z=>Z.items.map(Y=>Y.data.toString()))}));else{const X=await this.s.value.readFile(z),x=N.$Ce.fromString(X.toString()),Z=await k.deserializeNotebook(x.buffer,p);if(p.isCancellationRequested)return;v.NotebookData.from(Z).cells.forEach(ue=>T.push({input:ue.source,outputs:ue.outputs.flatMap(te=>te.items.map(we=>we.valueBytes.toString()))}))}if(p.isCancellationRequested)return;T.forEach((X,x)=>{const Z=w.contentPattern.pattern,Y=new o.$mWb(X.input,void 0,X.outputs),ue=Y.findInInputs(Z),te=Y.findInOutputs(Z),we=te.flatMap(Se=>(0,t.$uL)(Se.matches,Se.textBuffer)).map((Se,_)=>(Se.webviewIndex=_,Se));if(ue.length>0||te.length>0){const Se={index:x,contentResults:(0,t.$uL)(ue,Y.inputTextBuffer),webviewResults:we};O.push(Se)}});const W={resource:z,cellResults:O};I.set(z,W);return}catch{return}});return await Promise.all(j),{limitHit:F,results:[...I.values()]}}async y(r,w){const d=await this.s.value.stat(r);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==A.$pl&&typeof d.mtime=="number"&&typeof d.size=="number"&&w.mtime<d.mtime&&w.etag!==A.$ql({mtime:w.mtime,size:d.size}))throw new A.$fl((0,l.localize)(1,null),3,w)}z(r){return r.scheme===s.Schemas.file?r.fsPath:r.toString()}A(r,w,d){if(this.h.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const D=new n.$Alc(w,this.d,r,d.visibleRanges.map(v.NotebookRange.to),d.selections.map(v.NotebookRange.to),typeof d.viewColumn=="number"?v.ViewColumn.to(d.viewColumn):void 0);this.h.set(w,D)}$acceptDocumentAndEditorsDelta(r){if(r.value.removedDocuments)for(const d of r.value.removedDocuments){const D=S.URI.revive(d),p=this.g.get(D);p&&(p.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(p.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===D.toString()&&this.h.delete(k.id)}if(r.value.addedDocuments){const d=[];for(const D of r.value.addedDocuments){const p=S.URI.revive(D.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const k=new a.$zlc(this.c,this.q,this.r,p,D);d.push(...D.cells.map(y=>a.$ylc.asModelAddData(y))),this.g.get(p)?.dispose(),this.g.set(p,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:d}),this.m.fire(k.apiNotebook)}}if(r.value.addedEditors)for(const d of r.value.addedEditors){if(this.h.has(d.id))return;const D=S.URI.revive(d.documentUri),p=this.g.get(D);p&&this.A(p,d.id,d)}const w=[];if(r.value.removedEditors)for(const d of r.value.removedEditors){const D=this.h.get(d);D&&(this.h.delete(d),this.k?.id===D.id&&(this.k=void 0),w.push(D))}if(r.value.visibleEditors){this.l=r.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const d=new Set;this.l.forEach(D=>d.add(D.id));for(const D of this.h.values()){const p=d.has(D.id);D._acceptVisibility(p)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}r.value.newActiveEditor===null?this.k=void 0:r.value.newActiveEditor&&(this.h.get(r.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${r.value.newActiveEditor}`),this.k=this.h.get(r.value.newActiveEditor)),r.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(r){const w=E.$AP.String.with("notebookType","A notebook type"),d=new E.$CP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new E.$AP("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>N.$Ce.wrap(p))],new E.$BP("Notebook Data",p=>v.NotebookData.to(p.value))),D=new E.$CP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new E.$AP("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new f.$mw(v.NotebookData.from(p)))],new E.$BP("Bytes",p=>p.buffer));r.registerApiCommand(d),r.registerApiCommand(D)}}e.$Jlc=h}),define(ke[371],Ee([1,0,17,22,47,35,23,40,36]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0;class S{constructor(m,E,v){this.k=m,this.l=E,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&R.$kk(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&R.$kk(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const E=this.k.folderQueries||[];return new Promise((v,u)=>{const f=a=>{this.f++,m(a)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const n=a.toString(),i=l.$oc(n);this.j&&this.j(n,i)||this.v(f,{base:a,basename:i})}),Promise.all(E.map(a=>this.p(a,f))).then(a=>{v({limitHit:this.e,stats:a[0]||void 0})},a=>{u(new Error((0,L.$bj)(a)))})})}async p(m,E){const v=new N.$me,u=this.q(m),f=this.r(),a=new $.$kL(this.k,m),n=!a.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=b.$0d.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,v.token),o=i.elapsed(),t=b.$0d.create();return this.g&&!this.e||(s&&s.forEach(g=>{const h=l.$hc.relative(m.folder.path,g.path);if(n){const c=l.$oc(g.path);this.v(E,{base:m.folder,relativePath:h,basename:c});return}this.s(f,m.folder,h,E)}),this.g&&!this.e)?null:(this.u(f,a,E),{providerTime:o,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(m){const E=(0,$.$jL)(this.k.includePattern,m.includePattern),v=(0,$.$jL)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:v,includes:E,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},E,v,u){if(v===this.a){const a=l.$oc(this.a);this.v(u,{base:E,relativePath:this.a,basename:a})}function f(a){const n=l.$oc(a),i=l.$nc(a);let s=m[i];s||(s=m[i]=[],f(i)),s.push({base:E,relativePath:a,basename:n})}f(v)}u({rootEntries:m,pathToEntries:E},v,u){const f=this,a=this.a;function n(i){const s=(0,$.$mL)(()=>i.map(o=>o.basename));for(let o=0,t=i.length;o<t;o++){const g=i[o],{relativePath:h,basename:c}=g;if(v.matchesExcludesSync(h,c,a!==c?s:void 0))continue;const r=E[h];if(r)n(r);else{if(h===a)continue;f.v(u,g)}if(f.e)break}}n(m)}v(m,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(E))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,E,v,u){const f=this.c(m.cacheKey),a=new S(m,E,f&&f.token);let n=0;const i=s=>{n+=s.length,v(s.map(o=>this.d(o)))};return this.e(a,A.a,i,u).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:s.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new N.$me),this.b.get(m)}d(m){return m.relativePath?{resource:M.$4g(m.base,m.relativePath)}:{resource:m.base}}e(m,E,v,u){const f=u.onCancellationRequested(()=>{m.cancel()}),a=i=>{i&&(n.push(i),E>0&&n.length>=E&&(v(n),n=[]))};let n=[];return m.search(a).then(i=>(n.length&&v(n),f.dispose(),i),i=>(n.length&&v(n),f.dispose(),Promise.reject(i)))}}e.$Blc=A}),define(ke[372],Ee([1,0,19,73,35,103,27,15,17,23,14,18,2,100,245,54,12,42,146,367,36]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$uM=D;let o=class{constructor(k,y,P,I,F){this.a=k,this.b=y,this.c=P,this.d=I,this.e=F}text(k,y,P={}){k=this.f(k,P);const I=this.a.getValue(),F=y&&y.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(y?.map(a.$Li),P),type:2,contentPattern:k,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(k,y){const P=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const I={...k,wordSeparators:P.editor.wordSeparators};return this.j(k,y)&&(I.isCaseSensitive=!0),this.k(k)&&(I.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),I}file(k,y={}){return{...this.h(k,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(k,y){return k?(k=Array.isArray(k)?k.map(r):r(k),y?this.parseSearchPaths(k):{pattern:g(...Array.isArray(k)?k:[k])}):{}}h(k=[],y={}){const P=this.g(y.includePattern,y.expandPatterns),I=this.g(y.excludePattern,y.expandPatterns),F=k.length>1,j=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,y,I)):k.map(T=>this.r(T,y,I,F))).filter(T=>!!T),z={_reason:y._reason,folderQueries:j,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:I.pattern,includePattern:P.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const T=l.$Hb(l.$Rb(this.c.groups.map(X=>X.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const B=T.filter(X=>(0,s.$aL)(z,X.fsPath)),W=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const O=y.extraFileResources&&y.extraFileResources.filter(T=>(0,s.$aL)(z,T.fsPath));return z.extraFileResources=O&&O.length?O:void 0,z}i(k){const y=[],P=new M.$Bc,I={};let F=!1;return k.forEach(j=>{if(j.scheme===b.Schemas.walkThrough)return;if((0,S.$8g)(j)){const O=this.b.getWorkspaceFolder(j)?.uri??j.with({path:$.$nc(j.fsPath)});let T=P.get(O);T||(F=!0,T={folder:O,includePattern:{}},y.push(T),P.set(O,T));const B=$.$mc(O.fsPath,j.fsPath);(0,C.$cg)(T.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&(F=!0,I[j.fsPath]=!0)}),{folderQueries:y,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(k,y){if(y.isSmartCase){if(k.isRegExp){if(A.$Uf(k.pattern,!0))return!0}else if(A.$Uf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,E.$BC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const y=W=>$.$jc(W)||/^\.\.?([\/\\]|$)/.test(W),I=(Array.isArray(k)?k:h(k)).map(W=>{const X=this.e.resolvedUserHome;return X?(0,R.$rw)(W,X.scheme===b.Schemas.file?X.fsPath:X.path):W}),F=N.$K(I,W=>y(W)?"searchPaths":"exprSegments"),j=(F.exprSegments||[]).map(W=>A.$bf(W,"/")).map(W=>A.$bf(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),c(W))),z={},O=this.m(F.searchPaths||[]);O&&O.length&&(z.searchPaths=O);const T=l.$Rb(j),B=g(...T);return B&&(z.pattern=B),z}l(k,y){return y.disregardExcludeSettings?void 0:(0,s.$_K)(k,!y.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const y=k.flatMap(I=>{let{pathPortion:F,globPortion:j}=t(I);return j&&(j=w(j)),this.n(F).flatMap(O=>this.o(O,j))}),P=new Map;return y.forEach(I=>{const F=I.searchPath.toString(),j=P.get(F);j?I.pattern&&(j.pattern=j.pattern||{},j.pattern[I.pattern]=!0):P.set(F,{searchPath:I.searchPath,pattern:I.pattern?g(I.pattern):void 0})}),Array.from(P.values())}n(k){if($.$jc(k)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==b.Schemas.file?[{searchPath:y[0].uri.with({path:k})}]:[{searchPath:m.URI.file($.$ic(k))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(k=r(k),k.startsWith("../")||k===".."){const I=$.$hc.resolve(y.path,k);return[{searchPath:y.with({path:I})}]}const P=w(k);return[{searchPath:y,pattern:P}]}else{if(k==="./"||k===".\\")return[];{const y=k.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(F=>{const j=y.match(new RegExp(`^${A.$8e(F.name)}(?:/(.*)|$)`));return j?{match:j,folder:F}:null}).filter(C.$_f);if(I.length)return I.map(F=>{const j=F.match[1];return{searchPath:F.folder.uri,pattern:j&&w(j)}});{const F=k.match(/\.[\/\\](.+)[\/\\]?/),j=F?F[1]:k,z=v.localize(0,null,j);throw new Error(z)}}}}o(k,y){const P=k.pattern&&y?`${k.pattern}/${y}`:k.pattern||y,I=[{searchPath:k.searchPath,pattern:P}];return P&&!P.endsWith("**")&&I.push({searchPath:k.searchPath,pattern:P+"/**"}),I}q(k,y,P){const I=this.r((0,a.$Li)(k.searchPath),y,P,!1);return I?{...I,includePattern:k.pattern}:null}r(k,y,P,I){let F;const j=m.URI.isUri(k)?k:k.uri;if(P.searchPaths){const W=P.searchPaths.filter(X=>(0,S.$Wg)(X.searchPath,j))[0];if(W&&!W.pattern)return null;W&&(F=W.pattern)}const z=this.a.getValue({resource:j}),T={...this.l(z,y)||{},...F||{}},B=m.URI.isUri(k)?(0,S.$1g)(k):k.name;return{folder:j,folderName:I?B:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};e.$tM=o,e.$tM=o=Je([qe(0,u.$Wi),qe(1,a.$zi),qe(2,n.$ID),qe(3,f.$Wj),qe(4,i.$rM)],o);function t(p){const k=p.match(/[\*\{\}\(\)\[\]\?]/);if(k){const y=k.index,P=p.substr(0,y).match(/[/|\\][^/\\]*$/);if(P){let I=p.substr(0,P.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:p.substr((P.index||0)+1)}}}return{pathPortion:p}}function g(...p){return p.length?p.reduce((k,y)=>(k[y]=!0,k),Object.create(null)):void 0}function h(p){return L.$ik(p,",").map(k=>k.trim()).filter(k=>!!k.length)}function c(p){return[`**/${p}/**`,`**/${p}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function w(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(p){return p.replace(/([?*[\]])/g,"[$1]")}function D(p,k){p=l.$Mb(p,I=>I.toString());const y=[],P=k.getWorkspace();return p&&p.forEach(I=>{let F;if(k.getWorkbenchState()===2)F=(0,S.$6g)(P.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const j=k.getWorkspaceFolder(I);if(j){const z=j.name;if(P.folders.filter(T=>T.name===z).length===1){const T=(0,S.$6g)(j.uri,I);T===""?F=`./${j.name}`:F=`./${j.name}/${T}`}else F=I.fsPath}}F&&y.push(d(F))}),y}}),define(ke[373],Ee([1,0,23,2,22,13,5,372,36,42,8]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ytb=m,e.$ztb=u;const C=7e3;function m(f,a){const n=a.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],s=[];for(const r of n)if(/^workspaceContains:/.test(r)){const w=r.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||f.forceUsingSearch?s.push(w):i.push(w)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,A.$jh)(),g=r=>t({activationEvent:r}),h=Promise.all(i.map(r=>E(f,r,g))).then(()=>{}),c=v(f,a.identifier,s,g);return Promise.all([h,c]).then(()=>{t(void 0)}),o}async function E(f,a,n){for(const i of f.folders)if(await f.exists(l.$4g(N.URI.revive(i),a))){n(`workspaceContains:${a}`);return}}async function v(f,a,n,i){if(n.length===0)return Promise.resolve(void 0);const s=new L.$me,o=f.checkExists(f.folders,n,s.token),t=setTimeout(async()=>{s.cancel(),f.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},C);let g=!1;try{g=await o}catch(h){R.$4(h)||R.$1(h)}s.dispose(),clearTimeout(t),g&&i(`workspaceContains:${n.join(",")}`)}function u(f,a,n,i){const s=f.get(M.$pi),o=f.get($.$4K),g=s.createInstance(b.$tM).file(a.map(h=>(0,S.$Li)(N.URI.revive(h))),{_reason:"checkExists",includePattern:n,exists:!0});return o.fileSearch(g,i).then(h=>!!h.limitHit,h=>R.$4(h)?!1:Promise.reject(h))}}),define(ke[49],Ee([1,0,220,17,59,23,8,3,77,2,12,6,45,305,118,44,26,148,13,25,21,282,7,66,5,28,93,20,107,70,43,121,4,373,117,284,15,115,40,11,116]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o,t,g,h,c,r,w,d,D,p,k,y,P,I,F,j,z,O,T,B){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=e.$glc=e.$flc=e.$elc=e.$dlc=void 0,e.$dlc=(0,h.$qi)("IHostUtils");let X=W=class extends b.$Uc{constructor(U,ne,$e,Pe,se,re,oe,G,ie,me,be,Ae,fe){super(),this.Y=Ae,this.Z=fe,this.a=this.B(new y.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ne,this.g=$e,this.f=oe,this.j=Pe,this.m=se,this.s=re,this.t=ie,this.u=me,this.w=be,this.y=this.g.getProxy(C.$PM.MainThreadWorkspace),this.z=this.g.getProxy(C.$PM.MainThreadTelemetry),this.C=this.g.getProxy(C.$PM.MainThreadExtensionService),this.D=new M.$ph,this.F=new M.$ph,this.G=new M.$ph,this.H=new M.$ph,this.I=new Se(this.f.extensions.activationEvents),this.L=new a.$R$b(this.I,this.f.extensions.allExtensions);const De=new i.$Mm(this.f.extensions.myExtensions);this.J=new a.$R$b(this.I,te(this.L,De)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new v.$Ykc(this.g,this.s),this.N=new I.$9kc(this.g),this.O=G,this.h=U.createChild(new d.$oi([v.$Zkc,this.M],[I.$0kc,this.N])),this.P=this.B(new E.$Xkc(this.J,this.L,{onExtensionActivationError:(Ie,Te,q)=>{this.C.$onExtensionActivationError(Ie,n.$3(Te),q)},actualActivateExtension:async(Ie,Te)=>{if(a.$R$b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Te),new E.$Wkc;const q=this.J.getExtensionDescription(Ie);return this.fb(q,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this.eb(se))}catch{}await Promise.all(U)}terminate(U,ne=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Pe=>{this.s.error(Pe)}),this.g.dispose();const $e=this.$();Promise.race([(0,M.$rh)(5e3),$e]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ne}`):this.s.info(`Extension host exiting with code ${ne}`),this.s.flush(),this.s.dispose(),this.c.exit(ne)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ne=await this.C.$getExtension(U);return ne&&{...ne,identifier:new i.$Lm(ne.identifier.value),extensionLocation:S.URI.revive(ne.extensionLocation)}}ab(U,ne){return this.P.activateByEvent(U,ne)}bb(U,ne){return this.P.activateById(U,ne)}activateByIdWithErrors(U,ne){return this.bb(U,ne).then(()=>{const $e=this.P.getActivatedExtension(U);if($e.activationFailed)return Promise.reject($e.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===j.Schemas.file&&this.c.fsRealpath){const ne=U.fsPath;this.R.has(ne)||this.R.set(ne,this.c.fsRealpath(ne));const $e=await this.R.get(ne);return S.URI.file($e)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new we(U))),this.Q}async db(U){const ne=$.$wi.forUris($e=>R.$Ug.ignorePathCasing($e));return await Promise.all(U.map(async $e=>{if(this.wb($e)){const Pe=await this.cb($e.extensionLocation);ne.set(Pe,$e)}})),ne}eb(U){let ne=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ne;const $e=this.P.getActivatedExtension(U);if(!$e)return ne;try{typeof $e.module.deactivate=="function"&&(ne=Promise.resolve($e.module.deactivate()).then(void 0,Pe=>(this.s.error(Pe),Promise.resolve(void 0))))}catch(Pe){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Pe)}try{(0,b.$Pc)($e.subscriptions)}catch(Pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Pe)}return ne}async fb(U,ne){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ne).then($e=>{const Pe=$e.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Pe.codeLoadingTime,Pe.activateCallTime,Pe.activateResolvedTime,ne),this.gb(U,ne,"success",Pe),$e},$e=>{throw this.gb(U,ne,"failure"),$e})}gb(U,ne,$e,Pe){const se=Z(U,ne);this.z.$publicLog2("extensionActivationTimes",{...se,...Pe||{},outcome:$e})}hb(U,ne){const $e=Z(U,ne);this.z.$publicLog2("activatePlugin",$e);const Pe=this.wb(U);if(!Pe)return Promise.resolve(new E.$Vkc(E.$Skc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ne.startup}, activationEvent: '${ne.activationEvent}'${U.identifier.value!==ne.extensionId.value?`, root cause: ${ne.extensionId.value}`:""}`),this.s.flush();const se=new E.$Tkc(ne.startup);return Promise.all([this.xb(U,(0,R.$4g)(U.extensionLocation,Pe),se),this.ib(U)]).then(re=>(L.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),W.jb(this.s,U.identifier,re[0],re[1],se))).then(re=>(L.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),re))}ib(U){const ne=this.Z.createLanguageModelAccessInformation(U),$e=new o.$2kc(U,this.M),Pe=new o.$1kc(U.identifier.value,!1,this.M),se=new F.$$kc(U,this.N),re=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,oe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([$e.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const G=this;let ie,me;const be=(0,f.$xG)(U,"ipc")?this.f.messagePorts?.get(i.$Lm.toKey(U.identifier)):void 0;return Object.freeze({globalState:$e,workspaceState:Pe,secrets:se,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ae){return N.$kc(U.extensionLocation.fsPath,Ae)},get storagePath(){return G.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return G.O.globalValue(U).fsPath},get logPath(){return N.$kc(G.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return S.URI.joinPath(G.f.logsLocation,U.identifier.value)},get storageUri(){return G.O.workspaceValue(U)},get globalStorageUri(){return G.O.globalValue(U)},get extensionMode(){return re},get extension(){return ie===void 0&&(ie=new ue(G,U.identifier,U,oe,!1)),ie},get extensionRuntime(){return(0,f.$yG)(U,"extensionRuntime"),G.extensionRuntime},get environmentVariableCollection(){return G.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!me){if(!be)return;const Ae=y.Event.buffer(y.Event.fromDOMEventEmitter(be,"message",fe=>fe.data));be.start(),me={onDidReceiveMessage:Ae,postMessage:be.postMessage.bind(be)}}return me}})})}static jb(U,ne,$e,Pe,se){return $e=$e||{activate:void 0,deactivate:void 0},this.kb(U,ne,$e,Pe,se).then(re=>new E.$Ukc(!1,null,se.build(),$e,re,Pe.subscriptions))}static kb(U,ne,$e,Pe,se){if(typeof $e.activate=="function")try{se.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ne.value}`);const re=typeof global=="object"?global:self,oe=$e.activate.apply(re,[Pe]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(oe).then(G=>(se.activateResolveStop(),G))}catch(re){return Promise.reject(re)}else return Promise.resolve($e)}lb(U,ne){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ne}).then(void 0,$e=>{this.s.error($e)})}mb(U,ne=0){const Pe=Date.now();(0,T.$B)(()=>{for(let se=ne;se<U.length;se+=1){const re=U[se];for(const oe of re.activationEvents??[])if(oe==="onStartupFinished")if(Date.now()-Pe>50){this.mb(U,se);break}else this.lb(re,oe)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(U=>{const ne=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),$e=this.J.getAllExtensionDescriptions();if(ne)this.mb($e);else for(const Pe of $e)if(Pe.activationEvents)for(const se of Pe.activationEvents)se==="onStartupFinished"&&this.lb(Pe,se)})}ob(){const U=this.ab("*",!0).then(void 0,re=>{this.s.error(re)});this.B(this.j.onDidChangeWorkspace(re=>this.pb(re.added)));const ne=this.j.workspace?this.j.workspace.folders:[],$e=this.pb(ne),Pe=this.rb(),se=Promise.all([Pe,U,$e]).then(()=>{});return Promise.race([se,(0,M.$rh)(1e4)]).then(()=>{this.nb()}),se}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ne=>this.qb(U,ne))).then(()=>{})}async qb(U,ne){if(this.isActivated(ne.identifier))return;const $e=!this.f.remote.isRemote&&!!this.f.remote.authority,Pe={logService:this.s,folders:U.map(re=>re.uri),forceUsingSearch:$e||!this.c.fsExists,exists:re=>this.c.fsExists(re.fsPath),checkExists:(re,oe,G)=>this.y.$checkExists(re,oe,G)},se=await(0,P.$ytb)(Pe,ne);if(se)return this.bb(ne.identifier,{startup:!0,extensionId:ne.identifier,activationEvent:se.activationEvent}).then(void 0,re=>this.s.error(re))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ne}=this.f.environment;if(!U||!ne)throw new Error(l.localize(0,null));const $e=await this.xb(null,ne,new E.$Tkc(!1));if(!$e||typeof $e.run!="function")throw new Error(l.localize(1,null,ne.toString()));return new Promise((Pe,se)=>{const re=(ie,me)=>{ie?(T.$t&&this.s.error("Test runner called back with error",ie),se(ie)):(T.$t&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),Pe(typeof me=="number"&&me>0?1:0))},oe=(0,R.$Rg)(ne),G=$e.run(oe,re);G&&G.then&&G.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),Pe(0)}).catch(ie=>{T.$t&&this.s.error("Test runner finished with error",ie),se(ie instanceof Error&&ie.stack?ie.stack:String(ie))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$rh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ne){return this.S[U]=ne,(0,b.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ne}=await this.ub(U);return ne?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ne=U.indexOf("+");if(ne===-1)throw new t.$XM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const $e=U.substr(0,ne);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${$e}`,!1),{authorityPrefix:$e,resolver:this.S[$e]}}async $resolveAuthority(U,ne){const $e=O.$0d.create(!1),Pe=()=>`[resolveAuthority(${(0,g.$Fl)(U)},${ne})][${$e.elapsed()}ms] `,se=V=>this.s.info(`${Pe()}${V}`),re=V=>this.s.warn(`${Pe()}${V}`),oe=(V,J=void 0)=>this.s.error(`${Pe()}${V}`,J),G=V=>{if(V instanceof t.$XM)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},ie=async V=>{se(`activating resolver for ${V}...`);const{resolver:J,authorityPrefix:Q}=await this.ub(V);if(!J)throw oe(`no resolver for ${Q}`),new t.$XM(`No remote extension installed to resolve ${Q}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:Q,remoteAuthority:V}},me=U.split(/@|%40/g).reverse();se(`activating remote resolvers ${me.join(" -> ")}`);let be;try{be=await Promise.all(me.map(ie)).catch(async V=>{if(!(V instanceof t.$XM)||V._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return re(`resolving nested authorities failed: ${V.message}`),[await ie(U)]})}catch(V){return G(V)}const Ae=new M.$Bh;Ae.cancelAndSet(()=>se("waiting..."),1e3);let fe,De;for(const[V,{authorityPrefix:J,resolver:Q,remoteAuthority:he}]of be.entries())try{if(V===be.length-1)se("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${J}`),fe=await Q.resolve(he,{resolveAttempt:ne,execServer:De}),L.mark(`code/extHost/didResolveAuthorityOK/${J}`),se("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,t.$WM.isManagedResolvedAuthority(fe)?fe:void 0));else{if(se(`invoking resolveExecServer() for ${he}`),L.mark(`code/extHost/willResolveExecServer/${J}`),De=await Q.resolveExecServer?.(he,{resolveAttempt:ne,execServer:De}),!De)throw new t.$XM(`Exec server was not available for ${he}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(pe){return L.mark(`code/extHost/didResolveAuthorityError/${J}`),oe("returned an error",pe),Ae.dispose(),G(pe)}Ae.dispose();const Ie={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};se(`returned ${t.$WM.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let q;if(t.$WM.isManagedResolvedAuthority(fe)){const V=ne;this.Y.setFactory(V,fe.makeConnection),q={authority:U,connectTo:new g.$Cl(V),connectionToken:fe.connectionToken}}else q={authority:U,connectTo:new g.$Dl(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:q,options:Te,tunnelInformation:Ie}}}async $getCanonicalURI(U,ne){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$Fl)(U)})`);const{resolver:$e}=await this.ub(U);if(!$e)return null;const Pe=S.URI.revive(ne);if(typeof $e.getCanonicalURI>"u")return Pe;const se=await(0,M.$ih)(()=>$e.getCanonicalURI(Pe));return se||Pe}async $startExtensionHost(U){U.toAdd.forEach(re=>re.extensionLocation=S.URI.revive(re.extensionLocation));const{globalRegistry:ne,myExtensions:$e}=x(this.I,this.L,this.J,U),Pe=await this.db($e);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(ne.getAllExtensionDescriptions()),this.J.set($e),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.tb()}$activateByEvent(U,ne){return ne===1?this.D.wait().then($e=>this.ab(U,!1)):this.G.wait().then($e=>this.ab(U,!1))}async $activate(U,ne){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ne),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(re=>re.extensionLocation=S.URI.revive(re.extensionLocation));const{globalRegistry:ne,myExtensions:$e}=x(this.I,this.L,this.J,U),Pe=await this.db($e);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(ne.getAllExtensionDescriptions()),this.J.set($e),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ne=s.$Ce.alloc(U),$e=Math.random()%256;for(let Pe=0;Pe<U;Pe++)ne.writeUInt8($e,Pe);return ne}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$elc=X,e.$elc=X=W=Je([qe(0,h.$pi),qe(1,e.$dlc),qe(2,w.$cP),qe(3,u.$Bkc),qe(4,m.$Ekc),qe(5,A.$Wj),qe(6,c.$sP),qe(7,r.$Hkc),qe(8,D.$ACb),qe(9,p.$3kc),qe(10,z.$alc),qe(11,B.$blc),qe(12,k.$7kc)],X);function x(_,U,ne,$e){_.addActivationEvents($e.addActivationEvents);const Pe=new a.$R$b(_,U.getAllExtensionDescriptions());Pe.deltaExtensions($e.toAdd,$e.toRemove);const se=new i.$Mm(ne.getAllExtensionDescriptions().map(oe=>oe.identifier));for(const oe of $e.myToRemove)se.delete(oe);for(const oe of $e.myToAdd)se.add(oe);const re=te(Pe,se);return{globalRegistry:Pe,myExtensions:re}}function Z(_,U){return{id:_.identifier.value,name:_.name,extensionVersion:_.version,publisherDisplayName:_.publisher,activationEvents:_.activationEvents?_.activationEvents.join(","):null,isBuiltin:_.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function Y(_){return _.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$flc=(0,h.$qi)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(U,ne,$e,Pe,se){this.#e=U,this.#t=ne,this.#i=$e.identifier,this.id=$e.identifier.value,this.extensionUri=$e.extensionLocation,this.extensionPath=N.$ic((0,R.$Rg)($e.extensionLocation)),this.packageJSON=$e,this.extensionKind=Pe,this.isFromDifferentExtensionHost=se}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$glc=ue;function te(_,U){return _.getAllExtensionDescriptions().filter(ne=>U.has(ne.identifier))}class we{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$hlc=we;class Se{constructor(U){this.a=new i.$Nm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ne of Object.keys(U))this.a.set(ne,U[ne])}}}),define(ke[374],Ee([1,0,59,2,6,45,26,25,20,28,5,49,12,14]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;let u=class{constructor(s,o,t,g,h,c,r){this.c=s,this.d=o,this.e=t,this.f=g,this.g=h,this.h=c,this.i=r,this.a=new Map,this.b=[]}async install(){this.j(),l.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new a(this.c,o,this.d,s,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,o,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const o of s.nodeModuleName)this.a.set(o,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(o=>s.alternativeModuleName(o))}};e.$qmc=u,e.$qmc=u=Je([qe(2,A.$pi),qe(3,R.$Ekc),qe(4,C.$flc),qe(5,S.$sP),qe(6,m.$Wj)],u);let f=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&v.a.size){const o=(0,E.$8e)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",g=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${h}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const o=this.b.exec(this.c(s));if(!o)return;const[,t,g,h]=o,c=v.a.get(g);if(c!==void 0)return console.warn(`${g} as been renamed to ${c}, please update your imports`),t+c+h}c(s){return s.replace(/\\/g,"/")}};f=v=Je([qe(0,S.$sP)],f);class a{constructor(s,o,t,g,h){this.c=s,this.d=o,this.e=t,this.f=g,this.g=h,this.nodeModuleName="vscode",this.a=new b.$Nm}load(s,o){const t=this.d.findSubstr(o);if(t){let g=this.a.get(t.identifier);return g||(g=this.c(t,this.e,this.f),this.a.set(t.identifier,g)),g}if(!this.b){let g="";this.d.forEach((h,c)=>g+=`	${c} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${g}`),this.b=this.c(M.$sG,this.e,this.f)}return this.b}}let n=class{constructor(s,o,t){this.e=s,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$PM.MainThreadTelemetry);const g=t.getProxy(L.$PM.MainThreadWindow);this.c=(h,c)=>{const r=N.URI.parse(h);return c?this.g(h,c):r.scheme==="http"||r.scheme==="https"?g.$openUri(r,h,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this.f?g.$openUri(r,h,{}):this.g(h,c)}}load(s,o,t){const g=this.e.findSubstr(o);return g&&(this.a=g.identifier.value,this.h()),this.b=t(s),this.c}g(s,o){return this.i(),this.b(s,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,$.$cP)],n)}),define(ke[61],Ee([1,0,46,3,17,51,5,72,71,49,7,44,302,45]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=void 0,e.$ilc=(0,M.$qi)("IExtHostVariableResolverProvider");class v extends m.$eQ{constructor(a,n,i,s,o,t,g){function h(){if(i){const c=i.activeEditor();if(c)return c.document.uri;const r=s.tabGroups.all.find(w=>w.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof A.$CO||r.input instanceof A.$HO)return r.input.modified;if(r.input instanceof A.$BO||r.input instanceof A.$GO||r.input instanceof A.$EO)return r.input.uri}}}super({getFolderUri:c=>{const r=t.folders.filter(w=>w.name===c);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,r)=>o.getConfiguration(void 0,c).get(r),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=h();if(c)return L.$ic(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const c=h();if(c){const r=n.getWorkspaceFolder(c);if(r)return L.$ic(r.uri.fsPath)}}},getSelectedText:()=>{if(i){const c=i.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(i){const c=i.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>a.getExtension(c)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(R.env))}}let u=class extends N.$Uc{constructor(a,n,i,s,o){super(),this.b=a,this.c=n,this.g=i,this.h=s,this.j=o,this.a=new l.$V(async()=>{const t=await this.h.getConfigProvider(),h={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{h.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,h,this.m())})}getResolver(){return this.a.value}m(){}};e.$jlc=u,e.$jlc=u=Je([qe(0,S.$flc),qe(1,C.$Bkc),qe(2,b.$nP),qe(3,E.$Ekc),qe(4,$.$Qkc)],u)}),define(ke[96],Ee([1,0,8,4,2,25,5,6,71,49,20,7,44,143,294,45,61,3,57,33,16]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=e.$nlc=e.$mlc=e.$llc=e.$klc=void 0,e.$klc=(0,M.$qi)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(d,D,p,k,y,P,I){this.N=D,this.O=p,this.P=k,this.Q=y,this.R=P,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$be,this.o=new N.$be,this.q=new N.$be,this.w=new N.$be,this.l=d.getProxy(b.$PM.MainThreadDebugService),this.A=new N.$be,this.C=new N.$be,this.y=new g(this.l),this.z=new Map,this.O.getExtensionRegistry().then(F=>{F.onDidChange(j=>{this.V(F)}),this.V(F)})}async $getVisualizerTreeItem(d,D){const p=this.W(D);if(!p)return;const k=await this.H.get(d)?.getTreeItem?.(p);return k?this.U(d,k):void 0}registerDebugVisualizationTree(d,D,p){const k=R.$Lm.toKey(d.identifier),y=this.jb(k,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,p),this.l.$registerDebugVisualizerTree(y,!!p.editItem),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(d,D){const p=this.J.get(D)?.item;return p?(await this.H.get(d)?.getChildren?.(p))?.map(y=>this.U(d,y))||[]:[]}async $editVisualizerTreeItem(d,D){const p=this.J.get(d);if(!p)return;const k=await this.H.get(p.provider)?.editItem?.(p.item,D);return this.U(p.provider,k||p.item)}$disposeVisualizedTree(d){const D=this.J.get(d);if(!D)return;const p=[D.children];for(const k of p)if(k)for(const y of k)p.push(this.J.get(y)?.children),this.J.delete(y)}U(d,D){let p=this.I.get(D);return p||(p=this.F++,this.I.set(D,p),this.J.set(p,{provider:d,item:D})),s.DebugTreeItem.from(D,p)}asDebugSourceUri(d,D){const p=d;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let k=`debug:${encodeURIComponent(p.path||"")}`,y="?";return D&&(k+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),k+=`${y}ref=${p.sourceReference}`,L.URI.parse(k)}else{if(p.path)return L.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(d){const D=[];for(const p of d.getAllExtensionDescriptions())if(p.contributes){const k=p.contributes.debuggers;if(k&&k.length>0)for(const y of k)(0,v.$_G)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const d=[];return this.z.forEach(D=>d.push(D)),d}async $resolveDebugVisualizer(d,D){const p=this.L.get(d);if(!p)throw new Error(`No debug visualizer found with id '${d}'`);let{v:k,provider:y,extensionId:P}=p;if(k.visualization||(k=await y.resolveDebugVisualization?.(k,D)||k,p.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(P,k.visualization)}async $executeDebugVisualizerCommand(d){const D=this.L.get(d);if(!D)throw new Error(`No debug visualizer found with id '${d}'`);const p=D.v.visualization;p&&"command"in p&&this.S.executeCommand(p.command,...p.arguments||[])}W(d){const D=this.m.get(d.sessionId);return D&&{session:D.api,variable:d.variable,containerId:d.containerId,frameId:d.frameId,threadId:d.threadId}}async $provideDebugVisualizers(d,D,p,k){const y=this.W(p),P=this.jb(d,D),I=this.G.get(P);if(!y||!I)return[];const F=await I.provideDebugVisualization(y,k);return F?F.map(j=>{const z=++this.M;this.L.set(z,{v:j,provider:I,extensionId:d});const O=j.iconPath?this.lb(j.iconPath):void 0;return{id:z,name:j.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.kb(d,j.visualization)}}):[]}$disposeDebugVisualizers(d){for(const D of d)this.L.delete(D)}registerDebugVisualizationProvider(d,D,p){if(!d.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const k=R.$Lm.toKey(d.identifier),y=this.jb(k,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,p),this.l.$registerDebugVisualizer(k,D),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,D),this.G.delete(D)})}addBreakpoints(d){const D=d.filter(y=>{const P=y.id;return this.z.has(P)?!1:(this.z.set(P,y),!0)});this.gb(D,[],[]);const p=[],k=new Map;for(const y of D)if(y instanceof C.$SN){let P=k.get(y.location.uri.toString());P||(P={type:"sourceMulti",uri:y.location.uri,lines:[]},k.set(y.location.uri.toString(),P),p.push(P)),P.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof C.$TN&&p.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(p)}removeBreakpoints(d){const D=d.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const p=D.filter(P=>P instanceof C.$SN).map(P=>P.id),k=D.filter(P=>P instanceof C.$TN).map(P=>P.id),y=D.filter(P=>P instanceof C.$UN).map(P=>P.id);return this.l.$unregisterBreakpoints(p,k,y)}startDebugging(d,D,p){return this.l.$startDebugging(d?d.uri:void 0,D,{parentSessionID:p.parentSession?p.parentSession.id:void 0,lifecycleManagedByParent:p.lifecycleManagedByParent,repl:p.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact,suppressSaveBeforeStart:p.suppressSaveBeforeStart,suppressDebugStatusbar:p.suppressDebugStatusbar??p.debugUI?.simple,suppressDebugToolbar:p.suppressDebugToolbar??p.debugUI?.simple,suppressDebugView:p.suppressDebugView??p.debugUI?.simple})}stopDebugging(d){return this.l.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,D,p){if(!D)return new C.$RM(()=>{});const k=this.d++;return this.f.push({type:d,handle:k,provider:D}),this.l.$registerDebugConfigurationProvider(d,p,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,k),new C.$RM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(d,D,p){if(!p)return new C.$RM(()=>{});if(!this.cb(d,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:D,handle:k,factory:p}),this.l.$registerDebugAdapterDescriptorFactory(D,k),new C.$RM(()=>{this.h=this.h.filter(y=>y.factory!==p),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(d,D){if(!D)return new C.$RM(()=>{});const p=this.j++;return this.k.push({type:d,handle:p,factory:D}),new C.$RM(()=>{this.k=this.k.filter(k=>k.factory!==D)})}async $runInTerminal(d,D){return Promise.resolve(void 0)}async $substituteVariables(d,D){let p;const k=await this.ib(d);return k&&(p={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(p,D)}X(d,D){if(d.type==="implementation")return new c(d.implementation)}Y(){}async $startDASession(d,D){const p=this,k=await this.hb(D);return this.eb(this.$(k.type),k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const P=this.Z(y),I=this.X(P,k);if(!I)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const F=I;return this.D.set(d,F),this.db(k).then(j=>(j&&this.E.set(d,j),F.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const O=z,T={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(O.arguments.value);T.body={signature:B},F.sendResponse(T)}else throw new Error("no signer")}catch(B){T.success=!1,T.message=B.message,F.sendResponse(T)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(z),z=(0,v.$eH)(z,!0),p.l.$acceptDAMessage(d,z)}),F.onError(z=>{j&&j.onError&&j.onError(z),this.l.$acceptDAError(d,z.name,z.message,z.stack)}),F.onExit(z=>{j&&j.onExit&&j.onExit(z??void 0,void 0),this.l.$acceptDAExit(d,z??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),F.startSession()))})}$sendDAMessage(d,D){D=(0,v.$dH)(D,!1);const p=this.E.get(d);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(D),this.D.get(d)?.sendMessage(D)}$stopDASession(d){const D=this.E.get(d);this.E.delete(d),D&&D.onWillStopSession&&D.onWillStopSession();const p=this.D.get(d);return this.D.delete(d),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const D=[],p=[],k=[];if(d.added)for(const y of d.added){const P=y.id;if(P&&!this.z.has(P)){let I;if(y.type==="function")I=new C.$TN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")I=new C.$UN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const F=L.URI.revive(y.uri);I=new C.$SN(new C.$4M(F,new C.$SM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,C.$QN)(I,P),this.z.set(P,I),D.push(I)}}if(d.removed)for(const y of d.removed){const P=this.z.get(y);P&&(this.z.delete(y),p.push(P))}if(d.changed){for(const y of d.changed)if(y.id){const P=this.z.get(y.id);if(P){if(P instanceof C.$TN&&y.type==="function"){const I=P;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.functionName=y.functionName}else if(P instanceof C.$SN&&y.type==="source"){const I=P;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.location=new C.$4M(L.URI.revive(y.uri),new C.$SM(y.line,y.character))}k.push(P)}}}this.gb(D,p,k)}async $acceptStackFrameFocus(d){let D;if(d){const p=await this.hb(d.sessionId);d.kind==="thread"?D=new C.$1N(p.api,d.threadId):D=new C.$ZN(p.api,d.threadId,d.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(d,D,p){return(0,l.$ih)(async()=>{const k=this.bb(d);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return k.provideDebugConfigurations(y,p)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(d,D,p,k){return(0,l.$ih)(async()=>{const y=this.bb(d);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return y.resolveDebugConfiguration(P,p,k)})}$resolveDebugConfigurationWithSubstitutedVariables(d,D,p,k){return(0,l.$ih)(async()=>{const y=this.bb(d);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(P,p,k)})}async $provideDebugAdapter(d,D){const p=this.ab(d);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(D);return this.eb(p,k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(d){const D=await this.hb(d);this.n.fire(D.api)}async $acceptDebugSessionTerminated(d){const D=await this.hb(d);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(d){this.u=d?await this.hb(d):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(d,D){(await this.hb(d))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(d,D){const k={session:(await this.hb(d)).api,event:D.event,body:D.body};this.w.fire(k)}Z(d){if(d instanceof C.$VN)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof C.$WN)return{type:"server",port:d.port,host:d.host};if(d instanceof C.$XN)return{type:"pipeServer",path:d.path};if(d instanceof C.$YN)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}$(d){const D=this.h.filter(p=>p.type===d);if(D.length>0)return D[0].factory}ab(d){const D=this.h.filter(p=>p.handle===d);if(D.length>0)return D[0].factory}bb(d){const D=this.f.filter(p=>p.handle===d);if(D.length>0)return D[0].provider}cb(d,D){if(d.contributes){const p=d.contributes.debuggers;if(p&&p.length>0){for(const k of p)if(k.label&&k.type&&k.type===D)return!0}}return!1}db(d){const p=d.configuration.type,k=this.k.filter(y=>y.type===p||y.type==="*").map(y=>(0,l.$ih)(()=>y.factory.createDebugAdapterTracker(d.api)).then(P=>P,P=>null));return Promise.race([Promise.all(k).then(y=>{const P=y.filter(I=>!!I);if(P.length>0)return new h(P)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(d,D){const p=D.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new C.$WN(p));if(d){const y=await this.O.getExtensionRegistry();return(0,l.$ih)(()=>d.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(P=>{if(P)return P})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,k))}fb(d,D){}gb(d,D,p){(d.length>0||D.length>0||p.length>0)&&this.A.fire(Object.freeze({added:d,removed:D,changed:p}))}async hb(d){if(d)if(typeof d=="string"){const D=this.m.get(d);if(D)return D}else{let D=this.m.get(d.id);if(!D){const p=await this.ib(d.folderUri),k=d.parent?this.m.get(d.parent):void 0;D=new t(this.l,d.id,d.type,d.name,p,d.configuration,k?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(d){if(d){const D=L.URI.revive(d);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(d,D){return`${d}\0${D}`}kb(d,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${d}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(d){const D=this.mb(d);let p,k;return"id"in D?k=n.ThemeIcon.asClassName(D):p=D,{iconPath:p,iconClass:k}}mb(d){if(d instanceof C.$NN)return{id:d.id};const D=typeof d=="object"&&"dark"in d?d.dark:d,p=typeof d=="object"&&"light"in d?d.light:d;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof p=="string"?L.URI.file(p):p}}};e.$llc=o,e.$llc=o=Je([qe(0,A.$cP),qe(1,m.$Bkc),qe(2,S.$flc),qe(3,u.$Ekc),qe(4,$.$Qkc),qe(5,f.$ilc),qe(6,i.$yP)],o);class t{constructor(d,D,p,k,y,P,I){this.f=d,this.g=D,this.h=p,this.j=k,this.k=y,this.l=P,this.m=I}get api(){const d=this;return this.d??=Object.freeze({id:d.g,type:d.h,get name(){return d.j},set name(D){d.j=D,d.f.$setDebugSessionName(d.g,D)},parentSession:d.m,workspaceFolder:d.k,configuration:d.l,customRequest(D,p){return d.f.$customDebugAdapterRequest(d.g,D,p)},getDebugProtocolBreakpoint(D){return d.f.$getDebugProtocolBreakpoint(d.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(d){this.j=d}get configuration(){return this.l}}e.$mlc=t;class g{constructor(d){this.value=Object.freeze({append(D){d.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$nlc=g;class h{constructor(d){this.d=d}onWillStartSession(){this.d.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(d):void 0)}onWillStopSession(){this.d.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.d.forEach(D=>D.onError?D.onError(d):void 0)}onExit(d,D){this.d.forEach(p=>p.onExit?p.onExit(d,D):void 0)}}class c extends E.$Eob{constructor(d){super(),this.h=d,d.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.h.handleMessage(d)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends o{constructor(d,D,p,k,y,P,I){super(d,D,p,k,y,P,I)}};e.$olc=r,e.$olc=r=Je([qe(0,A.$cP),qe(1,m.$Bkc),qe(2,S.$flc),qe(3,u.$Ekc),qe(4,$.$Qkc),qe(5,f.$ilc),qe(6,i.$yP)],r)}),define(ke[375],Ee([1,0,13,59,2,6,322,12,84,107,28,258,20,67,49,90]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0;class f{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(b.$Wj),t=i.get(m.$cP).getProxy(R.$PM.MainThreadErrors);l.setUnexpectedErrorHandler(g=>{s.error(g);const h=l.$3(g);t.$onUnexpectedError(h)})}static async installFullHandler(i){const s=i.get(b.$Wj),o=i.get(m.$cP),t=i.get(v.$flc),g=i.get(u.$wP),h=o.getProxy(R.$PM.MainThreadExtensionService),c=o.getProxy(R.$PM.MainThreadErrors),r=await t.getExtensionPathIndex(),w=new WeakMap;function d(k,y){if(w.has(k))return w.get(k).stack;let P="",I,F;for(const z of y)P+=`
	at ${z.toString()}`,F=z.getFileName(),!I&&F&&(I=r.findSubstr(L.URI.file(F)));const j=`${k.name||"Error"}: ${k.message||""}${P}`;return w.set(k,{extensionIdentifier:I?.identifier,stack:j}),j}const D=Symbol("prepareStackTrace wrapped");let p=d;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(k){if(k===d||!k||k[D]){p=k||d;return}p=function(y,P){return d(y,P),k.call(Error,y,P)},Object.assign(p,{[D]:!0})}}),l.setUnexpectedErrorHandler(k=>{s.error(k);const y=l.$3(k),P=w.get(k);if(!P?.extensionIdentifier){c.$onUnexpectedError(y);return}h.$onExtensionRuntimeError(P.extensionIdentifier,y);const I=g.onExtensionError(P.extensionIdentifier,k);s.trace("forwarded error to extension?",I,P)})}}e.$rmc=f;class a{constructor(i,s,o,t,g){this.a=o,this.b=new M.$Z$b(i,null,t),s=a.e(s,this.b);const h=new S.$oi(...(0,$.$ps)());h.set(A.$sP,{_serviceBrand:void 0,...s,messagePorts:g}),h.set(m.$cP,new m.$dP(this.b)),h.set(E.$ykc,new E.$zkc(t)),h.set(v.$dlc,o);const c=new C.$7q(h,!0);c.invokeFunction(f.installEarlyHandler),this.d=c.invokeFunction(r=>r.get(b.$Wj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=c.invokeFunction(r=>r.get(v.$flc)),this.c.initialize(),c.invokeFunction(f.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(R.$PM.MainThreadExtensionService);return L.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const o=i.environment.extensionDevelopmentLocationURI;return o&&(i.environment.extensionDevelopmentLocationURI=o.map(t=>L.URI.revive(s.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$smc=a}),define(ke[376],Ee([1,0,8,11,231,251,141,96,71,49,20,43,7,61,44,295,296,45,33]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;let i=class extends b.$llc{constructor(h,c,r,w,d,D,p,k){super(h,c,r,w,D,p,k),this.pb=d,this.nb=new t}X(h,c){switch(h.type){case"server":return new u.$xmc(h);case"pipeServer":return new u.$ymc(h);case"executable":return new u.$zmc(h,c.type)}return super.X(h,c)}fb(h,c){const r=u.$zmc.platformAdapterExecutable(c.getAllExtensionDescriptions(),h.type);if(r)return new m.$VN(r.command,r.args,r.options)}Y(){return new M.$Ncc}async $runInTerminal(h,c){if(h.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const r=await this.P.getConfigProvider(),w=this.pb.getDefaultShell(!0),d=this.pb.getDefaultShellArgs(!0),D=h.title||L.localize(0,null),p=JSON.stringify({shell:w,shellArgs:d});let k=await this.nb.checkout(p,D),y,P=!1;if(k)y=h.cwd;else{const z={shellPath:w,shellArgs:d,cwd:h.cwd,name:D,iconPath:new m.$NN("debug")};P=!0,k=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(k,p)}k.show(!0);const I=await k.processId;P?await new Promise(z=>setTimeout(z,1e3)):(k.state.isInteractedWith&&k.sendText(""),r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0||w.indexOf("cmd.exe")>=0?k.sendText("cls"):w.indexOf("bash")>=0?k.sendText("clear"):N.$i?k.sendText("cls"):k.sendText("clear")));const F=(0,f.$Bmc)(w,h.args,!!h.argsCanBeInterpretedByShell,y,h.env);k.sendText(F);const j=this.onDidTerminateDebugSession(z=>{z.id===c&&(this.nb.free(k),j.dispose())});return I}else if(h.kind==="external")return o(h,await this.P.getConfigProvider());return super.$runInTerminal(h,c)}};e.$Cmc=i,e.$Cmc=i=Je([qe(0,A.$cP),qe(1,v.$Bkc),qe(2,S.$flc),qe(3,a.$Ekc),qe(4,C.$3kc),qe(5,$.$Qkc),qe(6,E.$ilc),qe(7,n.$yP)],i);let s;function o(g,h){if(!s)if(N.$i)s=new R.$ybc;else if(N.$j)s=new R.$zbc;else if(N.$k)s=new R.$Abc;else throw new Error("external terminals not supported on this platform");const c=h.getConfiguration("terminal");return s.runInTerminal(g.title,g.cwd,g.args,g.env||{},c.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(h,c,r=!1){const d=[...this.b.entries()].map(([D,p])=>(0,l.$dh)(async k=>{if(D.name!==c||p.lastUsedAt!==-1&&await(0,f.$Amc)(await D.processId))return null;const y=Date.now();return p.lastUsedAt+t.a>y||k.isCancellationRequested?null:p.config!==h?(r&&D.dispose(),null):(p.lastUsedAt=y,D)}));return await(0,l.$vh)(d,D=>!!D)}insert(h,c){this.b.set(h,{lastUsedAt:Date.now(),config:c})}free(h){const c=this.b.get(h);c&&(c.lastUsedAt=-1)}onTerminalClosed(h){this.b.delete(h)}}}),define(ke[377],Ee([1,0,17,2,105,44,72,45,42,43,20,28,95,15,12,91,23,64,61]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;let i=class extends m.$7lc{constructor(o,t,g,h,c,r,w,d,D){super(o,t,g,h,c,r,w,d),this.C=g,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const g=t;if(!t.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const h=m.TaskHandleDTO.from(g,this.C),c=await this.a.$getTaskExecution(h);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.z(c,t);return this.a.$executeTask(h).catch(()=>{}),r}else{const h=m.TaskDTO.from(t,o);if(h===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(h.execution)&&await this.y(h,t,!1);const c=await this.z(await this.a.$getTaskExecution(h),t);return this.a.$executeTask(h).catch(()=>{}),c}}v(o,t,g,h){const c=[];if(h)for(const r of h){this.A(r,g),(!r.definition||!o[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const w=m.TaskDTO.from(r,g.extension);w&&(c.push(w),m.CustomExecutionDTO.is(w.execution)&&t.push(this.y(w,r,!0)))}return{tasks:c,extension:g.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const g=N.URI.file((0,a.homedir)());t=new $.$Ki({uri:g,name:f.$1g(g),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const g=N.URI.revive(o),h={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(g),r=await this.b.getWorkspaceFolders2()??[],w=await this.D.getResolver(),d=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(r);for(const D of t.variables)h.variables[D]=await w.resolveAsync(d,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(l.$uc);for(let p=0;p<D.length;p++)D[p]=await w.resolveAsync(d,D[p])}h.process=await L.win32.findExecutable(await w.resolveAsync(d,t.process.name),t.process.cwd!==void 0?await w.resolveAsync(d,t.process.cwd):void 0,D)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,g){return L.win32.findExecutable(o,t,g)}};e.$umc=i,e.$umc=i=Je([qe(0,A.$cP),qe(1,C.$sP),qe(2,R.$Bkc),qe(3,M.$nP),qe(4,b.$Ekc),qe(5,S.$3kc),qe(6,v.$Wj),qe(7,u.$fkc),qe(8,n.$ilc)],i)}),define(ke[378],Ee([1,0,64,61]),function(le,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=void 0;class L extends N.$jlc{m(){return(0,l.homedir)()}}e.$anc=L}),define(ke[159],Ee([1,0,19,8,22,47,15,17,23,2,36]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Dlc=e.$Clc=void 0,e.$Elc=u;class C{constructor(n,i,s){this.d=n,this.e=i,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const s=this.g.folderQueries||[],o=new L.$me(i);return new Promise((t,g)=>{this.a=new E(n);let h=!1;const c=(r,w)=>{if(!h&&!this.b){const d=this.h(r);u(r)&&typeof this.g.maxResults=="number"&&this.c+d>this.g.maxResults&&(this.b=!0,h=!0,o.cancel(),r=this.j(r,this.g.maxResults-this.c));const D=this.h(r);this.c+=D,(D>0||!u(r))&&this.a.add(r,w)}};Promise.all(s.map((r,w)=>this.k(r,d=>c(d,w),o.token))).then(r=>{o.dispose(),this.a.flush();const w=r.some(d=>!!d&&!!d.limitHit);t({limitHit:this.b||w,messages:(0,l.$Rb)(r.map(d=>d?.message?Array.isArray(d.message)?d.message:[d.message]:[])),stats:{type:this.f}})},r=>{o.dispose();const w=(0,R.$bj)(r);g(new Error(w))})})}h(n){return u(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const s=Array.isArray(n.ranges)?n.ranges:[n.ranges],o=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:s.slice(0,i),preview:{matches:o.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,s){const o=new A.$kL(this.g,n),t=[],g={report:r=>{if(!this.l(r))return;const w=n.folder.scheme===M.Schemas.file?(0,A.$lL)(()=>this.e.readdir($.$3g(r.uri))):void 0,d=$.$6g(n.folder,r.uri);if(d){const D=o.includedInQuery(d,b.$oc(d),w);(0,N.$ch)(D)?t.push(D.then(p=>{p&&i(r)})):D&&i(r)}}},h=this.n(n);let c;return this.d.query.type===3?c=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,h,g,s):c=await this.d.provider.provideTextSearchResults(m(this.d.query.contentPattern),h,g,s),t.length&&await Promise.all(t),c}l(n){if(u(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$jL)(this.g.includePattern,n.includePattern),s=(0,A.$jL)(this.g.excludePattern,n.excludePattern),o={folder:S.URI.from(n.folder),excludes:s,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(o.usePCRE2=this.g.usePCRE2),o}}e.$Clc=C;function m(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new f(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$Wg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Dlc=E;function v(a){return u(a)?{preview:{matches:(0,l.$2b)(a.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:a.preview.text},ranges:(0,l.$2b)(a.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function u(a){return!!a.preview}class f{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Flc=f}),define(ke[97],Ee([1,0,3,6,5,371,20,67,12,2,159]),function(le,e,l,N,L,R,M,b,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=e.$Glc=void 0,e.$Ilc=m,e.$Glc=(0,L.$qi)("IExtHostSearch");let C=class{constructor(u,f,a){this.n=u,this.o=f,this.q=a,this.c=this.n.getProxy(N.$PM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$Blc}s(u){return this.o.transformOutgoingScheme(u)}registerTextSearchProvider(u,f){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const a=this.d++;return this.e.set(a,f),this.c.$registerTextSearchProvider(a,this.s(u)),(0,l.$Sc)(()=>{this.g.delete(u),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(u,f){if(this.i.has(u))throw new Error(`an AI text search provider for the scheme '${u}'is already registered`);this.i.add(u);const a=this.d++;return this.h.set(a,f),this.c.$registerAITextSearchProvider(a,this.s(u)),(0,l.$Sc)(()=>{this.i.delete(u),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(u,f){if(this.k.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.k.add(u);const a=this.d++;return this.j.set(a,f),this.c.$registerFileSearchProvider(a,this.s(u)),(0,l.$Sc)(()=>{this.k.delete(u),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(u,f,a,n){const i=m(a),s=this.j.get(u);if(s)return this.l.fileSearch(i,s,o=>{this.c.$handleFileMatch(u,f,o.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+u)}async doInternalFileSearchWithCustomCallback(u,f,a){return{messages:[]}}$clearCache(u){return this.l.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,f,a,n){const i=this.e.get(u);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${u}`);const s=m(a);return this.t(s,i).search(t=>this.c.$handleTextMatch(u,f,t),n)}$provideAITextSearchResults(u,f,a,n){const i=this.h.get(u);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${u}`);const s=m(a);return this.v(s,i).search(t=>this.c.$handleTextMatch(u,f,t),n)}$enableExtensionHostSearch(){}t(u,f){return new A.$Clc({query:u,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(u,f){return new A.$Clc({query:u,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$Hlc=C,e.$Hlc=C=Je([qe(0,M.$cP),qe(1,b.$ykc),qe(2,$.$Wj)],C);function m(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(E),extraFileResources:v.extraFileResources&&v.extraFileResources.map(u=>S.URI.revive(u))}}function E(v){return{...v,folder:S.URI.revive(v.folder)}}}),define(ke[379],Ee([1,0,22,13,4,3,15,41,2,135,198,179,79,25,32,12,86,87,277,6,324,350,91,120,328,329,330,311,300,33,331,45,332,96,151,333,313,325,334,335,72,71,326,49,336,69,337,60,28,351,352,314,338,121,339,115,116,315,370,341,283,342,353,343,157,316,344,345,346,20,347,97,117,348,317,349,118,93,95,90,43,155,354,355,327,356,357,70,16,7,318,67,319,92,358,359,150,44,293,114,26,94]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o,t,g,h,c,r,w,d,D,p,k,y,P,I,F,j,z,O,T,B,W,X,x,Z,Y,ue,te,we,Se,_,U,ne,$e,Pe,se,re,oe,G,ie,me,be,Ae,fe,De,Ie,Te,q,V,J,Q,he,pe,ze,Ve,Ze,it,ot,nt,st,Ce,Be,He,Ne,Xe,ae,ce,Re,Ge,Me,tt,ht,wt,Lt,At,xt,_t,Pt,Vt,Xt,et,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=Zt;function Zt(dt){const vt=dt.get(we.$sP),ti=dt.get(te.$jkc),Yt=dt.get(Y.$Gkc),zt=dt.get(x.$flc),gt=dt.get(Pt.$Bkc),Ut=dt.get(st.$wP),Wt=dt.get(k.$Ekc),Kt=dt.get(ht.$ykc),Ye=dt.get(J.$cP),ui=dt.get(it.$Zkc),Ht=dt.get(ot.$Hkc),Bt=dt.get(u.$Xj),mt=dt.get(u.$Wj),Tt=dt.get(Re.$ACb),Rt=dt.get(t.$fkc),Ft=dt.get(_t.$lmc),ii=dt.get(pe.$0kc),Gt=dt.get(W.$Qkc),ni=dt.get(re.$blc),Nt=dt.get(g.$pkc),Ot=dt.get($e.$7kc);Ye.set(i.$QM.ExtHostFileSystemInfo,ti),Ye.set(i.$QM.ExtHostLogLevelServiceShape,Bt),Ye.set(i.$QM.ExtHostWorkspace,gt),Ye.set(i.$QM.ExtHostConfiguration,Wt),Ye.set(i.$QM.ExtHostExtensionService,zt),Ye.set(i.$QM.ExtHostStorage,ui),Ye.set(i.$QM.ExtHostTunnelService,Tt),Ye.set(i.$QM.ExtHostWindow,Ft),Ye.set(i.$QM.ExtHostSecretState,ii),Ye.set(i.$QM.ExtHostTelemetry,Ut),Ye.set(i.$QM.ExtHostEditorTabs,Gt),Ye.set(i.$QM.ExtHostManagedSockets,ni),Ye.set(i.$QM.ExtHostAuthentication,Nt),Ye.set(i.$QM.ExtHostChatProvider,Ot);const It=Ye.set(i.$QM.ExtHostDecorations,dt.get(I.$qlc)),St=Ye.set(i.$QM.ExtHostDocumentsAndEditors,dt.get(B.$nP)),pt=Ye.set(i.$QM.ExtHostCommands,dt.get(D.$yP)),Ct=Ye.set(i.$QM.ExtHostTerminalService,dt.get(Ce.$3kc)),li=Ye.set(i.$QM.ExtHostTerminalShellIntegration,dt.get(Be.$0lc)),Dt=Ye.set(i.$QM.ExtHostDebugService,dt.get(P.$klc)),hi=Ye.set(i.$QM.ExtHostSearch,dt.get(he.$Glc)),Jt=Ye.set(i.$QM.ExtHostTask,dt.get(nt.$9lc)),wi=Ye.set(i.$QM.ExtHostOutputService,dt.get(De.$Vlc)),ei=Ye.set(i.$QM.ExtHostLocalization,dt.get(se.$alc)),vi=Ye.set(i.$QM.ExtHostUrls,new wt.$imc(Ye)),kt=Ye.set(i.$QM.ExtHostDocuments,new T.$mkc(Ye,St)),$i=Ye.set(i.$QM.ExtHostDocumentContentProviders,new z.$slc(Ye,St,mt)),Le=Ye.set(i.$QM.ExtHostDocumentSaveParticipant,new O.$tlc(mt,kt,Ye.getProxy(i.$PM.MainThreadBulkEdits))),je=Ye.set(i.$QM.ExtHostNotebook,new G.$Jlc(Ye,pt,St,kt,Yt,hi)),ye=Ye.set(i.$QM.ExtHostNotebookDocuments,new me.$Plc(je)),ee=Ye.set(i.$QM.ExtHostNotebookEditors,new be.$Qlc(mt,je)),Fe=Ye.set(i.$QM.ExtHostNotebookKernels,new Ae.$Rlc(Ye,vt,je,pt,mt)),Ke=Ye.set(i.$QM.ExtHostNotebookRenderers,new fe.$Tlc(Ye,je)),_e=Ye.set(i.$QM.ExtHostNotebookDocumentSaveParticipant,new ie.$Olc(mt,je,Ye.getProxy(i.$PM.MainThreadBulkEdits))),Qe=Ye.set(i.$QM.ExtHostEditors,new Ne.$vkc(Ye,St)),lt=Ye.set(i.$QM.ExtHostTreeViews,new ce.$gmc(Ye.getProxy(i.$PM.MainThreadTreeViews),pt,mt)),Et=Ye.set(i.$QM.ExtHostEditorInsets,new d.$wkc(Ye.getProxy(i.$PM.MainThreadEditorInsets),Qe,vt.remote)),jt=Ye.set(i.$QM.ExtHostDiagnostics,new F.$lkc(Ye,mt,ti,St)),qt=Ye.set(i.$QM.ExtHostLanguages,new Pe.$Mlc(Ye,kt,pt.converter,Kt)),ut=Ye.set(i.$QM.ExtHostLanguageFeatures,new ne.$nkc(Ye,Kt,kt,pt,jt,mt,Rt,Ut)),ri=Ye.set(i.$QM.ExtHostFileSystem,new Z.$vlc(Ye,ut)),di=Ye.set(i.$QM.ExtHostFileSystemEventService,new ue.$wlc(Ye,mt,St)),pi=Ye.set(i.$QM.ExtHostQuickOpen,(0,V.$Zlc)(Ye,gt,pt)),Di=Ye.set(i.$QM.ExtHostSCM,new Q.$2lc(Ye,pt,kt,mt)),Ri=Ye.set(i.$QM.ExtHostQuickDiff,new q.$Ylc(Ye,Kt)),Mi=Ye.set(i.$QM.ExtHostShare,new ze.$3lc(Ye,Kt)),Li=Ye.set(i.$QM.ExtHostComments,(0,p.$xkc)(Ye,pt,kt)),Ni=Ye.set(i.$QM.ExtHostProgress,new Te.$Xlc(Ye.getProxy(i.$PM.MainThreadProgress))),cn=Ye.set(i.$QM.ExtHostLabelService,new U.$Llc(Ye)),Oi=Ye.set(i.$QM.ExtHostTheming,new Xe.$dmc(Ye)),Ti=Ye.set(i.$QM.ExtHostTimeline,new ae.$fmc(Ye,pt)),yi=Ye.set(i.$QM.ExtHostWebviews,new Lt.$Lkc(Ye,vt.remote,gt,mt,Rt)),Ci=Ye.set(i.$QM.ExtHostWebviewPanels,new At.$Okc(Ye,yi,gt)),Hi=Ye.set(i.$QM.ExtHostCustomEditors,new y.$Pkc(Ye,kt,Ht,yi,Ci)),Gi=Ye.set(i.$QM.ExtHostWebviewViews,new xt.$jmc(Ye,yi)),bi=Ye.set(i.$QM.ExtHostTesting,new He.$_lc(Ye,mt,pt,St)),Ji=Ye.set(i.$QM.ExtHostUriOpeners,new tt.$hmc(Ye)),Qi=Ye.set(i.$QM.ExtHostProfileContentHandlers,new Ie.$Wlc(Ye));Ye.set(i.$QM.ExtHostInteractive,new _.$Klc(Ye,je,St,pt,mt));const un=Ye.set(i.$QM.ExtHostInlineChat,new Se.$xlc(Ye,pt,kt,mt)),Fi=Ye.set(i.$QM.ExtHostChatAgents2,new c.$skc(Ye,mt,pt)),ji=Ye.set(i.$QM.ExtHostChatVariables,new r.$tkc(Ye)),Pi=Ye.set(i.$QM.ExtHostAiRelatedInformation,new s.$ekc(Ye)),ln=Ye.set(i.$QM.ExtHostAiEmbeddingVector,new X.$ulc(Ye)),Xi=Ye.set(i.$QM.ExtHostStatusBar,new Ze.$6lc(Ye,pt.converter)),Zi=Ye.set(i.$QM.ExtHostSpeech,new Ve.$4lc(Ye)),hn=Object.values(i.$QM);Ye.assertRegistered(hn);const zi=new h.$rkc(Ye,St),Yi=new w.$ukc(Ye),Ii=new oe.$Nlc(Ye,mt),Bi=new j.$rlc(Ye);return o.$okc.register(pt),function(We,oi,Ui){function at(de){return(ve,Ue,ct)=>{const yt=de(Mt=>{try{ve.call(Ue,Mt)}catch(Si){N.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Ut.onExtensionError(We.identifier,Si)}});return ct?.push(yt),yt}}const bt=function(){let de=!We.isUnderDevelopment;function ve(){de||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ve();else{const yt=ct;typeof yt.scheme>"u"&&ve(),typeof yt.exclusive=="boolean"&&(0,et.$yG)(We,"documentFiltersExclusive")}return ct}}(),dn={getSession(de,ve,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,et.$yG)(We,"authLearnMore"),Nt.getSession(We,de,ve,Ue)},getSessions(de,ve){return(0,et.$yG)(We,"authGetSessions"),Nt.getSessions(We,de,ve)},async hasSession(de,ve){return(0,et.$yG)(We,"authSession"),!!await Nt.getSession(We,de,ve,{silent:!0})},get onDidChangeSessions(){return at(Nt.onDidChangeSessions)},registerAuthenticationProvider(de,ve,Ue,ct){return Nt.registerAuthenticationProvider(de,ve,Ue,ct)}},ai={registerCommand(de,ve,Ue){return pt.registerCommand(!0,de,ve,Ue,void 0,We)},registerTextEditorCommand(de,ve,Ue){return pt.registerCommand(!0,de,(...ct)=>{const yt=Qe.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}return yt.edit(Mt=>{ve.apply(Ue,[yt,Mt,...ct])}).then(Mt=>{Mt||mt.warn("Edits from command "+de+" were not applied.")},Mt=>{mt.warn("An error occurred while running command "+de,Mt)})},void 0,void 0,We)},registerDiffInformationCommand:(de,ve,Ue)=>((0,et.$yG)(We,"diffCommand"),pt.registerCommand(!0,de,async(...ct)=>{const yt=St.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}const Mt=await Qe.getDiffInformation(yt.id);ve.apply(Ue,[Mt,...ct])},void 0,void 0,We)),executeCommand(de,...ve){return pt.executeCommand(de,...ve)},getCommands(de=!1){return pt.getCommands(de)}},ki={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return at(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$yG)(We,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$yG)(We,"telemetry"),at(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$vP)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,ve){return st.$uP.validateSender(de),Ut.instantiateLogger(We,de,ve)},openExternal(de,ve){return Ft.openUri(de,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===vt.environment.appUriScheme)return vi.createAppUri(de);try{return await Ft.asExternalUri(de,{allowTunneling:!!vt.remote.authority})}catch(ve){if((0,M.$zg)(de,M.Schemas.http)||(0,M.$zg)(de,M.Schemas.https))return de;throw ve}},get remoteName(){return(0,f.$Cm)(vt.remote.authority)},get remoteAuthority(){return(0,et.$yG)(We,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return at(mt.onDidChangeLogLevel)},get appQuality(){return(0,et.$yG)(We,"resolvers"),vt.quality},get appCommit(){return(0,et.$yG)(We,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(ki);const xi={createTestController(de,ve,Ue){return bi.createTestController(We,de,ve,Ue)},createTestObserver(){return(0,et.$yG)(We,"testObserver"),bi.createTestObserver()},runTests(de){return(0,et.$yG)(We,"testObserver"),bi.runTests(de)},get onDidChangeTestResults(){return(0,et.$yG)(We,"testObserver"),at(bi.onResultsChanged)},get testResults(){return(0,et.$yG)(We,"testObserver"),bi.results}},Ei=vt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,_i={getExtension(de,ve){(0,et.$xG)(We,"extensionsAny")||(ve=!1);const Ue=oi.mine.getExtensionDescription(de);if(Ue)return new x.$glc(zt,We.identifier,Ue,Ei,!1);if(ve){const ct=oi.all.getExtensionDescription(de);if(ct)return new x.$glc(zt,We.identifier,ct,Ei,!0)}},get all(){const de=[];for(const ve of oi.mine.getAllExtensionDescriptions())de.push(new x.$glc(zt,We.identifier,ve,Ei,!1));return de},get allAcrossExtensionHosts(){(0,et.$yG)(We,"extensionsAny");const de=new E.$Mm(oi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ve=[];for(const Ue of oi.all.getAllExtensionDescriptions()){const ct=!de.has(Ue.identifier);ve.push(new x.$glc(zt,We.identifier,Ue,Ei,ct))}return ve},get onDidChange(){return(0,et.$xG)(We,"extensionsAny")?at(L.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):at(oi.mine.onDidChange)}},en={createDiagnosticCollection(de){return jt.createDiagnosticCollection(We.identifier,de)},get onDidChangeDiagnostics(){return at(jt.onDidChangeDiagnostics)},getDiagnostics:de=>jt.getDiagnostics(de),getLanguages(){return qt.getLanguages()},setTextDocumentLanguage(de,ve){return qt.changeLanguage(de.uri,ve)},match(de,ve){const Ue=Ge.LanguageSelector.from(de);let ct;return(0,A.$Vt)(Ue)&&(ct=je.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Mt=>Mt.document===ve))?.apiNotebook),(0,A.$Ut)(Ue,ve.uri,ve.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(de,ve,Ue){return ut.registerCodeActionProvider(We,bt(de),ve,Ue)},registerDocumentPasteEditProvider(de,ve,Ue){return(0,et.$yG)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,bt(de),ve,Ue)},registerCodeLensProvider(de,ve){return ut.registerCodeLensProvider(We,bt(de),ve)},registerDefinitionProvider(de,ve){return ut.registerDefinitionProvider(We,bt(de),ve)},registerDeclarationProvider(de,ve){return ut.registerDeclarationProvider(We,bt(de),ve)},registerImplementationProvider(de,ve){return ut.registerImplementationProvider(We,bt(de),ve)},registerTypeDefinitionProvider(de,ve){return ut.registerTypeDefinitionProvider(We,bt(de),ve)},registerHoverProvider(de,ve){return ut.registerHoverProvider(We,bt(de),ve,We.identifier)},registerEvaluatableExpressionProvider(de,ve){return ut.registerEvaluatableExpressionProvider(We,bt(de),ve,We.identifier)},registerInlineValuesProvider(de,ve){return ut.registerInlineValuesProvider(We,bt(de),ve,We.identifier)},registerDocumentHighlightProvider(de,ve){return ut.registerDocumentHighlightProvider(We,bt(de),ve)},registerMultiDocumentHighlightProvider(de,ve){return ut.registerMultiDocumentHighlightProvider(We,bt(de),ve)},registerLinkedEditingRangeProvider(de,ve){return ut.registerLinkedEditingRangeProvider(We,bt(de),ve)},registerReferenceProvider(de,ve){return ut.registerReferenceProvider(We,bt(de),ve)},registerRenameProvider(de,ve){return ut.registerRenameProvider(We,bt(de),ve)},registerNewSymbolNamesProvider(de,ve){return(0,et.$yG)(We,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(We,bt(de),ve)},registerDocumentSymbolProvider(de,ve,Ue){return ut.registerDocumentSymbolProvider(We,bt(de),ve,Ue)},registerWorkspaceSymbolProvider(de){return ut.registerWorkspaceSymbolProvider(We,de)},registerDocumentFormattingEditProvider(de,ve){return ut.registerDocumentFormattingEditProvider(We,bt(de),ve)},registerDocumentRangeFormattingEditProvider(de,ve){return ut.registerDocumentRangeFormattingEditProvider(We,bt(de),ve)},registerOnTypeFormattingEditProvider(de,ve,Ue,...ct){return ut.registerOnTypeFormattingEditProvider(We,bt(de),ve,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(de,ve,Ue){return ut.registerDocumentSemanticTokensProvider(We,bt(de),ve,Ue)},registerDocumentRangeSemanticTokensProvider(de,ve,Ue){return ut.registerDocumentRangeSemanticTokensProvider(We,bt(de),ve,Ue)},registerSignatureHelpProvider(de,ve,Ue,...ct){return typeof Ue=="object"?ut.registerSignatureHelpProvider(We,bt(de),ve,Ue):ut.registerSignatureHelpProvider(We,bt(de),ve,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(de,ve,...Ue){return ut.registerCompletionItemProvider(We,bt(de),ve,Ue)},registerInlineCompletionItemProvider(de,ve,Ue){return ve.handleDidShowCompletionItem&&(0,et.$yG)(We,"inlineCompletionsAdditions"),ve.handleDidPartiallyAcceptCompletionItem&&(0,et.$yG)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$yG)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,bt(de),ve,Ue)},registerInlineEditProvider(de,ve){return(0,et.$yG)(We,"inlineEdit"),ut.registerInlineEditProvider(We,bt(de),ve)},registerDocumentLinkProvider(de,ve){return ut.registerDocumentLinkProvider(We,bt(de),ve)},registerColorProvider(de,ve){return ut.registerColorProvider(We,bt(de),ve)},registerFoldingRangeProvider(de,ve){return ut.registerFoldingRangeProvider(We,bt(de),ve)},registerSelectionRangeProvider(de,ve){return ut.registerSelectionRangeProvider(We,de,ve)},registerCallHierarchyProvider(de,ve){return ut.registerCallHierarchyProvider(We,de,ve)},registerTypeHierarchyProvider(de,ve){return ut.registerTypeHierarchyProvider(We,de,ve)},setLanguageConfiguration:(de,ve)=>ut.setLanguageConfiguration(We,de,ve),getTokenInformationAtPosition(de,ve){return(0,et.$yG)(We,"tokenInformation"),qt.tokenAtPosition(de,ve)},registerInlayHintsProvider(de,ve){return ut.registerInlayHintsProvider(We,de,ve)},createLanguageStatusItem(de,ve){return qt.createLanguageStatusItem(We,de,ve)},registerDocumentDropEditProvider(de,ve,Ue){return ut.registerDocumentOnDropEditProvider(We,de,ve,(0,et.$xG)(We,"documentPaste")?Ue:void 0)}},fn={get activeTextEditor(){return Qe.getActiveTextEditor()},get visibleTextEditors(){return Qe.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(de,ve,Ue){$.URI.isUri(de)&&de.scheme===M.Schemas.vscodeRemote&&!de.authority&&Rt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(de)?Promise.resolve(Wi.openTextDocument(de)):Promise.resolve(de));return Qe.showTextDocument(ct,ve,Ue)},createTextEditorDecorationType(de){return Qe.createTextEditorDecorationType(We,de)},onDidChangeActiveTextEditor(de,ve,Ue){return at(Qe.onDidChangeActiveTextEditor)(de,ve,Ue)},onDidChangeVisibleTextEditors(de,ve,Ue){return at(Qe.onDidChangeVisibleTextEditors)(de,ve,Ue)},onDidChangeTextEditorSelection(de,ve,Ue){return at(Qe.onDidChangeTextEditorSelection)(de,ve,Ue)},onDidChangeTextEditorOptions(de,ve,Ue){return at(Qe.onDidChangeTextEditorOptions)(de,ve,Ue)},onDidChangeTextEditorVisibleRanges(de,ve,Ue){return at(Qe.onDidChangeTextEditorVisibleRanges)(de,ve,Ue)},onDidChangeTextEditorViewColumn(de,ve,Ue){return at(Qe.onDidChangeTextEditorViewColumn)(de,ve,Ue)},onDidCloseTerminal(de,ve,Ue){return at(Ct.onDidCloseTerminal)(de,ve,Ue)},onDidOpenTerminal(de,ve,Ue){return at(Ct.onDidOpenTerminal)(de,ve,Ue)},onDidChangeActiveTerminal(de,ve,Ue){return at(Ct.onDidChangeActiveTerminal)(de,ve,Ue)},onDidChangeTerminalDimensions(de,ve,Ue){return(0,et.$yG)(We,"terminalDimensions"),at(Ct.onDidChangeTerminalDimensions)(de,ve,Ue)},onDidChangeTerminalState(de,ve,Ue){return at(Ct.onDidChangeTerminalState)(de,ve,Ue)},onDidWriteTerminalData(de,ve,Ue){return(0,et.$yG)(We,"terminalDataWriteEvent"),at(Ct.onDidWriteTerminalData)(de,ve,Ue)},onDidExecuteTerminalCommand(de,ve,Ue){return(0,et.$yG)(We,"terminalExecuteCommandEvent"),at(Ct.onDidExecuteTerminalCommand)(de,ve,Ue)},onDidChangeTerminalShellIntegration(de,ve,Ue){return(0,et.$yG)(We,"terminalShellIntegration"),at(li.onDidChangeTerminalShellIntegration)(de,ve,Ue)},onDidStartTerminalShellExecution(de,ve,Ue){return(0,et.$yG)(We,"terminalShellIntegration"),at(li.onDidStartTerminalShellExecution)(de,ve,Ue)},onDidEndTerminalShellExecution(de,ve,Ue){return(0,et.$yG)(We,"terminalShellIntegration"),at(li.onDidEndTerminalShellExecution)(de,ve,Ue)},get state(){return Ft.getState(We)},onDidChangeWindowState(de,ve,Ue){return at(Ft.onDidChangeWindowState)(de,ve,Ue)},showInformationMessage(de,...ve){return Ii.showMessage(We,b.default.Info,de,ve[0],ve.slice(1))},showWarningMessage(de,...ve){return Ii.showMessage(We,b.default.Warning,de,ve[0],ve.slice(1))},showErrorMessage(de,...ve){return Ii.showMessage(We,b.default.Error,de,ve[0],ve.slice(1))},showQuickPick(de,ve,Ue){return pi.showQuickPick(We,de,ve,Ue)},showWorkspaceFolderPick(de){return pi.showWorkspaceFolderPick(de)},showInputBox(de,ve){return pi.showInput(de,ve)},showOpenDialog(de){return Bi.showOpenDialog(We,de)},showSaveDialog(de){return Bi.showSaveDialog(de)},createStatusBarItem(de,ve,Ue){let ct,yt,Mt;return typeof de=="string"?(ct=de,yt=ve,Mt=Ue):(yt=de,Mt=ve),Xi.createStatusBarEntry(We,ct,yt,Mt)},setStatusBarMessage(de,ve){return Xi.setStatusBarMessage(de,ve)},withScmProgress(de){return Rt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Ni.withProgress(We,{location:Me.ProgressLocation.SourceControl},(ve,Ue)=>de({report(ct){}}))},withProgress(de,ve){return Ni.withProgress(We,de,ve)},createOutputChannel(de,ve){return wi.createOutputChannel(de,ve,We)},createWebviewPanel(de,ve,Ue,ct){return Ci.createWebviewPanel(We,de,ve,Ue,ct)},createWebviewTextEditorInset(de,ve,Ue,ct){return(0,et.$yG)(We,"editorInsets"),Et.createWebviewEditorInset(de,ve,Ue,ct,We)},createTerminal(de,ve,Ue){return typeof de=="object"?"pty"in de?Ct.createExtensionTerminal(de):Ct.createTerminalFromOptions(de):Ct.createTerminal(de,ve,Ue)},registerTerminalLinkProvider(de){return Ct.registerLinkProvider(de)},registerTerminalProfileProvider(de,ve){return Ct.registerProfileProvider(We,de,ve)},registerTerminalQuickFixProvider(de,ve){return(0,et.$yG)(We,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(de,We.identifier.value,ve)},registerTreeDataProvider(de,ve){return lt.registerTreeDataProvider(de,ve,We)},createTreeView(de,ve){return lt.createTreeView(de,ve,We)},registerWebviewPanelSerializer:(de,ve)=>Ci.registerWebviewPanelSerializer(We,de,ve),registerCustomEditorProvider:(de,ve,Ue={})=>Hi.registerCustomEditorProvider(We,de,ve,Ue),registerFileDecorationProvider(de){return It.registerFileDecorationProvider(de,We)},registerUriHandler(de){return vi.registerUriHandler(We,de)},createQuickPick(){return pi.createQuickPick(We)},createInputBox(){return pi.createInputBox(We)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(de,ve,Ue){return at(Oi.onDidChangeActiveColorTheme)(de,ve,Ue)},registerWebviewViewProvider(de,ve,Ue){return Gi.registerWebviewViewProvider(We,de,ve,Ue?.webviewOptions)},get activeNotebookEditor(){return je.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,ve,Ue){return at(je.onDidChangeActiveNotebookEditor)(de,ve,Ue)},get visibleNotebookEditors(){return je.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(je.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,ve,Ue){return at(ee.onDidChangeNotebookEditorSelection)(de,ve,Ue)},onDidChangeNotebookEditorVisibleRanges(de,ve,Ue){return at(ee.onDidChangeNotebookEditorVisibleRanges)(de,ve,Ue)},showNotebookDocument(de,ve){return je.showNotebookDocument(de,ve)},registerExternalUriOpener(de,ve,Ue){return(0,et.$yG)(We,"externalUriOpener"),Ji.registerExternalUriOpener(We.identifier,de,ve,Ue)},registerProfileContentHandler(de,ve){return(0,et.$yG)(We,"profileContentHandlers"),Qi.registerProfileContentHandler(We,de,ve)},registerQuickDiffProvider(de,ve,Ue,ct){return(0,et.$yG)(We,"quickDiffProvider"),Ri.registerQuickDiffProvider(bt(de),ve,Ue,ct)},get tabGroups(){return Gt.tabGroups},registerShareProvider(de,ve){return(0,et.$yG)(We,"shareProvider"),Mi.registerShareProvider(bt(de),ve)}},Wi={get rootPath(){return Rt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(de){throw new N.$9("rootPath")},getWorkspaceFolder(de){return gt.getWorkspaceFolder(de)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(de){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(de){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(de,ve,...Ue)=>gt.updateWorkspaceFolders(We,de,ve||0,...Ue),onDidChangeWorkspaceFolders:function(de,ve,Ue){return at(gt.onDidChangeWorkspace)(de,ve,Ue)},asRelativePath:(de,ve)=>gt.getRelativePath(de,ve),findFiles:(de,ve,Ue,ct)=>gt.findFiles(de,ve,Ue,We.identifier,ct),findFiles2:(de,ve,Ue)=>((0,et.$yG)(We,"findFiles2"),gt.findFiles2(de,ve,We.identifier,Ue)),findTextInFiles:(de,ve,Ue,ct)=>{(0,et.$yG)(We,"findTextInFiles");let yt,Mt;return typeof ve=="object"?(yt=ve,Mt=Ue):(yt={},Mt=ve,ct=Ue),gt.findTextInFiles(de,yt||{},Mt,We.identifier,ct)},save:de=>gt.save(de),saveAs:de=>gt.saveAs(de),saveAll:de=>gt.saveAll(de),applyEdit(de,ve){return zi.applyWorkspaceEdit(de,We,ve)},createFileSystemWatcher:(de,ve,Ue,ct)=>{let yt;return typeof ve=="boolean"?yt={ignoreCreateEvents:!!ve,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ve&&((0,et.$yG)(We,"createFileSystemWatcher"),yt={...ve,correlate:!0}),di.createFileSystemWatcher(gt,We,de,yt)},get textDocuments(){return kt.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new N.$9("textDocuments")},openTextDocument(de){let ve;const Ue=de;if(typeof de=="string")ve=Promise.resolve($.URI.file(de));else if($.URI.isUri(de))ve=Promise.resolve(de);else if(!Ue||typeof Ue=="object")ve=kt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ct=>(ct.scheme===M.Schemas.vscodeRemote&&!ct.authority&&Rt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),kt.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(de,ve,Ue)=>at(kt.onDidAddDocument)(de,ve,Ue),onDidCloseTextDocument:(de,ve,Ue)=>at(kt.onDidRemoveDocument)(de,ve,Ue),onDidChangeTextDocument:(de,ve,Ue)=>at(kt.onDidChangeDocument)(de,ve,Ue),onDidSaveTextDocument:(de,ve,Ue)=>at(kt.onDidSaveDocument)(de,ve,Ue),onWillSaveTextDocument:(de,ve,Ue)=>at(Le.getOnWillSaveTextDocumentEvent(We))(de,ve,Ue),get notebookDocuments(){return je.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,ve){let Ue;if($.URI.isUri(de))Ue=de,await je.openNotebookDocument(de);else if(typeof de=="string")Ue=$.URI.revive(await je.createNotebookDocument({viewType:de,content:ve}));else throw new Error("Invalid arguments");return je.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,ve,Ue){return at(ye.onDidSaveNotebookDocument)(de,ve,Ue)},onDidChangeNotebookDocument(de,ve,Ue){return at(ye.onDidChangeNotebookDocument)(de,ve,Ue)},onWillSaveNotebookDocument(de,ve,Ue){return at(_e.getOnWillSaveNotebookDocumentEvent(We))(de,ve,Ue)},get onDidOpenNotebookDocument(){return at(je.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(je.onDidCloseNotebookDocument)},registerNotebookSerializer(de,ve,Ue,ct){return je.registerNotebookSerializer(We,de,ve,Ue,(0,et.$xG)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(de,ve,Ue)=>at(Ui.onDidChangeConfiguration)(de,ve,Ue),getConfiguration(de,ve){return ve=arguments.length===1?void 0:ve,Ui.getConfiguration(de,ve,We)},registerTextDocumentContentProvider(de,ve){return $i.registerTextDocumentContentProvider(de,ve)},registerTaskProvider:(de,ve)=>(Rt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(We,de,ve)),registerFileSystemProvider(de,ve,Ue){return(0,R.$Rc)(ri.registerFileSystemProvider(We,de,ve,Ue),Yt.addFileSystemProvider(de,ve,Ue))},get fs(){return Yt.value},registerFileSearchProvider:(de,ve)=>((0,et.$yG)(We,"fileSearchProvider"),hi.registerFileSearchProvider(de,ve)),registerTextSearchProvider:(de,ve)=>((0,et.$yG)(We,"textSearchProvider"),hi.registerTextSearchProvider(de,ve)),registerAITextSearchProvider:(de,ve)=>((0,et.$yG)(We,"aiTextSearchProvider"),(0,et.$yG)(We,"textSearchProvider"),hi.registerAITextSearchProvider(de,ve)),registerRemoteAuthorityResolver:(de,ve)=>((0,et.$yG)(We,"resolvers"),zt.registerRemoteAuthorityResolver(de,ve)),registerResourceLabelFormatter:de=>((0,et.$yG)(We,"resolvers"),cn.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,et.$yG)(We,"resolvers"),zt.getRemoteExecServer(de)),onDidCreateFiles:(de,ve,Ue)=>at(di.onDidCreateFile)(de,ve,Ue),onDidDeleteFiles:(de,ve,Ue)=>at(di.onDidDeleteFile)(de,ve,Ue),onDidRenameFiles:(de,ve,Ue)=>at(di.onDidRenameFile)(de,ve,Ue),onWillCreateFiles:(de,ve,Ue)=>at(di.getOnWillCreateFileEvent(We))(de,ve,Ue),onWillDeleteFiles:(de,ve,Ue)=>at(di.getOnWillDeleteFileEvent(We))(de,ve,Ue),onWillRenameFiles:(de,ve,Ue)=>at(di.getOnWillRenameFileEvent(We))(de,ve,Ue),openTunnel:de=>((0,et.$yG)(We,"tunnels"),Tt.openTunnel(We,de).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,et.$yG)(We,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(de,ve,Ue)=>((0,et.$yG)(We,"tunnels"),at(Tt.onDidChangeTunnels)(de,ve,Ue)),registerPortAttributesProvider:(de,ve)=>((0,et.$yG)(We,"portsAttributes"),Tt.registerPortsAttributesProvider(de,ve)),registerTunnelProvider:(de,ve)=>((0,et.$yG)(We,"tunnelFactory"),Tt.registerTunnelProvider(de,ve)),registerTimelineProvider:(de,ve)=>((0,et.$yG)(We,"timeline"),Ti.registerTimelineProvider(de,ve,We.identifier,pt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:de=>((0,et.$yG)(We,"workspaceTrust"),gt.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,ve,Ue)=>at(gt.onDidGrantWorkspaceTrust)(de,ve,Ue),registerEditSessionIdentityProvider:(de,ve)=>((0,et.$yG)(We,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(de,ve)),onWillCreateEditSessionIdentity:(de,ve,Ue)=>((0,et.$yG)(We,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent(We))(de,ve,Ue)),registerCanonicalUriProvider:(de,ve)=>((0,et.$yG)(We,"canonicalUriProvider"),gt.registerCanonicalUriProvider(de,ve)),getCanonicalUri:(de,ve,Ue)=>((0,et.$yG)(We,"canonicalUriProvider"),gt.provideCanonicalUri(de,ve,Ue))},tn={get inputBox(){return Rt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Di.getLastInputBox(We)},createSourceControl(de,ve,Ue){return Di.createSourceControl(We,de,ve,Ue)}},gn={createCommentController(de,ve){return Li.createCommentController(We,de,ve)}},mn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,et.$xG)(We,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(de,ve){return(0,et.$yG)(We,"debugVisualization"),Dt.registerDebugVisualizationProvider(We,de,ve)},registerDebugVisualizationTreeProvider(de,ve){return(0,et.$yG)(We,"debugVisualization"),Dt.registerDebugVisualizationTree(We,de,ve)},onDidStartDebugSession(de,ve,Ue){return at(Dt.onDidStartDebugSession)(de,ve,Ue)},onDidTerminateDebugSession(de,ve,Ue){return at(Dt.onDidTerminateDebugSession)(de,ve,Ue)},onDidChangeActiveDebugSession(de,ve,Ue){return at(Dt.onDidChangeActiveDebugSession)(de,ve,Ue)},onDidReceiveDebugSessionCustomEvent(de,ve,Ue){return at(Dt.onDidReceiveDebugSessionCustomEvent)(de,ve,Ue)},onDidChangeBreakpoints(de,ve,Ue){return at(Dt.onDidChangeBreakpoints)(de,ve,Ue)},onDidChangeActiveStackItem(de,ve,Ue){return(0,et.$yG)(We,"debugFocus"),at(Dt.onDidChangeActiveStackItem)(de,ve,Ue)},registerDebugConfigurationProvider(de,ve,Ue){return Dt.registerDebugConfigurationProvider(de,ve,Ue||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,ve){return Dt.registerDebugAdapterDescriptorFactory(We,de,ve)},registerDebugAdapterTrackerFactory(de,ve){return Dt.registerDebugAdapterTrackerFactory(de,ve)},startDebugging(de,ve,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Dt.startDebugging(de,ve,{parentSession:Ue}):Dt.startDebugging(de,ve,Ue||{})},stopDebugging(de){return Dt.stopDebugging(de)},addBreakpoints(de){return Dt.addBreakpoints(de)},removeBreakpoints(de){return Dt.removeBreakpoints(de)},asDebugSourceUri(de,ve){return Dt.asDebugSourceUri(de,ve)}},nn={registerTaskProvider:(de,ve)=>Jt.registerTaskProvider(We,de,ve),fetchTasks:de=>Jt.fetchTasks(de),executeTask:de=>Jt.executeTask(We,de),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(de,ve,Ue)=>at(Jt.onDidStartTask)(de,ve,Ue),onDidEndTask:(de,ve,Ue)=>at(Jt.onDidEndTask)(de,ve,Ue),onDidStartTaskProcess:(de,ve,Ue)=>at(Jt.onDidStartTaskProcess)(de,ve,Ue),onDidEndTaskProcess:(de,ve,Ue)=>at(Jt.onDidEndTaskProcess)(de,ve,Ue)},qi={createNotebookController(de,ve,Ue,ct,yt){return Fe.createNotebookController(We,de,ve,Ue,ct,(0,et.$xG)(We,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(de,ve)=>je.registerNotebookCellStatusBarItemProvider(We,de,ve),createRendererMessaging(de){return Ke.createRendererMessaging(We,de)},createNotebookControllerDetectionTask(de){return(0,et.$yG)(We,"notebookKernelSource"),Fe.createNotebookControllerDetectionTask(We,de)},registerKernelSourceActionProvider(de,ve){return(0,et.$yG)(We,"notebookKernelSource"),Fe.registerKernelSourceActionProvider(We,de,ve)},onDidChangeNotebookCellExecutionState(de,ve,Ue){return(0,et.$yG)(We,"notebookCellExecutionState"),at(Fe.onDidChangeNotebookCellExecutionState)(de,ve,Ue)}},rn={t(...de){if(typeof de[0]=="string"){const ve=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return ei.getMessage(We.identifier.value,{message:ve,args:Ue})}return ei.getMessage(We.identifier.value,de[0])},get bundle(){return ei.getBundle(We.identifier.value)},get uri(){return ei.getBundleUri(We.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(de,ve){return(0,et.$yG)(We,"interactive"),un.registerProvider(We,de,ve)},transferActiveChat(de){return(0,et.$yG)(We,"interactive"),Fi.transferActiveChat(de)}},on={getRelatedInformation(de,ve){return(0,et.$yG)(We,"aiRelatedInformation"),Pi.getRelatedInformation(We,de,ve)},registerRelatedInformationProvider(de,ve){return(0,et.$yG)(We,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(We,de,ve)},registerEmbeddingVectorProvider(de,ve){return(0,et.$yG)(We,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(We,de,ve)}},$n={registerChatResponseProvider(de,ve,Ue){return(0,et.$yG)(We,"chatProvider"),Ot.registerLanguageModel(We,de,ve,Ue)},registerChatVariableResolver(de,ve,Ue){return(0,et.$yG)(We,"chatVariableResolver"),ji.registerVariableResolver(We,de,ve,Ue)},registerMappedEditsProvider(de,ve){return(0,et.$yG)(We,"mappedEditsProvider"),ut.registerMappedEditsProvider(We,de,ve)},createChatParticipant(de,ve){return(0,et.$yG)(We,"chatParticipant"),Fi.createChatAgent(We,de,ve)},createDynamicChatParticipant(de,ve,Ue,ct){return(0,et.$yG)(We,"chatParticipantAdditions"),Fi.createDynamicChatAgent(We,de,ve,Ue,ct)}},pn={get languageModels(){return(0,et.$yG)(We,"languageModels"),Ot.getLanguageModelIds()},onDidChangeLanguageModels:(de,ve,Ue)=>((0,et.$yG)(We,"languageModels"),Ot.onDidChangeProviders(de,ve,Ue)),sendChatRequest(de,ve,Ue,ct){return(0,et.$yG)(We,"languageModels"),Ot.sendChatRequest(We,de,ve,Ue,ct)}},an={registerSpeechProvider(de,ve){return(0,et.$yG)(We,"speech"),Zi.registerProvider(We.identifier,de,ve)}};return{version:vt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:ki,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:pn,notebooks:qi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Wi,Breakpoint:Me.$RN,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$MO,CallHierarchyIncomingCall:Me.$dN,CallHierarchyItem:Me.$cN,CallHierarchyOutgoingCall:Me.$eN,CancellationError:N.$5,CancellationTokenSource:l.$me,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$_M,CodeActionKind:Me.$aN,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$fN,Color:Me.$sN,ColorInformation:Me.$tN,ColorPresentation:Me.$uN,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$mN,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$nN,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$CN,DebugAdapterExecutable:Me.$VN,DebugAdapterInlineImplementation:Me.$YN,DebugAdapterNamedPipeServer:Me.$XN,DebugAdapterServer:Me.$WN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$cO,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$6M,DiagnosticRelatedInformation:Me.$5M,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$RM,DocumentHighlight:Me.$8M,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$9M,DocumentLink:Me.$rN,DocumentSymbol:Me.$$M,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$2N,InlineValueText:Me.$3N,InlineValueVariableLookup:Me.$4N,InlineValueEvaluatableExpression:Me.$5N,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:L.$be,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$eO,FileDecoration2:Me.$eO,FileSystemError:Me.$8N,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Me.$9N,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$TN,InlineCompletionItem:Me.$oN,InlineCompletionList:Me.$pN,Hover:Me.$7M,IndentAction:C.IndentAction,Location:Me.$4M,MarkdownString:Me.$gN,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Me.$hN,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$SM,ProcessExecution:Me.$AN,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$dO,Range:Me.$TM,RelativePattern:Me.$PN,Selection:Me.$UM,SelectionRange:Me.$bN,SemanticTokens:Me.$_N,SemanticTokensBuilder:Me.$$N,SemanticTokensEdit:Me.$aO,SemanticTokensEdits:Me.$bO,SemanticTokensLegend:Me.$0N,ShellExecution:Me.$BN,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$jN,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$iN,SnippetString:Me.$3M,SourceBreakpoint:Me.$SN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$0M,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$DN,TaskGroup:Me.$zN,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$vN,TerminalQuickFixTerminalCommand:Me.$xN,TerminalQuickFixOpener:Me.$wN,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$yN,TerminalExitReason:Me.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Me.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$YM,SnippetTextEdit:Me.$1M,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$ON,ThemeIcon:Me.$NN,TreeItem:Me.$EN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$AO,UIKind:Xt.UIKind,Uri:$.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$2M,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$KN,DocumentDropOrPasteEditKind:Me.$LN,DocumentPasteEdit:Me.$MN,InlayHint:Me.$lN,InlayHintLabelPart:Me.$kN,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$XM,ResolvedAuthority:Me.$VM,ManagedResolvedAuthority:Me.$WM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$oO,NotebookRange:Me.$gO,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$hO,NotebookData:Me.$iO,NotebookRendererScript:Me.$mO,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$kO,NotebookCellOutputItem:Me.$jO,NotebookCellStatusBarItem:Me.$lO,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$ZM,NotebookKernelSourceAction:Me.$nO,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$qO,LinkedEditingRanges:Me.$pO,TestResultState:Me.TestResultState,TestRunRequest:Me.$rO,TestMessage:Me.$sO,TestTag:Me.$tO,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:Me.$JN,DataTransferItem:Me.$FN,TestCoverageCount:Me.$uO,FileCoverage:Me.$wO,StatementCoverage:Me.$xO,BranchCoverage:Me.$yO,DeclarationCoverage:Me.$zO,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$BO,TabInputTextDiff:Me.$CO,TabInputTextMerge:Me.$DO,TabInputCustom:Me.$EO,TabInputNotebook:Me.$GO,TabInputNotebookDiff:Me.$HO,TabInputWebview:Me.$FO,TabInputTerminal:Me.$IO,TabInputInteractiveWindow:Me.$JO,TabInputChat:Me.$KO,TabInputTextMultiDiff:Me.$LO,TelemetryTrustedValue:a.$_o,LogLevel:u.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$ZN,Thread:Me.$1N,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$NO,ChatResponseFileTreePart:Me.$QO,ChatResponseAnchorPart:Me.$RO,ChatResponseProgressPart:Me.$SO,ChatResponseReferencePart:Me.$UO,ChatResponseTextEditPart:Me.$VO,ChatResponseMarkdownWithVulnerabilitiesPart:Me.$OO,ChatResponseCommandButtonPart:Me.$TO,ChatResponseDetectedParticipantPart:Me.$PO,ChatRequestTurn:Me.$WO,ChatResponseTurn:Me.$XO,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$YO,LanguageModelChatUserMessage:Me.$ZO,LanguageModelChatAssistantMessage:Me.$1O,LanguageModelSystemMessage:Me.$YO,LanguageModelUserMessage:Me.$ZO,LanguageModelAssistantMessage:Me.$1O,LanguageModelError:Me.$2O,NewSymbolName:Me.$7N,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$3O,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(ke[380],Ee([1,0,84,157,44,151,45,33,72,43,95,96,97,118,70,91,150,69,60,117,90,71,149,12,61,115,116,120,121,155]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o,t,g,h,c,r,w,d,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$os)(c.$alc,c.$_kc,1),(0,l.$os)(g.$Xj,t.$nmc,1),(0,l.$os)(u.$fkc,u.$gkc,1),(0,l.$os)(b.$yP,b.$xP,0),(0,l.$os)(w.$pkc,w.$qkc,0),(0,l.$os)(d.$7kc,d.$8kc,0),(0,l.$os)(M.$Ekc,M.$Ckc,0),(0,l.$os)(a.$Gkc,a.$Fkc,0),(0,l.$os)(C.$klc,C.$olc,0),(0,l.$os)(R.$qlc,R.$plc,0),(0,l.$os)($.$nP,$.$mP,0),(0,l.$os)(r.$blc,r.$clc,0),(0,l.$os)(n.$jkc,n.$ikc,0),(0,l.$os)(N.$Vlc,N.$Ulc,1),(0,l.$os)(m.$Glc,m.$Hlc,0),(0,l.$os)(E.$Zkc,E.$Ykc,0),(0,l.$os)(A.$9lc,A.$8lc,0),(0,l.$os)(S.$3kc,S.$6kc,0),(0,l.$os)(D.$0lc,D.$$lc,0),(0,l.$os)(v.$ACb,v.$BCb,0),(0,l.$os)(f.$lmc,f.$kmc,0),(0,l.$os)(L.$Bkc,L.$Akc,0),(0,l.$os)(i.$0kc,i.$9kc,0),(0,l.$os)(s.$wP,s.$tP,0),(0,l.$os)(o.$Qkc,o.$Rkc,0),(0,l.$os)(h.$ilc,h.$jlc,0)}),define(ke[122],Ee([1,0,19,12,36,94]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0,e.$Dmc=M,e.$Emc=b;function M(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}function b(C,m,E,v){const u=(0,l.$2b)(E,$),f=new L.$9K(m,u,v),a=f.preview.matches;return{ranges:(0,l.$2b)(u,S),uri:C,preview:{text:f.preview.text,matches:(0,l.$2b)(a,S)}}}function $(C){return new L.$0K(C.start.line,C.start.character,C.end.line,C.end.character)}function S(C){return new R.$XK(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let A=class{constructor(m,E){this.a=m,this.b=E}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$Fmc=A,e.$Fmc=A=Je([qe(1,N.$Wj)],A)}),define(ke[381],Ee([1,0,53,17,76,34,11,14,122,382]),function(le,e,l,N,L,R,M,b,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=C,e.$Hmc=f,e.$Imc=n;const A=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(i,s,o,t){const g=m(i,s,o,t),h=s.folder.fsPath;return{cmd:l.spawn(A,g.args,{cwd:h}),rgDiskPath:A,siblingClauses:g.siblingClauses,rgArgs:g,cwd:h}}function m(i,s,o,t){const g=["--files","--hidden","--case-sensitive","--no-require-git"];v([s],o,!1).forEach(c=>{const r=(0,$.$Dmc)(c);if(g.push("-g",r),M.$j){const w=(0,L.$9l)(r);w!==r&&g.push("-g",w)}});const h=E([s],t,void 0,!1);return h.globArgs.forEach(c=>{const r=`!${(0,$.$Dmc)(c)}`;if(g.push("-g",r),M.$j){const w=(0,L.$9l)(r);w!==r&&g.push("-g",w)}}),s.disregardIgnoreFiles!==!1?g.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&g.push("--no-ignore-parent"),s.ignoreSymlinks||g.push("--follow"),i.exists&&g.push("--quiet"),g.push("--no-config"),s.disregardGlobalIgnoreFiles&&g.push("--no-ignore-global"),{args:g,siblingClauses:h.siblingClauses}}function E(i,s,o,t=!0){const g=[];let h={};return i.forEach(c=>{const r=Object.assign({},c.excludePattern||{},s||{}),w=u(r,t?c.folder.fsPath:void 0,o);g.push(...w.globArgs),w.siblingClauses&&(h=Object.assign(h,w.siblingClauses))}),{globArgs:g,siblingClauses:h}}function v(i,s,o=!0){const t=[];return i.forEach(g=>{const h=Object.assign({},s||{},g.includePattern||{}),c=u(h,o?g.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function u(i,s,o){const t=[],g={};return Object.keys(i).forEach(h=>{if(o&&o.has(h)||!h)return;const c=i[h];h=a(s?f(s,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof c=="boolean"&&c?(h.startsWith("\\\\")&&(h+="**"),t.push(n(h))):c&&c.when&&(g[h]=c)}),{globArgs:t,siblingClauses:g}}function f(i,s){return N.$jc(s)?s:N.$kc(i,s)}function a(i){return i=b.$bf(i,"\\"),b.$bf(i,"/")}function n(i){return R.$mg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[383],Ee([1,0,53,52,17,384,19,47,35,76,34,11,40,14,18,31,36,381,132]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=e.$Jmc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(h=>h())});class s{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&$.$kk(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=c.shouldGlobMatchFilePattern?null:(0,n.$pr)(this.b).normalizedLowercase),this.u=c.excludePattern&&$.$kk(c.excludePattern),this.t=new Map,c.folderQueries.forEach(r=>{const w=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),d=r.folder.fsPath;c.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==d).forEach(D=>{(0,A.$qg)(D,d)&&(w[L.$mc(d,D)]=!0)}),this.t.set(d,new t(w,d))})}cancel(){this.l=!0,i.forEach(c=>c())}walk(c,r,w,d,D){if(this.m=m.$0d.create(!1),this.l)return D(null,this.j);r.forEach(p=>{const k=L.$oc(p.fsPath);this.u&&this.u(p.fsPath,k)||this.J(w,{relativePath:p.fsPath,searchPath:void 0})}),this.r=m.$0d.create(!1),this.w(c,(p,k)=>{this.x(this.y,this,p,w,d,y=>{if(y){const P=(0,b.$bj)(y);console.error(P),this.q.push(P),k(y,void 0)}else k(null,void 0)})},(p,k)=>{this.m.stop();const y=p?M.$Hb(p)[0]:null;D(y,this.j)})}w(c,r,w){const d=new Array(c.length),D=new Array(c.length);let p=!1,k=0;if(c.length===0)return w(null,[]);c.forEach((y,P)=>{r(y,(I,F)=>{if(I?(p=!0,d[P]=null,D[P]=I):(d[P]=F,D[P]=null),++k===c.length)return w(p?D:null,d)})})}x(c,r,...w){try{c.apply(r,w)}catch(d){w[w.length-1](d)}}y(c,r,w,d){const D=c.folder.fsPath,p=C.$j,k=()=>j&&j.kill();i.add(k);let y=B=>{i.delete(k),y=()=>{},d(B)},P="";const I=this.D(),F=(0,a.$Gmc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),j=F.cmd,z=!Object.keys(F.siblingClauses).length,O=F.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let T=`${F.rgDiskPath} ${O}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),w({message:T}),this.s=0,this.z(j,"utf8",w,(B,W,X)=>{if(B){y(B);return}if(this.j){y();return}const Z=(P+(p?S.$8l(W||""):W)).split(`
`);if(X){const Y=Z.length;Z[Y-1]=Z[Y-1].trim(),Z[Y-1]||Z.pop()}else P=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Z.length,z){for(const Y of Z)if(this.J(r,{base:D,relativePath:Y,searchPath:this.N(c,Y)}),this.j){k();break}(X||this.j)&&y();return}this.G(c,I,D,Z,r),X&&(this.H(I,D,r),y())})}spawnFindCmd(c){const r=this.t.get(c.folder.fsPath),w=r.getBasenameTerms(),d=r.getPathTerms(),D=["-L","."];if(w.length||d.length){D.push("-not","(","(");for(const p of w)D.push("-name",p),D.push("-o");for(const p of d)D.push("-path",p),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),l.spawn("find",D,{cwd:c.folder.fsPath})}readStdout(c,r,w){let d="";this.z(c,r,()=>{},(D,p,k)=>{if(D){w(D);return}d+=p,k&&w(null,d)})}z(c,r,w,d){let D=(y,P,I)=>{(y||I)&&(D=()=>{},this.r?.stop()),d(y,P,I)},p=!1;c.stdout?(this.A(c.stdout,r,D),c.stdout.once("data",()=>p=!0)):w({message:"stdout is null"});let k;c.stderr?k=this.B(c.stderr):w({message:"stderr is null"}),c.on("error",y=>{D(y)}),c.on("close",y=>{let P;!p&&(P=this.C(k,r))&&g(P)?D(new Error(`command failed with error code ${y}: ${this.C(k,r)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(c,r,w){const d=new R.StringDecoder(r);return c.on("data",D=>{w(null,d.write(D))}),d}B(c){const r=[];return c.on("data",w=>{r.push(w)}),r}C(c,r){const w=new R.StringDecoder(r);return c.map(d=>w.write(d)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:r},w,d,D){d.indexOf(this.b)!==-1&&this.J(D,{base:w,relativePath:this.b,searchPath:this.N(c,this.b)});const p=k=>{const y=L.$oc(k),P=L.$nc(k);let I=r[P];I||(I=r[P]=[],p(P)),I.push({base:w,relativePath:k,basename:y,searchPath:this.N(c,k)})};d.forEach(p)}H({rootEntries:c,pathToEntries:r},w,d){const D=this,p=this.t.get(w),k=this.b;function y(P){D.o++;const I=(0,f.$mL)(()=>P.map(F=>F.basename));for(let F=0,j=P.length;F<j;F++){const z=P[F],{relativePath:O,basename:T}=z;if(p.test(O,T,k!==T?I:void 0))continue;const B=r[O];if(B)y(B);else{if(D.p++,O===k)continue;D.J(d,z)}if(D.j)break}}y(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,r,w,d,D){const p=c.folder,k=(0,f.$mL)(()=>w);this.w(w,(y,P)=>{if(this.l||this.j)return P(null);const I=r?[r,y].join(L.sep):y;if(this.t.get(c.folder.fsPath).test(I,y,this.a.filePattern!==y?k:void 0))return P(null);const F=[p.fsPath,I].join(L.sep);N.lstat(F,(j,z)=>{if(j||this.l||this.j)return P(null);this.L(F,z,(O,T)=>O||this.l||this.j?P(null):T.isDirectory()?(this.o++,this.M(F,z,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?P(null):(this.v[W]=!0,u.Promises.readdir(F).then(X=>{if(this.l||this.j)return P(null);this.I(c,I,X,d,x=>P(x||null))},X=>{P(null)})))):(this.p++,I===this.b||this.h&&v.$8f(T.size)&&T.size>this.h||this.J(d,{base:p.fsPath,relativePath:I,searchPath:this.N(c,I)}),P(null,void 0)))})},y=>{const P=y&&M.$Hb(y);return D(P&&P.length>0?P[0]:void 0)})}J(c,r){this.K(r)&&(!this.d||this.d(r.relativePath,L.$oc(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(r))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$hL)(c,this.c);if(this.b)return(0,f.$hL)(c,this.b,!1)}return!0}L(c,r,w){return r.isSymbolicLink()?N.stat(c,w):w(null,r)}M(c,r,w){return r.isSymbolicLink()?N.realpath(c,(d,D)=>d?w(d):w(null,D)):w(null,c)}N(c,r){return c.folderName?L.$kc(c.folderName,r):r}}e.$Jmc=s;class o{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new s(c)}search(c,r,w){this.c.walk(this.a,this.b,c,r,(d,D)=>{w(d,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Kmc=o;class t{constructor(c,r){this.expression=c,this.c=r,this.d(c)}d(c){let r,w;Object.keys(c).filter(d=>c[d]).forEach(d=>{L.$jc(d)?(r=r||$.$fk(),r[d]=c[d]):(w=w||$.$fk(),w[d]=c[d])}),this.a=r&&$.$kk(r,{trimForExclusions:!0}),this.b=w&&$.$kk(w,{trimForExclusions:!0})}test(c,r,w){return this.b&&this.b(c,r,w)||this.a&&this.a(L.$kc(this.c,c),r,w)}getBasenameTerms(){const c=[];return this.a&&c.push(...$.$mk(this.a)),this.b&&c.push(...$.$mk(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...$.$nk(this.a)),this.b&&c.push(...$.$nk(this.b)),c}}function g(h){const c=h.trim().split(`
`),r=c[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return E.$Vf(c[c.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(ke[385],Ee([1,0,98,21,193,22]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9D=e.$1D=e.DecodeStreamErrorKind=e.$ZD=e.$YD=e.$XD=e.$VD=e.$UD=e.$TD=e.$SD=void 0,e.$WD=M,e.$2D=v,e.$3D=u,e.$4D=f,e.$5D=a,e.$6D=n,e.$7D=h,e.$8D=c,e.$SD="utf8",e.$TD="utf8bom",e.$UD="utf16be",e.$VD="utf16le";function M(r){return[e.$SD,e.$TD,e.$UD,e.$VD].some(w=>w===r)}e.$XD=[254,255],e.$YD=[255,254],e.$ZD=[239,187,191];const b=512,$=512,S=512*8,A=512*128;var C;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(w,d){super(w),this.decodeStreamErrorKind=d}}e.$1D=m;class E{static async create(w){let d;if(w!==e.$SD)d=(await(0,L.$RD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(w));else{const D=new TextDecoder;d={write(p){return D.decode(p,{stream:!0})},end(){return D.decode()}}}return new E(d)}constructor(w){this.a=w}write(w){return this.a.write(w)}end(){return this.a.end()}}function v(r,w){const d=w.minBytesRequiredForDetection??w.guessEncoding?S:$;return new Promise((D,p)=>{const k=(0,l.$qe)(z=>z.join("")),y=[];let P=0,I;const F=new R.$me,j=async()=>{try{const z=await c({buffer:N.$Ce.concat(y),bytesRead:P},w.guessEncoding);if(z.seemsBinary&&w.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);z.encoding=await w.overwriteEncoding(z.encoding),I=await E.create(z.encoding);const O=I.write(N.$Ce.concat(y).buffer);k.write(O),y.length=0,P=0,D({stream:k,detected:z})}catch(z){F.cancel(),k.destroy(),p(z)}};(0,l.$ue)(r,{onData:async z=>{I?k.write(I.write(z.buffer)):(y.push(z),P+=z.byteLength,P>=d&&(r.pause(),await j(),setTimeout(()=>r.resume())))},onError:z=>k.error(z),onEnd:async()=>{I||await j(),k.end(I?.end())}},F.token)})}async function u(r,w,d){const p=(await(0,L.$RD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(w),d);let k=!1,y=!1;return{read(){if(y)return null;const P=r.read();if(typeof P!="string"){if(y=!0,!k&&d?.addBOM)switch(w){case e.$SD:case e.$TD:return N.$Ce.wrap(Uint8Array.from(e.$ZD));case e.$UD:return N.$Ce.wrap(Uint8Array.from(e.$XD));case e.$VD:return N.$Ce.wrap(Uint8Array.from(e.$YD))}const I=p.end();return I&&I.length>0?(k=!0,N.$Ce.wrap(I)):null}return k=!0,N.$Ce.wrap(p.write(P))}}}async function f(r){return(await(0,L.$RD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(r))}function a(r){return r===e.$TD||r===null?e.$SD:r}function n(r,w){if(!r||w<e.$XD.length)return null;const d=r.readUInt8(0),D=r.readUInt8(1);if(d===e.$XD[0]&&D===e.$XD[1])return e.$UD;if(d===e.$YD[0]&&D===e.$YD[1])return e.$VD;if(w<e.$ZD.length)return null;const p=r.readUInt8(2);return d===e.$ZD[0]&&D===e.$ZD[1]&&p===e.$ZD[2]?e.$TD:null}const i=["ascii","utf-16","utf-32"];async function s(r){const w=await(0,L.$RD)("jschardet","dist/jschardet.min.js"),d=r.slice(0,A),D=g(d.buffer),p=w.detect(D);if(!p||!p.encoding)return null;const k=p.encoding.toLowerCase();return 0<=i.indexOf(k)?null:t(p.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(r){const w=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[w]||w}function g(r){let w="";for(let d=0;d<r.length;d++)w+=String.fromCharCode(r[d]);return w}function h(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const w=r.match(/windows(\d+)/);return w?"windows-"+w[1]:r}}}function c({buffer:r,bytesRead:w},d){let D=n(r,w),p=!1;if(D!==e.$UD&&D!==e.$VD&&r){let k=!0,y=!0,P=!1;for(let I=0;I<w&&I<b;I++){const F=I%2===1,j=r.readUInt8(I)===0;if(j&&(P=!0),k&&(F&&!j||!F&&j)&&(k=!1),y&&(F&&j||!F&&!j)&&(y=!1),j&&!k&&!y)break}P&&(k?D=e.$VD:y?D=e.$UD:p=!0)}return d&&!p&&!D&&r?s(r.slice(0,w)).then(k=>({seemsBinary:!1,encoding:k})):{seemsBinary:p,encoding:D}}e.$9D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[160],Ee([1,0,385,31,159]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;class R extends L.$Clc{constructor(b,$,S=N,A="searchProcess"){super({query:b,provider:$},{readdir:C=>S.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,l.$7D)(C)},A)}}e.$Smc=R}),define(ke[161],Ee([1,0,53,401,384,19,73,35,14,2,36,94,402,382,122]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=e.$Lmc=void 0,e.$Nmc=t,e.$Omc=h,e.$Pmc=r,e.$Qmc=w,e.$Rmc=D;const u=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(k){this.a=k}provideTextSearchResults(k,y,P,I){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((F,j)=>{I.onCancellationRequested(()=>Z());const z=t(k,y),O=y.folder.fsPath,T=z.map(Se=>Se.match(/^-/)?Se:`'${Se}'`).join(" ");this.a.appendLine(`${u} ${T}
 - cwd: ${O}`);let B=l.spawn(u,z,{cwd:O});B.on("error",Se=>{console.error(Se),this.a.appendLine("Error: "+(Se&&Se.message)),j((0,A.$dL)(new A.$bL(Se&&Se.message,A.SearchErrorCode.rgProcessError)))});let W=!1;const X=new i(y.maxResults,y.folder,y.previewOptions);X.on("result",Se=>{W=!0,ue="",P.report(Se)});let x=!1;const Z=()=>{x=!0,B?.kill(),X?.cancel()};let Y=!1;X.on("hitLimit",()=>{Y=!0,Z()});let ue="";B.stdout.on("data",Se=>{X.handleData(Se),W||(ue+=Se)});let te=!1;B.stdout.once("data",()=>te=!0);let we="";B.stderr.on("data",Se=>{const _=Se.toString();this.a.appendLine(_),we.length+_.length<1e6&&(we+=_)}),B.on("close",()=>{if(this.a.appendLine(te?"Got data from stdout":"No data from stdout"),this.a.appendLine(W?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),x)F({limitHit:Y});else{X.flush(),B=null;let Se;we&&!te&&(Se=a(we))?j((0,A.$dL)(new A.$bL(Se.message,Se.code))):F({limitHit:Y})}})})}}e.$Lmc=f;function a(p){const k=p.split(`
`),y=k[0].trim();if(k.some(I=>I.startsWith("regex parse error")))return new A.$bL(n(k),A.SearchErrorCode.regexParseError);const P=y.match(/grep config error: unknown encoding: (.*)/);if(P)return new A.$bL(`Unknown encoding: ${P[1]}`,A.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new A.$bL(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new A.$bL(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new A.$bL(y,A.SearchErrorCode.regexParseError)}function n(p){const k=["Regex parse error"],y=p.filter(P=>P.startsWith("PCRE2:"));if(y.length>=1){const P=y[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const I=P.split(":")[1];k.push(":"+I)}}return k.join("")}class i extends N.EventEmitter{constructor(k,y,P){super(),this.g=k,this.h=y,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,y){return super.on(k,y),this}handleData(k){if(this.b)return;const y=typeof k=="string"?k:this.d.write(k);this.k(y)}k(k){let y=k.indexOf(`
`);const P=this.a+k;if(y>=0)y+=this.a.length;else{this.a=P;return}let I=0;for(;y>=0;)this.m(P.substring(I,y).trim()),I=y+1,y=P.indexOf(`
`,I);this.a=P.substring(I)}m(k){if(this.b||!k)return;let y;try{y=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(y.type==="match"){const P=s(y.data.path),I=S.URI.joinPath(this.h,P),F=this.n(y.data,I);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const P=s(y.data.path),I=S.URI.joinPath(this.h,P);this.o(y.data,I).forEach(j=>this.p(j))}}n(k,y){const P=k.line_number-1,I=s(k.lines),F=Buffer.from(I);let j=0,z=0,O=P;k.submatches.length===0&&k.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const T=(0,R.$Hb)(k.submatches.map((B,W)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=s(B.match),x=F.slice(j,B.start).toString(),Z=o(x),Y=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+z,ue=o(X),te=Z.numLines+O,we=ue.numLines+te,Se=ue.numLines>0?ue.lastLineLength:ue.lastLineLength+Y;return j=B.end,z=Se,O=we,new C.$XK(te,Y,we,Se)}));return(0,v.$Emc)(y,I,T,this.j)}o(k,y){const P=s(k.lines),I=k.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((F,j)=>({text:F,uri:y,lineNumber:I+j}))}p(k){this.emit("result",k)}}e.$Mmc=i;function s(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function o(p){const k=/\n/g;let y=0,P=-1,I;for(;I=k.exec(p);)y++,P=I.index;const F=P>=0?p.length-P-1:p.length;return{numLines:y,lastLineLength:F}}function t(p,k){const y=["--hidden","--no-require-git"];y.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:I}=(0,M.$K)(k.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const j=new Set;I.forEach(z=>{j.add(z)}),y.push("-g","!*"),j.forEach(z=>{g(z).map(v.$Dmc).forEach(O=>{y.push("-g",O)})})}P&&P.length&&P.forEach(j=>{y.push("-g",j)}),k.excludes.map(v.$Dmc).forEach(j=>y.push("-g",`!${j}`)),k.maxFileSize&&y.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),k.followSymlinks&&y.push("--follow"),k.encoding&&k.encoding!=="utf8"&&y.push("--encoding",k.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,$.$8e)(p.pattern),p.isRegExp=!0),k.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),p.isRegExp&&(p.pattern=h(p.pattern),y.push("--engine","auto"));let F;if(p.isWordMatch){const z=(0,$.$ef)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",z)}else if(p.isRegExp){let j=r(p.pattern);j=w(j),y.push("--regexp",j)}else F=p.pattern,y.push("--fixed-strings");return y.push("--no-config"),k.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),p.isMultiline&&y.push("--multiline"),k.beforeContext&&y.push("--before-context",k.beforeContext+""),k.afterContext&&y.push("--after-context",k.afterContext+""),y.push("--"),F&&y.push(F),y.push("."),y}function g(p){return D(p).flatMap(y=>{const P=(0,b.$ik)(y,"/");return P.map((I,F)=>P.slice(0,F+1).join("/"))})}function h(p){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(k);)p=p.replace(k,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(y);)p=p.replace(y,"$1\\x{$2}");return p}const c=p=>p.type==="Assertion"&&p.kind==="lookbehind";function r(p){let k;try{k=new m.RegExpParser().parsePattern(p)}catch{return p}let y="",P=0;const I=(z,O,T)=>{y+=p.slice(P,z)+T,P=O},F=[];return new m.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const O=F[0];if(!O)I(z.start,z.end,"\\r?\\n");else if(!F.some(c))if(O.type==="CharacterClass")if(O.negate){const T=p.slice(O.start+2,z.start)+p.slice(z.end,O.end-1);O.parent?.type==="Quantifier"?I(O.start,O.end,T?`[^${T}]`:"."):I(O.start,O.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=p.slice(O.start+1,z.start)+p.slice(z.end,O.end-1);I(O.start,O.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else O.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){c(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(k),y+=p.slice(P),y}function w(p){return p.replace(/\n/g,"\\r?\\n")}function d(p){let k=!1,y=!1,P="",I="";for(let F=0;F<p.length;F++){const j=p[F];switch(j){case"\\":y?(k?I+="\\"+j:P+="\\"+j,y=!1):y=!0;break;case"{":if(y)k?I+=j:P+=j,y=!1;else{if(k)return{strInBraces:P+"{"+I+"{"+p.substring(F+1)};k=!0}break;case"}":if(y)k?I+=j:P+=j,y=!1;else{if(k)return{fixedStart:P,strInBraces:I,fixedEnd:p.substring(F+1)};P+=j}break;default:k?I+=(y?"\\":"")+j:P+=(y?"\\":"")+j,y=!1;break}}return{strInBraces:P+(k?"{"+I:"")}}function D(p){const{fixedStart:k,strInBraces:y,fixedEnd:P}=d(p);if(k===void 0||P===void 0)return[y];let I=(0,b.$ik)(y,",");I.length||(I=[""]);const F=D(P);return I.flatMap(j=>{const z=k+j;return F.map(O=>z+O)})}}),define(ke[386],Ee([1,0,22,161,108,15]),function(le,e,l,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class M{constructor(S){this.b=S,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(S,A,C,m){const E=new N.$Lmc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:R.Schemas.file})},u=new L.$Zv(f=>C.report({...f,uri:f.uri.with({scheme:A.folder.scheme})}));return this.c(m,f=>E.provideTextSearchResults(S,v,u,f))}else return this.c(m,v=>E.provideTextSearchResults(S,A,C,v))}async c(S,A){const C=b(S);this.a.add(C);const m=await A(C.token);return this.a.delete(C),m}d(){this.a.forEach(S=>S.cancel())}}e.$Vmc=M;function b($){const S=new l.$me;return $.onCancellationRequested(()=>S.cancel()),S}}),define(ke[387],Ee([1,0,31,161,160]),function(le,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;class R{constructor($){this.a=$}search($,S,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(E){A({message:E})}},m=new L.$Smc(this.a,new N.$Lmc(C),l);return new Promise((E,v)=>m.search(u=>{S(u.map(M))},$).then(u=>E({limitHit:u.limitHit,type:"success",stats:u.stats}),v))}}e.$Tmc=R;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,S)=>{if(S.ranges){const A=S;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(ke[388],Ee([1,0,19,8,13,4,132,17,40,2,32,36,383,387]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0;class v{static{this.a=512}constructor(s="searchProcess"){this.d=s,this.b=Object.create(null)}fileSearch(s){let o;const t=a(s),g=new R.$be({onDidAddFirstListener:()=>{o=(0,N.$dh)(h=>this.doFileSearchWithEngine(m.$Kmc,t,c=>g.fire(c),h)),o.then(h=>g.fire(h),h=>g.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return g.event}textSearch(s){let o;const t=a(s),g=new R.$be({onDidAddFirstListener:()=>{o=(0,N.$dh)(h=>this.f(t,c=>g.fire(c),h)),o.then(h=>g.fire(h),h=>g.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return g.event}f(s,o,t){return s.maxFileSize=this.g().maxFileSize,new E.$Tmc(s).search(t,o,o)}g(){return{maxFileSize:16*A.$sl.GB}}doFileSearch(s,o,t){return this.doFileSearchWithEngine(m.$Kmc,s,o,t)}doFileSearchWithEngine(s,o,t,g,h=v.a){let c=0;const r=d=>{Array.isArray(d)?(c+=d.length,t(d.map(D=>this.h(D)))):d.relativePath?(c++,t(this.h(d))):t(d)};if(o.sortByScore){let d=this.l(o,r,g);if(!d){const D=o.maxResults?Object.assign({},o,{maxResults:null}):o,p=new s(D);d=this.j(p,o,t,r,g)}return new Promise((D,p)=>{d.then(([k,y])=>{const P=y.map(I=>this.h(I));this.o(P,t,h),D(k)},p)})}const w=new s(o);return this.r(w,r,h,g).then(d=>({limitHit:d.limitHit,type:"success",stats:{detailStats:d.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}h(s){return{path:s.base?(0,b.$kc)(s.base,s.relativePath):s.relativePath}}j(s,o,t,g,h){const c=new R.$be;let r=(0,N.$dh)(d=>{let D=[];const p=k=>{Array.isArray(k)?D=k:(g(k),c.fire(k))};return this.r(s,p,-1,d).then(k=>[k,D])}),w;if(o.cacheKey){w=this.k(o.cacheKey);const d={promise:r,event:c.event,resolved:!1};w.resultsToSearchCache[o.filePattern||""]=d,r.then(()=>{d.resolved=!0},D=>{delete w.resultsToSearchCache[o.filePattern||""]}),r=this.s(r)}return r.then(([d,D])=>{const p=w?w.scorerCache:Object.create(null),k=(typeof o.maxResults!="number"||o.maxResults>0)&&$.$0d.create(!1);return this.n(o,D,p,h).then(y=>{const P=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:d.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:y.length},messages:d.messages,limitHit:d.limitHit||typeof o.maxResults=="number"&&D.length>o.maxResults},y]})})}k(s){const o=this.b[s];return o||(this.b[s]=new u)}l(s,o,t){const g=s.cacheKey&&this.b[s.cacheKey];if(!g)return;const h=this.q(g,s.filePattern||"",o,t);if(h)return h.then(([c,r,w])=>{const d=$.$0d.create(!1);return this.n(s,r,g.scorerCache,t).then(D=>{const p=d.elapsed(),k={fromCache:!0,detailStats:w,type:this.d,resultCount:r.length,sortingTime:p};return[{type:"success",limitHit:c.limitHit||typeof s.maxResults=="number"&&r.length>s.maxResults,stats:k},D]})})}n(s,o,t,g){const h=(0,M.$pr)(s.filePattern||""),c=(w,d)=>(0,M.$or)(w,d,h,!0,f,t),r=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return l.$Gb(o,c,r,1e4,g)}o(s,o,t){if(t&&t>0)for(let g=0;g<s.length;g+=t)o(s.slice(g,g+t));else o(s)}q(s,o,t,g){const h=$.$0d.create(!1),c=o.indexOf(b.sep)>=0;let r;for(const p in s.resultsToSearchCache)if(o.startsWith(p)){if(c&&p.indexOf(b.sep)<0&&p!=="")continue;const k=s.resultsToSearchCache[p];r={promise:this.s(k.promise),event:k.event,resolved:k.resolved};break}if(!r)return null;const w=h.elapsed(),d=$.$0d.create(!1),D=r.event(t);return g&&g.onCancellationRequested(()=>{D.dispose()}),r.promise.then(([p,k])=>{if(g&&g.isCancellationRequested)throw(0,L.$6)();const y=[],P=(0,M.$pr)(o).normalizedLowercase;for(const I of k)(0,C.$hL)(I,P)&&y.push(I);return[p,y,{cacheWasResolved:r.resolved,cacheLookupTime:w,cacheFilterTime:d.elapsed(),cacheEntryCount:k.length}]})}r(s,o,t,g){return new Promise((h,c)=>{let r=[];g?.onCancellationRequested(()=>s.cancel()),s.search(w=>{w&&(t?(r.push(w),t>0&&r.length>=t&&(o(r),r=[])):o(w))},w=>{o(w)},(w,d)=>{r.length&&o(r),w?(o({message:"Search finished. Error: "+w.message}),c(w)):(o({message:"Search finished. Stats: "+JSON.stringify(d.stats)}),h(d))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}s(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return s.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return s.finally(o)}}}}e.$Umc=v;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(i){return(0,b.$oc)(i.relativePath)}getItemDescription(i){return(0,b.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function a(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>S.URI.revive(s))}}function n(i){return{...i,folder:S.URI.revive(i.folder)}}}),define(ke[389],Ee([1,0,3,15,2,31,12,28,20,97,67,36,388,386,122,160]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=void 0;let f=class extends S.$Hlc{constructor(n,i,s,o){super(n,s,o),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new l.$Tc;const t=new v.$Fmc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new E.$Vmc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$Fmc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new E.$Vmc(n))),this.A.add(this.C(N.Schemas.file,new m.$Umc("fileSearchProvider")))}C(n,i){const s=this.d++;return this.y=i,this.x=s,this.c.$registerFileSearchProvider(s,this.s(n)),(0,l.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,i,s,o){const t=(0,S.$Ilc)(s);if(n===this.x){const g=Date.now();return this.D(n,i,t,o).then(h=>{const c=Date.now()-g;return this.q.debug(`Ext host file search time: ${c}ms`),h})}return super.$provideFileSearchResults(n,i,s,o)}doInternalFileSearchWithCustomCallback(n,i,s){const o=t=>{if((0,C.$gL)(t)&&(t=[t]),Array.isArray(t)){s(t.map(g=>L.URI.file(g.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,o,i)}async D(n,i,s,o){return this.doInternalFileSearchWithCustomCallback(s,o,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new u.$Smc(n,i,void 0,"textSearchProvider")}};e.$Wmc=f,e.$Wmc=f=Je([qe(0,$.$cP),qe(1,b.$sP),qe(2,A.$ykc),qe(3,M.$Wj)],f)}),define(ke[123],Ee([1,0,403,63,64,404,21,13,4,3,17,11,30,81,82]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$hi=e.$gi=e.$fi=void 0,e.$ii=h,e.$ji=c,e.$li=d,e.$mi=D;class u{traceSocketEvent(k,y){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,y)}constructor(k,y=""){this.f=!0,this.debugLabel=y,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const y=P=>{this.traceSocketEvent("read",P),k(M.$Ce.wrap(P))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(k){const y=P=>{k({type:0,hadError:P,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(k){const y=()=>{k()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$fi=u;var f;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var a;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(a||(a={}));class n extends S.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,y){this.socket.traceSocketEvent(k,y)}constructor(k,y,P,I){super(),this.f=this.B(new $.$be),this.g=this.B(new $.$be),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:P?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,y,P,I,this.f,(F,j)=>this.m(F,j))),this.B(this.a.onError(F=>{console.error(F),(0,b.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new v.$ai,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let y=0;for(;y<k.byteLength;)this.a.writeMessage(k.slice(y,Math.min(y+262144,k.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(k,{compressed:y,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let I=2;k.byteLength<126?I+=0:k.byteLength<2**16?I+=2:I+=8;const F=M.$Ce.alloc(I),j=y?64:0,z=P&15;if(F.writeUInt8(128|j|z,0),k.byteLength<126)F.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){F.writeUInt8(126,1);let O=1;F.writeUInt8(k.byteLength>>>8&255,++O),F.writeUInt8(k.byteLength>>>0&255,++O)}else{F.writeUInt8(127,1);let O=1;F.writeUInt8(0,++O),F.writeUInt8(0,++O),F.writeUInt8(0,++O),F.writeUInt8(0,++O),F.writeUInt8(k.byteLength>>>24&255,++O),F.writeUInt8(k.byteLength>>>16&255,++O),F.writeUInt8(k.byteLength>>>8&255,++O),F.writeUInt8(k.byteLength>>>0&255,++O)}this.socket.write(M.$Ce.concat([F,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),P=y.readUInt8(0),I=(P&128)>>>7,F=(P&64)>>>6,j=P&15,z=y.readUInt8(1),O=(z&128)>>>7,T=z&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),P=y.readUInt8(1),I=(P&128)>>>7;let F=P&127,j=1;F===126?F=y.readUInt8(++j)*2**8+y.readUInt8(++j):F===127&&(F=y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j));let z=0;I&&(z=y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$gi=n;class i extends S.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$Ce.alloc(0)}constructor(k,y,P,I,F,j){super(),this.n=k,this.r=F,this.s=j,this.a=this.B(new $.$be),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$be),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$be),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new s(this.n,I,P,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(k,y){this.g.push({data:k,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:y}=this.g.shift();if(this.f&&y.compressed){const P=await this.w(this.f,k);this.s(P,y)}else this.s(k,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,y){return new Promise((P,I)=>{k.write(y),k.flush(F=>P(F))})}acceptFrame(k,y,P){this.h.push({data:k,isCompressed:y,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const y=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,y,P){return new Promise((I,F)=>{k.write(y),P&&k.write(M.$Ce.fromByteArray([0,0,255,255])),k.flush(j=>I(j))})}}class s extends S.$Uc{get recordedInflateBytes(){return this.j?M.$Ce.concat(this.f):M.$Ce.alloc(0)}constructor(k,y,P,I){super(),this.h=k,this.j=y,this.a=this.B(new $.$be),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(M.$Ce.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=M.$Ce.concat(this.g);this.g.length=0,k(y)})}}class o extends S.$Uc{constructor(k,y){super(),this.g=k,this.a=this.B(new $.$be),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(M.$Ce.wrap(P))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=M.$Ce.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),k(y)})}}function t(p,k){if(k===0)return;const y=p.byteLength>>>2;for(let O=0;O<y;O++){const T=p.readUInt32BE(O*4);p.writeUInt32BE(T^k,O*4)}const P=y*4,I=p.byteLength-P,F=k>>>24&255,j=k>>>16&255,z=k>>>8&255;I>=1&&p.writeUInt8(p.readUInt8(P)^F,P),I>=2&&p.writeUInt8(p.readUInt8(P+1)^j,P+1),I>=3&&p.writeUInt8(p.readUInt8(P+2)^z,P+2)}e.$hi=process.env.XDG_RUNTIME_DIR;const g={2:107,1:103};function h(){const p=(0,m.$Mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const k=process.platform!=="darwin"&&e.$hi?e.$hi:(0,L.tmpdir)(),y=(0,A.$kc)(k,`vscode-ipc-${p}.sock`);return r(y),y}function c(p,k,y){const I=(0,l.createHash)("sha256").update(p).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${y}-${k}-sock`;const F=y.substr(0,4),j=k.substr(0,6);let z;return process.platform!=="darwin"&&e.$hi&&!process.env.VSCODE_PORTABLE?z=(0,A.$kc)(e.$hi,`vscode-${I}-${F}-${j}.sock`):z=(0,A.$kc)(p,`${F}-${j}.sock`),r(z),z}function r(p){const k=g[C.$u];typeof k=="number"&&p.length>=k&&console.warn(`WARNING: IPC handle "${p}" is longer than ${k} chars, try a shorter --user-data-dir`)}class w extends E.$7h{static b(k){const y=$.Event.fromNodeEventEmitter(k,"connection");return $.Event.map(y,P=>({protocol:new v.$bi(new u(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(k){super(w.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ki=w;function d(p){return new Promise((k,y)=>{const P=(0,N.createServer)();P.on("error",y),P.listen(p,()=>{P.removeListener("error",y),k(new w(P))})})}function D(p,k){return new Promise((y,P)=>{const I=(0,N.createConnection)(p,()=>{I.removeListener("error",P),y(v.$ci.fromSocket(new u(I,`ipc-client${k}`),k))});I.once("error",P)})}}),define(ke[390],Ee([1,0,63,64,173,123,8,3,11,54,12,139,267,268,110,88,21]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=e.$Jcc=e.$Icc=void 0;async function a(t,g,h,c,r){let w;for(let d=3;d&&(w?.dispose(),w=await new n(t,g,h,c,r).waitForReady(),!(r&&L.$Pg[r]||!L.$Pg[w.tunnelLocalPort]));d--);return w}class n extends b.$Uc{constructor(g,h,c,r,w){super(),this.m=h,this.n=w,this.privacy=u.TunnelPrivacyId.Private,this.j=new Map,this.a=g,this.b=l.createServer(),this.c=new M.$ph,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=d=>this.r(d),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=r,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(h=>{h()})}async waitForReady(){const g=this.n??this.tunnelRemotePort,h=(0,u.$aw)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,L.$Qg)(g,2,1e3,h),r=null;return this.b.listen(c,this.m),await this.c.wait(),r=this.b.address(),r||(c=0,this.b.listen(c,this.m),await this.c.wait(),r=this.b.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async r(g){g.pause();const h=(0,u.$$v)(this.tunnelRemoteHost)||(0,u.$aw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,m.$Ml)(this.a,h,this.tunnelRemotePort),r=c.getSocket(),w=c.readEntireBuffer();c.dispose(),w.byteLength>0&&g.write(w.buffer),g.on("end",()=>{g.localAddress&&this.j.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{g.localAddress&&this.j.delete(g.localAddress),r instanceof R.$fi?r.socket.destroy():r.end()}),r instanceof R.$fi?this.t(g,r):this.s(g,r),g.localAddress&&this.j.set(g.localAddress,()=>{g.end(),r.end()})}s(g,h){h.onClose(()=>g.destroy()),h.onEnd(()=>g.end()),h.onData(c=>g.write(c.buffer)),g.on("data",c=>h.write(f.$Ce.wrap(c))),g.resume()}t(g,h){const c=h.socket;c.on("end",()=>g.end()),c.on("close",()=>g.end()),c.on("error",()=>{g.destroy()}),c.pipe(g),g.pipe(c)}}e.$Icc=n;let i=class extends u.$dw{constructor(g,h,c,r,w){super(h,w),this.v=g,this.w=c,this.y=r}isPortPrivileged(g){return(0,u.$bw)(g,this.m,$.OS,N.release())}t(g,h,c,r,w,d,D,p){const k=this.s(h,c);if(k)return++k.refcount,k.value;if((0,u.$7v)(g))return this.u(g,h,c,w,d,D,p);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${c} on local port ${w}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:g,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=a(y,r,h,c,w);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(h,c,P),P}}};e.$Jcc=i,e.$Jcc=i=Je([qe(0,E.$Gl),qe(1,A.$Wj),qe(2,v.$Jl),qe(3,C.$dk),qe(4,S.$Wi)],i);let s=class extends i{constructor(g,h,c,r,w){super(g,h,c,r,w)}};e.$Kcc=s,e.$Kcc=s=Je([qe(0,E.$Gl),qe(1,A.$Wj),qe(2,v.$Jl),qe(3,C.$dk),qe(4,S.$Wi)],s);let o=class extends b.$Uc{constructor(g,h,c,r,w){super(),this.b=g,this.c=h,this.f=c,this.g=r,this.h=w,this.a=new Map}async openTunnel(g,h,c,r,w,d,D,p,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${r} on local port ${d}.`),!this.a.has(g)){const y=new s(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(g,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(g))})}return this.a.get(g).openTunnel(h,c,r,w,d,D,p,k)}};e.$Lcc=o,e.$Lcc=o=Je([qe(0,E.$Gl),qe(1,A.$Wj),qe(2,C.$dk),qe(3,v.$Jl),qe(4,S.$Wi)],o)}),define(ke[391],Ee([1,0,123,287,52,33,2,12,42]),function(le,e,l,N,L,R,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=e.$DP=void 0;class S{constructor(m,E,v){this.b=m,this.c=E,this.f=v,this.a=N.createServer((u,f)=>this.h(u,f)),this.g().catch(u=>(E.error(u),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,E){const v=(f,a)=>{E.writeHead(f,{"content-type":"application/json"}),E.end(JSON.stringify(a||null),n=>n&&this.c.error(n))},u=[];m.setEncoding("utf8"),m.on("data",f=>u.push(f)),m.on("end",async()=>{try{const f=JSON.parse(u.join(""));let a;switch(f.type){case"open":a=await this.i(f);break;case"openExternal":a=await this.j(f);break;case"status":a=await this.l(f);break;case"extensionManagement":a=await this.k(f);break;default:v(404,`Unknown message type: ${f.type}`);break}v(200,a)}catch(f){const a=f instanceof Error?f.message:JSON.stringify(f);v(500,a),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:E,folderURIs:v,forceNewWindow:u,diffMode:f,mergeMode:a,addMode:n,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:o,remoteAuthority:t}=m,g=[];if(Array.isArray(v))for(const w of v)try{g.push({folderUri:M.URI.parse(w)})}catch{}if(Array.isArray(E))for(const w of E)try{(0,$.$Vi)(w)?g.push({workspaceUri:M.URI.parse(w)}):g.push({fileUri:M.URI.parse(w)})}catch{}const h=o?M.URI.file(o):void 0,r={forceNewWindow:u,diffMode:f,mergeMode:a,addMode:n,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!h&&!n,waitMarkerFileURI:h,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",g,r)}async j(m){for(const E of m.uris){const v=M.URI.parse(E),u=v.scheme==="file"?v:E;await this.b.executeCommand("_remoteCLI.openExternal",u)}}async k(m){const E=u=>u?.map(f=>/\.vsix$/i.test(f)?M.URI.parse(f):f),v={list:m.list,install:E(m.install),uninstall:E(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$DP=S;let A=class extends S{constructor(m,E){super(m,E,(0,l.$ii)())}};e.$EP=A,e.$EP=A=Je([qe(0,R.$yP),qe(1,b.$Wj)],A)}),define(ke[392],Ee([1,0,59,379,374,286,49,361,2,15,7,391,104,320,360]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class u extends L.$qmc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(h,c,r){return h=t(h),n.a.has(h)?n.a.get(h).load(h,$.URI.file((0,m.$Yq)(c.filename)),w=>s.apply(this,[w,c,r])):s.apply(this,arguments)};const o=i._resolveLookupPaths;i._resolveLookupPaths=(g,h)=>o.call(this,t(g),h);const t=g=>{for(const h of n.b){const c=h(g);if(c){g=c;break}}return g}}}class f extends M.$elc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(E.$Zmc);const n=this.h.invokeFunction(N.$mmc);if(this.h.createInstance(b.$Ymc),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(C.$EP);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(v.$1mc),await this.h.createInstance(u,n,{mine:this.J,all:this.L}).install(),l.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,R.$Xmc)(this.j,s,this,this.s,this.z,this.f),l.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,s){if(i.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let o=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&l.mark(`code/extHost/willLoadExtensionCode/${t}`),o=le.__$__nodeRequire(i.fsPath)}finally{t&&l.mark(`code/extHost/didLoadExtensionCode/${t}`),s.codeLoadingStop()}return o}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const s=n[i];s===null?delete process.env[i]:process.env[i]=s}}}e.$2mc=f}),define(ke[393],Ee([1,0,53,21,4,3,125,11,23,2,31,12,266,66,110,88,390,28,20,70,368]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0,e.$3mc=o,e.$4mc=t,e.$5mc=g,e.$6mc=h,e.$7mc=r,e.$8mc=w,e.$9mc=d;function o(k){const y=k.trim().split(`
`),P=[];return y.forEach(F=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);j&&j.length>=3&&P.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),P.reduce((F,j)=>(F[j.socket]=j,F),{})}function t(...k){const y=[].concat(...k.map(h));return[...new Map(y.filter(P=>P.st==="0A").map(P=>{const I=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:g(I[0]),port:parseInt(I[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}function g(k){let y="";if(k.length===8)for(let P=k.length-2;P>=0;P-=2)y+=parseInt(k.substr(P,2),16),P!==0&&(y+=".");else for(let P=0;P<k.length;P+=8){const I=k.substring(P,P+8);let F="";for(let j=8;j>=2;j-=2)F+=I.substring(j-2,j),(j===6||j===2)&&(F=parseInt(F,16).toString(16),y+=`${F}`,F="",P+j!==k.length-6&&(y+=":"))}return y}function h(k){const y=k.trim().split(`
`),P=y.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return y.map(F=>F.trim().split(/\s+/).reduce((j,z,O)=>(j[P[O]||O]=z,j),{}))}function c(k){return!!k.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||k.indexOf("out/server-main.js")!==-1||k.indexOf("_productName=VSCode")!==-1}function r(k){const y=k.trim().split(`
`),P=[];return y.forEach(I=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);F&&F.length>=4&&P.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),P}async function w(k,y,P){const I=P.reduce((j,z)=>(j[z.pid]=z,j),{}),F=[];return k.forEach(({socket:j,ip:z,port:O})=>{const T=y[j]?y[j].pid:void 0,B=T?I[T]?.cmd:void 0;T&&B&&!c(B)&&F.push({host:z,port:O,detail:B,pid:T})}),F}function d(k,y,P){const I=new Map,F=r(y);for(const j of k){const z=P.get(j.port);if(z){I.set(j.port,z);continue}const O=F.find(T=>T.cmd.includes(`${j.port}`));if(O){let T=O,B;do B=F.find(W=>W.ppid===T.pid),B&&(T=B);while(B);I.set(j.port,{host:j.ip,port:j.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else I.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return I}let D=class extends i.$BCb{constructor(y,P,I,F){super(y,P,I),this.D=P,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new M.$ym;let F=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(B=>(0,u.$$v)(B.host)||(0,u.$aw)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(B=>B.port).join(", ")}`);const O=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),F++>3&&I.update(O),(!P||JSON.stringify(P)!==JSON.stringify(z))&&(P=z,await this.a.$onFoundNewCandidates(P));const T=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(B=>setTimeout(()=>B(),T))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",P="";try{y=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(y,P),F=await new Promise(x=>{(0,l.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,Y,ue)=>{x(Y)})}),j=o(F),z=await A.Promises.readdir("/proc"),O=[];for(const x of z)try{const Z=Number(x),Y=$.$4g(S.URI.file("/proc"),x);if((await A.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(Z)){const te=await A.Promises.readlink($.$4g(Y,"cwd").fsPath),we=await A.Promises.readFile($.$4g(Y,"cmdline").fsPath,"utf8");O.push({pid:Z,cwd:te,cmd:we})}}catch{}const T=[],B=I.filter(x=>{const Z=j[x.socket];return Z||T.push(x),Z}),W=w(B,j,O);let X;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const x=await new Promise(Z=>{(0,l.exec)("ps -F -A -l | grep root",(Y,ue,te)=>{Z(ue)})});this.z=d(T,x,this.z),X=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${X.map(Z=>Z.port).join(", ")}`)}return W.then(x=>X?x.concat(X):x)}w(y){return async P=>{const I=new f.$Icc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,O,T){const B=await y.makeConnection();return p.connect(B,z,O,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$Cl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await I.waitForReady();const F=new L.$be;return{localAddress:(0,s.$dM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{I.dispose(),F.fire(),F.dispose()}}}}};e.$0mc=D,e.$0mc=D=Je([qe(0,n.$cP),qe(1,a.$sP),qe(2,C.$Wj),qe(3,v.$Jl)],D);class p extends m.$zsb{static connect(y,P,I,F){const j=new R.$Tc,z={onClose:j.add(new L.$be),onData:j.add(new L.$be),onEnd:j.add(new L.$be)};j.add(y.onDidReceiveMessage(T=>z.onData.fire(N.$Ce.wrap(T)))),j.add(y.onDidEnd(()=>z.onEnd.fire())),j.add(y.onDidClose(T=>z.onClose.fire({type:0,error:T,hadError:!!T})));const O=new p(y,F,z);return O.B(j),(0,m.$ysb)(O,P,I,F,z)}constructor(y,P,I){super(P,I),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[394],Ee([1,0,84,363,377,376,389,392,393,96,49,97,95,43,70,93,362,321,12,378,61,281,106,110,141]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a,n,i,s,o,t,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$os)(A.$flc,b.$2mc,0),(0,l.$os)(n.$Xj,a.$_mc,1),(0,l.$os)(n.$Wj,new t.$ni(o.$pmc,[!1],!0)),(0,l.$os)(g.$Jl,h.$Ncc,1),(0,l.$os)(u.$Hkc,f.$$mc,0),(0,l.$os)(S.$klc,R.$Cmc,0),(0,l.$os)(C.$Glc,M.$Wmc,0),(0,l.$os)(m.$9lc,L.$umc,0),(0,l.$os)(E.$3kc,N.$tmc,0),(0,l.$os)(v.$ACb,$.$0mc,0),(0,l.$os)(s.$ilc,i.$anc,0)}),define(ke[405],Ee([1,0,63,406,59,13,82,123,264,114,375,21,31,104,8,135,288,304,380,394]),function(le,e,l,N,L,R,M,b,$,S,A,C,m,E,v,u,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const n=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const w=globalThis._VSCODE_NODE_MODULES.module,d=w._load;w._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const i=process.exit.bind(process),s=process.on.bind(process);function o(w){process.exit=function(d){if(w)i(d);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(d,D){d==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),s(d,D)}}let t=function(w){i()};function g(){const w=(0,a.$in)(process.env);if(w.type===3)return new Promise((d,D)=>{const p=k=>{const y=k[0],P=new M.$di;y.on("message",I=>P.fire(C.$Ce.wrap(I.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),d({onMessage:P.event,send:I=>y.postMessage(I.buffer)})};process.parentPort.on("message",k=>p(k.ports))});if(w.type===2)return new Promise((d,D)=>{let p=null;const k=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,P=3e5,I=new v.$Dh(()=>t("renderer disconnected for too long (1)"),y),F=new v.$Dh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(z,O)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const T=C.$Ce.wrap(Buffer.from(z.initialDataChunk,"base64"));let B;if(z.skipWebSocketFrames)B=new b.$fi(O,"extHost-socket");else{const W=C.$Ce.wrap(Buffer.from(z.inflateBytes,"base64"));B=new b.$gi(new b.$fi(O,"extHost-socket"),z.permessageDeflate,W,!1)}p?(I.cancel(),F.cancel(),p.beginAcceptReconnection(B,T),p.endAcceptReconnection(),p.sendResume()):(clearTimeout(k),p=new M.$ei({socket:B,initialChunk:T}),p.sendResume(),p.onDidDispose(()=>t("renderer disconnected")),d(p),p.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;I.isScheduled()&&F.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const d=w.pipeName;return new Promise((D,p)=>{const k=l.createConnection(d,()=>{k.removeListener("error",p);const y=new M.$ei({socket:new b.$fi(k,"extHost-renderer")});y.sendResume(),D(y)});k.once("error",p),k.on("close",()=>{t("renderer closed the socket")})})}}async function h(){const w=await g();return new class{constructor(){this.a=new M.$di,this.onMessage=this.a.event,this.b=!1,w.onMessage(d=>{(0,S.$Um)(d,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(d)})}send(d){this.b||w.send(d)}async drain(){if(w.drain)return w.drain()}}}function c(w){return new Promise(d=>{const D=w.onMessage(p=>{D.dispose();const k=JSON.parse(p.toString()),y=k.commit,P=$.default.commit;if(y&&P&&y!==P&&i(55),k.parentPid){let I=0;setInterval(function(){try{process.kill(k.parentPid,0),I=0}catch(j){j&&j.code==="EPERM"?(I++,I>=3&&t(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${k.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(k.parentPid)}catch(j){(0,R.$1)(j)}}w.send((0,S.$Tm)(0)),d({protocol:w,initData:k})});w.send((0,S.$Tm)(1))})}async function r(){const w=[];process.on("unhandledRejection",(I,F)=>{w.push(F),setTimeout(()=>{const j=w.indexOf(F);j>=0&&F.catch(z=>{w.splice(j,1),(0,R.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const F=w.indexOf(I);F>=0&&w.splice(F,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const d=await h();L.mark("code/extHost/didConnectToRenderer");const D=await c(d);L.mark("code/extHost/didWaitForInitData");const{initData:p}=D;o(!!p.environment.extensionTestsLocationURI),p.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,p.environment.skipWorkspaceStorageLock=(0,u.boolean)(n.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(F){i(F)}fsExists(F){return m.Promises.exists(F)}fsRealpath(F){return(0,E.$Xq)(F)}};let y=null;p.remote.authority&&n.transformURIs&&(y=(0,f.$ss)(p.remote.authority));const P=new A.$smc(D.protocol,p,k,y);t=I=>P.terminate(I)}r().catch(w=>console.log(w))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b22eef9573fc76eb0e322015ca4236ca7056747b/core/vs/workbench/api/node/extensionHostProcess.js.map
