/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(fe){for(var e=[],I=0,N=fe.length;I<N;I++)e[I]=Ae[fe[I]];return e};define(Ae[68],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=N,e.$Vh=A,e.$Wh=O;function I(M){return(p,$,k)=>{let T=null,y=null;if(typeof k.value=="function"?(T="value",y=k.value):typeof k.get=="function"&&(T="get",y=k.get),!y)throw new Error("not supported");k[T]=M(y,$)}}function N(M,p,$){let k=null,T=null;if(typeof $.value=="function"?(k="value",T=$.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(k="get",T=$.get),!T)throw new Error("not supported");const y=`$memoize$${p}`;$[k]=function(...l){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,l)}),this[y]}}function A(M,p,$){return I((k,T)=>{const y=`$debounce$${T}`,l=`$debounce$result$${T}`;return function(...v){this[l]||(this[l]=$?$():void 0),clearTimeout(this[y]),p&&(this[l]=p(this[l],...v),v=[this[l]]),this[y]=setTimeout(()=>{k.apply(this,v),this[l]=$?$():void 0},M)}})}function O(M,p,$){return I((k,T)=>{const y=`$throttle$timer$${T}`,l=`$throttle$result$${T}`,v=`$throttle$lastRun$${T}`,m=`$throttle$pending$${T}`;return function(...s){if(this[l]||(this[l]=$?$():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[l]=p(this[l],...s)),this[m])return;const o=this[v]+M;o<=Date.now()?(this[v]=Date.now(),k.apply(this,[this[l]]),this[l]=$?$():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[v]=Date.now(),k.apply(this,[this[l]]),this[l]=$?$():void 0},o-Date.now()))}})}}),define(Ae[90],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=void 0;class I{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$hP=I,e.$iP=new I("id#")}),define(Ae[123],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=M,e.$Cn=y,e.$Dn=l,e.$En=v,e.$Fn=m,e.$Gn=s,e.$Hn=o,e.$In=n,e.$Jn=r,e.$Kn=t,e.$Ln=a,e.$Mn=d;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var A;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(i,b=!1){let c=0;const f=i.length;let u="",S=0,h=16,E=0;function g(q){let R=0,U=0;for(;R<q;){const K=i.charCodeAt(c);if(K>=48&&K<=57)U=U*16+K-48;else if(K>=65&&K<=70)U=U*16+K-65+10;else if(K>=97&&K<=102)U=U*16+K-97+10;else break;c++,R++}return R<q&&(U=-1),U}function D(q){c=q,u="",S=0,h=16,E=0}function w(){const q=c;if(i.charCodeAt(c)===48)c++;else for(c++;c<i.length&&k(i.charCodeAt(c));)c++;if(c<i.length&&i.charCodeAt(c)===46)if(c++,c<i.length&&k(i.charCodeAt(c)))for(c++;c<i.length&&k(i.charCodeAt(c));)c++;else return E=3,i.substring(q,c);let R=c;if(c<i.length&&(i.charCodeAt(c)===69||i.charCodeAt(c)===101))if(c++,(c<i.length&&i.charCodeAt(c)===43||i.charCodeAt(c)===45)&&c++,c<i.length&&k(i.charCodeAt(c))){for(c++;c<i.length&&k(i.charCodeAt(c));)c++;R=c}else E=3;return i.substring(q,R)}function C(){let q="",R=c;for(;;){if(c>=f){q+=i.substring(R,c),E=2;break}const U=i.charCodeAt(c);if(U===34){q+=i.substring(R,c),c++;break}if(U===92){if(q+=i.substring(R,c),c++,c>=f){E=2;break}switch(i.charCodeAt(c++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const se=g(4);se>=0?q+=String.fromCharCode(se):E=4;break}default:E=5}R=c;continue}if(U>=0&&U<=31)if($(U)){q+=i.substring(R,c),E=2;break}else E=6;c++}return q}function P(){if(u="",E=0,S=c,c>=f)return S=f,h=17;let q=i.charCodeAt(c);if(p(q)){do c++,u+=String.fromCharCode(q),q=i.charCodeAt(c);while(p(q));return h=15}if($(q))return c++,u+=String.fromCharCode(q),q===13&&i.charCodeAt(c)===10&&(c++,u+=`
`),h=14;switch(q){case 123:return c++,h=1;case 125:return c++,h=2;case 91:return c++,h=3;case 93:return c++,h=4;case 58:return c++,h=6;case 44:return c++,h=5;case 34:return c++,u=C(),h=10;case 47:{const R=c-1;if(i.charCodeAt(c+1)===47){for(c+=2;c<f&&!$(i.charCodeAt(c));)c++;return u=i.substring(R,c),h=12}if(i.charCodeAt(c+1)===42){c+=2;const U=f-1;let K=!1;for(;c<U;){if(i.charCodeAt(c)===42&&i.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,E=1),u=i.substring(R,c),h=13}return u+=String.fromCharCode(q),c++,h=16}case 45:if(u+=String.fromCharCode(q),c++,c===f||!k(i.charCodeAt(c)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=w(),h=11;default:for(;c<f&&V(q);)c++,q=i.charCodeAt(c);if(S!==c){switch(u=i.substring(S,c),u){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return u+=String.fromCharCode(q),c++,h=16}}function V(q){if(p(q)||$(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:D,getPosition:()=>c,scan:b?W:P,getToken:()=>h,getTokenValue:()=>u,getTokenOffset:()=>S,getTokenLength:()=>c-S,getTokenError:()=>E}}function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function $(i){return i===10||i===13||i===8232||i===8233}function k(i){return i>=48&&i<=57}var T;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(T||(T={}));function y(i,b){const c=[],f=new Object;let u;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function E(g,D,w,C){S.value=g,S.offset=D,S.length=w,S.type=C,S.colonOffset=void 0,u=S}try{t(i,{onObjectBegin:(g,D)=>{if(b<=g)throw f;u=void 0,h=b>g,c.push("")},onObjectProperty:(g,D,w)=>{if(b<D||(E(g,D,w,"property"),c[c.length-1]=g,b<=D+w))throw f},onObjectEnd:(g,D)=>{if(b<=g)throw f;u=void 0,c.pop()},onArrayBegin:(g,D)=>{if(b<=g)throw f;u=void 0,c.push(0)},onArrayEnd:(g,D)=>{if(b<=g)throw f;u=void 0,c.pop()},onLiteralValue:(g,D,w)=>{if(b<D||(E(g,D,w,d(g)),b<=D+w))throw f},onSeparator:(g,D,w)=>{if(b<=D)throw f;if(g===":"&&u&&u.type==="property")u.colonOffset=D,h=!1,u=void 0;else if(g===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(h=!0,c[c.length-1]=""),u=void 0}}})}catch(g){if(g!==f)throw g}return{path:c,previousNode:u,isAtPropertyKey:h,matches:g=>{let D=0;for(let w=0;D<g.length&&w<c.length;w++)if(g[D]===c[w]||g[D]==="*")D++;else if(g[D]!=="**")return!1;return D===g.length}}}function l(i,b=[],c=O.DEFAULT){let f=null,u=[];const S=[];function h(g){Array.isArray(u)?u.push(g):f!==null&&(u[f]=g)}return t(i,{onObjectBegin:()=>{const g={};h(g),S.push(u),u=g,f=null},onObjectProperty:g=>{f=g},onObjectEnd:()=>{u=S.pop()},onArrayBegin:()=>{const g=[];h(g),S.push(u),u=g,f=null},onArrayEnd:()=>{u=S.pop()},onLiteralValue:h,onError:(g,D,w)=>{b.push({error:g,offset:D,length:w})}},c),u[0]}function v(i,b=[],c=O.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(g){f.type==="property"&&(f.length=g-f.offset,f=f.parent)}function S(g){return f.children.push(g),g}t(i,{onObjectBegin:g=>{f=S({type:"object",offset:g,length:-1,parent:f,children:[]})},onObjectProperty:(g,D,w)=>{f=S({type:"property",offset:D,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:g,offset:D,length:w,parent:f})},onObjectEnd:(g,D)=>{f.length=g+D-f.offset,f=f.parent,u(g+D)},onArrayBegin:(g,D)=>{f=S({type:"array",offset:g,length:-1,parent:f,children:[]})},onArrayEnd:(g,D)=>{f.length=g+D-f.offset,f=f.parent,u(g+D)},onLiteralValue:(g,D,w)=>{S({type:d(g),offset:D,length:w,parent:f,value:g}),u(D+w)},onSeparator:(g,D,w)=>{f.type==="property"&&(g===":"?f.colonOffset=D:g===","&&u(D))},onError:(g,D,w)=>{b.push({error:g,offset:D,length:w})}},c);const E=f.children[0];return E&&delete E.parent,E}function m(i,b){if(!i)return;let c=i;for(const f of b)if(typeof f=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let u=!1;for(const S of c.children)if(Array.isArray(S.children)&&S.children[0].value===f){c=S.children[1],u=!0;break}if(!u)return}else{const u=f;if(c.type!=="array"||u<0||!Array.isArray(c.children)||u>=c.children.length)return;c=c.children[u]}return c}function s(i){if(!i.parent||!i.parent.children)return[];const b=s(i.parent);if(i.parent.type==="property"){const c=i.parent.children[0].value;b.push(c)}else if(i.parent.type==="array"){const c=i.parent.children.indexOf(i);c!==-1&&b.push(c)}return b}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const b=Object.create(null);for(const c of i.children){const f=c.children[1];f&&(b[c.children[0].value]=o(f))}return b}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function n(i,b,c=!1){return b>=i.offset&&b<i.offset+i.length||c&&b===i.offset+i.length}function r(i,b,c=!1){if(n(i,b,c)){const f=i.children;if(Array.isArray(f))for(let u=0;u<f.length&&f[u].offset<=b;u++){const S=r(f[u],b,c);if(S)return S}return i}}function t(i,b,c=O.DEFAULT){const f=M(i,!1);function u(ie){return ie?()=>ie(f.getTokenOffset(),f.getTokenLength()):()=>!0}function S(ie){return ie?Pe=>ie(Pe,f.getTokenOffset(),f.getTokenLength()):()=>!0}const h=u(b.onObjectBegin),E=S(b.onObjectProperty),g=u(b.onObjectEnd),D=u(b.onArrayBegin),w=u(b.onArrayEnd),C=S(b.onLiteralValue),P=S(b.onSeparator),V=u(b.onComment),W=S(b.onError),q=c&&c.disallowComments,R=c&&c.allowTrailingComma;function U(){for(;;){const ie=f.scan();switch(f.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ie){case 12:case 13:q?K(10):V();break;case 16:K(1);break;case 15:case 14:break;default:return ie}}}function K(ie,Pe=[],Fe=[]){if(W(ie),Pe.length+Fe.length>0){let ne=f.getToken();for(;ne!==17;){if(Pe.indexOf(ne)!==-1){U();break}else if(Fe.indexOf(ne)!==-1)break;ne=U()}}}function se(ie){const Pe=f.getTokenValue();return ie?C(Pe):E(Pe),U(),!0}function ce(){switch(f.getToken()){case 11:{let ie=0;try{ie=JSON.parse(f.getTokenValue()),typeof ie!="number"&&(K(2),ie=0)}catch{K(2)}C(ie);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return U(),!0}function ve(){return f.getToken()!==10?(K(3,[],[2,5]),!1):(se(!1),f.getToken()===6?(P(":"),U(),be()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){h(),U();let ie=!1;for(;f.getToken()!==2&&f.getToken()!==17;){if(f.getToken()===5){if(ie||K(4,[],[]),P(","),U(),f.getToken()===2&&R)break}else ie&&K(6,[],[]);ve()||K(4,[],[2,5]),ie=!0}return g(),f.getToken()!==2?K(7,[2],[]):U(),!0}function ue(){D(),U();let ie=!1;for(;f.getToken()!==4&&f.getToken()!==17;){if(f.getToken()===5){if(ie||K(4,[],[]),P(","),U(),f.getToken()===4&&R)break}else ie&&K(6,[],[]);be()||K(4,[],[4,5]),ie=!0}return w(),f.getToken()!==4?K(8,[4],[]):U(),!0}function be(){switch(f.getToken()){case 3:return ue();case 1:return Ie();case 10:return se(!0);default:return ce()}}return U(),f.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):be()?(f.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function a(i,b){const c=M(i),f=[];let u,S=0,h;do switch(h=c.getPosition(),u=c.scan(),u){case 12:case 13:case 17:S!==h&&f.push(i.substring(S,h)),b!==void 0&&f.push(c.getTokenValue().replace(/[^\r\n]/g,b)),S=c.getPosition();break}while(u!==17);return f.join("")}function d(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(fe,e){typeof define=="function"&&define.amd?define(Ae[124],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(ke,$e){for(var ge=0;ge<$e.length;ge++){var J=$e[ge];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ke,J.key,J)}}function I(ke,$e,ge){return $e&&e(ke.prototype,$e),ge&&e(ke,ge),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function N(ke,$e){if(ke){if(typeof ke=="string")return A(ke,$e);var ge=Object.prototype.toString.call(ke).slice(8,-1);if(ge==="Object"&&ke.constructor&&(ge=ke.constructor.name),ge==="Map"||ge==="Set")return Array.from(ke);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return A(ke,$e)}}function A(ke,$e){($e==null||$e>ke.length)&&($e=ke.length);for(var ge=0,J=new Array($e);ge<$e;ge++)J[ge]=ke[ge];return J}function O(ke,$e){var ge=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(ge)return(ge=ge.call(ke)).next.bind(ge);if(Array.isArray(ke)||(ge=N(ke))||$e&&ke&&typeof ke.length=="number"){ge&&(ke=ge);var J=0;return function(){return J>=ke.length?{done:!0}:{done:!1,value:ke[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=M();function p(ke){fe.defaults=ke}var $=/[&<>"']/,k=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function($e){return l[$e]};function m(ke,$e){if($e){if($.test(ke))return ke.replace(k,v)}else if(T.test(ke))return ke.replace(y,v);return ke}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ke){return ke.replace(s,function($e,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var n=/(^|[^\[])\^/g;function r(ke,$e){ke=typeof ke=="string"?ke:ke.source,$e=$e||"";var ge={replace:function(Y,he){return he=he.source||he,he=he.replace(n,"$1"),ke=ke.replace(Y,he),ge},getRegex:function(){return new RegExp(ke,$e)}};return ge}var t=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(ke,$e,ge){if(ke){var J;try{J=decodeURIComponent(o(ge)).replace(t,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}$e&&!a.test(ge)&&(ge=u($e,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var i={},b=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,f=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(ke,$e){i[" "+ke]||(b.test(ke)?i[" "+ke]=ke+"/":i[" "+ke]=g(ke,"/",!0)),ke=i[" "+ke];var ge=ke.indexOf(":")===-1;return $e.substring(0,2)==="//"?ge?$e:ke.replace(c,"$1")+$e:$e.charAt(0)==="/"?ge?$e:ke.replace(f,"$1")+$e:ke+$e}var S={exec:function(){}};function h(ke){for(var $e=1,ge,J;$e<arguments.length;$e++){ge=arguments[$e];for(J in ge)Object.prototype.hasOwnProperty.call(ge,J)&&(ke[J]=ge[J])}return ke}function E(ke,$e){var ge=ke.replace(/\|/g,function(he,le,Ne){for(var de=!1,Ce=le;--Ce>=0&&Ne[Ce]==="\\";)de=!de;return de?"|":" |"}),J=ge.split(/ \|/),Y=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>$e)J.splice($e);else for(;J.length<$e;)J.push("");for(;Y<J.length;Y++)J[Y]=J[Y].trim().replace(/\\\|/g,"|");return J}function g(ke,$e,ge){var J=ke.length;if(J===0)return"";for(var Y=0;Y<J;){var he=ke.charAt(J-Y-1);if(he===$e&&!ge)Y++;else if(he!==$e&&ge)Y++;else break}return ke.slice(0,J-Y)}function D(ke,$e){if(ke.indexOf($e[1])===-1)return-1;for(var ge=ke.length,J=0,Y=0;Y<ge;Y++)if(ke[Y]==="\\")Y++;else if(ke[Y]===$e[0])J++;else if(ke[Y]===$e[1]&&(J--,J<0))return Y;return-1}function w(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ke,$e){if($e<1)return"";for(var ge="";$e>1;)$e&1&&(ge+=ke),$e>>=1,ke+=ke;return ge+ke}function P(ke,$e,ge,J){var Y=$e.href,he=$e.title?m($e.title):null,le=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){J.state.inLink=!0;var Ne={type:"link",raw:ge,href:Y,title:he,text:le,tokens:J.inlineTokens(le)};return J.state.inLink=!1,Ne}return{type:"image",raw:ge,href:Y,title:he,text:m(le)}}function V(ke,$e){var ge=ke.match(/^(\s+)(?:```)/);if(ge===null)return $e;var J=ge[1];return $e.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var le=he[0];return le.length>=J.length?Y.slice(J.length):Y}).join(`
`)}var W=function(){function ke(ge){this.options=ge||fe.defaults}var $e=ke.prototype;return $e.space=function(J){var Y=this.rules.block.newline.exec(J);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},$e.code=function(J){var Y=this.rules.block.code.exec(J);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:g(he,`
`)}}},$e.fences=function(J){var Y=this.rules.block.fences.exec(J);if(Y){var he=Y[0],le=V(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:le}}},$e.heading=function(J){var Y=this.rules.block.heading.exec(J);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var le=g(he,"#");(this.options.pedantic||!le||/ $/.test(le))&&(he=le.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},$e.hr=function(J){var Y=this.rules.block.hr.exec(J);if(Y)return{type:"hr",raw:Y[0]}},$e.blockquote=function(J){var Y=this.rules.block.blockquote.exec(J);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},$e.list=function(J){var Y=this.rules.block.list.exec(J);if(Y){var he,le,Ne,de,Ce,Me,ze,z,L,G,H,ee,re=Y[1].trim(),Te=re.length>1,Be={type:"list",raw:"",ordered:Te,start:Te?+re.slice(0,-1):"",loose:!1,items:[]};re=Te?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Te?re:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ee=!1,!(!(Y=Qe.exec(J))||this.rules.block.hr.test(J)));){if(he=Y[0],J=J.substring(he.length),z=Y[2].split(`
`,1)[0],L=J.split(`
`,1)[0],this.options.pedantic?(de=2,H=z.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,H=z.slice(de),de+=Y[1].length),Me=!1,!z&&/^ *$/.test(L)&&(he+=L+`
`,J=J.substring(L.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");J&&(G=J.split(`
`,1)[0],z=G,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(z)||it.test(z)||_e.test(z)||et.test(J)));){if(z.search(/[^ ]/)>=de||!z.trim())H+=`
`+z.slice(de);else if(!Me)H+=`
`+z;else break;!Me&&!z.trim()&&(Me=!0),he+=G+`
`,J=J.substring(G.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(he)&&(ze=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(H),le&&(Ne=le[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!le,checked:Ne,loose:!1,text:H}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Ce=0;Ce<nt;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var at=Be.items[Ce].tokens.filter(function(je){return je.type==="space"}),mt=at.every(function(je){for(var st=je.raw.split(""),X=0,Z=O(st),me;!(me=Z()).done;){var He=me.value;if(He===`
`&&(X+=1),X>1)return!0}return!1});!Be.loose&&at.length&&mt&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},$e.html=function(J){var Y=this.rules.block.html.exec(J);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]);he.type="paragraph",he.text=le,he.tokens=this.lexer.inline(le)}return he}},$e.def=function(J){var Y=this.rules.block.def.exec(J);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},$e.table=function(J){var Y=this.rules.block.table.exec(J);if(Y){var he={type:"table",header:E(Y[1]).map(function(ze){return{text:ze}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var le=he.align.length,Ne,de,Ce,Me;for(Ne=0;Ne<le;Ne++)/^ *-+: *$/.test(he.align[Ne])?he.align[Ne]="right":/^ *:-+: *$/.test(he.align[Ne])?he.align[Ne]="center":/^ *:-+ *$/.test(he.align[Ne])?he.align[Ne]="left":he.align[Ne]=null;for(le=he.rows.length,Ne=0;Ne<le;Ne++)he.rows[Ne]=E(he.rows[Ne],he.header.length).map(function(ze){return{text:ze}});for(le=he.header.length,de=0;de<le;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(le=he.rows.length,de=0;de<le;de++)for(Me=he.rows[de],Ce=0;Ce<Me.length;Ce++)Me[Ce].tokens=this.lexer.inline(Me[Ce].text);return he}}},$e.lheading=function(J){var Y=this.rules.block.lheading.exec(J);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},$e.paragraph=function(J){var Y=this.rules.block.paragraph.exec(J);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},$e.text=function(J){var Y=this.rules.block.text.exec(J);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},$e.escape=function(J){var Y=this.rules.inline.escape.exec(J);if(Y)return{type:"escape",raw:Y[0],text:m(Y[1])}},$e.tag=function(J){var Y=this.rules.inline.tag.exec(J);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]}},$e.link=function(J){var Y=this.rules.inline.link.exec(J);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var le=g(he.slice(0,-1),"\\");if((he.length-le.length)%2===0)return}else{var Ne=D(Y[2],"()");if(Ne>-1){var de=Y[0].indexOf("!")===0?5:4,Ce=de+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Me=Y[2],ze="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);z&&(Me=z[1],ze=z[3])}else ze=Y[3]?Y[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(he)?Me=Me.slice(1):Me=Me.slice(1,-1)),P(Y,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},$e.reflink=function(J,Y){var he;if((he=this.rules.inline.reflink.exec(J))||(he=this.rules.inline.nolink.exec(J))){var le=(he[2]||he[1]).replace(/\s+/g," ");if(le=Y[le.toLowerCase()],!le||!le.href){var Ne=he[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return P(he,le,he[0],this.lexer)}},$e.emStrong=function(J,Y,he){he===void 0&&(he="");var le=this.rules.inline.emStrong.lDelim.exec(J);if(le&&!(le[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=le[1]||le[2]||"";if(!Ne||Ne&&(he===""||this.rules.inline.punctuation.exec(he))){var de=le[0].length-1,Ce,Me,ze=de,z=0,L=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(L.lastIndex=0,Y=Y.slice(-1*J.length+de);(le=L.exec(Y))!=null;)if(Ce=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!Ce){if(Me=Ce.length,le[3]||le[4]){ze+=Me;continue}else if((le[5]||le[6])&&de%3&&!((de+Me)%3)){z+=Me;continue}if(ze-=Me,!(ze>0)){if(Me=Math.min(Me,Me+ze+z),Math.min(de,Me)%2){var G=J.slice(1,de+le.index+Me);return{type:"em",raw:J.slice(0,de+le.index+Me+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=J.slice(2,de+le.index+Me-1);return{type:"strong",raw:J.slice(0,de+le.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},$e.codespan=function(J){var Y=this.rules.inline.code.exec(J);if(Y){var he=Y[2].replace(/\n/g," "),le=/[^ ]/.test(he),Ne=/^ /.test(he)&&/ $/.test(he);return le&&Ne&&(he=he.substring(1,he.length-1)),he=m(he,!0),{type:"codespan",raw:Y[0],text:he}}},$e.br=function(J){var Y=this.rules.inline.br.exec(J);if(Y)return{type:"br",raw:Y[0]}},$e.del=function(J){var Y=this.rules.inline.del.exec(J);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},$e.autolink=function(J,Y){var he=this.rules.inline.autolink.exec(J);if(he){var le,Ne;return he[2]==="@"?(le=m(this.options.mangle?Y(he[1]):he[1]),Ne="mailto:"+le):(le=m(he[1]),Ne=le),{type:"link",raw:he[0],text:le,href:Ne,tokens:[{type:"text",raw:le,text:le}]}}},$e.url=function(J,Y){var he;if(he=this.rules.inline.url.exec(J)){var le,Ne;if(he[2]==="@")le=m(this.options.mangle?Y(he[0]):he[0]),Ne="mailto:"+le;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);le=m(he[0]),he[1]==="www."?Ne="http://"+le:Ne=le}return{type:"link",raw:he[0],text:le,href:Ne,tokens:[{type:"text",raw:le,text:le}]}}},$e.inlineText=function(J,Y){var he=this.rules.inline.text.exec(J);if(he){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]):he[0]:le=m(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:le}}},ke}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=r(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=r(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=r(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=r(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=r(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=h({},q),q.gfm=h({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=r(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=h({},q.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:r(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=r(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=r(q._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=r(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=r(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=r(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=r(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=r(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=r(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=r(R.reflink).replace("label",R._label).replace("ref",q._label).getRegex(),R.nolink=r(R.nolink).replace("ref",q._label).getRegex(),R.reflinkSearch=r(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=h({},R),R.pedantic=h({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=h({},R.normal,{escape:r(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=r(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=h({},R.gfm,{br:r(R.br).replace("{2,}","*").getRegex(),text:r(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ke){var $e="",ge,J,Y=ke.length;for(ge=0;ge<Y;ge++)J=ke.charCodeAt(ge),Math.random()>.5&&(J="x"+J.toString(16)),$e+="&#"+J+";";return $e}var se=function(){function ke(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||fe.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:q.normal,inline:R.normal};this.options.pedantic?(J.block=q.pedantic,J.inline=R.pedantic):this.options.gfm&&(J.block=q.gfm,this.options.breaks?J.inline=R.breaks:J.inline=R.gfm),this.tokenizer.rules=J}ke.lex=function(J,Y){var he=new ke(Y);return he.lex(J)},ke.lexInline=function(J,Y){var he=new ke(Y);return he.inlineTokens(J)};var $e=ke.prototype;return $e.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},$e.blockTokens=function(J,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ze,z,L){return z+"    ".repeat(L.length)});for(var le,Ne,de,Ce;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(le=ze.call({lexer:he},J,Y))?(J=J.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.space(J)){J=J.substring(le.raw.length),le.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(le);continue}if(le=this.tokenizer.code(J)){J=J.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+le.raw,Ne.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(le);continue}if(le=this.tokenizer.fences(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.heading(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.hr(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.blockquote(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.list(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.html(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.def(J)){J=J.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+le.raw,Ne.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.lheading(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(de=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,z=J.slice(1),L=void 0;he.options.extensions.startBlock.forEach(function(G){L=G.call({lexer:this},z),typeof L=="number"&&L>=0&&(ze=Math.min(ze,L))}),ze<1/0&&ze>=0&&(de=J.substring(0,ze+1))}(),this.state.top&&(le=this.tokenizer.paragraph(de))){Ne=Y[Y.length-1],Ce&&Ne.type==="paragraph"?(Ne.raw+=`
`+le.raw,Ne.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(le),Ce=de.length!==J.length,J=J.substring(le.raw.length);continue}if(le=this.tokenizer.text(J)){J=J.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+le.raw,Ne.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(le);continue}if(J){var Me="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,Y},$e.inline=function(J,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:J,tokens:Y}),Y},$e.inlineTokens=function(J,Y){var he=this;Y===void 0&&(Y=[]);var le,Ne,de,Ce=J,Me,ze,z;if(this.tokens.links){var L=Object.keys(this.tokens.links);if(L.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)L.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ze||(z=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(le=H.call({lexer:he},J,Y))?(J=J.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.escape(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.tag(J)){J=J.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&le.type==="text"&&Ne.type==="text"?(Ne.raw+=le.raw,Ne.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.link(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&le.type==="text"&&Ne.type==="text"?(Ne.raw+=le.raw,Ne.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.emStrong(J,Ce,z)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.codespan(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.br(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.del(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.autolink(J,K)){J=J.substring(le.raw.length),Y.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(J,K))){J=J.substring(le.raw.length),Y.push(le);continue}if(de=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=J.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Te){re=Te.call({lexer:this},ee),typeof re=="number"&&re>=0&&(H=Math.min(H,re))}),H<1/0&&H>=0&&(de=J.substring(0,H+1))}(),le=this.tokenizer.inlineText(de,U)){J=J.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(z=le.raw.slice(-1)),ze=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=le.raw,Ne.text+=le.text):Y.push(le);continue}if(J){var G="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},I(ke,null,[{key:"rules",get:function(){return{block:q,inline:R}}}]),ke}(),ce=function(){function ke(ge){this.options=ge||fe.defaults}var $e=ke.prototype;return $e.code=function(J,Y,he){var le=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(J,le);Ne!=null&&Ne!==J&&(he=!0,J=Ne)}return J=J.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+m(le,!0)+'">'+(he?J:m(J,!0))+`</code></pre>
`:"<pre><code>"+(he?J:m(J,!0))+`</code></pre>
`},$e.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},$e.html=function(J){return J},$e.heading=function(J,Y,he,le){if(this.options.headerIds){var Ne=this.options.headerPrefix+le.slug(he);return"<h"+Y+' id="'+Ne+'">'+J+"</h"+Y+`>
`}return"<h"+Y+">"+J+"</h"+Y+`>
`},$e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$e.list=function(J,Y,he){var le=Y?"ol":"ul",Ne=Y&&he!==1?' start="'+he+'"':"";return"<"+le+Ne+`>
`+J+"</"+le+`>
`},$e.listitem=function(J){return"<li>"+J+`</li>
`},$e.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$e.paragraph=function(J){return"<p>"+J+`</p>
`},$e.table=function(J,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+Y+`</table>
`},$e.tablerow=function(J){return`<tr>
`+J+`</tr>
`},$e.tablecell=function(J,Y){var he=Y.header?"th":"td",le=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return le+J+("</"+he+`>
`)},$e.strong=function(J){return"<strong>"+J+"</strong>"},$e.em=function(J){return"<em>"+J+"</em>"},$e.codespan=function(J){return"<code>"+J+"</code>"},$e.br=function(){return this.options.xhtml?"<br/>":"<br>"},$e.del=function(J){return"<del>"+J+"</del>"},$e.link=function(J,Y,he){if(J=d(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var le='<a href="'+m(J)+'"';return Y&&(le+=' title="'+Y+'"'),le+=">"+he+"</a>",le},$e.image=function(J,Y,he){if(J=d(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var le='<img src="'+J+'" alt="'+he+'"';return Y&&(le+=' title="'+Y+'"'),le+=this.options.xhtml?"/>":">",le},$e.text=function(J){return J},ke}(),ve=function(){function ke(){}var $e=ke.prototype;return $e.strong=function(J){return J},$e.em=function(J){return J},$e.codespan=function(J){return J},$e.del=function(J){return J},$e.html=function(J){return J},$e.text=function(J){return J},$e.link=function(J,Y,he){return""+he},$e.image=function(J,Y,he){return""+he},$e.br=function(){return""},ke}(),Ie=function(){function ke(){this.seen={}}var $e=ke.prototype;return $e.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$e.getNextSafeSlug=function(J,Y){var he=J,le=0;if(this.seen.hasOwnProperty(he)){le=this.seen[J];do le++,he=J+"-"+le;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[J]=le,this.seen[he]=0),he},$e.slug=function(J,Y){Y===void 0&&(Y={});var he=this.serialize(J);return this.getNextSafeSlug(he,Y.dryrun)},ke}(),ue=function(){function ke(ge){this.options=ge||fe.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new Ie}ke.parse=function(J,Y){var he=new ke(Y);return he.parse(J)},ke.parseInline=function(J,Y){var he=new ke(Y);return he.parseInline(J)};var $e=ke.prototype;return $e.parse=function(J,Y){Y===void 0&&(Y=!0);var he="",le,Ne,de,Ce,Me,ze,z,L,G,H,ee,re,Te,Be,Qe,_e,et,tt,it,nt=J.length;for(le=0;le<nt;le++){if(H=J[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(it=this.options.extensions.renderers[H.type].call({parser:this},H),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=it||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(L="",z="",Ce=H.header.length,Ne=0;Ne<Ce;Ne++)z+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(L+=this.renderer.tablerow(z),G="",Ce=H.rows.length,Ne=0;Ne<Ce;Ne++){for(ze=H.rows[Ne],z="",Me=ze.length,de=0;de<Me;de++)z+=this.renderer.tablecell(this.parseInline(ze[de].tokens),{header:!1,align:H.align[de]});G+=this.renderer.tablerow(z)}he+=this.renderer.table(L,G);continue}case"blockquote":{G=this.parse(H.tokens),he+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,re=H.start,Te=H.loose,Ce=H.items.length,G="",Ne=0;Ne<Ce;Ne++)Qe=H.items[Ne],_e=Qe.checked,et=Qe.task,Be="",Qe.task&&(tt=this.renderer.checkbox(_e),Te?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=tt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=tt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:tt}):Be+=tt),Be+=this.parse(Qe.tokens,Te),G+=this.renderer.listitem(Be,et,_e);he+=this.renderer.list(G,ee,re);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;le+1<nt&&J[le+1].type==="text";)H=J[++le],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Y?this.renderer.paragraph(G):G;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return he},$e.parseInline=function(J,Y){Y=Y||this.renderer;var he="",le,Ne,de,Ce=J.length;for(le=0;le<Ce;le++){if(Ne=J[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(de=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){he+=de||"";continue}switch(Ne.type){case"escape":{he+=Y.text(Ne.text);break}case"html":{he+=Y.html(Ne.text);break}case"link":{he+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{he+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{he+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{he+=Y.codespan(Ne.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{he+=Y.text(Ne.text);break}default:{var Me='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return he},ke}();function be(ke,$e,ge){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof $e=="function"&&(ge=$e,$e=null),$e=h({},be.defaults,$e||{}),w($e),ge){var J=$e.highlight,Y;try{Y=se.lex(ke,$e)}catch(Ce){return ge(Ce)}var he=function(Me){var ze;if(!Me)try{$e.walkTokens&&be.walkTokens(Y,$e.walkTokens),ze=ue.parse(Y,$e)}catch(z){Me=z}return $e.highlight=J,Me?ge(Me):ge(null,ze)};if(!J||J.length<3||(delete $e.highlight,!Y.length))return he();var le=0;be.walkTokens(Y,function(Ce){Ce.type==="code"&&(le++,setTimeout(function(){J(Ce.text,Ce.lang,function(Me,ze){if(Me)return he(Me);ze!=null&&ze!==Ce.text&&(Ce.text=ze,Ce.escaped=!0),le--,le===0&&he()})},0))}),le===0&&he();return}function Ne(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+m(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=se.lex(ke,$e);if($e.walkTokens){if($e.async)return Promise.all(be.walkTokens(de,$e.walkTokens)).then(function(){return ue.parse(de,$e)}).catch(Ne);be.walkTokens(de,$e.walkTokens)}return ue.parse(de,$e)}catch(Ce){Ne(Ce)}}be.options=be.setOptions=function(ke){return h(be.defaults,ke),p(be.defaults),be},be.getDefaults=M,be.defaults=fe.defaults,be.use=function(){for(var ke=arguments.length,$e=new Array(ke),ge=0;ge<ke;ge++)$e[ge]=arguments[ge];var J=h.apply(void 0,[{}].concat($e)),Y=be.defaults.extensions||{renderers:{},childTokens:{}},he;$e.forEach(function(le){if(le.extensions&&(he=!0,le.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Y.renderers?Y.renderers[de.name]:null;Ce?Y.renderers[de.name]=function(){for(var Me=arguments.length,ze=new Array(Me),z=0;z<Me;z++)ze[z]=arguments[z];var L=de.renderer.apply(this,ze);return L===!1&&(L=Ce.apply(this,ze)),L}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),le.renderer&&function(){var de=be.defaults.renderer||new ce,Ce=function(z){var L=de[z];de[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=le.renderer[z].apply(de,H);return re===!1&&(re=L.apply(de,H)),re}};for(var Me in le.renderer)Ce(Me);J.renderer=de}(),le.tokenizer&&function(){var de=be.defaults.tokenizer||new W,Ce=function(z){var L=de[z];de[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=le.tokenizer[z].apply(de,H);return re===!1&&(re=L.apply(de,H)),re}};for(var Me in le.tokenizer)Ce(Me);J.tokenizer=de}(),le.walkTokens){var Ne=be.defaults.walkTokens;J.walkTokens=function(de){var Ce=[];return Ce.push(le.walkTokens.call(this,de)),Ne&&(Ce=Ce.concat(Ne.call(this,de))),Ce}}he&&(J.extensions=Y),be.setOptions(J)})},be.walkTokens=function(ke,$e){for(var ge=[],J=function(){var Ne=he.value;switch(ge=ge.concat($e.call(be,Ne)),Ne.type){case"table":{for(var de=O(Ne.header),Ce;!(Ce=de()).done;){var Me=Ce.value;ge=ge.concat(be.walkTokens(Me.tokens,$e))}for(var ze=O(Ne.rows),z;!(z=ze()).done;)for(var L=z.value,G=O(L),H;!(H=G()).done;){var ee=H.value;ge=ge.concat(be.walkTokens(ee.tokens,$e))}break}case"list":{ge=ge.concat(be.walkTokens(Ne.items,$e));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[Ne.type]?be.defaults.extensions.childTokens[Ne.type].forEach(function(re){ge=ge.concat(be.walkTokens(Ne[re],$e))}):Ne.tokens&&(ge=ge.concat(be.walkTokens(Ne.tokens,$e)))}},Y=O(ke),he;!(he=Y()).done;)J();return ge},be.parseInline=function(ke,$e){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");$e=h({},be.defaults,$e||{}),w($e);try{var ge=se.lexInline(ke,$e);return $e.walkTokens&&be.walkTokens(ge,$e.walkTokens),ue.parseInline(ge,$e)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+m(J.message+"",!0)+"</pre>";throw J}},be.Parser=ue,be.parser=ue.parse,be.Renderer=ce,be.TextRenderer=ve,be.Lexer=se,be.lexer=se.lex,be.Tokenizer=W,be.Slugger=Ie,be.parse=be;var ie=be.options,Pe=be.setOptions,Fe=be.use,ne=be.walkTokens,j=be.parseInline,x=be,pe=ue.parse,Oe=se.lex;fe.Lexer=se,fe.Parser=ue,fe.Renderer=ce,fe.Slugger=Ie,fe.TextRenderer=ve,fe.Tokenizer=W,fe.getDefaults=M,fe.lexer=Oe,fe.marked=be,fe.options=ie,fe.parse=x,fe.parseInline=j,fe.parser=pe,fe.setOptions=Pe,fe.use=Fe,fe.walkTokens=ne,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Ae[125],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=I;function I(s){const o=O(s);if(o&&o.length>0)return new Uint32Array(o)}let N=0;const A=new Uint32Array(10);function O(s){if(N=0,M(s,y,4352),N>0||(M(s,l,4449),N>0)||(M(s,v,4520),N>0)||(M(s,m,12593),N))return A.subarray(0,N);if(s>=44032&&s<=55203){const o=s-44032,n=o%588,r=Math.floor(o/588),t=Math.floor(n/28),a=n%28-1;if(r<y.length?M(r,y,0):4352+r-12593<m.length&&M(4352+r,m,12593),t<l.length?M(t,l,0):4449+t-12593<m.length&&M(4449+t-12593,m,12593),a>=0&&(a<v.length?M(a,v,0):4520+a-12593<m.length&&M(4520+a-12593,m,12593)),N>0)return A.subarray(0,N)}}function M(s,o,n){s>=n&&s<n+o.length&&p(o[s-n])}function p(s){s!==0&&(A[N++]=s&255,s>>8&&(A[N++]=s>>8&255),s>>16&&(A[N++]=s>>16&255))}var $;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var k;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(k||(k={}));var T;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(T||(T={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ae[126],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=I,e.rot=N;function I(p,$,k){return Math.min(Math.max(p,$),k)}function N(p,$){return($+p%$)%$}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=A;class O{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=O;class M{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const k=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=M}),function(){function fe(A){const O=[];typeof A=="number"&&O.push("code/timeOrigin",A);function M($){O.push($,Date.now())}function p(){const $=[];for(let k=0;k<O.length;k+=2)$.push({name:O[k],startTime:O[k+1]});return $}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(A+M.startTime)});return O}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function I(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),define(Ae[127],Re([1,0,40]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=void 0;const N=Symbol("unset");class A{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert($,k,T){this.d($,y=>y._value=k,T)}mutate($,k){this.d($,T=>T._value=k(T._value===N?void 0:T._value))}delete($){const k=this.c($);if(!k)return;let T=k.length-1;const y=k[T].node._value;if(y!==N){for(this.b--,k[T].node._value=N;T>0;T--){const{node:l,part:v}=k[T];if(l.children?.size||l._value!==N)break;k[T-1].node.children.delete(v)}return y}}*deleteRecursive($){const k=this.c($);if(!k)return;const T=k[k.length-1].node;for(let y=k.length-1;y>0;y--){const l=k[y-1];if(l.node.children.delete(k[y].part),l.node.children.size>0||l.node._value!==N)break}for(const y of O(T))y._value!==N&&(this.b--,yield y._value)}find($){let k=this.a;for(const T of $){const y=k.children?.get(T);if(!y)return;k=y}return k._value===N?void 0:k._value}hasKeyOrParent($){let k=this.a;for(const T of $){const y=k.children?.get(T);if(!y)return!1;if(y._value!==N)return!0;k=y}return!1}hasKeyOrChildren($){let k=this.a;for(const T of $){const y=k.children?.get(T);if(!y)return!1;k=y}return!0}hasKey($){let k=this.a;for(const T of $){const y=k.children?.get(T);if(!y)return!1;k=y}return k._value!==N}c($){const k=[{part:"",node:this.a}];let T=0;for(const y of $){const l=k[T].node.children?.get(y);if(!l)return;k.push({part:y,node:l}),T++}return k}d($,k,T){let y=this.a;for(const m of $){if(y.children)if(y.children.has(m))y=y.children.get(m);else{const s=new M;y.children.set(m,s),y=s}else{const s=new M;y.children=new Map([[m,s]]),y=s}T?.(y)}const l=y._value===N?0:1;k(y);const v=y._value===N?0:1;this.b+=v-l}*values(){for(const{_value:$}of O(this.a))$!==N&&(yield $)}}e.$4O=A;function*O(p){const $=[p];for(;$.length>0;){const k=$.pop();if(yield k,k.children)for(const T of k.children.values())$.push(T)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value($){this._value=$===void 0?N:$}}}),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:fe)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function I(N){if(e[N])return e[N].exports;var A=e[N]={i:N,l:!1,exports:{}};return fe[N].call(A.exports,A,A.exports,I),A.l=!0,A.exports}return I.m=fe,I.c=e,I.d=function(N,A,O){I.o(N,A)||Object.defineProperty(N,A,{enumerable:!0,get:O})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,A){if(1&A&&(N=I(N)),8&A||4&A&&typeof N=="object"&&N&&N.__esModule)return N;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:N}),2&A&&typeof N!="string")for(var M in N)I.d(O,M,function(p){return N[p]}.bind(null,M));return O},I.n=function(N){var A=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(A,"a",A),A},I.o=function(N,A){return Object.prototype.hasOwnProperty.call(N,A)},I.p="",I(I.s=0)}([function(fe,e,I){(function(N){var A;e=fe.exports=Fe,A=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var L=Array.prototype.slice.call(arguments,0);L.unshift("SEMVER"),console.log.apply(console,L)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],$=e.src=[],k=0,T=k++;$[T]="0|[1-9]\\d*";var y=k++;$[y]="[0-9]+";var l=k++;$[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=k++;$[v]="("+$[T]+")\\.("+$[T]+")\\.("+$[T]+")";var m=k++;$[m]="("+$[y]+")\\.("+$[y]+")\\.("+$[y]+")";var s=k++;$[s]="(?:"+$[T]+"|"+$[l]+")";var o=k++;$[o]="(?:"+$[y]+"|"+$[l]+")";var n=k++;$[n]="(?:-("+$[s]+"(?:\\."+$[s]+")*))";var r=k++;$[r]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var t=k++;$[t]="[0-9A-Za-z-]+";var a=k++;$[a]="(?:\\+("+$[t]+"(?:\\."+$[t]+")*))";var d=k++,i="v?"+$[v]+$[n]+"?"+$[a]+"?";$[d]="^"+i+"$";var b="[v=\\s]*"+$[m]+$[r]+"?"+$[a]+"?",c=k++;$[c]="^"+b+"$";var f=k++;$[f]="((?:<|>)?=?)";var u=k++;$[u]=$[y]+"|x|X|\\*";var S=k++;$[S]=$[T]+"|x|X|\\*";var h=k++;$[h]="[v=\\s]*("+$[S]+")(?:\\.("+$[S]+")(?:\\.("+$[S]+")(?:"+$[n]+")?"+$[a]+"?)?)?";var E=k++;$[E]="[v=\\s]*("+$[u]+")(?:\\.("+$[u]+")(?:\\.("+$[u]+")(?:"+$[r]+")?"+$[a]+"?)?)?";var g=k++;$[g]="^"+$[f]+"\\s*"+$[h]+"$";var D=k++;$[D]="^"+$[f]+"\\s*"+$[E]+"$";var w=k++;$[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=k++;$[C]="(?:~>?)";var P=k++;$[P]="(\\s*)"+$[C]+"\\s+",p[P]=new RegExp($[P],"g");var V=k++;$[V]="^"+$[C]+$[h]+"$";var W=k++;$[W]="^"+$[C]+$[E]+"$";var q=k++;$[q]="(?:\\^)";var R=k++;$[R]="(\\s*)"+$[q]+"\\s+",p[R]=new RegExp($[R],"g");var U=k++;$[U]="^"+$[q]+$[h]+"$";var K=k++;$[K]="^"+$[q]+$[E]+"$";var se=k++;$[se]="^"+$[f]+"\\s*("+b+")$|^$";var ce=k++;$[ce]="^"+$[f]+"\\s*("+i+")$|^$";var ve=k++;$[ve]="(\\s*)"+$[f]+"\\s*("+b+"|"+$[h]+")",p[ve]=new RegExp($[ve],"g");var Ie=k++;$[Ie]="^\\s*("+$[h]+")\\s+-\\s+("+$[h]+")\\s*$";var ue=k++;$[ue]="^\\s*("+$[E]+")\\s+-\\s+("+$[E]+")\\s*$";var be=k++;$[be]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)A(ie,$[ie]),p[ie]||(p[ie]=new RegExp($[ie]));function Pe(L,G){if(L instanceof Fe)return L;if(typeof L!="string"||L.length>O||!(G?p[c]:p[d]).test(L))return null;try{return new Fe(L,G)}catch{return null}}function Fe(L,G){if(L instanceof Fe){if(L.loose===G)return L;L=L.version}else if(typeof L!="string")throw new TypeError("Invalid Version: "+L);if(L.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Fe))return new Fe(L,G);A("SemVer",L,G),this.loose=G;var H=L.trim().match(G?p[c]:p[d]);if(!H)throw new TypeError("Invalid Version: "+L);if(this.raw=L,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<M)return re}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=Pe,e.valid=function(L,G){var H=Pe(L,G);return H?H.version:null},e.clean=function(L,G){var H=Pe(L.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Fe,Fe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Fe.prototype.toString=function(){return this.version},Fe.prototype.compare=function(L){return A("SemVer.compare",this.version,this.loose,L),L instanceof Fe||(L=new Fe(L,this.loose)),this.compareMain(L)||this.comparePre(L)},Fe.prototype.compareMain=function(L){return L instanceof Fe||(L=new Fe(L,this.loose)),j(this.major,L.major)||j(this.minor,L.minor)||j(this.patch,L.patch)},Fe.prototype.comparePre=function(L){if(L instanceof Fe||(L=new Fe(L,this.loose)),this.prerelease.length&&!L.prerelease.length)return-1;if(!this.prerelease.length&&L.prerelease.length)return 1;if(!this.prerelease.length&&!L.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=L.prerelease[G];if(A("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return j(H,ee)}while(++G)},Fe.prototype.inc=function(L,G){switch(L){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+L)}return this.format(),this.raw=this.version,this},e.inc=function(L,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Fe(L,H).inc(G,ee).version}catch{return null}},e.diff=function(L,G){if(ke(L,G))return null;var H=Pe(L),ee=Pe(G);if(H.prerelease.length||ee.prerelease.length){for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return re},e.compareIdentifiers=j;var ne=/^[0-9]+$/;function j(L,G){var H=ne.test(L),ee=ne.test(G);return H&&ee&&(L=+L,G=+G),H&&!ee?-1:ee&&!H?1:L<G?-1:L>G?1:0}function x(L,G,H){return new Fe(L,H).compare(new Fe(G,H))}function pe(L,G,H){return x(L,G,H)>0}function Oe(L,G,H){return x(L,G,H)<0}function ke(L,G,H){return x(L,G,H)===0}function $e(L,G,H){return x(L,G,H)!==0}function ge(L,G,H){return x(L,G,H)>=0}function J(L,G,H){return x(L,G,H)<=0}function Y(L,G,H,ee){var re;switch(G){case"===":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L===H;break;case"!==":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L!==H;break;case"":case"=":case"==":re=ke(L,H,ee);break;case"!=":re=$e(L,H,ee);break;case">":re=pe(L,H,ee);break;case">=":re=ge(L,H,ee);break;case"<":re=Oe(L,H,ee);break;case"<=":re=J(L,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return re}function he(L,G){if(L instanceof he){if(L.loose===G)return L;L=L.value}if(!(this instanceof he))return new he(L,G);A("comparator",L,G),this.loose=G,this.parse(L),this.semver===le?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(L,G){return j(G,L)},e.major=function(L,G){return new Fe(L,G).major},e.minor=function(L,G){return new Fe(L,G).minor},e.patch=function(L,G){return new Fe(L,G).patch},e.compare=x,e.compareLoose=function(L,G){return x(L,G,!0)},e.rcompare=function(L,G,H){return x(G,L,H)},e.sort=function(L,G){return L.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(L,G){return L.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=pe,e.lt=Oe,e.eq=ke,e.neq=$e,e.gte=ge,e.lte=J,e.cmp=Y,e.Comparator=he;var le={};function Ne(L,G){if(L instanceof Ne)return L.loose===G?L:new Ne(L.raw,G);if(L instanceof he)return new Ne(L.value,G);if(!(this instanceof Ne))return new Ne(L,G);if(this.loose=G,this.raw=L,this.set=L.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+L);this.format()}function de(L){return!L||L.toLowerCase()==="x"||L==="*"}function Ce(L,G,H,ee,re,Te,Be,Qe,_e,et,tt,it,nt){return((G=de(H)?"":de(ee)?">="+H+".0.0":de(re)?">="+H+"."+ee+".0":">="+G)+" "+(Qe=de(_e)?"":de(et)?"<"+(+_e+1)+".0.0":de(tt)?"<"+_e+"."+(+et+1)+".0":it?"<="+_e+"."+et+"."+tt+"-"+it:"<="+Qe)).trim()}function Me(L,G){for(var H=0;H<L.length;H++)if(!L[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<L.length;H++)if(A(L[H].semver),L[H].semver!==le&&L[H].semver.prerelease.length>0){var ee=L[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function ze(L,G,H){try{G=new Ne(G,H)}catch{return!1}return G.test(L)}function z(L,G,H,ee){var re,Te,Be,Qe,_e;switch(L=new Fe(L,ee),G=new Ne(G,ee),H){case">":re=pe,Te=J,Be=Oe,Qe=">",_e=">=";break;case"<":re=Oe,Te=ge,Be=pe,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(L,G,ee))return!1;for(var et=0;et<G.set.length;++et){var tt=G.set[et],it=null,nt=null;if(tt.forEach(function(at){at.semver===le&&(at=new he(">=0.0.0")),it=it||at,nt=nt||at,re(at.semver,it.semver,ee)?it=at:Be(at.semver,nt.semver,ee)&&(nt=at)}),it.operator===Qe||it.operator===_e||(!nt.operator||nt.operator===Qe)&&Te(L,nt.semver)||nt.operator===_e&&Be(L,nt.semver))return!1}return!0}he.prototype.parse=function(L){var G=this.loose?p[se]:p[ce],H=L.match(G);if(!H)throw new TypeError("Invalid comparator: "+L);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Fe(H[2],this.loose):this.semver=le},he.prototype.toString=function(){return this.value},he.prototype.test=function(L){return A("Comparator.test",L,this.loose),this.semver===le||(typeof L=="string"&&(L=new Fe(L,this.loose)),Y(L,this.operator,this.semver,this.loose))},he.prototype.intersects=function(L,G){if(!(L instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(L.value,G),ze(this.value,H,G);if(L.operator==="")return H=new Ne(this.value,G),ze(L.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||L.operator!==">="&&L.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||L.operator!=="<="&&L.operator!=="<"),Te=this.semver.version===L.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||L.operator!==">="&&L.operator!=="<="),Qe=Y(this.semver,"<",L.semver,G)&&(this.operator===">="||this.operator===">")&&(L.operator==="<="||L.operator==="<"),_e=Y(this.semver,">",L.semver,G)&&(this.operator==="<="||this.operator==="<")&&(L.operator===">="||L.operator===">");return ee||re||Te&&Be||Qe||_e},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(L){return L.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(L){var G=this.loose;L=L.trim(),A("range",L,G);var H=G?p[ue]:p[Ie];L=L.replace(H,Ce),A("hyphen replace",L),L=L.replace(p[ve],"$1$2$3"),A("comparator trim",L,p[ve]),L=(L=(L=L.replace(p[P],"$1~")).replace(p[R],"$1^")).split(/\s+/).join(" ");var ee=G?p[se]:p[ce],re=L.split(" ").map(function(Te){return function(Be,Qe){return A("comp",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){A("caret",it,nt);var at=nt?p[K]:p[U];return it.replace(at,function(mt,je,st,X,Z){var me;return A("caret",it,mt,je,st,X,Z),de(je)?me="":de(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":de(X)?me=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Z?(A("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+Z+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+Z+" <"+(+je+1)+".0.0"):(A("no pr"),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+" <"+(+je+1)+".0.0"),A("caret return",me),me})}(tt,et)}).join(" ")}(Be,Qe),A("caret",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){var at=nt?p[W]:p[V];return it.replace(at,function(mt,je,st,X,Z){var me;return A("tilde",it,mt,je,st,X,Z),de(je)?me="":de(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":de(X)?me=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Z?(A("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0"):me=">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0",A("tilde return",me),me})}(tt,et)}).join(" ")}(Be,Qe),A("tildes",Be),Be=function(_e,et){return A("replaceXRanges",_e,et),_e.split(/\s+/).map(function(tt){return function(it,nt){it=it.trim();var at=nt?p[D]:p[g];return it.replace(at,function(mt,je,st,X,Z,me){A("xRange",it,mt,je,st,X,Z,me);var He=de(st),ye=He||de(X),ot=ye||de(Z);return je==="="&&ot&&(je=""),He?mt=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(ye&&(X=0),ot&&(Z=0),je===">"?(je=">=",ye?(st=+st+1,X=0,Z=0):ot&&(X=+X+1,Z=0)):je==="<="&&(je="<",ye?st=+st+1:X=+X+1),mt=je+st+"."+X+"."+Z):ye?mt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(mt=">="+st+"."+X+".0 <"+st+"."+(+X+1)+".0"),A("xRange return",mt),mt})}(tt,et)}).join(" ")}(Be,Qe),A("xrange",Be),Be=function(_e,et){return A("replaceStars",_e,et),_e.trim().replace(p[be],"")}(Be,Qe),A("stars",Be),Be}(Te,G)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Te){return!!Te.match(ee)})),re=re.map(function(Te){return new he(Te,G)})},Ne.prototype.intersects=function(L,G){if(!(L instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return L.set.some(function(re){return re.every(function(Te){return ee.intersects(Te,G)})})})})},e.toComparators=function(L,G){return new Ne(L,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(L){if(!L)return!1;typeof L=="string"&&(L=new Fe(L,this.loose));for(var G=0;G<this.set.length;G++)if(Me(this.set[G],L))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(L,G,H){var ee=null,re=null;try{var Te=new Ne(G,H)}catch{return null}return L.forEach(function(Be){Te.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Fe(ee=Be,H)))}),ee},e.minSatisfying=function(L,G,H){var ee=null,re=null;try{var Te=new Ne(G,H)}catch{return null}return L.forEach(function(Be){Te.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Fe(ee=Be,H)))}),ee},e.validRange=function(L,G){try{return new Ne(L,G).range||"*"}catch{return null}},e.ltr=function(L,G,H){return z(L,G,"<",H)},e.gtr=function(L,G,H){return z(L,G,">",H)},e.outside=z,e.prerelease=function(L,G){var H=Pe(L,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(L,G,H){return L=new Ne(L,H),G=new Ne(G,H),L.intersects(G)},e.coerce=function(L){if(L instanceof Fe)return L;if(typeof L!="string")return null;var G=L.match(p[w]);return G==null?null:Pe((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(fe,e){var I,N,A=fe.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(o){if(I===setTimeout)return setTimeout(o,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var $,k=[],T=!1,y=-1;function l(){T&&$&&(T=!1,$.length?k=$.concat(k):y=-1,k.length&&v())}function v(){if(!T){var o=p(l);T=!0;for(var n=k.length;n;){for($=k,k=[];++y<n;)$&&$[y].run();y=-1,n=k.length}$=null,T=!1,function(r){if(N===clearTimeout)return clearTimeout(r);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(r);try{N(r)}catch{try{return N.call(null,r)}catch{return N.call(this,r)}}}(o)}}function m(o,n){this.fun=o,this.array=n}function s(){}A.nextTick=function(o){var n=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)n[r-1]=arguments[r];k.push(new m(o,n)),k.length!==1||T||p(v)},m.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=s,A.addListener=s,A.once=s,A.off=s,A.removeListener=s,A.removeAllListeners=s,A.emit=s,A.prependListener=s,A.prependOnceListener=s,A.listeners=function(o){return[]},A.binding=function(o){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(o){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Ae[128],Re([1,0,14,6]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=A,e.$oe=O,e.$pe=M,e.$qe=p,e.$re=k,e.$se=T,e.$te=y,e.$ue=l,e.$ve=v,e.$we=m,e.$xe=s,e.$ye=o,e.$ze=n,e.$Ae=r,e.$Be=t;function A(a){const d=a;return d?typeof d.read=="function":!1}function O(a){const d=a;return d?[d.on,d.pause,d.resume,d.destroy].every(i=>typeof i=="function"):!1}function M(a){const d=a;return d?O(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}function p(a,d){return new $(a,d)}class ${constructor(d,i){this.e=d,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(i=>i(d))}h(d){this.c.error.length===0?(0,I.$1)(d):this.c.error.slice(0).forEach(i=>i(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,i){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(d,i){if(this.a.destroyed)return;let b;switch(d){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const c=b.indexOf(i);c>=0&&b.splice(c,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(a,d){const i=[];let b;for(;(b=a.read())!==null;)i.push(b);return d(i)}function T(a,d,i){const b=[];let c;for(;(c=a.read())!==null&&b.length<i;)b.push(c);return c===null&&b.length>0?d(b):{read:()=>{if(b.length>0)return b.shift();if(typeof c<"u"){const f=c;return c=void 0,f}return a.read()}}}function y(a,d){return new Promise((i,b)=>{const c=[];l(a,{onData:f=>{d&&c.push(f)},onError:f=>{d?b(f):i(void 0)},onEnd:()=>{i(d?d(c):void 0)}})})}function l(a,d,i){a.on("error",b=>{i?.isCancellationRequested||d.onError(b)}),a.on("end",()=>{i?.isCancellationRequested||d.onEnd()}),a.on("data",b=>{i?.isCancellationRequested||d.onData(b)})}function v(a,d){return new Promise((i,b)=>{const c=new N.$Tc,f=[],u=E=>{if(f.push(E),f.length>d)return c.dispose(),a.pause(),i({stream:a,buffer:f,ended:!1})},S=E=>(c.dispose(),b(E)),h=()=>(c.dispose(),i({stream:a,buffer:f,ended:!0}));c.add((0,N.$Sc)(()=>a.removeListener("error",S))),a.on("error",S),c.add((0,N.$Sc)(()=>a.removeListener("end",h))),a.on("end",h),c.add((0,N.$Sc)(()=>a.removeListener("data",u))),a.on("data",u)})}function m(a,d){const i=p(d);return i.end(a),i}function s(){const a=p(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let d=!1;return{read:()=>d?null:(d=!0,a)}}function n(a,d,i){const b=p(i);return l(a,{onData:c=>b.write(d.data(c)),onError:c=>b.error(d.error?d.error(c):c),onEnd:()=>b.end()}),b}function r(a,d,i){let b=!1;return{read:()=>{const c=d.read();return b?c:(b=!0,c!==null?i([a,c]):a)}}}function t(a,d,i){let b=!1;const c=p(i);return l(d,{onData:f=>b?c.write(f):(b=!0,c.write(i([a,f]))),onError:f=>c.error(f),onEnd:()=>{b||(b=!0,c.write(a)),c.end()}}),c}}),define(Ae[23],Re([1,0,41,128]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=k,e.$Ee=T,e.$Fe=y,e.$Ge=l,e.$He=v,e.$Ie=m,e.$Je=s,e.$Ke=o,e.$Le=n,e.$Me=r,e.$Ne=t,e.$Oe=a,e.$Pe=d,e.$Qe=i,e.$Re=b,e.$Se=c,e.$Te=f,e.$Ue=u,e.$Ve=S,e.$We=g;const A=typeof Buffer<"u",O=new I.$V(()=>new Uint8Array(256));let M,p;class ${static alloc(w){return A?new $(Buffer.allocUnsafe(w)):new $(new Uint8Array(w))}static wrap(w){return A&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new $(w)}static fromString(w,C){return!(C?.dontUseNodeBuffer||!1)&&A?new $(Buffer.from(w)):(M||(M=new TextEncoder),new $(M.encode(w)))}static fromByteArray(w){const C=$.alloc(w.length);for(let P=0,V=w.length;P<V;P++)C.buffer[P]=w[P];return C}static concat(w,C){if(typeof C>"u"){C=0;for(let W=0,q=w.length;W<q;W++)C+=w[W].byteLength}const P=$.alloc(C);let V=0;for(let W=0,q=w.length;W<q;W++){const R=w[W];P.set(R,V),V+=R.byteLength}return P}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=$.alloc(this.byteLength);return w.set(this),w}toString(){return A?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(w,C){return new $(this.buffer.subarray(w,C))}set(w,C){if(w instanceof $)this.buffer.set(w.buffer,C);else if(w instanceof Uint8Array)this.buffer.set(w,C);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),C);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return l(this.buffer,w)}writeUInt32BE(w,C){v(this.buffer,w,C)}readUInt32LE(w){return m(this.buffer,w)}writeUInt32LE(w,C){s(this.buffer,w,C)}readUInt8(w){return o(this.buffer,w)}writeUInt8(w,C){n(this.buffer,w,C)}indexOf(w,C=0){return k(this.buffer,w instanceof $?w.buffer:w,C)}}e.$Ce=$;function k(D,w,C=0){const P=w.byteLength,V=D.byteLength;if(P===0)return 0;if(P===1)return D.indexOf(w[0]);if(P>V-C)return-1;const W=O.value;W.fill(w.length);for(let K=0;K<w.length;K++)W[w[K]]=w.length-K-1;let q=C+w.length-1,R=q,U=-1;for(;q<V;)if(D[q]===w[R]){if(R===0){U=q;break}q--,R--}else q+=Math.max(w.length-R,W[D[q]]),R=w.length-1;return U}function T(D,w){return D[w+0]<<0>>>0|D[w+1]<<8>>>0}function y(D,w,C){D[C+0]=w&255,w=w>>>8,D[C+1]=w&255}function l(D,w){return D[w]*2**24+D[w+1]*2**16+D[w+2]*2**8+D[w+3]}function v(D,w,C){D[C+3]=w,w=w>>>8,D[C+2]=w,w=w>>>8,D[C+1]=w,w=w>>>8,D[C]=w}function m(D,w){return D[w+0]<<0>>>0|D[w+1]<<8>>>0|D[w+2]<<16>>>0|D[w+3]<<24>>>0}function s(D,w,C){D[C+0]=w&255,w=w>>>8,D[C+1]=w&255,w=w>>>8,D[C+2]=w&255,w=w>>>8,D[C+3]=w&255}function o(D,w){return D[w]}function n(D,w,C){D[C]=w}function r(D){return N.$re(D,w=>$.concat(w))}function t(D){return N.$ye(D)}function a(D){return N.$te(D,w=>$.concat(w))}async function d(D){return D.ended?$.concat(D.buffer):$.concat([...D.buffer,await a(D.stream)])}function i(D){return N.$we(D,w=>$.concat(w))}function b(D){return N.$ze(D,{data:w=>typeof w=="string"?$.fromString(w):$.wrap(w)},w=>$.concat(w))}function c(D){return N.$qe(w=>$.concat(w),D)}function f(D,w){return N.$Ae(D,w,C=>$.concat(C))}function u(D,w){return N.$Be(D,w,C=>$.concat(C))}function S(D){let w=0,C=0,P=0;const V=new Uint8Array(Math.floor(D.length/4*3)),W=R=>{switch(C){case 3:V[P++]=w|R,C=0;break;case 2:V[P++]=w|R>>>2,w=R<<6,C=3;break;case 1:V[P++]=w|R>>>4,w=R<<4,C=2;break;default:w=R<<2,C=1}};for(let R=0;R<D.length;R++){const U=D.charCodeAt(R);if(U>=65&&U<=90)W(U-65);else if(U>=97&&U<=122)W(U-97+26);else if(U>=48&&U<=57)W(U-48+52);else if(U===43||U===45)W(62);else if(U===47||U===95)W(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${D[R]}`)}}const q=P;for(;C>0;)W(0);return $.wrap(V).slice(0,q)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:D},w=!0,C=!1){const P=C?E:h;let V="";const W=D.byteLength%3;let q=0;for(;q<D.byteLength-W;q+=3){const R=D[q+0],U=D[q+1],K=D[q+2];V+=P[R>>>2],V+=P[(R<<4|U>>>4)&63],V+=P[(U<<2|K>>>6)&63],V+=P[K&63]}if(W===1){const R=D[q+0];V+=P[R>>>2],V+=P[R<<4&63],w&&(V+="==")}else if(W===2){const R=D[q+0],U=D[q+1];V+=P[R>>>2],V+=P[(R<<4|U>>>4)&63],V+=P[U<<2&63],w&&(V+="=")}return V}}),define(Ae[129],Re([1,0,28,125,15]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.FuzzyScore=e.$sk=e.$rk=void 0,e.or=O,e.$tk=p,e.$uk=$,e.$vk=y,e.$wk=S,e.$xk=h,e.$yk=P,e.$zk=V,e.$Ak=W,e.$Bk=q,e.$Ck=x,e.$Ek=$e,e.$Fk=Y,e.$Gk=he;function O(...de){return function(Ce,Me){for(let ze=0,z=de.length;ze<z;ze++){const L=de[ze](Ce,Me);if(L)return L}return null}}e.$rk=M.bind(void 0,!1),e.$sk=M.bind(void 0,!0);function M(de,Ce,Me){if(!Me||Me.length<Ce.length)return null;let ze;return de?ze=A.$uf(Me,Ce):ze=Me.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function p(de,Ce){const Me=Ce.toLowerCase().indexOf(de.toLowerCase());return Me===-1?null:[{start:Me,end:Me+de.length}]}function $(de,Ce){return k(de.toLowerCase(),Ce.toLowerCase(),0,0)}function k(de,Ce,Me,ze){if(Me===de.length)return[];if(ze===Ce.length)return null;if(de[Me]===Ce[ze]){let z=null;return(z=k(de,Ce,Me+1,ze+1))?a({start:ze,end:ze+1},z):null}return k(de,Ce,Me,ze+1)}function T(de){return 97<=de&&de<=122}function y(de){return 65<=de&&de<=90}function l(de){return 48<=de&&de<=57}function v(de){return de===32||de===9||de===10||de===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>m.add(de.charCodeAt(0)));function s(de){return v(de)||m.has(de)}function o(de,Ce){return de===Ce||s(de)&&s(Ce)}const n=new Map;function r(de){if(n.has(de))return n.get(de);let Ce;const Me=(0,N.$pk)(de);return Me&&(Ce=Me),n.set(de,Ce),Ce}function t(de){return T(de)||y(de)||l(de)}function a(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function d(de,Ce){for(let Me=Ce;Me<de.length;Me++){const ze=de.charCodeAt(Me);if(y(ze)||l(ze)||Me>0&&!t(de.charCodeAt(Me-1)))return Me}return de.length}function i(de,Ce,Me,ze){if(Me===de.length)return[];if(ze===Ce.length)return null;if(de[Me]!==Ce[ze].toLowerCase())return null;{let z=null,L=ze+1;for(z=i(de,Ce,Me+1,ze+1);!z&&(L=d(Ce,L))<Ce.length;)z=i(de,Ce,Me+1,L),L++;return z===null?null:a({start:ze,end:ze+1},z)}}function b(de){let Ce=0,Me=0,ze=0,z=0,L=0;for(let Te=0;Te<de.length;Te++)L=de.charCodeAt(Te),y(L)&&Ce++,T(L)&&Me++,t(L)&&ze++,l(L)&&z++;const G=Ce/de.length,H=Me/de.length,ee=ze/de.length,re=z/de.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:re}}function c(de){const{upperPercent:Ce,lowerPercent:Me}=de;return Me===0&&Ce>.6}function f(de){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:ze,numericPercent:z}=de;return Me>.2&&Ce<.8&&ze>.6&&z<.2}function u(de){let Ce=0,Me=0,ze=0,z=0;for(let L=0;L<de.length;L++)ze=de.charCodeAt(L),y(ze)&&Ce++,T(ze)&&Me++,v(ze)&&z++;return(Ce===0||Me===0)&&z===0?de.length<=30:Ce<=5}function S(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!u(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Me=b(Ce);if(!f(Me)){if(!c(Me))return null;Ce=Ce.toLowerCase()}let ze=null,z=0;for(de=de.toLowerCase();z<Ce.length&&(ze=i(de,Ce,0,z))===null;)z=d(Ce,z+1);return ze}function h(de,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let ze=null,z=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();z<Ce.length&&(ze=E(de,Ce,0,z,Me),ze===null);)z=g(Ce,z+1);return ze}function E(de,Ce,Me,ze,z){let L=0;if(Me===de.length)return[];if(ze===Ce.length)return null;if(!o(de.charCodeAt(Me),Ce.charCodeAt(ze))){const ee=r(de.charCodeAt(Me));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!o(ee[re],Ce.charCodeAt(ze+re)))return null;L+=ee.length-1}let G=null,H=ze+L+1;if(G=E(de,Ce,Me+1,H,z),!z)for(;!G&&(H=g(Ce,H))<Ce.length;)G=E(de,Ce,Me+1,H,z),H++;if(!G)return null;if(de.charCodeAt(Me)!==Ce.charCodeAt(ze)){const ee=r(de.charCodeAt(Me));if(!ee)return G;for(let re=0;re<ee.length;re++)if(ee[re]!==Ce.charCodeAt(ze+re))return G}return a({start:ze,end:ze+L+1},G)}function g(de,Ce){for(let Me=Ce;Me<de.length;Me++)if(s(de.charCodeAt(Me))||Me>0&&s(de.charCodeAt(Me-1)))return Me;return de.length}const D=O(e.$sk,S,p),w=O(e.$sk,S,$),C=new I.$Ec(1e4);function P(de,Ce,Me=!1){if(typeof de!="string"||typeof Ce!="string")return null;let ze=C.get(de);ze||(ze=new RegExp(A.$cf(de),"i"),C.set(de,ze));const z=ze.exec(Ce);return z?[{start:z.index,end:z.index+z[0].length}]:Me?w(de,Ce):D(de,Ce)}function V(de,Ce){const Me=$e(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?q(Me):null}function W(de,Ce,Me,ze,z,L){const G=Math.min(13,de.length);for(;Me<G;Me++){const H=$e(de,Ce,Me,ze,z,L,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,L]}function q(de){if(typeof de>"u")return[];const Ce=[],Me=de[1];for(let ze=de.length-1;ze>1;ze--){const z=de[ze]+Me,L=Ce[Ce.length-1];L&&L.end===z?L.end=z+1:Ce.push({start:z,end:z+1})}return Ce}const R=128;function U(){const de=[],Ce=[];for(let Me=0;Me<=R;Me++)Ce[Me]=0;for(let Me=0;Me<=R;Me++)de.push(Ce.slice(0));return de}function K(de){const Ce=[];for(let Me=0;Me<=de;Me++)Ce[Me]=0;return Ce}const se=K(2*R),ce=K(2*R),ve=U(),Ie=U(),ue=U(),be=!1;function ie(de,Ce,Me,ze,z){function L(H,ee,re=" "){for(;H.length<ee;)H=re+H;return H}let G=` |   |${ze.split("").map(H=>L(H,3)).join("|")}
`;for(let H=0;H<=Me;H++)H===0?G+=" |":G+=`${Ce[H-1]}|`,G+=de[H].slice(0,z+1).map(ee=>L(ee.toString(),3)).join("|")+`
`;return G}function Pe(de,Ce,Me,ze){de=de.substr(Ce),Me=Me.substr(ze),console.log(ie(Ie,de,de.length,Me,Me.length)),console.log(ie(ue,de,de.length,Me,Me.length)),console.log(ie(ve,de,de.length,Me,Me.length))}function Fe(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Me=de.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.$Mf(Me)}}function ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function j(de,Ce,Me){return Ce[de]!==Me[de]}function x(de,Ce,Me,ze,z,L,G=!1){for(;Ce<Me&&z<L;)de[Ce]===ze[z]&&(G&&(se[Ce]=z),Ce+=1),z+=1;return Ce===Me}var pe;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Oe;(function(de){de.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}de.isDefault=Ce})(Oe||(e.FuzzyScore=Oe={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Me){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Me}}e.$Dk=ke;function $e(de,Ce,Me,ze,z,L,G=ke.default){const H=de.length>R?R:de.length,ee=ze.length>R?R:ze.length;if(Me>=H||L>=ee||H-Me>ee-L||!x(Ce,Me,H,z,L,ee,!0))return;ge(H,ee,Me,L,Ce,z);let re=1,Te=1,Be=Me,Qe=L;const _e=[!1];for(re=1,Be=Me;Be<H;re++,Be++){const at=se[Be],mt=ce[Be],je=Be+1<H?ce[Be+1]:ee;for(Te=at-L+1,Qe=at;Qe<je;Te++,Qe++){let st=Number.MIN_SAFE_INTEGER,X=!1;Qe<=mt&&(st=J(de,Ce,Be,Me,ze,z,Qe,ee,L,ve[re-1][Te-1]===0,_e));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=st+Ie[re-1][Te-1]);const me=Qe>at,He=me?Ie[re][Te-1]+(ve[re][Te-1]>0?-5:0):0,ye=Qe>at+1&&ve[re][Te-1]>0,ot=ye?Ie[re][Te-2]+(ve[re][Te-2]>0?-5:0):0;if(ye&&(!me||ot>=He)&&(!X||ot>=Z))Ie[re][Te]=ot,ue[re][Te]=3,ve[re][Te]=0;else if(me&&(!X||He>=Z))Ie[re][Te]=He,ue[re][Te]=2,ve[re][Te]=0;else if(X)Ie[re][Te]=Z,ue[re][Te]=1,ve[re][Te]=ve[re-1][Te-1]+1;else throw new Error("not possible")}}if(be&&Pe(de,Me,ze,L),!_e[0]&&!G.firstMatchCanBeWeak)return;re--,Te--;const et=[Ie[re][Te],L];let tt=0,it=0;for(;re>=1;){let at=Te;do{const mt=ue[re][at];if(mt===3)at=at-2;else if(mt===2)at=at-1;else break}while(at>=1);tt>1&&Ce[Me+re-1]===z[L+Te-1]&&!j(at+L-1,ze,z)&&tt+1>ve[re][at]&&(at=Te),at===Te?tt++:tt=1,it||(it=at),re--,Te=at-1,et.push(Te)}ee===H&&G.boostFullMatch&&(et[0]+=2);const nt=it-H;return et[0]-=nt,et}function ge(de,Ce,Me,ze,z,L){let G=de-1,H=Ce-1;for(;G>=Me&&H>=ze;)z[G]===L[H]&&(ce[G]=H,G--),H--}function J(de,Ce,Me,ze,z,L,G,H,ee,re,Te){if(Ce[Me]!==L[G])return Number.MIN_SAFE_INTEGER;let Be=1,Qe=!1;return G===Me-ze?Be=de[Me]===z[G]?7:5:j(G,z,L)&&(G===0||!j(G-1,z,L))?(Be=de[Me]===z[G]?7:5,Qe=!0):Fe(L,G)&&(G===0||!Fe(L,G-1))?Be=5:(Fe(L,G-1)||ne(L,G-1))&&(Be=5,Qe=!0),Be>1&&Me===ze&&(Te[0]=!0),Qe||(Qe=j(G,z,L)||Fe(L,G-1)||ne(L,G-1)),Me===ze?G>ee&&(Be-=Qe?3:5):re?Be+=Qe?2:0:Be+=Qe?0:1,G+1===H&&(Be-=Qe?3:5),Be}function Y(de,Ce,Me,ze,z,L,G){return le(de,Ce,Me,ze,z,L,!0,G)}function he(de,Ce,Me,ze,z,L,G){return le(de,Ce,Me,ze,z,L,!1,G)}function le(de,Ce,Me,ze,z,L,G,H){let ee=$e(de,Ce,Me,ze,z,L,H);if(ee&&!G)return ee;if(de.length>=3){const re=Math.min(7,de.length-1);for(let Te=Me+1;Te<re;Te++){const Be=Ne(de,Te);if(Be){const Qe=$e(Be,Be.toLowerCase(),Me,ze,z,L,H);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function Ne(de,Ce){if(Ce+1>=de.length)return;const Me=de[Ce],ze=de[Ce+1];if(Me!==ze)return de.slice(0,Ce)+ze+Me+de.slice(Ce+2)}}),define(Ae[33],Re([1,0,15]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(N||(N={})),function(A){const O="error",M="warning",p="warn",$="info",k="ignore";function T(l){return l?I.$tf(O,l)?A.Error:I.$tf(M,l)||I.$tf(p,l)?A.Warning:I.$tf($,l)?A.Info:A.Ignore:A.Ignore}A.fromValue=T;function y(l){switch(l){case A.Error:return O;case A.Warning:return M;case A.Info:return $;default:return k}}A.toString=y}(N||(N={})),e.default=N}),define(Ae[130],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(Ae[52],Re([1,0,18,15]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class A{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const m=v.charCodeAt(0),s=this.b.charCodeAt(this.c);return m-s}value(){return this.b[this.c]}}e.$si=A;class O{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,N.$nf)(v,this.b,0,v.length,this.c,this.d):(0,N.$pf)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=O;class M{constructor(v=!0,m=!0){this.f=v,this.g=m}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let m=v.length-1;m>=0;m--,this.c--){const s=this.b.charCodeAt(m);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,N.$nf)(v,this.b,0,v.length,this.d,this.e):(0,N.$pf)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=M;var p;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(p||(p={}));class ${constructor(v,m){this.f=v,this.g=m,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,N.$of)(v,this.c.scheme);if(this.d[this.e]===2)return(0,N.$of)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,N.$mf)(v,this.c.query);if(this.d[this.e]===5)return(0,N.$mf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=$;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(T||(T={}));class y{static forUris(v=()=>!1,m=()=>!1){return new y(new $(v,m))}static forPaths(v=!1){return new y(new M(void 0,!v))}static forStrings(){return new y(new A)}static forConfigKeys(){return new y(new O)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,m){if(m){const s=m.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o,v)}else{const s=v.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o[0],o[1])}}set(v,m){const s=this.b.reset(v);let o;this.c||(this.c=new k,this.c.segment=s.value());const n=[];for(o=this.c;;){const t=s.cmp(o.segment);if(t>0)o.left||(o.left=new k,o.left.segment=s.value()),n.push([-1,o]),o=o.left;else if(t<0)o.right||(o.right=new k,o.right.segment=s.value()),n.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new k,o.mid.segment=s.value()),n.push([0,o]),o=o.mid;else break}const r=o.value;o.value=m,o.key=v;for(let t=n.length-1;t>=0;t--){const a=n[t][1];a.updateHeight();const d=a.balanceFactor();if(d<-1||d>1){const i=n[t][0],b=n[t+1][0];if(i===1&&b===1)n[t][1]=a.rotateLeft();else if(i===-1&&b===-1)n[t][1]=a.rotateRight();else if(i===1&&b===-1)a.right=n[t+1][1]=n[t+1][1].rotateRight(),n[t][1]=a.rotateLeft();else if(i===-1&&b===1)a.left=n[t+1][1]=n[t+1][1].rotateLeft(),n[t][1]=a.rotateRight();else throw new Error;if(t>0)switch(n[t-1][0]){case-1:n[t-1][1].left=n[t][1];break;case 1:n[t-1][1].right=n[t][1];break;case 0:n[t-1][1].mid=n[t][1];break}else this.c=n[0][1]}}return r}get(v){return this.d(v)?.value}d(v){const m=this.b.reset(v);let s=this.c;for(;s;){const o=m.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(m.hasNext())m.next(),s=s.mid;else break}return s}has(v){const m=this.d(v);return!(m?.value===void 0&&m?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,m){const s=this.b.reset(v),o=[];let n=this.c;for(;n;){const r=s.cmp(n.segment);if(r>0)o.push([-1,n]),n=n.left;else if(r<0)o.push([1,n]),n=n.right;else if(s.hasNext())s.next(),o.push([0,n]),n=n.mid;else break}if(n){if(m?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const r=this.f(n.right);if(r.key){const{key:t,value:a,segment:d}=r;this.e(r.key,!1),n.key=t,n.value=a,n.segment=d}}else{const r=n.left??n.right;if(o.length>0){const[t,a]=o[o.length-1];switch(t){case-1:a.left=r;break;case 0:a.mid=r;break;case 1:a.right=r;break}}else this.c=r}for(let r=o.length-1;r>=0;r--){const t=o[r][1];t.updateHeight();const a=t.balanceFactor();if(a>1?(t.right.balanceFactor()>=0||(t.right=t.right.rotateRight()),o[r][1]=t.rotateLeft()):a<-1&&(t.left.balanceFactor()<=0||(t.left=t.left.rotateLeft()),o[r][1]=t.rotateRight()),r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const m=this.b.reset(v);let s=this.c,o;for(;s;){const n=m.cmp(s.segment);if(n>0)s=s.left;else if(n<0)s=s.right;else if(m.hasNext())m.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(v){return this.g(v,!1)}g(v,m){const s=this.b.reset(v);let o=this.c;for(;o;){const n=s.cmp(o.segment);if(n>0)o=o.left;else if(n<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[m,s]of this)v(s,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const m=[];return this.j(v,m),m[Symbol.iterator]()}j(v,m){v&&(v.left&&this.j(v.left,m),v.value&&m.push([v.key,v.value]),v.mid&&this.j(v.mid,m),v.right&&this.j(v.right,m))}_isBalanced(){const v=m=>{if(!m)return!0;const s=m.balanceFactor();return s<-1||s>1?!1:v(m.left)&&v(m.right)};return v(this.c)}}e.$wi=y}),define(Ae[42],Re([1,0,91]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=A;var N;(function(M){function p($){return $&&typeof $=="object"&&typeof $.id=="string"}M.isThemeColor=p})(N||(e.ThemeColor=N={}));function A(M){return{id:M}}var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function $(r){const t=p.exec(r.id);if(!t)return $(I.$Pj.error);const[,a,d]=t,i=["codicon","codicon-"+a];return d&&i.push("codicon-modifier-"+d.substring(1)),i}M.asClassNameArray=$;function k(r){return $(r).join(" ")}M.asClassName=k;function T(r){return"."+$(r).join(".")}M.asCSSSelector=T;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||N.isThemeColor(r.color))}M.isThemeIcon=y;const l=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function v(r){const t=l.exec(r);if(!t)return;const[,a]=t;return{id:a}}M.fromString=v;function m(r){return{id:r}}M.fromId=m;function s(r,t){let a=r.id;const d=a.lastIndexOf("~");return d!==-1&&(a=a.substring(0,d)),t&&(a=`${a}~${t}`),{id:a}}M.modify=s;function o(r){const t=r.id.lastIndexOf("~");if(t!==-1)return r.id.substring(t+1)}M.getModifier=o;function n(r,t){return r.id===t.id&&r.color?.id===t.color?.id}M.isEqual=n})(O||(e.ThemeIcon=O={}))}),define(Ae[131],Re([1,0,129,15,42]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=$,e.$Ik=T,e.$Jk=l,e.$Kk=v,e.$Lk=s,e.$Mk=o;const O="$(",M=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function $(n){return n.replace(p,(r,t)=>t?r:`\\${r}`)}const k=new RegExp(`\\\\${M.source}`,"g");function T(n){return n.replace(k,r=>`\\${r}`)}const y=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function l(n){return n.indexOf(O)===-1?n:n.replace(y,(r,t,a,d)=>a?r:t||d||"")}function v(n){return n?n.replace(/\$\((.*?)\)/g,(r,t)=>` ${t} `).trim():""}const m=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(n){m.lastIndex=0;let r="";const t=[];let a=0;for(;;){const d=m.lastIndex,i=m.exec(n),b=n.substring(d,i?.index);if(b.length>0){r+=b;for(let c=0;c<b.length;c++)t.push(a)}if(!i)break;a+=i[0].length}return{text:r,iconOffsets:t}}function o(n,r,t=!1){const{text:a,iconOffsets:d}=r;if(!d||d.length===0)return(0,I.$yk)(n,a,t);const i=(0,N.$af)(a," "),b=a.length-i.length,c=(0,I.$yk)(n,i,t);if(c)for(const f of c){const u=d[f.start+b]+b;f.start+=u,f.end+=u}return c}}),define(Ae[35],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(A){return I.test(A)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(p){for(let $=0;$<p.length;$++)p[$]=Math.floor(Math.random()*256);return p};const O=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){A(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let $=0,k="";return k+=M[O[$++]],k+=M[O[$++]],k+=M[O[$++]],k+=M[O[$++]],k+="-",k+=M[O[$++]],k+=M[O[$++]],k+="-",k+=M[O[$++]],k+=M[O[$++]],k+="-",k+=M[O[$++]],k+=M[O[$++]],k+="-",k+=M[O[$++]],k+=M[O[$++]],k+=M[O[$++]],k+=M[O[$++]],k+=M[O[$++]],k+=M[O[$++]],k}}()}),define(Ae[132],Re([1,0,18,40,35]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=O,e.$Ht=M,e.$Jt=k;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function M(y,l,v){const m={id:(0,A.$Mg)(),name:y,uri:l,data:v};return{asString:async()=>"",asFile:()=>m,value:void 0}}class p{constructor(){this.a=new Map}get size(){let l=0;for(const v of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const v=[...this.a.keys()];return N.Iterable.some(this,([m,s])=>s.asFile())&&v.push("files"),T($(l),v)}get(l){return this.a.get(this.b(l))?.[0]}append(l,v){const m=this.a.get(l);m?m.push(v):this.a.set(this.b(l),[v])}replace(l,v){this.a.set(this.b(l),[v])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,v]of this.a)for(const m of v)yield[l,m]}b(l){return $(l)}}e.$It=p;function $(y){return y.toLowerCase()}function k(y,l){return T($(y),l.map($))}function T(y,l){if(y==="*/*")return l.length>0;if(l.includes(y))return!0;const v=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[m,s,o]=v;return o==="*"?l.some(n=>n.startsWith(s+"/")):!1}e.$Kt=Object.freeze({create:y=>(0,I.$Mb)(y.map(l=>l.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Kt.split(y).filter(l=>!l.startsWith("#"))})}),define(Ae[133],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=N;var I;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function N(A){let O=0,M=0,p=0,$=0;for(let k=0,T=A.length;k<T;k++){const y=A.charCodeAt(k);y===13?(O===0&&(M=k),O++,k+1<T&&A.charCodeAt(k+1)===10?($|=2,k++):$|=3,p=k+1):y===10&&($|=1,O===0&&(M=k),O++,p=k+1)}return O===0&&(M=A.length),[O,M,A.length-p,$]}}),define(Ae[134],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[135],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var I;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class N{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let $=0,k=p.notIn.length;$<k;$++)switch(p.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,$){if(p.getTokenCount()===0)return!0;const k=p.findTokenIndexAtOffset($-2),T=p.getStandardTokenType(k);return this.isOK(T)}g(p,$){for(let k=p;k<=$;k++){const T=String.fromCharCode(k);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=N;class A{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of p)O(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),O(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),O(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),O(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&O(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$bu=A;function O(M,p,$){M.has(p)?M.get(p).push($):M.set(p,[$])}}),define(Ae[136],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=e.NodeColor=e.$qC=void 0,e.$sC=A,e.$tC=O,e.$uC=k,e.$vC=T,e.$wC=y,e.$xC=l,e.$yC=v,e.$zC=m;class I{constructor(o,n){this.piece=o,this.color=n,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rC)return A(this.right);let o=this;for(;o.parent!==e.$rC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$rC?e.$rC:o.parent}prev(){if(this.left!==e.$rC)return O(this.left);let o=this;for(;o.parent!==e.$rC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$rC?e.$rC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qC=I;var N;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$rC=new I(null,0),e.$rC.parent=e.$rC,e.$rC.left=e.$rC,e.$rC.right=e.$rC,e.$rC.color=0;function A(s){for(;s.left!==e.$rC;)s=s.left;return s}function O(s){for(;s.right!==e.$rC;)s=s.right;return s}function M(s){return s===e.$rC?0:s.size_left+s.piece.length+M(s.right)}function p(s){return s===e.$rC?0:s.lf_left+s.piece.lineFeedCnt+p(s.right)}function $(){e.$rC.parent=e.$rC}function k(s,o){const n=o.right;n.size_left+=o.size_left+(o.piece?o.piece.length:0),n.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=n.left,n.left!==e.$rC&&(n.left.parent=o),n.parent=o.parent,o.parent===e.$rC?s.root=n:o.parent.left===o?o.parent.left=n:o.parent.right=n,n.left=o,o.parent=n}function T(s,o){const n=o.left;o.left=n.right,n.right!==e.$rC&&(n.right.parent=o),n.parent=o.parent,o.size_left-=n.size_left+(n.piece?n.piece.length:0),o.lf_left-=n.lf_left+(n.piece?n.piece.lineFeedCnt:0),o.parent===e.$rC?s.root=n:o===o.parent.right?o.parent.right=n:o.parent.left=n,n.right=o,o.parent=n}function y(s,o){let n,r;if(o.left===e.$rC?(r=o,n=r.right):o.right===e.$rC?(r=o,n=r.left):(r=A(o.right),n=r.right),r===s.root){s.root=n,n.color=0,o.detach(),$(),s.root.parent=e.$rC;return}const t=r.color===1;if(r===r.parent.left?r.parent.left=n:r.parent.right=n,r===o?(n.parent=r.parent,m(s,n)):(r.parent===o?n.parent=r:n.parent=r.parent,m(s,n),r.left=o.left,r.right=o.right,r.parent=o.parent,r.color=o.color,o===s.root?s.root=r:o===o.parent.left?o.parent.left=r:o.parent.right=r,r.left!==e.$rC&&(r.left.parent=r),r.right!==e.$rC&&(r.right.parent=r),r.size_left=o.size_left,r.lf_left=o.lf_left,m(s,r)),o.detach(),n.parent.left===n){const d=M(n),i=p(n);if(d!==n.parent.size_left||i!==n.parent.lf_left){const b=d-n.parent.size_left,c=i-n.parent.lf_left;n.parent.size_left=d,n.parent.lf_left=i,v(s,n.parent,b,c)}}if(m(s,n.parent),t){$();return}let a;for(;n!==s.root&&n.color===0;)n===n.parent.left?(a=n.parent.right,a.color===1&&(a.color=0,n.parent.color=1,k(s,n.parent),a=n.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,n=n.parent):(a.right.color===0&&(a.left.color=0,a.color=1,T(s,a),a=n.parent.right),a.color=n.parent.color,n.parent.color=0,a.right.color=0,k(s,n.parent),n=s.root)):(a=n.parent.left,a.color===1&&(a.color=0,n.parent.color=1,T(s,n.parent),a=n.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,n=n.parent):(a.left.color===0&&(a.right.color=0,a.color=1,k(s,a),a=n.parent.left),a.color=n.parent.color,n.parent.color=0,a.left.color=0,T(s,n.parent),n=s.root));n.color=0,$()}function l(s,o){for(m(s,o);o!==s.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const n=o.parent.parent.right;n.color===1?(o.parent.color=0,n.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,k(s,o)),o.parent.color=0,o.parent.parent.color=1,T(s,o.parent.parent))}else{const n=o.parent.parent.left;n.color===1?(o.parent.color=0,n.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(s,o)),o.parent.color=0,o.parent.parent.color=1,k(s,o.parent.parent))}s.root.color=0}function v(s,o,n,r){for(;o!==s.root&&o!==e.$rC;)o.parent.left===o&&(o.parent.size_left+=n,o.parent.lf_left+=r),o=o.parent}function m(s,o){let n=0,r=0;if(o!==s.root){for(;o!==s.root&&o===o.parent.right;)o=o.parent;if(o!==s.root)for(o=o.parent,n=M(o.left)-o.size_left,r=p(o.left)-o.lf_left,o.size_left+=n,o.lf_left+=r;o!==s.root&&(n!==0||r!==0);)o.parent.left===o&&(o.parent.size_left+=n,o.parent.lf_left+=r),o=o.parent}}}),define(Ae[92],Re([1,0,93,29,94,136,95]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=void 0,e.$GC=T,e.$HC=y;const p=65535;function $(n){let r;return n[n.length-1]<65536?r=new Uint16Array(n.length):r=new Uint32Array(n.length),r.set(n,0),r}class k{constructor(r,t,a,d,i){this.lineStarts=r,this.cr=t,this.lf=a,this.crlf=d,this.isBasicASCII=i}}function T(n,r=!0){const t=[0];let a=1;for(let d=0,i=n.length;d<i;d++){const b=n.charCodeAt(d);b===13?d+1<i&&n.charCodeAt(d+1)===10?(t[a++]=d+2,d++):t[a++]=d+1:b===10&&(t[a++]=d+1)}return r?$(t):t}function y(n,r){n.length=0,n[0]=0;let t=1,a=0,d=0,i=0,b=!0;for(let f=0,u=r.length;f<u;f++){const S=r.charCodeAt(f);S===13?f+1<u&&r.charCodeAt(f+1)===10?(i++,n[t++]=f+2,f++):(a++,n[t++]=f+1):S===10?(d++,n[t++]=f+1):b&&S!==9&&(S<32||S>126)&&(b=!1)}const c=new k($(n),a,d,i,b);return n.length=0,c}class l{constructor(r,t,a,d,i){this.bufferIndex=r,this.start=t,this.end=a,this.lineFeedCnt=d,this.length=i}}e.$IC=l;class v{constructor(r,t){this.buffer=r,this.lineStarts=t}}e.$JC=v;class m{constructor(r,t){this.a=[],this.c=r,this.d=t,this.b=0,r.root!==O.$rC&&r.iterate(r.root,a=>(a!==O.$rC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(r){this.a=r,this.b=[]}get(r){for(let t=this.b.length-1;t>=0;t--){const a=this.b[t];if(a.nodeStartOffset<=r&&a.nodeStartOffset+a.node.piece.length>=r)return a}return null}get2(r){for(let t=this.b.length-1;t>=0;t--){const a=this.b[t];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<r&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=r)return a}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let t=!1;const a=this.b;for(let d=0;d<a.length;d++){const i=a[d];if(i.node.parent===null||i.nodeStartOffset>=r){a[d]=null,t=!0;continue}}if(t){const d=[];for(const i of a)i!==null&&d.push(i);this.b=d}}}class o{constructor(r,t,a){this.create(r,t,a)}create(r,t,a){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=O.$rC,this.b=1,this.c=0,this.d=t,this.e=t.length,this.f=a;let d=null;for(let i=0,b=r.length;i<b;i++)if(r[i].buffer.length>0){r[i].lineStarts||(r[i].lineStarts=T(r[i].buffer));const c=new l(i+1,{line:0,column:0},{line:r[i].lineStarts.length-1,column:r[i].buffer.length-r[i].lineStarts[r[i].lineStarts.length-1]},r[i].lineStarts.length-1,r[i].buffer.length);this.a.push(r[i]),d=this.S(d,c)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const t=p,a=t-Math.floor(t/3),d=a*2;let i="",b=0;const c=[];if(this.iterate(this.root,f=>{const u=this.R(f),S=u.length;if(b<=a||b+S<d)return i+=u,b+=S,!0;const h=i.replace(/\r\n|\r|\n/g,r);return c.push(new v(h,T(h))),i=u,b=S,!0}),b>0){const f=i.replace(/\r\n|\r|\n/g,r);c.push(new v(f,T(f)))}this.create(c,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new m(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let t=0;return this.iterate(this.root,d=>{if(d===O.$rC)return!0;const i=this.R(d),b=i.length,c=r.G(t),f=r.G(t+b),u=r.getValueInRange2(c,f);return t+=b,i===u})}getOffsetAt(r,t){let a=0,d=this.root;for(;d!==O.$rC;)if(d.left!==O.$rC&&d.lf_left+1>=r)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt+1>=r){a+=d.size_left;const i=this.B(d,r-d.lf_left-2);return a+=i+t-1}else r-=d.lf_left+d.piece.lineFeedCnt,a+=d.size_left+d.piece.length,d=d.right;return a}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let t=this.root,a=0;const d=r;for(;t!==O.$rC;)if(t.size_left!==0&&t.size_left>=r)t=t.left;else if(t.size_left+t.piece.length>=r){const i=this.A(t,r-t.size_left);if(a+=t.lf_left+i.index,i.index===0){const b=this.getOffsetAt(a+1,1),c=d-b;return new I.$jt(a+1,c+1)}return new I.$jt(a+1,i.remainder+1)}else if(r-=t.size_left+t.piece.length,a+=t.lf_left+t.piece.lineFeedCnt,t.right===O.$rC){const i=this.getOffsetAt(a+1,1),b=d-r-i;return new I.$jt(a+1,b+1)}else t=t.right;return new I.$jt(1,1)}getValueInRange(r,t){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const a=this.H(r.startLineNumber,r.startColumn),d=this.H(r.endLineNumber,r.endColumn),i=this.getValueInRange2(a,d);return t?t!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,t):t===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,t):i}getValueInRange2(r,t){if(r.node===t.node){const c=r.node,f=this.a[c.piece.bufferIndex].buffer,u=this.u(c.piece.bufferIndex,c.piece.start);return f.substring(u+r.remainder,u+t.remainder)}let a=r.node;const d=this.a[a.piece.bufferIndex].buffer,i=this.u(a.piece.bufferIndex,a.piece.start);let b=d.substring(i+r.remainder,i+a.piece.length);for(a=a.next();a!==O.$rC;){const c=this.a[a.piece.bufferIndex].buffer,f=this.u(a.piece.bufferIndex,a.piece.start);if(a===t.node){b+=c.substring(f,f+t.remainder);break}else b+=c.substr(f,a.piece.length);a=a.next()}return b}getLinesContent(){const r=[];let t=0,a="",d=!1;return this.iterate(this.root,i=>{if(i===O.$rC)return!0;const b=i.piece;let c=b.length;if(c===0)return!0;const f=this.a[b.bufferIndex].buffer,u=this.a[b.bufferIndex].lineStarts,S=b.start.line,h=b.end.line;let E=u[S]+b.start.column;if(d&&(f.charCodeAt(E)===10&&(E++,c--),r[t++]=a,a="",d=!1,c===0))return!0;if(S===h)return!this.f&&f.charCodeAt(E+c-1)===13?(d=!0,a+=f.substr(E,c-1)):a+=f.substr(E,c),!0;a+=this.f?f.substring(E,Math.max(E,u[S+1]-this.e)):f.substring(E,u[S+1]).replace(/(\r\n|\r|\n)$/,""),r[t++]=a;for(let g=S+1;g<h;g++)a=this.f?f.substring(u[g],u[g+1]-this.e):f.substring(u[g],u[g+1]).replace(/(\r\n|\r|\n)$/,""),r[t++]=a;return!this.f&&f.charCodeAt(u[h]+b.end.column-1)===13?(d=!0,b.end.column===0?t--:a=f.substr(u[h],b.end.column-1)):a=f.substr(u[h],b.end.column),!0}),d&&(r[t++]=a,a=""),r[t++]=a,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t)return 0;const a=this.a[t.piece.bufferIndex],d=this.u(t.piece.bufferIndex,t.piece.start);return a.buffer.charCodeAt(d)}else{const t=this.a[r.node.piece.bufferIndex],d=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return t.buffer.charCodeAt(d)}}getLineCharCode(r,t){const a=this.H(r,t+1);return this.l(a)}getLineLength(r){if(r===this.getLineCount()){const t=this.getOffsetAt(r,1);return this.getLength()-t}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const t=this.G(r);return this.l(t)}findMatchesInNode(r,t,a,d,i,b,c,f,u,S,h){const E=this.a[r.piece.bufferIndex],g=this.u(r.piece.bufferIndex,r.piece.start),D=this.u(r.piece.bufferIndex,i),w=this.u(r.piece.bufferIndex,b);let C;const P={line:0,column:0};let V,W;t._wordSeparators?(V=E.buffer.substring(D,w),W=q=>q+D,t.reset(0)):(V=E.buffer,W=q=>q,t.reset(D));do if(C=t.next(V),C){if(W(C.index)>=w)return S;this.s(r,W(C.index)-g,P);const q=this.t(r.piece.bufferIndex,i,P),R=P.line===i.line?P.column-i.column+d:P.column+1,U=R+C[0].length;if(h[S++]=(0,M.$CC)(new N.$kt(a+q,R,a+q,U),C,f),W(C.index)+C[0].length>=w||S>=u)return S}while(C);return S}findMatchesLineByLine(r,t,a,d){const i=[];let b=0;const c=new M.$FC(t.wordSeparators,t.regex);let f=this.H(r.startLineNumber,r.startColumn);if(f===null)return[];const u=this.H(r.endLineNumber,r.endColumn);if(u===null)return[];let S=this.s(f.node,f.remainder);const h=this.s(u.node,u.remainder);if(f.node===u.node)return this.findMatchesInNode(f.node,c,r.startLineNumber,r.startColumn,S,h,t,a,d,b,i),i;let E=r.startLineNumber,g=f.node;for(;g!==u.node;){const w=this.t(g.piece.bufferIndex,S,g.piece.end);if(w>=1){const P=this.a[g.piece.bufferIndex].lineStarts,V=this.u(g.piece.bufferIndex,g.piece.start),W=P[S.line+w],q=E===r.startLineNumber?r.startColumn:1;if(b=this.findMatchesInNode(g,c,E,q,S,this.s(g,W-V),t,a,d,b,i),b>=d)return i;E+=w}const C=E===r.startLineNumber?r.startColumn-1:0;if(E===r.endLineNumber){const P=this.getLineContent(E).substring(C,r.endColumn-1);return b=this.n(t,c,P,r.endLineNumber,C,b,i,a,d),i}if(b=this.n(t,c,this.getLineContent(E).substr(C),E,C,b,i,a,d),b>=d)return i;E++,f=this.H(E,1),g=f.node,S=this.s(f.node,f.remainder)}if(E===r.endLineNumber){const w=E===r.startLineNumber?r.startColumn-1:0,C=this.getLineContent(E).substring(w,r.endColumn-1);return b=this.n(t,c,C,r.endLineNumber,w,b,i,a,d),i}const D=E===r.startLineNumber?r.startColumn:1;return b=this.findMatchesInNode(u.node,c,E,D,S,h,t,a,d,b,i),i}n(r,t,a,d,i,b,c,f,u){const S=r.wordSeparators;if(!f&&r.simpleSearch){const E=r.simpleSearch,g=E.length,D=a.length;let w=-g;for(;(w=a.indexOf(E,w+g))!==-1;)if((!S||(0,M.$EC)(S,a,D,w,g))&&(c[b++]=new A.$vv(new N.$kt(d,w+1+i,d,w+1+g+i),null),b>=u))return b;return b}let h;t.reset(0);do if(h=t.next(a),h&&(c[b++]=(0,M.$CC)(new N.$kt(d,h.index+1+i,d,h.index+1+h[0].length+i),h,f),b>=u))return b;while(h);return b}insert(r,t,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==O.$rC){const{node:d,remainder:i,nodeStartOffset:b}=this.G(r),c=d.piece,f=c.bufferIndex,u=this.s(d,i);if(d.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&b+c.length===r&&t.length<p){this.F(d,t),this.y();return}if(b===r)this.o(t,d),this.h.validate(r);else if(b+d.piece.length>r){const S=[];let h=new l(c.bufferIndex,u,c.end,this.t(c.bufferIndex,u,c.end),this.u(f,c.end)-this.u(f,u));if(this.K()&&this.M(t)&&this.I(d,i)===10){const w={line:h.start.line+1,column:0};h=new l(h.bufferIndex,w,h.end,this.t(h.bufferIndex,w,h.end),h.length-1),t+=`
`}if(this.K()&&this.L(t))if(this.I(d,i-1)===13){const w=this.s(d,i-1);this.C(d,w),t="\r"+t,d.piece.length===0&&S.push(d)}else this.C(d,u);else this.C(d,u);const E=this.w(t);h.length>0&&this.S(d,h);let g=d;for(let D=0;D<E.length;D++)g=this.S(g,E[D]);this.v(S)}else this.q(t,d)}else{const d=this.w(t);let i=this.T(null,d[0]);for(let b=1;b<d.length;b++)i=this.S(i,d[b])}this.y()}delete(r,t){if(this.j.lineNumber=0,this.j.value="",t<=0||this.root===O.$rC)return;const a=this.G(r),d=this.G(r+t),i=a.node,b=d.node;if(i===b){const E=this.s(i,a.remainder),g=this.s(i,d.remainder);if(a.nodeStartOffset===r){if(t===i.piece.length){const D=i.next();(0,O.$wC)(this,i),this.N(D),this.y();return}this.D(i,g),this.h.validate(r),this.N(i),this.y();return}if(a.nodeStartOffset+i.piece.length===r+t){this.C(i,E),this.O(i),this.y();return}this.E(i,E,g),this.y();return}const c=[],f=this.s(i,a.remainder);this.C(i,f),this.h.validate(r),i.piece.length===0&&c.push(i);const u=this.s(b,d.remainder);this.D(b,u),b.piece.length===0&&c.push(b);const S=i.next();for(let E=S;E!==O.$rC&&E!==b;E=E.next())c.push(E);const h=i.piece.length===0?i.prev():i;this.v(c),this.O(h),this.y()}o(r,t){const a=[];if(this.K()&&this.M(r)&&this.L(t)){const b=t.piece,c={line:b.start.line+1,column:0},f=new l(b.bufferIndex,c,b.end,this.t(b.bufferIndex,c,b.end),b.length-1);t.piece=f,r+=`
`,(0,O.$yC)(this,t,-1,-1),t.piece.length===0&&a.push(t)}const d=this.w(r);let i=this.T(t,d[d.length-1]);for(let b=d.length-2;b>=0;b--)i=this.T(i,d[b]);this.N(i),this.v(a)}q(r,t){this.Q(r,t)&&(r+=`
`);const a=this.w(r),d=this.S(t,a[0]);let i=d;for(let b=1;b<a.length;b++)i=this.S(i,a[b]);this.N(d)}s(r,t,a){const d=r.piece,i=r.piece.bufferIndex,b=this.a[i].lineStarts,f=b[d.start.line]+d.start.column+t;let u=d.start.line,S=d.end.line,h=0,E=0,g=0;for(;u<=S&&(h=u+(S-u)/2|0,g=b[h],h!==S);)if(E=b[h+1],f<g)S=h-1;else if(f>=E)u=h+1;else break;return a?(a.line=h,a.column=f-g,null):{line:h,column:f-g}}t(r,t,a){if(a.column===0)return a.line-t.line;const d=this.a[r].lineStarts;if(a.line===d.length-1)return a.line-t.line;const i=d[a.line+1],b=d[a.line]+a.column;if(i>b+1)return a.line-t.line;const c=b-1;return this.a[r].buffer.charCodeAt(c)===13?a.line-t.line+1:a.line-t.line}u(r,t){return this.a[r].lineStarts[t.line]+t.column}v(r){for(let t=0;t<r.length;t++)(0,O.$wC)(this,r[t])}w(r){if(r.length>p){const S=[];for(;r.length>p;){const E=r.charCodeAt(p-1);let g;E===13||E>=55296&&E<=56319?(g=r.substring(0,p-1),r=r.substring(p-1)):(g=r.substring(0,p),r=r.substring(p));const D=T(g);S.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:g.length-D[D.length-1]},D.length-1,g.length)),this.a.push(new v(g,D))}const h=T(r);return S.push(new l(this.a.length,{line:0,column:0},{line:h.length-1,column:r.length-h[h.length-1]},h.length-1,r.length)),this.a.push(new v(r,h)),S}let t=this.a[0].buffer.length;const a=T(r,!1);let d=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===t&&t!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},d=this.g;for(let S=0;S<a.length;S++)a[S]+=t+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+r,t+=1}else{if(t!==0)for(let S=0;S<a.length;S++)a[S]+=t;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=r}const i=this.a[0].buffer.length,b=this.a[0].lineStarts.length-1,c=i-this.a[0].lineStarts[b],f={line:b,column:c},u=new l(0,d,f,this.t(0,d,f),i-t);return this.g=f,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,t=0){let a=this.root,d="";const i=this.h.get2(r);if(i){a=i.node;const b=this.B(a,r-i.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,f=this.u(a.piece.bufferIndex,a.piece.start);if(i.nodeStartLineNumber+a.piece.lineFeedCnt===r)d=c.substring(f+b,f+a.piece.length);else{const u=this.B(a,r-i.nodeStartLineNumber);return c.substring(f+b,f+u-t)}}else{let b=0;const c=r;for(;a!==O.$rC;)if(a.left!==O.$rC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const f=this.B(a,r-a.lf_left-2),u=this.B(a,r-a.lf_left-1),S=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);return b+=a.size_left,this.h.set({node:a,nodeStartOffset:b,nodeStartLineNumber:c-(r-1-a.lf_left)}),S.substring(h+f,h+u-t)}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const f=this.B(a,r-a.lf_left-2),u=this.a[a.piece.bufferIndex].buffer,S=this.u(a.piece.bufferIndex,a.piece.start);d=u.substring(S+f,S+a.piece.length);break}else r-=a.lf_left+a.piece.lineFeedCnt,b+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==O.$rC;){const b=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),f=this.u(a.piece.bufferIndex,a.piece.start);return d+=b.substring(f,f+c-t),d}else{const c=this.u(a.piece.bufferIndex,a.piece.start);d+=b.substr(c,a.piece.length)}a=a.next()}return d}y(){let r=this.root,t=1,a=0;for(;r!==O.$rC;)t+=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;this.b=t,this.c=a,this.h.validate(this.c)}A(r,t){const a=r.piece,d=this.s(r,t),i=d.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===t){const b=this.t(r.piece.bufferIndex,a.start,d);if(b!==i)return{index:b,remainder:0}}return{index:i,remainder:d.column}}B(r,t){if(t<0)return 0;const a=r.piece,d=this.a[a.bufferIndex].lineStarts,i=a.start.line+t+1;return i>a.end.line?d[a.end.line]+a.end.column-d[a.start.line]-a.start.column:d[i]-d[a.start.line]-a.start.column}C(r,t){const a=r.piece,d=a.lineFeedCnt,i=this.u(a.bufferIndex,a.end),b=t,c=this.u(a.bufferIndex,b),f=this.t(a.bufferIndex,a.start,b),u=f-d,S=c-i,h=a.length+S;r.piece=new l(a.bufferIndex,a.start,b,f,h),(0,O.$yC)(this,r,S,u)}D(r,t){const a=r.piece,d=a.lineFeedCnt,i=this.u(a.bufferIndex,a.start),b=t,c=this.t(a.bufferIndex,b,a.end),f=this.u(a.bufferIndex,b),u=c-d,S=i-f,h=a.length+S;r.piece=new l(a.bufferIndex,b,a.end,c,h),(0,O.$yC)(this,r,S,u)}E(r,t,a){const d=r.piece,i=d.start,b=d.end,c=d.length,f=d.lineFeedCnt,u=t,S=this.t(d.bufferIndex,d.start,u),h=this.u(d.bufferIndex,t)-this.u(d.bufferIndex,i);r.piece=new l(d.bufferIndex,d.start,u,S,h),(0,O.$yC)(this,r,h-c,S-f);const E=new l(d.bufferIndex,a,b,this.t(d.bufferIndex,a,b),this.u(d.bufferIndex,b)-this.u(d.bufferIndex,a)),g=this.S(r,E);this.N(g)}F(r,t){this.Q(t,r)&&(t+=`
`);const a=this.K()&&this.L(t)&&this.M(r),d=this.a[0].buffer.length;this.a[0].buffer+=t;const i=T(t,!1);for(let g=0;g<i.length;g++)i[g]+=d;if(a){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:d-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const b=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[b],f={line:b,column:c},u=r.piece.length+t.length,S=r.piece.lineFeedCnt,h=this.t(0,r.piece.start,f),E=h-S;r.piece=new l(r.piece.bufferIndex,r.piece.start,f,h,u),this.g=f,(0,O.$yC)(this,r,t.length,E)}G(r){let t=this.root;const a=this.h.get(r);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:r-a.nodeStartOffset};let d=0;for(;t!==O.$rC;)if(t.size_left>r)t=t.left;else if(t.size_left+t.piece.length>=r){d+=t.size_left;const i={node:t,remainder:r-t.size_left,nodeStartOffset:d};return this.h.set(i),i}else r-=t.size_left+t.piece.length,d+=t.size_left+t.piece.length,t=t.right;return null}H(r,t){let a=this.root,d=0;for(;a!==O.$rC;)if(a.left!==O.$rC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const i=this.B(a,r-a.lf_left-2),b=this.B(a,r-a.lf_left-1);return d+=a.size_left,{node:a,remainder:Math.min(i+t-1,b),nodeStartOffset:d}}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const i=this.B(a,r-a.lf_left-2);if(i+t-1<=a.piece.length)return{node:a,remainder:i+t-1,nodeStartOffset:d};t-=a.piece.length-i;break}else r-=a.lf_left+a.piece.lineFeedCnt,d+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==O.$rC;){if(a.piece.lineFeedCnt>0){const i=this.B(a,0),b=this.J(a);return{node:a,remainder:Math.min(t-1,i),nodeStartOffset:b}}else if(a.piece.length>=t-1){const i=this.J(a);return{node:a,remainder:t-1,nodeStartOffset:i}}else t-=a.piece.length;a=a.next()}return null}I(r,t){if(r.piece.lineFeedCnt<1)return-1;const a=this.a[r.piece.bufferIndex],d=this.u(r.piece.bufferIndex,r.piece.start)+t;return a.buffer.charCodeAt(d)}J(r){if(!r)return 0;let t=r.size_left;for(;r!==this.root;)r.parent.right===r&&(t+=r.parent.size_left+r.parent.piece.length),r=r.parent;return t}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===O.$rC||r.piece.lineFeedCnt===0)return!1;const t=r.piece,a=this.a[t.bufferIndex].lineStarts,d=t.start.line,i=a[d]+t.start.column;return d===a.length-1||a[d+1]>i+1?!1:this.a[t.bufferIndex].buffer.charCodeAt(i)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===O.$rC||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const t=r.prev();this.M(t)&&this.P(t,r)}}O(r){if(this.K()&&this.M(r)){const t=r.next();this.L(t)&&this.P(r,t)}}P(r,t){const a=[],d=this.a[r.piece.bufferIndex].lineStarts;let i;r.piece.end.column===0?i={line:r.piece.end.line-1,column:d[r.piece.end.line]-d[r.piece.end.line-1]-1}:i={line:r.piece.end.line,column:r.piece.end.column-1};const b=r.piece.length-1,c=r.piece.lineFeedCnt-1;r.piece=new l(r.piece.bufferIndex,r.piece.start,i,c,b),(0,O.$yC)(this,r,-1,-1),r.piece.length===0&&a.push(r);const f={line:t.piece.start.line+1,column:0},u=t.piece.length-1,S=this.t(t.piece.bufferIndex,f,t.piece.end);t.piece=new l(t.piece.bufferIndex,f,t.piece.end,S,u),(0,O.$yC)(this,t,-1,-1),t.piece.length===0&&a.push(t);const h=this.w(`\r
`);this.S(r,h[0]);for(let E=0;E<a.length;E++)(0,O.$wC)(this,a[E])}Q(r,t){if(this.K()&&this.M(r)){const a=t.next();if(this.L(a)){if(r+=`
`,a.piece.length===1)(0,O.$wC)(this,a);else{const d=a.piece,i={line:d.start.line+1,column:0},b=d.length-1,c=this.t(d.bufferIndex,i,d.end);a.piece=new l(d.bufferIndex,i,d.end,c,b),(0,O.$yC)(this,a,-1,-1)}return!0}}return!1}iterate(r,t){if(r===O.$rC)return t(O.$rC);const a=this.iterate(r.left,t);return a&&t(r)&&this.iterate(r.right,t)}R(r){if(r===O.$rC)return"";const t=this.a[r.piece.bufferIndex],a=r.piece,d=this.u(a.bufferIndex,a.start),i=this.u(a.bufferIndex,a.end);return t.buffer.substring(d,i)}getPieceContent(r){const t=this.a[r.bufferIndex],a=this.u(r.bufferIndex,r.start),d=this.u(r.bufferIndex,r.end);return t.buffer.substring(a,d)}S(r,t){const a=new O.$qC(t,1);if(a.left=O.$rC,a.right=O.$rC,a.parent=O.$rC,a.size_left=0,a.lf_left=0,this.root===O.$rC)this.root=a,a.color=0;else if(r.right===O.$rC)r.right=a,a.parent=r;else{const i=(0,O.$sC)(r.right);i.left=a,a.parent=i}return(0,O.$xC)(this,a),a}T(r,t){const a=new O.$qC(t,1);if(a.left=O.$rC,a.right=O.$rC,a.parent=O.$rC,a.size_left=0,a.lf_left=0,this.root===O.$rC)this.root=a,a.color=0;else if(r.left===O.$rC)r.left=a,a.parent=r;else{const d=(0,O.$tC)(r.left);d.right=a,a.parent=d}return(0,O.$xC)(this,a),a}U(r){let t="";return this.iterate(r,a=>(t+=this.R(a),!0)),t}}e.$KC=o}),define(Ae[137],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c9=e.$b9=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const M=this.a.get(O);return this.a.delete(O),M}}addDragOperationTransfer(O,M){this.a.set(O,M)}}e.$b9=I;class N{constructor(O){this.identifier=O}}e.$c9=N}),define(Ae[138],Re([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Ae[139],Re([1,0,5,6,138]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0,e.$aj=T;class O extends N.$Uc{constructor(l,v="",m="",s=!0,o){super(),this.h=this.B(new I.$be),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=v,this.u=m,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,v){this.C&&await this.C(l)}}e.$8i=O;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$be),this.onWillRun=this.f.event,this.m=this.B(new I.$be),this.onDidRun=this.m.event}async run(l,v){if(!l.enabled)return;this.f.fire({action:l});let m;try{await this.u(l,v)}catch(s){m=s}this.m.fire({action:l,error:m})}async u(l,v){await l.run(v)}}e.$9i=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let v=[];for(const m of l)m.length&&(v.length?v=[...v,new p,...m]:v=m);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$0i=p;class ${get actions(){return this.a}constructor(l,v,m,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=v,this.class=s,this.a=m}async run(){}}e.$$i=$;class k extends O{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,A.localize(0,null),void 0,!1)}}e.$_i=k;function T(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...l)=>y.run(...l),tooltip:y.label}}}),define(Ae[140],Re([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Ae[141],Re([1,0,140]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=k,e.$Wm=T,e.$Xm=y;const N=60,A=N*60,O=A*24,M=O*7,p=O*30,$=O*365;function k(l,v,m,s){typeof l!="number"&&(l=l.getTime());const o=Math.round((new Date().getTime()-l)/1e3);if(o<-30)return(0,I.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!s&&o<30)return(0,I.localize)(1,null);let n;return o<N?(n=o,v?n===1?m?(0,I.localize)(2,null,n):(0,I.localize)(3,null,n):m?(0,I.localize)(4,null,n):(0,I.localize)(5,null,n):n===1?m?(0,I.localize)(6,null,n):(0,I.localize)(7,null,n):m?(0,I.localize)(8,null,n):(0,I.localize)(9,null,n)):o<A?(n=Math.floor(o/N),v?n===1?m?(0,I.localize)(10,null,n):(0,I.localize)(11,null,n):m?(0,I.localize)(12,null,n):(0,I.localize)(13,null,n):n===1?m?(0,I.localize)(14,null,n):(0,I.localize)(15,null,n):m?(0,I.localize)(16,null,n):(0,I.localize)(17,null,n)):o<O?(n=Math.floor(o/A),v?n===1?m?(0,I.localize)(18,null,n):(0,I.localize)(19,null,n):m?(0,I.localize)(20,null,n):(0,I.localize)(21,null,n):n===1?m?(0,I.localize)(22,null,n):(0,I.localize)(23,null,n):m?(0,I.localize)(24,null,n):(0,I.localize)(25,null,n)):o<M?(n=Math.floor(o/O),v?n===1?(0,I.localize)(26,null,n):(0,I.localize)(27,null,n):n===1?(0,I.localize)(28,null,n):(0,I.localize)(29,null,n)):o<p?(n=Math.floor(o/M),v?n===1?m?(0,I.localize)(30,null,n):(0,I.localize)(31,null,n):m?(0,I.localize)(32,null,n):(0,I.localize)(33,null,n):n===1?m?(0,I.localize)(34,null,n):(0,I.localize)(35,null,n):m?(0,I.localize)(36,null,n):(0,I.localize)(37,null,n)):o<$?(n=Math.floor(o/p),v?n===1?m?(0,I.localize)(38,null,n):(0,I.localize)(39,null,n):m?(0,I.localize)(40,null,n):(0,I.localize)(41,null,n):n===1?m?(0,I.localize)(42,null,n):(0,I.localize)(43,null,n):m?(0,I.localize)(44,null,n):(0,I.localize)(45,null,n)):(n=Math.floor(o/$),v?n===1?m?(0,I.localize)(46,null,n):(0,I.localize)(47,null,n):m?(0,I.localize)(48,null,n):(0,I.localize)(49,null,n):n===1?m?(0,I.localize)(50,null,n):(0,I.localize)(51,null,n):m?(0,I.localize)(52,null,n):(0,I.localize)(53,null,n))}function T(l,v){const m=Math.abs(l/1e3);return m<1?v?(0,I.localize)(54,null,l):(0,I.localize)(55,null,l):m<N?v?(0,I.localize)(56,null,Math.round(l)/1e3):(0,I.localize)(57,null,Math.round(l)/1e3):m<A?v?(0,I.localize)(58,null,Math.round(l/(1e3*N))):(0,I.localize)(59,null,Math.round(l/(1e3*N))):m<O?v?(0,I.localize)(60,null,Math.round(l/(1e3*A))):(0,I.localize)(61,null,Math.round(l/(1e3*A))):(0,I.localize)(62,null,Math.round(l/(1e3*O)))}function y(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ae[142],Re([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Ae[43],Re([1,0,18,17,142]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=$,e.$cj=k,e.$dj=T;function O(y,l){return l&&(y.stack||y.stacktrace)?A.localize(0,null,p(y),M(y.stack)||M(y.stacktrace)):p(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function p(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?A.localize(1,null,y.message):y.message||A.localize(2,null)}function $(y=null,l=!1){if(!y)return A.localize(3,null);if(Array.isArray(y)){const v=I.$Hb(y),m=$(v[0],l);return v.length>1?A.localize(4,null,m,v.length):m}if(N.$4f(y))return y;if(y.detail){const v=y.detail;if(v.error)return O(v.error,l);if(v.exception)return O(v.exception,l)}return y.stack?O(y,l):y.message?y.message:A.localize(5,null)}function k(y){const l=y;return l instanceof Error&&Array.isArray(l.actions)}function T(y,l){let v;return typeof y=="string"?v=new Error(y):v=y,v.actions=l,v}}),define(Ae[143],Re([1,0,41,19]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=p,e.$_q=$,e.$ar=k,e.$br=T,e.$cr=y,e.$dr=l,e.$er=v,e.$fr=m,e.$gr=s,e.$hr=o,e.$ir=u,e.$jr=S,e.$kr=h;const A=new I.$V(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),O=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(E,g,D=!1){const w=E||"",C=g||"",P=A.value.collator.compare(w,C);return A.value.collatorIsNumeric&&P===0&&w!==C?w<C?-1:1:P}function $(E,g){const D=O.value.collator;return E=E||"",g=g||"",a(D,E,g)}function k(E,g){const D=O.value.collator;return E=E||"",g=g||"",c(E,g)||a(D,E,g)}function T(E,g){const D=O.value.collator;return E=E||"",g=g||"",b(E,g)||a(D,E,g)}function y(E,g){return E=E||"",g=g||"",E===g?0:E<g?-1:1}function l(E,g){const[D,w]=r(E),[C,P]=r(g);let V=A.value.collator.compare(w,P);if(V===0){if(A.value.collatorIsNumeric&&w!==P)return w<P?-1:1;if(V=A.value.collator.compare(D,C),A.value.collatorIsNumeric&&V===0&&D!==C)return D<C?-1:1}return V}function v(E,g){E=E||"",g=g||"";const D=t(E),w=t(g),C=O.value.collator,P=M.value.collator;return a(P,D,w)||a(C,E,g)}function m(E,g){E=E||"",g=g||"";const D=t(E),w=t(g),C=O.value.collator,P=M.value.collator;return a(P,D,w)||c(E,g)||a(C,E,g)}function s(E,g){E=E||"",g=g||"";const D=t(E),w=t(g),C=O.value.collator,P=M.value.collator;return a(P,D,w)||b(E,g)||a(C,E,g)}function o(E,g){E=E||"",g=g||"";const D=t(E).toLowerCase(),w=t(g).toLowerCase();return D!==w?D<w?-1:1:E!==g?E<g?-1:1:0}const n=/^(.*?)(\.([^.]*))?$/;function r(E,g=!1){const D=E?n.exec(E):[];let w=[D&&D[1]||"",D&&D[3]||""];return g&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function t(E){const g=E?n.exec(E):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function a(E,g,D){const w=E.compare(g,D);return w!==0?w:g.length!==D.length?g.length<D.length?-1:1:0}function d(E){const g=E.charAt(0);return g.toLocaleUpperCase()!==g}function i(E){const g=E.charAt(0);return g.toLocaleLowerCase()!==g}function b(E,g){return d(E)&&i(g)?-1:i(E)&&d(g)?1:0}function c(E,g){return i(E)&&d(g)?-1:d(E)&&i(g)?1:0}function f(E,g,D=!1){return D||(E=E&&E.toLowerCase(),g=g&&g.toLowerCase()),E===g?0:E<g?-1:1}function u(E,g,D=!1){const w=E.split(N.sep),C=g.split(N.sep),P=w.length-1,V=C.length-1;let W,q;for(let R=0;;R++){if(W=P===R,q=V===R,W&&q)return p(w[R],C[R],D);if(W)return-1;if(q)return 1;const U=f(w[R],C[R],D);if(U!==0)return U}}function S(E,g,D){const w=E.toLowerCase(),C=g.toLowerCase(),P=h(E,g,D);if(P)return P;const V=w.endsWith(D),W=C.endsWith(D);if(V!==W)return V?-1:1;const q=p(w,C);return q!==0?q:w.localeCompare(C)}function h(E,g,D){const w=E.toLowerCase(),C=g.toLowerCase(),P=w.startsWith(D),V=C.startsWith(D);if(P!==V)return P?-1:1;if(P&&V){if(w.length<C.length)return-1;if(w.length>C.length)return 1}return 0}}),define(Ae[47],Re([1,0,19,21,15,17]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=M,e.$kg=p,e.$lg=$,e.$mg=k,e.$ng=T,e.$og=m,e.$pg=s,e.$qg=o,e.$rg=n,e.$sg=r,e.$tg=t,e.$ug=a,e.$vg=d,e.$wg=i,e.$xg=b,e.$yg=u;function M(S){return S===47||S===92}function p(S){return S.replace(/[\\/]/g,I.$hc.sep)}function $(S){return S.indexOf("/")===-1&&(S=p(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}function k(S,h=I.$hc.sep){if(!S)return"";const E=S.length,g=S.charCodeAt(0);if(M(g)){if(M(S.charCodeAt(1))&&!M(S.charCodeAt(2))){let w=3;const C=w;for(;w<E&&!M(S.charCodeAt(w));w++);if(C!==w&&!M(S.charCodeAt(w+1))){for(w+=1;w<E;w++)if(M(S.charCodeAt(w)))return S.slice(0,w+1).replace(/[\\/]/g,h)}}return h}else if(n(g)&&S.charCodeAt(1)===58)return M(S.charCodeAt(2))?S.slice(0,2)+h:S.slice(0,2);let D=S.indexOf("://");if(D!==-1){for(D+=3;D<E;D++)if(M(S.charCodeAt(D)))return S.slice(0,D+1)}return""}function T(S){if(!N.$i||!S||S.length<5)return!1;let h=S.charCodeAt(0);if(h!==92||(h=S.charCodeAt(1),h!==92))return!1;let E=2;const g=E;for(;E<S.length&&(h=S.charCodeAt(E),h!==92);E++);return!(g===E||(h=S.charCodeAt(E+1),isNaN(h)||h===92))}const y=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(S,h=N.$i){const E=h?y:l;return!(!S||S.length===0||/^\s+$/.test(S)||(E.lastIndex=0,E.test(S))||h&&v.test(S)||S==="."||S===".."||h&&S[S.length-1]==="."||h&&S.length!==S.trim().length||S.length>255)}function s(S,h,E){const g=S===h;return!E||g?g:!S||!h?!1:(0,A.$tf)(S,h)}function o(S,h,E,g=I.sep){if(S===h)return!0;if(!S||!h||h.length>S.length)return!1;if(E){if(!(0,A.$uf)(S,h))return!1;if(h.length===S.length)return!0;let w=h.length;return h.charAt(h.length-1)===g&&w--,S.charAt(w)===g}return h.charAt(h.length-1)!==g&&(h+=g),S.indexOf(h)===0}function n(S){return S>=65&&S<=90||S>=97&&S<=122}function r(S,h){return N.$i&&S.endsWith(":")&&(S+=I.sep),(0,I.$jc)(S)||(S=(0,I.$kc)(h,S)),S=(0,I.$ic)(S),N.$i?(S=(0,A.$bf)(S,I.sep),S.endsWith(":")&&(S+=I.sep)):(S=(0,A.$bf)(S,I.sep),S||(S=I.sep)),S}function t(S){const h=(0,I.$ic)(S);return N.$i?S.length>3?!1:a(h)&&(S.length===2||h.charCodeAt(2)===92):h===I.$hc.sep}function a(S,h=N.$i){return h?n(S.charCodeAt(0))&&S.charCodeAt(1)===58:!1}function d(S,h=N.$i){return a(S,h)?S[0]:void 0}function i(S,h,E){return h.length>S.length?-1:S===h?0:(E&&(S=S.toLowerCase(),h=h.toLowerCase()),S.indexOf(h))}function b(S){const h=S.split(":");let E,g,D;for(const w of h){const C=Number(w);(0,O.$8f)(C)?g===void 0?g=C:D===void 0&&(D=C):E=E?[E,w].join(":"):w}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:g!==void 0?g:void 0,column:D!==void 0?D:g!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(S,h,E=8){let g="";for(let w=0;w<E;w++){let C;w===0&&N.$i&&!h&&(E===3||E===4)?C=f:C=c,g+=C.charAt(Math.floor(Math.random()*C.length))}let D;return h?D=`${h}-${g}`:D=g,S?(0,I.$kc)(S,D):D}}),define(Ae[69],Re([1,0,19]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=O,e.$Js=M,e.$Ks=p,e.$Ls=k,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(T){const y=(0,I.$pc)(T),l=N[y.toLowerCase()];return l!==void 0?l:M(T)}function M(T){const y=(0,I.$pc)(T);return A[y.toLowerCase()]}function p(T){for(const y in A)if(A[y]===T)return y}const $=/^(.+)\/(.+?)(;.+)?$/;function k(T,y){const l=$.exec(T);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:y?void 0:T}}),define(Ae[53],Re([1,0,23,2]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=A,e.$Yh=O,e.$Zh=p;function A($){return JSON.stringify($,M)}function O($){let k=JSON.parse($);return k=p(k),k}function M($,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function p($,k=0){if(!$||k>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof I.$Ce||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let T=0;T<$.length;++T)$[T]=p($[T],k+1);else for(const T in $)Object.hasOwnProperty.call($,T)&&($[T]=p($[T],k+1))}return $}}),define(Ae[12],Re([1,0,14,21,15,2,19]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=$,e.$Ag=k,e.$Eg=y;var p;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.commentsInput="comment",m.codeSetting="code-setting"})(p||(e.Schemas=p={}));function $(m,s){return O.URI.isUri(m)?(0,A.$tf)(m.scheme,s):(0,A.$uf)(m,s+":")}function k(m,...s){return s.some(o=>$(m,o))}e.$Bg="vscode-tkn",e.$Cg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=y(s,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,p.vscodeRemoteResource)}set(s,o,n){this.a[s]=o,this.b[s]=n}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(d){return I.$1(d),s}const o=s.authority;let n=this.a[o];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this.b[o],t=this.c[o];let a=`path=${encodeURIComponent(s.path)}`;return typeof t=="string"&&(a+=`&${e.$Cg}=${encodeURIComponent(t)}`),O.URI.from({scheme:N.$o?this.d:p.vscodeRemoteResource,authority:`${n}:${r}`,path:this.g,query:a})}}e.$Dg=new T;function y(m,s){return M.$hc.join(s??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class l{static{this.a=e.$Jg}asBrowserUri(s){const o=this.b(s,fe);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===p.vscodeRemote?e.$Dg.rewrite(s):s.scheme===p.file&&(N.$m||N.$q===`${p.vscodeFileResource}://${l.a}`)?s.with({scheme:p.vscodeFileResource,authority:s.authority||l.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,fe);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===p.vscodeFileResource?s.with({scheme:p.file,authority:s.authority!==l.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return O.URI.isUri(s)?s:O.URI.parse(o.toUrl(s))}}e.$Kg=new l;var v;(function(m){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function n(t){let a;typeof t=="string"?a=new URL(t).searchParams:t instanceof URL?a=t.searchParams:O.URI.isUri(t)&&(a=new URL(t.toString(!0)).searchParams);const d=a?.get(o);if(d)return s.get(d)}m.getHeadersFromQuery=n;function r(t,a,d){if(!globalThis.crossOriginIsolated)return;const i=a&&d?"3":d?"2":"1";t instanceof URLSearchParams?t.set(o,i):t[o]=i}m.addSearchParam=r})(v||(e.COI=v={}))}),define(Ae[24],Re([1,0,47,12,19,21,15,2]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=$,e.$ah=T,e.$bh=l;function $(v){return(0,p.$xc)(v,!0)}class k{constructor(m){this.a=m}compare(m,s,o=!1){return m===s?0:(0,M.$mf)(this.getComparisonKey(m,o),this.getComparisonKey(s,o))}isEqual(m,s,o=!1){return m===s?!0:!m||!s?!1:this.getComparisonKey(m,o)===this.getComparisonKey(s,o)}getComparisonKey(m,s=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,s,o=!1){if(m.scheme===s.scheme){if(m.scheme===N.Schemas.file)return I.$qg($(m),$(s),this.a(m))&&m.query===s.query&&(o||m.fragment===s.fragment);if((0,e.$9g)(m.authority,s.authority))return I.$qg(m.path,s.path,this.a(m),"/")&&m.query===s.query&&(o||m.fragment===s.fragment)}return!1}joinPath(m,...s){return p.URI.joinPath(m,...s)}basenameOrAuthority(m){return(0,e.$1g)(m)||m.authority}basename(m){return A.$hc.basename(m.path)}extname(m){return A.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let s;return m.scheme===N.Schemas.file?s=p.URI.file(A.$nc($(m))).path:(s=A.$hc.dirname(m.path),m.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),s="/")),m.with({path:s})}normalizePath(m){if(!m.path.length)return m;let s;return m.scheme===N.Schemas.file?s=p.URI.file(A.$ic($(m))).path:s=A.$hc.normalize(m.path),m.with({path:s})}relativePath(m,s){if(m.scheme!==s.scheme||!(0,e.$9g)(m.authority,s.authority))return;if(m.scheme===N.Schemas.file){const r=A.$mc($(m),$(s));return O.$i?I.$kg(r):r}let o=m.path||"/";const n=s.path||"/";if(this.a(m)){let r=0;for(const t=Math.min(o.length,n.length);r<t&&!(o.charCodeAt(r)!==n.charCodeAt(r)&&o.charAt(r).toLowerCase()!==n.charAt(r).toLowerCase());r++);o=n.substr(0,r)+o.substr(r)}return A.$hc.relative(o,n)}resolvePath(m,s){if(m.scheme===N.Schemas.file){const o=p.URI.file(A.$lc($(m),s));return m.with({authority:o.authority,path:o.path})}return s=I.$lg(s),m.with({path:A.$hc.resolve(m.path,s)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,s){return m===s||m!==void 0&&s!==void 0&&(0,M.$tf)(m,s)}hasTrailingPathSeparator(m,s=A.sep){if(m.scheme===N.Schemas.file){const o=$(m);return o.length>I.$mg(o).length&&o[o.length-1]===s}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,s=A.sep){return(0,e.$0g)(m,s)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,s=A.sep){let o=!1;if(m.scheme===N.Schemas.file){const n=$(m);o=n!==void 0&&n.length===I.$mg(n).length&&n[n.length-1]===s}else{s="/";const n=m.path;o=n.length===1&&n.charCodeAt(n.length-1)===47}return!o&&!(0,e.$0g)(m,s)?m.with({path:m.path+"/"}):m}}e.$Sg=k,e.$Tg=new k(()=>!1),e.$Ug=new k(v=>v.scheme===N.Schemas.file?!O.$k:!0),e.$Vg=new k(v=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function T(v,m){const s=[];for(let o=0;o<v.length;o++){const n=m(v[o]);v.some((r,t)=>t===o?!1:(0,e.$Xg)(n,m(r)))||s.push(v[o])}return s}var y;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function m(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(t=>{const[a,d]=t.split(":");a&&d&&o.set(a,d)});const r=s.path.substring(0,s.path.indexOf(";"));return r&&o.set(v.META_DATA_MIME,r),o}v.parseMetaData=m})(y||(e.DataUri=y={}));function l(v,m,s){if(m){let o=v.path;return o&&o[0]!==A.$hc.sep&&(o=A.$hc.sep+o),v.with({scheme:s,authority:m,path:o})}return v.with({scheme:s})}}),define(Ae[11],Re([1,0,22,14,5,6,24,21,130,41]),function(fe,e,I,N,A,O,M,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=T,e.$dh=y,e.$eh=l,e.$fh=v,e.$gh=m,e.$hh=s,e.$ih=o,e.$jh=n,e.$rh=S,e.$sh=h,e.$th=E,e.$uh=g,e.$vh=D,e.$Kh=Ie,e.$Sh=ke;function T(ge){return!!ge&&typeof ge.then=="function"}function y(ge){const J=new I.$me,Y=ge(J.token),he=new Promise((le,Ne)=>{const de=J.token.onCancellationRequested(()=>{de.dispose(),Ne(new N.$5)});Promise.resolve(Y).then(Ce=>{de.dispose(),J.dispose(),le(Ce)},Ce=>{de.dispose(),J.dispose(),Ne(Ce)})});return new class{cancel(){J.cancel(),J.dispose()}then(le,Ne){return he.then(le,Ne)}catch(le){return this.then(void 0,le)}finally(le){return he.finally(le)}}}function l(ge,J,Y){return new Promise((he,le)=>{const Ne=J.onCancellationRequested(()=>{Ne.dispose(),he(Y)});ge.then(he,le).finally(()=>Ne.dispose())})}function v(ge,J){return new Promise((Y,he)=>{const le=J.onCancellationRequested(()=>{le.dispose(),he(new N.$5)});ge.then(Y,he).finally(()=>le.dispose())})}async function m(ge){let J=-1;const Y=ge.map((he,le)=>he.then(Ne=>(J=le,Ne)));try{return await Promise.race(Y)}finally{ge.forEach((he,le)=>{le!==J&&he.cancel()})}}function s(ge,J,Y){let he;const le=setTimeout(()=>{he?.(void 0),Y?.()},J);return Promise.race([ge.finally(()=>clearTimeout(le)),new Promise(Ne=>he=Ne)])}function o(ge){return new Promise((J,Y)=>{const he=ge();T(he)?he.then(J,Y):J(he)})}function n(){let ge,J;return{promise:new Promise((he,le)=>{ge=he,J=le}),resolve:ge,reject:J}}class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=J(),new Promise((Y,he)=>{this.a.then(le=>{this.a=null,Y(le)},le=>{this.a=null,he(le)})})}dispose(){this.f=!0}}e.$kh=r;class t{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$lh=t;class a{constructor(){this.a=new Map}queue(J,Y){const le=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(J)===le&&this.a.delete(J)});return this.a.set(J,le),le}}e.$mh=a;const d=(ge,J)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,J()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},i=ge=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ge())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class b{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,Y=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((le,Ne)=>{this.d=le,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const le=this.g;return this.g=null,le()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===$.$$d?i(he):d(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=b;class c{constructor(J){this.a=new b(J),this.b=new r}trigger(J,Y){return this.a.trigger(()=>this.b.queue(J),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=c;class f{constructor(){this.a=!1,this.b=new Promise((J,Y)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=f;class u extends f{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$qh=u;function S(ge,J){return J?new Promise((Y,he)=>{const le=setTimeout(()=>{Ne.dispose(),Y()},ge),Ne=J.onCancellationRequested(()=>{clearTimeout(le),Ne.dispose(),he(new N.$5)})}):y(Y=>S(ge,Y))}function h(ge,J=0,Y){const he=setTimeout(()=>{ge(),Y&&le.dispose()},J),le=(0,O.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(le)});return Y?.add(le),le}function E(ge){const J=[];let Y=0;const he=ge.length;function le(){return Y<he?ge[Y++]():null}function Ne(de){de!=null&&J.push(de);const Ce=le();return Ce?Ce.then(Ne):Promise.resolve(J)}return Promise.resolve(null).then(Ne)}function g(ge,J=he=>!!he,Y=null){let he=0;const le=ge.length,Ne=()=>{if(he>=le)return Promise.resolve(Y);const de=ge[he++];return Promise.resolve(de()).then(Me=>J(Me)?Promise.resolve(Me):Ne())};return Ne()}function D(ge,J=he=>!!he,Y=null){if(ge.length===0)return Promise.resolve(Y);let he=ge.length;const le=()=>{he=-1;for(const Ne of ge)Ne.cancel?.()};return new Promise((Ne,de)=>{for(const Ce of ge)Ce.then(Me=>{--he>=0&&J(Me)?(le(),Ne(Me)):he===0&&Ne(Y)}).catch(Me=>{--he>=0&&(le(),de(Me))})})}class w{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new A.$be}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:J,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const Y=J.factory();Y.then(J.c,J.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=w;class C extends w{constructor(){super(1)}}e.$xh=C;class P{constructor(){this.a=new ue,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$yh=P;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new Pe;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,Y=M.$Tg){const he=Y.getComparisonKey(J);return this.a.get(he)?.size??0}queueFor(J,Y,he=M.$Tg){const le=he.getComparisonKey(J);let Ne=this.a.get(le);if(!Ne){Ne=new C;const de=this.f++,Ce=A.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(le),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(de,Ce),this.a.set(le,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=V;class W{constructor(J,Y){this.a=-1,typeof J=="function"&&typeof Y=="number"&&this.setIfNotSet(J,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},Y)}setIfNotSet(J,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},Y))}}e.$Ah=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,Y,he=globalThis){this.cancel();const le=he.setInterval(()=>{J()},Y);this.d=(0,O.$Sc)(()=>{he.clearInterval(le),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=q;class R{constructor(J,Y){this.b=-1,this.a=J,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=R;class U{constructor(J,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=J,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=U;class K extends R{constructor(J,Y){super(J,Y),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Eh=K;class se extends O.$Uc{constructor(J,Y){super(),this.g=J,this.h=Y,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of J)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(ge,J)=>{(0,p.$B)(()=>{if(Y)return;const he=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Hh=(ge,J,Y)=>{const he=ge.requestIdleCallback(J,typeof Y=="number"?{timeout:Y}:void 0);let le=!1;return{dispose(){le||(le=!0,ge.cancelIdleCallback(he))}}},e.$Gh=ge=>(0,e.$Hh)(globalThis,ge)}();class ce{constructor(J,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Hh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=ce;class ve extends ce{constructor(J){super(globalThis,J)}}e.$Jh=ve;async function Ie(ge,J,Y){let he;for(let le=0;le<Y;le++)try{return await ge()}catch(Ne){he=Ne,await S(J)}throw he}class ue{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,Y,he){return this.a={taskId:J,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(J),()=>this.d(J)),Y}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:Y,resolve:he,reject:le}=n();this.b={run:J,promise:Y,promiseResolve:he,promiseReject:le}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=ue;class be{constructor(J,Y=()=>Date.now()){this.d=J,this.f=Y,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Mh=be;var ie;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(ie||(ie={}));class Pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,Y)=>{this.a=J,this.b=Y})}complete(J){return new Promise(Y=>{this.a(J),this.d={outcome:0,value:J},Y()})}error(J){return new Promise(Y=>{this.b(J),this.d={outcome:1,value:J},Y()})}cancel(){return this.error(new N.$5)}}e.$Nh=Pe;var Fe;(function(ge){async function J(he){let le;const Ne=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{le||(le=Ce)})));if(typeof le<"u")throw le;return Ne}ge.settled=J;function Y(he){return new Promise(async(le,Ne)=>{try{await he(le,Ne)}catch(de){Ne(de)}})}ge.withAsyncBody=Y})(Fe||(e.Promises=Fe={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=ne;class j{constructor(J){this.b=J,this.a=new k.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=j;var x;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(x||(x={}));class pe{static fromArray(J){return new pe(Y=>{Y.emitMany(J)})}static fromPromise(J){return new pe(async Y=>{Y.emitMany(await J)})}static fromPromises(J){return new pe(async Y=>{await Promise.all(J.map(async he=>Y.emitOne(await he)))})}static merge(J){return new pe(async Y=>{await Promise.all(J.map(async he=>{for await(const le of he)Y.emitOne(le)}))})}static{this.EMPTY=pe.fromArray([])}constructor(J,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new A.$be,queueMicrotask(async()=>{const he={emitOne:le=>this.h(le),emitMany:le=>this.j(le),reject:le=>this.l(le)};try{await Promise.resolve(J(he)),this.k()}catch(le){this.l(le)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,Y){return new pe(async he=>{for await(const le of J)he.emitOne(Y(le))})}map(J){return pe.map(this,J)}static filter(J,Y){return new pe(async he=>{for await(const le of J)Y(le)&&he.emitOne(le)})}filter(J){return pe.filter(this,J)}static coalesce(J){return pe.filter(J,Y=>!!Y)}coalesce(){return pe.coalesce(this)}static async toPromise(J){const Y=[];for await(const he of J)Y.push(he);return Y}toPromise(){return pe.toPromise(this)}h(J){this.a===0&&(this.b.push(J),this.g.fire())}j(J){this.a===0&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(J){this.a===0&&(this.a=2,this.d=J,this.g.fire())}}e.$Qh=pe;class Oe extends pe{constructor(J,Y){super(Y),this.m=J}cancel(){this.m.cancel()}}e.$Rh=Oe;function ke(ge){const J=new I.$me,Y=ge(J.token);return new Oe(J,async he=>{const le=J.token.onCancellationRequested(()=>{le.dispose(),J.dispose(),he.reject(new N.$5)});try{for await(const Ne of Y){if(J.token.isCancellationRequested)return;he.emitOne(Ne)}le.dispose(),J.dispose()}catch(Ne){le.dispose(),J.dispose(),he.reject(Ne)}})}class $e{constructor(J){this.a=new Pe,this.b=new pe(le=>{if(Y){le.reject(Y);return}return he&&le.emitMany(he),this.d=Ne=>le.reject(Ne),this.f=Ne=>le.emitOne(Ne),this.a.p},J);let Y,he;this.f=le=>{he||(he=[]),he.push(le)},this.d=le=>{Y||(Y=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Th=$e}),define(Ae[36],Re([1,0,18,11,47,28,19,21,15]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=k,e.$ik=m,e.$jk=C,e.$kk=P,e.$lk=V,e.$mk=W,e.$nk=q,e.$ok=se;function k(){return Object.create(null)}e.$gk="**",e.$hk="/";const T="[/\\\\]",y="[^/\\\\]",l=/\//g;function v(ce,ve){switch(ce){case 0:return"";case 1:return`${y}*?`;default:return`(?:${T}|${y}+${T}${ve?`|${T}${y}+`:""})*?`}}function m(ce,ve){if(!ce)return[];const Ie=[];let ue=!1,be=!1,ie="";for(const Pe of ce){switch(Pe){case ve:if(!ue&&!be){Ie.push(ie),ie="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":be=!0;break;case"]":be=!1;break}ie+=Pe}return ie&&Ie.push(ie),Ie}function s(ce){if(!ce)return"";let ve="";const Ie=m(ce,e.$hk);if(Ie.every(ue=>ue===e.$gk))ve=".*";else{let ue=!1;Ie.forEach((be,ie)=>{if(be===e.$gk){if(ue)return;ve+=v(2,ie===Ie.length-1)}else{let Pe=!1,Fe="",ne=!1,j="";for(const x of be){if(x!=="}"&&Pe){Fe+=x;continue}if(ne&&(x!=="]"||!j)){let pe;x==="-"?pe=x:(x==="^"||x==="!")&&!j?pe="^":x===e.$hk?pe="":pe=(0,$.$8e)(x),j+=pe;continue}switch(x){case"{":Pe=!0;continue;case"[":ne=!0;continue;case"}":{const Oe=`(?:${m(Fe,",").map(ke=>s(ke)).join("|")})`;ve+=Oe,Pe=!1,Fe="";break}case"]":{ve+="["+j+"]",ne=!1,j="";break}case"?":ve+=y;continue;case"*":ve+=v(1);continue;default:ve+=(0,$.$8e)(x)}}ie<Ie.length-1&&(Ie[ie+1]!==e.$gk||ie+2<Ie.length)&&(ve+=T)}ue=be===e.$gk})}return ve}const o=/^\*\*\/\*\.[\w\.-]+$/,n=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,t=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.$Ec(1e4),b=function(){return!1},c=function(){return null};function f(ce,ve){if(!ce)return c;let Ie;typeof ce!="string"?Ie=ce.pattern:Ie=ce,Ie=Ie.trim();const ue=`${Ie}_${!!ve.trimForExclusions}`;let be=i.get(ue);if(be)return u(be,ce);let ie;return o.test(Ie)?be=h(Ie.substr(4),Ie):(ie=n.exec(S(Ie,ve)))?be=E(ie[1],Ie):(ve.trimForExclusions?t:r).test(Ie)?be=g(Ie,ve):(ie=a.exec(S(Ie,ve)))?be=D(ie[1].substr(1),Ie,!0):(ie=d.exec(S(Ie,ve)))?be=D(ie[1],Ie,!1):be=w(Ie),i.set(ue,be),u(be,ce)}function u(ce,ve){if(typeof ve=="string")return ce;const Ie=function(ue,be){return(0,A.$qg)(ue,ve.base,!p.$k)?ce((0,$.$af)(ue.substr(ve.base.length),M.sep),be):null};return Ie.allBasenames=ce.allBasenames,Ie.allPaths=ce.allPaths,Ie.basenames=ce.basenames,Ie.patterns=ce.patterns,Ie}function S(ce,ve){return ve.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function h(ce,ve){return function(Ie,ue){return typeof Ie=="string"&&Ie.endsWith(ce)?ve:null}}function E(ce,ve){const Ie=`/${ce}`,ue=`\\${ce}`,be=function(Pe,Fe){return typeof Pe!="string"?null:Fe?Fe===ce?ve:null:Pe===ce||Pe.endsWith(Ie)||Pe.endsWith(ue)?ve:null},ie=[ce];return be.basenames=ie,be.patterns=[ve],be.allBasenames=ie,be}function g(ce,ve){const Ie=K(ce.slice(1,-1).split(",").map(Fe=>f(Fe,ve)).filter(Fe=>Fe!==c),ce),ue=Ie.length;if(!ue)return c;if(ue===1)return Ie[0];const be=function(Fe,ne){for(let j=0,x=Ie.length;j<x;j++)if(Ie[j](Fe,ne))return ce;return null},ie=Ie.find(Fe=>!!Fe.allBasenames);ie&&(be.allBasenames=ie.allBasenames);const Pe=Ie.reduce((Fe,ne)=>ne.allPaths?Fe.concat(ne.allPaths):Fe,[]);return Pe.length&&(be.allPaths=Pe),be}function D(ce,ve,Ie){const ue=M.sep===M.$hc.sep,be=ue?ce:ce.replace(l,M.sep),ie=M.sep+be,Pe=M.$hc.sep+ce;let Fe;return Ie?Fe=function(ne,j){return typeof ne=="string"&&(ne===be||ne.endsWith(ie)||!ue&&(ne===ce||ne.endsWith(Pe)))?ve:null}:Fe=function(ne,j){return typeof ne=="string"&&(ne===be||!ue&&ne===ce)?ve:null},Fe.allPaths=[(Ie?"*/":"./")+ce],Fe}function w(ce){try{const ve=new RegExp(`^${s(ce)}$`);return function(Ie){return ve.lastIndex=0,typeof Ie=="string"&&ve.test(Ie)?ce:null}}catch{return c}}function C(ce,ve,Ie){return!ce||typeof ve!="string"?!1:P(ce)(ve,void 0,Ie)}function P(ce,ve={}){if(!ce)return b;if(typeof ce=="string"||V(ce)){const Ie=f(ce,ve);if(Ie===c)return b;const ue=function(be,ie){return!!Ie(be,ie)};return Ie.allBasenames&&(ue.allBasenames=Ie.allBasenames),Ie.allPaths&&(ue.allPaths=Ie.allPaths),ue}return R(ce,ve)}function V(ce){const ve=ce;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function W(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function R(ce,ve){const Ie=K(Object.getOwnPropertyNames(ce).map(Fe=>U(Fe,ce[Fe],ve)).filter(Fe=>Fe!==c)),ue=Ie.length;if(!ue)return c;if(!Ie.some(Fe=>!!Fe.requiresSiblings)){if(ue===1)return Ie[0];const Fe=function(x,pe){let Oe;for(let ke=0,$e=Ie.length;ke<$e;ke++){const ge=Ie[ke](x,pe);if(typeof ge=="string")return ge;(0,N.$ch)(ge)&&(Oe||(Oe=[]),Oe.push(ge))}return Oe?(async()=>{for(const ke of Oe){const $e=await ke;if(typeof $e=="string")return $e}return null})():null},ne=Ie.find(x=>!!x.allBasenames);ne&&(Fe.allBasenames=ne.allBasenames);const j=Ie.reduce((x,pe)=>pe.allPaths?x.concat(pe.allPaths):x,[]);return j.length&&(Fe.allPaths=j),Fe}const be=function(Fe,ne,j){let x,pe;for(let Oe=0,ke=Ie.length;Oe<ke;Oe++){const $e=Ie[Oe];$e.requiresSiblings&&j&&(ne||(ne=(0,M.$oc)(Fe)),x||(x=ne.substr(0,ne.length-(0,M.$pc)(Fe).length)));const ge=$e(Fe,ne,x,j);if(typeof ge=="string")return ge;(0,N.$ch)(ge)&&(pe||(pe=[]),pe.push(ge))}return pe?(async()=>{for(const Oe of pe){const ke=await Oe;if(typeof ke=="string")return ke}return null})():null},ie=Ie.find(Fe=>!!Fe.allBasenames);ie&&(be.allBasenames=ie.allBasenames);const Pe=Ie.reduce((Fe,ne)=>ne.allPaths?Fe.concat(ne.allPaths):Fe,[]);return Pe.length&&(be.allPaths=Pe),be}function U(ce,ve,Ie){if(ve===!1)return c;const ue=f(ce,Ie);if(ue===c)return c;if(typeof ve=="boolean")return ue;if(ve){const be=ve.when;if(typeof be=="string"){const ie=(Pe,Fe,ne,j)=>{if(!j||!ue(Pe,Fe))return null;const x=be.replace("$(basename)",()=>ne),pe=j(x);return(0,N.$ch)(pe)?pe.then(Oe=>Oe?ce:null):pe?ce:null};return ie.requiresSiblings=!0,ie}}return ue}function K(ce,ve){const Ie=ce.filter(Fe=>!!Fe.basenames);if(Ie.length<2)return ce;const ue=Ie.reduce((Fe,ne)=>{const j=ne.basenames;return j?Fe.concat(j):Fe},[]);let be;if(ve){be=[];for(let Fe=0,ne=ue.length;Fe<ne;Fe++)be.push(ve)}else be=Ie.reduce((Fe,ne)=>{const j=ne.patterns;return j?Fe.concat(j):Fe},[]);const ie=function(Fe,ne){if(typeof Fe!="string")return null;if(!ne){let x;for(x=Fe.length;x>0;x--){const pe=Fe.charCodeAt(x-1);if(pe===47||pe===92)break}ne=Fe.substr(x)}const j=ue.indexOf(ne);return j!==-1?be[j]:null};ie.basenames=ue,ie.patterns=be,ie.allBasenames=ue;const Pe=ce.filter(Fe=>!Fe.basenames);return Pe.push(ie),Pe}function se(ce,ve){return(0,I.$ub)(ce,ve,(Ie,ue)=>typeof Ie=="string"&&typeof ue=="string"?Ie===ue:typeof Ie!="string"&&typeof ue!="string"?Ie.base===ue.base&&Ie.pattern===ue.pattern:!1)}}),define(Ae[54],Re([1,0,14,131,24,15,2]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ok=k,e.$Pk=T,e.$Qk=y,e.$Rk=l,e.$Sk=v,e.$Tk=m,e.$Uk=s,e.$Vk=o;var p;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class ${constructor(r="",t=!1){if(this.value=r,typeof this.value!="string")throw(0,I.$7)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(r,t=0){return this.value+=l(this.supportThemeIcons?(0,N.$Hk)(r):r).replace(/([ \t]+)/g,(a,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,t){return this.value+=`
${v(t,r)}
`,this}appendLink(r,t,a){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(r),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(r,t){const a=new RegExp((0,O.$8e)(t),"g");return r.replace(a,(d,i)=>r.charAt(i-1)!=="\\"?`\\${d}`:d)}}e.$Nk=$;function k(n){return T(n)?!n.value:Array.isArray(n)?n.every(k):!0}function T(n){return n instanceof $?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}function y(n,r){return n===r?!0:!n||!r?!1:n.value===r.value&&n.isTrusted===r.isTrusted&&n.supportThemeIcons===r.supportThemeIcons&&n.supportHtml===r.supportHtml&&(n.baseUri===r.baseUri||!!n.baseUri&&!!r.baseUri&&(0,A.$Wg)(M.URI.from(n.baseUri),M.URI.from(r.baseUri)))}function l(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function v(n,r){const t=n.match(/^`+/gm)?.reduce((d,i)=>d.length>i.length?d:i).length??0,a=t>=3?t+1:3;return[`${"`".repeat(a)}${r}`,n,`${"`".repeat(a)}`].join(`
`)}function m(n){return n.replace(/"/g,"&quot;")}function s(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(n){const r=[],t=n.split("|").map(d=>d.trim());n=t[0];const a=t[1];if(a){const d=/height=(\d+)/.exec(a),i=/width=(\d+)/.exec(a),b=d?d[1]:"",c=i?i[1]:"",f=isFinite(parseInt(c)),u=isFinite(parseInt(b));f&&r.push(`width="${c}"`),u&&r.push(`height="${b}"`)}return{href:n,dimensions:r}}}),define(Ae[96],Re([1,0,18,47,19,21,24,15]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=$,e.$pw=T,e.$qw=l,e.$rw=v,e.$sw=n,e.$tw=t,e.$uw=a,e.$vw=d,e.$ww=i,e.$xw=b;function $(f,u){const{os:S,tildify:h,relative:E}=u;if(E){const w=k(f,E,S);if(typeof w=="string")return w}let g=f.fsPath;if(S===1&&!O.$i?g=g.replace(/\//g,"\\"):S!==1&&O.$i&&(g=g.replace(/\\/g,"/")),S!==1&&h?.userHome){const w=h.userHome.fsPath;let C;f.scheme!==h.userHome.scheme&&f.path[0]===A.$hc.sep&&f.path[1]!==A.$hc.sep?C=h.userHome.with({path:f.path}).fsPath:C=g,g=l(C,w,S)}return(S===1?A.$gc:A.$hc).normalize(T(g,S===1))}function k(f,u,S){const h=S===1?A.$gc:A.$hc,E=S===3?M.$Tg:M.$Vg,g=u.getWorkspace(),D=(0,I.$Ob)(g.folders);if(!D)return;f.scheme!==D.uri.scheme&&f.path[0]===A.$hc.sep&&f.path[1]!==A.$hc.sep&&(f=D.uri.with({path:f.path}));const w=u.getWorkspaceFolder(f);if(!w)return;let C;if(E.isEqual(w.uri,f)?C="":C=E.relativePath(w.uri,f)??"",C&&(C=h.normalize(C)),g.folders.length>1&&!u.noPrefix){const P=w.name?w.name:E.basenameOrAuthority(w.uri);C=C?`${P} \u2022 ${C}`:P}return C}function T(f,u=O.$i){return(0,N.$ug)(f,u)?f.charAt(0).toUpperCase()+f.slice(1):f}let y=Object.create(null);function l(f,u,S=O.OS){if(S===1||!f||!u)return f;let h=y.original===u?y.normalized:void 0;h||(h=u,O.$i&&(h=(0,N.$kg)(h)),h=`${(0,p.$bf)(h,A.$hc.sep)}${A.$hc.sep}`,y={original:u,normalized:h});let E=f;return O.$i&&(E=(0,N.$kg)(E)),(S===3?E.startsWith(h):(0,p.$uf)(E,h))?`~/${E.substr(h.length)}`:f}function v(f,u){return f.replace(/^~($|\/|\\)/,`${u}$1`)}const m="\u2026",s="\\\\",o="~";function n(f,u=A.sep){const S=new Array(f.length);let h=!1;for(let E=0;E<f.length;E++){const g=f[E];if(g===""){S[E]=`.${u}`;continue}if(!g){S[E]=g;continue}h=!0;let D="",w=g;w.indexOf(s)===0?(D=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(u)===0?(D=w.substr(0,w.indexOf(u)+u.length),w=w.substr(w.indexOf(u)+u.length)):w.indexOf(o)===0&&(D=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length));const C=w.split(u);for(let P=1;h&&P<=C.length;P++)for(let V=C.length-P;h&&V>=0;V--){h=!1;let W=C.slice(V,V+P).join(u);for(let q=0;!h&&q<f.length;q++)if(q!==E&&f[q]&&f[q].indexOf(W)>-1){const R=V+P===C.length,U=V>0&&f[q].indexOf(u)>-1?u+W:W,K=f[q].endsWith(U);h=!R||K}if(!h){let q="";(C[0].endsWith(":")||D!=="")&&(V===1&&(V=0,P++,W=C[0]+u+W),V>0&&(q=C[0]+u),q=D+q),V>0&&(q=q+m+u),q=q+W,V+P<C.length&&(q=q+u+m),S[E]=q}}h&&(S[E]=g)}return S}var r;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function t(f,u=Object.create(null)){const S=[];let h=!1,E="";for(const g of f)if(g==="$"||h&&g==="{")E&&S.push({value:E,type:r.TEXT}),E="",h=!0;else if(g==="}"&&h){const D=u[E];if(typeof D=="string")D.length&&S.push({value:D,type:r.VARIABLE});else if(D){const w=S[S.length-1];(!w||w.type!==r.SEPARATOR)&&S.push({value:D.label,type:r.SEPARATOR})}E="",h=!1}else E+=g;return E&&!h&&S.push({value:E,type:r.TEXT}),S.filter((g,D)=>{if(g.type===r.SEPARATOR){const w=S[D-1],C=S[D+1];return[w,C].every(P=>P&&(P.type===r.VARIABLE||P.type===r.TEXT)&&P.value.length>0)}return!0}).map(g=>g.value).join("")}function a(f,u){return O.$j||u?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):f.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function d(f,u){return O.$j||u?f.replace(/\(&&\w\)|&&/g,""):O.$i?f.replace(/&&|&/g,S=>S==="&"?"&&":"&"):f.replace(/&&/g,"_")}function i(f){return f.replace(/&/g,"&&")}function b(f){if(f.endsWith("]")){const u=f.lastIndexOf(" [",f.length-2);if(u!==-1){const S=c(f.substring(0,u)),h=f.substring(u);return{name:S.name+h,parentPath:S.parentPath}}}return c(f)}function c(f){const u=f.indexOf("/")!==-1?A.$hc:A.$gc,S=u.basename(f),h=u.dirname(f);return S.length?{name:S,parentPath:h}:{name:h,parentPath:""}}}),define(Ae[144],Re([1,0,23,2]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=p,e.$vn=k,e.$wn=T;function A(y){return y.toJSON()}class O{constructor(l){this.a=l}transformIncoming(l){const v=this.a.transformIncoming(l);return v===l?l:A(N.URI.from(v))}transformOutgoing(l){const v=this.a.transformOutgoing(l);return v===l?l:A(N.URI.from(v))}transformOutgoingURI(l){const v=this.a.transformOutgoing(l);return v===l?l:N.URI.from(v)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$sn=O,e.$tn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function M(y,l,v){if(!y||v>200)return null;if(typeof y=="object"){if(y instanceof N.URI)return l.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const s=M(y[m],l,v+1);s!==null&&(y[m]=s)}}return null}function p(y,l){const v=M(y,l,0);return v===null?y:v}function $(y,l,v,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return v?N.URI.revive(l.transformIncoming(y)):l.transformIncoming(y);if(y instanceof I.$Ce)return null;for(const s in y)if(Object.hasOwnProperty.call(y,s)){const o=$(y[s],l,v,m+1);o!==null&&(y[s]=o)}}return null}function k(y,l){const v=$(y,l,!1,0);return v===null?y:v}function T(y,l){const v=$(y,l,!0,0);return v===null?y:v}}),define(Ae[145],Re([1,0,15,21,23]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=T,e.$ut=y;let O;function M(){return O||(O=new TextDecoder("UTF-16LE")),O}let p;function $(){return p||(p=new TextDecoder("UTF-16BE")),p}let k;function T(){return k||(k=N.$D()?M():$()),k}function y(m,s,o){const n=new Uint16Array(m.buffer,s,o);return o>0&&(n[0]===65279||n[0]===65534)?l(m,s,o):M().decode(n)}function l(m,s,o){const n=[];let r=0;for(let t=0;t<o;t++){const a=A.$Ee(m,s);s+=2,n[r++]=String.fromCharCode(a)}return n.join("")}class v{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return T().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const o=this.a-this.d;o<=1&&(o===0||I.$xf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const o=s.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=s;return}for(let n=0;n<o;n++)this.b[this.d++]=s.charCodeAt(n)}}e.$vt=v}),define(Ae[146],Re([1,0,23,145]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=M;function A($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,T,y,l){this.oldPosition=k,this.oldText=T,this.newPosition=y,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,T,y){const l=T.length;I.$He(k,l,y),y+=4;for(let v=0;v<l;v++)I.$Fe(k,T.charCodeAt(v),y),y+=2;return y}static d(k,T){const y=I.$Ge(k,T);return T+=4,(0,N.$ut)(k,T,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(k,T){return I.$He(k,this.oldPosition,T),T+=4,I.$He(k,this.newPosition,T),T+=4,T=O.c(k,this.oldText,T),T=O.c(k,this.newText,T),T}static read(k,T,y){const l=I.$Ge(k,T);T+=4;const v=I.$Ge(k,T);T+=4;const m=O.d(k,T);T+=O.a(m);const s=O.d(k,T);return T+=O.a(s),y.push(new O(l,m,v,s)),T}}e.$wt=O;function M($,k){return $===null||$.length===0?k:new p($,k).compress()}class p{constructor(k,T){this.a=k,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,T=0,y=this.n(k),l=this.l(T);for(;k<this.f||T<this.h;){if(y===null){this.k(l),l=this.l(++T);continue}if(l===null){this.m(y),y=this.n(++k);continue}if(l.oldEnd<=y.newPosition){this.k(l),l=this.l(++T);continue}if(y.newEnd<=l.oldPosition){this.m(y),y=this.n(++k);continue}if(l.oldPosition<y.newPosition){const[n,r]=p.r(l,y.newPosition-l.oldPosition);this.k(n),l=r;continue}if(y.newPosition<l.oldPosition){const[n,r]=p.q(y,l.oldPosition-y.newPosition);this.m(n),y=r;continue}let s,o;if(l.oldEnd===y.newEnd)s=y,o=l,y=this.n(++k),l=this.l(++T);else if(l.oldEnd<y.newEnd){const[n,r]=p.q(y,l.oldLength);s=n,o=l,y=r,l=this.l(++T)}else{const[n,r]=p.r(l,y.newLength);s=y,o=n,y=this.n(++k),l=r}this.d[this.e++]=new O(s.oldPosition,s.oldText,o.newPosition,o.newText),this.g+=s.newLength-s.oldLength,this.j+=o.newLength-o.oldLength}const v=p.s(this.d);return p.t(v)}k(k){this.d[this.e++]=p.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=p.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,T){return new O(T.oldPosition-k,T.oldText,T.newPosition,T.newText)}static p(k,T){return new O(T.oldPosition,T.oldText,T.newPosition+k,T.newText)}static q(k,T){const y=k.newText.substr(0,T),l=k.newText.substr(T);return[new O(k.oldPosition,k.oldText,k.newPosition,y),new O(k.oldEnd,"",k.newPosition+T,l)]}static r(k,T){const y=k.oldText.substr(0,T),l=k.oldText.substr(T);return[new O(k.oldPosition,y,k.newPosition,k.newText),new O(k.oldPosition+T,l,k.newEnd,"")]}static s(k){if(k.length===0)return k;const T=[];let y=0,l=k[0];for(let v=1;v<k.length;v++){const m=k[v];l.oldEnd===m.oldPosition?l=new O(l.oldPosition,l.oldText+m.oldText,l.newPosition,l.newText+m.newText):(T[y++]=l,l=m)}return T[y++]=l,T}static t(k){if(k.length===0)return k;const T=[];let y=0;for(let l=0;l<k.length;l++){const v=k[l];v.oldText!==v.newText&&(T[y++]=v)}return T}}}),define(Ae[147],Re([1,0,36,19]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=A,e.$Vt=O;function A(M,p,$,k,T,y){if(Array.isArray(M)){let l=0;for(const v of M){const m=A(v,p,$,k,T,y);if(m===10)return m;m>l&&(l=m)}return l}else{if(typeof M=="string")return k?M==="*"?5:M===$?10:0:0;if(M){const{language:l,pattern:v,scheme:m,hasAccessToAllModels:s,notebookType:o}=M;if(!k&&!s)return 0;o&&T&&(p=T);let n=0;if(m)if(m===p.scheme)n=10;else if(m==="*")n=5;else return 0;if(l)if(l===$)n=10;else if(l==="*")n=Math.max(n,5);else return 0;if(o)if(o===y)n=10;else if(o==="*"&&y!==void 0)n=Math.max(n,5);else return 0;if(v){let r;if(typeof v=="string"?r=v:r={...v,base:(0,N.$ic)(v.base)},r===p.fsPath||(0,I.$jk)(r,p.fsPath))n=10;else return 0}return n}else return 0}}function O(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(O):!!M.notebookType}}),define(Ae[148],Re([1,0,5,15,29,94,92,133,146,6]),function(fe,e,I,N,A,O,M,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class T extends k.$Uc{constructor(l,v,m,s,o,n,r){super(),this.m=this.B(new I.$be),this.onDidChangeContent=this.m.event,this.f=v,this.j=!n,this.g=s,this.h=o,this.c=new M.$KC(l,m,r)}equals(l){return!(l instanceof T)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,v){return this.c.getOffsetAt(l,v)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,v){const m=l+v,s=this.getPositionAt(l),o=this.getPositionAt(m);return new A.$kt(s.lineNumber,s.column,o.lineNumber,o.column)}getValueInRange(l,v=0){if(l.isEmpty())return"";const m=this.n(v);return this.c.getValueInRange(l,m)}getValueLengthInRange(l,v=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const m=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const n=this.n(v),r=this.getEOL();if(n.length!==r.length){const t=n.length-r.length,a=l.endLineNumber-l.startLineNumber;o=t*a}return s-m+o}getCharacterCountInRange(l,v=0){if(this.j){let m=0;const s=l.startLineNumber,o=l.endLineNumber;for(let n=s;n<=o;n++){const r=this.getLineContent(n),t=n===s?l.startColumn-1:0,a=n===o?l.endColumn-1:r.length;for(let d=t;d<a;d++)N.$xf(r.charCodeAt(d))?(m=m+1,d=d+1):m=m+1}return m+=this.n(v).length*(o-s),m}return this.getValueLengthInRange(l,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,v){return this.c.getLineCharCode(l,v)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const v=N.$if(this.getLineContent(l));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(l){const v=N.$kf(this.getLineContent(l));return v===-1?0:v+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,v,m){let s=this.g,o=this.h,n=this.j,r=!0,t=[];for(let u=0;u<l.length;u++){const S=l[u];r&&S._isTracked&&(r=!1);const h=S.range;if(S.text){let C=!0;n||(C=!N.$If(S.text),n=C),!s&&C&&(s=N.$Hf(S.text)),!o&&C&&(o=N.$Kf(S.text))}let E="",g=0,D=0,w=0;if(S.text){let C;[g,D,w,C]=(0,p.$Nt)(S.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?E=S.text:E=S.text.replace(/\r\n|\r|\n/g,P)}t[u]={sortIndex:u,identifier:S.identifier||null,range:h,rangeOffset:this.getOffsetAt(h.startLineNumber,h.startColumn),rangeLength:this.getValueLengthInRange(h),text:E,eolCount:g,firstLineLength:D,lastLineLength:w,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}t.sort(T.u);let a=!1;for(let u=0,S=t.length-1;u<S;u++){const h=t[u].range.getEndPosition(),E=t[u+1].range.getStartPosition();if(E.isBeforeOrEqual(h)){if(E.isBefore(h))throw new Error("Overlapping ranges are not allowed!");a=!0}}r&&(t=this.s(t));const d=m||v?T._getInverseEditRanges(t):[],i=[];if(v)for(let u=0;u<t.length;u++){const S=t[u],h=d[u];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let E=h.startLineNumber;E<=h.endLineNumber;E++){let g="";E===h.startLineNumber&&(g=this.getLineContent(S.range.startLineNumber),N.$if(g)!==-1)||i.push({lineNumber:E,oldContent:g})}}let b=null;if(m){let u=0;b=[];for(let S=0;S<t.length;S++){const h=t[S],E=d[S],g=this.getValueInRange(h.range),D=h.rangeOffset+u;u+=h.text.length-g.length,b[S]={sortIndex:h.sortIndex,identifier:h.identifier,range:E,text:g,textChange:new $.$wt(h.rangeOffset,g,D,h.text)}}a||b.sort((S,h)=>S.sortIndex-h.sortIndex)}this.g=s,this.h=o,this.j=n;const c=this.t(t);let f=null;if(v&&i.length>0){i.sort((u,S)=>S.lineNumber-u.lineNumber),f=[];for(let u=0,S=i.length;u<S;u++){const h=i[u].lineNumber;if(u>0&&i[u-1].lineNumber===h)continue;const E=i[u].oldContent,g=this.getLineContent(h);g.length===0||g===E||N.$if(g)!==-1||f.push(h)}}return this.m.fire(),new O.$zv(b,c,f)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let v=!1;const m=l[0].range,s=l[l.length-1].range,o=new A.$kt(m.startLineNumber,m.startColumn,s.endLineNumber,s.endColumn);let n=m.startLineNumber,r=m.startColumn;const t=[];for(let c=0,f=l.length;c<f;c++){const u=l[c],S=u.range;v=v||u.forceMoveMarkers,t.push(this.getValueInRange(new A.$kt(n,r,S.startLineNumber,S.startColumn))),u.text.length>0&&t.push(u.text),n=S.endLineNumber,r=S.endColumn}const a=t.join(""),[d,i,b]=(0,p.$Nt)(a);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:d,firstLineLength:i,lastLineLength:b,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(l){l.sort(T.w);const v=[];for(let m=0;m<l.length;m++){const s=l[m],o=s.range.startLineNumber,n=s.range.startColumn,r=s.range.endLineNumber,t=s.range.endColumn;if(o===r&&n===t&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const a=new A.$kt(o,n,r,t);v.push({range:a,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return v}findMatchesLineByLine(l,v,m,s){return this.c.findMatchesLineByLine(l,v,m,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,v){const m=l.startLineNumber,s=l.startColumn,[o,n,r]=(0,p.$Nt)(v);let t;if(v.length>0){const a=o+1;a===1?t=new A.$kt(m,s,m,s+n):t=new A.$kt(m,s,m+a-1,r+1)}else t=new A.$kt(m,s,m,s);return t}static _getInverseEditRanges(l){const v=[];let m=0,s=0,o=null;for(let n=0,r=l.length;n<r;n++){const t=l[n];let a,d;o?o.range.endLineNumber===t.range.startLineNumber?(a=m,d=s+(t.range.startColumn-o.range.endColumn)):(a=m+(t.range.startLineNumber-o.range.endLineNumber),d=t.range.startColumn):(a=t.range.startLineNumber,d=t.range.startColumn);let i;if(t.text.length>0){const b=t.eolCount+1;b===1?i=new A.$kt(a,d,a,d+t.firstLineLength):i=new A.$kt(a,d,a+b-1,t.lastLineLength+1)}else i=new A.$kt(a,d,a,d);m=i.endLineNumber,s=i.endColumn,v.push(i),o=t}return v}static u(l,v){const m=A.$kt.compareRangesUsingEnds(l.range,v.range);return m===0?l.sortIndex-v.sortIndex:m}static w(l,v){const m=A.$kt.compareRangesUsingEnds(l.range,v.range);return m===0?v.sortIndex-l.sortIndex:-m}}e.$LC=T}),define(Ae[149],Re([1,0,15,92,148]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=void 0;class O{constructor($,k,T,y,l,v,m,s,o){this.a=$,this.b=k,this.c=T,this.d=y,this.e=l,this.f=v,this.g=m,this.h=s,this.j=o}k($){const k=this.c+this.d+this.e,T=this.c+this.e;return k===0?$===1?`
`:`\r
`:T>k/2?`\r
`:`
`}create($){const k=this.k($),T=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let l=0,v=T.length;l<v;l++){const m=T[l].buffer.replace(/\r\n|\r|\n/g,k),s=(0,N.$GC)(m);T[l]=new N.$JC(m,s)}const y=new A.$LC(T,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:y,disposable:y}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&I.$Rf($)&&(this.b=I.$Qf,$=$.substr(1));const k=$.charCodeAt($.length-1);k===13||k>=55296&&k<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=k):(this.m($,!1),this.c=!1,this.d=k)}m($,k){!k&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const k=(0,N.$HC)(this.e,$);this.a.push(new N.$JC($,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Hf($)),this.k||(this.k=I.$Kf($)))}finish($=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const k=(0,N.$GC)($.buffer);$.lineStarts=k,this.d===13&&this.f++}}}e.$MC=M}),define(Ae[97],Re([1,0,23,21]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbb=$,e.$ubb=T;var A;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(A||(A={}));function O(y){for(let l=0,v=y.length;l<v;l+=4){const m=y[l+0],s=y[l+1],o=y[l+2],n=y[l+3];y[l+0]=n,y[l+1]=o,y[l+2]=s,y[l+3]=m}}function M(y){const l=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return N.$D()||O(l),I.$Ce.wrap(l)}function p(y){const l=y.buffer;if(N.$D()||O(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const v=new Uint8Array(l.byteLength);return v.set(l),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function $(y){const l=new Uint32Array(k(y));let v=0;if(l[v++]=y.id,y.type==="full")l[v++]=1,l[v++]=y.data.length,l.set(y.data,v),v+=y.data.length;else{l[v++]=2,l[v++]=y.deltas.length;for(const m of y.deltas)l[v++]=m.start,l[v++]=m.deleteCount,m.data?(l[v++]=m.data.length,l.set(m.data,v),v+=m.data.length):l[v++]=0}return M(l)}function k(y){let l=0;if(l+=2,y.type==="full")l+=1+y.data.length;else{l+=1,l+=3*y.deltas.length;for(const v of y.deltas)v.data&&(l+=v.data.length)}return l}function T(y){const l=p(y);let v=0;const m=l[v++];if(l[v++]===1){const r=l[v++],t=l.subarray(v,v+r);return v+=r,{id:m,type:"full",data:t}}const o=l[v++],n=[];for(let r=0;r<o;r++){const t=l[v++],a=l[v++],d=l[v++];let i;d>0&&(i=l.subarray(v,v+d),v+=d),n[r]={start:t,deleteCount:a,data:i}}return{id:m,type:"delta",deltas:n}}}),define(Ae[150],Re([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Ae[151],Re([1,0,18,26,21,134,152,150]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=r,e.clampedFloat=a,e.stringSet=b,e.cursorStyleToString=w,e.filterValidationDecorations=le;var $;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=k;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class y{constructor(Z,me,He,ye){this.id=Z,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Z,me){return v(Z,me)}compute(Z,me,He){return He}}class l{constructor(Z,me){this.newValue=Z,this.didChange=me}}e.ApplyUpdateResult=l;function v(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new l(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const He=Array.isArray(X)&&Array.isArray(Z)&&I.$ub(X,Z);return new l(Z,!He)}let me=!1;for(const He in Z)if(Z.hasOwnProperty(He)){const ye=v(X[He],Z[He]);ye.didChange&&(X[He]=ye.newValue,me=!0)}return new l(X,me)}class m{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,me){return v(Z,me)}validate(Z){return this.defaultValue}}class s{constructor(Z,me,He,ye){this.id=Z,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Z,me){return v(Z,me)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,me,He){return He}}function o(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class n extends s{constructor(Z,me,He,ye=void 0){typeof ye<"u"&&(ye.type="boolean",ye.default=He),super(Z,me,He,ye)}validate(Z){return o(Z,this.defaultValue)}}function r(X,Z,me,He){if(typeof X>"u")return Z;let ye=parseInt(X,10);return isNaN(ye)?Z:(ye=Math.max(me,ye),ye=Math.min(He,ye),ye|0)}class t extends s{static clampedInt(Z,me,He,ye){return r(Z,me,He,ye)}constructor(Z,me,He,ye,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=ye,dt.maximum=ot),super(Z,me,He,dt),this.minimum=ye,this.maximum=ot}validate(Z){return t.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function a(X,Z,me,He){if(typeof X>"u")return Z;const ye=d.float(X,Z);return d.clamp(ye,me,He)}class d extends s{static clamp(Z,me,He){return Z<me?me:Z>He?He:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z>"u")return me;const He=parseFloat(Z);return isNaN(He)?me:He}constructor(Z,me,He,ye,ot){typeof ot<"u"&&(ot.type="number",ot.default=He),super(Z,me,He,ot),this.validationFn=ye}validate(Z){return this.validationFn(d.float(Z,this.defaultValue))}}class i extends s{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,He,ye=void 0){typeof ye<"u"&&(ye.type="string",ye.default=He),super(Z,me,He,ye)}validate(Z){return i.string(Z,this.defaultValue)}}function b(X,Z,me,He){return typeof X!="string"?Z:He&&X in He?He[X]:me.indexOf(X)===-1?Z:X}class c extends s{constructor(Z,me,He,ye,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=ye,ot.default=He),super(Z,me,He,ot),this.c=ye}validate(Z){return b(Z,this.defaultValue,this.c)}}class f extends y{constructor(Z,me,He,ye,ot,dt,It=void 0){typeof It<"u"&&(It.type="string",It.enum=ot,It.default=ye),super(Z,me,He,It),this.c=ot,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function u(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class S extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,He){return He===0?Z.accessibilitySupport:He}}class h extends y{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:p.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function g(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function w(X){switch(X){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function C(X){switch(X){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class P extends m{constructor(){super(142)}compute(Z,me,He){const ye=["monaco-editor"];return me.get(39)&&ye.push(me.get(39)),Z.extraEditorClassName&&ye.push(Z.extraEditorClassName),me.get(74)==="default"?ye.push("mouse-default"):me.get(74)==="copy"&&ye.push("mouse-copy"),me.get(111)&&ye.push("showUnused"),me.get(140)&&ye.push("showDeprecated"),ye.join(" ")}}class V extends n{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(Z,me,He){return He&&Z.emptySelectionClipboard}}class W extends y{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:p.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:p.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":b(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":b(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends y{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class R extends y{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?R.OFF:Z==="true"?R.TRANSLATE:Z:Z?R.TRANSLATE:R.OFF}compute(Z,me,He){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=R;class U extends m{constructor(){super(50)}compute(Z,me,He){return Z.fontInfo}}class K extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(Z){const me=d.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(me,6,100)}compute(Z,me,He){return Z.fontInfo.fontSize}}class se extends y{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:se.d,maximum:se.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:se.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(t.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,se.d,se.e))}}class ce extends y{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:He,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:He,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:He,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:He,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:He,description:p.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{multiple:b(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??b(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??b(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??b(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??b(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??b(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends y{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:p.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:t.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var Ie;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class ue extends m{constructor(){super(145)}compute(Z,me,He){return ue.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,He=Math.floor(Z.paddingTop/Z.lineHeight);let ye=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(ye=Math.max(ye,me-1));const ot=(He+Z.viewLineCount+ye)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:ye,desiredRatio:ot,minimapLineCount:dt}}static c(Z,me){const He=Z.outerWidth,ye=Z.outerHeight,ot=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const dt=me.stableMinimapLayoutInput,It=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Qt=Z.lineHeight,Ut=Z.typicalHalfwidthCharacterWidth,xt=Z.scrollBeyondLastLine,_t=Z.minimap.renderCharacters;let Pt=ot>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Vt=Z.minimap.maxColumn,Zt=Z.minimap.size,Xe=Z.minimap.side,si=Z.verticalScrollbarWidth,Xt=Z.viewLineCount,lt=Z.remainingWidth,vt=Z.isViewportWrapping,ti=_t?2:3;let Yt=Math.floor(ot*ye);const Lt=Yt/ot;let ft=!1,jt=!1,Bt=ti*Pt,qt=Pt/ot,Ge=1;if(Zt==="fill"||Zt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Gt,desiredRatio:ni,minimapLineCount:Mt}=ue.computeContainedMinimapLineCount({viewLineCount:Xt,scrollBeyondLastLine:xt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:ye,lineHeight:Qt,pixelRatio:ot});if(Xt/Mt>1)ft=!0,jt=!0,Pt=1,Bt=1,qt=Pt/ot;else{let Ct=!1,Et=Pt+1;if(Zt==="fit"){const pt=Math.ceil((ii+Xt+Gt)*Bt);vt&&It&&lt<=me.stableFitRemainingWidth?(Ct=!0,Et=me.stableFitMaxMinimapScale):Ct=pt>Yt}if(Zt==="fill"||Ct){ft=!0;const pt=Pt;Bt=Math.min(Qt*ot,Math.max(1,Math.floor(1/ni))),vt&&It&&lt<=me.stableFitRemainingWidth&&(Et=me.stableFitMaxMinimapScale),Pt=Math.min(Et,Math.max(1,Math.floor(Bt/ti))),Pt>pt&&(Ge=Math.min(2,Pt/pt)),qt=Pt/ot/Ge,Yt=Math.ceil(Math.max(Ot,ii+Xt+Gt)*Bt),vt?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=lt,me.stableFitMaxMinimapScale=Pt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ui=Math.floor(Vt*qt),Ht=Math.min(ui,Math.max(0,Math.floor((lt-si-2)*qt/(Ut+qt)))+e.MINIMAP_GUTTER_WIDTH);let zt=Math.floor(ot*Ht);const gt=zt/ot;zt=Math.floor(zt*Ge);const Tt=_t?1:2,At=Xe==="left"?0:He-Ht-si;return{renderMinimap:Tt,minimapLeft:At,minimapWidth:Ht,minimapHeightIsEditorHeight:ft,minimapIsSampling:jt,minimapScale:Pt,minimapLineHeight:Bt,minimapCanvasInnerWidth:zt,minimapCanvasInnerHeight:Yt,minimapCanvasOuterWidth:gt,minimapCanvasOuterHeight:Lt}}static computeLayout(Z,me){const He=me.outerWidth|0,ye=me.outerHeight|0,ot=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,It=me.typicalHalfwidthCharacterWidth,Qt=me.maxDigitWidth,Ut=me.pixelRatio,xt=me.viewLineCount,_t=Z.get(137),Pt=_t==="inherit"?Z.get(136):_t,Vt=Pt==="inherit"?Z.get(132):Pt,Zt=Z.get(135),Xe=me.isDominatedByLongLines,si=Z.get(57),Xt=Z.get(68).renderType!==0,lt=Z.get(69),vt=Z.get(105),ti=Z.get(84),Yt=Z.get(73),Lt=Z.get(103),ft=Lt.verticalScrollbarSize,jt=Lt.verticalHasArrows,Bt=Lt.arrowSize,qt=Lt.horizontalScrollbarSize,Ge=Z.get(43),ui=Z.get(110)!=="never";let Ht=Z.get(66);Ge&&ui&&(Ht+=16);let zt=0;if(Xt){const li=Math.max(dt,lt);zt=Math.round(li*Qt)}let gt=0;si&&(gt=ot*me.glyphMarginDecorationLaneCount);let Tt=0,At=Tt+gt,Ot=At+zt,ii=Ot+Ht;const Gt=He-gt-zt-Ht;let ni=!1,Mt=!1,Nt=-1;Pt==="inherit"&&Xe?(ni=!0,Mt=!0):Vt==="on"||Vt==="bounded"?Mt=!0:Vt==="wordWrapColumn"&&(Nt=Zt);const Ct=ue.c({outerWidth:He,outerHeight:ye,lineHeight:ot,typicalHalfwidthCharacterWidth:It,pixelRatio:Ut,scrollBeyondLastLine:vt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Yt,verticalScrollbarWidth:ft,viewLineCount:xt,remainingWidth:Gt,isViewportWrapping:Mt},me.memory||new T);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Tt+=Ct.minimapWidth,At+=Ct.minimapWidth,Ot+=Ct.minimapWidth,ii+=Ct.minimapWidth);const Et=Gt-Ct.minimapWidth,pt=Math.max(1,Math.floor((Et-ft-2)/It)),St=jt?Bt:0;return Mt&&(Nt=Math.max(1,pt),Vt==="bounded"&&(Nt=Math.min(Nt,Zt))),{width:He,height:ye,glyphMarginLeft:Tt,glyphMarginWidth:gt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:At,lineNumbersWidth:zt,decorationsLeft:Ot,decorationsWidth:Ht,contentLeft:ii,contentWidth:Et,minimap:Ct,viewportColumn:pt,isWordWrapMinified:ni,isViewportWrapping:Mt,wrappingColumn:Nt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:qt,overviewRuler:{top:St,width:ft,height:ye-2*St,right:0}}}}e.EditorLayoutInfoComputer=ue;class be extends y{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(Z){return b(Z,"simple",["simple","advanced"])}compute(Z,me,He){return me.get(2)===2?"advanced":He}}var ie;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(ie||(e.ShowLightbulbIconMode=ie={}));class Pe extends y{constructor(){const Z={enabled:ie.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ie.Off,ie.OnCode,ie.On],default:Z.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:b(Z.enabled,this.defaultValue.enabled,[ie.Off,ie.OnCode,ie.On])}}}class Fe extends y{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:p.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends y{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:p.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:b(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class j extends y{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):t.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,me,He){return He<0?t.clampedInt(-He*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class x extends d{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>d.clamp(Z,0,150),{markdownDescription:p.localize(66,null)})}compute(Z,me,He){return Z.fontInfo.lineHeight}}class pe extends y{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:Z.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:b(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(me.side,this.defaultValue.side,["right","left"]),showSlider:b(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(me.scale,1,1,3),maxColumn:t.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Oe(X){return X==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class ke extends y{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:t.clampedInt(me.top,0,0,1e3),bottom:t.clampedInt(me.bottom,0,0,1e3)}}}class $e extends y{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:p.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class ge extends m{constructor(){super(143)}compute(Z,me,He){return Z.pixelRatio}}class J extends y{constructor(){const Z={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Z.strings,description:p.localize(88,null)},comments:{anyOf:me,default:Z.comments,description:p.localize(89,null)},other:{anyOf:me,default:Z.other,description:p.localize(90,null)}},default:Z,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Ut=Z?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:me,comments:He,strings:ye}=Z,ot=["on","inline","off"];let dt,It,Qt;return typeof me=="boolean"?dt=me?"on":"off":dt=b(me,this.defaultValue.other,ot),typeof He=="boolean"?It=He?"on":"off":It=b(He,this.defaultValue.comments,ot),typeof ye=="boolean"?Qt=ye?"on":"off":Qt=b(ye,this.defaultValue.strings,ot),{other:dt,comments:It,strings:Qt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends y{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(Z){let me=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(me=4,He=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:He}}}function le(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Ne extends y{constructor(){const Z=[],me={type:"number",description:p.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:Z,description:p.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="number")me.push({column:t.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const ye=He;me.push({column:t.clampedInt(ye.column,0,0,1e4),color:ye.color})}return me.sort((He,ye)=>He.column-ye.column),me}return this.defaultValue}}class de extends y{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends y{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,He=t.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=t.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:t.clampedInt(me.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:t.clampedInt(me.verticalSliderSize,ye,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends y{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:p.localize(118,null)}})}applyUpdate(Z,me){let He=!1;me.allowedCharacters&&Z&&(N.$1n(Z.allowedCharacters,me.allowedCharacters)||(Z={...Z,allowedCharacters:me.allowedCharacters},He=!0)),me.allowedLocales&&Z&&(N.$1n(Z.allowedLocales,me.allowedLocales)||(Z={...Z,allowedLocales:me.allowedLocales},He=!0));const ye=super.applyUpdate(Z,me);return He?new l(ye.newValue,!0):ye}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,me){if(typeof Z!="object"||!Z)return me;const He={};for(const[ye,ot]of Object.entries(Z))ot===!0&&(He[ye]=!0);return He}}class z extends y{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:b(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily)}}}class L extends y{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:p.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends y{constructor(){const Z={enabled:O.$Us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$Us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends y{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:Z.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:Z.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:Z.highlightActiveIndentation,description:p.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Z,me){const He=me.indexOf(X);return He===-1?Z:me[He]}class re extends y{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:Z.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:Z.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:b(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:b(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Te extends y{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends y{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&me.push(He)}catch{}return me}return this.defaultValue}}var Qe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class _e extends y{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,me,He){return me.get(2)===2?0:He}}class et extends m{constructor(){super(146)}compute(Z,me,He){const ye=me.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}class tt extends y{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:b(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends y{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:b(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?at:A.$k?mt:nt,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(X){return e.editorOptionsRegistry[X.id]=X,X}var st;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new n(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:je(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:je(new S),accessibilityPageSize:je(new t(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",p.localize(218,null))),ariaRequired:je(new n(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new n(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:je(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:je(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:je(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:je(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:je(new f(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:je(new n(13,"automaticLayout",!1)),autoSurround:je(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:je(new G),bracketPairGuides:je(new H),stickyTabStops:je(new n(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:je(new n(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:je(new t(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:je(new n(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:je(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:je(new t(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:je(new n(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:je(new h),contextmenu:je(new n(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new n(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:je(new f(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:je(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:je(new f(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(260,null)})),cursorSurroundingLines:je(new t(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:je(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:je(new t(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:je(new n(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new n(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new n(34,"domReadOnly",!1)),dragAndDrop:je(new n(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:je(new V),dropIntoEditor:je(new tt),stickyScroll:je(new Fe),experimentalWhitespaceRendering:je(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new d(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:p.localize(271,null)})),find:je(new W),fixedOverflowWidgets:je(new n(42,"fixedOverflowWidgets",!1)),folding:je(new n(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:je(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:je(new n(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:je(new n(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:je(new t(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new n(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:je(new U),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new se),fontVariations:je(new R),formatOnPaste:je(new n(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:je(new n(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:je(new n(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:je(new ce),hideCursorInOverviewRuler:je(new n(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:je(new ve),inDiffEditor:je(new n(61,"inDiffEditor",!1)),letterSpacing:je(new d(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:p.localize(285,null)})),lightbulb:je(new Pe),lineDecorationsWidth:je(new j),lineHeight:je(new x),lineNumbers:je(new he),lineNumbersMinChars:je(new t(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new n(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:je(new n(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:je(new c(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:je(new pe),mouseStyle:je(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new d(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:je(new n(76,"mouseWheelZoom",!1,{markdownDescription:A.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:je(new n(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:je(new f(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Oe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:je(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:je(new t(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:je(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:je(new n(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:je(new t(83,"overviewRulerLanes",3,0,3)),padding:je(new ke),pasteAs:je(new it),parameterHints:je(new $e),peekWidgetDefaultFocus:je(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:je(new n(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:je(new J),quickSuggestionsDelay:je(new t(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:je(new n(91,"readOnly",!1)),readOnlyMessage:je(new de),renameOnType:je(new n(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:je(new n(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:je(new c(95,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:je(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new n(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:je(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:je(new t(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new n(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:je(new Ne),scrollbar:je(new Me),scrollBeyondLastColumn:je(new t(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:je(new n(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:je(new n(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:je(new n(107,"selectionClipboard",!0,{description:p.localize(325,null),included:A.$k})),selectionHighlight:je(new n(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:je(new n(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:je(new n(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:je(new n(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:je(new ne),snippetSuggestions:je(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:je(new Te),smoothScrolling:je(new n(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:je(new t(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new re),inlineSuggest:je(new z),inlineEdit:je(new L),inlineCompletionsAccessibilityVerbose:je(new n(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:je(new t(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new t(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new n(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:je(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:je(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:je(new t(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new ze),unusualLineTerminators:je(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:je(new n(127,"useShadowDOM",!0)),useTabStops:je(new n(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:je(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new i(131,"wordSeparators",M.$Vs,{description:p.localize(359,null)})),wordWrap:je(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:je(new i(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new t(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:je(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new P),defaultColorDecorators:je(new n(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:je(new ge),tabFocusMode:je(new n(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:je(new ue),wrappingInfo:je(new et),wrappingIndent:je(new _e),wrappingStrategy:je(new be)}}),define(Ae[153],Re([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[154],Re([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[155],Re([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[156],Re([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[157],Re([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[158],Re([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Ae[159],Re([9,10]),function(fe,e){return fe.create("vs/platform/log/common/log",e)}),define(Ae[160],Re([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Ae[161],Re([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[162],Re([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Ae[163],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[164],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[165],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[166],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[167],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ae[168],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[169],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[170],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[171],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[172],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[173],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[174],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[175],Re([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[176],Re([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Ae[177],Re([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Ae[178],Re([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Ae[179],Re([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ae[180],Re([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[181],Re([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[182],Re([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[183],Re([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[184],Re([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[185],Re([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ae[186],Re([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[187],Re([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[188],Re([1,0,14,155]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var A;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...k){switch(k.length){case 1:return(0,N.localize)(0,null,k[0]);case 2:return(0,N.localize)(1,null,k[0],k[1]);case 3:return(0,N.localize)(2,null,k[0],k[1],k[2]);default:return}}const M=(0,N.localize)(3,null),p=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const y=this.d,l=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:l};this.g.push({offset:y,lexeme:l,additionalInfo:T}),this.f.push(v)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const y=this.c.substring(this.d,this.e),l=$.b.get(y);l?this.k(l):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,y=!1,l=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(p);return}const m=this.c.charCodeAt(T);if(y)y=!1;else if(m===47&&!l){T++;break}else m===91?l=!0:m===92?y=!0:m===93&&(l=!1);T++}for(;T<this.c.length&&$.a.has(this.c.charCodeAt(T));)T++;this.e=T;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=$}),define(Ae[189],Re([1,0,24,33,157,301]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=$,e.$Bp=k,e.$Cp=T,e.$Dp=y,e.$Ep=l,e.$Fp=v,e.$Gp=m;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function $(n){return n=n.trim(),n==="*"||M.test(n)}function k(n){if(!$(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=n.match(M);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}function T(n){if(!n)return null;const r=n.majorBase,t=n.majorMustEqual,a=n.minorBase;let d=n.minorMustEqual;const i=n.patchBase;let b=n.patchMustEqual;n.hasCaret&&(r===0||(d=!1),b=!1);let c=0;if(n.preRelease){const f=p.exec(n.preRelease);if(f){const[,u,S,h]=f;c=Date.UTC(Number(u),Number(S)-1,Number(h))}}return{majorBase:r,majorMustEqual:t,minorBase:a,minorMustEqual:d,patchBase:i,patchMustEqual:b,isMinimum:n.hasGreaterEquals,notBefore:c}}function y(n,r,t){let a;typeof n=="string"?a=T(k(n)):a=n;let d;r instanceof Date?d=r.getTime():typeof r=="string"&&(d=new Date(r).getTime());let i;if(typeof t=="string"?i=T(k(t)):i=t,!a||!i)return!1;const b=a.majorBase,c=a.minorBase,f=a.patchBase;let u=i.majorBase,S=i.minorBase,h=i.patchBase;const E=i.notBefore;let g=i.majorMustEqual,D=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?b>u?!0:b<u?!1:c>S?!0:c<S||d&&d<E?!1:f>=h:(b===1&&u===0&&(!g||!D||!w)&&(u=1,S=0,h=0,g=!0,D=!1,w=!1),b<u?!1:b>u?!g:c<S?!1:c>S?!D:f<h?!1:f>h?!w:!(d&&d<E))}function l(n,r,t,a,d){const i=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return i.push([N.default.Error,A.localize(0,null)]),i;if(typeof a.name!="string")return i.push([N.default.Error,A.localize(1,null,"name")]),i;if(typeof a.version!="string")return i.push([N.default.Error,A.localize(2,null,"version")]),i;if(!a.engines)return i.push([N.default.Error,A.localize(3,null,"engines")]),i;if(typeof a.engines.vscode!="string")return i.push([N.default.Error,A.localize(4,null,"engines.vscode")]),i;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return i.push([N.default.Error,A.localize(5,null,"extensionDependencies")]),i;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return i.push([N.default.Error,A.localize(6,null,"activationEvents")]),i;if(typeof a.main>"u"&&typeof a.browser>"u")return i.push([N.default.Error,A.localize(7,null,"activationEvents","main","browser")]),i}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&i.push([N.default.Warning,A.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return i.push([N.default.Error,A.localize(9,null,"main")]),i;{const f=(0,I.$4g)(t,a.main);(0,I.$Xg)(f,t)||i.push([N.default.Warning,A.localize(10,null,f.path,t.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return i.push([N.default.Error,A.localize(11,null,"browser")]),i;{const f=(0,I.$4g)(t,a.browser);(0,I.$Xg)(f,t)||i.push([N.default.Warning,A.localize(12,null,f.path,t.path)])}}if(!O.valid(a.version))return i.push([N.default.Error,A.localize(13,null)]),i;const b=[];if(!v(n,r,a,d,b))for(const f of b)i.push([N.default.Error,f]);return i}function v(n,r,t,a,d){return a||typeof t.main>"u"&&typeof t.browser>"u"?!0:s(n,r,t.engines.vscode,d)}function m(n,r,t){return n==="*"||s(r,t,n)}function s(n,r,t,a=[]){const d=T(k(t));if(!d)return a.push(A.localize(14,null,t)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return a.push(A.localize(15,null,t)),!1}else if(!d.majorMustEqual)return a.push(A.localize(16,null,t)),!1;return y(n,r,d)?!0:(a.push(A.localize(17,null,n,t)),!1)}function o(n){if(!Array.isArray(n))return!1;for(let r=0,t=n.length;r<t;r++)if(typeof n[r]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class I{constructor(A,O=[],M=!1){this.ctor=A,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.$ni=I}),define(Ae[55],Re([1,0,70]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=O,e.$ps=M;const N=[];var A;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function O(p,$,k){$ instanceof I.$ni||($=new I.$ni($,[],!!k)),N.push([p,$])}function M(){return N}}),define(Ae[190],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class I{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$5q=I;class N{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const M of this.a.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const p=this.lookupOrInsertNode(O),$=this.lookupOrInsertNode(M);p.outgoing.set($.key,$),$.incoming.set(p.key,p)}removeNode(O){const M=this.b(O);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(O){const M=this.b(O);let p=this.a.get(M);return p||(p=new I(M,O),this.a.set(M,p)),p}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[M,p]of this.a)O.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this.a){const p=new Set([O]),$=this.c(M,p);if($)return $}}c(O,M){for(const[p,$]of O.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const k=this.c($,M);if(k)return k;M.delete(p)}}}e.$6q=N}),define(Ae[3],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=A,e.$ri=O;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p($){return $[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(I||(e._util=I={})),e.$pi=A("instantiationService");function N(M,p,$){p[I.DI_TARGET]===p?p[I.DI_DEPENDENCIES].push({id:M,index:$}):(p[I.DI_DEPENDENCIES]=[{id:M,index:$}],p[I.DI_TARGET]=p)}function A(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const p=function($,k,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(p,$,T)};return p.toString=()=>M,I.serviceIds.set(M,p),p}function O(M){return M}}),define(Ae[48],Re([1,0,17,2,3]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=O,e.$Yi=M,e.$Zi=$,e.$1i=k,e.$2i=T,e.$3i=y,e.$4i=l,e.$5i=m,e.$6i=s,e.$7i=o,e.$Wi=(0,A.$qi)("configurationService");function O(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof N.URI)}function M(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof N.URI)}var p;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function $(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(n){return n.applicationValue!==void 0||n.userValue!==void 0||n.userLocalValue!==void 0||n.userRemoteValue!==void 0||n.workspaceValue!==void 0||n.workspaceFolderValue!==void 0}function T(n,r){const t=Object.create(null);for(const a in n)y(t,a,n[a],r);return t}function y(n,r,t,a){const d=r.split("."),i=d.pop();let b=n;for(let c=0;c<d.length;c++){const f=d[c];let u=b[f];switch(typeof u){case"undefined":u=b[f]=Object.create(null);break;case"object":if(u===null){a(`Ignoring ${r} as ${d.slice(0,c+1).join(".")} is null`);return}break;default:a(`Ignoring ${r} as ${d.slice(0,c+1).join(".")} is ${JSON.stringify(u)}`);return}b=u}if(typeof b=="object"&&b!==null)try{b[i]=t}catch{a(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(b)}`)}else a(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(b)}`)}function l(n,r){const t=r.split(".");v(n,t)}function v(n,r){const t=r.shift();if(r.length===0){delete n[t];return}if(Object.keys(n).indexOf(t)!==-1){const a=n[t];typeof a=="object"&&!Array.isArray(a)&&(v(a,r),Object.keys(a).length===0&&delete n[t])}}function m(n,r,t){function a(b,c){let f=b;for(const u of c){if(typeof f!="object"||f===null)return;f=f[u]}return f}const d=r.split("."),i=a(n,d);return typeof i>"u"?t:i}function s(n,r,t){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in n?I.$6f(n[a])&&I.$6f(r[a])?s(n[a],r[a],t):t&&(n[a]=r[a]):n[a]=r[a])})}function o(n){return n.replace(/[\[\]]/g,"")}}),define(Ae[31],Re([1,0,21,15,188,3,154,14]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=k,e.$pj=b,e.$qj=c,e.$Jj=ie;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",I.$j),$.set("isLinux",I.$k),$.set("isWindows",I.$i),$.set("isWeb",I.$o),$.set("isMacNative",I.$j&&!I.$o),$.set("isEdge",I.$H),$.set("isFirefox",I.$F),$.set("isChrome",I.$E),$.set("isSafari",I.$G);function k(ne,j){if($.get(ne)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(ne,j)}const T=Object.prototype.hasOwnProperty;var y;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const l={regexParsingWithErrorRecovery:!0},v=(0,M.localize)(0,null),m=(0,M.localize)(1,null),s=(0,M.localize)(2,null),o=(0,M.localize)(3,null),n=(0,M.localize)(4,null),r=(0,M.localize)(5,null),t=(0,M.localize)(6,null),a=(0,M.localize)(7,null);class d{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=l){this.k=j,this.d=new A.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const pe=this.D(),Oe=pe.type===17?r:void 0;throw this.h.push({message:n,offset:pe.offset,lexeme:A.$lj.getLexeme(pe),additionalInfo:Oe}),d.c}return x}catch(x){if(x!==d.c)throw x;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const x=this.o();j.push(x)}return j.length===1?j[0]:i.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const x=this.s();j.push(x)}return j.length===1?j[0]:i.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),S.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),C.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=j.lexeme;if(this.z(),this.y(9)){const Oe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Oe.type!==10)throw this.B("REGEX",Oe);const ke=Oe.lexeme,$e=ke.lastIndexOf("/"),ge=$e===ke.length-1?void 0:this.w(ke.substring($e+1));let J;try{J=new RegExp(ke.substring(1,$e),ge)}catch{throw this.B("REGEX",Oe)}return U.create(x,J)}switch(Oe.type){case 10:case 19:{const ke=[Oe.lexeme];this.z();let $e=this.D(),ge=0;for(let Ne=0;Ne<Oe.lexeme.length;Ne++)Oe.lexeme.charCodeAt(Ne)===40?ge++:Oe.lexeme.charCodeAt(Ne)===41&&ge--;for(;!this.E()&&$e.type!==15&&$e.type!==16;){switch($e.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Ne=0;Ne<$e.lexeme.length;Ne++)$e.lexeme.charCodeAt(Ne)===40?ge++:Oe.lexeme.charCodeAt(Ne)===41&&ge--}if(ge<0)break;ke.push(A.$lj.getLexeme($e)),this.z(),$e=this.D()}const J=ke.join(""),Y=J.lastIndexOf("/"),he=Y===J.length-1?void 0:this.w(J.substring(Y+1));let le;try{le=new RegExp(J.substring(1,Y),he)}catch{throw this.B("REGEX",Oe)}return i.regex(x,le)}case 18:{const ke=Oe.lexeme;this.z();let $e=null;if(!(0,N.$3e)(ke)){const ge=ke.indexOf("/"),J=ke.lastIndexOf("/");if(ge!==J&&ge>=0){const Y=ke.slice(ge+1,J),he=ke[J+1]==="i"?"i":"";try{$e=new RegExp(Y,he)}catch{throw this.B("REGEX",Oe)}}}if($e===null)throw this.B("REGEX",Oe);return U.create(x,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Oe=this.u();return i.notIn(x,Oe)}switch(this.D().type){case 3:{this.z();const Oe=this.u();if(this.x().type===18)return i.equals(x,Oe);switch(Oe){case"true":return i.has(x);case"false":return i.not(x);default:return i.equals(x,Oe)}}case 4:{this.z();const Oe=this.u();if(this.x().type===18)return i.notEquals(x,Oe);switch(Oe){case"true":return i.not(x);case"false":return i.has(x);default:return i.notEquals(x,Oe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),R.create(x,this.u());case 7:return this.z(),V.create(x,this.u());case 8:return this.z(),W.create(x,this.u());case 13:return this.z(),i.in(x,this.u());default:return i.has(x)}}case 20:throw this.h.push({message:t,offset:j.offset,lexeme:"",additionalInfo:a}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,x){if(this.C(j))return this.z();throw this.B(x,this.D())}B(j,x,pe){const Oe=(0,M.localize)(8,null,j,A.$lj.getLexeme(x)),ke=x.offset,$e=A.$lj.getLexeme(x);return this.h.push({message:Oe,offset:ke,lexeme:$e,additionalInfo:pe}),d.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=d;class i{static false(){return u.INSTANCE}static true(){return S.INSTANCE}static has(j){return h.create(j)}static equals(j,x){return E.create(j,x)}static notEquals(j,x){return w.create(j,x)}static regex(j,x){return U.create(j,x)}static in(j,x){return g.create(j,x)}static notIn(j,x){return D.create(j,x)}static not(j){return C.create(j)}static and(...j){return ce.create(j,null,!0)}static or(...j){return ve.create(j,null,!0)}static greater(j,x){return V.create(j,x)}static greaterEquals(j,x){return W.create(j,x)}static smaller(j,x){return q.create(j,x)}static smallerEquals(j,x){return R.create(j,x)}static{this.c=new d({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$oj=i;function b(ne){const j=new d({regexParsingWithErrorRecovery:!1});return ne.map(x=>(j.parse(x),j.lexingErrors.length>0?j.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,M.localize)(9,null,pe.additionalInfo):(0,M.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function c(ne,j){const x=ne?ne.substituteConstants():void 0,pe=j?j.substituteConstants():void 0;return!x&&!pe?!0:!x||!pe?!1:x.equals(pe)}function f(ne,j){return ne.cmp(j)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return S.INSTANCE}}e.$rj=u;class S{static{this.INSTANCE=new S}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return u.INSTANCE}}e.$sj=S;class h{static create(j,x=null){const pe=$.get(j);return typeof pe=="boolean"?pe?S.INSTANCE:u.INSTANCE:new h(j,x)}constructor(j,x){this.key=j,this.c=x,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=$.get(this.key);return typeof j=="boolean"?j?S.INSTANCE:u.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$tj=h;class E{static create(j,x,pe=null){if(typeof x=="boolean")return x?h.create(j,pe):C.create(j,pe);const Oe=$.get(j);return typeof Oe=="boolean"?x===(Oe?"true":"false")?S.INSTANCE:u.INSTANCE:new E(j,x,pe)}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=$.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?S.INSTANCE:u.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$uj=E;class g{static create(j,x){return new g(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:be(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.f),pe=j.getValue(this.d);return Array.isArray(x)?x.includes(pe):typeof pe=="string"&&typeof x=="object"&&x!==null?T.call(x,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$vj=g;class D{static create(j,x){return new D(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=11,this.c=g.create(j,x)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=D;class w{static create(j,x,pe=null){if(typeof x=="boolean")return x?C.create(j,pe):h.create(j,pe);const Oe=$.get(j);return typeof Oe=="boolean"?x===(Oe?"true":"false")?u.INSTANCE:S.INSTANCE:new w(j,x,pe)}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=$.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?u.INSTANCE:S.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$xj=w;class C{static create(j,x=null){const pe=$.get(j);return typeof pe=="boolean"?pe?u.INSTANCE:S.INSTANCE:new C(j,x)}constructor(j,x){this.c=j,this.d=x,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=$.get(this.c);return typeof j=="boolean"?j?u.INSTANCE:S.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.$yj=C;function P(ne,j){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?j(ne):u.INSTANCE}class V{static create(j,x,pe=null){return P(x,Oe=>new V(j,Oe,pe))}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$zj=V;class W{static create(j,x,pe=null){return P(x,Oe=>new W(j,Oe,pe))}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Aj=W;class q{static create(j,x,pe=null){return P(x,Oe=>new q(j,Oe,pe))}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Bj=q;class R{static create(j,x,pe=null){return P(x,Oe=>new R(j,Oe,pe))}constructor(j,x,pe){this.c=j,this.d=x,this.f=pe,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Cj=R;class U{static create(j,x){return new U(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const x=this.f?this.f.source:"",pe=j.f?j.f.source:"";return x<pe?-1:x>pe?1:0}equals(j){if(j.type===this.type){const x=this.f?this.f.source:"",pe=j.f?j.f.source:"";return this.d===j.d&&x===pe}return!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Dj=U;class K{static create(j){return new K(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new K(this.c.map(j))}negate(){return this.c}}e.$Ej=K;function se(ne){let j=null;for(let x=0,pe=ne.length;x<pe;x++){const Oe=ne[x].substituteConstants();if(ne[x]!==Oe&&j===null){j=[];for(let ke=0;ke<x;ke++)j[ke]=ne[ke]}j!==null&&(j[x]=Oe)}return j===null?ne:j}class ce{static create(j,x,pe){return ce.d(j,x,pe)}constructor(j,x){this.expr=j,this.c=x,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,pe=this.expr.length;x<pe;x++){const Oe=f(this.expr[x],j.expr[x]);if(Oe!==0)return Oe}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,pe=this.expr.length;x<pe;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=se(this.expr);return j===this.expr?this:ce.create(j,this.c,!1)}evaluate(j){for(let x=0,pe=this.expr.length;x<pe;x++)if(!this.expr[x].evaluate(j))return!1;return!0}static d(j,x,pe){const Oe=[];let ke=!1;for(const $e of j)if($e){if($e.type===1){ke=!0;continue}if($e.type===0)return u.INSTANCE;if($e.type===6){Oe.push(...$e.expr);continue}Oe.push($e)}if(Oe.length===0&&ke)return S.INSTANCE;if(Oe.length!==0){if(Oe.length===1)return Oe[0];Oe.sort(f);for(let $e=1;$e<Oe.length;$e++)Oe[$e-1].equals(Oe[$e])&&(Oe.splice($e,1),$e--);if(Oe.length===1)return Oe[0];for(;Oe.length>1;){const $e=Oe[Oe.length-1];if($e.type!==9)break;Oe.pop();const ge=Oe.pop(),J=Oe.length===0,Y=ve.create($e.expr.map(he=>ce.create([he,ge],null,pe)),null,J);Y&&(Oe.push(Y),Oe.sort(f))}if(Oe.length===1)return Oe[0];if(pe){for(let $e=0;$e<Oe.length;$e++)for(let ge=$e+1;ge<Oe.length;ge++)if(Oe[$e].negate().equals(Oe[ge]))return u.INSTANCE;if(Oe.length===1)return Oe[0]}return new ce(Oe,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new ce(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());this.c=ve.create(j,this,!0)}return this.c}}e.$Fj=ce;class ve{static create(j,x,pe){return ve.d(j,x,pe)}constructor(j,x){this.expr=j,this.c=x,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,pe=this.expr.length;x<pe;x++){const Oe=f(this.expr[x],j.expr[x]);if(Oe!==0)return Oe}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,pe=this.expr.length;x<pe;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=se(this.expr);return j===this.expr?this:ve.create(j,this.c,!1)}evaluate(j){for(let x=0,pe=this.expr.length;x<pe;x++)if(this.expr[x].evaluate(j))return!0;return!1}static d(j,x,pe){let Oe=[],ke=!1;if(j){for(let $e=0,ge=j.length;$e<ge;$e++){const J=j[$e];if(J){if(J.type===0){ke=!0;continue}if(J.type===1)return S.INSTANCE;if(J.type===9){Oe=Oe.concat(J.expr);continue}Oe.push(J)}}if(Oe.length===0&&ke)return u.INSTANCE;Oe.sort(f)}if(Oe.length!==0){if(Oe.length===1)return Oe[0];for(let $e=1;$e<Oe.length;$e++)Oe[$e-1].equals(Oe[$e])&&(Oe.splice($e,1),$e--);if(Oe.length===1)return Oe[0];if(pe){for(let $e=0;$e<Oe.length;$e++)for(let ge=$e+1;ge<Oe.length;ge++)if(Oe[$e].negate().equals(Oe[ge]))return S.INSTANCE;if(Oe.length===1)return Oe[0]}return new ve(Oe,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new ve(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());for(;j.length>1;){const x=j.shift(),pe=j.shift(),Oe=[];for(const ke of Fe(x))for(const $e of Fe(pe))Oe.push(ce.create([ke,$e],null,!1));j.unshift(ve.create(Oe,null,!1))}this.c=ve.create(j,this,!0)}return this.c}}e.$Gj=ve;class Ie extends h{static{this.d=[]}static all(){return Ie.d.values()}constructor(j,x,pe){super(j,null),this.f=x,typeof pe=="object"?Ie.d.push({...pe,key:j}):pe!==!0&&Ie.d.push({key:j,description:pe,type:x!=null?typeof x:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return E.create(this.key,j)}notEqualsTo(j){return w.create(this.key,j)}}e.$Hj=Ie,e.$Ij=(0,O.$qi)("contextKeyService");function ue(ne,j){return ne<j?-1:ne>j?1:0}function be(ne,j,x,pe){return ne<x?-1:ne>x?1:j<pe?-1:j>pe?1:0}function ie(ne,j){if(ne.type===0||j.type===1)return!0;if(ne.type===9)return j.type===9?Pe(ne.expr,j.expr):!1;if(j.type===9){for(const x of j.expr)if(ie(ne,x))return!0;return!1}if(ne.type===6){if(j.type===6)return Pe(j.expr,ne.expr);for(const x of ne.expr)if(ie(x,j))return!0;return!1}return ne.equals(j)}function Pe(ne,j){let x=0,pe=0;for(;x<ne.length&&pe<j.length;){const Oe=ne[x].cmp(j[pe]);if(Oe<0)return!1;Oe===0&&x++,pe++}return x===ne.length}function Fe(ne){return ne.type===9?ne.expr:[ne]}}),define(Ae[191],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,I.$qi)("environmentService"),e.$yi=(0,I.$ri)(e.$xi)}),define(Ae[98],Re([1,0,156,3]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=A,e.$Uo=O,e.$Vo=M,e.$Wo=p,e.$Xo=$,e.$Yo=k,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function A(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(t,a){switch(t){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(t,a){return a==="web"&&!t.includes("web")}function $(t,a,d){return p(a,d)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===d}function k(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var T;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var y;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var v;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Zo=(0,N.$qi)("extensionGalleryService");var m;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Unknown="Unknown",t.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var s;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class o extends Error{constructor(a,d){super(a),this.code=d,this.name=d}}e.$1o=o;var n;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed"})(n||(e.ExtensionGalleryErrorCode=n={}));class r extends Error{constructor(a,d){super(a),this.code=d,this.name=d}}e.$2o=r,e.$3o=(0,N.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,N.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,N.$qi)("IExtensionTipsService"),e.$8o=(0,I.localize2)(0,"Extensions"),e.$9o=(0,I.localize2)(1,"Preferences")}),define(Ae[44],Re([1,0,52,19,15,17,2,158,3,21,12,41]),function(fe,e,I,N,A,O,M,p,$,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=l,e.$Yk=s,e.$Zk=n,e.$1k=r,e.$2k=t,e.$3k=a,e.$4k=d,e.$5k=i,e.$6k=b,e.$7k=c,e.$8k=f,e.$0k=h,e.$$k=E,e.$_k=g,e.$al=D,e.$bl=w,e.$el=q,e.$ql=ve,e.$rl=Ie,e.$tl=be,e.$Wk=(0,$.$qi)("fileService");function l(ie){return ie.create===!0}var v;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var m;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function s(ie){const Pe=ie;return!!Pe&&typeof Pe.onDidChange=="function"}var o;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function n(ie){return!!(ie.capabilities&2)}function r(ie){return!!(ie.capabilities&8)}function t(ie){return!!(ie.capabilities&131072)}function a(ie){return!!(ie.capabilities&4)}function d(ie){return!!(ie.capabilities&16)}function i(ie){return n(ie)?!!(ie.capabilities&16384):!1}function b(ie){return n(ie)?!!(ie.capabilities&32768):!1}function c(ie){return!!(ie.capabilities&65536)}function f(ie){return!!(ie.capabilities&2048)}var u;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class S extends Error{static create(Pe,Fe){const ne=new S(Pe.toString(),Fe);return g(ne,Fe),ne}constructor(Pe,Fe){super(Pe),this.code=Fe}}e.$9k=S;function h(ie,Pe){return S.create(ie,Pe)}function E(ie){return ie||h((0,p.localize)(0,null),u.Unknown)}function g(ie,Pe){return ie.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",ie}function D(ie){if(!ie)return u.Unknown;if(ie instanceof S)return ie.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!Pe)return u.Unknown;switch(Pe[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function w(ie){if(ie instanceof R)return ie.fileOperationResult;switch(D(ie)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}var C;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class P{constructor(Pe,Fe,ne){this.resource=Pe,this.operation=Fe,this.target=ne}isOperation(Pe){return this.operation===Pe}}e.$cl=P;var V;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class W{static{this.a=null}constructor(Pe,Fe){this.c=Fe,this.b=void 0,this.d=new y.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawAdded.map(j=>[j,!0])),ne}),this.f=new y.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawUpdated.map(j=>[j,!0])),ne}),this.g=new y.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawDeleted.map(j=>[j,!0])),ne}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ne of Pe){switch(ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}this.b!==W.a&&(typeof ne.cId=="number"?this.b===void 0?this.b=ne.cId:this.b!==ne.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(Pe,...Fe){return this.h(Pe,{includeChildren:!1},...Fe)}affects(Pe,...Fe){return this.h(Pe,{includeChildren:!0},...Fe)}h(Pe,Fe,...ne){if(!Pe)return!1;const j=ne.length>0;return!!((!j||ne.includes(1))&&(this.d.value.get(Pe)||Fe.includeChildren&&this.d.value.findSuperstr(Pe))||(!j||ne.includes(0))&&(this.f.value.get(Pe)||Fe.includeChildren&&this.f.value.findSuperstr(Pe))||(!j||ne.includes(2))&&(this.g.value.findSubstr(Pe)||Fe.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$dl=W;function q(ie,Pe,Fe){return!ie||!Pe||ie===Pe||Pe.length>ie.length?!1:(Pe.charAt(Pe.length-1)!==N.sep&&(Pe+=N.sep),Fe?(0,A.$uf)(ie,Pe):ie.indexOf(Pe)===0)}class R extends Error{constructor(Pe,Fe,ne){super(Pe),this.fileOperationResult=Fe,this.options=ne}}e.$fl=R;class U extends R{constructor(Pe,Fe,ne,j){super(Pe,Fe,j),this.fileOperationResult=Fe,this.size=ne}}e.$gl=U;class K extends R{constructor(Pe,Fe,ne){super(Pe,2,ne),this.stat=Fe}}e.$hl=K;var se;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var ce;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$pl="";function ve(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}async function Ie(ie,Pe){if(!Pe.hasProvider(M.URI.from({scheme:ie.scheme})))return new Promise(Fe=>{const ne=Pe.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===ie.scheme&&j.added&&(ne.dispose(),Fe())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Pe){return(0,O.$8f)(Pe)||(Pe=0),Pe<ue.KB?(0,p.localize)(1,null,Pe.toFixed(0)):Pe<ue.MB?(0,p.localize)(2,null,(Pe/ue.KB).toFixed(2)):Pe<ue.GB?(0,p.localize)(3,null,(Pe/ue.MB).toFixed(2)):Pe<ue.TB?(0,p.localize)(4,null,(Pe/ue.GB).toFixed(2)):(0,p.localize)(5,null,(Pe/ue.TB).toFixed(2))}}e.$sl=ue;function be(ie){const Pe=typeof ie=="string"||ie?.scheme===T.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===T.Schemas.file?1024*ue.MB:Pe?10*ue.MB:k.$o?50*ue.MB:1024*ue.MB}}),define(Ae[71],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class I{constructor(...A){this.a=new Map;for(const[O,M]of A)this.set(O,M)}set(A,O){const M=this.a.get(A);return this.a.set(A,O),M}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$oi=I}),define(Ae[192],Re([1,0,11,14,6,70,190,3,71,193]),function(fe,e,I,N,A,O,M,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const T=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new $.$oi,n=!1,r,t=T){this.i=o,this.j=n,this.k=r,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$pi,this),this._globalGraph=t?r?._globalGraph??new M.$6q(a=>a):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,A.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const n=new class extends l{dispose(){this.h.delete(n),super.dispose()}}(o,this.j,this,this.l);return this.h.add(n),n}invokeFunction(o,...n){this.m();const r=m.traceInvocation(this.l,o);let t=!1;try{return o({get:d=>{if(t)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(d,r);if(!i)throw new Error(`[invokeFunction] unknown service '${d}'`);return i}},...n)}finally{t=!0,r.stop()}}createInstance(o,...n){this.m();let r,t;return o instanceof O.$ni?(r=m.traceCreation(this.l,o.ctor),t=this.o(o.ctor,o.staticArguments.concat(n),r)):(r=m.traceCreation(this.l,o),t=this.o(o,n,r)),r.stop(),t}o(o,n=[],r){const t=p._util.getServiceDependencies(o).sort((i,b)=>i.index-b.index),a=[];for(const i of t){const b=this.s(i.id,r);b||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),a.push(b)}const d=t.length>0?t[0].index:n.length;if(n.length!==d){console.trace(`[createInstance] First service dependency of ${o.name} at position ${d+1} conflicts with ${n.length} static arguments`);const i=d-n.length;i>0?n=n.concat(new Array(i)):n=n.slice(0,d)}return Reflect.construct(o,n.concat(a))}q(o,n){if(this.i.get(o)instanceof O.$ni)this.i.set(o,n);else if(this.k)this.k.q(o,n);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const n=this.i.get(o);return!n&&this.k?this.k.r(o):n}s(o,n){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const r=this.r(o);return r instanceof O.$ni?this.u(o,r,n.branch(o,!0)):(n.branch(o,!1),r)}u(o,n,r){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,n,r)}finally{this.t.delete(o)}}v(o,n,r){const t=new M.$6q(i=>i.id.toString());let a=0;const d=[{id:o,desc:n,_trace:r}];for(;d.length;){const i=d.pop();if(t.lookupOrInsertNode(i),a++>1e3)throw new y(t);for(const b of p._util.getServiceDependencies(i.desc.ctor)){const c=this.r(b.id);if(c||this.y(`[createInstance] ${o} depends on ${b.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(b.id)),c instanceof O.$ni){const f={id:b.id,desc:c,_trace:i._trace.branch(b.id,!0)};t.insertEdge(i,f),d.push(f)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new y(t);break}for(const{data:b}of i){if(this.r(b.id)instanceof O.$ni){const f=this.w(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this.q(b.id,f)}t.removeNode(b)}}return this.r(o)}w(o,n,r=[],t,a){if(this.i.get(o)instanceof O.$ni)return this.x(o,n,r,t,a,this.g);if(this.k)return this.k.w(o,n,r,t,a);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}x(o,n,r=[],t,a,d){if(t){const i=new l(void 0,this.j,this,this.l);i.c=String(o);const b=new Map,c=new I.$Jh(()=>{const f=i.o(n,r,a);for(const[u,S]of b){const h=f[u];if(typeof h=="function")for(const E of S)E.disposable=h.apply(f,E.listener)}return b.clear(),d.add(f),f});return new Proxy(Object.create(null),{get(f,u){if(!c.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let E=b.get(u);return E||(E=new k.$5c,b.set(u,E)),(D,w,C)=>{if(c.isInitialized)return c.value[u](D,w,C);{const P={listener:[D,w,C],disposable:void 0},V=E.push(P);return(0,A.$Sc)(()=>{V(),P.disposable?.dispose()})}}}if(u in f)return f[u];const S=c.value;let h=S[u];return typeof h!="function"||(h=h.bind(S),f[u]=h),h},set(f,u,S){return c.value[u]=S,!0},getPrototypeOf(f){return n.prototype}})}else{const i=this.o(n,r,a);return d.add(i),i}}y(o,n){if(n&&console.warn(o),this.j)throw new Error(o)}}e.$7q=l;var v;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(v||(v={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,n){return o?new m(2,n.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,n){return o?new m(1,n.name):m.c}static{this.f=0}constructor(o,n){this.type=o,this.name=n,this.g=Date.now(),this.h=[]}branch(o,n){const r=new m(3,o.toString());return this.h.push([o,n,r]),r}stop(){const o=Date.now()-this.g;m.f+=o;let n=!1;function r(a,d){const i=[],b=new Array(a+1).join("	");for(const[c,f,u]of d.h)if(f&&u){n=!0,i.push(`${b}CREATES -> ${c}`);const S=r(a+1,u);S&&i.push(S)}else i.push(`${b}uses -> ${c}`);return i.join(`
`)}const t=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||n)&&m.all.add(t.join(`
`))}}e.$8q=m}),define(Ae[13],Re([1,0,159,43,5,99,6,28,21,24,17,2,31,3]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=s,e.log=n,e.$$j=h,e.$_j=E,e.$ak=g,e.$bk=D,e.$Wj=(0,v.$qi)("logService"),e.$Xj=(0,v.$qi)("loggerService");function m(){return new Date().toISOString()}function s(w){return(0,T.$8f)(w)}var o;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Zj=o.Info;function n(w,C,P){switch(C){case o.Trace:w.trace(P);break;case o.Debug:w.debug(P);break;case o.Info:w.info(P);break;case o.Warning:w.warn(P);break;case o.Error:w.error(P);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function r(w,C=!1){let P="";for(let V=0;V<w.length;V++){let W=w[V];if(W instanceof Error&&(W=(0,N.$bj)(W,C)),typeof W=="object")try{W=JSON.stringify(W)}catch{}P+=(V>0?" ":"")+W}return P}class t extends M.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new A.$be),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$2j=t;class a extends t{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(o.Trace)&&this.g(o.Trace,r([C,...P],!0))}debug(C,...P){this.f(o.Debug)&&this.g(o.Debug,r([C,...P]))}info(C,...P){this.f(o.Info)&&this.g(o.Info,r([C,...P]))}warn(C,...P){this.f(o.Warning)&&this.g(o.Warning,r([C,...P]))}error(C,...P){if(this.f(o.Error))if(C instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=C.stack,this.g(o.Error,r(V))}else this.g(o.Error,r([C,...P]))}flush(){}}e.$3j=a;class d extends t{constructor(C=e.$Zj){super(),this.setLevel(C),this.g=!$.$i}trace(C,...P){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,C,...P):console.warn(`[main ${m()}]`,C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,C,...P):console.error(`[main ${m()}]`,C,...P))}flush(){}}e.$4j=d;class i extends t{constructor(C=e.$Zj,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$5j=i;class b extends t{constructor(C,P=e.$Zj){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...P])}debug(C,...P){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...P])}info(C,...P){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...P])}warn(C,...P){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...P])}error(C,...P){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,N.$bj)(C,this.f(o.Trace))}flush(){}}e.$6j=b;class c extends t{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const V of this.g)V.trace(C,...P)}debug(C,...P){for(const V of this.g)V.debug(C,...P)}info(C,...P){for(const V of this.g)V.info(C,...P)}warn(C,...P){for(const V of this.g)V.warn(C,...P)}error(C,...P){for(const V of this.g)V.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$7j=c;class f extends M.$Uc{constructor(C,P,V){if(super(),this.h=C,this.j=P,this.b=new p.$Bc,this.c=this.B(new A.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$be),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(C){return(0,T.$4f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const V=this.n(C),W=(0,T.$4f)(C)?C:P?.id??(0,O.$ej)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const R=P?.logLevel==="always"?o.Trace:P?.logLevel;q||(q=this.s(V,R??this.getLogLevel(V)??this.h,{...P,id:W}));const U={logger:q,info:{resource:V,id:W,logLevel:R,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(U.info),this.b.set(V,U),q}n(C){return(0,T.$4f)(C)?(0,k.$4g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(y.URI.isUri(C)){const V=C,W=P,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=C;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const V=this.m(C);V&&P!==!V.info.hidden&&(V.info.hidden=!P,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=f;class u{constructor(){this.onDidChangeLogLevel=new A.$be().event}setLevel(C){}getLevel(){return o.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$9j=u;class S extends u{}e.$0j=S;function h(w){if(w.verbose)return o.Trace;if(typeof w.logLevel=="string"){const C=D(w.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Zj}function E(w){switch(w){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function g(w){switch(w){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function D(w){switch(w){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ck=new l.$Hj("logLevel",E(o.Info))}),define(Ae[194],Re([1,0,6,13]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0;class A extends I.$Uc{constructor(M,p=[]){super(),this.a=new N.$7j([M,...p]),this.B(M.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$AQ=A}),define(Ae[100],Re([1,0,33,160,3]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var M;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function($){function k(m,s){return s-m}$.compare=k;const T=Object.create(null);T[$.Error]=(0,N.localize)(0,null),T[$.Warning]=(0,N.localize)(1,null),T[$.Info]=(0,N.localize)(2,null);function y(m){return T[m]||""}$.toString=y;function l(m){switch(m){case I.default.Error:return $.Error;case I.default.Warning:return $.Warning;case I.default.Info:return $.Info;case I.default.Ignore:return $.Hint}}$.fromSeverity=l;function v(m){switch(m){case $.Error:return I.default.Error;case $.Warning:return I.default.Warning;case $.Info:return I.default.Info;case $.Hint:return I.default.Ignore}}$.toSeverity=v}(M||(e.MarkerSeverity=M={}));var p;(function($){const k="";function T(l){return y(l,!0)}$.makeKey=T;function y(l,v){const m=[k];return l.source?m.push(l.source.replace("\xA6","\\\xA6")):m.push(k),l.code?typeof l.code=="string"?m.push(l.code.replace("\xA6","\\\xA6")):m.push(l.code.value.replace("\xA6","\\\xA6")):m.push(k),l.severity!==void 0&&l.severity!==null?m.push(M.toString(l.severity)):m.push(k),l.message&&v?m.push(l.message.replace("\xA6","\\\xA6")):m.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?m.push(l.startLineNumber.toString()):m.push(k),l.startColumn!==void 0&&l.startColumn!==null?m.push(l.startColumn.toString()):m.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?m.push(l.endLineNumber.toString()):m.push(k),l.endColumn!==void 0&&l.endColumn!==null?m.push(l.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}$.makeKeyOptionalMessage=y})(p||(e.IMarkerData=p={})),e.$Tt=(0,A.$qi)("markerService")}),define(Ae[195],Re([1,0,5,33,3]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tv=e.Severity=void 0,e.$Uv=p,e.Severity=N.default,e.$Tv=(0,A.$qi)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var M;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(y){if(y){const l=y;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var $;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class k{constructor(){this.progress=new T,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$Vv=k;class T{infinite(){}done(){}total(l){}worked(l){}}e.$Wv=T}),define(Ae[196],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,I.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(fe,e,I,N){var A=arguments.length,O=A<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(fe,e,I,N);else for(var p=fe.length-1;p>=0;p--)(M=fe[p])&&(O=(A<3?M(O):A>3?M(e,I,O):M(e,I))||O);return A>3&&O&&Object.defineProperty(e,I,O),O},Ve=this&&this.__param||function(fe,e){return function(I,N){e(I,N,fe)}};define(Ae[101],Re([1,0,11,22,6,3]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.ProgressLocation=e.$Xv=void 0,e.$Xv=(0,O.$qi)("progressService");var M;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Yv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$Zv=p;class ${get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const v=this.d;this.d=()=>{v?.(),l()}}):Promise.resolve()}}e.$1v=$;let k=class extends A.$Uc{constructor(l,v){super(),this.a=new I.$Nh,v.withProgress(l,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,A.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$2v=k,e.$2v=k=Je([Ve(1,e.$Xv)],k);class T extends A.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new A.$Tc)}start(l){this.stop();const v=++this.a,m=new N.$me;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,A.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Sc)(()=>m.cancel())),this.b.add((0,A.$Sc)(()=>this.c?this.c.done():void 0)),{id:v,token:m.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$3v=T,e.$4v=(0,O.$qi)("editorProgressService")}),define(Ae[30],Re([1,0,56,17]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class A{constructor(){this.a=new Map}add(M,p){I.ok(N.$4f(M)),I.ok(N.$6f(p)),I.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$9n=new A}),define(Ae[72],Re([1,0,5,30]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function A(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this.b=new I.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,k){this.a[A($)]=k,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const M=new O;N.$9n.add(e.$0n.JSONContribution,M)}),define(Ae[57],Re([1,0,18,5,17,153,48,72,30]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=s,e.$no=o,e.$oo=n,e.$po=t,e.$qo=a;var k;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$bo={Configuration:"base.contributions.configuration"};var T;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const y=$.$9n.as(p.$0n.JSONContribution);class l{constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$io,this.g),this.v()}registerConfiguration(i,b=!0){this.registerConfigurations([i],b)}registerConfigurations(i,b=!0){const c=new Set;this.n(i,b,c),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(i){const b=new Set;this.o(i,b),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:b})}updateConfigurations({add:i,remove:b}){const c=new Set;this.o(b,c),this.n(i,!1,c),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(i){const b=new Set;this.k(i,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}k(i,b){const c=[];for(const{overrides:f,source:u}of i)for(const S in f)if(b.add(S),e.$lo.test(S)){const h=this.a.get(S),E=h?.valuesSources??new Map;if(u)for(const C of Object.keys(f[S]))E.set(C,u);const g={...h?.value||{},...f[S]};this.a.set(S,{source:u,value:g,valuesSources:E});const D=(0,M.$7i)(S),w={type:"object",default:g,description:O.localize(1,null,D),$ref:e.$io,defaultDefaultValue:g,source:A.$4f(u)?void 0:u,defaultValueSource:u};c.push(...s(S)),this.d[S]=w,this.b.properties[S]=w}else{this.a.set(S,{value:f[S],source:u});const h=this.d[S];h&&(this.w(S,h),this.r(S,h))}this.m(c)}deregisterDefaultConfigurations(i){const b=new Set;this.l(i,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}l(i,b){for(const{overrides:c,source:f}of i)for(const u in c){const S=this.a.get(u),h=A.$4f(f)?f:f?.id,E=A.$4f(S?.source)?S?.source:S?.source?.id;if(h===E)if(b.add(u),this.a.delete(u),e.$lo.test(u))delete this.d[u],delete this.b.properties[u];else{const g=this.d[u];g&&(this.w(u,g),this.r(u,g))}}this.u()}deltaConfiguration(i){let b=!1;const c=new Set;i.removedDefaults&&(this.l(i.removedDefaults,c),b=!0),i.addedDefaults&&(this.k(i.addedDefaults,c),b=!0),i.removedConfigurations&&this.o(i.removedConfigurations,c),i.addedConfigurations&&this.n(i.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:b})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const b of i)this.h.add(b);this.u()}n(i,b,c){i.forEach(f=>{this.p(f,b,f.extensionInfo,f.restrictedProperties,void 0,c),this.c.push(f),this.q(f)})}o(i,b){const c=f=>{if(f.properties)for(const u in f.properties){b.add(u);const S=this.d[u];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[u],this.s(u,f.properties[u])}f.allOf?.forEach(u=>c(u))};for(const f of i){c(f);const u=this.c.indexOf(f);u!==-1&&this.c.splice(u,1)}}p(i,b=!0,c,f,u=3,S){u=A.$ag(i.scope)?u:i.scope;const h=i.properties;if(h)for(const g in h){const D=h[g];if(b&&t(g,D)){delete h[g];continue}if(D.source=c,D.defaultDefaultValue=h[g].default,this.w(g,D),e.$lo.test(g)?D.scope=void 0:(D.scope=A.$ag(D.scope)?u:D.scope,D.restricted=A.$ag(D.restricted)?!!f?.includes(g):D.restricted),h[g].hasOwnProperty("included")&&!h[g].included){this.f[g]=h[g],delete h[g];continue}else this.d[g]=h[g],h[g].policy?.name&&this.e.set(h[g].policy.name,g);!h[g].deprecationMessage&&h[g].markdownDeprecationMessage&&(h[g].deprecationMessage=h[g].markdownDeprecationMessage),S.add(g)}const E=i.allOf;if(E)for(const g of E)this.p(g,b,c,f,u,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const b=c=>{const f=c.properties;if(f)for(const S in f)this.r(S,f[S]);c.allOf?.forEach(b)};b(i)}r(i,b){switch(e.$co.properties[i]=b,b.scope){case 1:e.$do.properties[i]=b;break;case 2:e.$eo.properties[i]=b;break;case 6:e.$fo.properties[i]=b;break;case 3:e.$go.properties[i]=b;break;case 4:e.$ho.properties[i]=b;break;case 5:e.$ho.properties[i]=b,this.g.properties[i]=b;break}}s(i,b){switch(delete e.$co.properties[i],b.scope){case 1:delete e.$do.properties[i];break;case 2:delete e.$eo.properties[i];break;case 6:delete e.$fo.properties[i];break;case 3:delete e.$go.properties[i];break;case 4:case 5:delete e.$ho.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const b=`[${i}]`,c={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$io};this.w(b,c),e.$co.properties[b]=c,e.$do.properties[b]=c,e.$eo.properties[b]=c,e.$fo.properties[b]=c,e.$go.properties[b]=c,e.$ho.properties[b]=c}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=i,e.$do.patternProperties[e.$ko]=i,e.$eo.patternProperties[e.$ko]=i,e.$fo.patternProperties[e.$ko]=i,e.$go.patternProperties[e.$ko]=i,e.$ho.patternProperties[e.$ko]=i,this.i.fire()}w(i,b){const c=this.a.get(i);let f=c?.value,u=c?.source;A.$$f(f)&&(f=b.defaultDefaultValue,u=void 0),A.$$f(f)&&(f=n(b.type)),b.default=f,b.defaultValueSource=u}}const v="\\[([^\\]]+)\\]",m=new RegExp(v,"g");e.$ko=`^(${v})+$`,e.$lo=new RegExp(e.$ko);function s(d){const i=[];if(e.$lo.test(d)){let b=m.exec(d);for(;b?.length;){const c=b[1].trim();c&&i.push(c),b=m.exec(d)}}return(0,I.$Mb)(i)}function o(d){return d.reduce((i,b)=>`${i}[${b}]`,"")}function n(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const r=new l;$.$9n.add(e.$bo.Configuration,r);function t(d,i){return d.trim()?e.$lo.test(d)?O.localize(7,null,d):r.getConfigurationProperties()[d]!==void 0?O.localize(8,null,d):i.policy?.name&&r.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,d,i.policy?.name,r.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}function a(){const d=[],i=r.getConfigurationProperties();for(const b of Object.keys(i))d.push([b,i[b].scope]);return d.push(["launch",4]),d.push(["task",4]),d}}),define(Ae[197],Re([1,0,18,5,123,6,28,26,17,2,48,57,30]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=t;function v(b){return Object.isFrozen(b)?b:p.$Xn(b)}class m{static createEmptyModel(c){return new m({},[],[],void 0,c)}constructor(c,f,u,S,h){this.b=c,this.c=f,this.d=u,this.raw=S,this.f=h,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const c=this.raw.map(f=>{if(f instanceof m)return f;const u=new s("",this.f);return u.parseRaw(f),u.configurationModel});this.g=c.reduce((f,u)=>u===f?u:f.merge(u),c[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,T.$5i)(this.contents,c):this.contents}inspect(c,f){const u=this;return{get value(){return v(u.rawConfiguration.getValue(c))},get override(){return f?v(u.rawConfiguration.getOverrideValue(c,f)):void 0},get merged(){return v(f?u.rawConfiguration.override(f).getValue(c):u.rawConfiguration.getValue(c))},get overrides(){const S=[];for(const{contents:h,identifiers:E,keys:g}of u.rawConfiguration.overrides){const D=new m(h,g,[],void 0,u.f).getValue(c);D!==void 0&&S.push({identifiers:E,value:D})}return S.length?v(S):void 0}}}getOverrideValue(c,f){const u=this.j(f);return u?c?(0,T.$5i)(u,c):u:void 0}getKeysForOverrideIdentifier(c){const f=[];for(const u of this.overrides)u.identifiers.includes(c)&&f.push(...u.keys);return I.$Mb(f)}getAllOverrideIdentifiers(){const c=[];for(const f of this.overrides)c.push(...f.identifiers);return I.$Mb(c)}override(c){let f=this.a.get(c);return f||(f=this.h(c),this.a.set(c,f)),f}merge(...c){const f=p.$Wn(this.contents),u=p.$Wn(this.overrides),S=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const E of c)if(h.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.i(f,E.contents);for(const g of E.overrides){const[D]=u.filter(w=>I.$ub(w.identifiers,g.identifiers));D?(this.i(D.contents,g.contents),D.keys.push(...g.keys),D.keys=I.$Mb(D.keys)):u.push(p.$Wn(g))}for(const g of E.keys)S.indexOf(g)===-1&&S.push(g)}return new m(f,S,u,h.every(E=>E instanceof m)?void 0:h,this.f)}h(c){const f=this.j(c);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const u={};for(const S of I.$Mb([...Object.keys(this.contents),...Object.keys(f)])){let h=this.contents[S];const E=f[S];E&&(typeof h=="object"&&typeof E=="object"?(h=p.$Wn(h),this.i(h,E)):h=E),u[S]=h}return new m(u,this.keys,this.overrides,void 0,this.f)}i(c,f){for(const u of Object.keys(f)){if(u in c&&$.$6f(c[u])&&$.$6f(f[u])){this.i(c[u],f[u]);continue}c[u]=p.$Wn(f[u])}}j(c){let f=null,u=null;const S=h=>{h&&(u?this.i(u,h):u=p.$Wn(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===c?f=h.contents:h.identifiers.includes(c)&&S(h.contents);return S(f),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,f){this.k(c,f,!0)}setValue(c,f){this.k(c,f,!1)}removeValue(c){const f=this.keys.indexOf(c);f!==-1&&(this.keys.splice(f,1),(0,T.$4i)(this.contents,c),y.$lo.test(c)&&this.overrides.splice(this.overrides.findIndex(u=>I.$ub(u.identifiers,(0,y.$mo)(c))),1))}k(c,f,u){(0,T.$3i)(this.contents,c,f,S=>this.f.error(S)),u=u||this.keys.indexOf(c)===-1,u&&this.keys.push(c),y.$lo.test(c)&&this.overrides.push({identifiers:(0,y.$mo)(c),keys:Object.keys(this.contents[c]),contents:(0,T.$2i)(this.contents[c],S=>this.f.error(S))})}}e.$ro=m;class s{constructor(c,f){this.f=c,this.g=f,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,f){if(!$.$ag(c)){const u=this.h(c);this.parseRaw(u,f)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,f){this.a=c;const{contents:u,keys:S,overrides:h,restricted:E,hasExcludedProperties:g}=this.i(c,f);this.b=new m(u,S,h,g?[c]:void 0,this.g),this.c=E||[]}h(c){let f={},u=null,S=[];const h=[],E=[];function g(w){Array.isArray(S)?S.push(w):u!==null&&(S[u]=w)}const D={onObjectBegin:()=>{const w={};g(w),h.push(S),S=w,u=null},onObjectProperty:w=>{u=w},onObjectEnd:()=>{S=h.pop()},onArrayBegin:()=>{const w=[];g(w),h.push(S),S=w,u=null},onArrayEnd:()=>{S=h.pop()},onLiteralValue:g,onError:(w,C,P)=>{E.push({error:w,offset:C,length:P})}};if(c)try{A.$Kn(c,D),f=S[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return f}i(c,f){const u=l.$9n.as(y.$bo.Configuration).getConfigurationProperties(),S=this.j(c,u,!0,f);c=S.raw;const h=(0,T.$2i)(c,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),E=Object.keys(c),g=this.l(c,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:h,keys:E,overrides:g,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(c,f,u,S){let h=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:h};const E={},g=[];for(const D in c)if(y.$lo.test(D)&&u){const w=this.j(c[D],f,!1,S);E[D]=w.raw,h=h||w.hasExcludedProperties,g.push(...w.restricted)}else{const w=f[D],C=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&g.push(D),!S.exclude?.includes(D)&&(S.include?.includes(D)||(C===void 0||S.scopes===void 0||S.scopes.includes(C))&&!(S.skipRestricted&&w?.restricted))?E[D]=c[D]:h=!0}return{raw:E,restricted:g,hasExcludedProperties:h}}l(c,f){const u=[];for(const S of Object.keys(c))if(y.$lo.test(S)){const h={};for(const E in c[S])h[E]=c[S][E];u.push({identifiers:(0,y.$mo)(S),keys:Object.keys(h),contents:(0,T.$2i)(h,f)})}return u}}e.$so=s;class o extends O.$Uc{constructor(c,f,u,S,h){super(),this.c=c,this.f=f,this.g=S,this.h=h,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),h),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&u.isEqual(E.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=o;class n{constructor(c,f,u,S,h,E,g,D,w,C,P,V,W){this.a=c,this.b=f,this.c=u,this.overrideIdentifiers=S,this.d=h,this.f=E,this.g=g,this.h=D,this.i=w,this.j=C,this.k=P,this.l=V,this.m=W}get value(){return v(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class r{constructor(c,f,u,S,h,E,g,D,w,C){this.j=c,this.l=f,this.m=u,this.n=S,this.p=h,this.q=E,this.r=g,this.s=D,this.t=w,this.u=C,this.h=null,this.i=new M.$Bc,this.v=null}getValue(c,f,u){return this.w(c,f,u).getValue(c)}updateValue(c,f,u={}){let S;u.resource?(S=this.t.get(u.resource),S||(S=m.createEmptyModel(this.u),this.t.set(u.resource,S))):S=this.s,f===void 0?S.removeValue(c):S.setValue(c,f),u.resource||(this.h=null)}inspect(c,f,u){const S=this.w(c,f,u),h=this.A(f.resource,u),E=f.resource?this.t.get(f.resource)||this.s:this.s,g=new Set;for(const D of S.overrides)for(const w of D.identifiers)S.getOverrideValue(c,w)!==void 0&&g.add(w);return new n(c,f,S.getValue(c),g.size?[...g]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,h||void 0,E)}keys(c){const f=this.A(void 0,c);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(c){this.j=c,this.h=null,this.i.clear()}updatePolicyConfiguration(c){this.l=c}updateApplicationConfiguration(c){this.m=c,this.h=null,this.i.clear()}updateLocalUserConfiguration(c){this.n=c,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(c){this.p=c,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(c){this.q=c,this.h=null,this.i.clear()}updateFolderConfiguration(c,f){this.r.set(c,f),this.i.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.i.delete(c)}compareAndUpdateDefaultConfiguration(c,f){const u=[];if(!f){const{added:S,updated:h,removed:E}=d(this.j,c);f=[...S,...h,...E]}for(const S of f)for(const h of(0,y.$mo)(S)){const E=this.j.getKeysForOverrideIdentifier(h),g=c.getKeysForOverrideIdentifier(h),D=[...g.filter(w=>E.indexOf(w)===-1),...E.filter(w=>g.indexOf(w)===-1),...E.filter(w=>!p.$1n(this.j.override(h).getValue(w),c.override(h).getValue(w)))];u.push([h,D])}return this.updateDefaultConfiguration(c),{keys:f,overrides:u}}compareAndUpdatePolicyConfiguration(c){const{added:f,updated:u,removed:S}=d(this.l,c),h=[...f,...u,...S];return h.length&&this.updatePolicyConfiguration(c),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:f,updated:u,removed:S,overrides:h}=d(this.applicationConfiguration,c),E=[...f,...u,...S];return E.length&&this.updateApplicationConfiguration(c),{keys:E,overrides:h}}compareAndUpdateLocalUserConfiguration(c){const{added:f,updated:u,removed:S,overrides:h}=d(this.localUserConfiguration,c),E=[...f,...u,...S];return E.length&&this.updateLocalUserConfiguration(c),{keys:E,overrides:h}}compareAndUpdateRemoteUserConfiguration(c){const{added:f,updated:u,removed:S,overrides:h}=d(this.remoteUserConfiguration,c),E=[...f,...u,...S];return E.length&&this.updateRemoteUserConfiguration(c),{keys:E,overrides:h}}compareAndUpdateWorkspaceConfiguration(c){const{added:f,updated:u,removed:S,overrides:h}=d(this.workspaceConfiguration,c),E=[...f,...u,...S];return E.length&&this.updateWorkspaceConfiguration(c),{keys:E,overrides:h}}compareAndUpdateFolderConfiguration(c,f){const u=this.folderConfigurations.get(c),{added:S,updated:h,removed:E,overrides:g}=d(u,f),D=[...S,...h,...E];return(D.length||!u)&&this.updateFolderConfiguration(c,f),{keys:D,overrides:g}}compareAndDeleteFolderConfiguration(c){const f=this.folderConfigurations.get(c);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:u,updated:S,removed:h,overrides:E}=d(f,void 0);return{keys:[...u,...S,...h],overrides:E}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(c,f,u){let S=this.x(f,u);return f.overrideIdentifier&&(S=S.override(f.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(c)!==void 0&&(S=S.merge(this.l)),S}x({resource:c},f){let u=this.y();if(f&&c){const S=f.getFolder(c);S&&(u=this.z(S.uri)||u);const h=this.t.get(c);h&&(u=u.merge(h))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(c){let f=this.i.get(c);if(!f){const u=this.y(),S=this.r.get(c);S?(f=u.merge(S),this.i.set(c,f)):f=u}return f}A(c,f){if(f&&c){const u=f.getFolder(c);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((c,f)=>{const{contents:u,overrides:S,keys:h}=this.r.get(f);return c.push([f,{contents:u,overrides:S,keys:h}]),c},[])}}allKeys(){const c=new Set;return this.j.keys.forEach(f=>c.add(f)),this.userConfiguration.keys.forEach(f=>c.add(f)),this.q.keys.forEach(f=>c.add(f)),this.r.forEach(f=>f.keys.forEach(u=>c.add(u))),[...c.values()]}B(){const c=new Set;return this.j.getAllOverrideIdentifiers().forEach(f=>c.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>c.add(f)),this.q.getAllOverrideIdentifiers().forEach(f=>c.add(f)),this.r.forEach(f=>f.getAllOverrideIdentifiers().forEach(u=>c.add(u))),[...c.values()]}D(c){const f=new Set;return this.j.getKeysForOverrideIdentifier(c).forEach(u=>f.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(u=>f.add(u)),this.q.getKeysForOverrideIdentifier(c).forEach(u=>f.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(c).forEach(S=>f.add(S))),[...f.values()]}static parse(c,f){const u=this.E(c.defaults,f),S=this.E(c.policy,f),h=this.E(c.application,f),E=this.E(c.user,f),g=this.E(c.workspace,f),D=c.folders.reduce((w,C)=>(w.set(k.URI.revive(C[0]),this.E(C[1],f)),w),new M.$Bc);return new r(u,S,h,E,m.createEmptyModel(f),g,D,m.createEmptyModel(f),new M.$Bc,f)}static E(c,f){return new m(c.contents,c.keys,c.overrides,void 0,f)}}e.$uo=r;function t(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const c=new Set,f=new Map;for(const S of b)S.keys.forEach(h=>c.add(h)),S.overrides.forEach(([h,E])=>{const g=(0,M.$yc)(f,h,new Set);E.forEach(D=>g.add(D))});const u=[];return f.forEach((S,h)=>u.push([h,[...S.values()]])),{keys:[...c.values()],overrides:u}}class a{constructor(c,f,u,S,h){this.change=c,this.f=f,this.g=u,this.h=S,this.i=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const E of c.keys)this.affectedKeys.add(E);for(const[,E]of c.overrides)for(const g of E)this.affectedKeys.add(g);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=r.parse(this.f.data,this.i)),this.j}affectsConfiguration(c,f){const u=this.a+c,S=this.d.indexOf(u);if(S<0)return!1;const h=S+u.length;if(h>=this.d.length)return!1;const E=this.d.charCodeAt(h);if(E!==this.b&&E!==this.c)return!1;if(f){const g=this.previousConfiguration?this.previousConfiguration.getValue(c,f,this.f?.workspace):void 0,D=this.g.getValue(c,f,this.h);return!p.$1n(g,D)}return!0}}e.$wo=a;function d(b,c){const{added:f,removed:u,updated:S}=i(c?.rawConfiguration,b?.rawConfiguration),h=[],E=b?.getAllOverrideIdentifiers()||[],g=c?.getAllOverrideIdentifiers()||[];if(c){const D=g.filter(w=>!E.includes(w));for(const w of D)h.push([w,c.getKeysForOverrideIdentifier(w)])}if(b){const D=E.filter(w=>!g.includes(w));for(const w of D)h.push([w,b.getKeysForOverrideIdentifier(w)])}if(c&&b){for(const D of E)if(g.includes(D)){const w=i({contents:b.getOverrideValue(void 0,D)||{},keys:b.getKeysForOverrideIdentifier(D)},{contents:c.getOverrideValue(void 0,D)||{},keys:c.getKeysForOverrideIdentifier(D)});h.push([D,[...w.added,...w.removed,...w.updated]])}}return{added:f,removed:u,updated:S,overrides:h}}function i(b,c){const f=b?c?b.keys.filter(h=>c.keys.indexOf(h)===-1):[...b.keys]:[],u=c?b?c.keys.filter(h=>b.keys.indexOf(h)===-1):[...c.keys]:[],S=[];if(b&&c){for(const h of c.keys)if(b.keys.indexOf(h)!==-1){const E=(0,T.$5i)(c.contents,h),g=(0,T.$5i)(b.contents,h);p.$1n(E,g)||S.push(h)}}return{added:f,removed:u,updated:S}}}),define(Ae[102],Re([1,0,14,3]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=k,e.$Bl=(0,N.$qi)("remoteAuthorityResolverService");var A;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class O{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=O;class M{constructor(y,l){this.host=y,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=M;var p;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class $ extends I.$bb{static isNotAvailable(y){return y instanceof $&&y._code===p.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof $&&y._code===p.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof $&&y._code===p.NoResolverFound}static isInvalidAuthority(y){return y instanceof $&&y._code===p.InvalidAuthority}static isHandled(y){return y instanceof $&&y.isHandled}constructor(y,l=p.Unknown,v){super(y),this._message=y,this._code=l,this._detail=v,this.isHandled=l===p.NotAvailable&&v===!0,Object.setPrototypeOf(this,$.prototype)}}e.$El=$;function k(T){const y=T.indexOf("+");return y===-1?T:T.substring(0,y)}}),define(Ae[58],Re([1,0,12]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=N,e.$Cm=A,e.$Dm=O,e.$Em=M;function N($){return $.scheme===I.Schemas.vscodeRemote?$.authority:void 0}function A($){if(!$)return;const k=$.indexOf("+");return k<0?$:$.substr(0,k)}function O($){const{host:k,port:T}=p($);if(typeof T>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:T}}function M($,k){let{host:T,port:y}=p($);return typeof y>"u"&&(y=k),{host:T,port:y}}function p($){const k=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const T=$.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const y=$.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:$,port:void 0}}}),define(Ae[20],Re([1,0,15,3,58]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=O,e.$Om=y,e.$Pm=l,e.$Qm=v,e.$Rm=m,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function O(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class ${constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,n){if(typeof o>"u"||o===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof o=="string"||typeof n=="string"){const r=typeof o=="string"?o:o.value,t=typeof n=="string"?n:n.value;return I.$tf(r,t)}return o._lower===n._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Lm=$;class k{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const n of o)this.add(n)}add(o){this.c.add($.toKey(o))}delete(o){return this.c.delete($.toKey(o))}has(o){return this.c.has($.toKey(o))}}e.$Mm=k;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete($.toKey(o))}get(o){return this.c.get($.toKey(o))}has(o){return this.c.has($.toKey(o))}set(o,n){this.c.set($.toKey(o),n)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=T;function y(s){return l(s)}function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function v(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function m(s,o){if(o){const n=`onResolveRemoteAuthority:${(0,A.$Cm)(o)}`;return!!s.activationEvents?.includes(n)}return!1}e.$Sm=(0,N.$qi)("IBuiltinExtensionsScannerService")}),define(Ae[103],Re([1,0,14,20]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const $ of M){const k=this.readActivationEvents($);k.length>0&&(p[N.$Lm.toKey($.identifier)]=k)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let $=0;$<p.length;$++)p[$]==="onUri"&&(p[$]=`onUri:${N.$Lm.toKey(M.identifier)}`);if(!M.contributes)return p;for(const $ in M.contributes){const k=this.a.get($);if(!k)continue;const T=M.contributes[$],y=Array.isArray(T)?T:[T];try{k(y,p)}catch(l){(0,I.$1)(l)}}return p}}e.$cG=A,e.$dG=new A}),define(Ae[198],Re([1,0,21,73,35]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=M,e.$$o=p;function O($){if(I.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function M($,k,T,y,l,v,m,s,o){const n=Object.create(null);n["common.machineId"]=v,n["common.sqmId"]=m,n.sessionID=(0,A.$Mg)()+Date.now(),n.commitHash=y,n.version=l,n["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),n["common.platform"]=(0,I.$h)(I.$u),n["common.nodePlatform"]=N.$ec,n["common.nodeArch"]=T,n["common.product"]=o||"desktop",s&&(n["common.msftInternal"]=s);let r=0;const t=Date.now();Object.defineProperties(n,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),I.$l&&(n["common.snap"]="true");const a=O(k);return a&&(n["common.platformDetail"]=a),n}function p($){const k=N.env.USERDNSDOMAIN;if(!k)return!1;const T=k.toLowerCase();return $.some(y=>T===y)}}),define(Ae[199],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,I.$qi)("telemetryService"),e.$Wl=(0,I.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var N;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var A;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Ae[59],Re([1,0,26,17,58,198,199]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=T,e.$hp=y,e.$ip=l,e.$jp=v,e.$kp=s,e.$lp=n,e.$mp=r,e.$np=d;class p{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$_o=p;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=$,e.$bp=new $;class k{async publicLog(b,c,f){}async publicLogError(b,c,f){}}e.$cp=k,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function T(i,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!i.enableTelemetry)}function y(i,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function l(i){const b=i.getValue(M.$4l),c=i.getValue(M.$5l);if(i.getValue(M.$6l)===!1||c===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function v(i){const b={},c={},f={};o(i,f);for(let u in f){u=u.length>150?u.substr(u.length-149):u;const S=f[u];typeof S=="number"?c[u]=S:typeof S=="boolean"?c[u]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${S.length}`),b[u]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(b[u]=S)}return{properties:b,measurements:c}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const b=(0,A.$Cm)(i);return m.has(b)?b:"other"}function o(i,b,c=0,f){if(i)for(const u of Object.getOwnPropertyNames(i)){const S=i[u],h=f?f+u:u;Array.isArray(S)?b[h]=(0,I.$2n)(S):S instanceof Date?b[h]=S.toISOString():(0,N.$6f)(S)?c<2?o(S,b,c+1,h+"."):b[h]=(0,I.$2n)(S):b[h]=S}}function n(i,b){const c=i.msftInternalDomains||[],f=b.getValue("telemetry.internalTesting");return(0,O.$$o)(c)||f}function r(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,b){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let c=i;const f=[];for(const E of b)for(;;){const g=E.exec(i);if(!g)break;f.push([g.index,E.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(c="";;){const E=S.exec(i);if(!E)break;const g=f.some(([D,w])=>E.index<w&&D<S.lastIndex);!u.test(E[0])&&!g&&(c+=i.substring(h,E.index)+"<REDACTED: user-file-path>",h=S.lastIndex)}return h<i.length&&(c+=i.substr(h)),c}function a(i){if(!i)return i;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of b)if(c.regex.test(i))return`<REDACTED: ${c.label}>`;return i}function d(i,b){return(0,I.$Yn)(i,c=>{if(c instanceof p||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let f=c.replaceAll("%20"," ");f=t(f,b);for(const u of b)f=f.replace(u,"");return f=a(f),f}})}}),define(Ae[200],Re([1,0,15,98,20,21,2,14,73,59]),function(fe,e,I,N,A,O,M,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=T,e.$qp=m,e.$rp=s,e.$sp=o,e.$tp=n,e.$up=r,e.$vp=t,e.$wp=a,e.$yp=d,e.$zp=b;function T(c,f){return c.uuid&&f.uuid?c.uuid===f.uuid:c.id===f.id?!0:(0,I.$of)(c.id,f.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(f){const u=f.manifest?f.manifest.version:f.version,S=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new l(f.identifier,u,S)}static parse(f){const u=y.exec(f);return u&&u[1]&&u[2]?new l({id:u[1]},u[2],u[4]||void 0):null}constructor(f,u,S="undefined"){this.version=u,this.targetPlatform=S,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof l?T(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$pp=l;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(c){const f=v.exec(c);return f&&f[1]?[o(f[1]),f[2]]:[o(c),void 0]}function s(c,f){return`${c}.${f}`}function o(c){return c.toLowerCase()}function n(c,f){return o(s(c??A.$Hm,f))}function r(c,f){const u=[],S=h=>{for(const E of u)if(E.some(g=>T(f(g),f(h))))return E;return null};for(const h of c){const E=S(h);E?E.push(h):u.push([h])}return u}function t(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new k.$_o(c.identifier.id),name:new k.$_o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$xp=new A.$Lm("pprice.better-merge");function d(c,f){const u=[],S=f.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const h=S.shift();if(h&&u.every(E=>!T(E.identifier,{id:h}))){const E=c.filter(g=>T(g.identifier,{id:h}));E.length===1&&(u.push(E[0]),S.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function i(c,f){if(!O.$k)return!1;let u;try{u=(await c.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await c.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){f.debug("Error while getting the os-release file.",(0,p.$0)(h))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function b(c,f){const u=await i(c,f),S=(0,N.$Vo)(u?"alpine":O.$u,$.$fc);return f.debug("ComputeTargetPlatform:",S),S}}),define(Ae[201],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=I,e.$ds=N,e.$es=A,e.$fs=O,e.$gs=M,e.$hs=p;function I($){return[...$.entries()]}function N($){return $?[...$.entries()]:[]}function A($){return new Map($)}function O($){return new Map($??[])}function M($){return Array.from($.entries()).map(k=>[k[0],I(k[1].map),N(k[1].descriptionMap)])}function p($){return new Map($.map(k=>[k[0],{map:A(k[1]),descriptionMap:O(k[2])}]))}}),define(Ae[202],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rsb=void 0;class I{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,O,M=5){const p=O($=>{const k=typeof $=="string"?$:$.data;let T=this.a.get(A);if(T){T.data.push(k);return}const y=setTimeout(()=>this.flushBuffer(A),M);T={data:[k],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(A),p.dispose()}},this.a.set(A,T)});return p}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const O=this.a.get(A);O&&(this.a.delete(A),this.b(A,O.data.join("")))}}e.$Rsb=I}),define(Ae[203],Re([1,0,11,91,302,42,5,17,2,161,72,30]),function(fe,e,I,N,A,O,M,p,$,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0w=e.$9w=e.$8w=e.$7w=e.$6w=e.$5w=e.IconFontDefinition=e.IconContribution=e.$2w=void 0,e.$3w=o,e.$4w=n,e.$2w={IconContribution:"base.contributions.icons"};var l;(function(d){function i(b,c){let f=b.defaults;for(;O.ThemeIcon.isThemeIcon(f);){const u=s.getIcon(f.id);if(!u)return;f=u.defaults}return f}d.getDefinition=i})(l||(e.IconContribution=l={}));var v;(function(d){function i(c){return{weight:c.weight,style:c.style,src:c.src.map(f=>({format:f.format,location:f.location.toString()}))}}d.toJSONObject=i;function b(c){const f=u=>(0,p.$4f)(u)?u:void 0;if(c&&Array.isArray(c.src)&&c.src.every(u=>(0,p.$4f)(u.format)&&(0,p.$4f)(u.location)))return{weight:f(c.weight),style:f(c.style),src:c.src.map(u=>({format:u.format,location:$.URI.parse(u.location)}))}}d.fromJSONObject=b})(v||(e.IconFontDefinition=v={}));class m{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,b,c,f){const u=this.b[i];if(u){if(c&&!u.description){u.description=c,this.d.properties[i].markdownDescription=`${c} $(${i})`;const E=this.e.enum.indexOf(i);E!==-1&&(this.e.enumDescriptions[E]=c),this.a.fire()}return u}const S={id:i,description:c,defaults:b,deprecationMessage:f};this.b[i]=S;const h={$ref:"#/definitions/icons"};return f&&(h.deprecationMessage=f),c&&(h.markdownDescription=`${c}: $(${i})`),this.d.properties[i]=h,this.e.enum.push(i),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const b=this.e.enum.indexOf(i);b!==-1&&(this.e.enum.splice(b,1),this.e.enumDescriptions.splice(b,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,b){const c=this.f[i];return c||(this.f[i]=b,this.a.fire(),b)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(u,S)=>u.id.localeCompare(S.id),b=u=>{for(;O.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.b).map(u=>this.b[u]);for(const u of f.filter(S=>!!S.description).sort(i))c.push(`|<i class="${b(u)}"></i>|${u.id}|${O.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const u of f.filter(S=>!O.ThemeIcon.isThemeIcon(S.defaults)).sort(i))c.push(`|<i class="${b(u)}"></i>|${u.id}|`);return c.join(`
`)}}const s=new m;y.$9n.add(e.$2w.IconContribution,s);function o(d,i,b,c){return s.registerIcon(d,i,b,c)}function n(){return s}function r(){const d=(0,A.$Lj)();for(const i in d){const b="\\"+d[i].toString(16);s.registerIcon(i,{fontCharacter:b})}}r(),e.$5w="vscode://schemas/icons";const t=y.$9n.as(T.$0n.JSONContribution);t.registerSchema(e.$5w,s.getIconSchema());const a=new I.$Ch(()=>t.notifySchemaChanged(e.$5w),200);s.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$6w=o("widget-close",N.$Pj.close,(0,k.localize)(2,null)),e.$7w=o("goto-previous-location",N.$Pj.arrowUp,(0,k.localize)(3,null)),e.$8w=o("goto-next-location",N.$Pj.arrowDown,(0,k.localize)(4,null)),e.$9w=O.ThemeIcon.modify(N.$Pj.sync,"spin"),e.$0w=O.ThemeIcon.modify(N.$Pj.loading,"spin")}),define(Ae[204],Re([1,0,5,2,48,3,13]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=k,e.$8v=y,e.$9v=l,e.$$v=v,e.$aw=m,e.$bw=s,e.$5v=(0,O.$qi)("tunnelService"),e.$6v=(0,O.$qi)("sharedTunnelsService");var p;(function(r){r.Http="http",r.Https="https"})(p||(e.TunnelProtocol=p={}));var $;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})($||(e.TunnelPrivacyId=$={}));function k(r){return!!r.forwardPort}var T;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function y(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function l(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const a of t){const d=a.split("=")[1];if(/^https?:/.exec(d)){const i=y(N.URI.parse(d));if(i)return i}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(r){return e.$0v.indexOf(r)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(r){return e.$_v.indexOf(r)>=0}function s(r,t,a,d){if(a===1)return!1;if(a===2&&m(t)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(i?.length===4&&parseInt(i[1])>=18)return!1}return r<1024}class o{constructor(t,a,d){this.remoteAddress=t,this.localAddress=a,this.b=d,this.a=new I.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=o;let n=class{constructor(t,a){this.k=t,this.l=a,this.a=new I.$be,this.onTunnelOpened=this.a.event,this.b=new I.$be,this.onTunnelClosed=this.b.event,this.c=new I.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],a=Array.from(this.e.values());for(const d of a){const i=Array.from(d.values());for(const b of i){const c=await b.value;c&&typeof c!="string"&&t.push(c)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:a}of t.values())await a.then(d=>typeof d!="string"?d?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,a,d,i,b){this.q(t,a,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:a,localAddress:d,privacy:i,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,a){(m(t)||v(t))&&(t=e.$0v[0]);const d=this.s(t,a);if(d)return++d.refcount,d.value}openTunnel(t,a,d,i,b,c=!1,f,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${d} on local port ${b}.`);const S=this.f??t;if(!S)return;if(a||(a="localhost"),i||(i=this.m),this.f&&this.j.has(d)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.t(S,a,d,i,b,c,f,u);return h?h.then(E=>{if(E){if(typeof E=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,d),E}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,d);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.o(E);return(E.tunnelRemoteHost!==a||E.tunnelRemotePort!==d)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),f&&E.privacy!==f&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const a=this.e.get(t.tunnelRemoteHost);if(a){const d=a.get(t.tunnelRemotePort);d&&(d.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,d))}}}}async p(t,a,d){if(d.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${a}.`);const i=d.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(a),i}}async closeTunnel(t,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${a} `);const d=this.e.get(t);if(d&&d.has(a)){const i=d.get(a);i.refcount=0,await this.p(t,a,i)}}q(t,a,d){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(a,{refcount:1,value:d})}async r(t,a){const d=this.e.get(t);if(d){const i=d.get(a),b=i?await i.value:void 0;(!b||typeof b=="string")&&d.delete(a),d.size===0&&this.e.delete(t)}}s(t,a){const d=[t];v(t)?(d.push(...e.$0v),d.push(...e.$_v)):m(t)&&d.push(...e.$_v);const i=d.map(b=>this.e.get(b));for(const b of i){const c=b?.get(a);if(c)return c}}canTunnel(t){return!!y(t)}u(t,a,d,i,b,c,f){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${d} on local port ${i}.`);const u=d;this.j.add(u);const S=i===void 0?d:i,h={elevationRequired:b?this.isPortPrivileged(S):!1},E={remoteAddress:{host:a,port:d},localAddressPort:i,privacy:c,public:c?c!==$.Private:void 0,protocol:f},g=t.forwardPort(E,h);return g?(this.q(a,d,g),g.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),g}};e.$dw=n,e.$dw=n=Je([Ve(0,M.$Wj),Ve(1,A.$Wi)],n)}),define(Ae[205],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ew=void 0,e.$ew=(0,I.$qi)("editSessionIdentityService");var N;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Ae[206],Re([1,0,12]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=N,e.$nM=A,e.$oM=O,e.$pM=M,e.$qM=p;function N($){return $.scheme!==I.Schemas.file&&$.scheme!==I.Schemas.vscodeRemote}function A($){if($.folders.length)return $.folders.every(k=>N(k.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}function O($){return A($)?.scheme}function M($){return A($)?.authority}function p($){return A($)!==void 0}}),define(Ae[49],Re([1,0,162,19,52,24,2,3,12]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=k,e.$Bi=T,e.$Ei=y,e.$Fi=l,e.$Gi=v,e.$Hi=s,e.$Ii=o,e.$Li=t,e.$Qi=a,e.$Ri=d,e.$Ti=i,e.$Ui=b,e.$Vi=c,e.$zi=(0,p.$qi)("contextService");function k(f){const u=f;return typeof u?.id=="string"&&M.URI.isUri(u.uri)}function T(f){return typeof f?.id=="string"&&!k(f)&&!l(f)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function y(f,u){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,N.$oc)(f)}:u?e.$Ci:e.$Di;const S=f;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function l(f){const u=f;return typeof u?.id=="string"&&M.URI.isUri(u.configPath)}function v(f){const u=f;if(u?.uri)return{id:u.id,uri:M.URI.revive(u.uri)};const S=f;if(S?.configPath)return{id:S.id,configPath:M.URI.revive(S.configPath)};if(f?.id)return{id:f.id}}var m;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function s(f){const u=f;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function o(f){const u=f;return!!(u&&typeof u=="object"&&M.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class n{constructor(u,S,h,E,g){this.h=u,this.j=h,this.k=E,this.l=g,this.c=A.$wi.forUris(this.l,()=>!0),this.folders=S}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=A.$wi.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=n;class r{constructor(u,S){this.raw=S,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,O.$4g)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=r;function t(f){return new r({uri:f,index:0,name:(0,O.$Zg)(f)},{uri:f.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,I.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function a(f,u){return O.$Ug.isEqualOrParent(f,u.untitledWorkspacesHome)}function d(f){let u;return M.URI.isUri(f)?u=f:u=f.configuration,u?.scheme===$.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(f){return f.id===e.$Si}function b(f,u){return!a(f,u)&&!d(f)}function c(f){return(typeof f=="string"?(0,N.$pc)(f):(0,O.$2g)(f))===e.$Ni}}),define(Ae[74],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class I{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const O=this.c++;return this.b.set(O,A),this.e(),O}get(A,O){return this.b.has(A)?this.b.get(A)[O]:void 0}delete(A){this.b.delete(A),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$dkc=I}),define(Ae[45],Re([1,0,12,24,3]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=void 0;class O{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new N.$Sg(p=>{const $=this.b.get(p.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(p,$){$===null?this.b.delete(p.scheme):this.b.set(p.scheme,$)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$ikc=O,e.$jkc=(0,A.$qi)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=void 0,e.$sP=(0,I.$qi)("IExtHostInitDataService")}),define(Ae[207],Re([1,0,168,13,194,27]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=void 0;let M=class extends A.$AQ{constructor($,k,T){const y=T.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",l=T.remote.isRemote?(0,I.localize)(0,null):$?(0,I.localize)(1,null):(0,I.localize)(2,null);super(k.createLogger(y,{name:l}))}};e.$pmc=M,e.$pmc=M=Je([Ve(1,N.$Xj),Ve(2,O.$sP)],M)}),define(Ae[208],Re([1,0,11]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=e.$1kc=void 0;class N{constructor(M,p,$){this.h=new Map,this.a=M,this.b=p,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new I.$Ch(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of k.values())T.complete()}catch(T){for(const y of k.values())y.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let $=this.f[M];return typeof $>"u"&&($=p),$}update(M,p){this.f[M]=p;const $=this.h.get(M);if($!==void 0)return $.p;const k=new I.$Nh;return this.h.set(M,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$1kc=N;class A extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$2kc=A}),define(Ae[209],Re([1,0,5,2]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=void 0;class A{constructor(M){this.c=M,this.a=new I.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,$,k){const y=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(p.value,$,k);this.b.fire(y)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$Plc=A}),define(Ae[16],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0,e.$cP=(0,I.$qi)("IExtHostRpcService");class N{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$dP=N}),define(Ae[210],Re([1,0,20,5]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class A{#e;constructor(M,p){this.b=new N.$be,this.onDidChange=this.b.event,this.a=I.$Lm.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$$kc=A}),define(Ae[60],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=e.$ykc=void 0,e.$ykc=(0,I.$qi)("IURITransformerService");class N{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$zkc=N}),define(Ae[211],Re([1,0,23]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nb=A,e.$$nb=M;class N{constructor(){this.buffers=[]}add($){let k=this.buffers.indexOf($);return k<0&&(k=this.buffers.length,this.buffers.push($)),k}}function A(p,$){if($.serializeBuffersForPostMessage){const k=new N,y=JSON.stringify(p,(v,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m)};if(ArrayBuffer.isView(m)){const s=O(m);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m.buffer),view:{type:s,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),l=k.buffers.map(v=>{const m=new Uint8Array(v);return I.$Ce.wrap(m)});return{message:y,buffers:l}}else return{message:JSON.stringify(p),buffers:[]}}function O(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,$){const k=$.map(l=>{const v=new ArrayBuffer(l.byteLength);return new Uint8Array(v).set(l.buffer),v}),T=$.length?(l,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const m=v,{index:s}=m,o=k[s];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(p,T),arrayBuffers:k}}}),define(Ae[104],Re([1,0,177,17,2,6,3,30,44,12,43,139,33]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$BF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$sF=e.EditorInputCapabilities=e.$rF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=void 0,e.$iF=s,e.$jF=o,e.$kF=n,e.$lF=r,e.$mF=t,e.$nF=a,e.$oF=d,e.$pF=i,e.$qF=b,e.$tF=E,e.$uF=D,e.$vF=w,e.$wF=C,e.$xF=P,e.$yF=V,e.$zF=W,e.$AF=ce,e.$CF=ue,e.$DF=ie,e.$EF=Pe,e.$FF=Fe,e.$dF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$eF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$fF="workbench.editor.sidebysideEditor",e.$gF="workbench.editors.textDiffEditor",e.$hF="workbench.editors.binaryResourceDiffEditor";var v;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var m;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function s(ne){const j=ne;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}function o(ne){const j=ne;return!!j&&typeof j.getScrollPosition=="function"&&typeof j.setScrollPosition=="function"&&!!j.onDidChangeScroll}function n(ne,j,x){for(const pe of x.visibleEditorPanes)if(pe.group.id===j&&ne.matches(pe.input))return pe.getViewState()}function r(ne){if(E(ne))return!1;const j=ne;return A.URI.isUri(j?.resource)}function t(ne){if(E(ne))return!1;const j=ne;return j?.original!==void 0&&j.modified!==void 0}function a(ne){if(E(ne))return!1;const j=ne;return!j||j.resources&&!Array.isArray(j.resources)?!1:!!j.resources||!!j.multiDiffSource}function d(ne){if(E(ne)||t(ne))return!1;const j=ne;return j?.primary!==void 0&&j.secondary!==void 0}function i(ne){if(E(ne))return!1;const j=ne;return j?j.resource===void 0||j.resource.scheme===k.Schemas.untitled||j.forceUntitled===!0:!1}function b(ne){if(E(ne))return!1;const j=ne;return A.URI.isUri(j?.base?.resource)&&A.URI.isUri(j?.input1?.resource)&&A.URI.isUri(j?.input2?.resource)&&A.URI.isUri(j?.result?.resource)}var c;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(c||(e.Verbosity=c={}));var f;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f||(e.SaveReason=f={}));class u{constructor(){this.a=new Map}registerSource(j,x){let pe=this.a.get(j);return pe||(pe={source:j,label:x},this.a.set(j,pe)),pe.source}getSourceLabel(j){return this.a.get(j)?.label??j}}e.$rF=new u;var S;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class h extends O.$Uc{}e.$sF=h;function E(ne){return ne instanceof h}function g(ne){const j=ne;return A.URI.isUri(j?.preferredResource)}function D(ne){const j=ne;return E(j?.primary)&&E(j?.secondary)}function w(ne){const j=ne;return E(j?.modified)&&E(j?.original)}function C(ne,j,x,pe,Oe){return Fe(pe,[(0,y.$aj)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const ke={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(j,ke)}}),(0,y.$aj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Oe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function P(ne){return E(ne?.editor)}function V(ne){const j=ne;return P(ne)&&j?.group!==void 0}function W(ne){const j=ne;return typeof j?.groupId=="number"&&E(j.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var R;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var U;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class K{getOriginalUri(j,x){if(!j)return;if(b(j))return e.$BF.getOriginalUri(j.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:ke}=this.a(j);if(Oe&&ke){if(x?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===U.PRIMARY?Oe:ke}}if(t(j)||a(j)||d(j)||b(j))return;const pe=g(j)?j.preferredResource:j.resource;return!pe||!x||!x.filterByScheme?pe:this.b(pe,x.filterByScheme)}a(j){return D(j)||d(j)?{primary:j.primary,secondary:j.secondary}:w(j)||t(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,x){if(!j)return;if(b(j))return e.$BF.getCanonicalUri(j.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:ke}=this.a(j);if(Oe&&ke){if(x?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===U.PRIMARY?Oe:ke}}if(t(j)||a(j)||d(j)||b(j))return;const pe=j.resource;return!pe||!x||!x.filterByScheme?pe:this.b(pe,x.filterByScheme)}b(j,x){if(Array.isArray(x)){if(x.some(pe=>j.scheme===pe))return j}else if(x===j.scheme)return j}}var se;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(se||(e.EditorCloseMethod=se={}));function ce(ne,j,x,pe){if(!ne.isSticky(j))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return x===se.MOUSE||x===se.KEYBOARD;case"mouse":return x===se.MOUSE;case"keyboard":return x===se.KEYBOARD}return!1}e.$BF=new K;var ve;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ve||(e.CloseDirection=ve={}));class Ie{constructor(){this.c=new Map,this.d=new Map}start(j){const x=this.a=j.get(M.$pi);for(const[pe,Oe]of this.c)this.e(pe,Oe,x);this.c.clear()}e(j,x,pe){const Oe=pe.createInstance(x);this.d.set(j,Oe)}registerFileEditorFactory(j){if(this.b)throw new Error("Can only register one file editor factory.");this.b=j}getFileEditorFactory(){return(0,N.$cg)(this.b)}registerEditorSerializer(j,x){if(this.c.has(j)||this.d.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.a?this.e(j,x,this.a):this.c.set(j,x),(0,O.$Sc)(()=>{this.c.delete(j),this.d.delete(j)})}getEditorSerializer(j){return this.d.get(typeof j=="string"?j:j.typeId)}}p.$9n.add(e.$dF.EditorFactory,new Ie);async function ue(ne,j,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async pe=>{const Oe=A.URI.revive(pe.fileUri);if(!Oe){x.info("Cannot resolve the path because it is not valid.",pe);return}if(!await j.canHandleResource(Oe)){x.info("Cannot resolve the path because it cannot be handled",pe);return}let $e=pe.exists,ge=pe.type;if(typeof $e!="boolean"||typeof ge!="number")try{ge=(await j.stat(Oe)).isDirectory?$.FileType.Directory:$.FileType.Unknown,$e=!0}catch(Y){x.error(Y),$e=!1}if(!$e&&pe.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",pe);return}if(ge===$.FileType.Directory){x.info("Cannot resolve the path because it is a directory",pe);return}const J={...pe.options,pinned:!0};return $e?{resource:Oe,options:J}:{resource:Oe,options:J,forceUntitled:!0}}))}var be;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(be||(e.EditorsOrder=be={}));function ie(ne){const j=ne;if(!j)return!1;const x=j;if(x.modified)return ie(x.modified);const pe=j;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function Pe(ne){return(0,T.$cj)(ne)}function Fe(ne,j,x){const pe=(0,T.$dj)(ne,j);return pe.forceMessage=x?.forceMessage,pe.forceSeverity=x?.forceSeverity,pe.allowDialog=x?.allowDialog,pe}}),define(Ae[212],Re([1,0,5,178,3,6,28,30,18,26,91,203]),function(fe,e,I,N,A,O,M,p,$,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.$MF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$LF=e.ViewContentGroups=e.$JF=e.ViewContainerLocation=e.Extensions=e.$IF=e.$HF=e.$GF=void 0,e.$KF=m,e.$GF="views",e.$HF=(0,N.localize)(0,null),e.$IF=(0,y.$3w)("default-view-icon",T.$Pj.window,(0,N.localize)(1,null));var l;(function(b){b.ViewContainersRegistry="workbench.registry.view.containers",b.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var v;(function(b){b[b.Sidebar=0]="Sidebar",b[b.Panel=1]="Panel",b[b.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$JF=[0,1,2];function m(b){switch(b){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class s extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onDidRegister=this.c.event,this.f=this.B(new I.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(c,f,u){const S=this.get(c.id);if(S)return S;const h=c;return h.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:h.openCommandActionDescriptor??{id:h.id},(0,M.$yc)(this.g,f,[]).push(h),u?.isDefault&&this.h.push(h),this.c.fire({viewContainer:h,viewContainerLocation:f}),h}deregisterViewContainer(c){for(const f of this.g.keys()){const u=this.g.get(f),S=u?.indexOf(c);if(S!==-1){u?.splice(S,1),u.length===0&&this.g.delete(f),this.f.fire({viewContainer:c,viewContainerLocation:f});return}}}get(c){return this.all.filter(f=>f.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(u=>u?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(f=>this.getViewContainerLocation(f)===c)}}p.$9n.add(l.ViewContainersRegistry,new s);var o;(function(b){b.Open="2_open",b.Debug="4_debug",b.SCM="5_scm",b.More="9_more"})(o||(e.ViewContentGroups=o={}));function n(b,c){const f=b.group??o.More,u=c.group??o.More;return f!==u?f.localeCompare(u):(b.order??5)-(c.order??5)}class r extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(c,f){this.registerViews2([{views:c,viewContainer:f}])}registerViews2(c){c.forEach(({views:f,viewContainer:u})=>this.r(f,u)),this.c.fire(c)}deregisterViews(c,f){const u=this.s(c,f);u.length&&this.f.fire({views:u,viewContainer:f})}moveViews(c,f){for(const u of this.m.keys())if(u!==f){const S=this.s(c,u);S.length&&(this.r(S,f),this.g.fire({views:S,from:u,to:f}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const f of this.j){const u=(this.m.get(f)||[]).filter(S=>S.id===c)[0];if(u)return u}return null}getViewContainer(c){for(const f of this.j)if((this.m.get(f)||[]).filter(S=>S.id===c)[0])return f;return null}registerViewWelcomeContent(c,f){return this.n.add(c,f),this.h.fire(c),(0,O.$Sc)(()=>{this.n.delete(c,f),this.h.fire(c)})}registerViewWelcomeContent2(c,f){const u=new Map;for(const[S,h]of f)this.n.add(c,h),u.set(S,(0,O.$Sc)(()=>{this.n.delete(c,h),this.h.fire(c)}));return this.h.fire(c),u}getViewWelcomeContent(c){const f=[];return this.n.forEach(c,u=>f.push(u)),f.sort(n)}r(c,f){let u=this.m.get(f);u||(u=[],this.m.set(f,u),this.j.push(f));for(const S of c){if(this.getView(S.id)!==null)throw new Error((0,N.localize)(2,null,S.id));u.push(S)}}s(c,f){const u=this.m.get(f);if(!u)return[];const S=[],h=[];for(const E of u)c.includes(E)?S.push(E):h.push(E);return S.length&&(h.length?this.m.set(f,h):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),S}}p.$9n.add(l.ViewsRegistry,new r),e.$LF=(0,A.$qi)("viewDescriptorService");var t;(function(b){b[b.Default=0]="Default",b[b.Expand=1]="Expand"})(t||(e.ViewVisibilityState=t={}));var a;(function(b){b[b.None=0]="None",b[b.Collapsed=1]="Collapsed",b[b.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class d{constructor(c,f){this.c=!1,this.d=!1,(0,k.$Zn)(this,c),this.d=!!f,this.resolve=async u=>{if(f&&!this.c){const S=await f(u);S&&(this.tooltip=this.tooltip??S.tooltip,this.command=this.command??S.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$MF=d;class i extends Error{constructor(c){super((0,N.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$NF=i}),define(Ae[213],Re([1,0,179,31]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$RF=new N.$Hj("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$SF=new N.$Hj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$TF=new N.$Hj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$UF=new N.$Hj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$VF=new N.$Hj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$WF=new N.$Hj("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$XF=new N.$Hj("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$YF=new N.$Hj("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$ZF=new N.$Hj("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$1F=new N.$Hj("inChatInput",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$2F=new N.$Hj("inChat",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$3F=new N.$Hj("chatIsEnabled",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$4F=new N.$Hj("chatCursorAtTop",!1),e.$5F=new N.$Hj("chatInputHasAgent",!1),e.$6F=new N.$Hj("chatLocation",void 0)}),define(Ae[214],Re([1,0,5,40,6,31,3,213]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.$4G=e.$3G=e.ChatAgentLocation=void 0;var $;(function(y){y.Panel="panel",y.Terminal="terminal",y.Notebook="notebook",y.Editor="editor"})($||(e.ChatAgentLocation=$={})),function(y){function l(v){switch(v){case"panel":return y.Panel;case"terminal":return y.Terminal;case"notebook":return y.Notebook;case"editor":return y.Editor}return y.Panel}y.fromRaw=l}($||(e.ChatAgentLocation=$={})),e.$3G=(0,M.$qi)("chatAgentService");let k=class{static{this.AGENT_LEADER="@"}constructor(l){this.f=l,this.b=[],this.d=new I.$be,this.onDidChangeAgents=this.d.event,this.e=p.$3F.bindTo(this.f)}registerAgent(l,v){if(this.getAgent(l))throw new Error(`Agent already registered: ${JSON.stringify(l)}`);const s=this,o=v.slashCommands;v={...v,get slashCommands(){return o.filter(r=>!r.when||s.f.contextMatchesRules(O.$oj.deserialize(r.when)))}};const n={data:v};return this.b.push(n),(0,A.$Sc)(()=>{this.b=this.b.filter(r=>r!==n),this.d.fire(void 0)})}registerAgentImplementation(l,v){const m=this.g(l);if(!m)throw new Error(`Unknown agent: ${JSON.stringify(l)}`);if(m.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(l)}`);return m.data.isDefault&&this.e.set(!0),m.impl=v,this.d.fire(new T(m.data,v)),(0,A.$Sc)(()=>{m.impl=void 0,this.d.fire(void 0),m.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(l,v){const m={data:l,impl:v};return this.b.push(m),this.d.fire(new T(l,v)),(0,A.$Sc)(()=>{this.b=this.b.filter(s=>s!==m),this.d.fire(void 0)})}updateAgent(l,v){const m=this.g(l);if(!m?.impl)throw new Error(`No activated agent with id ${JSON.stringify(l)} registered`);m.data.metadata={...m.data.metadata,...v},this.d.fire(new T(m.data,m.impl))}getDefaultAgent(l){return this.getActivatedAgents().find(v=>!!v.isDefault&&v.locations.includes(l))}getContributedDefaultAgent(l){return this.getAgents().find(v=>!!v.isDefault&&v.locations.includes(l))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),l=>!!l.data.metadata.isSecondary)?.data}g(l){return this.b.find(v=>v.data.id===l)}getAgent(l){return this.g(l)?.data}getAgents(){return this.b.map(l=>l.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(l=>!!l.impl).map(l=>new T(l.data,l.impl))}getAgentsByName(l){return this.getAgents().filter(v=>v.name===l)}async invokeAgent(l,v,m,s,o){const n=this.g(l);if(!n?.impl)throw new Error(`No activated agent with id ${l}`);return await n.impl.invoke(v,m,s,o)}async getFollowups(l,v,m,s,o){const n=this.g(l);if(!n?.impl)throw new Error(`No activated agent with id ${l}`);return n.impl?.provideFollowups?n.impl.provideFollowups(v,m,s,o):[]}};e.$4G=k,e.$4G=k=Je([Ve(0,O.$Ij)],k);class T{constructor(l,v){this.b=l,this.d=v}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(l,v,m,s){return this.d.invoke(l,v,m,s)}async provideFollowups(l,v,m,s){return this.d.provideFollowups?this.d.provideFollowups(l,v,m,s):[]}provideWelcomeMessage(l,v){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(l,v)}provideSampleQuestions(l,v){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(l,v)}}e.$5G=T}),define(Ae[215],Re([1,0,2,29,3]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$$F=O,e.$_F=M;function O(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof I.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(N.$kt.isIRange)}function M(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(O)}var p;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var $;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$aG=(0,A.$qi)("IChatService"),e.$bG="accessibility.voice.keywordActivation"}),define(Ae[216],Re([1,0,5,11,180]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eob=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new I.$be,this.o=new I.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,$,k,T){const y={command:p};if($&&Object.keys($).length>0&&(y.arguments=$),this.u("request",y),typeof T=="number"){const l=setTimeout(()=>{clearTimeout(l);const v=this.f.get(y.seq);if(v){this.f.delete(y.seq);const m={type:"response",seq:0,request_seq:y.seq,success:!1,command:p,message:(0,A.localize)(0,null,T,p)};v(m)}},T)}return k&&this.f.set(y.seq,k),y.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,$){return p.type!=="event"||$.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,N.$rh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const $=p,k=this.f.get($.request_seq);k&&(this.f.delete($.request_seq),k($));break}}}}u(p,$){$.type=p,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach(($,k)=>p.set(k,$)),await(0,N.$rh)(500),p.forEach(($,k)=>{$({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Eob=O}),define(Ae[217],Re([1,0,2,181,31,3]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$iJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$gJ=e.MemoryRangeType=e.State=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=void 0,e.$fJ=$,e.$hJ=T,e.$6H="workbench.view.debug",e.$7H="workbench.debug.variablesView",e.$8H="workbench.debug.watchExpressionsView",e.$9H="workbench.debug.callStackView",e.$0H="workbench.debug.loadedScriptsView",e.$$H="workbench.debug.breakPointsView",e.$_H="workbench.debug.disassemblyView",e.$aI="workbench.panel.repl",e.$bI="workbench.panel.repl.view",e.$cI=new A.$Hj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$dI=new A.$Hj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$eI=new A.$Hj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$fI="debugUx",e.$gI=new A.$Hj(e.$fI,"default",{type:"string",description:N.localize(3,null)}),e.$hI=new A.$Hj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$iI=new A.$Hj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$jI=new A.$Hj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$kI=new A.$Hj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$lI=new A.$Hj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$mI=new A.$Hj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$nI=new A.$Hj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$oI=new A.$Hj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$pI=new A.$Hj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$qI=new A.$Hj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$rI=new A.$Hj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$sI=new A.$Hj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$tI=new A.$Hj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$uI=new A.$Hj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$vI=new A.$Hj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$wI=new A.$Hj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$xI=new A.$Hj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$yI=new A.$Hj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$zI=new A.$Hj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$AI=new A.$Hj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$BI=new A.$Hj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$CI=new A.$Hj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$DI=new A.$Hj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$EI=new A.$Hj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$FI=new A.$Hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$GI=new A.$Hj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$HI=new A.$Hj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$II=new A.$Hj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$JI=new A.$Hj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$KI=new A.$Hj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$LI=new A.$Hj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$MI=new A.$Hj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$NI=new A.$Hj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$OI=new A.$Hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$PI=new A.$Hj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$QI=new A.$Hj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$RI=new A.$Hj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$SI=new A.$Hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$TI=new A.$Hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$UI=new A.$Hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$VI=new A.$Hj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$WI=new A.$Hj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$XI=new A.$Hj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$YI=new A.$Hj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$ZI=new A.$Hj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$1I=new A.$Hj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$2I=new A.$Hj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$3I=new A.$Hj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$4I=new A.$Hj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$5I=new A.$Hj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$6I=new A.$Hj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$7I=new A.$Hj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$8I=new A.$Hj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$9I=new A.$Hj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$0I=new A.$Hj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$$I=new A.$Hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$_I=new A.$Hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=t=>N.localize(61,null,t);e.$aJ=M,e.$bJ="editor.contrib.debug",e.$cJ="editor.contrib.breakpoint",e.$dJ="debug",e.$eJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var p;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(p||(e.State=p={}));function $(t){switch(t){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$gJ="vscode-debug-memory";function T(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var y;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var l;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var v;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(v||(e.DebuggerString=v={})),e.$iJ=(0,O.$qi)("debugService");var m;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var s;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var o;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var n;(function(t){t.deserialize=a=>a,t.serialize=a=>a})(n||(e.IDebugVisualizationTreeItem=n={}));var r;(function(t){t.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:I.URI.revive(a.iconPath.light),dark:I.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),t.serialize=a=>a})(r||(e.IDebugVisualization=r={}))}),define(Ae[218],Re([1,0,15,2,19,26,12,29,22,18]),function(fe,e,I,N,A,O,M,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=void 0,e.$8G=y,e.$9G=l,e.$0G=v,e.$$G=m,e.$_G=s,e.$aH=o,e.$bH=n,e.$cH=t,e.$dH=i,e.$eH=b,e.$fH=f,e.$gH=S;const T=/{([^}]+)}/g;function y(E,g,D){return E.replace(T,function(w,C){return g&&C.length>0&&C[0]!=="_"?w:D&&D.hasOwnProperty(C)?D[C]:w})}function l(E){const g={};for(const D of Object.keys(E))D.startsWith("!")||(g[D]=E[D]);return g}function v(E){return E.configuration.request==="attach"&&!m(E)&&(!E.parentSession||v(E.parentSession))}function m(E){let g=E.configuration.type;if(g)return g==="vslsShare"&&(g=E.configuration.adapterProxy.configuration.type),(0,I.$tf)(g,"extensionhost")||(0,I.$tf)(g,"pwa-extensionhost")?E:E.parentSession?m(E.parentSession):void 0}function s(E){return E.type&&(E.label||E.program||E.runtime)}function o(E,g,D){let w,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=P.exec(E);){const W=V.index+1,q=W+V[0].length;if(W<=g&&q>=D){w=V[0],C=W;break}}if(w){const W=/\w+/g;let q=null;for(;(q=W.exec(w))&&!(q.index+1+C+q[0].length>=D););q&&(w=w.substring(0,W.lastIndex))}return w?{start:C,end:C+w.length-1}:{start:0,end:0}}async function n(E,g,D,w){if(E.evaluatableExpressionProvider.has(g)){const C=E.evaluatableExpressionProvider.ordered(g),P=(0,k.$Hb)(await Promise.all(C.map(async V=>{try{return await V.provideEvaluatableExpression(g,D,w??$.CancellationToken.None)}catch{return}})));if(P.length>0){let V=P[0].expression;const W=P[0].range;return V||(V=g.getLineContent(D.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const C=g.getLineContent(D.lineNumber),{start:P,end:V}=o(C,D.column,D.column),W=C.substring(P-1,V);return{matchingExpression:W,range:new p.$kt(D.lineNumber,P,D.lineNumber,P+W.length)}}return null}const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(E){return!!(E&&E.match(r))}function a(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(t(E.path))return N.URI.parse(E.path);if((0,A.$jc)(E.path))return N.URI.file(E.path)}return E.path}function d(E){if(typeof E.path=="object"){const g=N.URI.revive(E.path);if(g)return g.scheme===M.Schemas.file?g.fsPath:g.toString()}return E.path}function i(E,g){const D=g?a:d,w=(0,O.$Wn)(E);return c(w,(C,P)=>{C&&P&&(P.path=D(P))}),w}function b(E,g){const D=g?a:d,w=(0,O.$Wn)(E);return c(w,(C,P)=>{!C&&P&&(P.path=D(P))}),w}function c(E,g){switch(E.type){case"event":{const D=E;switch(D.event){case"output":g(!1,D.body.source);break;case"loadedSource":g(!1,D.body.source);break;case"breakpoint":g(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=E;switch(D.command){case"setBreakpoints":g(!0,D.arguments.source);break;case"breakpointLocations":g(!0,D.arguments.source);break;case"source":g(!0,D.arguments.source);break;case"gotoTargets":g(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(w=>g(!1,w));break;default:break}break}case"response":{const D=E;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(w=>g(!1,w.source));break;case"loadedSources":D.body.sources.forEach(w=>g(!1,w));break;case"scopes":D.body.scopes.forEach(w=>g(!1,w.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(w=>g(!1,w.source));break;case"setBreakpoints":D.body.breakpoints.forEach(w=>g(!1,w.source));break;case"disassemble":D.body?.instructions.forEach(C=>g(!1,C.location));break;default:break}break}}}function f(E){return E.filter(g=>!g.presentation?.hidden).sort((g,D)=>g.presentation?D.presentation?g.presentation.group?D.presentation.group?g.presentation.group!==D.presentation.group?g.presentation.group.localeCompare(D.presentation.group):u(g.presentation.order,D.presentation.order):-1:D.presentation.group?1:u(g.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function u(E,g){return typeof E!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:E-g}async function S(E,g){const D=E.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(D!=="none"&&(await g.saveAll(),D==="allEditorsInActiveGroup")){const w=g.activeEditorPane;w&&w.input.resource?.scheme===M.Schemas.untitled&&await g.save({editor:w.input,groupId:w.group.id})}await E.reloadConfiguration()}const h=(E,g)=>!E||!g?E===g:E.name===g.name&&E.path===g.path&&E.sourceReference===g.sourceReference;e.$hH=h}),define(Ae[219],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.CellExecutionUpdateType=void 0;var N;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$vK=(0,I.$qi)("INotebookExecutionService")}),define(Ae[220],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yib=e.$xib=e.ProxyKernelState=e.$wib=void 0,e.$wib=100;var N;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$xib=(0,I.$qi)("INotebookKernelService"),e.$yib=(0,I.$qi)("INotebookKernelHistoryService")}),define(Ae[221],Re([1,0,6,29,149,95]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mWb=void 0;class M extends I.$Uc{constructor($,k,T){super(),this._source=$,this.b=k,this.c=T,this.a=void 0}f($){const k=$.getLineCount();return new N.$kt(1,1,k,this.g($,k))}g($,k){if(k<1||k>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const $=new A.$MC;$.acceptChunk(this._source);const k=$.finish(!0),{textBuffer:T,disposable:y}=k.create(1);this.b=T,this.B(y)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const k=new A.$MC;k.acceptChunk($);const T=k.finish(!0),{textBuffer:y,disposable:l}=T.create(1);return this.B(l),y})),this.a}findInInputs($){const T=new O.$AC($,!1,!1,null).parseSearchRequest();if(!T)return[];const y=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(y,T,!0,5e3)}findInOutputs($){const T=new O.$AC($,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(y=>{const l=y.findMatchesLineByLine(this.f(y),T,!0,5e3);if(l.length!==0)return{textBuffer:y,matches:l}}).filter(y=>!!y):[]}}e.$mWb=M}),define(Ae[50],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(O){O.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var N;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class A{static fromExtHostTestItem(M,p,$=M.parent){if(M._isRoot)return new A([p]);const k=[M.id];for(let T=$;T&&T.id!==p;T=T.parent)k.push(T.id);return k.push(p),new A(k.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new A(M.split("\0"))}static join(M,p){return new A([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:A.isChild(M,p)?2:A.isChild(p,M)?3:1}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new A(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new A(this.path,M)}compare(M){if(typeof M=="string")return A.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$BL=A}),define(Ae[61],Re([1,0,2,93,29,50]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$IL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HL=e.$GL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EL=e.$DL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$CL=e.TestResultState=void 0;var M;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$CL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var $;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$DL=[2,4,8,16,32,64];const k=R=>"runId"in R;e.$EL=k;var T;(function(R){R.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),R.deserialize=(U,K)=>({range:A.$kt.lift(K.range),uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var y;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(y||(e.TestMessageType=y={}));var l;(function(R){R.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&T.serialize(U.location)}),R.deserialize=(U,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(U,K.location)})})(l||(e.ITestErrorMessage=l={}));const v=(R,U)=>`${U?"s":"e"}${R}`;e.$FL=v;var m;(function(R){R.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&T.serialize(U.location)}),R.deserialize=(U,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(U,K.location)})})(m||(e.ITestOutputMessage=m={}));var s;(function(R){R.serialize=U=>U.type===0?l.serialize(U):m.serialize(U),R.deserialize=(U,K)=>K.type===0?l.deserialize(U,K):m.deserialize(U,K)})(s||(e.ITestMessage=s={}));var o;(function(R){R.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),R.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(s.serialize)}),R.deserialize=(U,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(se=>s.deserialize(U,se))})})(o||(e.ITestTaskState=o={}));const n="\0",r=(R,U)=>R+n+U;e.$GL=r;const t=R=>{const U=R.indexOf(n);return{ctrlId:R.slice(0,U),tagId:R.slice(U+1)}};e.$HL=t;var a;(function(R){R.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),R.deserialize=(U,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?U.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?A.$kt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(a||(e.ITestItem=a={}));var d;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(d||(e.TestItemExpandState=d={}));var i;(function(R){R.serialize=U=>({expand:U.expand,item:a.serialize(U.item)}),R.deserialize=(U,K)=>({controllerId:O.$BL.root(K.item.extId),expand:K.expand,item:a.deserialize(U,K.item)})})(i||(e.InternalTestItem=i={}));var b;(function(R){R.serialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.uri!==void 0&&(K.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(K.range=U.item.range?.toJSON()),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}},R.deserialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.range!==void 0&&(K.range=U.item.range?A.$kt.lift(U.item.range):null),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}}})(b||(e.ITestItemUpdate=b={}));const c=(R,U)=>{U.expand!==void 0&&(R.expand=U.expand),U.item!==void 0&&(R.item=R.item?Object.assign(R.item,U.item):U.item)};e.$IL=c;var f;(function(R){R.serializeWithoutMessages=U=>({...i.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serializeWithoutMessages)}),R.serialize=U=>({...i.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serialize)}),R.deserialize=(U,K)=>({...i.deserialize(U,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(se=>o.deserialize(U,se)),retired:!0})})(f||(e.TestResultItem=f={}));var u;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(U,K)=>{U.covered+=K.covered,U.total+=K.total}})(u||(e.ICoverageCount=u={}));var S;(function(R){R.serialize=U=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:U.uri.toJSON()}),R.deserialize=(U,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(S||(e.IFileCoverage=S={}));function h(R){return{...R,location:R.location?.toJSON()}}function E(R){return R.location=R.location?N.$jt.isIPosition(R.location)?N.$jt.lift(R.location):A.$kt.lift(R.location):void 0,R}e.$JL=3;var g;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(g||(e.DetailType=g={}));var D;(function(R){R.serialize=U=>U.type===0?C.serialize(U):P.serialize(U),R.deserialize=U=>U.type===0?C.deserialize(U):P.deserialize(U)})(D||(e.CoverageDetails=D={}));var w;(function(R){R.serialize=h,R.deserialize=E})(w||(e.IBranchCoverage=w={}));var C;(function(R){R.serialize=h,R.deserialize=E})(C||(e.IDeclarationCoverage=C={}));var P;(function(R){R.serialize=U=>({...h(U),branches:U.branches?.map(w.serialize)}),R.deserialize=U=>({...E(U),branches:U.branches?.map(w.deserialize)})})(P||(e.IStatementCoverage=P={}));var V;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(R){R.deserialize=(U,K)=>K.op===0?{op:K.op,item:i.deserialize(U,K.item)}:K.op===1?{op:K.op,item:b.deserialize(K.item)}:K.op===2?{op:K.op,uri:U.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,R.serialize=U=>U.op===0?{op:U.op,item:i.serialize(U.item)}:U.op===1?{op:U.op,item:b.serialize(U.item)}:U})(W||(e.TestsDiffOp=W={}));class q{constructor(U){this.k=U,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(U){const K=this.v();for(const se of U)switch(se.op){case 0:this.l(i.deserialize(this.k,se.item),K);break;case 1:this.o(b.deserialize(se.item),K);break;case 3:this.p(se.itemId,K);break;case 5:this.q(se.itemId);break;case 4:this.updatePendingRoots(se.amount);break;case 6:this.c.set(se.tag.id,se.tag);break;case 7:this.c.delete(se.id);break}K.complete?.()}l(U,K){const se=O.$BL.parentId(U.item.extId)?.toString();let ce;if(!se)ce=this.w(U),this.g.add(ce),this.f.set(U.item.extId,ce);else if(this.f.has(se)){const ve=this.f.get(se);ve.children.add(U.item.extId),ce=this.w(U,ve),this.f.set(U.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return K.add?.(ce),U.expand===2&&this.h++,ce}o(U,K){const se=this.f.get(U.extId);if(se)return U.expand!==void 0&&(se.expand===2&&this.h--,U.expand===2&&this.h++),(0,e.$IL)(se,U),K.update?.(se),se}p(U,K){const se=this.f.get(U);if(!se)return;const ce=O.$BL.parentId(se.item.extId)?.toString();ce?this.f.get(ce).children.delete(se.item.extId):this.g.delete(se);const ve=[[U]];for(;ve.length;)for(const Ie of ve.pop()){const ue=this.f.get(Ie);ue&&(ve.push(ue.children),this.f.delete(Ie),K.remove?.(ue,ue!==se),ue.expand===2&&this.h--)}}q(U){}updatePendingRoots(U){this.j+=U}v(){return{}}}e.$KL=q}),define(Ae[75],Re([1,0,11,5,6,56,61,50]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.TestItemEventOp=void 0;var $;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const k=(r,t)=>r===t,y=Object.entries({range:(r,t)=>r===t?!0:!r||!t?!1:r.equalsRange(t),busy:k,label:k,description:k,error:k,sortText:k,tags:(r,t)=>!(r.length!==t.length||r.some(a=>!t.includes(a)))}),l=(r,t)=>{let a;for(const[d,i]of y)i(r[d],t[d])||(a?a[d]=t[d]:a={[d]:t[d]});return a};class v extends A.$Uc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new I.$Ch(()=>this.flushDiff(),200)),this.g=this.B(new N.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===t.uri){a.docv=t.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===t.item.extId){(0,M.$IL)(a.item,t.item);return}if(a.op===0&&a.item.item.extId===t.item.extId){(0,M.$IL)(a.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,a){const d=this.tree.get(t);if(d){if((d.expandLevels===void 0||a>d.expandLevels)&&(d.expandLevels=a),d.expand===1){const i=this.M(d);return i.isOpen()?this.L(d,a-1):i.wait().then(()=>this.L(d,a-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.L(d,a-1)):this.L(d,a-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,a){switch(a.op){case 3:this.O(p.$BL.joinToString(t.fullId,a.id));break;case 0:this.z(a.item,t);break;case 5:for(const d of a.ops)this.w(t,d);break;case 1:this.C(a.new,a.old,t.fullId.toString());break;case 2:this.J(t);break;case 4:this.pushDiff({op:1,item:{extId:t.fullId.toString(),item:a.update}});break;case 6:this.y(t.actual.uri);break;default:(0,O.$cd)(a)}}y(t){t&&this.pushDiff({op:2,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,a){const d=p.$BL.fromExtHostTestItem(t,this.root.id,a?.actual),i=this.s.getApiFor(t);i.parent&&i.parent!==a?.actual&&this.s.getChildren(i.parent).delete(t.id);let b=this.tree.get(d.toString());if(!b){b={fullId:d,actual:t,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},t.tags.forEach(this.D,this),this.tree.set(b.fullId.toString(),b),this.G(t,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:b.expand,item:this.s.toITestItem(t)}}),this.I(t,b,a);return}if(b.actual===t){this.H(t,b,a);return}if(b.actual.uri?.toString()!==t.uri?.toString())return this.O(d.toString()),this.z(t,a);const c=this.s.getChildren(b.actual),f=b.actual,u=l(this.s.toITestItem(f),this.s.toITestItem(t));this.s.getApiFor(f).listener=void 0,b.actual=t,b.resolveBarrier=void 0,b.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(t.tags,f.tags,d.toString()),delete u.tags),this.w(b,{op:4,update:u})),this.I(t,b,a);for(const[h,E]of c)this.s.getChildren(t).get(E.id)||this.O(p.$BL.joinToString(d,E.id));const S=b.expandLevels;S!==void 0&&queueMicrotask(()=>{b.expand===1&&(b.expandLevels=void 0,this.expand(d.toString(),S))}),this.y(b.actual.uri)}C(t,a,d){const i=new Set(a.map(b=>b.id));for(const b of t)i.delete(b.id)||this.D(b);this.pushDiff({op:1,item:{extId:d,item:{tags:t.map(b=>(0,M.$GL)(this.s.controllerId,b.id))}}}),i.forEach(this.F,this)}D(t){const a=this.j.get(t.id);a?a.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$GL)(this.s.controllerId,t.id)}}))}F(t){const a=this.j.get(t);a&&!--a.refCount&&(this.j.delete(t),this.pushDiff({op:7,id:(0,M.$GL)(this.s.controllerId,t)}))}G(t,a){this.s.getApiFor(t).parent=a&&a.actual!==this.root?a.actual:void 0}H(t,a,d){this.G(t,d);const i=this.s.getApiFor(t);i.parent=d?.actual,i.listener=b=>this.w(a,b),this.J(a)}I(t,a,d){this.H(t,a,d);for(const[i,b]of this.s.getChildren(t))this.z(b,a)}J(t){let a;this.h?t.resolveBarrier?a=t.resolveBarrier.isOpen()?3:2:a=t.actual.canResolveChildren?1:0:a=0,a!==t.expand&&(t.expand=a,this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:a}}),a===1&&t.expandLevels!==void 0&&this.M(t))}L(t,a){if(a<0)return;const d=[];for(const[i,b]of this.s.getChildren(t.actual)){const c=this.expand(p.$BL.joinToString(t.fullId,b.id),a);(0,I.$ch)(c)&&d.push(c)}if(d.length)return Promise.all(d).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const b=new I.$ph;return b.open(),b}t.expand=2,this.N(t);const a=t.resolveBarrier=new I.$ph,d=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,b)};let i;try{i=this.h(t.actual===this.root?void 0:t.actual)}catch(b){d(b)}return(0,I.$ch)(i)?i.catch(d).then(()=>{a.open(),this.J(t)}):(a.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const a=this.tree.get(t);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:t});const d=[a];for(;d.length;){const i=d.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const b of i.actual.tags)this.F(b.id);this.tree.delete(i.fullId.toString());for(const[b,c]of this.s.getChildren(i.actual))d.push(this.tree.get(p.$BL.joinToString(i.fullId,c.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$5O=v;class m extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$6O=m;class s extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$7O=s;class o extends Error{constructor(t,a,d){super(`TestItem with ID "${t}" is from controller "${a}" and cannot be added as a child of an item from controller "${d}".`)}}e.$8O=o;const n=(r,t,a)=>{let d=new Map;return{get size(){return d.size},forEach(i,b){for(const c of d.values())i.call(b,c,this)},[Symbol.iterator](){return d.entries()},replace(i){const b=new Map,c=new Set(d.keys()),f={op:5,ops:[]};for(const u of i){if(!(u instanceof a))throw new s(u.id);const S=t(u).controllerId;if(S!==r.controllerId)throw new o(u.id,S,r.controllerId);if(b.has(u.id))throw new m(u.id);b.set(u.id,u),c.delete(u.id),f.ops.push({op:0,item:u})}for(const u of c.keys())f.ops.push({op:3,id:u});r.listener?.(f),d=b},add(i){if(!(i instanceof a))throw new s(i.id);d.set(i.id,i),r.listener?.({op:0,item:i})},delete(i){d.delete(i)&&r.listener?.({op:3,id:i})},get(i){return d.get(i)},toJSON(){return Array.from(d.values())}}};e.$9O=n}),define(Ae[105],Re([1,0,75]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.$0O=void 0;const N=new WeakMap,A=(M,p)=>{const $={controllerId:p};return N.set(M,$),$};e.$0O=A;const O=M=>{const p=N.get(M);if(!p)throw new I.$7O(M?.id||"<unknown>");return p};e.$$O=O}),define(Ae[76],Re([1,0,12,2]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qxb=e.$Pxb=e.$Oxb=void 0,e.$Rxb=A,e.$Sxb=M,e.$Oxb="vscode-cdn.net",e.$Pxb=`vscode-resource.${e.$Oxb}`,e.$Qxb=`'self' https://*.${e.$Oxb}`;function A(p,$){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:($&&$.authority&&$.isRemote&&p.scheme===I.Schemas.file&&(p=N.URI.from({scheme:I.Schemas.vscodeRemote,authority:$.authority,path:p.path})),N.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${O(p.authority)}.${e.$Pxb}`,path:p.path,fragment:p.fragment,query:p.query}))}function O(p){return p.replace(/./g,$=>{const k=$.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?$:"-"+k.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,($,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Ae[222],Re([1,0,5,6,76]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=void 0;class O{constructor(p,$,k){this.d=p,this.e=$,this.f=k,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const T=$.getVisibleTextEditors();for(const y of this.c.values())T.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,$,k,T,y){let l;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===p){l=t;break}if(!l)throw new Error("not a visible editor");const v=this,m=this.a++,s=new I.$be,o=new I.$be,n=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,A.$Rxb)(t,v.f)}get cspSource(){return A.$Qxb}set options(t){this.b=t,v.d.$setOptions(m,t)}get options(){return this.b}set html(t){this.a=t,v.d.$setHtml(m,t)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(t){return v.d.$postMessage(m,t)}},r=new class{constructor(){this.editor=p,this.line=$,this.height=k,this.webview=n,this.onDidDispose=o.event}dispose(){v.c.has(m)&&(v.c.delete(m),v.d.$disposeEditorInset(m),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(m,l.id,l.value.document.uri,$+1,k,T||{},y.identifier,y.extensionLocation),this.c.set(m,{editor:p,inset:r,onDidReceiveMessage:s}),r}$onDidDispose(p){const $=this.c.get(p);$&&$.inset.dispose()}$onDidReceiveMessage(p,$){this.c.get(p)?.onDidReceiveMessage.fire($)}}e.$wkc=O}),define(Ae[106],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=void 0,e.$RL="__",e.$SL=(0,I.$qi)("IAuthenticationService"),e.$TL=(0,I.$qi)("IAuthenticationExtensionsService")}),define(Ae[223],Re([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.VariableKind=e.$1P=void 0,e.$1P=(0,I.$qi)("configurationResolverService");var N;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class A extends Error{constructor(M,p){super(p),this.variable=M}}e.$2P=A}),define(Ae[224],Re([1,0,19,73,17,26,21,96,184,223,15]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,m,s,o){this.h=new Map,this.a=v,this.b=m,this.g=s,o&&(this.c=o.then(n=>this.i(n)))}i(v){if(M.$i){const m=Object.create(null);return Object.keys(v).forEach(s=>{m[s.toLowerCase()]=v[s]}),m}return v}resolveWithEnvironment(v,m,s){return this.l({env:this.i(v),userHome:void 0},m?m.uri:void 0,s)}async resolveAsync(v,m){const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,m)}async j(v,m,s,o){const n=O.$Wn(m);M.$i&&n.windows?Object.keys(n.windows).forEach(t=>n[t]=n.windows[t]):M.$j&&n.osx?Object.keys(n.osx).forEach(t=>n[t]=n.osx[t]):M.$k&&n.linux&&Object.keys(n.linux).forEach(t=>n[t]=n.linux[t]),delete n.windows,delete n.osx,delete n.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,v?v.uri:void 0,n,s,o)}async resolveAnyAsync(v,m,s){return this.j(v,m,s)}async resolveAnyMap(v,m,s){const o=new Map;return{newConfig:await this.j(v,m,s,o),resolvedVariables:o}}resolveWithInteractionReplace(v,m,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,m,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,m){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,m)}async l(v,m,s,o,n){if(A.$4f(s))return this.m(v,m,s,o,n);if(Array.isArray(s))return Promise.all(s.map(r=>this.l(v,m,r,o,n)));if(A.$6f(s)){const r=Object.create(null),t=await Promise.all(Object.keys(s).map(async a=>[await this.m(v,m,a,o,n),await this.l(v,m,s[a],o,n)]));for(const[a,d]of t)r[a]=d;return r}return s}m(v,m,s,o,n){return(0,T.$lf)(s,y.VARIABLE_REGEXP,async(r,t)=>{if(t.includes(y.VARIABLE_LHS))return r;let a=await this.o(v,r,t,m,o);return n?.set(t,a),a!==r&&A.$4f(a)&&a.match(y.VARIABLE_REGEXP)&&(a=await this.m(v,m,a,o,n)),a})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,m,s,o,n){let r;const t=s.split(":");t.length>1&&(s=t[0],r=t[1]);const a=b=>{const c=this.a.getFilePath();if(c)return(0,p.$pw)(c);throw new k.$2P(b,(0,$.localize)(0,null,m))},d=b=>{const c=a(b);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,p.$pw)(f)}throw new k.$2P(b,(0,$.localize)(1,null,m,I.$oc(c)))},i=b=>{if(r){const c=this.a.getFolderUri(r);if(c)return c;throw new k.$2P(b,(0,$.localize)(2,null,m,r))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.$2P(b,(0,$.localize)(3,null,m)):new k.$2P(b,(0,$.localize)(4,null,m))};switch(s){case"env":if(r){if(v.env){const b=v.env[M.$i?r.toLowerCase():r];if(A.$4f(b))return b}return""}throw new k.$2P(k.VariableKind.Env,(0,$.localize)(5,null,m));case"config":if(r){const b=this.a.getConfigurationValue(o,r);if(A.$ag(b))throw new k.$2P(k.VariableKind.Config,(0,$.localize)(6,null,m,r));if(A.$6f(b))throw new k.$2P(k.VariableKind.Config,(0,$.localize)(7,null,m,r));return b}throw new k.$2P(k.VariableKind.Config,(0,$.localize)(8,null,m));case"command":return this.p(k.VariableKind.Command,m,r,n,"command");case"input":return this.p(k.VariableKind.Input,m,r,n,"input");case"extensionInstallFolder":if(r){const b=await this.a.getExtension(r);if(!b)throw new k.$2P(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,m,r));return this.n(b.extensionLocation)}throw new k.$2P(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,m));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,p.$pw)(this.n(i(k.VariableKind.WorkspaceFolder)));case"cwd":return o||r?(0,p.$pw)(this.n(i(k.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$pw)(I.$oc(this.n(i(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new k.$2P(k.VariableKind.UserHome,(0,$.localize)(11,null,m))}case"lineNumber":{const b=this.a.getLineNumber();if(b)return b;throw new k.$2P(k.VariableKind.LineNumber,(0,$.localize)(12,null,m))}case"selectedText":{const b=this.a.getSelectedText();if(b)return b;throw new k.$2P(k.VariableKind.SelectedText,(0,$.localize)(13,null,m))}case"file":return a(k.VariableKind.File);case"fileWorkspaceFolder":return d(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(d(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||r?I.$mc(this.n(i(k.VariableKind.RelativeFile)),a(k.VariableKind.RelativeFile)):a(k.VariableKind.RelativeFile);case"relativeFileDirname":{const b=I.$nc(a(k.VariableKind.RelativeFileDirname));if(o||r){const c=I.$mc(this.n(i(k.VariableKind.RelativeFileDirname)),b);return c.length===0?".":c}return b}case"fileDirname":return I.$nc(a(k.VariableKind.FileDirname));case"fileExtname":return I.$pc(a(k.VariableKind.FileExtname));case"fileBasename":return I.$oc(a(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const b=I.$oc(a(k.VariableKind.FileBasenameNoExtension));return b.slice(0,b.length-I.$pc(b).length)}case"fileDirnameBasename":return I.$oc(I.$nc(a(k.VariableKind.FileDirnameBasename)));case"execPath":{const b=this.a.getExecPath();return b||m}case"execInstallFolder":{const b=this.a.getAppRoot();return b||m}case"pathSeparator":case"/":return I.sep;default:try{const b=r?`${s}:${r}`:s;return this.p(k.VariableKind.Unknown,m,b,n,void 0)}catch{return m}}}}p(v,m,s,o,n){if(s&&o){const r=n===void 0?o[s]:o[n+":"+s];if(typeof r=="string")return r;throw new k.$2P(v,(0,$.localize)(14,null,m))}return m}}e.$eQ=y}),define(Ae[107],Re([1,0,3,104]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ID=void 0,e.$JD=k,e.$KD=l,e.$LD=v,e.$ID=(0,I.$qi)("editorGroupsService");var A;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var O;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var M;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var $;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function k(m){const s=m;return(0,N.$tF)(s?.editor)&&(0,N.$tF)(s?.replacement)}var T;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var y;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function l(m){const s=m;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function v(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ae[225],Re([1,0,3,107]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$QD=A,e.$MD=(0,I.$qi)("editorService"),e.$ND=-1,e.$OD=-2,e.$PD=-3;function A(O){const M=O;return typeof O=="number"||(0,N.$KD)(M)}}),define(Ae[226],Re([1,0,3,191]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=void 0,e.$aM=(0,I.$ri)(N.$xi)}),define(Ae[108],Re([1,0,20,5,19,6,11]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=e.$T$b=e.$S$b=e.$R$b=e.$Q$b=void 0;class p{constructor(r,t){this.versionId=r,this.removedDueToLooping=t}}e.$Q$b=p;class ${static isHostExtension(r,t,a){if(t.getExtensionDescription(r))return!1;const d=a.getExtensionDescription(r);return d?!!((d.main||d.browser)&&d.api==="none"):!1}constructor(r,t){this.j=r,this.c=new N.$be,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(s),this.f=new I.$Nm,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const t=this.j.readActivationEvents(r);for(const a of t)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,t){this.e=o(this.e,t),this.e=this.e.concat(r);const a=$.l(this.e);return this.e=o(this.e,a.map(d=>d.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,a)}static l(r){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,f){this.addNode(c),this.addNode(f),this.c.has(c)?this.c.get(c).push(f):this.c.set(c,[f])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,f){const u=t.getArcs(c);for(let S=0;S<u.length;S++)if(!f.has(u[S]))return!1;return!0}getNodes(){return this.e}},a=new I.$Nm;for(const c of r)if(a.set(c.identifier,c),c.extensionDependencies)for(const f of c.extensionDependencies)t.addArc(I.$Lm.toKey(c.identifier),I.$Lm.toKey(f));const d=new Set;t.getNodes().filter(c=>t.getArcs(c).length===0).forEach(c=>d.add(c));const i=t.getNodes().filter(c=>!d.has(c));let b;do{b=!1;for(let c=0;c<i.length;c++){const f=i[c];t.hasOnlyGoodArcs(f,d)&&(i.splice(c,1),c--,d.add(f),b=!0)}}while(b);return i.map(c=>a.get(c))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const t=this.h.get(r);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const t=this.f.get(r);return t||void 0}getExtensionDescriptionByUUID(r){for(const t of this.g)if(t.uuid===r)return t}getExtensionDescriptionByIdOrUUID(r,t){return this.getExtensionDescription(r)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$R$b=$;class k{constructor(r,t){this.versionId=r,this.extensions=t}}e.$S$b=k;class T{constructor(r){this.d=new v,this.c=new $(r,[])}async acquireLock(r){const t=await this.d.acquire(r);return new y(this,t)}deltaExtensions(r,t,a){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,a)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,t){return this.c.getExtensionDescriptionByIdOrUUID(r,t)}}e.$T$b=T;class y extends O.$Uc{constructor(r,t){super(),this.f=r,this.c=!1,this.B(t)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$U$b=y;class l{constructor(r){this.name=r;const t=(0,M.$jh)();this.promise=t.promise,this.c=t.resolve}resolve(r){this.c(r)}}class v{constructor(){this.c=[],this.d=!1}async acquire(r){const t=new l(r);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let t=!0;const a=setTimeout(()=>{t&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),d=()=>{t&&(clearTimeout(a),t=!1,this.d=!1,this.e())};r.resolve((0,O.$Sc)(d))}}var m;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(m||(m={}));function s(n,r){const t=n.isBuiltin?0:n.isUnderDevelopment?2:1,a=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(t!==a)return t-a;const d=A.$hc.basename(n.extensionLocation.path),i=A.$hc.basename(r.extensionLocation.path);return d<i?-1:d>i?1:0}function o(n,r){const t=new I.$Mm(r);return n.filter(a=>!t.has(a.identifier))}}),define(Ae[77],Re([1,0,23]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Tm=M,e.$Um=p;var N;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(N||(e.UIKind=N={}));var A;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var O;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function M(k){const T=I.$Ce.alloc(1);switch(k){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function p(k,T){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var $;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ae[62],Re([1,0,3,5,13,27,77,58,59,26,2,6,171]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$uP=e.$tP=void 0,e.$vP=s;let v=class extends y.$Uc{constructor(n,r){super(),this.s=n,this.t=r,this.a=this.B(new N.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:$.$ep,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(r.onDidChangeLogLevel(t=>{(0,A.$Yj)(t)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(n,r,t){const a=this.getTelemetryDetails(),d=new m(r,t,n,this.n,this.j,this.getBuiltInCommonProperties(n),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),i=this.r.get(n.identifier.value)??[];return this.r.set(n.identifier.value,[...i,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(n,r,t){this.f=n,this.g=r,this.c=t??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(n){const r=Object.create(null);switch(r["common.extname"]=`${n.publisher}.${n.name}`,r["common.extversion"]=n.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.sqmid"]=this.s.telemetryInfo.sqmId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:r["common.uikind"]="web";break;case M.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,p.$Cm)((0,$.$kp)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(n){this.h=this.getTelemetryConfiguration(),this.f=n;const r=this.getTelemetryDetails();this.r.forEach((t,a)=>{const d=t.filter(i=>!i.isDisposed);d.length===0?this.r.delete(a):this.r.set(a,d)}),this.r.forEach(t=>{for(const a of t)a.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(n,r){const a=this.r.get(n.value)?.filter(i=>!i.isDisposed);if(!a)return this.r.delete(n.value),!1;let d=!1;for(const i of a)i.ignoreUnhandledExtHostErrors||(i.logError(r),d=!0);return d}};e.$tP=v,e.$tP=v=Je([Ve(0,O.$sP),Ve(1,A.$Xj)],v);class m{static validateSender(n){if(typeof n!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof n.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof n.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof n.flush<"u"&&typeof n.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(n,r,t,a,d,i,b){this.g=t,this.h=a,this.i=d,this.j=i,this.a=new N.$be,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=n,this.d={isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}}updateTelemetryEnablements(n,r){this.e&&(this.d={isUsageEnabled:n,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(n){let r="properties"in n?n.properties??{}:n;return r=(0,$.$np)(r,[]),this.c&&(r=(0,k.$Zn)(r,this.c)),this.b||(r=(0,k.$Zn)(r,this.j)),"properties"in n?n.properties=r:n=r,n}k(n,r){this.f&&(this.g.publisher==="vscode"?n=this.g.name+"/"+n:n=this.g.identifier.value+"/"+n,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(n,r),this.h.trace(n,r))}logUsage(n,r){this.d.isUsageEnabled&&this.k(n,r)}logError(n,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof n=="string")this.k(n,r);else{const t={name:n.name,message:n.message,stack:n.stack,cause:n.cause},a=(0,$.$np)(t,[]),d=new Error(a.message,{cause:a.cause});d.stack=a.stack,d.name=a.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(d,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const n=this,r={logUsage:n.logUsage.bind(n),get isUsageEnabled(){return n.d.isUsageEnabled},get isErrorsEnabled(){return n.d.isErrorsEnabled},logError:n.logError.bind(n),dispose:n.dispose.bind(n),onDidChangeEnableStates:n.a.event.bind(n)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let n=this.f;this.f=void 0,Promise.resolve(n.flush()).then(n=void 0),this.e=void 0}else this.f=void 0}}e.$uP=m;function s(o){const n=Date.now()-new Date(o).getTime();return isNaN(n)?!1:n<1e3*60*60*24}e.$wP=(0,I.$qi)("IExtHostTelemetry")}),define(Ae[25],Re([1,0,5,2,200,103,20,3]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=e.ActivationKind=e.$AG=e.$zG=e.$wG=e.ExtensionHostStartup=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$xG=l,e.$yG=v,e.$BG=n,e.$CG=r,e.$sG=Object.freeze({identifier:new M.$Lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$tG="extensions.webWorker",e.$uG=(0,p.$qi)("extensionService");class ${constructor(d){this.dependency=d}}e.$vG=$;var k;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(d,i,b){this.c=d,this.d=i.slice(0),this.e=b.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$dG.createActivationEventsMap(this.d)}}set(d,i,b){if(this.c>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this.c})`);const c=[],f=[],u=[],S=[],h=y(this.d),E=y(i),g=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=E.get(V.identifier);if(!W){c.push(V.identifier),h.delete(V.identifier);continue}if(!g(V,W)){c.push(V.identifier),h.delete(V.identifier);continue}}for(const V of i){const W=h.get(V.identifier);if(!W){f.push(V);continue}if(!g(W,V)){c.push(W.identifier),h.delete(W.identifier);continue}}const D=new M.$Mm(this.e),w=new M.$Mm(b);for(const V of this.e)w.has(V)||u.push(V);for(const V of b)D.has(V)||S.push(V);const C=O.$dG.createActivationEventsMap(f),P={versionId:d,toRemove:c,toAdd:f,addActivationEvents:C,myToRemove:u,myToAdd:S};return this.delta(P),P}delta(d){if(this.c>=d.versionId)return null;const{toRemove:i,toAdd:b,myToRemove:c,myToAdd:f}=d,u=new M.$Mm(i),S=new M.$Mm(c);for(let h=0;h<this.d.length;h++)u.has(this.d[h].identifier)&&(this.d.splice(h,1),h--);for(let h=0;h<this.e.length;h++)S.has(this.e[h])&&(this.e.splice(h,1),h--);for(const h of b)this.d.push(h);for(const h of f)this.e.push(h);return this.f=null,d}containsExtension(d){for(const i of this.e)if(M.$Lm.equals(i,d))return!0;return!1}containsActivationEvent(d){return this.f||(this.f=this.g()),this.f.has(d)}g(){const d=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const b=O.$dG.readActivationEvents(i);for(const c of b)d.add(c)}return d}}e.$wG=T;function y(a){const d=new M.$Nm;for(const i of a)d.set(i.identifier,i);return d}function l(a,d){return a.enabledApiProposals?a.enabledApiProposals.includes(d):!1}function v(a,d){if(!l(a,d))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class m{constructor(d,i,b,c){this.codeLoadingTime=d,this.activateCallTime=i,this.activateResolvedTime=b,this.activationReason=c}}e.$zG=m;class s{constructor(d,i){this.description=d,this.value=i}}e.$AG=s;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function n(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,A.$tp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function r(a,d){return{identifier:new M.$Lm((0,A.$rp)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!d,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,publisherDisplayName:a.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activateById(d,i){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$DG=t}),define(Ae[227],Re([1,0,14,108,20,25,13,11]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=e.$Vkc=e.$Ukc=e.$Tkc=e.$Skc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(n,r,t,a){this.startup=n,this.codeLoadingTime=r,this.activateCallTime=t,this.activateResolvedTime=a}}e.$Skc=$;class k{constructor(n){this.a=n,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(n,r){return n===-1||r===-1?-1:r-n}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Tkc=k;class T{constructor(n,r,t,a,d,i){this.activationFailed=n,this.activationFailedError=r,this.activationTimes=t,this.module=a,this.exports=d,this.subscriptions=i}}e.$Ukc=T;class y extends T{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Vkc=y;class l extends T{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wkc=l;class v extends T{constructor(n){super(!0,n,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(n,r,t,a){this.g=a,this.a=n,this.b=r,this.c=t,this.d=new A.$Nm,this.f=Object.create(null)}dispose(){for(const[n,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const n=[];for(const[r,t]of this.d)n.push(t.wait());await Promise.all(n)}isActivated(n){const r=this.d.get(n);return!!(r&&r.value)}getActivatedExtension(n){const r=this.d.get(n);if(!r||!r.value)throw new Error(`Extension '${n.value}' is not known or not activated`);return r.value}async activateByEvent(n,r){if(this.f[n])return;const t=this.a.getExtensionDescriptionsForActivationEvent(n);await this.h(t.map(a=>({id:a.identifier,reason:{startup:r,extensionId:a.identifier,activationEvent:n}}))),this.f[n]=!0}activateById(n,r){const t=this.a.getExtensionDescription(n);if(!t)throw new Error(`Extension '${n.value}' is not known`);return this.h([{id:t.identifier,reason:r}])}async h(n){const r=n.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(r.map(t=>t.wait()))}j(n){if(this.d.has(n.id))return this.d.get(n.id);if(this.l(n.id))return this.k(n,null,[],null);const r=this.a.getExtensionDescription(n.id);if(!r){const d=new Error(`Cannot activate unknown extension '${n.id.value}'`),i=this.k(n,null,[],new v(d));return this.c.onExtensionActivationError(n.id,d,new O.$vG(n.id.value)),i}const t=[],a=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const d of a){if(this.m(d))continue;const i=this.d.get(d);if(i){t.push(i);continue}if(this.l(d)){t.push(this.j({id:this.b.getExtensionDescription(d).identifier,reason:n.reason}));continue}const b=this.a.getExtensionDescription(d);if(b){if(!b.main&&!b.browser)continue;t.push(this.j({id:b.identifier,reason:n.reason}));continue}const c=r.displayName||r.identifier.value,f=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${d}'`),u=this.k(n,r.displayName,[],new v(f));return this.c.onExtensionActivationError(r.identifier,f,new O.$vG(d)),u}return this.k(n,r.displayName,t,null)}k(n,r,t,a){const d=new s(n.id,r,n.reason,t,a,this.c,this.g);return this.d.set(n.id,d),d}l(n){return N.$R$b.isHostExtension(n,this.a,this.b)}m(n){const r=this.b.getExtensionDescription(n);return r?!r.main&&!r.browser:!1}};e.$Xkc=m,e.$Xkc=m=Je([Ve(3,M.$Wj)],m);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(n,r,t,a,d,i,b){this.c=n,this.d=r,this.f=t,this.g=a,this.h=d,this.j=i,this.k=b,this.a=new p.$ph,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let n=0;n<this.g.length;n++){const r=this.g[n];if(r.value&&!r.value.activationFailed){this.g.splice(n,1),n--;continue}if(r.value&&r.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);t.detail=r.value.activationFailedError,this.h=new v(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(n=>n.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(n){const r=new Error;if(n&&n.name&&(r.name=n.name),n&&n.message?r.message=`Activating extension '${this.c.value}' failed: ${n.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${n}.`,n&&n.stack&&(r.stack=n.stack),this.h=new v(r),this.b&&I.$4(n))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(n)}}};s=Je([Ve(6,M.$Wj)],s)}),define(Ae[228],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[229],Re([1,0,186,14,33,98,72,30,20,228,196,103]),function(fe,e,I,N,A,O,M,p,$,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=void 0;const l=p.$9n.as(M.$0n.JSONContribution);class v{constructor(d,i,b){this.a=d,this.b=i,this.c=b}d(d,i){this.a({type:d,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(d){this.d(A.default.Error,d)}warn(d){this.d(A.default.Warning,d)}info(d){this.d(A.default.Info,d)}}e.$mG=v;class m{static a(d){const i=new $.$Mm;for(let b=0,c=d.length;b<c;b++)i.add(d[b].description.identifier);return i}static compute(d,i){if(!d||!d.length)return new m(i,[]);if(!i||!i.length)return new m([],d);const b=this.a(d),c=this.a(i),f=i.filter(S=>!b.has(S.description.identifier)),u=d.filter(S=>!c.has(S.description.identifier));return new m(f,u)}constructor(d,i){this.added=d,this.removed=i}}e.$nG=m;class s{constructor(d,i){this.name=d,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(d){if(this.a!==null)throw new Error("Handler already set!");this.a=d,this.d()}acceptUsers(d){this.c=m.compute(this.b,d),this.b=d,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(d){(0,N.$1)(d)}}}e.$oG=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},n="vscode://schemas/vscode-extensions";e.$pG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Km},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$No}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$No}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(d){if(this.a.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const i=new s(d.extensionPoint,d.defaultExtensionKind);return this.a.set(d.extensionPoint,i),d.activationEventsGenerator&&y.$dG.register(d.extensionPoint,d.activationEventsGenerator),e.$pG.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,l.registerSchema(n,e.$pG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$qG=r;const t={ExtensionsRegistry:"ExtensionsRegistry"};p.$9n.add(t.ExtensionsRegistry,new r),e.$rG=p.$9n.as(t.ExtensionsRegistry),l.registerSchema(n,e.$pG),l.registerSchema(T.$ek,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ae[230],Re([1,0,182,17,26,229,31,5]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var k;(function(l){function v(m,s,o){if(!m)return;const n=N.$4f(m.type)?m.type:void 0;if(!n||n.length===0){o.error(I.localize(3,null));return}const r=[];if(Array.isArray(m.required))for(const t of m.required)N.$4f(t)&&r.push(t);return{extensionId:s.value,taskType:n,required:r,properties:m.properties?A.$Wn(m.properties):{},when:m.when?M.$oj.deserialize(m.when):void 0}}l.from=v})(k||(k={}));const T=O.$rG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,v)=>{for(const m of l)m.type&&v.push(`onTaskType:${m.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:$}});class y{constructor(){this.d=new p.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,m)=>{T.setHandler((s,o)=>{this.c=void 0;try{for(const n of o.removed){const r=n.value;for(const t of r)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const n of o.added){const r=n.value;for(const t of r){const a=k.from(t,n.description.identifier,n.collector);a&&(this.a[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const m of this.all()){const s={type:"object",additionalProperties:!1};m.required.length>0&&(s.required=m.required.slice(0)),m.properties!==void 0?s.properties=A.$Wn(m.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[m.taskType]},v.push(s)}this.c={oneOf:v}}return this.c}}e.$UH=new y}),define(Ae[231],Re([1,0,183,17,24,26,31,230]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5H=e.JsonSchemaVersion=e.ExecutionEngine=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YH=e.ShellQuoting=e.$XH=e.$WH=e.$VH=void 0,e.$VH="settings",e.$WH=new M.$Hj("taskRunning",!1,I.localize(0,null)),e.$XH=I.localize2(2,"Tasks");var $;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$YH="$customized",function(R){function U(K){if(!K)return R.Strong;switch(K.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=U}($||(e.ShellQuoting=$={}));var k;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var T;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(T||(e.RevealKind=T={})),function(R){function U(K){switch(K.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=U}(T||(e.RevealKind=T={}));var y;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(R){function U(K){switch(K.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=U}(y||(e.RevealProblemKind=y={}));var l;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(l||(e.PanelKind=l={})),function(R){function U(K){switch(K.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=U}(l||(e.PanelKind=l={}));var v;(function(R){R.defaults={echo:!0,reveal:T.Always,revealProblems:y.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var m;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(R){function U(se){switch(se.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=U;function K(se){switch(se){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=K}(m||(e.RuntimeType=m={}));var s;(function(R){function U(K){return N.$4f(K)?K:K.value}R.value=U})(s||(e.CommandString=s={}));var o;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function U(se){return se===R.Clean._id||se===R.Build._id||se===R.Rebuild._id||se===R.Test._id}R.is=U;function K(se){if(se!==void 0)return N.$4f(se)?U(se)?{_id:se,isDefault:!1}:void 0:se}R.from=K})(o||(e.TaskGroup=o={}));var n;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(n||(e.TaskScope=n={}));var r;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function U(K){switch(K){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=U})(r||(e.TaskSourceKind=r={}));var t;(function(R){R.parallel="parallel",R.sequence="sequence"})(t||(e.DependsOrder=t={}));var a;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var d;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class i{constructor(U,K,se,ce,ve,Ie){this._label="",this._id=U,K&&(this._label=K),se&&(this.type=se),this.runOptions=ce,this.configurationProperties=ve,this._source=Ie}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,K=!1){if(U===void 0)return!1;if(N.$4f(U))return U===this._label||U===this.configurationProperties.identifier||K&&U===this._id;const se=this.getDefinition(!0);return se!==void 0&&se._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$ZH=i;class b extends i{constructor(U,K,se,ce,ve,Ie,ue,be){super(U,se,void 0,ue,be,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,ve&&(this.command=ve)}clone(){return new b(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(U){return U instanceof b}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const se={type:e.$YH,folder:U,id:K};return JSON.stringify(se)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$1g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new b(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$1H=b;class c extends i{constructor(U,K,se,ce,ve,Ie,ue){super(U,se,ce,Ie,ue,K),this._source=K,this.configures=ve}static is(U){return U instanceof c}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$1g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const se={type:e.$YH,folder:U,id:K};return JSON.stringify(se)}}e.$2H=c;class f extends i{constructor(U,K,se,ce,ve,Ie,ue,be,ie){super(U,se,ce,be,ie,K),this.defines=ve,this.hasDefinedMatchers=ue,this.command=Ie,this.icon=ie.icon,this.hide=ie.hide}clone(){return new f(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof f}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new f(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$3H=f;class u extends i{constructor(U,K,se,ce,ve,Ie){super(U,se,ce,ve,Ie,K),this._source=K}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new u(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$4H=u;var S;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(R){R._default=R.Terminal}(S||(e.ExecutionEngine=S={}));var h;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(h||(e.JsonSchemaVersion=h={}));class E{constructor(U){this.c=new Map;for(let K=0;K<U.length;K++)this.c.set(U[K].uri.toString(),K)}compare(U,K){const se=U.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(se&&ce){let ve=this.c.get(se.uri.toString());ve=ve===void 0?0:ve+1;let Ie=this.c.get(ce.uri.toString());return Ie=Ie===void 0?0:Ie+1,ve===Ie?U._label.localeCompare(K._label):ve-Ie}else return!se&&ce?-1:se&&!ce?1:0}}e.$5H=E;var g;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(g||(e.TaskEventKind=g={}));var D;(function(R){R.SingleRun="singleRun",R.Background="background"})(D||(e.TaskRunType=D={}));var w;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var C;(function(R){function U(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?"background":"singleRun",group:be.configurationProperties.group,__task:be}}function K(be,ie,Pe){return{...U(be),kind:"start",terminalId:ie,resolvedVariables:Pe}}R.start=K;function se(be,ie,Pe){return{...U(be),kind:"processStarted",terminalId:ie,processId:Pe}}R.processStarted=se;function ce(be,ie,Pe){return{...U(be),kind:"processEnded",terminalId:ie,exitCode:Pe}}R.processEnded=ce;function ve(be,ie,Pe){return{...U(be),kind:"terminated",exitReason:Pe,terminalId:ie}}R.terminated=ve;function Ie(be,ie,Pe){return{...U(ie),kind:be,terminalId:Pe}}R.general=Ie;function ue(){return{kind:"changed"}}R.changed=ue})(C||(e.TaskEvent=C={}));var P;(function(R){function U(se){const ce=Object.keys(se).sort();let ve="";for(const Ie of ce){let ue=se[Ie];ue instanceof Object?ue=U(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ve+=Ie+","+ue+","}return ve}function K(se){const ve={_key:U(se),type:se.taskType};return Object.assign(ve,se),ve}R.create=K})(P||(e.KeyedTaskIdentifier=P={}));var V;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(R){function U(K,se){const ce=p.$UH.get(K.type);if(ce===void 0){const be=O.$Wn(K);return delete be._key,P.create(be)}const ve=Object.create(null);ve.type=ce.taskType;const Ie=new Set;ce.required.forEach(be=>Ie.add(be));const ue=ce.properties;for(const be of Object.keys(ue)){const ie=K[be];if(ie!=null)ve[be]=ie;else if(Ie.has(be)){const Pe=ue[be];if(Pe.default!==void 0)ve[be]=O.$Wn(Pe.default);else switch(Pe.type){case"boolean":ve[be]=!1;break;case"number":case"integer":ve[be]=0;break;case"string":ve[be]="";break;default:se.error(I.localize(1,null,JSON.stringify(K,void 0,0),be));return}}}return P.create(ve)}R.createTaskIdentifier=U})(q||(e.TaskDefinition=q={}))}),define(Ae[232],Re([1,0,14]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=e.$V$b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,I.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$V$b=N;class A extends N{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$W$b=A}),define(Ae[34],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$jw=void 0,e.$kw=A,e.$lw=O;class I{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++I.count}}e.$jw=I;const N=[];function A(p){const $=new I(p);return N[$.nid]=$,$}function O(p){return N[p].sid}class M{constructor($){this.value=$}}e.$mw=M}),define(Ae[4],Re([1,0,34]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$OM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var A;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var O;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var M;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var $;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var T;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$OM=y;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var m;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$PM={MainThreadAuthentication:(0,I.$kw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$kw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$kw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$kw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$kw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$kw)("MainThreadClipboard"),MainThreadCommands:(0,I.$kw)("MainThreadCommands"),MainThreadComments:(0,I.$kw)("MainThreadComments"),MainThreadConfiguration:(0,I.$kw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$kw)("MainThreadConsole"),MainThreadDebugService:(0,I.$kw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$kw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$kw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$kw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$kw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$kw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$kw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$kw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$kw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$kw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$kw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$kw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$kw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$kw)("MainThreadLanguages"),MainThreadLogger:(0,I.$kw)("MainThreadLogger"),MainThreadMessageService:(0,I.$kw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$kw)("MainThreadOutputService"),MainThreadProgress:(0,I.$kw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$kw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$kw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$kw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$kw)("MainThreadSecretState"),MainThreadStorage:(0,I.$kw)("MainThreadStorage"),MainThreadSpeech:(0,I.$kw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$kw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$kw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$kw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$kw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$kw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$kw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$kw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$kw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$kw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$kw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$kw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$kw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$kw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$kw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$kw)("MainThreadSCM"),MainThreadSearch:(0,I.$kw)("MainThreadSearch"),MainThreadShare:(0,I.$kw)("MainThreadShare"),MainThreadTask:(0,I.$kw)("MainThreadTask"),MainThreadWindow:(0,I.$kw)("MainThreadWindow"),MainThreadLabelService:(0,I.$kw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$kw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$kw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$kw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$kw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$kw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$kw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$kw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$kw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$kw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$kw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$kw)("MainThreadTimeline"),MainThreadTesting:(0,I.$kw)("MainThreadTesting"),MainThreadLocalization:(0,I.$kw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$kw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$kw)("MainThreadAiEmbeddingVector")},e.$QM={ExtHostCommands:(0,I.$kw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$kw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$kw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$kw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$kw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$kw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$kw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$kw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$kw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$kw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$kw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$kw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$kw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$kw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$kw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$kw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$kw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$kw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$kw)("ExtHostStatusBar"),ExtHostShare:(0,I.$kw)("ExtHostShare"),ExtHostExtensionService:(0,I.$kw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$kw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$kw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$kw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$kw)("ExtHostSCM"),ExtHostSearch:(0,I.$kw)("ExtHostSearch"),ExtHostTask:(0,I.$kw)("ExtHostTask"),ExtHostWorkspace:(0,I.$kw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$kw)("ExtHostWindow"),ExtHostWebviews:(0,I.$kw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$kw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$kw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$kw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$kw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$kw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$kw)("ExtHostProgress"),ExtHostComments:(0,I.$kw)("ExtHostComments"),ExtHostSecretState:(0,I.$kw)("ExtHostSecretState"),ExtHostStorage:(0,I.$kw)("ExtHostStorage"),ExtHostUrls:(0,I.$kw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$kw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$kw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$kw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$kw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$kw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$kw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$kw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$kw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$kw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$kw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$kw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$kw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$kw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$kw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$kw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$kw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$kw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$kw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$kw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$kw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$kw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$kw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$kw)("ExtHostTimeline"),ExtHostTesting:(0,I.$kw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$kw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$kw)("ExtHostLocalization")}}),define(Ae[78],Re([1,0,3,13,4,16]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=e.$gkc=e.$fkc=void 0,e.$fkc=(0,I.$qi)("IExtHostApiDeprecationService");let M=class{constructor($,k){this.c=k,this.a=new Set,this.b=$.getProxy(A.$PM.MainThreadTelemetry)}report($,k,T){const y=this.d($,k);this.a.has(y)||(this.a.add(y),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:$}))}d($,k){return`${$}-${k.identifier.value}`}};e.$gkc=M,e.$gkc=M=Je([Ve(0,O.$cP),Ve(1,N.$Wj)],M),e.$hkc=Object.freeze(new class{report(p,$,k){}})}),define(Ae[233],Re([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class N{constructor(O){const M=O.getProxy(I.$PM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$ukc=N}),define(Ae[234],Re([1,0,26,4,27,16]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0;let M=class{constructor(T,y){this.a=T.getProxy(N.$PM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,y){const l=this,v=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){l.e(T,y,v,arguments)}})}e(T,y,l,v){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:$(v,this.b)}),this.c&&this.f(T,l,v)}};e.$omc=M,e.$omc=M=Je([Ve(0,O.$cP),Ve(1,A.$sP)],M);const p=1e5;function $(k,T){const y=[];if(k.length)for(let l=0;l<k.length;l++){let v=k[l];if(typeof v>"u")v="undefined";else if(v instanceof Error){const m=v;m.stack?v=m.stack:v=m.toString()}y.push(v)}if(T){const l=new Error().stack;l&&y.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,I.$2n)(y);return l.length>p?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Ae[235],Re([1,0,2,4,25]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class O{constructor(p){this.a=p.getProxy(N.$PM.MainThreadDialogs)}showOpenDialog(p,$){return $?.allowUIResources&&(0,A.$yG)(p,"showLocal"),this.a.$showOpenDialog($).then(k=>k?k.map(T=>I.URI.revive(T)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then($=>$?I.URI.revive($):void 0)}}e.$rlc=O}),define(Ae[236],Re([1,0,6,4]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;class A{constructor(M){this.b=0,this.a=M.getProxy(N.$PM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Llc=A}),define(Ae[79],Re([1,0,21,15,2,3,13,4,27,16]),function(fe,e,I,N,A,O,M,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=e.$_kc=void 0;let T=class{constructor(l,v,m){this.f=m,this.d=new Map,this.a=v.getProxy(p.$PM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===I.$g}getMessage(l,v){const{message:m,args:s,comment:o}=v;if(this.c)return(0,N.$5e)(m,s??{});let n=m;o&&o.length>0&&(n+=`/${Array.isArray(o)?o.join(""):o}`);const r=this.d.get(l)?.contents[n];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${n}`),(0,N.$5e)(r??m,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let v;const m=await this.g(l);if(!m){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(m),o=JSON.parse(s);v=l.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${m}: ${s.message}`);return}v&&this.d.set(l.identifier.value,{contents:v,uri:m})}async g(l){if(l.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return A.URI.revive(v)}return l.l10n?A.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$_kc=T,e.$_kc=T=Je([Ve(0,$.$sP),Ve(1,k.$cP),Ve(2,M.$Wj)],T),e.$alc=(0,O.$qi)("IExtHostLocalizationService")}),define(Ae[237],Re([1,0,13,4,27,16,2,53]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;let $=class extends I.$8j{constructor(y,l){super(l.logLevel,l.logsLocation,l.loggers.map(v=>(0,p.$Zh)(v))),this.r=y.getProxy(N.$PM.MainThreadLogger)}$setLogLevel(y,l){l?this.setLogLevel(M.URI.revive(l),y):this.setLogLevel(y)}setVisibility(y,l){super.setVisibility(y,l),this.r.$setVisibility(y,l)}s(y,l,v){return new k(this.r,y,l,v)}};e.$nmc=$,e.$nmc=$=Je([Ve(0,O.$cP),Ve(1,A.$sP)],$);class k extends I.$3j{constructor(y,l,v,m){super(m?.logLevel==="always"),this.r=y,this.s=l,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(l,m).then(()=>{this.u(this.n),this.m=!0})}g(y,l){const v=[[y,l]];this.m?this.u(v):this.n.push(...v)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ae[80],Re([1,0,4,3,6,16,23]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=e.$blc=void 0,e.$blc=(0,N.$qi)("IExtHostManagedSockets");let p=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(I.$PM.MainThreadManagedSockets)}setFactory(y,l){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(y,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const l=++this.b,v=await this.c.makeConnection(),m=new A.$Tc;return this.d.set(l,new k(l,v,m)),m.add((0,A.$Sc)(()=>this.d.delete(l))),m.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),m.dispose()})),m.add(v.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),m.dispose()})),m.add(v.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,M.$Ce.wrap(s)))),l}$remoteSocketWrite(y,l){this.d.get(y)?.actual.send(l.buffer)}$remoteSocketEnd(y){const l=this.d.get(y);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$clc=p,e.$clc=p=Je([Ve(0,O.$cP)],p);class ${constructor(y,l){this.socketFactoryId=y,this.makeConnection=l}}class k extends A.$Uc{constructor(y,l,v){super(),this.socketId=y,this.actual=l,this.B(v)}}}),define(Ae[238],Re([1,0,4,13,25]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;function O(p){return p&&p.title}let M=class{constructor($,k){this.b=k,this.a=$.getProxy(I.$PM.MainThreadMessageService)}showMessage($,k,T,y,l){const v={source:{identifier:$.identifier,label:$.displayName||$.name}};let m;typeof y=="string"||O(y)?m=[y,...l]:(v.modal=y?.modal,v.useCustom=y?.useCustom,v.detail=y?.detail,m=l),v.useCustom&&(0,A.$yG)($,"resolvers");const s=[];let o=!1;for(let n=0;n<m.length;n++){const r=m[n];if(typeof r=="string")s.push({title:r,handle:n,isCloseAffordance:!1});else if(typeof r=="object"){const{title:t,isCloseAffordance:a}=r;s.push({title:t,isCloseAffordance:!!a,handle:n}),a&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,r):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,r)}return this.a.$showMessage(k,T,v,s).then(n=>{if(typeof n=="number")return m[n]})}};e.$Nlc=M,e.$Nlc=M=Je([Ve(1,N.$Wj)],M)}),define(Ae[239],Re([1,0,6,17,2,25,4]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class p{constructor(k){this.b=new Map,this.a=k.getProxy(M.$PM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,T,y){if((0,O.$yG)(k,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,y),this.a.$registerProfileContentHandler(T,y.name,y.description,k.identifier.value),(0,I.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(k,T,y,l){const v=this.b.get(k);if(!v)throw new Error(`Unknown handler with id: ${k}`);return v.saveProfile(T,y,l)}async $readProfile(k,T,y){const l=this.b.get(k);if(!l)throw new Error(`Unknown handler with id: ${k}`);return l.readProfile((0,N.$4f)(T)?T:A.URI.revive(T),y)}}e.$Wlc=p}),define(Ae[81],Re([1,0,4,5,3]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=e.$9kc=void 0;class O{constructor(p){this.b=new N.$be,this.onDidChangePassword=this.b.event,this.a=p.getProxy(I.$PM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,$){return this.a.$getPassword(p,$)}store(p,$,k){return this.a.$setPassword(p,$,k)}delete(p,$){return this.a.$deletePassword(p,$)}}e.$9kc=O,e.$0kc=(0,A.$qi)("IExtHostSecretState")}),define(Ae[240],Re([1,0,22,6,4]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class O{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(A.$PM.MainThreadSpeech)}async $createSpeechToTextSession(p,$,k){const T=this.c.get(p);if(!T)return;const y=new N.$Tc,l=new I.$me;this.d.set($,l);const v=y.add(T.provideSpeechToTextSession(l.token,k?{language:k}:void 0));y.add(v.onDidChange(m=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,m)})),y.add(l.token.onCancellationRequested(()=>y.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,$){const k=this.c.get(p);if(!k)return;const T=new N.$Tc,y=new I.$me;this.d.set($,y);const l=T.add(k.provideKeywordRecognitionSession(y.token));T.add(l.onDidChange(v=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,v)})),T.add(y.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,$,k){const T=O.a++;return this.c.set(T,k),this.b.$registerProvider(T,$,{extension:p,displayName:p.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$4lc=O}),define(Ae[82],Re([1,0,4,5,3]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=e.$Ykc=void 0;class O{constructor(p,$){this.c=$,this.b=new N.$be,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(I.$PM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,$){this.a.$registerExtensionStorageKeysToSync(p,$)}async initializeExtensionStorage(p,$,k){const T=await this.a.$initializeExtensionStorage(p,$);let y;return T&&(y=this.d(p,$,T)),y||k}setValue(p,$,k){return this.a.$setValue(p,$,k)}$acceptValue(p,$,k){const T=this.d(p,$,k);T&&this.b.fire({shared:p,key:$,value:T})}d(p,$,k){try{return JSON.parse(k)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${p}): ${T}`)}}}e.$Ykc=O,e.$Zkc=(0,A.$qi)("IExtHostStorage")}),define(Ae[241],Re([1,0,6,12,2,4]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(O.$PM.MainThreadUriOpeners)}registerExternalUriOpener($,k,T,y){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=y.schemes.find(v=>!M.a.has(v));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(k,T),this.b.$registerUriOpener(k,y.schemes,$,y.label),(0,I.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri($,k,T){const y=this.c.get($);if(!y)throw new Error(`Unknown opener with id: ${$}`);const l=A.URI.revive(k);return y.canOpenExternalUri(l,T)}async $openUri($,k,T){const y=this.c.get($);if(!y)throw new Error(`Unknown opener id: '${$}'`);return y.openExternalUri(A.URI.revive(k.resolvedUri),{sourceUri:A.URI.revive(k.sourceUri)},T)}}e.$hmc=M}),define(Ae[242],Re([1,0,4,2,6,14,20]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;class p{static{this.a=0}constructor(k){this.c=new M.$Mm,this.d=new Map,this.b=k.getProxy(I.$PM.MainThreadUrls)}registerUriHandler(k,T){const y=k.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const l=p.a++;return this.c.add(y),this.d.set(l,T),this.b.$registerUriHandler(l,y,k.displayName||k.name),(0,A.$Sc)(()=>{this.c.delete(y),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(k,T){const y=this.d.get(k);if(!y)return Promise.resolve(void 0);try{y.handleUri(N.URI.revive(T))}catch(l){(0,O.$1)(l)}return Promise.resolve(void 0)}async createAppUri(k){return N.URI.revive(await this.b.$createAppUri(k))}}e.$imc=p}),define(Ae[63],Re([1,0,5,6,12,26,2,189,211,76,4]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Jkc=void 0,e.$Kkc=l,e.$Mkc=s,e.$Nkc=o;class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,d,i,b,c,f,u){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$be,this._onDidDispose=this.#h.event,this.#e=a,this.#t=d,this.#o=i,this.#n=b,this.#s=c,this.#r=f,this.#l=l(f),this.#d=v(f),this.#i=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,k.$Rxb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===A.Schemas.https||a.scheme===A.Schemas.http){let d=a.toString();return d.endsWith("/")||(d+="/"),d+" "+k.$Qxb}return k.$Qxb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),O.$1n(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const d=(0,$.$0nb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const d=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,c,f,u,S,h)=>{const E=M.URI.from({scheme:u||"file",path:decodeURIComponent(S)}),g=(0,k.$Rxb)(E,{isRemote:d,authority:i}).toString();return`${c}${g}${h}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,c,f,u,S,h)=>{const E=M.URI.from({scheme:u||"file",path:decodeURIComponent(S)}),g=(0,k.$Rxb)(E,{isRemote:d,authority:i}).toString();return`${c}${g}${h}`})}}e.$Jkc=y;function l(t){try{const a=(0,p.$Cp)((0,p.$Bp)(t.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function v(t){try{const a=(0,p.$Cp)((0,p.$Bp)(t.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class m extends N.$Uc{constructor(a,d,i,b,c){super(),this.c=d,this.f=i,this.g=b,this.h=c,this.b=new Map,this.a=a.getProxy(T.$PM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,d,i){const b=this.j(a);if(b){const{message:c}=(0,$.$$nb)(d,i.value);b._onMessageEmitter.fire(c)}}$onMissingCsp(a,d){this.g.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,d,i){const b=new y(a,this.a,n(d),this.c,this.f,i,this.h);this.b.set(a,b);const c=b._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return b}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$Lkc=m;function s(t){return{id:t.identifier,location:t.extensionLocation}}function o(t,a,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||r(t,a)}}function n(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(a=>M.URI.from(a))}}function r(t,a){return[...(a?.getWorkspaceFolders()||[]).map(d=>d.uri),t.extensionLocation]}}),define(Ae[109],Re([1,0,5,4,2,12,15,3,16,25]),function(fe,e,I,N,A,O,M,p,$,k){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0;let y=class{static{T=this}static{this.a={focused:!0,active:!0}}getState(v){const m=this.d;return{get focused(){return m.focused},get active(){return(0,k.$yG)(v,"windowActivity"),m.active}}}constructor(v){this.c=new I.$be,this.onDidChangeWindowState=this.c.event,this.d=T.a,this.b=v.getProxy(N.$PM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:s})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,m){m!==this.d[v]&&(this.d={...this.d,[v]:m},this.c.fire(this.d))}openUri(v,m){let s;if(typeof v=="string"){s=v;try{v=A.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,M.$3e)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,s,m)}async asExternalUri(v,m){if((0,M.$3e)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(v,m);return A.URI.from(s)}};e.$kmc=y,e.$kmc=y=T=Je([Ve(0,$.$cP)],y),e.$lmc=(0,p.$qi)("IExtHostWindow")}),define(Ae[243],Re([1,0,234,27,16]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0;let O=class extends I.$omc{constructor(p,$){super(p,$)}f(p,$,k){$.apply(console,k)}};e.$woc=O,e.$woc=O=Je([Ve(0,A.$cP),Ve(1,N.$sP)],O)}),define(Ae[244],Re([1,0,11,23,22,14,5,6,144,232,34]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$X$b=o,e.$Y$b=n;function l(w,C){try{return JSON.stringify(w,C)}catch{return"null"}}const v="$$ref$$",m={[v]:-1};class s{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function o(w,C=null,P=!1){const V=[];return{jsonString:(P?l:JSON.stringify)(w,(q,R)=>{if(typeof R>"u")return m;if(typeof R=="object"){if(R instanceof N.$Ce){const U=V.push(R)-1;return{[v]:U}}if(C)return C(q,R)}return R}),referencedBuffers:V}}function n(w,C,P){return JSON.parse(w,(V,W)=>{if(W){const q=W[v];if(typeof q=="number")return C[q];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}function r(w,C){return JSON.stringify(w,C)}function t(w){return w?(C,P)=>P&&P.$mid===1?w.transformOutgoing(P):P:null}var a;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var d;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const i=()=>{},b=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class f extends p.$Uc{static{y=b}static{this.a=3*1e3}constructor(C,P=null,V=null){super(),this[y]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=V,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=T.$jw.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$Ch(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+f.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+f.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,$.$vn)(C,this.g):C}getProxy(C){const{nid:P,sid:V}=C;return this.s[P]||(this.s[P]=this.J(P,V)),this.s[P]}J(C,P){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...R)=>this.U(C,q,R)),q===c?P:W[q])};return new Proxy(Object.create(null),V)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,V=C.length;P<V;P++){const W=C[P];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,V=S.read(C,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:R,method:U,args:K}=E.deserializeRequestJSONArgs(V);this.g&&(K=(0,$.$vn)(K,this.g)),this.M(P,q,R,U,K,W===2);break}case 3:case 4:{let{rpcId:R,method:U,args:K}=E.deserializeRequestMixedArgs(V);this.g&&(K=(0,$.$vn)(K,this.g)),this.M(P,q,R,U,K,W===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let R=E.deserializeReplyOKJSON(V);this.g&&(R=(0,$.$vn)(R,this.g)),this.O(P,q,R);break}case 10:{const R=E.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(P,q,R);break}case 8:{const R=E.deserializeReplyOKVSBuffer(V);this.O(P,q,R);break}case 11:{let R=E.deserializeReplyErrError(V);this.g&&(R=(0,$.$vn)(R,this.g)),this.P(P,q,R);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,V,W,q,R){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,T.$lw)(V)}.${W}(`,q);const U=String(P);let K,se;if(R){const ve=new A.$me;q.push(ve.token),K=this.Q(V,W,q),se=()=>ve.cancel()}else K=this.Q(V,W,q),se=i;this.u[U]=se;const ce=E.serializeAcknowledged(P);this.f?.logOutgoing(ce.byteLength,P,1,"ack"),this.c.send(ce),K.then(ve=>{delete this.u[U];const Ie=E.serializeReplyOK(P,ve,this.h);this.f?.logOutgoing(Ie.byteLength,P,1,"reply:",ve),this.c.send(Ie)},ve=>{delete this.u[U];const Ie=E.serializeReplyErr(P,ve);this.f?.logOutgoing(Ie.byteLength,P,1,"replyErr:",ve),this.c.send(Ie)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const V=String(P);this.u[V]?.()}O(C,P,V){this.f?.logIncoming(C,P,0,"receiveReply:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(C,P,V){this.f?.logIncoming(C,P,0,"receiveReplyErr:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let R;V&&(V.$isError?(R=new Error,R.name=V.name,R.message=V.message,R.stack=V.stack):R=V),q.resolveErr(R)}Q(C,P,V){try{return Promise.resolve(this.S(C,P,V))}catch(W){return Promise.reject(W)}}S(C,P,V){const W=this.m[C];if(!W)throw new Error("Unknown actor "+(0,T.$lw)(C));const q=W[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,T.$lw)(C));return q.apply(W,V)}U(C,P,V){if(this.j)return new k.$W$b;let W=null;if(V.length>0&&A.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(O.$6());const q=E.serializeRequestArguments(V,this.h),R=++this.t,U=String(R),K=new k.$V$b,se=new p.$Tc;W&&se.add(W.onCancellationRequested(()=>{const ve=E.serializeCancel(R);this.f?.logOutgoing(ve.byteLength,R,0,"cancel"),this.c.send(E.serializeCancel(R))})),this.w[U]=new u(K,se),this.F(R);const ce=E.serializeRequest(R,C,P,q,!!W);return this.f?.logOutgoing(ce.byteLength,R,0,`request: ${(0,T.$lw)(C)}.${P}(`,V),this.c.send(ce),K}}e.$Z$b=f;class u{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class S{static alloc(C,P,V){const W=new S(N.$Ce.alloc(V+1+4),0);return W.writeUInt8(C),W.writeUInt32(P),W}static read(C,P){return new S(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let V=0,W=C.length;V<W;V++){const q=C[V];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let R=0;R<q.buffers.length;++R)P+=this.sizeVSBuffer(q.buffers[R]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,V=C.length;P<V;P++){const W=C[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let V=0;V<C;V++)switch(this.readUInt8()){case 1:P[V]=this.readLongString();break;case 2:P[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),R=this.readLongString(),U=[];for(let K=0;K<q;++K)U.push(this.readVSBuffer());P[V]=new T.$mw(n(R,U,null));break}case 4:P[V]=void 0;break}return P}}var h;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(h||(h={}));class E{static a(C){for(let P=0,V=C.length;P<V;P++)if(C[P]instanceof N.$Ce||C[P]instanceof T.$mw||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const V=[];for(let W=0,q=C.length;W<q;W++){const R=C[W];if(R instanceof N.$Ce)V[W]={type:2,value:R};else if(typeof R>"u")V[W]={type:4};else if(R instanceof T.$mw){const{jsonString:U,referencedBuffers:K}=o(R.value,P);V[W]={type:3,value:N.$Ce.fromString(U),buffers:K}}else V[W]={type:1,value:N.$Ce.fromString(r(R,P))}}return{type:1,args:V}}return{type:0,args:r(C,P)}}static serializeRequest(C,P,V,W,q){switch(W.type){case 0:return this.b(C,P,V,W.args,q);case 1:return this.c(C,P,V,W.args,q)}}static b(C,P,V,W,q){const R=N.$Ce.fromString(V),U=N.$Ce.fromString(W);let K=0;K+=S.sizeUInt8(),K+=S.sizeShortString(R),K+=S.sizeLongString(U);const se=S.alloc(q?2:1,C,K);return se.writeUInt8(P),se.writeShortString(R),se.writeLongString(U),se.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),V=C.readShortString(),W=C.readLongString();return{rpcId:P,method:V,args:JSON.parse(W)}}static c(C,P,V,W,q){const R=N.$Ce.fromString(V);let U=0;U+=S.sizeUInt8(),U+=S.sizeShortString(R),U+=S.sizeMixedArray(W);const K=S.alloc(q?4:3,C,U);return K.writeUInt8(P),K.writeShortString(R),K.writeMixedArray(W),K.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),V=C.readShortString(),W=C.readMixedArray(),q=new Array(W.length);for(let R=0,U=W.length;R<U;R++){const K=W[R];typeof K=="string"?q[R]=JSON.parse(K):q[R]=K}return{rpcId:P,method:V,args:q}}static serializeAcknowledged(C){return S.alloc(5,C,0).buffer}static serializeCancel(C){return S.alloc(6,C,0).buffer}static serializeReplyOK(C,P,V){if(typeof P>"u")return this.d(C);if(P instanceof N.$Ce)return this.e(C,P);if(P instanceof T.$mw){const{jsonString:W,referencedBuffers:q}=o(P.value,V,!0);return this.g(C,W,q)}else return this.f(C,l(P,V))}static d(C){return S.alloc(7,C,0).buffer}static e(C,P){let V=0;V+=S.sizeVSBuffer(P);const W=S.alloc(8,C,V);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const V=N.$Ce.fromString(P);let W=0;W+=S.sizeLongString(V);const q=S.alloc(9,C,W);return q.writeLongString(V),q.buffer}static g(C,P,V){const W=N.$Ce.fromString(P);let q=0;q+=S.sizeUInt32,q+=S.sizeLongString(W);for(const U of V)q+=S.sizeVSBuffer(U);const R=S.alloc(10,C,q);R.writeUInt32(V.length),R.writeLongString(W);for(const U of V)R.writeBuffer(U);return R.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const V=C.readUInt32(),W=C.readLongString(),q=[];for(let R=0;R<V;++R)q.push(C.readVSBuffer());return new T.$mw(n(W,q,P))}static serializeReplyErr(C,P){const V=P?l(O.$3(P),null):void 0;if(typeof V!="string")return this.h(C);const W=N.$Ce.fromString(V);let q=0;q+=S.sizeLongString(W);const R=S.alloc(11,C,q);return R.writeLongString(W),R.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return S.alloc(12,C,0).buffer}}var g;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var D;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(D||(D={}))}),define(Ae[245],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0;const I=function(O){const M=p=>{globalThis.removeEventListener("message",M);const $=p.data;Object.defineProperties(globalThis,{postMessage:{value(k,T){$.postMessage(k,T)}},onmessage:{get(){return $.onmessage},set(k){$.onmessage=k}}}),$.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",M)}.toString();class N extends EventTarget{constructor(O,M,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${I})('${M}'))`,k=new Blob([$],{type:"application/javascript"}),T=URL.createObjectURL(k),y=new MessageChannel,l=T,v={type:"_newWorker",id:l,port:y.port2,url:T,options:p};O(v,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:l}),URL.revokeObjectURL(T),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(m){y.port1.onmessage=m}},onmessageerror:{get(){return y.port1.onmessageerror},set(m){y.port1.onmessageerror=m}}}),y.port1.addEventListener("messageerror",m=>{const s=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(s)}),y.port1.addEventListener("message",m=>{const s=new MessageEvent("message",{data:m.data});this.dispatchEvent(s)}),y.port1.start()}}e.$yoc=N}),define(Ae[246],Re([1,0,23,28,12,55,3]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$rK=void 0,e.$sK=T,e.$tK=y,e.$rK=(0,M.$qi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${p.join("")}]+`),k=7;function T(v){if(v.scheme!==A.Schemas.vscodeNotebookCell)return;const m=v.fragment.indexOf("s");if(m<0)return;const s=parseInt(v.fragment.substring(0,m).replace($,""),k),o=(0,I.$Ve)(v.fragment.substring(m+1)).toString();if(!isNaN(s))return{handle:s,notebook:v.with({scheme:o,fragment:null})}}function y(v,m){const s=m.toString(k),n=`${s.length<p.length?p[s.length-1]:"z"}${s}s${(0,I.$We)(I.$Ce.fromString(v.scheme),!0,!0)}`;return v.with({scheme:A.Schemas.vscodeNotebookCell,fragment:n})}class l{constructor(){this.a=new N.$Bc}getNotebook(m){if(m.scheme===A.Schemas.vscodeNotebookCell){const s=T(m);if(s){const o=this.a.get(s.notebook);if(o)return o}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$uK=l,(0,O.$os)(e.$rK,l,1)}),define(Ae[83],Re([1,0,23,36,40,69,12,19,21,31,246]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=e.CellStatusbarAlignment=e.$KK=e.NotebookEditorPriority=e.$HK=e.$GK=e.$EK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DK=e.$CK=e.$BK=e.$AK=e.CellKind=e.$zK=e.$yK=e.$xK=void 0,e.$FK=b,e.$IK=f,e.$JK=u,e.$MK=E,e.$NK=D,e.$xK="workbench.editor.notebook",e.$yK="workbench.editor.notebookTextDiffEditor",e.$zK="workbench.editor.interactive";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.$AK=["application/json","application/javascript","text/html","image/svg+xml",O.$Hs.latex,O.$Hs.markdown,"image/png","image/jpeg",O.$Hs.text],e.$BK=[O.$Hs.latex,O.$Hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Hs.text],e.$CK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DK="_notAvailable";var l;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var v;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var m;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var s;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var n;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(n||(e.NotebookCellsChangeType=n={}));var r;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var t;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var a;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function se(ie,Pe){return(0,T.$tK)(ie,Pe)}K.generate=se;function ce(ie){return(0,T.$sK)(ie)}K.parse=ce;function ve(ie,Pe){return ie.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${Pe??""},${ie.scheme!==M.Schemas.file?ie.scheme:""}`})}K.generateCellOutputUri=ve;function Ie(ie){if(ie.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const Pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!Pe)return;const Fe=Pe[1]&&Pe[1]!==""?Pe[1]:void 0,ne=Pe[2];return{outputId:Fe,notebook:ie.with({scheme:ne||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ie;function ue(ie,Pe,Fe){return K.generate(ie,Pe).with({scheme:Fe})}K.generateCellPropertyUri=ue;function be(ie,Pe){if(ie.scheme===Pe)return K.parse(ie.with({scheme:K.scheme}))}K.parseCellPropertyUri=be})(a||(e.CellUri=a={}));const d=K=>$.$i?K.replace(/\//g,"\\"):K;class i{constructor(se=[],ce=e.$AK){this.e=ce,this.d=[...new Set(se)].map(ve=>({pattern:ve,matches:N.$kk(d(ve))}))}sort(se){const ce=new Map(A.Iterable.map(se,Ie=>[Ie,d(Ie)]));let ve=[];for(const{matches:Ie}of this.d)for(const[ue,be]of ce)if(Ie(be)){ve.push(ue),ce.delete(ue);break}return ce.size&&(ve=ve.concat([...ce.keys()].sort((Ie,ue)=>this.e.indexOf(Ie)-this.e.indexOf(ue)))),ve}prioritize(se,ce){const ve=this.f(se);if(ve===-1){this.d.unshift({pattern:se,matches:N.$kk(d(se))});return}const Ie=new Set(ce.map(be=>this.f(be,ve)));Ie.delete(-1);const ue=Array.from(Ie).sort();this.d.splice(ve+1,0,...ue.map(be=>this.d[be]));for(let be=ue.length-1;be>=0;be--)this.d.splice(ue[be],1)}toArray(){return this.d.map(se=>se.pattern)}f(se,ce=this.d.length){const ve=d(se);for(let Ie=0;Ie<ce;Ie++)if(this.d[Ie].matches(ve))return Ie;return-1}}e.$EK=i;function b(K,se,ce,ve=(Ie,ue)=>Ie===ue){const Ie=[];function ue(Pe,Fe,ne){if(Fe===0&&ne.length===0)return;const j=Ie[Ie.length-1];j&&j.start+j.deleteCount===Pe?(j.deleteCount+=Fe,j.toInsert.push(...ne)):Ie.push({start:Pe,deleteCount:Fe,toInsert:ne})}let be=0,ie=0;for(;;){if(be===K.length){ue(be,0,se.slice(ie));break}if(ie===se.length){ue(be,K.length-be,[]);break}const Pe=K[be],Fe=se[ie];if(ve(Pe,Fe)){be+=1,ie+=1;continue}ce(Fe)?(ue(be,1,[]),be+=1):(ue(be,0,[Fe]),ie+=1)}return Ie}e.$GK=new k.$Hj("notebookEditorCursorAtBoundary","none"),e.$HK=new k.$Hj("notebookEditorCursorAtLineBoundary","none");var c;(function(K){K.default="default",K.option="option"})(c||(e.NotebookEditorPriority=c={}));function f(K){const se=K;return!!((typeof se.include=="string"||N.$lk(se.include))&&(typeof se.exclude=="string"||N.$lk(se.exclude)))}function u(K,se,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(se)>=0||K.viewType===se)return!0;if(K.filenamePattern){const ve=f(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ie=f(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(N.$jk(ve,(0,p.$oc)(ce.fsPath).toLowerCase()))return!(Ie&&N.$jk(Ie,(0,p.$oc)(ce.fsPath).toLowerCase()))}return!1}e.$KK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var S;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class h{static{this.d="notebook/"}static create(se){return`${h.d}${se}`}static parse(se){if(se.startsWith(h.d))return se.substring(h.d.length)}}e.$LK=h;function E(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const g=new TextDecoder;function D(K){const se=[];let ce=!1;for(const be of K)(se.length===0||ce)&&(se.push(be),ce=!0);let ve=P(se);const Ie=I.$Ce.concat(se.map(be=>I.$Ce.wrap(be))),ue=U(Ie);return ve=ve||ue.byteLength!==Ie.byteLength,{data:ue,didCompression:ve}}e.$OK="\x1B[A";const w=e.$OK.split("").map(K=>K.charCodeAt(0)),C=10;function P(K){let se=!1;return K.forEach((ce,ve)=>{if(ve===0||ce.length<e.$OK.length)return;const Ie=K[ve-1],ue=ce.subarray(0,e.$OK.length);if(ue[0]===w[0]&&ue[1]===w[1]&&ue[2]===w[2]){const be=Ie.lastIndexOf(C);if(be===-1)return;se=!0,K[ve-1]=Ie.subarray(0,be),K[ve]=ce.subarray(e.$OK.length)}}),se}function V(K){let se=K;do K=se,se=K.replace(/[^\n]\x08/gm,"");while(se.length<K.length);return K}function W(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const se=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+se.slice(ce.length,se.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,R=13;function U(K){return!K.buffer.includes(q)&&!K.buffer.includes(R)?K:I.$Ce.fromString(W(V(g.decode(K.buffer))))}}),define(Ae[7],Re([1,0,18,14,54,28,69,15,17,2,35,20,44,102,83]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m){"use strict";var s,o,n,r,t,a,d,i,b,c,f,u,S,h,E,g,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$3O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$2O=e.$1O=e.$ZO=e.$YO=e.ChatLocation=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$MO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zO=e.$yO=e.$xO=e.$wO=e.$uO=e.$tO=e.$sO=e.$rO=e.TestRunProfileKind=e.TestResultState=e.$qO=e.$pO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oO=e.NotebookVariablesRequestKind=e.$nO=e.$mO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.ColorThemeKind=e.$fO=e.$eO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dO=e.$cO=e.DebugConsoleMode=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$9N=e.$8N=e.FileChangeType=e.$7N=e.NewSymbolNameTag=e.$6N=e.$5N=e.$4N=e.$3N=e.InlineCompletionTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$PN=e.ConfigurationTarget=e.$ON=e.$NN=e.$MN=e.$LN=e.DocumentPasteTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$EN=e.ViewBadge=e.ProgressLocation=e.$DN=e.$CN=e.TaskScope=e.ShellQuoting=e.$BN=e.$AN=e.$zN=e.TaskPanelKind=e.TaskRevealKind=e.$yN=e.TerminalLocation=e.$xN=e.$wN=e.$vN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$uN=e.$tN=e.$sN=e.$rN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$pN=e.$oN=e.$nN=e.$mN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$lN=e.$kN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.LanguageStatusSeverity=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.CodeActionTriggerKind=e.$$M=e.$0M=e.SymbolTag=e.SymbolKind=e.$9M=e.$8M=e.DocumentHighlightKind=e.$7M=e.$6M=e.$5M=e.$4M=e.DiagnosticSeverity=e.DiagnosticTag=e.$3M=e.$2M=e.FileEditType=e.$1M=e.$ZM=e.$YM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$qN=dt,e.$QN=Q,e.$vO=Rt;function w(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(B,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Ee,...Ke]=te;return Reflect.construct(B,Ke,Ee.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let V=s=class{static from(...F){let te=F;return new s(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$RM=V,e.$RM=V=s=Je([w],V);let W=o=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Ee=1;Ee<F.length;Ee++){const Ke=F[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Ee=1;Ee<F.length;Ee++){const Ke=F[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:te,character:Ee}=F;return typeof te=="number"&&typeof Ee=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,N.$7)("line must be non-negative");if(te<0)throw(0,N.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,N.$7)();let Ee;return typeof F>"u"?Ee=0:typeof F=="number"?Ee=F:(Ee=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),Ee===0&&te===0?this:new o(this.line+Ee,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,N.$7)();let Ee;return typeof F>"u"?Ee=this.line:typeof F=="number"?Ee=F:(Ee=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),Ee===this.line&&te===this.character?this:new o(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$SM=W,e.$SM=W=o=Je([w],W);let q=n=class{static isRange(F){return F instanceof n?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof n)return F;if(this.isRange(F))return new n(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,Ee,Ke){let Ye,ht;if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new W(F,te),ht=new W(Ee,Ke)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),ht=W.of(te)),!Ye||!ht)throw new Error("Invalid arguments");Ye.isBefore(ht)?(this.c=Ye,this.e=ht):(this.c=ht,this.e=Ye)}contains(F){return n.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=W.Max(F.start,this.c),Ee=W.Min(F.end,this.e);if(!te.isAfter(Ee))return new n(te,Ee)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=W.Min(F.start,this.c),Ee=W.Max(F.end,this.end);return new n(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,N.$7)();let Ee;return F?W.isPosition(F)?Ee=F:(Ee=F.start||this.start,te=F.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new n(Ee,te)}toJSON(){return[this.start,this.end]}};e.$TM=q,e.$TM=q=n=Je([w],q);let R=r=class extends q{static isSelection(F){return F instanceof r?!0:F?q.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,Ee,Ke){let Ye,ht;if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new W(F,te),ht=new W(Ee,Ke)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),ht=W.of(te)),!Ye||!ht)throw new Error("Invalid arguments");super(Ye,ht),this.f=Ye,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$UM=R,e.$UM=R=r=Je([w],R);const U=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,N.$7)("connectionToken")};class K{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,Ee){if(typeof F!="string"||F.length===0)throw(0,N.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,N.$7)("port");typeof Ee<"u"&&U(Ee),this.host=F,this.port=Math.round(te),this.connectionToken=Ee}}e.$VM=K;class se{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&U(te)}}e.$WM=se;class ce extends Error{static NotAvailable(F,te){return new ce(F,v.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ce(F,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=v.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(F),this._message=F,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.$XM=ce;var ve;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let ue=t=class{static isTextEdit(F){return F instanceof t?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new t(F,te)}static insert(F,te){return t.replace(new q(F,F),te)}static delete(F){return t.replace(F,"")}static setEndOfLine(F){const te=new t(new q(new W(0,0),new W(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,N.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,N.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,N.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$YM=ue,e.$YM=ue=t=Je([w],ue);let be=a=class{static isNotebookCellEdit(F){return F instanceof a?!0:F?xe.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new a(F,te)}static insertCells(F,te){return new a(new xe(F,F),te)}static deleteCells(F){return new a(F,[])}static updateCellMetadata(F,te){const Ee=new a(new xe(F,F),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(F){const te=new a(new xe(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$ZM=be,e.$ZM=be=a=Je([w],be);class ie{static isSnippetTextEdit(F){return F instanceof ie?!0:F?q.isRange(F.range)&&ne.isSnippetString(F.snippet):!1}static replace(F,te){return new ie(F,te)}static insert(F,te){return ie.replace(new q(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$1M=ie;var Pe;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Pe||(e.FileEditType=Pe={}));let Fe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,Ee,Ke){this.c.push({_type:1,from:F,to:te,options:Ee,metadata:Ke})}createFile(F,te,Ee){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:Ee})}deleteFile(F,te,Ee){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:Ee})}e(F,te,Ee){this.c.push({_type:3,metadata:Ee,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,Ee,Ke){const Ye=te.start,ht=te.end;(Ye!==ht||Ee.length>0)&&this.c.push({_type:5,uri:F,index:Ye,count:ht-Ye,cells:Ee,metadata:Ke})}g(F,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:F,edit:{editType:3,index:te,metadata:Ee}})}replace(F,te,Ee,Ke){this.c.push({_type:2,uri:F,edit:new ue(te,Ee),metadata:Ke})}insert(F,te,Ee,Ke){this.replace(F,new q(te,te),Ee,Ke)}delete(F,te,Ee){this.replace(F,te,"",Ee)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,Ye;Array.isArray(Ee)?(Ke=Ee[0],Ye=Ee[1]):Ke=Ee,be.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(F,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(F,Ke.newNotebookMetadata,Ye):this.f(F,Ke.range,Ke.newCells,Ye):ie.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:F,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:F,edit:Ke,metadata:Ye})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===F.toString()&&(this.c[Ee]=void 0);break}}(0,I.$Ib)(this.c)}}get(F){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===F.toString()&&te.push(Ee.edit);return te}entries(){const F=new O.$Bc;for(const te of this.c)if(te._type===2){let Ee=F.get(te.uri);Ee||(Ee=[te.uri,[]],F.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$2M=Fe,e.$2M=Fe=Je([w],Fe);let ne=d=class{static isSnippetString(F){return F instanceof d?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=d.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const Ee=new d;Ee.e=this.e,F(Ee),this.e=Ee.e,F=Ee.value}else F=d.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const Ee=F.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const Ee=new d;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$3M=ne,e.$3M=ne=d=Je([w],ne);var j;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(j||(e.DiagnosticTag=j={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let pe=i=class{static isLocation(F){return F instanceof i?!0:F?q.isRange(F.range)&&k.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(q.isRange(te))this.range=q.of(te);else if(W.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$4M=pe,e.$4M=pe=i=Je([w],pe);let Oe=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&k.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$5M=Oe,e.$5M=Oe=Je([w],Oe);let ke=class{constructor(F,te,Ee=x.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,I.$ub)(F.tags,te.tags)&&(0,I.$ub)(F.relatedInformation,te.relatedInformation,Oe.isEqual)}};e.$6M=ke,e.$6M=ke=Je([w],ke);let $e=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$7M=$e,e.$7M=$e=Je([w],$e);var ge;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let J=class{constructor(F,te=ge.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$8M=J,e.$8M=J=Je([w],J);let Y=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$9M=Y,e.$9M=Y=Je([w],Y);var he;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var le;(function(B){B[B.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let Ne=b=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,Ee,Ke,Ye){this.name=F,this.kind=te,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof pe?this.location=Ke:Ee instanceof q&&(this.location=new pe(Ke,Ee)),b.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$0M=Ne,e.$0M=Ne=b=Je([w],Ne);let de=c=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(c.validate)}constructor(F,te,Ee,Ke,Ye){this.name=F,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=Ye,this.children=[],c.validate(this)}};e.$$M=de,e.$$M=de=c=Je([w],de);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Me=class{constructor(F,te){this.title=F,this.kind=te}};e.$_M=Me,e.$_M=Me=Je([w],Me);let ze=class{static{f=this}static{this.c="."}constructor(F){this.value=F}append(F){return new f(this.value?this.value+f.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+f.c)}};e.$aN=ze,e.$aN=ze=f=Je([w],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let z=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$bN=z,e.$bN=z=Je([w],z);class L{constructor(F,te,Ee,Ke,Ye,ht){this.kind=F,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=ht}}e.$cN=L;class G{constructor(F,te){this.fromRanges=te,this.from=F}}e.$dN=G;class H{constructor(F,te){this.fromRanges=te,this.to=F}}e.$eN=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let re=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$fN=re,e.$fN=re=Je([w],re);let Te=u=class{#e;static isMarkdownString(F){return F instanceof u?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new A.$Nk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$gN=Te,e.$gN=Te=u=Je([w],Te);let Be=class{constructor(F,te){this.label=F,this.documentation=te}};e.$hN=Be,e.$hN=Be=Je([w],Be);let Qe=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$iN=Qe,e.$iN=Qe=Je([w],Qe);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$jN=_e,e.$jN=_e=Je([w],_e);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let it=class{constructor(F){this.value=F}};e.$kN=it,e.$kN=it=Je([w],it);let nt=class{constructor(F,te,Ee){this.position=F,this.label=te,this.kind=Ee}};e.$lN=nt,e.$lN=nt=Je([w],nt);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var mt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(mt||(e.CompletionItemKind=mt={}));var je;(function(B){B[B.Deprecated=1]="Deprecated"})(je||(e.CompletionItemTag=je={}));let st=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&mt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$mN=st,e.$mN=st=Je([w],st);let X=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$nN=X,e.$nN=X=Je([w],X);let Z=class{constructor(F,te,Ee){this.insertText=F,this.range=te,this.command=Ee}};e.$oN=Z,e.$oN=Z=Je([w],Z);let me=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$pN=me,e.$pN=me=Je([w],me);var He;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(He||(e.PartialAcceptTriggerKind=He={}));var ye;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ye||(e.ViewColumn=ye={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,F){return`${y.$Lm.toKey(B)}.${F}`}var It;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(It||(e.TextEditorLineNumbersStyle=It={}));var Qt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var Ut;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var xt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Pt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Pt||(e.DecorationRangeBehavior=Pt={})),function(B){function F(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(xt||(e.TextEditorSelectionChangeKind=xt={}));var Vt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(B){function F(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=F}(Vt||(e.SyntaxTokenType=Vt={}));let Zt=class{constructor(F,te){if(te&&!k.URI.isUri(te))throw(0,N.$7)("target");if(!q.isRange(F)||F.isEmpty)throw(0,N.$7)("range");this.range=F,this.target=te}};e.$rN=Zt,e.$rN=Zt=Je([w],Zt);let Xe=class{constructor(F,te,Ee,Ke){this.red=F,this.green=te,this.blue=Ee,this.alpha=Ke}};e.$sN=Xe,e.$sN=Xe=Je([w],Xe);let si=class{constructor(F,te){if(te&&!(te instanceof Xe))throw(0,N.$7)("color");if(!q.isRange(F)||F.isEmpty)throw(0,N.$7)("range");this.range=F,this.color=te}};e.$tN=si,e.$tN=si=Je([w],si);let Xt=class{constructor(F){if(!F||typeof F!="string")throw(0,N.$7)("label");this.label=F}};e.$uN=Xt,e.$uN=Xt=Je([w],Xt);var lt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(lt||(e.ColorFormat=lt={}));var vt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(vt||(e.SourceControlInputBoxValidationType=vt={}));var ti;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Yt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(Yt||(e.TerminalShellExecutionCommandLineConfidence=Yt={}));class Lt{constructor(F,te,Ee){if(this.startIndex=F,this.length=te,this.tooltip=Ee,typeof F!="number"||F<0)throw(0,N.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,N.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,N.$7)("tooltip")}}e.$vN=Lt;class ft{constructor(F){this.uri=F}}e.$wN=ft;class jt{constructor(F){this.terminalCommand=F}}e.$xN=jt;var Bt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Bt||(e.TerminalLocation=Bt={}));class qt{constructor(F){if(this.options=F,typeof F!="object")throw(0,N.$7)("options")}}e.$yN=qt;var Ge;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ge||(e.TaskRevealKind=Ge={}));var ui;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Ht=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(F){switch(F){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,N.$7)("name");this.c=F}get id(){return this.c}};e.$zN=Ht,e.$zN=Ht=S=Je([w],Ht);function zt(B){let F="";for(let te=0;te<B.length;te++)F+=B[te].replace(/,/g,",,")+",";return F}let gt=class{constructor(F,te,Ee){if(typeof F!="string")throw(0,N.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,N.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return zt(F)}};e.$AN=gt,e.$AN=gt=Je([w],gt);let Tt=class{constructor(F,te,Ee){if(this.f=[],Array.isArray(te)){if(!F)throw(0,N.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,N.$7)("command");this.e=F,this.f=te,this.g=Ee}else{if(typeof F!="string")throw(0,N.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,N.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,N.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return zt(F)}};e.$BN=Tt,e.$BN=Tt=Je([w],Tt);var At;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(At||(e.ShellQuoting=At={}));var Ot;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ot||(e.TaskScope=Ot={}));class ii{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.$Mg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$CN=ii;let Gt=class{static{h=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,Ee,Ke,Ye,ht){this.k=!1,this.l=this.definition=F;let $t;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ke,$t=Ye,this.k=!0):te===Ot.Global||te===Ot.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,$t=ht):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,$t=ht),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof gt?this.l={type:h.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:h.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:h.c,id:this.q.computeId()}:this.l={type:h.g,id:(0,T.$Mg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,N.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(h.g===te||h.e===te||h.f===te||h.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$DN=Gt,e.$DN=Gt=h=Je([w],Gt);var ni;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Mt;(function(B){function F(te){const Ee=te;return(0,$.$8f)(Ee.value)?Ee.tooltip&&!(0,$.$4f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}B.isViewBadge=F})(Mt||(e.ViewBadge=Mt={}));let Nt=E=class{static isTreeItem(F,te){const Ee=F;if(Ee.checkboxState!==void 0){const Ke=(0,$.$8f)(Ee.checkboxState)?Ee.checkboxState:(0,$.$6f)(Ee.checkboxState)&&(0,$.$8f)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,$.$8f)(Ee.checkboxState)&&(0,$.$6f)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Et.Checked&&Ke!==Et.Unchecked||Ye!==void 0&&!(0,$.$4f)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(F instanceof E)return!0;if(Ee.label!==void 0&&!(0,$.$4f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,$.$4f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,$.$4f)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,$.$4f)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,$.$4f)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,$.$4f)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,$.$4f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,$.$4f)(Ee.tooltip)&&!(Ee.tooltip instanceof Te)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<Ct.None&&Ee.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,$.$4f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(F,te=Ct.None){this.collapsibleState=te,k.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$EN=Nt,e.$EN=Nt=E=Je([w],Nt);var Ct;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Ct||(e.TreeItemCollapsibleState=Ct={}));var Et;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$FN=pt,e.$FN=pt=Je([w],pt);class St extends pt{}e.$GN=St;class li extends St{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$HN=li;class Dt{constructor(F,te,Ee,Ke){this.name=F,this.uri=te,this._itemId=Ee,this.c=Ke}data(){return this.c()}}e.$IN=Dt;let hi=class{#e=new Map;constructor(F){for(const[te,Ee]of F??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[Ee,Ke]of this.#e)for(const Ye of Ke)F.call(te,Ye,Ee,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const Ee of te)yield[F,Ee]}#t(F){return F.toLowerCase()}};e.$JN=hi,e.$JN=hi=Je([w],hi);let Kt=class{constructor(F,te,Ee){this.insertText=F,this.title=te,this.kind=Ee}};e.$KN=Kt,e.$KN=Kt=Je([w],Kt);var vi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class ei{static{this.c="."}constructor(F){this.value=F}append(...F){return new ei((this.value?[this.value,...F]:F).join(ei.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+ei.c)}}e.$LN=ei,ei.Empty=new ei("");class wi{constructor(F,te,Ee){this.title=te,this.insertText=F,this.kind=Ee}}e.$MN=wi;let yt=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$NN=yt,e.$NN=yt=Je([w],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let $i=class{constructor(F){this.id=F}};e.$ON=$i,e.$ON=$i=Je([w],$i);var we;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(we||(e.ConfigurationTarget=we={}));let Se=class{get base(){return this.c}set base(F){this.c=F,this.e=k.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!k.URI.isUri(F)&&!k.URI.isUri(F.uri)))throw(0,N.$7)("base");if(typeof te!="string")throw(0,N.$7)("pattern");typeof F=="string"?this.baseUri=k.URI.file(F):k.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PN=Se,e.$PN=Se=Je([w],Se);const ae=new WeakMap;function Q(B,F){ae.set(B,F)}let De=class{constructor(F,te,Ee,Ke,Ye){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=ae.get(this)??(0,T.$Mg)()),this.c}};e.$RN=De,e.$RN=De=Je([w],De);let We=class extends De{constructor(F,te,Ee,Ke,Ye,ht){if(super(te,Ee,Ke,Ye,ht),F===null)throw(0,N.$7)("location");this.location=F}};e.$SN=We,e.$SN=We=Je([w],We);let Ze=class extends De{constructor(F,te,Ee,Ke,Ye,ht){super(te,Ee,Ke,Ye,ht),this.functionName=F}};e.$TN=Ze,e.$TN=Ze=Je([w],Ze);let qe=class extends De{constructor(F,te,Ee,Ke,Ye,ht,$t,Jt){if(super(Ke,Ye,ht,$t,Jt),!te)throw(0,N.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=Ee}};e.$UN=qe,e.$UN=qe=Je([w],qe);let ut=class{constructor(F,te,Ee){this.command=F,this.args=te||[],this.options=Ee}};e.$VN=ut,e.$VN=ut=Je([w],ut);let kt=class{constructor(F,te){this.port=F,this.host=te}};e.$WN=kt,e.$WN=kt=Je([w],kt);let Ft=class{constructor(F){this.path=F}};e.$XN=Ft,e.$XN=Ft=Je([w],Ft);let Wt=class{constructor(F){this.implementation=F}};e.$YN=Wt,e.$YN=Wt=Je([w],Wt);class ct{constructor(F,te,Ee){this.session=F,this.threadId=te,this.frameId=Ee}}e.$ZN=ct;class ri{constructor(F,te){this.session=F,this.threadId=te}}e.$1N=ri;let di=class{constructor(F,te){this.range=F,this.expression=te}};e.$2N=di,e.$2N=di=Je([w],di);var pi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let Si=class{constructor(F,te){this.range=F,this.text=te}};e.$3N=Si,e.$3N=Si=Je([w],Si);let Ri=class{constructor(F,te,Ee=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$4N=Ri,e.$4N=Ri=Je([w],Ri);let Mi=class{constructor(F,te){this.range=F,this.expression=te}};e.$5N=Mi,e.$5N=Mi=Je([w],Mi);let Ni=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$6N=Ni,e.$6N=Ni=Je([w],Ni);var Ti;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ti||(e.NewSymbolNameTag=Ti={}));class cn{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$7N=cn;var Oi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Fi=g=class extends Error{static FileExists(F){return new g(F,l.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(F){return new g(F,l.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(F){return new g(F,l.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(F){return new g(F,l.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(F){return new g(F,l.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(F){return new g(F,l.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(F,te=l.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(F)?F.toString(!0):F),this.code=Ee?.name??"Unknown",(0,l.$_k)(this,te),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$8N=Fi,e.$8N=Fi=g=Je([w],Fi);let yi=class{constructor(F,te,Ee){this.start=F,this.end=te,this.kind=Ee}};e.$9N=yi,e.$9N=yi=Je([w],yi);var Ii;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var Gi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Gi||(e.CommentThreadCollapsibleState=Gi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var bi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(bi||(e.CommentState=bi={}));var Ji;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Qi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$0N=un;function Li(B){return typeof B>"u"||(0,$.$5f)(B)}class zi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,Ee=F.tokenTypes.length;te<Ee;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,Ee=F.tokenModifiers.length;te<Ee;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,Ee,Ke,Ye){if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(F,te,Ee,Ke,Ye);if(q.isRange(F)&&typeof te=="string"&&Li(Ee))return this.o(F,te,Ee);throw(0,N.$7)()}o(F,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=F.start.line,Ye=F.start.character,ht=F.end.character-F.start.character,$t=this.k.get(te);let Jt=0;if(Ee)for(const ci of Ee){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Jt|=1<<fi>>>0}this.q(Ke,Ye,ht,$t,Jt)}q(F,te,Ee,Ke,Ye){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Jt;gi++){let mi=this.g[5*gi],qi=this.g[5*gi+1];mi===0?(mi=ci,qi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=qi,ci=mi,fi=qi}}let ht=F,$t=te;this.f&&this.j>0&&(ht-=this.c,ht===0&&($t-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=$t,this.g[this.j++]=Ee,this.g[this.j++]=Ke,this.g[this.j++]=Ye,this.c=F,this.e=te}static r(F){const te=[],Ee=F.length/5|0;for(let $t=0;$t<Ee;$t++)te[$t]=$t;te.sort(($t,Jt)=>{const ci=F[5*$t],fi=F[5*Jt];if(ci===fi){const gi=F[5*$t+1],mi=F[5*Jt+1];return gi-mi}return ci-fi});const Ke=new Uint32Array(F.length);let Ye=0,ht=0;for(let $t=0;$t<Ee;$t++){const Jt=5*te[$t],ci=F[Jt+0],fi=F[Jt+1],gi=F[Jt+2],mi=F[Jt+3],qi=F[Jt+4],Mn=ci-Ye,ur=Mn===0?fi-ht:fi,Hi=5*$t;Ke[Hi+0]=Mn,Ke[Hi+1]=ur,Ke[Hi+2]=gi,Ke[Hi+3]=mi,Ke[Hi+4]=qi,Ye=ci,ht=fi}return Ke}build(F){return this.f?new Pi(new Uint32Array(this.g),F):new Pi(zi.r(this.g),F)}}e.$$N=zi;class Pi{constructor(F,te){this.resultId=te,this.data=F}}e.$_N=Pi;class ln{constructor(F,te,Ee){this.start=F,this.deleteCount=te,this.data=Ee}}e.$aO=ln;class Zi{constructor(F,te){this.resultId=te,this.edits=F}}e.$bO=Zi;var Xi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));class hn{constructor(F){this.name=F}}e.$cO=hn;let Ui=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$dO=Ui,e.$dO=Ui=Je([w],Ui);var Yi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Ci;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Ci||(e.InputBoxValidationSeverity=Ci={}));var ji;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(ji||(e.ExtensionKind=ji={}));class Ue{static validate(F){if(typeof F.badge=="string"){let te=(0,p.$Df)(F.badge,0);if(te<F.badge.length&&(te+=(0,p.$Df)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!yt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,Ee){this.badge=F,this.tooltip=te,this.color=Ee}}e.$eO=Ue;let oi=class{constructor(F){this.kind=F}};e.$fO=oi,e.$fO=oi=Je([w],oi);var Bi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Bi||(e.ColorThemeKind=Bi={}));class xe{static isNotebookRange(F){return F instanceof xe?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,N.$7)("start must be positive");if(te<0)throw(0,N.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,Ee=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(Ee=F.end),te===this.c&&Ee===this.e?this:new xe(te,Ee)}}e.$gO=xe;class bt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>bt.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,Ee,Ke,Ye,ht,$t){this.kind=F,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=Ye??[],this.metadata=ht,this.executionSummary=$t,bt.validate(this)}}e.$hO=bt;class dn{constructor(F){this.cells=F}}e.$iO=dn;class ai{static isNotebookCellOutputItem(F){return F instanceof ai?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ai.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ai.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ai.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ai(F,te)}static#e=new TextEncoder;static text(F,te=M.$Hs.text){const Ee=ai.#e.encode(String(F));return new ai(Ee,te)}static json(F,te="text/x-json"){const Ee=JSON.stringify(F,void 0,"	");return ai.text(Ee,te)}constructor(F,te){this.data=F,this.mime=te;const Ee=(0,M.$Ls)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$jO=ai;class ki{static isNotebookCellOutput(F){return F instanceof ki?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const Ee=new Set,Ke=new Set;for(let Ye=0;Ye<F.length;Ye++){const ht=F[Ye],$t=(0,M.$Ls)(ht.mime);if(!Ee.has($t)||(0,m.$MK)($t)){Ee.add($t);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ke.size===0?F:F.filter((Ye,ht)=>!Ke.has(ht))}constructor(F,te,Ee){this.items=ki.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,T.$Mg)(),this.metadata=te??Ee)}}e.$kO=ki;var xi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Ei;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var _i;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(F,te){this.text=F,this.alignment=te}}e.$lO=fn;var Wi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(F,te=[]){this.uri=F,this.provides=(0,I.$3b)(te)}}e.$mO=gn;class mn{constructor(F){this.label=F}}e.$nO=mn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Vi=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$oO=Vi,e.$oO=Vi=Je([w],Vi);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$pO=$n;class pn{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$qO=pn;var an;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var _;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(_||(e.TestRunProfileKind=_={}));let oe=class{constructor(F=void 0,te=void 0,Ee=void 0,Ke=!1){this.include=F,this.exclude=te,this.profile=Ee,this.continuous=Ke}};e.$rO=oe,e.$rO=oe=Je([w],oe);let Le=D=class{static diff(F,te,Ee){const Ke=new D(F);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(F){this.message=F}};e.$sO=Le,e.$sO=Le=D=Je([w],Le);let rt=class{constructor(F){this.id=F}};e.$tO=rt,e.$tO=rt=Je([w],rt);class wt{constructor(F,te){this.covered=F,this.total=te,Rt(this)}}e.$uO=wt;function Rt(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class Di{static fromDetails(F,te){const Ee=new wt(0,0),Ke=new wt(0,0),Ye=new wt(0,0);for(const $t of te)if("branches"in $t){Ee.total+=1,Ee.covered+=$t.executed?1:0;for(const Jt of $t.branches)Ke.total+=1,Ke.covered+=Jt.executed?1:0}else Ye.total+=1,Ye.covered+=$t.executed?1:0;const ht=new Di(F,Ee,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ht.detailedCoverage=te,ht}constructor(F,te,Ee,Ke){this.uri=F,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ke}}e.$wO=Di;class Nn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee=[]){this.executed=F,this.location=te,this.branches=Ee}}e.$xO=Nn;class Tn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee){this.executed=F,this.location=te,this.label=Ee}}e.$yO=Tn;class On{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee){this.name=F,this.executed=te,this.location=Ee}}e.$zO=On;var bn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var vn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var wn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn||(e.PortAutoForwardAction=wn={}));class Fn{constructor(F,te,Ee,Ke,Ye,ht){this.kind=F,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=ht}}e.$AO=Fn;class Ln{constructor(F){this.uri=F}}e.$BO=Ln;class zn{constructor(F,te){this.original=F,this.modified=te}}e.$CO=zn;class Un{constructor(F,te,Ee,Ke){this.base=F,this.input1=te,this.input2=Ee,this.result=Ke}}e.$DO=Un;class jn{constructor(F,te){this.uri=F,this.viewType=te}}e.$EO=jn;class Bn{constructor(F){this.viewType=F}}e.$FO=Bn;class Wn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$GO=Wn;class Vn{constructor(F,te,Ee){this.original=F,this.modified=te,this.notebookType=Ee}}e.$HO=Vn;class qn{constructor(){}}e.$IO=qn;class Hn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$JO=Hn;class Gn{constructor(){}}e.$KO=Gn;class Kn{constructor(F){this.textDiffs=F}}e.$LO=Kn;var yn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Jn{constructor(F,te){this.label=F,this.values=te}}e.$MO=Jn;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Qn{constructor(F){this.value=typeof F=="string"?new Te(F):F}}e.$NO=Qn;class Zn{constructor(F,te){this.value=typeof F=="string"?new Te(F):F,this.vulnerabilities=te}}e.$OO=Zn;class Xn{constructor(F,te){this.participant=F,this.command=te}}e.$PO=Xn;class Yn{constructor(F,te){this.value=F,this.baseUri=te}}e.$QO=Yn;class xn{constructor(F,te){this.value=F,this.title=te}}e.$RO=xn;class _n{constructor(F){this.value=F}}e.$SO=_n;class er{constructor(F){this.value=F}}e.$TO=er;class tr{constructor(F){this.value=F}}e.$UO=tr;class ir{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$VO=ir;class nr{constructor(F,te,Ee,Ke){this.prompt=F,this.command=te,this.variables=Ee,this.participant=Ke}}e.$WO=nr;class rr{constructor(F,te,Ee,Ke){this.response=F,this.result=te,this.participant=Ee,this.command=Ke}}e.$XO=rr;var In;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class sr{constructor(F){this.content=F}}e.$YO=sr;class or{constructor(F,te){this.content=F,this.name=te}}e.$ZO=or;class ar{constructor(F,te){this.content=F,this.name=te}}e.$1O=ar;class Ai extends Error{static NotFound(F){return new Ai(F,Ai.NotFound.name)}static NoPermissions(F){return new Ai(F,Ai.NoPermissions.name)}constructor(F,te,Ee){super(F,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$2O=Ai;var Pn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var Cn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Cn||(e.SpeechToTextStatus=Cn={}));var An;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class cr{constructor(F,te){this.text=F,this.range=te}}e.$3O=cr;var Rn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(Ae[247],Re([1,0,4,7]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class A{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$PM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,$){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(M);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(p,$)??[]}getRelatedInformation(M,p,$){return this.c.$getAiRelatedInformation(p,$)}registerRelatedInformationProvider(M,p,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiRelatedInformationProvider(k,p),new N.$RM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$ekc=A}),define(Ae[84],Re([1,0,5,4,7,20,106,3,16]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0,e.$pkc=(0,p.$qi)("IExtHostAuthentication");let k=class{constructor(l){this.b=new Map,this.c=new I.$be,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=l.getProxy(N.$PM.MainThreadAuthentication)}async getSession(l,v,m,s={}){const o=O.$Lm.toKey(l.identifier),n=[...m].sort().join(" ");return await this.d.getOrCreate(`${o} ${v} ${n}`,async()=>{await this.a.$ensureProvider(v);const r=l.displayName||l.name;return this.a.$getSession(v,m,o,r,s)})}async getSessions(l,v,m){const s=O.$Lm.toKey(l.identifier),o=[...m].sort().join(" ");return await this.f.getOrCreate(`${s} ${o}`,async()=>{await this.a.$ensureProvider(v);const n=l.displayName||l.name;return this.a.$getSessions(v,m,s,n)})}async removeSession(l,v){const m=this.b.get(l);return m?m.provider.removeSession(v):this.a.$removeSession(l,v)}registerAuthenticationProvider(l,v,m,s){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:v,provider:m,options:s??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(n=>this.a.$sendDidChangeSessions(l,n));return this.a.$registerAuthenticationProvider(l,v,s?.supportsMultipleAccounts??!1),new A.$RM(()=>{o.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}$createSession(l,v,m){const s=this.b.get(l);if(s)return Promise.resolve(s.provider.createSession(v,m));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$removeSession(l,v){const m=this.b.get(l);if(m)return Promise.resolve(m.provider.removeSession(v));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$getSessions(l,v){const m=this.b.get(l);if(m)return Promise.resolve(m.provider.getSessions(v));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,v){return l.startsWith(M.$RL)||this.c.fire({provider:{id:l,label:v}}),Promise.resolve()}};e.$qkc=k,e.$qkc=k=Je([Ve(0,$.$cP)],k);class T{constructor(){this.a=new Map}getOrCreate(l,v){const m=this.a.get(l);if(m)return m;const s=v().finally(()=>this.a.delete(l));return this.a.set(l,s),s}}}),define(Ae[110],Re([1,0,2,4,7,3,16,13,18,15,19,25]),function(fe,e,I,N,A,O,M,p,$,k,T,y){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=e.$plc=void 0;let v=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,o){this.h=o,this.f=new Map,this.g=s.getProxy(N.$PM.MainThreadDecorations)}registerFileDecorationProvider(s,o){const n=l.c++;this.f.set(n,{provider:s,extensionDescription:o}),this.g.$registerDecorationProvider(n,o.identifier.value);const r=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(n,null);return}const a=(0,$.$3b)(t);if(a.length<=l.d){this.g.$onDidChange(n,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const d=a.map(c=>({uri:c,rank:(0,k.$9e)(c.path,"/")})),i=(0,$.$zb)(d,(c,f)=>c.rank-f.rank||(0,k.$mf)(c.uri.path,f.uri.path)),b=[];e:for(const c of i){let f;for(const u of c){const S=(0,T.$nc)(u.uri.path);if(f!==S&&(f=S,b.push(u.uri)>=l.d))break e}}this.g.$onDidChange(n,b)});return new A.$RM(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(n),this.f.delete(n)})}async $provideDecorations(s,o,n){if(!this.f.has(s))return Object.create(null);const r=Object.create(null),{provider:t,extensionDescription:a}=this.f.get(s);return await Promise.all(o.map(async d=>{try{const{uri:i,id:b}=d,c=await Promise.resolve(t.provideFileDecoration(I.URI.revive(i),n));if(!c)return;try{A.$eO.validate(c),c.badge&&typeof c.badge!="string"&&(0,y.$yG)(a,"codiconDecoration"),r[b]=[c.propagate,c.tooltip,c.badge,c.color]}catch(f){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${f}`)}}catch(i){this.h.error(i)}})),r}};e.$plc=v,e.$plc=v=l=Je([Ve(0,M.$cP),Ve(1,p.$Wj)],v),e.$qlc=(0,O.$qi)("IExtHostDecorations")}),define(Ae[248],Re([1,0,14,2,7,4,12,22,15]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;class k{static{this.a=0}constructor(y,l,v){this.d=l,this.e=v,this.b=new Map,this.c=y.getProxy(O.$PM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,l){if(Object.keys(M.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const v=k.a++;this.b.set(v,l),this.c.$registerTextContentProvider(v,y);let m;if(typeof l.onDidChange=="function"){let s;m=l.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;s&&await s;const n=this.$provideTextDocumentContent(v,o).then(async r=>{if(!r&&typeof r!="string")return;const t=this.d.getDocument(o);if(!t)return;const a=(0,$.$gf)(r);if(!t.equalLines(a))return this.c.$onVirtualDocumentChange(o,r)}).catch(I.$1).finally(()=>{s===n&&(s=void 0)});s=n})}return new A.$RM(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(y,l){const v=this.b.get(y);return v?Promise.resolve(v.provideTextDocumentContent(N.URI.revive(l),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$slc=k}),define(Ae[111],Re([1,0,56,12,15,303,152,7,18]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0,e.$eP=T;const k=new Map;function T(m,s){s?k.set(m,s):k.delete(m)}function y(m){return k.get(m)}class l extends O.$Pv{constructor(s,o,n,r,t,a,d){super(o,n,r,t),this.c=s,this.m=a,this.q=d,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,$.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===N.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,n){return s.y(o,n)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,I.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,I.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const n=this.g,r=o.start.line,t=o.end.line,a=[];a.push(this.f[r].substring(o.start.character));for(let d=r+1;d<t;d++)a.push(this.f[d]);return a.push(this.f[t].substring(0,o.end.character)),a.join(n)}t(s){let o;if(s instanceof p.$SM?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.f[o],o===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),n=this.f[o.index].length;return new p.$SM(o.index,Math.min(o.remainder,n))}w(s){if(!(s instanceof p.$TM))throw new Error("Invalid argument");const o=this.x(s.start),n=this.x(s.end);return o===s.start&&n===s.end?s:new p.$TM(o.line,o.character,n.line,n.character)}x(s){if(!(s instanceof p.$SM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:o,character:n}=s,r=!1;if(o<0)o=0,n=0,r=!0;else if(o>=this.f.length)o=this.f.length-1,n=this.f[o].length,r=!0;else{const t=this.f[o].length;n<0?(n=0,r=!0):n>t&&(n=t,r=!0)}return r?new p.$SM(o,n):s}y(s,o){const n=this.x(s);if(!o)o=y(this.m);else if((0,A.$ff)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const r=(0,M.$Zs)(n.character+1,(0,M.$Xs)(o),this.f[n.line],0);if(r)return new p.$TM(n.line,r.startColumn-1,n.line,r.endColumn-1)}}e.$fP=l;class v{constructor(s,o,n){this.a=s,this.b=o,this.c=n}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$TM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$TM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$gP=v}),define(Ae[249],Re([1,0,4,7]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class A{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$PM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(M);if(!k)throw new Error("Embedding vector provider not found");const T=await k.provideEmbeddingVector(p,$);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(M,p,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiEmbeddingVectorProvider(p,k),new N.$RM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$ulc=A}),define(Ae[64],Re([1,0,4,44,7,23,3,16,45,6,11,24,12]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=e.$Fkc=void 0;let m=v=class{constructor(o,n){this.b=new Map,this.c=new T.$zh,this.a=o.getProxy(I.$PM.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(t){try{let a;const d=r.b.get(t.scheme);return d?(await r.a.$ensureActivation(t.scheme),a=await d.impl.stat(t)):a=await r.a.$stat(t),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===N.FilePermission.Readonly?1:void 0}}catch(a){v.e(a)}},async readDirectory(t){try{const a=r.b.get(t.scheme);return a?(await r.a.$ensureActivation(t.scheme),(await a.impl.readDirectory(t)).slice()):await r.a.$readdir(t)}catch(a){return v.e(a)}},async createDirectory(t){try{const a=r.b.get(t.scheme);return a&&!a.isReadonly?(await r.a.$ensureActivation(t.scheme),await r.d(a.impl,a.extUri,t)):await r.a.$mkdir(t)}catch(a){return v.e(a)}},async readFile(t){try{const a=r.b.get(t.scheme);return a?(await r.a.$ensureActivation(t.scheme),(await a.impl.readFile(t)).slice()):(await r.a.$readFile(t)).buffer}catch(a){return v.e(a)}},async writeFile(t,a){try{const d=r.b.get(t.scheme);return d&&!d.isReadonly?(await r.a.$ensureActivation(t.scheme),await r.d(d.impl,d.extUri,d.extUri.dirname(t)),await r.c.queueFor(t,()=>Promise.resolve(d.impl.writeFile(t,a,{create:!0,overwrite:!0})))):await r.a.$writeFile(t,O.$Ce.wrap(a))}catch(d){return v.e(d)}},async delete(t,a){try{const d=r.b.get(t.scheme);return d&&!d.isReadonly&&!a?.useTrash?(await r.a.$ensureActivation(t.scheme),await d.impl.delete(t,{recursive:!1,...a})):await r.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(d){return v.e(d)}},async rename(t,a,d){try{return await r.a.$rename(t,a,{overwrite:!1,...d})}catch(i){return v.e(i)}},async copy(t,a,d){try{return await r.a.$copy(t,a,{overwrite:!1,...d})}catch(i){return v.e(i)}},isWritableFileSystem(t){const a=n.getCapabilities(t);if(typeof a=="number")return!(a&2048)}})}async d(o,n,r){const t=[];for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&N.FileType.Directory))throw A.$8N.FileExists(`Unable to create folder '${r.scheme===l.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(N.$al(a)!==N.FileSystemProviderErrorCode.FileNotFound)throw a;t.push(n.basename(r)),r=n.dirname(r)}for(let a=t.length-1;a>=0;a--){r=n.joinPath(r,t[a]);try{await o.createDirectory(r)}catch(d){if(N.$al(d)!==N.FileSystemProviderErrorCode.FileExists)throw d}}}static e(o){if(o instanceof A.$8N)throw o;if(o instanceof N.$9k)switch(o.code){case N.FileSystemProviderErrorCode.FileExists:throw A.$8N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw A.$8N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw A.$8N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw A.$8N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw A.$8N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw A.$8N.Unavailable(o.message);default:throw new A.$8N(o.message,o.name)}if(!(o instanceof Error))throw new A.$8N(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw A.$8N.Unavailable(o.message);switch(o.name){case N.FileSystemProviderErrorCode.FileExists:throw A.$8N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw A.$8N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw A.$8N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw A.$8N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw A.$8N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw A.$8N.Unavailable(o.message);default:throw new A.$8N(o.message,o.name)}}addFileSystemProvider(o,n,r){return this.b.set(o,{impl:n,extUri:r?.isCaseSensitive?y.$Tg:y.$Vg,isReadonly:!!r?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$Tg}};e.$Fkc=m,e.$Fkc=m=v=Je([Ve(0,p.$cP),Ve(1,$.$jkc)],m),e.$Gkc=(0,M.$qi)("IExtHostConsumerFileSystem")}),define(Ae[85],Re([1,0,3,27,13,64,2]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0,e.$Hkc=(0,I.$qi)("IExtensionStoragePaths");let p=class{constructor(k,T,y){this.d=T,this.f=y,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(k){return M.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,T=await this.g(k);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(M.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(k){if(this.c)return M.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return M.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ikc=p,e.$Ikc=p=Je([Ve(0,N.$sP),Ve(1,A.$Wj),Ve(2,O.$Gkc)],p)}),define(Ae[250],Re([1,0,7,16,5]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;let O=class{constructor(p){this.a=new I.$fO(I.ColorThemeKind.Dark),this.b=new A.$be}get activeColorTheme(){return this.a}$onColorThemeChange(p){let $;switch(p){case"light":$=I.ColorThemeKind.Light;break;case"hcDark":$=I.ColorThemeKind.HighContrast;break;case"hcLight":$=I.ColorThemeKind.HighContrastLight;break;default:$=I.ColorThemeKind.Dark}this.a=new I.$fO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$dmc=O,e.$dmc=O=Je([Ve(0,N.$cP)],O)}),define(Ae[86],Re([1,0,22,5,6,174,3,13,204,4,27,16,7]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BCb=e.$ACb=e.TunnelDtoConverter=void 0;class v extends $.$cw{}var m;(function(o){function n(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:t.protocol}}o.fromApiTunnel=n;function r(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==$.TunnelPrivacyId.ConstantPrivate&&t.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}o.fromServiceTunnel=r})(m||(e.TunnelDtoConverter=m={})),e.$ACb=(0,M.$qi)("IExtHostTunnelService");let s=class extends A.$Uc{constructor(n,r,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=n.getProxy(k.$PM.MainThreadTunnelService)}async openTunnel(n,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const t=await this.a.$openTunnel(r,n.displayName);if(t){const a=new v(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(n,r){n.portRange===void 0&&n.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:n,provider:r}),this.a.$registerPortsAttributesProvider(n,t),new l.$RM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(n,r,t,a,d){const i=[];for(const c of n){const f=this.r.get(c);if(!f)return[];i.push(...await Promise.all(r.map(async u=>{let S;try{S=await f.provider.providePortAttributes({port:u,pid:t,commandLine:a},d)}catch{S=await f.provider.providePortAttributes(u,t,a,d)}return{providedAttributes:S,port:u}})))}const b=i.filter(c=>!!c.providedAttributes);return b.length>0?b.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(n){}registerTunnelProvider(n,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,d)=>await n.provideTunnel(a,d,I.CancellationToken.None)??void 0;const t=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions,protocol:r.tunnelFeatures.protocol===void 0?!0:r.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,A.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(n,r){if(n){n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.f=n.showCandidatePort,this.a.$setCandidateFilter());const t=n.tunnelFactory??(r?this.w(r):void 0);if(t){this.b=t;let a=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const d=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(d)}}else this.b=void 0;return(0,A.$Sc)(()=>{this.b=void 0})}w(n){}async $closeTunnel(n,r){if(this.g.has(n.host)){const t=this.g.get(n.host);t.has(n.port)&&(r&&t.get(n.port).disposeListener.dispose(),await t.get(n.port).tunnel.dispose(),t.delete(n.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(n,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(n,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const a=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(n.remoteAddress.host)||this.g.set(n.remoteAddress.host,new Map);const d=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:a,disposeListener:d}),m.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(n){const r=await Promise.all(n.map(a=>this.f(a.host,a.port,a.detail??""))),t=n.filter((a,d)=>r[d]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(a=>a.port).join(", ")} to ${t.map(a=>a.port).join(", ")}`),t}};e.$BCb=s,e.$BCb=s=Je([Ve(0,y.$cP),Ve(1,T.$sP),Ve(2,p.$Wj)],s)}),define(Ae[8],Re([1,0,18,23,132,251,54,28,124,53,69,26,127,24,17,2,29,87,100,105,104,214,83,50,61,225,7]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a,d,i,b,c,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$_O=U,e.$aP=se,e.$bP=ce;var S;(function(we){function Se(Q){const{selectionStartLineNumber:De,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:qe}=Q,ut=new u.$SM(De-1,We-1),kt=new u.$SM(Ze-1,qe-1);return new u.$UM(ut,kt)}we.to=Se;function ae(Q){const{anchor:De,active:We}=Q;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}we.from=ae})(S||(e.Selection=S={}));var h;(function(we){function Se(Q){if(!Q)return;const{start:De,end:We}=Q;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}we.from=Se;function ae(Q){if(!Q)return;const{startLineNumber:De,startColumn:We,endLineNumber:Ze,endColumn:qe}=Q;return new u.$TM(De-1,We-1,Ze-1,qe-1)}we.to=ae})(h||(e.Range=h={}));var E;(function(we){function Se(Q){return{uri:Q.uri,range:h.from(Q.range)}}we.from=Se;function ae(Q){return new u.$4M(s.URI.revive(Q.uri),h.to(Q.range))}we.to=ae})(E||(e.Location=E={}));var g;(function(we){function Se(ae){switch(ae){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}we.to=Se})(g||(e.TokenType=g={}));var D;(function(we){function Se(Q){return new u.$SM(Q.lineNumber-1,Q.column-1)}we.to=Se;function ae(Q){return{lineNumber:Q.line+1,column:Q.character+1}}we.from=ae})(D||(e.Position=D={}));var w;(function(we){function Se(De,We,Ze){return(0,I.$Hb)((0,I.$3b)(De).map(qe=>ae(qe,We,Ze)))}we.from=Se;function ae(De,We,Ze){if(typeof De=="string")return{$serialized:!0,language:De,isBuiltin:Ze?.isBuiltin};if(De)return{$serialized:!0,language:De.language,scheme:Q(De.scheme,We),pattern:Z.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType,isBuiltin:Ze?.isBuiltin}}function Q(De,We){return We&&typeof De=="string"?We.transformOutgoingScheme(De):De}})(w||(e.DocumentSelector=w={}));var C;(function(we){function Se(Q){switch(Q){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}we.from=Se;function ae(Q){switch(Q){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}we.to=ae})(C||(e.DiagnosticTag=C={}));var P;(function(we){function Se(Q){let De;return Q.code&&((0,m.$4f)(Q.code)||(0,m.$8f)(Q.code)?De=String(Q.code):De={value:String(Q.code.value),target:Q.code.target}),{...h.from(Q.range),message:Q.message,source:Q.source,code:De,severity:W.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(V.from),tags:Array.isArray(Q.tags)?(0,I.$Hb)(Q.tags.map(C.from)):void 0}}we.from=Se;function ae(Q){const De=new u.$6M(h.to(Q),Q.message,W.to(Q.severity));return De.source=Q.source,De.code=(0,m.$4f)(Q.code)?Q.code:Q.code?.value,De.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(V.to),De.tags=Q.tags&&(0,I.$Hb)(Q.tags.map(C.to)),De}we.to=ae})(P||(e.Diagnostic=P={}));var V;(function(we){function Se(Q){return{...h.from(Q.location.range),message:Q.message,resource:Q.location.uri}}we.from=Se;function ae(Q){return new u.$5M(new u.$4M(Q.resource,h.to(Q)),Q.message)}we.to=ae})(V||(e.DiagnosticRelatedInformation=V={}));var W;(function(we){function Se(Q){switch(Q){case u.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}we.from=Se;function ae(Q){switch(Q){case r.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}we.to=ae})(W||(e.DiagnosticSeverity=W={}));var q;(function(we){function Se(Q){return typeof Q=="number"&&Q>=u.ViewColumn.One?Q-1:Q===u.ViewColumn.Beside?f.$OD:f.$ND}we.from=Se;function ae(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ae})(q||(e.ViewColumn=q={}));function R(we){return typeof we.range<"u"}function U(we){return we.length===0?!0:!!R(we[0])}var K;(function(we){function Se(qe){return qe.map(we.from)}we.fromMany=Se;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let ut;if(ae(qe)){const{language:ct,value:ri}=qe;ut={value:"```"+ct+`
`+ri+"\n```\n"}}else u.$gN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Ft=ct=>{try{let ri=s.URI.parse(ct,!0);ri=ri.with({query:De(ri.query,kt)}),kt[ct]=ri}catch{}return""},Wt=new $.marked.Renderer;return Wt.link=Ft,Wt.image=ct=>typeof ct=="string"?Ft(M.$Vk(ct).href):"",(0,$.marked)(ut.value,{renderer:Wt}),ut}we.from=Q;function De(qe,ut){if(!qe)return qe;let kt;try{kt=(0,k.$Yh)(qe)}catch{}if(!kt)return qe;let Ft=!1;return kt=(0,y.$Yn)(kt,Wt=>{if(s.URI.isUri(Wt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ct]=Wt,Ft=!0,ct}else return}),Ft?JSON.stringify(kt):qe}function We(qe){const ut=new u.$gN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?s.URI.from(qe.baseUri):void 0,ut}we.to=We;function Ze(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Ze})(K||(e.MarkdownString=K={}));function se(we){return U(we)?we.map(Se=>({range:h.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?K.fromMany(Se.hoverMessage):Se.hoverMessage?K.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):we.map(Se=>({range:h.from(Se)}))}function ce(we){return typeof we>"u"?we:typeof we=="string"?s.URI.file(we):we}var ve;(function(we){function Se(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ce(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}we.from=Se})(ve||(e.ThemableDecorationAttachmentRenderOptions=ve={}));var Ie;(function(we){function Se(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ce(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ve.from(ae.before):void 0,after:ae.after?ve.from(ae.after):void 0}}we.from=Se})(Ie||(e.ThemableDecorationRenderOptions=Ie={}));var ue;(function(we){function Se(ae){if(typeof ae>"u")return ae;switch(ae){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Se})(ue||(e.DecorationRangeBehavior=ue={}));var be;(function(we){function Se(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?ue.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?Ie.from(ae.light):void 0,dark:ae.dark?Ie.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ce(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ve.from(ae.before):void 0,after:ae.after?ve.from(ae.after):void 0}}we.from=Se})(be||(e.DecorationRenderOptions=be={}));var ie;(function(we){function Se(Q){return{text:Q.newText,eol:Q.newEol&&at.from(Q.newEol),range:h.from(Q.range)}}we.from=Se;function ae(Q){const De=new u.$YM(h.to(Q.range),Q.text);return De.newEol=typeof Q.eol>"u"?void 0:at.to(Q.eol),De}we.to=ae})(ie||(e.TextEdit=ie={}));var Pe;(function(we){function Se(Q,De){const We={edits:[]};if(Q instanceof u.$2M){const Ze=new p.$Cc;for(const qe of Q._allEntries())qe._type===1&&s.URI.isUri(qe.to)&&qe.from===void 0&&Ze.add(qe.to);for(const qe of Q._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,N.$We)(N.$Ce.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),We.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?We.edits.push({resource:qe.uri,textEdit:ie.from(qe.edit),versionId:Ze.has(qe.uri)?void 0:De?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?We.edits.push({resource:qe.uri,textEdit:{range:h.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(qe.uri)?void 0:De?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?We.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&We.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:De?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ut.from)}})}return We}we.from=Se;function ae(Q){const De=new u.$2M,We=new p.$Bc;for(const Ze of Q.edits)if(Ze.textEdit){const qe=Ze,ut=s.URI.revive(qe.resource),kt=h.to(qe.textEdit.range),Ft=qe.textEdit.text,Wt=qe.textEdit.insertAsSnippet;let ct;Wt?ct=u.$1M.replace(kt,new u.$3M(Ft)):ct=u.$YM.replace(kt,Ft);const ri=We.get(ut);ri?ri.push(ct):We.set(ut,[ct])}else De.renameFile(s.URI.revive(Ze.oldResource),s.URI.revive(Ze.newResource),Ze.options);for(const[Ze,qe]of We)De.set(Ze,qe);return De}we.to=ae})(Pe||(e.WorkspaceEdit=Pe={}));var Fe;(function(we){const Se=Object.create(null);Se[u.SymbolKind.File]=0,Se[u.SymbolKind.Module]=1,Se[u.SymbolKind.Namespace]=2,Se[u.SymbolKind.Package]=3,Se[u.SymbolKind.Class]=4,Se[u.SymbolKind.Method]=5,Se[u.SymbolKind.Property]=6,Se[u.SymbolKind.Field]=7,Se[u.SymbolKind.Constructor]=8,Se[u.SymbolKind.Enum]=9,Se[u.SymbolKind.Interface]=10,Se[u.SymbolKind.Function]=11,Se[u.SymbolKind.Variable]=12,Se[u.SymbolKind.Constant]=13,Se[u.SymbolKind.String]=14,Se[u.SymbolKind.Number]=15,Se[u.SymbolKind.Boolean]=16,Se[u.SymbolKind.Array]=17,Se[u.SymbolKind.Object]=18,Se[u.SymbolKind.Key]=19,Se[u.SymbolKind.Null]=20,Se[u.SymbolKind.EnumMember]=21,Se[u.SymbolKind.Struct]=22,Se[u.SymbolKind.Event]=23,Se[u.SymbolKind.Operator]=24,Se[u.SymbolKind.TypeParameter]=25;function ae(De){return typeof Se[De]=="number"?Se[De]:6}we.from=ae;function Q(De){for(const We in Se)if(Se[We]===De)return Number(We);return u.SymbolKind.Property}we.to=Q})(Fe||(e.SymbolKind=Fe={}));var ne;(function(we){function Se(Q){switch(Q){case u.SymbolTag.Deprecated:return 1}}we.from=Se;function ae(Q){switch(Q){case 1:return u.SymbolTag.Deprecated}}we.to=ae})(ne||(e.SymbolTag=ne={}));var j;(function(we){function Se(Q){return{name:Q.name,kind:Fe.from(Q.kind),tags:Q.tags&&Q.tags.map(ne.from),containerName:Q.containerName,location:$e.from(Q.location)}}we.from=Se;function ae(Q){const De=new u.$0M(Q.name,Fe.to(Q.kind),Q.containerName,$e.to(Q.location));return De.tags=Q.tags&&Q.tags.map(ne.to),De}we.to=ae})(j||(e.WorkspaceSymbol=j={}));var x;(function(we){function Se(Q){const De={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:h.from(Q.range),selectionRange:h.from(Q.selectionRange),kind:Fe.from(Q.kind),tags:Q.tags?.map(ne.from)??[]};return Q.children&&(De.children=Q.children.map(Se)),De}we.from=Se;function ae(Q){const De=new u.$$M(Q.name,Q.detail,Fe.to(Q.kind),h.to(Q.range),h.to(Q.selectionRange));return(0,I.$Lb)(Q.tags)&&(De.tags=Q.tags.map(ne.to)),Q.children&&(De.children=Q.children.map(ae)),De}we.to=ae})(x||(e.DocumentSymbol=x={}));var pe;(function(we){function Se(Q){const De=new u.$cN(Fe.to(Q.kind),Q.name,Q.detail||"",s.URI.revive(Q.uri),h.to(Q.range),h.to(Q.selectionRange));return De._sessionId=Q._sessionId,De._itemId=Q._itemId,De}we.to=Se;function ae(Q,De,We){if(De=De??Q._sessionId,We=We??Q._itemId,De===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:We,name:Q.name,detail:Q.detail,kind:Fe.from(Q.kind),uri:Q.uri,range:h.from(Q.range),selectionRange:h.from(Q.selectionRange),tags:Q.tags?.map(ne.from)}}we.from=ae})(pe||(e.CallHierarchyItem=pe={}));var Oe;(function(we){function Se(ae){return new u.$dN(pe.to(ae.from),ae.fromRanges.map(Q=>h.to(Q)))}we.to=Se})(Oe||(e.CallHierarchyIncomingCall=Oe={}));var ke;(function(we){function Se(ae){return new u.$eN(pe.to(ae.to),ae.fromRanges.map(Q=>h.to(Q)))}we.to=Se})(ke||(e.CallHierarchyOutgoingCall=ke={}));var $e;(function(we){function Se(Q){return{range:Q.range&&h.from(Q.range),uri:Q.uri}}we.from=Se;function ae(Q){return new u.$4M(s.URI.revive(Q.uri),h.to(Q.range))}we.to=ae})($e||(e.location=$e={}));var ge;(function(we){function Se(Q){const De=Q,We=Q;return{originSelectionRange:De.originSelectionRange?h.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:We.uri,range:h.from(De.targetRange?De.targetRange:We.range),targetSelectionRange:De.targetSelectionRange?h.from(De.targetSelectionRange):void 0}}we.from=Se;function ae(Q){return{targetUri:s.URI.revive(Q.uri),targetRange:h.to(Q.range),targetSelectionRange:Q.targetSelectionRange?h.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?h.to(Q.originSelectionRange):void 0}}we.to=ae})(ge||(e.DefinitionLink=ge={}));var J;(function(we){function Se(Q){return{range:h.from(Q.range),contents:K.fromMany(Q.contents)}}we.from=Se;function ae(Q){return new u.$7M(Q.contents.map(K.to),h.to(Q.range))}we.to=ae})(J||(e.Hover=J={}));var Y;(function(we){function Se(Q){return{range:h.from(Q.range),expression:Q.expression}}we.from=Se;function ae(Q){return new u.$2N(h.to(Q.range),Q.expression)}we.to=ae})(Y||(e.EvaluatableExpression=Y={}));var he;(function(we){function Se(Q){if(Q instanceof u.$3N)return{type:"text",range:h.from(Q.range),text:Q.text};if(Q instanceof u.$4N)return{type:"variable",range:h.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof u.$5N)return{type:"expression",range:h.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Se;function ae(Q){switch(Q.type){case"text":return{range:h.to(Q.range),text:Q.text};case"variable":return{range:h.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:h.to(Q.range),expression:Q.expression}}}we.to=ae})(he||(e.InlineValue=he={}));var le;(function(we){function Se(Q){return{frameId:Q.frameId,stoppedLocation:h.from(Q.stoppedLocation)}}we.from=Se;function ae(Q){return new u.$6N(Q.frameId,h.to(Q.stoppedLocation))}we.to=ae})(le||(e.InlineValueContext=le={}));var Ne;(function(we){function Se(Q){return{range:h.from(Q.range),kind:Q.kind}}we.from=Se;function ae(Q){return new u.$8M(h.to(Q.range),Q.kind)}we.to=ae})(Ne||(e.DocumentHighlight=Ne={}));var de;(function(we){function Se(Q){return{uri:Q.uri,highlights:Q.highlights.map(Ne.from)}}we.from=Se;function ae(Q){return new u.$9M(s.URI.revive(Q.uri),Q.highlights.map(Ne.to))}we.to=ae})(de||(e.MultiDocumentHighlight=de={}));var Ce;(function(we){function Se(ae){switch(ae){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}we.to=Se})(Ce||(e.CompletionTriggerKind=Ce={}));var Me;(function(we){function Se(ae){return{triggerKind:Ce.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}we.to=Se})(Me||(e.CompletionContext=Me={}));var ze;(function(we){function Se(Q){switch(Q){case u.CompletionItemTag.Deprecated:return 1}}we.from=Se;function ae(Q){switch(Q){case 1:return u.CompletionItemTag.Deprecated}}we.to=ae})(ze||(e.CompletionItemTag=ze={}));var z;(function(we){const Se=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ae(We){return Se.get(We)??9}we.from=ae;const Q=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function De(We){return Q.get(We)??u.CompletionItemKind.Property}we.to=De})(z||(e.CompletionItemKind=z={}));var L;(function(we){function Se(ae,Q){const De=new u.$mN(ae.label);return De.insertText=ae.insertText,De.kind=z.to(ae.kind),De.tags=ae.tags?.map(ze.to),De.detail=ae.detail,De.documentation=M.$Pk(ae.documentation)?K.to(ae.documentation):ae.documentation,De.sortText=ae.sortText,De.filterText=ae.filterText,De.preselect=ae.preselect,De.commitCharacters=ae.commitCharacters,o.$kt.isIRange(ae.range)?De.range=h.to(ae.range):typeof ae.range=="object"&&(De.range={inserting:h.to(ae.range.insert),replacing:h.to(ae.range.replace)}),De.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?De.insertText=new u.$3M(ae.insertText):(De.insertText=ae.insertText,De.textEdit=De.range instanceof u.$TM?new u.$YM(De.range,De.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(De.additionalTextEdits=ae.additionalTextEdits.map(We=>ie.to(We))),De.command=Q&&ae.command?Q.fromInternal(ae.command):void 0,De}we.to=Se})(L||(e.CompletionItem=L={}));var G;(function(we){function Se(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:K.fromStrict(Q.documentation)}}we.from=Se;function ae(Q){return{label:Q.label,documentation:M.$Pk(Q.documentation)?K.to(Q.documentation):Q.documentation}}we.to=ae})(G||(e.ParameterInformation=G={}));var H;(function(we){function Se(Q){return{label:Q.label,documentation:K.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(G.from):[],activeParameter:Q.activeParameter}}we.from=Se;function ae(Q){return{label:Q.label,documentation:M.$Pk(Q.documentation)?K.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(G.to):[],activeParameter:Q.activeParameter}}we.to=ae})(H||(e.SignatureInformation=H={}));var ee;(function(we){function Se(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(H.from):[]}}we.from=Se;function ae(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(H.to):[]}}we.to=ae})(ee||(e.SignatureHelp=ee={}));var re;(function(we){function Se(ae,Q){const De=new u.$lN(D.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(Te.to.bind(void 0,ae)),Q.kind&&Be.to(Q.kind));return De.textEdits=Q.textEdits&&Q.textEdits.map(ie.to),De.tooltip=M.$Pk(Q.tooltip)?K.to(Q.tooltip):Q.tooltip,De.paddingLeft=Q.paddingLeft,De.paddingRight=Q.paddingRight,De}we.to=Se})(re||(e.InlayHint=re={}));var Te;(function(we){function Se(ae,Q){const De=new u.$kN(Q.label);return De.tooltip=M.$Pk(Q.tooltip)?K.to(Q.tooltip):Q.tooltip,n.Command.is(Q.command)&&(De.command=ae.fromInternal(Q.command)),Q.location&&(De.location=$e.to(Q.location)),De}we.to=Se})(Te||(e.InlayHintLabelPart=Te={}));var Be;(function(we){function Se(Q){return Q}we.from=Se;function ae(Q){return Q}we.to=ae})(Be||(e.InlayHintKind=Be={}));var Qe;(function(we){function Se(Q){return{range:h.from(Q.range),url:Q.target,tooltip:Q.tooltip}}we.from=Se;function ae(Q){let De;if(Q.url)try{De=typeof Q.url=="string"?s.URI.parse(Q.url,!0):s.URI.revive(Q.url)}catch{}return new u.$rN(h.to(Q.range),De)}we.to=ae})(Qe||(e.DocumentLink=Qe={}));var _e;(function(we){function Se(Q){const De=new u.$uN(Q.label);return Q.textEdit&&(De.textEdit=ie.to(Q.textEdit)),Q.additionalTextEdits&&(De.additionalTextEdits=Q.additionalTextEdits.map(We=>ie.to(We))),De}we.to=Se;function ae(Q){return{label:Q.label,textEdit:Q.textEdit?ie.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(De=>ie.from(De)):void 0}}we.from=ae})(_e||(e.ColorPresentation=_e={}));var et;(function(we){function Se(Q){return new u.$sN(Q[0],Q[1],Q[2],Q[3])}we.to=Se;function ae(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}we.from=ae})(et||(e.Color=et={}));var tt;(function(we){function Se(Q){return{range:h.from(Q.range)}}we.from=Se;function ae(Q){return new u.$bN(h.to(Q.range))}we.to=ae})(tt||(e.SelectionRange=tt={}));var it;(function(we){function Se(ae){switch(ae){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}we.to=Se})(it||(e.TextDocumentSaveReason=it={}));var nt;(function(we){function Se(Q){switch(Q){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.Interval:return 3;case u.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Se;function ae(Q){switch(Q){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 3:return u.TextEditorLineNumbersStyle.Interval;case 1:default:return u.TextEditorLineNumbersStyle.On}}we.to=ae})(nt||(e.TextEditorLineNumbersStyle=nt={}));var at;(function(we){function Se(Q){if(Q===u.EndOfLine.CRLF)return 1;if(Q===u.EndOfLine.LF)return 0}we.from=Se;function ae(Q){if(Q===1)return u.EndOfLine.CRLF;if(Q===0)return u.EndOfLine.LF}we.to=ae})(at||(e.EndOfLine=at={}));var mt;(function(we){function Se(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Se})(mt||(e.ProgressLocation=mt={}));var je;(function(we){function Se(Q){const De={start:Q.start+1,end:Q.end+1};return Q.kind&&(De.kind=st.from(Q.kind)),De}we.from=Se;function ae(Q){const De={start:Q.start-1,end:Q.end-1};return Q.kind&&(De.kind=st.to(Q.kind)),De}we.to=ae})(je||(e.FoldingRange=je={}));var st;(function(we){function Se(Q){if(Q)switch(Q){case u.FoldingRangeKind.Comment:return n.$6t.Comment;case u.FoldingRangeKind.Imports:return n.$6t.Imports;case u.FoldingRangeKind.Region:return n.$6t.Region}}we.from=Se;function ae(Q){if(Q)switch(Q.value){case n.$6t.Comment.value:return u.FoldingRangeKind.Comment;case n.$6t.Imports.value:return u.FoldingRangeKind.Imports;case n.$6t.Region.value:return u.FoldingRangeKind.Region}}we.to=ae})(st||(e.FoldingRangeKind=st={}));var X;(function(we){function Se(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?h.from(ae.selection):void 0,override:typeof ae.override=="boolean"?a.$eF.id:void 0}}we.from=Se})(X||(e.TextEditorOpenOptions=X={}));var Z;(function(we){function Se(We){return We instanceof u.$PN?We.toJSON():typeof We=="string"?We:ae(We)||Q(We)?new u.$PN(We.baseUri??We.base,We.pattern).toJSON():We}we.from=Se;function ae(We){const Ze=We;return Ze?s.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function Q(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function De(We){return typeof We=="string"?We:new u.$PN(s.URI.revive(We.baseUri),We.pattern)}we.to=De})(Z||(e.GlobPattern=Z={}));var me;(function(we){function Se(ae){if(ae){if(Array.isArray(ae))return ae.map(Se);if(typeof ae=="string")return ae;{const Q=ae;return{language:Q.language,scheme:Q.scheme,pattern:Z.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}we.from=Se})(me||(e.LanguageSelector=me={}));var He;(function(we){function Se(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(De=>Array.isArray(De)&&De.every(We=>We&&typeof We=="object"&&"uri"in We&&s.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof u.$TM)))}we.is=Se;function ae(Q){return{documents:Q.documents.map(De=>De.map(We=>({uri:s.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>h.from(Ze))})))}}we.from=ae})(He||(e.MappedEditsContext=He={}));var ye;(function(we){function Se(Q){return{start:Q.start,end:Q.end}}we.from=Se;function ae(Q){return new u.$gO(Q.start,Q.end)}we.to=ae})(ye||(e.NotebookRange=ye={}));var ot;(function(we){function Se(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}we.to=Se;function ae(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}we.from=ae})(ot||(e.NotebookCellExecutionSummary=ot={}));var dt;(function(we){function Se(ae){if(ae===i.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(ae===i.NotebookCellExecutionState.Pending)return;if(ae===i.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}we.to=Se})(dt||(e.NotebookCellExecutionState=dt={}));var It;(function(we){function Se(Q){switch(Q){case u.NotebookCellKind.Markup:return i.CellKind.Markup;case u.NotebookCellKind.Code:default:return i.CellKind.Code}}we.from=Se;function ae(Q){switch(Q){case i.CellKind.Markup:return u.NotebookCellKind.Markup;case i.CellKind.Code:default:return u.NotebookCellKind.Code}}we.to=ae})(It||(e.NotebookCellKind=It={}));var Qt;(function(we){function Se(Q){const De={metadata:Q.metadata??Object.create(null),cells:[]};for(const We of Q.cells)u.$hO.validate(We),De.cells.push(Ut.from(We));return De}we.from=Se;function ae(Q){const De=new u.$iO(Q.cells.map(Ut.to));return(0,m.$eg)(Q.metadata)||(De.metadata=Q.metadata),De}we.to=ae})(Qt||(e.NotebookData=Qt={}));var Ut;(function(we){function Se(Q){return{cellKind:It.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:ot.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(_t.from):[]}}we.from=Se;function ae(Q){return new u.$hO(It.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(_t.to):void 0,Q.metadata,Q.internalMetadata?ot.to(Q.internalMetadata):void 0)}we.to=ae})(Ut||(e.NotebookCellData=Ut={}));var xt;(function(we){function Se(Q){return{mime:Q.mime,valueBytes:N.$Ce.wrap(Q.data)}}we.from=Se;function ae(Q){return new u.$jO(Q.valueBytes.buffer,Q.mime)}we.to=ae})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(we){function Se(Q){return{outputId:Q.id,items:Q.items.map(xt.from),metadata:Q.metadata}}we.from=Se;function ae(Q){const De=Q.items.map(xt.to);return new u.$kO(De,Q.outputId,Q.metadata)}we.to=ae})(_t||(e.NotebookCellOutput=_t={}));var Pt;(function(we){function Se(De){return Q(De)?{include:Z.from(De.include)??void 0,exclude:Z.from(De.exclude)??void 0}:Z.from(De)??void 0}we.from=Se;function ae(De){return Q(De)?{include:Z.to(De.include),exclude:Z.to(De.exclude)}:Z.to(De)}we.to=ae;function Q(De){const We=De;return We?!(0,m.$ag)(We.include)&&!(0,m.$ag)(We.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var Vt;(function(we){function Se(ae,Q,De){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(We,De),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}we.from=Se})(Vt||(e.NotebookStatusBarItem=Vt={}));var Zt;(function(we){function Se(ae,Q,De){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:Q.toInternal(We,De),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}we.from=Se})(Zt||(e.NotebookKernelSourceAction=Zt={}));var Xe;(function(we){function Se(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}we.from=Se})(Xe||(e.NotebookDocumentContentOptions=Xe={}));var si;(function(we){function Se(Q){return{uri:Q.uri,provides:Q.provides}}we.from=Se;function ae(Q){return new u.$mO(s.URI.revive(Q.uri),Q.provides)}we.to=ae})(si||(e.NotebookRendererScript=si={}));var Xt;(function(we){function Se(Q){return{message:K.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:h.from(Q.location.range),uri:Q.location.uri}}}we.from=Se;function ae(Q){const De=new u.$sO(typeof Q.message=="string"?Q.message:K.to(Q.message));return De.actualOutput=Q.actual,De.expectedOutput=Q.expected,De.contextValue=Q.contextValue,De.location=Q.location?$e.to(Q.location):void 0,De}we.to=ae})(Xt||(e.TestMessage=Xt={}));var lt;(function(we){we.namespace=c.$GL,we.denamespace=c.$HL})(lt||(e.TestTag=lt={}));var vt;(function(we){function Se(Q){const De=(0,t.$$O)(Q).controllerId;return{extId:b.$BL.fromExtHostTestItem(Q,De).toString(),label:Q.label,uri:s.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(We=>lt.namespace(De,We.id)),range:o.$kt.lift(h.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&K.fromStrict(Q.error)||null}}we.from=Se;function ae(Q){return{parent:void 0,error:void 0,id:b.$BL.fromString(Q.extId).localId,label:Q.label,uri:s.URI.revive(Q.uri),tags:(Q.tags||[]).map(De=>{const{tagId:We}=lt.denamespace(De);return new u.$tO(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}we.toPlain=ae})(vt||(e.TestItem=vt={})),function(we){function Se(Q){return{id:Q.id}}we.from=Se;function ae(Q){return new u.$tO(Q.id)}we.to=ae}(lt||(e.TestTag=lt={}));var ti;(function(we){const Se=(Q,De)=>{const We=Q.value;if(!We)return;const Ze={...vt.toPlain(We.item),parent:De,taskStates:We.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(Xt.to)})),children:[]};if(Q.children)for(const qe of Q.children.values()){const ut=Se(qe,Ze);ut&&Ze.children.push(ut)}return Ze};function ae(Q){const De=new l.$4O;for(const qe of Q.items)De.insert(b.$BL.fromString(qe.item.extId).path,qe);const We=[De.nodes],Ze=[];for(;We.length;)for(const qe of We.pop())qe.value?Ze.push(qe):qe.children&&We.push(qe.children.values());return{completedAt:Q.completedAt,results:Ze.map(qe=>Se(qe)).filter(m.$_f)}}we.to=ae})(ti||(e.TestResults=ti={}));var Yt;(function(we){function Se(We){return{covered:We.covered,total:We.total}}function ae(We){return"line"in We?D.from(We):h.from(We)}function Q(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ae(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:0,name:We.name,count:We.executed,location:ae(We.location)}}we.fromDetails=Q;function De(We,Ze){return u.$vO(Ze.statementCoverage),u.$vO(Ze.branchCoverage),u.$vO(Ze.declarationCoverage),{id:We,uri:Ze.uri,statement:Se(Ze.statementCoverage),branch:Ze.branchCoverage&&Se(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Se(Ze.declarationCoverage)}}we.fromFile=De})(Yt||(e.TestCoverage=Yt={}));var Lt;(function(we){function Se(ae){switch(ae){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}we.to=Se})(Lt||(e.CodeActionTriggerKind=Lt={}));var ft;(function(we){function Se(Q){const De=new u.$AO(Fe.to(Q.kind),Q.name,Q.detail||"",s.URI.revive(Q.uri),h.to(Q.range),h.to(Q.selectionRange));return De._sessionId=Q._sessionId,De._itemId=Q._itemId,De}we.to=Se;function ae(Q,De,We){if(De=De??Q._sessionId,We=We??Q._itemId,De===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:We,kind:Fe.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:h.from(Q.range),selectionRange:h.from(Q.selectionRange),tags:Q.tags?.map(ne.from)}}we.from=ae})(ft||(e.TypeHierarchyItem=ft={}));var jt;(function(we){function Se(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}we.from=Se})(jt||(e.ViewBadge=jt={}));var Bt;(function(we){function Se(We,Ze,qe){const ut=Ze.fileData;return ut?new u.$HN(new u.$IN(ut.name,s.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>qe(ut.id)))):We===T.$Hs.uriList&&Ze.uriListData?new u.$GN(De(Ze.uriListData)):new u.$GN(Ze.asString)}we.to=Se;async function ae(We,Ze){const qe=await Ze.asString();if(We===T.$Hs.uriList)return{asString:qe,fileData:void 0,uriListData:Q(qe)};const ut=Ze.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}we.from=ae;function Q(We){return A.$Kt.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return s.URI.parse(Ze)}catch{}return Ze})}function De(We){return A.$Kt.create(We.map(Ze=>typeof Ze=="string"?Ze:s.URI.revive(Ze)))}})(Bt||(e.DataTransferItem=Bt={}));var qt;(function(we){function Se(Q,De){const We=Q.items.map(([Ze,qe])=>[Ze,Bt.to(Ze,qe,De)]);return new u.$JN(We)}we.toDataTransfer=Se;async function ae(Q){const De={items:[]},We=[];for(const[Ze,qe]of Q)We.push((async()=>{De.items.push([Ze,await Bt.from(Ze,qe)])})());return await Promise.all(We),De}we.from=ae})(qt||(e.DataTransfer=qt={}));var Ge;(function(we){function Se(Q,De){return{kind:"reply",agentId:Q.participant??De?.agentId??"",subCommand:Q.command??De?.command,message:Q.prompt,title:Q.label}}we.from=Se;function ae(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}we.to=ae})(Ge||(e.ChatFollowup=Ge={}));var ui;(function(we){function Se(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}we.from=Se})(ui||(e.ChatInlineFollowup=ui={}));var Ht;(function(we){function Se(Q){switch(Q.role){case 0:return new u.$YO(Q.content);case 1:return new u.$ZO(Q.content);case 2:return new u.$1O(Q.content)}}we.to=Se;function ae(Q){if(Q instanceof u.$YO)return{role:0,content:Q.content};if(Q instanceof u.$ZO)return{role:1,content:Q.content};if(Q instanceof u.$1O)return{role:2,content:Q.content};throw new Error("Invalid LanguageModelMessage")}we.from=ae})(Ht||(e.LanguageModelMessage=Ht={}));var zt;(function(we){function Se(De){const We={};for(const Ze of Object.keys(De))We[Ze]=De[Ze].map(we.to);return We}we.objectTo=Se;function ae(De){return{level:gt.to(De.level),kind:De.kind,value:(0,s.$wc)(De.value)?s.URI.revive(De.value):De.value,description:De.description}}we.to=ae;function Q(De){return{level:gt.from(De.level),kind:De.kind,value:De.value,description:De.description}}we.from=Q})(zt||(e.ChatVariable=zt={}));var gt;(function(we){function Se(Q){switch(Q){case"short":return u.ChatVariableLevel.Short;case"medium":return u.ChatVariableLevel.Medium;case"full":default:return u.ChatVariableLevel.Full}}we.to=Se;function ae(Q){switch(Q){case u.ChatVariableLevel.Short:return"short";case u.ChatVariableLevel.Medium:return"medium";case u.ChatVariableLevel.Full:default:return"full"}}we.from=ae})(gt||(e.ChatVariableLevel=gt={}));var Tt;(function(we){function Se(ae){switch(ae){case 1:return u.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return u.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return u.InteractiveEditorResponseFeedbackKind.Undone;case 3:return u.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return u.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Se})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var At;(function(we){function Se(Q){return{kind:"markdownContent",content:K.from(Q.value)}}we.from=Se;function ae(Q){return new u.$NO(K.to(Q.content))}we.to=ae})(At||(e.ChatResponseMarkdownPart=At={}));var Ot;(function(we){function Se(Q){return{kind:"markdownVuln",content:K.from(Q.value),vulnerabilities:Q.vulnerabilities}}we.from=Se;function ae(Q){return new u.$OO(K.to(Q.content),Q.vulnerabilities)}we.to=ae})(Ot||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ot={}));var ii;(function(we){function Se(Q){return{kind:"agentDetection",agentId:Q.participant,command:Q.command}}we.from=Se;function ae(Q){return new u.$PO(Q.agentId,Q.command)}we.to=ae})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Gt;(function(we){function Se(Q){const{value:De,baseUri:We}=Q;function Ze(qe,ut){return qe.map(kt=>{const Ft=s.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Ft,children:kt.children&&Ze(kt.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,v.$1g)(We),uri:We,children:Ze(De,We)}}}we.from=Se;function ae(Q){const De=(0,k.$Zh)(Q.treeData);function We(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&We(kt.children)}))}const Ze=De.uri,qe=De.children?We(De.children):[];return new u.$QO(qe,Ze)}we.to=ae})(Gt||(e.ChatResponseFilesPart=Gt={}));var ni;(function(we){function Se(Q){return{kind:"inlineReference",name:Q.title,inlineReference:s.URI.isUri(Q.value)?Q.value:E.from(Q.value)}}we.from=Se;function ae(Q){const De=(0,k.$Zh)(Q);return new u.$RO(s.URI.isUri(De.inlineReference)?De.inlineReference:E.to(De.inlineReference),Q.name)}we.to=ae})(ni||(e.ChatResponseAnchorPart=ni={}));var Mt;(function(we){function Se(Q){return{kind:"progressMessage",content:K.from(Q.value)}}we.from=Se;function ae(Q){return new u.$SO(Q.content.value)}we.to=ae})(Mt||(e.ChatResponseProgressPart=Mt={}));var Nt;(function(we){function Se(Q,De,We){return{kind:"command",command:De.toInternal(Q.value,We)??{command:Q.value.command,title:Q.value.title}}}we.from=Se;function ae(Q,De){return new u.$TO(De.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}we.to=ae})(Nt||(e.ChatResponseCommandButtonPart=Nt={}));var Ct;(function(we){function Se(Q){return{kind:"textEdit",uri:Q.uri,edits:Q.edits.map(De=>ie.from(De))}}we.from=Se;function ae(Q){return new u.$VO(s.URI.revive(Q.uri),Q.edits.map(De=>ie.to(De)))}we.to=ae})(Ct||(e.ChatResponseTextEditPart=Ct={}));var Et;(function(we){function Se(Q){return"variableName"in Q.value?{kind:"reference",reference:{variableName:Q.value.variableName,value:s.URI.isUri(Q.value.value)||!Q.value.value?Q.value.value:E.from(Q.value.value)}}:{kind:"reference",reference:s.URI.isUri(Q.value)?Q.value:E.from(Q.value)}}we.from=Se;function ae(Q){const De=(0,k.$Zh)(Q),We=Ze=>s.URI.isUri(Ze)?Ze:E.to(Ze);return new u.$UO("variableName"in De.reference?{variableName:De.reference.variableName,value:De.reference.value&&We(De.reference.value)}:We(De.reference))}we.to=ae})(Et||(e.ChatResponseReferencePart=Et={}));var pt;(function(we){function Se(De,We,Ze){return De instanceof u.$NO?At.from(De):De instanceof u.$RO?ni.from(De):De instanceof u.$UO?Et.from(De):De instanceof u.$SO?Mt.from(De):De instanceof u.$QO?Gt.from(De):De instanceof u.$TO?Nt.from(De,We,Ze):De instanceof u.$VO?Ct.from(De):De instanceof u.$OO?Ot.from(De):De instanceof u.$PO?ii.from(De):{kind:"markdownContent",content:K.from("")}}we.from=Se;function ae(De,We){switch(De.kind){case"reference":return Et.to(De);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(De,We)}}we.to=ae;function Q(De,We){switch(De.kind){case"markdownContent":return At.to(De);case"inlineReference":return ni.to(De);case"progressMessage":return;case"treeData":return Gt.to(De);case"command":return Nt.to(De,We)}}we.toContent=Q})(pt||(e.ChatResponsePart=pt={}));var St;(function(we){function Se(ae){return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,variables:ae.variables.variables.map(Dt.to),location:li.to(ae.location)}}we.to=Se})(St||(e.ChatAgentRequest=St={}));var li;(function(we){function Se(ae){switch(ae){case d.ChatAgentLocation.Notebook:return u.ChatLocation.Notebook;case d.ChatAgentLocation.Terminal:return u.ChatLocation.Terminal;case d.ChatAgentLocation.Panel:return u.ChatLocation.Panel;case d.ChatAgentLocation.Editor:return u.ChatLocation.Editor}}we.to=Se})(li||(e.ChatLocation=li={}));var Dt;(function(we){function Se(ae){return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],values:ae.values.map(zt.to)}}we.to=Se})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var hi;(function(we){function Se(ae){return{label:ae.label,values:ae.values.map(zt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}we.from=Se})(hi||(e.ChatAgentCompletionItem=hi={}));var Kt;(function(we){function Se(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}we.to=Se})(Kt||(e.ChatAgentResult=Kt={}));var vi;(function(we){function Se(ae,Q,De){if(Q.action.kind==="vote")return;const We=Kt.to(ae);if(Q.action.kind==="command"){const Ze=Q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:De.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:We}}else return Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Ge.to(Q.action.followup)},result:We}:Q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Q.action.action==="accepted"},result:We}:{action:Q.action,result:We}}we.to=Se})(vi||(e.ChatAgentUserActionEvent=vi={}));var ei;(function(we){function Se(ae,Q,De){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:Q.toInternal(ae,De)}we.from=Se})(ei||(e.TerminalQuickFix=ei={}));var wi;(function(we){function Se(ae){return{kind:yt.to(ae.kind)}}we.to=Se})(wi||(e.PartialAcceptInfo=wi={}));var yt;(function(we){function Se(ae){switch(ae){case 0:return u.PartialAcceptTriggerKind.Word;case 1:return u.PartialAcceptTriggerKind.Line;case 2:return u.PartialAcceptTriggerKind.Suggest;default:return u.PartialAcceptTriggerKind.Unknown}}we.to=Se})(yt||(e.PartialAcceptTriggerKind=yt={}));var $i;(function(we){function Se(ae,Q){return{id:Q,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}we.from=Se})($i||(e.DebugTreeItem=$i={}))}),define(Ae[252],Re([1,0,4,16,8,34]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=void 0;let M=class{constructor($,k){this.a=$.getProxy(I.$PM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>k.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,k,T){const y=new O.$mw(A.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,T?.isRefactoring??!1)}};e.$rkc=M,e.$rkc=M=Je([Ve(0,N.$cP)],M)}),define(Ae[253],Re([1,0,18,11,43,5,40,6,65,17,2,163,20,4,8,7,215,25]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class r{constructor(i,b,c,f,u){this.i=i,this.j=b,this.k=c,this.l=f,this.m=u,this.b=$.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let b=function(f){if(i.c){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,f),u}};const i=this;this.b.reset();const c=f=>{typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,f)};this.g={markdown(f){b(this.markdown);const u=new s.$NO(f),S=m.ChatResponseMarkdownPart.from(u);return c(S),this},markdownWithVulnerabilities(f,u){b(this.markdown),u&&(0,n.$yG)(i.i,"chatParticipantAdditions");const S=new s.$OO(f,u),h=m.ChatResponseMarkdownWithVulnerabilitiesPart.from(S);return c(h),this},filetree(f,u){b(this.filetree);const S=new s.$QO(f,u),h=m.ChatResponseFilesPart.from(S);return c(h),this},anchor(f,u){b(this.anchor);const S=new s.$RO(f,u),h=m.ChatResponseAnchorPart.from(S);return c(h),this},button(f){b(this.anchor);const u=new s.$TO(f),S=m.ChatResponseCommandButtonPart.from(u,i.l,i.m);return c(S),this},progress(f){b(this.progress);const u=new s.$SO(f),S=m.ChatResponseProgressPart.from(u);return c(S),this},reference(f){if(b(this.reference),"variableName"in f&&!f.value){const u=i.j.variables.variables.find(S=>S.name===f.variableName);if(u){let S;if(u.references?.length)S=u.references.map(h=>({kind:"reference",reference:{variableName:f.variableName,value:h.reference}}));else{const h=new s.$UO(f);S=[m.ChatResponseReferencePart.from(h)]}return S.forEach(h=>c(h)),this}}else{const u=new s.$UO(f),S=m.ChatResponseReferencePart.from(u);c(S)}return this},textEdit(f,u){b(this.textEdit),(0,n.$yG)(i.i,"chatParticipantAdditions");const S=new s.$VO(f,u),h=m.ChatResponseTextEditPart.from(S);return c(h),this},detectedParticipant(f,u){b(this.detectedParticipant),(0,n.$yG)(i.i,"chatParticipantAdditions");const S=new s.$PO(f,u),h=m.ChatResponseDetectedParticipantPart.from(S);return c(h),this},push(f){if(b(this.push),(f instanceof s.$VO||f instanceof s.$OO||f instanceof s.$PO)&&(0,n.$yG)(i.i,"chatParticipantAdditions"),f instanceof s.$UO)this.reference(f.value);else{const u=m.ChatResponsePart.from(f,i.l,i.m);c(u)}return this}}}return this.g}}class t{static{this.b=0}constructor(i,b,c){this.i=b,this.j=c,this.c=new Map,this.g=new p.$4c,this.d=i.getProxy(v.$PM.MainThreadChatAgents2)}transferActiveChat(i){this.d.$transferActiveChatSession(i)}createChatAgent(i,b,c){const f=t.b++,u=new a(i,b,this.d,f,c);return this.c.set(f,u),this.d.$registerAgent(f,i.identifier,b,{},void 0),u.apiAgent}createDynamicChatAgent(i,b,c,f,u){const S=t.b++,h=new a(i,b,this.d,S,u);return this.c.set(S,h),this.d.$registerAgent(S,i.identifier,b,{isSticky:!0},{name:c,description:f}),h.apiAgent}async $invokeAgent(i,b,c,f){const u=this.c.get(i);if(!u)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let S=this.g.get(b.sessionId);S||(S=new p.$Tc,this.g.set(b.sessionId,S));const h=new r(u.extension,b,this.d,this.j.converter,S);try{const E=await this.k(b.agentId,c),g=u.invoke(m.ChatAgentRequest.to(b),{history:E},h.apiObject,f);return await(0,N.$eh)(Promise.resolve(g).then(D=>{if(D?.metadata)try{JSON.stringify(D.metadata)}catch(w){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${w.message}`;return this.i.error(`[${u.extension.identifier.value}] [@${u.id}] ${C}`,u.extension),{errorDetails:{message:C},timings:h.timings}}return{errorDetails:D?.errorDetails,timings:h.timings,metadata:D?.metadata}}),f)}catch(E){return this.i.error(E,u.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,A.$bj)(E)),responseIsIncomplete:!0}}}finally{h.close()}}async k(i,b){const c=[];for(const f of b.history){const u=m.ChatAgentResult.to(f.result),S=i===f.request.agentId?u:{...u,metadata:void 0};c.push(new s.$WO(f.request.message,f.request.command,f.request.variables.variables.map(m.ChatAgentResolvedVariable.to),f.request.agentId));const h=(0,I.$Hb)(f.response.map(E=>m.ChatResponsePart.toContent(E,this.j.converter)));c.push(new s.$XO(h,S,f.request.agentId,f.request.command))}return c}$releaseSession(i){this.g.deleteAndDispose(i)}async $provideFollowups(i,b,c,f,u){const S=this.c.get(b);if(!S)return Promise.resolve([]);const h=await this.k(S.id,f),E=m.ChatAgentResult.to(c);return(await S.provideFollowups(E,{history:h},u)).filter(g=>{const D=!g.participant||M.Iterable.some(this.c.values(),w=>w.id===g.participant&&l.$Lm.equals(w.extension.identifier,S.extension.identifier));return D||this.i.warn(`[@${S.id}] ChatFollowup refers to an unknown participant: ${g.participant}`),D}).map(g=>m.ChatFollowup.from(g,i))}$acceptFeedback(i,b,c,f){const u=this.c.get(i);if(!u)return;const S=m.ChatAgentResult.to(b);let h;switch(c){case o.InteractiveSessionVoteDirection.Down:h=s.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:h=s.ChatResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(f?{result:S,kind:h,reportIssue:f}:{result:S,kind:h}))}$acceptAction(i,b,c){const f=this.c.get(i);if(!f||c.action.kind==="vote")return;const u=m.ChatAgentUserActionEvent.to(b,c,this.j.converter);u&&f.acceptAction(Object.freeze(u))}async $invokeCompletionProvider(i,b,c){const f=this.c.get(i);return f?(await f.invokeCompletionProvider(b,c)).map(m.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(i,b,c){const f=this.c.get(i);if(f)return await f.provideWelcomeMessage(m.ChatLocation.to(b),c)}async $provideSampleQuestions(i,b,c){const f=this.c.get(i);if(f)return(await f.provideSampleQuestions(m.ChatLocation.to(b),c)).map(u=>m.ChatFollowup.from(u,void 0))}}e.$skc=t;class a{constructor(i,b,c,f,u){this.extension=i,this.id=b,this.u=c,this.w=f,this.x=u,this.n=new O.$be,this.o=new O.$be}acceptFeedback(i){this.n.fire(i)}acceptAction(i){this.o.fire(i)}async invokeCompletionProvider(i,b){return this.q?await this.q.provider.provideCompletionItems(i,b)??[]:[]}async provideFollowups(i,b,c){if(!this.b)return[];const f=await this.b.provideFollowups(i,b,c);return f?f.filter(u=>!(u&&"commandId"in u)).filter(u=>!(u&&"message"in u)):[]}async provideWelcomeMessage(i,b){if(!this.s)return[];const c=await this.s.provideWelcomeMessage(i,b);return c?c.map(f=>typeof f=="string"?f:m.MarkdownString.from(f)):[]}async provideSampleQuestions(i,b){if(!this.s||!this.s.provideSampleQuestions)return[];const c=await this.s.provideSampleQuestions(i,b);return c||[]}get apiAgent(){let i=!1,b=!1;const c=()=>{i||b||(b=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof s.$NN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:m.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:m.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),b=!1}))},f=this;return{get id(){return f.id},get fullName(){return(0,n.$yG)(f.extension,"defaultChatParticipant"),f.c??f.extension.displayName??f.extension.name},set fullName(u){(0,n.$yG)(f.extension,"defaultChatParticipant"),f.c=u,c()},get iconPath(){return f.d},set iconPath(u){f.d=u,c()},get requestHandler(){return f.x},set requestHandler(u){(0,k.$bg)(typeof u=="function","Invalid request handler"),f.x=u},get followupProvider(){return f.b},set followupProvider(u){f.b=u,c()},get isDefault(){return(0,n.$yG)(f.extension,"defaultChatParticipant"),f.g},set isDefault(u){(0,n.$yG)(f.extension,"defaultChatParticipant"),f.g=u,c()},get helpTextPrefix(){return(0,n.$yG)(f.extension,"defaultChatParticipant"),f.i},set helpTextPrefix(u){(0,n.$yG)(f.extension,"defaultChatParticipant"),f.i=u,c()},get helpTextVariablesPrefix(){return(0,n.$yG)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(u){(0,n.$yG)(f.extension,"defaultChatParticipant"),f.j=u,c()},get helpTextPostfix(){return(0,n.$yG)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(u){(0,n.$yG)(f.extension,"defaultChatParticipant"),f.k=u,c()},get isSecondary(){return(0,n.$yG)(f.extension,"defaultChatParticipant"),f.m},set isSecondary(u){(0,n.$yG)(f.extension,"defaultChatParticipant"),f.m=u,c()},get sampleRequest(){return f.l},set sampleRequest(u){f.l=u,c()},get supportIssueReporting(){return(0,n.$yG)(f.extension,"chatParticipantAdditions"),f.p},set supportIssueReporting(u){(0,n.$yG)(f.extension,"chatParticipantAdditions"),f.p=u,c()},get onDidReceiveFeedback(){return f.n.event},set participantVariableProvider(u){if((0,n.$yG)(f.extension,"chatParticipantAdditions"),f.q=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");f.u.$registerAgentCompletionsProvider(f.w,u.triggerCharacters)}else f.u.$unregisterAgentCompletionsProvider(f.w)},get participantVariableProvider(){return(0,n.$yG)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(u){(0,n.$yG)(f.extension,"defaultChatParticipant"),f.s=u,c()},get welcomeMessageProvider(){return(0,n.$yG)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,n.$xG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(u){f.t=u,c()},get requester(){return f.t},dispose(){i=!0,f.b=void 0,f.n.dispose(),f.u.$unregisterAgent(f.w)}}}invoke(i,b,c,f){return this.x(i,b,c,f)}}}),define(Ae[254],Re([1,0,14,6,4,8,7,25]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class ${static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(A.$PM.MainThreadChatVariables)}async $resolveVariable(y,l,v,m){const s=this.b.get(y);if(s)try{if(s.resolver.resolve2){(0,p.$yG)(s.extension,"chatParticipantAdditions");const o=new k(l,this.c),n=await s.resolver.resolve2(s.data.name,{prompt:v},o.apiObject,m);if(n)return n.map(O.ChatVariable.from)}else{const o=await s.resolver.resolve(s.data.name,{prompt:v},m);if(o)return o.map(O.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(y,l,v,m){const s=$.a++;return this.b.set(s,{extension:y,data:{name:l,description:v},resolver:m}),this.c.$registerVariable(s,{name:l,description:v}),(0,N.$Sc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$tkc=$;class k{constructor(y,l){this.c=y,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(m){if(y.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,m),s}};const y=this,v=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){l(this.progress);const s=new M.$SO(m),o=O.ChatResponseProgressPart.from(s);return v(o),this},reference(m){l(this.reference);const s=new M.$UO(m),o=O.ChatResponseReferencePart.from(s);return v(o),this},push(m){return l(this.push),m instanceof M.$UO?v(O.ChatResponseReferencePart.from(m)):m instanceof M.$SO&&v(O.ChatResponseProgressPart.from(m)),this}}}return this.b}}}),define(Ae[255],Re([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=v;function v(m,s,o){const n=m.getProxy(y.$PM.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Nm,s.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const E=this.b.get(h.handle);return E?E.value:h}else if(h&&h.$mid===7){const E=h,g=this.b.get(E.commentControlHandle);if(!g)return E;const D=g.getCommentThread(E.commentThreadHandle);return D?D.value:E}else if(h&&(h.$mid===9||h.$mid===8)){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const g=E.getCommentThread(h.thread.commentThreadHandle);return g?h.$mid===8?g.value:{thread:g.value,text:h.text}:h}else if(h&&h.$mid===10){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const g=E.getCommentThread(h.thread.commentThreadHandle);if(!g)return h;const D=h.commentUniqueId,w=g.getCommentByUniqueId(D);return w||h}else if(h&&h.$mid===11){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const g=E.getCommentThread(h.thread.commentThreadHandle);if(!g)return h;const D=h.text,w=h.commentUniqueId,C=g.getCommentByUniqueId(w);return C?(typeof C.body=="string"?C.body=D:C.body=new T.$gN(D),C):h}return h}})}createCommentController(h,E,g){const D=r.a++,w=new a(h,D,E,g);this.b.set(w.handle,w);const C=this.c.get(h.identifier)||[];return C.push(w),this.c.set(h.identifier,C),w.value}async $createCommentThreadTemplate(h,E,g){const D=this.b.get(h);D&&D.$createCommentThreadTemplate(E,g)}async $setActiveComment(h,E){const g=this.b.get(h);g&&g.$setActiveComment(E??void 0)}async $updateCommentThreadTemplate(h,E,g){const D=this.b.get(h);D&&D.$updateCommentThreadTemplate(E,g)}$deleteCommentThread(h,E){this.b.get(h)?.$deleteCommentThread(E)}async $provideCommentingRanges(h,E,g){const D=this.b.get(h);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const w=await o.ensureDocumentData(M.URI.revive(E));return(0,I.$ih)(async()=>{const C=await D.commentingRangeProvider.provideCommentingRanges(w.document,g);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(V=>k.Range.from(V)),fileComments:C.fileComments}),P})}$toggleReaction(h,E,g,D,w){const C=this.b.get(h);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$ih)(()=>{const P=C.getCommentThread(E);if(P){const V=P.getCommentByUniqueId(D.uniqueIdInThread);if(C!==void 0&&V&&C.reactionHandler)return C.reactionHandler(V,b(w))}return Promise.resolve(void 0)})}}class t{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,typeof h=="object"?((0,l.$yG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=h.resolved,this.b.applicability=h.applicability):this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,E,g,D,w,C,P,V){this.m=E,this.n=g,this.o=D,this.p=w,this.q=C,this.extensionDescription=P,this.r=V,this.handle=t.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Vc,this.l.value=new O.$Tc,this.n===void 0&&(this.n=`${h}.${this.handle}`),n.$createCommentThread(E,this.handle,this.n,this.o,k.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{n.$deleteCommentThread(E,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(q){W.range=q},get comments(){return W.comments},set comments(q){W.comments=q},get collapsibleState(){return W.collapsibleState},set collapsibleState(q){W.collapsibleState=q},get canReply(){return W.canReply},set canReply(q){W.canReply=q},get contextValue(){return W.contextValue},set contextValue(q){W.contextValue=q},get label(){return W.label},set label(q){W.label=q},get state(){return W.state},set state(q){W.state=q},dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Tc);const h=g=>Object.prototype.hasOwnProperty.call(this.b,g),E={};h("range")&&(E.range=k.Range.from(this.p)),h("label")&&(E.label=this.label),h("contextValue")&&(E.contextValue=this.contextValue??null),h("comments")&&(E.comments=this.q.map(g=>d(this,g,this.k,this.extensionDescription))),h("collapsibleState")&&(E.collapseState=c(this.g)),h("canReply")&&(E.canReply=this.canReply),h("state")&&(E.state=f(this.h)),h("applicability")&&(E.applicability=u(this.h)),h("isTemplate")&&(E.isTemplate=this.r),this.b={},n.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(h){for(const E of this.k){const g=E[0],D=E[1];if(h===D)return g}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Je([(0,N.$Vh)(100)],t.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,h?.resourceHints&&(0,l.$yG)(this.h,"commentingRangeHint"),n.$updateCommentingRanges(this.handle,h?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,n.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,n.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$yG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$yG)(this.h,"activeComment"),this.f}constructor(h,E,g,D){this.h=h,this.i=E,this.j=g,this.k=D,this.a=new Map,n.$registerCommentController(this.handle,g,D,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(C){w.options=C},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(C){w.commentingRangeProvider=C},get reactionHandler(){return w.reactionHandler},set reactionHandler(C){w.reactionHandler=C},get activeCommentThread(){return w.activeCommentThread},createCommentThread(C,P,V){return w.createCommentThread(C,P,V).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{n.$unregisterCommentController(this.handle)}})}createCommentThread(h,E,g){E===void 0&&(0,l.$yG)(this.h,"fileComments");const D=new t(this.id,this.handle,void 0,h,E,g,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(h){if(!h){this.e=void 0,this.f=void 0;return}const E=this.a.get(h.commentThreadHandle);E&&(this.e=h.uniqueIdInThread?E.getCommentByUniqueId(h.uniqueIdInThread):void 0,this.f=E)}$createCommentThreadTemplate(h,E){const g=new t(this.id,this.handle,void 0,M.URI.revive(h),k.Range.to(E),[],this.h,!0);return g.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(h,E){const g=this.a.get(h);g&&(g.range=k.Range.to(E))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.g.forEach(h=>h.dispose())}}function d(S,h,E,g){let D=E.get(h);return D||(D=++S.commentHandle,E.set(h,D)),h.state!==void 0&&(0,l.$yG)(g,"commentsDraftState"),h.reactions?.some(w=>w.reactors!==void 0)&&(0,l.$yG)(g,"commentReactor"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:D,body:typeof h.body=="string"?h.body:k.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(w=>i(w)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function i(S){return{label:S.label,iconPath:S.iconPath?k.$bP(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(h=>h.name):S.reactors}}function b(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?M.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(h=>({name:h}))}}function c(S){if(S!==void 0)switch(S){case T.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function f(S){let h;if(typeof S=="object"?h=S.resolved:h=S,h!==void 0)switch(h){case T.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function u(S){let h;if(typeof S=="object"&&(h=S.applicability),h!==void 0)switch(h){case T.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new r}}),define(Ae[256],Re([1,0,22,99,6,12,24,2,8,63,74,4,7]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class v{constructor(b,c){this.document=b,this.b=c,this.a=1,this.c=new T.$dkc("custom documents")}addEdit(b){return this.c.add([b])}async undo(b,c){await this.f(b).undo(),c||this.disposeBackup()}async redo(b,c){await this.f(b).redo(),c||this.disposeBackup()}disposeEdits(b){for(const c of b)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const b=d(this.document.uri)+this.a++;return(0,M.$4g)(this.b,b)}updateBackup(b){this.d?.delete(),this.d=b}disposeBackup(){this.d?.delete(),this.d=void 0}f(b){const c=this.c.get(b,0);if(!c)throw new Error("No edit found");return c}}class m{constructor(){this.a=new Map}get(b,c){return this.a.get(this.b(b,c))}add(b,c,f){const u=this.b(b,c.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${b} resource:${c.uri}`);const S=new v(c,f);return this.a.set(u,S),S}delete(b,c){const f=this.b(b,c.uri);this.a.delete(f)}b(b,c){return`${b}@@@${c}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider(b,c,f){return this.b(0,b,c,f)}addCustomProvider(b,c,f){return this.b(1,b,c,f)}get(b){return this.a.get(b)}b(b,c,f,u){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:b,extension:f,provider:u}),new l.$RM(()=>this.a.delete(c))}}class n{constructor(b,c,f,u,S){this.d=c,this.f=f,this.g=u,this.h=S,this.b=new o,this.c=new m,this.a=b.getProxy(y.$PM.MainThreadCustomEditors)}registerCustomEditorProvider(b,c,f,u){const S=new A.$Tc;return t(f)?(S.add(this.b.addTextProvider(c,b,f)),this.a.$registerTextEditorProvider((0,k.$Mkc)(b),c,u.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,k.$Kkc)(b))):(S.add(this.b.addCustomProvider(c,b,f)),r(f)&&S.add(f.onDidChangeCustomDocument(h=>{const E=this.i(c,h.document.uri);if(a(h)){const g=E.addEdit(h);this.a.$onDidEdit(h.document.uri,c,g,h.label)}else this.a.$onContentChange(h.document.uri,c)})),this.a.$registerCustomEditorProvider((0,k.$Mkc)(b),c,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,k.$Kkc)(b))),l.$RM.from(S,new l.$RM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(b,c,f,u,S){const h=this.b.get(c);if(!h)throw new Error(`No provider found for '${c}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${c}'`);const E=p.URI.revive(b),g=await h.provider.openCustomDocument(E,{backupId:f,untitledDocumentData:u?.buffer},S);let D;return r(h.provider)&&this.f&&(D=this.f.workspaceValue(h.extension)??this.f.globalValue(h.extension)),this.c.add(c,g,D),{editable:r(h.provider)}}async $disposeCustomDocument(b,c){const f=this.b.get(c);if(!f)throw new Error(`No provider found for '${c}'`);if(f.type!==1)throw new Error(`Invalid provider type for '${c}'`);const u=p.URI.revive(b),{document:S}=this.i(c,u);this.c.delete(c,S),S.dispose()}async $resolveCustomEditor(b,c,f,u,S,h){const E=this.b.get(f);if(!E)throw new Error(`No provider found for '${f}'`);const g=$.ViewColumn.to(S),D=this.g.createNewWebview(c,u.contentOptions,E.extension),w=this.h.createNewWebviewPanel(c,f,u.title,g,u.options,D,u.active),C=p.URI.revive(b);switch(E.type){case 1:{const{document:P}=this.i(f,C);return E.provider.resolveCustomEditor(P,w,h)}case 0:{const P=this.d.getDocument(C);return E.provider.resolveCustomTextEditor(P,w,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(b,c,f){this.i(c,b).disposeEdits(f)}async $onMoveCustomEditor(b,c,f){const u=this.b.get(f);if(!u)throw new Error(`No provider found for '${f}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const S=this.h.getWebviewPanel(b);if(!S)throw new Error("No webview found");const h=p.URI.revive(c),E=this.d.getDocument(h);await u.provider.moveCustomTextEditor(E,S,I.CancellationToken.None)}async $undo(b,c,f,u){return this.i(c,b).undo(f,u)}async $redo(b,c,f,u){return this.i(c,b).redo(f,u)}async $revert(b,c,f){const u=this.i(c,b);await this.j(c).revertCustomDocument(u.document,f),u.disposeBackup()}async $onSave(b,c,f){const u=this.i(c,b);await this.j(c).saveCustomDocument(u.document,f),u.disposeBackup()}async $onSaveAs(b,c,f,u){const S=this.i(c,b);return this.j(c).saveCustomDocumentAs(S.document,p.URI.revive(f),u)}async $backup(b,c,f){const u=this.i(c,b),h=await this.j(c).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},f);return u.updateBackup(h),h.id}i(b,c){const f=this.c.get(b,p.URI.revive(c));if(!f)throw new Error("No custom document found");return f}j(b){const f=this.b.get(b)?.provider;if(!f||!r(f))throw new Error("Custom document is not editable");return f}}e.$Pkc=n;function r(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function a(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function d(i){const b=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,N.$ej)(b)+""}}),define(Ae[257],Re([1,0,164,100,2,4,7,8,5,13,28,45]),function(fe,e,I,N,A,O,M,p,$,k,T,y){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=void 0;class v{#e;#t;#i;constructor(o,n,r,t,a,d,i,b){this.d=o,this.e=n,this.f=r,this.g=t,this.h=a,this.c=!1,this.f=Math.max(t,r),this.#i=new T.$Bc(c=>d.getComparisonKey(c)),this.#e=i,this.#t=b}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,n){if(!o){this.clear();return}this.j();let r=[];if(A.URI.isUri(o)){if(!n){this.delete(o);return}this.#i.set(o,n.slice()),r=[o]}else if(Array.isArray(o)){r=[];let d;o=[...o].sort(v.k);for(const i of o){const[b,c]=i;if((!d||b.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=b,r.push(b),this.#i.set(b,[])),c)this.#i.get(b)?.push(...c);else{const f=this.#i.get(b);f&&(f.length=0)}}}if(this.#t.fire(r),!this.#e)return;const t=[];let a=0;for(const d of r){let i=[];const b=this.#i.get(d);if(b)if(b.length>this.g){i=[];const c=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const u of b)if(u.severity===c[f]&&i.push({...p.Diagnostic.from(u),modelVersionId:this.h(d)})===this.g)break e;i.push({severity:N.MarkerSeverity.Info,message:(0,I.localize)(0,null,b.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=b.map(c=>({...p.Diagnostic.from(c),modelVersionId:this.h(d)}));if(t.push([d,i]),a+=i.length,a>this.f)break}this.#e.$changeMany(this.e,t)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,n){this.j();for(const[r,t]of this)o.call(n,r,t,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const n=this.#i.get(o);return Array.isArray(n)?Object.freeze(n.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,n){return o[0].toString()<n[0].toString()?-1:o[0].toString()>n[0].toString()?1:0}}e.$kkc=v;let m=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const n=new T.$Bc;for(const r of o)n.set(r,r);return{uris:Object.freeze(Array.from(n.values()))}}constructor(o,n,r,t){this.j=n,this.k=r,this.l=t,this.g=new Map,this.h=new $.$fe({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,l._mapper),this.f=o.getProxy(O.$PM.MainThreadDiagnostics)}createDiagnosticCollection(o,n){const{g:r,f:t,h:a,j:d,k:i,l:b}=this,c=new class{$changeMany(S,h){t.$changeMany(S,h),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,S,h.length===0?"CLEARING":h)}$clear(S){t.$clear(S),d.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,S)}dispose(){t.dispose()}};let f;if(!n)n="_generated_diagnostic_collection_name_#"+l.c++,f=n;else if(!r.has(n))f=n;else{this.j.warn(`DiagnosticCollection with name '${n}' does already exist.`);do f=n+l.c++;while(r.has(f))}return new class extends v{constructor(){super(n,f,l.e,l.d,S=>b.getDocument(S)?.version,i.extUri,c,a),r.set(f,this)}dispose(){super.dispose(),r.delete(f)}}}getDiagnostics(o){if(o)return this.m(o);{const n=new Map,r=[];for(const t of this.g.values())t.forEach((a,d)=>{let i=n.get(a.toString());typeof i>"u"&&(i=r.length,n.set(a.toString(),i),r.push([a,[]])),r[i][1]=r[i][1].concat(...d)});return r}}m(o){let n=[];for(const r of this.g.values())r.has(o)&&(n=n.concat(r.get(o)));return n}$acceptMarkersChange(o){if(!this.n){const n="_generated_mirror",r=new v(n,n,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(n,r),this.n=r}for(const[n,r]of o)this.n.set(A.URI.revive(n),r.map(p.Diagnostic.to))}};e.$lkc=m,e.$lkc=m=l=Je([Ve(1,k.$Wj),Ve(2,y.$jkc)],m)}),define(Ae[258],Re([1,0,2,14,7,8,193,34]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class ${constructor(T,y,l,v={timeout:1500,errors:3}){this.c=T,this.d=y,this.f=l,this.g=v,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(y,l,v)=>{const s={dispose:this.a.push([y,l,T])};return Array.isArray(v)&&v.push(s),s}}async $participateInSave(T,y){const l=I.URI.revive(T);let v=!1;const m=setTimeout(()=>v=!0,this.g.timeout),s=[];try{for(const o of[...this.a]){if(v)break;const n=this.d.getDocument(l),r=await this.h(o,{document:n,reason:O.TextDocumentSaveReason.to(y)});s.push(r)}}finally{clearTimeout(m)}return s}h([T,y,l],v){const m=this.b.get(T);return typeof m=="number"&&m>this.g.errors?Promise.resolve(!1):this.i(l,T,y,v).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,y,l,v){const m=[],s=Date.now(),{document:o,reason:n}=v,{version:r}=o,t=Object.freeze({document:o,reason:n,waitUntil(a){if(Object.isFrozen(m))throw(0,N.$8)("waitUntil can not be called async");m.push(Promise.resolve(a))}});try{y.apply(l,[t])}catch(a){return Promise.reject(a)}return Object.freeze(m),new Promise((a,d)=>{const i=setTimeout(()=>d(new Error("timeout")),this.g.timeout);return Promise.all(m).then(b=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(i),a(b)}).catch(b=>{clearTimeout(i),d(b)})}).then(a=>{const d={edits:[]};for(const i of a)if(Array.isArray(i)&&i.every(b=>b instanceof A.$YM))for(const{newText:b,newEol:c,range:f}of i)d.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:f&&O.Range.from(f),text:b,eol:c&&O.EndOfLine.from(c)}});if(d.edits.length!==0)return r===o.version?this.f.$tryApplyWorkspaceEdit(new p.$mw(d)):Promise.reject(new Error("concurrent_edits"))})}}e.$tlc=$}),define(Ae[259],Re([1,0,5,6,2,4,111,8,17,26,7]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=void 0;class y{constructor(v,m){this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=v.getProxy(O.$PM.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const m=this.g.getDocument(v);if(m)return m}getDocument(v){const m=this.getDocumentData(v);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return m.document}ensureDocumentData(v){const m=this.g.getDocument(v);if(m)return Promise.resolve(m);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const n=A.URI.revive(o);return(0,$.$cg)(this.g.getDocument(n))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then(m=>A.URI.revive(m))}$acceptModelLanguageChanged(v,m){const s=A.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(v){const m=A.URI.revive(v),s=this.g.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,m){const s=A.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,m,s){const o=A.URI.revive(v),n=this.g.getDocument(o);if(!n)throw new Error("unknown document");n._acceptIsDirty(s),n.onEvents(m);let r;m.isUndoing?r=T.TextDocumentChangeReason.Undo:m.isRedoing&&(r=T.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Xn)({document:n.document,contentChanges:m.changes.map(t=>({range:p.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:r}))}setWordDefinitionFor(v,m){(0,M.$eP)(v,m)}}e.$mkc=y}),define(Ae[66],Re([1,0,260,5,17,2,3,4,16,8,7]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=void 0,e.$Qkc=(0,M.$qi)("IExtHostEditorTabs");class y{constructor(o,n,r){this.e=r,this.d=n,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,n={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(n)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$BO(O.URI.revive(this.b.input.uri));case 2:return new T.$CO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new T.$DO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new T.$EO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$FO(this.b.input.viewType);case 4:return new T.$GO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$HO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$IO;case 9:return new T.$JO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$KO;case 11:return new T.$LO(this.b.input.diffEditors.map(o=>new T.$CO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class l{constructor(o,n){this.c=[],this.d="",this.b=o,this.e=n;for(const r of o.tabs)r.isActive&&(this.d=r.id),this.c.push(new y(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,n={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return k.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(r=>r.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(r=>r.apiObject))}};this.a=Object.freeze(n)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const r=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,r),o.tabDto.isActive&&(this.d=r.tabId),r}else if(o.kind===1){const r=this.c.splice(o.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(o.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,r),r}const n=this.c.find(r=>r.tabId===o.tabDto.id);if(!n)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),n.acceptDtoUpdate(o.tabDto),n}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new N.$be,this.c=new N.$be,this.e=[],this.a=o.getProxy(p.$PM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,n={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(r=>r.apiObject))},get activeTabGroup(){const r=o.d;return(0,A.$cg)(o.e.find(a=>a.groupId===r)?.apiObject)},close:async(r,t)=>{const a=Array.isArray(r)?r:[r];return a.length?m(a[0])?this.j(a,t):this.i(a,t):!0}};this.f=Object.freeze(n)}return this.f}$acceptEditorTabModel(o){const n=new Set(this.e.map(c=>c.groupId)),r=new Set(o.map(c=>c.groupId)),t=(0,I.$L)(n,r),a=this.e.filter(c=>t.removed.includes(c.groupId)).map(c=>c.apiObject),d=[],i=[];this.e=o.map(c=>{const f=new l(c,()=>this.d);return t.added.includes(f.groupId)?d.push(f.apiObject):i.push(f.apiObject),f});const b=(0,A.$cg)(o.find(c=>c.isActive===!0)?.groupId);b!==void 0&&this.d!==b&&(this.d=b),this.c.fire(Object.freeze({opened:d,closed:a,changed:i}))}$acceptTabGroupUpdate(o){const n=this.e.find(r=>r.groupId===o.groupId);if(!n)throw new Error("Update Group IPC call received before group creation.");n.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[n.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const n=this.e.find(t=>t.groupId===o.groupId);if(!n)throw new Error("Update Tabs IPC call received before group creation.");const r=n.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(o){for(const n of this.e)for(const r of n.tabs)if(r.apiObject===o)return r}h(o){return this.e.find(n=>n.apiObject===o)}async i(o,n){const r=[];for(const t of o){const a=this.g(t);if(!a)throw new Error("Tab close: Invalid tab not found!");r.push(a.tabId)}return this.a.$closeTab(r,n)}async j(o,n){const r=[];for(const t of o){const a=this.h(t);if(!a)throw new Error("Group close: Invalid group not found!");r.push(a.groupId)}return this.a.$closeGroup(r,n)}};e.$Rkc=v,e.$Rkc=v=Je([Ve(0,$.$cP)],v);function m(s){return s.tabs!==void 0}}),define(Ae[261],Re([1,0,2,4,6,7,8,304,15,23,25,54]),function(fe,e,I,N,A,O,M,p,$,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const o=this.a.indexOf(s);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),o=[];let n,r,t=14,a=14;for(const d of s){let i=n?(0,$.$vf)(n,d):0;for(i===0?r=1:r=a;i<d.length;i++)i+1===d.length?(t=a,a=9):a+=1,o.push([r,d.toUpperCase().charCodeAt(i),a]),o.push([r,d.toLowerCase().charCodeAt(i),a]),r=a;n=d,a=t}o.push([9,58,10]),o.push([10,47,12]),this.b=new p.$32(o)}}provideDocumentLinks(s){this.c();const o=[],n=p.$42.computeLinks({getLineContent(r){return s.lineAt(r-1).text},getLineCount(){return s.lineCount}},this.b);for(const r of n){const t=M.DocumentLink.to(r);t.target&&o.push(t)}return o}}class v{constructor(s,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(N.$PM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,o,n,r={}){if(v.j(n),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const t=this.h++;this.b.add(o),this.d.add(o),this.c.set(t,n);let a=2;r.isCaseSensitive&&(a+=1024),r.isReadonly&&(a+=2048),typeof n.copy=="function"&&(a+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,T.$yG)(s,"fsChunks"),a+=4);let d;r.isReadonly&&(0,y.$Pk)(r.isReadonly)&&r.isReadonly.value!==""&&(d={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,o,a,d).catch(b=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${o}`),console.error(b)});const i=n.onDidChangeFile(b=>{const c=[];for(const f of b){const{uri:u,type:S}=f;if(u.scheme!==o)continue;let h;switch(S){case O.FileChangeType.Changed:h=0;break;case O.FileChangeType.Created:h=1;break;case O.FileChangeType.Deleted:h=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:u,type:h})}this.a.$onFileSystemChange(t,c)});return(0,A.$Sc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:o,ctime:n,mtime:r,size:t,permissions:a}=s;return{type:o,ctime:n,mtime:r,size:t,permissions:a}}$stat(s,o){return Promise.resolve(this.l(s).stat(I.URI.revive(o))).then(n=>v.k(n))}$readdir(s,o){return Promise.resolve(this.l(s).readDirectory(I.URI.revive(o)))}$readFile(s,o){return Promise.resolve(this.l(s).readFile(I.URI.revive(o))).then(n=>k.$Ce.wrap(n))}$writeFile(s,o,n,r){return Promise.resolve(this.l(s).writeFile(I.URI.revive(o),n.buffer,r))}$delete(s,o,n){return Promise.resolve(this.l(s).delete(I.URI.revive(o),n))}$rename(s,o,n,r){return Promise.resolve(this.l(s).rename(I.URI.revive(o),I.URI.revive(n),r))}$copy(s,o,n,r){const t=this.l(s);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(I.URI.revive(o),I.URI.revive(n),r))}$mkdir(s,o){return Promise.resolve(this.l(s).createDirectory(I.URI.revive(o)))}$watch(s,o,n,r){const t=this.l(s).watch(I.URI.revive(n),r);this.f.set(o,t)}$unwatch(s,o){const n=this.f.get(o);n&&(n.dispose(),this.f.delete(o))}$open(s,o,n){const r=this.l(s);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(I.URI.revive(o),n))}$close(s,o){const n=this.l(s);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(o))}$read(s,o,n,r){const t=this.l(s);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const a=k.$Ce.alloc(r);return Promise.resolve(t.read(o,n,a.buffer,0,r)).then(d=>a.slice(0,d))}$write(s,o,n,r){const t=this.l(s);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(o,n,r.buffer,0,r.byteLength))}l(s){const o=this.c.get(s);if(!o){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return o}}e.$vlc=v}),define(Ae[262],Re([1,0,5,36,2,4,8,7,41]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,m,s,o,n,r){this.a=Math.random(),this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const t=(0,N.$kk)(n),a=typeof n=="string",d=r?.correlate,i=o(b=>{if(!(typeof b.session=="number"&&b.session!==this.a)&&!(d&&typeof b.session>"u")){if(!r?.ignoreCreateEvents)for(const c of b.created){const f=A.URI.revive(c);t(f.fsPath)&&(!a||m.getWorkspaceFolder(f))&&this.b.fire(f)}if(!r?.ignoreChangeEvents)for(const c of b.changed){const f=A.URI.revive(c);t(f.fsPath)&&(!a||m.getWorkspaceFolder(f))&&this.c.fire(f)}if(!r?.ignoreDeleteEvents)for(const c of b.deleted){const f=A.URI.revive(c);t(f.fsPath)&&(!a||m.getWorkspaceFolder(f))&&this.d.fire(f)}}});this.g=p.$RM.from(this.i(v,s,n,r,r?.correlate),this.b,this.c,this.d,i)}i(v,m,s,o,n){const r=p.$RM.from();if(typeof s=="string")return r;const t=v.getProxy(O.$PM.MainThreadFileSystemEventService);let a=!1;return(s.pattern.includes(N.$gk)||s.pattern.includes(N.$hk))&&(a=!0),t.$watch(m.identifier.value,this.a,s.baseUri,{recursive:a,excludes:o?.excludes??[]},!!n),p.$RM.from({dispose:()=>t.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(v){this.a=v,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(A.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(A.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class y{constructor(v,m,s){this.j=v,this.k=m,this.l=s,this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.g=new I.$de,this.h=new I.$de,this.i=new I.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,m,s,o){return new k(this.j,v,m,this.a.event,M.GlobPattern.from(s),o)}$onFileEvent(v){this.a.fire(new T(v))}$onDidRunFileOperation(v,m){switch(v){case 2:this.b.fire(Object.freeze({files:m.map(s=>({oldUri:A.URI.revive(s.source),newUri:A.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(s=>A.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(s=>A.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,m){return(s,o,n)=>{const r=function(a){s.call(o,a)};return r.extension=v,m.event(r,void 0,n)}}async $onWillRunFileOperation(v,m,s,o){switch(v){case 2:return await this.n(this.g,{files:m.map(n=>({oldUri:A.URI.revive(n.source),newUri:A.URI.revive(n.target)}))},s,o);case 1:return await this.n(this.i,{files:m.map(n=>A.URI.revive(n.target))},s,o);case 0:case 3:return await this.n(this.h,{files:m.map(n=>A.URI.revive(n.target))},s,o)}}async n(v,m,s,o){const n=new Set,r=[];if(await v.fireAsync(m,o,async(a,d)=>{const i=Date.now(),b=await Promise.resolve(a);b instanceof p.$2M&&(r.push([d.extension,b]),n.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",d.extension.identifier)}),o.isCancellationRequested||r.length===0)return;const t={edits:[]};for(const[,a]of r){const{edits:d}=M.WorkspaceEdit.from(a,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});t.edits=t.edits.concat(d)}return{edit:t,extensionNames:Array.from(n)}}}e.$wlc=y}),define(Ae[263],Re([1,0,18,11,22,14,90,6,26,65,15,17,2,29,305,87,97,166,20,8,7,25,74,4]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a,d,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=void 0;class c{constructor(z,L){this.d=z,this.e=L}async provideDocumentSymbols(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(G,L);if(!(0,I.$Kb)(H))return H[0]instanceof a.$$M?H.map(t.DocumentSymbol.from):c.f(H)}static f(z){z=z.slice(0).sort((H,ee)=>{let re=H.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(H.location.range.end)),re});const L=[],G=[];for(const H of z){const ee={name:H.name||"!!MISSING: name!!",kind:t.SymbolKind.from(H.kind),tags:H.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:t.Range.from(H.location.range),selectionRange:t.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),L.push(ee);break}const re=G[G.length-1];if(v.$kt.containsRange(re.range,ee.range)&&!v.$kt.equalsRange(re.range,ee.range)){re.children?.push(ee),G.push(ee);break}G.pop()}}return L}}class f{constructor(z,L,G,H,ee,re){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.l=re,this.d=new i.$dkc("CodeLens"),this.e=new Map}async provideCodeLenses(z,L){const G=this.f.getDocument(z),H=await this.h.provideCodeLenses(G,L);if(!H||L.isCancellationRequested)return;const ee=this.d.add(H),re=new p.$Tc;this.e.set(ee,re);const Te={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Te.lenses.push({cacheId:[ee,Be],range:t.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,re)});return Te}async resolveCodeLens(z,L){const G=z.cacheId&&this.d.get(...z.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,L),H||(H=G),L.isCancellationRequested)return;const ee=z.cacheId&&this.e.get(z.cacheId[0]);if(ee){if(!H.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return z.command=this.g.toInternal(H.command,ee),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function u(ze){return Array.isArray(ze)?ze.map(t.DefinitionLink.from):ze?[t.DefinitionLink.from(ze)]:[]}class S{constructor(z,L){this.d=z,this.e=L}async provideDefinition(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideDefinition(H,ee,G);return u(re)}}class h{constructor(z,L){this.d=z,this.e=L}async provideDeclaration(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideDeclaration(H,ee,G);return u(re)}}class E{constructor(z,L){this.d=z,this.e=L}async provideImplementation(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideImplementation(H,ee,G);return u(re)}}class g{constructor(z,L){this.d=z,this.e=L}async provideTypeDefinition(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideTypeDefinition(H,ee,G);return u(re)}}class D{constructor(z,L){this.d=z,this.e=L}async provideHover(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideHover(H,ee,G);if(!(!re||(0,I.$Kb)(re.contents)))return re.range||(re.range=H.getWordRangeAtPosition(ee)),re.range||(re.range=new a.$TM(ee,ee)),t.Hover.from(re)}}class w{constructor(z,L){this.d=z,this.e=L}async provideEvaluatableExpression(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideEvaluatableExpression(H,ee,G);if(re)return t.EvaluatableExpression.from(re)}}class C{constructor(z,L){this.d=z,this.e=L}async provideInlineValues(z,L,G,H){const ee=this.d.getDocument(z),re=await this.e.provideInlineValues(ee,t.Range.to(L),t.InlineValueContext.to(G),H);if(Array.isArray(re))return re.map(Te=>t.InlineValue.from(Te))}}class P{constructor(z,L){this.d=z,this.e=L}async provideDocumentHighlights(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(re))return re.map(t.DocumentHighlight.from)}}class V{constructor(z,L){this.d=z,this.e=L}async provideMultiDocumentHighlights(z,L,G,H){const ee=this.d.getDocument(z),re=G.map(Qe=>this.d.getDocument(Qe)),Te=t.Position.to(L),Be=await this.e.provideMultiDocumentHighlights(ee,Te,re,H);if(Array.isArray(Be))return Be.map(t.MultiDocumentHighlight.from)}}class W{constructor(z,L){this.d=z,this.e=L}async provideLinkedEditingRanges(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideLinkedEditingRanges(H,ee,G);if(re&&Array.isArray(re.ranges))return{ranges:(0,I.$Hb)(re.ranges.map(t.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(z,L){this.d=z,this.e=L}async provideReferences(z,L,G,H){const ee=this.d.getDocument(z),re=t.Position.to(L),Te=await this.e.provideReferences(ee,re,G,H);if(Array.isArray(Te))return Te.map(t.location.from)}}class R{static{this.d=1e3}constructor(z,L,G,H,ee,re,Te){this.g=z,this.h=L,this.j=G,this.k=H,this.l=ee,this.m=re,this.n=Te,this.e=new i.$dkc("CodeAction"),this.f=new Map}async provideCodeActions(z,L,G,H){const ee=this.g.getDocument(z),re=m.$mt.isISelection(L)?t.Selection.to(L):t.Range.to(L),Te=[];for(const it of this.j.getDiagnostics(z))if(re.intersection(it.range)&&Te.push(it)>R.d)break;const Be={diagnostics:Te,only:G.only?new a.$aN(G.only):void 0,triggerKind:t.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(ee,re,Be,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const _e=this.e.add(Qe),et=new p.$Tc;this.f.set(_e,et);const tt=[];for(let it=0;it<Qe.length;it++){const nt=Qe[it];if(nt)if(R.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,et)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=nt.ranges??[];tt.push({cacheId:[_e,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,et),diagnostics:nt.diagnostics&&nt.diagnostics.map(t.Diagnostic.from),edit:nt.edit&&t.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,d.$xG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,d.$xG)(this.m,"codeActionRanges")?(0,I.$Hb)(at.map(t.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:_e,actions:tt}}async resolveCodeAction(z,L){const[G,H]=z,ee=this.e.get(G,H);if(!ee||R.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,L)??ee;let Te;re.edit&&(Te=t.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const Qe=this.f.get(G);Qe&&(Be=this.h.toInternal(re.command,Qe))}return{edit:Te,command:Be}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class U{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new i.$dkc("DocumentPasteEdit")}async prepareDocumentPaste(z,L,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(z),re=L.map(Qe=>t.Range.to(Qe)),Te=t.DataTransfer.toDataTransfer(G,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(ee,re,Te,H),H.isCancellationRequested)return;const Be=Array.from(Te).filter(([,Qe])=>!(Qe instanceof a.$GN));return t.DataTransfer.from(Be)}async providePasteEdits(z,L,G,H,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(L),Be=G.map(tt=>t.Range.to(tt)),Qe=t.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolvePasteFileData(this.h,z,tt)).buffer),_e=await this.g.provideDocumentPasteEdits(Te,Be,Qe,{only:ee.only?new a.$LN(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,n.localize)(0,null,this.j.displayName||this.j.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?t.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?t.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class K{constructor(z,L){this.d=z,this.e=L}async provideDocumentFormattingEdits(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentFormattingEdits(H,L,G);if(Array.isArray(ee))return ee.map(t.TextEdit.from)}}class se{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeFormattingEdits(z,L,G,H){const ee=this.d.getDocument(z),re=t.Range.to(L),Te=await this.e.provideDocumentRangeFormattingEdits(ee,re,G,H);if(Array.isArray(Te))return Te.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,L,G,H){(0,y.$bg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(z),re=L.map(t.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(ee,re,G,H);if(Array.isArray(Te))return Te.map(t.TextEdit.from)}}class ce{constructor(z,L){this.d=z,this.e=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,L,G,H,ee){const re=this.d.getDocument(z),Te=t.Position.to(L),Be=await this.e.provideOnTypeFormattingEdits(re,Te,G,H,ee);if(Array.isArray(Be))return Be.map(t.TextEdit.from)}}class ve{constructor(z,L){this.e=z,this.f=L,this.d=new i.$dkc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,L){const G=await this.e.provideWorkspaceSymbols(z,L);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let re=0;re<G.length;re++){const Te=G[re];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}ee.symbols.push({...t.WorkspaceSymbol.from(Te),cacheId:[H,re]})}return ee}async resolveWorkspaceSymbol(z,L){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const G=this.d.get(...z.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,L);return H&&(0,$.$Zn)(z,t.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Ie{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideRenameEdits(z,L,G,H){const ee=this.d.getDocument(z),re=t.Position.to(L);try{const Te=await this.e.provideRenameEdits(ee,re,G,H);return Te?t.WorkspaceEdit.from(Te):void 0}catch(Te){const Be=Ie.g(Te);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(z,L,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),ee=t.Position.to(L);try{const re=await this.e.prepareRename(H,ee,G);let Te,Be;if(a.$TM.isRange(re)?(Te=re,Be=H.getText(re)):(0,y.$6f)(re)&&(Te=re.range,Be=re.placeholder),!Te||!Be)return;if(Te.start.line>ee.line||Te.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Te),text:Be}}catch(re){const Te=Ie.g(re);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(re)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideNewSymbolNames(z,L,G){const H=this.d.getDocument(z),ee=t.Range.to(L);try{const re=await this.e.provideNewSymbolNames(H,ee,G);return re?re.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(re){this.f.error(ue.g(re)??JSON.stringify(re,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class be{constructor(z,L){this.resultId=z,this.tokens=L}}class ie{constructor(z,L){this.f=z,this.g=L,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,L,G){const H=this.f.getDocument(z),ee=L!==0?this.d.get(L):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(L),re?(re=ie.h(re),this.o(ie.n(ee,re),re)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return ie.j(z)?ie.k(z)?z:new a.$_N(new Uint32Array(z.data),z.resultId):ie.l(z)?ie.m(z)?z:new a.$bO(z.edits.map(L=>new a.$aO(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const L of z.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static n(z,L){if(!ie.j(L)||!z||!z.tokens)return L;const G=z.tokens,H=G.length,ee=L.data,re=ee.length;let Te=0;const Be=Math.min(H,re);for(;Te<Be&&G[Te]===ee[Te];)Te++;if(Te===H&&Te===re)return new a.$bO([],L.resultId);let Qe=0;const _e=Be-Te;for(;Qe<_e&&G[H-Qe-1]===ee[re-Qe-1];)Qe++;return new a.$bO([{start:Te,deleteCount:H-Te-Qe,data:ee.subarray(Te,re-Qe)}],L.resultId)}o(z,L){if(ie.j(z)){const G=this.e++;return this.d.set(G,new be(z.resultId,z.data)),(0,o.$tbb)({id:G,type:"full",data:z.data})}if(ie.l(z)){const G=this.e++;return ie.j(L)?this.d.set(G,new be(L.resultId,L.data)):this.d.set(G,new be(z.resultId)),(0,o.$tbb)({id:G,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Pe{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeSemanticTokens(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentRangeSemanticTokens(H,t.Range.to(L),G);return ee?this.f(ee):null}f(z){return(0,o.$tbb)({id:0,type:"full",data:z.data})}}class Fe{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new i.$dkc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,L,G,H){const ee=this.f.getDocument(z),re=t.Position.to(L),Te=ee.getWordRangeAtPosition(re)||new a.$TM(re,re),Be=Te.with({end:re}),Qe=new k.$0d,_e=await this.h.provideCompletionItems(ee,re,H,t.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const et=Array.isArray(_e)?new a.$nN(_e):_e,tt=Fe.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new p.$Tc;this.e.set(tt,it);const nt=[],at={x:tt,b:nt,a:{replace:t.Range.from(Te),insert:t.Range.from(Be)},c:et.isIncomplete||void 0,d:Qe.elapsed()};for(let mt=0;mt<et.items.length;mt++){const je=et.items[mt],st=this.l(je,[tt,mt],Be,Te);nt.push(st)}return at}async resolveCompletionItem(z,L){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...z);if(!G)return;const H=this.l(G,z),ee=await this.h.resolveCompletionItem(G,L);if(!ee)return;const re=this.l(ee,z);return(H.h!==re.h||H.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==re.n||H.o!==re.o||!(0,$.$1n)(H.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L,G,H){const ee=this.e.get(L[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(z.command,ee),Te={x:L,a:z.label,b:z.kind!==void 0?t.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(t.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:t.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(t.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=z.textEdit.newText):typeof z.insertText=="string"?Te.h=z.insertText:z.insertText instanceof a.$3M&&(Te.h=z.insertText.value,Te.i|=4);let Be;return z.textEdit?Be=z.textEdit.range:z.range&&(Be=z.range),a.$TM.isRange(Be)?Te.j=t.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Te.j={insert:t.Range.from(Be.inserting),replace:t.Range.from(Be.replacing)}),Te}}class ne{async provideInlineCompletions(z,L,G,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,L,G){}handlePartialAccept(z,L,G,H){}}class j extends ne{constructor(z,L,G,H){super(),this.f=z,this.g=L,this.h=G,this.j=H,this.d=new pe,this.e=(0,d.$xG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,d.$xG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,L,G,H){const ee=this.g.getDocument(z),re=t.Position.to(L),Te=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:t.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Te||H.isCancellationRequested)return;const Be=Array.isArray(Te)?Te:Te.items,Qe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],_e=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Be}),items:Be.map((it,nt)=>{let at;it.command&&(et||(et=new p.$Tc),at=this.j.toInternal(it.command,et));const mt=it.insertText;return{insertText:typeof mt=="string"?mt:{snippet:mt.value},filterText:it.filterText,range:it.range?t.Range.from(it.range):void 0,command:at,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(et||(et=new p.$Tc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,L,G){const H=this.d.get(z)?.items[L];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(z,L,G,H){const ee=this.d.get(z)?.items[L];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,t.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(z,L,G){const H=this.f.getDocument(z),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[L.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let re;const Te=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new p.$Tc),Be=this.h.toInternal(ee.accepted,re));let Qe;return ee.rejected&&(re||(re=new p.$Tc),Qe=this.h.toInternal(ee.rejected,re)),{pid:Te,text:ee.text,range:t.Range.from(ee.range),accepted:Be,rejected:Qe}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,L,G,H){this.f=L,this.g=G,this.h=H,this.d=new pe,this.e={[s.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const L=this.e++;return this.d.set(L,z),L}disposeReferenceId(z){const L=this.d.get(z);return this.d.delete(z),L}get(z){return this.d.get(z)}}class Oe{constructor(z,L){this.e=z,this.f=L,this.d=new i.$dkc("SignatureHelp")}async provideSignatureHelp(z,L,G,H){const ee=this.e.getDocument(z),re=t.Position.to(L),Te=this.g(G),Be=await this.f.provideSignatureHelp(ee,re,H,Te);if(Be){const Qe=this.d.add([Be]);return{...t.SignatureHelp.from(Be),id:Qe}}}g(z){let L;if(z.activeSignatureHelp){const G=t.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(L=H,L.activeSignature=G.activeSignature,L.activeParameter=G.activeParameter):L=G}return{...z,activeSignatureHelp:L}}releaseSignatureHelp(z){this.d.delete(z)}}class ke{constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new i.$dkc("InlayHints"),this.e=new Map}async provideInlayHints(z,L,G){const H=this.f.getDocument(z),ee=t.Range.to(L),re=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`);return}if(G.isCancellationRequested)return;const Te=this.d.add(re);this.e.set(Te,new p.$Tc);const Be={hints:[],cacheId:Te};for(let Qe=0;Qe<re.length;Qe++)this.l(re[Qe],ee)&&Be.hints.push(this.m(re[Qe],[Te,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`),Be}async resolveInlayHint(z,L){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.h.resolveInlayHint(G,L);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L){return z.label.length===0||Array.isArray(z.label)&&z.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(L&&!L.contains(z.position))}m(z,L){const G=this.e.get(L[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:L,tooltip:t.MarkdownString.fromStrict(z.tooltip),position:t.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(t.TextEdit.from),kind:z.kind&&t.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const ee=[];H.label=ee;for(const re of z.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:re.value,tooltip:t.MarkdownString.fromStrict(re.tooltip)};a.$4M.isLocation(re.location)&&(Te.location=t.location.from(re.location)),re.command&&(Te.command=this.g.toInternal(re.command,G)),ee.push(Te)}}return H}}class $e{constructor(z,L){this.e=z,this.f=L,this.d=new i.$dkc("DocumentLink")}async provideLinks(z,L){const G=this.e.getDocument(z),H=await this.f.provideDocumentLinks(G,L);if(!(!Array.isArray(H)||H.length===0)&&!L.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter($e.g).map(t.DocumentLink.from)};{const ee=this.d.add(H),re={links:[],cacheId:ee};for(let Te=0;Te<H.length;Te++){if(!$e.g(H[Te]))continue;const Be=t.DocumentLink.from(H[Te]);Be.cacheId=[ee,Te],re.links.push(Be)}return re}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,L){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.f.resolveDocumentLink(G,L);if(!(!H||!$e.g(H)))return t.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class ge{constructor(z,L){this.d=z,this.e=L}async provideColors(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentColors(G,L);return Array.isArray(H)?H.map(re=>({color:t.Color.from(re.color),range:t.Range.from(re.range)})):[]}async provideColorPresentations(z,L,G){const H=this.d.getDocument(z),ee=t.Range.to(L.range),re=t.Color.to(L.color),Te=await this.e.provideColorPresentations(re,{document:H,range:ee},G);if(Array.isArray(Te))return Te.map(t.ColorPresentation.from)}}class J{constructor(z,L){this.d=z,this.e=L}async provideFoldingRanges(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideFoldingRanges(H,L,G);if(Array.isArray(ee))return ee.map(t.FoldingRange.from)}}class Y{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideSelectionRanges(z,L,G){const H=this.d.getDocument(z),ee=L.map(t.Position.to),re=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let Be=0;Be<ee.length;Be++){const Qe=[];Te.push(Qe);let _e=ee[Be],et=re[Be];for(;;){if(!et.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(t.SelectionRange.from(et)),!et.parent)break;_e=et.range,et=et.parent}}return Te}}class he{constructor(z,L){this.f=z,this.g=L,this.d=new M.$hP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=t.Position.to(L),re=await this.g.prepareCallHierarchy(H,ee,G);if(!re)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(re)?re.map(Be=>this.h(Te,Be)):[this.h(Te,re)]}async provideCallsTo(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(re=>({from:this.h(z,re.from),fromRanges:re.fromRanges.map(Te=>t.Range.from(Te))}))}async provideCallsFrom(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(re=>({to:this.h(z,re.to),fromRanges:re.fromRanges.map(Te=>t.Range.from(Te))}))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=t.CallHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class le{constructor(z,L){this.f=z,this.g=L,this.d=new M.$hP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=t.Position.to(L),re=await this.g.prepareTypeHierarchy(H,ee,G);if(!re)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(re)?re.map(Be=>this.h(Te,Be)):[this.h(Te,re)]}async provideSupertypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(re=>this.h(z,re))}async provideSubtypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(re=>this.h(z,re))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=t.TypeHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class Ne{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new i.$dkc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,L,G,H,ee){const re=this.f.getDocument(L),Te=t.Position.to(G),Be=t.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,tt)).buffer),Qe=await this.g.provideDocumentDropEdits(re,Te,Be,ee);if(!Qe)return;const _e=(0,I.$3b)(Qe),et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,n.localize)(1,null,this.j.displayName||this.j.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?t.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?t.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class de{constructor(z,L){this.d=z,this.e=L}async provideMappedEdits(z,L,G,H){const ee=l.URI.revive(z),re=this.d.getDocument(ee),Te=G.documents.map(_e=>_e.map(et=>({uri:l.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(tt=>t.Range.to(tt))}))),Be={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(re,L,Be,H);return Qe?t.WorkspaceEdit.from(Qe):null}}class Ce{constructor(z,L){this.adapter=z,this.extension=L}}class Me{static{this.d=0}constructor(z,L,G,H,ee,re,Te,Be){this.g=L,this.h=G,this.j=H,this.k=ee,this.l=re,this.m=Te,this.n=Be,this.f=new Map,this.e=z.getProxy(b.$PM.MainThreadLanguageFeatures)}o(z,L){return t.DocumentSelector.from(z,this.g,L)}p(z){return new a.$RM(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Me.d++}async s(z,L,G,H,ee,re=!1){const Te=this.f.get(z);if(!Te||!(Te.adapter instanceof L))return H;const Be=Date.now();re||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Te.adapter,Te.extension);return Promise.resolve(Qe).catch(_e=>{(0,O.$4)(_e)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Te.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),A.CancellationToken.isCancellationToken(ee)?(0,N.$fh)(Qe,ee):Qe}t(z,L){const G=this.q();return this.f.set(G,new Ce(z,L)),G}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,L,G,H){const ee=this.t(new c(this.h,G),z),re=H&&H.label||Me.u(z);return this.e.$registerDocumentSymbolProvider(ee,this.o(L,z),re),this.p(ee)}$provideDocumentSymbols(z,L,G){return this.s(z,c,H=>H.provideDocumentSymbols(l.URI.revive(L),G),void 0,G)}registerCodeLensProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new f(this.h,this.j.converter,G,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(L,z),ee);let re=this.p(H);if(ee!==void 0){const Te=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));re=a.$RM.from(re,Te)}return re}$provideCodeLenses(z,L,G){return this.s(z,f,H=>H.provideCodeLenses(l.URI.revive(L),G),void 0,G)}$resolveCodeLens(z,L,G){return this.s(z,f,H=>H.resolveCodeLens(L,G),void 0,void 0)}$releaseCodeLenses(z,L){this.s(z,f,G=>Promise.resolve(G.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(z,L,G){const H=this.t(new S(this.h,G),z);return this.e.$registerDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideDefinition(z,L,G,H){return this.s(z,S,ee=>ee.provideDefinition(l.URI.revive(L),G,H),[],H)}registerDeclarationProvider(z,L,G){const H=this.t(new h(this.h,G),z);return this.e.$registerDeclarationSupport(H,this.o(L,z)),this.p(H)}$provideDeclaration(z,L,G,H){return this.s(z,h,ee=>ee.provideDeclaration(l.URI.revive(L),G,H),[],H)}registerImplementationProvider(z,L,G){const H=this.t(new E(this.h,G),z);return this.e.$registerImplementationSupport(H,this.o(L,z)),this.p(H)}$provideImplementation(z,L,G,H){return this.s(z,E,ee=>ee.provideImplementation(l.URI.revive(L),G,H),[],H)}registerTypeDefinitionProvider(z,L,G){const H=this.t(new g(this.h,G),z);return this.e.$registerTypeDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideTypeDefinition(z,L,G,H){return this.s(z,g,ee=>ee.provideTypeDefinition(l.URI.revive(L),G,H),[],H)}registerHoverProvider(z,L,G,H){const ee=this.t(new D(this.h,G),z);return this.e.$registerHoverProvider(ee,this.o(L,z)),this.p(ee)}$provideHover(z,L,G,H){return this.s(z,D,ee=>ee.provideHover(l.URI.revive(L),G,H),void 0,H)}registerEvaluatableExpressionProvider(z,L,G,H){const ee=this.t(new w(this.h,G),z);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(L,z)),this.p(ee)}$provideEvaluatableExpression(z,L,G,H){return this.s(z,w,ee=>ee.provideEvaluatableExpression(l.URI.revive(L),G,H),void 0,H)}registerInlineValuesProvider(z,L,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new C(this.h,G),z);this.e.$registerInlineValuesProvider(re,this.o(L,z),ee);let Te=this.p(re);if(ee!==void 0){const Be=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Te=a.$RM.from(Te,Be)}return Te}$provideInlineValues(z,L,G,H,ee){return this.s(z,C,re=>re.provideInlineValues(l.URI.revive(L),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(z,L,G){const H=this.t(new P(this.h,G),z);return this.e.$registerDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,L,G){const H=this.t(new V(this.h,G),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}$provideDocumentHighlights(z,L,G,H){return this.s(z,P,ee=>ee.provideDocumentHighlights(l.URI.revive(L),G,H),void 0,H)}$provideMultiDocumentHighlights(z,L,G,H,ee){return this.s(z,V,re=>re.provideMultiDocumentHighlights(l.URI.revive(L),G,H.map(Te=>l.URI.revive(Te)),ee),void 0,ee)}registerLinkedEditingRangeProvider(z,L,G){const H=this.t(new W(this.h,G),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(L,z)),this.p(H)}$provideLinkedEditingRanges(z,L,G,H){return this.s(z,W,async ee=>{const re=await ee.provideLinkedEditingRanges(l.URI.revive(L),G,H);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Me.w(re.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,L,G){const H=this.t(new q(this.h,G),z);return this.e.$registerReferenceSupport(H,this.o(L,z)),this.p(H)}$provideReferences(z,L,G,H,ee){return this.s(z,q,re=>re.provideReferences(l.URI.revive(L),G,H,ee),void 0,ee)}registerCodeActionProvider(z,L,G,H){const ee=new p.$Tc,re=this.t(new R(this.h,this.j.converter,this.k,G,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(re,this.o(L,z),{providedKinds:H?.providedCodeActionKinds?.map(Te=>Te.value),documentation:H?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,ee)}))},Me.u(z),!!G.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(z,L,G,H,ee){return this.s(z,R,re=>re.provideCodeActions(l.URI.revive(L),G,H,ee),void 0,ee)}$resolveCodeAction(z,L,G){return this.s(z,R,H=>H.resolveCodeAction(L,G),{},void 0)}$releaseCodeActions(z,L){this.s(z,R,G=>Promise.resolve(G.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(z,L,G){const H=this.t(new K(this.h,G),z);return this.e.$registerDocumentFormattingSupport(H,this.o(L,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,L,G,H){return this.s(z,K,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(L),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,L,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new se(this.h,G),z);return this.e.$registerRangeFormattingSupport(ee,this.o(L,z),z.identifier,z.displayName||z.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(z,L,G,H,ee){return this.s(z,se,re=>re.provideDocumentRangeFormattingEdits(l.URI.revive(L),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(z,L,G,H,ee){return this.s(z,se,re=>re.provideDocumentRangesFormattingEdits(l.URI.revive(L),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(z,L,G,H){const ee=this.t(new ce(this.h,G),z);return this.e.$registerOnTypeFormattingSupport(ee,this.o(L,z),H,z.identifier),this.p(ee)}$provideOnTypeFormattingEdits(z,L,G,H,ee,re){return this.s(z,ce,Te=>Te.provideOnTypeFormattingEdits(l.URI.revive(L),G,H,ee,re),void 0,re)}registerWorkspaceSymbolProvider(z,L){const G=this.t(new ve(L,this.l),z);return this.e.$registerNavigateTypeSupport(G,typeof L.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(z,L,G){return this.s(z,ve,H=>H.provideWorkspaceSymbols(L,G),{symbols:[]},G)}$resolveWorkspaceSymbol(z,L,G){return this.s(z,ve,H=>H.resolveWorkspaceSymbol(L,G),void 0,void 0)}$releaseWorkspaceSymbols(z,L){this.s(z,ve,G=>G.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(z,L,G){const H=this.t(new Ie(this.h,G,this.l),z);return this.e.$registerRenameSupport(H,this.o(L,z),Ie.supportsResolving(G)),this.p(H)}$provideRenameEdits(z,L,G,H,ee){return this.s(z,Ie,re=>re.provideRenameEdits(l.URI.revive(L),G,H,ee),void 0,ee)}$resolveRenameLocation(z,L,G,H){return this.s(z,Ie,ee=>ee.resolveRenameLocation(l.URI.revive(L),G,H),void 0,H)}registerNewSymbolNamesProvider(z,L,G){const H=this.t(new ue(this.h,G,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(L,z)),this.p(H)}$provideNewSymbolNames(z,L,G,H){return this.s(z,ue,ee=>ee.provideNewSymbolNames(l.URI.revive(L),G,H),void 0,H)}registerDocumentSemanticTokensProvider(z,L,G,H){const ee=this.t(new ie(this.h,G),z),re=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(L,z),H,re);let Te=this.p(ee);if(re){const Be=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(re));Te=a.$RM.from(Te,Be)}return Te}$provideDocumentSemanticTokens(z,L,G,H){return this.s(z,ie,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(L),G,H),null,H)}$releaseDocumentSemanticTokens(z,L){this.s(z,ie,G=>G.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,L,G,H){const ee=this.t(new Pe(this.h,G),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(L,z),H),this.p(ee)}$provideDocumentRangeSemanticTokens(z,L,G,H){return this.s(z,Pe,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(L),G,H),null,H)}registerCompletionItemProvider(z,L,G,H){const ee=this.t(new Fe(this.h,this.j.converter,G,this.m,z),z);return this.e.$registerCompletionsProvider(ee,this.o(L,z),H,Fe.supportsResolving(G),z.identifier),this.p(ee)}$provideCompletionItems(z,L,G,H,ee){return this.s(z,Fe,re=>re.provideCompletionItems(l.URI.revive(L),G,H,ee),void 0,ee)}$resolveCompletionItem(z,L,G){return this.s(z,Fe,H=>H.resolveCompletionItem(L,G),void 0,G)}$releaseCompletionItems(z,L){this.s(z,Fe,G=>G.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(z,L,G,H){const ee=new j(z,this.h,G,this.j.converter),re=this.t(ee,z);return this.e.$registerInlineCompletionsSupport(re,this.o(L,z),ee.supportsHandleEvents,r.$Lm.toKey(z.identifier.value),H?.yieldTo?.map(Te=>r.$Lm.toKey(Te))||[]),this.p(re)}$provideInlineCompletions(z,L,G,H,ee){return this.s(z,ne,re=>re.provideInlineCompletions(l.URI.revive(L),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(z,L,G,H){this.s(z,ne,async ee=>{ee.handleDidShowCompletionItem(L,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,L,G,H,ee){this.s(z,ne,async re=>{re.handlePartialAccept(L,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(z,L){this.s(z,ne,async G=>{G.disposeCompletions(L)},void 0,void 0)}registerInlineEditProvider(z,L,G){const H=new x(z,this.h,G,this.j.converter),ee=this.t(H,z);return this.e.$registerInlineEditProvider(ee,this.o(L,z),z.identifier),this.p(ee)}$provideInlineEdit(z,L,G,H){return this.s(z,x,ee=>ee.provideInlineEdits(l.URI.revive(L),G,H),void 0,H)}$freeInlineEdit(z,L){this.s(z,x,async G=>{G.disposeEdit(L)},void 0,void 0)}registerSignatureHelpProvider(z,L,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,re=this.t(new Oe(this.h,G),z);return this.e.$registerSignatureHelpProvider(re,this.o(L,z),ee),this.p(re)}$provideSignatureHelp(z,L,G,H,ee){return this.s(z,Oe,re=>re.provideSignatureHelp(l.URI.revive(L),G,H,ee),void 0,ee)}$releaseSignatureHelp(z,L){this.s(z,Oe,G=>G.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(z,L,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ke(this.h,this.j.converter,G,this.l,z),z);this.e.$registerInlayHintsProvider(ee,this.o(L,z),typeof G.resolveInlayHint=="function",H,Me.u(z));let re=this.p(ee);if(H!==void 0){const Te=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));re=a.$RM.from(re,Te)}return re}$provideInlayHints(z,L,G,H){return this.s(z,ke,ee=>ee.provideInlayHints(l.URI.revive(L),G,H),void 0,H)}$resolveInlayHint(z,L,G){return this.s(z,ke,H=>H.resolveInlayHint(L,G),void 0,G)}$releaseInlayHints(z,L){this.s(z,ke,G=>G.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(z,L,G){const H=this.t(new $e(this.h,G),z);return this.e.$registerDocumentLinkProvider(H,this.o(L,z),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,L,G){return this.s(z,$e,H=>H.provideLinks(l.URI.revive(L),G),void 0,G,L.scheme==="output")}$resolveDocumentLink(z,L,G){return this.s(z,$e,H=>H.resolveLink(L,G),void 0,void 0,!0)}$releaseDocumentLinks(z,L){this.s(z,$e,G=>G.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(z,L,G){const H=this.t(new ge(this.h,G),z);return this.e.$registerDocumentColorProvider(H,this.o(L,z)),this.p(H)}$provideDocumentColors(z,L,G){return this.s(z,ge,H=>H.provideColors(l.URI.revive(L),G),[],G)}$provideColorPresentations(z,L,G,H){return this.s(z,ge,ee=>ee.provideColorPresentations(l.URI.revive(L),G,H),void 0,H)}registerFoldingRangeProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new J(this.h,G),z)),this.e.$registerFoldingRangeProvider(H,this.o(L,z),z.identifier,ee);let re=this.p(H);if(ee!==void 0){const Te=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=a.$RM.from(re,Te)}return re}$provideFoldingRanges(z,L,G,H){return this.s(z,J,ee=>ee.provideFoldingRanges(l.URI.revive(L),G,H),void 0,H)}registerSelectionRangeProvider(z,L,G){const H=this.t(new Y(this.h,G,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(L,z)),this.p(H)}$provideSelectionRanges(z,L,G,H){return this.s(z,Y,ee=>ee.provideSelectionRanges(l.URI.revive(L),G,H),[],H)}registerCallHierarchyProvider(z,L,G){const H=this.t(new he(this.h,G),z);return this.e.$registerCallHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareCallHierarchy(z,L,G,H){return this.s(z,he,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(L),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,L,G,H){return this.s(z,he,ee=>ee.provideCallsTo(L,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,L,G,H){return this.s(z,he,ee=>ee.provideCallsFrom(L,G,H),void 0,H)}$releaseCallHierarchy(z,L){this.s(z,he,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(z,L,G){const H=this.t(new le(this.h,G),z);return this.e.$registerTypeHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareTypeHierarchy(z,L,G,H){return this.s(z,le,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(L),G,H)),void 0,H)}$provideTypeHierarchySupertypes(z,L,G,H){return this.s(z,le,ee=>ee.provideSupertypes(L,G,H),void 0,H)}$provideTypeHierarchySubtypes(z,L,G,H){return this.s(z,le,ee=>ee.provideSubtypes(L,G,H),void 0,H)}$releaseTypeHierarchy(z,L){this.s(z,le,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Ce(new Ne(this.e,this.h,G,ee,z),z)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(L,z),(0,d.$xG)(z,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(z,L,G,H,ee,re){return this.s(z,Ne,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(L,l.URI.revive(G),H,ee,re)),void 0,void 0)}$resolveDropEdit(z,L,G){return this.s(z,Ne,H=>H.resolveDropEdit(L,G),{},void 0)}$releaseDropEdits(z,L){this.s(z,Ne,G=>Promise.resolve(G.releaseDropEdits(L)),void 0,void 0)}registerMappedEditsProvider(z,L,G){const H=this.t(new de(this.h,G),z);return this.e.$registerMappedEditsProvider(H,this.o(L,z)),this.p(H)}$provideMappedEdits(z,L,G,H,ee){return this.s(z,de,re=>Promise.resolve(re.provideMappedEdits(L,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Ce(new U(this.e,this.h,G,ee,z),z)),this.e.$registerPasteEditProvider(ee,this.o(L,z),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(z,L,G,H,ee){return this.s(z,U,re=>re.prepareDocumentPaste(l.URI.revive(L),G,H,ee),void 0,ee)}$providePasteEdits(z,L,G,H,ee,re,Te){return this.s(z,U,Be=>Be.providePasteEdits(L,l.URI.revive(G),H,ee,re,Te),void 0,Te)}$resolvePasteEdit(z,L,G){return this.s(z,U,H=>H.resolvePasteEdit(L,G),{},void 0)}$releasePasteEdits(z,L){this.s(z,U,G=>Promise.resolve(G.releasePasteEdits(L)),void 0,void 0)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Me.w(z.decreaseIndentPattern),increaseIndentPattern:Me.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Me.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Me.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Me.w(z.beforeText),afterText:z.afterText?Me.w(z.afterText):void 0,previousLineText:z.previousLineText?Me.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Me.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(L=>a.SyntaxTokenType.toString(L)):void 0}}static D(z){return z.map(Me.C)}setLanguageConfiguration(z,L,G){const{wordPattern:H}=G;if(H&&(0,T.$ff)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(L,H):this.h.setWordDefinitionFor(L,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ee=this.q(),re={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,L,re),this.p(ee)}$setWordDefinitions(z){for(const L of z)this.h.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.$nkc=Me}),define(Ae[88],Re([1,0,22,6,4,8,7,101,20,11,5,167,106,14,3,16,84,13,40]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=e.$7kc=void 0,e.$7kc=(0,m.$qi)("IExtHostLanguageModels");class a{constructor(c,f){this.option=c,this.stream=new k.$Th,this.stream=f??new k.$Th}}class d{constructor(){this.a=new Map,this.b=new k.$Th,this.c=!1,this.d=!1;const c=this;this.apiObject={stream:c.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,c]of this.a)yield c.stream;else yield this.b}handleFragment(c){if(this.c)return;this.d=!0;let f=this.a.get(c.index);f||(this.a.size===0?f=new a(c.index,this.b):f=new a(c.index),this.a.set(c.index,f)),f.stream.emitOne(c.part)}get isStreaming(){return this.d}reject(c){this.c=!0;for(const f of this.f())f.reject(c)}resolve(){this.c=!0;for(const c of this.f())c.resolve()}}let i=class{static{t=this}static{this.a=1}constructor(c,f,u){this.j=f,this.k=u,this.c=new T.$be,this.d=new T.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new $.$Nm,this.i=new Map,this.o=new Set,this.b=c.getProxy(A.$PM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(c,f,u,S){const h=t.a++;this.f.set(h,{extension:c.identifier,provider:u,languageModelId:f});let E;return S.auth&&(E={providerLabel:c.displayName||c.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(h,f,{extension:c.identifier,identifier:f,model:S.name??"",auth:E}),(0,N.$Sc)(()=>{this.f.delete(h),this.b.$unregisterProvider(h)})}async $provideLanguageModelResponse(c,f,u,S,h,E){const g=this.f.get(c);if(!g)return;const D=new p.$Zv(async w=>{if(E.isCancellationRequested){this.j.warn(`[CHAT](${g.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:w.index,part:w.part})});return g.provider.provideLanguageModelResponse2(S.map(O.LanguageModelMessage.to),h,$.$Lm.toKey(u),D,E)}$provideTokenLength(c,f,u){const S=this.f.get(c);return S?Promise.resolve(S.provider.provideTokenCount(f,u)):Promise.resolve(0)}$updateLanguageModels(c){const f=[],u=[];if(c.added)for(const S of c.added)this.g.set(S.identifier,S),f.push(S.model);if(c.removed)for(const S of c.removed){this.g.delete(S),u.push(S);for(const[h,E]of this.i)E.languageModelId===S&&(E.res.reject(new v.$5),this.i.delete(h))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(u)})),c.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(c){const f=new Array;for(const{from:u,to:S,enabled:h}of c){const E=this.h.get(u)??new $.$Mm;if(E.has(S)!==h){h?E.add(S):E.delete(S),this.h.set(u,E);const D={from:u,to:S};f.push(D),this.c.fire(D)}}}async sendChatRequest(c,f,u,S,h){const E=c.identifier,g=await this.b.$prepareChatAccess(E,f,S.justification);if(!g||!this.g.has(f))throw M.$2O.NotFound(`Language model '${f}' is unknown.`);if(this.m(E,g)&&(!await this.l(c,{identifier:g.extension,displayName:g.auth.providerLabel},S.justification,S.silent)||!this.h.get(E)?.has(g.extension)))throw M.$2O.NoPermissions(`Language model '${f}' cannot be used by '${E.value}'.`);const D=Math.random()*1e6|0,w=this.b.$fetchResponse(E,f,D,u.map(O.LanguageModelMessage.from),S.modelOptions??{},h),C=new k.$ph,P=new d;this.i.set(D,{languageModelId:f,res:P});let V;if(w.catch(W=>{C.isOpen()?P.reject(W):V=W}).finally(()=>{this.i.delete(D),P.resolve(),C.open()}),await C.wait(),V)throw new M.$2O(`Language model '${f}' errored, check cause for more details`,"Unknown",V);return P.apiObject}async $handleResponseFragment(c,f){const u=this.i.get(c);u&&u.res.handleFragment(f)}async l(c,f,u,S){const h=l.$RL+f.identifier.value;if(await this.k.getSession(c,h,[],{silent:!0}))return this.$updateModelAccesslist([{from:c.identifier,to:f.identifier,enabled:!0}]),!0;if(S)return!1;try{const g=u?(0,y.localize)(0,null,f.displayName,u):(0,y.localize)(1,null,f.displayName);return await this.k.getSession(c,h,[],{forceNewSession:{detail:g}}),this.$updateModelAccesslist([{from:c.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(c,f){return!!f.auth&&!$.$Lm.equals(f.extension,c)}async n(c){for(const f of this.o)try{await this.l(f,{identifier:c.extension,displayName:""},void 0,!0)}catch(u){this.j.error("Fake Auth request failed"),this.j.error(u)}}createLanguageModelAccessInformation(c){this.o.add(c);const f=this,u=T.Event.signal(T.Event.filter(this.c.event,h=>$.$Lm.equals(h.from,c.identifier))),S=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(u,S)},canSendRequest(h){const E=f.g.get(h);if(!E)return;if(!f.m(c.identifier,E))return!0;const g=f.h.get(c.identifier);if(g)return g.has(E.extension)},async computeTokenLength(h,E,g){g??=I.CancellationToken.None;const D=f.g.get(h);if(!D)throw M.$2O.NotFound(`Language model '${h}' is unknown.`);const w=r.Iterable.find(f.f.values(),C=>C.languageModelId===h);return w?w.provider.provideTokenCount(E,g):f.b.$countTokens(D.identifier,E,g)}}}};e.$8kc=i,e.$8kc=i=t=Je([Ve(0,s.$cP),Ve(1,n.$Wj),Ve(2,o.$pkc)],i)}),define(Ae[264],Re([1,0,4,8,7,33,11,6,25]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class k{constructor(y,l,v,m){this.c=l,this.d=v,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(I.$PM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,l){await this.a.$changeLanguage(y,l);const v=this.c.getDocumentData(y);if(!v)throw new Error(`document '${y.toString()}' NOT found`);return v.document}async tokenAtPosition(y,l){const v=y.version,m=N.Position.from(l),s=await this.a.$tokensAtPosition(y.uri,m),o={type:A.StandardTokenType.Other,range:y.getWordRangeAtPosition(l)??new A.$TM(l.line,l.character,l.line,l.character)};if(!s)return o;const n={range:N.Range.to(s.range),type:N.TokenType.to(s.type)};return!n.range.contains(l)||v!==y.version?o:n}createLanguageStatusItem(y,l,v){const m=this.f++,s=this.a,o=this.g,n=`${y.identifier.value}/${l}`;if(o.has(n))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(n);const r={selector:v,id:l,name:y.displayName??y.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const a=new p.$Tc,d=()=>{if(t?.dispose(),!o.has(n)){console.warn(`LanguageStatusItem (${l}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,M.$sh)(()=>{a.clear(),this.a.$setLanguageStatus(m,{id:n,name:r.name??y.displayName??y.name,source:y.displayName??y.name,selector:N.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===A.LanguageStatusSeverity.Error?O.default.Error:r.severity===A.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:r.command&&this.d.toInternal(r.command,a),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},i={dispose(){a.dispose(),t?.dispose(),s.$removeLanguageStatus(m),o.delete(n)},get id(){return r.id},get name(){return r.name},set name(b){r.name=b,d()},get selector(){return r.selector},set selector(b){r.selector=b,d()},get text(){return r.text},set text(b){r.text=b,d()},set text2(b){(0,$.$yG)(y,"languageStatusText"),r.text=b,d()},get text2(){return(0,$.$yG)(y,"languageStatusText"),r.text},get detail(){return r.detail},set detail(b){r.detail=b,d()},get severity(){return r.severity},set severity(b){r.severity=b,d()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(b){r.accessibilityInformation=b,d()},get command(){return r.command},set command(b){r.command=b,d()},get busy(){return r.busy},set busy(b){r.busy=b,d()}};return d(),i}}e.$Mlc=k}),define(Ae[265],Re([1,0,12,2,8,7,83]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=void 0;class p{constructor(y,l,v,m){this.start=y,this.deletedCount=l,this.deletedItems=v,this.items=m}asApiEvent(){return{range:new O.$gO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,l,v){this.notebook=y,this.h=l,this.j=v,this.handle=v.handle,this.uri=N.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(A.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return y.g},set mime(m){y.g=m},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(v)}return this.f}setOutputs(y){this.a=y.map(A.NotebookCellOutput.to)}setOutputItems(y,l,v){const m=v.map(A.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===y);if(s&&(l||(s.items.length=0),s.items.push(...m),s.items.length>1&&s.items.every(o=>M.$MK(o.mime)))){const o=new Map,n=[];s.items.forEach(r=>{let t;o.has(r.mime)?t=o.get(r.mime):(t=[],o.set(r.mime,t),n.push(r.mime)),t.push(r.data)}),s.items.length=0,n.forEach(r=>{const t=M.$NK(o.get(r));s.items.push({mime:r,data:t.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$ylc=$;class k{static{this.a=0}constructor(y,l,v,m,s){this.k=y,this.l=l,this.m=v,this.uri=m,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,l={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===I.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(v){return v=y.n(v),y.b[v].apiCell},getCells(v){return(v?y.p(v):y.b).map(s=>s.apiCell)},save(){return y.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,l,v){this.g=y.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:v});const m={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},s=[];for(const n of y.rawEvents)n.kind===M.NotebookCellsChangeType.ModelChange?this.r(n.changes,!1,m.contentChanges):n.kind===M.NotebookCellsChangeType.Move?this.s(n.index,n.length,n.newIdx,m.contentChanges):n.kind===M.NotebookCellsChangeType.Output?(this.t(n.index,n.outputs),s.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===M.NotebookCellsChangeType.OutputItem?(this.u(n.index,n.outputId,n.append,n.outputItems),s.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(n.index,n.language),s.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document})):n.kind===M.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document}):n.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(n.index,n.mime):n.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(n.index,n.metadata),s.push({cell:this.b[n.index].apiCell,metadata:this.b[n.index].apiCell.metadata})):n.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(n.index,n.internalMetadata),s.push({cell:this.b[n.index].apiCell,executionSummary:this.b[n.index].apiCell.executionSummary}));const o=new Map;for(let n=0;n<s.length;n++){const r=s[n],t=o.get(r.cell);if(t===void 0){const a=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});o.set(r.cell,a-1)}else m.cellChanges[t]={...m.cellChanges[t],...r}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let l=y.start|0,v=y.end|0;return l<0&&(l=0),v>this.b.length&&(v=this.b.length),y.with({start:l,end:v})}p(y){y=this.o(y);const l=[];for(let v=y.start;v<y.end;v++)l.push(this.b[v]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,l,v){if(this.j)return;const m=[],s=[],o=[];if(y.reverse().forEach(n=>{const t=n[2].map(i=>{const b=new $(this,this.l,i);return l||s.push($.asModelAddData(i)),b}),a=new p(n[0],n[1],[],t),d=this.b.splice(n[0],n[1],...t);for(const i of d)o.push(i.uri),a.deletedItems.push(i.apiCell);m.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),v)for(const n of m)v.push(n.asApiEvent())}s(y,l,v,m){const s=this.b.splice(y,l);this.b.splice(v,0,...s);const o=[new p(y,l,s.map(n=>n.apiCell),[]),new p(v,0,[],s)];for(const n of o)m.push(n.asApiEvent())}t(y,l){this.b[y].setOutputs(l)}u(y,l,v,m){this.b[y].setOutputItems(l,v,m)}v(y,l){const v=this.b[y];v.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(v.uri,l)}w(y,l){const v=this.b[y];v.apiCell.mime=l}x(y,l){this.b[y].setMetadata(l)}y(y,l){this.b[y].setInternalMetadata(l)}getCellFromApiCell(y){return this.b.find(l=>l.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(l=>l.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$zlc=k}),define(Ae[266],Re([1,0,5,2,8,7,34]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0;class p{constructor(k,T,y,l={timeout:1500,errors:3}){this.b=k,this.c=T,this.d=y,this.f=l,this.a=new I.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(T,y,l)=>{const v=function(s){T.call(y,s)};return v.extension=k,this.a.event(v,void 0,l)}}async $participateInSave(k,T,y){const l=N.URI.revive(k),v=this.c.getNotebookDocument(l);if(!v)throw new Error("Unable to resolve notebook document");const m=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:A.TextDocumentSaveReason.to(T)},y,async(o,n)=>{const r=Date.now(),t=await await Promise.resolve(o);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier),!y.isCancellationRequested&&t&&(t instanceof O.$2M?m.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(m.length===0)return!0;const s={edits:[]};for(const o of m){const{edits:n}=A.WorkspaceEdit.from(o);s.edits=s.edits.concat(n)}return this.d.$tryApplyWorkspaceEdit(new M.$mw(s))}}e.$Olc=p}),define(Ae[112],Re([1,0,14,8,7]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,$,k,T,y,l){this.id=p,this.f=$,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=T,this.c=l}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection($){this.selections=[$]},get selections(){return p.a},set selections($){if(!Array.isArray($)||!$.every(A.$gO.isNotebookRange))throw(0,I.$7)("selections");p.a=$,p.g($)},get visibleRanges(){return p.b},revealRange($,k){p.f.$tryRevealRange(p.id,N.NotebookRange.from($),k??A.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(N.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Alc=O}),define(Ae[267],Re([1,0,5,13,8]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=void 0;let O=class{constructor(p,$){this.c=p,this.d=$,this.a=new I.$be,this.b=new I.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,$);const k=this.d.getEditorById(p);$.visibleRanges&&k._acceptVisibleRanges($.visibleRanges.ranges.map(A.NotebookRange.to)),$.selections&&k._acceptSelections($.selections.selections.map(A.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const $ in p)this.d.getEditorById($)._acceptViewColumn(A.ViewColumn.to(p[$]))}};e.$Qlc=O,e.$Qlc=O=Je([Ve(0,N.$Wj)],O)}),define(Ae[268],Re([1,0,5,4,112]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=void 0;class O{constructor(p,$){this.c=$,this.a=new Map,this.b=p.getProxy(N.$PM.MainThreadNotebookRenderers)}$postRendererMessage(p,$,k){const T=this.c.getEditorById(p);this.a.get($)?.fire({editor:T.apiEditor,message:k})}createRendererMessaging(p,$){if(!p.contributes?.notebookRenderer?.some(T=>T.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(T,y,l)=>this.d($).event(T,y,l),postMessage:(T,y)=>{A.$Alc.apiEditorsToExtHost.has(T)&&([T,y]=[y,T]);const l=y&&A.$Alc.apiEditorsToExtHost.get(y);return this.b.$postMessage(l?.id,$,T)}}}d(p){let $=this.a.get(p);return $||($=new I.$be({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(p)}}),this.a.set(p,$),$)}}e.$Tlc=O}),define(Ae[269],Re([1,0,8,101,22,68,14]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;class p{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,l,v){const m=this.b++,{title:s,location:o,cancellable:n}=l,r={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(m,{location:I.ProgressLocation.from(o),title:s,source:r,cancellable:n},y.isUnderDevelopment?void 0:y.identifier.value).catch(M.$2),this.d(m,v,!!n)}d(y,l,v){let m;v&&(m=new A.$me,this.c.set(y,m));const s=n=>{this.a.$progressEnd(n),this.c.delete(n),m?.dispose()};let o;try{o=l(new k(this.a,y),v&&m?m.token:A.CancellationToken.None)}catch(n){throw s(y),n}return o.then(n=>s(y),n=>s(y)),o}$acceptProgressCanceled(y){const l=this.c.get(y);l&&(l.cancel(),this.c.delete(y))}}e.$Xlc=p;function $(T,y){return T.message=y.message,typeof y.increment=="number"&&(typeof T.increment=="number"?T.increment+=y.increment:T.increment=y.increment),T}class k extends N.$Zv{constructor(y,l){super(v=>this.throttledReport(v)),this.c=y,this.d=l}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,O.$Wh)(100,(T,y)=>$(T,y),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Ae[270],Re([1,0,2,4,11,8]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;class M{static{this.a=0}constructor($,k){this.d=k,this.c=new Map,this.b=$.getProxy(N.$PM.MainThreadQuickDiff)}$provideOriginalResource($,k,T){const y=I.URI.revive(k),l=this.c.get($);return l?(0,A.$ih)(()=>l.provideOriginalResource(y,T)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider($,k,T,y){const l=M.a++;return this.c.set(l,k),this.b.$registerQuickDiffProvider(l,O.DocumentSelector.from($,this.d),T,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Ylc=M}),define(Ae[271],Re([1,0,22,5,6,4,2,7,14,18,33,42,25,8]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=m;function m(s,o,n){const r=s.getProxy(O.$PM.MainThreadQuickOpen);class t{constructor(h,E){this.e=new Map,this.f=0,this.a=h,this.b=E}showQuickPick(h,E,g,D=I.CancellationToken.None){this.c=void 0;const w=Promise.resolve(E),C=++this.f,P=r.$show(C,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},D),V={},W=P.then(()=>V);return Promise.race([W,w]).then(q=>{if(q===V)return;const R=(0,l.$xG)(h,"quickPickItemTooltip");return w.then(U=>{const K=[];for(let se=0;se<U.length;se++){const ce=U[se];if(typeof ce=="string")K.push({label:ce,handle:se});else if(ce.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!R&&console.warn(`Extension '${h.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`);const ve=ce.iconPath?c(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:R?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:se})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=se=>{g.onDidSelectItem(U[se])}),r.$setItems(C,K),P.then(se=>{if(typeof se=="number")return U[se];if(Array.isArray(se))return se.map(ce=>U[ce])})})}).then(void 0,q=>{if(!(0,$.$4)(q))return r.$setError(C,q),Promise.reject(q)})}$onItemSelected(h){this.c?.(h)}showInput(h,E=I.CancellationToken.None){return this.d=h?.validateInput,r.$input(h,typeof this.d=="function",E).then(void 0,g=>{if(!(0,$.$4)(g))return Promise.reject(g)})}async $validateInput(h){if(!this.d)return;const E=await this.d(h);if(!E||typeof E=="string")return E;let g;switch(E.severity){case p.InputBoxValidationSeverity.Info:g=T.default.Info;break;case p.InputBoxValidationSeverity.Warning:g=T.default.Warning;break;case p.InputBoxValidationSeverity.Error:g=T.default.Error;break;default:g=E.message?T.default.Error:T.default.Ignore;break}return{content:E.message,severity:g}}async showWorkspaceFolderPick(h,E=I.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!g)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(w=>w.uri.toString()===g.uri.toString())}createQuickPick(h){const E=new f(h,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(h){const E=new u(h,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(h,E){this.e.get(h)?._fireDidChangeValue(E)}$onDidAccept(h){this.e.get(h)?._fireDidAccept()}$onDidChangeActive(h,E){const g=this.e.get(h);g instanceof f&&g._fireDidChangeActive(E)}$onDidChangeSelection(h,E){const g=this.e.get(h);g instanceof f&&g._fireDidChangeSelection(E)}$onDidTriggerButton(h,E){this.e.get(h)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(h,E,g){const D=this.e.get(h);D instanceof f&&D._fireDidTriggerItemButton(E,g)}$onDidHide(h){this.e.get(h)?._fireDidHide()}}class a{static{this.a=1}constructor(h,E){this.x=h,this.y=E,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$be,this.q=new N.$be,this.r=new N.$be,this.s=new N.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(h){this.b=h,this.z({title:h})}get step(){return this.c}set step(h){this.c=h,this.z({step:h})}get totalSteps(){return this.d}set totalSteps(h){this.d=h,this.z({totalSteps:h})}get enabled(){return this.g}set enabled(h){this.g=h,this.z({enabled:h})}get busy(){return this.j}set busy(h){this.j=h,this.z({busy:h})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(h){this.k=h,this.z({ignoreFocusOut:h})}get value(){return this.l}set value(h){this.l=h,this.z({value:h})}get placeholder(){return this.m}set placeholder(h){this.m=h,this.z({placeholder:h})}get buttons(){return this.n}set buttons(h){this.n=h.slice(),this.o.clear(),h.forEach((E,g)=>{const D=E===p.$dO.Back?-1:g;this.o.set(D,E)}),this.z({buttons:h.map((E,g)=>({...c(E.iconPath),tooltip:E.tooltip,handle:E===p.$dO.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(h){this.l=h,this.q.fire(h)}_fireDidTriggerButton(h){const E=this.o.get(h);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(h){if(!this.v){for(const E of Object.keys(h)){const g=h[E];this.u[E]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function d(S){if(S instanceof p.$NN)return{id:S.id};const h=b(S),E=i(S);return{dark:typeof h=="string"?M.URI.file(h):h,light:typeof E=="string"?M.URI.file(E):E}}function i(S){return typeof S=="object"&&"light"in S?S.light:S}function b(S){return typeof S=="object"&&"dark"in S?S.dark:S}function c(S){const h=d(S);let E,g;return"id"in h?g=y.ThemeIcon.asClassName(h):E=h,{iconPath:E,iconClass:g}}class f extends a{constructor(h,E){super(h.identifier,E),this.O=h,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$be,this.L=[],this.M=new N.$be,this.N=new N.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(h){this.B=h.slice(),this.C.clear(),this.D.clear(),h.forEach((D,w)=>{this.C.set(w,D),this.D.set(D,w)});const E=(0,l.$xG)(this.O,"quickPickItemTooltip"),g=[];for(let D=0;D<h.length;D++){const w=h[D];if(w.kind===p.QuickPickItemKind.Separator)g.push({type:"separator",label:w.label});else{w.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=w.iconPath?c(w.iconPath):void 0;g.push({handle:D,label:w.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:E?v.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((P,V)=>({...c(P.iconPath),tooltip:P.tooltip,handle:V}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(h){this.E=h,this.z({canSelectMany:h})}get matchOnDescription(){return this.F}set matchOnDescription(h){this.F=h,this.z({matchOnDescription:h})}get matchOnDetail(){return this.G}set matchOnDetail(h){this.G=h,this.z({matchOnDetail:h})}get sortByLabel(){return this.H}set sortByLabel(h){this.H=h,this.z({sortByLabel:h})}get keepScrollPosition(){return this.I}set keepScrollPosition(h){this.I=h,this.z({keepScrollPosition:h})}get activeItems(){return this.J}set activeItems(h){this.J=h.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(h){this.L=h.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(h){const E=(0,k.$Hb)(h.map(g=>this.C.get(g)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(h){const E=(0,k.$Hb)(h.map(g=>this.C.get(g)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(h,E){const g=this.C.get(h);if(!g||!g.buttons||!g.buttons.length)return;const D=g.buttons[E];D&&this.N.fire({button:D,item:g})}}class u extends a{constructor(h,E){super(h.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(h){this.B=h,this.z({password:h})}get prompt(){return this.C}set prompt(h){this.C=h,this.z({prompt:h})}get valueSelection(){return this.D}set valueSelection(h){this.D=h,this.z({valueSelection:h})}get validationMessage(){return this.E}set validationMessage(h){this.E=h,h?typeof h=="string"?this.z({validationMessage:h,severity:T.default.Error}):this.z({validationMessage:h.message,severity:h.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new t(o,n)}}),define(Ae[272],Re([1,0,2,5,68,6,11,4,18,143,13,20,42,8,25,12,21]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$1lc=void 0;function r(C){return C instanceof I.URI}function t(C,P){return C.scheme===s.Schemas.file&&P.scheme===s.Schemas.file&&o.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function a(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||l.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function d(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(l.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function i(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const V=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,W=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,k.$ir)(V,W)}function b(C,P){let V=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(V=i(C,P),V!==0)return V;if(C.light&&P.light)V=i(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(V!==0)return V;if(C.dark&&P.dark)V=i(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return V}function c(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let V=0;V<C.arguments.length;V++){const W=C.arguments[V],q=P.arguments[V];if(W!==q&&!(r(W)&&r(q)&&t(W,q)))return W<q?-1:1}return 0}function f(C,P){let V=(0,k.$ir)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(V!==0)return V;if(C.command&&P.command)V=c(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(V!==0)return V;if(C.decorations&&P.decorations)V=b(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)V=(0,k.$ir)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)V=(0,k.$ir)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return V}function u(C,P){for(let V=0;V<C.length;V++)if(C[V]!==P[V])return!1;return!0}function S(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?u(C.arguments,P.arguments):C.arguments===P.arguments)}function h(C,P){return(0,$.$ub)(C,P,S)}class E{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,m.$yG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,m.$yG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,m.$yG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,V,W,q,R){this.k=P,this.l=q,this.m=R,this.d="",this.e=new N.$be,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(P,V){(0,m.$yG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,V)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$1lc=E;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,V,W,q,R,U,K){this.q=P,this.s=V,this.t=W,this.u=q,this.v=R,this.multiDiffEditorEnableViewChanges=U,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,V){const W=this.h.get(P);return W?(0,M.$ih)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(f),W=(0,$.$Db)(this.o,P,f).map(U=>{const K=U.toInsert.map(se=>{const ce=this.e++;this.g.set(ce,se);const ve=se.resourceUri;let Ie;if(se.command)if(se.command.command==="vscode.open"||se.command.command==="vscode.diff"||se.command.command==="vscode.changes"){const ge=new O.$Tc;Ie=this.s.converter.toInternal(se.command,ge),this.j.set(ce,ge)}else this.h.set(ce,se.command);const ue=(0,m.$xG)(this.w,"scmMultiDiffEditor"),be=ue?se.multiDiffEditorOriginalUri:void 0,ie=ue?se.multiFileDiffEditorModifiedUri:void 0,Pe=a(se.decorations),Fe=se.decorations&&a(se.decorations.light)||Pe,ne=se.decorations&&a(se.decorations.dark)||Pe,j=[Fe,ne],x=se.decorations&&se.decorations.tooltip||"",pe=se.decorations&&!!se.decorations.strikeThrough,Oe=se.decorations&&!!se.decorations.faded,ke=se.contextValue||"";return{rawResource:[ce,ve,j,x,pe,Oe,ke,Ie,be,ie],handle:ce}});return{start:U.start,deleteCount:U.deleteCount,toInsert:K}}),q=W.map(({start:U,deleteCount:K,toInsert:se})=>[U,K,se.map(ce=>ce.rawResource)]),R=W.reverse();for(const{start:U,deleteCount:K,toInsert:se}of R){const ce=se.map(Ie=>Ie.handle),ve=this.n.splice(U,K,...ce);for(const Ie of ve)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let V;(0,m.$xG)(this.x,"quickDiffProvider")&&(V=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:V})}get historyProvider(){return(0,m.$yG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,m.$yG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new O.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new O.$Tc,this.o=P;const V=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,m.$yG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,m.$yG)(this.x,"scmActionButton"),this.p.value=new O.$Tc,this.q=P;const V=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&h(this.t,P))return;this.s.value=new O.$Tc,this.t=P;const V=(P||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(P,V,W,q,R,U,K){this.x=P,this.y=q,this.z=R,this.A=U,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Vc,this.m=void 0,this.n=new O.$Vc,this.o=void 0,this.p=new O.$Vc,this.s=new O.$Vc,this.t=void 0,this.u=!1,this.v=new N.$be,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=W;const se=I.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${R}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new E(P,V,this.#e,this.w,se),this.#e.$registerSourceControl(this.w,R,U,K,se)}createResourceGroup(P,V,W){const q=(0,m.$xG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,R=new g(this.#e,this.y,this.w,P,V,q,this.x),U=N.Event.once(R.onDidDispose)(()=>this.C.delete(R));return this.C.set(R,U),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const P=[],V=[];for(const[W,q]of this.C){q.dispose();const R=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});N.Event.once(W.onDidDispose)(()=>{this.D.delete(W),R.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),P.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const U=W._takeResourceStateSnapshot();U.length>0&&V.push([W.handle,U]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,P,V),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&P.push([V.handle,W])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,A.$Vh)(100)],D.prototype,"eventuallyAddResourceGroups",null),Je([(0,A.$Vh)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{n=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new y.$Nm,this.j=new N.$be,this.e=P.getProxy(p.$PM.MainThreadSCM),this.f=P.getProxy(p.$PM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const U=this.g.get(R.sourceControlHandle);if(!U)return R;const K=U.getResourceGroup(R.groupHandle);return K?K.getResourceState(R.handle):R}else if(R&&R.$mid===4){const U=this.g.get(R.sourceControlHandle);return U?U.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const U=this.g.get(R.handle);return U||R}return R}})}createSourceControl(P,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const R=n.d++,U=new D(P,this.m,this.e,this.l,V,W,q);this.g.set(R,U);const K=this.h.get(P.identifier)||[];return K.push(U),this.h.set(P.identifier,K),U}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const V=this.h.get(P.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(P,V,W){const q=I.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const R=this.g.get(P);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ih)(()=>R.quickDiffProvider.provideOriginalResource(q,W)).then(U=>U||null)}$onInputBoxValueChange(P,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const W=this.g.get(P);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(P,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,V,W);const R=this.g.get(P);if(!R)return Promise.resolve(void 0);const U=R.getResourceGroup(V);return U?U.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(P,V,W){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ih)(()=>q.inputBox.validateInput(V,W)).then(R=>{if(!R)return Promise.resolve(void 0);const U=v.MarkdownString.fromStrict(R.message);return U?Promise.resolve([U,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,V,W,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(P,V,W,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(V,W,q))?.map(K=>({...K,icon:d(K)}))??void 0}async $provideHistoryItemSummary(P,V,W,q){const R=this.g.get(P)?.historyProvider;if(typeof R?.provideHistoryItemSummary!="function")return;const U=await R.provideHistoryItemSummary(V,W,q);return U?{...U,icon:d(U)}:void 0}async $provideHistoryItemChanges(P,V,W,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$2lc=w,e.$2lc=w=n=Je([Ve(3,T.$Wj)],w)}),define(Ae[273],Re([1,0,4,8,2]),function(fe,e,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;class O{static{this.a=0}constructor(p,$){this.d=$,this.c=new Map,this.b=p.getProxy(I.$PM.MainThreadShare)}async $provideShare(p,$,k){return await this.c.get(p)?.provideShare({selection:N.Range.to($.selection),resourceUri:A.URI.revive($.resourceUri)},k)??void 0}registerShareProvider(p,$){const k=O.a++;return this.c.set(k,$),this.b.$registerShareProvider(k,N.DocumentSelector.from(p,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$3lc=O}),define(Ae[274],Re([1,0,7,4,170,6,8,17]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=e.$5lc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$ON("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$ON("statusBarItem.warningForeground")]])}#e;#t;constructor(l,v,m,s,o,n=I.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new O.$Tc,this.#e=l,this.#t=v,o&&s){this.c=(0,I.$qN)(s.identifier,o);const t=m.get(this.c);t&&(n=t.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,r=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String($.a++);this.e=s,this.f=o,this.g=n,this.h=this.u(r)}u(l){if((0,p.$8f)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!$.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new O.$Tc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let v;this.m?v=this.m:v=(0,A.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=$.b.get(this.o.id));const s=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,v,this.k,s,this.r?.internal,m,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5lc=$;class k{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const v={message:l};return this.b.unshift(v),this.c(),new I.$RM(()=>{const m=this.b.indexOf(v);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(l,v){this.e=new Map,this.a=l.getProxy(N.$PM.MainThreadStatusBar),this.b=v,this.c=new k(this)}$acceptStaticEntries(l){for(const v of l)this.e.set(v.entryId,v)}createStatusBarEntry(l,v,m,s){return new $(this.a,this.b,this.e,l,v,m,s)}setStatusBarMessage(l,v){const m=this.c.setMessage(l);let s;return typeof v=="number"?s=setTimeout(()=>m.dispose(),v):typeof v<"u"&&v.then(()=>m.dispose(),()=>m.dispose()),new I.$RM(()=>{m.dispose(),clearTimeout(s)})}}e.$6lc=T}),define(Ae[113],Re([1,0,29,105,50,75,61,8,2]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=e.$pP=e.$oP=void 0;const k=(t,a,d,i)=>{let b=a;return{enumerable:!0,configurable:!1,get(){return b},set(c){if(!d(b,c)){const f=b;b=c,t.listener?.(i(c,f))}}}},T=(t,a)=>t===a,y={range:(t,a)=>t===a?!0:!t||!a?!1:t.isEqual(a),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(t,a)=>!(t.length!==a.length||t.some(d=>!a.find(i=>d.id===i.id)))},l=t=>a=>({op:4,update:t(a)}),v=(t,a)=>({range:(()=>{let d;const i=l(b=>({range:I.$kt.lift(p.Range.from(b))}));return{enumerable:!0,configurable:!1,get(){return d},set(b){t.listener?.({op:6}),y.range(d,b)||(d=b,t.listener?.(i(b)))}}})(),label:k(t,a,y.label,l(d=>({label:d}))),description:k(t,void 0,y.description,l(d=>({description:d}))),sortText:k(t,void 0,y.sortText,l(d=>({sortText:d}))),canResolveChildren:k(t,!1,y.canResolveChildren,d=>({op:2,state:d})),busy:k(t,!1,y.busy,l(d=>({busy:d}))),error:k(t,void 0,y.error,l(d=>({error:p.MarkdownString.fromStrict(d)||null}))),tags:k(t,[],y.tags,(d,i)=>({op:1,new:d.map(p.TestTag.from),old:i.map(p.TestTag.from)}))}),m=t=>{const a=A.$BL.fromString(t.extId),d=new o(a.controllerId,a.localId,t.label,$.URI.revive(t.uri)||void 0);return d.range=p.Range.to(t.range||void 0),d.description=t.description||void 0,d.sortText=t.sortText||void 0,d.tags=t.tags.map(i=>p.TestTag.to({id:(0,M.$HL)(i).tagId})),d},s=t=>{let a;for(const d of t.tests){const i=m(d.item);(0,N.$$O)(i).parent=a,a=i}return a};e.$oP=s;class o{constructor(a,d,i,b){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const c=(0,N.$0O)(this,a);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:b,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof n?void 0:c.parent}},children:{value:(0,O.$9O)(c,N.$$O,o),enumerable:!0,writable:!1},...v(c,i)})}}e.$pP=o;class n extends o{constructor(a,d){super(a,a,d,void 0),this._isRoot=!0}}e.$qP=n;class r extends O.$5O{constructor(a,d,i){super({controllerId:a,getDocumentVersion:b=>b&&i.getDocument(b)?.version,getApiFor:N.$$O,getChildren:b=>b.children,root:new n(a,d),toITestItem:p.TestItem.from})}}e.$rP=r}),define(Ae[32],Re([1,0,17,7,8,26,4,18,13,53,29,93,2,6,3,16,113,23,34,43,65,59,62,35]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a,d,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=void 0;let c=class{#e;#t;#i;constructor(g,D,w){this.b=new Map,this.c=new Map,this.#e=g.getProxy(M.$PM.MainThreadCommands),this.d=D,this.#i=w,this.#t=g.getProxy(M.$PM.MainThreadTelemetry),this.converter=new f(this,C=>{const P=this.c.get(C);return P?.result===S.Void?P:void 0},D),this.f=[{processArgument(C){return(0,k.$Zh)(C)}},{processArgument(C){return(0,O.$Yn)(C,function(P){if(T.$kt.isIRange(P))return A.Range.to(P);if(y.$jt.isIPosition(P))return A.Position.to(P);if(T.$kt.isIRange(P.range)&&l.URI.isUri(P.uri))return A.location.to(P);if(P instanceof n.$Ce)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const D=this.registerCommand(!1,g.id,async(...w)=>{const C=g.args.map((V,W)=>{if(!V.validate(w[W]))throw new Error(`Invalid argument '${V.name}' when running '${g.id}', received: ${typeof w[W]=="object"?JSON.stringify(w[W],null,"	"):w[W]} `);return V.convert(w[W])}),P=await this.executeCommand(g.internalId,...C);return g.result.convert(P,w,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new N.$RM(()=>{D.dispose(),this.c.delete(g.id)})}registerCommand(g,D,w,C,P,V){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:w,thisArg:C,metadata:P,extension:V}),g&&this.#e.$registerCommand(D),new N.$RM(()=>{this.b.delete(D)&&g&&this.#e.$unregisterCommand(D)})}executeCommand(g,...D){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,D,!0)}async g(g,D,w){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,D,!1);{let C=!1;const P=(0,O.$Yn)(D,function(V){if(V instanceof N.$SM)return A.Position.from(V);if(V instanceof N.$TM)return A.Range.from(V);if(V instanceof N.$4M)return A.location.from(V);if(N.$gO.isNotebookRange(V))return A.NotebookRange.from(V);if(V instanceof ArrayBuffer)return C=!0,n.$Ce.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return C=!0,n.$Ce.wrap(V);if(V instanceof n.$Ce)return C=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(g,C?new r.$mw(P):P,w);return(0,k.$Zh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(g,D,!1);throw V}}}async h(g,D,w){const C=this.b.get(g);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:V,metadata:W}=C;if(W?.args)for(let R=0;R<W.args.length;R++)try{(0,I.$ig)(D[R],W.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${W.args[R].name}' - ${W.args[R].description}`)}const q=a.$0d.create();try{return await P.apply(V,D)}catch(R){if(g===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...D);U&&(g=U.command)}if(this.d.error(R,g,C.extension?.identifier),!w)throw R;if(C.extension?.identifier){const U=this.#i.onExtensionError(C.extension.identifier,R);this.d.trace("forwarded error to extension?",U,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$bj)(R)),this.id=g,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,g,q.elapsed())}}j(g,D,w){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new d.$_o(D),duration:w})}$executeContributedCommand(g,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const w=this.b.get(g);return w?(D=D.map(C=>this.f.reduce((P,V)=>V.processArgument(P,w.extension?.identifier),C)),this.h(g,D,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(D=>(g&&(D=D.filter(w=>w[0]!=="_")),D))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[D,w]of this.b){const{metadata:C}=w;C&&(g[D]=C)}return Promise.resolve(g)}};e.$xP=c,e.$xP=c=Je([Ve(0,s.$cP),Ve(1,$.$Wj),Ve(2,i.$wP)],c),e.$yP=(0,m.$qi)("IExtHostCommands");class f{constructor(g,D,w){this.d=g,this.f=D,this.g=w,this.delegatingCommandId=`__vsc${(0,b.$Mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,D){if(!g)return;const w={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return w;const C=this.f(g.command);if(C)w.id=C.internalId,w.arguments=C.args.map((P,V)=>P.convert(g.arguments&&g.arguments[V]));else if((0,p.$Lb)(g.arguments)){const P=`${g.command} /${++this.c}`;this.b.set(P,g),D.add((0,v.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),w.$ident=P,w.id=this.delegatingCommandId,w.arguments=[P],this.g.trace("CommandsConverter#CREATE",g.command,P)}return w}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const D=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$zP=f;class u{static{this.Uri=new u("uri","Uri of a text document",g=>l.URI.isUri(g),g=>g)}static{this.Position=new u("position","A position in a text document",g=>N.$SM.isPosition(g),A.Position.from)}static{this.Range=new u("range","A range in a text document",g=>N.$TM.isRange(g),A.Range.from)}static{this.Selection=new u("selection","A selection in a text document",g=>N.$UM.isSelection(g),A.Selection.from)}static{this.Number=new u("number","",g=>typeof g=="number",g=>g)}static{this.String=new u("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=u.Arr(u.String)}static Arr(g){return new u(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,D=>Array.isArray(D)&&D.every(w=>g.validate(w)),D=>D.map(w=>g.convert(w)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",g=>g instanceof N.$cN,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",g=>g instanceof N.$AO,A.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",g=>g instanceof o.$pP,A.TestItem.from)}constructor(g,D,w,C){this.name=g,this.description=D,this.validate=w,this.convert=C}optional(){return new u(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,D){return new u(g??this.name,D??this.description,this.validate,this.convert)}}e.$AP=u;class S{static{this.Void=new S("no result",g=>g)}constructor(g,D){this.description=g,this.convert=D}}e.$BP=S;class h{constructor(g,D,w,C,P){this.id=g,this.internalId=D,this.description=w,this.args=C,this.result=P}}e.$CP=h}),define(Ae[275],Re([1,0,18,12,2,87,97,31,32,8,7]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=void 0;const y=[new $.$CP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of DocumentHighlight-instances.",v(k.DocumentHighlight.to))),new $.$CP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$AP.Uri],new $.$BP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,I.$Kb)(s))return;class n extends T.$0M{static to(t){const a=new n(t.name,k.SymbolKind.to(t.kind),t.containerName||"",new T.$4M(o[0],k.Range.to(t.range)));return a.detail=t.detail,a.range=a.location.range,a.selectionRange=k.Range.to(t.selectionRange),a.children=t.children?t.children.map(n.to):[],a}}return s.map(n.to)})),new $.$CP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$AP.Uri,new $.$AP("options","Formatting options",s=>!0,s=>s)],new $.$BP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new $.$CP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$AP.Uri,$.$AP.Range,new $.$AP("options","Formatting options",s=>!0,s=>s)],new $.$BP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new $.$CP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$AP.Uri,$.$AP.Position,new $.$AP("ch","Trigger character",s=>typeof s=="string",s=>s),new $.$AP("options","Formatting options",s=>!0,s=>s)],new $.$BP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new $.$CP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",m)),new $.$CP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",m)),new $.$CP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",m)),new $.$CP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",m)),new $.$CP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location-instances.",v(k.location.to))),new $.$CP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Hover-instances.",v(k.Hover.to))),new $.$CP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$AP.Uri,new $.$AP("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>T.$SM.isPosition(o)),s=>s.map(k.Position.from))],new $.$BP("A promise that resolves to an array of ranges.",s=>s.map(o=>{let n;for(const r of o.reverse())n=new T.$bN(k.Range.to(r),n);return n}))),new $.$CP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$AP.String.with("query","Search string")],new $.$BP("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new $.$CP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new $.$CP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$AP.CallHierarchyItem],new $.$BP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new $.$CP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$AP.CallHierarchyItem],new $.$BP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new $.$CP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:k.Range.to(s.range),placeholder:s.text}})),new $.$CP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$AP.Uri,$.$AP.Position,$.$AP.String.with("newName","The new symbol name")],new $.$BP("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new $.$CP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$AP.Uri,$.$AP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$BP("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new $.$CP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$AP.Uri],new $.$BP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$0N(s.tokenTypes,s.tokenModifiers)})),new $.$CP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$AP.Uri],new $.$BP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$ubb)(s);if(o.type==="full")return new T.$_N(o.data,void 0)})),new $.$CP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$AP.Uri,$.$AP.Range.optional()],new $.$BP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$0N(s.tokenTypes,s.tokenModifiers)})),new $.$CP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$AP.Uri,$.$AP.Range],new $.$BP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$ubb)(s);if(o.type==="full")return new T.$_N(o.data,void 0)})),new $.$CP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$AP.Uri,$.$AP.Position,$.$AP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$AP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$BP("A promise that resolves to a CompletionList-instance.",(s,o,n)=>{if(!s)return new T.$nN([]);const r=s.suggestions.map(t=>k.CompletionItem.to(t,n));return new T.$nN(r,s.incomplete)})),new $.$CP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$AP.Uri,$.$AP.Position,$.$AP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$BP("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new $.$CP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$AP.Uri,$.$AP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$BP("A promise that resolves to an array of CodeLens-instances.",(s,o,n)=>v(r=>new T.$fN(k.Range.to(r.range),r.command&&n.fromInternal(r.command)))(s))),new $.$CP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$AP.Uri,new $.$AP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.$TM.isRange(s),s=>T.$UM.isSelection(s)?k.Selection.from(s):k.Range.from(s)),$.$AP.String.with("kind","Code action kind to return code actions for").optional(),$.$AP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$BP("A promise that resolves to an array of Command-instances.",(s,o,n)=>v(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return n.fromInternal(r.command)}else{const t=new T.$_M(r.title,r.kind?new T.$aN(r.kind):void 0);return r.edit&&(t.edit=k.WorkspaceEdit.to(r.edit)),r.command&&(t.command=n.fromInternal(r.command)),t.isPreferred=r.isPreferred,t}})(s))),new $.$CP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$AP.Uri],new $.$BP("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new T.$tN(k.Range.to(o.range),k.Color.to(o.color))):[])),new $.$CP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$AP("color","The color to show and insert",s=>s instanceof T.$sN,k.Color.from),new $.$AP("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new $.$BP("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new $.$CP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$AP.Uri,$.$AP.Range],new $.$BP("A promise that resolves to an array of Inlay objects",(s,o,n)=>s.map(k.InlayHint.to.bind(void 0,n)))),new $.$CP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$AP.Uri],new $.$BP("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(k.FoldingRange.to)})),new $.$CP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$BP("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new $.$CP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$AP.Uri,$.$AP.Range,new $.$AP("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof T.$TM,s=>k.InlineValueContext.from(s))],new $.$BP("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new $.$CP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$AP("uriOrString","Uri-instance or string (only http/https)",s=>A.URI.isUri(s)||typeof s=="string"&&(0,N.$Ag)(s,N.Schemas.http,N.Schemas.https),s=>s),new $.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),$.$AP.String.with("label","").optional()],$.$BP.Void),new $.$CP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$AP.Uri.with("resource","Resource to open"),$.$AP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],$.$BP.Void),new $.$CP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$AP.Uri.with("left","Left-hand side resource of the diff editor"),$.$AP.Uri.with("right","Right-hand side resource of the diff editor"),$.$AP.String.with("title","Human readable title for the diff editor").optional(),new $.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],$.$BP.Void),new $.$CP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$AP.String.with("title","Human readable title for the changes editor"),new $.$AP("resourceList","List of resources to compare",s=>{for(const o of s){if(o.length!==3)return!1;const[n,r,t]=o;if(!A.URI.isUri(n)||!A.URI.isUri(r)&&r!==void 0&&r!==null||!A.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},s=>s)],$.$BP.Void),new $.$CP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new $.$CP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$AP.TypeHierarchyItem],new $.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new $.$CP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$AP.TypeHierarchyItem],new $.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new $.$CP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$AP.TestItem],$.$BP.Void),new $.$CP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$AP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$BP.Void),new $.$CP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$AP.String.with("name","The context key name"),new $.$AP("value","The context key value",()=>!0,s=>s)],$.$BP.Void),new $.$CP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$AP.Uri,$.$AP.StringArray,new $.$AP("MappedEditsContext","Mapped Edits Context",s=>k.MappedEditsContext.is(s),s=>k.MappedEditsContext.from(s))],new $.$BP("A promise that resolves to a workspace edit or null",s=>s?k.WorkspaceEdit.to(s):null))];class l{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",p.$pj)}}e.$okc=l;function v(s){return o=>{if(Array.isArray(o))return o.map(s)}}function m(s){if(!Array.isArray(s))return;const o=[];for(const n of s)O.$2t(n)?o.push(k.DefinitionLink.to(n)):o.push(k.location.to(n));return o}}),define(Ae[276],Re([1,0,11,6,2,4,32,8,7]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class k{static{this.a=0}constructor(v,m){this.extension=v,this.provider=m,this.handle=k.a++}}class T{constructor(v){this.session=v,this.responses=[]}}class y{static{this.a=0}constructor(v,m,s,o){this.f=s,this.g=o,this.b=new Map,this.d=new Map,this.e=v.getProxy(O.$PM.MainThreadInlineChat),m.registerApiCommand(new M.$CP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$AP("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?p.Range.from(n.initialRange):void 0,initialSelection:$.$UM.isSelection(n.initialSelection)?p.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?p.Position.from(n.position):void 0}})],M.$BP.Void))}registerProvider(v,m,s){const o=new k(v,m);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,s?.label??v.displayName??v.name,v.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",s?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(v,m,s,o){const n=this.b.get(v);if(!n){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(A.URI.revive(m)),t=p.Selection.to(s),a=await n.provider.prepareInteractiveEditorSession({document:r,selection:t},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(t))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const d=y.a++;return this.d.set(d,new T(a)),{id:d,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:p.Range.from(a.wholeRange),message:a.message}}async $provideResponse(v,m,s,o){const n=this.b.get(v);if(!n)return;const r=this.d.get(m.id);if(!r)return;const t={prompt:s.prompt,selection:p.Selection.to(s.selection),wholeRange:p.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(A.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let a=!1;const d={report:async E=>{if(!s.live&&E.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:E.message,edits:E.edits?.map(p.TextEdit.from),editsShouldBeInstant:E.editsShouldBeInstant,slashCommand:E.slashCommand?.command,markdownFragment:$.$gN.isMarkdownString(E.content)?E.content.value:E.content})}},i=Promise.resolve(n.provider.provideInteractiveEditorResponse(r.session,t,d,o));let b;try{b=await(0,I.$eh)(i,o)}finally{a=!0}if(!b)return;const c=r.responses.push(b)-1,f={wholeRange:p.Range.from(b.wholeRange),placeholder:b.placeholder};if(!y.h(b))return{...f,id:c,type:"editorEdit",message:p.MarkdownString.from(b.contents),edits:[]};const{edits:u,contents:S}=b,h=S!==void 0?p.MarkdownString.from(S):void 0;return u instanceof $.$2M?{...f,id:c,type:"bulkEdit",edits:p.WorkspaceEdit.from(u),message:h}:{...f,id:c,type:"editorEdit",edits:u.map(p.TextEdit.from),message:h}}async $provideFollowups(v,m,s,o){const n=this.b.get(v),r=this.d.get(m),t=r?.responses[s];if(n&&t&&n.provider.provideFollowups){const a=Promise.resolve(n.provider.provideFollowups(r.session,t,o));return(await(0,I.$eh)(a,o))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(v,m,s,o){const n=this.b.get(v),r=this.d.get(m),t=r?.responses[s];if(n&&t){const a=p.InteractiveEditorResponseFeedbackKind.to(o);n.provider.handleInteractiveEditorResponseFeedback?.(r.session,t,a)}}$releaseSession(v,m){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$xlc=y}),define(Ae[277],Re([1,0,2,32]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class A{constructor(M,p,$,k,T){this.a=p,this.b=$,this.c=k;const y=new N.$CP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$AP("showOptions","Show Options",l=>!0,l=>l),new N.$AP("resource","Interactive resource Uri",l=>!0,l=>l),new N.$AP("controllerId","Notebook controller Id",l=>!0,l=>l),new N.$AP("title","Interactive editor title",l=>!0,l=>l)],new N.$BP("Notebook and input URI",l=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const v=this.a.getEditorById(l.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:I.URI.revive(l.notebookUri),inputUri:I.URI.revive(l.inputUri),notebookEditor:v.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:I.URI.revive(l.notebookUri),inputUri:I.URI.revive(l.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(M,p,$,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:$,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Klc=A}),define(Ae[278],Re([1,0,18,11,22,5,6,28,2,20,13,4,32,8,7,76,219,25,34,220]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0,e.$Slc=u;let a=class{constructor(h,E,g,D,w){this.m=E,this.n=g,this.o=D,this.q=w,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=h.getProxy(y.$PM.MainThreadNotebookKernels);const C=new l.$CP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$AP("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],l.$BP.Void),P=new l.$CP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$AP.Uri],new l.$BP("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(h,E,g,D,w,C){for(const Pe of this.j.values())if(Pe.controller.id===E&&k.$Lm.equals(h.identifier,Pe.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const P=this.k++,V=this;this.q.trace(`NotebookController[${P}], CREATED by ${h.identifier.value}, ${E}`);const W=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${h.identifier}'`);let q=!1;const R=new O.$be,U=new O.$be,K={id:u(h.identifier,E),notebookType:g,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:D||h.identifier.value,preloads:C?C.map(v.NotebookRendererScript.from):[]};let se=w??W,ce,ve;this.a.$addKernel(P,K).catch(Pe=>{console.log(Pe),q=!0});let Ie=0;const ue=()=>{if(q)return;const Pe=++Ie;Promise.resolve().then(()=>{Pe===Ie&&this.a.$updateKernel(P,K)})},be=new p.$Bc,ie={get id(){return E},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return K.label},set label(Pe){K.label=Pe??h.displayName??h.name,ue()},get detail(){return K.detail??""},set detail(Pe){K.detail=Pe,ue()},get description(){return K.description??""},set description(Pe){K.description=Pe,ue()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(Pe){K.supportedLanguages=Pe,ue()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(Pe){K.supportsExecutionOrder=Pe,ue()},get rendererScripts(){return K.preloads?K.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return se},set executeHandler(Pe){se=Pe??W},get interruptHandler(){return ce},set interruptHandler(Pe){ce=Pe,K.supportsInterrupt=!!Pe,ue()},set variableProvider(Pe){(0,n.$yG)(h,"notebookVariableProvider"),ve=Pe,K.hasVariableProvider=!!Pe,Pe?.onDidChangeVariables(Fe=>V.a.$variablesUpdated(Fe.uri)),ue()},get variableProvider(){return ve},createNotebookCellExecution(Pe){if(q)throw new Error("notebook controller is DISPOSED");if(!be.has(Pe.notebook.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(Fe=>Fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Pe.notebook.uri.toString()}`);return V._createNotebookCellExecution(Pe,u(h.identifier,this.id))},createNotebookExecution(Pe){if((0,n.$yG)(h,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!be.has(Pe.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(Fe=>Fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Pe.uri.toString()}`);return V._createNotebookExecution(Pe,u(h.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),R.dispose(),U.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(Pe,Fe){Fe===m.NotebookControllerAffinity2.Hidden&&(0,n.$yG)(h,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(P,Pe.uri,Fe)},onDidReceiveMessage:U.event,postMessage(Pe,Fe){return(0,n.$yG)(h,"notebookMessaging"),V.a.$postMessage(P,Fe&&V.n.getIdByEditor(Fe),Pe)},asWebviewUri(Pe){return(0,n.$yG)(h,"notebookMessaging"),(0,s.$Rxb)(Pe,V.m.remote)}};return this.j.set(P,{extensionId:h.identifier,controller:ie,onDidReceiveMessage:U,onDidChangeSelection:R,associatedNotebooks:be}),ie}getIdByController(h){for(const[E,g]of this.j)if(g.controller===h)return u(g.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,E){const g=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(g,E);const w={dispose:()=>{this.f.delete(g),D.a.$removeKernelDetectionTask(g)}};return this.f.set(g,w),w}registerKernelSourceActionProvider(h,E,g){const D=this.i++,w=typeof g.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,C=this;this.h.set(D,g),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,E);let P;return w!==void 0&&(P=g.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(D),C.a.$removeKernelSourceActionProvider(D,D),P?.dispose()}}}async $provideKernelSourceActions(h,E){const g=this.h.get(h);if(g){const D=new M.$Tc;return(await g.provideNotebookKernelSourceActions(E)??[]).map(C=>v.NotebookKernelSourceAction.from(C,this.o.converter,D))}return[]}$acceptNotebookAssociation(h,E,g){const D=this.j.get(h);if(D){const w=this.n.getNotebookDocument($.URI.revive(E));g?D.associatedNotebooks.set(w.uri,!0):D.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${h}] ASSOCIATE notebook`,w.uri.toString(),g),D.onDidChangeSelection.fire({selected:g,notebook:w.apiNotebook})}}async $executeCells(h,E,g){const D=this.j.get(h);if(!D)return;const w=this.n.getNotebookDocument($.URI.revive(E)),C=[];for(const P of g){const V=w.getCell(P);V&&C.push(V.apiCell)}try{this.q.trace(`NotebookController[${h}] EXECUTE cells`,w.uri.toString(),C.length),await D.controller.executeHandler.call(D.controller,C,w.apiNotebook,D.controller)}catch(P){this.q.error(`NotebookController[${h}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(h,E,g){const D=this.j.get(h);if(!D)return;const w=this.n.getNotebookDocument($.URI.revive(E));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,w.apiNotebook);else for(const C of g){const P=w.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(D.controller.interruptHandler){const C=this.c.get(w.uri);g.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(h,E,g,D,w,C,P){const V=this.j.get(h);if(!V)return;const W=this.n.getNotebookDocument($.URI.revive(g)),q=V.controller.variableProvider;if(!q)return;let R;if(D!==void 0){if(R=this.s[D],!R)return}else this.s={};const U=w==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(W.apiNotebook,R,U,C,P);let se=0;for await(const ce of K){if(P.isCancellationRequested)return;const ve={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ve.id]=ce.variable,this.a.$receiveVariable(E,ve),se++>=t.$wib)return}}$acceptKernelMessageFromRenderer(h,E,g){const D=this.j.get(h);if(!D)return;const w=this.n.getEditorById(E);D.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:g}))}$cellExecutionChanged(h,E,g){const w=this.n.getNotebookDocument($.URI.revive(h)).getCell(E);if(w){const C=g?v.NotebookCellExecutionState.to(g):m.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:w.apiCell,state:C})}}_createNotebookCellExecution(h,E){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const w=new i(E,D,this.a);this.b.set(D.uri,w);const C=w.onDidChangeState(()=>{w.state===d.Resolved&&(w.dispose(),C.dispose(),this.b.delete(D.uri))});return w.asApiObject()}_createNotebookExecution(h,E){const g=this.n.getNotebookDocument(h.uri),D=h.getCells().find(P=>{const V=g.getCellFromApiCell(P);return V&&this.b.has(V.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const w=new c(E,g,this.a),C=w.onDidChangeState(()=>{w.state===b.Resolved&&(w.dispose(),C.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[w,C]),w.asApiObject()}};e.$Rlc=a,e.$Rlc=a=Je([Ve(4,T.$Wj)],a);var d;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(d||(d={}));class i extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(h,E,g){super(),this.m=E,this.n=g,this.b=i.a++,this.c=new O.$be,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new A.$me),this.h=new f(10,D=>this.s(D)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const E=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new r.$mw(E))}t(){if(this.f===d.Init)throw new Error("Must call start before modifying cell output");if(this.f===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let E=this.m;if(h&&(E=this.m.notebook.getCellFromApiCell(h)),!E)throw new Error("INVALID cell");return E.handle}y(h){return h.map(E=>{const g=m.$kO.ensureUniqueMimeTypes(E.items,!0);return g===E.items?v.NotebookCellOutput.from(E):v.NotebookCellOutput.from({items:g,id:E.id,metadata:E.metadata})})}async z(h,E,g){const D=this.w(E),w=this.y((0,I.$3b)(h));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:D,append:g,outputs:w})}async C(h,E,g){return h=m.$kO.ensureUniqueMimeTypes((0,I.$3b)(h),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:h.map(v.NotebookCellOutputItem.from),outputId:E.id,append:g})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(g){h.j=g,h.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(g){if(h.f===d.Resolved||h.f===d.Started)throw new Error("Cannot call start again");h.f=d.Started,h.c.fire(),h.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,D,w){if(h.f===d.Resolved)throw new Error("Cannot call resolve twice");h.f=d.Resolved,h.c.fire(),h.h.flush();const C=w?{message:w.message,stack:w.stack,location:w?.location?{startLineNumber:w.location.start.line,startColumn:w.location.start.character,endLineNumber:w.location.end.line,endColumn:w.location.end.character}:void 0,uri:w.uri}:void 0;h.n.$completeExecution(h.b,new r.$mw({runEndTime:D,lastRunSuccess:g,error:C}))},clearOutput(g){return h.t(),h.z([],g,!1)},appendOutput(g,D){return h.t(),h.z(g,D,!0)},replaceOutput(g,D){return h.t(),h.z(g,D,!1)},appendOutputItems(g,D){return h.t(),h.C(g,D,!0)},replaceOutputItems(g,D){return h.t(),h.C(g,D,!1)}})}}var b;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(b||(b={}));class c extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(h,E,g){super(),this.h=E,this.j=g,this.b=c.a++,this.c=new O.$be,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new A.$me),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===b.Resolved||this.f===b.Started)throw new Error("Cannot call start again");this.f=b.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===b.Resolved)throw new Error("Cannot call resolve twice");this.f=b.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class f{constructor(h,E){this.f=h,this.g=E,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new N.$Nh,this.b=Date.now(),(0,N.$rh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>h.complete())}}function u(S,h){return`${S.value}/${h}`}}),define(Ae[51],Re([1,0,5,4,3,2,16,6,7,172,14,201,22,35,202,42,11,8,32]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=e.$5kc=e.$4kc=e.$3kc=void 0,e.$3kc=(0,A.$qi)("IExtHostTerminalService");class t extends p.$Uc{constructor(g,D,w,C){super(),this.u=g,this._id=D,this.w=w,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(V,W=!0){P.C(),P.u.$sendText(P._id,V,W)},show(V){P.C(),P.u.$show(P._id,V)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(g,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??D?.cwd??void 0,env:g.env??void 0,icon:u(g.iconPath)??void 0,color:s.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(g.location,D?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,D,w,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:s.ThemeColor.isThemeColor(P)?P.id:void 0,location:D?.location||this.z(g,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(g,D){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in g?{viewColumn:n.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.y=g}setExitStatus(g,D){this.j=Object.freeze({code:g,reason:D})}setDimensions(g,D){return g===this.f&&D===this.h||g===0||D===0?!1:(this.f=g,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(g){this.n=g}_setProcessId(g){this.g?(this.g(g),this.g=void 0):this.b.then(D=>{D!==g&&(this.b=Promise.resolve(g))})}}e.$4kc=t;class a{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new I.$be,this.onProcessData=this.a.event,this.b=new I.$be,this.d=new I.$be,this.onDidChangeProperty=this.d.event,this.f=new I.$be,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,D){this.g.setDimensions?.({columns:g,rows:D})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,i=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,D,w){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$be,this.onDidCloseTerminal=this.H.event,this.I=new I.$be,this.onDidOpenTerminal=this.I.event,this.J=new I.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$be,this.onDidChangeTerminalState=this.M.event,this.N=new I.$be,this.onDidChangeShell=this.N.event,this.O=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(N.$PM.MainThreadTerminalService),this.y=new m.$Rsb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:C=>{const P=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let V=0;V<C.length&&C[V].$mid===15;V++)C[V]=P(C[V]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,D){const w=new t(this.a,(0,v.$Mg)(),g,g.name),C=new a(g.pty);return w.createExtensionTerminal(g.location,D,this.R(g,D).resolvedExtHostIdentifier,u(g.iconPath),S(g.color)).then(P=>{const V=this.S(P,C);this.h[P]=V}),this.f.push(w),w.value}R(g,D){if(D=D||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const w=g.location.parentTerminal;if(w){const C=this.f.find(P=>P.value===w);C&&(D.resolvedExtHostIdentifier=C._id)}}else g.location&&typeof g.location!="object"?D.location=g.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(g,D){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const C=new a(D),P=this.S(g,C);this.h[g]=P}async $acceptActiveTerminalChanged(g){const D=this.b;if(g===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const w=this.getTerminalById(g);w&&(this.b=w,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,D){const w=this.getTerminalById(g);w&&this.O.fire({terminal:w.value,data:D})}async $acceptTerminalDimensions(g,D,w){const C=this.getTerminalById(g);C&&C.setDimensions(D,w)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(g,D){const w=this.getTerminalById(g);w&&this.P.fire({terminal:w.value,...D})}async $acceptTerminalMaximumDimensions(g,D,w){this.g.get(g)?.resize(D,w)}async $acceptTerminalTitleChange(g,D){const w=this.getTerminalById(g);w&&(w.name=D)}async $acceptTerminalClosed(g,D,w){const C=this.X(this.f,g);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(D,w),this.H.fire(P.value)}}$acceptTerminalOpened(g,D,w,C){if(D){const W=this.X(this.f,D);if(W!==null){this.f[W]._id=g,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:O.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},V=new t(this.a,g,P,w);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(g,D){this.getTerminalById(g)?._setProcessId(D)}async $startExtensionTerminal(g,D){const w=this.getTerminalById(g);if(!w)return{message:(0,k.localize)(0,null,g)};w.isOpen||await new Promise(P=>{const V=this.onDidOpenTerminal(async W=>{W===w.value&&(V.dispose(),P())})});const C=this.g.get(g);C?C.startSendingEvents(D):this.j[g]={initialDimensions:D}}S(g,D){const w=new p.$Tc;w.add(D.onProcessReady(P=>this.a.$sendProcessReady(g,P.pid,P.cwd,P.windowsPty))),w.add(D.onDidChangeProperty(P=>this.a.$sendProcessProperty(g,P))),this.y.startBuffering(g,D.onProcessData),w.add(D.onProcessExit(P=>this.U(g,P))),this.g.set(g,D);const C=this.j[g];return C&&D instanceof a&&(D.startSendingEvents(C.initialDimensions),delete this.j[g]),w}$acceptProcessAckDataEvent(g,D){this.g.get(g)?.acknowledgeDataEvent(D)}$acceptProcessInput(g,D){this.g.get(g)?.input(D)}$acceptTerminalInteraction(g){const D=this.getTerminalById(g);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(g,D){this.getTerminalById(g)?.setSelection(D)}$acceptProcessResize(g,D,w){try{this.g.get(g)?.resize(D,w)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(g,D){this.g.get(g)?.shutdown(D)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(D=>this.a.$sendProcessProperty(g,{type:"cwd",value:D}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new $.$RM(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,D,w){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,w),this.a.$registerProfileProvider(D,g.identifier.value),new $.$RM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(g,D,w){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,w),this.a.$registerQuickFixProvider(g,D),new $.$RM(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,D){const w=new l.$me().token;if(w.isCancellationRequested)return;const C=this.D.get(g);if(!C)return;const P=await C.provideTerminalQuickFixes(D,w);if(P===null||Array.isArray(P)&&P.length===0)return;const V=new p.$Tc;if(this.w.value=V,!Array.isArray(P))return P?n.TerminalQuickFix.from(P,this.Q.converter,V):void 0;const W=[];for(const q of P){const R=n.TerminalQuickFix.from(q,this.Q.converter,V);R&&W.push(R)}return W}async $createContributedProfileTerminal(g,D){const w=new l.$me().token;let C=await this.C.get(g)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,D);return}this.createTerminalFromOptions(C.options,D)}}async $provideLinks(g,D){const w=this.getTerminalById(g);if(!w)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const P=new l.$me;this.G.set(g,P);const V=[],W={terminal:w.value,line:D},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async se=>{P.token.onCancellationRequested(()=>se({provider:K,links:[]}));const ce=await K.provideTerminalLinks(W,P.token)||[];P.token.isCancellationRequested||se({provider:K,links:ce})}));const R=await Promise.all(q);if(P.token.isCancellationRequested)return[];const U=new Map;for(const K of R)K&&K.links.length>0&&V.push(...K.links.map(se=>{const ce={id:d++,startIndex:se.startIndex,length:se.length,label:se.tooltip};return U.set(ce.id,{provider:K.provider,link:se}),ce}));return this.F.set(g,U),V}$activateLink(g,D){const w=this.F.get(g)?.get(D);w&&w.provider.handleTerminalLink(w.link)}U(g,D){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const w=this.h[g];w&&(w.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,D)}getTerminalById(g){return this.W(this.f,g)}getTerminalIdByApiObject(g){const D=this.f.findIndex(w=>w.value===g);return D>=0?D:null}W(g,D){const w=this.X(g,D);return w!==null?g[w]:null}X(g,D){const w=g.findIndex(C=>C._id===D);return w>=0?w:null}getEnvironmentVariableCollection(g){let D=this.n.get(g.identifier.value);return D||(D=new b,this.Z(g.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(g,D){const w=(0,y.$cs)(D.map),C=(0,y.$ds)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(g,D.persistent,w.length===0?void 0:w,C)}$initEnvironmentVariableCollections(g){g.forEach(D=>{const w=D[0],C=new b(D[1]);this.Z(w,C)})}$acceptDefaultProfile(g,D){const w=this.s;this.s=g,this.u=D,w?.path!==g.path&&this.N.fire(g.path)}Z(g,D){this.n.set(g,D),D.onDidChangeCollection(()=>{this.Y(g,D)})}};e.$5kc=i,e.$5kc=i=Je([Ve(1,r.$yP),Ve(2,M.$cP)],i);class b{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$be,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const D=this.h(g);let w=this.a.get(D);return w||(w=new c(this,g),this.a.set(D,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(g,D,w,C){this.f(g,{value:D,type:$.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:C})}append(g,D,w,C){this.f(g,{value:D,type:$.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:C})}prepend(g,D,w,C){this.f(g,{value:D,type:$.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:C})}f(g,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(g,D.scope),C=this.map.get(w),P=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==D.value||C.type!==D.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const V=this.g(g,D.scope),W={variable:g,...D,options:P};this.map.set(V,W),this.d.fire()}}get(g,D){const w=this.g(g,D),C=this.map.get(w);return C?h(C):void 0}g(g,D){const w=this.h(D);return w.length?`${g}:::${w}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const D=new Map;for(const[w,C]of this.map)this.h(C.scope)===this.h(g)&&D.set(C.variable,h(C));return D}delete(g,D){const w=this.g(g,D);this.map.delete(w),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[D,w]of this.map)w.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(D);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,D){const w=this.h(D),C=this.descriptionMap.get(w);if(!C||C.description!==g){let P;typeof g=="string"?P=g:P=g?.value.split(`

`)[0];const V={description:P,scope:D};this.descriptionMap.set(w,V),this.d.fire()}}getDescription(g){const D=this.h(g);return this.descriptionMap.get(D)?.description}k(g){const D=this.h(g);this.descriptionMap.delete(D)}}class c{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,D){this.b=g,this.d=D,this.a=new I.$be}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,D,w){this.b.replace(g,D,w,this.d)}append(g,D,w){this.b.append(g,D,w,this.d)}prepend(g,D,w){this.b.prepend(g,D,w,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,D){this.b.getVariableMap(this.d).forEach((w,C)=>g.call(D,C,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let f=class extends i{constructor(g,D){super(!1,g,D)}createTerminal(g,D,w){throw new T.$_}createTerminalFromOptions(g,D){throw new T.$_}};e.$6kc=f,e.$6kc=f=Je([Ve(0,r.$yP),Ve(1,M.$cP)],f);function u(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function S(E){return s.ThemeColor.isThemeColor(E)?E:void 0}function h(E){const g={...E};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ae[114],Re([1,0,7,6,3,4,16,51,5,2,11]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=e.$0lc=void 0,e.$0lc=(0,A.$qi)("IExtHostTerminalShellIntegration");let y=class extends N.$Uc{constructor(o,n){super(),this.h=n,this.b=new Map,this.c=new $.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$PM.MainThreadTerminalShellIntegration),this.B((0,N.$Sc)(()=>{for(const[r,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(o){const n=this.h.getTerminalById(o);if(!n)return;const r=n.value;let t=this.b.get(o);t||(t=new l(n.value,this.f),this.b.set(o,t),t.store.add(n.onWillDispose(()=>this.b.get(o)?.dispose())),t.store.add(t.onDidRequestShellExecution(a=>this.a.$executeCommand(o,a))),t.store.add(t.onDidRequestEndExecution(a=>this.g.fire(a))),t.store.add(t.onDidRequestChangeShellIntegration(a=>this.c.fire(a))),n.shellIntegration=t.value),this.c.fire({terminal:r,shellIntegration:t.value})}$shellExecutionStart(o,n,r,t,a){this.b.has(o)||this.$shellIntegrationChange(o);const d={value:n,confidence:r,isTrusted:t};this.b.get(o)?.startShellExecution(d,a)}$shellExecutionEnd(o,n,r,t,a){const d={value:n,confidence:r,isTrusted:t};this.b.get(o)?.endShellExecution(d,a)}$shellExecutionData(o,n){this.b.get(o)?.emitData(n)}$cwdChange(o,n){this.b.get(o)?.setCwd((0,k.$wc)(n)?k.URI.revive(n):n)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$$lc=y,e.$$lc=y=Je([Ve(0,M.$cP),Ve(1,p.$3kc)],y);class l extends N.$Uc{get currentExecution(){return this.a}constructor(o,n){super(),this.j=o,this.m=n,this.b=!1,this.store=this.B(new N.$Tc),this.f=this.B(new $.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$be),this.onDidRequestEndExecution=this.h.event;const r=this;this.value={get cwd(){return r.c},executeCommand(t,a){let d=t;a&&(d+=` "${a.map(c=>`${c.replaceAll('"','\\"')}`).join('" "')}"`),r.g.fire(d);const i={value:d,confidence:I.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},b=r.startShellExecution(i,r.c,!0).value;return r.b=!0,b}}}startShellExecution(o,n,r){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new v(o,n);r?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,n){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:n}),this.a=void 0)}setCwd(o){let n=!1;k.URI.isUri(this.c)?n=!k.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(n=!0),n&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class v{constructor(o,n){this.c=o,this.cwd=n,this.b=!1;const r=this;this.value={get commandLine(){return r.c},get cwd(){return r.cwd},read(){return r.d()}}}d(){if(!this.a){if(this.b)return T.$Qh.EMPTY;this.a=new m}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class m extends N.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const o=this.a=new T.$ph;return new T.$Qh(async r=>{this.b.push(r),await o.wait()})}emitData(o){for(const n of this.b)n.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ae[279],Re([1,0,11,23,22,5,251,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=e.$amc=e.$_lc=void 0;let a=class extends $.$Uc{constructor(P,V,W,q){super(),this.w=q,this.f=this.B(new O.$be),this.g=new Map,this.s=this.B(new O.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(l.$PM.MainThreadTesting),this.m=new E(this.h),this.j=new c(this.h,V),W.registerArgumentProcessor({processArgument:R=>{switch(R?.$mid){case 16:{const U=R,K=U.tests[U.tests.length-1].item.extId;return this.g.get(n.$BL.root(K))?.collection.tree.get(K)?.actual??(0,m.$oP)(R)}case 18:{const{test:U,message:K}=R,se=U.item.extId;return{test:this.g.get(n.$BL.root(se))?.collection.tree.get(se)?.actual??(0,m.$oP)({$mid:16,tests:[U]}),message:s.TestMessage.to(K)}}default:return R}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const R=await W.executeCommand("_testing.getExplorerSelection"),U=K=>{const se=this.g.get(n.$BL.root(K));if(se)return n.$BL.isRoot(K)?se.controller:se.collection.tree.get(K)?.actual};return{include:R?.include.map(U).filter(k.$_f)||[],exclude:R?.exclude.map(U).filter(k.$_f)||[]}})}createTestController(P,V,W,q){if(this.g.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const R=new $.$Tc,U=R.add(new m.$rP(V,W,this.w));U.root.label=W;const K=new Map,se=new Set,ce=this.h,ve={items:U.root.children,get label(){return W},set label(ue){W=ue,U.root.label=ue,ce.$updateController(V,{label:W})},get refreshHandler(){return q},set refreshHandler(ue){q=ue,ce.$updateController(V,{canRefresh:!!ue})},get id(){return V},createRunProfile:(ue,be,ie,Pe,Fe,ne)=>{let j=(0,p.$ej)(ue);for(;K.has(j);)j++;return new D(this.h,K,se,this.s.event,V,j,ue,be,ie,Pe,Fe,ne)},createTestItem(ue,be,ie){return new m.$pP(V,ue,be,ie)},createTestRun:(ue,be,ie=!0)=>this.j.createTestRun(V,U,ue,be,ie),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const be=ue instanceof Array?ue:[ue];this.h.$markTestRetired(be.map(ie=>n.$BL.fromExtHostTestItem(ie,V).toString()))}},set resolveHandler(ue){U.resolveHandler=ue},get resolveHandler(){return U.resolveHandler},dispose:()=>{R.dispose()}};ce.$registerTestController(V,W,!!q),R.add((0,$.$Sc)(()=>ce.$unregisterTestController(V)));const Ie={controller:ve,collection:U,profiles:K,extension:P,activeProfiles:se};return this.g.set(V,Ie),R.add((0,$.$Sc)(()=>this.g.delete(V))),R.add(U.onDidGenerateDiff(ue=>ce.$publishDiff(V,ue.map(t.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(P,V=A.CancellationToken.None){const W=f(P);if(!W)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(W.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(R=>n.$BL.fromExtHostTestItem(R,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:w[W.kind],profileId:W.profileId,controllerId:W.controllerId}],exclude:P.exclude?.map(R=>R.id)},V)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,V){return(await this.j.getCoverageDetails(P,V))?.map(s.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,V){this.g.get(P)?.profiles.get(V)?.configureHandler?.()}$setDefaultRunProfiles(P){const V=new Map;for(const[W,q]of Object.entries(P)){const R=this.g.get(W);if(!R)continue;const U=new Map,K=q.filter(ce=>!R.activeProfiles.has(ce)),se=[...R.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)U.set(ce,!0),R.activeProfiles.add(ce);for(const ce of se)U.set(ce,!1),R.activeProfiles.delete(ce);U.size&&V.set(W,U)}this.s.fire(V)}async $refreshTests(P,V){await this.g.get(P)?.controller.refreshHandler?.(V)}$publishTestResults(P){this.results=Object.freeze(P.map(s.TestResults.to).concat(this.results).sort((V,W)=>W.completedAt-V.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,V){const W=this.g.get(n.$BL.fromString(P).controllerId)?.collection;W&&(await W.expand(P,V<0?1/0:V),W.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(V=>t.TestsDiffOp.deserialize({asCanonicalUri:W=>W},V)))}async $runControllerTests(P,V){return Promise.all(P.map(W=>this.y(W,!1,V)))}async $startContinuousRun(P,V){const W=new A.$me(V),q=await Promise.all(P.map(R=>this.y(R,!0,W.token)));return!V.isCancellationRequested&&!q.some(R=>R.error)&&await new Promise(R=>V.onCancellationRequested(R)),W.dispose(!0),q}async y(P,V,W){const q=this.g.get(P.controllerId);if(!q)return{};const{collection:R,profiles:U}=q,K=U.get(P.profileId);if(!K)return{};const se=P.testIds.map(ue=>R.tree.get(ue)).filter(k.$_f),ce=P.excludeExtIds.map(ue=>q.collection.tree.get(ue)).filter(k.$_f).filter(ue=>se.some(be=>be.fullId.compare(ue.fullId)===2));if(!se.length)return{};const ve=new o.$rO(se.some(ue=>ue.actual instanceof m.$qP)?void 0:se.map(ue=>ue.actual),ce.map(ue=>ue.actual),K,V),Ie=(0,t.$EL)(P)&&this.j.prepareForMainThreadTestRun(ve,u.fromInternal(P,q.collection),K,W);try{return await K.runHandler(ve,W),{}}catch(ue){return{error:String(ue)}}finally{Ie&&Ie.hasRunningTasks&&!W.isCancellationRequested&&await O.Event.toPromise(Ie.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$_lc=a,e.$_lc=a=Je([Ve(0,v.$cP),Ve(1,y.$Wj)],a);const d=1e4;var i;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(i||(i={}));class b extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,V,W,q,R){super(),this.y=P,this.z=V,this.C=W,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$me(R));const U=this.B(new I.$Ch(()=>this.F(),d));this.B(this.j.token.onCancellationRequested(()=>U.schedule()));const K=new O.$be;this.s=K.event,this.B((0,$.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,V){const[,W,q]=n.$BL.fromString(P).path,R=this.w.get(q);if(!R)return[];const U=this.g.get(W);if(!U)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(U.run,R,V)??[]}createRun(P){const V=this.y.id,W=this.y.controllerId,q=(0,T.$Mg)(),R=ce=>(ve,...Ie)=>{if(K){this.C.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ve)&&(this.H(ve),ce(ve,...Ie))},U=(ce,ve)=>{const Ie=ve instanceof Array?ve.map(s.TestMessage.from):[s.TestMessage.from(ve)];if(ce.uri&&ce.range){const ue={range:s.Range.from(ce.range),uri:ce.uri};for(const be of Ie)be.location=be.location||ue}this.z.$appendTestMessagesInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),Ie)};let K=!1;const se={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ce=>{const ve=ce.uri.toString(),Ie=new n.$BL([V,q,ve]).toString();this.w.set(ve,ce),this.z.$appendCoverage(V,q,s.TestCoverage.fromFile(Ie,ce))},enqueued:R(ce=>{this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),1)}),skipped:R(ce=>{this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),5)}),started:R(ce=>{this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),2)}),errored:R((ce,ve,Ie)=>{U(ce,ve),this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),6,Ie)}),failed:R((ce,ve,Ie)=>{U(ce,ve),this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),4,Ie)}),passed:R((ce,ve)=>{this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ve)}),appendOutput:(ce,ve,Ie)=>{K||(Ie&&(this.y.isIncluded(Ie)?this.H(Ie):Ie=void 0),this.z.$appendOutputToRun(V,q,N.$Ce.fromString(ce),ve&&s.location.from(ve),Ie&&n.$BL.fromExtHostTestItem(Ie,W).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(V,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:se}),this.z.$startedTestRunTask(V,{id:q,name:P,running:!0}),se}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof m.$pP))throw new r.$7O(P.id);if(this.h.has(n.$BL.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const V=[],W=this.y.colllection.root;for(;;){const q=s.TestItem.from(P);if(V.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),P===W))break;P=P.parent||W}this.z.$addTestsToRun(this.y.controllerId,this.y.id,V)}dispose(){this.G(),super.dispose()}}class c{get trackers(){return this.c.values()}constructor(P,V){this.g=P,this.h=V,this.c=new Map,this.f=new Map}getCoverageDetails(P,V){const W=n.$BL.root(P);return this.f.get(W)?.getCoverageDetails(P,V)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[V,{id:W}]of this.c)W===P&&this.c.delete(V)}prepareForMainThreadTestRun(P,V,W,q){return this.j(P,V,W,q)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,V,W,q,R){const U=this.c.get(W);if(U)return U.createRun(q);const K=u.fromPublic(P,V,W,R),se=f(W);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!W.continuous,profile:se&&{group:w[se.kind],id:se.profileId},exclude:W.exclude?.map(ve=>n.$BL.fromExtHostTestItem(ve,V.root.id).toString())??[],id:K.id,include:W.include?.map(ve=>n.$BL.fromExtHostTestItem(ve,V.root.id).toString())??[V.root.id],persist:R});const ce=this.j(W,K,W.profile);return O.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(P,V,W,q){const R=new b(V,this.g,this.h,W,q);return this.c.set(P,R),this.f.set(R.id,R),R}}e.$amc=c;const f=C=>{if(C.profile){if(!(C.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class u{static fromPublic(P,V,W,q){return new u(P,(0,T.$Mg)(),W.include?.map(R=>n.$BL.fromExtHostTestItem(R,P).toString())??[P],W.exclude?.map(R=>n.$BL.fromExtHostTestItem(R,P).toString())??[],q,V)}static fromInternal(P,V){return new u(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,V)}constructor(P,V,W,q,R,U){this.controllerId=P,this.id=V,this.isPersisted=R,this.colllection=U,this.c=W.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(P){const V=n.$BL.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const W of this.f)if(V===W||V.startsWith(W))return!1;for(const W of this.c)if(V===W||V.startsWith(W))return!0;return!1}}e.$bmc=u;class S{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,s.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const V=n.$BL.parentId(P.item.extId);if(V&&this.h.has(V.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:V,g:W}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...V].map(q=>q.revived)},get removed(){return[...W].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class h extends t.$KL{constructor(){super(...arguments),this.s=new O.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,V){return{...P,revived:s.TestItem.toPlain(P.item),depth:V?V.depth+1:0,children:new Set}}v(){return new S(this.s)}}class E{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(V=>V.revived)},dispose:(0,M.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new h({asCanonicalUri:V=>V});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const g=(C,P,V,W)=>{V?Object.assign(V,W):P.$updateTestRunConfig(C.controllerId,C.profileId,W)};class D{#e;#t;#i;#n;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,g(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,g(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),g(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,g(this,this.#e,this.#n,{tag:P?s.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,g(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return O.Event.chain(this.#i,P=>P.map(V=>V.get(this.controllerId)?.get(this.profileId)).filter(k.$_f))}constructor(P,V,W,q,R,U,K,se,ce,ve=!1,Ie=void 0,ue=!1){this.controllerId=R,this.profileId=U,this.f=K,this.kind=se,this.runHandler=ce,this._tag=Ie,this.g=ue,this.#e=P,this.#s=V,this.#t=W,this.#i=q,V.set(U,this);const be=w[se];if(typeof be!="number")throw new Error(`Unknown TestRunProfile.group ${se}`);ve&&W.add(U),this.#n={profileId:U,controllerId:R,tag:Ie?s.TestTag.namespace(this.controllerId,Ie.id):null,label:K,group:be,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$cmc=D;const w={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ae[115],Re([1,0,56,14,90,8,7]),function(fe,e,I,N,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=e.$jP=void 0;class p{static{this.c=new A.$hP("TextEditorDecorationType")}constructor(l,v,m){const s=p.c.nextId();l.$registerTextEditorDecorationType(v.identifier,s,O.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$jP=p;class ${constructor(l,v){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,v){this.k();let m=null;if(l instanceof M.$SM)m=new M.$TM(l,l);else if(l instanceof M.$TM)m=l;else throw new Error("Unrecognized location");this.l(m,v,!1)}insert(l,v){this.k(),this.l(new M.$TM(l,l),v,!0)}delete(l){this.k();let v=null;if(l instanceof M.$TM)v=l;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(l,v,m){const s=this.c.validateRange(l);this.g.push({range:s,text:v,forceMoveMarkers:m})}setEndOfLine(l){if(this.k(),l!==M.EndOfLine.LF&&l!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=l}}class k{constructor(l,v,m,s){this.c=l,this.d=v,this._accept(m),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(n){o.n(n)},get indentSize(){return o.g},set indentSize(n){o.p(n)},get insertSpaces(){return o.j},set insertSpaces(n){o.s(n)},get cursorStyle(){return o.k},set cursorStyle(n){o.t(n)},get lineNumbers(){return o.l},set lineNumbers(n){o.u(n)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const v=Math.floor(l);return v>0?v:null}if(typeof l=="string"){const v=parseInt(l,10);return isNaN(v)?null:v>0?v:null}return null}n(l){const v=this.m(l);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const v=Math.floor(l);return v>0?v:null}if(typeof l=="string"){const v=parseInt(l,10);return isNaN(v)?null:v>0?v:null}return null}p(l){const v=this.o(l);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const v=this.q(l);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(l)})))}assign(l){const v={};let m=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(m=!0,v.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,m=!0,v.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(m=!0,v.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,m=!0,v.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(m=!0,v.insertSpaces=s):this.j!==s&&(this.j=s,m=!0,v.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,m=!0,v.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,m=!0,v.lineNumbers=O.TextEditorLineNumbersStyle.from(l.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(l,v){v.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(m)})}}e.$kP=k;class T{constructor(l,v,m,s,o,n,r,t){this.id=l,this.j=v,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,n,m),this.e=r,this.f=t;const a=this;this.value=Object.freeze({get document(){return s.value},set document(d){throw new N.$9("document")},get selection(){return a.c&&a.c[0]},set selection(d){if(!(d instanceof M.$UM))throw(0,N.$7)("selection");a.c=[d],a.l()},get selections(){return a.c},set selections(d){if(!Array.isArray(d)||d.some(i=>!(i instanceof M.$UM)))throw(0,N.$7)("selections");a.c=d,a.l()},get visibleRanges(){return a.e},set visibleRanges(d){throw new N.$9("visibleRanges")},get options(){return a.d.value},set options(d){a.g||a.d.assign(d)},get viewColumn(){return a.f},set viewColumn(d){throw new N.$9("viewColumn")},edit(d,i={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new $(s.value,i);return d(b),a.m(b)},insertSnippet(d,i,b={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!i||Array.isArray(i)&&i.length===0)c=a.c.map(f=>O.Range.from(f));else if(i instanceof M.$SM){const{lineNumber:f,column:u}=O.Position.from(i);c=[{startLineNumber:f,startColumn:u,endLineNumber:f,endColumn:u}]}else if(i instanceof M.$TM)c=[O.Range.from(i)];else{c=[];for(const f of i)if(f instanceof M.$TM)c.push(O.Range.from(f));else{const{lineNumber:u,column:S}=O.Position.from(f);c.push({startLineNumber:u,startColumn:S,endLineNumber:u,endColumn:S})}}return v.$tryInsertSnippet(l,s.value.version,d.value,c,b)},setDecorations(d,i){const b=i.length===0;b&&!a.h.has(d.key)||(b?a.h.delete(d.key):a.h.add(d.key),a.n(()=>{if(O.$_O(i))return v.$trySetDecorations(l,d.key,O.$aP(i));{const c=new Array(4*i.length);for(let f=0,u=i.length;f<u;f++){const S=i[f];c[4*f]=S.start.line+1,c[4*f+1]=S.start.character+1,c[4*f+2]=S.end.line+1,c[4*f+3]=S.end.character+1}return v.$trySetDecorationsFast(l,d.key,c)}}))},revealRange(d,i){a.n(()=>v.$tryRevealRange(l,O.Range.from(d),i||M.TextEditorRevealType.Default))},show(d){v.$tryShowEditor(l,O.ViewColumn.from(d))},hide(){v.$tryHideEditor(l)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,I.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,I.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,I.ok)(!this.g),this.f=l}_acceptSelections(l){(0,I.ok)(!this.g),this.c=l}async l(){const l=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const v=l.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const m=v.edits.map(o=>o.range);m.sort((o,n)=>o.end.line===n.end.line?o.end.character===n.end.character?o.start.line===n.start.line?o.start.character-n.start.character:o.start.line-n.start.line:o.end.character-n.end.character:o.end.line-n.end.line);for(let o=0,n=m.length-1;o<n;o++){const r=m[o].end;if(m[o+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=v.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,s,{setEndOfLine:typeof v.setEndOfLine=="number"?O.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$lP=T}),define(Ae[67],Re([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,40,41]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=void 0;class n{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(a,d){this.h=a,this.i=d,this.a=null,this.b=new Map,this.c=new v.$Bc,this.d=new N.$be,this.e=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const d=[],i=[],b=[];if(a.removedDocuments)for(const c of a.removedDocuments){const f=O.URI.revive(c),u=this.c.get(f);u?.unref()&&(this.c.delete(f),d.push(u.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const f=O.URI.revive(c.uri);let u=this.c.get(f);if(u&&f.scheme!==m.Schemas.vscodeNotebookCell&&f.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);u||(u=new n(new $.$fP(this.h.getProxy(p.$PM.MainThreadDocuments),f,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set(f,u),i.push(u.value)),u.ref()}if(a.removedEditors)for(const c of a.removedEditors){const f=this.b.get(c);this.b.delete(c),f&&b.push(f)}if(a.addedEditors)for(const c of a.addedEditors){const f=O.URI.revive(c.documentUri);I.ok(this.c.has(f),`document '${f}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const u=this.c.get(f).value,S=new T.$lP(c.id,this.h.getProxy(p.$PM.MainThreadTextEditors),this.i,new o.$V(()=>u.document),c.selections.map(y.Selection.to),c.options,c.visibleRanges.map(h=>y.Range.to(h)),typeof c.editorPosition=="number"?y.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,S)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,A.$Pc)(d),(0,A.$Pc)(b),a.removedDocuments&&this.e.fire(d),a.addedDocuments&&this.d.fire(i),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return s.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const d=this.b.get(this.a);return a?d:d?.value}allEditors(){return[...this.b.values()]}};e.$mP=r,e.$mP=r=Je([Ve(0,k.$cP),Ve(1,l.$Wj)],r),e.$nP=(0,M.$qi)("IExtHostDocumentsAndEditors")}),define(Ae[280],Re([1,0,18,5,4,115,8,7]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=void 0;class ${constructor(T,y){this.i=y,this.a=new N.$be,this.b=new N.$be,this.c=new N.$be,this.d=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(A.$PM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const y=this.i.allEditors();return T?y:y.map(l=>l.value)}async showTextDocument(T,y,l){let v;typeof y=="number"?v={position:M.ViewColumn.from(y),preserveFocus:l}:typeof y=="object"?v={position:M.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?M.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:v={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(T.uri,v),s=m&&this.i.getEditor(m);if(s)return s.value;throw m?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,y){return new O.$jP(this.h,T,y).value}$acceptEditorPropertiesChanged(T,y){const l=this.i.getEditor(T);if(!l)throw new Error("unknown text editor");if(y.options&&l._acceptOptions(y.options),y.selections){const v=y.selections.selections.map(M.Selection.to);l._acceptSelections(v)}if(y.visibleRanges){const v=I.$Hb(y.visibleRanges.map(M.Range.to));l._acceptVisibleRanges(v)}if(y.options&&this.b.fire({textEditor:l.value,options:{...y.options,lineNumbers:M.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const v=p.TextEditorSelectionChangeKind.fromValue(y.selections.source),m=y.selections.selections.map(M.Selection.to);this.a.fire({textEditor:l.value,selections:m,kind:v})}if(y.visibleRanges){const v=I.$Hb(y.visibleRanges.map(M.Range.to));this.c.fire({textEditor:l.value,visibleRanges:v})}}$acceptEditorPositionData(T){for(const y in T){const l=this.i.getEditor(y);if(!l)throw new Error("Unknown text editor");const v=M.ViewColumn.to(T[y]);l.value.viewColumn!==v&&(l._acceptViewColumn(v),this.d.fire({textEditor:l.value,viewColumn:v}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$vkc=$}),define(Ae[281],Re([1,0,2,3,4,6,7,8,20,17]),function(fe,e,I,N,A,O,M,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=void 0,e.$emc=(0,N.$qi)("IExtHostTimeline");class T{constructor(v,m){this.b=new Map,this.c=new Map,this.a=v.getProxy(A.$PM.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&$.$Lm.equals(o,this.b.get(s.source)?.extension)){const n=s.uri===void 0?void 0:I.URI.revive(s.uri);return this.c.get(s.source)?.get(y(n))?.get(s.handle)}else return;return s}})}async $getTimeline(v,m,s,o){return this.b.get(v)?.provider.provideTimeline(I.URI.revive(m),s,o)}registerTimelineProvider(v,m,s,o){const n=new O.$Tc,r=this.d(m.id,o,n).bind(this);let t;m.onDidChange&&(t=m.onDidChange(d=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:m.id}),this));const a=this.c;return this.f({...m,scheme:v,onDidChange:void 0,async provideTimeline(d,i,b){i?.resetCache&&(n.clear(),a.get(m.id)?.clear());const c=await m.provideTimeline(d,i,b);if(c==null)return;const f=r(d,i);return{...c,source:m.id,items:c.items.map(f)}},dispose(){for(const d of a.values())d.get(m.id)?.clear();t?.dispose(),n.dispose()}},s)}d(v,m,s){return(o,n)=>{let r;if(n?.cacheResults){let t=this.c.get(v);t===void 0&&(t=new Map,this.c.set(v,t));const a=y(o);r=t.get(a),r===void 0&&(r=new Map,t.set(a,r))}return t=>{const{iconPath:a,...d}=t,i=`${v}|${t.id??t.timestamp}`;r?.set(i,t);let b,c,f;t.iconPath&&(a instanceof M.$NN?f={id:a.id,color:a.color}:I.URI.isUri(a)?(b=a,c=a):{light:b,dark:c}=a);let u;return M.$gN.isMarkdownString(d.tooltip)?u=p.MarkdownString.from(d.tooltip):(0,k.$4f)(d.tooltip)?u=d.tooltip:M.$gN.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=p.MarkdownString.from(d.detail)):(0,k.$4f)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=d.detail),{...d,id:d.id??void 0,handle:i,source:v,command:t.command?m.toInternal(t.command,s):void 0,icon:b,iconDark:c,themeIcon:f,tooltip:u,accessibilityInformation:t.accessibilityInformation}}}}f(v,m){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:m}),(0,O.$Sc)(()=>{for(const o of this.c.values())o.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$fmc=T;function y(l){return l?.toString()}}),define(Ae[282],Re([1,0,173,24,2,5,6,212,11,7,17,18,8,54,22,137,25]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;function n(a,d){if((0,T.$4f)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let i;return Array.isArray(a.highlights)&&(i=a.highlights.filter(b=>b.length===2&&typeof b[0]=="number"&&typeof b[1]=="number"),i=i.length?i:void 0),{label:a.label,highlights:i}}}class r extends M.$Uc{constructor(d,i,b){super(),this.f=d,this.g=i,this.h=b,this.a=new Map,this.b=new s.$b9;function c(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:f=>c(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(u=>c(u)?this.r(u):u):f})}registerTreeDataProvider(d,i,b){const c=this.createTreeView(d,{treeDataProvider:i},b);return{dispose:()=>c.dispose()}}createTreeView(d,i,b){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=i.dragAndDropController?.dropMimeTypes??[],f=i.dragAndDropController?.dragMimeTypes??[],u=!!i.dragAndDropController?.handleDrag,S=!!i.dragAndDropController?.handleDrop,h=this.m(d,i,b),E={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:c,dragMimeTypes:f,hasHandleDrag:u,hasHandleDrop:S,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(d,E),D={get onDidCollapseElement(){return h.onDidCollapseElement},get onDidExpandElement(){return h.onDidExpandElement},get selection(){return h.selectedElements},get onDidChangeSelection(){return h.onDidChangeSelection},get activeItem(){return(0,o.$yG)(b,"treeViewActiveItem"),h.focusedElement},get onDidChangeActiveItem(){return(0,o.$yG)(b,"treeViewActiveItem"),h.onDidChangeActiveItem},get visible(){return h.visible},get onDidChangeVisibility(){return h.onDidChangeVisibility},get onDidChangeCheckboxState(){return h.onDidChangeCheckboxState},get message(){return h.message},set message(w){(0,v.$Pk)(w)&&(0,o.$yG)(b,"treeViewMarkdownMessage"),h.message=w},get title(){return h.title},set title(w){h.title=w},get description(){return h.description},set description(w){h.description=w},get badge(){return h.badge},set badge(w){w!==void 0&&k.ViewBadge.isViewBadge(w)?h.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(h.badge=void 0)},reveal:(w,C)=>h.reveal(w,C),dispose:async()=>{await g,this.a.delete(d),h.dispose()}};return this.B(D),D}$getChildren(d,i){const b=this.a.get(d);return b?b.getChildren(i):Promise.reject(new p.$NF(d))}async $handleDrop(d,i,b,c,f,u,S,h){const E=this.a.get(d);if(!E)return Promise.reject(new p.$NF(d));const g=l.DataTransfer.toDataTransfer(b,async D=>(await this.f.$resolveDropFileData(d,i,D)).buffer);return S===d&&h&&await this.j(g,E,h,f,u),E.onDrop(g,c,f)}async j(d,i,b,c,f){const u=this.b.removeDragOperationTransfer(f);if(u)(await u)?.forEach((S,h)=>{S&&d.set(h,S)});else if(f&&i.handleDrag){const S=i.handleDrag(b,d,c);this.b.addDragOperationTransfer(f,S),await S}return d}async $handleDrag(d,i,b,c){const f=this.a.get(d);if(!f)return Promise.reject(new p.$NF(d));const u=await this.j(new k.$JN,f,i,c,b);if(!(!u||c.isCancellationRequested))return l.DataTransfer.from(u)}async $hasResolve(d){const i=this.a.get(d);if(!i)throw new p.$NF(d);return i.hasResolve}$resolve(d,i,b){const c=this.a.get(d);if(!c)throw new p.$NF(d);return c.resolveTreeItem(i,b)}$setExpanded(d,i,b){const c=this.a.get(d);if(!c)throw new p.$NF(d);c.setExpanded(i,b)}$setSelectionAndFocus(d,i,b){const c=this.a.get(d);if(!c)throw new p.$NF(d);c.setSelectionAndFocus(i,b)}$setVisible(d,i){const b=this.a.get(d);if(!b){if(!i)return;throw new p.$NF(d)}b.setVisible(i)}$changeCheckboxState(d,i){const b=this.a.get(d);if(!b)throw new p.$NF(d);b.setCheckboxState(i)}m(d,i,b){const c=this.B(new t(d,i,this.f,this.g.converter,this.h,b));return this.a.set(d,c),c}r(d){const i=this.a.get(d.$treeViewId);return i&&"$treeItemHandle"in d?i.getExtensionElement(d.$treeItemHandle):i&&"$focusedTreeItem"in d&&d.$focusedTreeItem?i.focusedElement:null}}e.$gmc=r;class t extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(d=>this.getExtensionElement(d)).filter(d=>!(0,T.$ag)(d))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(d,i,b,c,f,u){if(super(),this.I=d,this.J=b,this.L=c,this.M=f,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$me,u.contributes&&u.contributes.views)for(const g in u.contributes.views)for(const D of u.contributes.views[g])D.id===d&&(this.P=D.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let S,h;const E=O.Event.debounce(this.F.event,(g,D)=>(g||(g={message:!1,elements:[]}),D.element!==!1&&(S||(S=new Promise(w=>h=w),this.G=this.G.then(()=>S)),Array.isArray(D.element)?g.elements.push(...D.element):g.elements.push(D.element)),D.message&&(g.message=!0),g),200,!0);this.B(E(({message:g,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const w=h;return S=null,this.$(D).then(()=>w())})),g&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(d){const i=d?this.getExtensionElement(d):void 0;if(d&&!i)return this.M.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let b=this.X(d);return b||(b=await this.Y(i)),b?b.map(c=>c.item):void 0}getExtensionElement(d){return this.j.get(d)}reveal(d,i){i=i||{select:!0,focus:!1};const b=(0,T.$ag)(i.select)?!0:i.select,c=(0,T.$ag)(i.focus)?!1:i.focus,f=(0,T.$ag)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.G.then(()=>this.S(d)).then(u=>this.W(d,u[u.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:u.map(h=>h.item)},{select:b,focus:c,expand:f})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:b,focus:c,expand:f})}get message(){return this.O}set message(d){this.O=d,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(d){this.P=d,this.J.$setTitle(this.I,d,this.Q)}get description(){return this.Q}set description(d){this.Q=d,this.J.$setTitle(this.I,this.P,d)}get badge(){return this.R}set badge(d){this.R?.value===d?.value&&this.R?.tooltip===d?.tooltip||(this.R=l.ViewBadge.from(d),this.J.$setBadge(this.I,d))}setExpanded(d,i){const b=this.getExtensionElement(d);b&&(i?this.u.fire(Object.freeze({element:b})):this.w.fire(Object.freeze({element:b})))}setSelectionAndFocus(d,i){const b=!(0,y.$ub)(this.s,d);this.s=d;const c=this.t!==i;this.t=i,b&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this.r&&(this.r=d,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(d){const i=(await Promise.all(d.map(async b=>{const c=this.getExtensionElement(b.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:b.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(b=>b!==void 0);i.forEach(b=>{b.treeItem.checkboxState=b.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(b=>[b.extensionItem,b.newState])})}async handleDrag(d,i,b){const c=[];for(const f of d){const u=this.getExtensionElement(f);u&&c.push(u)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,i,b),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(d,i,b){const c=i?this.getExtensionElement(i):void 0;if(!(!c&&i||!this.g?.handleDrop))return(0,$.$ih)(()=>this.g?.handleDrop?this.g.handleDrop(c,d,b):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(d,i){if(!this.f.resolveTreeItem)return;const b=this.j.get(d);if(b){const c=this.m.get(b);if(c){const f=await this.f.resolveTreeItem(c.extensionItem,b,i)??c.extensionItem;return this.hb(f),c.item.tooltip=this.eb(f.tooltip),c.item.command=this.fb(c.disposableStore,f.command),c.item}}}S(d){return this.U(d).then(i=>i?this.S(i).then(b=>this.W(i,b[b.length-1]).then(c=>(b.push(c),b))):Promise.resolve([]))}U(d){const i=this.m.get(d);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,$.$ih)(()=>this.f.getParent(d))}W(d,i){const b=this.m.get(d);return b?Promise.resolve(b):(0,$.$ih)(()=>this.f.getTreeItem(d)).then(c=>this.kb(d,c,i,!0)).then(c=>this.getChildren(i?i.item.handle:void 0).then(()=>{const f=this.getExtensionElement(c);if(f){const u=this.m.get(f);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(d){if(d){let i;if(typeof d=="string"){const b=this.getExtensionElement(d);i=b?this.m.get(b):void 0}else i=d;return i&&i.children||void 0}return this.h}async Y(d){this.rb(d);const i=new m.$me(this.Z.token);try{const b=d?this.m.get(d):void 0,c=await this.f.getChildren(d);if(i.token.isCancellationRequested)return;const f=(0,y.$Hb)(c||[]),u=await Promise.all((0,y.$Hb)(f).map(h=>this.f.getTreeItem(h)));if(i.token.isCancellationRequested)return;const S=u.map((h,E)=>h?this.db(f[E],h,b):null);return(0,y.$Hb)(S)}finally{i.dispose()}}$(d){if(d.some(b=>!b))return this.Z.dispose(!0),this.Z=new m.$me,this.tb(),this.J.$refresh(this.I);{const b=this.ab(d);if(b.length)return this.bb(b)}return Promise.resolve(void 0)}ab(d){const i=new Set,b=d.map(f=>this.m.get(f));for(const f of b)if(f&&!i.has(f.item.handle)){let u=f;for(;u&&u.parent&&b.findIndex(S=>u&&u.parent&&S&&S.item.handle===u.parent.item.handle)===-1;){const S=this.j.get(u.parent.item.handle);u=S?this.m.get(S):void 0}u&&!u.parent&&i.add(f.item.handle)}const c=[];return i.forEach(f=>{const u=this.j.get(f);if(u){const S=this.m.get(u);S&&(!S.parent||!i.has(S.parent.item.handle))&&c.push(f)}}),c}bb(d){const i={};return Promise.all(d.map(b=>this.cb(b).then(c=>{c&&(i[b]=c.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(d){const i=this.getExtensionElement(d);if(i){const b=this.m.get(i);if(b)return this.rb(i),(0,$.$ih)(()=>this.f.getTreeItem(i)).then(c=>{if(c){const f=this.ib(i,c,b.parent);return this.pb(i,f,b,b.parent),b.dispose(),f}return null})}return Promise.resolve(null)}db(d,i,b){const c=this.ib(d,i,b);if(i.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,i.id));return this.ob(d,c),this.qb(c,b),c}eb(d){return k.$gN.isMarkdownString(d)?l.MarkdownString.from(d):d}fb(d,i){return i?{...this.L.toInternal(i,d),originalId:i.command}:void 0}gb(d){if(d.checkboxState===void 0)return;let i,b,c;return typeof d.checkboxState=="number"?i=d.checkboxState:(i=d.checkboxState.state,b=d.checkboxState.tooltip,c=d.checkboxState.accessibilityInformation),{isChecked:i===k.TreeItemCheckboxState.Checked,tooltip:b,accessibilityInformation:c}}hb(d){if(!k.$EN.isTreeItem(d,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(d,i,b){this.hb(i);const c=this.B(new M.$Tc),f=this.kb(d,i,b),u=this.lb(i);return{item:{handle:f,parentHandle:b?b.item.handle:void 0,label:n(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(c,i.command),contextValue:i.contextValue,icon:u,iconDark:this.mb(i)||u,themeIcon:this.jb(i),collapsibleState:(0,T.$ag)(i.collapsibleState)?k.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:b,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(d){return d.iconPath instanceof k.$NN?d.iconPath:void 0}kb(d,{id:i,label:b,resourceUri:c},f,u){if(i)return`${t.b}/${i}`;const S=n(b,this.N),h=f?f.item.handle:t.a;let E=S?S.label:c?(0,N.$1g)(c):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const g=this.m.has(d)?this.m.get(d).item.handle:void 0,D=this.X(f)||[];let w,C=0;do{if(w=`${h}/${C}:${E}`,u||!this.j.has(w)||g===w)break;C++}while(C<=D.length);return w}lb(d){if(d.iconPath&&!(d.iconPath instanceof k.$NN))return typeof d.iconPath=="string"||A.URI.isUri(d.iconPath)?this.nb(d.iconPath):this.nb(d.iconPath.light)}mb(d){if(d.iconPath&&!(d.iconPath instanceof k.$NN)&&d.iconPath.dark)return this.nb(d.iconPath.dark)}nb(d){return A.URI.isUri(d)?d:A.URI.file(d)}ob(d,i){this.j.set(i.item.handle,d),this.m.set(d,i)}pb(d,i,b,c){this.j.delete(i.item.handle),this.m.delete(d),i.item.handle!==b.item.handle&&this.j.delete(b.item.handle),this.ob(d,i);const f=this.X(c)||[],u=f.filter(S=>S.item.handle===b.item.handle)[0];u&&f.splice(f.indexOf(u),1,i)}qb(d,i){i?(i.children||(i.children=[]),i.children.push(d)):(this.h||(this.h=[]),this.h.push(d))}rb(d){if(d){const i=this.m.get(d);if(i){if(i.children)for(const b of i.children){const c=this.j.get(b.item.handle);c&&this.sb(c)}i.children=void 0}}else this.tb()}sb(d){const i=this.m.get(d);if(i){if(i.children)for(const b of i.children){const c=this.j.get(b.item.handle);c&&this.sb(c)}this.m.delete(d),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(d=>d.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[283],Re([1,0,5,6,2,35,8,63,4,7]),function(fe,e,I,N,A,O,M,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;class T extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(m,s,o,n){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$be),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=s,this.#n=o,this.#i=n.viewType,this.#s=n.panelOptions,this.#o=n.viewColumn,this.#r=n.title,this.#u=n.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(m){this.c(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#a}set iconPath(m){this.c(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,A.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(m){this.#l||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#u=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:M.ViewColumn.from(m),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends N.$Uc{static c(){return(0,O.$Mg)()}constructor(m,s,o){super(),this.j=s,this.m=o,this.g=new Map,this.h=new Map,this.f=m.getProxy($.$PM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,s,o,n,r={}){const t=typeof n=="object"?n.viewColumn:n,a={viewColumn:M.ViewColumn.from(t),preserveFocus:typeof n=="object"&&!!n.preserveFocus},d=(0,p.$Kkc)(m),i=y.c();this.f.$createWebviewPanel((0,p.$Mkc)(m),i,s,{title:o,panelOptions:l(r),webviewOptions:(0,p.$Nkc)(m,this.m,r),serializeBuffersForPostMessage:d},a);const b=this.j.createNewWebview(i,r,m);return this.createNewWebviewPanel(i,s,o,t,r,b,!0)}$onDidChangeWebviewPanelViewStates(m){const s=Object.keys(m);s.sort((o,n)=>{const r=m[o],t=m[n];return r.active?1:t.active?-1:+r.visible-+t.visible});for(const o of s){const n=this.getWebviewPanel(o);if(!n)continue;const r=m[o];n._updateViewState({active:r.active,visible:r.visible,viewColumn:M.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,s,o){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:o,extension:m}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,p.$Kkc)(m)}),new k.$RM(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(m,s,o,n){const r=this.h.get(s);if(!r)throw new Error(`No serializer found for '${s}'`);const{serializer:t,extension:a}=r,d=this.j.createNewWebview(m,o.webviewOptions,a),i=this.createNewWebviewPanel(m,s,o.title,n,o.panelOptions,d,o.active);await t.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(m,s,o,n,r,t,a){const d=new T(m,this.f,t,{viewType:s,title:o,viewColumn:n,panelOptions:r,active:a});return this.g.set(m,d),d}getWebviewPanel(m){return this.g.get(m)}}e.$Okc=y;function l(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ae[284],Re([1,0,5,6,63,8,4,7]),function(fe,e,I,N,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=void 0;class $ extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,l,v,m,s,o){super(),this.#s=!1,this.#u=this.B(new I.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$be),this.onDidDispose=this.#l.event,this.#i=v,this.#a=m,this.#e=y,this.#t=l,this.#n=s,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(y,l){this.d=l,this.b=new Map,this.c=new Map,this.a=y.getProxy(M.$PM.MainThreadWebviewViews)}registerWebviewViewProvider(y,l,v,m){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:v,extension:y}),this.a.$registerWebviewViewProvider((0,A.$Mkc)(y),l,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$Kkc)(y)}),new p.$RM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(y,l,v,m,s){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:n,extension:r}=o,t=this.d.createNewWebview(y,{},r),a=new $(y,this.a,l,v,t,!0);this.c.set(y,a),await n.resolveWebviewView(a,{state:m},s)}async $onDidChangeWebviewViewVisibility(y,l){this.e(y)._setVisible(l)}async $disposeWebviewView(y){const l=this.e(y);this.c.delete(y),l.dispose(),this.d.deleteWebview(y)}e(y){const l=this.c.get(y);if(!l)throw new Error("No webview found");return l}}e.$jmc=k}),define(Ae[285],Re([1,0,5,30,31,3]),function(fe,e,I,N,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.OutputChannelUpdateMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=void 0,e.$XL="text/x-code-output",e.$YL="output",e.$ZL="Log",e.$1L="text/x-code-log-output",e.$2L="log",e.$3L="workbench.panel.output",e.$4L=new A.$Hj("inOutput",!1),e.$5L=new A.$Hj("activeLogOutput",!1),e.$6L=new A.$Hj("activeLogOutput.levelSettable",!1),e.$7L=new A.$Hj("activeLogOutput.level",""),e.$8L=new A.$Hj("activeLogOutput.levelIsDefault",!1),e.$9L=new A.$Hj("outputView.scrollLock",!1),e.$0L=(0,O.$qi)("outputService");var M;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$$L={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new I.$be,this.onDidRegisterChannel=this.b.event,this.c=new I.$be,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(T=>k.push(T)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}N.$9n.add(e.$$L.OutputChannels,new p),e.$_L=new A.$Hj("activeOutputChannel","")}),define(Ae[116],Re([1,0,4,3,16,20,13,285,64,27,45,141,23,17,44,5,6]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=void 0;class n extends M.$3j{get disposed(){return this.n}constructor(d,i,b,c,f){super(),this.id=d,this.name=i,this.r=b,this.s=c,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(b.getLevel()),this.B(b.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,d)}replace(d){const i=this.m;this.info(d),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(d,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof d=="boolean"?d:i))}hide(){this.s.$close(this.id)}g(d,i){this.m+=l.$Ce.fromString(i).byteLength,(0,M.log)(this.r,d,i),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends n{appendLine(d){this.append(d)}}let t=class{constructor(d,i,b,c,f,u){this.i=i,this.j=b,this.k=c,this.l=f,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=d.getProxy(I.$PM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,y.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.h=d;for(const[i,b]of this.g)b.visible=i===this.h}createOutputChannel(d,i,b){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const c=typeof i=="object"&&i.log,f=(0,v.$4f)(i)?i:void 0;if((0,v.$4f)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const S=this.i.environment.extensionLogLevel?.find(([E])=>O.$Lm.equals(b.identifier,E))?.[1];S&&(u=(0,M.$bk)(S));const h=c?this.o(d,u,b):this.n(d,f,b);return h.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),c?this.r(d,u??this.m.getLevel(),h):this.q(d,h)}async n(d,i,b){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,f=this.k.extUri.joinPath(c,`${this.f++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(d,f,i,b.identifier.value);return new n(S,d,u,this.a,b)}async o(d,i,b){const c=await this.p(b),f=d.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(c,`${f}.log`),S=`${b.identifier.value}.${f}`,h=this.l.createLogger(u,{id:S,name:d,logLevel:i,extensionId:b.identifier.value});return new r(S,d,h,this.a,b)}p(d){let i=this.d.get(d.identifier.value);if(!i){const b=this.k.extUri.joinPath(this.i.logsLocation,d.identifier.value);this.d.set(d.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(b)}catch(c){if((0,m.$al)(c)!==m.FileSystemProviderErrorCode.FileExists)throw c}return b})())}return i}q(d,i){let b=!1;const c=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return d},append(f){c(),i.then(u=>u.append(f))},appendLine(f){c(),i.then(u=>u.appendLine(f))},clear(){c(),i.then(f=>f.clear())},replace(f){c(),i.then(u=>u.replace(f))},show(f,u){c(),i.then(S=>S.show(f,u))},hide(){c(),i.then(f=>f.hide())},dispose(){b=!0,i.then(f=>f.dispose())}}}r(d,i,b){const c=new o.$Tc,f=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},u=c.add(new s.$be);function S(h){i=h,u.fire(h)}return b.then(h=>{c.add(h),h.logLevel!==i&&S(h.logLevel),c.add(h.onDidChangeLogLevel(E=>S(E)))}),{...this.q(d,b),get logLevel(){return i},onDidChangeLogLevel:u.event,trace(h,...E){f(),b.then(g=>g.trace(h,...E))},debug(h,...E){f(),b.then(g=>g.debug(h,...E))},info(h,...E){f(),b.then(g=>g.info(h,...E))},warn(h,...E){f(),b.then(g=>g.warn(h,...E))},error(h,...E){f(),b.then(g=>g.error(h,...E))},dispose(){c.dispose()}}}};e.$Ulc=t,e.$Ulc=t=Je([Ve(0,A.$cP),Ve(1,k.$sP),Ve(2,$.$Gkc),Ve(3,T.$jkc),Ve(4,M.$Xj),Ve(5,M.$Wj)],t),e.$Vlc=(0,N.$qi)("IExtHostOutputService")}),define(Ae[117],Re([1,0,3,11]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$an=(0,I.$qi)("remoteAgentService"),e.$bn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let O=1/0;for(let p=0;p<this.maxSampleCount;p++){const $=await A.getRoundTripTime();if($===void 0)return;O=Math.min(O,$/2),await(0,N.$rh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(O):M=this.initial.reduce((p,$)=>p+$,0)/this.initial.length,this.lastMeasurement={initial:M,current:O,average:this.average.reduce((p,$)=>p+$,0)/this.average.length,high:typeof M>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ae[286],Re([1,0,176,57,30,49,48,6,5,117,21,26,11]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=void 0,e.$qJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$rJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$sJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$tJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$uJ={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new $.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const m=new v;A.$9n.add(e.$uJ.ConfigurationMigration,m);let s=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const d of a.added)await this.f(d,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(a=>this.g(a,r?.uri))])}async g(r,t){const a=this.a.inspect(r.key,{resource:t}),d=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,b]of d){const c=a[i];if(!c)continue;const f=[];if(c.value!==void 0){const u=await this.h(r,i,c.value,t,void 0);for(const S of u??[])f.push([S,[]])}for(const{identifiers:u,value:S}of c.overrides??[])if(S!==void 0){const h=await this.h(r,i,S,t,u);for(const E of h??[])f.push([E,u])}f.length&&await Promise.allSettled(f.map(async([[u,S],h])=>this.a.updateValue(u,S.value,{resource:t,overrideIdentifiers:h},b)))}}async h(r,t,a,d,i){const b=f=>{const S=this.a.inspect(f,{resource:d})[t];if(S)return i?S.overrides?.find(({identifiers:h})=>(0,y.$1n)(h,i))?.value:S.value},c=await r.migrateFn(a,b);return Array.isArray(c)?c:[[r.key,c]]}};e.$vJ=s,e.$vJ=s=Je([Ve(0,M.$Wi),Ve(1,O.$zi)],s);let o=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new l.$Nh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;A.$9n.as(N.$bo.Configuration).registerConfiguration({...e.$sJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$wJ=o,e.$wJ=o=Je([Ve(0,k.$an)],o)}),define(Ae[287],Re([1,0,36,12,19,24,185,286,57,3,30]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$wgb=e.$vgb=void 0,e.$xgb=s,e.$ygb=o,e.$vgb=(0,k.$qi)("editorResolverService"),e.$wgb="workbench.editorAssociations";const y=T.$9n.as($.$bo.Configuration),l={...p.$rJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(l);var v;(function(n){n.builtin="builtin",n.option="option",n.exclusive="exclusive",n.default="default"})(v||(e.RegisteredEditorPriority=v={}));var m;(function(n){n[n.ABORT=1]="ABORT",n[n.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function s(n){switch(n){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}function o(n,r){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(r.scheme))return!1;const d=typeof n=="string"&&n.indexOf(A.$hc.sep)>=0?`${r.scheme}:${r.path}`:(0,O.$1g)(r);return I.$jk(typeof n=="string"?n.toLowerCase():n,d.toLowerCase())}}),define(Ae[288],Re([1,0,47,12,19,21,24,2,3,206,49,226,117]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,$.$qi)("pathService");let m=v=class{constructor(o,n,r,t){this.d=o,this.e=n,this.f=r,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??o})()}hasValidBasename(o,n,r){return typeof n=="string"||typeof n>"u"?this.a.then(t=>this.h(o,t,n)):this.h(o,n,r)}h(o,n,r){return o.scheme===N.Schemas.file||o.scheme===N.Schemas.vscodeRemote?(0,I.$og)(r??(0,M.$1g)(o),n===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,n){if(o.remoteAuthority)return N.Schemas.vscodeRemote;const r=(0,k.$oM)(n.getWorkspace());if(r)return r;const t=n.getWorkspace().folders[0];if(t)return t.uri.scheme;const a=n.getWorkspace().configuration;return a?a.scheme:N.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?A.$gc:A.$hc)}async fileURI(o){let n="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const t=o.indexOf("/",2);t===-1?(n=o.substring(2),o="/"):(n=o.substring(2,t),o=o.substring(t)||"/")}return p.URI.from({scheme:N.Schemas.file,authority:n,path:o,query:"",fragment:""})}};e.$sM=m,e.$sM=m=v=Je([Ve(1,l.$an),Ve(2,y.$aM),Ve(3,T.$zi)],m)}),define(Ae[118],Re([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$XK=e.$WK=void 0;class I{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new I(0,0)}with(M){return new I(0,0)}}e.$WK=I;class N{constructor(M,p,$,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(M,p),this.end=new I($,k)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$XK=N;var A;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Ae[46],Re([1,0,18,36,26,47,15,3,19,14,118,11]),function(fe,e,I,N,A,O,M,p,$,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$iL=e.$bL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$$K=e.$0K=e.$9K=e.$8K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.TextSearchCompleteMessageType=void 0,e.$5K=n,e.$6K=r,e.$7K=t,e.$_K=h,e.$aL=E,e.$cL=w,e.$dL=C,e.$eL=P,e.$fL=V,e.$gL=W,e.$hL=q,e.$jL=U,e.$lL=ce,e.$mL=ve,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$YK="workbench.view.search",e.$ZK="workbench.panel.search",e.$1K="workbench.view.search",e.$2K="search-result",e.$3K="search.exclude";const l="\u27EA ",v=" characters skipped \u27EB",m=(l.length+v.length+5)*2;e.$4K=(0,p.$qi)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text",ue[ue.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text",ue[ue.aiText=3]="aiText"})(o||(e.QueryType=o={}));function n(ue){return!!ue.preview}function r(ue){return!!ue.resource}function t(ue){return!!ue.message}var a;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class d{constructor(be){this.resource=be,this.results=[]}}e.$8K=d;class i{constructor(be,ie,Pe,Fe){this.ranges=ie,this.webviewIndex=Fe;const ne=Array.isArray(ie)?ie:[ie];if(Pe&&Pe.matchLines===1&&b(ne)){be=(0,M.$Wf)(be,Pe.matchLines);let j="",x=0,pe=0;const Oe=Math.floor(Pe.charsPerLine/5),ke=[];for(const $e of ne){const ge=Math.max($e.startColumn-Oe,0),J=$e.startColumn+Pe.charsPerLine;if(ge>pe+Oe+m){const Y=l+(ge-pe)+v;j+=Y+be.slice(ge,J),x+=ge-(pe+Y.length)}else j+=be.slice(pe,J);ke.push(new f(0,$e.startColumn-x,$e.endColumn-x)),pe=J}this.preview={text:j,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const j=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:be,matches:(0,I.$2b)(ie,x=>new c(x.startLineNumber-j,x.startColumn,x.endLineNumber-j,x.endColumn))}}}}e.$9K=i;function b(ue){const be=ue[0].startLineNumber;for(const ie of ue)if(ie.startLineNumber!==be||ie.endLineNumber!==be)return!1;return!0}class c{constructor(be,ie,Pe,Fe){this.startLineNumber=be,this.startColumn=ie,this.endLineNumber=Pe,this.endColumn=Fe}}e.$0K=c;class f extends c{constructor(be,ie,Pe){super(be,ie,be,Pe)}}e.$$K=f;var u;(function(ue){ue.List="list",ue.Tree="tree"})(u||(e.ViewMode=u={}));var S;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function h(ue,be=!0){const ie=ue&&ue.files&&ue.files.exclude,Pe=be&&ue&&ue.search&&ue.search.exclude;if(!ie&&!Pe)return;if(!ie||!Pe)return ie||Pe;let Fe=Object.create(null);return Fe=A.$Zn(Fe,A.$Wn(ie)),Fe=A.$Zn(Fe,A.$Wn(Pe),!0),Fe}function E(ue,be){return ue.excludePattern&&N.$jk(ue.excludePattern,be)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&N.$jk(ue.includePattern,be)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(ie=>{const Pe=ie.folder.fsPath;if(O.$qg(be,Pe)){const Fe=$.$mc(Pe,be);return!ie.includePattern||!!N.$jk(ie.includePattern,Fe)}else return!1}):!1:!0}var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class D extends Error{constructor(be,ie){super(be),this.code=ie}}e.$bL=D;function w(ue){const be=ue.message;if((0,k.$4)(ue))return new D(be,g.canceled);try{const ie=JSON.parse(be);return new D(ie.message,ie.code)}catch{return new D(be,g.other)}}function C(ue){const be={message:ue.message,code:ue.code};return new Error(JSON.stringify(be))}function P(ue){return ue.type==="error"?!0:ue.type==="success"}function V(ue){return ue.type==="success"}function W(ue){return!!ue.path}function q(ue,be,ie=!0){const Pe=ue.searchPath?ue.searchPath:ue.relativePath;return ie?(0,M.$Tf)(Pe,be):N.$jk(be,Pe)}class R{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$iL=R;function U(ue,be){const ie={...ue||{},...be||{}};return Object.keys(ie).filter(Pe=>{const Fe=ie[Pe];return typeof Fe=="boolean"&&Fe})}class K{constructor(be,ie){this.c=null,this.a={...be.excludePattern||{},...ie.excludePattern||{}},this.b=N.$kk(this.a);let Pe=be.includePattern;ie.includePattern&&(Pe?Pe={...Pe,...ie.includePattern}:Pe=ie.includePattern),Pe&&(this.c=N.$kk(Pe))}matchesExcludesSync(be,ie,Pe){return!!(this.b&&this.b(be,ie,Pe))}includedInQuerySync(be,ie,Pe){return!(this.b&&this.b(be,ie,Pe)||this.c&&!this.c(be,ie,Pe))}includedInQuery(be,ie,Pe){const Fe=this.b(be,ie,Pe),ne=()=>this.c?!!this.c(be,ie,Pe):!0;return(0,y.$ch)(Fe)?Fe.then(j=>j?!1:ne()):ne()}hasSiblingExcludeClauses(){return se(this.a)}}e.$kL=K;function se(ue){for(const be in ue)if(typeof ue[be]!="boolean")return!0;return!1}function ce(ue){if(!ue)return;let be;return ie=>(be||(be=(ue()||Promise.resolve([])).then(Pe=>Pe?Ie(Pe):{})),be.then(Pe=>!!Pe[ie]))}function ve(ue){if(!ue)return;let be;return ie=>{if(!be){const Pe=ue();be=Pe?Ie(Pe):{}}return!!be[ie]}}function Ie(ue){const be={};for(const ie of ue)be[ie]=!0;return be}}),define(Ae[37],Re([1,0,18,11,22,5,6,52,12,126,24,15,2,175,3,13,195,49,45,27,16,8,7,60,46,4,53]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a,d,i,b,c,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=e.$Akc=void 0;function S(V,W,q){return new T.$Sg(R=>D(R,q)).isEqual(V,W)}function h(V,W,q){return S(V.uri,W.uri,q)?0:(0,y.$mf)(V.uri.toString(),W.uri.toString())}function E(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:S(V.uri,W.uri,q)?(0,y.$mf)(V.name,W.name):(0,y.$mf)(V.uri.toString(),W.uri.toString())}function g(V,W,q,R){const U=V.slice(0).sort((se,ce)=>q(se,ce,R)),K=W.slice(0).sort((se,ce)=>q(se,ce,R));return(0,I.$Eb)(U,K,(se,ce)=>q(se,ce,R))}function D(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class w extends n.$Ji{static toExtHostWorkspace(W,q,R,U){if(!W)return{workspace:null,added:[],removed:[]};const{id:K,name:se,folders:ce,configuration:ve,transient:Ie,isUntitled:ue}=W,be=[],ie=q;q?ce.forEach((j,x)=>{const pe=l.URI.revive(j.uri),Oe=w.o(R||q,pe,U);Oe?(Oe.name=j.name,Oe.index=j.index,be.push(Oe)):be.push({uri:pe,name:j.name,index:x})}):be.push(...ce.map(({uri:j,name:x,index:pe})=>({uri:l.URI.revive(j),name:x,index:pe}))),be.sort((j,x)=>j.index<x.index?-1:1);const Pe=new w(K,se,be,!!Ie,ve?l.URI.revive(ve):null,!!ue,j=>D(j,U)),{added:Fe,removed:ne}=g(ie?ie.workspaceFolders:[],Pe.workspaceFolders,h,U);return{workspace:Pe,added:Fe,removed:ne}}static o(W,q,R){for(let U=0;U<W.folders.length;U++){const K=W.workspaceFolders[U];if(S(K.uri,q,R))return K}}constructor(W,q,R,U,K,se,ce){super(W,R.map(ve=>new n.$Ki(ve)),U,K,ce),this.t=q,this.u=se,this.q=[],this.s=p.$wi.forUris(ce),R.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,T.$3g)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let C=class{constructor(W,q,R,U,K){this.c=new O.$be,this.onDidChangeWorkspace=this.c.event,this.g=new O.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$de,this.C=new Map,this.h=U,this.s=R,this.t=K,this.j=new k.$xm,this.k=new N.$ph,this.o=W.getProxy(f.$PM.MainThreadWorkspace),this.q=W.getProxy(f.$PM.MainThreadMessageService);const se=q.workspace;this.l=se?new w(se.id,se.name,[],!!se.transient,se.configuration?l.URI.revive(se.configuration):null,!!se.isUntitled,ce=>D(ce,R)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:$.Schemas.untitled,path:(0,T.$1g)((0,T.$3g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,R,...U){const K=[];if(Array.isArray(U)&&U.forEach(ue=>{l.URI.isUri(ue.uri)&&!K.some(be=>S(be.uri,ue.uri,this.s))&&K.push({uri:ue.uri,name:ue.name||(0,T.$Zg)(ue.uri)})}),this.n||[q,R].some(ue=>typeof ue!="number"||ue<0)||R===0&&K.length===0)return!1;const se=this.x?this.x.workspaceFolders:[];if(q+R>se.length)return!1;const ce=se.slice(0);ce.splice(q,R,...K.map(ue=>({uri:ue.uri,name:ue.name||(0,T.$Zg)(ue.uri),index:void 0})));for(let ue=0;ue<ce.length;ue++){const be=ce[ue];if(ce.some((ie,Pe)=>Pe!==ue&&S(be.uri,ie.uri,this.s)))return!1}ce.forEach((ue,be)=>ue.index=be);const{added:ve,removed:Ie}=g(se,ce,E,this.s);if(ve.length===0&&Ie.length===0)return!1;if(this.o){const ue=W.displayName||W.name;this.o.$updateWorkspaceFolders(ue,q,R,K).then(void 0,be=>{this.n=void 0;const ie={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(o.Severity.Error,(0,v.localize)(0,null,ue,be.toString()),ie,[])})}return this.y(ce),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let R,U="";if(typeof W=="string"?(R=l.URI.file(W),U=W):typeof W<"u"&&(R=W,U=W.fsPath),!R)return U;const K=this.getWorkspaceFolder(R,!0);if(!K)return U;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let se=(0,T.$6g)(K.uri,R);return q&&K.name&&(se=`${K.name}/${se}`),se}y(W){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:R,removed:U}=w.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:U}))}findFiles(W,q,R,U,K=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let se="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?se=q:se=q.pattern),this.z(W,void 0,{exclude:se,maxResults:R,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(W,q={},R,U=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,W,q,U)}async z(W,q,R,U=A.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const K=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,se={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:K,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ve,folder:Ie}=P(d.GlobPattern.from(W));ce=Ie,se.includePattern=ve}else{const{includePattern:ve,folder:Ie}=P(d.GlobPattern.from(q));ce=Ie,se.filePattern=ve}return this.o.$startFileSearch(ce??null,se,U).then(ve=>Array.isArray(ve)?ve.map(Ie=>l.URI.revive(Ie)):[])}async findTextInFiles(W,q,R,U,K=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const se=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ve,folder:Ie}=P(d.GlobPattern.from(q.include)),ue=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,be={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ve,excludePattern:ue},ie=!1;if(this.u[se]=Pe=>{if(ie)return;const Fe=l.URI.revive(Pe.resource);Pe.results.forEach(ne=>{const j=(0,u.$Zh)(ne);(0,c.$5K)(j)?R({uri:Fe,preview:{text:j.preview.text,matches:(0,I.$2b)(j.preview.matches,x=>new i.$TM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(j.ranges,x=>new i.$TM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):R({uri:Fe,text:j.text,lineNumber:j.lineNumber})})},K.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(W,Ie??null,be,se,K);return delete this.u[se],Pe||{}}catch(Pe){throw delete this.u[se],Pe}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return l.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return l.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const R=this.t.transformOutgoingScheme(W),U=this.A++;return this.o.$registerEditSessionIdentityProvider(U,R),(0,M.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const R=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const U=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!U),!U)return;const K=await U.provideEditSessionIdentity(R,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(W,q,R,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const K=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const se=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!se),!se)return;const ce=await se.provideEditSessionIdentityMatch?.(q,R,U);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(q,R,U)=>{const K=function(ce){q.call(R,ce)};return K.extension=W,this.B.event(K,void 0,U)}}async $onWillCreateEditSessionIdentity(W,q,R){const U=await this.resolveWorkspaceFolder(l.URI.revive(W));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:U},q,async(K,se)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>R&&this.h.warn("SLOW edit session create-participant",se.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const R=this.t.transformOutgoingScheme(W),U=this.A++;return this.o.$registerCanonicalUriProvider(U,R),(0,M.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(W,q,R){const U=this.C.get(W.scheme);if(!U)return;const K=await U.provideCanonicalUri?.(l.URI.revive(W),q,R);if(K)return K}async $provideCanonicalUri(W,q,R){return this.provideCanonicalUri(l.URI.revive(W),{targetScheme:q},R)}};e.$Akc=C,e.$Akc=C=Je([Ve(0,a.$cP),Ve(1,t.$sP),Ve(2,r.$jkc),Ve(3,s.$Wj),Ve(4,b.$ykc)],C),e.$Bkc=(0,m.$qi)("IExtHostWorkspace");function P(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=l.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(Ae[38],Re([1,0,26,5,37,4,7,197,57,17,11,3,16,13,2]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=e.$Dkc=e.$Ckc=void 0;function s(b,c){if(c){const f=c.split(".");let u=b;for(let S=0;u&&S<f.length;S++)u=u[f[S]];return u}}function o(b){return b instanceof m.URI}function n(b){return b&&b.uri instanceof m.URI&&b.languageId&&typeof b.languageId=="string"}function r(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function t(b){return b&&b.uri instanceof m.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function a(b){if(o(b))return{resource:b};if(n(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(r(b))return{overrideIdentifier:b.languageId};if(t(b))return{resource:b.uri};if(b===null)return{resource:null}}let d=class{constructor(c,f,u){this.a=c.getProxy(O.$PM.MainThreadConfiguration),this.c=f,this.b=u,this.d=new T.$ph,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new i(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,f){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(c,f))}};e.$Ckc=d,e.$Ckc=d=Je([Ve(0,l.$cP),Ve(1,A.$Bkc),Ve(2,v.$Wj)],d);class i{constructor(c,f,u,S){this.a=new N.$be,this.b=c,this.f=S,this.c=f,this.e=p.$uo.parse(u,S),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,f){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$uo.parse(c,this.f),this.d=this.k(c.configurationScopes),this.a.fire(this.j(f,u))}getConfiguration(c,f,u){const S=a(f)||{},h=this.g(c?s(this.e.getValue(void 0,S,this.c.workspace),c):this.e.getValue(void 0,S,this.c.workspace));c&&this.h(c,S,u?.identifier);function E(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(D){return typeof s(h,D)<"u"},get:(D,w)=>{this.h(c?`${c}.${D}`:D,S,u?.identifier);let C=s(h,D);if(typeof C>"u")C=w;else{let P;const V=(W,q)=>{if((0,k.$6f)(W)){let R;const U=()=>{P=P||(0,I.$Wn)(h),R=R||s(P,q)};return new Proxy(W,{get:(K,se)=>{if(typeof se=="string"&&se.toLowerCase()==="tojson")return U(),()=>R;if(P)return R=R||s(P,q),R[se];const ce=K[se];return typeof se=="string"?V(ce,`${q}.${se}`):ce},set:(K,se,ce)=>(U(),R&&(R[se]=ce),!0),deleteProperty:(K,se)=>(U(),R&&delete R[se],!0),defineProperty:(K,se,ce)=>(U(),R&&Object.defineProperty(R,se,ce),!0)})}return Array.isArray(W)?(0,I.$Wn)(W):W};C=V(C,D)}return C},update:(D,w,C,P)=>{D=c?`${c}.${D}`:D;const V=E(C);return w!==void 0?this.b.$updateConfigurationOption(V,D,w,S,P):this.b.$removeConfigurationOption(V,D,S,P)},inspect:D=>{D=c?`${c}.${D}`:D;const w=this.e.inspect(D,S,this.c.workspace);if(w)return{key:D,defaultValue:(0,I.$Wn)(w.policy?.value??w.default?.value),globalValue:(0,I.$Wn)(w.user?.value??w.application?.value),workspaceValue:(0,I.$Wn)(w.workspace?.value),workspaceFolderValue:(0,I.$Wn)(w.workspaceFolder?.value),defaultLanguageValue:(0,I.$Wn)(w.default?.override),globalLanguageValue:(0,I.$Wn)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,I.$Wn)(w.workspace?.override),workspaceFolderLanguageValue:(0,I.$Wn)(w.workspaceFolder?.override),languageIds:(0,I.$Wn)(w.overrideIdentifiers)}}};return typeof h=="object"&&(0,I.$Zn)(g,h,!1),Object.freeze(g)}g(c){const f=u=>(0,k.$6f)(u)?new Proxy(u,{get:(S,h)=>f(S[h]),set:(S,h,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(S,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(S,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return f(c)}h(c,f,u){const S=$.$lo.test(c)?4:this.d.get(c),h=u?`[${u.value}] `:"";if(S===4){typeof f?.resource>"u"&&this.f.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(S===3){f?.resource&&this.f.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,f){const u=new p.$wo(c,f,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,h)=>u.affectsConfiguration(S,a(h))})}k(c){return c.reduce((f,u)=>(f.set(u[0],u[1]),f),new Map)}}e.$Dkc=i,e.$Ekc=(0,y.$qi)("IExtHostConfiguration")}),define(Ae[119],Re([1,0,2,11,5,4,7,37,67,38,22,51,16,27,3,12,21,13,78,231,14]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=e.$7lc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(d||(d={}));var i;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(i||(i={}));var b;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(b||(b={}));var c;(function(V){function W(U){if(U){const K=U;return K&&!!K.process}else return!1}V.is=W;function q(U){if(U==null)return;const K={process:U.process,args:U.args};return U.options&&(K.options=b.from(U.options)),K}V.from=q;function R(U){if(U!=null)return new M.$AN(U.process,U.args,U.options)}V.to=R})(c||(c={}));var f;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(f||(f={}));var u;(function(V){function W(U){if(U){const K=U;return K&&(!!K.commandLine||!!K.command)}else return!1}V.is=W;function q(U){if(U==null)return;const K={};return U.commandLine!==void 0?K.commandLine=U.commandLine:(K.command=U.command,K.args=U.args),U.options&&(K.options=f.from(U.options)),K}V.from=q;function R(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new M.$BN(U.commandLine,U.options):new M.$BN(U.command,U.args?U.args:[],U.options)}V.to=R})(u||(u={}));var S;(function(V){function W(U){if(U){const K=U;return K&&K.customExecution==="customExecution"}else return!1}V.is=W;function q(U){return{customExecution:"customExecution"}}V.from=q;function R(U,K){return K.get(U)}V.to=R})(S||(e.CustomExecutionDTO=S={}));var h;(function(V){function W(q,R){let U;return q.scope!==void 0&&typeof q.scope!="number"?U=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&R&&R.workspaceFile?U=R.workspaceFile:U=t.$VH),{id:q._id,workspaceFolder:U}}V.from=W})(h||(e.TaskHandleDTO=h={}));var E;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(E||(E={}));var g;(function(V){function W(U,K){if(U==null)return[];const se=[];for(const ce of U){const ve=q(ce,K);ve&&se.push(ve)}return se}V.fromMany=W;function q(U,K){if(U==null)return;let se;U.execution instanceof M.$AN?se=c.from(U.execution):U.execution instanceof M.$BN?se=u.from(U.execution):U.execution&&U.execution instanceof M.$CN&&(se=S.from(U.execution));const ce=d.from(U.definition);let ve;return U.scope?typeof U.scope=="number"?ve=U.scope:ve=U.scope.uri:ve=M.TaskScope.Workspace,!ce||!ve?void 0:{_id:U._id,definition:ce,name:U.name,source:{extensionId:K.identifier.value,label:U.source,scope:ve},execution:se,isBackground:U.isBackground,group:E.from(U.group),presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}V.from=q;async function R(U,K,se){if(U==null)return;let ce;c.is(U.execution)?ce=c.to(U.execution):u.is(U.execution)?ce=u.to(U.execution):S.is(U.execution)&&(ce=S.to(U._id,se));const ve=d.to(U.definition);let Ie;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Ie=U.source.scope:Ie=await K.resolveWorkspaceFolder(I.URI.revive(U.source.scope)):Ie=M.TaskScope.Workspace),!ve||!Ie)return;const ue=new M.$DN(ve,Ie,U.name,U.source.label,ce,U.problemMatchers);return U.isBackground!==void 0&&(ue.isBackground=U.isBackground),U.group!==void 0&&(ue.group=M.$zN.from(U.group._id),ue.group&&U.group.isDefault&&(ue.group=new M.$zN(ue.group.id,ue.group.label),U.group.isDefault===!0&&(ue.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ue.presentationOptions=i.to(U.presentationOptions)),U._id&&(ue._id=U._id),U.detail&&(ue.detail=U.detail),ue}V.to=R})(g||(e.TaskDTO=g={}));var D;(function(V){function W(R){return R}V.from=W;function q(R){if(R)return Object.assign(Object.create(null),R)}V.to=q})(D||(D={}));class w{#e;constructor(W,q,R){this._id=q,this.a=R,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let C=class{constructor(W,q,R,U,K,se,ce,ve){this.q=new A.$be,this.r=new A.$be,this.s=new A.$be,this.u=new A.$be,this.a=W.getProxy(O.$PM.MainThreadTask),this.b=R,this.c=U,this.d=K,this.e=se,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,R){if(!R)return new M.$RM(()=>{});const U=this.x();return this.j.set(U,{type:q,provider:R,extension:W}),this.a.$registerTaskProvider(U,q),new M.$RM(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(D.from(W)).then(async q=>{const R=[];for(const U of q){const K=await g.to(U,this.b,this.m);K&&R.push(K)}return R})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,R){const U=this.m.get(W.id);U&&(this.o.set(W.id,U),this.e.attachPtyToTerminal(q,await U.callback(R))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const R=this.j.get(W);if(!R)return Promise.reject(new Error("no handler found"));const U=[],K=(0,N.$ih)(()=>R.provider.provideTasks(T.CancellationToken.None)).then(se=>this.v(q,U,R,se));return new Promise(se=>{K.then(ce=>{Promise.all(U).then(()=>{se(ce)})})})}async $resolveTask(W,q){const R=this.j.get(W);if(!R)return Promise.reject(new Error("no handler found"));if(q.definition.type!==R.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${R.type}].`);const U=await g.to(q,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const K=await R.provider.resolveTask(U,T.CancellationToken.None);if(!K)return;this.A(K,R);const se=g.from(K,R.extension);if(!se)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(se.execution)&&await this.y(se,K,!0),await this.w(se)}x(){return this.h++}async y(W,q,R){const U=await this.a.$createTaskId(W);!R&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,q.execution)),this.m.set(U,q.execution)}async z(W,q){if(typeof W=="string"){const K=this.l.get(W);if(!K)throw new a.$bb("Unexpected: The specified task is missing an execution");return K}const R=this.l.get(W.id);if(R)return R;let U;return q?U=Promise.resolve(new w(this,W.id,q)):U=g.to(W.task,this.b,this.m).then(K=>{if(!K)throw new a.$bb("Unexpected: Task does not exist.");return new w(this,W.id,K)}),this.l.set(W.id,U),U.then(K=>(this.k.set(W.id,K),K))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const R=this.n.values();let U=R.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=R.next()}};e.$7lc=C,e.$7lc=C=Je([Ve(0,l.$cP),Ve(1,v.$sP),Ve(2,p.$Bkc),Ve(3,$.$nP),Ve(4,k.$Ekc),Ve(5,y.$3kc),Ve(6,n.$Wj),Ve(7,r.$fkc)],C);let P=class extends C{constructor(W,q,R,U,K,se,ce,ve){super(W,q,R,U,K,se,ce,ve),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const R=g.from(q,W);if(R===void 0)throw new Error("Task is not valid");if(S.is(R.execution))await this.y(R,q,!1);else throw new a.$_;const U=await this.z(await this.a.$getTaskExecution(R),q);return this.a.$executeTask(R).catch(K=>{throw new Error(K)}),U}v(W,q,R,U){const K=[];if(U)for(const se of U){if(this.A(se,R),!se.definition||!W[se.definition.type]){const ve=se.source?se.source:"No task source";this.f.warn(`The task [${ve}, ${se.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=g.from(se,R.extension);ce&&S.is(ce.execution)?(K.push(ce),q.push(this.y(ce,se,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:R.extension}}async w(W){if(S.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,R){}};e.$8lc=P,e.$8lc=P=Je([Ve(0,l.$cP),Ve(1,v.$sP),Ve(2,p.$Bkc),Ve(3,$.$nP),Ve(4,k.$Ekc),Ve(5,y.$3kc),Ve(6,n.$Wj),Ve(7,r.$fkc)],P),e.$9lc=(0,m.$qi)("IExtHostTask")}),define(Ae[289],Re([1,0,46,29]),function(fe,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=void 0,e.$sL=A,e.$uL=O;function A(M){return"cellResults"in M}e.$tL="rawCell#";function O(M,p){let $=-1;const k=[];let T=[];return M.forEach(l=>{l.range.startLineNumber!==$&&T.length>0&&(k.push([...T]),T=[]),T.push(l),$=l.range.endLineNumber}),T.length>0&&k.push([...T]),k.map(l=>{const v=[],m=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let o=m;o<=s;o++)v.push(p.getLineContent(o));return new I.$9K(v.join(`
`)+`
`,l.map(o=>new N.$kt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ae[290],Re([1,0,169,23,5,6,28,15,17,2,44,74,4,32,8,7,34,265,112,26,12,221,289,287]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a,d,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,S,h,E,g,D){this.q=h,this.r=E,this.s=g,this.t=D,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new A.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.$dkc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(l.$PM.MainThreadNotebook),this.c=u.getProxy(l.$PM.MainThreadNotebookDocuments),this.d=u.getProxy(l.$PM.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===13){const C=w.notebookEditor?.notebookUri,P=w.cell.handle,W=this.g.get(C)?.getCell(P);if(W)return W.apiCell}if(w&&w.$mid===14){const C=w.uri,P=this.g.get(C);if(P)return P.apiNotebook}return w}}),c.B(S)}getEditorById(u){const S=this.h.get(u);if(!S)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(u){for(const[S,h]of this.h)if(h.apiEditor===u)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,S){const h=this.g.get(u);if(!h&&!S)throw new Error(`NO notebook document for '${u}'`);return h}static u(u,S){if(!S)return;const h=S.filenamePattern.map(E=>m.NotebookExclusiveDocumentPattern.from(E)).filter(E=>E!==void 0);if(S.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:S.displayName,filenamePattern:h,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,S,h){const E=c.a++,g=typeof h.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(E,h),this.b.$registerNotebookCellStatusBarItemProvider(E,g,S);let D;return g!==void 0&&(D=h.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(g))),new s.$RM(()=>{this.f.delete(E),this.b.$unregisterNotebookCellStatusBarItemProvider(E,g),D?.dispose()})}async createNotebookDocument(u){const S=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&m.NotebookData.from(u.content)});return k.URI.revive(S)}async openNotebookDocument(u){const S=this.g.get(u);if(S)return S.apiNotebook;const h=await this.c.$tryOpenNotebook(u),E=this.g.get(k.URI.revive(h));return(0,$.$cg)(E?.apiNotebook)}async showNotebookDocument(u,S){k.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let h;typeof S=="object"?h={position:m.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(m.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:h={preserveFocus:!1};const E=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,h),g=E&&this.h.get(E)?.apiEditor;if(g)return g;throw E?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,S,h,E){const g=this.f.get(u),D=k.URI.revive(S),w=this.g.get(D);if(!w||!g)return;const C=w.getCellFromIndex(h);if(!C)return;const P=await g.provideCellStatusBarItems(C.apiCell,E);if(!P)return;const V=new O.$Tc,W=this.p.add([V]),R=(Array.isArray(P)?P:[P]).map(U=>m.NotebookStatusBarItem.from(U,this.i,V));return{cacheId:W,items:R}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,S,h,E,g){if((0,p.$3e)(S))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:S,serializer:h,options:E}),this.b.$registerNotebookSerializer(D,{id:u.identifier,location:u.extensionLocation},S,m.NotebookDocumentContentOptions.from(E),c.u(u,g)),(0,O.$Sc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(u,S,h){const E=this.x.get(u);if(!E)throw new Error("NO serializer found");const g=await E.serializer.deserializeNotebook(S.buffer,h);return new o.$mw(m.NotebookData.from(g))}async $notebookToData(u,S,h){const E=this.x.get(u);if(!E)throw new Error("NO serializer found");const g=await E.serializer.serializeNotebook(m.NotebookData.to(S.value),h);return N.$Ce.wrap(g)}async $saveNotebook(u,S,h,E,g){const D=k.URI.revive(S),w=this.x.get(u);if(!w)throw new Error("NO serializer found");const C=this.g.get(D);if(!C)throw new Error("Document NOT found");if(C.versionId!==h)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new T.$fl((0,I.localize)(0,null,this.z(D)),6);await this.y(D,E);const P={metadata:(0,t.$5n)(C.apiNotebook.metadata,U=>!(w.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of C.apiNotebook.getCells()){const K=new s.$hO(U.kind,U.document.getText(),U.document.languageId,U.mime,w.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);K.metadata=(0,t.$5n)(U.metadata,se=>!(w.options?.transientCellMetadata??{})[se]),P.cells.push(K)}const V=await w.serializer.serializeNotebook(P,g);await this.s.value.writeFile(D,V);const W=this.s.getFileSystemProviderExtUri(D.scheme),q=await this.s.value.stat(D);return{name:W.basename(D),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$ql({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(u,S,h,E,g){const D=this.x.get(u)?.serializer;if(!D)return{limitHit:!1,results:[]};const w=new M.$Cc;await(async(q,R,U)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(se=>{const ce={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:se};return this.t.doInternalFileSearchWithCustomCallback(ce,R,ve=>{ve.forEach(Ie=>{w.has(Ie)||E.some(be=>K.isFromSettings&&!be.isFromSettings?!1:be.filenamePatterns.some(ie=>(0,b.$ygb)(ie,Ie)))||w.add(Ie)})}).catch(ve=>{if(ve.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ve})}))))})(h,g,S);const P=new M.$Bc;let V=!1;const W=Array.from(w).map(async q=>{const R=[];try{if(g.isCancellationRequested)return;if(S.maxResults&&[...P.values()].reduce((ce,ve)=>ce+ve.cellResults.length,0)>S.maxResults){V=!0;return}const U=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ve=>U.push({input:ve.document.getText(),outputs:ve.outputs.flatMap(Ie=>Ie.items.map(ue=>ue.data.toString()))}));else{const ce=await this.s.value.readFile(q),ve=N.$Ce.fromString(ce.toString()),Ie=await D.deserializeNotebook(ve.buffer,g);if(g.isCancellationRequested)return;m.NotebookData.from(Ie).cells.forEach(be=>U.push({input:be.source,outputs:be.outputs.flatMap(ie=>ie.items.map(Pe=>Pe.valueBytes.toString()))}))}if(g.isCancellationRequested)return;U.forEach((ce,ve)=>{const Ie=S.contentPattern.pattern,ue=new d.$mWb(ce.input,void 0,ce.outputs),be=ue.findInInputs(Ie),ie=ue.findInOutputs(Ie),Pe=ie.flatMap(Fe=>(0,i.$uL)(Fe.matches,Fe.textBuffer)).map((Fe,ne)=>(Fe.webviewIndex=ne,Fe));if(be.length>0||ie.length>0){const Fe={index:ve,contentResults:(0,i.$uL)(be,ue.inputTextBuffer),webviewResults:Pe};R.push(Fe)}});const se={resource:q,cellResults:R};P.set(q,se);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...P.values()]}}async y(u,S){const h=await this.s.value.stat(u);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==T.$pl&&typeof h.mtime=="number"&&typeof h.size=="number"&&S.mtime<h.mtime&&S.etag!==T.$ql({mtime:S.mtime,size:h.size}))throw new T.$fl((0,I.localize)(1,null),3,S)}z(u){return u.scheme===a.Schemas.file?u.fsPath:u.toString()}A(u,S,h){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const E=new r.$Alc(S,this.d,u,h.visibleRanges.map(m.NotebookRange.to),h.selections.map(m.NotebookRange.to),typeof h.viewColumn=="number"?m.ViewColumn.to(h.viewColumn):void 0);this.h.set(S,E)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const h of u.value.removedDocuments){const E=k.URI.revive(h),g=this.g.get(E);g&&(g.dispose(),this.g.delete(E),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(g.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===E.toString()&&this.h.delete(D.id)}if(u.value.addedDocuments){const h=[];for(const E of u.value.addedDocuments){const g=k.URI.revive(E.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const D=new n.$zlc(this.c,this.q,this.r,g,E);h.push(...E.cells.map(w=>n.$ylc.asModelAddData(w))),this.g.get(g)?.dispose(),this.g.set(g,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this.m.fire(D.apiNotebook)}}if(u.value.addedEditors)for(const h of u.value.addedEditors){if(this.h.has(h.id))return;const E=k.URI.revive(h.documentUri),g=this.g.get(E);g&&this.A(g,h.id,h)}const S=[];if(u.value.removedEditors)for(const h of u.value.removedEditors){const E=this.h.get(h);E&&(this.h.delete(h),this.k?.id===E.id&&(this.k=void 0),S.push(E))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(E=>this.h.get(E)).filter(E=>!!E);const h=new Set;this.l.forEach(E=>h.add(E.id));for(const E of this.h.values()){const g=h.has(E.id);E._acceptVisibility(g)}this.l=[...this.h.values()].map(E=>E).filter(E=>E.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const S=v.$AP.String.with("notebookType","A notebook type"),h=new v.$CP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new v.$AP("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>N.$Ce.wrap(g))],new v.$BP("Notebook Data",g=>m.NotebookData.to(g.value))),E=new v.$CP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new v.$AP("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new o.$mw(m.NotebookData.from(g)))],new v.$BP("Bytes",g=>g.buffer));u.registerApiCommand(h),u.registerApiCommand(E)}}e.$Jlc=c}),define(Ae[291],Re([1,0,19,22,43,36,24,65,46]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0;class k{constructor(l,v,m){this.k=l,this.l=v,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&O.$kk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&O.$kk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const v=this.k.folderQueries||[];return new Promise((m,s)=>{const o=n=>{this.f++,l(n)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(n=>{const r=n.toString(),t=I.$oc(r);this.j&&this.j(r,t)||this.v(o,{base:n,basename:t})}),Promise.all(v.map(n=>this.p(n,o))).then(n=>{m({limitHit:this.e,stats:n[0]||void 0})},n=>{s(new Error((0,A.$bj)(n)))})})}async p(l,v){const m=new N.$me,s=this.q(l),o=this.r(),n=new $.$kL(this.k,l),r=!n.hasSiblingExcludeClauses();let t;try{this.h.add(m),t=p.$0d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,m.token),d=t.elapsed(),i=p.$0d.create();return this.g&&!this.e||(a&&a.forEach(b=>{const c=I.$hc.relative(l.folder.path,b.path);if(r){const f=I.$oc(b.path);this.v(v,{base:l.folder,relativePath:c,basename:f});return}this.s(o,l.folder,c,v)}),this.g&&!this.e)?null:(this.u(o,n,v),{providerTime:d,postProcessTime:i.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(l){const v=(0,$.$jL)(this.k.includePattern,l.includePattern),m=(0,$.$jL)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:m,includes:v,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},v,m,s){if(m===this.a){const n=I.$oc(this.a);this.v(s,{base:v,relativePath:this.a,basename:n})}function o(n){const r=I.$oc(n),t=I.$nc(n);let a=l[t];a||(a=l[t]=[],o(t)),a.push({base:v,relativePath:n,basename:r})}o(m)}u({rootEntries:l,pathToEntries:v},m,s){const o=this,n=this.a;function r(t){const a=(0,$.$mL)(()=>t.map(d=>d.basename));for(let d=0,i=t.length;d<i;d++){const b=t[d],{relativePath:c,basename:f}=b;if(m.matchesExcludesSync(c,f,n!==f?a:void 0))continue;const u=v[c];if(u)r(u);else{if(c===n)continue;o.v(s,b)}if(o.e)break}}r(l)}v(l,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(v))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,v,m,s){const o=this.c(l.cacheKey),n=new k(l,v,o&&o.token);let r=0;const t=a=>{r+=a.length,m(a.map(d=>this.d(d)))};return this.e(n,T.a,t,s).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:a.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new N.$me),this.b.get(l)}d(l){return l.relativePath?{resource:M.$4g(l.base,l.relativePath)}:{resource:l.base}}e(l,v,m,s){const o=s.onCancellationRequested(()=>{l.cancel()}),n=t=>{t&&(r.push(t),v>0&&r.length>=v&&(m(r),r=[]))};let r=[];return l.search(n).then(t=>(r.length&&m(r),o.dispose(),t),t=>(r.length&&m(r),o.dispose(),Promise.reject(t)))}}e.$Blc=T}),define(Ae[292],Re([1,0,18,260,36,96,28,12,19,24,15,17,2,95,187,48,13,49,107,288,46]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$uM=E;let d=class{constructor(D,w,C,P,V){this.a=D,this.b=w,this.c=C,this.d=P,this.e=V}text(D,w,C={}){D=this.f(D,C);const P=this.a.getValue(),V=w&&w.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(w?.map(n.$Li),C),type:2,contentPattern:D,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||V||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(D,w){const C=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const P={...D,wordSeparators:C.editor.wordSeparators};return this.j(D,w)&&(P.isCaseSensitive=!0),this.k(D)&&(P.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),P}file(D,w={}){return{...this.h(D,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(D,w){return D?(D=Array.isArray(D)?D.map(u):u(D),w?this.parseSearchPaths(D):{pattern:b(...Array.isArray(D)?D:[D])}):{}}h(D=[],w={}){const C=this.g(w.includePattern,w.expandPatterns),P=this.g(w.excludePattern,w.expandPatterns),V=D.length>1,W=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(U=>this.q(U,w,P)):D.map(U=>this.r(U,w,P,V))).filter(U=>!!U),q={_reason:w._reason,folderQueries:W,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const U=I.$Hb(I.$Rb(this.c.groups.map(ce=>ce.editors.map(ve=>ve.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const K=U.filter(ce=>(0,a.$aL)(q,ce.fsPath)),se=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(se)),{...q,...se}}const R=w.extraFileResources&&w.extraFileResources.filter(U=>(0,a.$aL)(q,U.fsPath));return q.extraFileResources=R&&R.length?R:void 0,q}i(D){const w=[],C=new M.$Bc,P={};let V=!1;return D.forEach(W=>{if(W.scheme===p.Schemas.walkThrough)return;if((0,k.$8g)(W)){const R=this.b.getWorkspaceFolder(W)?.uri??W.with({path:$.$nc(W.fsPath)});let U=C.get(R);U||(V=!0,U={folder:R,includePattern:{}},w.push(U),C.set(R,U));const K=$.$mc(R.fsPath,W.fsPath);(0,y.$cg)(U.includePattern)[K.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,P[W.fsPath]=!0)}),{folderQueries:w,includePattern:P,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(D,w){if(w.isSmartCase){if(D.isRegExp){if(T.$Uf(D.pattern,!0))return!0}else if(T.$Uf(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,v.$BC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const w=se=>$.$jc(se)||/^\.\.?([\/\\]|$)/.test(se),P=(Array.isArray(D)?D:c(D)).map(se=>{const ce=this.e.resolvedUserHome;return ce?(0,O.$rw)(se,ce.scheme===p.Schemas.file?ce.fsPath:ce.path):se}),V=N.$K(P,se=>w(se)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(se=>T.$bf(se,"/")).map(se=>T.$bf(se,"\\")).map(se=>(se[0]==="."&&(se="*"+se),f(se))),q={},R=this.m(V.searchPaths||[]);R&&R.length&&(q.searchPaths=R);const U=I.$Rb(W),K=b(...U);return K&&(q.pattern=K),q}l(D,w){return w.disregardExcludeSettings?void 0:(0,a.$_K)(D,!w.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const w=D.flatMap(P=>{let{pathPortion:V,globPortion:W}=i(P);return W&&(W=S(W)),this.n(V).flatMap(R=>this.o(R,W))}),C=new Map;return w.forEach(P=>{const V=P.searchPath.toString(),W=C.get(V);W?P.pattern&&(W.pattern=W.pattern||{},W.pattern[P.pattern]=!0):C.set(V,{searchPath:P.searchPath,pattern:P.pattern?b(P.pattern):void 0})}),Array.from(C.values())}n(D){if($.$jc(D)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==p.Schemas.file?[{searchPath:w[0].uri.with({path:D})}]:[{searchPath:l.URI.file($.$ic(D))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(D=u(D),D.startsWith("../")||D===".."){const P=$.$hc.resolve(w.path,D);return[{searchPath:w.with({path:P})}]}const C=S(D);return[{searchPath:w,pattern:C}]}else{if(D==="./"||D===".\\")return[];{const w=D.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(V=>{const W=w.match(new RegExp(`^${T.$8e(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(y.$_f);if(P.length)return P.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&S(W)}});{const V=D.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:D,q=m.localize(0,null,W);throw new Error(q)}}}}o(D,w){const C=D.pattern&&w?`${D.pattern}/${w}`:D.pattern||w,P=[{searchPath:D.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:D.searchPath,pattern:C+"/**"}),P}q(D,w,C){const P=this.r((0,n.$Li)(D.searchPath),w,C,!1);return P?{...P,includePattern:D.pattern}:null}r(D,w,C,P){let V;const W=l.URI.isUri(D)?D:D.uri;if(C.searchPaths){const se=C.searchPaths.filter(ce=>(0,k.$Wg)(ce.searchPath,W))[0];if(se&&!se.pattern)return null;se&&(V=se.pattern)}const q=this.a.getValue({resource:W}),U={...this.l(q,w)||{},...V||{}},K=l.URI.isUri(D)?(0,k.$1g)(D):D.name;return{folder:W,folderName:P?K:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!q.search.followSymlinks}}};e.$tM=d,e.$tM=d=Je([Ve(0,s.$Wi),Ve(1,n.$zi),Ve(2,r.$ID),Ve(3,o.$Wj),Ve(4,t.$rM)],d);function i(g){const D=g.match(/[\*\{\}\(\)\[\]\?]/);if(D){const w=D.index,C=g.substr(0,w).match(/[/|\\][^/\\]*$/);if(C){let P=g.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:g.substr((C.index||0)+1)}}}return{pathPortion:g}}function b(...g){return g.length?g.reduce((D,w)=>(D[w]=!0,D),Object.create(null)):void 0}function c(g){return A.$ik(g,",").map(D=>D.trim()).filter(D=>!!D.length)}function f(g){return[`**/${g}/**`,`**/${g}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function u(g){return g.replace(/\\/g,"/")}function S(g){return u(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(g){return g.replace(/([?*[\]])/g,"[$1]")}function E(g,D){g=I.$Mb(g,P=>P.toString());const w=[],C=D.getWorkspace();return g&&g.forEach(P=>{let V;if(D.getWorkbenchState()===2)V=(0,k.$6g)(C.folders[0].uri,P),V&&V!=="."&&(V="./"+V);else{const W=D.getWorkspaceFolder(P);if(W){const q=W.name;if(C.folders.filter(U=>U.name===q).length===1){const U=(0,k.$6g)(W.uri,P);U===""?V=`./${W.name}`:V=`./${W.name}/${U}`}else V=P.fsPath}}V&&w.push(h(V))}),w}}),define(Ae[293],Re([1,0,24,2,22,14,3,292,46,49,11]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ytb=l,e.$ztb=s;const y=7e3;function l(o,n){const r=n.activationEvents;if(!r)return Promise.resolve(void 0);const t=[],a=[];for(const u of r)if(/^workspaceContains:/.test(u)){const S=u.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||o.forceUsingSearch?a.push(S):t.push(S)}if(t.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:d,resolve:i}=(0,T.$jh)(),b=u=>i({activationEvent:u}),c=Promise.all(t.map(u=>v(o,u,b))).then(()=>{}),f=m(o,n.identifier,a,b);return Promise.all([c,f]).then(()=>{i(void 0)}),d}async function v(o,n,r){for(const t of o.folders)if(await o.exists(I.$4g(N.URI.revive(t),n))){r(`workspaceContains:${n}`);return}}async function m(o,n,r,t){if(r.length===0)return Promise.resolve(void 0);const a=new A.$me,d=o.checkExists(o.folders,r,a.token),i=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${n.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},y);let b=!1;try{b=await d}catch(c){O.$4(c)||O.$1(c)}a.dispose(),clearTimeout(i),b&&t(`workspaceContains:${r.join(",")}`)}function s(o,n,r,t){const a=o.get(M.$pi),d=o.get($.$4K),b=a.createInstance(p.$tM).file(n.map(c=>(0,k.$Li)(N.URI.revive(c))),{_reason:"checkExists",includePattern:r,exists:!0});return d.fileSearch(b,t).then(c=>!!c.limitHit,c=>O.$4(c)?!1:Promise.reject(c))}}),define(Ae[39],Re([1,0,165,19,89,24,11,6,52,2,13,4,38,227,82,37,25,108,14,20,23,208,7,102,3,27,85,16,71,86,51,88,5,293,81,210,12,79,65,21,80]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a,d,i,b,c,f,u,S,h,E,g,D,w,C,P,V,W,q,R,U,K){"use strict";var se;Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=e.$glc=e.$flc=e.$elc=e.$dlc=void 0,e.$dlc=(0,c.$qi)("IHostUtils");let ce=se=class extends p.$Uc{constructor(j,x,pe,Oe,ke,$e,ge,J,Y,he,le,Ne,de){super(),this.Y=Ne,this.Z=de,this.a=this.B(new w.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=pe,this.f=ge,this.j=Oe,this.m=ke,this.s=$e,this.t=Y,this.u=he,this.w=le,this.y=this.g.getProxy(y.$PM.MainThreadWorkspace),this.z=this.g.getProxy(y.$PM.MainThreadTelemetry),this.C=this.g.getProxy(y.$PM.MainThreadExtensionService),this.D=new M.$ph,this.F=new M.$ph,this.G=new M.$ph,this.H=new M.$ph,this.I=new Fe(this.f.extensions.activationEvents),this.L=new n.$R$b(this.I,this.f.extensions.allExtensions);const Ce=new t.$Mm(this.f.extensions.myExtensions);this.J=new n.$R$b(this.I,ie(this.L,Ce)),U.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ue(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ue(this.J)}`)),this.M=new m.$Ykc(this.g,this.s),this.N=new P.$9kc(this.g),this.O=J,this.h=j.createChild(new h.$oi([m.$Zkc,this.M],[P.$0kc,this.N])),this.P=this.B(new v.$Xkc(this.J,this.L,{onExtensionActivationError:(Me,ze,z)=>{this.C.$onExtensionActivationError(Me,r.$3(ze),z)},actualActivateExtension:async(Me,ze)=>{if(n.$R$b.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,ze),new v.$Wkc;const z=this.J.getExtensionDescription(Me);return this.fb(z,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(j){r.$1(j)}}async $(){this.O.onWillDeactivateAll();let j=[];try{j=this.J.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.eb(ke))}catch{}await Promise.all(j)}terminate(j,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${j}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(Oe=>{this.s.error(Oe)}),this.g.dispose();const pe=this.$();Promise.race([(0,M.$rh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(j){return this.G.isOpen()?this.P.isActivated(j):!1}async getExtension(j){const x=await this.C.$getExtension(j);return x&&{...x,identifier:new t.$Lm(x.identifier.value),extensionLocation:k.URI.revive(x.extensionLocation)}}ab(j,x){return this.P.activateByEvent(j,x)}bb(j,x){return this.P.activateById(j,x)}activateByIdWithErrors(j,x){return this.bb(j,x).then(()=>{const pe=this.P.getActivatedExtension(j);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(j=>this.J)}getExtensionExports(j){if(this.G.isOpen())return this.P.getActivatedExtension(j).exports;try{return this.P.getActivatedExtension(j).exports}catch{return null}}async cb(j){if(j.scheme===W.Schemas.file&&this.c.fsRealpath){const x=j.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const pe=await this.R.get(x);return k.URI.file(pe)}return j}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(j=>new Pe(j))),this.Q}async db(j){const x=$.$wi.forUris(pe=>O.$Ug.ignorePathCasing(pe));return await Promise.all(j.map(async pe=>{if(this.wb(pe)){const Oe=await this.cb(pe.extensionLocation);x.set(Oe,pe)}})),x}eb(j){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(j))return x;const pe=this.P.getActivatedExtension(j);if(!pe)return x;try{typeof pe.module.deactivate=="function"&&(x=Promise.resolve(pe.module.deactivate()).then(void 0,Oe=>(this.s.error(Oe),Promise.resolve(void 0))))}catch(Oe){this.s.error(`An error occurred when deactivating the extension '${j.value}':`),this.s.error(Oe)}try{(0,p.$Pc)(pe.subscriptions)}catch(Oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this.s.error(Oe)}return x}async fb(j,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(j.identifier):await this.C.$onWillActivateExtension(j.identifier),this.hb(j,x).then(pe=>{const Oe=pe.activationTimes;return this.C.$onDidActivateExtension(j.identifier,Oe.codeLoadingTime,Oe.activateCallTime,Oe.activateResolvedTime,x),this.gb(j,x,"success",Oe),pe},pe=>{throw this.gb(j,x,"failure"),pe})}gb(j,x,pe,Oe){const ke=Ie(j,x);this.z.$publicLog2("extensionActivationTimes",{...ke,...Oe||{},outcome:pe})}hb(j,x){const pe=Ie(j,x);this.z.$publicLog2("activatePlugin",pe);const Oe=this.wb(j);if(!Oe)return Promise.resolve(new v.$Vkc(v.$Skc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${j.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const ke=new v.$Tkc(x.startup);return Promise.all([this.xb(j,(0,O.$4g)(j.extensionLocation,Oe),ke),this.ib(j)]).then($e=>(A.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),se.jb(this.s,j.identifier,$e[0],$e[1],ke))).then($e=>(A.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),$e))}ib(j){const x=this.Z.createLanguageModelAccessInformation(j),pe=new d.$2kc(j,this.M),Oe=new d.$1kc(j.identifier.value,!1,this.M),ke=new V.$$kc(j,this.N),$e=j.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ge=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([pe.whenReady,Oe.whenReady,this.O.whenReady]).then(()=>{const J=this;let Y,he;const le=(0,o.$xG)(j,"ipc")?this.f.messagePorts?.get(t.$Lm.toKey(j.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:Oe,secrets:ke,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(Ne){return N.$kc(j.extensionLocation.fsPath,Ne)},get storagePath(){return J.O.workspaceValue(j)?.fsPath},get globalStoragePath(){return J.O.globalValue(j).fsPath},get logPath(){return N.$kc(J.f.logsLocation.fsPath,j.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,j.identifier.value)},get storageUri(){return J.O.workspaceValue(j)},get globalStorageUri(){return J.O.globalValue(j)},get extensionMode(){return $e},get extension(){return Y===void 0&&(Y=new be(J,j.identifier,j,ge,!1)),Y},get extensionRuntime(){return(0,o.$yG)(j,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!he){if(!le)return;const Ne=w.Event.buffer(w.Event.fromDOMEventEmitter(le,"message",de=>de.data));le.start(),he={onDidReceiveMessage:Ne,postMessage:le.postMessage.bind(le)}}return he}})})}static jb(j,x,pe,Oe,ke){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(j,x,pe,Oe,ke).then($e=>new v.$Ukc(!1,null,ke.build(),pe,$e,Oe.subscriptions))}static kb(j,x,pe,Oe,ke){if(typeof pe.activate=="function")try{ke.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${x.value}`);const $e=typeof global=="object"?global:self,ge=pe.activate.apply($e,[Oe]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(ge).then(J=>(ke.activateResolveStop(),J))}catch($e){return Promise.reject($e)}else return Promise.resolve(pe)}lb(j,x){this.bb(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:x}).then(void 0,pe=>{this.s.error(pe)})}mb(j,x=0){const Oe=Date.now();(0,U.$B)(()=>{for(let ke=x;ke<j.length;ke+=1){const $e=j[ke];for(const ge of $e.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Oe>50){this.mb(j,ke);break}else this.lb($e,ge)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(j=>{const x=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(x)this.mb(pe);else for(const Oe of pe)if(Oe.activationEvents)for(const ke of Oe.activationEvents)ke==="onStartupFinished"&&this.lb(Oe,ke)})}ob(){const j=this.ab("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.pb($e.added)));const x=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(x),Oe=this.rb(),ke=Promise.all([Oe,j,pe]).then(()=>{});return Promise.race([ke,(0,M.$rh)(1e4)]).then(()=>{this.nb()}),ke}pb(j){return j.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(j,x))).then(()=>{})}async qb(j,x){if(this.isActivated(x.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,Oe={logService:this.s,folders:j.map($e=>$e.uri),forceUsingSearch:pe||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,ge,J)=>this.y.$checkExists($e,ge,J)},ke=await(0,C.$ytb)(Oe,x);if(ke)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ke.activationEvent}).then(void 0,$e=>this.s.error($e))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(j){throw console.error(j),j}}async sb(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:x}=this.f.environment;if(!j||!x)throw new Error(I.localize(0,null));const pe=await this.xb(null,x,new v.$Tkc(!1));if(!pe||typeof pe.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Oe,ke)=>{const $e=(Y,he)=>{Y?(U.$t&&this.s.error("Test runner called back with error",Y),ke(Y)):(U.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Oe(typeof he=="number"&&he>0?1:0))},ge=(0,O.$Rg)(x),J=pe.run(ge,$e);J&&J.then&&J.then(()=>{U.$t&&this.s.info("Test runner finished successfully."),Oe(0)}).catch(Y=>{U.$t&&this.s.error("Test runner finished with error",Y),ke(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$rh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,x){return this.S[j]=x,(0,p.$Sc)(()=>{delete this.S[j]})}async getRemoteExecServer(j){const{resolver:x}=await this.ub(j);return x?.resolveExecServer?.(j,{resolveAttempt:0})}async ub(j){const x=j.indexOf("+");if(x===-1)throw new i.$XM("Not an authority that can be resolved!",b.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=j.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(j,x){const pe=R.$0d.create(!1),Oe=()=>`[resolveAuthority(${(0,b.$Fl)(j)},${x})][${pe.elapsed()}ms] `,ke=L=>this.s.info(`${Oe()}${L}`),$e=L=>this.s.warn(`${Oe()}${L}`),ge=(L,G=void 0)=>this.s.error(`${Oe()}${L}`,G),J=L=>{if(L instanceof i.$XM)return{type:"error",error:{code:L._code,message:L._message,detail:L._detail}};throw L},Y=async L=>{ke(`activating resolver for ${L}...`);const{resolver:G,authorityPrefix:H}=await this.ub(L);if(!G)throw ge(`no resolver for ${H}`),new i.$XM(`No remote extension installed to resolve ${H}.`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:L}},he=j.split(/@|%40/g).reverse();ke(`activating remote resolvers ${he.join(" -> ")}`);let le;try{le=await Promise.all(he.map(Y)).catch(async L=>{if(!(L instanceof i.$XM)||L._code!==b.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw L;return $e(`resolving nested authorities failed: ${L.message}`),[await Y(j)]})}catch(L){return J(L)}const Ne=new M.$Bh;Ne.cancelAndSet(()=>ke("waiting..."),1e3);let de,Ce;for(const[L,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of le.entries())try{if(L===le.length-1)ke("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${G}`),de=await H.resolve(ee,{resolveAttempt:x,execServer:Ce}),A.mark(`code/extHost/didResolveAuthorityOK/${G}`),ke("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,i.$WM.isManagedResolvedAuthority(de)?de:void 0));else{if(ke(`invoking resolveExecServer() for ${ee}`),A.mark(`code/extHost/willResolveExecServer/${G}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new i.$XM(`Exec server was not available for ${ee}`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(re){return A.mark(`code/extHost/didResolveAuthorityError/${G}`),ge("returned an error",re),Ne.dispose(),J(re)}Ne.dispose();const Me={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};ke(`returned ${i.$WM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let z;if(i.$WM.isManagedResolvedAuthority(de)){const L=x;this.Y.setFactory(L,de.makeConnection),z={authority:j,connectTo:new b.$Cl(L),connectionToken:de.connectionToken}}else z={authority:j,connectTo:new b.$Dl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:z,options:ze,tunnelInformation:Me}}}async $getCanonicalURI(j,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,b.$Fl)(j)})`);const{resolver:pe}=await this.ub(j);if(!pe)return null;const Oe=k.URI.revive(x);if(typeof pe.getCanonicalURI>"u")return Oe;const ke=await(0,M.$ih)(()=>pe.getCanonicalURI(Oe));return ke||Oe}async $startExtensionHost(j){j.toAdd.forEach($e=>$e.extensionLocation=k.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:pe}=ve(this.I,this.L,this.J,j),Oe=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(pe),U.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ue(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ue(this.J)}`)),this.tb()}$activateByEvent(j,x){return x===1?this.D.wait().then(pe=>this.ab(j,!1)):this.G.wait().then(pe=>this.ab(j,!1))}async $activate(j,x){return await this.G.wait(),this.J.getExtensionDescription(j)?(await this.bb(j,x),!0):!1}async $deltaExtensions(j){j.toAdd.forEach($e=>$e.extensionLocation=k.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:pe}=ve(this.I,this.L,this.J,j),Oe=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(pe),U.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ue(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ue(this.J)}`)),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const x=a.$Ce.alloc(j),pe=Math.random()%256;for(let Oe=0;Oe<j;Oe++)x.writeUInt8(pe,Oe);return x}async $updateRemoteConnectionData(j){this.X=j,this.a.fire()}};e.$elc=ce,e.$elc=ce=se=Je([Ve(0,c.$pi),Ve(1,e.$dlc),Ve(2,S.$cP),Ve(3,s.$Bkc),Ve(4,l.$Ekc),Ve(5,T.$Wj),Ve(6,f.$sP),Ve(7,u.$Hkc),Ve(8,E.$ACb),Ve(9,g.$3kc),Ve(10,q.$alc),Ve(11,K.$blc),Ve(12,D.$7kc)],ce);function ve(ne,j,x,pe){ne.addActivationEvents(pe.addActivationEvents);const Oe=new n.$R$b(ne,j.getAllExtensionDescriptions());Oe.deltaExtensions(pe.toAdd,pe.toRemove);const ke=new t.$Mm(x.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of pe.myToRemove)ke.delete(ge);for(const ge of pe.myToAdd)ke.add(ge);const $e=ie(Oe,ke);return{globalRegistry:Oe,myExtensions:$e}}function Ie(ne,j){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}function ue(ne){return ne.getAllExtensionDescriptions().map(j=>j.identifier.value).join(",")}e.$flc=(0,c.$qi)("IExtHostExtensionService");class be{#e;#t;#i;constructor(j,x,pe,Oe,ke){this.#e=j,this.#t=x,this.#i=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=N.$ic((0,O.$Rg)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=Oe,this.isFromDifferentExtensionHost=ke}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$glc=be;function ie(ne,j){return ne.getAllExtensionDescriptions().filter(x=>j.has(x.identifier))}class Pe{constructor(j){this.a=j}setSearchTree(j){this.a=j}findSubstr(j){return this.a.findSubstr(j)}forEach(j){return this.a.forEach(j)}}e.$hlc=Pe;class Fe{constructor(j){this.a=new t.$Nm,this.addActivationEvents(j)}readActivationEvents(j){return this.a.get(j.identifier)??[]}addActivationEvents(j){for(const x of Object.keys(j))this.a.set(x,j[x])}}}),define(Ae[294],Re([1,0,89,2,4,38,25,20,16,27,3,39,13,15]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;let s=class{constructor(a,d,i,b,c,f,u){this.c=a,this.d=d,this.e=i,this.f=b,this.g=c,this.h=f,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const d=await this.g.getExtensionPathIndex();this.register(new n(this.c,d,this.d,a,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,d,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const d of a.nodeModuleName)this.a.set(d,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(d=>a.alternativeModuleName(d))}};e.$qmc=s,e.$qmc=s=Je([Ve(2,T.$pi),Ve(3,O.$Ekc),Ve(4,y.$flc),Ve(5,k.$sP),Ve(6,l.$Wj)],s);let o=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&m.a.size){const d=(0,v.$8e)(this.c(a.environment.appRoot.fsPath)),i="[a-z0-9_.-]",b=`@${i}+\\/${i}+|${i}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${d}/${c}\\/)(${b})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const d=this.b.exec(this.c(a));if(!d)return;const[,i,b,c]=d,f=m.a.get(b);if(f!==void 0)return console.warn(`${b} as been renamed to ${f}, please update your imports`),i+f+c}c(a){return a.replace(/\\/g,"/")}};o=m=Je([Ve(0,k.$sP)],o);class n{constructor(a,d,i,b,c){this.c=a,this.d=d,this.e=i,this.f=b,this.g=c,this.nodeModuleName="vscode",this.a=new p.$Nm}load(a,d){const i=this.d.findSubstr(d);if(i){let b=this.a.get(i.identifier);return b||(b=this.c(i,this.e,this.f),this.a.set(i.identifier,b)),b}if(!this.b){let b="";this.d.forEach((c,f)=>b+=`	${f} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${b}`),this.b=this.c(M.$sG,this.e,this.f)}return this.b}}let r=class{constructor(a,d,i){this.e=a,this.f=d,this.nodeModuleName=["open","opn"],this.d=i.getProxy(A.$PM.MainThreadTelemetry);const b=i.getProxy(A.$PM.MainThreadWindow);this.c=(c,f)=>{const u=N.URI.parse(c);return f?this.g(c,f):u.scheme==="http"||u.scheme==="https"?b.$openUri(u,c,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?b.$openUri(u,c,{}):this.g(c,f)}}load(a,d,i){const b=this.e.findSubstr(d);return b&&(this.a=b.identifier.value,this.h()),this.b=i(a),this.c}g(a,d){return this.i(),this.b(a,d)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Je([Ve(2,$.$cP)],r)}),define(Ae[120],Re([1,0,41,6,19,73,3,67,66,39,7,37,224,38]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=void 0,e.$ilc=(0,M.$qi)("IExtHostVariableResolverProvider");class m extends l.$eQ{constructor(n,r,t,a,d,i,b){function c(){if(t){const f=t.activeEditor();if(f)return f.document.uri;const u=a.tabGroups.all.find(S=>S.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof T.$CO||u.input instanceof T.$HO)return u.input.modified;if(u.input instanceof T.$BO||u.input instanceof T.$GO||u.input instanceof T.$EO)return u.input.uri}}}super({getFolderUri:f=>{const u=i.folders.filter(S=>S.name===f);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(f,u)=>d.getConfiguration(void 0,f).get(u),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=c();if(f)return A.$ic(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const f=c();if(f){const u=r.getWorkspaceFolder(f);if(u)return A.$ic(u.uri.fsPath)}}},getSelectedText:()=>{if(t){const f=t.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(t){const f=t.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>n.getExtension(f)},void 0,b?Promise.resolve(b):void 0,Promise.resolve(O.env))}}let s=class extends N.$Uc{constructor(n,r,t,a,d){super(),this.b=n,this.c=r,this.g=t,this.h=a,this.j=d,this.a=new I.$V(async()=>{const i=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,i,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$jlc=s,e.$jlc=s=Je([Ve(0,k.$flc),Ve(1,y.$Bkc),Ve(2,p.$nP),Ve(3,v.$Ekc),Ve(4,$.$Qkc)],s)}),define(Ae[121],Re([1,0,11,5,2,20,3,4,66,39,16,7,37,216,218,38,120,6,42,32,8]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=e.$nlc=e.$mlc=e.$llc=e.$klc=void 0,e.$klc=(0,M.$qi)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(h,E,g,D,w,C,P){this.N=E,this.O=g,this.P=D,this.Q=w,this.R=C,this.S=P,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$be,this.o=new N.$be,this.q=new N.$be,this.w=new N.$be,this.l=h.getProxy(p.$PM.MainThreadDebugService),this.A=new N.$be,this.C=new N.$be,this.y=new b(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(W=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(h,E){const g=this.W(E);if(!g)return;const D=await this.H.get(h)?.getTreeItem?.(g);return D?this.U(h,D):void 0}registerDebugVisualizationTree(h,E,g){const D=O.$Lm.toKey(h.identifier),w=this.jb(D,E);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.H.set(w,g),this.l.$registerDebugVisualizerTree(w,!!g.editItem),(0,n.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(w),this.H.delete(E)})}async $getVisualizerTreeItemChildren(h,E){const g=this.J.get(E)?.item;return g?(await this.H.get(h)?.getChildren?.(g))?.map(w=>this.U(h,w))||[]:[]}async $editVisualizerTreeItem(h,E){const g=this.J.get(h);if(!g)return;const D=await this.H.get(g.provider)?.editItem?.(g.item,E);return this.U(g.provider,D||g.item)}$disposeVisualizedTree(h){const E=this.J.get(h);if(!E)return;const g=[E.children];for(const D of g)if(D)for(const w of D)g.push(this.J.get(w)?.children),this.J.delete(w)}U(h,E){let g=this.I.get(E);return g||(g=this.F++,this.I.set(E,g),this.J.set(g,{provider:h,item:E})),a.DebugTreeItem.from(E,g)}asDebugSourceUri(h,E){const g=h;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let D=`debug:${encodeURIComponent(g.path||"")}`,w="?";return E&&(D+=`${w}session=${encodeURIComponent(E.id)}`,w="&"),D+=`${w}ref=${g.sourceReference}`,A.URI.parse(D)}else{if(g.path)return A.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(h){const E=[];for(const g of h.getAllExtensionDescriptions())if(g.contributes){const D=g.contributes.debuggers;if(D&&D.length>0)for(const w of D)(0,m.$_G)(w)&&E.push(w.type)}this.l.$registerDebugTypes(E)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const h=[];return this.z.forEach(E=>h.push(E)),h}async $resolveDebugVisualizer(h,E){const g=this.L.get(h);if(!g)throw new Error(`No debug visualizer found with id '${h}'`);let{v:D,provider:w,extensionId:C}=g;if(D.visualization||(D=await w.resolveDebugVisualization?.(D,E)||D,g.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${w}'`);return this.kb(C,D.visualization)}async $executeDebugVisualizerCommand(h){const E=this.L.get(h);if(!E)throw new Error(`No debug visualizer found with id '${h}'`);const g=E.v.visualization;g&&"command"in g&&this.S.executeCommand(g.command,...g.arguments||[])}W(h){const E=this.m.get(h.sessionId);return E&&{session:E.api,variable:h.variable,containerId:h.containerId,frameId:h.frameId,threadId:h.threadId}}async $provideDebugVisualizers(h,E,g,D){const w=this.W(g),C=this.jb(h,E),P=this.G.get(C);if(!w||!P)return[];const V=await P.provideDebugVisualization(w,D);return V?V.map(W=>{const q=++this.M;this.L.set(q,{v:W,provider:P,extensionId:h});const R=W.iconPath?this.lb(W.iconPath):void 0;return{id:q,name:W.name,iconClass:R?.iconClass,iconPath:R?.iconPath,visualization:this.kb(h,W.visualization)}}):[]}$disposeDebugVisualizers(h){for(const E of h)this.L.delete(E)}registerDebugVisualizationProvider(h,E,g){if(!h.contributes?.debugVisualizers?.some(C=>C.id===E))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${E})`);const D=O.$Lm.toKey(h.identifier),w=this.jb(D,E);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.G.set(w,g),this.l.$registerDebugVisualizer(D,E),(0,n.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,E),this.G.delete(E)})}addBreakpoints(h){const E=h.filter(w=>{const C=w.id;return this.z.has(C)?!1:(this.z.set(C,w),!0)});this.gb(E,[],[]);const g=[],D=new Map;for(const w of E)if(w instanceof y.$SN){let C=D.get(w.location.uri.toString());C||(C={type:"sourceMulti",uri:w.location.uri,lines:[]},D.set(w.location.uri.toString(),C),g.push(C)),C.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character,mode:w.mode})}else w instanceof y.$TN&&g.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName,mode:w.mode});return this.l.$registerBreakpoints(g)}removeBreakpoints(h){const E=h.filter(C=>this.z.delete(C.id));this.gb([],E,[]);const g=E.filter(C=>C instanceof y.$SN).map(C=>C.id),D=E.filter(C=>C instanceof y.$TN).map(C=>C.id),w=E.filter(C=>C instanceof y.$UN).map(C=>C.id);return this.l.$unregisterBreakpoints(g,D,w)}startDebugging(h,E,g){return this.l.$startDebugging(h?h.uri:void 0,E,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(h){return this.l.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,E,g){if(!E)return new y.$RM(()=>{});const D=this.d++;return this.f.push({type:h,handle:D,provider:E}),this.l.$registerDebugConfigurationProvider(h,g,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,D),new y.$RM(()=>{this.f=this.f.filter(w=>w.provider!==E),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(h,E,g){if(!g)return new y.$RM(()=>{});if(!this.cb(h,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.$(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:E,handle:D,factory:g}),this.l.$registerDebugAdapterDescriptorFactory(E,D),new y.$RM(()=>{this.h=this.h.filter(w=>w.factory!==g),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(h,E){if(!E)return new y.$RM(()=>{});const g=this.j++;return this.k.push({type:h,handle:g,factory:E}),new y.$RM(()=>{this.k=this.k.filter(D=>D.factory!==E)})}async $runInTerminal(h,E){return Promise.resolve(void 0)}async $substituteVariables(h,E){let g;const D=await this.ib(h);return D&&(g={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(g,E)}X(h,E){if(h.type==="implementation")return new f(h.implementation)}Y(){}async $startDASession(h,E){const g=this,D=await this.hb(E);return this.eb(this.$(D.type),D).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const C=this.Z(w),P=this.X(C,D);if(!P)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const V=P;return this.D.set(h,V),this.db(D).then(W=>(W&&this.E.set(h,W),V.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const R=q,U={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(R.arguments.value);U.body={signature:K},V.sendResponse(U)}else throw new Error("no signer")}catch(K){U.success=!1,U.message=K.message,V.sendResponse(U)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(q),q=(0,m.$eH)(q,!0),g.l.$acceptDAMessage(h,q)}),V.onError(q=>{W&&W.onError&&W.onError(q),this.l.$acceptDAError(h,q.name,q.message,q.stack)}),V.onExit(q=>{W&&W.onExit&&W.onExit(q??void 0,void 0),this.l.$acceptDAExit(h,q??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),V.startSession()))})}$sendDAMessage(h,E){E=(0,m.$dH)(E,!1);const g=this.E.get(h);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(E),this.D.get(h)?.sendMessage(E)}$stopDASession(h){const E=this.E.get(h);this.E.delete(h),E&&E.onWillStopSession&&E.onWillStopSession();const g=this.D.get(h);return this.D.delete(h),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const E=[],g=[],D=[];if(h.added)for(const w of h.added){const C=w.id;if(C&&!this.z.has(C)){let P;if(w.type==="function")P=new y.$TN(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode);else if(w.type==="data")P=new y.$UN(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage,w.mode);else{const V=A.URI.revive(w.uri);P=new y.$SN(new y.$4M(V,new y.$SM(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode)}(0,y.$QN)(P,C),this.z.set(C,P),E.push(P)}}if(h.removed)for(const w of h.removed){const C=this.z.get(w);C&&(this.z.delete(w),g.push(C))}if(h.changed){for(const w of h.changed)if(w.id){const C=this.z.get(w.id);if(C){if(C instanceof y.$TN&&w.type==="function"){const P=C;P.enabled=w.enabled,P.condition=w.condition,P.hitCondition=w.hitCondition,P.logMessage=w.logMessage,P.functionName=w.functionName}else if(C instanceof y.$SN&&w.type==="source"){const P=C;P.enabled=w.enabled,P.condition=w.condition,P.hitCondition=w.hitCondition,P.logMessage=w.logMessage,P.location=new y.$4M(A.URI.revive(w.uri),new y.$SM(w.line,w.character))}D.push(C)}}}this.gb(E,g,D)}async $acceptStackFrameFocus(h){let E;if(h){const g=await this.hb(h.sessionId);h.kind==="thread"?E=new y.$1N(g.api,h.threadId):E=new y.$ZN(g.api,h.threadId,h.frameId)}this.B=E,this.C.fire(this.B)}$provideDebugConfigurations(h,E,g){return(0,I.$ih)(async()=>{const D=this.bb(h);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.ib(E);return D.provideDebugConfigurations(w,g)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(h,E,g,D){return(0,I.$ih)(async()=>{const w=this.bb(h);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(E);return w.resolveDebugConfiguration(C,g,D)})}$resolveDebugConfigurationWithSubstitutedVariables(h,E,g,D){return(0,I.$ih)(async()=>{const w=this.bb(h);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(E);return w.resolveDebugConfigurationWithSubstitutedVariables(C,g,D)})}async $provideDebugAdapter(h,E){const g=this.ab(h);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(E);return this.eb(g,D).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(w)})}async $acceptDebugSessionStarted(h){const E=await this.hb(h);this.n.fire(E.api)}async $acceptDebugSessionTerminated(h){const E=await this.hb(h);E&&(this.o.fire(E.api),this.m.delete(E.id))}async $acceptDebugSessionActiveChanged(h){this.u=h?await this.hb(h):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(h,E){(await this.hb(h))?._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(h,E){const D={session:(await this.hb(h)).api,event:E.event,body:E.body};this.w.fire(D)}Z(h){if(h instanceof y.$VN)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof y.$WN)return{type:"server",port:h.port,host:h.host};if(h instanceof y.$XN)return{type:"pipeServer",path:h.path};if(h instanceof y.$YN)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}$(h){const E=this.h.filter(g=>g.type===h);if(E.length>0)return E[0].factory}ab(h){const E=this.h.filter(g=>g.handle===h);if(E.length>0)return E[0].factory}bb(h){const E=this.f.filter(g=>g.handle===h);if(E.length>0)return E[0].provider}cb(h,E){if(h.contributes){const g=h.contributes.debuggers;if(g&&g.length>0){for(const D of g)if(D.label&&D.type&&D.type===E)return!0}}return!1}db(h){const g=h.configuration.type,D=this.k.filter(w=>w.type===g||w.type==="*").map(w=>(0,I.$ih)(()=>w.factory.createDebugAdapterTracker(h.api)).then(C=>C,C=>null));return Promise.race([Promise.all(D).then(w=>{const C=w.filter(P=>!!P);if(C.length>0)return new c(C)}),new Promise(w=>setTimeout(()=>w(void 0),1e3))]).catch(w=>{})}async eb(h,E){const g=E.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new y.$WN(g));if(h){const w=await this.O.getExtensionRegistry();return(0,I.$ih)(()=>h.createDebugAdapterDescriptor(E.api,this.fb(E,w))).then(C=>{if(C)return C})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(E,D))}fb(h,E){}gb(h,E,g){(h.length>0||E.length>0||g.length>0)&&this.A.fire(Object.freeze({added:h,removed:E,changed:g}))}async hb(h){if(h)if(typeof h=="string"){const E=this.m.get(h);if(E)return E}else{let E=this.m.get(h.id);if(!E){const g=await this.ib(h.folderUri),D=h.parent?this.m.get(h.parent):void 0;E=new i(this.l,h.id,h.type,h.name,g,h.configuration,D?.api),this.m.set(E.id,E),this.l.$sessionCached(E.id)}return E}throw new Error("cannot find session")}ib(h){if(h){const E=A.URI.revive(h);return this.N.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}jb(h,E){return`${h}\0${E}`}kb(h,E){if(E){if("title"in E&&"command"in E)return{type:0};if("treeId"in E)return{type:1,id:`${h}\0${E.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(h){const E=this.mb(h);let g,D;return"id"in E?D=r.ThemeIcon.asClassName(E):g=E,{iconPath:g,iconClass:D}}mb(h){if(h instanceof y.$NN)return{id:h.id};const E=typeof h=="object"&&"dark"in h?h.dark:h,g=typeof h=="object"&&"light"in h?h.light:h;return{dark:typeof E=="string"?A.URI.file(E):E,light:typeof g=="string"?A.URI.file(g):g}}};e.$llc=d,e.$llc=d=Je([Ve(0,T.$cP),Ve(1,l.$Bkc),Ve(2,k.$flc),Ve(3,s.$Ekc),Ve(4,$.$Qkc),Ve(5,o.$ilc),Ve(6,t.$yP)],d);class i{constructor(h,E,g,D,w,C,P){this.f=h,this.g=E,this.h=g,this.j=D,this.k=w,this.l=C,this.m=P}get api(){const h=this;return this.d??=Object.freeze({id:h.g,type:h.h,get name(){return h.j},set name(E){h.j=E,h.f.$setDebugSessionName(h.g,E)},parentSession:h.m,workspaceFolder:h.k,configuration:h.l,customRequest(E,g){return h.f.$customDebugAdapterRequest(h.g,E,g)},getDebugProtocolBreakpoint(E){return h.f.$getDebugProtocolBreakpoint(h.g,E.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(h){this.j=h}get configuration(){return this.l}}e.$mlc=i;class b{constructor(h){this.value=Object.freeze({append(E){h.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.$nlc=b;class c{constructor(h){this.d=h}onWillStartSession(){this.d.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.d.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.d.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(h):void 0)}onWillStopSession(){this.d.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.d.forEach(E=>E.onError?E.onError(h):void 0)}onExit(h,E){this.d.forEach(g=>g.onExit?g.onExit(h,E):void 0)}}class f extends v.$Eob{constructor(h){super(),this.h=h,h.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.h.handleMessage(h)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let u=class extends d{constructor(h,E,g,D,w,C,P){super(h,E,g,D,w,C,P)}};e.$olc=u,e.$olc=u=Je([Ve(0,T.$cP),Ve(1,l.$Bkc),Ve(2,k.$flc),Ve(3,s.$Ekc),Ve(4,$.$Qkc),Ve(5,o.$ilc),Ve(6,t.$yP)],u)}),define(Ae[295],Re([1,0,14,89,2,4,244,13,55,71,27,192,16,60,39,62]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0;class o{static async installEarlyHandler(t){Error.stackTraceLimit=100;const a=t.get(p.$Wj),i=t.get(l.$cP).getProxy(O.$PM.MainThreadErrors);I.setUnexpectedErrorHandler(b=>{a.error(b);const c=I.$3(b);i.$onUnexpectedError(c)})}static async installFullHandler(t){const a=t.get(p.$Wj),d=t.get(l.$cP),i=t.get(m.$flc),b=t.get(s.$wP),c=d.getProxy(O.$PM.MainThreadExtensionService),f=d.getProxy(O.$PM.MainThreadErrors),u=await i.getExtensionPathIndex(),S=new WeakMap;function h(D,w){if(S.has(D))return S.get(D).stack;let C="",P,V;for(const q of w)C+=`
	at ${q.toString()}`,V=q.getFileName(),!P&&V&&(P=u.findSubstr(A.URI.file(V)));const W=`${D.name||"Error"}: ${D.message||""}${C}`;return S.set(D,{extensionIdentifier:P?.identifier,stack:W}),W}const E=Symbol("prepareStackTrace wrapped");let g=h;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(D){if(D===h||!D||D[E]){g=D||h;return}g=function(w,C){return h(w,C),D.call(Error,w,C)},Object.assign(g,{[E]:!0})}}),I.setUnexpectedErrorHandler(D=>{a.error(D);const w=I.$3(D),C=S.get(D);if(!C?.extensionIdentifier){f.$onUnexpectedError(w);return}c.$onExtensionRuntimeError(C.extensionIdentifier,w);const P=b.onExtensionError(C.extensionIdentifier,D);a.trace("forwarded error to extension?",P,C)})}}e.$rmc=o;class n{constructor(t,a,d,i,b){this.a=d,this.b=new M.$Z$b(t,null,i),a=n.e(a,this.b);const c=new k.$oi(...(0,$.$ps)());c.set(T.$sP,{_serviceBrand:void 0,...a,messagePorts:b}),c.set(l.$cP,new l.$dP(this.b)),c.set(v.$ykc,new v.$zkc(i)),c.set(m.$dlc,d);const f=new y.$7q(c,!0);f.invokeFunction(o.installEarlyHandler),this.d=f.invokeFunction(u=>u.get(p.$Wj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=f.invokeFunction(u=>u.get(m.$flc)),this.c.initialize(),f.invokeFunction(o.installFullHandler)}async asBrowserUri(t){const a=this.b.getProxy(O.$PM.MainThreadExtensionService);return A.URI.revive(await a.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,a){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=A.URI.revive(a.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=A.URI.revive(a.transformIncomingURIs(t.environment.appRoot));const d=t.environment.extensionDevelopmentLocationURI;return d&&(t.environment.extensionDevelopmentLocationURI=d.map(i=>A.URI.revive(a.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=A.URI.revive(a.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=A.URI.revive(a.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=A.URI.revive(a.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=A.URI.revive(a.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=A.URI.revive(a.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=A.URI.revive(a.transformIncomingURIs(t.logsLocation)),t.workspace=a.transformIncomingURIs(t.workspace),t}}e.$smc=n}),define(Ae[296],Re([1,0,18,11,22,43,12,19,24,2,46]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Dlc=e.$Clc=void 0,e.$Elc=s;class y{constructor(r,t,a){this.d=r,this.e=t,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(r,t){const a=this.g.folderQueries||[],d=new A.$me(t);return new Promise((i,b)=>{this.a=new v(r);let c=!1;const f=(u,S)=>{if(!c&&!this.b){const h=this.h(u);s(u)&&typeof this.g.maxResults=="number"&&this.c+h>this.g.maxResults&&(this.b=!0,c=!0,d.cancel(),u=this.j(u,this.g.maxResults-this.c));const E=this.h(u);this.c+=E,(E>0||!s(u))&&this.a.add(u,S)}};Promise.all(a.map((u,S)=>this.k(u,h=>f(h,S),d.token))).then(u=>{d.dispose(),this.a.flush();const S=u.some(h=>!!h&&!!h.limitHit);i({limitHit:this.b||S,messages:(0,I.$Rb)(u.map(h=>h?.message?Array.isArray(h.message)?h.message:[h.message]:[])),stats:{type:this.f}})},u=>{d.dispose();const S=(0,O.$bj)(u);b(new Error(S))})})}h(r){return s(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,t){const a=Array.isArray(r.ranges)?r.ranges:[r.ranges],d=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:a.slice(0,t),preview:{matches:d.slice(0,t),text:r.preview.text},uri:r.uri}}async k(r,t,a){const d=new T.$kL(this.g,r),i=[],b={report:u=>{if(!this.l(u))return;const S=r.folder.scheme===M.Schemas.file?(0,T.$lL)(()=>this.e.readdir($.$3g(u.uri))):void 0,h=$.$6g(r.folder,u.uri);if(h){const E=d.includedInQuery(h,p.$oc(h),S);(0,N.$ch)(E)?i.push(E.then(g=>{g&&t(u)})):E&&t(u)}}},c=this.n(r);let f;return this.d.query.type===3?f=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,b,a):f=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),c,b,a),i.length&&await Promise.all(i),f}l(r){if(s(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const t=(0,T.$jL)(this.g.includePattern,r.includePattern),a=(0,T.$jL)(this.g.excludePattern,r.excludePattern),d={folder:k.URI.from(r.folder),excludes:a,includes:t,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.e.toCanonicalName(r.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(d.usePCRE2=this.g.usePCRE2),d}}e.$Clc=y;function l(n){return{isCaseSensitive:n.isCaseSensitive||!1,isRegExp:n.isRegExp||!1,isWordMatch:n.isWordMatch||!1,isMultiline:n.isMultiline||!1,pattern:n.pattern}}class v{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new o(512,t=>this.g(t))}add(r,t){this.d&&(this.b!==t||!$.$Wg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:r.uri,results:[]}),this.d.results.push(m(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$Dlc=v;function m(n){return s(n)?{preview:{matches:(0,I.$2b)(n.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:n.preview.text},ranges:(0,I.$2b)(n.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:n.text,lineNumber:n.lineNumber}}function s(n){return!!n.preview}class o{static{this.a=4e3}static{this.b=50}constructor(r,t){this.g=r,this.h=t,this.c=0,this.d=[],this.e=0}addItem(r,t){r&&this.j(r,t)}addItems(r,t){r&&this.k(r,t)}j(r,t){this.d.push(r),this.e+=t,this.l()}k(r,t){this.d=this.d.concat(r),this.e+=t,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Flc=o}),define(Ae[122],Re([1,0,6,4,3,291,16,60,13,2,296]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=e.$Glc=void 0,e.$Ilc=l,e.$Glc=(0,A.$qi)("IExtHostSearch");let y=class{constructor(s,o,n){this.n=s,this.o=o,this.q=n,this.c=this.n.getProxy(N.$PM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Blc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const n=this.d++;return this.e.set(n,o),this.c.$registerTextSearchProvider(n,this.s(s)),(0,I.$Sc)(()=>{this.g.delete(s),this.e.delete(n),this.c.$unregisterProvider(n)})}registerAITextSearchProvider(s,o){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const n=this.d++;return this.h.set(n,o),this.c.$registerAITextSearchProvider(n,this.s(s)),(0,I.$Sc)(()=>{this.i.delete(s),this.h.delete(n),this.c.$unregisterProvider(n)})}registerFileSearchProvider(s,o){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const n=this.d++;return this.j.set(n,o),this.c.$registerFileSearchProvider(n,this.s(s)),(0,I.$Sc)(()=>{this.k.delete(s),this.j.delete(n),this.c.$unregisterProvider(n)})}$provideFileSearchResults(s,o,n,r){const t=l(n),a=this.j.get(s);if(a)return this.l.fileSearch(t,a,d=>{this.c.$handleFileMatch(s,o,d.map(i=>i.resource))},r);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,o,n){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,n,r){const t=this.e.get(s);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const a=l(n);return this.t(a,t).search(i=>this.c.$handleTextMatch(s,o,i),r)}$provideAITextSearchResults(s,o,n,r){const t=this.h.get(s);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const a=l(n);return this.v(a,t).search(i=>this.c.$handleTextMatch(s,o,i),r)}$enableExtensionHostSearch(){}t(s,o){return new T.$Clc({query:s,provider:o},{readdir:n=>Promise.resolve([]),toCanonicalName:n=>n},"textSearchProvider")}v(s,o){return new T.$Clc({query:s,provider:o},{readdir:n=>Promise.resolve([]),toCanonicalName:n=>n},"aiTextSearchProvider")}};e.$Hlc=y,e.$Hlc=y=Je([Ve(0,M.$cP),Ve(1,p.$ykc),Ve(2,$.$Wj)],y);function l(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(s=>k.URI.revive(s))}}function v(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(Ae[297],Re([1,0,22,14,5,6,12,33,2,151,147,135,94,20,44,13,58,59,205,4,247,275,78,84,252,253,254,233,222,32,255,38,256,121,110,257,235,248,258,259,67,66,249,39,261,64,262,45,27,276,277,236,263,88,264,79,80,238,290,266,209,267,278,268,116,239,269,270,271,16,272,122,81,273,240,274,82,85,119,62,51,114,279,280,250,281,282,86,8,7,241,60,242,63,283,284,109,37,217,77,25,118]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a,d,i,b,c,f,u,S,h,E,g,D,w,C,P,V,W,q,R,U,K,se,ce,ve,Ie,ue,be,ie,Pe,Fe,ne,j,x,pe,Oe,ke,$e,ge,J,Y,he,le,Ne,de,Ce,Me,ze,z,L,G,H,ee,re,Te,Be,Qe,_e,et,tt,it,nt,at,mt,je,st,X,Z,me,He,ye,ot,dt,It,Qt,Ut,xt,_t,Pt,Vt,Zt,Xe,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=Xt;function Xt(lt){const vt=lt.get(Pe.$sP),ti=lt.get(ie.$jkc),Yt=lt.get(ue.$Gkc),Lt=lt.get(ve.$flc),ft=lt.get(Pt.$Bkc),jt=lt.get(it.$wP),Bt=lt.get(D.$Ekc),qt=lt.get(dt.$ykc),Ge=lt.get(G.$cP),ui=lt.get(_e.$Zkc),Ht=lt.get(et.$Hkc),zt=lt.get(s.$Xj),gt=lt.get(s.$Wj),Tt=lt.get(me.$ACb),At=lt.get(i.$fkc),Ot=lt.get(_t.$lmc),ii=lt.get(re.$0kc),Gt=lt.get(se.$Qkc),ni=lt.get($e.$blc),Mt=lt.get(b.$pkc),Nt=lt.get(pe.$7kc);Ge.set(t.$QM.ExtHostFileSystemInfo,ti),Ge.set(t.$QM.ExtHostLogLevelServiceShape,zt),Ge.set(t.$QM.ExtHostWorkspace,ft),Ge.set(t.$QM.ExtHostConfiguration,Bt),Ge.set(t.$QM.ExtHostExtensionService,Lt),Ge.set(t.$QM.ExtHostStorage,ui),Ge.set(t.$QM.ExtHostTunnelService,Tt),Ge.set(t.$QM.ExtHostWindow,Ot),Ge.set(t.$QM.ExtHostSecretState,ii),Ge.set(t.$QM.ExtHostTelemetry,jt),Ge.set(t.$QM.ExtHostEditorTabs,Gt),Ge.set(t.$QM.ExtHostManagedSockets,ni),Ge.set(t.$QM.ExtHostAuthentication,Mt),Ge.set(t.$QM.ExtHostChatProvider,Nt);const Ct=Ge.set(t.$QM.ExtHostDecorations,lt.get(P.$qlc)),Et=Ge.set(t.$QM.ExtHostDocumentsAndEditors,lt.get(K.$nP)),pt=Ge.set(t.$QM.ExtHostCommands,lt.get(E.$yP)),St=Ge.set(t.$QM.ExtHostTerminalService,lt.get(nt.$3kc)),li=Ge.set(t.$QM.ExtHostTerminalShellIntegration,lt.get(at.$0lc)),Dt=Ge.set(t.$QM.ExtHostDebugService,lt.get(C.$klc)),hi=Ge.set(t.$QM.ExtHostSearch,lt.get(ee.$Glc)),Kt=Ge.set(t.$QM.ExtHostTask,lt.get(tt.$9lc)),vi=Ge.set(t.$QM.ExtHostOutputService,lt.get(Ce.$Vlc)),ei=Ge.set(t.$QM.ExtHostLocalization,lt.get(ke.$alc)),wi=Ge.set(t.$QM.ExtHostUrls,new It.$imc(Ge)),yt=Ge.set(t.$QM.ExtHostDocuments,new U.$mkc(Ge,Et)),$i=Ge.set(t.$QM.ExtHostDocumentContentProviders,new q.$slc(Ge,Et,gt)),we=Ge.set(t.$QM.ExtHostDocumentSaveParticipant,new R.$tlc(gt,yt,Ge.getProxy(t.$PM.MainThreadBulkEdits))),Se=Ge.set(t.$QM.ExtHostNotebook,new J.$Jlc(Ge,pt,Et,yt,Yt,hi)),ae=Ge.set(t.$QM.ExtHostNotebookDocuments,new he.$Plc(Se)),Q=Ge.set(t.$QM.ExtHostNotebookEditors,new le.$Qlc(gt,Se)),De=Ge.set(t.$QM.ExtHostNotebookKernels,new Ne.$Rlc(Ge,vt,Se,pt,gt)),We=Ge.set(t.$QM.ExtHostNotebookRenderers,new de.$Tlc(Ge,Se)),Ze=Ge.set(t.$QM.ExtHostNotebookDocumentSaveParticipant,new Y.$Olc(gt,Se,Ge.getProxy(t.$PM.MainThreadBulkEdits))),qe=Ge.set(t.$QM.ExtHostEditors,new je.$vkc(Ge,Et)),ut=Ge.set(t.$QM.ExtHostTreeViews,new Z.$gmc(Ge.getProxy(t.$PM.MainThreadTreeViews),pt,gt)),kt=Ge.set(t.$QM.ExtHostEditorInsets,new h.$wkc(Ge.getProxy(t.$PM.MainThreadEditorInsets),qe,vt.remote)),Ft=Ge.set(t.$QM.ExtHostDiagnostics,new V.$lkc(Ge,gt,ti,Et)),Wt=Ge.set(t.$QM.ExtHostLanguages,new Oe.$Mlc(Ge,yt,pt.converter,qt)),ct=Ge.set(t.$QM.ExtHostLanguageFeatures,new x.$nkc(Ge,qt,yt,pt,Ft,gt,At,jt)),ri=Ge.set(t.$QM.ExtHostFileSystem,new Ie.$vlc(Ge,ct)),di=Ge.set(t.$QM.ExtHostFileSystemEventService,new be.$wlc(Ge,gt,Et)),pi=Ge.set(t.$QM.ExtHostQuickOpen,(0,L.$Zlc)(Ge,ft,pt)),Si=Ge.set(t.$QM.ExtHostSCM,new H.$2lc(Ge,pt,yt,gt)),Ri=Ge.set(t.$QM.ExtHostQuickDiff,new z.$Ylc(Ge,qt)),Mi=Ge.set(t.$QM.ExtHostShare,new Te.$3lc(Ge,qt)),Ni=Ge.set(t.$QM.ExtHostComments,(0,g.$xkc)(Ge,pt,yt)),Ti=Ge.set(t.$QM.ExtHostProgress,new ze.$Xlc(Ge.getProxy(t.$PM.MainThreadProgress))),cn=Ge.set(t.$QM.ExtHostLabelService,new j.$Llc(Ge)),Oi=Ge.set(t.$QM.ExtHostTheming,new st.$dmc(Ge)),Fi=Ge.set(t.$QM.ExtHostTimeline,new X.$fmc(Ge,pt)),yi=Ge.set(t.$QM.ExtHostWebviews,new Qt.$Lkc(Ge,vt.remote,ft,gt,At)),Ii=Ge.set(t.$QM.ExtHostWebviewPanels,new Ut.$Okc(Ge,yi,ft)),Gi=Ge.set(t.$QM.ExtHostCustomEditors,new w.$Pkc(Ge,yt,Ht,yi,Ii)),Ki=Ge.set(t.$QM.ExtHostWebviewViews,new xt.$jmc(Ge,yi)),bi=Ge.set(t.$QM.ExtHostTesting,new mt.$_lc(Ge,gt,pt,Et)),Ji=Ge.set(t.$QM.ExtHostUriOpeners,new ot.$hmc(Ge)),Qi=Ge.set(t.$QM.ExtHostProfileContentHandlers,new Me.$Wlc(Ge));Ge.set(t.$QM.ExtHostInteractive,new ne.$Klc(Ge,Se,Et,pt,gt));const un=Ge.set(t.$QM.ExtHostInlineChat,new Fe.$xlc(Ge,pt,yt,gt)),Li=Ge.set(t.$QM.ExtHostChatAgents2,new f.$skc(Ge,gt,pt)),zi=Ge.set(t.$QM.ExtHostChatVariables,new u.$tkc(Ge)),Pi=Ge.set(t.$QM.ExtHostAiRelatedInformation,new a.$ekc(Ge)),ln=Ge.set(t.$QM.ExtHostAiEmbeddingVector,new ce.$ulc(Ge)),Zi=Ge.set(t.$QM.ExtHostStatusBar,new Qe.$6lc(Ge,pt.converter)),Xi=Ge.set(t.$QM.ExtHostSpeech,new Be.$4lc(Ge)),hn=Object.values(t.$QM);Ge.assertRegistered(hn);const Ui=new c.$rkc(Ge,Et),Yi=new S.$ukc(Ge),Ci=new ge.$Nlc(Ge,gt),ji=new W.$rlc(Ge);return d.$okc.register(pt),function(Ue,oi,Bi){function xe(_){return(oe,Le,rt)=>{const wt=_(Rt=>{try{oe.call(Le,Rt)}catch(Di){N.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Di.toString()}`,{cause:Di})),jt.onExtensionError(Ue.identifier,Di)}});return rt?.push(wt),wt}}const bt=function(){let _=!Ue.isUnderDevelopment;function oe(){_||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")oe();else{const wt=rt;typeof wt.scheme>"u"&&oe(),typeof wt.exclusive=="boolean"&&(0,Xe.$yG)(Ue,"documentFiltersExclusive")}return rt}}(),dn={getSession(_,oe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Xe.$yG)(Ue,"authLearnMore"),Mt.getSession(Ue,_,oe,Le)},getSessions(_,oe){return(0,Xe.$yG)(Ue,"authGetSessions"),Mt.getSessions(Ue,_,oe)},async hasSession(_,oe){return(0,Xe.$yG)(Ue,"authSession"),!!await Mt.getSession(Ue,_,oe,{silent:!0})},get onDidChangeSessions(){return xe(Mt.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Le,rt){return Mt.registerAuthenticationProvider(_,oe,Le,rt)}},ai={registerCommand(_,oe,Le){return pt.registerCommand(!0,_,oe,Le,void 0,Ue)},registerTextEditorCommand(_,oe,Le){return pt.registerCommand(!0,_,(...rt)=>{const wt=qe.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return wt.edit(Rt=>{oe.apply(Le,[wt,Rt,...rt])}).then(Rt=>{Rt||gt.warn("Edits from command "+_+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+_,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(_,oe,Le)=>((0,Xe.$yG)(Ue,"diffCommand"),pt.registerCommand(!0,_,async(...rt)=>{const wt=Et.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Rt=await qe.getDiffInformation(wt.id);oe.apply(Le,[Rt,...rt])},void 0,void 0,Ue)),executeCommand(_,...oe){return pt.executeCommand(_,...oe)},getCommands(_=!1){return pt.getCommands(_)}},ki={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return xe(St.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return xe(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$yG)(Ue,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$yG)(Ue,"telemetry"),xe(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$vP)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return it.$uP.validateSender(_),jt.instantiateLogger(Ue,_,oe)},openExternal(_,oe){return Ot.openUri(_,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===vt.environment.appUriScheme)return wi.createAppUri(_);try{return await Ot.asExternalUri(_,{allowTunneling:!!vt.remote.authority})}catch(oe){if((0,M.$zg)(_,M.Schemas.http)||(0,M.$zg)(_,M.Schemas.https))return _;throw oe}},get remoteName(){return(0,o.$Cm)(vt.remote.authority)},get remoteAuthority(){return(0,Xe.$yG)(Ue,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return xe(gt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$yG)(Ue,"resolvers"),vt.quality},get appCommit(){return(0,Xe.$yG)(Ue,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(ki);const xi={createTestController(_,oe,Le){return bi.createTestController(Ue,_,oe,Le)},createTestObserver(){return(0,Xe.$yG)(Ue,"testObserver"),bi.createTestObserver()},runTests(_){return(0,Xe.$yG)(Ue,"testObserver"),bi.runTests(_)},get onDidChangeTestResults(){return(0,Xe.$yG)(Ue,"testObserver"),xe(bi.onResultsChanged)},get testResults(){return(0,Xe.$yG)(Ue,"testObserver"),bi.results}},Ei=vt.remote.isRemote?ye.ExtensionKind.Workspace:ye.ExtensionKind.UI,_i={getExtension(_,oe){(0,Xe.$xG)(Ue,"extensionsAny")||(oe=!1);const Le=oi.mine.getExtensionDescription(_);if(Le)return new ve.$glc(Lt,Ue.identifier,Le,Ei,!1);if(oe){const rt=oi.all.getExtensionDescription(_);if(rt)return new ve.$glc(Lt,Ue.identifier,rt,Ei,!0)}},get all(){const _=[];for(const oe of oi.mine.getAllExtensionDescriptions())_.push(new ve.$glc(Lt,Ue.identifier,oe,Ei,!1));return _},get allAcrossExtensionHosts(){(0,Xe.$yG)(Ue,"extensionsAny");const _=new v.$Mm(oi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),oe=[];for(const Le of oi.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);oe.push(new ve.$glc(Lt,Ue.identifier,Le,Ei,rt))}return oe},get onDidChange(){return(0,Xe.$xG)(Ue,"extensionsAny")?xe(A.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):xe(oi.mine.onDidChange)}},en={createDiagnosticCollection(_){return Ft.createDiagnosticCollection(Ue.identifier,_)},get onDidChangeDiagnostics(){return xe(Ft.onDidChangeDiagnostics)},getDiagnostics:_=>Ft.getDiagnostics(_),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(_,oe){return Wt.changeLanguage(_.uri,oe)},match(_,oe){const Le=He.LanguageSelector.from(_);let rt;return(0,T.$Vt)(Le)&&(rt=Se.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Rt=>Rt.document===oe))?.apiNotebook),(0,T.$Ut)(Le,oe.uri,oe.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,oe,Le){return ct.registerCodeActionProvider(Ue,bt(_),oe,Le)},registerDocumentPasteEditProvider(_,oe,Le){return(0,Xe.$yG)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,bt(_),oe,Le)},registerCodeLensProvider(_,oe){return ct.registerCodeLensProvider(Ue,bt(_),oe)},registerDefinitionProvider(_,oe){return ct.registerDefinitionProvider(Ue,bt(_),oe)},registerDeclarationProvider(_,oe){return ct.registerDeclarationProvider(Ue,bt(_),oe)},registerImplementationProvider(_,oe){return ct.registerImplementationProvider(Ue,bt(_),oe)},registerTypeDefinitionProvider(_,oe){return ct.registerTypeDefinitionProvider(Ue,bt(_),oe)},registerHoverProvider(_,oe){return ct.registerHoverProvider(Ue,bt(_),oe,Ue.identifier)},registerEvaluatableExpressionProvider(_,oe){return ct.registerEvaluatableExpressionProvider(Ue,bt(_),oe,Ue.identifier)},registerInlineValuesProvider(_,oe){return ct.registerInlineValuesProvider(Ue,bt(_),oe,Ue.identifier)},registerDocumentHighlightProvider(_,oe){return ct.registerDocumentHighlightProvider(Ue,bt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ct.registerMultiDocumentHighlightProvider(Ue,bt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ct.registerLinkedEditingRangeProvider(Ue,bt(_),oe)},registerReferenceProvider(_,oe){return ct.registerReferenceProvider(Ue,bt(_),oe)},registerRenameProvider(_,oe){return ct.registerRenameProvider(Ue,bt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Xe.$yG)(Ue,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(Ue,bt(_),oe)},registerDocumentSymbolProvider(_,oe,Le){return ct.registerDocumentSymbolProvider(Ue,bt(_),oe,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(Ue,_)},registerDocumentFormattingEditProvider(_,oe){return ct.registerDocumentFormattingEditProvider(Ue,bt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ct.registerDocumentRangeFormattingEditProvider(Ue,bt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Le,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,bt(_),oe,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,oe,Le){return ct.registerDocumentSemanticTokensProvider(Ue,bt(_),oe,Le)},registerDocumentRangeSemanticTokensProvider(_,oe,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ue,bt(_),oe,Le)},registerSignatureHelpProvider(_,oe,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ue,bt(_),oe,Le):ct.registerSignatureHelpProvider(Ue,bt(_),oe,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,oe,...Le){return ct.registerCompletionItemProvider(Ue,bt(_),oe,Le)},registerInlineCompletionItemProvider(_,oe,Le){return oe.handleDidShowCompletionItem&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),Le&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,bt(_),oe,Le)},registerInlineEditProvider(_,oe){return(0,Xe.$yG)(Ue,"inlineEdit"),ct.registerInlineEditProvider(Ue,bt(_),oe)},registerDocumentLinkProvider(_,oe){return ct.registerDocumentLinkProvider(Ue,bt(_),oe)},registerColorProvider(_,oe){return ct.registerColorProvider(Ue,bt(_),oe)},registerFoldingRangeProvider(_,oe){return ct.registerFoldingRangeProvider(Ue,bt(_),oe)},registerSelectionRangeProvider(_,oe){return ct.registerSelectionRangeProvider(Ue,_,oe)},registerCallHierarchyProvider(_,oe){return ct.registerCallHierarchyProvider(Ue,_,oe)},registerTypeHierarchyProvider(_,oe){return ct.registerTypeHierarchyProvider(Ue,_,oe)},setLanguageConfiguration:(_,oe)=>ct.setLanguageConfiguration(Ue,_,oe),getTokenInformationAtPosition(_,oe){return(0,Xe.$yG)(Ue,"tokenInformation"),Wt.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ct.registerInlayHintsProvider(Ue,_,oe)},createLanguageStatusItem(_,oe){return Wt.createLanguageStatusItem(Ue,_,oe)},registerDocumentDropEditProvider(_,oe,Le){return ct.registerDocumentOnDropEditProvider(Ue,_,oe,(0,Xe.$xG)(Ue,"documentPaste")?Le:void 0)}},fn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,oe,Le){$.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&At.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await($.URI.isUri(_)?Promise.resolve(Wi.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,oe,Le)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(Ue,_)},onDidChangeActiveTextEditor(_,oe,Le){return xe(qe.onDidChangeActiveTextEditor)(_,oe,Le)},onDidChangeVisibleTextEditors(_,oe,Le){return xe(qe.onDidChangeVisibleTextEditors)(_,oe,Le)},onDidChangeTextEditorSelection(_,oe,Le){return xe(qe.onDidChangeTextEditorSelection)(_,oe,Le)},onDidChangeTextEditorOptions(_,oe,Le){return xe(qe.onDidChangeTextEditorOptions)(_,oe,Le)},onDidChangeTextEditorVisibleRanges(_,oe,Le){return xe(qe.onDidChangeTextEditorVisibleRanges)(_,oe,Le)},onDidChangeTextEditorViewColumn(_,oe,Le){return xe(qe.onDidChangeTextEditorViewColumn)(_,oe,Le)},onDidCloseTerminal(_,oe,Le){return xe(St.onDidCloseTerminal)(_,oe,Le)},onDidOpenTerminal(_,oe,Le){return xe(St.onDidOpenTerminal)(_,oe,Le)},onDidChangeActiveTerminal(_,oe,Le){return xe(St.onDidChangeActiveTerminal)(_,oe,Le)},onDidChangeTerminalDimensions(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalDimensions"),xe(St.onDidChangeTerminalDimensions)(_,oe,Le)},onDidChangeTerminalState(_,oe,Le){return xe(St.onDidChangeTerminalState)(_,oe,Le)},onDidWriteTerminalData(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalDataWriteEvent"),xe(St.onDidWriteTerminalData)(_,oe,Le)},onDidExecuteTerminalCommand(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalExecuteCommandEvent"),xe(St.onDidExecuteTerminalCommand)(_,oe,Le)},onDidChangeTerminalShellIntegration(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),xe(li.onDidChangeTerminalShellIntegration)(_,oe,Le)},onDidStartTerminalShellExecution(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),xe(li.onDidStartTerminalShellExecution)(_,oe,Le)},onDidEndTerminalShellExecution(_,oe,Le){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),xe(li.onDidEndTerminalShellExecution)(_,oe,Le)},get state(){return Ot.getState(Ue)},onDidChangeWindowState(_,oe,Le){return xe(Ot.onDidChangeWindowState)(_,oe,Le)},showInformationMessage(_,...oe){return Ci.showMessage(Ue,p.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Ci.showMessage(Ue,p.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Ci.showMessage(Ue,p.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Le){return pi.showQuickPick(Ue,_,oe,Le)},showWorkspaceFolderPick(_){return pi.showWorkspaceFolderPick(_)},showInputBox(_,oe){return pi.showInput(_,oe)},showOpenDialog(_){return ji.showOpenDialog(Ue,_)},showSaveDialog(_){return ji.showSaveDialog(_)},createStatusBarItem(_,oe,Le){let rt,wt,Rt;return typeof _=="string"?(rt=_,wt=oe,Rt=Le):(wt=_,Rt=oe),Zi.createStatusBarEntry(Ue,rt,wt,Rt)},setStatusBarMessage(_,oe){return Zi.setStatusBarMessage(_,oe)},withScmProgress(_){return At.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ti.withProgress(Ue,{location:ye.ProgressLocation.SourceControl},(oe,Le)=>_({report(rt){}}))},withProgress(_,oe){return Ti.withProgress(Ue,_,oe)},createOutputChannel(_,oe){return vi.createOutputChannel(_,oe,Ue)},createWebviewPanel(_,oe,Le,rt){return Ii.createWebviewPanel(Ue,_,oe,Le,rt)},createWebviewTextEditorInset(_,oe,Le,rt){return(0,Xe.$yG)(Ue,"editorInsets"),kt.createWebviewEditorInset(_,oe,Le,rt,Ue)},createTerminal(_,oe,Le){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,oe,Le)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return St.registerProfileProvider(Ue,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Xe.$yG)(Ue,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,Ue.identifier.value,oe)},registerTreeDataProvider(_,oe){return ut.registerTreeDataProvider(_,oe,Ue)},createTreeView(_,oe){return ut.createTreeView(_,oe,Ue)},registerWebviewPanelSerializer:(_,oe)=>Ii.registerWebviewPanelSerializer(Ue,_,oe),registerCustomEditorProvider:(_,oe,Le={})=>Gi.registerCustomEditorProvider(Ue,_,oe,Le),registerFileDecorationProvider(_){return Ct.registerFileDecorationProvider(_,Ue)},registerUriHandler(_){return wi.registerUriHandler(Ue,_)},createQuickPick(){return pi.createQuickPick(Ue)},createInputBox(){return pi.createInputBox(Ue)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Le){return xe(Oi.onDidChangeActiveColorTheme)(_,oe,Le)},registerWebviewViewProvider(_,oe,Le){return Ki.registerWebviewViewProvider(Ue,_,oe,Le?.webviewOptions)},get activeNotebookEditor(){return Se.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Le){return xe(Se.onDidChangeActiveNotebookEditor)(_,oe,Le)},get visibleNotebookEditors(){return Se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return xe(Se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Le){return xe(Q.onDidChangeNotebookEditorSelection)(_,oe,Le)},onDidChangeNotebookEditorVisibleRanges(_,oe,Le){return xe(Q.onDidChangeNotebookEditorVisibleRanges)(_,oe,Le)},showNotebookDocument(_,oe){return Se.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Le){return(0,Xe.$yG)(Ue,"externalUriOpener"),Ji.registerExternalUriOpener(Ue.identifier,_,oe,Le)},registerProfileContentHandler(_,oe){return(0,Xe.$yG)(Ue,"profileContentHandlers"),Qi.registerProfileContentHandler(Ue,_,oe)},registerQuickDiffProvider(_,oe,Le,rt){return(0,Xe.$yG)(Ue,"quickDiffProvider"),Ri.registerQuickDiffProvider(bt(_),oe,Le,rt)},get tabGroups(){return Gt.tabGroups},registerShareProvider(_,oe){return(0,Xe.$yG)(Ue,"shareProvider"),Mi.registerShareProvider(bt(_),oe)}},Wi={get rootPath(){return At.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new N.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Le)=>ft.updateWorkspaceFolders(Ue,_,oe||0,...Le),onDidChangeWorkspaceFolders:function(_,oe,Le){return xe(ft.onDidChangeWorkspace)(_,oe,Le)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Le,rt)=>ft.findFiles(_,oe,Le,Ue.identifier,rt),findFiles2:(_,oe,Le)=>((0,Xe.$yG)(Ue,"findFiles2"),ft.findFiles2(_,oe,Ue.identifier,Le)),findTextInFiles:(_,oe,Le,rt)=>{(0,Xe.$yG)(Ue,"findTextInFiles");let wt,Rt;return typeof oe=="object"?(wt=oe,Rt=Le):(wt={},Rt=oe,rt=Le),ft.findTextInFiles(_,wt||{},Rt,Ue.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return Ui.applyWorkspaceEdit(_,Ue,oe)},createFileSystemWatcher:(_,oe,Le,rt)=>{let wt;return typeof oe=="boolean"?wt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:oe&&((0,Xe.$yG)(Ue,"createFileSystemWatcher"),wt={...oe,correlate:!0}),di.createFileSystemWatcher(ft,Ue,_,wt)},get textDocuments(){return yt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new N.$9("textDocuments")},openTextDocument(_){let oe;const Le=_;if(typeof _=="string")oe=Promise.resolve($.URI.file(_));else if($.URI.isUri(_))oe=Promise.resolve(_);else if(!Le||typeof Le=="object")oe=yt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&At.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),yt.ensureDocumentData(rt).then(wt=>wt.document)))},onDidOpenTextDocument:(_,oe,Le)=>xe(yt.onDidAddDocument)(_,oe,Le),onDidCloseTextDocument:(_,oe,Le)=>xe(yt.onDidRemoveDocument)(_,oe,Le),onDidChangeTextDocument:(_,oe,Le)=>xe(yt.onDidChangeDocument)(_,oe,Le),onDidSaveTextDocument:(_,oe,Le)=>xe(yt.onDidSaveDocument)(_,oe,Le),onWillSaveTextDocument:(_,oe,Le)=>xe(we.getOnWillSaveTextDocumentEvent(Ue))(_,oe,Le),get notebookDocuments(){return Se.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Le;if($.URI.isUri(_))Le=_,await Se.openNotebookDocument(_);else if(typeof _=="string")Le=$.URI.revive(await Se.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return Se.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,oe,Le){return xe(ae.onDidSaveNotebookDocument)(_,oe,Le)},onDidChangeNotebookDocument(_,oe,Le){return xe(ae.onDidChangeNotebookDocument)(_,oe,Le)},onWillSaveNotebookDocument(_,oe,Le){return xe(Ze.getOnWillSaveNotebookDocumentEvent(Ue))(_,oe,Le)},get onDidOpenNotebookDocument(){return xe(Se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return xe(Se.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Le,rt){return Se.registerNotebookSerializer(Ue,_,oe,Le,(0,Xe.$xG)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,oe,Le)=>xe(Bi.onDidChangeConfiguration)(_,oe,Le),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Bi.getConfiguration(_,oe,Ue)},registerTextDocumentContentProvider(_,oe){return $i.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(At.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Ue,_,oe)),registerFileSystemProvider(_,oe,Le){return(0,O.$Rc)(ri.registerFileSystemProvider(Ue,_,oe,Le),Yt.addFileSystemProvider(_,oe,Le))},get fs(){return Yt.value},registerFileSearchProvider:(_,oe)=>((0,Xe.$yG)(Ue,"fileSearchProvider"),hi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Xe.$yG)(Ue,"textSearchProvider"),hi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Xe.$yG)(Ue,"aiTextSearchProvider"),(0,Xe.$yG)(Ue,"textSearchProvider"),hi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Xe.$yG)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Xe.$yG)(Ue,"resolvers"),cn.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Xe.$yG)(Ue,"resolvers"),Lt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Le)=>xe(di.onDidCreateFile)(_,oe,Le),onDidDeleteFiles:(_,oe,Le)=>xe(di.onDidDeleteFile)(_,oe,Le),onDidRenameFiles:(_,oe,Le)=>xe(di.onDidRenameFile)(_,oe,Le),onWillCreateFiles:(_,oe,Le)=>xe(di.getOnWillCreateFileEvent(Ue))(_,oe,Le),onWillDeleteFiles:(_,oe,Le)=>xe(di.getOnWillDeleteFileEvent(Ue))(_,oe,Le),onWillRenameFiles:(_,oe,Le)=>xe(di.getOnWillRenameFileEvent(Ue))(_,oe,Le),openTunnel:_=>((0,Xe.$yG)(Ue,"tunnels"),Tt.openTunnel(Ue,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Xe.$yG)(Ue,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(_,oe,Le)=>((0,Xe.$yG)(Ue,"tunnels"),xe(Tt.onDidChangeTunnels)(_,oe,Le)),registerPortAttributesProvider:(_,oe)=>((0,Xe.$yG)(Ue,"portsAttributes"),Tt.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Xe.$yG)(Ue,"tunnelFactory"),Tt.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Xe.$yG)(Ue,"timeline"),Fi.registerTimelineProvider(_,oe,Ue.identifier,pt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Xe.$yG)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Le)=>xe(ft.onDidGrantWorkspaceTrust)(_,oe,Le),registerEditSessionIdentityProvider:(_,oe)=>((0,Xe.$yG)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Le)=>((0,Xe.$yG)(Ue,"editSessionIdentityProvider"),xe(ft.getOnWillCreateEditSessionIdentityEvent(Ue))(_,oe,Le)),registerCanonicalUriProvider:(_,oe)=>((0,Xe.$yG)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Le)=>((0,Xe.$yG)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Le))},tn={get inputBox(){return At.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(Ue)},createSourceControl(_,oe,Le){return Si.createSourceControl(Ue,_,oe,Le)}},gn={createCommentController(_,oe){return Ni.createCommentController(Ue,_,oe)}},mn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,Xe.$xG)(Ue,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Xe.$yG)(Ue,"debugVisualization"),Dt.registerDebugVisualizationProvider(Ue,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Xe.$yG)(Ue,"debugVisualization"),Dt.registerDebugVisualizationTree(Ue,_,oe)},onDidStartDebugSession(_,oe,Le){return xe(Dt.onDidStartDebugSession)(_,oe,Le)},onDidTerminateDebugSession(_,oe,Le){return xe(Dt.onDidTerminateDebugSession)(_,oe,Le)},onDidChangeActiveDebugSession(_,oe,Le){return xe(Dt.onDidChangeActiveDebugSession)(_,oe,Le)},onDidReceiveDebugSessionCustomEvent(_,oe,Le){return xe(Dt.onDidReceiveDebugSessionCustomEvent)(_,oe,Le)},onDidChangeBreakpoints(_,oe,Le){return xe(Dt.onDidChangeBreakpoints)(_,oe,Le)},onDidChangeActiveStackItem(_,oe,Le){return(0,Xe.$yG)(Ue,"debugFocus"),xe(Dt.onDidChangeActiveStackItem)(_,oe,Le)},registerDebugConfigurationProvider(_,oe,Le){return Dt.registerDebugConfigurationProvider(_,oe,Le||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return Dt.registerDebugAdapterDescriptorFactory(Ue,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return Dt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Dt.startDebugging(_,oe,{parentSession:Le}):Dt.startDebugging(_,oe,Le||{})},stopDebugging(_){return Dt.stopDebugging(_)},addBreakpoints(_){return Dt.addBreakpoints(_)},removeBreakpoints(_){return Dt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return Dt.asDebugSourceUri(_,oe)}},nn={registerTaskProvider:(_,oe)=>Kt.registerTaskProvider(Ue,_,oe),fetchTasks:_=>Kt.fetchTasks(_),executeTask:_=>Kt.executeTask(Ue,_),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(_,oe,Le)=>xe(Kt.onDidStartTask)(_,oe,Le),onDidEndTask:(_,oe,Le)=>xe(Kt.onDidEndTask)(_,oe,Le),onDidStartTaskProcess:(_,oe,Le)=>xe(Kt.onDidStartTaskProcess)(_,oe,Le),onDidEndTaskProcess:(_,oe,Le)=>xe(Kt.onDidEndTaskProcess)(_,oe,Le)},Vi={createNotebookController(_,oe,Le,rt,wt){return De.createNotebookController(Ue,_,oe,Le,rt,(0,Xe.$xG)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>Se.registerNotebookCellStatusBarItemProvider(Ue,_,oe),createRendererMessaging(_){return We.createRendererMessaging(Ue,_)},createNotebookControllerDetectionTask(_){return(0,Xe.$yG)(Ue,"notebookKernelSource"),De.createNotebookControllerDetectionTask(Ue,_)},registerKernelSourceActionProvider(_,oe){return(0,Xe.$yG)(Ue,"notebookKernelSource"),De.registerKernelSourceActionProvider(Ue,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Le){return(0,Xe.$yG)(Ue,"notebookCellExecutionState"),xe(De.onDidChangeNotebookCellExecutionState)(_,oe,Le)}},rn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ei.getMessage(Ue.identifier.value,{message:oe,args:Le})}return ei.getMessage(Ue.identifier.value,_[0])},get bundle(){return ei.getBundle(Ue.identifier.value)},get uri(){return ei.getBundleUri(Ue.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(_,oe){return(0,Xe.$yG)(Ue,"interactive"),un.registerProvider(Ue,_,oe)},transferActiveChat(_){return(0,Xe.$yG)(Ue,"interactive"),Li.transferActiveChat(_)}},on={getRelatedInformation(_,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),Pi.getRelatedInformation(Ue,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(Ue,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(Ue,_,oe)}},$n={registerChatResponseProvider(_,oe,Le){return(0,Xe.$yG)(Ue,"chatProvider"),Nt.registerLanguageModel(Ue,_,oe,Le)},registerChatVariableResolver(_,oe,Le){return(0,Xe.$yG)(Ue,"chatVariableResolver"),zi.registerVariableResolver(Ue,_,oe,Le)},registerMappedEditsProvider(_,oe){return(0,Xe.$yG)(Ue,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ue,_,oe)},createChatParticipant(_,oe){return(0,Xe.$yG)(Ue,"chatParticipant"),Li.createChatAgent(Ue,_,oe)},createDynamicChatParticipant(_,oe,Le,rt){return(0,Xe.$yG)(Ue,"chatParticipantAdditions"),Li.createDynamicChatAgent(Ue,_,oe,Le,rt)}},pn={get languageModels(){return(0,Xe.$yG)(Ue,"languageModels"),Nt.getLanguageModelIds()},onDidChangeLanguageModels:(_,oe,Le)=>((0,Xe.$yG)(Ue,"languageModels"),Nt.onDidChangeProviders(_,oe,Le)),sendChatRequest(_,oe,Le,rt){return(0,Xe.$yG)(Ue,"languageModels"),Nt.sendChatRequest(Ue,_,oe,Le,rt)}},an={registerSpeechProvider(_,oe){return(0,Xe.$yG)(Ue,"speech"),Xi.registerProvider(Ue.identifier,_,oe)}};return{version:vt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:ki,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:pn,notebooks:Vi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Wi,Breakpoint:ye.$RN,TerminalOutputAnchor:ye.TerminalOutputAnchor,ChatResultFeedbackKind:ye.ChatResultFeedbackKind,ChatVariableLevel:ye.ChatVariableLevel,ChatCompletionItem:ye.$MO,CallHierarchyIncomingCall:ye.$dN,CallHierarchyItem:ye.$cN,CallHierarchyOutgoingCall:ye.$eN,CancellationError:N.$5,CancellationTokenSource:I.$me,CandidatePortSource:t.CandidatePortSource,CodeAction:ye.$_M,CodeActionKind:ye.$aN,CodeActionTriggerKind:ye.CodeActionTriggerKind,CodeLens:ye.$fN,Color:ye.$sN,ColorInformation:ye.$tN,ColorPresentation:ye.$uN,ColorThemeKind:ye.ColorThemeKind,CommentMode:ye.CommentMode,CommentState:ye.CommentState,CommentThreadCollapsibleState:ye.CommentThreadCollapsibleState,CommentThreadState:ye.CommentThreadState,CommentThreadApplicability:ye.CommentThreadApplicability,CompletionItem:ye.$mN,CompletionItemKind:ye.CompletionItemKind,CompletionItemTag:ye.CompletionItemTag,CompletionList:ye.$nN,CompletionTriggerKind:ye.CompletionTriggerKind,ConfigurationTarget:ye.ConfigurationTarget,CustomExecution:ye.$CN,DebugAdapterExecutable:ye.$VN,DebugAdapterInlineImplementation:ye.$YN,DebugAdapterNamedPipeServer:ye.$XN,DebugAdapterServer:ye.$WN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ye.DebugConsoleMode,DebugVisualization:ye.$cO,DecorationRangeBehavior:ye.DecorationRangeBehavior,Diagnostic:ye.$6M,DiagnosticRelatedInformation:ye.$5M,DiagnosticSeverity:ye.DiagnosticSeverity,DiagnosticTag:ye.DiagnosticTag,Disposable:ye.$RM,DocumentHighlight:ye.$8M,DocumentHighlightKind:ye.DocumentHighlightKind,MultiDocumentHighlight:ye.$9M,DocumentLink:ye.$rN,DocumentSymbol:ye.$$M,EndOfLine:ye.EndOfLine,EnvironmentVariableMutatorType:ye.EnvironmentVariableMutatorType,EvaluatableExpression:ye.$2N,InlineValueText:ye.$3N,InlineValueVariableLookup:ye.$4N,InlineValueEvaluatableExpression:ye.$5N,InlineCompletionTriggerKind:ye.InlineCompletionTriggerKind,EventEmitter:A.$be,ExtensionKind:ye.ExtensionKind,ExtensionMode:ye.ExtensionMode,ExternalUriOpenerPriority:ye.ExternalUriOpenerPriority,FileChangeType:ye.FileChangeType,FileDecoration:ye.$eO,FileDecoration2:ye.$eO,FileSystemError:ye.$8N,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:ye.$9N,FoldingRangeKind:ye.FoldingRangeKind,FunctionBreakpoint:ye.$TN,InlineCompletionItem:ye.$oN,InlineCompletionList:ye.$pN,Hover:ye.$7M,IndentAction:y.IndentAction,Location:ye.$4M,MarkdownString:ye.$gN,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:ye.$hN,PortAutoForwardAction:ye.PortAutoForwardAction,Position:ye.$SM,ProcessExecution:ye.$AN,ProgressLocation:ye.ProgressLocation,QuickInputButtons:ye.$dO,Range:ye.$TM,RelativePattern:ye.$PN,Selection:ye.$UM,SelectionRange:ye.$bN,SemanticTokens:ye.$_N,SemanticTokensBuilder:ye.$$N,SemanticTokensEdit:ye.$aO,SemanticTokensEdits:ye.$bO,SemanticTokensLegend:ye.$0N,ShellExecution:ye.$BN,ShellQuoting:ye.ShellQuoting,SignatureHelp:ye.$jN,SignatureHelpTriggerKind:ye.SignatureHelpTriggerKind,SignatureInformation:ye.$iN,SnippetString:ye.$3M,SourceBreakpoint:ye.$SN,StandardTokenType:ye.StandardTokenType,StatusBarAlignment:ye.StatusBarAlignment,SymbolInformation:ye.$0M,SymbolKind:ye.SymbolKind,SymbolTag:ye.SymbolTag,Task:ye.$DN,TaskGroup:ye.$zN,TaskPanelKind:ye.TaskPanelKind,TaskRevealKind:ye.TaskRevealKind,TaskScope:ye.TaskScope,TerminalLink:ye.$vN,TerminalQuickFixTerminalCommand:ye.$xN,TerminalQuickFixOpener:ye.$wN,TerminalLocation:ye.TerminalLocation,TerminalProfile:ye.$yN,TerminalExitReason:ye.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:ye.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:ye.TextDocumentSaveReason,TextEdit:ye.$YM,SnippetTextEdit:ye.$1M,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:ye.TextEditorLineNumbersStyle,TextEditorRevealType:ye.TextEditorRevealType,TextEditorSelectionChangeKind:ye.TextEditorSelectionChangeKind,SyntaxTokenType:ye.SyntaxTokenType,TextDocumentChangeReason:ye.TextDocumentChangeReason,ThemeColor:ye.$ON,ThemeIcon:ye.$NN,TreeItem:ye.$EN,TreeItemCheckboxState:ye.TreeItemCheckboxState,TreeItemCollapsibleState:ye.TreeItemCollapsibleState,TypeHierarchyItem:ye.$AO,UIKind:Zt.UIKind,Uri:$.URI,ViewColumn:ye.ViewColumn,WorkspaceEdit:ye.$2M,DocumentPasteTriggerKind:ye.DocumentPasteTriggerKind,DocumentDropEdit:ye.$KN,DocumentDropOrPasteEditKind:ye.$LN,DocumentPasteEdit:ye.$MN,InlayHint:ye.$lN,InlayHintLabelPart:ye.$kN,InlayHintKind:ye.InlayHintKind,RemoteAuthorityResolverError:ye.$XM,ResolvedAuthority:ye.$VM,ManagedResolvedAuthority:ye.$WM,SourceControlInputBoxValidationType:ye.SourceControlInputBoxValidationType,ExtensionRuntime:ye.ExtensionRuntime,TimelineItem:ye.$oO,NotebookRange:ye.$gO,NotebookCellKind:ye.NotebookCellKind,NotebookCellExecutionState:ye.NotebookCellExecutionState,NotebookCellData:ye.$hO,NotebookData:ye.$iO,NotebookRendererScript:ye.$mO,NotebookCellStatusBarAlignment:ye.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ye.NotebookEditorRevealType,NotebookCellOutput:ye.$kO,NotebookCellOutputItem:ye.$jO,NotebookCellStatusBarItem:ye.$lO,NotebookControllerAffinity:ye.NotebookControllerAffinity,NotebookControllerAffinity2:ye.NotebookControllerAffinity2,NotebookEdit:ye.$ZM,NotebookKernelSourceAction:ye.$nO,NotebookVariablesRequestKind:ye.NotebookVariablesRequestKind,PortAttributes:ye.$qO,LinkedEditingRanges:ye.$pO,TestResultState:ye.TestResultState,TestRunRequest:ye.$rO,TestMessage:ye.$sO,TestTag:ye.$tO,TestRunProfileKind:ye.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:ye.$JN,DataTransferItem:ye.$FN,TestCoverageCount:ye.$uO,FileCoverage:ye.$wO,StatementCoverage:ye.$xO,BranchCoverage:ye.$yO,DeclarationCoverage:ye.$zO,WorkspaceTrustState:ye.WorkspaceTrustState,LanguageStatusSeverity:ye.LanguageStatusSeverity,QuickPickItemKind:ye.QuickPickItemKind,InputBoxValidationSeverity:ye.InputBoxValidationSeverity,TabInputText:ye.$BO,TabInputTextDiff:ye.$CO,TabInputTextMerge:ye.$DO,TabInputCustom:ye.$EO,TabInputNotebook:ye.$GO,TabInputNotebookDiff:ye.$HO,TabInputWebview:ye.$FO,TabInputTerminal:ye.$IO,TabInputInteractiveWindow:ye.$JO,TabInputChat:ye.$KO,TabInputTextMultiDiff:ye.$LO,TelemetryTrustedValue:n.$_o,LogLevel:s.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ye.InteractiveSessionVoteDirection,ChatCopyKind:ye.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ye.InteractiveEditorResponseFeedbackKind,StackFrame:ye.$ZN,Thread:ye.$1N,RelatedInformationType:ye.RelatedInformationType,SpeechToTextStatus:ye.SpeechToTextStatus,PartialAcceptTriggerKind:ye.PartialAcceptTriggerKind,KeywordRecognitionStatus:ye.KeywordRecognitionStatus,ChatResponseMarkdownPart:ye.$NO,ChatResponseFileTreePart:ye.$QO,ChatResponseAnchorPart:ye.$RO,ChatResponseProgressPart:ye.$SO,ChatResponseReferencePart:ye.$UO,ChatResponseTextEditPart:ye.$VO,ChatResponseMarkdownWithVulnerabilitiesPart:ye.$OO,ChatResponseCommandButtonPart:ye.$TO,ChatResponseDetectedParticipantPart:ye.$PO,ChatRequestTurn:ye.$WO,ChatResponseTurn:ye.$XO,ChatLocation:ye.ChatLocation,LanguageModelChatSystemMessage:ye.$YO,LanguageModelChatUserMessage:ye.$ZO,LanguageModelChatAssistantMessage:ye.$1O,LanguageModelSystemMessage:ye.$YO,LanguageModelUserMessage:ye.$ZO,LanguageModelAssistantMessage:ye.$1O,LanguageModelError:ye.$2O,NewSymbolName:ye.$7N,NewSymbolNameTag:ye.NewSymbolNameTag,InlineEdit:ye.$3O,InlineEditTriggerKind:ye.InlineEditTriggerKind}}}}),define(Ae[298],Re([1,0,55,116,37,110,38,32,67,51,119,121,122,82,86,78,109,64,45,81,62,66,237,13,120,79,80,84,88,114]),function(fe,e,I,N,A,O,M,p,$,k,T,y,l,v,m,s,o,n,r,t,a,d,i,b,c,f,u,S,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$os)(f.$alc,f.$_kc,1),(0,I.$os)(b.$Xj,i.$nmc,1),(0,I.$os)(s.$fkc,s.$gkc,1),(0,I.$os)(p.$yP,p.$xP,0),(0,I.$os)(S.$pkc,S.$qkc,0),(0,I.$os)(h.$7kc,h.$8kc,0),(0,I.$os)(M.$Ekc,M.$Ckc,0),(0,I.$os)(n.$Gkc,n.$Fkc,0),(0,I.$os)(y.$klc,y.$olc,0),(0,I.$os)(O.$qlc,O.$plc,0),(0,I.$os)($.$nP,$.$mP,0),(0,I.$os)(u.$blc,u.$clc,0),(0,I.$os)(r.$jkc,r.$ikc,0),(0,I.$os)(N.$Vlc,N.$Ulc,1),(0,I.$os)(l.$Glc,l.$Hlc,0),(0,I.$os)(v.$Zkc,v.$Ykc,0),(0,I.$os)(T.$9lc,T.$8lc,0),(0,I.$os)(k.$3kc,k.$6kc,0),(0,I.$os)(E.$0lc,E.$$lc,0),(0,I.$os)(m.$ACb,m.$BCb,0),(0,I.$os)(o.$lmc,o.$kmc,0),(0,I.$os)(A.$Bkc,A.$Akc,0),(0,I.$os)(t.$0kc,t.$9kc,0),(0,I.$os)(a.$wP,a.$tP,0),(0,I.$os)(d.$Qkc,d.$Rkc,0),(0,I.$os)(c.$ilc,c.$jlc,0)}),define(Ae[299],Re([1,0,297,39,2,294,7,11,243]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0;class k extends O.$qmc{j(){}getModule(v,m){for(const s of this.b){const o=s(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends N.$elc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$woc);const v=this.h.invokeFunction(I.$mmc);this.r=this.h.createInstance(k,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(v){return v.browser}async xb(v,m,s){m=m.with({path:y(m.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const n=A.URI.revive(await this.C.$asBrowserUri(m)),r=await fetch(n.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),r.status!==200)throw new Error(r.statusText);const t=await r.text(),a=`${m.toString(!0)}#vscode-extension`,d=`${t}
//# sourceURL=${a}`;let i;try{i=new Function("module","exports","require",d)}catch(u){throw console.error(o?`Loading code for extension ${o} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${m.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}v&&await this.w.initializeLocalizedMessages(v);const b={},c={exports:b},f=u=>{const S=this.r.getModule(u,m);if(S===void 0)throw new Error(`Cannot load module '${u}'`);return S};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(c,b,f),c.exports!==b?c.exports:b}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(v){}async Bb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+v;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,p.$rh)(10)}}e.$xoc=T;function y(l,v){return l.endsWith(v)?l:l+v}}),define(Ae[300],Re([1,0,70,55,13,39,207,85,299]),function(fe,e,I,N,A,O,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,N.$os)(A.$Wj,new I.$ni(M.$pmc,[!0],!0)),(0,N.$os)(O.$flc,$.$xoc,0),(0,N.$os)(p.$Hkc,p.$Ikc,0)}),define(Ae[306],Re([1,0,23,5,77,295,245,19,89,12,2,298,300]),function(fe,e,I,N,A,O,M,p,$,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=d;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(i){return/^(file|vscode-remote):/i.test(i)}const m=fetch.bind(self);function s(i){self.fetch=async function(b,c){return b instanceof Request||v(String(b))&&(b=(await i(T.URI.parse(String(b)))).toString(!0)),m(b,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,c,f,u,S){(async()=>(v(c.toString())&&(c=(await i(T.URI.parse(c.toString()))).toString(!0)),super.open(b,c,f??!0,u,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(b,c){if(/^file:/i.test(b.toString()))b=k.$Kg.uriToBrowserUri(T.URI.parse(b.toString())).toString(!0);else if(/^vscode-remote:/i.test(b.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const u=`(${function(g){function D(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const w=fetch.bind(self);self.fetch=function(P,V){return P instanceof Request?w(P,V):w(D(P),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,V,W,q,R){return super.open(P,D(V),W??!0,q,R)}};const C=importScripts.bind(self);self.importScripts=(...P)=>{C(...P.map(D))},C(g)}.toString()}('${b}'))`;c=c||{},c.name=`${name} -> ${c.name||p.$oc(b.toString())}`;const S=new Blob([u],{type:"application/javascript"}),h=URL.createObjectURL(S);return new i(h,c)}}else self.Worker=class extends M.$yoc{constructor(i,b){super(l,i,{name:p.$oc(i.toString()),...b})}};const o=new class{constructor(){this.pid=void 0}exit(i){y()}};class n{constructor(){const b=new MessageChannel,c=new N.$be;let f=!1;l(b.port2,[b.port2]),b.port1.onmessage=u=>{const{data:S}=u;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const h=I.$Ce.wrap(new Uint8Array(S,0,S.byteLength));if((0,A.$Um)(h,2)){f=!0,t("received terminate message from renderer");return}c.fire(h)},this.protocol={onMessage:c.event,send:u=>{if(!f){const S=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);b.port1.postMessage(S,[S])}}}}}function r(i){return new Promise(b=>{const c=i.onMessage(f=>{c.dispose();const u=JSON.parse(f.toString());i.send((0,A.$Tm)(0)),b({protocol:i,initData:u})});i.send((0,A.$Tm)(1))})}let t=i=>y();function a(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function d(){$.mark("code/extHost/willConnectToRenderer");const i=new n;return{onmessage(b){a(b)&&r(i.protocol).then(c=>{$.mark("code/extHost/didWaitForInitData");const f=new O.$smc(c.protocol,c.initData,o,null,b.data);s(u=>f.asBrowserUri(u)),t=u=>f.terminate(u)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b22eef9573fc76eb0e322015ca4236ca7056747b/core/vs/workbench/api/worker/extensionHostWorker.js.map
